/*****************************************************************************
**                                                                          **
**                       Edimax Proprietary Document                        **
**                               AP Wizard                                  **
**                    Copyright (c) 2008-2009 Edimax Inc.                   **
**                                                                          **
**   No.3,Wu-Chuan 3rd Road, Wu-Ku Lndustrial Pack. Taipei Hsien, Taiwan    **
**               TEL : 886-2-7739-6888 FAX : 886-2-7739-6887                **
**         E-mail:sales@edimax.com.tw      http://www.edimax.com            **
**                                                                          **
*****************************************************************************/
#ifndef CMDX_H
#define CMDX_H

/*****************************************************************************
**  FILE NAME:
**      cmdx.h
**
**  HISTORY:
**      12/10/2008 create
**
**  FUNCTION:
**      This file contains the data structures for get system info.
**
*****************************************************************************/

/************************************************
* Type defines                *
*************************************************/
typedef unsigned char   nuint8;
typedef unsigned short  nuint16;
typedef unsigned long   nuint32;
typedef unsigned int    uint;

#define AGENT_PORT		4416

#define MAC_ID_LEN		6	
#define IP_ADDRESS_LEN  4

/************************************************
* SEARCH                      *
*************************************************/
//-----------------------------------------
typedef struct ReponsePacket
{
	nuint8  Tag[4];
	nuint8  HeaderVersion[2];
	nuint8  Length[2];
	nuint8  ProductID[4];
	nuint8  Command[2];
	nuint8  NetworkType[2];
	nuint8  RTSPPort[2];
	nuint8  Result[2];
    nuint8  DataVersion[2];
	nuint8  MAC[6];
	nuint8  ModelName[16];
	nuint8  HostName[16];
	nuint8  Description[16];
	nuint8  NetworkMode[1];
	nuint8  IPaddr[4];
	nuint8  HttpPort[2];
	nuint8  SubnetMask[4];
	nuint8  GateWay[4];
	nuint8  AdminName[36];
	nuint8  AdminPassWd[16];
	nuint8	WLanEnable[1];
    nuint8  WLanOPMode[1];
	nuint8  WLanAuthMode[1];
	nuint8  WLanSSID[33];
	nuint8  WLanDomain[2];
	nuint8  WLanChannel[1];
	nuint8  WLanEncryptMethod[2];
	nuint8  WLanDefaultKey[1];
	nuint8  WLanWEPKey1[27];
	nuint8  WLanWEPKey2[27];
	nuint8  WLanWEPKey3[27];
	nuint8  WLanWEPKey4[27];
	nuint8  DNS1[4];
	nuint8  DNS2[4];
	nuint8  Section5[5];
	nuint8  Vendor[25];
	nuint8  Section6[7];
	nuint8  Title[30];
	nuint8  Section7[2];
}IPfinder_packet, *PIPfinder_packet;

/************************************************
* MODIFY IP                                     *
*************************************************/
//----------------------------------------------
typedef struct modifyip_packet 
{
	nuint8 Tag[4];				    // "McVa"
	nuint8 MAC[6];				    // MAC address
	nuint8 Login_Username[32];	    // login name
	nuint8 Login_Password[16];	    // login password
	nuint8 New_Username[32];	    // login name
	nuint8 New_Password[16];	    // login password
	nuint8 change_userinfo[4];		// 0: Do not modify user info    1: Modify user info
	nuint8 dhcp[4];					// 0: Dynamic    1: Static
	nuint8 IP_Addr[4];				// Desire ip address
	nuint8 NetMask[4];				// Desire netmask address
	nuint8 Gateway[4];				// Desire gateway address
	nuint8 dns1[4];					// Desire dns1 address
	nuint8 dns2[4];					// Desire dns2 address
    nuint8 DeviceName[33];			// Device Name
}Modify_Packet, *PModify_packet; 

#endif
