#include <memory.h>
#include <ctype.h>

#include <stdbool.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/wait.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <signal.h>

#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <net/route.h>
#include <sys/ioctl.h>
//#include <signal.h>
//#include <sys/ioctl.h>
#include <net/if.h>
//#include <linux/wireless.h>
//#include <dirent.h>

#include <linux/if_packet.h>
#include <linux/if_ether.h>
#include "ipd.h"

//#define WLAN_IF     "eth2"
//#define WLAN_IF     "wlan0"

//#define WLAN_IF     "ra0"
#define BRIDGE_IF     "br0"
//#define SIOCGIWRTLGETBSSDB          0x8B34	// get bss data base
//#define SIOCGIWRTLSCANREQ           0x8B33	// scan request
//#define SIOCGIWNAME                 0x8B01    /* get name == wireless protocol */
//#define SIOCGIFFLAGS                0x8913	/* get flags			         */
//#define SIOCGIFHWADDR               0x8927	/* Get hardware address		     */
//#define SIOCGIFADDR                 0x8915	/* get PA address		         */

//#define SIOCGIWRTLSTAINFO           0x8B30    // get station table information
//#define SIOCGIWRTLSTANUM            0x8B31    // get the number of stations in table
//#define SIOCGIWRTLJOINREQ           0x8B35    // join request
//#define SIOCGIWRTLJOINREQSTATUS     0x8B36    // get status of join request
//#define SIOCGIWRTLGETBSSINFO        0x8B37    // get currnet bss info
//#define SIOCGIWRTLGETWDSINFO        0x8B38
//#define SIOCGIWRTLSTAINFO_NEW       0x8B50

//#define SIOCDEVPRIVATE              0x8BE0
//#define SIOCIWFIRSTPRIV             SIOCDEVPRIVATE
//#define RTPRIV_IOCTL_GET_MAC_TABLE  (SIOCIWFIRSTPRIV + 0x0F)
//#define RTPRIV_IOCTL_GSITESURVEY    (SIOCIWFIRSTPRIV + 0x0D)
//#define RTPRIV_IOCTL_SET            (SIOCIWFIRSTPRIV + 0x02)
//#define OID_802_11_BSSID_LIST       0x0609
//#define RTPRIV_IOCTL_GSITESURVEY    (SIOCIWFIRSTPRIV + 0x0D)

#define MAX_BROADCAST_STRING_SIZE   1514

char G_zsIPAddr169[20];

/***************************************************************************/

int main(int argc, char** argv)
{
    int nSockfd;
    int nRecv_Len;
    struct sockaddr_in addr;
    unsigned char zsRecv_Buffer[MAX_BROADCAST_STRING_SIZE];
    FILE *fp;
    struct sockaddr_in addrSender;
    int nSenderAddrSize = sizeof(struct sockaddr_in);
    
    // Display Version
    printf("**** Airlive Agent Version 1.0.1 ***** \n");
    
    //check
    fp = fopen("/tmp/agentenabledflag", "r");
    if(fp != NULL) exit(0);
    
    // Add IP 169.254.x.x
    char  zsAddIP[128];
    
    memset(G_zsIPAddr169, 0 , sizeof(G_zsIPAddr169));
    memset(zsAddIP, 0 , sizeof(zsAddIP));
    
    srand(time(NULL));
    sprintf(G_zsIPAddr169, "169.254.%d.%d",  (rand() % 253) + 1, (rand() % 254));
    sprintf(zsAddIP, "ifconfig %s:1 %s",  BRIDGE_IF, G_zsIPAddr169);
    system(zsAddIP);
    // End
    
    //set socket
    nSockfd = socket(AF_INET, SOCK_DGRAM, 0);
    if(nSockfd < 0)
    {
        printf("**** socket() error!***** \n");
        exit(0);
    }
   
    //init local address
    addr.sin_family = AF_INET;
    addr.sin_port = htons(AGENT_PORT);
    addr.sin_addr.s_addr = INADDR_ANY;
    
    if (bind(nSockfd, (struct sockaddr *)&addr, sizeof(addr)) < 0)
    {
        printf("*****bind() error!***** \n");
	    exit(0);
    }
    else
    {
        fp = fopen("/tmp/agentenabledflag", "w");
	    if(fp == NULL)
	    {
	        exit(0);
	    }
	    else
	    {
	        fclose(fp);
	    }
    }
    
    while(1)
    {
        memset(zsRecv_Buffer, 0, MAX_BROADCAST_STRING_SIZE);
        nRecv_Len = recvfrom(nSockfd, zsRecv_Buffer, MAX_BROADCAST_STRING_SIZE, 0, (struct sockaddr *)&addrSender, &nSenderAddrSize);
        if(nRecv_Len > 0)
        {
            printf("rece size = %d \n", nRecv_Len);
            dispatch(zsRecv_Buffer, nRecv_Len, nSockfd, &addrSender);
        }
    } 
    return 0;
}
/***************************************************************************/

void dispatch(unsigned char *zpBuf, int nLen, int nSockfd, struct sockaddr_in *addrSender)
{
    if (zpBuf[0] == 'A' && zpBuf[1] == 'v' && zpBuf[2] == 'C' && zpBuf[3] == 'm')
	{	
        printf("*************************\n");
        printf("        is AvCm          \n");
        printf("*************************\n");
        searchAP(addrSender);
	}
    else if(zpBuf[0] == 'M' && zpBuf[1] == 'c' && zpBuf[2] == 'V' && zpBuf[3] == 'a')
    {
        printf("********************************\n");
        printf("         is McVa                \n");
        printf("********************************\n");
        modify_ipcam_info(zpBuf);
	}
}
/***************************************************************************/

int searchAP(struct sockaddr_in *addrSender)
{
    FILE *fp;
    IPfinder_packet    aFinderReply;
	
	struct sockaddr hwaddr;
    struct in_addr aIPAddr;
    
    int nIdx;
    int nLength = 0;
    int bDHCP = 0;
    char zsLine[2048];
    char zsIPAddr[20];
    char *zpGetInfo[7] = {"DEVICE_NAME=", "DHCP=", "WEB_PORT=", "DNS1=", "DNS2=" , "SSID=", "DEFAULT_GATEWAY="};
    
	memset(&aFinderReply, 0, sizeof(IPfinder_packet));
    
    // Get some info from flash
    system("flash all > /tmp/getinfo.txt");
    fp = fopen("/tmp/getinfo.txt", "r");
    while((fgets(zsLine, 80, fp)) != NULL)
    {
        if(memcmp(zpGetInfo[0], zsLine, strlen(zpGetInfo[0])) == 0)
        {
            //Get Model Name and Host Name 
            printf("%s\n", zsLine);
            nIdx = strlen(zpGetInfo[0]) + 1;
            nLength = (strlen(zsLine) - nIdx) - 2;
            nLength = nLength > 15 ? 15 : nLength;
            memcpy(aFinderReply.ModelName, &zsLine[nIdx], nLength);
            memcpy(aFinderReply.HostName, &zsLine[nIdx], nLength);
            memcpy(aFinderReply.Title, &zsLine[nIdx], nLength);
        }
        else if(memcmp(zpGetInfo[1], zsLine, strlen(zpGetInfo[1])) == 0)
        {
            printf("%s\n", zsLine);
            //Get DHCP Mode
            if (strstr(zsLine, "DHCP=1") != NULL)
            {   // DHCP Client
                printf("DHCP on \n");
                bDHCP = 1;
                aFinderReply.NetworkMode[0] = 0x00;
            }
            else
            {
                bDHCP = 0;
                printf("DHCP off \n");
                aFinderReply.NetworkMode[0] = 0x01;
            }
        }
        else if(memcmp(zpGetInfo[2], zsLine, strlen(zpGetInfo[2])) == 0)
        {
            printf("%s\n", zsLine);
            //Get WEB_PORT
            nIdx = strlen(zpGetInfo[2]);
            int nPort = atoi(&zsLine[nIdx]);
            aFinderReply.HttpPort[0] = (nuint8)nPort;
            aFinderReply.HttpPort[1] = (nuint8)(nPort >> 8);
        }
        else if(memcmp(zpGetInfo[3], zsLine, strlen(zpGetInfo[3])) == 0)
        {
            //Get DNS1
            printf("%s\n", zsLine);
            nIdx = strlen(zpGetInfo[3]) + 1;
            nLength = (strlen(zsLine) - nIdx) - 2;
            memset(zsIPAddr, 0, sizeof(zsIPAddr));
            memcpy(zsIPAddr, &zsLine[nIdx], nLength);
            aIPAddr.s_addr =  inet_addr(zsIPAddr);
            aFinderReply.DNS1[3] = (nuint8)(aIPAddr.s_addr >> 24);
            aFinderReply.DNS1[2] = (nuint8)(aIPAddr.s_addr >> 16);
            aFinderReply.DNS1[1] = (nuint8)(aIPAddr.s_addr >> 8);
            aFinderReply.DNS1[0] = (nuint8)(aIPAddr.s_addr);
        }
        else if(memcmp(zpGetInfo[4], zsLine, strlen(zpGetInfo[4])) == 0)
        {
            //Get DNS2
            printf("%s\n", zsLine);
            nIdx = strlen(zpGetInfo[4]) + 1;
            nLength = (strlen(zsLine) - nIdx) - 2;
            memset(zsIPAddr, 0, sizeof(zsIPAddr));
            memcpy(zsIPAddr, &zsLine[nIdx], nLength);
            aIPAddr.s_addr =  inet_addr(zsIPAddr);
            aFinderReply.DNS2[3] = (nuint8)(aIPAddr.s_addr >> 24);
            aFinderReply.DNS2[2] = (nuint8)(aIPAddr.s_addr >> 16);
            aFinderReply.DNS2[1] = (nuint8)(aIPAddr.s_addr >> 8);
            aFinderReply.DNS2[0] = (nuint8)(aIPAddr.s_addr);
        }
        else if(memcmp(zpGetInfo[5], zsLine, strlen(zpGetInfo[5])) == 0)
        {
            //Get SSID
            printf("%s\n", zsLine);
            nIdx = strlen(zpGetInfo[5]) + 1;
            nLength = (strlen(zsLine) - nIdx) - 2;
            nLength = nLength > 32 ? 32 : nLength;
            memcpy(aFinderReply.WLanSSID, &zsLine[nIdx], nLength);
        }
        else if(memcmp(zpGetInfo[6], zsLine, strlen(zpGetInfo[6])) == 0)
        {
            //Get Gateway
            printf("%s\n", zsLine);
            nIdx = strlen(zpGetInfo[6]) + 1;
            nLength = (strlen(zsLine) - nIdx) - 2;
            memset(zsIPAddr, 0, sizeof(zsIPAddr));
            memcpy(zsIPAddr, &zsLine[nIdx], nLength);
            aIPAddr.s_addr =  inet_addr(zsIPAddr);
            aFinderReply.GateWay[3] = (nuint8)(aIPAddr.s_addr >> 24);
            aFinderReply.GateWay[2] = (nuint8)(aIPAddr.s_addr >> 16);
            aFinderReply.GateWay[1] = (nuint8)(aIPAddr.s_addr >> 8);
            aFinderReply.GateWay[0] = (nuint8)(aIPAddr.s_addr);
        }
    }
    fclose(fp);	
    system("rm /tmp/getinfo.txt");
    
    // Get MacID myself    
    if(getMacID(&hwaddr) == 0)
    {
		memcpy(aFinderReply.MAC, hwaddr.sa_data, MAC_ID_LEN);
    }
    else
    {
        printf("**** get Mac ID fail! *****\n");
    }
    
    // Get IP Addr
    if(getIPAddr(&aIPAddr) == 0)
    {
        aFinderReply.IPaddr[3] = (nuint8)(aIPAddr.s_addr >> 24);
        aFinderReply.IPaddr[2] = (nuint8)(aIPAddr.s_addr >> 16);
        aFinderReply.IPaddr[1] = (nuint8)(aIPAddr.s_addr >> 8);
        aFinderReply.IPaddr[0] = (nuint8)(aIPAddr.s_addr);
    }
    else
    {
        printf("*****get IP Address fail!*****\n");
    }
    
    // Get Subnet
    if(getSubnetMask(&aIPAddr) == 0)
    {
        aFinderReply.SubnetMask[3] = (nuint8)(aIPAddr.s_addr >> 24);
        aFinderReply.SubnetMask[2] = (nuint8)(aIPAddr.s_addr >> 16);
        aFinderReply.SubnetMask[1] = (nuint8)(aIPAddr.s_addr >> 8);
        aFinderReply.SubnetMask[0] = (nuint8)(aIPAddr.s_addr);
    }
    else
    {
        printf("****get Subnet fail!*****\n");
    }
	
    if (bDHCP == 1)
    {
        // Clear gateway
        aFinderReply.GateWay[0] = 0;
        aFinderReply.GateWay[1] = 0;
        aFinderReply.GateWay[2] = 0;
        aFinderReply.GateWay[3] = 0;
    }
    
    // Set Fixed value

    //Set Vendor
    memcpy(aFinderReply.Vendor, "Airlive", sizeof("Airlive"));

    //Tag
    aFinderReply.Tag[0] = 0x20; 	
	aFinderReply.Tag[1] = 0x20; 	
	aFinderReply.Tag[2] = 0x20; 	
	aFinderReply.Tag[3] = 0x20; 	
    
	//Header
	aFinderReply.HeaderVersion[0] = 0x30;
	aFinderReply.HeaderVersion[1] = 0x32;
    
    //Length
    nLength = sizeof(IPfinder_packet);
    aFinderReply.Length[0] = (nuint8)(nLength >> 8);
    aFinderReply.Length[1] = nLength;
    
	//ProductID
	aFinderReply.ProductID[0] = 0x43;
	aFinderReply.ProductID[1] = 0x46;
	aFinderReply.ProductID[2] = 0x33;
	aFinderReply.ProductID[3] = 0x31;

	//Command
	aFinderReply.Command[0] = 0x01;

	//NetworkType
    aFinderReply.NetworkType[0] = 0x01;
    
    // Result
    aFinderReply.Result[0] = 0x01;
    aFinderReply.Result[1] = 0x00;
    
    // Data Version
    aFinderReply.DataVersion[0] = 0x34;
    aFinderReply.DataVersion[1] = 0x30;
    
	// WLAN enable
	aFinderReply.WLanEnable[0] = 0x01;	

    //Get OP mode
    aFinderReply.WLanOPMode[0] = 0x02; //Enable
        
    // Others    
    aFinderReply.RTSPPort[0] = 0x2A;
    aFinderReply.RTSPPort[1] = 0x02;

    aIPAddr.s_addr = inet_addr(G_zsIPAddr169);
    aFinderReply.Section5[3] = (nuint8)(aIPAddr.s_addr >> 24);
    aFinderReply.Section5[2] = (nuint8)(aIPAddr.s_addr >> 16);
    aFinderReply.Section5[1] = (nuint8)(aIPAddr.s_addr >> 8);
    aFinderReply.Section5[0] = (nuint8)(aIPAddr.s_addr);
    aFinderReply.Section5[4] = 0x01;
    
    aFinderReply.WLanDomain[0] = 0x0E;
    
    aFinderReply.Section6[5] = 0x2A;
    aFinderReply.Section6[6] = 0xae;
    
    nuint8 zs1[27] = {0x00, 0x41, 0x8c, 0x00, 0x00, 0x00, 0x00, 0x2a, 0xaa, 0xe0, 0x68, 0x7f, 0xb9, 0x9a, 0x20, 0x2a, 0xaf, 0x60, 0x50, 0x2a, 0xaa, 0xb7, 0x90, 0x2a, 0xaf, 0x29, 0x88};
    nuint8 zs2[27] = {0x00, 0x00, 0x00, 0x00, 0x2a, 0xaa, 0xe1, 0x3c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2a, 0xaa, 0xe2, 0x44, 0x2a, 0xb6, 0x41, 0x8c, 0x00, 0x00, 0x00}; 
    nuint8 zs3[27] = {0x00, 0x2a, 0xaa, 0xe0, 0x68, 0x7f, 0xb9, 0x9a, 0x20, 0x7f, 0xb9, 0x96, 0x90, 0x2a, 0xaa, 0xb7, 0x90, 0x2a, 0xba, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2a, 0xbb};
    nuint8 zs4[27] = {0x00, 0xf0, 0x00, 0x00, 0x00, 0x01, 0x2a, 0xaa, 0x80, 0xf4, 0x00, 0x00, 0x00, 0x06, 0x7f, 0xb9, 0x96, 0xb0, 0x2a, 0xb6, 0x59, 0x10, 0x00, 0x00, 0x00, 0x00, 0x2a};
    
    for (nIdx = 0; nIdx < 27; nIdx ++)
    {
        aFinderReply.WLanWEPKey1[nIdx] = zs1[nIdx];
        aFinderReply.WLanWEPKey2[nIdx] = zs2[nIdx];
        aFinderReply.WLanWEPKey3[nIdx] = zs3[nIdx];
        aFinderReply.WLanWEPKey4[nIdx] = zs4[nIdx];
    }
    // end
     
	return senddata(&aFinderReply, sizeof(IPfinder_packet), addrSender);
    
}
/***************************************************************************/

int modify_ipcam_info(char *dataBuffer)   //joshua for modify
{
    char ipaddr[64];
    char netmask[64];
    char Gateway[64];
    char dns1[64];
    char dns2[64];	
    char userinfo[64];
    char zsDeviceName[64];
    struct sockaddr hwaddr;
    PModify_packet pModifypacket;
    
    pModifypacket = (PModify_packet)dataBuffer;

     // Get MacID myself    
    if(getMacID(&hwaddr) == 0)
    {
		if (memcmp(pModifypacket->MAC, hwaddr.sa_data, MAC_ID_LEN) != 0)
        {
            return -1;
        }
    }
    else
    {
        printf("**** get Mac ID fail! *****\n");
        return -1;
    }
    
    printf("rece username = _%s_ \n", pModifypacket->Login_Username);	
    printf("rece password = _%s_ \n", pModifypacket->Login_Password);
    printf("rece IP = _%d_%d_%d_%d \n", pModifypacket->IP_Addr[0], pModifypacket->IP_Addr[1], pModifypacket->IP_Addr[2], pModifypacket->IP_Addr[3]);

    printf("rece MASK = _%d_%d_%d_%d \n", pModifypacket->NetMask[0], pModifypacket->NetMask[1], pModifypacket->NetMask[2], pModifypacket->NetMask[3]);	
    printf("rece GATWAY = _%d_%d_%d_%d \n", pModifypacket->Gateway[0], pModifypacket->Gateway[1], pModifypacket->Gateway[2], pModifypacket->Gateway[3] );
    printf("rece DNS1 = _%d_%d_%d_%d \n", pModifypacket->dns1[0], pModifypacket->dns1[1], pModifypacket->dns1[2], pModifypacket->dns1[3]);
    printf("rece DNS2 = _%d_%d_%d_%d \n", pModifypacket->dns2[0], pModifypacket->dns2[1], pModifypacket->dns2[2], pModifypacket->dns2[3]);
    
    printf("rece device name = _%s_ \n", pModifypacket->DeviceName);
    
    // change ip address
    if (pModifypacket->dhcp[0] == 1)
    {
        printf("ip static \n");
        system("flash set DHCP 0");
        
        sprintf(ipaddr, "flash set IP_ADDR %d.%d.%d.%d", pModifypacket->IP_Addr[0], pModifypacket->IP_Addr[1], pModifypacket->IP_Addr[2], pModifypacket->IP_Addr[3]);
        sprintf(netmask, "flash set SUBNET_MASK %d.%d.%d.%d", pModifypacket->NetMask[0], pModifypacket->NetMask[1], pModifypacket->NetMask[2], pModifypacket->NetMask[3] );
        sprintf(Gateway, "flash set DEFAULT_GATEWAY %d.%d.%d.%d", pModifypacket->Gateway[0], pModifypacket->Gateway[1], pModifypacket->Gateway[2], pModifypacket->Gateway[3]);
        sprintf(dns1, "flash set DNS1 %d.%d.%d.%d", pModifypacket->dns1[0], pModifypacket->dns1[1], pModifypacket->dns1[2], pModifypacket->dns1[3]);
        sprintf(dns2, "flash set DNS2 %d.%d.%d.%d", pModifypacket->dns2[0], pModifypacket->dns2[1], pModifypacket->dns2[2], pModifypacket->dns2[3]);
        
        system(ipaddr);
        system(netmask);
        system(Gateway);
        system(dns1);
        system(dns2);
    }
    else
    {
        printf("ip DHCP \n");
        system("flash set DHCP 1");
    }
    
    // change password
    if (pModifypacket->change_userinfo[0] == 1)
    {
        printf("change user info \n");
        sprintf(userinfo, "flash set USER_PASSWORD \"%s\"", pModifypacket->New_Password);
        system(userinfo);	
    }
    else
    {
        printf("not change user info \n");
    }
    
    // change device name
    sprintf(zsDeviceName, "flash set DEVICE_NAME \"%s\"", pModifypacket->DeviceName);
    system(zsDeviceName);	
        
    system("reboot.sh 2 &");
    
    return 0;
}
/***************************************************************************/

int senddata(void *buf, int nLen, struct sockaddr_in *addrSender)
{
    int fd;
    int result;
    int index;
    struct sockaddr_ll dest;
    struct ifreq ifr;
    struct sockaddr_in *addr;
    struct packet_header *pkt_hdr;
    unsigned char packet[2000];

	pkt_hdr = (struct packet_header *)packet;
	
    memset(&ifr, 0, sizeof(ifr));
    memset(&dest, 0, sizeof(dest));
    memset(&packet, 0, 2000);

    if ((fd = socket(PF_PACKET, SOCK_DGRAM, htons(ETH_P_IP))) < 0)
    {
        perror("socket");
	    return -1;
    }
    
   // Get Interfance index
    strncpy(ifr.ifr_name, BRIDGE_IF, sizeof(IFNAMSIZ));
    if (ioctl(fd, SIOCGIFINDEX, &ifr) < 0)
    {
        perror("ioctl SIOCGIFINDEX");
	    return -1;
    }
    index = ifr.ifr_ifindex;
    // end 
    
    dest.sll_family = PF_PACKET;
    dest.sll_protocol = htons(ETH_P_IP);
    dest.sll_ifindex = index;
    dest.sll_halen = 6;
    memset(dest.sll_addr, 0xff, 6);
	
    pkt_hdr->ip.protocol = IPPROTO_UDP;
    //pkt_hdr->ip.saddr = INADDR_ANY; //addr->sin_addr.s_addr;
    //pkt_hdr->ip.daddr = INADDR_BROADCAST;
    //pkt_hdr->ip.saddr = addr->sin_addr.s_addr;
    //pkt_hdr->ip.daddr = addrSender->sin_addr.s_addr;
    pkt_hdr->ip.saddr = inet_addr(G_zsIPAddr169);
    pkt_hdr->ip.daddr = inet_addr("169.254.255.255");
    
    pkt_hdr->ip.version = 4;
    pkt_hdr->ip.ttl = 128;
    pkt_hdr->ip.tot_len = htons(sizeof(pkt_hdr->udp) + sizeof(pkt_hdr->ip) + nLen);
    pkt_hdr->ip.ihl = sizeof(pkt_hdr->ip) >> 2;
    pkt_hdr->ip.check = 0x0000;
	
    pkt_hdr->udp.source = htons(AGENT_PORT);
    pkt_hdr->udp.dest = addrSender->sin_port;
    pkt_hdr->udp.len = htons(sizeof(pkt_hdr->udp) + nLen);
    pkt_hdr->udp.check = 0x0000;
    
    memcpy(packet + sizeof(struct packet_header), buf, nLen);
	
    pkt_hdr->udp.check = checksum((unsigned short*)&pkt_hdr->udp, sizeof(pkt_hdr->udp) + nLen);
    pkt_hdr->ip.check = checksum((unsigned short*)&pkt_hdr->ip, sizeof(pkt_hdr->udp) + sizeof(pkt_hdr->ip) + nLen);
    pkt_hdr->udp.check = 0x0000;

//#if defined(_7206APG_) || defined(_7206PDG_) || defined(_7209APG_) || defined(_EW7228APN_) // Realtek
    result = sendto(fd, packet, pkt_hdr->ip.tot_len, 0, (struct sockaddr *) &dest, sizeof(dest));
//#else // Ralink
//    result = sendto(fd, packet, (sizeof(pkt_hdr->udp) + sizeof(pkt_hdr->ip) + nLen), 0, (struct sockaddr *)&dest, sizeof(dest));
//#endif
    if (result <= 0)
    {
        perror("sendto Error");
    }
    
    // Get Current IP Address
    if (ioctl(fd, SIOCGIFADDR, &ifr) < 0)
    {
        perror("ioctl SIOCGIFADDR");
        return -1;
    }
    addr = ((struct sockaddr_in *)&ifr.ifr_addr);
    
    pkt_hdr->ip.saddr = addr->sin_addr.s_addr;
    pkt_hdr->ip.daddr = addrSender->sin_addr.s_addr;
    
    // Set IP Addr 169.254.x.x
    //pkt_hdr->ip.saddr = inet_addr(G_zsIPAddr169);
    //pkt_hdr->ip.daddr = inet_addr("169.254.255.255");
    
    pkt_hdr->ip.check = 0x0000;
    pkt_hdr->udp.check = 0x0000;
    pkt_hdr->udp.check = checksum((unsigned short*)&pkt_hdr->udp, sizeof(pkt_hdr->udp) + nLen);
    pkt_hdr->ip.check = checksum((unsigned short*)&pkt_hdr->ip, sizeof(pkt_hdr->udp) + sizeof(pkt_hdr->ip) + nLen);
    pkt_hdr->udp.check = 0x0000;
    
    result = sendto(fd, packet, pkt_hdr->ip.tot_len, 0, (struct sockaddr *) &dest, sizeof(dest));
    if (result <= 0)
    {
        perror("sendto Error");
    }
    // end 
    
    close(fd);
    
    return 0;
}
/***************************************************************************/

unsigned short checksum(unsigned short *buffer, int size)
{ 
    unsigned long cksum = 0;
    while(size > 1)
    {  
        cksum += *buffer ++;
	    size -= sizeof(unsigned short);
    }          
    if(size)
    {
         cksum += *(unsigned char *)buffer;
    }
    cksum = (cksum >> 16) + (cksum & 0xffff);
    cksum += (cksum >> 16);
    return(unsigned short) (~cksum);
}
/***************************************************************************/

int getInAddr( char *interface, ADDR_T type, void *pAddr )
{
    struct ifreq ifr;
    int skfd, found=0;
    struct sockaddr_in *addr;

    skfd = socket(AF_INET, SOCK_DGRAM, 0);

    strcpy(ifr.ifr_name, interface);
    if (ioctl(skfd, SIOCGIFFLAGS, &ifr) < 0)
	return (0);

    if (type == HW_ADDR) 
    {
    	if (ioctl(skfd, SIOCGIFHWADDR, &ifr) >= 0) 
    	{
		    memcpy(pAddr, &ifr.ifr_hwaddr, sizeof(struct sockaddr));
		    found = 1;
	    }
    }
    else if (type == IP_ADDR) 
    {
	    if (ioctl(skfd, SIOCGIFADDR, &ifr) == 0) 
	    {
		    addr = ((struct sockaddr_in *)&ifr.ifr_addr);
		    *((struct in_addr *)pAddr) = *((struct in_addr *)&addr->sin_addr);
		    found = 1;
	    }
    }
    else if (type == SUBNET_MASK) 
    {
	    if (ioctl(skfd, SIOCGIFNETMASK, &ifr) >= 0) 
	    {
		    addr = ((struct sockaddr_in *)&ifr.ifr_addr);
		    *((struct in_addr *)pAddr) = *((struct in_addr *)&addr->sin_addr);
		    found = 1;
	    }
    }
    close( skfd );
    return found;
}
/***************************************************************************/

int getMacID(void *hwaddr)
{
    if(BRIDGE_IF && getInAddr(BRIDGE_IF, HW_ADDR, hwaddr))
    {	
        return 0;
    }
    return -1;
}
/***************************************************************************/

int getIPAddr(void *intaddr)
{	
    if(BRIDGE_IF && getInAddr(BRIDGE_IF, IP_ADDR, intaddr))
    {	
        return 0;
    }
    return -1;
}
/***************************************************************************/
int getSubnetMask(void *intaddr)
{
    if(BRIDGE_IF && getInAddr(BRIDGE_IF, SUBNET_MASK, intaddr))
    {	
	    return 0;
    }
    return -1;
}
/***************************************************************************/

int getGatewayAddr(void *intaddr)
{	
    if(BRIDGE_IF && getInAddr(BRIDGE_IF, DEFAULT_GATEWAY, intaddr))
    {	
        return 0;
    }
    return -1;
}

/***************************************************************************/




