/*
 *      Include file of form handler
 *
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *
 *      $Id: apform.h,v 1.2 2005/05/13 07:52:54 tommy Exp $
 *
 */

#ifndef _INCLUDE_APFORM_H
#define _INCLUDE_APFORM_H

#ifdef _BOA_
#include "../webs.h"
#endif

#if HAVE_STDBOOL_H
# include <stdbool.h>
#else
typedef enum {false = 0, true = 1} bool;
#endif

#define noNO_ACTION

// bridge mode (wlan0+eth2.1)
#define BRIDGE_IF	T("br0")

#define ELAN_IF		T("eth0")
#define ELAN2_IF		T("eth2")		//Walter
#define ELAN3_IF		T("eth3")		//Walter
#define ELAN4_IF		T("eth4")		//Walter

#define WLAN_IF     T("wlan0")

#ifndef __TARGET_BOARD__		//Erwin 2004.01.30
  #define _CONFIG_SCRIPT_PATH	T(".")
  #define _LITTLE_ENDIAN_
#else
  #define _CONFIG_SCRIPT_PATH	T("/bin")
#endif

#ifdef _BOA_
#define FORM_FW_UPLOAD T("formUpload")
#define FORM_LANGUAGE_UPLOAD T("formLanguageUpgrade")
#define FORM_FW_CHECK T("formcheckfirmware")
#define FORM_CFG_UPLOAD T("formSetRestorePrev")
#define FORM_SAVE_CONF T("formSaveConfig")
#define FORM_SAVE_CONF_SEC T("formSaveConfigSec")
#endif

//#define _UPMIBFILE_SCRIPT_PROG  T("mibfile_run.sh")
#define _CONFIG_SCRIPT_PROG	T("init.sh")
#define _WLAN_SCRIPT_PROG	T("wlan.sh")
#define _PPPOE_SCRIPT_PROG	T("pppoe.sh")
#define _FIREWALL_SCRIPT_PROG	T("firewall.sh")
#define _PPPOE_DC_SCRIPT_PROG	T("disconnect.sh")
#define _IAPPAUTH_SCRIPT_PROG	T("iappauth.sh")
#define _RADIUS_SCRIPT_PROG	T("Radiusd.sh")

#ifdef _LOGIN_WEB_
	#define _Login_IDNUM_ 100
#endif

#define DEBUGP strcpy

///////////////////////////////////////////////////////////////////////////
static bool _is_hex(char c)
{
    return (((c >= '0') && (c <= '9')) ||
            ((c >= 'A') && (c <= 'F')) ||
            ((c >= 'a') && (c <= 'f')));
}

// Validate digit
static bool _isdigit(char c)
{
    return ((c >= '0') && (c <= '9'));
}

static int __inline__ string_to_hex(char_t *string, unsigned char *key, int len)
{
	char tmpBuf[4];
	int idx, ii=0;
	for (idx=0; idx<len; idx+=2) {
		tmpBuf[0] = string[idx];
		tmpBuf[1] = string[idx+1];
		tmpBuf[2] = 0;
		if ( !_is_hex(tmpBuf[0]) || !_is_hex(tmpBuf[1]))
			return 0;

		key[ii++] = (unsigned char) strtol(tmpBuf, (char**)NULL, 16);
	}
	return 1;
}

static int __inline__ string_to_dec(char_t *string, int *val)
{
	int idx;
	int len = strlen(string);

	for (idx=0; idx<len; idx++) {
		if ( !_isdigit(string[idx]))
			return 0;
	}

	*val = strtol(string, (char**)NULL, 10);
	return 1;
}

///////////////////////////////////////////////////////////////////////////////////////////

#define REPLACE_MSG(url)\
{\
	websHeader(wp);\
	websWrite(wp, T("<body class=\"background\" onLoad=document.location.replace(\"%s\")>"), url);\
	websFooter(wp);\
	websDone(wp, 200);\
}

#define REPLACE1_MSG(url)\
{\
	websHeader(wp);\
	websWrite(wp, T("<body class=\"background\" onLoad=parent.lFrame.location.replace(\"%s\")>"), url);\
	websFooter(wp);\
	websDone(wp, 200);\
}

#define REJECT_MSG()\
{\
	websHeader(wp);\
	websWrite(wp, T("<body class=\"background\" onLoad='window.close();'>\n</body>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}

#define WAIT_MSG_START(msg)\
{\
	websHeader(wp);\
	websWrite(wp, T("<head>\n<link rel=\"stylesheet\" href=\"/file/set.css\">\n")); \
	websWrite(wp, T("<meta http-equiv='Content-Type' content='text/html; charset=%s'>\n"),charset); \
	websWrite(wp, T("<script language='javascript' src='/javascript.js'></script>\n")); \
	websWrite(wp, T("<script language='javascript' src='/file/allasp-n.var'></script>\n")); \
	websWrite(wp, T("<title>Wait!</title>\n</head>\n")); \
	websWrite(wp, T("<body class=\"background\"><blockquote><h4></h4>\n")); \
	websWrite(wp, T("<span id=\"msgActId\" style=\"display:block\">\n")); \
	websWrite(wp, T("<script>if(window.waitmsg) bu1=showText(waitmsg); else bu1='%s';document.write(bu1);</script>\n</blockquote>\n</body>"),msg); \
	websWrite(wp, T("</span>\n")); \
}
#define WAIT_MSG(msg, url)\
{\
	websHeader(wp);\
	websWrite(wp, T("<head>																			\n"));\
	websWrite(wp, T("	<link rel='stylesheet' href='/file/set.css'>														\n"));\
	websWrite(wp, T("	<meta http-equiv='Content-Type' content='text/html; charset=%s'>										\n"),charset);\
	websWrite(wp, T("	<script type='text/javascript' src ='/javascript.js'></script>											\n"));\
	websWrite(wp, T("	<script type='text/javascript' src ='/file/allasp-n.var'></script>										\n"));\
	websWrite(wp, T("</head><!--WAIT_MSG-->																	\n"));\
	websWrite(wp, T("<body bgcolor=\"white\" LINK=\"#ffffff\" VLINK=\"#ffffff\" ALINK=\"#FFfffff\" leftmargin=\"0\" topmargin=\"5\">					\n"));\
	websWrite(wp, T("<blockquote>																		\n"));\
	websWrite(wp, T("	<h4>%s</h4>																	\n"),msg);\
	websWrite(wp, T("	<form name=\"test\">																\n"));\
	websWrite(wp, T("	<script>																	\n"));\
	websWrite(wp, T("	if( '%s' != '' )																\n"),url);\
	websWrite(wp, T("		if ( %d == 1)																\n"),lanipChanged);\
	websWrite(wp, T("		document.write('<input type=button name=\"okbutton\" value=\" OK! \" style=\"width:100px\" OnClick=top.location.replace(\"%s\")>');	\n"),url);\
	websWrite(wp, T("		else																	\n"));\
	websWrite(wp, T("		document.write('<input type=button name=\"okbutton\" value=\" OK! \" style=\"width:100px\" OnClick=window.location.replace(\"%s\")>');\n"),url);\
	websWrite(wp, T("	else																		\n"));\
	websWrite(wp, T("		document.write('<input type=button name=\"okbutton\" value=\" OK! \" style=\"width:100px\" OnClick=window.close()>');			\n"));\
	websWrite(wp, T("	</script>																	\n"));\
	websWrite(wp, T("	</form>																		\n"));\
	websWrite(wp, T("</blockquote>																		\n"));\
	websWrite(wp, T("<script>																		\n"));\
	websWrite(wp, T("	var secs = 10;																	\n"));\
	websWrite(wp, T("	var wait = secs * 1000;																\n"));\
	websWrite(wp, T("	document.test.okbutton.value = \"OK!\" + \"(\" + secs + \")\";											\n"));\
	websWrite(wp, T("	document.test.okbutton.disabled = true;														\n"));\
	websWrite(wp, T("	for(i = 1; i <= secs; i++)															\n"));\
	websWrite(wp, T("	{																		\n"));\
	websWrite(wp, T("		setTimeout(\"update(\" + i + \")\", i * 1000);												\n"));\
	websWrite(wp, T("	}																		\n"));\
	websWrite(wp, T("	setTimeout(\"timer()\", wait);															\n"));\
	websWrite(wp, T("	function update(num, value)															\n"));\
	websWrite(wp, T("	{																		\n"));\
	websWrite(wp, T("		if (num == (wait/1000))															\n"));\
	websWrite(wp, T("		{																	\n"));\
	websWrite(wp, T("			document.test.okbutton.value = \"OK!\";												\n"));\
	websWrite(wp, T("		}																	\n"));\
	websWrite(wp, T("		else																	\n"));\
	websWrite(wp, T("		{																	\n"));\
	websWrite(wp, T("			printnr = (wait / 1000)-num;													\n"));\
	websWrite(wp, T("			document.test.okbutton.value = \"OK!\" + \"(\" + printnr + \")\";								\n"));\
	websWrite(wp, T("		}																	\n"));\
	websWrite(wp, T("	}																		\n"));\
	websWrite(wp, T("	function timer()																\n"));\
	websWrite(wp, T("	{																		\n"));\
	websWrite(wp, T("		document.test.okbutton.disabled = false;												\n"));\
	websWrite(wp, T("		document.test.okbutton.value = \"OK!\";													\n"));\
	websWrite(wp, T("	}																		\n"));\
	websWrite(wp, T("</script>																		\n"));\
	websWrite(wp, T("</body>																		\n"));\
	websFooter(wp); \
	websDone(wp, 200); \
}

#define WAIT_MSG_START_END(msg)\
{\
	websWrite(wp, T("<script>document.getElementById('msgActId').style.display=\"none\";</script>\n"));\
	websWrite(wp, T("%s"),msg);\
}

#define OK_MSG3_NOHEAD(msg, url)\
{\
	websWrite(wp, T("<h4>%s</h4>																	\n"),msg);\
	websWrite(wp, T("<form name=\"test\"><!--OK_MSG3_NOHEAD-->													\n"));\
	websWrite(wp, T("<script>																	\n"));\
	websWrite(wp, T("if( '%s' != '' )																\n"),url);\
	websWrite(wp, T("	if ( %d == 1 )																\n"),lanipChanged);\
	websWrite(wp, T("	document.write('<input type=button name=\"okbutton\" value=\"OK!\" style=\"width:100px\" OnClick=top.location.replace(\"%s\")>');	\n"),url);\
	websWrite(wp, T("	else																	\n"));\
	websWrite(wp, T("	document.write('<input type=button name=\"okbutton\" value=\"OK!\" style=\"width:100px\" OnClick=window.location.replace(\"%s\")>');	\n"),url);\
	websWrite(wp, T("else																		\n"));\
	websWrite(wp, T("	document.write('<input type=button name=\"okbutton\" value=\"OK!\" style=\"width:100px\" OnClick=window.close()>');			\n"));\
	websWrite(wp, T("</script>																	\n"));\
	websWrite(wp, T("</form>																	\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}

#define REDIRECT_NOHEAD(url)\
{\
	websWrite(wp, T("<script>document.location.replace(\"%s\")</script>"),url);\
	websFooter(wp);\
	websDone(wp, 200);\
}

#if defined(_Customer_)
#define ERR_MSG(msg)\
{\
	websWrite(wp, T("<!DOCTYPE html PUBLIC \"-\/\/W3C\/\/DTD XHTML 1.0 Transitional\/\/EN\" \"http:\/\/www.w3.org\/TR\/xhtml1\/DTD\/xhtml1-transitional.dtd\">\n"));\
	websWrite(wp, T("<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\">\n"));\
	websWrite(wp, T("<!--ERR_MSG--><head>\n"));\
	websWrite(wp, T("<head>\n"));\
	websWrite(wp, T("  <meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1'>\n"));\
	websWrite(wp, T("  <script type='text/javascript' src='/FUNCTION_SCRIPT'></script>\n"));\
	websWrite(wp, T("  <script type='text/javascript' src='/javascript.js'></script>\n"));\
	websWrite(wp, T("  <script type=\"text/javascript\" src=\"/file/allasp-n.var\"></script>\n"));\
	websWrite(wp, T("  <script type=\"text/javascript\" src=\"/file/multilanguage.var\"></script>\n"));\
	websWrite(wp, T("  <link rel=\"stylesheet\" href=\"/menu_style.css\">\n"));\
	websWrite(wp, T("  <link rel=\"stylesheet\" href=\"/style.css\">\n"));\
	websWrite(wp, T("<title>Error!</title>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<script>\n"));\
	websWrite(wp, T("document.write('<body>');\n"));\
	websWrite(wp, T("  \/\/========================Define some variable\n"));\
	websWrite(wp, T("  button_style = 'font-size: 0.8em; font-family: Arial;';\n"));\
	websWrite(wp, T("\n"));\
	websWrite(wp, T("  \/\/========================Show title and message\n"));\
	websWrite(wp, T("\n"));\
	websWrite(wp, T("    Write_Header_Menu(%d,%d);\n"),main_menu,sub_menu);\
	websWrite(wp, T("\n"));\
	websWrite(wp, T("  document.write('<div id=\"content\">');\n"));\
	websWrite(wp, T("  document.write('<div class=\"content\">');\n"));\
	websWrite(wp, T("  </script><p>%s</p><script>"),msg);\
	websWrite(wp, T("  document.write('<div align=\"center\">');\n"));\
	websWrite(wp, T("\n"));\
	websWrite(wp, T("document.write('<input type=button value=\"OK\" onClick=\"history.go (-1);\">');\n"));\
	websWrite(wp, T("  document.write('</div>');\n"));\
	websWrite(wp, T("  document.write('<p>&nbsp;</p>');\n"));\
	websWrite(wp, T("  document.write('<p>&nbsp;</p>');\n"));\
	websWrite(wp, T("  document.write('</div>');\n"));\
	websWrite(wp, T("  document.write('</div>');\n"));\
	websWrite(wp, T("  Write_Footer_Menu();\n"));\
	websWrite(wp, T("</script>\n"));\
	websWrite(wp, T("</body>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}
#elif defined(_BR6428PNL_)
#define ERR_MSG(msg)\
{\
	websHeader(wp);\
	websWrite(wp, T("<!--ERR_MSG--><head>\n"));\
	websWrite(wp, T("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Expires\" content=\"-1\">\n"));\
	websWrite(wp, T("<link rel=\"stylesheet\" href=\"/file/set.css\">\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/javascript.js\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/multilanguage.var\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/allasp-n.var\"></script>\n"));\
	websWrite(wp, T("<title>Error!</title>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body class=\"mainbg\">\n"));\
	websWrite(wp, T("<blockquote>\n"));\
	websWrite(wp, T("<br><a class=\"titlecolor\">%s</a><br><br>\n"),msg);\
	websWrite(wp, T("<script>\n"));\
	websWrite(wp, T("document.write('<input type=button value=\"'+showText(OK)+'\" class=\"button\" onClick=\"history.go (-1);\">');\n"));\
	websWrite(wp, T("</script>\n"));\
	websWrite(wp, T("</blockquote>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}
#else
#define ERR_MSG(msg)\
{\
	websHeader(wp);\
	websWrite(wp, T("<!--ERR_MSG--><head>\n"));\
	websWrite(wp, T("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Expires\" content=\"-1\">\n"));\
	websWrite(wp, T("<link rel=\"stylesheet\" href=\"/file/set.css\">\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/javascript.js\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/multilanguage.var\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/allasp-n.var\"></script>\n"));\
	websWrite(wp, T("<title>Error!</title>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body class=\"mainbg\">\n"));\
	websWrite(wp, T("<blockquote>\n"));\
	websWrite(wp, T("<br><a class=\"titlecolor\">%s</a><br><br>\n"),msg);\
	websWrite(wp, T("<script>\n"));\
	websWrite(wp, T("document.write('<input type=button value=\"'+showText(OK)+'\" class=\"button\" onClick=\"history.go (-1);\">');\n"));\
	websWrite(wp, T("</script>\n"));\
	websWrite(wp, T("</blockquote>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}
#endif

#define ERR_MSG1(msg)\
{\
	websHeader(wp);\
	websWrite(wp, T("<!--ERR_MSG--><head>\n"));\
	websWrite(wp, T("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Expires\" content=\"-1\">\n"));\
	websWrite(wp, T("<link rel=\"stylesheet\" href=\"/file/set.css\">\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/javascript.js\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/multilanguage.var\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/allasp-n.var\"></script>\n"));\
	websWrite(wp, T("<title>Error!</title>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body class=\"mainbg\">\n"));\
	websWrite(wp, T("<blockquote>\n"));\
	websWrite(wp, T("<br><a class=\"titlecolor\">%s</a><br><br>\n"),msg);\
	websWrite(wp, T("<script>\n"));\
websWrite(wp, T("document.write('<input type=button value=\"'+showText(OK)+'\" class=\"button\" onClick=\"window.location.replace(\\\'\/tlupgrade.asp\\\');\">');\n"));\
	websWrite(wp, T("</script>\n"));\
	websWrite(wp, T("</blockquote>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}

#define LAN_MSG(url)\
{\
	websHeader(wp);\
	websWrite(wp, T("<head>																				\n"));\
	websWrite(wp, T("  <script>                                                                                                                                                                                             \n"));\
	websWrite(wp, T("  if( _MODE_ == 'Customer330' || _MODE_ == 'Customer331' ) document.write('<link href=\"/file/set.css\" type=\"text/css\" rel=\"stylesheet\">');                                                              \n"));\
	websWrite(wp, T("  else                                                    document.write('<link href=\"/file/set.css\" type=\"text/css\" rel=\"stylesheet\">');                                                             \n"));\
	websWrite(wp, T("  </script>                                                                                                                                                                                            \n"));\
	websWrite(wp, T("	<meta http-equiv='Content-Type' content='text/html; charset=%s'>											\n"),charset);\
	websWrite(wp, T("	<script language='javascript' src='/javascript.js'></script>												\n"));\
	websWrite(wp, T("	<script language='javascript' src='/file/allasp-n.var'></script>											\n"));\
	websWrite(wp, T("	<title>LAN_MSG!</title>																	\n"));\
	websWrite(wp, T("</head><!--LAN_MSG-->																		\n"));\
	websWrite(wp, T("<body class=\"background\">																	\n"));\
	websWrite(wp, T("<blockquote>																			\n"));\
	websWrite(wp, T("	<h4 class=\"textcolor\">eeee!</h4>															\n"));\
	websWrite(wp, T("	<form>																			\n"));\
	websWrite(wp, T("	<script>																		\n"));\
	websWrite(wp, T("	if ( '%s' != '' )																	\n"),url);\
	websWrite(wp, T("		document.write('<input name=\"okbutton\" type=button value=\"OK\" style=\"width:100px\" OnClick=parent.location.replace(\"http://%s\")>');	\n"),url);\
	websWrite(wp, T("	else																			\n"));\
	websWrite(wp, T("		document.write('<input name=\"okbutton\" type=button value=\"OK\" style=\"width:100px\" OnClick=window.close()>');				\n"));\
	websWrite(wp, T("	</script>																		\n"));\
	websWrite(wp, T("	</form>																			\n"));\
	websWrite(wp, T("	<script>																		\n"));\
	websWrite(wp, T("    document.write('</blockquote>');                                                                                                                                                                   \n"));\
	websWrite(wp, T("</script>                                                                                                                                                                                              \n"));\
	websWrite(wp, T("</body>																			\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}

#if defined(_Customer_)
#define UPGRADE_PROCESS_MSG(){\
	websHeader(wp);\
	websWrite(wp, T("<head>\n"));\
	websWrite(wp, T("	<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>\n"));\
	websWrite(wp, T("	<title>Success!</title>\n"));\
	websWrite(wp, T("	<style type=\"text/css\">\n"));\
	websWrite(wp, T("		#out{width:300px;height:20px;background:#CCCCCC;}\n"));\
	websWrite(wp, T("		#in{width:0px; height:20px;background:#0080FF;color:#000000;text-align:center;}\n"));\
	websWrite(wp, T("		.background{	background-color:#EEEEEE;	color:#000000;	font-family:Arial, Helvetica; }\n"));\
	websWrite(wp, T("	</style>\n"));\
	websWrite(wp, T("	<script>\n"));\
	websWrite(wp, T("		function getCookie(c_name)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			if (document.cookie.length>0)\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				c_start=document.cookie.indexOf(c_name + \"=\")\n"));\
	websWrite(wp, T("				if (c_start!=-1)\n"));\
	websWrite(wp, T("				{\n"));\
	websWrite(wp, T("					c_start=c_start + c_name.length+1;\n"));\
	websWrite(wp, T("					c_end=document.cookie.indexOf(\";\",c_start);\n"));\
	websWrite(wp, T("					if (c_end==-1) c_end=document.cookie.length;\n"));\
	websWrite(wp, T("					return unescape(document.cookie.substring(c_start,c_end));\n"));\
	websWrite(wp, T("				}\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("			else\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("					if (navigator.appName == 'Netscape') var lan = navigator.language.toLowerCase();\n"));\
	websWrite(wp, T("					else                                 var lan = navigator.browserLanguage;\n"));\
	websWrite(wp, T("					switch(lan.substr(0,2))\n"));\
	websWrite(wp, T("					{\n"));\
	websWrite(wp, T("						case \"zh\": return 1;\n"));\
	websWrite(wp, T("						case \"en\": return 1;\n"));\
	websWrite(wp, T("						default:    return 1;\n"));\
	websWrite(wp, T("					}\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		var firmware_upgrading=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"Firmware upgrading, please wait.\",\n"));\
	websWrite(wp, T("		\"ファームウェア更新中、しばらくお待ちください。\",\n"));\
	websWrite(wp, T("		\"軔體更新，請稍候。\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("		var upgrade_accomplished=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"Upgrade Accomplished.\",\n"));\
	websWrite(wp, T("		\"アップデートが完了しました。\",\n"));\
	websWrite(wp, T("		\"更新完成。\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("		var upgrade_accomplished_content=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"You should be able to reconnect to the router by refreshing the web page now. If not, please restart the router by reconnecting the power line manually.\",\n"));\
	websWrite(wp, T("		\"ブラウザのページを更新すると再接続できます。失敗した場合は、本製品の電源を入れなおして再起動してください。\",\n"));\
	websWrite(wp, T("		\"更新瀏覽器網頁可重新連線。失敗的話請重新開啟分享器電源或重新啟動\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("		var stype = getCookie('language');\n"));\
	websWrite(wp, T("		function showText(text)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			if(text[stype]==\"\") return text[0];\n"));\
	websWrite(wp, T("			else				return text[stype];\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		function dw(message,defaultMs)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			document.write(showText(message));\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("	</script>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body class=\"background\" onload=\"start();\">\n"));\
	websWrite(wp, T("	<div id='counting'>\n"));\
	websWrite(wp, T("		<blockquote><h4><script>dw(firmware_upgrading)</script></h4>\n"));\
	websWrite(wp, T("	<div id='out'>\n"));\
	websWrite(wp, T("		<div id=\"in\" style=\"width:0%%\">0%%</div>\n"));\
	websWrite(wp, T("	</div></blockquote>\n"));\
	websWrite(wp, T("	</div>\n"));\
	websWrite(wp, T("	<script type=\"text/javascript\">\n"));\
	websWrite(wp, T("		i=0;secs=80;\n"));\
	websWrite(wp, T("		function start()\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			ba=setInterval(\"begin()\",secs*10);\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		function begin()\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			i+=1;\n"));\
	websWrite(wp, T("			if(i<=100)\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				document.getElementById(\"in\").style.width=i+\"%%\";\n"));\
	websWrite(wp, T("				document.getElementById(\"in\").innerHTML=i+\"%%\";\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("			else\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				clearInterval(ba);\n"));\
	websWrite(wp, T("				document.getElementById(\"counting\").style.display=\"none\";\n"));\
	websWrite(wp, T("				document.write(\"<head>\");\n"));\
	websWrite(wp, T("				document.write(\"	<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>\");\n"));\
	websWrite(wp, T("				document.write(\"	<title>Success!</title>\");\n"));\
	websWrite(wp, T("				document.write(\"	<style type=\\\"text/css\\\">\");\n"));\
	websWrite(wp, T("				document.write(\"		.background{ background-color:#EEEEEE; color:#000000; font-family:Arial, Helvetica;}\");\n"));\
	websWrite(wp, T("				document.write(\"	</style>\");\n"));\
	websWrite(wp, T("				document.write(\"</head>\");\n"));\
	websWrite(wp, T("				document.write(\"<body class=\\\"background\\\">\");\n"));\
	websWrite(wp, T("				document.write(\"	<blockquote>\");\n"));\
	websWrite(wp, T("				document.write(\"		<h4>\"+showText(upgrade_accomplished)+\"</h4>\");\n"));\
	websWrite(wp, T("				document.write(\"		<br>\");\n"));\
	websWrite(wp, T("				document.write(\"		<font size=\\\"2\\\" class=\\\"textcolor\\\">\"+showText(upgrade_accomplished_content)+\"</font>\");\n"));\
	websWrite(wp, T("				document.write(\"	</blockquote>\");\n"));\
	websWrite(wp, T("				document.write(\"</body>\");\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("	</script>\n"));\
	websWrite(wp, T("</body>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}
#elif defined(_Customer_)
#define UPGRADE_PROCESS_MSG(){\
	websWrite(wp, T("<!DOCTYPE html PUBLIC \"-\/\/W3C\/\/DTD XHTML 1.0 Transitional\/\/EN\"\"http:\/\/www.w3.org\/TR\/xhtml1\/DTD\/xhtml1-transitional.dtd\">\n"));\
	websWrite(wp, T("<html xmlns=\"http:\/\/www.w3.org/1999/xhtml\">\n"));\
        websWrite(wp, T("<!--UPGRADE_PROCESS_MSG-->\n"));\
	websWrite(wp, T("<head>\n"));\
	websWrite(wp, T("<title>CustomerTech - HWREN15</title>\n"));\
	websWrite(wp, T("<meta http-equiv=\"Content-Type\"content=\"text/html; charset=iso-8859-1\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"PRAGMA\" content=\"NO-CACHE\">\n"));\
	websWrite(wp, T("<style type=\"text/css\">\n"));\
	websWrite(wp, T("	* {	padding: 0;	margin: 5;}\n"));\
	websWrite(wp, T("	a:link {color: #666; text-decoration: underline;}\n"));\
	websWrite(wp, T("	a:visited {color: #666; text-decoration: underline;}\n"));\
	websWrite(wp, T("	a:active {color: #666; text-decoration: underline;}\n"));\
	websWrite(wp, T("	a:hover {color: #666; text-decoration: underline;}\n"));\
	websWrite(wp, T("	.footer a:link {color: #a0afb9; text-decoration: none; }\n"));\
	websWrite(wp, T("	.footer a:visited {color: #a0afb9; text-decoration: underline;}\n"));\
	websWrite(wp, T("	.footer a:hover {color: #ffffff; text-decoration: underline;}\n"));\
	websWrite(wp, T("	.footer a:active {color: #a0afb9; text-decoration: none; } \n"));\
	websWrite(wp, T("	body {	margin:0px 20px 20px 0px; 	background:#e1e1e1; 	color: #333333;\n"));\
	websWrite(wp, T("	 	text-align:center;	padding:0; 	font:0.9em Arial, Helvetica, sans-serif;\n"));\
	websWrite(wp, T("		behavior: url(script/csshover2.htc); for ie6}\n"));\
	websWrite(wp, T("	h3, p { 	margin:0; 	padding:20px; 	text-align:left;}\n"));\
	websWrite(wp, T("	h4 { 	margin:0;  	padding:5px 0;}\n"));\
	websWrite(wp, T("	#righthdr {	text-align: right;	padding: 64px 20px 0px 0px;}\n"));\
	websWrite(wp, T("	.title {	font-size: 0.9em;	font-weight:bold;	color:#e1e1e1;}\n"));\
	websWrite(wp, T("	.modeltxt {	font-size: 0.7em;	color:#999999;}\n"));\
	websWrite(wp, T("	.ind { 	font:0.8em Arial, Helvetica, sans-serif;	padding-left:2px;	vertical-align:middle;	padding-top:4px;}\n"));\
	websWrite(wp, T("	#outer { 	text-align:left; 	border:0px solid #000000; 	width:850px; 	margin:auto;}\n"));\
	websWrite(wp, T("	#hdr { 	height:102px; 	background:#eeeeee; 	color:#333333;}\n"));\
	websWrite(wp, T("	#mainimg {        height:175px;        background:#c0c0c0;        color: #333333;\n"));\
	websWrite(wp, T("	        border:solid #000000;        border-width:1px 0 1px 0;\n"));\
	websWrite(wp, T("			background-image: url(\"/images/main_welcome.gif\");        background-repeat: no-repeat;}\n"));\
	websWrite(wp, T("	#wrapper {	background-repeat: no-repeat;	position:relative;	background-color: #333333;\n"));\
	websWrite(wp, T("		color: #ffffff;	width:850px;	padding:0;}\n"));\
	websWrite(wp, T("	#leftcol {	float:left;	width:200px;	padding: 20px 0px 50px 0px;	background-color: #333333;}\n"));\
	websWrite(wp, T("	#content {	width:640px;	background:#ffffff;	color: #333333;	text-align:left;}\n"));\
	websWrite(wp, T("	 #footer {	background: #333;	float: right;	list-style: none;	margin-left:0;\n"));\
	websWrite(wp, T("	#mainimg { 	height:175px; 	background:#c0c0c0; 	color: #333333; 	border:solid #000000;	\n"));\
	websWrite(wp, T("	 	border-width:1px 0 1px 0;	background-image: url(\"/images/main_welcome.gif\");	background-repeat: no-repeat;} \n"));\
	websWrite(wp, T("	#loginbox {	float:right;	padding:20px; 	margin-right: 10px;}\n"));\
	websWrite(wp, T("		padding: 0;	width: 100%%;	border-top:5px solid #225c83;	padding: 20px 0px 20px 0px;	height: auto;}\n"));\
	websWrite(wp, T("	.contenttut {	background-image: url('images/bg_leftshade.png');	border:none;	background-repeat: repeat-y;\n"));\
	websWrite(wp, T("		padding-top:0px;	border-left:2px solid #cccccc;	min-height:500px; /*ff*/	height: auto !important; /*ie7 */\n"));\
	websWrite(wp, T("		height: 500px; /*ie6 */}\n"));\
	websWrite(wp, T("	.footbox {		font-size: 0.7em;		text-align:left;	clear: both;	margin: 0px;	padding: 0px 0px 0px 20px;\n"));\
	websWrite(wp, T("		height: auto;	color: #a0afb9;	line-height: 1.4em;}\n"));\
	websWrite(wp, T("	.content {	background-image: url('images/bg_leftshade.png');	background-repeat: repeat-y;	padding-top:10px;\n"));\
	websWrite(wp, T("		border-left:2px solid #cccccc;	min-height:500px; /*ff*/	height: auto !important; /*ie7 */	height: 500px;	margin-top: 0px;}\n"));\
	websWrite(wp, T("	ul.logintxt { 	font: 0.6em Arial, Helvetica, sans-serif; 	text-transform: uppercase; 	text-align:right;\n"));\
	websWrite(wp, T("	 	letter-spacing: 0.5px; 	color: #e1e1e1; 	list-style:none;}\n"));\
	websWrite(wp, T("	ul.loginblk { 	font: 0.6em Arial, Helvetica, sans-serif; 	text-transform: uppercase; 	text-align:right;\n"));\
	websWrite(wp, T("	 	letter-spacing: 0.5px; 	color: #555555; 	list-style:none;}\n"));\
	websWrite(wp, T("	.loginblk {	padding:20px;	width:400px;	text-align:center;}\n"));\
	websWrite(wp, T("	ul li {	padding: 2px;}\n"));\
	websWrite(wp, T("	.button {	float: right;	float: right;}\n"));\
	websWrite(wp, T("	.arrow {	background-image: url('images/img_arrow.png');	background-repeat: no-repeat;\n"));\
	websWrite(wp, T("		vertical-align: bottom;	float:inherit;}\n"));\
	websWrite(wp, T("	.status { 	font: 0.9em  Arial, Helvetica, sans-serif;	font-weight:bold;\n"));\
	websWrite(wp, T("	 	text-transform: uppercase; 	text-align:right; 	color: #555555;}\n"));\
	websWrite(wp, T("	table {	font-size: 1.0em;	border-top-width: 0px;	border-right-width: 0px;	border-bottom-width: 0px;\n"));\
	websWrite(wp, T("		border-left-width: 0px;	border-top-style: none;	border-right-style: none;	border-bottom-style: none;	border-left-style: none;}\n"));\
	websWrite(wp, T("	table th {}\n"));\
	websWrite(wp, T("	table tr th {}\n"));\
	websWrite(wp, T("	table tr td {	padding: 10px; 	margin: 10px; }\n"));\
	websWrite(wp, T("	table.reg td {	color:#333333;	text-align: left;	padding: 5px;}\n"));\
	websWrite(wp, T("	table.reg {	font-size: 1.0em;	padding-top: 12px;	border-collapse: collapse;}\n"));\
	websWrite(wp, T("	table.reg th {	color:#024072;}\n"));\
	websWrite(wp, T("	table.reg tr th {	padding: 6px 10px 2px 10px;	font-weight: bold;	text-align: left;\n"));\
	websWrite(wp, T("		color:#f1f1f1;	border-bottom: 2px solid #393939;	background-color: #333333;	font-size: 11px;}\n"));\
	websWrite(wp, T("	table td {	font-size: 1.0em;	color:#333333;	text-align: left;}\n"));\
	websWrite(wp, T("	table.tbl {	font-size: 0.9em;	padding-top: 10px;	border: 2px;	border-color: #CCCCCC;}\n"));\
	websWrite(wp, T("	table.tbl th {	color:#e1e1e1;	background-color:#333333;}\n"));\
	websWrite(wp, T("	table.tbl tr th {	font-size: 0.9em;	border-bottom: #407da5 2px solid;	padding: 6px 10px 4px 10px;\n"));\
	websWrite(wp, T("		font-weight: bold;	text-align: left;	color:#e1e1e1;}\n"));\
	websWrite(wp, T("	table.tbl td {	font-size: 0.9em;	color:#333333;	text-align: left;	padding: 10px 10px 5px 10px;}\n"));\
	websWrite(wp, T("	.note {	font-size: 0.9em;	color: #666666;	font-weight: normal;}\n"));\
	websWrite(wp, T("	.gray {color: #666666;  font-weight: bold; }\n"));\
	websWrite(wp, T("	.green {color:#28903A; font-weight:bold; }\n"));\
	websWrite(wp, T("	.red {color: #971B1E; font-weight:bold; }\n"));\
	websWrite(wp, T("	.style1 {color: #006699;        font-weight: bold;}\n"));\
	websWrite(wp, T("	#out{width:300px;height:20px;background:#CCCCCC;}\n"));\
	websWrite(wp, T("	#in{width:0px; height:20px;background:#225c83;color:#000000;text-align:center;}\n"));\
	websWrite(wp, T("	#menu {	background: #333; float: right;	list-style: none;	margin-left:0px;	padding: 0;	width: 100%%;	border-bottom:10px solid #225c83;}\n"));\
	websWrite(wp, T("	#menu ul {	list-style: none;}\n"));\
	websWrite(wp, T("	#menu li {	float: left;	margin: 0;	padding: 0;\n"));\
	websWrite(wp, T("		font-family: \"Lucida Sans Unicode\", \"Bitstream Vera Sans\", \"Trebuchet Unicode MS\", \"Lucida Grande\", Verdana, Helvetica, sans-serif;\n"));\
	websWrite(wp, T("		font-size: 10pt;}\n"));\
	websWrite(wp, T("	#menu a {	background: #333 url(\"images/seperator.gif\") bottom right no-repeat;\n"));\
	websWrite(wp, T("		border-right: 1px solid #393939;	color: #ccc;	display: block;	float: left;\n"));\
	websWrite(wp, T("		margin: 0;	text-decoration: none;	padding-top: 8px;	padding-right: 14px;\n"));\
	websWrite(wp, T("		padding-bottom: 8px;	padding-left: 14px;}\n"));\
	websWrite(wp, T("	#menu a:hover {	background: #225c83 url(\"images/arrow_top.png\") top center no-repeat;	color: #fff;\n"));\
	websWrite(wp, T("		padding-bottom: 8px;	font-size: 10pt;}\n"));\
	websWrite(wp, T("	#menu ul .current a {	background: #225c83 url(\"images/arrow_top.png\") top center no-repeat;	color: #fff;\n"));\
	websWrite(wp, T("		padding-bottom: 8px;	font-size: 10pt;\n"));\
	websWrite(wp, T("		font-family: \"Lucida Sans Unicode\", \"Bitstream Vera Sans\", \"Trebuchet Unicode MS\", \"Lucida Grande\", Verdana, Helvetica, sans-serif;}\n"));\
	websWrite(wp, T("	#lftmenu {	background: #333;	list-style: none;	margin: 0;\n"));\
	websWrite(wp, T("		padding: 0;	width: 12em;	border-top:0px solid #393939;\n"));\
	websWrite(wp, T("		border-left:2px solid #225c83;	border-bottom:0px solid #393939;}\n"));\
	websWrite(wp, T("	#lftmenu ul {	list-style: none;}\n"));\
	websWrite(wp, T("	#lftmenu ol {	list-style: none;}\n"));\
	websWrite(wp, T("	#lftmenu li {\n"));\
	websWrite(wp, T("		font: 80%% \"Lucida Sans Unicode\", \"Bitstream Vera Sans\", \"Trebuchet Unicode MS\", \"Lucida Grande\", Verdana, Helvetica, sans-serif;\n"));\
	websWrite(wp, T("		margin: 0;	padding: 0;}\n"));\
	websWrite(wp, T("	#lftmenu a {	background: #333;	border-bottom: 1px solid #393939;\n"));\
	websWrite(wp, T("		color: #ccc;	display: block;	margin: 0;	padding: 8px 12px 8px 20px;\n"));\
	websWrite(wp, T("		text-decoration: none;	font-weight:normal;}\n"));\
	websWrite(wp, T("	#lftmenu a:hover {	background: #225c83 url(\"images/arrow_lft.png\") left center no-repeat;\n"));\
	websWrite(wp, T("		color: #fff;	padding-bottom: 8px;}\n"));\
	websWrite(wp, T("	#lftmenu ul .lftcurrent a {	background: #225c83 url(\"images/arrow_lft.png\") left center no-repeat;\n"));\
	websWrite(wp, T("		color: #fff;	padding-bottom: 8px;}\n"));\
	websWrite(wp, T("	#lftmenu ul li ul {	visibility:hidden;	margin: 0;	padding: 0;}\n"));\
	websWrite(wp, T("	#lftmenu .secmenu {\n"));\
	websWrite(wp, T("		font: 100%% \"Lucida Sans Unicode\", \"Bitstream Vera Sans\", \"Trebuchet Unicode MS\", \"Lucida Grande\", Verdana, Helvetica, sans-serif;\n"));\
	websWrite(wp, T("		color: #ccc;	display: block;	margin: 0;	padding: 4px 12px 10px 10px;	text-decoration: none;	font-weight:normal;}\n"));\
	websWrite(wp, T("	#lftmenu .secmenu a {	background: #333;	border-bottom: 1px dotted #393939;	color: #ccc;\n"));\
	websWrite(wp, T("		display: block;	margin: 0;	padding: 4px 12px 6px 20px;	text-decoration: none;	font-weight:normal;}\n"));\
	websWrite(wp, T("	#lftmenu .secmenu li a {	background: none; !important}\n"));\
	websWrite(wp, T("	#lftmenu ul .lftcurrent2 a {	background: #29465a; !important}\n"));\
	websWrite(wp, T("</style>\n"));\
	websWrite(wp, T("<script>\n"));\
	websWrite(wp, T("	function getCookie(c_name)\n"));\
	websWrite(wp, T("       {\n"));\
	websWrite(wp, T("       	if (document.cookie.length>0)\n"));\
	websWrite(wp, T("               {\n"));\
	websWrite(wp, T("               	c_start=document.cookie.indexOf(c_name + \"=\")\n"));\
	websWrite(wp, T("                       if (c_start!=-1)\n"));\
	websWrite(wp, T("                       {\n"));\
	websWrite(wp, T("                       	c_start=c_start + c_name.length+1;\n"));\
	websWrite(wp, T("                               c_end=document.cookie.indexOf(\";\",c_start);\n"));\
	websWrite(wp, T("                               if (c_end==-1) c_end=document.cookie.length;\n"));\
	websWrite(wp, T("                               return unescape(document.cookie.substring(c_start,c_end));\n"));\
	websWrite(wp, T("                       }\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("               else\n"));\
	websWrite(wp, T("               {\n"));\
	websWrite(wp, T("               	return 0;\n"));\
	websWrite(wp, T("               }\n"));\
	websWrite(wp, T("	}\n"));\
	websWrite(wp, T("       var stype = getCookie('language');\n"));\
	websWrite(wp, T("       function showText(text)\n"));\
	websWrite(wp, T("       {\n"));\
	websWrite(wp, T("       	if(text[stype]==\"\") return text[0];\n"));\
	websWrite(wp, T("               else                            return text[stype];\n"));\
	websWrite(wp, T("       }\n"));\
	websWrite(wp, T("       function dw(message,defaultMs)\n"));\
	websWrite(wp, T("       {\n"));\
	websWrite(wp, T("       	document.write(showText(message));\n"));\
	websWrite(wp, T("       }\n"));\
	websWrite(wp, T("       var firmware_upgrading=new Array\n"));\
	websWrite(wp, T("       (\n"));\
	websWrite(wp, T("       	\"Firmware upgrading, please wait.\"\n"));\
	websWrite(wp, T("       );\n"));\
	websWrite(wp, T("       var upgrade_accomplished=new Array\n"));\
	websWrite(wp, T("       (\n"));\
	websWrite(wp, T("       	\"Upgrade Accomplished.\"\n"));\
	websWrite(wp, T("       );\n"));\
	websWrite(wp, T("       var upgrade_accomplished_content=new Array\n"));\
	websWrite(wp, T("       (\n"));\
	websWrite(wp, T("       	\"You should be able to reconnect to the router by refreshing the web page now. If not, please restart the router by reconnecting the power line manually.\"\n"));\
	websWrite(wp, T("        );\n"));\
	websWrite(wp, T("</script>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body onload=\"//start();\">\n"));\
	websWrite(wp, T("<div id=\"outer\">\n"));\
	websWrite(wp, T("	<div id=\"mainimg\">\n"));\
	websWrite(wp, T("		<div id=\"righthdr\">\n"));\
	websWrite(wp, T("			<div class=\"title\">Hi-Gain&#8482; Wireless-150N Mini Range Extender</div>\n"));\
	websWrite(wp, T("			<div class=\"modeltxt\">HWREN15</div>\n"));\
	websWrite(wp, T("		</div>\n"));\
	websWrite(wp, T("	</div>\n"));\
	websWrite(wp, T("	<div id=\"wrapper\" align=\"right\">\n"));\
	websWrite(wp, T("		<div>\n"));\
	websWrite(wp, T("			<div id=\"menu\">\n"));\
	websWrite(wp, T("				<ul>\n"));\
	websWrite(wp, T("					<li><div style=\"width:146px;\">&nbsp;</div></li>\n"));\
	websWrite(wp, T("					<li><a href=\"/index.asp\">Quick Setup</a></li>\n"));\
	websWrite(wp, T("					<li><a href=\"/information.asp\">Status</a></li>\n"));\
	websWrite(wp, T(" 					<li><a href=\"/macfilter1.asp\">Security</a></li>\n"));\
	websWrite(wp, T("					<li><a href=\"/wladvance.asp\">Advanced&nbsp;Settings</a></li>\n"));\
	websWrite(wp, T("					<li><a href=\"/backup.asp\">Configuration</a></li>\n"));\
 	websWrite(wp, T("					<li class=\"current\"><a href=\"/upgrade.asp\">Upgrade</a></li>\n"));\
	websWrite(wp, T("					<li><a href=\"/reset.asp\">Reset</a></li>\n"));\
	websWrite(wp, T("				</ul>\n"));\
	websWrite(wp, T("			</div>\n"));\
	websWrite(wp, T("		</div>\n"));\
	websWrite(wp, T("		<div style=\"background:#407da5; height:45px;\"></div>\n"));\
	websWrite(wp, T("		<div id=\"content\">\n"));\
	websWrite(wp, T("             		<h3 align=\"aleft\" class=\"arrow\"><script>dw(firmware_upgrading);</script></h3>\n"));\
	websWrite(wp, T("			<div id='counting' align=\"center\">\n"));\
	websWrite(wp, T("               		<blockquote>\n"));\
	websWrite(wp, T("                       		<div id='out' align=\"left\">\n"));\
	websWrite(wp, T("                               		<div id=\"in\" style=\"width:0%%\">0%%</div>\n"));\
	websWrite(wp, T("               			</div>\n"));\
	websWrite(wp, T("               		</blockquote>\n"));\
	websWrite(wp, T("			</div>\n"));\
	websWrite(wp, T("			<p>&nbsp;</p>\n"));\
	websWrite(wp, T("			<p>&nbsp;</p>\n"));\
	websWrite(wp, T("			<p>&nbsp;</p>\n"));\
	websWrite(wp, T("       	</div>\n"));\
	websWrite(wp, T("       </div>\n"));\
	websWrite(wp, T("       <script type=\"text/javascript\">\n"));\
	websWrite(wp, T("               i=0;secs=95;\n"));\
	websWrite(wp, T("               function start()\n"));\
        websWrite(wp, T("               {\n "));\
	websWrite(wp, T("                       ba=setInterval(\"begin()\",secs*10);\n"));\
        websWrite(wp, T("               }\n "));\
	websWrite(wp, T("               function begin()\n"));\
	websWrite(wp, T("               {\n"));\
	websWrite(wp, T("                       i+=1;\n"));\
	websWrite(wp, T("                       if(i<=100)\n"));\
        websWrite(wp, T("                       {\n"));\
	websWrite(wp, T("                               document.getElementById(\"in\").style.width=i+\"%%\";\n"));\
	websWrite(wp, T("                               document.getElementById(\"in\").innerHTML=i+\"%%\";\n"));\
	websWrite(wp, T("                       }\n"));\
	websWrite(wp, T("                       else\n"));\
	websWrite(wp, T("                       {\n"));\
	websWrite(wp, T("                               parent.location.replace(\"/index.asp\");\n"));\
	websWrite(wp, T("                               clearInterval(ba);\n"));\
	websWrite(wp, T("                               document.getElementById(\"counting\").style.display=\"none\";\n"));\
	websWrite(wp, T("						}\n"));\
	websWrite(wp, T("				}\n"));\
	websWrite(wp, T("       </script>\n"));\
	websWrite(wp, T("       <div id=\"footer\">\n"));\
	websWrite(wp, T("               <div class=\"footbox\">\n"));\
	websWrite(wp, T("                       <div class=\"footer\">&#169; 2011<a href=\"http:\/\/www.Customertech.com\/\"> Customer Technologies, Inc.</a><br />\n"));\
	websWrite(wp, T("                               All rights reserved. </div>\n"));\
	websWrite(wp, T("               </div>\n"));\
	websWrite(wp, T("       </div>\n"));\
	websWrite(wp, T("</div>\n"));\
	websWrite(wp, T("</body>\n"));\
        websWrite(wp, T("<script>\n"));\
        websWrite(wp, T("start();\n"));\
        websWrite(wp, T("</script>\n"));\
	websWrite(wp, T("</html>\n"));\
	websDone(wp, 200);\
}
#elif defined(_BR6428PNL_)
#define UPGRADE_PROCESS_MSG(){\
	websHeader(wp);\
	websWrite(wp, T("<head>\n"));\
	websWrite(wp, T("	<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>\n"));\
	websWrite(wp, T("	<title>Success!</title>\n"));\
	websWrite(wp, T("	<style type=\"text/css\">\n"));\
	websWrite(wp, T("		#out{width:300px;height:20px;background:#CCCCCC;}\n"));\
	websWrite(wp, T("		#in{width:0px; height:20px;background:#0080FF;color:#000000;text-align:center;}\n"));\
	websWrite(wp, T("		.background{	background-color:#EEEEEE;	color:#000000;	font-family:Arial, Helvetica; }\n"));\
	websWrite(wp, T("	</style>\n"));\
	websWrite(wp, T("	<script>\n"));\
	websWrite(wp, T("		function getCookie(c_name)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			if (document.cookie.length>0)\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				c_start=document.cookie.indexOf(c_name + \"=\")\n"));\
	websWrite(wp, T("				if (c_start!=-1)\n"));\
	websWrite(wp, T("				{\n"));\
	websWrite(wp, T("					c_start=c_start + c_name.length+1;\n"));\
	websWrite(wp, T("					c_end=document.cookie.indexOf(\";\",c_start);\n"));\
	websWrite(wp, T("					if (c_end==-1) c_end=document.cookie.length;\n"));\
	websWrite(wp, T("					return unescape(document.cookie.substring(c_start,c_end));\n"));\
	websWrite(wp, T("				}\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("			else\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				return 1;\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		var stype = getCookie('language');\n"));\
	websWrite(wp, T("		function showText(text)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			if(text[stype]==\"\") return text[0];\n"));\
	websWrite(wp, T("			else				return text[stype];\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		function dw(message,defaultMs)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			document.write(showText(message));\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		var firmware_upgrading=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"Firmware upgrading, please wait.\",\n"));\
	websWrite(wp, T("		\"ファームウェア更新中、しばらくお待ちください。\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("		var upgrade_accomplished=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"Upgrade Accomplished.\",\n"));\
	websWrite(wp, T("		\"アップデートが完了しました。\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("		var upgrade_accomplished_content=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"You should be able to reconnect to the router by refreshing the web page now. If not, please restart the router by reconnecting the power line manually.\",\n"));\
	websWrite(wp, T("		\"ブラウザのページを更新すると再接続できます。失敗した場合は、2分ほど待ってからブラウザのページを更新してください。それでも失敗した場合は、本製品の電源を入れなおして再起動してください。\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("	</script>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body class=\"background\" onload=\"start();\">\n"));\
	websWrite(wp, T("	<div id='counting'>\n"));\
	websWrite(wp, T("		<blockquote><h4><script>dw(firmware_upgrading)</script></h4>\n"));\
	websWrite(wp, T("	<div id='out'>\n"));\
	websWrite(wp, T("		<div id=\"in\" style=\"width:0%%\">0%%</div>\n"));\
	websWrite(wp, T("	</div></blockquote>\n"));\
	websWrite(wp, T("	</div>\n"));\
	websWrite(wp, T("	<script type=\"text/javascript\">\n"));\
	websWrite(wp, T("		i=0;secs=95;\n"));\
	websWrite(wp, T("		function start()\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			ba=setInterval(\"begin()\",secs*10);\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		function begin()\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			i+=1;\n"));\
	websWrite(wp, T("			if(i<=100)\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				document.getElementById(\"in\").style.width=i+\"%%\";\n"));\
	websWrite(wp, T("				document.getElementById(\"in\").innerHTML=i+\"%%\";\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("			else\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				clearInterval(ba);\n"));\
	websWrite(wp, T("				document.getElementById(\"counting\").style.display=\"none\";\n"));\
	websWrite(wp, T("				document.write(\"<head>\");\n"));\
	websWrite(wp, T("				document.write(\"	<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>\");\n"));\
	websWrite(wp, T("				document.write(\"	<title>Success!</title>\");\n"));\
	websWrite(wp, T("				document.write(\"	<style type=\\\"text/css\\\">\");\n"));\
	websWrite(wp, T("				document.write(\"		.background{ background-color:#EEEEEE; color:#000000; font-family:Arial, Helvetica;}\");\n"));\
	websWrite(wp, T("				document.write(\"	</style>\");\n"));\
	websWrite(wp, T("				document.write(\"</head>\");\n"));\
	websWrite(wp, T("				document.write(\"<body class=\\\"background\\\">\");\n"));\
	websWrite(wp, T("				document.write(\"	<blockquote>\");\n"));\
	websWrite(wp, T("				document.write(\"		<h4>\"+showText(upgrade_accomplished)+\"</h4>\");\n"));\
	websWrite(wp, T("				document.write(\"		<br>\");\n"));\
	websWrite(wp, T("				document.write(\"		<font size=\\\"2\\\" class=\\\"textcolor\\\">\"+showText(upgrade_accomplished_content)+\"</font>\");\n"));\
	websWrite(wp, T("				document.write(\"	</blockquote>\");\n"));\
	websWrite(wp, T("				document.write(\"</body>\");\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("	</script>\n"));\
	websWrite(wp, T("</body>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}
#elif defined(_Airlive_7428HCN_)
#define UPGRADE_PROCESS_MSG(){\
	websHeader(wp);\
	websWrite(wp, T("<head>\n"));\
	websWrite(wp, T("	<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>\n"));\
	websWrite(wp, T("	<title>Success!</title>\n"));\
	websWrite(wp, T("	<style type=\"text/css\">\n"));\
	websWrite(wp, T("		#out{width:300px;height:20px;background:#CCCCCC;}\n"));\
	websWrite(wp, T("		#in{width:0px; height:20px;background:#0080FF;color:#000000;text-align:center;}\n"));\
	websWrite(wp, T("		.background{	background-color:#FFFFFF;	color:#000000;	font-family:Arial, Helvetica; }\n"));\
	websWrite(wp, T("	</style>\n"));\
	websWrite(wp, T("	<script>\n"));\
	websWrite(wp, T("		function getCookie(c_name)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			if (document.cookie.length>0)\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				c_start=document.cookie.indexOf(c_name + \"=\")\n"));\
	websWrite(wp, T("				if (c_start!=-1)\n"));\
	websWrite(wp, T("				{\n"));\
	websWrite(wp, T("					c_start=c_start + c_name.length+1;\n"));\
	websWrite(wp, T("					c_end=document.cookie.indexOf(\";\",c_start);\n"));\
	websWrite(wp, T("					if (c_end==-1) c_end=document.cookie.length;\n"));\
	websWrite(wp, T("					return unescape(document.cookie.substring(c_start,c_end));\n"));\
	websWrite(wp, T("				}\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("			else\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				return 0;\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		var stype = getCookie('language');\n"));\
	websWrite(wp, T("		function showText(text)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			if(text[stype]==\"\") return text[0];\n"));\
	websWrite(wp, T("			else				return text[stype];\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		function dw(message,defaultMs)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			document.write(showText(message));\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		var firmware_upgrading=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"Firmware upgrading, please wait.\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("		var upgrade_accomplished=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"Upgrade Accomplished.\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("		var upgrade_accomplished_content=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"You should be able to reconnect to the router by refreshing the web page now. If not, please restart the router by reconnecting the power line manually.\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("	</script>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body class=\"background\" onload=\"start();\">\n"));\
	websWrite(wp, T("	<div id='counting'>\n"));\
	websWrite(wp, T("		<blockquote><h4>Firmware upgrading, please wait.</h4>\n"));\
	websWrite(wp, T("	<div id='out'>\n"));\
	websWrite(wp, T("		<div id=\"in\" style=\"width:0%%\">0%%</div>\n"));\
	websWrite(wp, T("	</div></blockquote>\n"));\
	websWrite(wp, T("	</div>\n"));\
	websWrite(wp, T("	<script type=\"text/javascript\">\n"));\
	websWrite(wp, T("		i=0;secs=95;\n"));\
	websWrite(wp, T("		function start()\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			ba=setInterval(\"begin()\",secs*10);\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		function begin()\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			i+=1;\n"));\
	websWrite(wp, T("			if(i<=100)\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				document.getElementById(\"in\").style.width=i+\"%%\";\n"));\
	websWrite(wp, T("				document.getElementById(\"in\").innerHTML=i+\"%%\";\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("			else\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				clearInterval(ba);\n"));\
	websWrite(wp, T("				document.getElementById(\"counting\").style.display=\"none\";\n"));\
	websWrite(wp, T("				document.write(\"<head>\");\n"));\
	websWrite(wp, T("				document.write(\"	<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>\");\n"));\
	websWrite(wp, T("				document.write(\"	<title>Success!</title>\");\n"));\
	websWrite(wp, T("				document.write(\"	<style type=\\\"text/css\\\">\");\n"));\
	websWrite(wp, T("				document.write(\"		.background{ background-color:#FFFFFF; color:#000000; font-family:Arial, Helvetica;}\");\n"));\
	websWrite(wp, T("				document.write(\"	</style>\");\n"));\
	websWrite(wp, T("				document.write(\"</head>\");\n"));\
	websWrite(wp, T("				document.write(\"<body class=\\\"background\\\">\");\n"));\
	websWrite(wp, T("				document.write(\"	<blockquote>\");\n"));\
	websWrite(wp, T("				document.write(\"		<h4>Upgrade Accomplished.</h4>\");\n"));\
	websWrite(wp, T("				document.write(\"		<br>\");\n"));\
	websWrite(wp, T("				document.write(\"		<font size=\\\"2\\\" class=\\\"textcolor\\\">You should be able to reconnect to the router by refreshing the web page now. If not, please restart the router by reconnecting the power line manually.</font>\");\n"));\
	websWrite(wp, T("				document.write(\"	</blockquote>\");\n"));\
	websWrite(wp, T("				document.write(\"</body>\");\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("	</script>\n"));\
	websWrite(wp, T("</body>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}
#else
#define UPGRADE_PROCESS_MSG(){\
	websHeader(wp);\
	websWrite(wp, T("<head>\n"));\
	websWrite(wp, T("	<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>\n"));\
	websWrite(wp, T("	<title>Success!</title>\n"));\
	websWrite(wp, T("	<style type=\"text/css\">\n"));\
	websWrite(wp, T("		#out{width:300px;height:20px;background:#CCCCCC;}\n"));\
	websWrite(wp, T("		#in{width:0px; height:20px;background:#0080FF;color:#000000;text-align:center;}\n"));\
	websWrite(wp, T("		.background{	background-color:#EEEEEE;	color:#000000;	font-family:Arial, Helvetica; }\n"));\
	websWrite(wp, T("	</style>\n"));\
	websWrite(wp, T("	<script>\n"));\
	websWrite(wp, T("		function getCookie(c_name)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			if (document.cookie.length>0)\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				c_start=document.cookie.indexOf(c_name + \"=\")\n"));\
	websWrite(wp, T("				if (c_start!=-1)\n"));\
	websWrite(wp, T("				{\n"));\
	websWrite(wp, T("					c_start=c_start + c_name.length+1;\n"));\
	websWrite(wp, T("					c_end=document.cookie.indexOf(\";\",c_start);\n"));\
	websWrite(wp, T("					if (c_end==-1) c_end=document.cookie.length;\n"));\
	websWrite(wp, T("					return unescape(document.cookie.substring(c_start,c_end));\n"));\
	websWrite(wp, T("				}\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("			else\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				return 0;\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		var stype = getCookie('language');\n"));\
	websWrite(wp, T("		function showText(text)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			if(text[stype]==\"\") return text[0];\n"));\
	websWrite(wp, T("			else				return text[stype];\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		function dw(message,defaultMs)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			document.write(showText(message));\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		var firmware_upgrading=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"Firmware upgrading, please wait.\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("		var upgrade_accomplished=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"Upgrade Accomplished.\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("		var upgrade_accomplished_content=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"You should be able to reconnect to the router by refreshing the web page now. If not, please restart the router by reconnecting the power line manually.\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("	</script>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body class=\"background\" onload=\"start();\">\n"));\
	websWrite(wp, T("	<div id='counting'>\n"));\
	websWrite(wp, T("		<blockquote><h4><script>dw(firmware_upgrading)</script></h4>\n"));\
	websWrite(wp, T("	<div id='out'>\n"));\
	websWrite(wp, T("		<div id=\"in\" style=\"width:0%%\">0%%</div>\n"));\
	websWrite(wp, T("	</div></blockquote>\n"));\
	websWrite(wp, T("	</div>\n"));\
	websWrite(wp, T("	<script type=\"text/javascript\">\n"));\
	websWrite(wp, T("		i=0;secs=95;\n"));\
	websWrite(wp, T("		function start()\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			ba=setInterval(\"begin()\",secs*10);\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		function begin()\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			i+=1;\n"));\
	websWrite(wp, T("			if(i<=100)\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				document.getElementById(\"in\").style.width=i+\"%%\";\n"));\
	websWrite(wp, T("				document.getElementById(\"in\").innerHTML=i+\"%%\";\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("			else\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				clearInterval(ba);\n"));\
	websWrite(wp, T("				document.getElementById(\"counting\").style.display=\"none\";\n"));\
	websWrite(wp, T("				document.write(\"<head>\");\n"));\
	websWrite(wp, T("				document.write(\"	<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>\");\n"));\
	websWrite(wp, T("				document.write(\"	<title>Success!</title>\");\n"));\
	websWrite(wp, T("				document.write(\"	<style type=\\\"text/css\\\">\");\n"));\
	websWrite(wp, T("				document.write(\"		.background{ background-color:#EEEEEE; color:#000000; font-family:Arial, Helvetica;}\");\n"));\
	websWrite(wp, T("				document.write(\"	</style>\");\n"));\
	websWrite(wp, T("				document.write(\"</head>\");\n"));\
	websWrite(wp, T("				document.write(\"<body class=\\\"background\\\">\");\n"));\
	websWrite(wp, T("				document.write(\"	<blockquote>\");\n"));\
	websWrite(wp, T("				document.write(\"		<h4>\"+showText(upgrade_accomplished)+\"</h4>\");\n"));\
	websWrite(wp, T("				document.write(\"		<br>\");\n"));\
	websWrite(wp, T("				document.write(\"		<font size=\\\"2\\\" class=\\\"textcolor\\\">\"+showText(upgrade_accomplished_content)+\"</font>\");\n"));\
	websWrite(wp, T("				document.write(\"	</blockquote>\");\n"));\
	websWrite(wp, T("				document.write(\"</body>\");\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("	</script>\n"));\
	websWrite(wp, T("</body>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}
#endif

#ifdef _WEBSITE_FIRMWARE_UPGRADE_
#define WEBSITE_FIRMWARE_UPGRADE_MSG(){\
	websHeader(wp);\
	websWrite(wp, T("<head>\n"));\
	websWrite(wp, T("	<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>\n"));\
	websWrite(wp, T("	<title>Success!</title>\n"));\
	websWrite(wp, T("	<style type=\"text/css\">\n"));\
	websWrite(wp, T("		#out{width:300px;height:20px;background:#CCCCCC;}\n"));\
	websWrite(wp, T("		#in{width:0px; height:20px;background:#0080FF;color:#000000;text-align:center;}\n"));\
	websWrite(wp, T("		.background{	background-color:#EEEEEE;	color:#000000;	font-family:Arial, Helvetica; }\n"));\
	websWrite(wp, T("	</style>\n"));\
	websWrite(wp, T("	<script>\n"));\
	websWrite(wp, T("		function getCookie(c_name)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			if (document.cookie.length>0)\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				c_start=document.cookie.indexOf(c_name + \"=\")\n"));\
	websWrite(wp, T("				if (c_start!=-1)\n"));\
	websWrite(wp, T("				{\n"));\
	websWrite(wp, T("					c_start=c_start + c_name.length+1;\n"));\
	websWrite(wp, T("					c_end=document.cookie.indexOf(\";\",c_start);\n"));\
	websWrite(wp, T("					if (c_end==-1) c_end=document.cookie.length;\n"));\
	websWrite(wp, T("					return unescape(document.cookie.substring(c_start,c_end));\n"));\
	websWrite(wp, T("				}\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("			else\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				return 1;\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		var stype = getCookie('language');\n"));\
	websWrite(wp, T("		function showText(text)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			if(text[stype]==null || text[stype]==\"\") return text[0];\n"));\
	websWrite(wp, T("			else				return text[stype];\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		function dw(message,defaultMs)\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			document.write(showText(message));\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		var firmware_upgrading=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"Rebooting, please wait.\",\n"));\
	websWrite(wp, T("		\"ファームウェア更新中、しばらくお待ちください。\",\n"));\
	websWrite(wp, T("		\"正在重新啟動，請稍候。\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("		var upgrade_accomplished=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"Upgrade Accomplished.\",\n"));\
	websWrite(wp, T("		\"アップデートが完了しました。\",\n"));\
	websWrite(wp, T("		\"更新完成。\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("		var upgrade_accomplished_content=new Array\n"));\
	websWrite(wp, T("		(\n"));\
	websWrite(wp, T("		\"You should be able to reconnect to the router by refreshing the web page now. If not, please restart the router by reconnecting the power line manually.\",\n"));\
	websWrite(wp, T("		\"ブラウザのページを更新すると再接続できます。失敗した場合は、2分ほど待ってからブラウザのページを更新してください。それでも失敗した場合は、本製品の電源を入れなおして再起動してください。\",\n"));\
	websWrite(wp, T("		\"更新瀏覽器網頁可重新連線。失敗的話請重新開啟分享器電源或重新啟動\"\n"));\
	websWrite(wp, T("		);\n"));\
	websWrite(wp, T("	</script>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body class=\"background\" onload=\"start();\">\n"));\
	websWrite(wp, T("	<div id='counting'>\n"));\
	websWrite(wp, T("		<blockquote><h4><script>dw(firmware_upgrading)</script></h4>\n"));\
	websWrite(wp, T("	<div id='out'>\n"));\
	websWrite(wp, T("		<div id=\"in\" style=\"width:0%%\">0%%</div>\n"));\
	websWrite(wp, T("	</div></blockquote>\n"));\
	websWrite(wp, T("	</div>\n"));\
	websWrite(wp, T("	<script type=\"text/javascript\">\n"));\
	websWrite(wp, T("		i=0;secs=50;\n"));\
	websWrite(wp, T("		function start()\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			ba=setInterval(\"begin()\",secs*10);\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("		function begin()\n"));\
	websWrite(wp, T("		{\n"));\
	websWrite(wp, T("			i+=1;\n"));\
	websWrite(wp, T("			if(i<=100)\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				document.getElementById(\"in\").style.width=i+\"%%\";\n"));\
	websWrite(wp, T("				document.getElementById(\"in\").innerHTML=i+\"%%\";\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("			else\n"));\
	websWrite(wp, T("			{\n"));\
	websWrite(wp, T("				clearInterval(ba);\n"));\
	websWrite(wp, T("				document.getElementById(\"counting\").style.display=\"none\";\n"));\
	websWrite(wp, T("				document.write(\"<head>\");\n"));\
	websWrite(wp, T("				document.write(\"	<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>\");\n"));\
	websWrite(wp, T("				document.write(\"	<title>Success!</title>\");\n"));\
	websWrite(wp, T("				document.write(\"	<style type=\\\"text/css\\\">\");\n"));\
	websWrite(wp, T("				document.write(\"		.background{ background-color:#EEEEEE; color:#000000; font-family:Arial, Helvetica;}\");\n"));\
	websWrite(wp, T("				document.write(\"	</style>\");\n"));\
	websWrite(wp, T("				document.write(\"</head>\");\n"));\
	websWrite(wp, T("				document.write(\"<body class=\\\"background\\\">\");\n"));\
	websWrite(wp, T("				document.write(\"	<blockquote>\");\n"));\
	websWrite(wp, T("				document.write(\"		<h4>\"+showText(upgrade_accomplished)+\"</h4>\");\n"));\
	websWrite(wp, T("				document.write(\"		<br>\");\n"));\
	websWrite(wp, T("				document.write(\"		<font size=\\\"2\\\" class=\\\"textcolor\\\">\"+showText(upgrade_accomplished_content)+\"</font>\");\n"));\
	websWrite(wp, T("				document.write(\"	</blockquote>\");\n"));\
	websWrite(wp, T("				document.write(\"</body>\");\n"));\
	websWrite(wp, T("			}\n"));\
	websWrite(wp, T("		}\n"));\
	websWrite(wp, T("	</script>\n"));\
	websWrite(wp, T("</body>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}
#endif

#if defined(_Customer_)
#define OK_MSG(url)\
{\
	websWrite(wp, T("<!DOCTYPE html PUBLIC \"-\/\/W3C\/\/DTD XHTML 1.0 Transitional\/\/EN\" \"http:\/\/www.w3.org\/TR\/xhtml1\/DTD\/xhtml1-transitional.dtd\">\n"));\
	websWrite(wp, T("<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\">\n"));\
        websWrite(wp, T("<!--ok_msg function-->\n"));\
	websWrite(wp, T("<head>\n"));\
	websWrite(wp, T("  <meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1'>\n"));\
	websWrite(wp, T("  <script type='text/javascript' src='/FUNCTION_SCRIPT'></script>\n"));\
	websWrite(wp, T("  <script type='text/javascript' src='/javascript.js'></script>\n"));\
	websWrite(wp, T("  <link rel=\"stylesheet\" href=\"/menu_style.css\">\n"));\
	websWrite(wp, T("  <link rel=\"stylesheet\" href=\"/style.css\">\n"));\
	websWrite(wp, T("<title>Success!</title>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<script>\n"));\
	websWrite(wp, T("document.write('<body>');\n"));\
	websWrite(wp, T("  \/\/========================Define some variable\n"));\
	websWrite(wp, T("  if(window.aspSaveSetSuccess)  title = showText(aspSaveSetSuccess);\n"));\
	websWrite(wp, T("  else                          title = \"Save settings successfully!\";\n"));\
	websWrite(wp, T("  if(window.aspContinueApply) message = showText(aspContinueApply);\n"));\
	websWrite(wp, T("  else                        message = \"You may press CONTINUE button to continue configuring other settings or press APPLY button to restart the system for changes to take effect.\";\n"));\
	websWrite(wp, T("  button_style = 'font-size: 0.8em; font-family: Arial;';\n"));\
	websWrite(wp, T("  if(window.continue1) button_cont=showText(continue1);\n"));\
	websWrite(wp, T("  else                 button_cont='Continue';\n"));\
	websWrite(wp, T("  if(window.apply1) button_apply=showText(apply1);\n"));\
	websWrite(wp, T("  else              button_apply='Apply';\n"));\
	websWrite(wp, T("  if(window.ok1) button_ok = showText(ok1);\n"));\
	websWrite(wp, T("  else           button_ok = 'OK';\n"));\
	websWrite(wp, T("\n"));\
	websWrite(wp, T("  \/\/========================Show title and message\n"));\
	websWrite(wp, T("\n"));\
	websWrite(wp, T("    Write_Header_Menu(%d,%d);\n"),main_menu,sub_menu);\
	websWrite(wp, T("\n"));\
	websWrite(wp, T("  document.write('<div id=\"content\">');\n"));\
	websWrite(wp, T("  document.write('<div class=\"content\">');\n"));\
	websWrite(wp, T("  document.write('<h3 align=\"left\" class=\"arrow\">'+title+'</h3>');\n"));\
	websWrite(wp, T("  document.write('<p>'+message+'</p>');\n"));\
	websWrite(wp, T("  document.write('<div align=\"center\">');\n"));\
	websWrite(wp, T("  \/\/===============Continue, Apply and OK Button\n"));\
	websWrite(wp, T("\n"));\
	websWrite(wp, T("  if( '%s' != '' )\n"),url);\
	websWrite(wp, T("  {\n"));\
	websWrite(wp, T("  document.write('<form method=POST action=\"/goform/formApply\" name=okform>');\n"));\
	websWrite(wp, T("  \/\/===============Continue Button\n"));\
	websWrite(wp, T("  document.write('<input type=\"button\" value=\"'+button_cont+'\" style=\"'+button_style+'\" OnClick=window.location.replace(\"%s\")>');\n"),url);\
	websWrite(wp, T("  document.write('&nbsp;&nbsp;');\n"));\
	websWrite(wp, T("  \/\/===============Apply Button\n"));\
	websWrite(wp, T("  document.write('<input type=\"submit\" value=\"'+button_apply+'\" style=\"'+button_style+'\">');\n"));\
	websWrite(wp, T("  \/\/===============Hidden SubmitUrl\n"));\
	websWrite(wp, T("  document.write('<input type=hidden name=\"submit-url\" value=\"%s\">');\n"),url);\
	websWrite(wp, T("  }\n"));\
	websWrite(wp, T("  else\n"));\
	websWrite(wp, T("  {\n"));\
	websWrite(wp, T("    document.write('<form>');\n"));\
	websWrite(wp, T("    \/\/===============OK Button\n"));\
	websWrite(wp, T("    document.write('<input type=button value=\"'+button_ok+'\" style=\"'+button_style+'\" onClick=window.close();>');\n"));\
	websWrite(wp, T("  }\n"));\
	websWrite(wp, T("  document.write('</form>');\n"));\
	websWrite(wp, T("  document.write('</div>');\n"));\
	websWrite(wp, T("  document.write('<p>&nbsp;</p>');\n"));\
	websWrite(wp, T("  document.write('<p>&nbsp;</p>');\n"));\
	websWrite(wp, T("  document.write('</div>');\n"));\
	websWrite(wp, T("  document.write('</div>');\n"));\
	websWrite(wp, T("  Write_Footer_Menu();\n"));\
	websWrite(wp, T("</script>\n"));\
	websWrite(wp, T("</body>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}
#else
#define OK_MSG(url)\
{\
	websHeader(wp);\
	websWrite(wp, T("<!--OK_MSG--><head>\n"));\
	websWrite(wp, T("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Expires\" content=\"-1\">\n"));\
	websWrite(wp, T("<link rel=\"stylesheet\" href=\"/file/set.css\">\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/javascript.js\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/multilanguage.var\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/allasp-n.var\"></script>\n"));\
	websWrite(wp, T("<title>Success!</title>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body class=\"mainbg\">\n"));\
	websWrite(wp, T("<blockquote><br><a class=\"titlecolor\"><script>dw(SaveSettingsSuccessfully)</script></a><br><br>\n"));\
	if(wizardEnabled==1)\
	websWrite(wp, T("<a class=\"textcolor\"><script>dw(ApplyToReset)</script></a>\n"));\
	else\
	websWrite(wp, T("<a class=\"textcolor\"><script>dw(ContinueOrApply)</script></a>\n"));\
	websWrite(wp, T("<br><br>\n"));\
	if(url)\
	{\
		websWrite(wp, T("<form method=POST action=\"/goform/formApply\" name=okform>\n"));\
		websWrite(wp, T("<script>\n"));\
		if(wizardEnabled!=1) websWrite(wp, T("document.write('<input type=\"button\" value=\"'+showText(CONTINUE)+'\" class=\"button\" OnClick=window.location.replace(\"%s\")>&nbsp;&nbsp;');\n"),url);\
		websWrite(wp, T("document.write('<input type=\"submit\" value=\"'+showText(APPLY)+'\" class=\"button\">');\n"));\
		websWrite(wp, T("document.write('<input type=hidden name=\"submit-url\" value=\"%s\">');\n"),url);\
		websWrite(wp, T("document.write('<input type=hidden name=\"KeyID\" value=\"%s\">');\n"),url);\
		websWrite(wp, T("</script>\n"));\
	}\
	else\
	{\
		websWrite(wp, T("<form>\n"));\
	   websWrite(wp, T("<script>document.write('<input type=button value=\"'+showText(OK)+'\" class=\"button\" onClick=window.close();>');</script>\n"));\
	}\
	websWrite(wp, T("</form>\n"));\
	websWrite(wp, T("</blockquote>\n"));\
	websWrite(wp, T("</body>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}
#endif

#define OK_MSG1(msg, url)\
{\
	websHeader(wp);\
	websWrite(wp, T("<head>              \n"));\
	websWrite(wp, T("	<meta http-equiv='Content-Type' content='text/html; charset=%s'>							\n"),charset);\
	websWrite(wp, T("	<script type='text/javascript' src='/file/javascript.js'></script>								\n"));\
	websWrite(wp, T("	<script type='text/javascript' src='/file/allasp-n.var'></script>							\n"));\
	websWrite(wp, T("<script type='text/javascript' src='/FUNCTION_SCRIPT'></script>\n"));\
	websWrite(wp, T("  <script>                                                                                                                                                                                             \n"));\
	websWrite(wp, T("	if( typeof _MODE_	== 'undefined') _MODE_ =	'General';												\n"));\
	websWrite(wp, T("	if( typeof _IS_GATEWAY_	== 'undefined') _IS_GATEWAY_ =	'y';												\n"));\
	websWrite(wp, T("  if( _MODE_ == 'Customer330' || _MODE_ == 'Customer331' ) document.write('<link href=\"file/set.css\" type=\"text/css\" rel=\"stylesheet\">');                                                              \n"));\
	websWrite(wp, T("  else                                                    document.write('<link href=\"/file/set.css\" type=\"text/css\" rel=\"stylesheet\">');                                                             \n"));\
	websWrite(wp, T("  </script>                                                                                                                                                                                            \n"));\
	websWrite(wp, T("<title>Success!</title>\n"));\
	websWrite(wp, T("</head><!--OK_MSG1-->														\n"));\
	websWrite(wp, T("<script>															\n"));\
	websWrite(wp, T("	if ( _MODE_ == 'Customer330' || _MODE_ == 'Customer331' )								\n"));\
	websWrite(wp, T("		document.write('<body style=\"background-image:none;background-color:transparent;\">');											\n"));\
	websWrite(wp, T("	else															\n"));\
	websWrite(wp, T("		document.write('<body class=\"mainbg\">');									\n"));\
	websWrite(wp, T("</script>															\n"));\
	websWrite(wp, T("<blockquote>															\n"));\
	websWrite(wp, T("<h4>%s</h4>															\n"),msg);\
	websWrite(wp, T("	<form>															\n"));\
	websWrite(wp, T("	<script>														\n"));\
	websWrite(wp, T("	if(window.ok1)	cont=showText(ok1);											\n"));\
	websWrite(wp, T("	else		cont='OK';												\n"));\
	websWrite(wp, T("	if( '%s' != '' )													\n"),url);\
	websWrite(wp, T("	{															\n"));\
	websWrite(wp, T("		buffer='<input type=button value=\"'+cont+'\" style=\"width:100px\" onClick=window.location.replace(\"%s\")>';	\n"),url);\
	websWrite(wp, T("	}															\n"));\
	websWrite(wp, T("	else															\n"));\
	websWrite(wp, T("	{															\n"));\
	websWrite(wp, T("		buffer='<input type=button value=\"'+cont+'\" style=\"width:100px\" onClick=window.close()>';			\n"));\
	websWrite(wp, T("	}															\n"));\
	websWrite(wp, T("	document.write(buffer);													\n"));\
	websWrite(wp, T("	</script>														\n"));\
	websWrite(wp, T("	</form>															\n"));\
	websWrite(wp, T("</blockquote>															\n"));\
	websWrite(wp, T("</body>															\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}

#define OK_MSG2(msg,msg1,url)\
{\
	websHeader(wp);\
	websWrite(wp, T("<!--OK_MSG2--><head>\n"));\
	websWrite(wp, T("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Expires\" content=\"-1\">\n"));\
	websWrite(wp, T("<link rel=\"stylesheet\" href=\"/file/set.css\">\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/javascript.js\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/multilanguage.var\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/allasp-n.var\"></script>\n"));\
	websWrite(wp, T("<title>Success!</title>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body class=\"mainbg\">\n"));\
	websWrite(wp, T("<blockquote><br><a class=\"titlecolor\"><script>dw(SaveSettingsSuccessfully)</script></a><br><br>\n"));\
	websWrite(wp, T("<script>\n"));\
	websWrite(wp, T("if ( typeof(top.lFrame) == 'undefined' )\n"));\
	websWrite(wp, T("	document.write(' <a class=\"textcolor\">'+showText(ApplyToReset)+'</a> ');\n "));\
	websWrite(wp, T("else\n"));\
	websWrite(wp, T("	document.write(' <a class=\"textcolor\">'+showText(ContinueOrApply)+'</a> ');\n "));\
	websWrite(wp, T("</script>\n"));\
	websWrite(wp, T("<br><br>\n"));\
	websWrite(wp, T("<h>device SSID :</h>\n"));\
	websWrite(wp, T("<a style=\"font-weight:bold;\">%s</a><br><br>"),msg);\
	websWrite(wp, T("<h>Security :</h>\n"));\
	websWrite(wp, T("<a style=\"font-weight:bold;\">%s</a><br><br>"),msg1);\
	websWrite(wp, T(""));\
	if(url)\
	{\
		websWrite(wp, T("<form method=POST action=\"/goform/formApply\" name=okform>\n"));\
		websWrite(wp, T("<script>\n"));\
		websWrite(wp, T("	document.write('<input type=\"button\" value=\"Back\" onClick=\"history.go(-1);\" class=\"button\">&nbsp;&nbsp;');\n"));\
		websWrite(wp, T("if ( typeof(top.lFrame) != 'undefined' )\n"));\
		websWrite(wp, T("	document.write('<input type=\"button\" value=\"'+showText(CONTINUE)+'\" class=\"button\" OnClick=top.location.replace(\"%s\")>&nbsp;&nbsp;');\n"),url);\
		websWrite(wp, T("document.write('<input type=\"submit\" value=\"'+showText(APPLY)+'\" class=\"button\">');\n"));\
		websWrite(wp, T("document.write('<input type=hidden name=\"submit-url\" value=\"%s\">');\n"),url);\
		websWrite(wp, T("document.write('<input type=hidden name=\"KeyID\" value=\"%s\">');\n"),url);\
		websWrite(wp, T("</script>\n"));\
	}\
	else\
	{\
		websWrite(wp, T("<form>\n"));\
	   websWrite(wp, T("<script>document.write('<input type=button value=\"'+showText(OK)+'\" class=\"button\" onClick=window.close();>');</script>\n"));\
	}\
	websWrite(wp, T("</form>\n"));\
	websWrite(wp, T("</blockquote>\n"));\
	websWrite(wp, T("</body>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}

#define OK_MSG2_1(msg,msg1,url)\
{\
	websHeader(wp);\
	websWrite(wp, T("<!--OK_MSG2_1--><head>\n"));\
	websWrite(wp, T("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Expires\" content=\"-1\">\n"));\
	websWrite(wp, T("<link rel=\"stylesheet\" href=\"/file/set.css\">\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/javascript.js\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/multilanguage.var\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/allasp-n.var\"></script>\n"));\
	websWrite(wp, T("<title>Success!</title>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body class=\"mainbg\">\n"));\
	websWrite(wp, T("<blockquote><br><a class=\"titlecolor\"><script>dw(SaveSettingsSuccessfully)</script></a><br><br>\n"));\
	websWrite(wp, T("<script>\n"));\
	websWrite(wp, T("if ( typeof(top.lFrame) == 'undefined' )\n"));\
	websWrite(wp, T("	document.write(' <a class=\"textcolor\">'+showText(ApplyToReset)+'</a> ');\n "));\
	websWrite(wp, T("else\n"));\
	websWrite(wp, T("	document.write(' <a class=\"textcolor\">'+showText(ContinueOrApply)+'</a> ');\n "));\
	websWrite(wp, T("</script>\n"));\
	websWrite(wp, T("<br><br>\n"));\
	websWrite(wp, T("<h>Connected Access Point SSID :</h>\n"));\
	websWrite(wp, T("<a style=\"font-weight:bold;\">%s</a><br><br>"),msg);\
	websWrite(wp, T("<h>Security :</h>\n"));\
	websWrite(wp, T("<a style=\"font-weight:bold;\">%s</a><br><br>"),msg1);\
	websWrite(wp, T(""));\
	if(url)\
	{\
		websWrite(wp, T("<form method=POST action=\"/goform/formApply\" name=okform>\n"));\
		websWrite(wp, T("<script>\n"));\
		websWrite(wp, T("	document.write('<input type=\"button\" value=\"Back\" onClick=\"history.go(-1);\" class=\"button\">&nbsp;&nbsp;');\n"));\
		websWrite(wp, T("if ( typeof(top.lFrame) != 'undefined' )\n"));\
		websWrite(wp, T("	document.write('<input type=\"button\" value=\"'+showText(CONTINUE)+'\" class=\"button\" OnClick=top.location.replace(\"%s\")>&nbsp;&nbsp;');\n"),url);\
		websWrite(wp, T("document.write('<input type=\"submit\" value=\"'+showText(APPLY)+'\" class=\"button\">');\n"));\
		websWrite(wp, T("document.write('<input type=hidden name=\"submit-url\" value=\"%s\">');\n"),url);\
		websWrite(wp, T("document.write('<input type=hidden name=\"KeyID\" value=\"%s\">');\n"),url);\
		websWrite(wp, T("</script>\n"));\
	}\
	else\
	{\
		websWrite(wp, T("<form>\n"));\
	   websWrite(wp, T("<script>document.write('<input type=button value=\"'+showText(OK)+'\" class=\"button\" onClick=window.close();>');</script>\n"));\
	}\
	websWrite(wp, T("</form>\n"));\
	websWrite(wp, T("</blockquote>\n"));\
	websWrite(wp, T("</body>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}

#define UPGRADE_MSG(msg, url) { \
	websHeader(wp); \
	websWrite(wp, T("<head><link rel='stylesheet' href='/file/set.css'>\n")); \
   	websWrite(wp, T("<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>\n")); \
   	websWrite(wp, T("<script type='text/javascript' src='/javascript.js'></script>\n")); \
   	websWrite(wp, T("<script type='text/javascript' src='/file/allasp-n.var'></script>\n")); \
   	websWrite(wp, T("<title>Success!</title>\n</head>\n")); \
 	websWrite(wp, T("<body class=\"background\"><blockquote><h4>\n%s\n</h4>\n"),msg); \
	if (url) websWrite(wp, T("<form><input type=button name =\"okbutton\" value=\"OK!\" style=\"width:100px\" OnClick=window.location.replace(\"%s\")>\n</form></blockquote>\n</body>"), url); \
	else websWrite(wp, T("<form><input type=button name =\"okbutton\" value=\"OK!\" style=\"width:100px\" OnClick=window.close()>\n</form></blockquote>\n</body>")); \
	websFooter(wp); \
	websDone(wp, 200); \
}
#define OK_MSG3_1(msg,msg2,msg3,url)\
{\
	websHeader(wp);\
	websWrite(wp, T("<!--OK_MSG3_1--><head>\n"));\
	websWrite(wp, T("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"));\
	websWrite(wp, T("<meta http-equiv=\"Expires\" content=\"-1\">\n"));\
	websWrite(wp, T("<link rel=\"stylesheet\" href=\"/file/set.css\">\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/javascript.js\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/multilanguage.var\"></script>\n"));\
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/allasp-n.var\"></script>\n"));\
	websWrite(wp, T("<title>Success!</title>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<body class=\"mainbg\">\n"));\
	websWrite(wp, T("<blockquote><br><a class=\"titlecolor\"><script>dw(SaveSettingsSuccessfully)</script></a><br><br>\n"));\
	websWrite(wp, T("<script>\n"));\
	websWrite(wp, T("if ( typeof(top.lFrame) == 'undefined' )\n"));\
	websWrite(wp, T("	document.write(' <a class=\"textcolor\">'+showText(ApplyToReset)+'</a> ');\n "));\
	websWrite(wp, T("else\n"));\
	websWrite(wp, T("	document.write(' <a class=\"textcolor\">'+showText(ContinueOrApply)+'</a> ');\n "));\
	websWrite(wp, T("</script>\n"));\
	websWrite(wp, T("<br><br>\n"));\
	websWrite(wp, T(""));\
	if(url)\
	{\
		websWrite(wp, T("<form method=POST action=\"/goform/formApply\" name=okform>\n"));\
		websWrite(wp, T("<h>Connected Access Point SSID :</h>\n"));\
		websWrite(wp, T("<a style=\"font-weight:bold;\">%s</a><br><br>"),msg);\
		websWrite(wp, T("<h>Device SSID :</h>\n"));\
		websWrite(wp, T("<input name=\"deivceSSID\" size=\"32\" maxlength=\"32\" value=\"%s\" type=\"text\"><br><br>"),msg2);\
		websWrite(wp, T("<h>Security :</h>\n"));\
		websWrite(wp, T("<a style=\"font-weight:bold;\">%s</a><br><br>"),msg3);\
		websWrite(wp, T("<script>\n"));\
		websWrite(wp, T("	document.write('<input type=\"button\" value=\"Back\" onClick=\"history.go(-1);\" class=\"button\">&nbsp;&nbsp;');\n"));\
		websWrite(wp, T("if ( typeof(top.lFrame) != 'undefined' )\n"));\
		websWrite(wp, T("	document.write('<input type=\"button\" value=\"'+showText(CONTINUE)+'\" class=\"button\" OnClick=top.location.replace(\"%s\")>&nbsp;&nbsp;');\n"),url);\
		websWrite(wp, T("document.write('<input type=\"submit\" value=\"'+showText(APPLY)+'\" class=\"button\">');\n"));\
		websWrite(wp, T("document.write('<input type=hidden name=\"submit-url\" value=\"%s\">');\n"),url);\
		websWrite(wp, T("document.write('<input type=hidden name=\"KeyID\" value=\"%s\">');\n"),url);\
		websWrite(wp, T("</script>\n"));\
	}\
	else\
	{\
		websWrite(wp, T("<form>\n"));\
	   websWrite(wp, T("<script>document.write('<input type=button value=\"'+showText(OK)+'\" class=\"button\" onClick=window.close();>');</script>\n"));\
	}\
	websWrite(wp, T("</form>\n"));\
	websWrite(wp, T("</blockquote>\n"));\
	websWrite(wp, T("</body>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}

#if defined(_Customer_)
#define OK_MSG3(msg, url)\
{\
	websWrite(wp, T("<!DOCTYPE html PUBLIC \"-\/\/W3C\/\/DTD XHTML 1.0 Transitional\/\/EN\" \"http:\/\/www.w3.org\/TR\/xhtml1\/DTD\/xhtml1-transitional.dtd\">\n"));\
	websWrite(wp, T("<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\">\n"));\
	websWrite(wp, T("<!--OK_MSG3--><head>\n"));\
	websWrite(wp, T("<head>\n"));\
	websWrite(wp, T("  <meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1'>\n"));\
	websWrite(wp, T("  <script type='text/javascript' src='/FUNCTION_SCRIPT'></script>\n"));\
	websWrite(wp, T("  <script type='text/javascript' src='/javascript.js'></script>\n"));\
	websWrite(wp, T("  <script type=\"text/javascript\" src=\"/file/allasp-n.var\"></script>\n"));\
	websWrite(wp, T("  <script type=\"text/javascript\" src=\"/file/multilanguage.var\"></script>\n"));\
	websWrite(wp, T("  <link rel=\"stylesheet\" href=\"/menu_style.css\">\n"));\
	websWrite(wp, T("  <link rel=\"stylesheet\" href=\"/style.css\">\n"));\
	websWrite(wp, T("<title></title>\n"));\
	websWrite(wp, T("</head>\n"));\
	websWrite(wp, T("<script>\n"));\
	websWrite(wp, T("document.write('<body>');\n"));\
	websWrite(wp, T("  \/\/========================Define some variable\n"));\
	websWrite(wp, T("  button_style = 'font-size: 0.8em; font-family: Arial;';\n"));\
	websWrite(wp, T("\n"));\
	websWrite(wp, T("  \/\/========================Show title and message\n"));\
	websWrite(wp, T("\n"));\
	websWrite(wp, T("    Write_Header_Menu(%d,%d);\n"),main_menu,sub_menu);\
	websWrite(wp, T("\n"));\
	websWrite(wp, T("  document.write('<div id=\"content\">');\n"));\
	websWrite(wp, T("  document.write('<div class=\"content\">');\n"));\
	websWrite(wp, T("  </script><p>%s</p><script>"),msg);\
	websWrite(wp, T("  document.write('<div align=\"center\">');\n"));\
	websWrite(wp, T("\n"));\
	websWrite(wp, T("  document.write('<form name=\"test\">');\n"));\
	if(url)\
	{\
		if(lanipChanged==1)	websWrite(wp, T("document.write('<input type=button name=\"okbutton\" value=\"'+showText(OK)+'\" OnClick=top.location.replace(\"%s\")>');\n"),url);\
		else websWrite(wp, T("document.write('<input type=button name=\"okbutton\" value=\"'+showText(OK)+'\" OnClick=window.location.replace(\"%s\")>');\n"),url);\
	}\
	else websWrite(wp, T("document.write('<input type=button name=\"okbutton\" value=\"'+showText(OK)+'\" OnClick=window.close()>');\n"));\
	websWrite(wp, T("document.write('</form>');\n"));\
	websWrite(wp, T("  document.write('</div>');\n"));\
	websWrite(wp, T("  document.write('<p>&nbsp;</p>');\n"));\
	websWrite(wp, T("  document.write('<p>&nbsp;</p>');\n"));\
	websWrite(wp, T("  document.write('</div>');\n"));\
	websWrite(wp, T("  document.write('</div>');\n"));\
	websWrite(wp, T("  Write_Footer_Menu();\n"));\
	websWrite(wp, T("</script>\n"));\
	websWrite(wp, T("</body>\n"));\
	websWrite(wp, T("<script>\n"));\
	websWrite(wp, T("var secs = 30;\n"));\
	websWrite(wp, T("var wait = secs * 1000;\n"));\
	websWrite(wp, T("document.test.okbutton.value = showText(OK) + \"(\" + secs + \")\";\n"));\
	websWrite(wp, T("document.test.okbutton.disabled = true;\n"));\
	websWrite(wp, T("for(i = 1; i <= secs; i++)	setTimeout(\"update(\" + i + \")\", i * 1000);\n"));\
	websWrite(wp, T("setTimeout(\"timer()\", wait);\n"));\
	websWrite(wp, T("function update(num, value)\n"));\
	websWrite(wp, T("{\n"));\
	websWrite(wp, T("if (num == (wait/1000)) document.test.okbutton.value = showText(OK);\n"));\
	websWrite(wp, T("else\n"));\
	websWrite(wp, T("{\n"));\
	websWrite(wp, T("printnr = (wait / 1000)-num;\n"));\
	websWrite(wp, T("document.test.okbutton.value = showText(OK) + \"(\" + printnr + \")\";\n"));\
	websWrite(wp, T("}\n"));\
	websWrite(wp, T("}\n"));\
	websWrite(wp, T("function timer()\n"));\
	websWrite(wp, T("{\n"));\
	websWrite(wp, T("document.test.okbutton.disabled = false;\n"));\
	websWrite(wp, T("document.test.okbutton.value = showText(OK);\n"));\
	websWrite(wp, T("}\n"));\
	websWrite(wp, T("</script>\n"));\
	websFooter(wp);\
	websDone(wp, 200);\
}
#elif defined(_Customer_SA_)
	#define OK_MSG3(msg, url)\
	{\
		websHeader(wp);\
		websWrite(wp, T("<!--OK_MSG3--><head>\n"));\
		websWrite(wp, T("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n"));\
		websWrite(wp, T("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"));\
		websWrite(wp, T("<meta http-equiv=\"Expires\" content=\"-1\">\n"));\
		websWrite(wp, T("<link rel=\"stylesheet\" href=\"/file/set.css\">\n"));\
		websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/javascript.js\"></script>\n"));\
		websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/multilanguage.var\"></script>\n"));\
		websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/allasp-n.var\"></script>\n"));\
		websWrite(wp, T("<title></title>\n"));\
		websWrite(wp, T("</head>\n"));\
		websWrite(wp, T("<body class=\"mainbg\">\n"));\
		websWrite(wp, T("<blockquote><br><a class=\"titlecolor\">%s</a><br><br>\n"),msg);\
		websWrite(wp, T("<form name=\"test\">\n"));\
		if(url)\
		{\
			if(lanipChanged==1 || wizardEnabled==1)	websWrite(wp, T("<script>document.write('<input type=button name=\"okbutton\" value=\"'+showText(OK)+'\" class=\"button\" OnClick=top.location.replace(\"%s\")>');</script>\n"),url);\
			else websWrite(wp, T("<script>document.write('<input type=button name=\"okbutton\" value=\"'+showText(OK)+'\" class=\"button\" OnClick=window.location.replace(\"%s\")>');</script>\n"),url);\
		}\
		else websWrite(wp, T("<script>document.write('<input type=button name=\"okbutton\" value=\"'+showText(OK)+'\" class=\"button\" OnClick=window.close()>');</script>\n"));\
		websWrite(wp, T("</form>\n"));\
		websWrite(wp, T("</blockquote>\n"));\
		websWrite(wp, T("<script>\n"));\
		websWrite(wp, T("var secs = 90;\n"));\
		websWrite(wp, T("var wait = secs * 1000;\n"));\
		websWrite(wp, T("document.test.okbutton.value = showText(OK) + \"(\" + secs + \")\";\n"));\
		websWrite(wp, T("document.test.okbutton.disabled = true;\n"));\
		websWrite(wp, T("for(i = 1; i <= secs; i++)	setTimeout(\"update(\" + i + \")\", i * 1000);\n"));\
		websWrite(wp, T("setTimeout(\"timer()\", wait);\n"));\
		websWrite(wp, T("function update(num, value)\n"));\
		websWrite(wp, T("{\n"));\
		websWrite(wp, T("if (num == (wait/1000)) document.test.okbutton.value = showText(OK);\n"));\
		websWrite(wp, T("else\n"));\
		websWrite(wp, T("{\n"));\
		websWrite(wp, T("printnr = (wait / 1000)-num;\n"));\
		websWrite(wp, T("document.test.okbutton.value = showText(OK) + \"(\" + printnr + \")\";\n"));\
		websWrite(wp, T("}\n"));\
		websWrite(wp, T("}\n"));\
		websWrite(wp, T("function timer()\n"));\
		websWrite(wp, T("{\n"));\
		websWrite(wp, T("document.test.okbutton.disabled = false;\n"));\
		websWrite(wp, T("document.test.okbutton.value = showText(OK);\n"));\
		websWrite(wp, T("}\n"));\
		websWrite(wp, T("</script>\n"));\
		websWrite(wp, T("</body>\n"));\
		websFooter(wp);\
		websDone(wp, 200);\
	}
#elif defined(_Customer_EX_) || defined(_Customer_SC_)
	#define OK_MSG3(msg, url)\
	{\
		websHeader(wp);\
		websWrite(wp, T("<!--OK_MSG3--><head>\n"));\
		websWrite(wp, T("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n"));\
		websWrite(wp, T("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"));\
		websWrite(wp, T("<meta http-equiv=\"Expires\" content=\"-1\">\n"));\
		websWrite(wp, T("<link rel=\"stylesheet\" href=\"/file/set.css\">\n"));\
		websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/javascript.js\"></script>\n"));\
		websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/multilanguage.var\"></script>\n"));\
		websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/allasp-n.var\"></script>\n"));\
		websWrite(wp, T("<title></title>\n"));\
		websWrite(wp, T("</head>\n"));\
		websWrite(wp, T("<body class=\"mainbg\">\n"));\
		websWrite(wp, T("<blockquote><br><a class=\"titlecolor\">%s</a><br><br>\n"),msg);\
		websWrite(wp, T("<form name=\"test\">\n"));\
		if(url)\
		{\
			if(lanipChanged==1 || wizardEnabled==1)	websWrite(wp, T("<script>document.write('<input type=button name=\"okbutton\" value=\"'+showText(OK)+'\" class=\"button\" OnClick=top.location.replace(\"%s\")>');</script>\n"),url);\
			else websWrite(wp, T("<script>document.write('<input type=button name=\"okbutton\" value=\"'+showText(OK)+'\" class=\"button\" OnClick=window.location.replace(\"%s\")>');</script>\n"),url);\
		}\
		else websWrite(wp, T("<script>document.write('<input type=button name=\"okbutton\" value=\"'+showText(OK)+'\" class=\"button\" OnClick=window.close()>');</script>\n"));\
		websWrite(wp, T("</form>\n"));\
		websWrite(wp, T("</blockquote>\n"));\
		websWrite(wp, T("<script>\n"));\
		websWrite(wp, T("var secs = 30;\n"));\
		websWrite(wp, T("var wait = secs * 1000;\n"));\
		websWrite(wp, T("document.test.okbutton.value = showText(OK) + \"(\" + secs + \")\";\n"));\
		websWrite(wp, T("document.test.okbutton.disabled = true;\n"));\
		websWrite(wp, T("for(i = 1; i <= secs; i++)	setTimeout(\"update(\" + i + \")\", i * 1000);\n"));\
		websWrite(wp, T("setTimeout(\"timer()\", wait);\n"));\
		websWrite(wp, T("function update(num, value)\n"));\
		websWrite(wp, T("{\n"));\
		websWrite(wp, T("if (num == (wait/1000)) document.test.okbutton.value = showText(OK);\n"));\
		websWrite(wp, T("else\n"));\
		websWrite(wp, T("{\n"));\
		websWrite(wp, T("printnr = (wait / 1000)-num;\n"));\
		websWrite(wp, T("document.test.okbutton.value = showText(OK) + \"(\" + printnr + \")\";\n"));\
		websWrite(wp, T("}\n"));\
		websWrite(wp, T("}\n"));\
		websWrite(wp, T("function timer()\n"));\
		websWrite(wp, T("{\n"));\
		websWrite(wp, T("document.test.okbutton.disabled = false;\n"));\
		websWrite(wp, T("document.test.okbutton.value = showText(OK);\n"));\
		websWrite(wp, T("}\n"));\
		websWrite(wp, T("</script>\n"));\
		websWrite(wp, T("</body>\n"));\
		websFooter(wp);\
		websDone(wp, 200);\
	}
#else
	#define OK_MSG3(msg, url)\
	{\
		websHeader(wp);\
		websWrite(wp, T("<!--OK_MSG3--><head>\n"));\
		websWrite(wp, T("<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n"));\
		websWrite(wp, T("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"));\
		websWrite(wp, T("<meta http-equiv=\"Expires\" content=\"-1\">\n"));\
		websWrite(wp, T("<link rel=\"stylesheet\" href=\"/file/set.css\">\n"));\
		websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/javascript.js\"></script>\n"));\
		websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/multilanguage.var\"></script>\n"));\
		websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/allasp-n.var\"></script>\n"));\
		websWrite(wp, T("<title></title>\n"));\
		websWrite(wp, T("</head>\n"));\
		websWrite(wp, T("<body class=\"mainbg\">\n"));\
		websWrite(wp, T("<blockquote><br><a class=\"titlecolor\">%s</a><br><br>\n"),msg);\
		websWrite(wp, T("<form name=\"test\">\n"));\
		if(url)\
		{\
			if(lanipChanged==1 || wizardEnabled==1)	websWrite(wp, T("<script>document.write('<input type=button name=\"okbutton\" value=\"'+showText(OK)+'\" class=\"button\" OnClick=top.location.replace(\"%s\")>');</script>\n"),url);\
			else websWrite(wp, T("<script>document.write('<input type=button name=\"okbutton\" value=\"'+showText(OK)+'\" class=\"button\" OnClick=window.location.replace(\"%s\")>');</script>\n"),url);\
		}\
		else websWrite(wp, T("<script>document.write('<input type=button name=\"okbutton\" value=\"'+showText(OK)+'\" class=\"button\" OnClick=window.close()>');</script>\n"));\
		websWrite(wp, T("</form>\n"));\
		websWrite(wp, T("</blockquote>\n"));\
		websWrite(wp, T("<script>\n"));\
		websWrite(wp, T("var secs = 30;\n"));\
		websWrite(wp, T("var wait = secs * 1000;\n"));\
		websWrite(wp, T("document.test.okbutton.value = showText(OK) + \"(\" + secs + \")\";\n"));\
		websWrite(wp, T("document.test.okbutton.disabled = true;\n"));\
		websWrite(wp, T("for(i = 1; i <= secs; i++)	setTimeout(\"update(\" + i + \")\", i * 1000);\n"));\
		websWrite(wp, T("setTimeout(\"timer()\", wait);\n"));\
		websWrite(wp, T("function update(num, value)\n"));\
		websWrite(wp, T("{\n"));\
		websWrite(wp, T("if (num == (wait/1000)) document.test.okbutton.value = showText(OK);\n"));\
		websWrite(wp, T("else\n"));\
		websWrite(wp, T("{\n"));\
		websWrite(wp, T("printnr = (wait / 1000)-num;\n"));\
		websWrite(wp, T("document.test.okbutton.value = showText(OK) + \"(\" + printnr + \")\";\n"));\
		websWrite(wp, T("}\n"));\
		websWrite(wp, T("}\n"));\
		websWrite(wp, T("function timer()\n"));\
		websWrite(wp, T("{\n"));\
		websWrite(wp, T("document.test.okbutton.disabled = false;\n"));\
		websWrite(wp, T("document.test.okbutton.value = showText(OK);\n"));\
		websWrite(wp, T("}\n"));\
		websWrite(wp, T("</script>\n"));\
		websWrite(wp, T("</body>\n"));\
		websFooter(wp);\
		websDone(wp, 200);\
	}
#endif

//////////////////////////////////////////////////////////////////////////

/* Routines exported in fmmgmt.c */



extern void formPasswordSetup(webs_t wp, char_t *path, char_t *query);
extern void formUpload(webs_t wp, char_t * path, char_t * query);
extern void formUploadBootCode(webs_t wp, char_t * path, char_t * query);  //vance 2009.03.05 for upgrade boot code in fmmgmt.c
extern void formSaveConfig(webs_t wp, char_t *path, char_t *query);
extern void formSaveConfigSec(webs_t wp, char_t *path, char_t *query);
extern void formSecLog(webs_t wp, char_t *path, char_t *query);
#ifdef _WLCIOLOG_
extern void formWlLog(webs_t wp, char_t *path, char_t *query);
#endif
extern void formSysCmd(webs_t wp, char_t *path, char_t *query);
extern int sysCmdLog(int eid, webs_t wp, int argc, char_t **argv);
extern void formSysLog(webs_t wp, char_t *path, char_t *query);
extern int sysLogList(int eid, webs_t wp, int argc, char_t **argv);
extern void formDebug(webs_t wp, char_t *path, char_t *query);
extern void set_user_profile();
extern void reset_user_profile();
extern void formStats(webs_t wp, char_t *path, char_t *query);
extern void formHwSet(webs_t wp, char_t *path, char_t *query);
extern void formWdsEncrypt(webs_t wp, char_t *path, char_t *query);
extern int wdsList(int eid, webs_t wp, int argc, char_t **argv);

#ifdef _LOGIN_WEB_
extern void formLogin(webs_t wp, char_t *path, char_t *query);
extern int KeyID[100];
extern int IDtime[100];
extern int id;
#endif

#ifdef _Systempingtool_
extern void formSystempingEnd(webs_t wp, int argc, char_t **argv);
extern void formSystempingtool(webs_t wp, int argc, char_t **argv);
#endif

#ifdef _CONNECTION_INFO_
extern int formConnectInfoList(int eid, webs_t wp, int argc, char_t **argv);
#endif

#ifdef _CONNECTION_CTRL_
extern void formConnectionCtrlSet(webs_t wp, char_t *path, char_t *query);
#endif
////////////////////////////////////////////////////////////////////////////////////////

extern char _WAN_IF_[10];
extern char _LAN_IF_[10];

extern int main_menu;
extern int sub_menu;
extern int third_menu;

extern int upgrade_status;

extern char charset[20];

extern char *submitUrlp;
// Tommy
extern int lanipChanged;
extern int sitesurveyed;
#if defined(_Customer_) && (defined(_EW7218HNL_) || defined(_EW7428HRN_)) || defined(_SETTING_WIZARD_)
extern int auth_mode;
extern int encrypt_mode;
#endif
extern char GlobalWEPkey[60];
#ifdef _Systempingtool_
extern int pingstatus;
#endif
//kyle 2007.09.17 for wifi test
extern void formWifiEnable(webs_t wp, char_t *path, char_t *query);
//kyle 2007.03.12 for Wps
extern void formWpsEnable(webs_t wp, char_t *path, char_t *query);
#ifdef _WPS_NO_BROADCAST_
	extern void formWpsProxyEnable(webs_t wp, char_t *path, char_t *query);
#endif

//extern void formWpsConfig(webs_t wp, char_t *path, char_t *query);
extern void formWsc(webs_t wp, char_t *path, char_t *query); //Thomas_20100611
extern void formWpsRest(webs_t wp, char_t *path, char_t *query);
extern void formWpsStart(webs_t wp, char_t *path, char_t *query);
//end kyle

//kyle 2007.07.06
extern void formConnectionSetting(webs_t wp, char_t *path, char_t *query);
//end kyle
// Tommy
extern int wizardEnabled;

#if defined(HOME_GATEWAY) || defined(_AP_WITH_TIMEZONE_)
extern void formTimeZoneSetup(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef _QoS_MODE_SELECT_
extern int QosConList(int eid, webs_t wp, int argc, char_t **argv);
extern int ConQosShow(int eid, webs_t wp, int argc, char_t **argv);
extern void formConQoS(webs_t wp, char_t *path, char_t *query);
#endif

#if defined(HOME_GATEWAY) || defined(_AP_WITH_WIZARD_)
// Lance
extern void formUSBStorage(webs_t wp, char_t *path, char_t *query);
// End-Lance
//extern int wizardEnabled;
extern void formWizSetup(webs_t wp, char_t *path, char_t *query);

#if defined(_AUTO_WAN_PROB_)
extern void formWanProb(webs_t wp, char_t *path, char_t *query);
#endif
extern void formReManagementSetup(webs_t wp, char_t *path, char_t *query);


extern void formOpMode(webs_t wp, char_t *path, char_t *query);
extern void formStcIpSetup(webs_t wp, char_t *path, char_t *query);
extern void formDynIpSetup(webs_t wp, char_t *path, char_t *query);
extern void formPPPoESetup(webs_t wp, char_t *path, char_t *query);
extern void formPPTPSetup(webs_t wp, char_t *path, char_t *query);
extern void formL2TPSetup(webs_t wp, char_t *path, char_t *query);
extern void formTELBPSetup(webs_t wp, char_t *path, char_t *query);
extern void formDDNSSetup(webs_t wp, char_t *path, char_t *query);

extern void formWlEnable(webs_t wp, char_t *path, char_t *query);

extern void formVirtualSv(webs_t wp, char_t *path, char_t *query);
extern int virtualSvList(int eid, webs_t wp, int argc, char_t **argv);
extern void formUPNPSetup(webs_t wp, char_t *path, char_t *query);
extern void formALGSetup(webs_t wp, char_t *path, char_t *query);

extern void formAPModeSwitch(webs_t wp, char_t *path, char_t *query);
extern void formNatEnable(webs_t wp, char_t *path, char_t *query);
#if defined(_IGMP_PROXY_)
	extern void formIgmpEnable(webs_t wp, char_t *path, char_t *query);
#endif
extern void formFwEnable(webs_t wp, char_t *path, char_t *query);
extern int ACPCList(int eid, webs_t wp, int argc, char_t **argv);
extern void formPreventionSetup(webs_t wp, char_t *path, char_t *query);
extern int DMZList(int eid, webs_t wp, int argc, char_t **argv);
extern int StcRoutList(int eid, webs_t wp, int argc, char_t **argv);
extern int URLBList(int eid, webs_t wp, int argc, char_t **argv);
extern void formPSSetup(webs_t wp, char_t *path, char_t *query); // Lance 2004.2.9

extern void formQoS(webs_t wp, char_t *path, char_t *query);
extern int Wan1QosList(int eid, webs_t wp, int argc, char_t **argv);

#if defined(_Customer_) | defined(_MPPPOE_)
extern int Wan2QosList(int eid, webs_t wp, int argc, char_t **argv);
#endif
extern int QosShow(int eid, webs_t wp, int argc, char_t **argv);
extern void initQos();
extern int newpage;
extern int First, Changed;
extern void formConnect(); // Tommy 2005.11.02

#if defined(_ENRIP_)
//RIP
extern void formRIPSetup(webs_t wp, char_t *path, char_t *query);
#endif
#if defined(_ENSNMP_)
//SNMP
extern void formSNMPSetup(webs_t wp, char_t *path, char_t *query);
#endif
#ifdef _taiCustomer_
//RIP
 extern void formRIPSetup(webs_t wp, char_t *path, char_t *query);
//SNMP
extern void formSNMPSetup(webs_t wp, char_t *path, char_t *query);
#endif
#endif
extern void formReboot();
extern void formApply(); // Tommy 2005.4.29
extern void formAccept(webs_t wp, char_t *path, char_t *query);
extern void formLicence(webs_t wp, char_t *path, char_t *query);

////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////

/***********************      Added By Yeahone!      ***********************/

extern int showSomeString(int eid, webs_t wp, int argc, char_t **argv);
extern int showWebsPasswd(int eid, webs_t wp, int argc, char_t **argv);

/***********************      Added By Yeahone!      ***********************/

/* Routines exported in fmget.c */
#ifndef _BOA_
extern int getIndex(int eid, webs_t wp, int argc, char_t **argv);
#else
extern int getIndex(char *, char*);
extern int getIndexStr(int eid, webs_t wp, int argc, char_t **argv);
extern int getVar(int eid, webs_t wp, int argc, char_t **argv);
#endif
extern int getInfo(int eid, webs_t wp, int argc, char_t **argv);
extern int getMyName(int eid, webs_t wp, int argc, char_t **argv);
//kyle
#ifdef HOME_GATEWAY
extern int isConnectPPP();
#if defined(_Customer_) | defined(_MPPPOE_)
extern int isConnectPPP1();
#endif
#endif
/* Routines exported in fmwlan.c */
//kyle for Customer wizard.
#ifdef _Customer_
extern void formWizardWlanSetup(webs_t wp, char_t *path, char_t *query);
#endif
extern void formWlanSetup(webs_t wp, char_t *path, char_t *query);
extern void formWlanMP(webs_t wp, char_t *path, char_t *query);
extern int wlAcList(int eid, webs_t wp, int argc, char_t **argv);
extern int wlwdsList(int eid, webs_t wp, int argc, char_t **argv);
extern void formWlAc(webs_t wp, char_t *path, char_t *query);
extern void formWlWds(webs_t wp, char_t *path, char_t *query);
extern void formAdvanceSetup(webs_t wp, char_t *path, char_t *query);
extern int wirelessClientList(int eid, webs_t wp, int argc, char_t **argv);
#ifdef _BR6428PNL_
extern int wirelessClientList_Customer(int eid, webs_t wp, int argc, char_t **argv);
extern int wirelessClientNumber_Customer(int eid, webs_t wp, int argc, char_t **argv);
#endif
#ifdef _STAR_
extern int wirelessClientListM(int eid, webs_t wp, int argc, char_t **argv);
#endif
extern void formWirelessTbl(webs_t wp, char_t *path, char_t *query);
//extern void formWep(webs_t wp, char_t *path, char_t *query);	//Erwin
extern void formWlSiteSurvey(webs_t wp, char_t *path, char_t *query);
#if defined(_SETTING_WIZARD_)
extern void formWizSurvey(webs_t wp, char_t *path, char_t *query);
int WizSurveyTbl(int eid, webs_t wp, int argc, char_t **argv);
#endif
int wlSiteSurveyTbl(int eid, webs_t wp, int argc, char_t **argv);

// Static DHCP Lease
extern int SDHCPList(int eid, webs_t wp, int argc, char_t **argv);
extern void formSDHCP(webs_t wp, char_t *path, char_t *query);
//------------------

//vance add 2008.11.20
#ifdef _WIRELESS_SCHEDULE_
extern void formWlSch(webs_t wp, char_t *path, char_t *query);
extern int wlSchList(int eid, webs_t wp, int argc, char_t **argv);
#endif

//Felix 21011222
#ifdef _PROFILE_LIST_
extern void formProfileList(webs_t wp, char_t *path, char_t *query);
extern int profileList(int eid, webs_t wp, int argc, char_t **argv);
extern int profileListSSID(int eid, webs_t wp, int argc, char_t **argv);
extern int profileListShow(int eid, webs_t wp, int argc, char_t **argv);
extern int NoweditProfile;
#endif

#ifdef WLAN_WPA
extern void formWlEncrypt(webs_t wp, char_t *path, char_t *query);
#if defined(_Customer_SA_) || defined(_Customer_EX_)
extern void formWlEncryptWizard(webs_t wp, char_t *path, char_t *query);
#endif
#endif

#ifndef HOME_GATEWAY	// Radius server
extern void formCerload(webs_t wp, char_t * path, char_t * query);
extern void formStaEncrypt(webs_t wp, char_t *path, char_t *query);
extern void formStaSec(webs_t wp, char_t *path, char_t *query);
extern void formRadius(webs_t wp, char_t *path, char_t *query);
extern int RadiusCltList(int eid, webs_t wp, int argc, char_t **argv);
extern int RadiusUsrList(int eid, webs_t wp, int argc, char_t **argv);
#endif

/* Routines exported in fmtcpip.c */
extern void formTcpipSetup(webs_t wp, char_t *path, char_t *query);

extern int isDhcpClientExist(char *name);



#ifdef _7264Wn_
//ADSL
//New Add fmtcpip.c
	extern void formWizard(webs_t wp, char_t *path, char_t *query);
	extern void formWanAdslSetup(webs_t wp, char_t *path, char_t *query);
	extern void formAdslConsole(webs_t wp, char_t *path, char_t *query);
#endif


#ifdef HOME_GATEWAY
extern void formWanTcpipSetup(webs_t wp, char_t *path, char_t *query);
extern void formReflashClientTbl(webs_t wp, char_t *path, char_t *query);
extern int dhcpClientList(int eid, webs_t wp, int argc, char_t **argv);
#ifdef _EZVIEW_
extern int dhcpClientListforEZ(int eid, webs_t wp, int argc, char_t **argv);
#endif

//vance 2008.11.03
#ifdef _PC_DATABASE_
extern int groupList(int eid, webs_t wp, int argc, char_t **argv);
extern int pcDatabaseList(int eid, webs_t wp, int argc, char_t **argv);
extern void formPcdatabaseSetup(webs_t wp, char_t *path, char_t *query);
extern void formGroupSetup(webs_t wp, char_t *path, char_t *query);
#endif

/* Routines exported in fmfwall.c */
extern void formPortFw(webs_t wp, char_t *path, char_t *query);
//#endif
extern void formFilter(webs_t wp, char_t *path, char_t *query);
extern void formUrlb(webs_t wp, char_t *path, char_t *query);
//#ifdef HOME_GATEWAY
extern int portFwList(int eid, webs_t wp, int argc, char_t **argv);
//extern int portFilterList(int eid, webs_t wp, int argc, char_t **argv);
//extern int ipFilterList(int eid, webs_t wp, int argc, char_t **argv);
extern int macFilterList(int eid, webs_t wp, int argc, char_t **argv);
extern void formTriggerPort(webs_t wp, char_t *path, char_t *query);
extern int triggerPortList(int eid, webs_t wp, int argc, char_t **argv);
#endif

#ifdef _VLAN_CONFIG_SUPPORTED_
extern int vlanList(int eid, webs_t wp, int argc, char_t **argv);
extern void formVlan(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef _MSSID_	//Wise
extern void formMultipleSSID(webs_t wp, char_t *path, char_t *query);
//extern int MwirelessClientList(int eid, webs_t wp, int argc, char_t **argv);
#endif

#ifdef _EZVIEW_ //Wise
extern void formEZmngSetup(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef _PPPOE_PASSTHROUGH_
extern void formPPPoEpassEnable(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef _IPV6_BRIDGE_
extern void formIPv6BridgeEnable(webs_t wp, char_t *path, char_t *query);
#endif


#ifdef _HIDING_CGI_MP_PAGE_
void mp(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef _WAN3G_
extern void form3GSetup(webs_t wp, char_t *path, char_t *query);
#endif
#ifdef _STAR_CF_3G_ //vance 2009.02.04 3G connection for NetIndex
extern void formWan3GSetup(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef _WISP_
void formStaDrvSetup(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef _GET_A_DHCP_IP_
extern void get_a_dhcp_ip(webs_t wp, char_t *path, char_t *query);
#endif

void formrefresh(webs_t wp, char_t *path, char_t *query);
#ifdef _SOFT_ARSWITCH_
extern void formARoption(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef _STARCRAFT_
extern void formSTARCRAFTSetup(webs_t wp, char_t *path, char_t *query);
extern int STARCRAFTList(int eid, webs_t wp, int argc, char_t **argv);
#endif

#ifdef _AUTO_CHANNEL_DET_
int channelDet();
#endif

#ifdef _WEBSITE_FIRMWARE_UPGRADE_
void formUploadWebsite(webs_t wp, char_t *path, char_t *query);
#endif
#if defined(_Customer_) && (defined(_EW7218HNL_) || defined(_EW7428HRN_))
void formWizSetting(webs_t wp, char_t *path, char_t *query);
#endif
#if defined(_LED_SWITCH_) || defined(_SW_LED_SWITCH_)
extern void formLedSwitch(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef _GREEN_AP_SCHEDULE_
void formGreenAPschedule(webs_t wp, char_t *path, char_t *query);
#endif

int formsDefine(void);

#ifdef _AUTO_CHANNEL_DET_
int channelDet();
#endif

#if defined(_CONNECT_TEST_)
int CONNECT_TEST();
void formCONNOK(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef _Airlive_
void formAirliveWiz(webs_t wp, char_t *path, char_t *query);
void formSetSurvey(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef _Airlive_Schedule_
void formAirliveSchedule(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef _RTK_NTP_
void formNtp(webs_t wp, char_t *path, char_t *query);
#endif
extern int dhcpClientList(int eid, webs_t wp, int argc, char_t **argv);
extern void formReflashClientTbl(webs_t wp, char_t *path, char_t *query);

#endif // _INCLUDE_APFORM_H
