/**
 *      Header file of AP mib
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *
 *      $Id: apmib.h,v 1.1.1.1 2005/03/09 04:52:51 rex Exp $
 *
 */


#ifndef INCLUDE_APMIB_H
#define INCLUDE_APMIB_H

#ifdef _MSSID_
#if defined(_Customer_EX_) || defined(_Customer_SA_)
#define NUM_VWLAN               4
#else
#define NUM_VWLAN		3	// number of virtual wlan interface supported
#endif
#else
#define NUM_VWLAN		0
#endif
#ifdef UNIVERSAL_REPEATER
#define NUM_VWLAN_INTERFACE		NUM_VWLAN+1
#else
#define NUM_VWLAN_INTERFACE		NUM_VWLAN
#endif
#define MAX_IFACE_VLAN_CONFIG 10 /* no wds and vxd*/
#define IFNAMSIZE       16
// WLAN MIB id
typedef enum {
MIB_WLAN_SSID=1,
MIB_WLAN_CHAN_NUM,
MIB_WLAN_WEP,
MIB_WLAN_WEP64_KEY1,
MIB_WLAN_WEP64_KEY2,
MIB_WLAN_WEP64_KEY3,
MIB_WLAN_WEP64_KEY4,
MIB_WLAN_WEP128_KEY1,
MIB_WLAN_WEP128_KEY2,
MIB_WLAN_WEP128_KEY3,
MIB_WLAN_WEP128_KEY4,
MIB_WLAN_WEP_KEY_TYPE,
MIB_WLAN_WEP_DEFAULT_KEY,
MIB_WLAN_FRAG_THRESHOLD,
MIB_WLAN_SUPPORTED_RATE,
MIB_WLAN_BEACON_INTERVAL,
MIB_WLAN_PREAMBLE_TYPE,
MIB_WLAN_BASIC_RATE,
MIB_WLAN_RTS_THRESHOLD,
MIB_WLAN_AUTH_TYPE,
MIB_WLAN_HIDDEN_SSID,
MIB_WLAN_DISABLED,
// Rex add
MIB_WLAN_TX_POWER,
MIB_WLAN_WMM,
//kyle
MIB_WLAN_NOFORWARD,
MIB_WLAN_TURBO,
MIB_WLAN_N_FIX_RATE,
MIB_WLAN_N_CHANNEL_WIDTH,
//MIB_ALIAS_NAME,
MIB_ELAN_MAC_ADDR,
MIB_WLAN_MAC_ADDR,
#ifdef WLAN_WPA
MIB_WLAN_ENCRYPT,		// 0 - Encrypt disabled, 1 - WEP, 2 - WPA, 4 - WPA2, 6 - WPA2 mixed
MIB_WLAN_ENABLE_SUPP_NONWPA,
MIB_WLAN_SUPP_NONWPA,
MIB_WLAN_WPA_AUTH,		// WPA authentication type, 1 - WPA-Radius, 2 - PSK
MIB_WLAN_WPA_CIPHER_SUITE,	// WPA Cipher suite, 1 - TKIP, 2 - AES
MIB_WLAN_WPA_PSK,
MIB_WLAN_WPA_GROUP_REKEY_TIME,
#if defined(_Customer_EX_) || defined(_Customer_SA_)
MIB_WLAN_WPA_GROUP_REKEY_TIME_1,
MIB_WLAN_WPA_GROUP_REKEY_TIME_2,
MIB_WLAN_WPA_GROUP_REKEY_TIME_3,
MIB_WLAN_WPA_GROUP_REKEY_TIME_4,
MIB_WLAN_WPA_GROUP_REKEY_TIME_5,
MIB_WLAN_WPA_GROUP_REKEY_TIME_6,
MIB_WLAN_WPA_GROUP_REKEY_TIME_7,
#endif
MIB_WLAN_RS_IP,
MIB_WLAN_RS_PORT,
MIB_WLAN_RS_PASSWORD,
MIB_WLAN_ENABLE_1X,
MIB_WLAN_WPA_PSK_FORMAT,
#endif   //end    WLAN_WPA
MIB_WLAN_INACTIVITY_TIME,
MIB_WLAN_RATE_ADAPTIVE_ENABLED,
// access control MIB id
MIB_WLAN_AC_ENABLED,
MIB_WLAN_AC_NUM,
MIB_WLAN_AC_ADDR,
MIB_WLAN_AC_ADDR_ADD,
MIB_WLAN_AC_ADDR_DEL,
MIB_WLAN_AC_ADDR_DELALL,
//Airlive
#if defined(_MULTIPLE_WLAN_ACCESS_CONTROL_)
MIB_WLAN_AC2_ENABLED,
MIB_WLAN_AC2_NUM,
MIB_WLAN_AC2_ADDR,
MIB_WLAN_AC2_ADDR_ADD,
MIB_WLAN_AC2_ADDR_DEL,
MIB_WLAN_AC2_ADDR_DELALL,
MIB_WLAN_AC3_ENABLED,
MIB_WLAN_AC3_NUM,
MIB_WLAN_AC3_ADDR,
MIB_WLAN_AC3_ADDR_ADD,
MIB_WLAN_AC3_ADDR_DEL,
MIB_WLAN_AC3_ADDR_DELALL,
MIB_WLAN_AC4_ENABLED,
MIB_WLAN_AC4_NUM,
MIB_WLAN_AC4_ADDR,
MIB_WLAN_AC4_ADDR_ADD,
MIB_WLAN_AC4_ADDR_DEL,
MIB_WLAN_AC4_ADDR_DELALL,

MIB_WLAN_AC5_ENABLED,
MIB_WLAN_AC5_NUM,
MIB_WLAN_AC5_ADDR,
MIB_WLAN_AC5_ADDR_ADD,
MIB_WLAN_AC5_ADDR_DEL,
MIB_WLAN_AC5_ADDR_DELALL,
#endif
// web access control MIB
MIB_SUPER_NAME,
MIB_SUPER_PASSWORD,
MIB_USER_NAME,
MIB_USER_PASSWORD,
MIB_DHCP_CLIENT_START,
MIB_DHCP_CLIENT_END,

#ifdef HOME_GATEWAY

MIB_WAN_MAC_ADDR,
MIB_WAN_IP_ADDR,
MIB_WAN_SUBNET_MASK,
MIB_WAN_DEFAULT_GATEWAY,
MIB_WAN_DHCP,
MIB_WAN_DNS_MODE,
MIB_WAN_DNS1,
MIB_WAN_DNS2,
MIB_WAN_DNS3,
MIB_PPP_USER,
MIB_PPP_PASSWORD,
MIB_PPP_IDLE_TIME,
MIB_PPP_CONNECT_TYPE,
#if defined(_MPPPOE_)
MIB_PPP_USER1, //alex 2007/01/31
MIB_PPP_PASSWORD1, //alex 2007/01/31
MIB_PPP_IDLE_TIME1, //alex 2007/01/31
MIB_PPP_CONNECT_TYPE1, //alex 2007/01/31
#endif
MIB_PORTFW_ENABLED,
MIB_PORTFW_NUM,
MIB_PORTFW,
MIB_PORTFW_ADD,
MIB_PORTFW_DEL,
MIB_PORTFW_DELALL,
MIB_IPFILTER_ENABLED,
MIB_IPFILTER_NUM,
MIB_IPFILTER,
MIB_IPFILTER_ADD,
MIB_IPFILTER_DEL,
MIB_IPFILTER_DELALL,
MIB_MACFILTER_ENABLED,
#endif

#if defined(_BR6428PNL_) || defined(_AP_WITH_DNS_)
MIB_WAN_DNS_MODE,
MIB_WAN_DNS1,
MIB_WAN_DNS2,
MIB_WAN_DNS3,
#endif

#if defined(_BR6428PNL_) || defined(_AP_WITH_DHCP_CLIENT_)
MIB_DHCP_CHECK_ENABLED,
#endif

MIB_MACFILTER_NUM,
#ifdef HOME_GATEWAY
MIB_MACFILTER,
MIB_MACFILTER_ADD,
MIB_MACFILTER_DEL,
MIB_MACFILTER_DELALL,
MIB_PORTFILTER_ENABLED,
MIB_PORTFILTER_NUM,
MIB_PORTFILTER,
MIB_PORTFILTER_ADD,
MIB_PORTFILTER_DEL,
MIB_PORTFILTER_DELALL,
MIB_TRIGGERPORT_ENABLED,
MIB_TRIGGERPORT_NUM,
MIB_TRIGGERPORT,
MIB_TRIGGERPORT_ADD,
MIB_TRIGGERPORT_DEL,
MIB_TRIGGERPORT_DELALL,
MIB_DMZ_ENABLED,
MIB_WAN1_QOS_NUM,
MIB_WAN1_QOS,
MIB_WAN1_QOS_ADD,
MIB_WAN1_QOS_DEL,
MIB_WAN1_QOS_DELALL,
MIB_WAN1_QOS_UP,
MIB_WAN1_QOS_DOWN,
MIB_WAN1_QOS_EDIT,
MIB_WAN1_QOS_ENABLED,
#if defined(_MPPPOE_)
MIB_WAN2_QOS_NUM,
MIB_WAN2_QOS,
MIB_WAN2_QOS_ADD,
MIB_WAN2_QOS_DEL,
MIB_WAN2_QOS_DELALL,
MIB_WAN2_QOS_UP,
MIB_WAN2_QOS_DOWN,
MIB_WAN2_QOS_EDIT,
MIB_WAN2_QOS_ENABLED,
#endif
MIB_POLICY_SEND,
#endif
#ifdef _QoS_MODE_SELECT_
MIB_QoS_QOSTYPE,
MIB_WANCON_QOS_NUM,
MIB_WANCON_QOS,
MIB_WANCON_QOS_ADD,
MIB_WANCON_QOS_DEL,
MIB_WANCON_QOS_DELALL,
MIB_WANCON_QOS_UP,
MIB_WANCON_QOS_DOWN,
MIB_WANCON_QOS_EDIT,
#endif
#ifdef _VLAN_CONFIG_SUPPORTED_
MIB_VLANCONFIG_ENABLED,
MIB_VLANCONFIG_NUM,
MIB_VLANCONFIG,
MIB_VLANCONFIG_ADD,
MIB_VLANCONFIG_ADD1,
MIB_VLANCONFIG_DEL,
MIB_VLANCONFIG_DELALL,
#endif
// IP MIB id
MIB_IP_ADDR,
MIB_SUBNET_MASK,
MIB_DEFAULT_GATEWAY,
MIB_DHCP,
MIB_STP_ENABLED,
MIB_WLAN_DTIM_PERIOD,
MIB_WLAN_NETWORK_TYPE,
//----------------------------------------------------------------------------------
MIB_DHCPGATEWAYIP_ADDR,
MIB_DHCPNAMESERVER_ADDR,
MIB_DOMAIN_NAME,
MIB_LAN_LEASETIME,
// Lance 2003.11.14
MIB_WLAN_WDS_NUM,
MIB_WLAN_WDS,
MIB_WLAN_WDS_ADD,
MIB_WLAN_WDS_DEL,
MIB_WLAN_WDS_DELALL,
//-----------------------------------------------------------------------------------
// Hardware setting MIB
MIB_HW_BOARD_VER,
MIB_HW_NIC0_ADDR,
MIB_HW_NIC1_ADDR,
MIB_HW_WLAN_ADDR,
MIB_HW_REG_DOMAIN,
MIB_HW_RF_TYPE,
MIB_HW_TX_POWER_CCK,
MIB_HW_TX_POWER_OFDM,
MIB_HW_ANT_DIVERSITY,
MIB_HW_TX_ANT,
MIB_HW_TX_ANTB,
MIB_HW_CCA_MODE,
MIB_HW_PHY_TYPE,
MIB_HW_LED_TYPE,
MIB_HW_INIT_GAIN,
MIB_HW_11N_XCAP,
MIB_HW_11N_RXIMR,
MIB_HW_11N_LOFDMPWD,
MIB_HW_11N_ANTPWD_B,
MIB_HW_11N_ANTPWD_C,
MIB_HW_11N_ANTPWD_D,
MIB_HW_11N_THER_RFIC,
MIB_HW_WLAN_ADDR1,
MIB_HW_WLAN_ADDR2,
MIB_HW_WLAN_ADDR3,
MIB_HW_WLAN_ADDR4,
MIB_HW_WLAN_ADDR5,
MIB_HW_WLAN_ADDR6,
MIB_HW_WLAN_ADDR7,
MIB_HW_TX_POWER_OFDM_1S,
MIB_HW_TX_POWER_OFDM_2S,
MIB_HW_11N_LOFDMPWDA,
MIB_HW_11N_LOFDMPWDB,
MIB_HW_11N_TSSI1,
MIB_HW_11N_TSSI2,
MIB_HW_11N_THER,
MIB_HW_11N_RESERVED1,
#ifdef _ENABLE_POWER_TABLE_
MIB_HW_PWTBL_B,
MIB_HW_PWTBL_G,
MIB_HW_PWTBL_N_20M,
MIB_HW_PWTBL_N_40M,
MIB_HW_PWTBL_ENABLE,
#else
MIB_HW_11N_RESERVED2,
MIB_HW_11N_RESERVED3,
MIB_HW_11N_RESERVED4,
MIB_HW_11N_RESERVED5,
MIB_HW_11N_RESERVED6,
#endif
MIB_HW_11N_RESERVED7,
MIB_HW_11N_RESERVED8,
MIB_HW_WSC_PIN,
//96C
MIB_HW_TX_POWER_CCK_A,
MIB_HW_TX_POWER_CCK_B,
MIB_HW_TX_POWER_HT40_1S_A,
MIB_HW_TX_POWER_HT40_1S_B,
MIB_HW_TX_POWER_HT40_2S,
MIB_HW_TX_POWER_HT20,
MIB_HW_TX_POWER_DIFF_OFDM,
MIB_HW_11N_RESERVED9,
MIB_HW_11N_RESERVED10,
MIB_HW_TX_POWER_5G_HT40_1S_A,
MIB_HW_TX_POWER_5G_HT40_1S_B,
MIB_HW_TX_POWER_5G_HT40_2S,
MIB_HW_TX_POWER_5G_HT20,
MIB_HW_TX_POWER_5G_DIFF_OFDM,
//96C
//-------------------------------------Time Zone--------------------------------------------------
MIB_TIME_ZONE_SEL,
MIB_START_MONTH,
MIB_START_DAY,
MIB_END_MONTH,
MIB_END_DAY,
MIB_TIMESERVER_ADDR,
MIB_DAYLIGHT_ENABLE,
//---------------------------------Remote Management Host Address------------------------------
MIB_REMANHOST_ADDR,
MIB_REMANG_ENABLE,
MIB_DYNIP_HOSTNAME,
MIB_PPTPIP_ADDR,
MIB_PPTPIPMAKE_ADDR,
MIB_PPTPDFGATEWAY,
MIB_PPTPGATEWAY,
MIB_PPTP_USER,
MIB_PPTP_PASSWORD,
MIB_PPTP_IDLE_TIME,
MIB_PPP_SERVNAME,
MIB_PPP_MTU,
#if defined(_MPPPOE_)
MIB_PPP_SERVNAME1, //alex 2007/01/31
MIB_PPP_MTU1, //alex 2007/01/31
MIB_PPP_UNNUMIP, //alex 2007/01/31
MIB_PPP_UNNUMMASK, //alex 2007/01/31
MIB_PPP_UNNUMNAT, //alex 2007/01/31
MIB_PPPoE_MODE, //alex 2007/01/31
#endif
MIB_NAT_ENABLE,
MIB_FAST_NAT_ENABLE,
MIB_FIREWALL_ENABLE,
MIB_UPNP_ENABLE,
MIB_VSER_ENABLED,
MIB_VSER_NUM,
MIB_VSER,
MIB_VSER_DEL,
MIB_VSER_DELALL,
MIB_VSER_ADD,
MIB_WAN_MODE,
MIB_DMZ_NUM,
MIB_DMZ,
MIB_DMZ_ADD,
MIB_DMZ_DEL,
MIB_DMZ_DELALL,
MIB_POD_ENABLED,
MIB_PIN_ENABLED,
MIB_URLB_ENABLED,
MIB_URLB_NUM,
MIB_URLB,
MIB_URLB_ADD,
MIB_URLB_DEL,
MIB_URLB_DELALL,
MIB_ACPC_ENABLED,
MIB_ACPC_NUM,
MIB_ACPC,
MIB_ACPC_ADD,
MIB_ACPC_DEL,
MIB_ACPC_DELALL,
MIB_TELBPIP_ADDR,
MIB_TELBP_USER,
MIB_TELBP_PASSWORD,
MIB_TELBP_ENABLED,
MIB_PPTP_IPMODE,
MIB_DDNS_NAME,
MIB_DDNS_ACCOUNT,
MIB_DDNS_PASS,
MIB_DDNS_ENABLE,
MIB_DDNS_PVIDSEL,
MIB_REMAN_PORT,
MIB_PPTP_CONNECT_TYPE,
MIB_L2TP_IPMODE,
MIB_L2TP_IP_ADDR,
MIB_L2TP_MAKEADDR,
MIB_L2TP_DEFGATEWAY,
MIB_L2TP_GATEWAY,
MIB_L2TP_USER,
MIB_L2TP_PASSWORD,
MIB_L2TP_IDLE_TIME,
MIB_L2TP_CONNECT_TYPE,
MIB_PPTP_CONNT_ID,
MIB_PPTP_BEZEQ_ENABLE,
MIB_APP_LAYER_GATEWAY,
MIB_SCAN_ENABLED,
MIB_SYN_ENABLED,
MIB_DHIS_HOSTID,
MIB_DHIS_ISADDR,
MIB_DHIS_PASSWORD,
MIB_DHIS_AUTH_P1,
MIB_DHIS_AUTH_P2,
MIB_DHIS_AUTH_Q1,
MIB_DHIS_AUTH_Q2,
MIB_DHIS_SELECT,
MIB_WLAN_ENABLE_MAC_AUTH,
MIB_WLAN_RS_RETRY,
MIB_WLAN_RS_INTERVAL_TIME,
MIB_WLAN_ACCOUNT_RS_ENABLED,
MIB_WLAN_ACCOUNT_RS_IP,
MIB_WLAN_ACCOUNT_RS_PORT,
MIB_WLAN_ACCOUNT_RS_PASSWORD,
MIB_WLAN_ACCOUNT_UPDATE_ENABLED,
MIB_WLAN_ACCOUNT_UPDATE_DELAY,
MIB_WLAN_ACCOUNT_RS_RETRY,
MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME,
MIB_WLAN_IAPP_DISABLED,
MIB_AP_MODE,
MIB_WL_LINKMAC1,
MIB_WL_LINKMAC2,
MIB_WL_LINKMAC3,
MIB_WL_LINKMAC4,
MIB_WL_LINKMAC5,
MIB_WL_LINKMAC6,
MIB_SECURITY_MODE,		// 0: none 1:wep, 2: WPA_PSK, 3:WPA-Radius
MIB_CLIENT_IP_DISABLED,
MIB_SROUT_ENABLED,
MIB_SROUT_NUM,
MIB_SROUT,
MIB_SROUT_ADD,
MIB_SROUT_DEL,
MIB_SROUT_DELALL,
#ifndef HOME_GATEWAY	// Radius server
MIB_RSER_ENABLED,
MIB_RSER_CLT_NUM,
MIB_RSER_CLT,
MIB_RSER_CLT_ADD,
MIB_RSER_CLT_DEL,
MIB_RSER_CLT_DELALL,
MIB_RSER_USR_NUM,
MIB_RSER_USR,
MIB_RSER_USR_ADD,
MIB_RSER_USR_DEL,
MIB_RSER_USR_DELALL,
#endif
MIB_1X_MODE,
MIB_POD_PACK,
MIB_POD_TIME,
MIB_POD_BUR,
MIB_SYN_PACK,
MIB_SYN_TIME,
MIB_SYN_BUR,
MIB_SCAN_NUM,
MIB_PPTP_MTU,
MIB_L2TP_MTU,
MIB_WLAN_SET_TX,
MIB_WLAN_WDS_ENABLED,
MIB_WLAN_WDS_ENCRYPT,
MIB_WLAN_WDS_WPA_AUTH,
MIB_WLAN_WDS_WPA_CIPHER_SUITE,
MIB_WLAN_WDS_WPA2_CIPHER_SUITE,
MIB_WLAN_WDS_WPA_PSK,
MIB_WLAN_WDS_WPA_PSK_FORMAT,
MIB_WLAN_TRAN_RATE,
MIB_WLAN_RATE_MODE,
MIB_WLAN_CTS,
MIB_WLAN_BURST,
MIB_WLAN_WEP152_KEY1,
MIB_WLAN_WEP152_KEY2,
MIB_WLAN_WEP152_KEY3,
MIB_WLAN_WEP152_KEY4,
MIB_DMZ_EDIT,
MIB_PS_ENABLE,	// Lance 2004.2.9
MIB_PS_NAME,	// Lance 2004.2.10
MIB_PS_IPPENABLE, // Lance 2004.2.16
MIB_PS_LPRENABLE, // Lance 2004.2.16
MIB_PS_PORT1NAME, // Lance 2004.2.16
MIB_PS_PORT2NAME, // Lance 2004.2.16
MIB_LICENCE,
MIB_MACDENY_ENABLED,
MIB_IPDENY_ENABLED,
MIB_WLAN_BLOCK_RELAY,
MIB_STA_SEC_MODE,
MIB_STA_ENCRYPT,
MIB_STA_AUTH_TYPE,
MIB_STA_WPA_CIPHER_SUITE,
MIB_STA_WEP,
MIB_STA_WEP64_KEY1,
MIB_STA_WEP64_KEY2,
MIB_STA_WEP64_KEY3,
MIB_STA_WEP64_KEY4,
MIB_STA_WEP128_KEY1,
MIB_STA_WEP128_KEY2,
MIB_STA_WEP128_KEY3,
MIB_STA_WEP128_KEY4,
MIB_STA_WEP_DEFKEY,
MIB_STA_WEP_KEY_TYPE,
MIB_STA_WPA_PSK_FORMAT,
MIB_STA_WPA_PSK,
MIB_STA_WPA_AUTH,
MIB_WLAN_BSSID,
MIB_STA_SSID,
MIB_STA_ENRADIUS,
MIB_STA_EAP_TYPE,
MIB_STA_ID,
MIB_STA_PASS,
MIB_STA_PROTOCOL,
MIB_STA_EAP_ID,
MIB_STA_EAP_PASS,
MIB_STA_CLIENT_PASS,
MIB_STA_SERVER_PASS,
MIB_STA_ENCLT_CER,
MIB_STA_ENSER_CER,
MIB_CLT_CER_FILE,
MIB_SER_CER_FILE,
MIB_STA_RTS,
MIB_STA_FRAGMENT,
MIB_STA_PREAMBLE,
MIB_ADHOC_SEC_MODE,
MIB_AUTO_MAC_CLONE,
MIB_PPP_TTL_ENABLED,
#if defined(_MPPPOE_)
MIB_PPP_TTL_ENABLED1, //alex 2007/01/31
#endif
MIB_WLAN_PROTECTION_DISABLED,
MIB_WLAN_NAT25_MAC_CLONE,
MIB_WLAN_BAND,
MIB_WLAN_FIX_RATE,
MIB_WLAN_WPA2_PRE_AUTH,
MIB_WLAN_WPA2_CIPHER_SUITE,	// WPA Cipher suite, 1 - TKIP, 2 - AES
MIB_OP_MODE,
MIB_WISP_WAN_ID,
// Static Lease DHCP Server
MIB_STATIC_DHCP_ENABLED,
MIB_STATIC_DHCP_NUM,
MIB_STATIC_DHCP,
MIB_STATIC_DHCP_ADD,
#ifdef _PC_DATABASE_
MIB_STATIC_DHCP_EDIT, //vance 2008.11.03
#endif
MIB_STATIC_DHCP_DEL,
MIB_STATIC_DHCP_DELALL,
//-------------------------
MIB_WPS_ENABLE,//Kyle 2007.03.12
MIB_WPS_CONFIG_MODE,//Kyle 2007.03.12 , 3 bit  register(0x1) proxy(0x2) enrolee(0x4)
MIB_WPS_PROXY_ENABLE,//Kyle 2007.03.12
MIB_WPS_INTERNAL_REG,//Kyle 2007.03.12
MIB_WPS_DISPLAY_KEY,//kyle 2007.04.15
MIB_WPS_CONFIG_TYPE,//kyle 2007.03.12  1=via pin  0= via push button
MIB_WPS_CONFIG_STATUS,//kyle 2007.02.12  1=configured 0=unconfigured
MIB_WPS_PIN_CODE,//kyle 2007.02.12
MIB_AP_ROUTER_SWITCH,//kyle 2007.03.10 1=AP mode 0=Router mode
//kyle
MIB_DDNS_STATUS,
#if defined(_ENRIP_)
//RIP
MIB_RIP_ENABLED,
#endif
#if defined(_ENSNMP_)
//SNMP
MIB_SNMP_ENABLE,
MIB_SNMP_NAME,
#endif
#ifdef HOME_GATEWAY // For Guarantee QoS
MIB_MAX_DOWNLOAD_BANDWIDTH,
MIB_MAX_UPLOAD_BANDWIDTH,
#endif
//ADSL :Kyle
#ifdef _7264Wn_
MIB_ADSL_VPI,
MIB_ADSL_VCI,
/* Encapsulation
 * 0 pppoe LLC
 * 1 pppoe VC-Mux
 * 2 pppoa LLC
 * 3 pppoa VC-Mux
 * 4 bridge LLC
 * 5 bridge VC-Mux
 * 6 routed LLC
 * 7 routed VC-Mux
 */
MIB_ADSL_ENCAP,
/*Wan_type
 * 0 pppoe/pppoa
 * 1 bridge
 * 2 dynamic ip
 * 3 static ip
 */
MIB_ADSL_WAN_TYPE,
/**
 * ADSLMode
 * 0 Auto
 * 1 ADSL2+
 * 2 ADSL2
 * 2 G.DMT
 * 4 T1.413
 * 5 G.lite
 */
MIB_ADSL_ADSLMode,
/*
 * ADSLType
 * 0 ANNEX B
 * 1 ANNEX J
 * 2 ANNEX M
 * 3 ANNEX B/J/M
 */
MIB_ADSL_ADSLType,
/*Qos
 *
 */
MIB_ADSL_ATM,
MIB_ADSL_PCR,
MIB_ADSL_SCR,
MIB_ADSL_MBS,
#endif
/*add by kyle 2007.08.13
 * auto bridge when wan is private ip.
 *  */
MIB_AUTO_BRIDGE,
/** add by kyle 2008.0917
 * for WiFi Test
 * 32761. set_app_defined 
 */
MIB_WIFI_TEST,
MIB_IS_RESET_DEFAULT,
#ifdef UNIVERSAL_REPEATER
MIB_REPEATER_ENABLED,
MIB_REPEATER_SSID,
#endif
MIB_IGMP_PROXY_ENABLED,
#ifdef _corega_
MIB_TIMEZONE_SELECTED,
#endif
//Wise
#ifdef _MSSID_
MIB_WLAN_BAND_1,
MIB_WLAN_BAND_2,
MIB_WLAN_BAND_3,
MIB_WLAN_BAND_4,
MIB_WLAN_SSID_1,
MIB_WLAN_SSID_2,
MIB_WLAN_SSID_3,
MIB_WLAN_SSID_4,
MIB_WLAN_SSID_5,
MIB_WLAN_SSID_6,
MIB_WLAN_SSID_7,
MIB_WLAN_WEP64_KEY1_1,
MIB_WLAN_WEP64_KEY2_1,
MIB_WLAN_WEP64_KEY3_1,
MIB_WLAN_WEP64_KEY4_1,
MIB_WLAN_WEP64_KEY1_2,
MIB_WLAN_WEP64_KEY2_2,
MIB_WLAN_WEP64_KEY3_2,
MIB_WLAN_WEP64_KEY4_2,
MIB_WLAN_WEP64_KEY1_3,
MIB_WLAN_WEP64_KEY2_3,
MIB_WLAN_WEP64_KEY3_3,
MIB_WLAN_WEP64_KEY4_3,
MIB_WLAN_WEP64_KEY1_4,
MIB_WLAN_WEP64_KEY2_4,
MIB_WLAN_WEP64_KEY3_4,
MIB_WLAN_WEP64_KEY4_4,
MIB_WLAN_WEP64_KEY1_5,
MIB_WLAN_WEP64_KEY2_5,
MIB_WLAN_WEP64_KEY3_5,
MIB_WLAN_WEP64_KEY4_5,
MIB_WLAN_WEP64_KEY1_6,
MIB_WLAN_WEP64_KEY2_6,
MIB_WLAN_WEP64_KEY3_6,
MIB_WLAN_WEP64_KEY4_6,
MIB_WLAN_WEP64_KEY1_7,
MIB_WLAN_WEP64_KEY2_7,
MIB_WLAN_WEP64_KEY3_7,
MIB_WLAN_WEP64_KEY4_7,
MIB_WLAN_WEP128_KEY1_1,
MIB_WLAN_WEP128_KEY2_1,
MIB_WLAN_WEP128_KEY3_1,
MIB_WLAN_WEP128_KEY4_1,
MIB_WLAN_WEP128_KEY1_2,
MIB_WLAN_WEP128_KEY2_2,
MIB_WLAN_WEP128_KEY3_2,
MIB_WLAN_WEP128_KEY4_2,
MIB_WLAN_WEP128_KEY1_3,
MIB_WLAN_WEP128_KEY2_3,
MIB_WLAN_WEP128_KEY3_3,
MIB_WLAN_WEP128_KEY4_3,
MIB_WLAN_WEP128_KEY1_4,
MIB_WLAN_WEP128_KEY2_4,
MIB_WLAN_WEP128_KEY3_4,
MIB_WLAN_WEP128_KEY4_4,
MIB_WLAN_WEP128_KEY1_5,
MIB_WLAN_WEP128_KEY2_5,
MIB_WLAN_WEP128_KEY3_5,
MIB_WLAN_WEP128_KEY4_5,
MIB_WLAN_WEP128_KEY1_6,
MIB_WLAN_WEP128_KEY2_6,
MIB_WLAN_WEP128_KEY3_6,
MIB_WLAN_WEP128_KEY4_6,
MIB_WLAN_WEP128_KEY1_7,
MIB_WLAN_WEP128_KEY2_7,
MIB_WLAN_WEP128_KEY3_7,
MIB_WLAN_WEP128_KEY4_7,
MIB_WLAN_WPA_PSK_1,
MIB_WLAN_WPA_PSK_2,
MIB_WLAN_WPA_PSK_3,
MIB_WLAN_WPA_PSK_4,
MIB_WLAN_WPA_PSK_5,
MIB_WLAN_WPA_PSK_6,
MIB_WLAN_WPA_PSK_7,
MIB_SECURITY_MODE_1,
MIB_SECURITY_MODE_2,
MIB_SECURITY_MODE_3,
MIB_SECURITY_MODE_4,
MIB_SECURITY_MODE_5,
MIB_SECURITY_MODE_6,
MIB_SECURITY_MODE_7,
MIB_WLAN_ENABLE_1X_1,
MIB_WLAN_ENABLE_1X_2,
MIB_WLAN_ENABLE_1X_3,
MIB_WLAN_ENABLE_1X_4,
MIB_WLAN_ENABLE_1X_5,
MIB_WLAN_ENABLE_1X_6,
MIB_WLAN_ENABLE_1X_7,
MIB_WLAN_WEP_1,
MIB_WLAN_WEP_2,
MIB_WLAN_WEP_3,
MIB_WLAN_WEP_4,
MIB_WLAN_WEP_5,
MIB_WLAN_WEP_6,
MIB_WLAN_WEP_7,
MIB_WLAN_WEP_KEY_TYPE_1,
MIB_WLAN_WEP_KEY_TYPE_2,
MIB_WLAN_WEP_KEY_TYPE_3,
MIB_WLAN_WEP_KEY_TYPE_4,
MIB_WLAN_WEP_KEY_TYPE_5,
MIB_WLAN_WEP_KEY_TYPE_6,
MIB_WLAN_WEP_KEY_TYPE_7,
MIB_WLAN_WPA_CIPHER_SUITE_1,
MIB_WLAN_WPA_CIPHER_SUITE_2,
MIB_WLAN_WPA_CIPHER_SUITE_3,
MIB_WLAN_WPA_CIPHER_SUITE_4,
MIB_WLAN_WPA_CIPHER_SUITE_5,
MIB_WLAN_WPA_CIPHER_SUITE_6,
MIB_WLAN_WPA_CIPHER_SUITE_7,
MIB_WLAN_WPA2_CIPHER_SUITE_1,
MIB_WLAN_WPA2_CIPHER_SUITE_2,
MIB_WLAN_WPA2_CIPHER_SUITE_3,
MIB_WLAN_WPA2_CIPHER_SUITE_4,
MIB_WLAN_WPA2_CIPHER_SUITE_5,
MIB_WLAN_WPA2_CIPHER_SUITE_6,
MIB_WLAN_WPA2_CIPHER_SUITE_7,
MIB_WLAN_WPA_PSK_FORMAT_1,
MIB_WLAN_WPA_PSK_FORMAT_2,
MIB_WLAN_WPA_PSK_FORMAT_3,
MIB_WLAN_WPA_PSK_FORMAT_4,
MIB_WLAN_WPA_PSK_FORMAT_5,
MIB_WLAN_WPA_PSK_FORMAT_6,
MIB_WLAN_WPA_PSK_FORMAT_7,
MIB_WLAN_WEP_DEFAULT_KEY_1,
MIB_WLAN_WEP_DEFAULT_KEY_2,
MIB_WLAN_WEP_DEFAULT_KEY_3,
MIB_WLAN_WEP_DEFAULT_KEY_4,
MIB_WLAN_WEP_DEFAULT_KEY_5,
MIB_WLAN_WEP_DEFAULT_KEY_6,
MIB_WLAN_WEP_DEFAULT_KEY_7,
MIB_WLAN_SSID_MIRROR_1,
MIB_WLAN_SSID_MIRROR_2,
MIB_WLAN_SSID_MIRROR_3,
MIB_WLAN_SSID_MIRROR_4,
MIB_WLAN_SSID_MIRROR_5,
MIB_WLAN_SSID_MIRROR_6,
MIB_WLAN_SSID_MIRROR_7,
MIB_WLAN_FIX_RATE_1,
MIB_WLAN_FIX_RATE_2,
MIB_WLAN_FIX_RATE_3,
MIB_WLAN_FIX_RATE_4,
MIB_WLAN_FIX_RATE_5,
MIB_WLAN_FIX_RATE_6,
MIB_WLAN_FIX_RATE_7,
MIB_WLAN_HIDDEN_SSID_1,
MIB_WLAN_HIDDEN_SSID_2,
MIB_WLAN_HIDDEN_SSID_3,
MIB_WLAN_HIDDEN_SSID_4,
MIB_WLAN_HIDDEN_SSID_5,
MIB_WLAN_HIDDEN_SSID_6,
MIB_WLAN_HIDDEN_SSID_7,
MIB_WLAN_WMM_1,
MIB_WLAN_WMM_2,
MIB_WLAN_WMM_3,
MIB_WLAN_WMM_4,
MIB_WLAN_WMM_5,
MIB_WLAN_WMM_6,
MIB_WLAN_WMM_7,
MIB_WLAN_ACCESS_1,
MIB_WLAN_ACCESS_2,
MIB_WLAN_ACCESS_3,
MIB_WLAN_ACCESS_4,
MIB_WLAN_ENCRYPT_1,
MIB_WLAN_ENCRYPT_2,
MIB_WLAN_ENCRYPT_3,
MIB_WLAN_ENCRYPT_4,
MIB_WLAN_ENCRYPT_5,
MIB_WLAN_ENCRYPT_6,
MIB_WLAN_ENCRYPT_7,
MIB_WLAN_AUTH_TYPE_1,
MIB_WLAN_AUTH_TYPE_2,
MIB_WLAN_AUTH_TYPE_3,
MIB_WLAN_AUTH_TYPE_4,
MIB_WLAN_AUTH_TYPE_5,
MIB_WLAN_AUTH_TYPE_6,
MIB_WLAN_AUTH_TYPE_7,
MIB_WLAN_WPA_AUTH_1,		// WPA authentication type, 1 - WPA-Radius, 2 - PSK
MIB_WLAN_WPA_AUTH_2,		// WPA authentication type, 1 - WPA-Radius, 2 - PSK
MIB_WLAN_WPA_AUTH_3,		// WPA authentication type, 1 - WPA-Radius, 2 - PSK
MIB_WLAN_WPA_AUTH_4,		// WPA authentication type, 1 - WPA-Radius, 2 - PSK
MIB_WLAN_WPA_AUTH_5,		// WPA authentication type, 1 - WPA-Radius, 2 - PSK
MIB_WLAN_WPA_AUTH_6,		// WPA authentication type, 1 - WPA-Radius, 2 - PSK
MIB_WLAN_WPA_AUTH_7,		// WPA authentication type, 1 - WPA-Radius, 2 - PSK
	#if defined(_ENVLAN_)
	MIB_WLAN_VLANID_1,
	MIB_WLAN_VLANID_2,
	MIB_WLAN_VLANID_3,
	MIB_WLAN_VLANID_4,
	MIB_WLAN_VLANID_5,
	MIB_WLAN_VLANID_6,
	MIB_WLAN_VLANID_7,
	#endif
#endif
#ifdef _EZVIEW_
MIB_EZVIEW_NUM,
MIB_EZVIEW,
MIB_EZVIEW_ADD,
MIB_EZVIEW_DEL,
MIB_EZVIEW_DELALL,
MIB_EZVIEW_DMZ,
#endif


#ifdef _DALGFTP_
MIB_ALG_FTP_PORTS,
#endif
#ifdef _DBAND_
MIB_DUAL_BAND_SWITCH,
MIB_ABAND_MODE,
MIB_ABAND_CHANNEL,
#endif
#ifdef _LAN_WAN_ACCESS_
MIB_LAN_WAN_ACCESS,
#endif
#ifdef _PPPOE_PASSTHROUGH_
MIB_PPPOE_PASSTHROUGH,
#endif
#ifdef _IPV6_BRIDGE_
MIB_IPV6_BRIDGE,
#endif
#ifdef _WANTTL_
MIB_TTL_TYPE,
MIB_TTL_VALUE,
#endif
#ifdef _INDEPEND_DHCP_MTU_
MIB_DHCP_MTU,
#endif
#ifdef _SREBOOT_BLINK_POWER_
MID_IS_REBOOT,
#endif
#ifdef _WATCH_DOG_
MIB_WATCH_DOG_ENABLE,
MIB_WATCH_DOG_INTERVAL,
MIB_WATCH_DOG_HOST,
#endif
//vance 2008.11.03
#ifdef _PC_DATABASE_
MIB_GROUP1,
MIB_GROUP2,
MIB_GROUP3,
MIB_GROUP4,
MIB_GROUP1_DISABLED,
MIB_GROUP2_DISABLED,
MIB_GROUP3_DISABLED,
MIB_GROUP4_DISABLED,
#endif
//vance 2008.11.14
#ifdef _WIRELESS_SCHEDULE_
MIB_WLAN_SCH_ENABLED,
MIB_WLAN_SCH_NUM,
MIB_WLAN_SCH,
MIB_WLAN_SCH_ADD,
MIB_WLAN_SCH_DEL,
MIB_WLAN_SCH_DELALL,
#endif

//Felix 21011222
#ifdef _PROFILE_LIST_
MIB_PROFILE_LIST_NUM,
MIB_PROFILE_LIST,
MIB_PROFILE_LIST_ADD,
MIB_PROFILE_LIST_DEL,
MIB_PROFILE_LIST_DELALL,
MIB_PROFILE_LIST_EDIT,
#endif

#ifdef _WAN3G_
MIB_WWAN_AUTHMODESEL,
MIB_WWAN_OPMODESEL,
MIB_WWAN_NPSEL,
MIB_WWAN_NAME,
MIB_WWAN_PASSWORD,
MIB_WWAN_PINCODE,
MIB_WWAN_APN,
MIB_WWAN_PPPNAME,
MIB_WWAN_PPPPASS,
MIB_WWAN_PPPIDLETIME,
MIB_WWAN_PPPECHOTIMEOUT,
MIB_WWAN_PPPECHOCOUNT,
MIB_WWAN_PHONENO,
#endif
//vance 2009.02.04 for 3G connetion
#ifdef _STAR_CF_3G_
MIB_WWAN_NPSEL,
MIB_WWAN_NAME,
MIB_WWAN_PASSWORD,
MIB_WWAN_APN,
MIB_WWAN_PPPNAME,
MIB_WWAN_PPPPASS,
MIB_WWAN_PPPIDLETIME,
MIB_WWAN_PPPECHOTIMEOUT,
MIB_WWAN_PPPECHOCOUNT,
MIB_WWAN_PHONENO,
MIB_WWAN_CONNETTYPE,
#endif
#ifdef _GENERAL_3G_ //vance 2009.04.09 for general
MIB_WWAN_PINCODE,
MIB_WWAN_AUTHMODESEL,
MIB_WWAN_OPMODESEL,
#endif
#ifdef _WISP_
MIB_STADRV_TYPE,
MIB_STADRV_SSID,
MIB_STADRV_CHAN_NUM,
MIB_STADRV_BAND,
MIB_STADRV_ENCRYPT_TYPE,
MIB_STADRV_WEP_LENGTH,
MIB_STADRV_WEP_FORMAT1,
MIB_STADRV_WEP_FORMAT2,
MIB_STADRV_WEP_FORMAT3,
MIB_STADRV_WEP_FORMAT4,
MIB_STADRV_WEP_DEFAULT_KEY,
MIB_STADRV_WPA_CIPHER,
MIB_STADRV_PSK_FORMAT,
MIB_STADRV_WEPKEY1,
MIB_STADRV_WEPKEY2,
MIB_STADRV_WEPKEY3,
MIB_STADRV_WEPKEY4,
MIB_STADRV_PSKKEY,
MIB_STADRV_WANTYPE,
MIB_STADRV_HOSTNAME,
MIB_STADRV_CLONEMAC,
MIB_STADRV_IP,
MIB_STADRV_MASK,
MIB_STADRV_GATEWAY,
#endif
#ifdef _Unicorn_
MIB_QOS_MODE,
#endif
#ifdef _SDMZ_
MIB_DMZ_MODE,
MIB_DMZ_MAC_ADDR,
MIB_SUPERDMZ_REFRESHTIME,
#endif
#ifdef _CONNECTION_CTRL_
MIB_CONNECCOUNT_MAX,
MIB_UDPCOUNT_MAX,
MIB_ICMPCOUNT_MAX,
MIB_TCPCOUNT_MAX,
MIB_TIMEOUT_ESTABLISHED,
MIB_TIMEOUT_SYNSENT,
MIB_TIMEOUT_SYNRECV,
MIB_TIMEOUT_FINWAIT,
MIB_TIMEOUT_CLOSEWAIT,
MIB_TIMEOUT_LASTACK,
MIB_TIMEOUT_GENERIC,
MIB_CONNECTIONCTRL_ENABLED,
#endif
#if defined(_TRIPPPOE_) & defined(_MPPPOE_)
MIB_PPP_USER2,
MIB_PPP_PASSWORD2,
MIB_PPP_IDLE_TIME2,
MIB_PPP_CONNECT_TYPE2,
MIB_PPP_SERVNAME2,
MIB_PPP_MTU2,
MIB_PPP_UNNUMIP2,
MIB_PPP_UNNUMMASK2,
#endif
#ifdef _LEDSWITCH_
MIB_LED_CONTROL,
#endif

#ifdef _DHCP_SERVER_WITH_GW_DNS_
MIB_DHCP_SERVER_GW,
MIB_DHCP_SERVER_DNS1,
MIB_DHCP_SERVER_DNS2,
#endif
#ifdef _STARCRAFT_
MIB_STARCRAFT_NUM,
MIB_STARCRAFT,
MIB_STARCRAFT_ADD,
MIB_STARCRAFT_DEL,
MIB_STARCRAFT_DELALL,
#endif

#ifdef _GET_TIME_FROM_PC_
MIB_PC_TIME,
#endif

#if defined(_Customer_EX_) || defined(_Customer_SC_) || defined(_Customer_SA_)
MIB_GUARD_INTERVAL,
MIB_DECLINE_BA_REQUEST,
MIB_ISOLATION,
MIB_MBSSID_ISOLATION,
#endif

#ifdef _SNTP_A_M_CTL_ //vance 2009.02.20
MIB_TIMESERVER_DOMAIN,  //for time server domain name
MIB_TIMESERVER_ENABLE, //for sntp auto/manual setting
MIB_STATIC_SYSTEM_TIME,  //static system time for manual time setting
#endif

#if defined(_COPY_ROOT_SSID_)
MIB_SSID_CHOICE,
#endif

#ifdef _GREEN_AP_SCHEDULE_	//Felix 2011.02.15
MIB_GREENAP_ENABLE,
MIB_GREENAP_WEEKDAYS1,
MIB_GREENAP_WEEKDAYS2,
MIB_GREENAP_WEEKDAYS3,
MIB_GREENAP_WEEKDAYS4,
MIB_GREENAP_POWERLEVEL1,
MIB_GREENAP_POWERLEVEL2,
MIB_GREENAP_POWERLEVEL3,
MIB_GREENAP_POWERLEVEL4,
//MIB_GREENAP_TIME_TYPE,
MIB_GREENAP_START_HOUR1,
MIB_GREENAP_START_HOUR2,
MIB_GREENAP_START_HOUR3,
MIB_GREENAP_START_HOUR4,
MIB_GREENAP_START_MINUTE1,
MIB_GREENAP_START_MINUTE2,
MIB_GREENAP_START_MINUTE3,
MIB_GREENAP_START_MINUTE4,
MIB_GREENAP_STOP_HOUR1,
MIB_GREENAP_STOP_HOUR2,
MIB_GREENAP_STOP_HOUR3,
MIB_GREENAP_STOP_HOUR4,
MIB_GREENAP_STOP_MINUTE1,
MIB_GREENAP_STOP_MINUTE2,
MIB_GREENAP_STOP_MINUTE3,
MIB_GREENAP_STOP_MINUTE4,
MIB_WLAN_RF_POWER,
MIB_WLAN_TX_POWER_1,
MIB_WLAN_TX_POWER_2,
MIB_WLAN_TX_POWER_3,
MIB_WLAN_TX_POWER_4,
#endif

#ifdef _MULTIPLE_WLAN_RS_SETTING_
MIB_WLAN_RS_IP_1,
MIB_WLAN_RS_IP_2,
MIB_WLAN_RS_IP_3,
MIB_WLAN_RS_IP_4,
MIB_WLAN_RS_IP_5,
MIB_WLAN_RS_IP_6,
MIB_WLAN_RS_IP_7,
MIB_WLAN_RS_PORT_1,
MIB_WLAN_RS_PORT_2,
MIB_WLAN_RS_PORT_3,
MIB_WLAN_RS_PORT_4,
MIB_WLAN_RS_PORT_5,
MIB_WLAN_RS_PORT_6,
MIB_WLAN_RS_PORT_7,
MIB_WLAN_RS_PASSWORD_1,
MIB_WLAN_RS_PASSWORD_2,
MIB_WLAN_RS_PASSWORD_3,
MIB_WLAN_RS_PASSWORD_4,
MIB_WLAN_RS_PASSWORD_5,
MIB_WLAN_RS_PASSWORD_6,
MIB_WLAN_RS_PASSWORD_7,
MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_1,
MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_2,
MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_3,
MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_4,
MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_5,
MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_6,
MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_7,
MIB_WLAN_RS_INTERVAL_TIME_1,
MIB_WLAN_RS_INTERVAL_TIME_2,
MIB_WLAN_RS_INTERVAL_TIME_3,
MIB_WLAN_RS_INTERVAL_TIME_4,
MIB_WLAN_RS_INTERVAL_TIME_5,
MIB_WLAN_RS_INTERVAL_TIME_6,
MIB_WLAN_RS_INTERVAL_TIME_7,
#endif
#if defined(_WEB_ACCESS_CONTROL_)
MIB_WEB_CONTROL,
#endif
#if defined(_POWER_SAVING_)
MIB_POWER_SAVING,          
#endif
#if defined(_LED_SWITCH_) || defined(_SW_LED_SWITCH_)
MIB_LED_SWITCH,
#endif
#if defined(_Airlive_7428HCN_)
MIB_CS_REG_DOMAIN,
MIB_CLONE_MAC_ADDR,
MIB_KEEP_CONFIG,
MIB_DEVICE_NAME,
MIB_IP_FINDER,
MIB_WLAN_AGGREGATION,
MIB_WLAN_SHORT_GI,
MIB_ACK_TIMEOUT,
#endif

#ifdef _CONTROL_SIDEBAND_
MIB_CONTROL_SIDEBAND,
#endif

#ifdef _SYSTEM_LOG_
MIB_LOG_ENABLED,
MIB_REMOTELOG_ENABLED,
MIB_REMOTELOG_SERVER,
#endif

#ifdef _RTK_NTP_
MIB_NTP_ENABLED,
MIB_NTP_SERVER_ID,
MIB_NTP_TIMEZONE,
MIB_NTP_SERVER_IP1,
MIB_NTP_SERVER_IP2,
MIB_DAYLIGHT_SAVE,
MIB_TIME_YEAR,
MIB_TIME_MONTH,
MIB_TIME_DAY,
MIB_TIME_HOUR,
MIB_TIME_MIN,
MIB_TIME_SEC,
#endif

#ifdef _WEB_PORT_
MIB_WEB_PORT,
#endif

#ifdef _Airlive_Schedule_
MIB_WLSCH_ENABLED,
MIB_WLSCH_ENABLED_1,
MIB_WLSCH_ENABLED_2,
MIB_WLSCH_ENABLED_3,
MIB_WLSCH_ENABLED_4,
MIB_WLSCH_ENABLED_5,
MIB_WLSCH_ENABLED_6,
MIB_WLSCH_ENABLED_7,
MIB_WLSCH_ENABLED_8,
MIB_WLSCH_ENABLED_9,
MIB_WLSCH_ENABLED_10,
MIB_WLSCH_DAY1,
MIB_WLSCH_DAY2,
MIB_WLSCH_DAY3,
MIB_WLSCH_DAY4,
MIB_WLSCH_DAY5,
MIB_WLSCH_DAY6,
MIB_WLSCH_DAY7,
MIB_WLSCH_DAY8,
MIB_WLSCH_DAY9,
MIB_WLSCH_DAY10,
MIB_WLSCH_FROM_HOUR1,
MIB_WLSCH_FROM_HOUR2,
MIB_WLSCH_FROM_HOUR3,
MIB_WLSCH_FROM_HOUR4,
MIB_WLSCH_FROM_HOUR5,
MIB_WLSCH_FROM_HOUR6,
MIB_WLSCH_FROM_HOUR7,
MIB_WLSCH_FROM_HOUR8,
MIB_WLSCH_FROM_HOUR9,
MIB_WLSCH_FROM_HOUR10,
MIB_WLSCH_FROM_MIN1,
MIB_WLSCH_FROM_MIN2,
MIB_WLSCH_FROM_MIN3,
MIB_WLSCH_FROM_MIN4,
MIB_WLSCH_FROM_MIN5,
MIB_WLSCH_FROM_MIN6,
MIB_WLSCH_FROM_MIN7,
MIB_WLSCH_FROM_MIN8,
MIB_WLSCH_FROM_MIN9,
MIB_WLSCH_FROM_MIN10,
MIB_WLSCH_TO_HOUR1,
MIB_WLSCH_TO_HOUR2,
MIB_WLSCH_TO_HOUR3,
MIB_WLSCH_TO_HOUR4,
MIB_WLSCH_TO_HOUR5,
MIB_WLSCH_TO_HOUR6,
MIB_WLSCH_TO_HOUR7,
MIB_WLSCH_TO_HOUR8,
MIB_WLSCH_TO_HOUR9,
MIB_WLSCH_TO_HOUR10,
MIB_WLSCH_TO_MIN1,
MIB_WLSCH_TO_MIN2,
MIB_WLSCH_TO_MIN3,
MIB_WLSCH_TO_MIN4,
MIB_WLSCH_TO_MIN5,
MIB_WLSCH_TO_MIN6,
MIB_WLSCH_TO_MIN7,
MIB_WLSCH_TO_MIN8,
MIB_WLSCH_TO_MIN9,
MIB_WLSCH_TO_MIN10,
#endif
#ifdef _STANUM_
MIB_STANUM,
#endif
MIB_WDS_NUM,
MIB_WDS_LIST,
MIB_WDS_LIST_ADD,
MIB_WDS_LIST_DEL,
MIB_WDS_LIST_DELALL,
};
//---------------------------------------------------------------------------------------------
// MIB value and constant
#define MAX_SSID_LEN		33
#define WEP64_KEY_LEN		5
#define WEP128_KEY_LEN		13
#define WEP152_KEY_LEN		16
#define MAX_NAME_LEN		31
#define MAX_NAME		65
#define WPS_PIN_LEN 9   //kyle
//#define COMMENT_LEN	17
//#define COMMENT_LEN		35 //kyle
#define COMMENT_LEN		37 //kyle
#define MAX_CHAN_NUM		14
#define MAX_CCK_CHAN_NUM	14
#define MAX_OFDM_CHAN_NUM	162
#define MAX_2G_CHANNEL_NUM_MIB          14
#define MAX_5G_CHANNEL_NUM_MIB          196
#define MAX_WDS_NUM		4
#define MAX_QOS_NUM		16

#define MAX_QOSCON_NUM		16
// Static DHCP Lease --------------
#ifdef _corega_
#define MAX_STATIC_DHCP_NUM	32
#else
#define MAX_STATIC_DHCP_NUM	16
#endif
//---------------------------------
//vance 2008.11.14
#ifdef _WIRELESS_SCHEDULE_
#define MAX_WLAN_SCH_NUM	20
#endif

//Felix 20101222
#ifdef _PROFILE_LIST_
#define MAX_PROFILE_LIST_NUM	20
#define PROFILE_NAME_LEN        28
#define PROIFLE_SSID_LEN        32
#endif

#ifdef _EZVIEW_
#define MAX_EZVIEW_NUM 150
#endif
#ifdef _STARCRAFT_
#define MAX_STARCRAFT_NUM 150
#endif
#ifdef WLAN_WPA
#define MAX_PSK_LEN		64
#define MAX_RS_PASS_LEN  65
#endif
#define TX_RATE_1M		0x01
#define TX_RATE_2M		0x02
#define TX_RATE_5M		0x04
#define TX_RATE_11M		0x08
#define TX_RATE_6M		0x10
#define TX_RATE_9M		0x20
#define TX_RATE_12M		0x40
#define TX_RATE_18M		0x80
#define TX_RATE_24M		0x100
#define TX_RATE_36M		0x200
#define TX_RATE_48M		0x400
#define TX_RATE_54M		0x800
#ifdef _corega_
#define MAX_WLAN_AC_NUM			32
#else
#define MAX_WLAN_AC_NUM			20
#endif
//#ifdef HOME_GATEWAY
#ifdef _corega_
#define MAX_FILTER_NUM			32
#else
#define MAX_FILTER_NUM			20
#endif
//#endif
#define MAXFNAME			60
//#define	CLIENT_CERT_NAME 		("/cltCer.tgz")
//#define	SERVER_CERT_NAME 		("/ca.pem")
#ifdef __TARGET_BOARD__
#define UPG_DEVICE_NAME				("/dev/mtdblock0")
#define FLASH_DEVICE_NAME			("/dev/mtdblock0")
#define HW_SETTING_OFFSET			0x6000		// size 0x400
#define DEFAULT_SETTING_OFFSET			0x8000		// offset of config.bin
#define CURRENT_SETTING_OFFSET			0x8000
#define DEFAULT_SETTING_FILE			("/etc/config.bin")
#define CODE_IMAGE_OFFSET			0x10000
#define WEB_PAGE_OFFSET				0x10000
#define HW_SETTING_OFFSET_IN_FILE		0
#define DF_SETTING_OFFSET_IN_FILE		0x2000
#else
//--------------------- PC ---------------------
#define FLASH_DEVICE_NAME		"./setting.bin"
#define HW_SETTING_OFFSET		0
#define DEFAULT_SETTING_OFFSET		0x2000
#define DEFAULT_SETTING_FILE		"config-pc.bin"
#define CURRENT_SETTING_OFFSET		0 // (HW_SETTING_LEN + DF_SETTING_LEN)
#define CODE_IMAGE_OFFSET		0x10000
#define WEB_PAGE_OFFSET			0x10000
#define HW_SETTING_OFFSET_IN_FILE	0
#define DF_SETTING_OFFSET_IN_FILE	0x2000
#endif
 //----------end not mips--------------------------------
#define HW_SETTING_LEN				(sizeof(HW_SETTING_T)+7)
//#define DF_SETTING_LEN			(0x1c00)	//removed by Erwin
#define DF_SETTING_LEN				(0x8000)
#ifndef WIN32
#define __PACK__			__attribute__ ((packed))
#define __PACK__1			__attribute__ ((packed))
#else
#define __PACK__
#endif
/* Config/fw image file header */
typedef enum { HW_SETTING=1, DEFAULT_SETTING=2, CURRENT_SETTING=4 } CONFIG_DATA_T;
// update tag
//#define HW_SETTING_HEADER_TAG			((char *)"h6")
#define HW_SETTING_HEADER_TAG			((char *)"H6")
#define DEFAULT_SETTING_HEADER_TAG		((char *)"6V")
#define CURRENT_SETTING_HEADER_TAG		((char *)"6v")
// force tag
#define HW_SETTING_HEADER_FORCE_TAG		((char *)"HF")
#define DEFAULT_SETTING_HEADER_FORCE_TAG	((char *)"DF")
#define CURRENT_SETTING_HEADER_FORCE_TAG	((char *)"CF")
// upgrade
#define HW_SETTING_HEADER_UPGRADE_TAG		((char *)"HU")
#define DEFAULT_SETTING_HEADER_UPGRADE_TAG	((char *)"DU")
#define CURRENT_SETTING_HEADER_UPGRADE_TAG	((char *)"CU")
#define TAG_LEN					2
#ifdef _DFS_
	#define HW_SETTING_VER 2// hw setting version
#else
	#define HW_SETTING_VER			1	// hw setting version
#endif
#define DEFAULT_SETTING_VER		3	// default setting version

#ifdef _ADM5120_
#define MODTAG_LEN			4
#elif _NETINDEX_FW_CHECK_
#define SWVERSION_LEN			4
#define MAGICNO_LEN			6
#define uHWVERSION_LEN			8
#define lHWVERSION_LEN			10
#else
#define MODTAG_LEN			12
#endif
#define CURRENT_SETTING_VER		DEFAULT_SETTING_VER // current setting version
#define FW_HEADER			((char *)"CSYS")
// End Lance 2003.08.06
#define SIGNATURE_LEN			4
#ifdef _NETINDEX_FW_CHECK_ //vance 2009.02.24 for NetIndex
#define VERSION_LEN			2
#endif
/* wlan driver ioctl id */
#define SIOCGIWRTLSTAINFO   		0x8B30	// get station table information
#define SIOCGIWRTLSTANUM		0x8B31	// get the number of stations in table
#define SIOCGIWRTLSCANREQ		0x8B33	// scan request
#define SIOCGIWRTLGETBSSDB		0x8B34	// get bss data base
#define SIOCGIWRTLJOINREQ		0x8B35	// join request
#define SIOCGIWRTLJOINREQSTATUS		0x8B36	// get status of join request
#define SIOCGIWRTLGETBSSINFO		0x8B37	// get currnet bss info
#define SIOCGIWRTLGETWDSINFO		0x8B38
/* 802.11n RT2860 wlan driver ioctl id*/
#define RTPRIV_IOCTL_GET_MAC_TABLE	 (SIOCIWFIRSTPRIV + 0x0F)
#define RTPRIV_IOCTL_GSITESURVEY		(SIOCIWFIRSTPRIV + 0x0D)
#define RTPRIV_IOCTL_SET			(SIOCIWFIRSTPRIV + 0x02)
#define OID_802_11_BSSID_LIST                       0x0609
#define RTPRIV_IOCTL_GSITESURVEY		(SIOCIWFIRSTPRIV + 0x0D)
#define NUM_WLAN_INTERFACE              1       // number of wlan interface supported
#define NUM_WLAN_MULTIPLE_SSID  	8      	// number of wlan ssid support
#define PIN_LEN				8


#define MAX_STA_NUM			32	// max support sta number

/* flag of sta info */
#define STA_INFO_FLAG_AUTH_OPEN     	0x01
#define STA_INFO_FLAG_AUTH_WEP      	0x02
#define STA_INFO_FLAG_ASOC          	0x04
#define STA_INFO_FLAG_ASLEEP        	0x08
#ifdef WLAN_WPA
//typedef enum { ENCRYPT_DISABLED=0, ENCRYPT_WEP=1, ENCRYPT_PSK=3, ENCRYPT_ARS=4 } ENCRYPT_T;
typedef enum { ENCRYPT_DISABLED=0, ENCRYPT_WEP=1, ENCRYPT_WPA=2, ENCRYPT_WPA2=4, ENCRYPT_WPA2_MIXED=6 } ENCRYPT_T;
typedef enum { WDS_ENCRYPT_DISABLED=0, WDS_ENCRYPT_WEP64=1, WDS_ENCRYPT_WEP128=2, WDS_ENCRYPT_TKIP=3, WDS_ENCRYPT_AES=4} WDS_ENCRYPT_T;
typedef enum { SUPP_NONWPA_NONE=0,SUPP_NONWPA_WEP=1,SUPP_NONWPA_1X=2} SUPP_NONWAP_T;
typedef enum { WPA_AUTH_AUTO=1, WPA_AUTH_PSK=2 } WPA_AUTH_T;
typedef enum { WPA_CIPHER_TKIP=1, WPA_CIPHER_AES=2, WPA_CIPHER_MIXED=3 } WPA_CIPHER_T;
#endif
typedef enum { WEP_DISABLED=0, WEP64=1, WEP128=2, WEP152=3 } WEP_T;
typedef enum { KEY_ASCII=0, KEY_HEX } KEY_TYPE_T;
typedef enum { LONG_PREAMBLE=0, SHORT_PREAMBLE=1 } PREAMBLE_T;
typedef enum { DHCP_DISABLED=0, DHCP_CLIENT=1, DHCP_SERVER=2, PPPOE=3,  PPTP=4} DHCP_T;
typedef enum { GATEWAY_MODE=0, WISP_MODE=1, BRIDGE_MODE=2} OPMODE_T;
typedef enum { FCC=1, IC, ETSI, SPAIN, FRANCE, MKK } REG_DOMAIN_T;
typedef enum { AUTH_OPEN=0, AUTH_SHARED, AUTH_BOTH } AUTH_TYPE_T;
typedef enum { DNS_AUTO=0, DNS_MANUAL } DNS_TYPE_T;
typedef enum { CONTINUOUS=0, CONNECT_ON_DEMAND, MANUAL } PPP_CONNECT_TYPE_T;
typedef enum { RF_INTERSIL=1, RF_RFMD=2, RF_PHILIP=3, RF_MAXIM=4 } RF_TYPE_T;
typedef enum { LED_TX_RX=0, LED_LINK_TXRX=1, LED_LINKTXRX=2 } LED_TYPE_T;
typedef enum { AP_MODE=0, CLIENT_MODE=1, WDS_MODE=2 } WLAN_MODE_T;
typedef enum { INFRASTRUCTURE=0, ADHOC=1 } NETWORK_TYPE_T;
typedef enum { BAND_11B=1, BAND_11G=2, BAND_11BG=3, BAND_11A=4, BAND_11N=8 } BAND_TYPE_T;
#ifdef WIFI_SIMPLE_CONFIG
enum { WSC_AUTH_OPEN=1, WSC_AUTH_WPAPSK=2, WSC_AUTH_SHARED=4, WSC_AUTH_WPA=8, WSC_AUTH_WPA2=0x10, WSC_AUTH_WPA2PSK=0x20, WSC_AUTH_WPA2PSKMIXED=0x22 };
enum { WSC_ENCRYPT_NONE=1, WSC_ENCRYPT_WEP=2, WSC_ENCRYPT_TKIP=4, WSC_ENCRYPT_AES=8, WSC_ENCRYPT_TKIPAES=12 };
enum { CONFIG_METHOD_ETH=0x2, CONFIG_METHOD_PIN=0x4, CONFIG_METHOD_PBC=0x80 };
enum { CONFIG_BY_INTERNAL_REGISTRAR=1, CONFIG_BY_EXTERNAL_REGISTRAR=2};
#endif
#ifdef HOME_GATEWAY
typedef enum { PROTO_BOTH=3, PROTO_TCP=1, PROTO_UDP=2 } PROTO_TYPE_T;
#endif
#ifndef _LITTLE_ENDIAN_
#define DWORD_SWAP(v) ( (((v&0xff)<<24)&0xff000000) | ((((v>>8)&0xff)<<16)&0xff0000) | \
			((((v>>16)&0xff)<<8)&0xff00) | (((v>>24)&0xff)&0xff) )
#define WORD_SWAP(v) ((unsigned short)(((v>>8)&0xff) | ((v<<8)&0xff00)))
#else
#define DWORD_SWAP(v) (v)
#define WORD_SWAP(v) (v)
#endif
/* scramble saved configuration data */
#define ENCODE_DATA(data,len) { \
	int i; \
	for (i=0; i<len; i++) \
		data[i] = ~ ( data[i] + 0x38); \
}
#define DECODE_DATA(data,len) { \
	int i; \
	for (i=0; i<len; i++) \
		data[i] = ~data[i] - 0x38;	\
}
/* Do checksum and verification for configuration data */
#ifndef WIN32
static inline unsigned char CHECKSUM(unsigned char *data, int len)
#else
__inline unsigned char CHECKSUM(unsigned char *data, int len)
#endif
{
	int i;
	unsigned char sum=0;
	for (i=0; i<len; i++)
		sum += data[i];
	sum = ~sum + 1;
	return sum;
}
#ifndef WIN32
static inline int CHECKSUM_OK(unsigned char *data, int len)
#else
__inline int CHECKSUM_OK(unsigned char *data, int len)
#endif
{
	int i;
	unsigned char sum=0;
	for (i=0; i<len; i++)
		sum += data[i];
	if (sum == 0)
		return 1;
	else
		return 0;
}
#define SIOCGIWRTLSTAINFO_NEW   0x8B50
typedef struct ipn_wlan_survey {
	char type[16];
	char ssid[36];
	char channel[4];
	char encrypt[36];
	char signal[16];
	char bssid[20];
} IPN_WLAN_SURVEY_T, *IPN_WLAN_SURVEY_Tp;
/* WLAN sta info structure */
/*typedef struct wlan_sta_info {
        unsigned short  aid;
        unsigned char   addr[6];
        unsigned long   tx_packets;
        unsigned long   rx_packets;
	unsigned long	expired_time;  // 10 mini-sec
	unsigned short  flag;
        unsigned char   txOperaRates;
} WLAN_STA_INFO_T, *WLAN_STA_INFO_Tp;
*/
/* WLAN sta info structure */
typedef struct wlan_sta_info {
        unsigned short  aid;
        unsigned char   addr[6];
        unsigned long   tx_packets;
        unsigned long   rx_packets;
        unsigned long   expired_time;   // 10 msec unit
        unsigned short  flag;
        unsigned char   txOperaRates;
        unsigned char   rssi;
        unsigned long   link_time;              // 1 sec unit
        unsigned long   tx_fail;
        unsigned long tx_bytes;
        unsigned long rx_bytes;
        unsigned char network;
        unsigned char ht_info;  // bit0: 0=20M mode, 1=40M mode; bit1: 0=longGI, 1=shortGI
        unsigned char   resv[6];
} WLAN_STA_INFO_T, *WLAN_STA_INFO_Tp;
typedef struct wlan_rate{
	unsigned int id;
	unsigned char rate[20];
}WLAN_RATE_T, *WLAN_RATE_Tp;
typedef enum {
        MCS0=0x80,
        MCS1=0x81,
        MCS2=0x82,
        MCS3=0x83,
        MCS4=0x84,
        MCS5=0x85,
        MCS6=0x86,
        MCS7=0x87,
        MCS8=0x88,
        MCS9=0x89,
        MCS10=0x8a,
        MCS11=0x8b,
        MCS12=0x8c,
        MCS13=0x8d,
        MCS14=0x8e,
        MCS15=0x8f
        } RATE_11N_T;
/* 802.11n RT2860 stat info structure*/
typedef union  _MACHTTRANSMIT_SETTING {
	struct	{
	unsigned short   	MCS:7;                 // MCS
	unsigned short		BW:1;	//channel bandwidth 20MHz or 40 MHz
	unsigned short		ShortGI:1;
	unsigned short		STBC:2;	//SPACE
	unsigned short		rsv:3;
	unsigned short		MODE:2;	// Use definition MODE_xxx.
	}	field;
	unsigned short		word;
 } MACHTTRANSMIT_SETTING, *PMACHTTRANSMIT_SETTING;
typedef struct _RT_802_11_MAC_ENTRY {
    unsigned char       Addr[6];
    unsigned char       Aid;
    unsigned char       Psm;     // 0:PWR_ACTIVE, 1:PWR_SAVE
    unsigned char		MimoPs;  // 0:MMPS_STATIC, 1:MMPS_DYNAMIC, 3:MMPS_Enabled
    char				AvgRssi0;
	char				AvgRssi1;
	char				AvgRssi2;
	unsigned int		ConnectedTime;
    MACHTTRANSMIT_SETTING	TxRate;
} RT_802_11_MAC_ENTRY, *PRT_802_11_MAC_ENTRY;
/*
typedef struct _RT_802_11_MAC_TABLE {
    unsigned long       Num;
    RT_802_11_MAC_ENTRY Entry[MAX_STA_NUM];
} WLAN_STA_INFO_T, *WLAN_STA_INFO_Tp;
*/
typedef struct wlan_ipn_sta {
		short           aid;         // STA's unique AID (1 .. 2007) or 0 if not yet assigned
		unsigned char   addr[6];     // address of associated station
		unsigned char  auth_state;  // station status
		unsigned char   ps_state;    // station power save status
		unsigned long assoc_time;
} WLAN_IPN_STA_T, *WLAN_IPN_STA_Tp;
#ifdef WIN32
#pragma pack(1)
#endif
typedef struct macfilter_entry {
	unsigned char macAddr[6] __PACK__;
	unsigned char comment[COMMENT_LEN] __PACK__;
} __PACK__ MACFILTER_T, *MACFILTER_Tp;
typedef struct WDSList_entry {
        unsigned char macAddr[6] __PACK__;
        unsigned char comment[COMMENT_LEN] __PACK__;
} __PACK__ WDSList_T, *WDSList_Tp;
typedef struct URLB_entry {
	unsigned char URLBAddr[34] __PACK__;
} __PACK__ URLB_T, *URLB_Tp;
typedef struct edit_entry {
	char *selEntry;
	char *editEntry;
} EDIT_T, *EDIT_Tp;
// Static DHCP Lease------------------------
typedef struct staticdhcp_entry {
	unsigned char ipAddr[4] __PACK__;
	unsigned char macAddr[6] __PACK__;
#ifdef _PC_DATABASE_ //vance 2008.11.03
	unsigned char hostName[21] __PACK__;
	unsigned short groupIdx __PACK__;
#endif
} __PACK__ SDHCP_T, *SDHCP_Tp ;
//------------------------------------------
#ifdef HOME_GATEWAY
///////////////////////////////////////////////////////////////////////////////////////
#ifdef _VLAN_CONFIG_SUPPORTED_
typedef struct vlan_lanconfig_entry {
	unsigned char enabled __PACK__; //0-disable, 1-enable
	unsigned char netIface[IFNAMSIZE] __PACK__;	//net interface name  //IFNAMSIZE=16
	unsigned char tagged __PACK__; //0-disable tagged, 1-enable tagged
	//unsigned char untagged __PACK__; //0-disable un-tagged, 1-enable un-tagged
	unsigned char priority __PACK__; //0~7
	unsigned char cfi __PACK__;//Canonical Format Indicator
	//unsigned char groupId __PACK__;
	unsigned short vlanId __PACK__;//0~4090
} __PACK__ VLAN_CONFIG_T, *VLAN_CONFIG_Tp;
#endif
typedef struct portfw_entry {
	unsigned char ipAddr[4] __PACK__;
	unsigned short fromPort __PACK__;
	unsigned short toPort __PACK__;
	unsigned char protoType __PACK__;
#if defined(_MPPPOE_)
	unsigned char interface __PACK__;  //alex 2007/02/12
#endif
	unsigned char comment[COMMENT_LEN] __PACK__;
} __PACK__ PORTFW_T, *PORTFW_Tp;
typedef struct ipfilter_entry {	//no use
	unsigned char ipAddr[4] __PACK__;
	unsigned char protoType __PACK__;
	unsigned char comment[COMMENT_LEN] __PACK__;
} __PACK__ IPFILTER_T, *IPFILTER_Tp ;
typedef struct portfilter_entry {	//no use
	unsigned short fromPort __PACK__;
	unsigned short toPort __PACK__;
	unsigned char protoType __PACK__;
	unsigned char comment[COMMENT_LEN] __PACK__;
} __PACK__ PORTFILTER_T, *PORTFILTER_Tp;
typedef struct triggerport_entry {
	unsigned char  ip[4] __PACK__;
	unsigned short tcp_port[5][2] __PACK__;
	unsigned short udp_port[5][2] __PACK__;
	unsigned char comment[COMMENT_LEN] __PACK__;	// comment
	/*kyle
	unsigned short tri_fromPort __PACK__;	// trigger-from port
	unsigned short tri_toPort __PACK__;	// trigger-to port
	unsigned char tri_protoType __PACK__;	// trigger proto type
	unsigned short  inc_fromPort[5][2] __PACK__;	// incomming-from port
	unsigned short inc_toPort __PACK__;	// incoming-to port
	unsigned char inc_protoType __PACK__;	// incoming proto type
	unsigned char comment[COMMENT_LEN] __PACK__;	// comment
	*/
} __PACK__ TRIGGERPORT_T, *TRIGGERPORT_Tp;
typedef struct ACPC_entry {
	unsigned long serindex __PACK__;
	unsigned char sipAddr[4] __PACK__;
	unsigned char eipAddr[4] __PACK__;
	unsigned char protoType __PACK__;
	unsigned char comment[COMMENT_LEN] __PACK__;
	unsigned short  Port[5][2] __PACK__;
} __PACK__ ACPC_T, *ACPC_Tp;
typedef struct dmz_entry {
	unsigned char pipAddr[4] __PACK__;
	unsigned char cipAddr[4] __PACK__;
	unsigned char type __PACK__;
	unsigned char session __PACK__;
} __PACK__ DMZ_T, *DMZ_Tp ;
typedef struct srout_entry {
	unsigned char ipAddr[4] __PACK__;	// ststic routing destination lan ip
	unsigned char maskAddr[4] __PACK__;	// static routing subnet mask
	unsigned char gatewayAddr[4] __PACK__;	// static routing default gateway
	unsigned short hopCount __PACK__;	// static routing hop count
	unsigned char interface __PACK__;	// static routing interface
} __PACK__ SROUT_T, *SROUT_Tp;
typedef struct   qos_entry {
	unsigned long bwidthVal __PACK__1;
	unsigned char bwidthType __PACK__1;
	unsigned long downVal __PACK__1;
	unsigned char downType __PACK__1;
	unsigned char sourType __PACK__1;
	unsigned char sourStIp[4] __PACK__1;
	unsigned char sourEdIp[4] __PACK__1;
	unsigned char sourMac[8][6] __PACK__1;
	unsigned char destStIp[4] __PACK__1;
	unsigned char destEdIp[4] __PACK__1;
	unsigned short trafType __PACK__1;
	unsigned short sourPort[5][2] __PACK__1;
	unsigned short destPort[5][2] __PACK__1;
	unsigned short diffSevType __PACK__1;
	unsigned char protl __PACK__1;
	unsigned char ruleName[COMMENT_LEN] __PACK__1;
}  __PACK__ QOS_T, *QOS_Tp;
#endif
#ifdef _QoS_MODE_SELECT_
typedef struct   qoscon_entry {
	unsigned long ptpbw __PACK__1;
	unsigned long consize __PACK__1;
	unsigned char connectName[COMMENT_LEN] __PACK__1;
	unsigned char connectIP[15] __PACK__1;
}	__PACK__ QOSCON_T, *QOSCON_Tp;
#endif
#ifndef HOME_GATEWAY
typedef struct rserclt_entry {
	unsigned char ipAddr[4] __PACK__;
	unsigned char password[17] __PACK__;
} __PACK__ RSER_CLT_T, *RSER_CLT_Tp;
typedef struct rserusr_entry {
	unsigned char username[33] __PACK__;
	unsigned char password[17] __PACK__;
} __PACK__ RSER_USR_T, *RSER_USR_Tp;
#endif
#ifdef WLAN_WDS
typedef MACFILTER_T WDS_T;
typedef MACFILTER_Tp WDS_Tp;
#endif
typedef struct hw_setting {
        unsigned char boardVer __PACK__;        // h/w board version
        unsigned char nic0Addr[6] __PACK__;
        unsigned char nic1Addr[6] __PACK__;
        unsigned char macAddr[6] __PACK__;
        unsigned char macAddr1[6] __PACK__;
        unsigned char macAddr2[6] __PACK__;
        unsigned char macAddr3[6] __PACK__;
        unsigned char macAddr4[6] __PACK__;
        unsigned char macAddr5[6] __PACK__;
        unsigned char macAddr6[6] __PACK__;
        unsigned char macAddr7[6] __PACK__;
        unsigned char pwrlevelCCK_A[MAX_2G_CHANNEL_NUM_MIB] __PACK__; // CCK Tx power for each channel
        unsigned char pwrlevelCCK_B[MAX_2G_CHANNEL_NUM_MIB] __PACK__; // CCK Tx power for each channel
        unsigned char pwrlevelHT40_1S_A[MAX_2G_CHANNEL_NUM_MIB] __PACK__;
        unsigned char pwrlevelHT40_1S_B[MAX_2G_CHANNEL_NUM_MIB] __PACK__;
        unsigned char pwrdiffHT40_2S[MAX_2G_CHANNEL_NUM_MIB] __PACK__;
        unsigned char pwrdiffHT20[MAX_2G_CHANNEL_NUM_MIB] __PACK__;
        unsigned char pwrdiffOFDM[MAX_2G_CHANNEL_NUM_MIB] __PACK__;
        unsigned char regDomain __PACK__; // regulation domain
        unsigned char rfType __PACK__; // RF module type
        unsigned char ledType __PACK__; // LED type, see LED_TYPE_T for definition
        unsigned char xCap __PACK__;
        unsigned char TSSI1 __PACK__;
        unsigned char TSSI2 __PACK__;
        unsigned char Ther __PACK__;
        unsigned char Reserved1 __PACK__;
        unsigned char Reserved2 __PACK__;
        unsigned char Reserved3 __PACK__;
        unsigned char Reserved4 __PACK__;
        unsigned char Reserved5 __PACK__;
        unsigned char Reserved6 __PACK__;
        unsigned char Reserved7 __PACK__;
        unsigned char Reserved8 __PACK__;
        unsigned char Reserved9 __PACK__;
        unsigned char Reserved10 __PACK__;
        unsigned char pwrlevel5GHT40_1S_A[MAX_5G_CHANNEL_NUM_MIB];
        unsigned char pwrlevel5GHT40_1S_B[MAX_5G_CHANNEL_NUM_MIB];
        unsigned char pwrdiff5GHT40_2S[MAX_5G_CHANNEL_NUM_MIB];
        unsigned char pwrdiff5GHT20[MAX_5G_CHANNEL_NUM_MIB];
        unsigned char pwrdiff5GOFDM[MAX_5G_CHANNEL_NUM_MIB];
        unsigned char wscPin[PIN_LEN+1] __PACK__;
} __PACK__ HW_SETTING_T, *HW_SETTING_Tp;
#ifdef _EZVIEW_
typedef struct ezview_entry {
	unsigned char DeviceName[21] __PACK__;
	unsigned char ipAddr __PACK__;
	unsigned char macAddr[6] __PACK__;
	unsigned char BlockStartTime __PACK__;
	unsigned char BlockStopTime __PACK__;
	unsigned char QoS __PACK__;
	unsigned char TypeAndBlock __PACK__;
	unsigned short pf_from[5] __PACK__;
	unsigned short pf_to[5] __PACK__;
} __PACK__ EZVIEW_T, *EZVIEW_Tp;
#endif

#ifdef _STARCRAFT_
typedef struct starcraft_entry {
	unsigned char ip[4] __PACK__;
} __PACK__ STARCRAFT_T, *STARCRAFT_Tp;
#endif
//vance 2008.11.14
#ifdef _WIRELESS_SCHEDULE_
typedef struct schedule_entry {
	unsigned short int command __PACK__;
	unsigned char week __PACK__;
	unsigned char month __PACK__;
	unsigned char hour __PACK__;
	unsigned char day __PACK__;
	unsigned char minute __PACK__;
	unsigned char comment[COMMENT_LEN] __PACK__;
	unsigned char reserved1 __PACK__;
	unsigned char reserved2 __PACK__;
} __PACK__ SCHEDULE_T, *SCHEDULE_Tp;
#endif

//Felix 20101222
#ifdef _PROFILE_LIST_
typedef struct profilelist_entry {
	unsigned short int  profile_num __PACK__;
	unsigned char profile_name[PROFILE_NAME_LEN] __PACK__;
	unsigned char ssid[PROIFLE_SSID_LEN] __PACK__;
	unsigned short int channel __PACK__;
	unsigned char auth __PACK__;
	unsigned char encrypt __PACK__;
	unsigned char networktype __PACK__;
	unsigned char RTS_enable __PACK__;
	unsigned char Fragment_enable __PACK__;
	unsigned short int RTS_value __PACK__;
	unsigned short int Fragment_value __PACK__;
	unsigned char preamble_type __PACK__;
	unsigned char cam_psm __PACK__;
	unsigned char wep_length __PACK__;
	unsigned char wep_format __PACK__;
	unsigned char wepkey_index __PACK__;
	unsigned char wepkey1[26] __PACK__;
	unsigned char wepkey2[26] __PACK__;
	unsigned char wepkey3[26] __PACK__;
	unsigned char wepkey4[26] __PACK__;
	unsigned char wpapsk[64] __PACK__;
	unsigned char reserved1 __PACK__;
	unsigned char reserved2 __PACK__;
} __PACK__ PROFILELIST_T, *PROFILELIST_Tp;
#endif
	


typedef struct config_setting {
//**************************************** WLAN stuffs ****************************************
	unsigned char ssid[MAX_SSID_LEN]__PACK__ ; // SSID
	unsigned char channel __PACK__ ;// current channel
	unsigned char elanMacAddr[6] __PACK__ ; // Ethernet Lan MAC address
	unsigned char wlanMacAddr[6] __PACK__ ; // WLAN MAC address
	unsigned char wep __PACK__ ; // WEP flag, 0 - disabled, 1 - 64bits, 2 128 bits
	unsigned char wep64Key1[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key2[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key3[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key4[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep128Key1[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key2[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key3[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key4[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wepDefaultKey __PACK__ ;
	unsigned char wepKeyType __PACK__ ;
	unsigned short fragThreshold __PACK__ ;
	unsigned short rtsThreshold __PACK__ ;
	unsigned short supportedRates __PACK__ ;
	unsigned short basicRates __PACK__ ;
	unsigned short beaconInterval __PACK__ ;
	unsigned char preambleType __PACK__; // preamble type, 0 - long preamble, 1 - short preamble
	unsigned char authType __PACK__; //authentication type, 0- open-system,1 - shared-key, 2 - both
	unsigned char acEnabled __PACK__; // enable/disable WLAN access control
	unsigned char acNum __PACK__; // WLAN access control entry number
	MACFILTER_T acAddrArray[MAX_WLAN_AC_NUM] __PACK__; // WLAN access control array
	unsigned char hiddenSSID __PACK__ ;
	unsigned char wlanDisabled __PACK__; // enabled/disabled wlan interface
//	unsigned char aliasName[MAX_NAME_LEN] __PACK__; // device logical name
	unsigned long inactivityTime __PACK__; // wlan client inactivity time
	unsigned char rateAdaptiveEnabled __PACK__; // enable/disable rate adaptive
	unsigned char apMode __PACK__; // select AP mode type
	unsigned char iappDisabled __PACK__; // disable IAPP
	unsigned char protectionDisabled __PACK__; // disable g mode protection
	unsigned char maccloneEnabled __PACK__; // enable NAT2.5 MAC Clone
	unsigned char wlanBand __PACK__; // wlan band, bit0-11B, bit1-11G, bit2-11A
	unsigned short fixedTxRate __PACK__; // fixed wlan tx rate, used when rate adaptive is disabled
//**************************************** LAN stuffs ****************************************
	unsigned char ipAddr[4] __PACK__;
	unsigned char subnetMask[4] __PACK__;
	unsigned char defaultGateway[4] __PACK__;
	unsigned char dhcp __PACK__; // DHCP flag, 0 - disabled, 1 - client, 2 - server
	unsigned char stpEnabled __PACK__; // Spanning tree protocol flag, 0 - disabled, 1 - enabled
	// Supervisor of web server account
	unsigned char superName[MAX_NAME_LEN] __PACK__ ; // supervisor name
	unsigned char superPassword[MAX_NAME_LEN] __PACK__; // supervisor assword
	// web server account
	unsigned char userName[MAX_NAME_LEN] __PACK__; // supervisor name
	unsigned char userPassword[MAX_NAME_LEN] __PACK__; // supervisor assword
	unsigned char DhcpGatewayIPAddr[4] __PACK__;
	unsigned char DhcpNameServerIPAddr[4] __PACK__;
	unsigned char DomainNames[MAX_NAME_LEN] __PACK__; // Dhcp domain name
	unsigned char dhcpClientStart[4] __PACK__; // DHCP client start address
	unsigned char dhcpClientEnd[4] __PACK__; // DHCP client end address
	unsigned long leaseTime __PACK__;
	unsigned char dtimPeriod __PACK__; // DTIM period
	unsigned char networkType __PACK__; // adhoc or Infrastructure
//**************************************** WDS stuffs ****************************************
	unsigned char wlLinkMac1[6] __PACK__ ; // MAC address of WireLess PoP in used
	unsigned char wlLinkMac2[6] __PACK__ ; // MAC address of WAN port PoMP in used
	unsigned char wlLinkMac3[6] __PACK__ ; // MAC address of WAN port PoMP in used
	unsigned char wlLinkMac4[6] __PACK__ ; // MAC address of WAN port PoMP in used
	unsigned char wlLinkMac5[6] __PACK__ ; // MAC address of WAN port PoMP in used
	unsigned char wlLinkMac6[6] __PACK__ ; // MAC address of WAN port PoMP in used
	unsigned char wdsEnabled __PACK__; // wds enable/disable
	unsigned char wdsEncrypt __PACK__; // encrypt type, defined as ENCRYPT_t
	unsigned char wdsWpaAuth __PACK__; // WPA authentication type (auto or psk)
	unsigned char wdsWpaCipher __PACK__; // WPA unicast cipher suite
	unsigned char wdsWpa2Cipher __PACK__; // WPA unicast cipher suite
	unsigned char wdsWpaPSK[MAX_PSK_LEN+1] __PACK__; // WPA pre-shared key
	unsigned char wdsWpaPSKFormat __PACK__; // PSK format 0 - passphrase, 1 - hex
	unsigned char secMode __PACK__; // select security mode type
	unsigned char clIpDisabled __PACK__; // select get IP address type 0 - use ip 1-  automatically
	unsigned short sel1xMode __PACK__;	// selsect Radius type, 0-internal, 1--external
	unsigned char  wlanSetTx __PACK__;
//******************************wireless setting for inprocomm ******************************
	unsigned char  wlanTranRate[5] __PACK__;
	unsigned char  wlanRateMode __PACK__;
	unsigned char  wlanCts __PACK__;
	unsigned char  wlanBurst __PACK__;
	unsigned char wep152Key1[WEP152_KEY_LEN] __PACK__ ;
	unsigned char wep152Key2[WEP152_KEY_LEN] __PACK__ ;
	unsigned char wep152Key3[WEP152_KEY_LEN] __PACK__ ;
	unsigned char wep152Key4[WEP152_KEY_LEN] __PACK__ ;
	unsigned char  psEnable __PACK__ ; // Lance 2004.2.9
	unsigned char  psIPPEnable __PACK__ ; // Lance 2004.2.16
	unsigned char  psLPREnable __PACK__ ; // Lance 2004.2.16
	unsigned char  psName[48] __PACK__ ; // Lance 2004.2.10
	unsigned char  psPort1Name[48] __PACK__ ; // Lance 2004.2.16
	unsigned char  psPort2Name[48] __PACK__ ; // Lance 2004.2.16
	unsigned char  licence __PACK__ ;
	unsigned char blockRelay __PACK__; // block/un-block the relay between wireless client
	unsigned char autoMacClone __PACK__;
	unsigned char   opMode __PACK__; // lan,wan opration mode
	unsigned char   wispWanId  __PACK__; // wisp WAN interface
#ifdef WLAN_WPA
	unsigned char encrypt __PACK__; // encrypt type, defined as ENCRYPT_t
	unsigned char enableSuppNonWpa __PACK__; // enable/disable nonWPA client support
	unsigned char suppNonWpa __PACK__; // which kind of non-wpa client is supported (wep/1x)
	unsigned char wpaAuth __PACK__; // WPA authentication type (auto or psk)
	unsigned char wpaCipher __PACK__; // WPA unicast cipher suite
	unsigned char wpaPSK[MAX_PSK_LEN+1] __PACK__; // WPA pre-shared key
	unsigned long wpaGroupRekeyTime __PACK__; // group key rekey time in second
#if defined(_Customer_EX_) || defined(_Customer_SA_)
        unsigned long wpaGroupRekeyTime1 __PACK__; // group key rekey time in second
        unsigned long wpaGroupRekeyTime2 __PACK__; // group key rekey time in second
        unsigned long wpaGroupRekeyTime3 __PACK__; // group key rekey time in second
        unsigned long wpaGroupRekeyTime4 __PACK__; // group key rekey time in second
        unsigned long wpaGroupRekeyTime5 __PACK__; // group key rekey time in second
        unsigned long wpaGroupRekeyTime6 __PACK__; // group key rekey time in second
        unsigned long wpaGroupRekeyTime7 __PACK__; // group key rekey time in second
#endif
	unsigned char rsIpAddr[4] __PACK__; // radius server IP address
	unsigned short rsPort __PACK__; // radius server port number
	unsigned char rsPassword[MAX_RS_PASS_LEN] __PACK__; // radius server password
	unsigned char enable1X __PACK__; // enable/disable 802.1x
	unsigned char wpaPSKFormat __PACK__; // PSK format 0 - passphrase, 1 - hex
	unsigned char accountRsEnabled __PACK__; // enable/disable accounting server
	unsigned char accountRsIpAddr[4] __PACK__; // accounting radius server IP address
	unsigned short accountRsPort __PACK__; // accounting radius server port number
	unsigned char accountRsPassword[MAX_RS_PASS_LEN] __PACK__; // accounting radius server password
	unsigned char accountRsUpdateEnabled __PACK__; // enable/disable accounting server update
	unsigned short accountRsUpdateDelay __PACK__; // account server update delay time in sec
	unsigned char macAuthEnabled __PACK__; // mac authentication enabled/disabled
	unsigned char rsMaxRetry __PACK__; // radius server max try
	unsigned short rsIntervalTime __PACK__; // radius server timeout
	unsigned char accountRsMaxRetry __PACK__; // accounting radius server max try
	unsigned short accountRsIntervalTime __PACK__; // accounting radius server timeout
	unsigned char wpa2PreAuth __PACK__; // wpa2 Preauthtication support
	unsigned char wpa2Cipher __PACK__; // wpa2 Unicast cipher
#endif






#if defined(HOME_GATEWAY) || defined(_AP_WITH_TIMEZONE_)
//**************************************** System stuffs ****************************************
	unsigned short TimeZoneSel __PACK__;
	unsigned short startMonth __PACK__;
	unsigned short startDay __PACK__;
	unsigned short endMonth __PACK__;
	unsigned short endDay __PACK__;
#if defined(_BR6428PNL_)
        unsigned char  TimeServerAddr[30] __PACK__;//TimeServerAddr Address Setting
#else
	unsigned char  TimeServerAddr[4] __PACK__;//TimeServerAddr Address Setting
#endif
	unsigned char  DayLightEnable __PACK__ ;//DayLightEnable Setting
#endif
	//unsigned char  upnpEnable __PACK__ ; //edx chris
#ifdef HOME_GATEWAY
	unsigned char  reManHostAddr[4] __PACK__;//Remote Management Host Address Setting
	unsigned short reManPort __PACK__;
	unsigned char  reMangEnable __PACK__ ;
//**************************************** WAN stuffs ****************************************
	unsigned char  wanMode __PACK__ ;
	unsigned char wanDhcp __PACK__; // DHCP flag for WAN port, 0 - disabled, 1 - DHCP client
	unsigned char wanIpAddr[4] __PACK__;
	unsigned char wanSubnetMask[4] __PACK__;
	unsigned char wanDefaultGateway[4] __PACK__;
	DNS_TYPE_T dnsMode __PACK__;
	unsigned char dns1[4], dns2[4], dns3[4] __PACK__;
//**************************************** Dynamic IP stuffs ****************************************
	unsigned char wanMacAddr[6] __PACK__ ; // MAC address of WAN port in used
	unsigned char  dynIPHostName[MAX_NAME_LEN] __PACK__; // Dynamic IP Host Name
//**************************************** PPPoE stuffs ****************************************
	unsigned char pppUserName[65] __PACK__;
	unsigned char pppPassword[65] __PACK__;
	unsigned short pppIdleTime __PACK__;
	unsigned char pppConnectType __PACK__;
	unsigned char  pppServName[MAX_NAME_LEN] __PACK__;
	unsigned short pppMTU __PACK__ ;
#if defined(_MPPPOE_)
// alex 2007/01/31
//**************************************** PPPoE 1 stuffs ****************************************
	unsigned char pppUserName1[65] __PACK__;
	unsigned char pppPassword1[65] __PACK__;
	unsigned short pppIdleTime1 __PACK__;
	unsigned char pppConnectType1 __PACK__;
	unsigned char  pppServName1[MAX_NAME_LEN] __PACK__;
	unsigned short pppMTU1 __PACK__ ;
	unsigned short pppUnnumNAT __PACK__ ;
	unsigned char  pppUnnumIP[4] __PACK__ ;
	unsigned char  pppUnnumMask[4] __PACK__ ;
	unsigned short pppoeMode __PACK__;
#endif
//**************************************** pptp stuffs ****************************************
	unsigned char  pptpIpMode __PACK__;
	unsigned char  pptpIPAddr[4] __PACK__;
	unsigned char  pptpIPMaskAddr[4] __PACK__;
	unsigned char  pptpDfGateway[4] __PACK__;	//Disabled
#ifdef _PPTP_FQDN_
	unsigned char  pptpGateway[MAX_NAME_LEN] __PACK__;
#else
	unsigned char  pptpGateway[4] __PACK__;
#endif
	unsigned char  pptpUserName[65] __PACK__;
	unsigned char  pptpPassword[65] __PACK__;
	unsigned short pptpIdleTime __PACK__;
	unsigned char  pptpConnectType __PACK__;
	unsigned char  pptpConntID[MAX_NAME_LEN] __PACK__;
	unsigned char  pptpBEZEQEnable __PACK__;
	unsigned short pptpMTU __PACK__ ;
//**************************************** l2tp stuffs ****************************************
	unsigned char  L2TPIpMode __PACK__;
	unsigned char  L2TPIPAddr[4] __PACK__;
	unsigned char  L2TPMaskAddr[4] __PACK__;
	unsigned char  L2TPDefGateway[4] __PACK__;	//Disabled
	unsigned char  L2TPGateway[MAX_NAME_LEN] __PACK__;
	unsigned char  L2TPUserName[65] __PACK__;
	unsigned char  L2TPPassword[65] __PACK__;
	unsigned short L2TPIdleTime __PACK__;
	unsigned char  L2TPConnectType __PACK__;
	unsigned short L2TPMTU __PACK__ ;
//**************************************** tel big pond stuffs ****************************************
	unsigned char  telBPIPAddr[4] __PACK__;
	unsigned char  telBPUserName[65] __PACK__;
	unsigned char  telBPPassword[65] __PACK__;
	unsigned char  telBPEnabled __PACK__ ;
//**************************************** ddns stuffs ****************************************
	unsigned char  ddnsName[MAX_NAME_LEN] __PACK__;
	unsigned char  ddnsAccount[MAX_NAME_LEN] __PACK__;
	unsigned char  ddnsPass[MAX_NAME_LEN] __PACK__;
	unsigned char  ddnsEnable __PACK__ ;
	unsigned char  ddnspvidSel[10] __PACK__ ;
	unsigned long  dhisHostID __PACK__;
	unsigned char  dhisISAddr[MAX_NAME_LEN] __PACK__;
	unsigned char  dhispass[MAX_NAME_LEN] __PACK__;
	unsigned char  dhisAuthP1[51] __PACK__;
	unsigned char  dhisAuthP2[51] __PACK__;
	unsigned char  dhisAuthQ1[51] __PACK__;
	unsigned char  dhisAuthQ2[51] __PACK__;
	unsigned char  dhisSelect __PACK__ ;
//**************************************** NAT stuffs ****************************************
	unsigned char portFwEnabled __PACK__;
	unsigned char portFwNum __PACK__; // number of port-forwarding entry existed
	PORTFW_T portFwArray[MAX_FILTER_NUM] __PACK__; // port-forwarding array
	unsigned char ipFilterEnabled __PACK__;
	unsigned char ipFilterNum __PACK__; // number of ip-filter entry existed
	IPFILTER_T ipFilterArray[1] __PACK__; // ip-filter array Erwin Modify
	unsigned char portFilterEnabled __PACK__;
	unsigned char portFilterNum __PACK__; // number of port-filter entry existed
	PORTFILTER_T portFilterArray[1] __PACK__; // ip-filter array Erwin Modify
	unsigned char macFilterEnabled __PACK__;
	unsigned char macFilterNum __PACK__; // number of mac filter entry existed
	MACFILTER_T macFilterArray[MAX_FILTER_NUM] __PACK__; // mac-filter array
	unsigned char triggerPortEnabled __PACK__;
	unsigned char triggerPortNum __PACK__; // number of trigger port entry existed
	TRIGGERPORT_T triggerPortArray[MAX_FILTER_NUM] __PACK__; // trigger port array
	unsigned char sroutEnabled __PACK__;	// enabled of static routing
	unsigned char sroutNum __PACK__; // number of static routing
	SROUT_T sroutArray[MAX_FILTER_NUM] __PACK__; // static routing array
	unsigned char QosNum[4] __PACK__; // number of QoS
	unsigned char QosEnabled[4] __PACK__; // Enabled of QoS
	QOS_T QosArray[2][MAX_QOS_NUM] __PACK__; // QoS array
	unsigned char  upnpEnable __PACK__ ;
	unsigned char  vserEnabled __PACK__ ;
	unsigned char  vserNum __PACK__; // number of virtual-server entry existed
	PORTFW_T vserArray[MAX_FILTER_NUM] __PACK__; // virtual-server array
	unsigned char  natEnable __PACK__ ;
	unsigned char  fastNatEnable __PACK__;
	unsigned char  FirewallEnable __PACK__ ;
	unsigned long  appLayerGateway __PACK__;
//**************************************** FireWall stuffs ****************************************
	unsigned char	macDenyEnabled __PACK__ ;
	unsigned char	ipDenyEnabled __PACK__ ;
	unsigned char  ACPCEnabled __PACK__ ;
	unsigned char  ACPCNum __PACK__; // number of access control entry existed
	ACPC_T ACPCArray[MAX_FILTER_NUM] __PACK__; // access control array
	unsigned char  URLBEnabled __PACK__ ;
	unsigned char  URLBNum __PACK__; // number of url-blocking entry existed
	URLB_T URLBArray[MAX_FILTER_NUM] __PACK__; // url-blocking array
	unsigned char  podEnable __PACK__ ;
	unsigned char  pingEnable __PACK__ ;
	unsigned char  scanEnable __PACK__ ;
	unsigned char  synEnable __PACK__ ;
	unsigned short podPack __PACK__;
	unsigned char podTime __PACK__;
	unsigned short podBur __PACK__;
	unsigned short synPack __PACK__;
	unsigned char synTime __PACK__;
	unsigned short synBur __PACK__;
	unsigned long  scanNum __PACK__;
	unsigned char dmzEnabled __PACK__;
	unsigned char  DMZNum __PACK__; // number of DMZ entry existed
	DMZ_T DMZArray[MAX_FILTER_NUM] __PACK__; // DMZ array
	unsigned char	pppEnTtl __PACK__ ;
#if defined(_ENRIP_)
	//RIP
	unsigned char  ripEnable __PACK__ ;
#endif
#if defined(_ENSNMP_)
	//SNMP
	unsigned char  snmpEnable __PACK__ ;
	unsigned char  snmpName[MAX_NAME_LEN] __PACK__;
#endif
#endif
#if defined(_BR6428PNL_) || defined(_AP_WITH_DNS_)
	DNS_TYPE_T dnsMode __PACK__;
	unsigned char dns1[4], dns2[4], dns3[4] __PACK__;
#endif
#if defined(_BR6428PNL_) || defined(_AP_WITH_DHCP_CLIENT_)
	unsigned char dhcpcheckEnabled __PACK__;
#endif
#ifdef _QoS_MODE_SELECT_
	unsigned char QosCONNum __PACK__; // number of QoSCON
//	unsigned char QosEnabled[4] __PACK__; // Enabled of QoSCON
	QOSCON_T QosCONArray[MAX_QOSCON_NUM] __PACK__; // QoSCON array
#endif
#ifndef HOME_GATEWAY
//****************************** Radius Setting ******************************
	unsigned char rserEnabled __PACK__;	// enabled of radius server
	unsigned char rserCltNum __PACK__; // number of radius server client
	RSER_CLT_T rserCltArray[16] __PACK__; // radius server array client
	unsigned char rserUsrNum __PACK__; // number of radius server user
	RSER_USR_T rserUsrArray[96] __PACK__; // radius server array user
//****************************** Station Setting ******************************
	unsigned char staSecMode __PACK__; // select security mode type
	unsigned char adhocSecMode __PACK__; // select security mode type
	unsigned char staEncrypt __PACK__; // encrypt type, defined as ENCRYPT_t
	unsigned char staAuthType __PACK__; //authentication type,0- open-system,1-shared-key, 2 - both
	unsigned char staWpaCipher __PACK__; // WPA unicast cipher suite
	unsigned char staWep __PACK__ ; // WEP flag, 0 - disabled, 1 - 64bits, 2 128 bits
	unsigned char sta64Key1[WEP64_KEY_LEN] __PACK__ ;
	unsigned char sta64Key2[WEP64_KEY_LEN] __PACK__ ;
	unsigned char sta64Key3[WEP64_KEY_LEN] __PACK__ ;
	unsigned char sta64Key4[WEP64_KEY_LEN] __PACK__ ;
	unsigned char sta128Key1[WEP128_KEY_LEN] __PACK__ ;
	unsigned char sta128Key2[WEP128_KEY_LEN] __PACK__ ;
	unsigned char sta128Key3[WEP128_KEY_LEN] __PACK__ ;
	unsigned char sta128Key4[WEP128_KEY_LEN] __PACK__ ;
	unsigned char staWepDefKey __PACK__ ;
	unsigned char staKeyType __PACK__ ;
	unsigned char staPSKFormat __PACK__; // PSK format 0 - passphrase, 1 - hex
	unsigned char staPSK[MAX_PSK_LEN+1] __PACK__; // WPA pre-shared key
	unsigned char staWpaAuth __PACK__; // WPA authentication type (auto or psk)
	unsigned char wlanBssid[6] __PACK__ ;
	unsigned char staSsid[MAX_SSID_LEN]__PACK__ ; // SSID of station
	unsigned char staEnRadius __PACK__;
	unsigned char staEapTp __PACK__;
	unsigned char staId[MAX_NAME] __PACK__ ;
	unsigned char staPass[MAX_NAME] __PACK__ ;
	unsigned char staPoto[15] __PACK__ ;
	unsigned char staEapId[MAX_NAME] __PACK__ ;
	unsigned char staEapPass[MAX_NAME] __PACK__ ;
	unsigned char staEnCltCer __PACK__;
	unsigned char staCltPass[MAX_NAME] __PACK__ ;
	unsigned char staEnSerCer __PACK__;
	unsigned char staSerPass[MAX_NAME] __PACK__ ;
	unsigned char cltCerFile __PACK__;
	unsigned char serCerFile __PACK__;
	unsigned short staRts __PACK__;
	unsigned short staFrag __PACK__;
	unsigned char staPream __PACK__;
#endif
// Static DHCP Lease --------------
	unsigned char  SDHCPEnabled __PACK__ ;
	unsigned char  SDHCPNum __PACK__; // number of access control entry existed
	SDHCP_T SDHCPArray[MAX_STATIC_DHCP_NUM] __PACK__; // access control array
//---------------------------------
//---------------------------------
// WPS (Wi-Fi protected setup)----------------------
unsigned char wpsEnable __PACK__;//Kyle 2007.03.12, 1 enable ,0 disable
unsigned char wpsConfigMode __PACK__;//Kyle 2007.03.12 , 3 bit  register(0x1) proxy(0x2) enrolee(0x4)
unsigned wpsInternalReg __PACK__;//Kyle 2007.03.12,
unsigned wpsProxyEnable __PACK__;//Kyle 2007.03.12,
unsigned wpsDisplayKey __PACK__;//kyle 2007.04.15
unsigned char wpsConfigType __PACK__;//kyle 2007.03.12  1=via pin  0= via push button
unsigned char wpsConfigStatus __PACK__;//kyle 2007.03.121 1=configured 0=unconfigured.
unsigned char wpsPinCode[WPS_PIN_LEN] __PACK__;//Kyle 2007.03.12 8byte ping code.
//-----------------------------------------------
#ifdef HOME_GATEWAY  // For Guarantee QoS
	unsigned long  MaxDownBandwidth __PACK__ ;
	unsigned long  MaxUpBandwidth __PACK__ ;
#endif
#ifdef UNIVERSAL_REPEATER
	// for wlan0 interface
	unsigned char repeaterEnabled __PACK__; // universal repeater enable/disable
	unsigned char repeaterSSID[MAX_SSID_LEN] __PACK__;  // ssid on virtual interface
#endif
//#ifdef HOME_GATEWAY
//	unsigned char	Reserved[35] __PACK__;		// removed by Erwin
#ifdef _7264Wn_
	unsigned short 	adslVPI __PACK__;
	unsigned short 	adslVCI __PACK__;
	unsigned char 	adslEncapsulation __PACK__;
	unsigned char 	adslWanType __PACK__;
	unsigned char 	adslMode __PACK__;
	unsigned char 	adslType __PACK__;
	unsigned char 	adslATM __PACK__;
	unsigned long 	adslPCR __PACK__;
	unsigned long 	adslSCR __PACK__;
	unsigned long 	adslMBS __PACK__;
#endif
	unsigned char 	wlanTxPower __PACK__; 	// 0:100%, 90=90%, 75=75%,,,
	unsigned char 	wlanWmm __PACK__; 	  	// 0:Enable WMM, 1:Disable
	unsigned char 	wlanTurbo __PACK__; 	// 0:Enable Turbo, 1:Disable
	unsigned char   wlanNFixRate __PACK__;	// 0:auto, 1:MCS0 ,,,
	unsigned char   wlanNChanWidth __PACK__;// 0: 20M, 1:20M/40M HZ
	unsigned char  apRouterSwitch __PACK__;//0:ap mode, 1: router mode
	unsigned char 	wlanForward __PACK__; 	  	// 0:Enable noForwarding, 1:Disable
	unsigned char 	ddnsStatus __PACK__; 	  	// 0:Enable noForwarding, 1:Disable
	unsigned char  autoBridge __PACK__;     // 0: Enable auto bridge, 1 disable
	unsigned char  wifiTest   __PACK__;     // 0: Disable WiFi Test,1 Enable
	unsigned char  isResetDefault __PACK__;
	unsigned char igmpproxyEnabled __PACK__; // igmpproxy enable/disable
#ifdef _corega_
	unsigned char timezoneselected __PACK__ ;
#endif
//Wise
#ifdef _MSSID_
	unsigned char wlanBand1 __PACK__; // BAND1
	unsigned char wlanBand2 __PACK__; // BAND2
	unsigned char wlanBand3 __PACK__; // BAND3
	unsigned char wlanBand4 __PACK__; // BAND4
	unsigned char ssid1[MAX_SSID_LEN] __PACK__ ; // SSID
	unsigned char ssid2[MAX_SSID_LEN] __PACK__ ; // SSID
	unsigned char ssid3[MAX_SSID_LEN] __PACK__ ; // SSID
	unsigned char ssid4[MAX_SSID_LEN] __PACK__ ; // SSID
	unsigned char ssid5[MAX_SSID_LEN] __PACK__ ; // SSID
	unsigned char ssid6[MAX_SSID_LEN] __PACK__ ; // SSID
	unsigned char ssid7[MAX_SSID_LEN] __PACK__ ; // SSID
	unsigned char wep64Key11[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key21[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key31[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key41[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key12[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key22[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key32[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key42[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key13[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key23[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key33[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key43[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key14[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key24[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key34[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key44[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key15[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key25[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key35[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key45[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key16[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key26[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key36[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key46[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key17[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key27[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key37[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep64Key47[WEP64_KEY_LEN] __PACK__ ;
	unsigned char wep128Key11[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key21[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key31[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key41[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key12[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key22[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key32[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key42[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key13[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key23[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key33[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key43[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key14[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key24[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key34[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key44[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key15[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key25[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key35[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key45[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key16[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key26[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key36[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key46[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key17[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key27[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key37[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wep128Key47[WEP128_KEY_LEN] __PACK__ ;
	unsigned char wpaPSK1[MAX_PSK_LEN+1] __PACK__; // WPA pre-shared key
	unsigned char wpaPSK2[MAX_PSK_LEN+1] __PACK__; // WPA pre-shared key
	unsigned char wpaPSK3[MAX_PSK_LEN+1] __PACK__; // WPA pre-shared key
	unsigned char wpaPSK4[MAX_PSK_LEN+1] __PACK__; // WPA pre-shared key
	unsigned char wpaPSK5[MAX_PSK_LEN+1] __PACK__; // WPA pre-shared key
	unsigned char wpaPSK6[MAX_PSK_LEN+1] __PACK__; // WPA pre-shared key
	unsigned char wpaPSK7[MAX_PSK_LEN+1] __PACK__; // WPA pre-shared key
	unsigned char secMode1 __PACK__; // select security mode type
	unsigned char secMode2 __PACK__; // select security mode type
	unsigned char secMode3 __PACK__; // select security mode type
	unsigned char secMode4 __PACK__; // select security mode type
	unsigned char secMode5 __PACK__; // select security mode type
	unsigned char secMode6 __PACK__; // select security mode type
	unsigned char secMode7 __PACK__; // select security mode type
	unsigned char enable1X1 __PACK__; // enable/disable 802.1x
	unsigned char enable1X2 __PACK__; // enable/disable 802.1x
	unsigned char enable1X3 __PACK__; // enable/disable 802.1x
	unsigned char enable1X4 __PACK__; // enable/disable 802.1x
	unsigned char enable1X5 __PACK__; // enable/disable 802.1x
	unsigned char enable1X6 __PACK__; // enable/disable 802.1x
	unsigned char enable1X7 __PACK__; // enable/disable 802.1x
	unsigned short sel1xMode1 __PACK__;	// selsect Radius type, 0-internal, 1--external
	unsigned short sel1xMode2 __PACK__;	// selsect Radius type, 0-internal, 1--external
	unsigned short sel1xMode3 __PACK__;	// selsect Radius type, 0-internal, 1--external
	unsigned short sel1xMode4 __PACK__;	// selsect Radius type, 0-internal, 1--external
	unsigned short sel1xMode5 __PACK__;	// selsect Radius type, 0-internal, 1--external
	unsigned short sel1xMode6 __PACK__;	// selsect Radius type, 0-internal, 1--external
	unsigned short sel1xMode7 __PACK__;	// selsect Radius type, 0-internal, 1--external
	unsigned char wep1 __PACK__ ; // WEP flag, 0 - disabled, 1 - 64bits, 2 128 bits
	unsigned char wep2 __PACK__ ; // WEP flag, 0 - disabled, 1 - 64bits, 2 128 bits
	unsigned char wep3 __PACK__ ; // WEP flag, 0 - disabled, 1 - 64bits, 2 128 bits
	unsigned char wep4 __PACK__ ; // WEP flag, 0 - disabled, 1 - 64bits, 2 128 bits
	unsigned char wep5 __PACK__ ; // WEP flag, 0 - disabled, 1 - 64bits, 2 128 bits
	unsigned char wep6 __PACK__ ; // WEP flag, 0 - disabled, 1 - 64bits, 2 128 bits
	unsigned char wep7 __PACK__ ; // WEP flag, 0 - disabled, 1 - 64bits, 2 128 bits
	unsigned char wepKeyType1 __PACK__ ;
	unsigned char wepKeyType2 __PACK__ ;
	unsigned char wepKeyType3 __PACK__ ;
	unsigned char wepKeyType4 __PACK__ ;
	unsigned char wepKeyType5 __PACK__ ;
	unsigned char wepKeyType6 __PACK__ ;
	unsigned char wepKeyType7 __PACK__ ;
	unsigned char wpaCipher1 __PACK__; // WPA unicast cipher suite
	unsigned char wpaCipher2 __PACK__; // WPA unicast cipher suite
	unsigned char wpaCipher3 __PACK__; // WPA unicast cipher suite
	unsigned char wpaCipher4 __PACK__; // WPA unicast cipher suite
	unsigned char wpaCipher5 __PACK__; // WPA unicast cipher suite
	unsigned char wpaCipher6 __PACK__; // WPA unicast cipher suite
	unsigned char wpaCipher7 __PACK__; // WPA unicast cipher suite
	unsigned char wpa2Cipher1 __PACK__; // wpa2 Unicast cipher
	unsigned char wpa2Cipher2 __PACK__; // wpa2 Unicast cipher
	unsigned char wpa2Cipher3 __PACK__; // wpa2 Unicast cipher
	unsigned char wpa2Cipher4 __PACK__; // wpa2 Unicast cipher
	unsigned char wpa2Cipher5 __PACK__; // wpa2 Unicast cipher
	unsigned char wpa2Cipher6 __PACK__; // wpa2 Unicast cipher
	unsigned char wpa2Cipher7 __PACK__; // wpa2 Unicast cipher
	unsigned char wpaPSKFormat1 __PACK__; // PSK format 0 - passphrase, 1 - hex
	unsigned char wpaPSKFormat2 __PACK__; // PSK format 0 - passphrase, 1 - hex
	unsigned char wpaPSKFormat3 __PACK__; // PSK format 0 - passphrase, 1 - hex
	unsigned char wpaPSKFormat4 __PACK__; // PSK format 0 - passphrase, 1 - hex
	unsigned char wpaPSKFormat5 __PACK__; // PSK format 0 - passphrase, 1 - hex
	unsigned char wpaPSKFormat6 __PACK__; // PSK format 0 - passphrase, 1 - hex
	unsigned char wpaPSKFormat7 __PACK__; // PSK format 0 - passphrase, 1 - hex
	unsigned char wepDefaultKey1 __PACK__ ;
	unsigned char wepDefaultKey2 __PACK__ ;
	unsigned char wepDefaultKey3 __PACK__ ;
	unsigned char wepDefaultKey4 __PACK__ ;
	unsigned char wepDefaultKey5 __PACK__ ;
	unsigned char wepDefaultKey6 __PACK__ ;
	unsigned char wepDefaultKey7 __PACK__ ;
	unsigned char ssidMirror1 __PACK__ ;
	unsigned char ssidMirror2 __PACK__ ;
	unsigned char ssidMirror3 __PACK__ ;
	unsigned char ssidMirror4 __PACK__ ;
	unsigned char ssidMirror5 __PACK__ ;
	unsigned char ssidMirror6 __PACK__ ;
	unsigned char ssidMirror7 __PACK__ ;
	unsigned short fixedTxRate1 __PACK__; // fixed wlan tx rate, used when rate adaptive is disabled
	unsigned short fixedTxRate2 __PACK__; // fixed wlan tx rate, used when rate adaptive is disabled
	unsigned short fixedTxRate3 __PACK__; // fixed wlan tx rate, used when rate adaptive is disabled
	unsigned short fixedTxRate4 __PACK__; // fixed wlan tx rate, used when rate adaptive is disabled
	unsigned short fixedTxRate5 __PACK__; // fixed wlan tx rate, used when rate adaptive is disabled
	unsigned short fixedTxRate6 __PACK__; // fixed wlan tx rate, used when rate adaptive is disabled
	unsigned short fixedTxRate7 __PACK__; // fixed wlan tx rate, used when rate adaptive is disabled
	unsigned char hiddenSSID1 __PACK__ ;
	unsigned char hiddenSSID2 __PACK__ ;
	unsigned char hiddenSSID3 __PACK__ ;
	unsigned char hiddenSSID4 __PACK__ ;
	unsigned char hiddenSSID5 __PACK__ ;
	unsigned char hiddenSSID6 __PACK__ ;
	unsigned char hiddenSSID7 __PACK__ ;
	unsigned char wlanWmm1 __PACK__; 	  	// 0:Enable WMM, 1:Disable
	unsigned char wlanWmm2 __PACK__; 	  	// 0:Enable WMM, 1:Disable
	unsigned char wlanWmm3 __PACK__; 	  	// 0:Enable WMM, 1:Disable
	unsigned char wlanWmm4 __PACK__; 	  	// 0:Enable WMM, 1:Disable
	unsigned char wlanWmm5 __PACK__; 	  	// 0:Enable WMM, 1:Disable
	unsigned char wlanWmm6 __PACK__; 	  	// 0:Enable WMM, 1:Disable
	unsigned char wlanWmm7 __PACK__; 	  	// 0:Enable WMM, 1:Disable
	unsigned char wlanaccess1 __PACK__;		// 0:Enable LAN+WAN Mode, 1: Enable WAN Mode
	unsigned char wlanaccess2 __PACK__;		// 0:Enable LAN+WAN Mode, 1: Enable WAN Mode
	unsigned char wlanaccess3 __PACK__;		// 0:Enable LAN+WAN Mode, 1: Enable WAN Mode
	unsigned char wlanaccess4 __PACK__;		// 0:Enable LAN+WAN Mode, 1: Enable WAN Mode
	unsigned char encrypt1 __PACK__; // encrypt type, defined as ENCRYPT_t
	unsigned char encrypt2 __PACK__; // encrypt type, defined as ENCRYPT_t
	unsigned char encrypt3 __PACK__; // encrypt type, defined as ENCRYPT_t
	unsigned char encrypt4 __PACK__; // encrypt type, defined as ENCRYPT_t
	unsigned char encrypt5 __PACK__; // encrypt type, defined as ENCRYPT_t
	unsigned char encrypt6 __PACK__; // encrypt type, defined as ENCRYPT_t
	unsigned char encrypt7 __PACK__; // encrypt type, defined as ENCRYPT_t
	unsigned char authType1 __PACK__; //authentication type, 0- open-system,1 - shared-key, 2 - both
	unsigned char authType2 __PACK__; //authentication type, 0- open-system,1 - shared-key, 2 - both
	unsigned char authType3 __PACK__; //authentication type, 0- open-system,1 - shared-key, 2 - both
	unsigned char authType4 __PACK__; //authentication type, 0- open-system,1 - shared-key, 2 - both
	unsigned char authType5 __PACK__; //authentication type, 0- open-system,1 - shared-key, 2 - both
	unsigned char authType6 __PACK__; //authentication type, 0- open-system,1 - shared-key, 2 - both
	unsigned char authType7 __PACK__; //authentication type, 0- open-system,1 - shared-key, 2 - both
	unsigned char wpaAuth1 __PACK__; // WPA authentication type (auto or psk)
	unsigned char wpaAuth2 __PACK__; // WPA authentication type (auto or psk)
	unsigned char wpaAuth3 __PACK__; // WPA authentication type (auto or psk)
	unsigned char wpaAuth4 __PACK__; // WPA authentication type (auto or psk)
	unsigned char wpaAuth5 __PACK__; // WPA authentication type (auto or psk)
	unsigned char wpaAuth6 __PACK__; // WPA authentication type (auto or psk)
	unsigned char wpaAuth7 __PACK__; // WPA authentication type (auto or psk)
#if defined(_ENVLAN_)
	unsigned short vlanid1 __PACK__;
	unsigned short vlanid2 __PACK__;
	unsigned short vlanid3 __PACK__;
	unsigned short vlanid4 __PACK__;
	unsigned short vlanid5 __PACK__;
	unsigned short vlanid6 __PACK__;
	unsigned short vlanid7 __PACK__;
#endif
#endif
#ifdef _EZVIEW_
	unsigned char EZVIEWNum __PACK__;
	EZVIEW_T EZVIEWArray[MAX_EZVIEW_NUM] __PACK__;
	unsigned char EZVIEWdmz __PACK__;
#endif

#ifdef _DALGFTP_
	unsigned short ftpPorts __PACK__;
#endif
#ifdef _DBAND_
	unsigned short dualBandSwitch __PACK__;
	unsigned short aBandMode __PACK__;
	unsigned short aBandChannel __PACK__;
#endif
#ifdef _LAN_WAN_ACCESS_
	// enable lan<->wan access function by multiple ssid number.
	// add by Kyle 2008.03.27
	// bit 0= disable.
	// bit 1= enable.
	//
	// b11111111  8bit.
	//  ||||||||
	//  |||||||+---enable mssid 1 lan<->wan access.
	//  ||||||+----enable mssid 2 lan<->wan access.
	//  |||||+-----enable mssid 3 lan<->wan access.
	//  ||||+------enable mssid 4 lan<->wan access.
	//  |||+-------enable mssid 5 lan<->wan access.
	//  ||+--------enable mssid 6 lan<->wan access.
	//  |+---------enable mssid 7 lan<->wan access.
	//  +----------reserved.
	unsigned long  enableLanWanAccess __PACK__; //
#endif
#ifdef _PPPOE_PASSTHROUGH_
	unsigned char pppoepassthrough __PACK__;
#endif
#ifdef _IPV6_BRIDGE_
	unsigned char ipv6bridge __PACK__;
#endif
#ifdef _WANTTL_
	unsigned char ttlType __PACK__;
	unsigned short ttlValue __PACK__;
#endif
#ifdef _INDEPEND_DHCP_MTU_
	unsigned short dhcpMTU __PACK__ ;
#endif
#ifdef _SREBOOT_BLINK_POWER_
	unsigned char isReboot __PACK__;
#endif
#ifdef _WATCH_DOG_
    unsigned char  watchdog_enable __PACK__;
    unsigned short watchdog_interval __PACK__;
    unsigned char  watchdog_host[4] __PACK__;
#endif
//vance 2008.10.03
#ifdef _PC_DATABASE_
	unsigned char group1[64] __PACK__;
	unsigned char group2[64] __PACK__;
	unsigned char group3[64] __PACK__;
	unsigned char group4[64] __PACK__;
	unsigned char group1Disabled __PACK__;
	unsigned char group2Disabled __PACK__;
	unsigned char group3Disabled __PACK__;
	unsigned char group4Disabled __PACK__;
#endif
#if defined(_MULTIPLE_WLAN_ACCESS_CONTROL_ )
	unsigned char acEnabled2 __PACK__; // enable/disable WLAN access control MSSID2
	unsigned char acEnabled3 __PACK__; // enable/disable WLAN access control MSSID3
	unsigned char acEnabled4 __PACK__; // enable/disable WLAN access control MSSID4
	unsigned char acEnabled5 __PACK__; // enable/disable WLAN access control MSSID5

	unsigned char acNum2 __PACK__; // WLAN access control entry number MSSID2
	unsigned char acNum3 __PACK__; // WLAN access control entry number MSSID3
	unsigned char acNum4 __PACK__; // WLAN access control entry number MSSID4
	unsigned char acNum5 __PACK__; // WLAN access control entry number MSSID5

	MACFILTER_T acAddrArray2[MAX_WLAN_AC_NUM] __PACK__; // WLAN access control array2 MSSID2
	MACFILTER_T acAddrArray3[MAX_WLAN_AC_NUM] __PACK__; // WLAN access control array2 MSSID3
	MACFILTER_T acAddrArray4[MAX_WLAN_AC_NUM] __PACK__; // WLAN access control array2 MSSID4
	MACFILTER_T acAddrArray5[MAX_WLAN_AC_NUM] __PACK__; // WLAN access control array2 MSSID5
#endif
//vance 2008.11.14
#ifdef _WIRELESS_SCHEDULE_
	unsigned char WlanSchEnabled __PACK__;
	unsigned char WlanSchNum __PACK__;
	SCHEDULE_T WlanSchArray[MAX_WLAN_SCH_NUM] __PACK__;
#endif

//Felix 20101222
#ifdef _PROFILE_LIST_
	unsigned char ProfileListNum __PACK__;
	PROFILELIST_T ProfileListArray[MAX_PROFILE_LIST_NUM] __PACK__;
#endif

#ifdef _WAN3G_
	unsigned char	AuthModeSel[15] __PACK__; // add for 3G WWAN
	unsigned char   OPModeSel[15]   __PACK__;
	unsigned char   NPSel[15]       __PACK__;
	unsigned char   wwanName[MAX_NAME_LEN]  __PACK__;
	unsigned char   wwanPassword[MAX_NAME_LEN]  __PACK__;
	unsigned char   PINCode[10]       __PACK__;
	unsigned char   wwanAPN[MAX_NAME_LEN]  __PACK__;
	unsigned char   PPPName[MAX_NAME_LEN]  __PACK__;
	unsigned char   PPPPass[MAX_NAME_LEN]  __PACK__;
	unsigned short  PPPIdleTime __PACK__;
	unsigned short  PPPEchoTimeout __PACK__;
	unsigned short  PPPEchoCount __PACK__;  // after add the 3G WWAN mibs, the Reserved should minus 216
	unsigned char   wwanPhoneNo[MAX_NAME_LEN]  __PACK__;
#endif
//vance 2009.02.04 for 3G connetion
#ifdef _STAR_CF_3G_
		unsigned char   NPSel[15]       __PACK__;
		unsigned char   wwanName[MAX_NAME_LEN]  __PACK__;
		unsigned char   wwanPassword[MAX_NAME_LEN]  __PACK__;
		unsigned char   wwanAPN[MAX_NAME_LEN]  __PACK__;
		unsigned char   PPPName[MAX_NAME_LEN]  __PACK__;
		unsigned char   PPPPass[MAX_NAME_LEN]  __PACK__;
		unsigned short  PPPIdleTime __PACK__;
		unsigned short  PPPEchoTimeout __PACK__;
		unsigned short  PPPEchoCount __PACK__;  // after add the 3G WWAN mibs, the Reserved should minus 216
		unsigned char   wwanPhoneNo[MAX_NAME_LEN]  __PACK__;
		unsigned char   connetType  __PACK__;
#endif
#ifdef _WISP_
//	unsigned char stadrv_type __PACK__ ;
	unsigned char stadrv_ssid[MAX_SSID_LEN]__PACK__ ;
	unsigned char stadrv_channel __PACK__ ;// current channel
	unsigned char stadrv_band __PACK__ ;
	unsigned char stadrv_encrypttype __PACK__ ;
	unsigned char stadrv_weplength __PACK__ ;
	unsigned char stadrv_wepformat1 __PACK__ ;
	unsigned char stadrv_wepformat2 __PACK__ ;
	unsigned char stadrv_wepformat3 __PACK__ ;
	unsigned char stadrv_wepformat4 __PACK__ ;
	unsigned char stadrv_defaultkey __PACK__ ;
	unsigned char stadrv_wpacipher __PACK__ ;
	unsigned char stadrv_pskformat __PACK__ ;
	unsigned char stadrv_wepkey1[27] __PACK__ ;
	unsigned char stadrv_wepkey2[27] __PACK__ ;
	unsigned char stadrv_wepkey3[27] __PACK__ ;
	unsigned char stadrv_wepkey4[27] __PACK__ ;
	unsigned char stadrv_pskkey[65] __PACK__;
	unsigned char stadrv_clonemac[6] __PACK__;
/*	unsigned char stadrv_wantype __PACK__ ;
	unsigned char stadrv_hostname[31] __PACK__;
	unsigned char stadrv_ip[4] __PACK__;
	unsigned char stadrv_mask[4] __PACK__;
	unsigned char stadrv_gateway[4] __PACK__;
	*/
#endif
#ifdef _Unicorn_
	unsigned char qosmode __PACK__ ;
#endif
#ifdef _SDMZ_
	unsigned char dmzmode __PACK__;
	unsigned char dmzMacAddr[6] __PACK__ ;
	unsigned short refreshtime __PACK__;
#endif
#ifdef _CONNECTION_CTRL_
	unsigned short conneccountmax __PACK__;
	unsigned short udpcountmax __PACK__;
	unsigned short tcpcountmax __PACK__;
	unsigned short icmpcountmax __PACK__;
	unsigned short timeoutestablished __PACK__;
	unsigned short timeoutsynsent __PACK__;
	unsigned short timeoutsynrecv __PACK__;
	unsigned short timeoutfinwait __PACK__;
	unsigned short timeoutclosewait __PACK__;
	unsigned short timeoutlastcck __PACK__;
	unsigned short timeoutgeneric __PACK__;
	unsigned char connectionctrlenabled __PACK__;
#endif
//**************************************** PPPoE 2 stuffs ****************************************
#if defined(_TRIPPPOE_) & defined(_MPPPOE_)
   unsigned char pppUserName2[65] __PACK__;
   unsigned char pppPassword2[65] __PACK__;
   unsigned short pppIdleTime2 __PACK__;
   unsigned char pppConnectType2 __PACK__;
   unsigned char  pppServName2[MAX_NAME_LEN] __PACK__;
   unsigned short pppMTU2 __PACK__ ;
   unsigned char  pppUnnumIP2[4] __PACK__ ;
   unsigned char  pppUnnumMask2[4] __PACK__ ;
#endif
#ifdef _LEDSWITCH_
   unsigned char ledContorl __PACK__ ;
#endif
#ifdef _SNTP_A_M_CTL_ //vance 2009.02.20
	//for time server domain name
	unsigned char	 TimeServerDomain[MAX_NAME_LEN] __PACK__;
	//for sntp auto/manual setting
	unsigned char TimeServerEnable __PACK__;
	//static system time
	unsigned char  StaticSystemTime[13] __PACK__;
#endif

#ifdef _GREEN_AP_SCHEDULE_	//Felix 2011.02.15
	unsigned char greenap_enable __PACK__ ;
	unsigned char greenap_weekdays1 __PACK__ ;
	unsigned char greenap_weekdays2 __PACK__ ;
	unsigned char greenap_weekdays3 __PACK__ ;
	unsigned char greenap_weekdays4 __PACK__ ;
	unsigned char greenap_powerlevel1 __PACK__ ;
	unsigned char greenap_powerlevel2 __PACK__ ;
	unsigned char greenap_powerlevel3 __PACK__ ;
	unsigned char greenap_powerlevel4 __PACK__ ;
	//unsigned char greenap_timetype __PACK__ ;
	unsigned char greenap_starthour1 __PACK__ ;
	unsigned char greenap_starthour2 __PACK__ ;
	unsigned char greenap_starthour3 __PACK__ ;
	unsigned char greenap_starthour4 __PACK__ ;
	unsigned char greenap_startminute1 __PACK__ ;
	unsigned char greenap_startminute2 __PACK__ ;
	unsigned char greenap_startminute3 __PACK__ ;
	unsigned char greenap_startminute4 __PACK__ ;
	unsigned char greenap_stophour1 __PACK__ ;
	unsigned char greenap_stophour2 __PACK__ ;
	unsigned char greenap_stophour3 __PACK__ ;
	unsigned char greenap_stophour4 __PACK__ ;
	unsigned char greenap_stopminute1 __PACK__ ;
	unsigned char greenap_stopminute2 __PACK__ ;
	unsigned char greenap_stopminute3 __PACK__ ;
	unsigned char greenap_stopminute4 __PACK__ ;
	unsigned char RFPowerScale __PACK__;
	unsigned char wlanTxPower1 __PACK__ ;
	unsigned char wlanTxPower2 __PACK__ ;
	unsigned char wlanTxPower3 __PACK__ ;
	unsigned char wlanTxPower4 __PACK__ ;
#endif
#ifdef _QoS_MODE_SELECT_
unsigned char QoS_QOSTYPE __PACK__;
#endif
#ifdef _DHCP_SERVER_WITH_GW_DNS_
	unsigned char dhcp_server_gw[4] __PACK__;
	unsigned char dhcp_server_dns1[4] __PACK__;
	unsigned char dhcp_server_dns2[4] __PACK__;
#endif
#ifdef _GENERAL_3G_ //vance 2009.04.09 for general
	unsigned char   PINCode[10]       __PACK__;
	unsigned char	 AuthModeSel[15] __PACK__; // add for 3G WWAN
	unsigned char   OPModeSel[15]   __PACK__;
#endif
#ifdef _STARCRAFT_
	unsigned char STARCRAFTNum __PACK__;
	STARCRAFT_T STARCRAFTArray[MAX_STARCRAFT_NUM] __PACK__;
#endif

#ifdef _GET_TIME_FROM_PC_
   unsigned char pcTime __PACK__ ;
#endif

#if defined(_Customer_EX_) || defined(_Customer_SC_) || defined(_Customer_SA_)
   unsigned char guardInterval __PACK__ ;
   unsigned char DeclineBARequest __PACK__ ;
   unsigned char isolation __PACK__ ;
   unsigned char mbssidIsolation __PACK__ ;
#endif

#ifdef _MULTIPLE_WLAN_RS_SETTING_
	unsigned char rsIpAddr1[4] __PACK__; // radius server IP address
	unsigned char rsIpAddr2[4] __PACK__;
	unsigned char rsIpAddr3[4] __PACK__;
	unsigned char rsIpAddr4[4] __PACK__;
	unsigned char rsIpAddr5[4] __PACK__;
	unsigned char rsIpAddr6[4] __PACK__;
	unsigned char rsIpAddr7[4] __PACK__;
	unsigned short rsPort1 __PACK__; // radius server port number
	unsigned short rsPort2 __PACK__;
	unsigned short rsPort3 __PACK__;
	unsigned short rsPort4 __PACK__;
	unsigned short rsPort5 __PACK__;
	unsigned short rsPort6 __PACK__;
	unsigned short rsPort7 __PACK__;
	unsigned char rsPassword1[MAX_RS_PASS_LEN] __PACK__; // radius server password
	unsigned char rsPassword2[MAX_RS_PASS_LEN] __PACK__;
	unsigned char rsPassword3[MAX_RS_PASS_LEN] __PACK__;
	unsigned char rsPassword4[MAX_RS_PASS_LEN] __PACK__;
	unsigned char rsPassword5[MAX_RS_PASS_LEN] __PACK__;
	unsigned char rsPassword6[MAX_RS_PASS_LEN] __PACK__;
	unsigned char rsPassword7[MAX_RS_PASS_LEN] __PACK__;
	unsigned short rsIntervalTime1 __PACK__; // radius server timeout
	unsigned short rsIntervalTime2 __PACK__;
	unsigned short rsIntervalTime3 __PACK__;
	unsigned short rsIntervalTime4 __PACK__;
	unsigned short rsIntervalTime5 __PACK__;
	unsigned short rsIntervalTime6 __PACK__;
	unsigned short rsIntervalTime7 __PACK__;
	unsigned short accountRsIntervalTime1 __PACK__; // accounting radius server timeout
	unsigned short accountRsIntervalTime2 __PACK__;
	unsigned short accountRsIntervalTime3 __PACK__;
	unsigned short accountRsIntervalTime4 __PACK__;
	unsigned short accountRsIntervalTime5 __PACK__;
	unsigned short accountRsIntervalTime6 __PACK__;
	unsigned short accountRsIntervalTime7 __PACK__;
#endif

#if defined(_COPY_ROOT_SSID_)
	unsigned char ssidChoice __PACK__ ;
#endif

#if defined(_WEB_ACCESS_CONTROL_)
	unsigned char webContorl __PACK__;
#endif

#if defined(_POWER_SAVING_)
	unsigned char powersaving __PACK__;
#endif
#if defined(_LED_SWITCH_) || defined(_SW_LED_SWITCH_)
	unsigned char ledSwitch __PACK__;
#endif
#if defined(_Airlive_7428HCN_)
	unsigned char csRegDomain __PACK__;
	unsigned char cloneMacAddr[6] __PACK__;
	unsigned char keepConfig __PACK__;
	unsigned char deviceName[30] __PACK__;
	unsigned char ipFinder __PACK__;
	unsigned char aggregation __PACK__;
	unsigned char shortgiEnabled __PACK__;
        unsigned short ackTimeout __PACK__;
#endif
#ifdef _CONTROL_SIDEBAND_
	unsigned char controlSideband __PACK__;
#endif

#ifdef _SYSTEM_LOG_
	unsigned char scrlogEnabled __PACK__; // enable security log
	unsigned char rtLogEnabled __PACK__;
	unsigned char rtLogServer[4] __PACK__;
#endif

#ifdef _RTK_NTP_
	unsigned char ntpEnabled __PACK__; // ntp client enabled
	unsigned char ntpServerId __PACK__; // ntp Server Index
	unsigned char ntpTimeZone[8] __PACK__; // ntp  Time Zone
        unsigned char ntpServerIp1[4] __PACK__; // ntp  server ip address
        unsigned char ntpServerIp2[4] __PACK__; // ntp server ip address
	unsigned char daylightsaveEnabled __PACK__; //day light saving enabled
        unsigned short system_time_year __PACK__;
        unsigned char system_time_month __PACK__;
        unsigned char system_time_day __PACK__; 
        unsigned char system_time_hour __PACK__; 
        unsigned char system_time_min __PACK__; 
        unsigned char system_time_sec __PACK__; 
#endif

#ifdef _WEB_PORT_
	unsigned short webPort __PACK__; // ntp client enabled
#endif
#ifdef _Airlive_Schedule_
	unsigned char wlschEnabled __PACK__;
        unsigned char wlschEnabled_1 __PACK__;
        unsigned char wlschEnabled_2 __PACK__;
        unsigned char wlschEnabled_3 __PACK__;
        unsigned char wlschEnabled_4 __PACK__;
        unsigned char wlschEnabled_5 __PACK__;
        unsigned char wlschEnabled_6 __PACK__;
        unsigned char wlschEnabled_7 __PACK__;
        unsigned char wlschEnabled_8 __PACK__;
        unsigned char wlschEnabled_9 __PACK__;
        unsigned char wlschEnabled_10 __PACK__;
        unsigned char wlschDay1 __PACK__;
        unsigned char wlschDay2 __PACK__;
        unsigned char wlschDay3 __PACK__;
        unsigned char wlschDay4 __PACK__;
        unsigned char wlschDay5 __PACK__;
        unsigned char wlschDay6 __PACK__;
        unsigned char wlschDay7 __PACK__;
        unsigned char wlschDay8 __PACK__;
        unsigned char wlschDay9 __PACK__;
        unsigned char wlschDay10 __PACK__;
        unsigned char wlschFromHour1 __PACK__;
        unsigned char wlschFromHour2 __PACK__;
        unsigned char wlschFromHour3 __PACK__;
        unsigned char wlschFromHour4 __PACK__;
        unsigned char wlschFromHour5 __PACK__;
        unsigned char wlschFromHour6 __PACK__;
        unsigned char wlschFromHour7 __PACK__;
        unsigned char wlschFromHour8 __PACK__;
        unsigned char wlschFromHour9 __PACK__;
        unsigned char wlschFromHour10 __PACK__;
        unsigned char wlschFromMin1 __PACK__;
        unsigned char wlschFromMin2 __PACK__;
        unsigned char wlschFromMin3 __PACK__;
        unsigned char wlschFromMin4 __PACK__;
        unsigned char wlschFromMin5 __PACK__;
        unsigned char wlschFromMin6 __PACK__;
        unsigned char wlschFromMin7 __PACK__;
        unsigned char wlschFromMin8 __PACK__;
        unsigned char wlschFromMin9 __PACK__;
        unsigned char wlschFromMin10 __PACK__;
        unsigned char wlschToHour1 __PACK__;
        unsigned char wlschToHour2 __PACK__;
        unsigned char wlschToHour3 __PACK__;
        unsigned char wlschToHour4 __PACK__;
        unsigned char wlschToHour5 __PACK__;
        unsigned char wlschToHour6 __PACK__;
        unsigned char wlschToHour7 __PACK__;
        unsigned char wlschToHour8 __PACK__;
        unsigned char wlschToHour9 __PACK__;
        unsigned char wlschToHour10 __PACK__;
        unsigned char wlschToMin1 __PACK__;
        unsigned char wlschToMin2 __PACK__;
        unsigned char wlschToMin3 __PACK__;
        unsigned char wlschToMin4 __PACK__;
        unsigned char wlschToMin5 __PACK__;
        unsigned char wlschToMin6 __PACK__;
        unsigned char wlschToMin7 __PACK__;
        unsigned char wlschToMin8 __PACK__;
        unsigned char wlschToMin9 __PACK__;
        unsigned char wlschToMin10 __PACK__;

#endif

#ifdef _STANUM_
	unsigned char staNum __PACK__;
#endif

	unsigned char WDSNum __PACK__;
        WDSList_T WDSList[MAX_WDS_NUM] __PACK__;

	#if defined(_IS_GATEWAY_)
		unsigned char	Reserved[17560-_FLASH_RESERVED_] __PACK__;
	#else
		unsigned char	Reserved[17387-_FLASH_RESERVED_] __PACK__;//not sure 17560 or 25020
	#endif

#ifdef _VLAN_CONFIG_SUPPORTED_
unsigned char VlanConfigEnabled __PACK__;	
unsigned char VlanConfigNum __PACK__; // number of vlan config entry	
VLAN_CONFIG_T VlanConfigArray[MAX_IFACE_VLAN_CONFIG] __PACK__; // vlan config	
#endif

//-----------------------------------------------------------------------------------------------
} __PACK__ APMIB_T, *APMIB_Tp;
/* Config file header */
typedef struct param_header {
	unsigned char signature[SIGNATURE_LEN] __PACK__;  // Tag + version
	unsigned short len __PACK__;
} __PACK__ PARAM_HEADER_T, *PARAM_HEADER_Tp;
/* Firmware image file header */
typedef struct img_header {
#ifdef _NETINDEX_FW_CHECK_
	unsigned char signature[SIGNATURE_LEN] __PACK__;
	unsigned char SWVersion[VERSION_LEN] __PACK__;
	unsigned char magincNo[VERSION_LEN] __PACK__;
	unsigned char upperHWVersion[VERSION_LEN] __PACK__;
	unsigned char lowerHWVersion[VERSION_LEN] __PACK__;
	unsigned long len __PACK__;
#else
	unsigned char signature[SIGNATURE_LEN] __PACK__;
	#ifndef _ADM5120_
	unsigned long startAddr __PACK__;
	unsigned long burnAddr __PACK__;
	#endif
//	unsigned char modTag[SIGNATURE_LEN] __PACK__;
	unsigned long len __PACK__;
#endif
} __PACK__ IMG_HEADER_T, *IMG_HEADER_Tp;
/* Web page file header */
typedef IMG_HEADER_T WEB_HEADER_T;
typedef IMG_HEADER_Tp WEB_HEADER_Tp;
typedef struct _file_entry {
	char name[MAXFNAME] __PACK__;
	unsigned long size __PACK__;
} __PACK__ FILE_ENTRY_T, *FILE_ENTRY_Tp;
#ifdef WIN32
#pragma pack()
#endif
//////////////////////////////////////////////////////////
int apmib_init(void);
int apmib_reinit(void);
char *apmib_hwconf(void);
char *apmib_csconf(void);
char *apmib_dsconf(void);
int apmib_get(int id, void *value);
//int apmib_getDef(int id, void *value);	//removed by Erwin
int apmib_set(int id, void *value);
//int apmib_setDef(int id, void *value);	//removed by Erwin
int apmib_update(CONFIG_DATA_T type);
//int apmib_updateDef(void);	//removed by Erwin
int apmib_updateFlash(CONFIG_DATA_T type, char *data, int len, int force, int ver);
//extern APMIB_Tp pMib, pMibDef;		//removed by Erwin
extern APMIB_Tp pMib;
extern HW_SETTING_Tp pHwSetting;
extern PARAM_HEADER_T hsHeader, dsHeader, csHeader;
//extern int wlan_idx;
//extern int vwlan_idxx=4;
#endif // INCLUDE_APMIB_H
extern void dump_mem(void *ptr, int size);
