/*
 *      Web server handler routines for firewall
 *
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *
 *      $Id: fmfwall.c,v 1.2 2005/05/13 07:53:47 tommy Exp $
 *
 */

/*-- System inlcude files --*/
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <sys/wait.h>

#include "../webs.h"
#include "apform.h"
#include "apmib.h"
#include "utility.h"

//int need_reboot = 0;		//removed by Erwin
int Changed = 0;
int First   = 1;
int newpage = 1;    // 1: new page  0: original page


#ifdef HOME_GATEWAY

int selectNum = -1;
int selectWan = -1;

URLB_T URLBEntry;	// for URL blocking
void *pEntry;

void initQos() {
	int i, num_id, add_id,intVal;
	QOS_T entry;

	memset(&entry, '\0', sizeof(entry));
	apmib_get( MIB_WAN1_QOS_NUM, (void *)&intVal);
		if ( intVal == 0 ) {
			strcpy(entry.ruleName, "Others");
			entry.sourType = 2;
			apmib_set(MIB_WAN1_QOS_ADD, (void *)&entry);	//MIB_QOS_ADD
		}
}
/////////////////////////////////////////////////////////////////////////////
void formQoS(webs_t wp, char_t *path, char_t *query)
{

	char_t *strAddQos, *strDelQos, *strDelAllQos, *strApplyQos, *strEnable, *strApply, *strIsEnabled;
	char_t *strMvUp, *strMvDown, *strEditQos, *strShowQos, *strConfigWan;
	char_t *strName, *strBWVal, *strBWType, *strDUType, *strDownVal, *strDownType;
	char_t *strWanPort, *submitUrl, *strVal;
	char_t *strScType, *strScStIp, *strScEdIp, *strScMac;
	char_t *strDtStIp, *strDtEdIp;
	char_t *strTfType, *strProtl, *strScPort, *strDtPort, *strPortTmp, *strDiffSev, *strConfigNum;
	char_t *strMaxDown, *strMaxUp, *QoStype;
	char_t *strModeState;

	char tmpBuf[100];
	char *ptr1, *ptr2;
	int entryNum, i, selNum, andNum, intVal;
	int num_id, qos_id, add_id, edit_id, config_id, del_id, delall_id, send_id, enable_id;
	struct in_addr curIpAddr,entIpAddr ,curSubnet;
	unsigned long v1, v2, v3, v4;
	QOS_T entry, orgEntry;
	EDIT_T Edit;	
	
	strAddQos = websGetVar(wp, T("addQos"), T(""));
	strEditQos = websGetVar(wp, T("editQos"), T(""));
	strConfigWan = websGetVar(wp, T("configWan"), T(""));
	strConfigNum = websGetVar(wp, T("configNum"), T(""));
	strModeState = websGetVar(wp, T("nettype"), T(""));

//	num_id = qos_id = add_id = edit_id = config_id = del_id = delall_id = send_id = 0;
	selNum = atoi(strConfigWan);
	memset(&entry, '\0', sizeof(entry));


	//strApplyQos = websGetVar(wp, T("ApplyQos"), T(""));

	strIsEnabled = websGetVar(wp, T("isEnabled"), T(""));

	if (strIsEnabled[0]) {
		strVal = websGetVar(wp, T("enabled1"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			intVal = 1;
		else
			intVal = 0;

		if ( apmib_set( MIB_WAN1_QOS_ENABLED, (void *)&intVal) == 0) {//MIB_QOS_ENABLED
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrFlag))</script>"));
			goto setErr_qos;
		}
	}
#ifdef _Unicorn_
	if (strModeState[0]){
		intVal = atoi(strModeState);
		if (!apmib_set( MIB_QOS_MODE, (void *)&intVal)){
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrMode))</script>>"));
			goto setErr_qos;
		}
	}
#endif

#ifdef _QoS_MODE_SELECT_
	QoStype = websGetVar(wp, T("qosmod"), T(""));
	if (QoStype[0]) {
			string_to_dec(QoStype, &intVal);
			apmib_set(MIB_QoS_QOSTYPE, (void *)&intVal);
	}

#endif

/*	strVal = websGetVar(wp, T("enabled2"), T(""));
	if ( !gstrcmp(strVal, T("ON")))
		intVal = 1;
	else
		intVal = 0;
	if ( apmib_set( MIB_WAN2_QOS_ENABLED, (void *)&intVal) == 0) {//MIB_QOS_ENABLED
		strcpy(tmpBuf, T("Set enabled flag error!"));
		goto setErr_qos;
	}

	strVal = websGetVar(wp, T("enabled3"), T(""));
	if ( !gstrcmp(strVal, T("ON")))
		intVal = 1;
	else
		intVal = 0;
	if ( apmib_set( MIB_WAN3_QOS_ENABLED, (void *)&intVal) == 0) {//MIB_QOS_ENABLED
		strcpy(tmpBuf, T("Set enabled flag error!"));
		goto setErr_qos;
	}

	strVal = websGetVar(wp, T("enabled4"), T(""));
	if ( !gstrcmp(strVal, T("ON")))
		intVal = 1;
	else
		intVal = 0;
	if ( apmib_set( MIB_WAN4_QOS_ENABLED, (void *)&intVal) == 0) {//MIB_QOS_ENABLED
		strcpy(tmpBuf, T("Set enabled flag error!"));
		goto setErr_qos;
	}
*/
	/* Add new QoS table */
	if (strAddQos[0] || strEditQos[0]) {
		for (andNum=0x001; andNum<=0x008; (andNum=andNum*2)) {
			num_id = 0;
			if ( (selNum & andNum) == 0x001 ) {	//WAN 1
				num_id = MIB_WAN1_QOS_NUM;
				qos_id = MIB_WAN1_QOS;
				add_id = MIB_WAN1_QOS_ADD;
				edit_id = MIB_WAN1_QOS_EDIT;
				del_id = MIB_WAN1_QOS_DEL;
				send_id = MIB_POLICY_SEND;
			}
			if ( num_id == 0 )	continue;

			strName = websGetVar(wp, T("ruleName"), T(""));
			strBWVal = websGetVar(wp, T("bwidthVal"), T(""));
			strBWType = websGetVar(wp, T("bwidthType"), T(""));
			strDUType = websGetVar(wp, T("downUpType"), T(""));
			strDownVal = websGetVar(wp, T("downVal"), T(""));
			strDownType = websGetVar(wp, T("downType"), T(""));
			strWanPort = websGetVar(wp, T("portValue"), T(""));

			strScType = websGetVar(wp, T("sourType"), T(""));
			strScMac = websGetVar(wp, T("sourMac"), T(""));

			strTfType = websGetVar(wp, T("trafType"), T(""));
			strProtl = websGetVar(wp, T("protocol"), T(""));
			strScPort = websGetVar(wp, T("sourPort"), T(""));
			strDtPort = websGetVar(wp, T("destPort"), T(""));
			strDiffSev = websGetVar(wp, T("diffSevType"), T(""));


			if ( strDUType[0] == '0' ) { // Tommy
				strScStIp = websGetVar(wp, T("sourStIp"), T(""));
				strScEdIp = websGetVar(wp, T("sourEdIp"), T(""));
				strDtStIp = websGetVar(wp, T("destStIp"), T(""));
				strDtEdIp = websGetVar(wp, T("destEdIp"), T(""));
				strScPort = websGetVar(wp, T("sourPort"), T(""));
				strDtPort = websGetVar(wp, T("destPort"), T(""));
			}
			else {	//Download
				strDtStIp = websGetVar(wp, T("sourStIp"), T(""));
				strDtEdIp = websGetVar(wp, T("sourEdIp"), T(""));
				strScStIp = websGetVar(wp, T("destStIp"), T(""));
				strScEdIp = websGetVar(wp, T("destEdIp"), T(""));
				strDtPort = websGetVar(wp, T("sourPort"), T(""));
				strScPort = websGetVar(wp, T("destPort"), T(""));
			}

			if ( strName[0] ) {	//set rule name
				if (strlen(strName) > COMMENT_LEN-1) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrLong))</script>"));
					goto setErr_qos;
				}
				strcpy(entry.ruleName, strName);
			}

			if ( strDUType[0] == '0' )
			{
				if ( strBWType[0] == '0' )	//set bandwidth Type of QoS
					entry.bwidthType = 0;
				else
					entry.bwidthType = 1;



				v1=strtoul(strBWVal,NULL,0);
				entry.bwidthVal = (unsigned long)v1;
				entry.downType = 0;
				entry.downVal = (unsigned long) 0;
			}
			else
			{
				if ( strBWType[0] == '0' )	//set download bandwidth Type of QoS
					entry.downType = 0;
				else
					entry.downType = 1;

				v1=strtoul(strBWVal,NULL,0);
				entry.downVal = (unsigned long)v1;
				entry.bwidthType = 0;
				entry.bwidthVal = (unsigned long) 0;
			}


//*********************************** source address ***********************************
			if ( strScType[0] == '0' ) {
				entry.sourType = 0;	//set source address Type of QoS
				getInAddr(BRIDGE_IF, IP_ADDR, (void *)&curIpAddr);
				getInAddr(BRIDGE_IF, SUBNET_MASK, (void *)&curSubnet);


//				if (!strScStIp[0]) 	//set start ip of source address of QoS
//					strScStIp = "0.0.0.0";
				//inet_aton(strScStIp, (struct in_addr *)&entry.sourStIp);
				inet_aton(strScStIp, &entIpAddr);
				fixed_inet_aton(strScStIp,entry.sourStIp);
				//v1 = *((unsigned long *)entry.sourStIp);
  		  v1 = ((unsigned long)entIpAddr.s_addr);
  		 	v2 = *((unsigned long *)&curIpAddr);
				v3 = *((unsigned long *)&curSubnet);
				if ( !strScStIp[0] && ((v1 & v3) != (v2 & v3)) ) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSInvIpStart))</script>"));
					goto setErr_qos;
				}

//				if (!strScEdIp[0]) 	//set end ip of source address of QoS
				if (!strcmp(strScEdIp,"0.0.0.0")) 	//set end ip of source address of QoS
					strScEdIp = strScStIp;
				//inet_aton(strScEdIp, (struct in_addr *)&entry.sourEdIp);
				fixed_inet_aton(strScEdIp,entry.sourEdIp);
				v4 = *((unsigned long *)entry.sourEdIp);
				if ( !strScEdIp[0] && ((v4 & v3) != (v2 & v3)) ) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSInvIpEnd))</script>"));
					goto setErr_qos;
				}
				if ( v4 < v1 ) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSInvIpRange))</script>"));
					goto setErr_qos;
				}
			}
			else {
				entry.sourType = 1;
				if ( !strScMac[0] ) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrMacNo))</script>"));
					goto setErr_qos;
				}

				strPortTmp = strdup(strScMac);
				for (i=0;i<8; i++)	{
					if ((ptr1 = strchr(strScMac, ',')) != NULL) {
						*ptr1 = '\0';
						ptr1 ++;
					}

					if (strlen(strScMac)!=12 || !string_to_hex(strScMac, tmpBuf, 12)) {
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrMacInv))</script>"));
						goto setErr_qos;
					}
					memcpy(entry.sourMac[i], tmpBuf, 6);
//			printf("\nGGG3=%02x:%02x:%02x:%02x:%02x:%02x\n",entry.sourMac[i][0],entry.sourMac[i][1],entry.sourMac[i][2],entry.sourMac[i][3],entry.sourMac[i][4],entry.sourMac[i][5]);
					if( ptr1 == NULL)
						break;
					strScMac = ptr1;
				}
				free(strPortTmp);
			}
//*********************************** destination address ***********************************
//			if (!strDtStIp[0])		//set start ip of destination address of QoS
//				strDtStIp = "0.0.0.0";
			//inet_aton(strDtStIp, (struct in_addr *)&entry.destStIp);
			fixed_inet_aton(strDtStIp,entry.destStIp);
			v1 = *((unsigned long *)entry.destStIp);

//			if (!strDtEdIp[0])		//set end ip of destination address of QoS
			if (!strcmp(strDtEdIp,"0.0.0.0"))		//set end ip of destination address of QoS
				strDtEdIp = strDtStIp;
			//inet_aton(strDtEdIp, (struct in_addr *)&entry.destEdIp);
			fixed_inet_aton(strDtEdIp,entry.destEdIp);
			v4 = *((unsigned long *)entry.destEdIp);
;
			if ( v4 < v1 ) {
				strcpy(tmpBuf, T("<script>document.write(showText(aspformQoSInvIpDest))</script>"));
				goto setErr_qos;
			}
//*********************************** source port ***********************************
			if ( strTfType[0] == '0' )	//set traffic type of QoS
				entry.trafType = 0;
			else if ( strTfType[0] == '1' )
				entry.trafType = 1;
			else if ( strTfType[0] == '2' )
				entry.trafType = 2;
			else if ( strTfType[0] == '3' )
				entry.trafType = 3;
			else if ( strTfType[0] == '4' )
				entry.trafType = 4;

			if ( strProtl[0] == '0' )	//set protocol of QoS
				entry.protl = 0;
			else
				entry.protl = 1;
			strPortTmp = strdup(strScPort);
			for (i=0;i<5; i++)	{
				if ((ptr1 = strchr(strPortTmp, ',')) != NULL) {
					*ptr1 = '\0';
					ptr1 ++;
				}

				if ((ptr2 = strchr(strPortTmp, '-')) != NULL) {
					*ptr2 = '\0';
					ptr2 ++;

					if ((!(entry.sourPort[i][0] = atoi(strPortTmp))) ||
					   	(entry.sourPort[i][0] < 1) || (entry.sourPort[i][0] >65536)) {
						strcpy(tmpBuf, T("<script>document.write(showText(aspformQoSErrPortSrcFr))</script>"));
						goto setErr_qos;
					}
					if ((!(entry.sourPort[i][1]=atoi(ptr2))) ||
					   	(entry.sourPort[i][1] < 1) || (entry.sourPort[i][1] >65536))  {
						strcpy(tmpBuf, T("<script>document.write(showText(aspformQoSErrPortSrcTo))</script>"));
						goto setErr_qos;
					}
					if (entry.sourPort[i][1] < entry.sourPort[i][0]) {
						strcpy(tmpBuf, T("<script>document.write(showText(aspformQoSErrPortSrcOrd))</script>"));
						goto setErr_qos;
					}
				}
				else
					entry.sourPort[i][0]=entry.sourPort[i][1]=atol(strPortTmp);
					//fix by kyle port start can't be 0 or 1
					if(entry.sourPort[i][0]==1 || entry.sourPort[i][0]==0 ){
						entry.sourPort[i][0]=2;
					}
					if(entry.sourPort[i][1]==1 || entry.sourPort[i][1]==0){
							entry.sourPort[i][1]=2;
					}

					if( ptr1 == NULL)
					break;
				strPortTmp = ptr1;
			}
			free(strPortTmp);
//*********************************** destination port ***********************************
			strPortTmp = strdup(strDtPort);
			for (i=0;i<5; i++)	{
				if ((ptr1 = strchr(strPortTmp, ',')) != NULL) {
					*ptr1 = '\0';
					ptr1 ++;
				}

				if ((ptr2 = strchr(strPortTmp, '-')) != NULL) {
					*ptr2 = '\0';
					ptr2 ++;




					if ((!(entry.destPort[i][0] = atoi(strPortTmp))) ||
						   	(entry.destPort[i][0] < 2) || (entry.destPort[i][0] >65535)) {
						if(entry.destPort[i][0] < 2){
							entry.destPort[i][0]=2;
						}else{
							strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrPortDstFr))</script>"));
							goto setErr_qos;
						}
					}
					if ((!(entry.destPort[i][1]=atoi(ptr2))) ||
						   	(entry.destPort[i][1] < 2) || (entry.destPort[i][1] >65535))  {
						if(entry.destPort[i][1] < 2){
							entry.destPort[i][1]=2;
						}else{
							strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrPortDstTo))</script>"));
							goto setErr_qos;
						}
					}

					if (entry.destPort[i][1] < entry.destPort[i][0]) {
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrPortDstOrd))</script>"));
						goto setErr_qos;
					}
				}
				else
					entry.destPort[i][0]=entry.destPort[i][1]=atol(strPortTmp);
					//fix by kyle port start can't be 0 or 1
					if(entry.destPort[i][0]==1 || entry.destPort[i][0]==0)
						entry.destPort[i][0]=2;
					if(entry.destPort[i][1] == 1 || entry.destPort[i][1] == 0)
						entry.destPort[i][1]=2;

					if( ptr1 == NULL)
					break;
				strPortTmp = ptr1;
			}
			free(strPortTmp);
//************************************************************************
			if ( !apmib_get( num_id, (void *)&entryNum)) {		//MIB_QOS_NUM
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrGetNum))</script>"));
				goto setErr_qos;
			}

if ( !strEditQos[0] ) {
			if ( (entryNum + 1) > MAX_QOS_NUM) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSInvAddEntry))</script>"));
				goto setErr_qos;
			}
}
			if ( strAddQos[0] ) {

			//	printf("\n\n********add*********\n: \n bwidthVal=%d \n bwidthType=%s \n downVal=%d \n downType=%s \n sourType=%s \n sourStIp=%s \n sourEdIp=%s \n destStIp=%s \n destEdIp=%s \n trafType=%d \n diffSevType=%d \n protl=%s \n ruleName=%s",entry.bwidthVal,entry.bwidthType,entry.downVal,entry.downType,entry.sourType,fixed_inet_ntoa(entry.sourStIp),fixed_inet_ntoa(entry.sourEdIp),fixed_inet_ntoa(entry.destStIp),fixed_inet_ntoa(entry.destEdIp),entry.trafType,entry.diffSevType,entry.protl,entry.ruleName);

				// set to MIB. try to delete it first to avoid duplicate case
				apmib_set( del_id, (void *)&entry);			//MIB_QOS_DEL
				if ( apmib_set(add_id, (void *)&entry) == 0) {	//MIB_QOS_ADD
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrAddEntry))</script>"));
					goto setErr_qos;
				}
			}
			if ( strEditQos[0] ) {
				intVal = atoi(strConfigNum);
				*(( char *)&orgEntry) = (char)intVal;

				if ( !apmib_get( qos_id, (void *)&orgEntry)) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrGetTbl))</script>"));
					goto setErr_qos;
				}
				Edit.selEntry = (char *)&orgEntry;
				Edit.editEntry = (char *)&entry;
				//printf("\n******orgEntry*****: \n bwidthVal=%d \n bwidthType=%s \n downVal=%d \n downType=%s \n sourType=%s \n sourStIp=%s \n sourEdIp=%s \n destStIp=%s \n destEdIp=%s \n trafType=%d \n diffSevType=%d \n protl=%s \n ruleName=%s",orgEntry.bwidthVal,orgEntry.bwidthType,orgEntry.downVal,orgEntry.downType,orgEntry.sourType,fixed_inet_ntoa(orgEntry.sourStIp),fixed_inet_ntoa(orgEntry.sourEdIp),fixed_inet_ntoa(orgEntry.destStIp),fixed_inet_ntoa(orgEntry.destEdIp),orgEntry.trafType,orgEntry.diffSevType,orgEntry.protl,orgEntry.ruleName);
				//printf("\n\n********after edit*********\n: \n bwidthVal=%d \n bwidthType=%s \n downVal=%d \n downType=%s \n sourType=%s \n sourStIp=%s \n sourEdIp=%s \n destStIp=%s \n destEdIp=%s \n trafType=%d \n diffSevType=%d \n protl=%s \n ruleName=%s",entry.bwidthVal,entry.bwidthType,entry.downVal,entry.downType,entry.sourType,fixed_inet_ntoa(entry.sourStIp),fixed_inet_ntoa(entry.sourEdIp),fixed_inet_ntoa(entry.destStIp),fixed_inet_ntoa(entry.destEdIp),entry.trafType,entry.diffSevType,entry.protl,entry.ruleName);


				// set to MIB. try to delete it first to avoid duplicate case
//				apmib_set( del_id, (void *)&entry);	//MIB_QOS_DEL
				if ( !apmib_set( edit_id, (void *)&Edit)) {	//MIB_QOS_EDIT
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrEditTbl))</script>"));
					goto setErr_qos;
				}
			}
		}
	}

	strDelQos = websGetVar(wp, T("delSelQos"), T(""));
	strDelAllQos = websGetVar(wp, T("delAllQos"), T(""));
	strMvUp = websGetVar(wp, T("moveUpQos"), T(""));
	strMvDown = websGetVar(wp, T("moveDownQos"), T(""));
	strShowQos = websGetVar(wp, T("showQos"), T(""));

	/* config entry */
	if ( strMvUp[0] || strMvDown[0] || strDelQos[0] || strShowQos[0]) {
		if (strConfigWan[0] == '1') {
			num_id = MIB_WAN1_QOS_NUM;
			qos_id = MIB_WAN1_QOS;
		}
		if ( strMvUp[0] ) {			//move up entry
			if (strConfigWan[0] == '1')
				config_id = MIB_WAN1_QOS_UP;
	}
		else if ( strMvDown[0] ) {	//move down entry
			if (strConfigWan[0] == '1')
				config_id = MIB_WAN1_QOS_DOWN;
	}
		else if ( strDelQos[0] ) {	//del entry
			if (strConfigWan[0] == '1')
				config_id = MIB_WAN1_QOS_DEL;
		}

		if ( !apmib_get( num_id, (void *)&entryNum)) {	//MIB_OQS_NUM
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrGetNum))</script>"));
			goto setErr_qos;
		}
		for (i=entryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "select%d", i);

			strVal = websGetVar(wp, tmpBuf, T(""));
			if ( !gstrcmp(strVal, T("ON")) ) {

				if ( strShowQos[0] ) {
					selectNum = i;	//set select entry number
					selectWan = atoi(strConfigWan);
					*((char *)&entry) = (char)i;
					if ( !apmib_get( qos_id, (void *)&entry)) {	//MIB_QOS
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrGetTbl))</script>"));
						goto setErr_qos;
					}
					if ( entry.sourType == 2) {	// void other deleted
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSOther))</script>"));
						goto setErr_qos;
					}
				}
				else {
					*((char *)&entry) = (char)i;
					if ( !apmib_get( qos_id, (void *)&entry)) {	//MIB_QOS
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrGetTbl))</script>"));
						goto setErr_qos;
					}
					if ( strDelQos[0] ) {
						if ( entry.sourType == 2) {	// void other deleted
							strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSOtherD))</script>"));
							goto setErr_qos;
						}
					}
					if ( !apmib_set( config_id, (void *)&entry)) {	//Move Up, Move Down, Del
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrCfgTbl))</script>"));
						goto setErr_qos;
					}
				}
			}
		}
	}
	/* Delete all entry */
	if ( strDelAllQos[0]) {
		if (strConfigWan[0] == '1')
			delall_id = MIB_WAN1_QOS_DELALL;
		if ( !apmib_set(delall_id, (void *)&entry)) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrDelAll))</script>"));
			goto setErr_qos;
		}
		//initQos();  // Tommy
	}

// For Guarantee QoS

	strMaxDown = websGetVar(wp, T("maxdown"), T(""));

	if (strMaxDown[0]) {
		string_to_dec(strMaxDown, &intVal);
		if ( apmib_set(MIB_MAX_DOWNLOAD_BANDWIDTH, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("Set Max Download Bandwidth failed!"));
			goto setErr_qos;
		}
	}


	strMaxUp = websGetVar(wp, T("maxup"), T(""));
	if (strMaxUp[0]) {
		string_to_dec(strMaxUp, &intVal);
		if ( apmib_set(MIB_MAX_UPLOAD_BANDWIDTH, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("Set Max Upload Bandwidth failed!"));
			goto setErr_qos;
		}
	}

// End For Guarantee QoS

setOk_qos:

	Changed = 1;
	newpage = 0;

#ifndef NO_ACTION
//	if (!strShowQos[0])
//		system("/bin/firewall.sh");
	//if ( strApplyQos[0] ) {
		//First = 1;
		//Changed = 0;
//		need_reboot = 1;
		apmib_update(CURRENT_SETTING);
		//snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG);
		//system(tmpBuf);		//modified by Erwin
	//}

#endif

	submitUrl = websGetVar(wp, T("submitUrl"), T(""));   // hidden page

	strApply = websGetVar(wp, T("isApply"), T(""));   // Tommy
	// Tommy Modified on 0602
	if (strApply[0]) {

#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif
		

	OK_MSG(submitUrl);

		//OK_MSG(submitUrl);
	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}

	return;

setErr_qos:
	ERR_MSG(tmpBuf);
  	return;
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
#ifdef _QoS_MODE_SELECT_
void formConQoS(webs_t wp, char_t *path, char_t *query)
{
	char_t *strAddQos, *strDelQos, *strDelAllQos, *strConfigNum;
	char_t *strMvUp, *strMvDown, *strEditQos, *strShowQos, *strConfigWan;
	char_t *strName, *strBWVal, *strBWType, *strDUType, *strDownVal, *strDownType;
	char_t *submitUrl, *strVal, *QoSname, *QoSbwsize, *QoSconnect, *strApply,*QoSconip;
	char_t *strModeState, *QoStype, *strDelAll;
	char tmpBuf[100];
	char *ptr1, *ptr2;
	int conentryNum, i, selNum, andNum, intVal;
	int num_id, qos_id, add_id, edit_id, config_id, del_id, delall_id, send_id, enable_id;
	struct in_addr curIpAddr,entIpAddr ,curSubnet;
	unsigned long v1, v2, v3, v4;
	QOSCON_T conentry, conorgEntry;
	EDIT_T Edit;

	strAddQos = websGetVar(wp, T("addQos"), T(""));
	strEditQos = websGetVar(wp, T("editQos"), T(""));
	strMvUp = websGetVar(wp, T("moveUpQos"), T(""));
	strMvDown = websGetVar(wp, T("moveDownQos"), T(""));
	strDelQos = websGetVar(wp, T("delSelQos"), T(""));
	strDelAllQos = websGetVar(wp, T("delAllQos"), T(""));
	strShowQos = websGetVar(wp, T("showQos"), T(""));


	memset(&conentry, '\0', sizeof(conentry));

	QoStype = websGetVar(wp, T("qosmod"), T(""));
	if (QoStype[0]) {
		string_to_dec(QoStype, &intVal);
		apmib_set(MIB_QoS_QOSTYPE, (void *)&intVal);
	}

	if(strAddQos[0] || strEditQos[0])
	{
			num_id = 0;
			num_id = MIB_WANCON_QOS_NUM;
			qos_id = MIB_WANCON_QOS;
			add_id = MIB_WANCON_QOS_ADD;
			edit_id = MIB_WANCON_QOS_EDIT;
			del_id = MIB_WANCON_QOS_DEL;


			QoSname = websGetVar(wp, T("connectName"), T(""));
			QoSbwsize = websGetVar(wp, T("ptpbw"), T(""));
			QoSconnect = websGetVar(wp, T("consize"), T(""));
			QoSconip = websGetVar(wp, T("conip"), T(""));

			if ( QoSname[0] ) {	//set connection rule name.
				if (strlen(QoSname) > COMMENT_LEN-1) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrLong))</script>"));
					goto setErr_qos;
				}
			strcpy(conentry.connectName, QoSname);
			}

			if ( QoSbwsize[0] ) {
				string_to_dec(QoSbwsize, &intVal);
				conentry.ptpbw = intVal;
			}

			if ( QoSconnect[0] ) {
				string_to_dec(QoSconnect, &intVal);
				conentry.consize = intVal;
			}

			if ( QoSconip[0] ) {	//set connection IP.
				strcpy(conentry.connectIP, QoSconip);
			}
	//************************************************************************
			if ( !apmib_get( num_id, (void *)&conentryNum)) {		//MIB_CONQOS_NUM
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrGetNum))</script>"));
				goto setErr_qos;
			}

			if ( !strEditQos[0] ) {
				if ( (conentryNum + 1) > MAX_QOSCON_NUM) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSInvAddEntry))</script>"));
					goto setErr_qos;
				}
			}

			if ( strAddQos[0] ) {
				apmib_set( del_id, (void *)&conentry);			//MIB_CONQOS_DEL
				if ( apmib_set(add_id, (void *)&conentry) == 0) {	//MIB_CONQOS_ADD
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrAddEntry))</script>"));
					goto setErr_qos;
				}
			}

			if ( strEditQos[0] )
			{
				strConfigNum = websGetVar(wp, T("configNum"), T(""));

				intVal = atoi(strConfigNum);
				*(( char *)&conorgEntry) = (char)intVal;
				if ( !apmib_get( qos_id, (void *)&conorgEntry)) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrGetTbl))</script>"));
					goto setErr_qos;
				}
				Edit.selEntry = (char *)&conorgEntry;
				Edit.editEntry = (char *)&conentry;
				if ( !apmib_set( edit_id, (void *)&Edit)) {	//MIB_QOS_EDIT
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrEditTbl))</script>"));
					goto setErr_qos;
				}
			}
		//}
	}

	/* config entry */
	if ( strMvUp[0] || strMvDown[0] || strDelQos[0] || strShowQos[0]) {
		num_id = MIB_WANCON_QOS_NUM;
		qos_id = MIB_WANCON_QOS;
		if ( strMvUp[0] ) {			//move up entry
			config_id = MIB_WANCON_QOS_UP;
		}
		else if ( strMvDown[0] ) {	//move down entry
			config_id = MIB_WANCON_QOS_DOWN;
		}
		else if ( strDelQos[0] ) {	//del entry
			config_id = MIB_WANCON_QOS_DEL;
		}

		if ( !apmib_get( num_id, (void *)&conentryNum)) {	//MIB_OQS_NUM
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrGetNum))</script>"));
			goto setErr_qos;
		}
		for (i=conentryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "select%d", i);

			strVal = websGetVar(wp, tmpBuf, T(""));
			if ( !gstrcmp(strVal, T("ON")) )
			{

				if ( strShowQos[0] )
				{
					selectNum = i;	//set select entry number
					*((char *)&conentry) = (char)i;
					if ( !apmib_get( qos_id, (void *)&conentry)) {	//MIB_QOS
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrGetTbl))</script>"));
						goto setErr_qos;
					}

				}
				else
				{
					*((char *)&conentry) = (char)i;
					if ( !apmib_get( qos_id, (void *)&conentry)) {	//MIB_QOS
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrGetTbl))</script>"));
						goto setErr_qos;
					}

					if ( !apmib_set( config_id, (void *)&conentry)) {	//Move Up, Move Down, Del
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrCfgTbl))</script>"));
						goto setErr_qos;
					}
				}
			}
		}
	}
	/* Delete all entry */
	if ( strDelAllQos[0]) {
		delall_id = MIB_WANCON_QOS_DELALL;
		if ( !apmib_set(delall_id, (void *)&conentry)) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformQoSErrDelAll))</script>"));
			goto setErr_qos;
		}
	}
	setOk_qos:

		Changed = 1;
		newpage = 0;


		apmib_update(CURRENT_SETTING);


		submitUrl = websGetVar(wp, T("submitUrl"), T(""));

			strApply = websGetVar(wp, T("isApply"), T(""));
			if (strApply[0]) {

		#ifdef _TAG_IN_PAGE_
		main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
		sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
		#endif

				OK_MSG(submitUrl);
			}
			else {
				if (submitUrl[0])
					websRedirect(wp, submitUrl);
				else
					websDone(wp, 200);
			}

			return;

		setErr_qos:
			ERR_MSG(tmpBuf);
		  	return;
}


int QosConList(int eid, webs_t wp, int argc, char_t **argv)
{

	int	nBytesSent=0, entryNum=0, i=0;
	QOSCON_T entry;

	if ( !apmib_get(MIB_WANCON_QOS_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}


	for (i=1; i<=entryNum ; i++) {
		*((char *)&entry) = (char)i;

		if ( !apmib_get(MIB_WANCON_QOS, (void *)&entry))
			return -1;

		nBytesSent += websWrite(wp, T("<tr align=\"center\" class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("  <td>%d</td>\n"),i);

		nBytesSent += websWrite(wp, T("  <td>%s</td>\n"),entry.connectName);
			nBytesSent += websWrite(wp, T("  <td>%d</td>\n"),entry.ptpbw);
			nBytesSent += websWrite(wp, T("  <td>%d</td>\n"),entry.consize);
			nBytesSent += websWrite(wp, T("  <td><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td>"),i);
		nBytesSent += websWrite(wp, T("</tr>\n"));


	}
	return nBytesSent;
}

int ConQosShow(int eid, webs_t wp, int argc, char_t **argv)
{
	char  temp[COMMENT_LEN * 2 + 3];
	int	nBytesSent=0, i, qos_id=0, j;
	QOSCON_T entry;
	memset(&entry,   '\0', sizeof(entry)); //initialize



	*((char *)&entry) = (char)selectNum;

	if ( !apmib_get(MIB_WANCON_QOS, (void *)&entry))
	{
		//nBytesSent += websWrite(wp, T("var qosShow = new Array('','','','');"));
		nBytesSent += websWrite(wp, T("var qosShow = new Array('','','','','');"));
	}
	else
	{
		j=0;
		for(i=0;i<COMMENT_LEN;i++)
		{
			if( entry.connectName[i] == '\'' || entry.connectName[i] == '\\')
			{
				temp[j]='\\';
				temp[j+1]=entry.connectName[i];
				j=j+2;
			}
			else
			{
				temp[j]=entry.connectName[i];
				j=j+1;
			}
		}

		nBytesSent += websWrite(wp, T("var qosShow = new Array('%d','%s','%d','%d','%s');"),selectNum,entry.connectName, entry.ptpbw,entry.consize,entry.connectIP);
	}
	selectNum = -1;

	return nBytesSent;
}
#endif
/////////////////////////////////////////////////////////////////////////////////
int QosShow(int eid, webs_t wp, int argc, char_t **argv)
{
	char *strScStIp, *strScEdIp, *strDtStIp, *strDtEdIp;
	char buf[20], macTmp[150], scPtTmp[60], dtPtTmp[60], temp[COMMENT_LEN * 2 + 3];
	int	nBytesSent=0, i, qos_id=0, j;
	QOS_T entry;
	memset(&entry,   '\0', sizeof(entry));
	memset(&macTmp,  '\0', sizeof(macTmp));
	memset(&scPtTmp, '\0', sizeof(scPtTmp));
	memset(&dtPtTmp, '\0', sizeof(dtPtTmp));

	if (selectWan == 1) qos_id = MIB_WAN1_QOS;

	*((char *)&entry) = (char)selectNum;

	if ( !apmib_get( qos_id, (void *)&entry))
	{
		nBytesSent += websWrite(wp, T("var qosShow = new Array('','','','','','','','','','','','','','','','','');"));
	}
	else
	{
		strScStIp = strdup( fixed_inet_ntoa(entry.sourStIp));
		strScEdIp = strdup( fixed_inet_ntoa(entry.sourEdIp));
		strDtStIp = strdup( fixed_inet_ntoa(entry.destStIp));
		strDtEdIp = strdup( fixed_inet_ntoa(entry.destEdIp));

		if (!strcmp(strScStIp,"0.0.0.0"))	strScStIp = strScEdIp = "";
		if (!strcmp(strScStIp,strScEdIp))	strScEdIp = "";

		if (!strcmp(strDtStIp,"0.0.0.0"))	strDtStIp = strDtEdIp = "";
		if (!strcmp(strDtStIp,strDtEdIp))	strDtEdIp = "";

		for(i=0; i<=7; i++)
		{
			sprintf(buf, "%02x%02x%02x%02x%02x%02x",
				entry.sourMac[i][0], entry.sourMac[i][1], entry.sourMac[i][2],
			   entry.sourMac[i][3], entry.sourMac[i][4], entry.sourMac[i][5]);

			if (strcmp(buf, "000000000000"))
			{
				if (i != 0) strcat(macTmp, ",");
				strcat(macTmp, buf);
			}
		}
		for (i=0; i<=4; i++)
		{
			if (entry.sourPort[i][0] == entry.sourPort[i][1]) sprintf(buf, "%d", entry.sourPort[i][0]);
			else                                              sprintf(buf, "%d-%d", entry.sourPort[i][0], entry.sourPort[i][1]);

			if (strcmp(buf, "0-0") && strcmp(buf, "0"))
			{
				if ( i != 0) strcat(scPtTmp, ",");
				strcat(scPtTmp, buf);
			}

			if (entry.destPort[i][0] == entry.destPort[i][1]) sprintf(buf, "%d", entry.destPort[i][0]);
			else                                              sprintf(buf, "%d-%d", entry.destPort[i][0], entry.destPort[i][1]);

			if (strcmp(buf, "0-0") && strcmp(buf, "0"))
			{
				if ( i != 0) strcat(dtPtTmp, ",");
				strcat(dtPtTmp, buf);
			}
		}

		j=0;
		for(i=0;i<COMMENT_LEN;i++)
		{
			if( entry.ruleName[i] == '\'' || entry.ruleName[i] == '\\')
			{
				temp[j]='\\';
				temp[j+1]=entry.ruleName[i];
				j=j+2;
			}
			else
			{
				temp[j]=entry.ruleName[i];
				j=j+1;
			}
		}

		nBytesSent += websWrite(wp, T("var qosShow = new Array('%s','%lu','%d','%d','%s','%s','%s','%s','%s','%d','%d','%s','%s','%d','%d','%lu','%d');"),
			/*entry.ruleName*/temp, entry.bwidthVal, entry.bwidthType,
			entry.sourType, strScStIp, strScEdIp, macTmp, strDtStIp, strDtEdIp,
		   entry.trafType, entry.protl, scPtTmp, dtPtTmp, selectWan, selectNum, entry.downVal, entry.downType);
	}
	selectNum = -1;
	selectWan = -1;
	return nBytesSent;
}

/////////////////////////////////////////////////////////////////////////////
int Wan1QosList(int eid, webs_t wp, int argc, char_t **argv)
{

	int	nBytesSent=0, entryNum=0, i=0;
	QOS_T entry;

	if ( !apmib_get(MIB_WAN1_QOS_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}


	for (i=1; i<=entryNum ; i++) {
		*((char *)&entry) = (char)i;

		if ( !apmib_get(MIB_WAN1_QOS, (void *)&entry))
			return -1;

		nBytesSent += websWrite(wp, T("<tr align=\"center\" class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("  <td>%d</td>\n"),i);

		if ( entry.sourType == 2 )
		{
			nBytesSent += websWrite(wp, T("  <td><font color=\"red\">%s</font></td>\n"),entry.ruleName);
			nBytesSent += websWrite(wp, T("  <td><font color=\"red\"><script>dw(RemainedBandwidth)</script></font></td>\n"));
			nBytesSent += websWrite(wp, T("  <td><font color=\"red\"><script>dw(RemainedBandwidth)</script></font></td>\n"));
		}
		else
		{
			nBytesSent += websWrite(wp, T("  <td>%s</td>\n"),entry.ruleName);
			nBytesSent += websWrite(wp, T("  <td>%d</td>\n"),entry.bwidthVal);
			nBytesSent += websWrite(wp, T("  <td>%d</td>\n"),entry.downVal);
		}
			nBytesSent += websWrite(wp, T("  <td><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td>"),i);
		nBytesSent += websWrite(wp, T("</tr>\n"));


	}
	return nBytesSent;
}

/////////////////////////////////////////////////////////////////////////////
int EZQosList(int eid, webs_t wp, int argc, char_t **argv)
{

	int	nBytesSent=0, entryNum=0, i=0;
	#ifdef _EZ_QOS_
	EZQOS_T entry;

	if ( !apmib_get(MIB_EZ_QOS_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}
	
	for (i=1; i<=entryNum ; i++) {
		*((char *)&entry) = (char)i;

		if ( !apmib_get(MIB_EZ_QOS, (void *)&entry))
			return -1;

		nBytesSent += websWrite(wp, T("<td id=\"EZQOS_TD_%d\" class=\"without_pic_ezqos\" onClick=\"mouseclick_item(this)\"><img title=\"%s\" style=\"cursor:pointer;\" src=\"/file/%s.gif\" height=\"100%%\" width=\"100%%\"></td>"), i, entry.ruleName, entry.ruleName);
	}
#endif
	return nBytesSent;
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
void formApplyReboot(webs_t wp, char_t *path, char_t *query)
{

	system("/bin/reboot.sh");
	return;
}

/////////////////////////////////////////////////////////////////////////////
void formVirtualSv(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl, *strAddPort, *strDelPort, *strVal, *strDelAllPort;
#if defined(_Customer_) | defined(_MPPPOE_)
	char_t *strIp, *strFrom, *strTo, *strComment, *strApply, *strInterface; //alex 2007/02/12
#else
	char_t *strIp, *strFrom, *strTo, *strComment, *strApply;
#endif
	char tmpBuf[100];
	int entryNum, intVal, i;
	PORTFW_T entry;
	struct in_addr curIpAddr, entIpAddr,curSubnet;
	unsigned long v1, v2, v3;

	strAddPort = websGetVar(wp, T("addPortFw"), T(""));
	strDelPort = websGetVar(wp, T("deleteSelPortFw"), T(""));
	strDelAllPort = websGetVar(wp, T("deleteAllPortFw"), T(""));

	strApply = websGetVar(wp, T("isApply"), T(""));   // Tommy
	memset(&entry, '\0', sizeof(entry));
	if (!strApply[0]) {
		strVal = websGetVar(wp, T("enabled"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			intVal = 1;
		else
			intVal = 0;
		if ( apmib_set( MIB_VSER_ENABLED, (void *)&intVal) == 0) {//MIB_PORTFW_ENABLED
			strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrFlag))</script>"));  //设置?�许?��?失败
			goto setErr_portfw;
		}
	}

	/* Add new port-forwarding table */
	if (strAddPort[0]) {
		strIp = websGetVar(wp, T("ip"), T(""));
		strFrom = websGetVar(wp, T("fromPort"), T(""));
		strTo = websGetVar(wp, T("toPort"), T(""));
#if defined(_Customer_) | defined(_MPPPOE_)
		strInterface = websGetVar(wp, T("interface"), T("")); // alex 2007/02/12
#endif
		strComment = websGetVar(wp, T("comment"), T(""));

		if (!strIp[0] && !strFrom[0] && !strTo[0] && !strComment[0])
			goto setOk_portfw;

		if (!strIp[0]) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrIpNo))</script>"));  //ip?��?为空�?			goto setErr_portfw;
		}
		/*
		fixed_inet_aton(strIp, entry.ipAddr);
		getInAddr(BRIDGE_IF, IP_ADDR, (void *)&curIpAddr);
		getInAddr(BRIDGE_IF, SUBNET_MASK, (void *)&curSubnet);
		v1 = *((unsigned long *)entry.ipAddr);
		v2 = *((unsigned long *)&curIpAddr);
		v3 = *((unsigned long *)&curSubnet);
		*/
		//alex
   inet_aton(strIp, &entIpAddr);

   fixed_inet_aton(strIp,entry.ipAddr);

   getInAddr(BRIDGE_IF, IP_ADDR, (void *)&curIpAddr);

   getInAddr(BRIDGE_IF, SUBNET_MASK, (void *)&curSubnet);
   v1 = ((unsigned long)entIpAddr.s_addr);
 		v2 = ((unsigned long)curIpAddr.s_addr);
		v3 = ((unsigned long)curSubnet.s_addr);
		//alex

#ifdef __TARGET_BOARD__
		if ( (v1 & v3) != (v2 & v3) ) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvInvIp))</script>"));  //IP不在当�?子�???			goto setErr_portfw;
		}
#endif
		if ( !strFrom[0] ) { // if port-forwarding, from port must exist
			strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrNoPrivate))</script>"));  //?��??�端??�?			goto setErr_portfw;
		}
		if ( !string_to_dec(strFrom, &intVal) || intVal<1 || intVal>65535) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvInvValuePrivate))</script>"));  //私�?端口?��???			goto setErr_portfw;
		}
		entry.fromPort = (unsigned short)intVal;

		if ( !strTo[0] )
			entry.toPort = entry.fromPort;
		else {
			if ( !string_to_dec(strTo, &intVal) || intVal<1 || intVal>65535) {
				strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvInvValuePublic))</script>"));  //?�共端口?��???				goto setErr_portfw;
			}
		}
		entry.toPort = (unsigned short)intVal;

/*		if ( entry.fromPort  > entry.toPort ) {
			strcpy(tmpBuf, T("Error! Invalid port range."));
			goto setErr_portfw;
		}
*/
		strVal = websGetVar(wp, T("protocol"), T(""));
		if (strVal[0]) {

			#ifdef _zio_

			if ( strVal[0] == '0' || strVal[0] == '8' || strVal[0] == 'A' || strVal[0] == 'C')
				entry.protoType = PROTO_BOTH;
			else if ( strVal[0] == '1' || strVal[0] == '3' || strVal[0] == '4' || strVal[0] == '5' || strVal[0] == '6' || strVal[0] == '7' || strVal[0] == '9' || strVal[0] == 'B' || strVal[0] == 'D' )
				entry.protoType = PROTO_TCP;
			else if ( strVal[0] == '2' )
				entry.protoType = PROTO_UDP;

			#else

			if ( strVal[0] == '0' )
				entry.protoType = PROTO_BOTH;
			else if ( strVal[0] == '1' )
				entry.protoType = PROTO_TCP;
			else if ( strVal[0] == '2' )
				entry.protoType = PROTO_UDP;

			#endif
			else {
				#ifdef _Customer_
					strcpy(tmpBuf, T("Error! Invalid protocol type."));
				#else
					strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvInvPtcType))</script>"));  //?��??�议类�?
				#endif
				goto setErr_portfw;
			}
		}
		else {
			strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrPtcTypeEmpty))</script>"));  //goto setErr_portfw;
		}

#ifdef _zio_
		switch(strVal[0])
		{
			case '3':
				entry.fromPort = (unsigned short)80;
				entry.toPort   = (unsigned short)80;
				break;
			case '4':
				entry.fromPort = (unsigned short)443;
				entry.toPort   = (unsigned short)443;
				break;
			case '5':
				entry.fromPort = (unsigned short)21;
				entry.toPort   = (unsigned short)21;
				break;
			case '6':
				entry.fromPort = (unsigned short)110;
				entry.toPort   = (unsigned short)110;
				break;
			case '7':
				entry.fromPort = (unsigned short)25;
				entry.toPort   = (unsigned short)25;
				break;
			case '8':
				entry.fromPort = (unsigned short)53;
				entry.toPort   = (unsigned short)53;
				break;
			case '9':
				entry.fromPort = (unsigned short)23;
				entry.toPort   = (unsigned short)23;
				break;
			case 'A':
				entry.fromPort = (unsigned short)500;
				entry.toPort   = (unsigned short)500;
				break;
			case 'B':
				entry.fromPort = (unsigned short)1723;
				entry.toPort   = (unsigned short)1723;
				break;
			case 'C':
				entry.fromPort = (unsigned short)9292;
				entry.toPort   = (unsigned short)9292;
				break;
			case 'D':
				entry.fromPort = (unsigned short)1720;
				entry.toPort   = (unsigned short)1720;
				break;
			default:
				break;
		}
#endif


#if defined(_Customer_) | defined(_MPPPOE_)
		strVal = websGetVar(wp, T("interface"), T("")); // alex 2007/02/12
		if (strVal[0]) {
			if ( strVal[0] == '0' )
				entry.interface = 0;
			else if ( strVal[0] == '1' )
				entry.interface = 1;
			else {
				entry.interface = 0;
			}
		}
		else {
			entry.interface = 0;
		}
#endif
		if ( strComment[0] ) {
			if (strlen(strComment) > COMMENT_LEN-1) {
				strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrCmtLong))</script>"));  //注�?太长
				goto setErr_portfw;
			}
			strcpy(entry.comment, CharFilter3(strComment));
		}
		if ( !apmib_get(MIB_VSER_NUM, (void *)&entryNum)) {//MIB_PORTFW_NUM
			strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrGetNum))</script>"));
			goto setErr_portfw;
		}

		if ( (entryNum + 1) > MAX_FILTER_NUM) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrFullAdd))</script>"));  //?��?进入?��??�误
			goto setErr_portfw;
		}

		// Check if there is any port overlapped
		for (i=1; i<=entryNum; i++) {
			PORTFW_T checkEntry;
			*((char *)&checkEntry) = (char)i;
			if ( !apmib_get(MIB_VSER, (void *)&checkEntry)) {//MIB_PORTFW
				strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrGetTbl))</script>"));  //?��?进入?��??�误
				goto setErr_portfw;
			}
#if defined(_Customer_) | defined(_MPPPOE_)
			if (entry.toPort == checkEntry.toPort && entry.interface == checkEntry.interface ) { //alex 2007/02/12
#else
			if (entry.toPort == checkEntry.toPort ) {
#endif
				strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrSetRange))</script>"));  //端口超�???				goto setErr_portfw;
			}
/*			if ( ( (entry.fromPort <= checkEntry.fromPort &&
					entry.toPort >= checkEntry.fromPort) ||
			       (entry.fromPort >= checkEntry.fromPort &&
				entry.fromPort <= checkEntry.toPort)
			     )&&
			       (entry.protoType & checkEntry.protoType) ) {
				strcpy(tmpBuf, T("Setting port range has overlapped with used port numbers!"));
				goto setErr_portfw;
			}
*/		}

		// set to MIB. try to delete it first to avoid duplicate case
		apmib_set(MIB_VSER_DEL, (void *)&entry);//MIB_PORTFW_DEL
		if ( apmib_set(MIB_VSER_ADD, (void *)&entry) == 0) {//MIB_PORTFW_ADD
			strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrAdd))</script>"));  //?�表?��??�号?��?�?			goto setErr_portfw;
		}
	}

	/* Delete entry */
	if (strDelPort[0]) {
		if ( !apmib_get(MIB_VSER_NUM, (void *)&entryNum)) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrGetNum))</script>"));  //?��?进入?��??�误
			goto setErr_portfw;
		}

		for (i=entryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "select%d", i);

			strVal = websGetVar(wp, tmpBuf, T(""));
			if ( !gstrcmp(strVal, T("ON")) ) {
				*((char *)&entry) = (char)i;
				if ( !apmib_get(MIB_VSER, (void *)&entry)) {
					strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrGetTbl))</script>"));  //?��?表格进入?��??�误
					goto setErr_portfw;
				}
				if ( !apmib_set(MIB_VSER_DEL, (void *)&entry)) {
					strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrDelEntry))</script>"));  //?�除表格?��?�?					goto setErr_portfw;
				}
			}
		}
	}

	/* Delete all entry */
	if ( strDelAllPort[0]) {
		if ( !apmib_set(MIB_VSER_DELALL, (void *)&entry)) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrDelAll))</script>"));  //?�除?�?�表?�出??			goto setErr_portfw;
		}
	}

setOk_portfw:
	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
/*	pid = fork();
        if (pid) {
	      	waitpid(pid, NULL, 0);
	}
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG);
		execl( tmpBuf, _FIREWALL_SCRIPT_PROG, NULL);
               	exit(1);
        }*/
	// system("/bin/firewall.sh"); // Tommy
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

	// Tommy Modified on 0602
	if (strApply[0]) {

	OK_MSG(submitUrl);

		//OK_MSG(submitUrl);
	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}

	return;

setErr_portfw:
	ERR_MSG(tmpBuf);
  	return;
}
/////////////////////////////////////////////////////////////////////////////
int virtualSvList(int eid, webs_t wp, int argc, char_t **argv)
{
	int	nBytesSent=0, entryNum, i;
	PORTFW_T entry;
	char	*type, *ip, portFrom[20], portTo[20];

	if ( !apmib_get(MIB_VSER_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}
	for (i=1; i<=entryNum; i++)
	{
		*((char *)&entry) = (char)i;
		if ( !apmib_get(MIB_VSER, (void *)&entry)) return -1;

		ip = fixed_inet_ntoa(entry.ipAddr);

		if ( !strcmp(ip, "0.0.0.0")) ip = "----";

		if ( entry.protoType == PROTO_BOTH )     type = "TCP+UDP";
		else if ( entry.protoType == PROTO_TCP ) type = "TCP";
		else                                     type = "UDP";

		snprintf(portFrom, 20, "%d", entry.fromPort);
		snprintf(portTo, 20, "%d", entry.toPort);
		
		#ifdef _Customer_
		nBytesSent += websWrite(wp, T("<tr>\n"));
		nBytesSent += websWrite(wp, T("  <td class=\"table2\" align=\"center\"><font size=\"2\">%d</td>\n"),i);
		nBytesSent += websWrite(wp, T("  <td class=\"table2\" align=\"center\">%s</td>\n"),ip);
		nBytesSent += websWrite(wp, T("  <td class=\"table2\" align=\"center\">%s</td>\n"),portFrom);
		nBytesSent += websWrite(wp, T("  <td class=\"table2\" align=\"center\">%s</td>\n"),type);
		nBytesSent += websWrite(wp, T("  <td class=\"table2\" align=\"center\">%s</td>\n"),portTo);
		nBytesSent += websWrite(wp, T("  <td class=\"table2\" align=\"center\">&nbsp;%s</td>\n"),CharFilter4(entry.comment));
		nBytesSent += websWrite(wp, T("  <td class=\"table2\" align=\"center\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td>\n"),i);
		#else
		nBytesSent += websWrite(wp, T("<tr align=\"center\" class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("  <td><font size=\"2\">%d</td>\n"),i);
		#ifdef _NETBIOSNAME_
				nBytesSent += websWrite(wp, T("  <td><script>document.write(searchComName(\"%s\",0))</script></td>\n"),ip);
		#endif
	
		nBytesSent += websWrite(wp, T("  <td>%s</td>\n"),ip);
		nBytesSent += websWrite(wp, T("  <td>%s</td>\n"),portFrom);
		nBytesSent += websWrite(wp, T("  <td>%s</td>\n"),type);
		nBytesSent += websWrite(wp, T("  <td>%s</td>\n"),portTo);

		#if !defined(_Buffalo_)
		nBytesSent += websWrite(wp, T("  <td>&nbsp;%s</td>\n"),CharFilter4(entry.comment));
		#endif
		nBytesSent += websWrite(wp, T("  <td><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td>\n"),i);
		#endif
		nBytesSent += websWrite(wp, T("</tr>\n"));
	}
	return nBytesSent;
}
/////////////////////////////////////////////////////////////////////////////
void formPortFw(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl, *strAddPort, *strDelPort, *strVal, *strDelAllPort;
#if defined(_Customer_) | defined(_MPPPOE_)
	char_t *strIp, *strFrom, *strTo, *strComment, *strApply, *strInterface; //alex 2007/02/12
#else
	char_t *strIp, *strFrom, *strTo, *strComment, *strApply;
#endif
	char tmpBuf[200];
	int entryNum, intVal, i;
	PORTFW_T entry;
	struct in_addr curIpAddr, curSubnet, entIpAddr;
	unsigned long v1, v2, v3;

	strAddPort = websGetVar(wp, T("addPortFw"), T(""));
	strDelPort = websGetVar(wp, T("deleteSelPortFw"), T(""));
	strDelAllPort = websGetVar(wp, T("deleteAllPortFw"), T(""));

	strApply = websGetVar(wp, T("isApply"), T(""));   // Tommy
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

	memset(&entry, '\0', sizeof(entry));
	if (!strApply[0]) {
		strVal = websGetVar(wp, T("enabled"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			intVal = 1;
		else
			intVal = 0;
		if ( apmib_set( MIB_PORTFW_ENABLED, (void *)&intVal) == 0) {
			strcpy(tmpBuf, T("<script type='text/javascript'>if(window.aspformPortFwErrFlag) document.write(showText(aspformPortFwErrFlag)); else document.write(\"Set enabled flag error!\");</script>"));
		
			goto setErr_portfw;
		}
	}

	/* Add new port-forwarding table */
	if (strAddPort[0])
	{
		strIp   = websGetVar(wp, T("ip"),       T(""));
		strFrom = websGetVar(wp, T("fromPort"), T(""));
		strTo   = websGetVar(wp, T("toPort"),   T(""));

		#if defined(_Customer_) | defined(_MPPPOE_)
		strInterface = websGetVar(wp, T("interface"), T("")); // alex 2007/02/12
		#endif

		strComment = websGetVar(wp, T("comment"), T(""));

		if (!strIp[0] && !strFrom[0] && !strTo[0] && !strComment[0])
			goto setOk_portfw;

		if (!strIp[0])
		{
  			strcpy(tmpBuf, T("<script type='text/javascript'>if(window.aspformPortFwErrNoIp) document.write(showText(aspformPortFwErrNoIp)); else document.write(showText(aspformFilterErrInput));</script>"));

			goto setErr_portfw;
		}

		//alex
		inet_aton(strIp, &entIpAddr);
		fixed_inet_aton(strIp,entry.ipAddr);
		getInAddr(BRIDGE_IF, IP_ADDR, (void *)&curIpAddr);
		getInAddr(BRIDGE_IF, SUBNET_MASK, (void *)&curSubnet);
		v1 = ((unsigned long)entIpAddr.s_addr);
 		v2 = ((unsigned long)curIpAddr.s_addr);
		v3 = ((unsigned long)curSubnet.s_addr);

		//alex
		#if !defined(_zio_) && defined(__TARGET_BOARD__)
		if ( (v1 & v3) != (v2 & v3) )
		{
          		strcpy(tmpBuf, T("<script type='text/javascript'>if(window.aspformPortFwInvIp) document.write(showText(aspformPortFwInvIp)); else  document.write(\"Invalid IP address! It should be set within the current subnet.\");</script>"));
			goto setErr_portfw;

		}
		#endif

		if ( !strFrom[0] ) { // if port-forwarding, from port must exist
		
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrPortForm))</script>"));
			goto setErr_portfw;
		}
		if ( !string_to_dec(strFrom, &intVal) || intVal<1 || intVal>65535) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwInvPortForm))</script>"));

			goto setErr_portfw;
		}
		entry.fromPort = (unsigned short)intVal;

		if ( !strTo[0] )
			entry.toPort = entry.fromPort;
		else {
			if ( !string_to_dec(strTo, &intVal) || intVal<1 || intVal>65535) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrPortTo))</script>"));
				goto setErr_portfw;
			}
		}
		entry.toPort = (unsigned short)intVal;

		if ( entry.fromPort  > entry.toPort ) {
             		strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrPortRange))</script>"));

			goto setErr_portfw;
		}

		strVal = websGetVar(wp, T("protocol"), T(""));
		if (strVal[0]) {
			if ( strVal[0] == '0' )
				entry.protoType = PROTO_BOTH;
			else if ( strVal[0] == '1' )
				entry.protoType = PROTO_TCP;
			else if ( strVal[0] == '2' )
				entry.protoType = PROTO_UDP;
			else {
                    		strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwInvPtcType))</script>"));
				goto setErr_portfw;
			}
		}
		else {
               		strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrPtcType))</script>"));

			goto setErr_portfw;
		}

#if defined(_Customer_) | defined(_MPPPOE_)
		strVal = websGetVar(wp, T("interface"), T("")); // alex 2007/02/12
		if (strVal[0]) {
			if ( strVal[0] == '0' )
				entry.interface = 0;
			else if ( strVal[0] == '1' )
				entry.interface = 1;
			else {
				entry.interface = 0;
			}
		}
		else {
			entry.interface = 0;
		}
#endif
		if ( strComment[0] ) {
			if (strlen(strComment) > COMMENT_LEN-1) {

				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrCmtLong))</script>"));

				goto setErr_portfw;
			}
			strcpy(entry.comment, CharFilter3(strComment));
		}
		if ( !apmib_get(MIB_PORTFW_NUM, (void *)&entryNum)) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrGetNum))</script>"));

			goto setErr_portfw;
		}

		if ( (entryNum + 1) > MAX_FILTER_NUM) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(CannotCreateMoreEntries))</script>"));

			goto setErr_portfw;
		}

		// Check if there is any port overlapped
		for (i=1; i<=entryNum; i++)
		{
			PORTFW_T checkEntry;
			*((char *)&checkEntry) = (char)i;

			if ( !apmib_get(MIB_PORTFW, (void *)&checkEntry))
			{
                   	strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrGetTbl))</script>"));
				goto setErr_portfw;
			}

			if ( (
					(entry.fromPort <= checkEntry.fromPort && entry.toPort >= checkEntry.fromPort ) ||
					(entry.fromPort >= checkEntry.fromPort && entry.fromPort <= checkEntry.toPort )
			     )
			     &&

				#if defined(_Customer_) | defined(_MPPPOE_)
			     (entry.protoType & checkEntry.protoType)  && (entry.interface == checkEntry.interface) // alex 2007/02/12
				#else
			     (entry.protoType & checkEntry.protoType)
				#endif
				)
			{
				#if defined(_Customer_)
					strcpy(tmpBuf, T("Setting port range has overlapped with used port numbers!"));
				#else
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(PortFWOverlapped))</script>"));
				#endif
				goto setErr_portfw;
			}
		}

#ifdef _EZVIEW_
		int EZentryNum;
		apmib_get(MIB_EZVIEW_NUM, (void *)&EZentryNum);
		for (i=1; i<=EZentryNum; i++)
		{
			EZVIEW_T checkEntry;
			*((char *)&checkEntry) = (char)i;

			if ( !apmib_get(MIB_EZVIEW, (void *)&checkEntry))
			{
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrGetTbl))</script>"));

				goto setErr_portfw;
			}

			int j;

			for(j=0;j<5;j++)
			{
				sprintf(tmpBuf,"echo \"from=%5d, to=%5d, from=%5d, to=%5d\" >> a",entry.fromPort,entry.toPort,checkEntry.pf_from[j],checkEntry.pf_to[j]);
				system(tmpBuf);

				if ( 	(
						(entry.fromPort <= checkEntry.pf_from[j] && entry.toPort >= checkEntry.pf_from[j] ) ||
						(entry.fromPort >= checkEntry.pf_from[j] && entry.fromPort <= checkEntry.pf_to[j] )
			     		)
			     		&&
			     		(entry.protoType & PROTO_BOTH)
					)
				{
                               	strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(PortFWOverlapped))</script>"));
					goto setErr_portfw;
				}
			}
		}
#endif


		// set to MIB. try to delete it first to avoid duplicate case
		apmib_set(MIB_PORTFW_DEL, (void *)&entry);
		if ( apmib_set(MIB_PORTFW_ADD, (void *)&entry) == 0) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrAddTbl))</script>"));
			goto setErr_portfw;
		}
	}

	/* Delete entry */
	if (strDelPort[0]) {
		if ( !apmib_get(MIB_PORTFW_NUM, (void *)&entryNum)) {
              	strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrGetNum))</script>"));

			goto setErr_portfw;
		}

		for (i=entryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "select%d", i);

			strVal = websGetVar(wp, tmpBuf, T(""));
			if ( !gstrcmp(strVal, T("ON")) ) {
				*((char *)&entry) = (char)i;
				if ( !apmib_get(MIB_PORTFW, (void *)&entry)) {
                            			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrGetTbl))</script>"));

					goto setErr_portfw;
				}
				if ( !apmib_set(MIB_PORTFW_DEL, (void *)&entry)) {
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrDelTbl))</script>"));

					goto setErr_portfw;
				}
			}
		}
	}

	/* Delete all entry */
	if ( strDelAllPort[0]) {
		if ( !apmib_set(MIB_PORTFW_DELALL, (void *)&entry)) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformPortFwErrDelAll))</script>"));

			goto setErr_portfw;
		}
	}

setOk_portfw:
	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
/*	pid = fork();
        if (pid) {
	      	waitpid(pid, NULL, 0);
	}
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG);
		execl( tmpBuf, _FIREWALL_SCRIPT_PROG, NULL);
               	exit(1);
        }*/
	// system("/bin/firewall.sh"); //Tommy
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	// Tommy Modified on 0602
	if (strApply[0]) {

	OK_MSG(submitUrl);

		//OK_MSG(submitUrl);
	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}

	return;

setErr_portfw:
	ERR_MSG(tmpBuf);
  	return;
}


/* ------------------ URL BLOCKING --------------------*/
void formUrlb(webs_t wp, char_t *path, char_t *query)
{
	char_t *strAddURLB, *strDelURLB, *strDelAllURLB, *strURLB, *strIsEnabled;	// for URL blocking
	//URLB_T URLBEntry;	// for URL blocking
	char_t *strVal, *submitUrl, *strApply;
	char tmpBuf[100];
	int intVal, entryNum, i;
	//void *pEntry;
	strAddURLB = websGetVar(wp, T("addURLB"), T(""));
	strDelURLB = websGetVar(wp, T("deleteSelURLB"), T(""));
	strDelAllURLB = websGetVar(wp, T("deleteAllURLB"), T(""));
	strIsEnabled = websGetVar(wp, T("isEnabled"), T(""));

	if (strAddURLB[0] || strDelURLB[0] || strDelAllURLB[0]) {
		memset(&URLBEntry, '\0', sizeof(URLBEntry));
		pEntry = (void *)&URLBEntry;
	}

	if (strIsEnabled[0]) {
		//printf("haha..............\n");
		strVal = websGetVar(wp, T("enabled"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			intVal = 1;
		else
			intVal = 0;

		if ( apmib_set(MIB_URLB_ENABLED, (void *)&intVal) == 0) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformUrlbErrFlag))</script>"));
			goto setErr_urlb;
		}
	}

//*********************************** Add URL Blocking ***********************************
	if (strAddURLB[0]) {
		strURLB = websGetVar(wp, T("URLB"), T(""));

		if (!strURLB[0]) {
			goto setOk_urlb;

		}

		if ( strURLB[0] ) {
			if (strlen(strURLB) > 32) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformUrlbErrCmtLong))</script>"));
				goto setErr_urlb;
			}
			else {  // Lance 2003.11.06
				int i;
				for( i=0; i < strlen(strURLB); i++ )
					strURLB[i] = tolower(strURLB[i]);

				strncpy(URLBEntry.URLBAddr, strURLB, sizeof(URLBEntry.URLBAddr));
			}
		}
	//}

	//if (strAddURLB[0]) {
		if ( !apmib_get(MIB_URLB_NUM, (void *)&entryNum)) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformUrlbErrGetNum))</script>"));
			goto setErr_urlb;
		}
		/* if ( (entryNum + 1) > MAX_FILTER_NUM) {
			strcpy(tmpBuf, T("Cannot add new entry because table is full!"));
			goto setErr_urlb;
		} */
		// set to MIB. try to delete it first to avoid duplicate case
		apmib_set(MIB_URLB_DEL, pEntry);
		if ( apmib_set(MIB_URLB_ADD, pEntry) == 0) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformUrlbErrAddTbl))</script>"));
			goto setErr_urlb;
		}
	}


	/* Delete entry */
	if (strDelURLB[0]) {
		if ( !apmib_get(MIB_URLB_NUM, (void *)&entryNum)) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformUrlbErrGetNum))</script>"));
			goto setErr_urlb;
		}
		for (i=entryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "select%d", i);

			strVal = websGetVar(wp, tmpBuf, T(""));
			if ( !gstrcmp(strVal, T("ON")) ) {

				*((char *)pEntry) = (char)i;
				if ( !apmib_get(MIB_URLB, pEntry)) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformUrlbErrGetTbl))</script>"));
					goto setErr_urlb;
				}
				if ( !apmib_set(MIB_URLB_DEL, pEntry)) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformUrlbErrDelTbl))</script>"));
					goto setErr_urlb;
				}
			}
		}
	}

	/* Delete all entry */
	if (strDelAllURLB[0]) {
		if ( !apmib_set(MIB_URLB_DELALL, pEntry)) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformUrlbErrDelAll))</script>"));
			goto setErr_urlb;
		}
	}

setOk_urlb:
	apmib_update(CURRENT_SETTING);

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	strApply = websGetVar(wp, T("isApply"), T(""));   // Tommy
	// Tommy Modified on 0602
	if (strApply[0]) {
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif



	OK_MSG(submitUrl);

		//OK_MSG(submitUrl);
	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}

	return;

setErr_urlb:
	ERR_MSG(tmpBuf);
	return;
}

/////////////////////////////////////////////////////////////////////////////
void formFilter(webs_t wp, char_t *path, char_t *query)
{
	char_t *strAddIp, *strAddPort, *strAddMac, *strDelPort, *strDelIp, *strDelMac;
	//char_t *strAddURLB, *strDelURLB, *strDelAllURLB, *strURLB;	// for URL blocking
	char_t *strAddDMZ, *strDelDMZ, *strDelAllDMZ, *strsIp;		// for dmz
	char_t *strAddACPC, *strDelACPC, *strDelAllACPC;		// for ip filter
	char_t *strAddSRout, *strDelSRout, *strDelAllSRout;		// for static routing
#ifdef _SDMZ_
	char_t *strDmzMode;
	char_t *strDmzMac;
	char_t *strRefreshTime;
#endif

	char_t *strDelAllPort, *strDelAllIp, *strDelAllMac, *strVal, *submitUrl, *strComment, *strApply;
	char_t *strFrom, *strTo;
	char_t *strMacDenyEnabled, *strIpDenyEnabled;
	char tmpBuf[100];
	int entryNum, intVal, i;
	IPFILTER_T ipEntry;
	DMZ_T dmzEntry;		// for dmz
	//URLB_T URLBEntry;	// for URL blocking
	ACPC_T ACPCEntry;	// for ip filter
	SROUT_T sroutEntry;	// for static routing
	PORTFILTER_T portEntry;
	MACFILTER_T macEntry;
	struct in_addr curIpAddr, curSubnet, entIpAddr;
	void *pEntry;
	unsigned long v1, v2, v3, v4;
	int num_id, get_id, add_id, del_id, delall_id, enable_id;

/*#ifndef NO_ACTION
	int pid;
#endif*/

	strAddDMZ = websGetVar(wp, T("addDMZ"), T(""));
	strDelDMZ = websGetVar(wp, T("delSelDMZ"), T(""));
	strDelAllDMZ = websGetVar(wp, T("delAllDMZ"), T(""));

	strAddIp = websGetVar(wp, T("addFilterIp"), T(""));
	strDelIp = websGetVar(wp, T("deleteSelFilterIp"), T(""));
	strDelAllIp = websGetVar(wp, T("deleteAllFilterIp"), T(""));

	strAddPort = websGetVar(wp, T("addFilterPort"), T(""));
	strDelPort = websGetVar(wp, T("deleteSelFilterPort"), T(""));
	strDelAllPort = websGetVar(wp, T("deleteAllFilterPort"), T(""));

	strAddMac = websGetVar(wp, T("addFilterMac"), T(""));
	strDelMac = websGetVar(wp, T("deleteSelFilterMac"), T(""));
	strDelAllMac = websGetVar(wp, T("deleteAllFilterMac"), T(""));

	strAddACPC = websGetVar(wp, T("addACPC"), T(""));
	strDelACPC = websGetVar(wp, T("deleteSelACPC"), T(""));
	strDelAllACPC = websGetVar(wp, T("deleteAllACPC"), T(""));

	strAddSRout = websGetVar(wp, T("addSRout"), T(""));
	strDelSRout = websGetVar(wp, T("delSelSRout"), T(""));
	strDelAllSRout = websGetVar(wp, T("delAllSRout"), T(""));


	if (strAddIp[0] || strDelIp[0] || strDelAllIp[0]) {
		num_id = MIB_IPFILTER_NUM;
		get_id = MIB_IPFILTER;
		add_id = MIB_IPFILTER_ADD;
		del_id = MIB_IPFILTER_DEL;
		delall_id = MIB_IPFILTER_DELALL;
		enable_id = MIB_IPFILTER_ENABLED;
		memset(&ipEntry, '\0', sizeof(ipEntry));
		pEntry = (void *)&ipEntry;
	}
	else if (strAddDMZ[0] || strDelDMZ[0] || strDelAllDMZ[0]) {
		num_id = MIB_DMZ_NUM;
		get_id = MIB_DMZ;
		add_id = MIB_DMZ_ADD;
		del_id = MIB_DMZ_DEL;
		delall_id = MIB_DMZ_DELALL;
		enable_id = MIB_DMZ_ENABLED;
		memset(&dmzEntry, '\0', sizeof(dmzEntry));
		pEntry = (void *)&dmzEntry;
	}
	else if (strAddPort[0] || strDelPort[0] || strDelAllPort[0]) {
		num_id = MIB_PORTFILTER_NUM;
		get_id = MIB_PORTFILTER;
		add_id = MIB_PORTFILTER_ADD;
		del_id = MIB_PORTFILTER_DEL;
		delall_id = MIB_PORTFILTER_DELALL;
		enable_id = MIB_PORTFILTER_ENABLED;
		memset(&portEntry, '\0', sizeof(portEntry));
		pEntry = (void *)&portEntry;
	}
	else if (strAddACPC[0] || strDelACPC[0] || strDelAllACPC[0]) {
		num_id = MIB_ACPC_NUM;
		get_id = MIB_ACPC;
		add_id = MIB_ACPC_ADD;
		del_id = MIB_ACPC_DEL;
		delall_id = MIB_ACPC_DELALL;
		enable_id = MIB_ACPC_ENABLED;
		memset(&ACPCEntry, '\0', sizeof(ACPCEntry));
		pEntry = (void *)&ACPCEntry;
	}
	else if (strAddSRout[0] || strDelSRout[0] || strDelAllSRout[0]) {
		num_id = MIB_SROUT_NUM;
		get_id = MIB_SROUT;
		add_id = MIB_SROUT_ADD;
		del_id = MIB_SROUT_DEL;
		delall_id = MIB_SROUT_DELALL;
		enable_id = MIB_SROUT_ENABLED;
		memset(&sroutEntry, '\0', sizeof(sroutEntry));
		pEntry = (void *)&sroutEntry;
	}
	else{
		num_id = MIB_MACFILTER_NUM;
		get_id = MIB_MACFILTER;
		add_id = MIB_MACFILTER_ADD;
		del_id = MIB_MACFILTER_DEL;
		delall_id = MIB_MACFILTER_DELALL;
		enable_id = MIB_MACFILTER_ENABLED;
		memset(&macEntry, '\0', sizeof(macEntry));
		pEntry = (void *)&macEntry;
	}

	strMacDenyEnabled = websGetVar(wp, T("macDenyEnabled"), T(""));
	if (strMacDenyEnabled[0]) {
		if (!gstrcmp(strMacDenyEnabled, T("yes")))
			intVal = 1;
		else if (!gstrcmp(strMacDenyEnabled, T("no")))
			intVal = 0;
		else {
			strcpy(tmpBuf, T("Error!"));
			goto setErr_filter;
		}
		if ( apmib_set(MIB_MACDENY_ENABLED, (void *)&intVal) == 0) {
     			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrSetMac))</script>"));

			goto setErr_filter;
		}
	}

	strIpDenyEnabled = websGetVar(wp, T("ipDenyEnabled"), T(""));
	if (strIpDenyEnabled[0]) {
		if (!gstrcmp(strIpDenyEnabled, T("yes")))
			intVal = 1;
		else if (!gstrcmp(strIpDenyEnabled, T("no")))
			intVal = 0;
		else {
          		strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspFormFilterError))</script>"));
			goto setErr_filter;
		}
		if ( apmib_set(MIB_IPDENY_ENABLED, (void *)&intVal) == 0) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrSetIp))</script>"));
			goto setErr_filter;
		}
	}
#ifdef _SDMZ_
	strDmzMode = websGetVar(wp, T("DMZ_Mode"), T(""));
	strRefreshTime = websGetVar(wp, T("Refresh_Time"), T(""));

	if (strDmzMode[0]){
		if (!gstrcmp(strDmzMode, T("DMZ")))
			intVal = 0;
		else if (!gstrcmp(strDmzMode, T("SuperDMZ")))
			intVal = 1;
		if (!apmib_set(MIB_DMZ_MODE, (void *)&intVal)){
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrSetDmzMode))</script>"));
			goto setErr_filter;
		}
	}

	if (strRefreshTime[0]){
		intVal = atoi(strRefreshTime);
		if (!apmib_set(MIB_SUPERDMZ_REFRESHTIME, (void *)&intVal)){
             		strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrSetSuperDmzRefreshTime))</script>"));
			goto setErr_filter;
		}
	}

	strDmzMac = websGetVar(wp, T("DMZmac"), T(""));
	if (strDmzMac[0]) {
		if (strlen(strDmzMac)!=12 || !string_to_hex(strDmzMac, tmpBuf, 12)) {
             		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup16))</script>"));
			goto setErr_filter;
		}
		if ( !apmib_set(MIB_DMZ_MAC_ADDR, (void *)tmpBuf)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup3))</script>"));
			goto setErr_filter;
		}
	}
#endif

	if ( !apmib_get(num_id, (void *)&entryNum)) {
       		strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrGetNum))</script>"));
		goto setErr_filter;
	}
/*	if ( (entryNum + 1) > MAX_FILTER_NUM) {
		strcpy(tmpBuf, T("Cannot add new entry because table is full!"));
		goto setErr_filter;
	}
*/
	// Set enable flag
	if (strAddACPC[0] || strAddDMZ[0] || strAddIp[0] || strAddPort[0] || strAddMac[0] || strAddSRout[0]) {
		strVal = websGetVar(wp, T("enabled"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			intVal = 1;
		else
			intVal = 0;

		if ( apmib_set(enable_id, (void *)&intVal) == 0) {
        		strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrSetFlag))</script>"));
		
			goto setErr_filter;
		}
	}

	strComment = websGetVar(wp, T("comment"), T(""));

//*************************************** Add DMZ ****************************************
	if ( strAddDMZ[0] ) {
		char_t *strType, *strSession, *strPbIp, *strClIp;

		strType = websGetVar(wp, T("dmzType"), T(""));
		strSession = websGetVar(wp, T("session"), T(""));
		strPbIp = websGetVar(wp, T("pip"), T(""));
		strClIp = websGetVar(wp, T("cip"), T(""));

		if (!strType[0] && !strSession[0] && !strPbIp[0] && !strClIp[0] )
			goto setOk_filter;

		if (!strClIp[0]) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrNoIp))</script>"));
			goto setErr_filter;
		}



		//kyle
		inet_aton(strClIp, &entIpAddr);

		fixed_inet_aton(strClIp, dmzEntry.cipAddr);

		getInAddr(BRIDGE_IF, IP_ADDR, (void *)&curIpAddr);
		getInAddr(BRIDGE_IF, SUBNET_MASK, (void *)&curSubnet);
		v1 = ((unsigned long)entIpAddr.s_addr);
 		v2 = ((unsigned long)curIpAddr.s_addr);
		v3 = ((unsigned long)curSubnet.s_addr);
		//kyle
		/*
		fixed_inet_aton(strClIp, dmzEntry.cipAddr);
		getInAddr(BRIDGE_IF, IP_ADDR, (void *)&curIpAddr);
		getInAddr(BRIDGE_IF, SUBNET_MASK, (void *)&curSubnet);

		v1 = *((unsigned long *)dmzEntry.cipAddr);
		v2 = *((unsigned long *)&curIpAddr);
		v3 = *((unsigned long *)&curSubnet);
	*/
#ifdef __TARGET_BOARD__
		if ( (v1 & v3) != (v2 & v3) ) {
          		strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterInvIp))</script>"));
			goto setErr_filter;
		}
#endif
		if (strType[0] == '0') 	// type of dmz is dynamic ip
			dmzEntry.type = 0;
		else
			dmzEntry.type = 1;

		if (strSession[0] == '2')
			dmzEntry.session = 2;
		else
			dmzEntry.session = 1;

		if (!strcmp( strPbIp, "" ))
			strPbIp = "0.0.0.0";
		fixed_inet_aton(strPbIp, dmzEntry.pipAddr);
		for (i=1; i<=entryNum; i++) {	// Check if there is any ip overlapped
			DMZ_T checkEntry;
			*((char *)&checkEntry) = (char)i;
			if ( !apmib_get(get_id, (void *)&checkEntry)) {
              			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrGetTbl))</script>"));
				goto setErr_filter;
			}
			//if ( (dmzEntry.type == 1 && !memcmp(&checkEntry.pipAddr, &dmzEntry.pipAddr, 4)) || (dmzEntry.type == 0 && checkEntry.session == dmzEntry.session) ) {
			if ( (dmzEntry.type == 1 && !memcmp(&checkEntry.pipAddr, &dmzEntry.pipAddr, 4)) || (dmzEntry.type == 0 && !memcmp(&checkEntry.pipAddr, &dmzEntry.pipAddr, 4) )) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrSetIpPub))</script>"));
				goto setErr_filter;
			}
		}
	}
//*********************************** Add Static Routing ***********************************
	if (strAddSRout[0]) {
		char_t *strIp, *strMask, *strGateway, *strCount, *strFace;
		int k;
		FILE *fp;
		char wanAddr[3][50];

		strIp = websGetVar(wp, T("sroutIp"), T(""));
		strMask = websGetVar(wp, T("sroutMask"), T(""));
		strGateway = websGetVar(wp, T("sroutGateway"), T(""));
		strCount = websGetVar(wp, T("sroutCount"), T(""));
		strFace = websGetVar(wp, T("sroutFace"), T(""));

		if (!strIp[0] && !strMask[0] && !strGateway[0] && !strCount[0] && !strFace[0] )
			goto setOk_filter;

		if (!strIp[0] || !strMask[0] || !strGateway[0]) {
          		strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrInput))</script>"));
			goto setErr_filter;
		}

		//kyle
   		inet_aton(strIp, &entIpAddr);

		fixed_inet_aton(strIp, sroutEntry.ipAddr);
		fixed_inet_aton(strMask, sroutEntry.maskAddr);
		fixed_inet_aton(strGateway, sroutEntry.gatewayAddr);
		//printf("sroutEntry=%u%u%u%u",sroutEntry.ipAddr[0],sroutEntry.ipAddr[1],sroutEntry.ipAddr[2],sroutEntry.ipAddr[3]);

		v1 = ((unsigned long)entIpAddr.s_addr);
		//v1 = *((unsigned long *)&sroutEntry.ipAddr);	//check IP
		v2 = *((unsigned long *)&sroutEntry.maskAddr);
		v3 = v1 & v2 ;


		memcpy(&sroutEntry.ipAddr, &v3, 4);

#if 0 // RexHua, is wrong check
		if ( v3 != v1) {
			sprintf(tmpBuf, "<script type='text/javascript'>document.write(showText(aspformFilterInvIpType))</script>%d.%d.%d.%d",
			sroutEntry.ipAddr[0],sroutEntry.ipAddr[1],sroutEntry.ipAddr[2],sroutEntry.ipAddr[3]);
			goto setErr_filter;
		}
#endif
		// compare type gateway address with interface ip address
		if ( strFace[0] == '1' ) {
			system("wan-status.sh");
			if ((fp = fopen("/var/run/wanstat","r"))!=NULL) {
				for ( k=0 ; k<3 ; k++)
					fgets(wanAddr[k], 50, fp);
				fclose(fp);
			}
			inet_aton(wanAddr[1], &curIpAddr);
			inet_aton(wanAddr[2], &curSubnet);

			v1 = *((unsigned long *)&sroutEntry.gatewayAddr);
			v2 = *((unsigned long *)&curIpAddr);
			v3 = *((unsigned long *)&curSubnet);
/*#ifdef __TARGET_BOARD__
	#ifndef _EZVIEW_
			if ( (v1 & v3) != (v2 & v3) ) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterInvIpWan))</script>"));
				goto setErr_filter;
			}
	#endif
#endif*/
		} else {
			getInAddr(BRIDGE_IF, IP_ADDR, (void *)&curIpAddr);
			getInAddr(BRIDGE_IF, SUBNET_MASK, (void *)&curSubnet);

			v1 = *((unsigned long *)&sroutEntry.gatewayAddr);
			v2 = *((unsigned long *)&curIpAddr);
			v3 = *((unsigned long *)&curSubnet);
#ifdef __TARGET_BOARD__
	#ifndef _EZVIEW_
			if ( (v1 & v3) != (v2 & v3) ) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterInvIpLan))</script>"));
				goto setErr_filter;
			}
	#endif
#endif
		}

		if ( !string_to_dec(strCount, &intVal) || intVal<0 || intVal>255) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterInvHopCount))</script>"));
			goto setErr_filter;
		}
		sroutEntry.hopCount = (unsigned short)intVal;
		if (strFace[0]){
			if ( strFace[0] == '0' )
				sroutEntry.interface = 0;
			else
				sroutEntry.interface = 1;
		}
	}

//****************************** Add access control Ip filter ******************************
	if (strAddACPC[0]) {
		char *ptr, *ptr2, *ptr3;
		int	i;
		char_t *strIndex;
		unsigned long longVal;

		strVal = websGetVar(wp, T("sipaddr"), T(""));
		strsIp = websGetVar(wp, T("eipaddr"), T(""));
		if (!strVal[0] && !strComment[0])
			goto setOk_filter;

		if (!strVal[0]) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrNoIp))</script>"));
			goto setErr_filter;
		}
		if ( !strsIp[0])
			strsIp=strVal;

		fixed_inet_aton(strVal, ACPCEntry.sipAddr);
		fixed_inet_aton(strsIp, ACPCEntry.eipAddr);
		getInAddr(BRIDGE_IF, IP_ADDR, (void *)&curIpAddr);
		getInAddr(BRIDGE_IF, SUBNET_MASK, (void *)&curSubnet);

		v1 = *((unsigned long *)ACPCEntry.sipAddr);
		v4 = *((unsigned long *)ACPCEntry.eipAddr);
		v2 = *((unsigned long *)&curIpAddr);
		v3 = *((unsigned long *)&curSubnet);
#ifdef __TARGET_BOARD__
		if ( ((v1 & v3) != (v2 & v3)) || ((v4 & v3) != (v2 & v3))) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterInvIp))</script>"));
			goto setErr_filter;
		}
#endif
		strIndex = websGetVar(wp, T("serindex"), T(""));
		ptr = websGetVar(wp, T("Port"), T(""));

		longVal=strtoul(strIndex,NULL,0);
		ACPCEntry.serindex = longVal;

		if ( (longVal == 0) && !ptr[0] )
			ACPCEntry.serindex = 0xC000;
//------------------------------------------------------------------------------------
		for (i=0;i<5; i++) {
			if ((ptr2 = strchr(ptr, ',')) != NULL) {
				*ptr2 = '\0';
				ptr2 ++;
			}

			if ((ptr3 = strchr(ptr, '-')) != NULL) {
				*ptr3 = '\0';
				ptr3 ++;

				if ((!(ACPCEntry.Port[i][0] = atoi(ptr))) ||
						(ACPCEntry.Port[i][0] < 1) || (ACPCEntry.Port[i][0] >65536)) {
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterInvIpPortFr))</script>"));
					goto setErr_filter;
				}
				if ((!(ACPCEntry.Port[i][1]=atoi(ptr3))) ||
						(ACPCEntry.Port[i][1] < 1) || (ACPCEntry.Port[i][1] >65536))  {
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterInvIpPortTo))</script>"));
					goto setErr_filter;
				}
				if (ACPCEntry.Port[i][1] < ACPCEntry.Port[i][0]) {
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterInvPortRange))</script>"));
					goto setErr_filter;
				}
			}
			else
				ACPCEntry.Port[i][0]=ACPCEntry.Port[i][1]=atol(ptr);
/*				if (i>0)
					if (ACPCEntry.Port[i-1][1] > ACPCEntry.Port[i][1])  {
						strcpy(tmpBuf, T("Error!"));
						goto setErr_filter;
					}*/
			if( ptr2 == NULL)
				break;
			ptr = ptr2;
		}
	}

//*********************************** Add Ip filter ***********************************
	if (strAddIp[0]) {
		strVal = websGetVar(wp, T("ip"), T(""));
		if (!strVal[0] && !strComment[0])
			goto setOk_filter;

		if (!strVal[0]) {
          		strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrNoIp))</script>"));
			goto setErr_filter;
		}
		fixed_inet_aton(strVal, ipEntry.ipAddr);
		getInAddr(BRIDGE_IF, IP_ADDR, (void *)&curIpAddr);
		getInAddr(BRIDGE_IF, SUBNET_MASK, (void *)&curSubnet);

		v1 = *((unsigned long *)ipEntry.ipAddr);
		v2 = *((unsigned long *)&curIpAddr);
		v3 = *((unsigned long *)&curSubnet);
#ifdef __TARGET_BOARD__
		if ( (v1 & v3) != (v2 & v3) ) {
           		strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterInvIp))</script>"));
			goto setErr_filter;
		}
#endif
	}

	/* Add port filter */
	if (strAddPort[0]) {
		strFrom = websGetVar(wp, T("fromPort"), T(""));
		strTo = websGetVar(wp, T("toPort"), T(""));
		if (!strFrom[0] && !strTo[0] && !strComment[0])
			goto setOk_filter;

		if (!strFrom[0]) { // if port-forwarding, from port must exist
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrPortFr))</script>"));

			goto setErr_filter;
		}
		if ( !string_to_dec(strFrom, &intVal) || intVal<1 || intVal>65535) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterInvPortFr))</script>"));
	
			goto setErr_filter;
		}
		portEntry.fromPort = (unsigned short)intVal;

		if ( !strTo[0] )
			portEntry.toPort = portEntry.fromPort;
		else {
			if ( !string_to_dec(strTo, &intVal) || intVal<1 || intVal>65535) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrPortTo))</script>"));
				goto setErr_filter;
			}
			portEntry.toPort = (unsigned short)intVal;
		}

		if ( portEntry.fromPort  > portEntry.toPort ) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrPortRange))</script>"));
			goto setErr_filter;
		}
	}

	if (strAddACPC[0] || strAddPort[0] || strAddIp[0]) {
		strVal = websGetVar(wp, T("protocol"), T(""));
		if (strVal[0]) {
			if ( strVal[0] == '0' ) {
				if (strAddPort[0])
					portEntry.protoType = PROTO_BOTH;
				else if (strAddIp[0])
					ipEntry.protoType = PROTO_BOTH;
				else
					ACPCEntry.protoType = PROTO_BOTH;
			}
			else if ( strVal[0] == '1' ) {
				if (strAddPort[0])
					portEntry.protoType = PROTO_TCP;
				else if (strAddIp[0])
					ipEntry.protoType = PROTO_TCP;
				else
					ACPCEntry.protoType = PROTO_TCP;
			}
			else if ( strVal[0] == '2' ) {
				if (strAddPort[0])
					portEntry.protoType = PROTO_UDP;
				else if (strAddIp[0])
					ipEntry.protoType = PROTO_UDP;
				else
					ACPCEntry.protoType = PROTO_UDP;
			}
			else {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterInvPtcType))</script>"));
				goto setErr_filter;
			}
		}
		else {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrPtcTypeEmpty))</script>"));

			goto setErr_filter;
		}
	}

	if (strAddMac[0]) {

		strVal = websGetVar(wp, T("mac"), T(""));
		if (!strVal[0] && !strComment[0])
			goto setOk_filter;

		if ( !strVal[0] ) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrNoMac))</script>"));

			goto setErr_filter;
		}
		if (strlen(strVal)!=12 || !string_to_hex(strVal, macEntry.macAddr, 12)) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterInvNoMac))</script>"));

			goto setErr_filter;
		}
	}

	if (strAddACPC[0] || strAddDMZ[0] || strAddIp[0] || strAddPort[0] || strAddMac[0] || strAddSRout[0] ) {
	//printf("\nstrComment=%d  getComment=%d\n",strlen(strComment),(COMMENT_LEN-1));
		if ( strComment[0] ) {
			if (strlen(strComment) > COMMENT_LEN-1) {
             			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrCmtLong))</script>"));
				goto setErr_filter;
			}
			if (strAddIp[0])
				strcpy(ipEntry.comment, CharFilter3(strComment));
			else if (strAddPort[0])
				strcpy(portEntry.comment, CharFilter3(strComment));
			else if (strAddMac[0])
				strcpy(macEntry.comment, CharFilter3(strComment));
			else if (strAddACPC[0])
				strcpy(ACPCEntry.comment, CharFilter3(strComment));
		}
		if ( !apmib_get(num_id, (void *)&entryNum)) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrGetNum))</script>"));

			goto setErr_filter;
		}
		if ( (entryNum + 1) > MAX_FILTER_NUM) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrAdd))</script>"));

			goto setErr_filter;
		}
		// set to MIB. try to delete it first to avoid duplicate case
		apmib_set(del_id, pEntry);
		if ( apmib_set(add_id, pEntry) == 0) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrAddTbl))</script>"));

			goto setErr_filter;
		}
	}

	/* Delete entry */
	if (strDelACPC[0] || strDelDMZ[0] || strDelPort[0] || strDelIp[0] || strDelMac[0] || strDelSRout[0]) {
		if ( !apmib_get(num_id, (void *)&entryNum)) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrGetNum))</script>"));

			goto setErr_filter;
		}
		for (i=entryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "select%d", i);

			strVal = websGetVar(wp, tmpBuf, T(""));
			if ( !gstrcmp(strVal, T("ON")) ) {

				*((char *)pEntry) = (char)i;
				if ( !apmib_get(get_id, pEntry)) {
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrGetTbl))</script>"));

					goto setErr_filter;
				}
				if ( !apmib_set(del_id, pEntry)) {
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrDelTbl))</script>"));

					goto setErr_filter;
				}
			}
		}
	}

	/* Delete all entry */
	if (strDelAllACPC[0] || strDelAllDMZ[0] || strDelAllPort[0] || strDelAllIp[0] || strDelAllMac[0] || strDelAllSRout[0]) {
		if ( !apmib_set(delall_id, pEntry)) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrDelAll))</script>"));

			goto setErr_filter;
		}
	}
setOk_filter:
	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
/*	pid = fork();
        if (pid) {
	      	waitpid(pid, NULL, 0);
	}
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG);
		execl( tmpBuf, _FIREWALL_SCRIPT_PROG, NULL);
               	exit(1);
        }*/
	//system("/bin/firewall.sh");
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	strApply = websGetVar(wp, T("isApply"), T(""));   // Tommy
	// Tommy Modified on 0602
	if (strApply[0]) {
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

	OK_MSG(submitUrl);

		//OK_MSG(submitUrl);
	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
		{
			
			websDone(wp, 200);
		
		}
	}

  	return;
setErr_filter:
	ERR_MSG(tmpBuf);
  	return;
}



#ifdef _VLAN_CONFIG_SUPPORTED_
int vlanList(int eid, webs_t wp, int argc, char_t **argv)
{
	VLAN_CONFIG_T entry;
	char *strToken;
	int cmpResult=0;
	//char *tmpStr0;
	int  index=0;
	char IfaceName[32];
	OPMODE_T opmode=-1;
	char wanLan[8];
	
	memset(IfaceName,0x00,sizeof(IfaceName));
	memset(wanLan,0x00,sizeof(wanLan));
	
	cmpResult= strncmp(argv[0], "webVlanList_", strlen("webVlanList_"));
	strToken=strstr(argv[0], "_");
	index= atoi(strToken+1);

	if( index <= MAX_IFACE_VLAN_CONFIG && index != 0) // ignore item 0 
	{
		
		*((char *)&entry) = (char)index;
		if ( !apmib_get(MIB_VLANCONFIG, (void *)&entry))
		{
			fprintf(stderr,"Get vlan entry fail\n");
			return -1;
		}
		
		apmib_get( MIB_OP_MODE, (void *)&opmode);
		
		switch(index)
		{
			case 1:
			case 2:
			case 3:
			case 4:
				sprintf(IfaceName,"%s%d","Ethernet Port",index);
				sprintf(wanLan,"%s","LAN");
				break;
			case 5:
				sprintf(IfaceName,"%s","Wireless Primary AP");
				if(opmode == WISP_MODE)
				{
					sprintf(wanLan,"%s","WAN");
				}
				else
				{
					sprintf(wanLan,"%s","LAN");
				}
				break;
			case 6:
			case 7:
			case 8:
			case 9:
				sprintf(IfaceName,"%s%d","Virtual AP",index-5);
				sprintf(wanLan,"%s","LAN");
				break;
			case 10:
				sprintf(IfaceName,"%s","Ethernet Port5");
				if(opmode == WISP_MODE || opmode == BRIDGE_MODE)
				{
					sprintf(wanLan,"%s","LAN");
				}
				else
				{
					sprintf(wanLan,"%s","WAN");
				}
				break;
			case 11:
			sprintf(IfaceName,"%s","Local Host/WAN");
				sprintf(wanLan,"%s","LAN");
				break;
		}
		
		 //enabled/netIface/tagged/untagged/priority/cfi/groupId/vlanId/LanWan 
		websWrite(wp, T("%d|%s|%d|%d|%d|%d|%d|%d|%s"), entry.enabled,IfaceName,entry.tagged,0,entry.priority,entry.cfi,0,entry.vlanId,wanLan);
	}
	else
	{
		websWrite(wp, T("0|none|0|0|0|0|0|0|LAN") );
	}
	return 0;
}


void formVlan(webs_t wp, char_t *path, char_t *query)
{
	VLAN_CONFIG_T entry;
	char_t *submitUrl,*strTmp;
	int	i, vlan_onoff;
	char tmpBuf[100];
	
	//displayPostDate(wp->postData);

	strTmp= websGetVar(wp, T("vlan_onoff"), T(""));
	if(strTmp[0])
	{
		vlan_onoff = atoi(strTmp);
	}
	
	if (!apmib_set(MIB_VLANCONFIG_ENABLED, (void *)&vlan_onoff)) 
	{
		strcpy(tmpBuf, T("set  MIB_VLANCONFIG_ENABLED error!"));
		goto setErr;
	}
	
	if(vlan_onoff == 1)
	{
		if ( !apmib_set(MIB_VLANCONFIG_DELALL, (void *)&entry)) 
		{
			strcpy(tmpBuf, T("Delete all table error!"));
			goto setErr;
		}

		for(i=1; i<=MAX_IFACE_VLAN_CONFIG ; i++)
		{
			memset(&entry, '\0', sizeof(entry));
			
			*((char *)&entry) = (char)i;
			apmib_get(MIB_VLANCONFIG, (void *)&entry);			

			memset(tmpBuf,0x00, sizeof(tmpBuf));			
			sprintf(tmpBuf,"vlan_iface_%d",i);
			strTmp = websGetVar(wp, T(tmpBuf), T(""));
		
		
			if(strTmp[0])
			{
			}
			else
			{
				continue;
			}

			memset(tmpBuf,0x00, sizeof(tmpBuf));			
			sprintf(tmpBuf,"vlan_enable_%d",i);
			strTmp = websGetVar(wp, T(tmpBuf), T(""));
			if(strTmp[0])
			{
				entry.enabled = atoi(strTmp);
			}

			memset(tmpBuf,0x00, sizeof(tmpBuf));			
			sprintf(tmpBuf,"vlan_tag_%d",i);
			strTmp = websGetVar(wp, T(tmpBuf), T(""));
			if(strTmp[0])
			{
				entry.tagged = atoi(strTmp);
			}
		
			memset(tmpBuf,0x00, sizeof(tmpBuf));			
			sprintf(tmpBuf,"vlan_cfg_%d",i);
			strTmp = websGetVar(wp, T(tmpBuf), T(""));
			if(strTmp[0])
			{
				entry.cfi = atoi(strTmp);
			}
//printf("cfg = %d" , atoi(strTmp));
			memset(tmpBuf,0x00, sizeof(tmpBuf));			
			sprintf(tmpBuf,"vlan_id_%d",i);
			strTmp = websGetVar(wp, T(tmpBuf), T(""));
			if(strTmp[0])
			{
				entry.vlanId = atoi(strTmp);
			}

			memset(tmpBuf,0x00, sizeof(tmpBuf));			
			sprintf(tmpBuf,"vlan_priority_%d",i);
			strTmp = websGetVar(wp, T(tmpBuf), T(""));
			if(strTmp[0])
			{
				entry.priority = atoi(strTmp);
			}

			if ( apmib_set(MIB_VLANCONFIG_ADD, (void *)&entry) == 0) 
			{				
				strcpy(tmpBuf, T("Add table entry error!"));				
				goto setErr;
			}


			

		}
		
	}
	apmib_update(CURRENT_SETTING);
	//apmib_update_web(CURRENT_SETTING);



	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	if (submitUrl[0])
	{
		OK_MSG(submitUrl);
	}
	else
		websDone(wp, 200);
  	return;

setErr:
	ERR_MSG(tmpBuf);
	return;

}
#endif


/////////////////////////////////////////////////////////////////////////////
void formTriggerPort(webs_t wp, char_t *path, char_t *query)
{
	char_t *strAddPort, *strDelAllPort, *strDelPort, *strVal, *submitUrl;
	char_t *strTriFrom, *strTriTo, *strIncFrom, *strIncTo, *strComment, *strApply;
	//kyle
	char_t *ip ,*tcpOpen ,*udpOpen , *comment;
	char tmpBuf[100];
	int entryNum, intVal, i;
	TRIGGERPORT_T entry;
/*#ifndef NO_ACTION
	int pid;
#endif*/

//	char *ptr, *ptr2, *ptr3;
//	int	i;

	strApply = websGetVar(wp, T("isApply"), T(""));   // Tommy

	memset(&entry, '\0', sizeof(entry));
	if (!strApply[0]) {
		strVal = websGetVar(wp, T("enabled"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			intVal = 1;
		else
			intVal = 0;
		if ( apmib_set(MIB_TRIGGERPORT_ENABLED, (void *)&intVal) == 0) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformFilterErrDelAll))</script>"));
			goto setErr_triPort;
		}
	}
	/* Add port filter */
	strAddPort = websGetVar(wp, T("addPort"), T(""));
	if (strAddPort[0]) {
		/*
		strTriFrom = websGetVar(wp, T("triFromPort"), T(""));
		strTriTo = websGetVar(wp, T("triToPort"), T(""));
		strIncFrom = websGetVar(wp, T("incFromPort"), T(""));
		strIncTo = websGetVar(wp, T("incToPort"), T(""));
		strComment = websGetVar(wp, T("comment"), T(""));
		*/
		//kyle
		ip= websGetVar(wp, T("ip"), T(""));
		tcpOpen = websGetVar(wp, T("tcpopen"), T(""));
		udpOpen = websGetVar(wp, T("udpopen"), T(""));
		strComment = websGetVar(wp, T("comment"), T(""));
		fixed_inet_aton(ip,entry.ip);
		if (!ip[0] && !tcpOpen[0] && !udpOpen[0] &&!strComment[0])
			goto setOk_triPort;
		// get trigger port range and protocol
		/*kyle
		if (!strTriFrom[0]) { // from port must exist
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortErrPortFr))</script>"));
			goto setErr_triPort;
		}
		if ( !string_to_dec(strTriFrom, &intVal) || intVal<1 || intVal>65535) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPort1))</script>"));
			goto setErr_triPort;
		}
		entry.tri_fromPort = (unsigned short)intVal;



		if ( !strTriTo[0] )
			entry.tri_toPort = entry.tri_fromPort;
		else {
			if ( !string_to_dec(strTriTo, &intVal) || intVal<1 || intVal>65535) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPort2))</script>"));
				goto setErr_triPort;
			}
			entry.tri_toPort = (unsigned short)intVal;
		}

		if ( entry.tri_fromPort  > entry.tri_toPort) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPort3))</script>"));
			goto setErr_triPort;
		}
		kyle*/
/*		if ( (entry.tri_fromPort<=6112)&&(entry.tri_toPort>=6112) ) {////////////////
			strcpy(tmpBuf, T("Error! 6112 port will conflict with Starcraft game."));
			goto setErr_triPort;
		}
*/

/*kyle
		strVal = websGetVar(wp, T("triProtocol"), T(""));
		if (strVal[0]) {
			if ( strVal[0] == '0' ) {
				if (strAddPort[0])
					entry.tri_protoType = PROTO_BOTH;
				else
					entry.tri_protoType = PROTO_BOTH;
			}
			else if ( strVal[0] == '1' ) {
				if (strAddPort[0])
					entry.tri_protoType = PROTO_TCP;
				else
					entry.tri_protoType = PROTO_TCP;
			}
			else if ( strVal[0] == '2' ) {
				if (strAddPort[0])
					entry.tri_protoType = PROTO_UDP;
				else
					entry.tri_protoType = PROTO_UDP;
			}
			else {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortInvPtcType))</script>"));
				goto setErr_triPort;
			}
		}
		else {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortErrPtcTypeEmpty))</script>"));
			goto setErr_triPort;
		}
		kyle*/
/////////////////////////////////////////////////////////////////////////////////////////////
{
	char *ptr, *ptr2, *ptr3;
	int	i ;


		 ptr = tcpOpen;
	for (i=0;i<5; i++)	{
		if ((ptr2 = strchr(ptr, ',')) != NULL) {
			*ptr2 = '\0';
			ptr2 ++;
		}

		if ((ptr3 = strchr(ptr, '-')) != NULL) {
			*ptr3 = '\0';
			ptr3 ++;

			if ((!(entry.tcp_port[i][0] = atoi(ptr))) || (entry.tcp_port[i][0] < 1) || (entry.tcp_port[i][0] >65536)) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortInvPortFr))</script>"));
				goto setErr_triPort;
			}
			if ((!(entry.tcp_port[i][1]=atoi(ptr3))) || (entry.tcp_port[i][1] < 1) || (entry.tcp_port[i][1] >65536))  {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortInvPortTo))</script>"));
				goto setErr_triPort;
			}
			if (entry.tcp_port[i][0] > entry.tcp_port[i][1]) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortInvPortRange))</script>"));
				goto setErr_triPort;
			}
		}
		else
				entry.tcp_port[i][0]=entry.tcp_port[i][1]=atol(ptr);
/*kyle
				if (i>0)
					if (entry.tcp_port[i-1][1] > entry.tcp_port[i][1])  {
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspFormFilterError))</script>"));
						goto setErr_triPort;

					}
kyle*/
/*	if ((entry.inc_fromPort[i][0]<=6112) && (entry.inc_fromPort[i][1]>=6112))	 {
			strcpy(tmpBuf, T("Error! 6112 port will conflict with Starcraft game."));
			goto setErr_triPort;
		}
*/	//	printf("ERROR Port[%d]>Port[%d]\n",i,(i+1));
	//	printf("TTT%d-%d\n",entry.inc_fromPort[i][0],entry.inc_fromPort[i][1]);
		if( ptr2 == NULL)
			break;
		ptr = ptr2;
	}


		 ptr2 = NULL;
		 ptr3 = NULL;
		 ptr = udpOpen;
	for (i=0;i<5; i++)	{
		if ((ptr2 = strchr(ptr, ',')) != NULL) {
			*ptr2 = '\0';
			ptr2 ++;
		}

		if ((ptr3 = strchr(ptr, '-')) != NULL) {
			*ptr3 = '\0';
			ptr3 ++;

			if ((!(entry.udp_port[i][0] = atoi(ptr))) || (entry.udp_port[i][0] < 1) || (entry.udp_port[i][0] >65536)) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortInvPortFr))</script>"));
				goto setErr_triPort;
			}
			if ((!(entry.udp_port[i][1]=atoi(ptr3))) || (entry.udp_port[i][1] < 1) || (entry.udp_port[i][1] >65536))  {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortInvPortTo))</script>"));
				goto setErr_triPort;
			}
			if (entry.udp_port[i][0] > entry.udp_port[i][1]) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortInvPortRange))</script>"));
				goto setErr_triPort;
			}
		}
		else
				entry.udp_port[i][0]=entry.udp_port[i][1]=atol(ptr);
				/*kyle
				if (i>0)
					if (entry.udp_port[i-1][1] > entry.udp_port[i][1])  {
						strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspFormFilterError))</script>"));
						goto setErr_triPort;
					}
					kyle*/
/*	if ((entry.inc_fromPort[i][0]<=6112) && (entry.inc_fromPort[i][1]>=6112))	 {
			strcpy(tmpBuf, T("Error! 6112 port will conflict with Starcraft game."));
			goto setErr_triPort;
		}
*/	//	printf("ERROR Port[%d]>Port[%d]\n",i,(i+1));
	//	printf("TTT%d-%d\n",entry.inc_fromPort[i][0],entry.inc_fromPort[i][1]);
		if( ptr2 == NULL)
			break;
		ptr = ptr2;
	}



}
//////////////////////////////////////////////////////////////////////////////////////////////
		/*kyle
		strVal = websGetVar(wp, T("incProtocol"), T(""));
		if (strVal[0]) {
			if ( strVal[0] == '0' ) {
				if (strAddPort[0])
					entry.inc_protoType = PROTO_BOTH;
				else
					entry.inc_protoType = PROTO_BOTH;
			}
			else if ( strVal[0] == '1' ) {
				if (strAddPort[0])
					entry.inc_protoType = PROTO_TCP;
				else
					entry.inc_protoType = PROTO_TCP;
			}
			else if ( strVal[0] == '2' ) {
				if (strAddPort[0])
					entry.inc_protoType = PROTO_UDP;
				else
					entry.inc_protoType = PROTO_UDP;
			}
			else {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortInvPortType))</script>"));
				goto setErr_triPort;
			}
		}
		else {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortInvPortTypeEmpty))</script>"));
			goto setErr_triPort;
		}
	kyle*/
		// get comment
		if ( strComment[0] ) {
			if (strlen(strComment) > COMMENT_LEN-1) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortErrCmtLong))</script>"));
				goto setErr_triPort;
			}
			strcpy(entry.comment, CharFilter3(strComment));
		}

		// get entry number to see if it exceeds max
		if ( !apmib_get(MIB_TRIGGERPORT_NUM, (void *)&entryNum)) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortErrGetNum))</script>"));
			goto setErr_triPort;
		}
		if ( (entryNum + 1) > MAX_FILTER_NUM) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortErrAdd))</script>"));
			goto setErr_triPort;
		}
		/*kyle
		// Check if there is any port overlapped
		for (i=1; i<=entryNum; i++) {
			TRIGGERPORT_T checkEntry;
			*((char *)&checkEntry) = (char)i;
			if ( !apmib_get(MIB_TRIGGERPORT, (void *)&checkEntry)) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortErrGetTbl))</script>"));
				goto setErr_triPort;
			}
			if ( ( (entry.tri_fromPort <= checkEntry.tri_fromPort &&
					entry.tri_toPort >= checkEntry.tri_fromPort) ||
			       (entry.tri_fromPort >= checkEntry.tri_fromPort &&
				entry.tri_fromPort <= checkEntry.tri_toPort)
			     )&&
			       (entry.tri_protoType & checkEntry.tri_protoType) ) {
				strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortErrPortRange))</script>"));
				goto setErr_triPort;
			}
		}
		*/
		// set to MIB. try to delete it first to avoid duplicate case
		apmib_set(MIB_TRIGGERPORT_DEL, (void *)&entry);
		if ( apmib_set(MIB_TRIGGERPORT_ADD, (void *)&entry) == 0) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortErrAddTbl))</script>"));
			goto setErr_triPort;
		}
	}

	/* Delete entry */
	strDelPort = websGetVar(wp, T("deleteSelPort"), T(""));
	if (strDelPort[0]) {
		if ( !apmib_get(MIB_TRIGGERPORT_NUM, (void *)&entryNum)) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortErrGetNum))</script>"));
			goto setErr_triPort;
		}
		for (i=entryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "select%d", i);

			strVal = websGetVar(wp, tmpBuf, T(""));
			if ( !gstrcmp(strVal, T("ON")) ) {

				*((char *)&entry) = (char)i;
				if ( !apmib_get(MIB_TRIGGERPORT, (void *)&entry)) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortErrGetTbl))</script>"));
					goto setErr_triPort;
				}
				if ( !apmib_set(MIB_TRIGGERPORT_DEL, (void *)&entry)) {
					strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortErrDelTbl))</script>"));
					goto setErr_triPort;
				}
			}
		}
	}

//}
	/* Delete all entry */
	strDelAllPort = websGetVar(wp, T("deleteAllPort"), T(""));
	if ( strDelAllPort[0]) {
		if ( !apmib_set(MIB_TRIGGERPORT_DELALL, (void *)&entry)) {
			strcpy(tmpBuf, T("<script type='text/javascript'>document.write(showText(aspformTriggerPortErrDelAll))</script>"));
			goto setErr_triPort;
		}
	}

setOk_triPort:
	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
/*	pid = fork();
        if (pid) {
	      	waitpid(pid, NULL, 0);
	}
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG);
		execl( tmpBuf, _FIREWALL_SCRIPT_PROG, NULL);
               	exit(1);
        }*/
	// system("/bin/firewall.sh");
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	// Tommy Modified on 0602
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif
	if (strApply[0]) {
		OK_MSG(submitUrl);
	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}

	return;

setErr_triPort:
	ERR_MSG(tmpBuf);
  	return;
}

/////////////////////////////////////////////////////////////////////////////
int portFwList(int eid, webs_t wp, int argc, char_t **argv)
{
	int	nBytesSent=0, entryNum, i;
	PORTFW_T entry;


	char	*type, portRange[20], *ip;


	if ( !apmib_get(MIB_PORTFW_NUM, (void *)&entryNum))
	{
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}

	for (i=1; i<=entryNum; i++)
	{
		*((char *)&entry) = (char)i;

		if ( !apmib_get(MIB_PORTFW, (void *)&entry)) return -1;

		ip = fixed_inet_ntoa(entry.ipAddr);

		if ( !strcmp(ip, "0.0.0.0"))  ip = "----";

		if ( entry.protoType == PROTO_BOTH )      type = "TCP+UDP";

		else if ( entry.protoType == PROTO_TCP )  type = "TCP";
		else                                      type = "UDP";
	
		if ( entry.fromPort == 0)                  strcpy(portRange, "----");
		else if ( entry.fromPort == entry.toPort ) snprintf(portRange, 20, "%d", entry.fromPort);
		else                                       snprintf(portRange, 20, "%d-%d", entry.fromPort, entry.toPort);

		nBytesSent += websWrite(wp, T("<tr align=\"center\" class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("<td>%d</td>\n"),i);
       	#ifdef _NETBIOSNAME_
		nBytesSent += websWrite(wp, T("<td><script>document.write(searchComName(\"%s\",0))</script></td>\n"),ip);
        #endif
		nBytesSent += websWrite(wp, T("<td>%s</td>\n"),ip);
		nBytesSent += websWrite(wp, T("<td>%s</td>\n"),type);
		nBytesSent += websWrite(wp, T("<td>%s</td>\n"),portRange);
		nBytesSent += websWrite(wp, T("<td>%s</td>\n"),CharFilter4(entry.comment));
		nBytesSent += websWrite(wp, T("<td><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td>\n"),i);
		nBytesSent += websWrite(wp, T("</tr>\n"));
	}

	return nBytesSent;
}


/////////////////////////////////////////////////////////////////////////////
/*int portFilterList(int eid, webs_t wp, int argc, char_t **argv)
{
	int	nBytesSent=0, entryNum, i;
	PORTFILTER_T entry;
	char	*type, portRange[20];

	if ( !apmib_get(MIB_PORTFILTER_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}

	nBytesSent += websWrite(wp, T("<tr>"
      	"<td align=center width=\"30%%\" bgcolor=\"#808080\"><font size=\"2\"><b>Port Range</b></font></td>\n"
      	"<td align=center width=\"25%%\" bgcolor=\"#808080\"><font size=\"2\"><b>Protocol</b></font></td>\n"
	"<td align=center width=\"30%%\" bgcolor=\"#808080\"><font size=\"2\"><b>Comment</b></font></td>\n"
      	"<td align=center width=\"15%%\" bgcolor=\"#808080\"><font size=\"2\"><b>Select</b></font></td></tr>\n"));

	for (i=1; i<=entryNum; i++) {
		*((char *)&entry) = (char)i;
		if ( !apmib_get(MIB_PORTFILTER, (void *)&entry))
			return -1;

		if ( entry.protoType == PROTO_BOTH )
			type = "TCP+UDP";
		else if ( entry.protoType == PROTO_TCP )
			type = "TCP";
		else
			type = "UDP";

		if ( entry.fromPort == 0)
			strcpy(portRange, "----");
		else if ( entry.fromPort == entry.toPort )
			snprintf(portRange, 20, "%d", entry.fromPort);
		else
			snprintf(portRange, 20, "%d-%d", entry.fromPort, entry.toPort);

		nBytesSent += websWrite(wp, T("<tr>"
			"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</td>\n"
   			"<td align=center width=\"25%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</td>\n"
     			"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</td>\n"
      			"<td align=center width=\"15%%\" bgcolor=\"#C0C0C0\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td></tr>\n"),
				portRange, type, entry.comment, i);
	}
	return nBytesSent;
}
*/

/////////////////////////////////////////////////////////////////////////////
int StcRoutList(int eid, webs_t wp, int argc, char_t **argv)
{
	int	nBytesSent=0, entryNum, i;
	SROUT_T entry;
	char *ip, *mask, *gateway, *interface, ipBuf[20], maskBuf[20];

	if ( !apmib_get(MIB_SROUT_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}

	for (i=1; i<=entryNum; i++) {
		*((char *)&entry) = (char)i;
		if ( !apmib_get(MIB_SROUT, (void *)&entry))
			return -1;

		ip = fixed_inet_ntoa(entry.ipAddr);
		if ( !strcmp(ip, "0.0.0.0"))
			ip = "----";
		sprintf(ipBuf," %s", ip);

		mask = fixed_inet_ntoa(entry.maskAddr);
		if ( !strcmp(mask, "0.0.0.0"))
			mask = "----";
		sprintf(maskBuf," %s", mask);

		gateway = fixed_inet_ntoa(entry.gatewayAddr);
		if ( !strcmp(gateway, "0.0.0.0"))
			gateway = "----";

		if ( entry.interface ==0 )
			interface = "LAN";
		else
			interface = "WAN";
		nBytesSent += websWrite(wp, T("<tr align=\"center\" class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("<td>%d</td>\n"),i);
		nBytesSent += websWrite(wp, T("<td>%s</td>\n"),ipBuf);
		nBytesSent += websWrite(wp, T("<td>%s</td>\n"),maskBuf);
		nBytesSent += websWrite(wp, T("<td>%s</td>\n"),gateway);
		nBytesSent += websWrite(wp, T("<td>%d</td>\n"),entry.hopCount);
		nBytesSent += websWrite(wp, T("<td>%s</td>\n"),interface);
		nBytesSent += websWrite(wp, T("<td><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td>\n"),i);
		nBytesSent += websWrite(wp, T("</tr>\n"));
	}
	return nBytesSent;
}

/////////////////////////////////////////////////////////////////////////////
int DMZList(int eid, webs_t wp, int argc, char_t **argv)
{
	int	nBytesSent=0, entryNum, i;
	DMZ_T entry;
	char	 *pIp, *cIp, buf[20];
	int k, l;
	FILE *fp;
	char staTbl[7][20], staFile[15]={"/var/w1.ip"};

#if defined(_Customer_) | defined(_MPPPOE_)
	for (k=0; k<7; k++) {
		sprintf(staFile, "/var/w%d.ip", k+1);
		if ((fp = fopen( staFile ,"r")) != NULL) {
			fgets(staTbl[k], 20, fp);
			for(l=0; l<20; l++) {
				if(staTbl[k][l]=='\n') {
					staTbl[k][l]='\0';
					break;
				}
			}
			fclose(fp);
		}
		else
		{
			staTbl[k][0]='\0';
		}
	}
#else
	if ((fp = fopen( staFile ,"r")) != NULL) {
		for (k=0; k<7; k++) {
			fgets(staTbl[k], 20, fp);
			for(l=0; l<20; l++) {
				if(staTbl[k][l]=='\n') {
					staTbl[k][l]='\0';
					break;
				}
			}
		}
		fclose(fp);
	}
#endif
	if ( !apmib_get(MIB_DMZ_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}

	for (i=1; i<=entryNum; i++) {
		*((char *)&entry) = (char)i;
		if ( !apmib_get(MIB_DMZ, (void *)&entry))
			return -1;

		pIp = fixed_inet_ntoa(entry.pipAddr);
		if ( !strcmp(pIp, "0.0.0.0")) {
#if defined(_Customer_) | defined(_MPPPOE_)
//			if (fopen( staFile ,"r") == NULL)
			if (staTbl[entry.session-1][0] == '\0')
			{
				pIp = "WAN 1";
				if(entry.session == 2)
					pIp = "WAN 2";
			}
			else
				pIp = staTbl[entry.session-1];
#elif defined(_zio_)
			char buf1[50];
			buf1[0]='\0';
			system("wan-status.sh");
			if ((fp = fopen("/var/run/wanstat","r"))!=NULL) {
					fgets(buf1, 50, fp);
					fgets(buf1, 50, fp);
				}
			if (fopen( staFile ,"r") == NULL) strcpy(pIp,buf1);
			else pIp = staTbl[entry.session-1];

#else
			if (fopen( staFile ,"r") == NULL)
				pIp = "----";
			else
				pIp = staTbl[entry.session-1];
#endif
		}
		sprintf(buf," %s", pIp);

		cIp = fixed_inet_ntoa(entry.cipAddr);
		if ( !strcmp(cIp, "0.0.0.0"))
			cIp = "----";


		nBytesSent += websWrite(wp, T("<tr align=\"center\" class=\"table2\">\n"));


		nBytesSent += websWrite(wp, T("<td>%d</td>\n"),i);

		#ifdef _NETBIOSNAME_
		nBytesSent += websWrite(wp, T("<td><script>document.write(searchComName(\"%s\",0))</script></td>\n"),cIp);
		#endif

		nBytesSent += websWrite(wp, T("<td>%s</td>\n"),buf);
		nBytesSent += websWrite(wp, T("<td>%s</td>\n"),cIp);
		nBytesSent += websWrite(wp, T("<td><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td>\n"),i);
		nBytesSent += websWrite(wp, T("</tr>\n"));

	}

	return nBytesSent;
}


/////////////////////////////////////////////////////////////////////////////
int ACPCList(int eid, webs_t wp, int argc, char_t **argv)
{
	int	nBytesSent=0, entryNum, i, j, k=1;
	ACPC_T entry;
	char	*type, sip[25], eip[25];
	char	Range[100], Index[20], tmpRange[20];
	char	serName[500], buf[60];

	if ( !apmib_get(MIB_ACPC_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}

	for (i=1; i<=entryNum; i++) {
		*((char *)&entry) = (char)i;
		if ( !apmib_get(MIB_ACPC, (void *)&entry))
			return -1;
//Fixed by Kyle 2007/12/19
		 strcpy(sip,fixed_inet_ntoa(entry.sipAddr));
		 //sip = fixed_inet_ntoa(entry.sipAddr);
		if ( !strcmp(sip, "0.0.0.0"))
			sprintf(sip,"----");
			sprintf(buf,"%s", sip);
//Fixed by Kyle 2007/12/19
		strcpy(eip,fixed_inet_ntoa(entry.eipAddr));
		//eip = fixed_inet_ntoa(entry.eipAddr);
		if ( !strcmp(sip,eip)) {
			sprintf(eip, "");
			strcat(buf,eip);
		}
		else {
			strcat(buf,"-");
			strcat(buf,eip);
		}

//---------------------------------------------------------------------------------------
		snprintf(Index, 20, "%lu", entry.serindex);
		memset(serName,0,sizeof(serName));
		if (entry.serindex & 1 ) strncat(serName,"WWW",3);
		if (entry.serindex & 2 ) strncat(serName,", E-mail Sending",16);
		if (entry.serindex & 4 ) strncat(serName,", News Forums",13);
		if (entry.serindex & 8 ) strncat(serName,", E-mail Receiving",18);
		if (entry.serindex & 16 ) strncat(serName,", Secure HTTP",13);
		if (entry.serindex & 32 ) strncat(serName,", File Transfer",15);
		if (entry.serindex & 64 ) strncat(serName,", MSN Messenger",15);
		if (entry.serindex & 128 ) strncat(serName,", Telnet Service",16);
		if (entry.serindex & 256 ) strncat(serName,", AIM",5);
		if (entry.serindex & 512 ) strncat(serName,", NetMeeting",12);
		if (entry.serindex & 1024 ) strncat(serName,", DNS",5);
		if (entry.serindex & 2048 ) strncat(serName,", SNMP",6);
		if (entry.serindex & 4096 ) strncat(serName,", VPN-PPTP",10);
		if (entry.serindex & 8192 ) strncat(serName,", VPN-L2TP",10);
		if (entry.serindex & 16384 ) strncat(serName,", TCP",5);
		if (entry.serindex & 32768 ) strncat(serName,", UDP",5);
		if (serName[0]== ',') serName[0]= ' ';

		if ( entry.protoType == PROTO_BOTH )
			type = "TCP+UDP";
		else if ( entry.protoType == PROTO_TCP )
			type = "TCP";
		else
			type = "UDP";

		memset(Range,0,sizeof(Range));
		for (j=0 ; j<5 ; j++)
		{
			if ( entry.Port[j][0] != 0)
			{
				if ( entry.Port[j][0] == entry.Port[j][1] )
					snprintf(tmpRange, 20, "%d", entry.Port[j][0]);
				else
					snprintf(tmpRange, 20, "%d-%d", entry.Port[j][0], entry.Port[j][1]);
				if(j != 0)
					strcat(Range, ", ");
				strcat(Range, tmpRange);
			}
		}
		if ( !strcmp(Range,"") )
			type = "";

		nBytesSent += websWrite(wp, T("<tr align=\"center\" class=\"table2\">"));
		nBytesSent += websWrite(wp, T("<td ><font size=\"2\">%d</td>\n"),i);
		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\"><font size=\"2\">%s</td>\n"),entry.comment);
		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\"><font size=\"2\">%s</td>\n"),buf);
		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\"><font size=\"2\">%s</td>\n"),serName);
		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\"><font size=\"2\">%s</td>\n"),type);
		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\"><font size=\"2\">%s</td>\n"),Range);
		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td></tr>\n"),i);

	}

	return nBytesSent;
}


/////////////////////////////////////////////////////////////////////////////
/*int ipFilterList(int eid, webs_t wp, int argc, char_t **argv)
{
	int	nBytesSent=0, entryNum, i;
	IPFILTER_T entry;
	char	*type, *ip;

	if ( !apmib_get(MIB_IPFILTER_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}

	nBytesSent += websWrite(wp, T("<tr>"
      	"<td align=center width=\"30%%\" bgcolor=\"#808080\"><font size=\"2\"><b>Local IP Address</b></font></td>\n"
      	"<td align=center width=\"25%%\" bgcolor=\"#808080\"><font size=\"2\"><b>Protocol</b></font></td>\n"
      	"<td align=center width=\"25%%\" bgcolor=\"#808080\"><font size=\"2\"><b>Comment</b></font></td>\n"
      	"<td align=center width=\"20%%\" bgcolor=\"#808080\"><font size=\"2\"><b>Select</b></font></td></tr>\n"));

	for (i=1; i<=entryNum; i++) {
		*((char *)&entry) = (char)i;
		if ( !apmib_get(MIB_IPFILTER, (void *)&entry))
			return -1;

		ip = inet_ntoa(*((struct in_addr *)entry.ipAddr));
		if ( !strcmp(ip, "0.0.0.0"))
			ip = "----";

		if ( entry.protoType == PROTO_BOTH )
			type = "TCP+UDP";
		else if ( entry.protoType == PROTO_TCP )
			type = "TCP";
		else
			type = "UDP";

		nBytesSent += websWrite(wp, T("<tr>"
			"<td align=center width=\"30%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</td>\n"
      			"<td align=center width=\"25%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</td>\n"
      			"<td align=center width=\"25%%\" bgcolor=\"#C0C0C0\"><font size=\"2\">%s</td>\n"
      			"<td align=center width=\"20%%\" bgcolor=\"#C0C0C0\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td></tr>\n"),
				ip, type, entry.comment, i);
	}
	return nBytesSent;
}
*/

/////////////////////////////////////////////////////////////////////////////
int URLBList(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0, entryNum, i;
	URLB_T entry;

	if ( !apmib_get(MIB_URLB_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}

	for (i=1; i<=entryNum; i++) {
		*((char *)&entry) = (char)i;
		if ( !apmib_get(MIB_URLB, (void *)&entry))
			return -1;

		nBytesSent += websWrite(wp, T("<tr align=\"center\" class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("<td>%d</td>\n"),i);
		nBytesSent += websWrite(wp, T("<td>%s</td>\n"),entry.URLBAddr);
		nBytesSent += websWrite(wp, T("<td><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td>\n"),i);
		nBytesSent += websWrite(wp, T("</tr>\n"));
	}


	return nBytesSent;
}

/////////////////////////////////////////////////////////////////////////////
int macFilterList(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0, entryNum, i;
	MACFILTER_T entry;
	char tmpBuf[100];
	char tmpBuf2[100];

	if ( !apmib_get(MIB_MACFILTER_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}

	for (i=1; i<=entryNum; i++) {
		*((char *)&entry) = (char)i;
		if ( !apmib_get(MIB_MACFILTER, (void *)&entry))
			return -1;

		snprintf(tmpBuf, 100, T("%02x:%02x:%02x:%02x:%02x:%02x"),
			entry.macAddr[0], entry.macAddr[1], entry.macAddr[2],
			entry.macAddr[3], entry.macAddr[4], entry.macAddr[5]);
		snprintf(tmpBuf2, 100, T("%02x%02x%02x%02x%02x%02x"),
			entry.macAddr[0], entry.macAddr[1], entry.macAddr[2],
			entry.macAddr[3], entry.macAddr[4], entry.macAddr[5]);

		nBytesSent += websWrite(wp, T("<tr align=\"center\" class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("<td>%d</td>\n"),i);

		#ifdef _NETBIOSNAME_
		nBytesSent += websWrite(wp, T("<td><script>document.write(searchComName(\"%s\",2))</script></td>\n"),tmpBuf2);
		#endif

		nBytesSent += websWrite(wp, T("<td>%s</td>\n"),tmpBuf);
		nBytesSent += websWrite(wp, T("<td>&nbsp;%s</td>\n"),CharFilter4(entry.comment));
		nBytesSent += websWrite(wp, T("<td><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td>\n"),i);
		nBytesSent += websWrite(wp, T("</tr>\n"));
	}


	return nBytesSent;
}

/////////////////////////////////////////////////////////////////////////////
int triggerPortList(int eid, webs_t wp, int argc, char_t **argv)
{
	int	nBytesSent=0, entryNum, i;
	TRIGGERPORT_T entry;
	char	*triType, triPortRange[20], *incType, Range[100], tmpRange[20];

	char tcpRange[100], udpRange[100], *ipAddr;

	if ( !apmib_get(MIB_TRIGGERPORT_NUM, (void *)&entryNum))
	{
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}


	for (i=1; i<=entryNum; i++)
	{
		*((char *)&entry) = (char)i;
		if ( !apmib_get(MIB_TRIGGERPORT, (void *)&entry)) return -1;

		ipAddr=fixed_inet_ntoa(entry.ip);
		int j;
		memset(tcpRange,0,sizeof(tcpRange));
		for (j=0 ; j<5 ; j++)
		{
			if ( entry.tcp_port[j][0] != 0)
			{
				if ( entry.tcp_port[j][0] == entry.tcp_port[j][1] )
					snprintf(tmpRange, 20, "%d", entry.tcp_port[j][0]);
				else
					snprintf(tmpRange, 20, "%d-%d", entry.tcp_port[j][0], entry.tcp_port[j][1]);
				if(j != 0)
					strcat(tcpRange, ",");
				strcat(tcpRange, tmpRange);
			}
		}
		memset(udpRange,0,sizeof(udpRange));
		for (j=0 ; j<5 ; j++)
		{
			if ( entry.udp_port[j][0] != 0)
			{
				if ( entry.udp_port[j][0] == entry.udp_port[j][1] )
					snprintf(tmpRange, 20, "%d", entry.udp_port[j][0]);
				else
					snprintf(tmpRange, 20, "%d-%d", entry.udp_port[j][0], entry.udp_port[j][1]);
				if(j != 0)
					strcat(udpRange, ",");
				strcat(udpRange, tmpRange);
			}
		}
	
		nBytesSent += websWrite(wp, T("<tr align=\"center\" class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("  <td>%d</td>\n"),i);
		#ifdef _NETBIOSNAME_
		nBytesSent += websWrite(wp, T("  <td><script>document.write(searchComName(\"%s\",0))</script></td>\n"),ipAddr);
		#endif
		nBytesSent += websWrite(wp, T("  <td>%s</td>\n"),ipAddr);
		nBytesSent += websWrite(wp, T("  <td>%s</td>\n"),tcpRange);
		nBytesSent += websWrite(wp, T("  <td>%s</td>\n"),udpRange);
		nBytesSent += websWrite(wp, T("  <td>%s</td>\n"),CharFilter4(entry.comment));
		nBytesSent += websWrite(wp, T("  <td><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td>\n"),i);

		nBytesSent += websWrite(wp, T("</tr>\n"));
	}
	return nBytesSent;
}






















































#endif // HOME_GATEWAY
