/*
 *      Web server handler routines for management (password, save config, f/w update)
 *
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *
 *      $Id: fmmgmt.c,v 1.3 2005/05/13 07:53:51 tommy Exp $
 *
 */

#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>

#include "../../../define/C_DEFINE.h"
#include "../webs.h"
#ifndef _BOA_
#include "../um.h"
#endif
#include "apmib.h"
#include "apform.h"
#include "utility.h"

#define DEFAULT_GROUP		T("administrators")
#define ACCESS_URL		T("/")

static char superName[MAX_NAME_LEN]={0}, superPass[MAX_NAME_LEN]={0};
static char userName[MAX_NAME_LEN]={0}, userPass[MAX_NAME_LEN]={0};

#ifdef _LOGIN_WEB_
#include <time.h>
int KeyID[100];
int id;
int IDtime[100];
#endif

#ifdef _Systempingtool_
	pingstatus = 0;
#endif
////////////////////////////////////////////////////////////////////////////////
static int flash_write(char *buf, int offset, int len)
{
	int fh;
	int ok=1;

	fh = open(FLASH_DEVICE_NAME, O_RDWR);

	if ( fh == -1 )
		return 0;

	lseek(fh, offset, SEEK_SET);

	if ( write(fh, buf, len) != len)
		ok = 0;

	close(fh);
	sync();

	return ok;
}
////////////////////////////////////////////////////////////////////////////////
#ifdef _LITTLE_ENDIAN_
static void swap_mib_word_value(APMIB_Tp pMib)
{
	pMib->fragThreshold = WORD_SWAP(pMib->fragThreshold);
	pMib->rtsThreshold = WORD_SWAP(pMib->rtsThreshold);
	pMib->supportedRates = WORD_SWAP(pMib->supportedRates);
	pMib->basicRates = WORD_SWAP(pMib->basicRates);
	pMib->beaconInterval = WORD_SWAP(pMib->beaconInterval);
	pMib->inactivityTime = DWORD_SWAP(pMib->inactivityTime);
	pMib->leaseTime = DWORD_SWAP(pMib->leaseTime);
#if defined(_Customer_EX_) || defined(_Customer_SA_)
	pMib->wpaGroupRekeyTime1 = DWORD_SWAP(pMib->wpaGroupRekeyTime1);
	pMib->wpaGroupRekeyTime2 = DWORD_SWAP(pMib->wpaGroupRekeyTime2);
	pMib->wpaGroupRekeyTime3 = DWORD_SWAP(pMib->wpaGroupRekeyTime3);
	pMib->wpaGroupRekeyTime4 = DWORD_SWAP(pMib->wpaGroupRekeyTime4);
	pMib->wpaGroupRekeyTime5 = DWORD_SWAP(pMib->wpaGroupRekeyTime5);
	pMib->wpaGroupRekeyTime6 = DWORD_SWAP(pMib->wpaGroupRekeyTime6);
	pMib->wpaGroupRekeyTime7 = DWORD_SWAP(pMib->wpaGroupRekeyTime7);
#endif
#if defined(_AP_WITH_TIMEZONE_)
	pMib->TimeZoneSel = WORD_SWAP(pMib->TimeZoneSel);
#endif
#ifdef WLAN_WPA
	pMib->wpaGroupRekeyTime = DWORD_SWAP(pMib->wpaGroupRekeyTime);
	pMib->rsPort = WORD_SWAP(pMib->rsPort);
	pMib->accountRsPort = WORD_SWAP(pMib->accountRsPort);
	pMib->accountRsUpdateDelay = WORD_SWAP(pMib->accountRsUpdateDelay);
	pMib->rsIntervalTime = WORD_SWAP(pMib->rsIntervalTime);
	pMib->accountRsIntervalTime = WORD_SWAP(pMib->accountRsIntervalTime);
#endif

#ifdef HOME_GATEWAY
{
	int i,j;
	pMib->TimeZoneSel = WORD_SWAP(pMib->TimeZoneSel);
	pMib->startMonth = WORD_SWAP(pMib->startMonth);
	pMib->startDay = WORD_SWAP(pMib->startDay);
	pMib->endMonth = WORD_SWAP(pMib->endMonth);
	pMib->endDay = WORD_SWAP(pMib->endDay);
	pMib->reManPort = WORD_SWAP(pMib->reManPort);
	pMib->pppMTU = WORD_SWAP(pMib->pppMTU);
#if defined(_Customer_) | defined(_MPPPOE_)
	pMib->pppMTU1 = WORD_SWAP(pMib->pppMTU1); //alex 2007/01/31
	pMib->pppUnnumNAT = WORD_SWAP(pMib->pppUnnumNAT); //alex 2007/01/31
	pMib->pppoeMode = WORD_SWAP(pMib->pppoeMode); //alex 2007/01/31
#endif
	pMib->L2TPMTU = WORD_SWAP(pMib->L2TPMTU);
	pMib->pptpMTU = WORD_SWAP(pMib->pptpMTU);
	pMib->pppIdleTime = WORD_SWAP(pMib->pppIdleTime);
	pMib->pptpIdleTime = WORD_SWAP(pMib->pptpIdleTime);
	pMib->L2TPIdleTime = WORD_SWAP(pMib->L2TPIdleTime);
	pMib->appLayerGateway = DWORD_SWAP(pMib->appLayerGateway);
	pMib->dhisHostID = DWORD_SWAP(pMib->dhisHostID);
	pMib->podPack = WORD_SWAP(pMib->podPack);
	pMib->podBur = WORD_SWAP(pMib->podBur);
	pMib->synPack = WORD_SWAP(pMib->synPack);
	pMib->synBur = WORD_SWAP(pMib->synBur);
	pMib->scanNum = WORD_SWAP(pMib->scanNum);
//////////////////////////////////////////////////////////////////////////////////////////////
	for (i=0; i<pMib->vserNum; i++) {
		pMib->vserArray[i].fromPort = WORD_SWAP(pMib->vserArray[i].fromPort);
		pMib->vserArray[i].toPort = WORD_SWAP(pMib->vserArray[i].toPort);
	}
	for (i=0; i<pMib->portFwNum; i++) {
		pMib->portFwArray[i].fromPort = WORD_SWAP(pMib->portFwArray[i].fromPort);
		pMib->portFwArray[i].toPort = WORD_SWAP(pMib->portFwArray[i].toPort);
	}
	for (i=0; i<pMib->portFilterNum; i++) {	//no use
		pMib->portFilterArray[i].fromPort = WORD_SWAP(pMib->portFilterArray[i].fromPort);
		pMib->portFilterArray[i].toPort = WORD_SWAP(pMib->portFilterArray[i].toPort);
	}
	for (i=0; i<pMib->triggerPortNum; i++) {
		/*kyle
		pMib->triggerPortArray[i].tri_fromPort = WORD_SWAP(pMib->triggerPortArray[i].tri_fromPort);
		pMib->triggerPortArray[i].tri_toPort = WORD_SWAP(pMib->triggerPortArray[i].tri_toPort);
		for (j=0; j<=4; j++) {
			pMib->triggerPortArray[i].inc_fromPort[j][0] = WORD_SWAP(pMib->triggerPortArray[i].inc_fromPort[j][0]);
			pMib->triggerPortArray[i].inc_fromPort[j][1] = WORD_SWAP(pMib->triggerPortArray[i].inc_fromPort[j][1]);
		}
		pMib->triggerPortArray[i].inc_toPort = WORD_SWAP(pMib->triggerPortArray[i].inc_toPort);
		kyle*/

		for (j=0; j<=4; j++) {
			pMib->triggerPortArray[i].tcp_port[j][0] = WORD_SWAP(pMib->triggerPortArray[i].tcp_port[j][0]);
			pMib->triggerPortArray[i].tcp_port[j][1] = WORD_SWAP(pMib->triggerPortArray[i].tcp_port[j][1]);

			pMib->triggerPortArray[i].udp_port[j][0] = WORD_SWAP(pMib->triggerPortArray[i].udp_port[j][0]);
			pMib->triggerPortArray[i].udp_port[j][1] = WORD_SWAP(pMib->triggerPortArray[i].udp_port[j][1]);
		}
	}
	for (i=0; i<pMib->ACPCNum; i++) {
		pMib->ACPCArray[i].serindex = DWORD_SWAP(pMib->ACPCArray[i].serindex);
		for (j=0; j<=4; j++) {
			pMib->ACPCArray[i].Port[j][0] = WORD_SWAP(pMib->ACPCArray[i].Port[j][0]);
			pMib->ACPCArray[i].Port[j][1] = WORD_SWAP(pMib->ACPCArray[i].Port[j][1]);
		}
	}
	for (i=0; i<pMib->sroutNum; i++) {
		pMib->sroutArray[i].hopCount = WORD_SWAP(pMib->sroutArray[i].hopCount);
	}
}
#endif

}
#endif

///////////////////////////////////////////////////////////////////
//static void reset_user_profile()
//modify by vance 2009.03.11
void reset_user_profile()
{
#ifndef _BOA_
	struct stat status;
	umClose();

	if ( stat(T("umconfig.txt"), &status) == 0) // file existed
               	unlink(T("umconfig.txt"));

	umOpen();
	umRestore(T("umconfig.txt"));

	set_user_profile();
#else
	return;
#endif
}


/////////////////////////////////////////////////////////////////////////////
static unsigned short fwChecksumOk(char_t *data, int len)
{
	unsigned short sum=0;
	int i;

	for (i=0; i<len; i+=2) {
#ifdef _LITTLE_ENDIAN_
		sum += WORD_SWAP( *((unsigned short *)&data[i]) );
#else
		sum += *((unsigned short *)&data[i]);
#endif

	}
	return( (sum==0) ? 1 : 0);
}

/////////////////////////////////////////////////////////////////////////////
static unsigned short  fwChecksum(char_t *data, int len)
{
    unsigned short sum=0;
	int i;

	for (i=0; i<len; i+=2) {
    	#ifdef _LITTLE_ENDIAN_
   		sum += WORD_SWAP( *((unsigned short *)&data[i]) );
		#else
    	sum += *((unsigned short *)&data[i]);
		#endif
    }

	return( 0 - sum );
}


///////////////////////////////////////////////////////////////////////////////
void formAccept(webs_t wp, char_t *path, char_t *query)
{
    char_t  *submitUrl;
	//printf("\nkillall processes\n");
	//#ifdef __TARGET_BOARD__		//Erwin
	//	system("killall auth upnpd udhcpc iwcontrol diagd cleanlog.sh udhcpd");
	//#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	system(submitUrl);
	if (submitUrl[0])
		websRedirect(wp, submitUrl);
	else
		websDone(wp, 200);
  	return;
}
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
void formReboot(webs_t wp)
{
    char tmpBuf[200];
    char_t  *submitUrl;
    int	pid;
	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	//sprintf(tmpBuf, T("System Restarting! Please wait for a while !"));
	sprintf(tmpBuf, T("<script>document.write(showText(sysrst));</script>"));

	OK_MSG3(tmpBuf, submitUrl);
	system("/bin/reboot.sh 2 &");
}
///////////////////////////////////////////////////////////////////////////////
void formApply(webs_t wp) // Tommy 2005.8.24
{
    char tmpBuf[200];
    unsigned char buffer[100];
    unsigned char newurl[150];
    char_t  *submitUrl, *strDeivceSSID;
    int intVal;

	if (lanipChanged == 1) {
		if ( !apmib_get( MIB_IP_ADDR,  (void *)buffer) )
			return -1;

		sprintf(newurl, "http://%s", fixed_inet_ntoa(buffer));
		//sprintf(tmpBuf, T("System Restarting! Please wait for a while !"));
		sprintf(tmpBuf, T("<script>if(window.sysrst) document.write(showText(sysrst)); else  document.write(\"System Restarting! Please wait for a while !\");</script>"));
		//OK_MSG3(tmpBuf, newurl);
		//kill(1,SIGTERM);
	}
	else {
		submitUrl = websGetVar(wp, T("submit-url"), T(""));
		//sprintf(tmpBuf, T("System Restarting! Please wait for a while !"));
		sprintf(tmpBuf, T("<script>if(window.sysrst) document.write(showText(sysrst)); else  document.write(\"System Restarting! Please wait for a while !\");</script>"));
		//OK_MSG3(tmpBuf, submitUrl);
		//kill(1,SIGTERM);
	}
	unsigned char buffer1[100];

	apmib_get( MIB_AP_MODE, (void *)&intVal);
	if (intVal == 2 )
		sprintf(buffer1,"/bin/reboot.sh 2&");
	else
		sprintf(buffer1,"/bin/reset.sh ap 2 &");

	if (lanipChanged == 1){
		OK_MSG3(tmpBuf, newurl);
	}
	else{
		OK_MSG3(tmpBuf, submitUrl);
	}

	int val;	//Thomas_20100611
	apmib_get( MIB_WLAN_ENABLE_1X, (void *)&val);
	if ( val == 1 )
                system("/bin/reboot.sh 2 &");
	else
		system(buffer1);

	lanipChanged = 0;
#if defined(HOME_GATEWAY) || defined(_AP_WITH_WIZARD_)
	wizardEnabled = 0;
#endif
}

//-----------------------------------------------------

//kyle
#ifdef HOME_GATEWAY
///////////////////////////////////////////////////////////////////////////////
void formConnect(webs_t wp) // Tommy 2005.11.02
{
    char tmpBuf[200];
    char_t  *submitUrl;
	int type =2;
	int wanType=atoi(websGetVar(wp,"wanMode",""));
	submitUrl = websGetVar(wp, T("submit-url"), T(""));

	if (strcmp(websGetVar(wp,"buttonact",""),"Connect")==0)
	{
		system("echo on > /var/manual.var");
		int wait_time=30;

		if (wanType == 2)
			system("/bin/pppoe.sh connect"); // Lance 2004.2.3
		if (wanType == 3)
			system("/bin/pptp.sh connect");
		if (wanType == 6)
			#ifdef _L2TPD_
			system("/bin/l2tp_2.sh connect");
			#else
			system("/bin/l2tp.sh connect");
			#endif

		while (wait_time-- >0) {
		if (isConnectPPP())
			break;
			sleep(1);
		}
		if (isConnectPPP())
			strcpy(tmpBuf, T("Connected to server successfully.\n"));
		else
			strcpy(tmpBuf, T("Connect to server failed!\n"));

		OK_MSG1(tmpBuf, submitUrl);
		return;
	}

	if (strcmp(websGetVar(wp,"buttonact",""),"Disconnect")==0)
	{
		system("echo on > /var/manual.var");

		system("/bin/disconnect.sh all"); // Lance 2004.2.3

		if (wanType == 2)
			strcpy(tmpBuf, T("PPPoE disconnected.\n"));
		if (wanType == 3)
			strcpy(tmpBuf, T("PPTP disconnected.\n"));
		if (wanType == 6)
			strcpy(tmpBuf, T("L2TP disconnected.\n"));

		OK_MSG1(tmpBuf, submitUrl);
		return;
	}

	if (strcmp(websGetVar(wp,"buttonact",""),"Renew")==0)
	{
		//system("/bin/init.sh gw all"); // Lance 2004.2.3

		system("killall rdisc"); //Kyle 2007/12/12
		//vance 2009.01.06
		char buf[100];
		sprintf(buf,"dhcpc.sh %s wait",_WAN_IF_);
		system(buf);
		//system("dhcpc.sh eth2.2 wait");//Kyle 2007/12/12

		strcpy(tmpBuf, T("Dynamic IP renew successfully.\n"));

		OK_MSG1(tmpBuf, submitUrl);
		return;
	}
}
#endif
//////////////////////////////////////////////////////////////////////////////////////////////
#ifdef _SYSTEM_LOG_
static int process_msg(char *msg, int is_wlan_only)
{
	char *p1, *p2;
	p1 = strstr(msg, "(none)"); // host name

	if (p1 == NULL)
		return 0;
	if (is_wlan_only == 3){
		p2 = strstr(p1, "DoS");
		if (p2 && p2[3]==':'){
			memcpy(p1, p2, strlen(p2)+1);
		}else{
			p2 = strstr(p1, "wlan");
			if ((p2 && p2[5]==':') || (p2 && p2[9]==':'))	{// vxd interface
				memcpy(p1, p2, strlen(p2)+1);
			}else
				return 0;
			}
	}else if (is_wlan_only == 2){
		p2 = strstr(p1, "DoS");
		if (p2 && p2[3]==':')
			memcpy(p1, p2, strlen(p2)+1);
		else
			return 0;

	}else{
		p2 = strstr(p1, "wlan");
		if ((p2 && p2[5]==':') ||
			 (p2 && p2[9]==':'))	// vxd interface
			memcpy(p1, p2, strlen(p2)+1);
		else {
			if (is_wlan_only)
				return 0;

			p2 = strstr(p1, "klogd ");

			if (p2 == NULL)
				return 0;
			memcpy(p1, p2+6, strlen(p2)-6+1);
		}
	}
	return 1;
}

int sysLogList(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp;
	char  buf[200];
	int nBytesSent=0;
	int enabled;

	apmib_get(MIB_LOG_ENABLED, (void *)&enabled);
	if ( !(enabled & 1))
		goto err1;

	fp = fopen("/var/log/messages", "r");
	if (fp == NULL)
		goto err1;

	while(fgets(buf,200,fp)){
		int ret=0;
		if (enabled&2){ // system all
			ret = process_msg(buf, 0);
		}
		else {
			if((enabled&0xC) == 0xC){ //both wlan and DoS
				ret = process_msg(buf, 3);
			}else if (enabled&4)	// wlan only
				ret = process_msg(buf, 1);
			else if (enabled&8)	//DoS only
				ret = process_msg(buf, 2);
		}
		if (ret==0)
			continue;

		nBytesSent += websWrite(wp, T("%s"), buf);
//printf("buf = %s\n",buf);
	}
	fclose(fp);

err1:
	return nBytesSent;
}

void formSysLog(webs_t wp, char_t *path, char_t *query)
{

	char_t *submitUrl, *tmpStr;
	char tmpBuf[100];
	int enabled, rt_enabled;
	struct in_addr ipAddr ;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	tmpStr = websGetVar(wp, T("clear"), T(""));
	if(tmpStr[0]){
		snprintf(tmpBuf, 100, "echo \" \" > %s", "/var/log/messages");
		system(tmpBuf);
		websRedirect(wp, submitUrl);
		return;
	}

/*
 *	NOTE: If variable enabled (MIB_LOG_ENABLED) bitmask modify(bitmap),
 *	 	Please modify driver rtl8190 reference variable (dot1180211sInfo.log_enabled in linux-2.4.18/drivers/net/rtl8190/8190n_cfg.h)
 */
	apmib_get(MIB_LOG_ENABLED, (void *)&enabled);

	tmpStr = websGetVar(wp, T("logEnabled"), T(""));
	if(!strcmp(tmpStr, "ON")) {
		enabled |= 1;

		tmpStr = websGetVar(wp, T("syslogEnabled"), T(""));
		if(!strcmp(tmpStr, "ON"))
			enabled |= 2;
		else
			enabled &= ~2;

		tmpStr = websGetVar(wp, T("wlanlogEnabled"), T(""));
		if(!strcmp(tmpStr, "ON"))
			enabled |= 4;
		else
			enabled &= ~4;

	}
	else
		enabled &= ~1;

	if ( apmib_set(MIB_LOG_ENABLED, (void *)&enabled) == 0) {
		strcpy(tmpBuf, T("Set log enable error!"));
		goto setErr;
	}

	if(enabled & 1){
		tmpStr = websGetVar(wp, T("rtLogEnabled"), T(""));

		if(!strcmp(tmpStr, "ON"))
			rt_enabled= 1;
		else
			rt_enabled= 0;
		if ( apmib_set(MIB_REMOTELOG_ENABLED, (void *)&rt_enabled) == 0) {
			strcpy(tmpBuf, T("Set remote log enable error!"));
			goto setErr;
		}

		tmpStr = websGetVar(wp, T("logServer"), T(""));
		if(tmpStr[0]){
			inet_aton(tmpStr, &ipAddr);
			if ( apmib_set(MIB_REMOTELOG_SERVER, (void *)&ipAddr) == 0) {
				strcpy(tmpBuf, T("Set remote log server error!"));
				goto setErr;
			}
		}
	}
	apmib_update(CURRENT_SETTING);
	OK_MSG(submitUrl);
	return;

setErr:
	ERR_MSG(tmpBuf);
}
#else
void formSysLog(webs_t wp, char_t *path, char_t *query)
{
	char_t *strSave, *strClear, *submitUrl;
	FILE *fp;
	unsigned char tempbuf[100];
	int rdSize;

	// Save system log to file
	strSave = websGetVar(wp, T("send"), T(""));
	if (strSave[0]) {
		websWrite(wp, "HTTP/1.0 200 OK\n");
		websWrite(wp, "Content-Type: application/octet-stream;\n");
		websWrite(wp, "Content-Disposition: attachment;filename=\"syslog.txt\" \n");
		websWrite(wp, "Pragma: no-cache\n");
		websWrite(wp, "Cache-Control: no-cache\n");
		websWrite(wp, "\n");
		if ((fp = fopen("/var/log/syslog","r"))!=NULL) {
			while ((rdSize = fread(tempbuf, 1, 100, fp)) !=0 )
				websWriteDataNonBlock(wp, tempbuf, rdSize);
			fclose(fp);
		}
		websDone(wp, 200);
		return;
	}

	// clear security log file
	strClear = websGetVar(wp, T("reset"), T(""));
	if (strClear[0]) {
		system("/bin/syslog.sh clean");

		submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
		REPLACE_MSG(submitUrl);
		return;
	}
}
#endif
//////////////////////////////////////////////////////////////////////////////////////////////
void formHwSet(webs_t wp, char_t *path, char_t *query)
{
	char_t *strDom, *strNic0, *strNic1, *strWlan, *submitUrl, *strComd, *strInitGain, *strTxCCK, *strTxOFDM, *strWanIP, *strWlanSSID, *strWlanChannel, *strReboot;
	char_t *strAnntenna,*strMcs;
#ifdef _TX_POWER_CONTROL_
        char_t *strTxDeltar;
        char_t *strtxp;
#endif
	unsigned char tempbuf[600];
	char tmpBuf[100];
	int val;
	int intVal;
	//int initgain;
#ifdef _DFS_
		char_t *strReg,*strAReg,*strCountryCode;

		strReg  =  websGetVar(wp, T("countryReg"), T(""));
		strAReg =  websGetVar(wp, T("aBandCountryReg"), T(""));
		strCountryCode=websGetVar(wp,T("countryCode"),T(""));
		if ( strReg[0] ) {
			val = (strReg[0] - '0');
			apmib_set(MIB_HW_COUNTRY_REG, (void *)&val);
		}
		if ( strAReg[0] ) {
			val = (strAReg[0] - '0');
			apmib_set(MIB_HW_COUNTRY_REG_ABAND, (void *)&val);
		}

		if ( strCountryCode[0] ) {
			apmib_set(MIB_HW_COUNTRY_CODE, (void *)strCountryCode);
		}
		apmib_update(HW_SETTING);
#endif
#ifdef _TX_POWER_CONTROL_
                //set TX_POWER Protection
                strtxp = websGetVar(wp, T("tx_power"), T(""));
                if (strtxp[0])
                {
                        if (!gstrcmp(strtxp, T("Normal")))
                                val = 0;
                        else if (!gstrcmp(strtxp, T("Medium")))
                                val = 1;
                        else if (!gstrcmp(strtxp, T("High")))
                                val = 2;
                        else
                        {
                                DEBUGP(tmpBuf, T("Set Transmit Power Adjustment Error"));
                                ERR_MSG(tmpBuf);
                        }
                        if ( apmib_set(MIB_HW_11N_RESERVED9, (void *)&val) == 0)
                        {
                                DEBUGP(tmpBuf, T("Set Transmit Power Adjustment Error"));
                                ERR_MSG(tmpBuf);
                        }
                }
                apmib_update(HW_SETTING);
#endif

	strAnntenna = websGetVar(wp, T("Anntena"), T(""));
	strMcs = websGetVar(wp, T("Mcs"), T(""));
	printf("strAnntenna=%s\n",strAnntenna);
	printf("strMcs=%s\n",strMcs);
	if (strAnntenna[0]) {
		sprintf(tempbuf, "echo TxAntenna=%s >> /etc/Wireless/RT2860AP/RT2860AP.dat", strAnntenna);
		system(tempbuf);
#ifdef _TX_POWER_CONTROL_
                system("ifconfig ra0 down");
                system("ifconfig ra0 up");
#endif
		system("ifconfig wlan0 down");
		system("ifconfig wlan0 up");
	}

	if (strMcs[0]) {
		sprintf(tempbuf, "iwpriv ra0 set HtMcs=%s", strMcs);
		system(tempbuf);
	}
	strDom = websGetVar(wp, T("regDomain"), T(""));
	if (strDom[0]) {
		sprintf(tempbuf, "flash set HW_REG_DOMAIN %s", strDom);
		system(tempbuf);
	}

	strNic0 = websGetVar(wp, T("nic0Addr"), T(""));
	if (strNic0[0]) {
		sprintf(tempbuf, "flash set HW_NIC0_ADDR %s", strNic0);
		system(tempbuf);
	}

	strNic1 = websGetVar(wp, T("nic1Addr"), T(""));
	if (strNic1[0]) {
		sprintf(tempbuf, "flash set HW_NIC1_ADDR %s", strNic1);
		system(tempbuf);
	}

	strWlan = websGetVar(wp, T("wlanAddr"), T(""));
	if (strWlan[0]) {
		sprintf(tempbuf, "flash set HW_WLAN_ADDR %s", strWlan);
		system(tempbuf);

		//pippen 20060421
		sprintf(tempbuf,"iwpriv ra0 e2p 4=%c%c%c%c",strWlan[2],strWlan[3],strWlan[0],strWlan[1]);
		system(tempbuf);
		sprintf(tempbuf,"iwpriv ra0 e2p 6=%c%c%c%c",strWlan[6],strWlan[7],strWlan[4],strWlan[5]);
		system(tempbuf);
		sprintf(tempbuf,"iwpriv ra0 e2p 8=%c%c%c%c",strWlan[10],strWlan[11],strWlan[8],strWlan[9]);
		system(tempbuf);
		if (_RFTYPE_ == "1T1R")
			system("iwpriv ra0 e2p 34=0511");
		else if(_RFTYPE_ == "1T2R")
			system("iwpriv ra0 e2p 34=0512");
		else
			system("iwpriv ra0 e2p 34=0522");

		system(tempbuf);
	}
		sprintf(tempbuf, "flash set IS_RESET_DEFAULT 0");
		system(tempbuf);
	strWanIP = websGetVar(wp, T("wanAddr"), T(""));
	if (strWanIP[0]) {
		sprintf(tempbuf, "ifconfig %s %s", _WAN_IF_, strWanIP);
		system(tempbuf);
	}

	strWlanSSID = websGetVar(wp, T("wlanSSID"), T(""));
	if (strWlanSSID[0]) {
		sprintf(tempbuf, "iwpriv ra0 set SSID=%s", strWlanSSID);
		system(tempbuf);

	}

	strWlanChannel = websGetVar(wp, T("wlanChan"), T(""));
	if (strWlanChannel[0]) {
		sprintf(tempbuf, "iwpriv ra0 set Channel=%s", strWlanChannel);
		system(tempbuf);

	}

	strComd = websGetVar(wp, T("comd"), T(""));
	if (strComd[0]) {
		printf("%s\n",strComd);
		system(strComd);
	}
#if 1
	strInitGain = websGetVar(wp, T("initgain"), T("")); // Tommy Added on 01/17/2006
	if (strInitGain[0]) {
		//initgain = strtol( strInitGain, (char **)NULL, 10);
		//if ( apmib_set(MIB_HW_INIT_GAIN, (void *)&initgain) == 0) {
   	 	//	DEBUGP(tmpBuf, T("Set Repeater SSID error!"));
		//	goto setErr_wlan;
		//}
		//apmib_update(CURRENT_SETTING);
		sprintf(tempbuf, "flash set HW_INIT_GAIN %s", strInitGain);
		system(tempbuf);
	}

	strTxCCK = websGetVar(wp, T("txcck"), T("")); // Tommy Added on 01/17/2006
	if (strTxCCK[0]) {
		sprintf(tempbuf, "flash set HW_TX_POWER_CCK %s", strTxCCK);
		system(tempbuf);
	}

	strTxOFDM = websGetVar(wp, T("txofdm"), T("")); // Tommy Added on 01/17/2006
	if (strTxOFDM[0]) {
		sprintf(tempbuf, "flash set HW_TX_POWER_OFDM %s 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14 14", strTxOFDM);
		system(tempbuf);
	}
#endif
	strReboot = websGetVar(wp, T("isReboot"), T(""));
	if (strReboot[0]) {
		if ( !gstrcmp(strReboot, T("no")))
			val = 1;
		else
			val = 0;
	}

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	if (val == 1) {
		apmib_reinit();
		websRedirect(wp, submitUrl);
#ifdef _TX_POWER_CONTROL_
                system("/bin/reboot.sh 3 &");
#endif

	}
	else {
		OK_MSG3(tmpBuf, submitUrl);
		system("killall -SIGTERM pppd");
		kill(1,SIGTERM);
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////
void formSecLog(webs_t wp, char_t *path, char_t *query)
{
	char_t *strSave, *strClear, *submitUrl;
	FILE *fp;
	unsigned char tempbuf[100];
	int rdSize;

	// Save security log to file
	strSave = websGetVar(wp, T("send"), T(""));
	if (strSave[0]) {

		websWrite(wp, "HTTP/1.0 200 OK\n");
		websWrite(wp, "Content-Type: application/octet-stream;\n");
		websWrite(wp, "Content-Disposition: attachment;filename=\"security.txt\" \n");
		websWrite(wp, "Pragma: no-cache\n");
		websWrite(wp, "Cache-Control: no-cache\n");
		websWrite(wp, "\n");

		if ((fp = fopen("/var/log/security","r"))!=NULL) {
			while ((rdSize = fread(tempbuf, 1, 100, fp)) !=0 )
				websWriteDataNonBlock(wp, tempbuf, rdSize);
			fclose(fp);
		}
		websDone(wp, 200);
		return;
	}

	// clear security log file
	strClear = websGetVar(wp, T("reset"), T(""));
	if (strClear[0]) {
		system("/bin/seclog.sh clean");

		submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
		REPLACE_MSG(submitUrl);
		return;
	}
}
#ifdef _WLCIOLOG_
void formWlLog(webs_t wp, char_t *path, char_t *query)
{
	char_t *strSave, *strClear, *submitUrl;
	FILE *fp;
	unsigned char tempbuf[100];
	int rdSize;

	// Save wireless log to file
	strSave = websGetVar(wp, T("send"), T(""));
	if (strSave[0]) {

		websWrite(wp, "HTTP/1.0 200 OK\n");
		websWrite(wp, "Content-Type: application/octet-stream;\n");
		websWrite(wp, "Content-Disposition: attachment;filename=\"wirelesslog.txt\" \n");
		websWrite(wp, "Pragma: no-cache\n");
		websWrite(wp, "Cache-Control: no-cache\n");
		websWrite(wp, "\n");

//		system("cp /proc/wlciolog /tmp/wlciolog");

		if ((fp = fopen("/tmp/wlciolog1","r"))!=NULL) {
			while ((rdSize = fread(tempbuf, 1, 100, fp)) !=0 )
				websWriteDataNonBlock(wp, tempbuf, rdSize);
			fclose(fp);
		}
//		system("rm -rf /tmp/wlciolog");
		websDone(wp, 200);
		return;
	}

	// clear wireless log file
#if 0
	strClear = websGetVar(wp, T("reset"), T(""));
	if (strClear[0])
		system("echo 0 > /proc/wlciolog");
#endif
		submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
		REPLACE_MSG(submitUrl);
		return;
}
#endif
//////////////////////////////////////////////////////////////////////////////////////////////
void formDebug(webs_t wp, char_t *path, char_t *query)
{
	char_t *strPass;
	FILE *fp;
	unsigned char buffer[100];
	int rdSize;
	char tmpBuf[200];
	tmpBuf[0] = '\0';	
			
	strPass = websGetVar(wp, T("password"), T(""));
	if (strcmp(strPass,"report.txt")) // Lance 2003.11.05
	{
		strcpy(tmpBuf, T("ERROR: Invalid value of Command !"));
       	goto setErr_debug;
	}

	unlink("/tmp/savelog_finished");
	system("/bin/savelog.sh");

	int wait_time=30;
	while (wait_time-- >0) {
		if (access("/tmp/savelog_finished", 0) == 0) {
			printf("Finished generating report.txt ...\n");
			break;
		}
		sleep(1);
	}
   
	websWrite(wp, "HTTP/1.0 200 OK\n");
	websWrite(wp, "Content-Type: application/octet-stream;\n");
	websWrite(wp, "Content-Disposition: attachment;filename=\"report.txt\" \n"); // Lance 003.11.05
	websWrite(wp, "Pragma: no-cache\n");
	websWrite(wp, "Cache-Control: no-cache\n");
	websWrite(wp, "\n");

	if ((fp = fopen("/var/run/syslog","r"))!=NULL) {
		while ((rdSize = fread(buffer, 1, 100, fp)) !=0 ) {
			//websWriteDataNonBlock(wp, buffer, rdSize);
			websWriteBlock(wp, buffer, rdSize); // tommy
		}
		fclose(fp);
	}
	websDone(wp, 200);
	return;

setErr_debug:
	ERR_MSG(tmpBuf);
	return;
}

// Lance
void formUSBStorage(webs_t wp, char_t *path, char_t *query)
{
	char_t *strRequest;
	char tmpBuf[200];

	strRequest = websGetVar(wp, T("sub_dir"), T(""));

	if( strRequest[0] )
	{
	    sprintf(tmpBuf,"/bin/storage.sh %s", strRequest);
		system(tmpBuf);
	}
	else
		system("/bin/storage.sh");

	REPLACE_MSG("/storage.html");
}
// End-Lance

//////////////////////////////////////////////////////////////////////////////////////////////
#if 0
void formCerload(webs_t wp, char_t *path, char_t *query)
{
	char_t *strCltCerLoad, *strSerCerLoad, *submitUrl;
	char *ptr=NULL;
	int wfh, enCerFile, intVal=1;
	unsigned int flash_addr;
	unsigned short len;
	char tmpBuf[200];
	char *filename;

	strCltCerLoad = websGetVar(wp, T("cltCerLoad"), T(""));
	strSerCerLoad = websGetVar(wp, T("serCerLoad"), T(""));
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	if ( strCltCerLoad[0] ) {
		filename = CLIENT_CERT_NAME;
		flash_addr = CLIENT_CERT_ADDR;
		enCerFile = MIB_CLT_CER_FILE;
		system("rm /cltCer.tgz 2> /dev/null");
	}
	else {
		filename = SERVER_CERT_NAME;
		flash_addr = SERVER_CERT_ADDR;
		enCerFile = MIB_SER_CER_FILE;
		system("rm /ca.pem 2> /dev/null");
	}


	if (strCltCerLoad[0] || strSerCerLoad[0]) {
		ptr = wp->postData;
		len = wp->lenPostData;

		if ( len > CERT_MAX_ADDR-5 ) {
			strcpy(tmpBuf,T("file size is too big!\n"));
			goto back;
		}

		printf("file len=%d\n",len);
		if ( flash_write(&len, flash_addr, sizeof(len))==0 ) {
			strcpy(tmpBuf,T("Write length failed!\n"));
			goto back;
		}
		if ( flash_write((char *)ptr, flash_addr+sizeof(len), wp->lenPostData)==0 ) {
			strcpy(tmpBuf,T("Write flash failed!\n"));
			goto back;
		}

		wfh = open(filename, O_CREAT | O_WRONLY);
		if ( wfh != -1 ) {
			write(wfh, ptr, len);
			close(wfh);
		}

		if ( strCltCerLoad[0] ) {
			system("tar xvf /cltCer.tgz");
		}
		apmib_set( enCerFile, (void *)&intVal );
	}
	apmib_update(CURRENT_SETTING);

	OK_MSG(submitUrl);
	return;
back:
	ERR_MSG(tmpBuf);
	return;
}
#endif
//////////////////////////////////////////////////////////////////////////////////////////////

void formSaveConfig(webs_t wp, char_t *path, char_t *query)
{

	char_t *strRequest, *submitUrl;
	char *buf, *ptr=NULL;
	PARAM_HEADER_Tp pHeader;
	unsigned char checksum;
	int len, status=0, ver, force, len1;
	char tmpBuf[200];
#ifndef NO_ACTION
	int pid;
#endif
	*(wp->upload_data + atoi(wp->content_length))='\0';
	CONFIG_DATA_T type=0;

	len1 = sizeof(PARAM_HEADER_T) + sizeof(APMIB_T) + sizeof(checksum) + 100;  // 100 for expansion
	len = csHeader.len;
#ifdef _LITTLE_ENDIAN_
	len  = WORD_SWAP(len);
#endif
	len += sizeof(PARAM_HEADER_T) + 100;
	if (len1 > len)
		len = len1;

	buf = malloc(len);
	if ( buf == NULL ) {
		strcpy(tmpBuf, "Allocate buffer failed!");
		goto back;
	}
	
	strRequest = websGetVar(wp, T("save-cs"), T(""));
	if (strRequest[0])
		type |= CURRENT_SETTING;

	//strRequest = websGetVar(wp, T("save"), T(""));
	if (strstr(wp->upload_data,"save") > 0)
		type |= CURRENT_SETTING;

	strRequest = websGetVar(wp, T("save-hs"), T(""));
	if (strRequest[0])
		type |= HW_SETTING;

	strRequest = websGetVar(wp, T("save-ds"), T(""));
	if (strRequest[0])
		type |= DEFAULT_SETTING;

	strRequest = websGetVar(wp, T("save-all"), T(""));
	if (strRequest[0])
		type |= HW_SETTING | DEFAULT_SETTING | CURRENT_SETTING;

	if (type) {
		websWrite(wp, "HTTP/1.0 200 OK\n");

		websWrite(wp, "Content-Type: application/octet-stream;\n");
		websWrite(wp, "Content-Disposition: attachment;filename=\"config.bin\" \n");
		websWrite(wp, "Pragma: no-cache\n");
		websWrite(wp, "Cache-Control: no-cache\n");
		websWrite(wp, "\n");

		if (type & HW_SETTING) {
			pHeader = (PARAM_HEADER_Tp)buf;
			len = pHeader->len = hsHeader.len;
			memcpy(&buf[sizeof(PARAM_HEADER_T)], pHwSetting, pHeader->len-1);

#ifdef _LITTLE_ENDIAN_
			pHeader->len  = WORD_SWAP(pHeader->len);
#endif
			memcpy(pHeader->signature, hsHeader.signature, SIGNATURE_LEN);
			ptr = (char *)&buf[sizeof(PARAM_HEADER_T)];
			checksum = CHECKSUM(ptr, len-1);
			buf[sizeof(PARAM_HEADER_T)+len-1] = checksum;

			ptr = &buf[sizeof(PARAM_HEADER_T)];
			ENCODE_DATA(ptr,  len);
			websWriteBlock(wp, buf, len+sizeof(PARAM_HEADER_T));
		}

//		if (type & DEFAULT_SETTING) {			//removed by Erwin
		if (type & CURRENT_SETTING) {
			pHeader = (PARAM_HEADER_Tp)buf;
			len = pHeader->len = dsHeader.len;
//			memcpy(&buf[sizeof(PARAM_HEADER_T)], pMibDef, len-1);	//removed by Erwin
			memcpy(&buf[sizeof(PARAM_HEADER_T)], pMib, len-1);

#ifdef _LITTLE_ENDIAN_
			pHeader->len  = WORD_SWAP(pHeader->len);
			swap_mib_word_value((APMIB_Tp)&buf[sizeof(PARAM_HEADER_T)]);
#endif
			memcpy(pHeader->signature, dsHeader.signature, SIGNATURE_LEN);
			ptr = (char *)&buf[sizeof(PARAM_HEADER_T)];
			checksum = CHECKSUM(ptr, len-1);
			buf[sizeof(PARAM_HEADER_T)+len-1] = checksum;

			ptr = &buf[sizeof(PARAM_HEADER_T)];
			ENCODE_DATA(ptr,  len);

			int sendLength=0;
			int fileLength=len+sizeof(PARAM_HEADER_T);
			//2007.06.11 fixed by Kyle
			//websWriteDataNonBlock(wp, buf, len+sizeof(PARAM_HEADER_T))
			websWriteBlock(wp, buf, len+sizeof(PARAM_HEADER_T));


		}

		websDone(wp, 200);
		free(buf);
		return;
	}

	if (strstr(wp->upload_data,"load") > 0) {
	//strRequest = websGetVar(wp, T("load"), T(""));
	//if (strRequest[0]) {
		len = 0;
		status = 1;
		type = 0;
		
		#ifdef _BOA_
		{
			int iestr_offset;

			iestr_offset = parseMultiPart(wp);
			wp->postData = wp->upload_data + iestr_offset;
			wp->lenPostData = wp->upload_len - iestr_offset;
		}
		#endif
		while (len < wp->lenPostData) {
			pHeader = (PARAM_HEADER_Tp)&wp->postData[len];

#ifdef _LITTLE_ENDIAN_
			pHeader->len = WORD_SWAP(pHeader->len);
#endif
			len += sizeof(PARAM_HEADER_T);

			if ( sscanf(&pHeader->signature[TAG_LEN], "%02d", &ver) != 1)
				ver = -1;

			force = -1;
			if ( !memcmp(pHeader->signature, CURRENT_SETTING_HEADER_TAG, TAG_LEN) )
				force = 1; // update
			else if ( !memcmp(pHeader->signature, CURRENT_SETTING_HEADER_FORCE_TAG, TAG_LEN))
				force = 2; // force
			else if ( !memcmp(pHeader->signature, CURRENT_SETTING_HEADER_UPGRADE_TAG, TAG_LEN))
				force = 0; // upgrade

			if ( force >= 0 ) {

				ptr = &wp->postData[len];

				DECODE_DATA(ptr, pHeader->len);
				if ( !CHECKSUM_OK(ptr, pHeader->len)) {
					status = 0;
					break;
				}
#ifdef _LITTLE_ENDIAN_
				swap_mib_word_value((APMIB_Tp)ptr);
#endif
				apmib_updateFlash(CURRENT_SETTING, ptr, pHeader->len-1, force, ver);
				len += pHeader->len;
				type |= CURRENT_SETTING;
				continue;
			}

			if ( !memcmp(pHeader->signature, DEFAULT_SETTING_HEADER_TAG, TAG_LEN) )
				force = 1;	// update
			else if ( !memcmp(pHeader->signature, DEFAULT_SETTING_HEADER_FORCE_TAG, TAG_LEN) )
				force = 2;	// force
			else if ( !memcmp(pHeader->signature, DEFAULT_SETTING_HEADER_UPGRADE_TAG, TAG_LEN) )
				force = 0;	// upgrade
			char asd[100];

			if ( force >= 0 ) {

				ptr = &wp->postData[len];
				DECODE_DATA(ptr, pHeader->len);
				if ( !CHECKSUM_OK(ptr, pHeader->len)) {
					status = 0;
					break;
				}


#ifdef _LITTLE_ENDIAN_
				swap_mib_word_value((APMIB_Tp)ptr);
#endif
				apmib_updateFlash(DEFAULT_SETTING, ptr, pHeader->len-1, force, ver);
				len += pHeader->len;
				type |= DEFAULT_SETTING;
				continue;
			}


			if ( !memcmp(pHeader->signature, HW_SETTING_HEADER_TAG, TAG_LEN) )
				force = 1;	// update
			else if ( !memcmp(pHeader->signature, HW_SETTING_HEADER_FORCE_TAG, TAG_LEN) )
				force = 2;	// force
			else if ( !memcmp(pHeader->signature, HW_SETTING_HEADER_UPGRADE_TAG, TAG_LEN) )
				force = 0;	// upgrade

			if ( force >= 0 ) {

				ptr = &wp->postData[len];
				DECODE_DATA(ptr, pHeader->len);
				if ( !CHECKSUM_OK(ptr, pHeader->len)) {
					status = 0;
					break;
				}
				apmib_updateFlash(HW_SETTING, ptr, pHeader->len-1, force, ver);
				len += pHeader->len;
				type |= HW_SETTING;
				continue;
			}
		}
		if (status == 0 || type == 0) {// checksum error
			strcpy(tmpBuf, T("<script>if(typeof(aspformSaveConfigInvCfg) !=\"undefined\"){ document.write(showText(aspformSaveConfigInvCfg));}else{ document.write(\"Invalid configuration file!\");}</script>"));
		}
		else {
			if (type) {	// upload success
				if (apmib_reinit() ==0) {
					strcpy(tmpBuf,T("Re-initialize AP MIB failed!\n"));
					goto back;
				}
				reset_user_profile();  // re-initialize user password

			system("/bin/reset.sh ap 2 &");
			}
			strcpy(tmpBuf, T("<script>dw(UpdateSuccessfully)</script>"));
		}
back:

		ERR_MSG(tmpBuf);
		free(buf);
		return;
	}

	if (strstr(wp->upload_data,"reset") > 0) {
		system("/bin/scriptlib_util.sh flashDefault");
		if (apmib_reinit() ==0) {
			free(ptr);
			strcpy(tmpBuf, "Re-initialize AP MIB failed!\n");
			goto back;
		}
		reset_user_profile();  // re-initialize user password
	
		strcpy(tmpBuf, T("<script>document.write(showText(ReloadSettingsSuccessfully))</script>"));

		//printf("run rest s4");
		//ERR_MSG(tmpBuf);
		OK_MSG3(tmpBuf,"/default.asp");
		free(ptr);
		system("/bin/reboot.sh 2 &");	//Felix add 
	}

}
void formSaveConfigSec(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl;
	char *buf, *ptr=NULL;
	PARAM_HEADER_Tp pHeader;
	int len, status=0, ver, force;
	char tmpBuf[200];

	CONFIG_DATA_T type=0;
	len = 0;
	status = 1;
	type = 0;
	
#ifdef _BOA_
        int iestr_offset;
        iestr_offset = parseMultiPart(wp);
        wp->postData = wp->upload_data + iestr_offset;
        wp->lenPostData = wp->upload_len - iestr_offset;
#endif

	while (len < wp->lenPostData) {
		pHeader = (PARAM_HEADER_Tp)&wp->postData[len];

#ifdef _LITTLE_ENDIAN_
		pHeader->len = WORD_SWAP(pHeader->len);
#endif
		len += sizeof(PARAM_HEADER_T);

		if ( sscanf(&pHeader->signature[TAG_LEN], "%02d", &ver) != 1)
			ver = -1;

		force = -1;
		if ( !memcmp(pHeader->signature, CURRENT_SETTING_HEADER_TAG, TAG_LEN) )
			force = 1; // update
		else if ( !memcmp(pHeader->signature, CURRENT_SETTING_HEADER_FORCE_TAG, TAG_LEN))
			force = 2; // force
		else if ( !memcmp(pHeader->signature, CURRENT_SETTING_HEADER_UPGRADE_TAG, TAG_LEN))
			force = 0; // upgrade

		if ( force >= 0 ) {
			ptr = &wp->postData[len];
			DECODE_DATA(ptr, pHeader->len);
			if ( !CHECKSUM_OK(ptr, pHeader->len)) {
				status = 0;
				break;
			}
#ifdef _LITTLE_ENDIAN_
			swap_mib_word_value((APMIB_Tp)ptr);
#endif
			apmib_updateFlash(CURRENT_SETTING, ptr, pHeader->len-1, force, ver);
			len += pHeader->len;
			type |= CURRENT_SETTING;
			continue;
		}
		if ( !memcmp(pHeader->signature, DEFAULT_SETTING_HEADER_TAG, TAG_LEN) ){
			force = 1;	// update
		}	
		else if ( !memcmp(pHeader->signature, DEFAULT_SETTING_HEADER_FORCE_TAG, TAG_LEN) ){
			force = 2;	// force
		}	
		else if ( !memcmp(pHeader->signature, DEFAULT_SETTING_HEADER_UPGRADE_TAG, TAG_LEN) ){
			force = 0;	// upgrade
		}
		if ( force >= 0 ) {
			ptr = &wp->postData[len];
			DECODE_DATA(ptr, pHeader->len);
			if ( !CHECKSUM_OK(ptr, pHeader->len)) {
				status = 0;
				break;
			}

#ifdef _LITTLE_E
			swap_mib_word_value((APMIB_Tp)ptr);
#endif
			apmib_updateFlash(DEFAULT_SETTING, ptr, pHeader->len-1, force, ver);
			len += pHeader->len;
			type |= DEFAULT_SETTING;
			continue;
		}

		if ( !memcmp(pHeader->signature, HW_SETTING_HEADER_TAG, TAG_LEN) )
			force = 1;	// update
		else if ( !memcmp(pHeader->signature, HW_SETTING_HEADER_FORCE_TAG, TAG_LEN) )
			force = 2;	// force
		else if ( !memcmp(pHeader->signature, HW_SETTING_HEADER_UPGRADE_TAG, TAG_LEN) )
			force = 0;	// upgrade

		if ( force >= 0 ) {
			ptr = &wp->postData[len];
			DECODE_DATA(ptr, pHeader->len);
			if ( !CHECKSUM_OK(ptr, pHeader->len)) {
				status = 0;
				break;
			}
			apmib_updateFlash(HW_SETTING, ptr, pHeader->len-1, force, ver);
			len += pHeader->len;
			type |= HW_SETTING;
			continue;
		}

	}
	if (status == 0 || type == 0) // checksum error
		strcpy(tmpBuf, T("<script>if(typeof(aspformSaveConfigInvCfg) !=\"undefined\"){ document.write(showText(aspformSaveConfigInvCfg));}else{ document.write(\"Invalid configuration file!\");}</script>"));

	else {
		if (type) { // upload success
			if (apmib_reinit() ==0) {
				strcpy(tmpBuf,T("Re-initialize AP MIB failed!\n"));
				goto back;
			}
			reset_user_profile();  // re-initialize user password

	#ifdef HOME_GATEWAY
		system("/bin/reset.sh gw 2 &");
	#else
		system("/bin/reset.sh ap 2 &");
	#endif
		}

		strcpy(tmpBuf, T("<script>dw(UpdateSuccessfully)</script>"));

	}
back:

	ERR_MSG(tmpBuf);
	free(buf);
	return;
}
#ifdef _WEBSITE_FIRMWARE_UPGRADE_
void formUploadWebsite(webs_t wp, char_t * path, char_t * query)
{
	char tmpBuf[300],tmpBuf1[500];
	char *tmpchr1, *tmpchr2;
	char_t *strVal;
	FILE *website_upgrade_result;
	int i;
#ifdef _Customer_EX_
	system("> /tmp/website_upgrade_xml; wget http://www.planex.co.jp/support/driver/wireless/mzk-ex300n2/mzk-ex300n2.xml -O /tmp/website_upgrade_xml");
#elif _Customer_SA_
	system("> /tmp/website_upgrade_xml; wget http://www.planex.co.jp/support/driver/wireless/mzk-sa300n2/mzk-sa300n2.xml -O /tmp/website_upgrade_xml");
#elif _Customer_SC_
	system("> /tmp/website_upgrade_xml; wget http://www.planex.co.jp/support/driver/wireless/mzk-sc300n2/mzk-sc300n2.xml -O /tmp/website_upgrade_xml");
#endif
	if( (website_upgrade_result=fopen("/tmp/website_upgrade_xml", "r"))!=NULL )
	//if( (website_upgrade_result=fopen("./MZK-MF300N2.xml", "r"))!=NULL )
	{
		memset(&tmpBuf[0], 0, sizeof(tmpBuf));
		while( fgets(tmpBuf1, sizeof(tmpBuf1)-1, website_upgrade_result) > 0)
		{
			tmpchr1 = strstr(tmpBuf1, "<url>");
			tmpchr2 = strstr(tmpBuf1, "</url>");

			if( tmpchr1!=NULL && tmpchr2!=NULL )
			{
				memcpy(&tmpBuf[0], tmpchr1+strlen("<url>"), tmpchr2-tmpchr1-strlen("<url>") );
				break;
			}
		}
		fclose(website_upgrade_result);


		if(tmpBuf[0]) // XML 裡面有正確找到 <url>xxxxxxxxxx</url>
		{
			sprintf(tmpBuf1, "wget %s -O _WEBSITE_FIRMWARE_UPGRADE_", tmpBuf);
			system(tmpBuf1);

			if( (website_upgrade_result = fopen("/tmp/website_upgrade_result", "r")) != NULL )
			{
				fgets(tmpBuf, sizeof(tmpBuf)-1, website_upgrade_result);
				fclose(website_upgrade_result);
			}
			else
				sprintf(tmpBuf, "UnknownError");
		}
		else // XML 裡面找不到 <url>xxxxxx</url>
			sprintf(tmpBuf, "aspformUploadFilefail");
	}
	else // 打不開 XML
		sprintf(tmpBuf, "aspformUploadFilefail");


	// 把 tmpBuf 後面的空白字元去掉
	for(i=strlen(tmpBuf); i>=0 && (tmpBuf[i]==0x00||tmpBuf[i]==0x0A||tmpBuf[i]==0x0D||tmpBuf[i]==0x09); i--);
	tmpBuf[i+1]=0;

	if( strcmp(tmpBuf, "upgrade_accomplished")) // 如果不是成功訊息，就只顯示訊息
	{
		sprintf(tmpBuf1, "<script>dw(%s)</script>", tmpBuf);
		ERR_MSG(tmpBuf1);
		return;
	}
	else // 如果是成功訊息，就倒數並且重開機
	{
		int pid;
		pid = fork();
		if (pid)
			waitpid(pid, NULL, 0);
		else if (pid == 0)
		{
			WEBSITE_FIRMWARE_UPGRADE_MSG();
			exit(0);
		}
		sleep(2);

		#if defined(__TARGET_BOARD__) && !defined(_LANGUAGE_PACK_)
			#ifndef NO_ACTION
				//add by Kyle 20080229.
				#if defined(_KREBOOT_) && !defined (_NO_KREBOOT_)
					system("echo 1 > /proc/reset_but");
				#else
					system("sleep 2");
					pid = find_pid_by_name("init");
					#ifdef _FW_AB_CONTROL_ //vance 2009.03.13
						if (apmib_set(MIB_HW_FW_CONTROL, (void *)&control) == 0 )
						{
							strcpy(tmpBuf, T("ERROR: Unable to change firmware flag!"));
							goto ret_upload;
						}
						apmib_update(HW_SETTING);
					#endif
				system("sleep 2");
				system("killall -SIGTERM pppd");
				kill(pid, SIGTERM);
				#endif
			#endif
		#endif
		return;
	}
	return;
}
#endif
///////////////////////////////////////////////////////////////////////////////
void formUpload(webs_t wp, char_t * path, char_t * query)
{
#ifdef __TARGET_BOARD__
    int fh;
#else
    FILE *       fp;
    char_t *     bn = NULL;
#endif
    int		 len;
    int          locWrite;
    int          numLeft;
    int          numWrite;
    IMG_HEADER_Tp pHeader;
    char tmpBuf[200];
    char_t *strRequest, *submitUrl, *strVal, *strTarget;
    int flag, startAddr=-1, startAddrWeb=-1, intVal=0; //defEnable=0;	//removed by Erwin
    int target=0; // 0 upgrade router ; 1 upgrade adsl module

		FILE *fp1;
		char fw[2];
#ifndef NO_ACTION
    int pid;
#endif

#ifdef _BOA_
    {
	int iestr_offset;

	iestr_offset = parseMultiPart(wp);
	wp->postData = wp->upload_data + iestr_offset;
	wp->lenPostData = wp->upload_len - iestr_offset;
    }
#endif

#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

#ifdef _Airlive_7428HCN_
	char_t *keepSetting;
	int intVal2;

	if (strstr(wp->upload_data,"keepSetting") > 0)
		intVal2 = 1;
	else
		intVal2 = 0;

	if (apmib_set(MIB_KEEP_CONFIG, (void *)&intVal2) == 0 ){
		printf("ERROR: Unable to change firmware flag!\n");
		goto ret_upload;
	}
	if(intVal2 == 0)
		system("flash default");
#endif
	strRequest = websGetVar(wp, T("save"), T(""));

	if (strRequest[0])
	{
		int fh=0;
		char *buf=NULL;

		#ifdef __TARGET_BOARD__
			char *filename=FLASH_DEVICE_NAME;
			int imageLen=-1;
			IMG_HEADER_T header;
			strVal = websGetVar(wp, T("readAddr"), T(""));
			if ( strVal[0] )
				startAddr = strtol( strVal, (char **)NULL, 16);

			strVal = websGetVar(wp, T("size"), T(""));
			if ( strVal[0] )
				imageLen = strtol( strVal, (char **)NULL, 16);

			fh = open(filename, O_RDONLY);
			if ( fh == -1 ) {
					strcpy(tmpBuf, T("Open file failed!"));
				goto ret_err;
			}
			if (startAddr==-1 || imageLen==-1)
			{
				// read system image
				lseek(fh, CODE_IMAGE_OFFSET, SEEK_SET); // Lance 2003.06.15
				if ( read(fh, &header, sizeof(header)) != sizeof(header)) {
						strcpy(tmpBuf, T("Read image header error!"));
					goto ret_err;
				}

				if ( memcmp(header.signature, FW_HEADER, SIGNATURE_LEN) ) {  // Lance 2003.06.15
						printf("upgrade fail: Invalid file format! ( %s should be %s )\n",
										header.signature,
										FW_HEADER);
						strcpy(tmpBuf, T("Invalid file format!"));
					goto ret_err;
					}

				startAddr = CODE_IMAGE_OFFSET; // Lance 2003.06.15
				imageLen =  sizeof(header) + header.len;
			}

			buf = malloc(0x10000);
			if ( buf == NULL)
			{
					strcpy(tmpBuf, T("Allocate buffer failed!"));
				goto ret_err;
			}

			lseek(fh, startAddr, SEEK_SET);

			websWrite(wp, "HTTP/1.0 200 OK\n");
			websWrite(wp, "Content-Type: application/octet-stream;\n");
			websWrite(wp, "Content-Disposition: attachment;filename=\"apcode.bin\" \n");
			websWrite(wp, "Pragma: no-cache\n");
			websWrite(wp, "Cache-Control: no-cache\n");
			websWrite(wp, "\n");

			while (imageLen > 0)
			{
				int blocksize=0x10000;
				if (imageLen < blocksize)
					blocksize=imageLen;

				if ( read(fh, buf, blocksize) != blocksize) {
						strcpy(tmpBuf, T("Read image error!"));
					goto ret_err;
				}
				websWriteBlock(wp, (char *)buf, blocksize);
				imageLen -= blocksize;
			}

			{
				unsigned short checksum, checksum_org;
				unsigned long readLen = 0;
				unsigned char readBuf[1024];
				unsigned long i;
				int _flashfd;


				//if((_flashfd = open(FLASH_DEVICE_NAME, O_RDWR))<0)
				if((_flashfd = open(UPG_DEVICE_NAME, O_RDWR))<0)
				{
					strcpy(tmpBuf, T("Upgrade failed!"));
					goto ret_err;
				}

				for(i=0; i < 0x40000; i+=0x10000)
				{
					lseek(_flashfd, 0x10000 + i, SEEK_SET);
					read(_flashfd, readBuf, 12);

					if(memcmp(readBuf, "CSYS", 4))
						continue;
					readLen = *((unsigned long *)&readBuf[8]);

					printf("\n\nFound CSYS image in %lx, Len = %lx\n", 0x10000 + i, readLen);
					break;
				}

				if ( i == 0x40000)
				{
					close(_flashfd);
					strcpy(tmpBuf, T("Upgrade failed!"));
					goto ret_err;
				}

				checksum = 0;
				for(i=0 ;i < (readLen); i += 2)
				{
					read(_flashfd, readBuf, 2);
					checksum += *(unsigned short*)readBuf;
				}

				checksum_org = *(unsigned short*)readBuf;

				printf("\n checksum_org = %lx, checksum=%lx\n", checksum_org, checksum);
				if(checksum != 0)
				{
					strcpy(tmpBuf, T("Upgrade failed!"));
					goto ret_err;
				}
			}

			websDone(wp, 200);
		#else
			struct stat status;
			char *filename="apcode.bin";
			if ( stat(filename, &status) < 0 ) {
					strcpy(tmpBuf, T("Stat file failed!"));
				goto ret_err;
			}
			buf = malloc(status.st_size);
			if ( buf == NULL) {
					strcpy(tmpBuf, T("Allocate buffer failed!"));
				goto ret_err;
			}

			fh = open(filename, O_RDONLY);
			if ( fh == -1 ) {
					strcpy(tmpBuf, T("Open file failed!"));
				goto ret_err;
			}
			lseek(fh, CODE_IMAGE_OFFSET, SEEK_SET); // Lance 2003.06.15

			if ( read(fh, buf, status.st_size) != status.st_size) {
					strcpy(tmpBuf, T("Read file failed!"));
				goto ret_err;
			}
			websWriteBlock(wp, (char *)buf, status.st_size);
			websDone(wp, 200);
		#endif
			goto ret_ok;

		ret_err:
			ERR_MSG(tmpBuf);
		ret_ok:
			if (fh>0)
				close(fh);
			if (buf)
				free(buf);
			return;
   }

    // assume as firmware upload
    strVal = websGetVar(wp, T("writeAddrCode"), T(""));
    if ( strVal[0] ) {
	if ( !memcmp(strVal, "0x", 2))
		startAddr = strtol( &strVal[2], (char **)NULL, 16);
    }
    strVal = websGetVar(wp, T("writeAddrWebPages"), T(""));
    if ( strVal[0] ) {
	if ( !memcmp(strVal, "0x", 2))
		startAddrWeb = strtol( &strVal[2], (char **)NULL, 16);
    }
    submitUrl = websGetVar(wp, T("submit-url"), T(""));
    locWrite = 0;
    numLeft = wp->lenPostData;
    pHeader = (IMG_HEADER_Tp) wp->postData;

    // check header and checksum
//	printf("\nddddddd=%s len=%d\n",&wp->postData[12],strlen(&wp->postData[12]));
//    if (!memcmp(wp->postData, FW_HEADER, SIGNATURE_LEN)) { // Lance 2003.06.15
//    	flag = 1;
//	}

#ifdef _milan_
	if ((!memcmp(&wp->postData[MODTAG_LEN], "EWAS", SIGNATURE_LEN))
					|| (!memcmp(&wp->postData[MODTAG_LEN], "WBIP", SIGNATURE_LEN))) {
		if (memcmp(&wp->postData[MODTAG_LEN], _WEB_HEADER_, SIGNATURE_LEN)) {
//			defEnable = 1;	//removed by Erwin
		}
    	flag = 2;
	}
#else
	if ((!memcmp(&wp->postData[0], _WEB_HEADER_, SIGNATURE_LEN)) || (!memcmp(&wp->postData[MODTAG_LEN], "XZKJ", SIGNATURE_LEN))) {
    	flag = 2;
	}
	else {
			printf("upgrade fail: Invalid file format! ( %s should be %s or %s )\n", &wp->postData[0], _WEB_HEADER_,FW_HEADER);
		#ifdef _Customer_
			strcpy(tmpBuf, T("Invalid file format!"));
		#else
       	strcpy(tmpBuf, T("<script>document.write(showText(InvalidSomething).replace(/#####/,showText(FileFormat)))</script>"));
		#endif
      goto ret_upload;
    }
#endif

    len = pHeader->len;
#ifdef _LITTLE_ENDIAN_
    len  = DWORD_SWAP(len);
#endif

	printf("f/w length=%x, checksum=%x\n", len,*((unsigned short *)&wp->postData[sizeof(IMG_HEADER_T) + len-2]));
	if ( !fwChecksumOk(&wp->postData[sizeof(IMG_HEADER_T)], len)) {

		sprintf(tmpBuf, T("<b>Image checksum mismatched!, checksum=0x%x</b><br>"),
						fwChecksum(&wp->postData[sizeof(IMG_HEADER_T)], len-2));
		goto ret_upload;
	}
#ifdef __TARGET_BOARD__
//    fh = open(FLASH_DEVICE_NAME, O_RDWR);
	fh = open(UPG_DEVICE_NAME, O_RDWR);

    if ( fh == -1 ) {
#else
    if (flag == 1)
    	bn = "apcode.bin";
    else
    	bn = "web.gz.up";

    if ((fp = fopen((bn == NULL ? "upldForm.bin" : bn), "w+b")) == NULL) {
#endif
       	strcpy(tmpBuf, T("File open failed!"));
    } else {

#ifdef __TARGET_BOARD__
/*	if (defEnable == 1) {	//removed by Erwin
	    lseek(fh, DEFAULT_SETTING_OFFSET, SEEK_SET);
	    write(fh, "\0\0\0\0", 4);
	}
*/
	if (flag == 1) {
		if ( startAddr == -1)
			startAddr = CODE_IMAGE_OFFSET;
	}
	else {
		if ( startAddrWeb == -1)
			startAddr = WEB_PAGE_OFFSET;
		else
			startAddr = startAddrWeb;
	}
	#ifdef _ADM5120_
		startAddr = 0; // Rex Add for 7205ASg and 6214WSg
		lseek(fh, startAddr+WEB_PAGE_OFFSET, SEEK_SET);	//Modified lance 2005
		numWrite = write(fh, &(wp->postData[locWrite+WEB_PAGE_OFFSET]), numLeft-WEB_PAGE_OFFSET);	//lance 2005
	#else
		/*#ifdef _UPGRADE_PROCESS_
		int pid;
		pid = fork();
		if (pid) {
			waitpid(pid, NULL, 0);
		}
		else if (pid == 0) {
#ifdef _STAR_
			UPGRADE_PROCESS_MSG(130);
#else
			UPGRADE_PROCESS_MSG();
#endif
			exit(0);
		}
		sleep(2);
		#endif*/
		UPGRADE_PROCESS_MSG(); //EDX
		lseek(fh, startAddr, SEEK_SET);	//Modified lance 2005
			numWrite = write(fh, &(wp->postData[locWrite]), numLeft);	//lance 2005
	#endif
#else
	#ifdef _UPGRADE_PROCESS_
		int pid;
		pid = fork();
		if (pid) waitpid(pid, NULL, 0);
		else if (pid == 0)
		{
		#ifdef _STAR_
			UPGRADE_PROCESS_MSG(130);
		#else
			UPGRADE_PROCESS_MSG();
		#endif
		exit(0);
		}
	#endif
	numWrite = fwrite(&(wp->postData[locWrite]), sizeof(*(wp->postData)), numLeft, fp);
#endif

#ifdef _ADM5120_
	if (numWrite < numLeft-WEB_PAGE_OFFSET) {	//lance 2005
#else
	if (numWrite < numLeft) {	//lance 2005
#endif

#ifdef __TARGET_BOARD__
	sprintf(tmpBuf, T("File write failed.<br> locWrite=%d numLeft=%d numWrite=%d Size=%d bytes."), locWrite, numLeft, numWrite, wp->lenPostData);
#else
    sprintf(tmpBuf, T("File write failed.<br> ferror=%d locWrite=%d numLeft=%d numWrite=%d Size=%d bytes."), ferror(fp), locWrite, numLeft, numWrite, wp->lenPostData);
#endif

	}
	locWrite += numWrite;

#ifdef _ADM5120_
	numLeft -= (numWrite+WEB_PAGE_OFFSET);	//lance 2005
#else
	numLeft -= numWrite;	//lance 2005
#endif

#ifdef __TARGET_BOARD__

	//EDX 
	pid_t pid;
	pid = fork();
	if (pid == 0)
	{
		close(fh);
		exit(0);
	}
	else
		waitpid(pid, NULL, 0);
	//EDX
#else
	fclose(fp);
#endif

	if (numLeft == 0)
		sprintf(tmpBuf, T("Update successfully (size = %d bytes)!<br><br>Please wait a while for rebooting..."), wp->lenPostData);
	else
		sprintf(tmpBuf, T("numLeft=%d locWrite=%d Size=%d bytes."), numLeft, locWrite, wp->lenPostData);

    }

#ifdef __TARGET_BOARD__
#ifndef NO_ACTION

	//add by Kyle 20080229.
	#if defined(_KREBOOT_) && !defined (_NO_KREBOOT_)
			//system("echo 1 > /proc/reset_but"); //EDX remove
			system("/bin/reboot.sh 30 &");//EDX
	#else
		system("sleep 2");
		pid = find_pid_by_name("init");
		system("sleep 2");
	    system("killall -SIGTERM pppd");
	    kill(pid, SIGTERM);

	#endif
#endif
#endif
    return;

#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

ret_upload:
	if((fp1=fopen("/tmp/ERR_FW", "r"))!=NULL){
			if(fw[strlen(fw)-1]== '\n' ) fw[strlen(fw)-1] ='\0';
			fgets(fw,2,fp1);
			fclose(fp1);
	}
	if( fw[0]=='1'){
		ERR_MSG1(tmpBuf);
	}
	else{
		ERR_MSG(tmpBuf);
	}    
    system("echo 0 > /tmp/ERR_FW");
    return;

}
//////////////////////////////////////////////////////////////////////////////
/*void formPassword(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl, *strOPassword, *strNPassword;
	char tmpBuf[100];

	strOPassword = websGetVar(wp, T("oldpass"), T(""));
	apmib_get(MIB_USER_PASSWORD, (void *)tmpBuf);
	strNPassword = websGetVar(wp, T("newpass"), T(""));

	printf("\noldpass=%s\n",strOPassword);
	printf("\nMIB_USER_PASSWORD=%s\n",tmpBuf);
	printf("\nnewpass=%s\n",strNPassword);

	if ( strOPassword[0] || strNPassword[0])
	{
		if ( ! strcmp(strOPassword,tmpBuf )) {
        	  if ( umUserExists("admin"))
        	       umDeleteUser("admin");

         	  if ( umAddUser("admin", strNPassword, DEFAULT_GROUP, FALSE, FALSE) ) {
           	       strcpy(tmpBuf, T("ERROR: Password setting failed !"));
            	       goto setErr_pass;
	      	  }
		}
		else{
        	     strcpy(tmpBuf, T("ERROR: Password is not matched !"));
        	     goto setErr_pass;
		}
	}
	// Retrieve next page URL
	apmib_update(CURRENT_SETTING);

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	OK_MSG(submitUrl);
	return;

setErr_pass:
	ERR_MSG(tmpBuf);
}*/
/////////////////////////////////////////////////////////////////////////////
void formPasswordSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl, /**strUser,*/ *strPassword, *userid, *nextUserid, *strOPassword;
	char tmpBuf[100], strUser[100];
	apmib_get(MIB_USER_NAME, (void *)strUser);

	strPassword = websGetVar(wp, T("newpass"), T(""));
	strOPassword = websGetVar(wp, T("oldpass"), T(""));
	apmib_get(MIB_USER_PASSWORD, (void *)tmpBuf);
//	printf("\nUsername=%-10s oldpass=%-10s MIB_USER_PASSWORD=%-10s newpass=%-10s\n",strUser,strOPassword,tmpBuf,strPassword);
	if (  strcmp(strOPassword,tmpBuf )) {
		strcpy(tmpBuf, T("ERROR: Password is not matched !"));
        goto setErr_pass;
	}
	if ( strUser[0] ) {
		// Check if user name is the same as supervisor name
		if ( !apmib_get(MIB_SUPER_NAME, (void *)tmpBuf)) {
			strcpy(tmpBuf, T("ERROR: Get supervisor name MIB error!"));
			goto setErr_pass;
		}

		if ( !strcmp(strUser, tmpBuf)) {
			strcpy(tmpBuf, T("ERROR: Cannot use the same user name as supervisor."));
			goto setErr_pass;
		}
#ifndef _BOA_
		// Check if supervisor account exist. if not, create it
		if ( !umGroupExists(DEFAULT_GROUP) )
			if ( umAddGroup(DEFAULT_GROUP, (short)PRIV_ADMIN, AM_BASIC, FALSE, FALSE) ) {
				strcpy(tmpBuf, T("ERROR: Unable to add group."));
				goto setErr_pass;
			}
		if ( !umAccessLimitExists(ACCESS_URL) )
			if ( umAddAccessLimit(ACCESS_URL, AM_FULL, (short)0, DEFAULT_GROUP) ) {
				strcpy(tmpBuf, T("ERROR: Unable to add access limit."));
				goto setErr_pass;
			}
		if ( !umUserExists(superName))
			if ( umAddUser(superName, superPass, DEFAULT_GROUP, FALSE, FALSE) ) {
				strcpy(tmpBuf, T("ERROR: Unable to add supervisor account."));
				goto setErr_pass;
			}

		// Add new one
		if ( umUserExists(strUser))
			umDeleteUser(strUser);

		if ( umAddUser(strUser, strPassword, DEFAULT_GROUP, FALSE, FALSE) ) {
			strcpy(tmpBuf, T("ERROR: Unable to add user account."));
			goto setErr_pass;
		}
#endif

	}
#ifndef _BOA_
	else {
		// Set NULL account, delete supervisor from DB
		umDeleteAccessLimit("/");
		umDeleteUser(superName);
		umDeleteGroup(DEFAULT_GROUP);
	}
#endif
#if 0
	/* Delete current user account */
	userid = umGetFirstUser();
	while (userid) {
		if ( gstrcmp(userid, superName) && gstrcmp(userid, strUser)) {
			nextUserid = umGetNextUser(userid);
			if ( umDeleteUser(userid) ) {
				strcpy(tmpBuf, T("ERROR: Unable to delete user account."));
				goto setErr_pass;
			}
			userid = nextUserid;
			continue;
		}
		userid = umGetNextUser(userid);
	}
#endif
#if 0 //RexHua for RomFs
	if (umCommit(NULL) != 0) {
		strcpy(tmpBuf, T("ERROR: Unable to save user configuration."));
		goto setErr_pass;
	}
#endif
	/* Set user account to MIB */
	if ( !apmib_set(MIB_USER_NAME, (void *)strUser) ) {
		strcpy(tmpBuf, T("ERROR: Set user name to MIB database failed."));
		goto setErr_pass;
	}
	if ( !apmib_set(MIB_USER_PASSWORD, (void *)strPassword) ) {
		strcpy(tmpBuf, T("ERROR: Set user password to MIB database failed."));
		goto setErr_pass;
	}

	/* Retrieve next page URL */
	apmib_update(CURRENT_SETTING);

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	REPLACE_MSG(submitUrl); // Tommy Modified on 0602
	return;

setErr_pass:
	ERR_MSG(tmpBuf);
}

////////////////////////////////////////////////////////////////////
void set_user_profile()
{
	/* first time load, get mib */
	if ( !apmib_get( MIB_SUPER_NAME, (void *)superName ) ||
		!apmib_get( MIB_SUPER_PASSWORD, (void *)superPass ) ||
			!apmib_get( MIB_USER_NAME, (void *)userName ) ||
				!apmib_get( MIB_USER_PASSWORD, (void *)userPass ) ) {
#ifndef _BOA_
		error(E_L, E_LOG, T("Get user account MIB failed"));
#endif
		return;
	}
	/* Create umconfig.txt if necessary */
#ifndef _BOA_
	if ( userName[0] ) {
		/* Create supervisor */
		if ( !umGroupExists(DEFAULT_GROUP) )
			if ( umAddGroup(DEFAULT_GROUP, (short)PRIV_ADMIN, AM_BASIC, FALSE, FALSE) ) {
				error(E_L, E_LOG, T("ERROR: Unable to add group."));
				return;
			}
		if ( !umAccessLimitExists(ACCESS_URL) )
			if ( umAddAccessLimit(ACCESS_URL, AM_FULL, (short)0, DEFAULT_GROUP) ) {
				error(E_L, E_LOG, T("ERROR: Unable to add access limit."));
				return;
			}
		if ( !umUserExists(superName))
			if ( umAddUser(superName, superPass, DEFAULT_GROUP, FALSE, FALSE) ) {
				error(E_L, E_LOG, T("ERROR: Unable to add supervisor account."));
				return;
			}

		/* Create user */
		if ( umUserExists(userName))
			umDeleteUser(userName);

		if ( umAddUser(userName, userPass, DEFAULT_GROUP, FALSE, FALSE) ) {
			error(E_L, E_LOG, T("ERROR: Unable to add user account."));
			return;
		}
	}
#endif
}

/////////////////////////////////////////////////////////////////////////////
void formStats(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	if (submitUrl[0])
		websRedirect(wp, submitUrl);
}

#define _PATH_SYSCMD_LOG "/tmp/syscmd.log"
void formSysCmd(webs_t wp, char_t *path, char_t *query)
{
        char_t  *submitUrl, *sysCmd;
#ifndef NO_ACTION
        char_t tmpBuf[100];
#endif

        submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
        sysCmd = websGetVar(wp, T("sysCmd"), T(""));   // hidden page

#ifndef NO_ACTION
        if(sysCmd[0]){
                snprintf(tmpBuf, 100, "%s 2>&1 > %s",sysCmd,  _PATH_SYSCMD_LOG);
                system(tmpBuf);
        }
#endif
                websRedirect(wp, submitUrl);
        return;
}

int sysCmdLog(int eid, webs_t wp, int argc, char_t **argv)
{
        FILE *fp;
        char  buf[150];
        int nBytesSent=0;

        fp = fopen(_PATH_SYSCMD_LOG, "r");
        if ( fp == NULL )
                goto err1;
        while(fgets(buf,150,fp)){
                nBytesSent += websWrite(wp, T("%s"), buf);
        }
        fclose(fp);
        unlink(_PATH_SYSCMD_LOG);
err1:
        return nBytesSent;
}

#ifdef HOME_GATEWAY

int  opModeHandler(webs_t wp, char *tmpBuf)
{
	char_t *tmpStr;
	int opmode, wanId;
	int apmode;
	int repeater_enabled;

	tmpStr = websGetVar(wp, T("opMode"), T(""));
	if(tmpStr[0]){
		opmode = tmpStr[0] - '0' ;
		if ( apmib_set(MIB_OP_MODE, (void *)&opmode) == 0) {
			strcpy(tmpBuf, T("Set Opmode error!"));
			goto setErr_opmode;
		}
		if (opmode == 1) {
			apmode=0;
			if ( apmib_set(MIB_AP_MODE, (void *)&apmode) == 0) {
				DEBUGP(tmpBuf, T("Set WLAN Mode error!"));
				goto setErr_opmode;
			}
			repeater_enabled=1;
			if ( apmib_set(MIB_REPEATER_ENABLED, (void *)&repeater_enabled) == 0) {
				DEBUGP(tmpBuf, T("Set Universal Repeater Mode error!"));
				goto setErr_opmode;
			}
		}
		else {
			repeater_enabled=0;
			if ( apmib_set(MIB_REPEATER_ENABLED, (void *)&repeater_enabled) == 0) {
				DEBUGP(tmpBuf, T("Set Universal Repeater Mode error!"));
				goto setErr_opmode;
			}
		}
	}
	tmpStr = websGetVar(wp, T("wispWanId"), T(""));
	if(tmpStr[0]){
		wanId = tmpStr[0] - '0' ;
		if ( apmib_set(MIB_WISP_WAN_ID, (void *)&wanId) == 0) {
			strcpy(tmpBuf, T("Set WISP WAN Id error!"));
			goto setErr_opmode;
		}
	}
	return 0;

setErr_opmode:
	return -1;

}
void formOpMode(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl;
	char tmpBuf[100];

#ifndef NO_ACTION
	int pid;
#endif
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	if(opModeHandler(wp, tmpBuf) < 0)
		goto setErr;

	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	/*pid = fork();
        if (pid)
		waitpid(pid, NULL, 0);
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH,  _CONFIG_SCRIPT_PROG);

		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", "all", NULL);
               	exit(1);
       	} */ // Removed by Tommy
#endif
	OK_MSG(submitUrl);
	return;

setErr:
	ERR_MSG(tmpBuf);
}
#endif

#ifdef _EZVIEW_

char_t *get_ezview_tag(char tagname[], int in_int, webs_t wp)
{
	int j,k;
	char l, full_tag[30], num[5];
	j=in_int;
	k=0;
	while(j>=10)
	{
	num[k]=(char)(j%10+48);
	k++;
	j=j/10;
	}
	num[k]=(char)(j%10+48);
	for(j=0;j<=k/2;j++)	{l=num[j];num[j]=num[k-j];num[k-j]=l;}  //reverse num[]
	num[k+1]='\0';

	strcpy(full_tag,tagname);
	strcat(full_tag,num);

	return websGetVar(wp, T(full_tag) , T(""));
}

void formEZmngSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl;
	int i=0,j , QOSenabled, UpBw, DnBw, enable_pf=0;
	unsigned long aa;
	EZVIEW_T entry;
	QOS_T entry_qos;
	DMZ_T entry_dmz;
	PORTFW_T entry_pf_1, entry_pf_2, entry_pf_3, entry_pf_4, entry_pf_5;

	apmib_set(MIB_EZVIEW_DELALL,	(void *)&entry);
	apmib_set(MIB_WAN1_QOS_DELALL,	(void *)&entry_qos);
	apmib_set(MIB_DMZ_DELALL, (void *)&entry_dmz);

	apmib_get(MIB_WAN1_QOS_ENABLED,(void *)&QOSenabled );

	UpBw=atoi( websGetVar(wp, T("getup"), T("0")) );	apmib_set(MIB_MAX_UPLOAD_BANDWIDTH, (void *)&UpBw);
	DnBw=atoi( websGetVar(wp, T("getdown"), T("0")) );	apmib_set(MIB_MAX_DOWNLOAD_BANDWIDTH, (void *)&DnBw);


	while(	gstrcmp( get_ezview_tag("devicemac",i,wp) , T("") ) )
	{
		if ( !gstrcmp( get_ezview_tag("matter",i,wp) ,T("1") ))
		{
			memset(&entry, '\0', sizeof(entry));

			//=======BASIC Attributions
			strcpy(entry.DeviceName, get_ezview_tag("devicename",i,wp) );
			string_to_hex( get_ezview_tag("devicemac",i,wp) , entry.macAddr, 12);
			entry.ipAddr = atoi( get_ezview_tag("deviceip",i,wp) );
			entry.BlockStartTime = atoi( get_ezview_tag("blockst",i,wp) );
			entry.BlockStopTime = atoi( get_ezview_tag("blocket",i,wp) );
			entry.QoS = atoi( get_ezview_tag("Upload",i,wp) )*8+atoi( get_ezview_tag("Download",i,wp) );
			entry.TypeAndBlock = atoi( get_ezview_tag("misc",i,wp) );
			//========



			//=======QOS
			if(QOSenabled==1)
			{
//				system("echo hi");
				memset(&entry_qos, '\0', sizeof(entry_qos));
				apmib_get( MIB_MAX_UPLOAD_BANDWIDTH, (void *)&UpBw);
				aa = strtoul(  get_ezview_tag("Upload",i,wp)  ,NULL,0);
				aa = aa * 20 * UpBw / 100;
				strcpy(entry_qos.ruleName, get_ezview_tag("devicename",i,wp) );
				entry_qos.bwidthType = 1;
				entry_qos.downType = 0;
				entry_qos.downVal = (unsigned long)0;
				entry_qos.bwidthVal = (unsigned long)aa ;
				entry_qos.sourType = 0; //0:IP 1:MAC
				fixed_inet_aton(websGetVar(wp, T("local_ip"), T("")), entry_qos.sourStIp); entry_qos.sourStIp[3]=atoi(get_ezview_tag("deviceip",i,wp));
				fixed_inet_aton(websGetVar(wp, T("local_ip"), T("")), entry_qos.sourEdIp); entry_qos.sourEdIp[3]=atoi(get_ezview_tag("deviceip",i,wp));
				fixed_inet_aton("0.0.0.0", entry_qos.destStIp);
				fixed_inet_aton("0.0.0.0", entry_qos.destEdIp);
				entry_qos.trafType = 0;  //0:NONE 1:SMTP 2:HTTP 3:POP3 4:FTP
				entry_qos.protl = 0; //0:TCP 1:UDP
				entry_qos.sourPort[i][0]=2;
				entry_qos.sourPort[i][1]=65535;
				entry_qos.destPort[i][0]=2;
				entry_qos.destPort[i][1]=65535;
				apmib_set(MIB_WAN1_QOS_ADD, (void *)&entry_qos);
					//==
				memset(&entry_qos, '\0', sizeof(entry_qos));
				apmib_get( MIB_MAX_DOWNLOAD_BANDWIDTH, (void *)&DnBw);
				aa = strtoul(  get_ezview_tag("Download",i,wp)  ,NULL,0);
				aa = aa * 20 * DnBw / 100;
				strcpy(entry_qos.ruleName, get_ezview_tag("devicename",i,wp) );
				entry_qos.bwidthType = 0;
				entry_qos.downType = 1;
				entry_qos.downVal = (unsigned long)aa ;
				entry_qos.bwidthVal = (unsigned long)0;
				entry_qos.sourType = 0; //0:IP 1:MAC
				fixed_inet_aton(websGetVar(wp, T("local_ip"), T("")), entry_qos.destStIp); entry_qos.destStIp[3]=atoi(get_ezview_tag("deviceip",i,wp));
				fixed_inet_aton(websGetVar(wp, T("local_ip"), T("")), entry_qos.destEdIp); entry_qos.destEdIp[3]=atoi(get_ezview_tag("deviceip",i,wp));
				fixed_inet_aton("0.0.0.0", entry_qos.sourStIp);
				fixed_inet_aton("0.0.0.0", entry_qos.sourEdIp);
				entry_qos.trafType = 0;  //0:NONE 1:SMTP 2:HTTP 3:POP3 4:FTP
				entry_qos.protl = 0; //0:TCP 1:UDP
				entry_qos.sourPort[i][0]=2;
				entry_qos.sourPort[i][1]=65535;
				entry_qos.destPort[i][0]=2;
				entry_qos.destPort[i][1]=65535;
				apmib_set(MIB_WAN1_QOS_ADD, (void *)&entry_qos);
			}

			//=======Port Forwarding

			string_to_dec( get_ezview_tag("pf_from_1",i,wp) , &j);	entry.pf_from[0] = (unsigned short)j;
			string_to_dec( get_ezview_tag("pf_from_2",i,wp) , &j);	entry.pf_from[1] = (unsigned short)j;
			string_to_dec( get_ezview_tag("pf_from_3",i,wp) , &j);	entry.pf_from[2] = (unsigned short)j;
			string_to_dec( get_ezview_tag("pf_from_4",i,wp) , &j);	entry.pf_from[3] = (unsigned short)j;
			string_to_dec( get_ezview_tag("pf_from_5",i,wp) , &j);	entry.pf_from[4] = (unsigned short)j;
			string_to_dec( get_ezview_tag("pf_to_1",i,wp) , &j);    entry.pf_to[0] = (unsigned short)j;
			string_to_dec( get_ezview_tag("pf_to_2",i,wp) , &j);    entry.pf_to[1] = (unsigned short)j;
			string_to_dec( get_ezview_tag("pf_to_3",i,wp) , &j);    entry.pf_to[2] = (unsigned short)j;
			string_to_dec( get_ezview_tag("pf_to_4",i,wp) , &j);    entry.pf_to[3] = (unsigned short)j;
			string_to_dec( get_ezview_tag("pf_to_5",i,wp) , &j);    entry.pf_to[4] = (unsigned short)j;

			if(entry.pf_from[0]!=0 && entry.pf_to[0]!=0 ||
			   entry.pf_from[1]!=0 && entry.pf_to[1]!=0 ||
			   entry.pf_from[2]!=0 && entry.pf_to[2]!=0 ||
			   entry.pf_from[3]!=0 && entry.pf_to[3]!=0 ||
			   entry.pf_from[4]!=0 && entry.pf_to[4]!=0)
			enable_pf=1;

			apmib_set(MIB_EZVIEW_ADD, (void *)&entry);
		}

		i=i+1;
	}

	//=======DMZ
	if(atoi(websGetVar(wp, T("dmzz"), T("")))!=0)
	{
		j=1;
		apmib_set(MIB_DMZ_ENABLED, (void *)&j);
		memset(&entry_dmz, '\0', sizeof(entry_dmz));
		entry_dmz.type=0;
		entry_dmz.session=1;
		fixed_inet_aton("0.0.0.0", entry_dmz.pipAddr);
		fixed_inet_aton(websGetVar(wp, T("local_ip"), T("")), entry_dmz.cipAddr);
		entry_dmz.cipAddr[3]=atoi(websGetVar(wp, T("dmzz"), T("")));
		apmib_set(MIB_DMZ_ADD, (void *)&entry_dmz);
	}
	else
	{
		j=0;
		apmib_set(MIB_DMZ_ENABLED, (void *)&j);
	}
	j=atoi(websGetVar(wp, T("dmzz"), T("")));	apmib_set( MIB_EZVIEW_DMZ, (void *)&j);

	apmib_get(MIB_PORTFW_NUM,(void *)&j );
	if(j>0 || enable_pf==1 ) enable_pf=1;
	apmib_set( MIB_PORTFW_ENABLED, (void *)&enable_pf);

	apmib_update(CURRENT_SETTING);
	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	OK_MSG(submitUrl);
}
#endif

#ifdef _PPPOE_PASSTHROUGH_
void formPPPoEpassEnable(webs_t wp, char_t *path, char_t *query)
{
   	char_t *submitUrl, *strPPPoEPassthrough;
	int val;

	strPPPoEPassthrough = websGetVar(wp, T("pppoepassDisabled"), T(""));
	if (strPPPoEPassthrough[0]) {
		if (!gstrcmp(strPPPoEPassthrough, T("no")))
			val = 0;
		else val = 1;
		apmib_set(MIB_PPPOE_PASSTHROUGH, (void *)&val);
	}
	apmib_update(CURRENT_SETTING);
	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
	OK_MSG(submitUrl);
}
#endif
#ifdef _IPV6_BRIDGE_
void formIPv6BridgeEnable(webs_t wp, char_t *path, char_t *query)
{
   	char_t *submitUrl, *strIPv6Bridge;
	int val;

	strIPv6Bridge = websGetVar(wp, T("ipv6bridgeDisabled"), T(""));
	if (strIPv6Bridge[0]) {
		if (!gstrcmp(strIPv6Bridge, T("no")))
			val = 0;
		else val = 1;
		apmib_set(MIB_IPV6_BRIDGE, (void *)&val);
	}
	apmib_update(CURRENT_SETTING);

	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
	OK_MSG(submitUrl);
}
#endif

#ifdef _HIDING_CGI_MP_PAGE_
void mp(webs_t wp, char_t *path, char_t *query)
{
	char_t *command;
	char temp[500];
	FILE *ptr;
	int i;
	command = websGetVar(wp, T("command"), T(""));
#ifdef _LOGIN_WEB_
	char_t *getID;
	getID = websGetVar(wp, T("getID"), T(""));
	websHeader(wp);//<html>
	websWrite(wp, T("<head>\n"));
	websWrite(wp, T("<style>body { color: #333333; font: 9pt/18px \"Monospace\";font-weight:bold; }</style>\n"));
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/javascript.js\"></script>"));
	websWrite(wp, T("<script>var KeyID=0;findKey();</script>"));
	websWrite(wp, T("</head>\n"));
	websWrite(wp, T("<body>\n"));
	websWrite(wp, T("<script>document.write('<form action=\"/goform/mp?KeyID='+KeyID+'\" method=\"POST\" name=\"mp\">');</script>\n"));
	websWrite(wp, T("<input type=\"text\" name=\"command\" value=\"\">&nbsp;<input type=\"submit\" value=\"GO\">\n"));
	websWrite(wp, T("<input type=\"hidden\" name=\"getID\" value=\"\">&nbsp;"));
   	websWrite(wp,T("<script>\n"
    					"var sub=document.getElementsByName(\"getID\");\n"
    					"sub[0].value=sub[0].value+\"?KeyID=\"+KeyID;\n"
    					"</script>\n"));
	websWrite(wp, T("  </form>\n"));
#else
	websHeader(wp);//<html>
	websWrite(wp, T("<head>\n"));
	websWrite(wp, T("  <style>body { color: #333333; font: 9pt/18px \"Monospace\";font-weight:bold; }</style>\n"));
	websWrite(wp, T("<script type=\"text/javascript\" src=\"/file/javascript.js\"></script>"));
	websWrite(wp, T("</head>\n"));
	websWrite(wp, T("<body>\n"));
	websWrite(wp, T("  <form action=\"/goform/mp\" method=\"POST\" name=\"mp\">\n"));
	websWrite(wp, T("  	<input type=\"text\" name=\"command\" value=\"\">&nbsp;<input type=\"submit\" value=\"GO\">\n"));
	websWrite(wp, T("<input type=\"hidden\" name=\"getID\" value=\"\">&nbsp;"));
	websWrite(wp, T("  </form>\n"));
#endif

	if(command)
	{
		if( strchr(command,';') !=NULL )  *strchr(command,';')='\0';  //如果有分號，把第一個分號改成\0

		websWrite(wp, T("<font color=\"red\">#&nbsp;"));
		for(i=0;i<strlen(command);i++)
		{
			switch(command[i])
			{
				case '\n': websWrite(wp, T("<br>\n")); break;
				case ' ': websWrite(wp, T("&nbsp;")); break;
				case '\0': websWrite(wp, T("")); break;
				default: websWrite(wp, T("%c"),command[i]); break;
			}
		}
		websWrite(wp, T("</font><br>\n"));

		#ifdef __TARGET_BOARD__
			#if defined(_STAR_)
					sprintf(temp,"/var/rftest.sh %s > /tmp/rftest.out",command);
			#else
					sprintf(temp,"/bin/rftest.sh %s > /tmp/rftest.out",command);
			#endif




		#else
			sprintf(temp,"../../script/rftest.sh %s > /tmp/rftest.out",command);
		#endif
		system(temp);
		if((ptr=fopen("/tmp/rftest.out","r"))!=NULL)
		{
			while(fgets(temp,100, ptr)>0)
			{
				for(i=0;i<strlen(temp);i++)
				{
					switch(temp[i])
					{
						case '\n': websWrite(wp, T("<br>\n")); break;
						case ' ': websWrite(wp, T("&nbsp;")); break;
						case '\0': websWrite(wp, T("")); break;
						default: websWrite(wp, T("%c"),temp[i]); break;
					}
				}
			}
			fclose(ptr);
			system("rm -f /tmp/rftest.out");
		}
	}
	websWrite(wp, T("\n</body><script type=\"text/javascript\">document.mp.command.focus()</script>\n"));
	websFooter(wp);//</html>
	websDone(wp, 200);
}
#endif
#if defined(_NETBIOSNAME_)
void formrefresh(webs_t wp, char_t *path, char_t *query)
{

	char command[100];
	char lanIP[30];
	char_t  *submitUrl;

		#ifdef __TARGET_BOARD__
			struct in_addr	intaddr;
			if ( getInAddr(BRIDGE_IF, IP_ADDR, (void *)&intaddr ) )
				sprintf(lanIP, "%s", inet_ntoa(intaddr) );
			else
				sprintf(lanIP, "%s", "0.0.0.0" );

			int i=strlen(lanIP);
			while(lanIP[i]!='.') i--;
			lanIP[i]='\0';
#ifdef _NBTSCAN2_
			sprintf(command,"/bin/nbtscan -m -s %s.0/24 > /var/netName.var",lanIP); system(command);
#else
			sprintf(command,"/bin/nbtscan -a -r %s.1-50/24 > /var/netName.var",lanIP); system(command);
			sprintf(command,"/bin/nbtscan -a -r %s.51-100/24 >> /var/netName.var",lanIP); system(command);
			sprintf(command,"/bin/nbtscan -a -r %s.101-150/24 >> /var/netName.var",lanIP); system(command);
			sprintf(command,"/bin/nbtscan -a -r %s.151-200/24 >> /var/netName.var",lanIP); system(command);
			sprintf(command,"/bin/nbtscan -a -r %s.201-254/24 >> /var/netName.var",lanIP); system(command);
#endif
		#else
#ifdef _NBTSCAN2_
			system("../../nbtscan2/nbtscan -m -s 192.168.2.0/24 > netName.var");
#else
			system("../../nbtscan-1.5.1a/nbtscan -a -r -u 192.168.2.0/24 > netName.var");
#endif
		#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	websRedirect(wp, submitUrl);

}
#endif

#ifdef _LOGIN_WEB_ //vance 2008.12.09

void formLogin(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl, *strPassword, *strName, *submitID, *submitUID;
	char fName[100],fPass[100],tmpBuf[100];
	int getidtime;
  	int i=0;
  	int isFind=0;
	//flash value
	apmib_get(MIB_USER_PASSWORD, (void *)fPass);
	apmib_get(MIB_USER_NAME, (void *)fName);

	strName = websGetVar(wp, T("name"), T(""));
	strPassword = websGetVar(wp, T("pass"), T(""));
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	submitID = websGetVar(wp, T("submit-ID"), T(""));
	id = atoi((char_t*)websGetVar(wp,T("submit-ID"),T("")));

	if ( strName[0] && strPassword[0] && submitID[0])
	{
		if ( !strcmp(strName,fName) && !strcmp(strPassword,fPass) ) {
        	  	system("echo \"login successfully!!\n\"");
        	  	for (i=0;i<_Login_IDNUM_;i++){
        	  		if(KeyID[i]==id){
        	  			isFind=1;
        	  		}
        	  		else
        	  			isFind=0;
        	  	}
        	  	if(!isFind){
        	  		isFind=0;
        	  		for (i=0;i<_Login_IDNUM_;i++){
						if(KeyID[i]== -1){
							KeyID[i]=id;
							IDtime[i] = time((time_t *)NULL);
							isFind=1;
							break;
						}
					}
        	  	}else{
					   strcpy(tmpBuf, T("ID already add!"));
					   goto setErr_pass;
        	  	}
				if(!isFind){
					   strcpy(tmpBuf, T("ID list is full!"));
					   goto setErr_pass;
				}
				else{
					websRedirect(wp, submitUrl);
					return;
				}
		}
		else{
	        	     strcpy(tmpBuf, T("ERROR: login fail !"));
	        	     goto setErr_pass;
		}
	}

	return;

setErr_pass:
	ERR_MSG(tmpBuf);
}
#endif

#ifdef _Systempingtool_

void formSystempingEnd(webs_t wp, int argc, char_t **argv)
{
	char_t *submitUrl;

	pingstatus = atoi((char_t *)websGetVar(wp,T("pingEnd"),T("")));
	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	system("sed -i -e 's/---   END   ---/---   Finish   ---/' /tmp/pingresultdata.txt");

	websRedirect(wp, submitUrl);
   return;
}

void formSystempingtool(webs_t wp, int argc, char_t **argv)
{
	char_t *strip, *strnumbers, *pingofstart, *submitUrl;
	char tmpping[150];
	char tmpBuf[100];

	submitUrl = websGetVar(wp, T("submit-url"),T(""));
	strip = websGetVar(wp,T("ping_ip"), T(""));
	strnumbers = websGetVar(wp,T("ping_number"),T(""));
	pingofstart =  websGetVar(wp,T("Start"),T(""));
	pingstatus = atoi((char_t *)websGetVar(wp,T("pingStart"),T("")));

	if ( strip[0] ) {
		snprintf(tmpping,100,"/bin/scriptlib_util.sh systempingtool %s %s pingresultdata.txt&",strip,strnumbers);
		system(tmpping);
	}else{
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormSystempingtool1))</script>"));
		goto setErr_ping;
	}

	websRedirect(wp,submitUrl);
	return;

setErr_ping:
	ERR_MSG(tmpBuf);
}
#endif
#ifdef _GET_A_DHCP_IP_
void get_a_dhcp_ip(webs_t wp, char_t *path, char_t *query)
{
	system("dhcpc.sh br0 no");
	FILE *ptr;
	char tmp[200];

	websHeader(wp);//<html>

	ptr=fopen("/tmp/dhcptemp","r");
	while(fgets(tmp,199, ptr)>0)
	{
		websWrite(wp, T("%s"),tmp);
	}
	websFooter(wp);//</html>
	websDone(wp, 200);

}
#endif

#ifdef _SOFT_ARSWITCH_
void formARoption(webs_t wp, char_t *path, char_t *query)
{
	int old,natable,lanwan,dhc;
	char_t  *submitUrl;
	int new = 0; // router mode
	char tmpBuf[200];

	if (!gstrcmp(websGetVar(wp, T("mode"), T("")), T("1")))
		new=1; //AP mode
	else if (!gstrcmp(websGetVar(wp, T("mode"), T("")), T("2")))
		new=2; //convert mode

	apmib_get(MIB_AP_ROUTER_SWITCH, (void *)&old);

	apmib_set(MIB_AP_ROUTER_SWITCH, (void *)&new);

	if(old!=new)
	{
		if(new==0)
		{
			char* IP="192.168.1.1";
			natable=1; 	lanwan=7; 	dhc=2;
			apmib_set(MIB_LAN_WAN_ACCESS, (void *)&lanwan);
			apmib_set(MIB_NAT_ENABLE, (void *)&natable);
			apmib_set(MIB_DHCP, (void *)&dhc);
			#if defined(_Customer_)
				apmib_set(MIB_IP_ADDR, (void *)IP);
			#endif
		}
		else
		{
			char* IP="192.168.1.250";
			natable=0; 	lanwan=0; 	dhc=0;
		}
		#ifdef _LAN_WAN_ACCESS_
			apmib_set(MIB_LAN_WAN_ACCESS, (void *)&lanwan);
		#endif
		apmib_set(MIB_NAT_ENABLE, (void *)&natable);
		apmib_set(MIB_DHCP, (void *)&dhc);
	}
	apmib_update(CURRENT_SETTING);

	submitUrl = websGetVar(wp, T("option-url"), T(""));   // hidden page
//	websRedirect(wp, submitUrl);
	OK_MSG(submitUrl);
}
#endif

//vance 2009.03.05 upgrade firmware and boot code
void formUploadBootCode(webs_t wp, char_t * path, char_t * query)
{
#ifdef __TARGET_BOARD__
    int fh;
#else
    FILE *       fp;
    char_t *     bn = NULL;
#endif
    int		 len;
    int          locWrite;
    int          numLeft;
    int          numWrite;
    IMG_HEADER_Tp pHeader;
    char tmpBuf[200];
    char_t *strRequest, *submitUrl, *strVal, *strTarget;
    int flag, startAddr=-1, startAddrWeb=-1, intVal=0; //defEnable=0;	//removed by Erwin
    int target=0; // 0 upgrade router ; 1 upgrade adsl module
    int upgTarget=0; //0 firmware ,1 bootcode added by vance
#ifndef NO_ACTION
    int pid;
#endif

#ifdef _TAG_IN_PAGE_
main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
#endif
  strRequest = websGetVar(wp, T("save"), T(""));
#ifdef _7264Wn_
	 strTarget = websGetVar(wp, T("upgradeTarget"), T(""));
  target = 0;
 if(strTarget[0]){
				if(!gstrcmp(strTarget, T("Router"))){
						target = 0;
				}
				else if(!gstrcmp(strTarget, T("ADSL"))){
					target = 1;
				}else{
					target = 0;
				}
  	 }
  printf("DEBUG: target=%d \n",target);
#endif
if (strRequest[0]) {
	int fh=0;
	char *buf=NULL;

#ifdef __TARGET_BOARD__
	char *filename=FLASH_DEVICE_NAME;
	int imageLen=-1;
	IMG_HEADER_T header;

	strVal = websGetVar(wp, T("readAddr"), T(""));
	if ( strVal[0] )
		startAddr = strtol( strVal, (char **)NULL, 16);

	strVal = websGetVar(wp, T("size"), T(""));
	if ( strVal[0] )
		imageLen = strtol( strVal, (char **)NULL, 16);

	fh = open(filename, O_RDONLY);
	if ( fh == -1 ) {
      		strcpy(tmpBuf, T("Open file failed!"));
		goto ret_err;
	}
	if (startAddr==-1 || imageLen==-1) {
		// read system image
		lseek(fh, CODE_IMAGE_OFFSET, SEEK_SET); // Lance 2003.06.15
		if ( read(fh, &header, sizeof(header)) != sizeof(header)) {
     			strcpy(tmpBuf, T("Read image header error!"));
			goto ret_err;
		}

		if ( memcmp(header.signature, FW_HEADER, SIGNATURE_LEN) ) {  // Lance 2003.06.15
				printf("upgrade fail: Invalid file format! ( %s should be %s )\n",
								header.signature,
								FW_HEADER);
       			strcpy(tmpBuf, T("Invalid file format!"));
			goto ret_err;
	    	}



		startAddr = CODE_IMAGE_OFFSET; // Lance 2003.06.15
		imageLen =  sizeof(header) + header.len;
	}

	buf = malloc(0x10000);
	if ( buf == NULL) {
       		strcpy(tmpBuf, T("Allocate buffer failed!"));
		goto ret_err;
	}

	lseek(fh, startAddr, SEEK_SET);

	websWrite(wp, "HTTP/1.0 200 OK\n");
	websWrite(wp, "Content-Type: application/octet-stream;\n");
	websWrite(wp, "Content-Disposition: attachment;filename=\"apcode.bin\" \n");
	websWrite(wp, "Pragma: no-cache\n");
	websWrite(wp, "Cache-Control: no-cache\n");
	websWrite(wp, "\n");

	while (imageLen > 0) {
		int blocksize=0x10000;
		if (imageLen < blocksize)
			blocksize=imageLen;

		if ( read(fh, buf, blocksize) != blocksize) {
	     		strcpy(tmpBuf, T("Read image error!"));
			goto ret_err;
		}
		websWriteBlock(wp, (char *)buf, blocksize);
		imageLen -= blocksize;
	}



	{
    	unsigned short checksum, checksum_org;
		unsigned long readLen = 0;
		unsigned char readBuf[1024];
		unsigned long i;
		int _flashfd;


//		if((_flashfd = open(FLASH_DEVICE_NAME, O_RDWR))<0)
		if((_flashfd = open(UPG_DEVICE_NAME, O_RDWR))<0)
		{
			strcpy(tmpBuf, T("Upgrade failed!"));
			goto ret_err;
		}

		for(i=0; i < 0x40000; i+=0x10000)
		{
			lseek(_flashfd, 0x10000 + i, SEEK_SET);
			read(_flashfd, readBuf, 12);
			if(memcmp(readBuf, "CSYS", 4))
				continue;
			readLen = *((unsigned long *)&readBuf[8]);

			printf("\n\nFound CSYS image in %lx, Len = %lx\n", 0x10000 + i, readLen);
			break;
		}

		if ( i == 0x40000)
		{
			close(_flashfd);
			strcpy(tmpBuf, T("Upgrade failed!"));
			goto ret_err;
		}

		checksum = 0;
		for(i=0 ;i < (readLen); i += 2)
		{
			read(_flashfd, readBuf, 2);
			checksum += *(unsigned short*)readBuf;
		}

		checksum_org = *(unsigned short*)readBuf;

		printf("\n checksum_org = %lx, checksum=%lx\n", checksum_org, checksum);
		if(checksum != 0)
		{
         	strcpy(tmpBuf, T("Upgrade failed!"));
			goto ret_err;
		}
	}

	websDone(wp, 200);
#else
	struct stat status;
	char *filename="apcode.bin";
	if ( stat(filename, &status) < 0 ) {
       		strcpy(tmpBuf, T("Stat file failed!"));
		goto ret_err;
	}
	buf = malloc(status.st_size);
	if ( buf == NULL) {
       		strcpy(tmpBuf, T("Allocate buffer failed!"));
		goto ret_err;
	}

	fh = open(filename, O_RDONLY);
	if ( fh == -1 ) {
      		strcpy(tmpBuf, T("Open file failed!"));
		goto ret_err;
	}
	lseek(fh, CODE_IMAGE_OFFSET, SEEK_SET); // Lance 2003.06.15

	if ( read(fh, buf, status.st_size) != status.st_size) {
      		strcpy(tmpBuf, T("Read file failed!"));
		goto ret_err;
	}
	websWriteBlock(wp, (char *)buf, status.st_size);
	websDone(wp, 200);
#endif
	goto ret_ok;

ret_err:
	ERR_MSG(tmpBuf);
ret_ok:
	if (fh>0)
		close(fh);
	if (buf)
		free(buf);
	return;
   }

    // assume as firmware upload
    strVal = websGetVar(wp, T("writeAddrCode"), T(""));
    if ( strVal[0] ) {
	if ( !memcmp(strVal, "0x", 2))
		startAddr = strtol( &strVal[2], (char **)NULL, 16);
    }
    strVal = websGetVar(wp, T("writeAddrWebPages"), T(""));
    if ( strVal[0] ) {
	if ( !memcmp(strVal, "0x", 2))
		startAddrWeb = strtol( &strVal[2], (char **)NULL, 16);
    }
    submitUrl = websGetVar(wp, T("submit-url"), T(""));
    locWrite = 0;
    numLeft = wp->lenPostData;
    pHeader = (IMG_HEADER_Tp) wp->postData;

    // check header and checksum
//	printf("\nddddddd=%s len=%d\n",&wp->postData[12],strlen(&wp->postData[12]));
//    if (!memcmp(wp->postData, FW_HEADER, SIGNATURE_LEN)) { // Lance 2003.06.15
//    	flag = 1;
//	}
#ifdef _7264Wn_
	if(target==1){// UPgrade ADSL F/W
		if ( memcmp(&wp->postData[0], "ADSL", SIGNATURE_LEN) ) {  // kyle 2007.10.03
				printf("upgrade fail: Invalid file format! ( %s should be ADSL )\n",
								&wp->postData[0]);
		     			strcpy(tmpBuf, T("Invalid file format!"));
		goto ret_upload;
			  	}
	}
  else{
		if ( !memcmp(&wp->postData[0], "ADSL", SIGNATURE_LEN) ) {  // Lance 2003.10.03
				printf("upgrade fail: Invalid file format! ( should not be %s )\n",
								&wp->postData[0]);
		     			strcpy(tmpBuf, T("Invalid file format!"));
			goto ret_upload;
			  	}
   	}

#endif

	if ( !memcmp(&wp->postData[0], "BOOT", SIGNATURE_LEN) )   // Vance 2009.02.05
		upgTarget=1;
	/*else
	{
		printf("upgrade fail: Invalid file format! ( should not be %s )\n",&wp->postData[0]);
		strcpy(tmpBuf, T("Invalid file format!"));
		goto ret_upload;
	}*/

#ifdef _milan_
	if ((!memcmp(&wp->postData[MODTAG_LEN], "EWAS", SIGNATURE_LEN))
					|| (!memcmp(&wp->postData[MODTAG_LEN], "WBIP", SIGNATURE_LEN))) {
		if (memcmp(&wp->postData[MODTAG_LEN], _WEB_HEADER_, SIGNATURE_LEN)) {
//			defEnable = 1;	//removed by Erwin
		}
    	flag = 2;
	}
#elif _NETINDEX_FW_CHECK_ //vance 2009.02.24
	//check magic number
	/*unsigned char mag[2];
	memcpy(mag,&wp->postData[MAGICNO_LEN],2);
	if(upgTarget != 1)
	{
		if ((mag[0] == 1 && mag[1] == 0)) {*/
		    	flag = 2;
			/*}
		else {
			printf("upgrade fail: Invalid file format! ( %s should be %s or %s )\n", &wp->postData[MAGICNO_LEN], _WEB_HEADER_,FW_HEADER);
	       	strcpy(tmpBuf, T("<script>document.write(showText(InvalidSomething).replace(/#####/,showText(FileFormat)))</script>"));
	      goto ret_upload;
	    }
	}*/
#else
	//if ((!memcmp(&wp->postData[MODTAG_LEN], _WEB_HEADER_, SIGNATURE_LEN)) || (!memcmp(&wp->postData[MODTAG_LEN], "XZKJ", SIGNATURE_LEN))) {
    	flag = 2;
	/*}
	else {
			printf("upgrade fail: Invalid file format! ( %s should be %s or %s )\n", &wp->postData[MODTAG_LEN], _WEB_HEADER_,FW_HEADER);
       	strcpy(tmpBuf, T("<script>document.write(showText(InvalidSomething).replace(/#####/,showText(FileFormat)))</script>"));
      goto ret_upload;
    }*/
#endif

    len = pHeader->len;
#ifdef _LITTLE_ENDIAN_
    len  = DWORD_SWAP(len);
#endif

#ifdef _7207CG_
	apmib_set( MIB_CLT_CER_FILE, (void *)&intVal );
	apmib_set( MIB_SER_CER_FILE, (void *)&intVal );
	apmib_update(CURRENT_SETTING);
#endif
	printf("f/w length=%x, checksum=%x\n", len,*((unsigned short *)&wp->postData[sizeof(IMG_HEADER_T) + len-2]));

	if ( !fwChecksumOk(&wp->postData[sizeof(IMG_HEADER_T)], len)) {
		sprintf(tmpBuf, T("<b>Image checksum mismatched!, checksum=0x%x</b><br>"),
						fwChecksum(&wp->postData[sizeof(IMG_HEADER_T)], len-2));
		goto ret_upload;
	}

#ifdef __TARGET_BOARD__
//    fh = open(FLASH_DEVICE_NAME, O_RDWR);
#ifdef _7264Wn_

			if(target==0)
    		fh = open(UPG_DEVICE_NAME, O_RDWR);
    else
    		fh = open("/var/ras", O_RDWR | O_CREAT | O_TRUNC );
#else
	if(upgTarget == 0)
	{
#ifdef _FW_AB_CONTROL_ //vance 2009.03.11
		strVal = websGetVar(wp, T("fwface"), T(""));
		printf("fw control=%s\n",strVal);
		if (!gstrcmp(strVal, T("1"))) //can downgrade
			fh = open(UPG2_DEVICE_NAME, O_RDWR);
		else
			fh = open(UPG_DEVICE_NAME, O_RDWR);
#else
		fh = open(UPG_DEVICE_NAME, O_RDWR);
#endif
	}
	#ifdef _STAR_
	else if(upgTarget == 1)
		fh = open(BOOT_DEVICE_NAME, O_RDWR);
	#endif
#endif


    if ( fh == -1 ) {
#else
    if (flag == 1)
    	bn = "apcode.bin";
    else
    	bn = "web.gz.up";

    if ((fp = fopen((bn == NULL ? "upldForm.bin" : bn), "w+b")) == NULL) {
#endif
       	strcpy(tmpBuf, T("File open failed!"));
    } else {

#ifdef __TARGET_BOARD__

/*	if (defEnable == 1) {	//removed by Erwin
	    lseek(fh, DEFAULT_SETTING_OFFSET, SEEK_SET);
	    write(fh, "\0\0\0\0", 4);
	}
*/
	if (flag == 1) {
		if ( startAddr == -1)
			startAddr = CODE_IMAGE_OFFSET;
	}
	else {
		if ( startAddrWeb == -1)
			startAddr = WEB_PAGE_OFFSET;
		else
			startAddr = startAddrWeb;
	}
//printf("mtd=%s,startAddr=%d\n",UPG_DEVICE_NAME,startAddr);
	#ifdef _ADM5120_
		startAddr = 0; // Rex Add for 7205ASg and 6214WSg
		lseek(fh, startAddr+WEB_PAGE_OFFSET, SEEK_SET);	//Modified lance 2005
		numWrite = write(fh, &(wp->postData[locWrite+WEB_PAGE_OFFSET]), numLeft-WEB_PAGE_OFFSET);	//lance 2005
	#elif _7264Wn_
		if(target==0){
			lseek(fh, startAddr, SEEK_SET);	//Modified lance 2005
			numWrite = write(fh, &(wp->postData[locWrite]), numLeft);	//lance 2005
		}
		else{
			printf("DEBUG: locWrite=%d startAddr=%d ,numLeft=%d\n",locWrite,startAddr,numLeft);
			lseek(fh, 0, SEEK_SET);	//Modified lance 2005
			numWrite = write(fh, &(wp->postData[locWrite+16]), numLeft-18);	//lance 2005
		}
	#else
		#ifdef _UPGRADE_PROCESS_
		int pid;
		pid = fork();
		if (pid) {
			waitpid(pid, NULL, 0);
		}
		else if (pid == 0) {
#ifdef _STAR_
			if(upgTarget == 0)
			{
				UPGRADE_PROCESS_MSG(130);

			}
			else if(upgTarget == 1)
				UPGRADE_PROCESS_MSG(20);

#else
			UPGRADE_PROCESS_MSG();
#endif
			exit(0);
		}
		sleep(2);
		#endif
			lseek(fh, startAddr, SEEK_SET);	//Modified lance 2005
		//vance 2009.03.05
		if(upgTarget == 0)
			numWrite = write(fh, &(wp->postData[locWrite]), numLeft);	//lance 2005
		else if(upgTarget == 1)
			numWrite = write(fh, &(wp->postData[locWrite+16]), numLeft-18);	//lance 2005

	#endif

#else
	#ifdef _UPGRADE_PROCESS_
		int pid;
		pid = fork();
		if (pid) {
			waitpid(pid, NULL, 0);
		}
		else if (pid == 0){
#ifdef _STAR_
			if(upgTarget == 0)
			{
				UPGRADE_PROCESS_MSG(130);
			}
			else if(upgTarget == 1)
				UPGRADE_PROCESS_MSG(20);
#else
			UPGRADE_PROCESS_MSG();
#endif
			exit(0);
		}
	#endif
	//vance 2009.03.05
	if(upgTarget == 0)
	{
		numWrite = fwrite(&(wp->postData[locWrite]), sizeof(*(wp->postData)), numLeft, fp);
	}
	else if(upgTarget == 1)
	{
		printf("Boot code upgrading!!");
		numWrite = fwrite(&(wp->postData[locWrite+16]), sizeof(*(wp->postData)), numLeft-18, fp);
	}

#endif

	#ifdef _ADM5120_
		if (numWrite < numLeft-WEB_PAGE_OFFSET) {	//lance 2005
	#else
		if (numWrite < numLeft) {	//lance 2005
	#endif

#ifdef __TARGET_BOARD__
		sprintf(tmpBuf, T("File write failed.<br> locWrite=%d numLeft=%d numWrite=%d Size=%d bytes."), locWrite, numLeft, numWrite, wp->lenPostData);
#else
                sprintf(tmpBuf, T("File write failed.<br> ferror=%d locWrite=%d numLeft=%d numWrite=%d Size=%d bytes."), ferror(fp), locWrite, numLeft, numWrite, wp->lenPostData);
#endif

	}
	locWrite += numWrite;

	#ifdef _ADM5120_
	 	numLeft -= (numWrite+WEB_PAGE_OFFSET);	//lance 2005
	#else
	 	numLeft -= numWrite;	//lance 2005
	#endif
#ifdef __TARGET_BOARD__
	close(fh);
#else
	fclose(fp);
#endif

	if (numLeft == 0)
		sprintf(tmpBuf, T("Update successfully (size = %d bytes)!<br><br>Please wait a while for rebooting..."), wp->lenPostData);
	else
		sprintf(tmpBuf, T("numLeft=%d locWrite=%d Size=%d bytes."), numLeft, locWrite, wp->lenPostData);

    }

#ifdef __TARGET_BOARD__
#ifndef NO_ACTION

	//add by Kyle 20080229.
	#if defined(_KREBOOT_) && !defined (_NO_KREBOOT_)

		#define REBOOT       0x040000
		int fd;
		fd = open("/dev/reset_but", O_RDONLY);
		if (fd < 0) {
			perror("/dev/reset_but");
			return -1;
		}

		if (ioctl(fd, REBOOT, NULL) < 0) {
			perror("ioctl reset button");
			close(fd);
			return -1;
		}
		close(fd);
	#else

		system("sleep 2");
	    pid = find_pid_by_name("init");
	    system("killall -SIGTERM pppd");
	    kill(pid, SIGTERM);

	#endif
#endif
#endif
    return;

ret_upload:
	ERR_MSG(tmpBuf);
    return;

}
#ifdef _RTK_NTP_
int  ntpHandler(webs_t wp, char *tmpBuf, int fromWizard)
{
	int enabled=0, ntpServerIdx ;
	struct in_addr ipAddr ;
	char *tmpStr ;
//Brad add for daylight save
	int dlenabled=0;
//Brad add end
	if (fromWizard) {
		tmpStr = websGetVar(wp, T("enabled"), T(""));
		if(!strcmp(tmpStr, "ON"))
			enabled = 1 ;
		else
			enabled = 0 ;

		if ( apmib_set( MIB_NTP_ENABLED, (void *)&enabled) == 0) {
			strcpy(tmpBuf, T("Set enabled flag error!"));
			goto setErr_ntp;
		}
//Brad add for daylight save
		tmpStr = websGetVar(wp, T("dlenabled"), T(""));
		if(!strcmp(tmpStr, "ON"))
			dlenabled = 1 ;
		else
			dlenabled = 0 ;

		if ( apmib_set( MIB_DAYLIGHT_SAVE, (void *)&dlenabled) == 0) {
			strcpy(tmpBuf, T("Set enabled flag error!"));
			goto setErr_ntp;
		}
//Brad add end
	}
	else
		enabled = 1;
	if(enabled){
		tmpStr = websGetVar(wp, T("ntpServerId"), T(""));
		if(tmpStr[0]){
			ntpServerIdx = tmpStr[0] - '0' ;
			if ( apmib_set(MIB_NTP_SERVER_ID, (void *)&ntpServerIdx) == 0) {
				strcpy(tmpBuf, T("Set Time Zone error!"));
				goto setErr_ntp;
			}
		}
		tmpStr = websGetVar(wp, T("timeZone"), T(""));
		if(tmpStr[0]){
			if ( apmib_set(MIB_NTP_TIMEZONE, (void *)tmpStr) == 0) {
					strcpy(tmpBuf, T("Set Time Zone error!"));
				goto setErr_ntp;
		}
		}

		tmpStr = websGetVar(wp, T("ntpServerIp1"), T(""));
		if(tmpStr[0]){
			inet_aton(tmpStr, &ipAddr);
			if ( apmib_set(MIB_NTP_SERVER_IP1, (void *)&ipAddr) == 0) {
				strcpy(tmpBuf, T("Set NTP server error!"));
				goto setErr_ntp;
			}
			}
		tmpStr = websGetVar(wp, T("ntpServerIp2"), T(""));
		if(tmpStr[0]){
			inet_aton(tmpStr, &ipAddr);
			if ( apmib_set(MIB_NTP_SERVER_IP2,(void *) &ipAddr ) == 0) {
				strcpy(tmpBuf, T("Set NTP server IP error!"));
				goto setErr_ntp;
			}
		}
	}
	return 0 ;
setErr_ntp:
	return -1 ;

}
void formNtp(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl,*strVal, *tmpStr;
	char tmpBuf[100];
	int enabled=0;
//Brad add for daylight save
	int dlenabled=0;
//Brad add end
#ifndef NO_ACTION
//	int pid;
#endif
	int time_value=0;
	int cur_year=0;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	strVal = websGetVar(wp, T("save"), T(""));

	if(strVal[0]){
		struct tm tm_time;
		time_t tm;
		memcpy(&tm_time, localtime(&tm), sizeof(tm_time));
		tm_time.tm_sec = 0;
		tm_time.tm_min = 0;
		tm_time.tm_hour = 0;
		tm_time.tm_isdst = -1;  /* Be sure to recheck dst. */
		strVal = websGetVar(wp, T("year"), T(""));
		cur_year= atoi(strVal);
		tm_time.tm_year = atoi(strVal) - 1900;
		strVal = websGetVar(wp, T("month"), T(""));
		tm_time.tm_mon = atoi(strVal);
		strVal = websGetVar(wp, T("day"), T(""));
		tm_time.tm_mday = atoi(strVal);
		strVal = websGetVar(wp, T("hour"), T(""));
		tm_time.tm_hour = atoi(strVal);
		strVal = websGetVar(wp, T("minute"), T(""));
		tm_time.tm_min = atoi(strVal);
		strVal = websGetVar(wp, T("second"), T(""));
		tm_time.tm_sec = atoi(strVal);
		tm = mktime(&tm_time);
		if(tm < 0){
			sprintf(tmpBuf, "set Time Error\n");
			goto setErr_end;
		}
		if(stime(&tm) < 0){
			sprintf(tmpBuf, "set Time Error\n");
			goto setErr_end;
		}

		apmib_set( MIB_TIME_YEAR, (void *)&cur_year);
		time_value = tm_time.tm_mon;
		apmib_set( MIB_TIME_MONTH, (void *)&time_value);
		time_value = tm_time.tm_mday;
		apmib_set( MIB_TIME_DAY, (void *)&time_value);
		time_value = tm_time.tm_hour;
		apmib_set( MIB_TIME_HOUR, (void *)&time_value);
		time_value = tm_time.tm_min;
		apmib_set( MIB_TIME_MIN, (void *)&time_value);
		time_value = tm_time.tm_sec;
		apmib_set( MIB_TIME_SEC, (void *)&time_value);

		tmpStr = websGetVar(wp, T("timeZone"), T(""));
		if(tmpStr[0]){
			if ( apmib_set(MIB_NTP_TIMEZONE, (void *)tmpStr) == 0) {
					strcpy(tmpBuf, T("Set Time Zone error!"));
				goto setErr_end;
			}
		}

		tmpStr = websGetVar(wp, T("enabled"), T(""));
		if(!strcmp(tmpStr, "ON"))
			enabled = 1 ;
		else
			enabled = 0 ;
		if ( apmib_set( MIB_NTP_ENABLED, (void *)&enabled) == 0) {
			strcpy(tmpBuf, T("Set enabled flag error!"));
			goto setErr_end;
		}
//Brad add for daylight save
		tmpStr = websGetVar(wp, T("dlenabled"), T(""));
		if(!strcmp(tmpStr, "ON"))
			dlenabled = 1 ;
		else
			dlenabled = 0 ;
		if ( apmib_set( MIB_DAYLIGHT_SAVE, (void *)&dlenabled) == 0) {
			strcpy(tmpBuf, T("Set dl enabled flag error!"));
			goto setErr_end;
		}
//Brad add end
	}
	if (enabled == 0)
		goto  set_ntp_end;

	if(ntpHandler(wp, tmpBuf, 0) < 0)
		goto setErr_end ;

set_ntp_end:
//	apmib_update_web(CURRENT_SETTING);
//Brad modify for system re-init method
#if 0
	pid = find_pid_by_name("ntp.sh");
	if(pid)
		kill(pid, SIGTERM);

	pid = fork();
        if (pid)
		waitpid(pid, NULL, 0);
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _NTP_SCRIPT_PROG);
		execl( tmpBuf, _NTP_SCRIPT_PROG, NULL);
               	exit(1);
       	}
#endif
#ifndef NO_ACTION
	//run_init_script("all");
#endif
	apmib_update(CURRENT_SETTING);
	system("date.sh");
	OK_MSG(submitUrl);
	return;

setErr_end:
	ERR_MSG(tmpBuf);
}
#endif
