/**
 *      MIB table declaration
 *
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *
 *      $Id: mibtbl.c,v 1.2 2005/05/13 07:54:13 tommy Exp $
 *
 */
/* Include files */
#include "apmib.h"
#include "mibtbl.h"
/* Global variable definitions */
mib_table_entry_T mib_table[]={
{MIB_DHCP_CLIENT_START,			"DHCP_CLIENT_START",		IA_T,			_OFFSET(dhcpClientStart),	_SIZE(dhcpClientStart)},
{MIB_DHCP_CLIENT_END,			"DHCP_CLIENT_END",		IA_T,			_OFFSET(dhcpClientEnd),		_SIZE(dhcpClientEnd)},
{MIB_LICENCE,				"LICENCE",			BYTE_T,			_OFFSET(licence),		_SIZE(licence)},
//{MIB_UPNP_ENABLE,			"UPNP_ENABLE",			BYTE_T,			_OFFSET(upnpEnable),		_SIZE(upnpEnable)}, //edx chris

#ifdef HOME_GATEWAY
{MIB_WAN_DHCP,				"WAN_DHCP",			BYTE_T,			_OFFSET(wanDhcp),		_SIZE(wanDhcp)},
{MIB_WAN_DNS_MODE,			"DNS_MODE",			BYTE_T,			_OFFSET(dnsMode),		_SIZE(dnsMode)},
{MIB_WAN_DNS1,				"DNS1",				IA_T,			_OFFSET(dns1),			_SIZE(dns1)},
{MIB_WAN_DNS2,				"DNS2",				IA_T,			_OFFSET(dns2),			_SIZE(dns2)},
{MIB_WAN_DNS3,				"DNS3",				IA_T,			_OFFSET(dns3),			_SIZE(dns3)},
{MIB_WAN_MODE,				"WAN_MODE",			BYTE_T,			_OFFSET(wanMode),		_SIZE(wanMode)},
//************************************** Dynamic Ip **************************************
{MIB_DYNIP_HOSTNAME,			"DYNIP_HOSTNAME",		STRING_T,		_OFFSET(dynIPHostName),		_SIZE(dynIPHostName)},
{MIB_WAN_MAC_ADDR,			"WAN_MAC_ADDR",			BYTE6_T,		_OFFSET(wanMacAddr),		_SIZE(wanMacAddr)},
//************************************** Static Ip **************************************
{MIB_WAN_IP_ADDR,			"WAN_IP_ADDR",			IA_T,			_OFFSET(wanIpAddr),		_SIZE(wanIpAddr)},
{MIB_WAN_SUBNET_MASK,			"WAN_SUBNET_MASK",		IA_T,			_OFFSET(wanSubnetMask),		_SIZE(wanSubnetMask)},
{MIB_WAN_DEFAULT_GATEWAY,		"WAN_DEFAULT_GATEWAY",		IA_T,			_OFFSET(wanDefaultGateway),	_SIZE(wanDefaultGateway)},
//************************************** PPPoE Setting **************************************
{MIB_PPP_USER,				"PPP_USER_NAME",		STRING_T,		_OFFSET(pppUserName),		_SIZE(pppUserName)},
{MIB_PPP_PASSWORD,			"PPP_PASSWORD",			STRING_T,		_OFFSET(pppPassword),		_SIZE(pppPassword)},
{MIB_PPP_IDLE_TIME,			"PPP_IDLE_TIME",		WORD_T,			_OFFSET(pppIdleTime),		_SIZE(pppIdleTime)},
{MIB_PPP_CONNECT_TYPE,			"PPP_CONNECT_TYPE",		BYTE_T,			_OFFSET(pppConnectType),	_SIZE(pppConnectType)},
{MIB_PPP_SERVNAME,			"PPP_SERVNAME",			STRING_T,		_OFFSET(pppServName),		_SIZE(pppServName)},
{MIB_PPP_MTU,				"PPP_MTU",			WORD_T,			_OFFSET(pppMTU),		_SIZE(pppMTU)},
{MIB_PPP_TTL_ENABLED,			"PPP_TTL_ENABLED",		BYTE_T,			_OFFSET(pppEnTtl),		_SIZE(pppEnTtl)},
#if defined(_Customer_) | defined(_MPPPOE_)
// alex 2007/01/31
//************************************** PPPoE 1 Setting **************************************
{MIB_PPP_USER1,				"PPP_USER_NAME1",		STRING_T,		_OFFSET(pppUserName1),		_SIZE(pppUserName1)},
{MIB_PPP_PASSWORD1,			"PPP_PASSWORD1",		STRING_T,		_OFFSET(pppPassword1),		_SIZE(pppPassword1)},
{MIB_PPP_IDLE_TIME1,			"PPP_IDLE_TIME1",		WORD_T,			_OFFSET(pppIdleTime1),		_SIZE(pppIdleTime1)},
{MIB_PPP_CONNECT_TYPE1,			"PPP_CONNECT_TYPE1",		BYTE_T,			_OFFSET(pppConnectType1),	_SIZE(pppConnectType1)},
{MIB_PPP_SERVNAME1,			"PPP_SERVNAME1",		STRING_T,		_OFFSET(pppServName1),		_SIZE(pppServName1)},
{MIB_PPP_MTU1,				"PPP_MTU1",			WORD_T,			_OFFSET(pppMTU1),		_SIZE(pppMTU1)},
{MIB_PPPoE_MODE,			"PPPoEMODE",			WORD_T,			_OFFSET(pppoeMode),		_SIZE(pppoeMode)},
//alex 2007/02/01
//************************************** PPPoE Unnumbered IP Setting **************************************
{MIB_PPP_UNNUMIP,			"PPP_UNNUMIP",			IA_T,			_OFFSET(pppUnnumIP),		_SIZE(pppUnnumIP)},
{MIB_PPP_UNNUMMASK,			"PPP_UNNUMMASK",		IA_T,			_OFFSET(pppUnnumMask),		_SIZE(pppUnnumMask)},
{MIB_PPP_UNNUMNAT,			"PPP_UNNUMNAT",			WORD_T,			_OFFSET(pppUnnumNAT),		_SIZE(pppUnnumNAT)},
#endif
//************************************** PPTP Setting **************************************
{MIB_PPTP_IPMODE,			"PPTP_IPMODE",			BYTE_T,			_OFFSET(pptpIpMode),		_SIZE(pptpIpMode)},
{MIB_PPTPIP_ADDR,			"PPTP_IP_ADDR",			IA_T,			_OFFSET(pptpIPAddr),		_SIZE(pptpIPAddr)},
{MIB_PPTPIPMAKE_ADDR,			"PPTP_IP_MASK_ADDR",		IA_T,			_OFFSET(pptpIPMaskAddr),	_SIZE(pptpIPMaskAddr)},
{MIB_PPTPDFGATEWAY,			"PPTP_DEF_GATEWAY",		IA_T,			_OFFSET(pptpDfGateway),		_SIZE(pptpDfGateway)},
#ifdef _PPTP_FQDN_
{MIB_PPTPGATEWAY,			"PPTP_GATEWAY",			STRING_T,		_OFFSET(pptpGateway),		_SIZE(pptpGateway)},
#else
{MIB_PPTPGATEWAY,			"PPTP_GATEWAY",			IA_T,			_OFFSET(pptpGateway),		_SIZE(pptpGateway)},
#endif
{MIB_PPTP_USER,				"PPTP_USER_NAME",		STRING_T,		_OFFSET(pptpUserName),		_SIZE(pptpUserName)},
{MIB_PPTP_PASSWORD,			"PPTP_PASSWORD",		STRING_T,		_OFFSET(pptpPassword),		_SIZE(pptpPassword)},
{MIB_PPTP_IDLE_TIME,			"PPTP_IDLE_TIME",		WORD_T,			_OFFSET(pptpIdleTime),		_SIZE(pptpIdleTime)},
{MIB_PPTP_CONNECT_TYPE,			"PPTP_CONNECT_TYPE",		BYTE_T,			_OFFSET(pptpConnectType),	_SIZE(pptpConnectType)},
{MIB_PPTP_CONNT_ID,			"PPTP_CONNT_ID",		STRING_T,		_OFFSET(pptpConntID),		_SIZE(pptpConntID)},
{MIB_PPTP_BEZEQ_ENABLE,			"PPTP_BEZEQ_ENABLED",		BYTE_T,			_OFFSET(pptpBEZEQEnable),	_SIZE(pptpBEZEQEnable)},
{MIB_PPTP_MTU,				"PPTP_MTU",			WORD_T,			_OFFSET(pptpMTU),		_SIZE(pptpMTU)},
//************************************** L2TP Setting **************************************
{MIB_L2TP_IPMODE,			"L2TP_IPMODE",			BYTE_T,			_OFFSET(L2TPIpMode),		_SIZE(L2TPIpMode)},
{MIB_L2TP_IP_ADDR,			"L2TP_IP_ADDR",			IA_T,			_OFFSET(L2TPIPAddr),		_SIZE(L2TPIPAddr)},
{MIB_L2TP_MAKEADDR,			"L2TP_MASK_ADDR",		IA_T,			_OFFSET(L2TPMaskAddr),		_SIZE(L2TPMaskAddr)},
{MIB_L2TP_DEFGATEWAY,			"L2TP_DEFGATEWAY",		IA_T,			_OFFSET(L2TPDefGateway),	_SIZE(L2TPDefGateway)},
{MIB_L2TP_GATEWAY,			"L2TP_GATEWAY",			STRING_T,		_OFFSET(L2TPGateway),		_SIZE(L2TPGateway)},
{MIB_L2TP_USER,				"L2TP_USER_NAME",		STRING_T,		_OFFSET(L2TPUserName),		_SIZE(L2TPUserName)},
{MIB_L2TP_PASSWORD,			"L2TP_PASSWORD",		STRING_T,		_OFFSET(L2TPPassword),		_SIZE(L2TPPassword)},
{MIB_L2TP_IDLE_TIME,			"L2TP_IDLE_TIME",		WORD_T,			_OFFSET(L2TPIdleTime),		_SIZE(L2TPIdleTime)},
{MIB_L2TP_CONNECT_TYPE,			"L2TP_CONNECT_TYPE",		BYTE_T,			_OFFSET(L2TPConnectType),	_SIZE(L2TPConnectType)},
{MIB_L2TP_MTU,				"L2TP_MTU",			WORD_T,			_OFFSET(L2TPMTU),		_SIZE(L2TPMTU)},
//************************************** TelStra Big Pond **************************************
{MIB_TELBPIP_ADDR,			"TELBP_IP_ADDR",		IA_T,			_OFFSET(telBPIPAddr),		_SIZE(telBPIPAddr)},
{MIB_TELBP_USER,			"TELBP_USER_NAME",		STRING_T,		_OFFSET(telBPUserName),		_SIZE(telBPUserName)},
{MIB_TELBP_PASSWORD,			"TELBP_PASSWORD",		STRING_T,		_OFFSET(telBPPassword),		_SIZE(telBPPassword)},
{MIB_TELBP_ENABLED,			"TELBP_ENABLED",		BYTE_T,			_OFFSET(telBPEnabled),		_SIZE(telBPEnabled)},
//************************************** Port Forwarding **************************************
{MIB_PORTFW_ENABLED,			"PORTFW_ENABLED",		BYTE_T,			_OFFSET(portFwEnabled),		_SIZE(portFwEnabled)},
{MIB_PORTFW_NUM,			"PORTFW_TBL_NUM",		BYTE_T,			_OFFSET(portFwNum),		_SIZE(portFwNum)},
{MIB_PORTFW,				"PORTFW_TBL",			PORTFW_ARRAY_T,		_OFFSET(portFwArray),		_SIZE(portFwArray)},
//-------------------------------------------------------------------------------------------
{MIB_VSER,				"VSER_TBL",			VSER_ARRAY_T,		_OFFSET(vserArray),		_SIZE(vserArray)},
{MIB_IPFILTER_ENABLED,			"IPFILTER_ENABLED",		BYTE_T,			_OFFSET(ipFilterEnabled),	_SIZE(ipFilterEnabled)},
{MIB_IPFILTER_NUM,			"IPFILTER_TBL_NUM",		BYTE_T,			_OFFSET(ipFilterNum),		_SIZE(ipFilterNum)},
{MIB_IPFILTER,				"IPFILTER_TBL",			IPFILTER_ARRAY_T,	_OFFSET(ipFilterArray),		_SIZE(ipFilterArray)},
{MIB_DMZ_NUM,				"DMZ_TBL_NUM",			BYTE_T,			_OFFSET(DMZNum),		_SIZE(DMZNum)},
{MIB_DMZ,				"DMZ_TBL",			DMZ_ARRAY_T,		_OFFSET(DMZArray),		_SIZE(DMZArray)},
//************************************** URL Blocking **************************************
{MIB_URLB_ENABLED,			"URLB_ENABLED",			BYTE_T,			_OFFSET(URLBEnabled),		_SIZE(URLBEnabled)},
{MIB_URLB_NUM,				"URLB_TBL_NUM",			BYTE_T,			_OFFSET(URLBNum),		_SIZE(URLBNum)},
{MIB_URLB,				"URLB_TBL",			URLB_ARRAY_T,		_OFFSET(URLBArray),		_SIZE(URLBArray)},
//************************************** Access Control **************************************
{MIB_ACPC_ENABLED,			"ACPC_ENABLED",			BYTE_T,			_OFFSET(ACPCEnabled),		_SIZE(ACPCEnabled)},
{MIB_IPDENY_ENABLED,			"IPDENY_ENABLED",		BYTE_T,			_OFFSET(ipDenyEnabled),		_SIZE(ipDenyEnabled)},
{MIB_ACPC_NUM,				"ACPC_TBL_NUM",			BYTE_T,			_OFFSET(ACPCNum),		_SIZE(ACPCNum)},
{MIB_ACPC,				"ACPC_TBL",			ACPC_ARRAY_T,		_OFFSET(ACPCArray),		_SIZE(ACPCArray)},
{MIB_MACDENY_ENABLED,			"MACDENY_ENABLED",		BYTE_T,			_OFFSET(macDenyEnabled),	_SIZE(macDenyEnabled)},
{MIB_MACFILTER_ENABLED,			"MACFILTER_ENABLED",		BYTE_T,			_OFFSET(macFilterEnabled),	_SIZE(macFilterEnabled)},
{MIB_MACFILTER_NUM,			"MACFILTER_TBL_NUM",		BYTE_T,			_OFFSET(macFilterNum),		_SIZE(macFilterNum)},
{MIB_MACFILTER,				"MACFILTER_TBL",		MACFILTER_ARRAY_T,	_OFFSET(macFilterArray),	_SIZE(macFilterArray)},
{MIB_PORTFILTER_ENABLED,		"PORTFILTER_ENABLED",		BYTE_T,			_OFFSET(portFilterEnabled),	_SIZE(portFilterEnabled)},
{MIB_PORTFILTER_NUM,			"PORTFILTER_TBL_NUM",		BYTE_T,			_OFFSET(portFilterNum),		_SIZE(portFilterNum)},
{MIB_PORTFILTER,			"PORTFILTER_TBL",		PORTFILTER_ARRAY_T,	_OFFSET(portFilterArray),	_SIZE(portFilterArray)},
//************************************** Special Application **************************************
{MIB_TRIGGERPORT_ENABLED,		"TRIGGERPORT_ENABLED",		BYTE_T,			_OFFSET(triggerPortEnabled),	_SIZE(triggerPortEnabled)},
{MIB_TRIGGERPORT_NUM,			"TRIGGERPORT_TBL_NUM",		BYTE_T,			_OFFSET(triggerPortNum),	_SIZE(triggerPortNum)},
{MIB_TRIGGERPORT,			"TRIGGERPORT_TBL",		TRIGGERPORT_ARRAY_T,	_OFFSET(triggerPortArray),	_SIZE(triggerPortArray)},
{MIB_DMZ_ENABLED,			"DMZ_ENABLED", 			BYTE_T,			_OFFSET(dmzEnabled),		_SIZE(dmzEnabled)},
//************************************** Static Routing **************************************
{MIB_SROUT_ENABLED,			"SROUT_ENABLED",		BYTE_T,			_OFFSET(sroutEnabled),		_SIZE(sroutEnabled)},
{MIB_SROUT_NUM,				"SROUT_TBL_NUM",		BYTE_T,			_OFFSET(sroutNum),		_SIZE(sroutNum)},
{MIB_SROUT,				"SROUT_TBL",			SROUT_ARRAY_T,		_OFFSET(sroutArray),		_SIZE(sroutArray)},
{MIB_WAN1_QOS_ENABLED,			"WAN1_QOS_ENABLED",		BYTE_T,			_OFFSET(QosEnabled[0]),		_SIZE(QosEnabled[0])},	//WAN1
{MIB_WAN1_QOS_NUM,			"WAN1_QOS_TBL_NUM",		BYTE_T,			_OFFSET(QosNum[0]),		_SIZE(QosNum[0])},
{MIB_WAN1_QOS,				"WAN1_QOS_TBL",			WAN1_QOS_ARRAY_T,	_OFFSET(QosArray[0]),		_SIZE(QosArray[0])},
#if defined(_Customer_) | defined(_MPPPOE_)
{MIB_WAN2_QOS_ENABLED,			"WAN2_QOS_ENABLED",		BYTE_T,			_OFFSET(QosEnabled[1]),		_SIZE(QosEnabled[1])},	//WAN1
{MIB_WAN2_QOS_NUM,			"WAN2_QOS_TBL_NUM",		BYTE_T,			_OFFSET(QosNum[1]),		_SIZE(QosNum[1])},
{MIB_WAN2_QOS,				"WAN2_QOS_TBL",			WAN2_QOS_ARRAY_T,	_OFFSET(QosArray[1]),		_SIZE(QosArray[1])},
#endif
#endif

#if defined(_BR6428PNL_) || defined(_AP_WITH_DNS_)
{MIB_WAN_DNS_MODE,                      "DNS_MODE",                     BYTE_T,                 _OFFSET(dnsMode),               _SIZE(dnsMode)},
{MIB_WAN_DNS1,                          "DNS1",                         IA_T,                   _OFFSET(dns1),                  _SIZE(dns1)},
{MIB_WAN_DNS2,                          "DNS2",                         IA_T,                   _OFFSET(dns2),                  _SIZE(dns2)},
{MIB_WAN_DNS3,                          "DNS3",                         IA_T,                   _OFFSET(dns3),                  _SIZE(dns3)},
#endif
#if defined(_BR6428PNL_) || defined(_AP_WITH_DHCP_CLIENT_)
{MIB_DHCP_CHECK_ENABLED,		"DHCP_CHECK_ENABLED",		BYTE_T,			_OFFSET(dhcpcheckEnabled),	_SIZE(dhcpcheckEnabled)},
#endif
#ifdef _QoS_MODE_SELECT_ //Fly 2009.03.17
{MIB_QoS_QOSTYPE,				"QoS_QOSTYPE",			BYTE_T,				_OFFSET(QoS_QOSTYPE),	_SIZE(QoS_QOSTYPE)},
#endif
#ifdef _QoS_MODE_SELECT_ //Fly 2009.03.17
{MIB_WANCON_QOS_NUM,			"WAN_QOSCON_TBL_NUM",		BYTE_T,			_OFFSET(QosCONNum),		_SIZE(QosCONNum)},
{MIB_WANCON_QOS,				"WAN_QOSCON_TBL",			WAN_QOSCON_ARRAY_T,	_OFFSET(QosCONArray),		_SIZE(QosCONArray)},
#endif
// Static DHCP Lease -------------------------------------------------------------------------------------
{MIB_STATIC_DHCP_ENABLED,		"SDHCP_ENABLED",		BYTE_T,			_OFFSET(SDHCPEnabled),		_SIZE(SDHCPEnabled)},
{MIB_STATIC_DHCP_NUM,			"SDHCP_TBL_NUM",		BYTE_T,			_OFFSET(SDHCPNum),		_SIZE(SDHCPNum)},
{MIB_STATIC_DHCP,			"SDHCP_TBL",			SDHCP_ARRAY_T,		_OFFSET(SDHCPArray),		_SIZE(SDHCPArray)},
//------------------------------------------------------------------------------------------------------------
#ifndef HOME_GATEWAY
//************************************** RADIUS Server **************************************
{MIB_RSER_ENABLED,			"RSER_ENABLED",			BYTE_T,			_OFFSET(rserEnabled),		_SIZE(rserEnabled)},
{MIB_RSER_CLT_NUM,			"RSER_CLT_TBL_NUM",		BYTE_T,			_OFFSET(rserCltNum),		_SIZE(rserCltNum)},
{MIB_RSER_CLT,				"RSER_CLT_TBL",			RSER_CLT_ARRAY_T,	_OFFSET(rserCltArray),		_SIZE(rserCltArray)},
{MIB_RSER_USR_NUM,			"RSER_USR_TBL_NUM",		BYTE_T,			_OFFSET(rserUsrNum),		_SIZE(rserUsrNum)},
{MIB_RSER_USR,				"RSER_USR_TBL",			RSER_USR_ARRAY_T,	_OFFSET(rserUsrArray),		_SIZE(rserUsrArray)},
#endif
//#ifdef HOME_GATEWAY
// RexHua
{MIB_WLAN_TX_POWER,			"WLAN_TX_POWER",		BYTE_T,			_OFFSET(wlanTxPower),		_SIZE(wlanTxPower)},
{MIB_WLAN_WMM,				"WLAN_WMM",			BYTE_T,			_OFFSET(wlanWmm),		_SIZE(wlanWmm)},
{MIB_WLAN_TURBO,			"WLAN_TURBO",			BYTE_T,			_OFFSET(wlanTurbo),		_SIZE(wlanTurbo)},
{MIB_WLAN_N_FIX_RATE,			"WLAN_N_FIXRATE",		BYTE_T,		_OFFSET(wlanNFixRate),		_SIZE(wlanNFixRate)},
{MIB_WLAN_N_CHANNEL_WIDTH,		"WLAN_N_CHAN_WIDTH",		BYTE_T,	_OFFSET(wlanNChanWidth),	_SIZE(wlanNChanWidth)},
//#endif
//******************************wireless setting for inprocomm ******************************
{MIB_WLAN_TRAN_RATE,			"WLAN_TRAN_RATE",		STRING_T,		_OFFSET(wlanTranRate),		_SIZE(wlanTranRate)},
{MIB_WLAN_RATE_MODE,			"WLAN_RATE_MODE",		BYTE_T,			_OFFSET(wlanRateMode),		_SIZE(wlanRateMode)},
{MIB_WLAN_CTS,				"WLAN_CTS",			BYTE_T,			_OFFSET(wlanCts),		_SIZE(wlanCts)},
{MIB_WLAN_BURST,			"WLAN_BURST",			BYTE_T,			_OFFSET(wlanBurst),		_SIZE(wlanBurst)},
{MIB_WLAN_WEP152_KEY1,			"WEP152_KEY1",			BYTE16_T,		_OFFSET(wep152Key1),		_SIZE(wep152Key1)},
{MIB_WLAN_WEP152_KEY2,			"WEP152_KEY2",			BYTE16_T,		_OFFSET(wep152Key2),		_SIZE(wep152Key2)},
{MIB_WLAN_WEP152_KEY3,			"WEP152_KEY3",			BYTE16_T,		_OFFSET(wep152Key3),		_SIZE(wep152Key3)},
{MIB_WLAN_WEP152_KEY4,			"WEP152_KEY4",			BYTE16_T,		_OFFSET(wep152Key4),		_SIZE(wep152Key4)},
//*************************************** wireless setting ****************************************
{MIB_1X_MODE,				"DOT1X_MODE",			BYTE_T,			_OFFSET(sel1xMode),		_SIZE(sel1xMode)},
{MIB_ELAN_MAC_ADDR,			"ELAN_MAC_ADDR",		BYTE6_T,		_OFFSET(elanMacAddr),		_SIZE(elanMacAddr)},
{MIB_WLAN_MAC_ADDR,			"WLAN_MAC_ADDR",		BYTE6_T,		_OFFSET(wlanMacAddr),		_SIZE(wlanMacAddr)},
{MIB_WLAN_SSID,				"SSID",				STRING_T,		_OFFSET(ssid),			_SIZE(ssid)},
{MIB_WLAN_CHAN_NUM,			"CHANNEL",			BYTE_T,			_OFFSET(channel),		_SIZE(channel)},
{MIB_WLAN_WEP,				"WEP",				BYTE_T,			_OFFSET(wep),			_SIZE(wep)},
{MIB_WLAN_WEP64_KEY1,			"WEP64_KEY1",			BYTE5_T,		_OFFSET(wep64Key1),		_SIZE(wep64Key1)},
{MIB_WLAN_WEP64_KEY2,			"WEP64_KEY2",			BYTE5_T,		_OFFSET(wep64Key2),		_SIZE(wep64Key2)},
{MIB_WLAN_WEP64_KEY3,			"WEP64_KEY3",			BYTE5_T,		_OFFSET(wep64Key3),		_SIZE(wep64Key3)},
{MIB_WLAN_WEP64_KEY4,			"WEP64_KEY4",			BYTE5_T,		_OFFSET(wep64Key4),		_SIZE(wep64Key4)},
{MIB_WLAN_WEP128_KEY1,			"WEP128_KEY1",			BYTE13_T,		_OFFSET(wep128Key1),		_SIZE(wep128Key1)},
{MIB_WLAN_WEP128_KEY2,			"WEP128_KEY2",			BYTE13_T,		_OFFSET(wep128Key2),		_SIZE(wep128Key2)},
{MIB_WLAN_WEP128_KEY3,			"WEP128_KEY3",			BYTE13_T,		_OFFSET(wep128Key3),		_SIZE(wep128Key3)},
{MIB_WLAN_WEP128_KEY4,			"WEP128_KEY4",			BYTE13_T,		_OFFSET(wep128Key4),		_SIZE(wep128Key4)},
{MIB_WLAN_WEP_DEFAULT_KEY,		"WEP_DEFAULT_KEY",		BYTE_T,			_OFFSET(wepDefaultKey),		_SIZE(wepDefaultKey)},
{MIB_WLAN_WEP_KEY_TYPE,			"WEP_KEY_TYPE",			BYTE_T,			_OFFSET(wepKeyType),		_SIZE(wepKeyType)},
{MIB_WLAN_FRAG_THRESHOLD,		"FRAG_THRESHOLD",		WORD_T,			_OFFSET(fragThreshold),		_SIZE(fragThreshold)},
{MIB_WLAN_SUPPORTED_RATE,		"SUPPORTED_RATES",		WORD_T,			_OFFSET(supportedRates),	_SIZE(supportedRates)},
{MIB_WLAN_BEACON_INTERVAL,		"BEACON_INTERVAL",		WORD_T,			_OFFSET(beaconInterval),	_SIZE(beaconInterval)},
{MIB_WLAN_PREAMBLE_TYPE,		"PREAMBLE_TYPE",		BYTE_T,			_OFFSET(preambleType),		_SIZE(preambleType)},
{MIB_WLAN_BASIC_RATE,			"BASIC_RATES",			WORD_T,			_OFFSET(basicRates),		_SIZE(basicRates)},
{MIB_WLAN_RTS_THRESHOLD,		"RTS_THRESHOLD",		WORD_T,			_OFFSET(rtsThreshold),		_SIZE(rtsThreshold)},
{MIB_WLAN_AUTH_TYPE,			"AUTH_TYPE",			BYTE_T,			_OFFSET(authType),		_SIZE(authType)},
{MIB_WLAN_HIDDEN_SSID,			"HIDDEN_SSID",			BYTE_T,			_OFFSET(hiddenSSID),		_SIZE(hiddenSSID)},
{MIB_WLAN_DISABLED,			"WLAN_DISABLED",		BYTE_T,			_OFFSET(wlanDisabled),		_SIZE(wlanDisabled)},
{MIB_WLAN_INACTIVITY_TIME,		"INACTIVITY_TIME",		DWORD_T,		_OFFSET(inactivityTime),	_SIZE(inactivityTime)},
{MIB_WLAN_RATE_ADAPTIVE_ENABLED,	"RATE_ADAPTIVE_ENABLED",	BYTE_T,			_OFFSET(rateAdaptiveEnabled),	_SIZE(rateAdaptiveEnabled)},
{MIB_WLAN_DTIM_PERIOD,			"DTIM_PERIOD",			BYTE_T,			_OFFSET(dtimPeriod),		_SIZE(dtimPeriod)},
{MIB_WLAN_NETWORK_TYPE,			"NETWORK_TYPE",			BYTE_T,			_OFFSET(networkType),		_SIZE(networkType)},
{MIB_WLAN_IAPP_DISABLED,		"IAPP_DISABLED",		BYTE_T,			_OFFSET(iappDisabled),		_SIZE(iappDisabled)},
{MIB_WLAN_PROTECTION_DISABLED,		"PROTECTION_DISABLED",		BYTE_T,			_OFFSET(protectionDisabled),	_SIZE(protectionDisabled)},
{MIB_WLAN_NAT25_MAC_CLONE,		"MACCLONE_ENABLED",		BYTE_T,			_OFFSET(maccloneEnabled),	_SIZE(maccloneEnabled)},
{MIB_WLAN_BAND,				"BAND",				BYTE_T,			_OFFSET(wlanBand),		_SIZE(wlanBand)},
{MIB_WLAN_FIX_RATE,			"FIX_RATE",			WORD_T,			_OFFSET(fixedTxRate),		_SIZE(fixedTxRate)},
{MIB_WLAN_WPA2_PRE_AUTH,		"WPA2_PRE_AUTH",		BYTE_T,			_OFFSET(wpa2PreAuth),		_SIZE(wpa2PreAuth)},
{MIB_WLAN_WPA2_CIPHER_SUITE,		"WPA2_CIPHER_SUITE",		BYTE_T,			_OFFSET(wpa2Cipher),		_SIZE(wpa2Cipher)},
{MIB_WLAN_SET_TX,			"WLAN_SET_TX",			BYTE_T,			_OFFSET(wlanSetTx),		_SIZE(wlanSetTx)},
{MIB_AP_MODE,				"AP_MODE",			BYTE_T,			_OFFSET(apMode),		_SIZE(apMode)},
{MIB_SECURITY_MODE,			"SECURITY_MODE",		BYTE_T,			_OFFSET(secMode),		_SIZE(secMode)},
{MIB_CLIENT_IP_DISABLED,		"CLIENT_IP_DISABLED",		BYTE_T,			_OFFSET(clIpDisabled),		_SIZE(clIpDisabled)},
{MIB_WLAN_BLOCK_RELAY,			"WLAN_BLOCK_RELAY",		BYTE_T,			_OFFSET(blockRelay),		_SIZE(blockRelay)},
{MIB_AUTO_MAC_CLONE,			"AUTO_MAC_CLONE",		BYTE_T,			_OFFSET(autoMacClone),		_SIZE(autoMacClone)},
{MIB_OP_MODE,				"OP_MODE",			BYTE_T,			_OFFSET(opMode),		_SIZE(opMode)},
{MIB_WISP_WAN_ID,			"WISP_WAN_ID",			BYTE_T,			_OFFSET(wispWanId),		_SIZE(wispWanId)},

//************************************* STATION of SECURITY *************************************
#ifndef HOME_GATEWAY
//	#ifdef _IPN_WL_DEVICE_
{MIB_STA_SSID,				"STA_SSID",			STRING_T,		_OFFSET(staSsid),		_SIZE(staSsid)},
{MIB_STA_SEC_MODE,			"STA_SEC_MODE",			BYTE_T,			_OFFSET(staSecMode),		_SIZE(staSecMode)},
{MIB_ADHOC_SEC_MODE,			"ADHOC_SEC_MODE",		BYTE_T,			_OFFSET(adhocSecMode),		_SIZE(adhocSecMode)},
{MIB_STA_ENCRYPT,			"STA_ENCRYPT",			BYTE_T,			_OFFSET(staEncrypt),		_SIZE(staEncrypt)},
{MIB_STA_WPA_AUTH,			"STA_WPA_AUTH",			BYTE_T,			_OFFSET(staWpaAuth),		_SIZE(staWpaAuth)},
{MIB_STA_AUTH_TYPE,			"STA_AUTH_TYPE",		BYTE_T,			_OFFSET(staAuthType),		_SIZE(staAuthType)},
{MIB_STA_WPA_CIPHER_SUITE,		"STA_WPA_CIPHER_SUITE",		BYTE_T,			_OFFSET(staWpaCipher),		_SIZE(staWpaCipher)},
{MIB_STA_WEP,				"STA_WEP",			BYTE_T,			_OFFSET(staWep),		_SIZE(staWep)},
{MIB_STA_WEP64_KEY1,			"STA_WEP64_KEY1",		BYTE5_T,		_OFFSET(sta64Key1),		_SIZE(sta64Key1)},
{MIB_STA_WEP64_KEY2,			"STA_WEP64_KEY2",		BYTE5_T,		_OFFSET(sta64Key2),		_SIZE(sta64Key2)},
{MIB_STA_WEP64_KEY3,			"STA_WEP64_KEY3",		BYTE5_T,		_OFFSET(sta64Key3),		_SIZE(sta64Key3)},
{MIB_STA_WEP64_KEY4,			"STA_WEP64_KEY4",		BYTE5_T,		_OFFSET(sta64Key4),		_SIZE(sta64Key4)},
{MIB_STA_WEP128_KEY1,			"STA_WEP128_KEY1",		BYTE13_T,		_OFFSET(sta128Key1),		_SIZE(sta128Key1)},
{MIB_STA_WEP128_KEY2,			"STA_WEP128_KEY2",		BYTE13_T,		_OFFSET(sta128Key2),		_SIZE(sta128Key2)},
{MIB_STA_WEP128_KEY3,			"STA_WEP128_KEY3",		BYTE13_T,		_OFFSET(sta128Key3),		_SIZE(sta128Key3)},
{MIB_STA_WEP128_KEY4,			"STA_WEP128_KEY4",		BYTE13_T,		_OFFSET(sta128Key4),		_SIZE(sta128Key4)},
{MIB_STA_WEP_DEFKEY,			"STA_WEP_DEFKEY",		BYTE_T,			_OFFSET(staWepDefKey),		_SIZE(staWepDefKey)},
{MIB_STA_WEP_KEY_TYPE,			"STA_WEP_KEY_TYPE",		BYTE_T,			_OFFSET(staKeyType),		_SIZE(staKeyType)},
{MIB_STA_WPA_PSK_FORMAT,		"STA_PSK_FORMAT",		BYTE_T,			_OFFSET(staPSKFormat),		_SIZE(staPSKFormat)},
{MIB_STA_WPA_PSK,			"STA_WPA_PSK",			STRING_T,		_OFFSET(staPSK),		_SIZE(staPSK)},
{MIB_WLAN_BSSID,			"WLAN_BSSID",			BYTE6_T,		_OFFSET(wlanBssid),		_SIZE(wlanBssid)},
//{MIB_STA_METHOD,			"STA_METHOD",			BYTE_T,			_OFFSET(staMethod),		_SIZE(staMethod)},
{MIB_STA_ENRADIUS,			"STA_ENRADIUS",			BYTE_T,			_OFFSET(staEnRadius),		_SIZE(staEnRadius)},
{MIB_STA_EAP_TYPE,			"STA_EAP_TYPE",			BYTE_T,			_OFFSET(staEapTp),		_SIZE(staEapTp)},
{MIB_STA_ENCLT_CER,			"STA_ENCLT_CER",		BYTE_T,			_OFFSET(staEnCltCer),		_SIZE(staEnCltCer)},
{MIB_STA_ENSER_CER,			"STA_ENSER_CER",		BYTE_T,			_OFFSET(staEnSerCer),		_SIZE(staEnSerCer)},
{MIB_CLT_CER_FILE,			"CLT_CER_FILE",			BYTE_T,			_OFFSET(cltCerFile),		_SIZE(cltCerFile)},
{MIB_SER_CER_FILE,			"SER_CER_FILE",			BYTE_T,			_OFFSET(serCerFile),		_SIZE(serCerFile)},
{MIB_STA_ID,				"STA_ID",			STRING_T,		_OFFSET(staId),			_SIZE(staId)},
{MIB_STA_PASS,				"STA_PASS",			STRING_T,		_OFFSET(staPass),		_SIZE(staPass)},
{MIB_STA_PROTOCOL,			"STA_PROTOCOL",			STRING_T,		_OFFSET(staPoto),		_SIZE(staPoto)},
{MIB_STA_EAP_ID,			"STA_EAP_ID",			STRING_T,		_OFFSET(staEapId),		_SIZE(staEapId)},
{MIB_STA_EAP_PASS,			"STA_EAP_PASS",			STRING_T,		_OFFSET(staEapPass),		_SIZE(staEapPass)},
{MIB_STA_CLIENT_PASS,			"STA_CLIENT_PASS",		STRING_T,		_OFFSET(staCltPass),		_SIZE(staCltPass)},
{MIB_STA_SERVER_PASS,			"STA_SERVER_PASS",		STRING_T,		_OFFSET(staSerPass),		_SIZE(staSerPass)},
{MIB_STA_RTS,				"STA_RTS",			WORD_T,			_OFFSET(staRts),		_SIZE(staRts)},
{MIB_STA_FRAGMENT,			"STA_FRAGMENT",			WORD_T,			_OFFSET(staFrag),		_SIZE(staFrag)},
{MIB_STA_PREAMBLE,			"STA_PREAMBLE",			BYTE_T,			_OFFSET(staPream),		_SIZE(staPream)},
//	#endif
#endif
//**************************************** WEP of WDS****************************************
{MIB_WL_LINKMAC1, 			"WL_LINKMAC1",			BYTE6_T,		_OFFSET(wlLinkMac1),		_SIZE(wlLinkMac1)},
{MIB_WL_LINKMAC2, 			"WL_LINKMAC2",			BYTE6_T,		_OFFSET(wlLinkMac2),		_SIZE(wlLinkMac2)},
{MIB_WL_LINKMAC3, 			"WL_LINKMAC3",			BYTE6_T,		_OFFSET(wlLinkMac3),		_SIZE(wlLinkMac3)},
{MIB_WL_LINKMAC4, 			"WL_LINKMAC4",			BYTE6_T,		_OFFSET(wlLinkMac4),		_SIZE(wlLinkMac4)},
{MIB_WL_LINKMAC5, 			"WL_LINKMAC5",			BYTE6_T,		_OFFSET(wlLinkMac5),		_SIZE(wlLinkMac5)},
{MIB_WL_LINKMAC6, 			"WL_LINKMAC6",			BYTE6_T,		_OFFSET(wlLinkMac6),		_SIZE(wlLinkMac6)},
{MIB_WLAN_WDS_ENABLED,			"WDS_ENABLED",			BYTE_T,			_OFFSET(wdsEnabled),		_SIZE(wdsEnabled)},
{MIB_WLAN_WDS_ENCRYPT,			"WLAN_WDS_ENCRYPT",		BYTE_T,			_OFFSET(wdsEncrypt),		_SIZE(encrypt)},
{MIB_WLAN_WDS_WPA_AUTH,			"WLAN_WDS_WPA_AUTH",		BYTE_T,			_OFFSET(wdsWpaAuth),		_SIZE(wpaAuth)},
{MIB_WLAN_WDS_WPA_CIPHER_SUITE,		"WLAN_WDS_WPA_CIPHER_SUITE",	BYTE_T,			_OFFSET(wdsWpaCipher),		_SIZE(wpaCipher)},
{MIB_WLAN_WDS_WPA2_CIPHER_SUITE,	"WLAN_WDS_WPA2_CIPHER_SUITE",	BYTE_T,			_OFFSET(wdsWpa2Cipher),		_SIZE(wpa2Cipher)},
{MIB_WLAN_WDS_WPA_PSK,			"WLAN_WDS_WPA_PSK",		STRING_T,		_OFFSET(wdsWpaPSK),		_SIZE(wpaPSK)},
{MIB_WLAN_WDS_WPA_PSK_FORMAT,		"WLAN_WDS_PSK_FORMAT",		BYTE_T,			_OFFSET(wdsWpaPSKFormat),	_SIZE(wpaPSKFormat)},
//--------------------------------------------------------------------------------------------
#ifdef WLAN_WPA
{MIB_WLAN_ENCRYPT,			"WLAN_ENCRYPT",			BYTE_T,			_OFFSET(encrypt),		_SIZE(encrypt)},
{MIB_WLAN_ENABLE_SUPP_NONWPA,		"WLAN_ENABLE_SUPP_NONWPA",	BYTE_T,			_OFFSET(enableSuppNonWpa),	_SIZE(enableSuppNonWpa)},
{MIB_WLAN_SUPP_NONWPA,			"WLAN_SUPP_NONWPA",		BYTE_T,			_OFFSET(suppNonWpa),		_SIZE(suppNonWpa)},
{MIB_WLAN_WPA_AUTH,			"WLAN_WPA_AUTH",		BYTE_T,			_OFFSET(wpaAuth),		_SIZE(wpaAuth)},
{MIB_WLAN_WPA_CIPHER_SUITE,		"WLAN_WPA_CIPHER_SUITE",	BYTE_T,			_OFFSET(wpaCipher),		_SIZE(wpaCipher)},
{MIB_WLAN_WPA_PSK,			"WLAN_WPA_PSK",			STRING_T,		_OFFSET(wpaPSK),		_SIZE(wpaPSK)},
{MIB_WLAN_WPA_GROUP_REKEY_TIME,		"WLAN_WPA_GROUP_REKEY_TIME",	DWORD_T,		_OFFSET(wpaGroupRekeyTime),	_SIZE(wpaGroupRekeyTime)},
#if defined(_Customer_EX_) || defined(_Customer_SA_)
{MIB_WLAN_WPA_GROUP_REKEY_TIME_1,       "WLAN_WPA_GROUP_REKEY_TIME_1",  DWORD_T,                _OFFSET(wpaGroupRekeyTime1),     _SIZE(wpaGroupRekeyTime1)},
{MIB_WLAN_WPA_GROUP_REKEY_TIME_2,       "WLAN_WPA_GROUP_REKEY_TIME_2",  DWORD_T,                _OFFSET(wpaGroupRekeyTime2),     _SIZE(wpaGroupRekeyTime2)},
{MIB_WLAN_WPA_GROUP_REKEY_TIME_3,       "WLAN_WPA_GROUP_REKEY_TIME_3",  DWORD_T,                _OFFSET(wpaGroupRekeyTime3),     _SIZE(wpaGroupRekeyTime3)},
{MIB_WLAN_WPA_GROUP_REKEY_TIME_4,       "WLAN_WPA_GROUP_REKEY_TIME_4",  DWORD_T,                _OFFSET(wpaGroupRekeyTime4),     _SIZE(wpaGroupRekeyTime4)},
{MIB_WLAN_WPA_GROUP_REKEY_TIME_5,       "WLAN_WPA_GROUP_REKEY_TIME_5",  DWORD_T,                _OFFSET(wpaGroupRekeyTime5),     _SIZE(wpaGroupRekeyTime5)},
{MIB_WLAN_WPA_GROUP_REKEY_TIME_6,       "WLAN_WPA_GROUP_REKEY_TIME_6",  DWORD_T,                _OFFSET(wpaGroupRekeyTime6),     _SIZE(wpaGroupRekeyTime6)},
{MIB_WLAN_WPA_GROUP_REKEY_TIME_7,       "WLAN_WPA_GROUP_REKEY_TIME_7",  DWORD_T,                _OFFSET(wpaGroupRekeyTime7),     _SIZE(wpaGroupRekeyTime7)},
#endif
{MIB_WLAN_ENABLE_MAC_AUTH,		"MAC_AUTH_ENABLED",		BYTE_T,			_OFFSET(macAuthEnabled),	_SIZE(macAuthEnabled)},
{MIB_WLAN_RS_IP,			"RS_IP",			IA_T,			_OFFSET(rsIpAddr),		_SIZE(rsIpAddr)},
{MIB_WLAN_RS_PORT,			"RS_PORT",			WORD_T,			_OFFSET(rsPort),		_SIZE(rsPort)},
{MIB_WLAN_RS_PASSWORD,			"RS_PASSWORD",			STRING_T,		_OFFSET(rsPassword),		_SIZE(rsPassword)},
{MIB_WLAN_RS_RETRY,			"RS_MAXRETRY",			BYTE_T,			_OFFSET(rsMaxRetry),		_SIZE(rsMaxRetry)},
{MIB_WLAN_RS_INTERVAL_TIME,		"RS_INTERVAL_TIME",		WORD_T,			_OFFSET(rsIntervalTime),	_SIZE(rsIntervalTime)},
{MIB_WLAN_ACCOUNT_RS_ENABLED,		"ACCOUNT_RS_ENABLED",		BYTE_T,			_OFFSET(accountRsEnabled),	_SIZE(accountRsEnabled)},
{MIB_WLAN_ACCOUNT_RS_IP,		"ACCOUNT_RS_IP",		IA_T,			_OFFSET(accountRsIpAddr),	_SIZE(accountRsIpAddr)},
{MIB_WLAN_ACCOUNT_RS_PORT,		"ACCOUNT_RS_PORT",		WORD_T,			_OFFSET(accountRsPort),		_SIZE(accountRsPort)},
{MIB_WLAN_ACCOUNT_RS_PASSWORD,		"ACCOUNT_RS_PASSWORD",		STRING_T,		_OFFSET(accountRsPassword),	_SIZE(accountRsPassword)},
{MIB_WLAN_ACCOUNT_UPDATE_ENABLED,	"ACCOUNT_RS_UPDATE_ENABLED",	BYTE_T,			_OFFSET(accountRsUpdateEnabled),_SIZE(accountRsUpdateEnabled)},
{MIB_WLAN_ACCOUNT_UPDATE_DELAY,		"ACCOUNT_RS_UPDATE_DELAY",	WORD_T,			_OFFSET(accountRsUpdateDelay),	_SIZE(accountRsUpdateDelay)},
{MIB_WLAN_ACCOUNT_RS_RETRY,		"ACCOUNT_RS_MAXRETRY",		BYTE_T,			_OFFSET(accountRsMaxRetry),	_SIZE(accountRsMaxRetry)},
{MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME,	"ACCOUNT_RS_INTERVAL_TIME",	WORD_T,			_OFFSET(accountRsIntervalTime),	_SIZE(accountRsIntervalTime)},
//{MIB_WLAN_SUPP_NONWPA,		"WLAN_SUPP_NONWPA",		BYTE_T,			_OFFSET(suppNonWpa),		_SIZE(suppNonWpa)},
{MIB_WLAN_ENABLE_1X,			"WLAN_ENABLE_1X",		BYTE_T,			_OFFSET(enable1X),		_SIZE(enable1X)},
{MIB_WLAN_WPA_PSK_FORMAT,		"WLAN_PSK_FORMAT",		BYTE_T,			_OFFSET(wpaPSKFormat),		_SIZE(wpaPSKFormat)},
//{MIB_WLAN_RS_INTERVAL_TIME,		"MAC_AUTH_ENABLED",		BYTE_T,			_OFFSET(macAuthEnabled),	_SIZE(macAuthEnabled)},
#ifdef _MULTIPLE_WLAN_RS_SETTING_
{MIB_WLAN_RS_IP_1,                "RS_IP_1",                IA_T,                   _OFFSET(rsIpAddr1),       _SIZE(rsIpAddr1)},
{MIB_WLAN_RS_IP_2,                "RS_IP_2",                IA_T,                   _OFFSET(rsIpAddr2),       _SIZE(rsIpAddr2)},
{MIB_WLAN_RS_IP_3,                "RS_IP_3",                IA_T,                   _OFFSET(rsIpAddr3),       _SIZE(rsIpAddr3)},
{MIB_WLAN_RS_IP_4,                "RS_IP_4",                IA_T,                   _OFFSET(rsIpAddr4),       _SIZE(rsIpAddr4)},
{MIB_WLAN_RS_IP_5,                "RS_IP_5",                IA_T,                   _OFFSET(rsIpAddr5),       _SIZE(rsIpAddr5)},
{MIB_WLAN_RS_IP_6,                "RS_IP_6",                IA_T,                   _OFFSET(rsIpAddr6),       _SIZE(rsIpAddr6)},
{MIB_WLAN_RS_IP_7,                "RS_IP_7",                IA_T,                   _OFFSET(rsIpAddr7),       _SIZE(rsIpAddr7)},
{MIB_WLAN_RS_PORT_1,                      "RS_PORT_1",                      WORD_T,                 _OFFSET(rsPort1),                _SIZE(rsPort1)},
{MIB_WLAN_RS_PORT_2,                      "RS_PORT_2",                      WORD_T,                 _OFFSET(rsPort2),                _SIZE(rsPort2)},
{MIB_WLAN_RS_PORT_3,                      "RS_PORT_3",                      WORD_T,                 _OFFSET(rsPort3),                _SIZE(rsPort3)},
{MIB_WLAN_RS_PORT_4,                      "RS_PORT_4",                      WORD_T,                 _OFFSET(rsPort4),                _SIZE(rsPort4)},
{MIB_WLAN_RS_PORT_5,                      "RS_PORT_5",                      WORD_T,                 _OFFSET(rsPort5),                _SIZE(rsPort5)},
{MIB_WLAN_RS_PORT_6,                      "RS_PORT_6",                      WORD_T,                 _OFFSET(rsPort6),                _SIZE(rsPort6)},
{MIB_WLAN_RS_PORT_7,                      "RS_PORT_7",                      WORD_T,                 _OFFSET(rsPort7),                _SIZE(rsPort7)},
{MIB_WLAN_RS_PASSWORD_1,                  "RS_PASSWORD_1",                  STRING_T,               _OFFSET(rsPassword1),            _SIZE(rsPassword1)},
{MIB_WLAN_RS_PASSWORD_2,                  "RS_PASSWORD_2",                  STRING_T,               _OFFSET(rsPassword2),            _SIZE(rsPassword2)},
{MIB_WLAN_RS_PASSWORD_3,                  "RS_PASSWORD_3",                  STRING_T,               _OFFSET(rsPassword3),            _SIZE(rsPassword3)},
{MIB_WLAN_RS_PASSWORD_4,                  "RS_PASSWORD_4",                  STRING_T,               _OFFSET(rsPassword4),            _SIZE(rsPassword4)},
{MIB_WLAN_RS_PASSWORD_5,                  "RS_PASSWORD_5",                  STRING_T,               _OFFSET(rsPassword5),            _SIZE(rsPassword5)},
{MIB_WLAN_RS_PASSWORD_6,                  "RS_PASSWORD_6",                  STRING_T,               _OFFSET(rsPassword6),            _SIZE(rsPassword6)},
{MIB_WLAN_RS_PASSWORD_7,                  "RS_PASSWORD_7",                  STRING_T,               _OFFSET(rsPassword7),            _SIZE(rsPassword7)},
{MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_1,     "ACCOUNT_RS_INTERVAL_TIME_1",     WORD_T,                 _OFFSET(accountRsIntervalTime1), _SIZE(accountRsIntervalTime1)},
{MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_2,     "ACCOUNT_RS_INTERVAL_TIME_2",     WORD_T,                 _OFFSET(accountRsIntervalTime2), _SIZE(accountRsIntervalTime2)},
{MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_3,     "ACCOUNT_RS_INTERVAL_TIME_3",     WORD_T,                 _OFFSET(accountRsIntervalTime3), _SIZE(accountRsIntervalTime3)},
{MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_4,     "ACCOUNT_RS_INTERVAL_TIME_4",     WORD_T,                 _OFFSET(accountRsIntervalTime4), _SIZE(accountRsIntervalTime4)},
{MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_5,     "ACCOUNT_RS_INTERVAL_TIME_5",     WORD_T,                 _OFFSET(accountRsIntervalTime5), _SIZE(accountRsIntervalTime5)},
{MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_6,     "ACCOUNT_RS_INTERVAL_TIME_6",     WORD_T,                 _OFFSET(accountRsIntervalTime6), _SIZE(accountRsIntervalTime6)},
{MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_7,     "ACCOUNT_RS_INTERVAL_TIME_7",     WORD_T,                 _OFFSET(accountRsIntervalTime7), _SIZE(accountRsIntervalTime7)},
{MIB_WLAN_RS_INTERVAL_TIME_1,             "RS_INTERVAL_TIME_1",             WORD_T,                 _OFFSET(rsIntervalTime1),        _SIZE(rsIntervalTime1)},
{MIB_WLAN_RS_INTERVAL_TIME_2,             "RS_INTERVAL_TIME_2",             WORD_T,                 _OFFSET(rsIntervalTime2),        _SIZE(rsIntervalTime2)},
{MIB_WLAN_RS_INTERVAL_TIME_3,             "RS_INTERVAL_TIME_3",             WORD_T,                 _OFFSET(rsIntervalTime3),        _SIZE(rsIntervalTime3)},
{MIB_WLAN_RS_INTERVAL_TIME_4,             "RS_INTERVAL_TIME_4",             WORD_T,                 _OFFSET(rsIntervalTime4),        _SIZE(rsIntervalTime4)},
{MIB_WLAN_RS_INTERVAL_TIME_5,             "RS_INTERVAL_TIME_5",             WORD_T,                 _OFFSET(rsIntervalTime5),        _SIZE(rsIntervalTime5)},
{MIB_WLAN_RS_INTERVAL_TIME_6,             "RS_INTERVAL_TIME_6",             WORD_T,                 _OFFSET(rsIntervalTime6),        _SIZE(rsIntervalTime6)},
{MIB_WLAN_RS_INTERVAL_TIME_7,             "RS_INTERVAL_TIME_7",             WORD_T,                 _OFFSET(rsIntervalTime7),        _SIZE(rsIntervalTime7)},
#endif
#endif

//{MIB_ALIAS_NAME,			"ALIAS_NAME",			STRING_T,		_OFFSET(aliasName),		_SIZE(aliasName)},
{MIB_IP_ADDR,				"IP_ADDR",			IA_T,			_OFFSET(ipAddr),		_SIZE(ipAddr)},
//--------------------------------------------------------------------------------------------
{MIB_DHCPGATEWAYIP_ADDR,		"DHCPGATEWAYIP_ADDR",		IA_T,			_OFFSET(DhcpGatewayIPAddr),	_SIZE(DhcpGatewayIPAddr)},
{MIB_DHCPNAMESERVER_ADDR,		"DHCPNAMESERVER_ADDR",		IA_T,			_OFFSET(DhcpNameServerIPAddr),	_SIZE(DhcpNameServerIPAddr)},
{MIB_DOMAIN_NAME,			"DOMAIN_NAME",			STRING_T,		_OFFSET(DomainNames),		_SIZE(DomainNames)},
{MIB_LAN_LEASETIME,			"LAN_LEASE_TIME",		DWORD_T,		_OFFSET(leaseTime),		_SIZE(leaseTime)},
//--------------------------------------------------------------------------------------------
{MIB_SUBNET_MASK,			"SUBNET_MASK",			IA_T,			_OFFSET(subnetMask),		_SIZE(subnetMask)},
{MIB_DEFAULT_GATEWAY,			"DEFAULT_GATEWAY",		IA_T,			_OFFSET(defaultGateway),	_SIZE(defaultGateway)},
{MIB_DHCP,				"DHCP",				BYTE_T,			_OFFSET(dhcp),			_SIZE(dhcp)},
{MIB_STP_ENABLED,			"STP_ENABLED",			BYTE_T,			_OFFSET(stpEnabled),		_SIZE(stpEnabled)},
{MIB_WLAN_AC_NUM,			"WLAN_MACAC_NUM",		BYTE_T,			_OFFSET(acNum),			_SIZE(acNum)},
{MIB_WLAN_AC_ENABLED,			"WLAN_MACAC_ENABLED",		BYTE_T,			_OFFSET(acEnabled),		_SIZE(acEnabled)},
{MIB_WLAN_AC_ADDR,			"WLAN_MACAC_ADDR",		WLAC_ARRAY_T,		_OFFSET(acAddrArray),		_SIZE(acAddrArray)},
{MIB_SUPER_NAME,			"SUPER_NAME",			STRING_T,		_OFFSET(superName),		_SIZE(superName)},
{MIB_SUPER_PASSWORD,			"SUPER_PASSWORD",		STRING_T,		_OFFSET(superPassword),		_SIZE(superPassword)},
{MIB_USER_NAME,				"USER_NAME",			STRING_T,		_OFFSET(userName),		_SIZE(userName)},
{MIB_USER_PASSWORD,			"USER_PASSWORD",		STRING_T,		_OFFSET(userPassword),		_SIZE(userPassword)},
//----------------------------------------TimeZone------------------------------------------------
#if defined(HOME_GATEWAY) || defined(_AP_WITH_TIMEZONE_)
{MIB_TIME_ZONE_SEL,			"TIME_ZONE_SEL",		WORD_T,			_OFFSET(TimeZoneSel),		_SIZE(TimeZoneSel)},
{MIB_START_MONTH,			"START_MONTH",			WORD_T,			_OFFSET(startMonth),		_SIZE(startMonth)},
{MIB_START_DAY,				"START_DAY",			WORD_T,			_OFFSET(startDay),		_SIZE(startDay)},
{MIB_END_MONTH,				"END_MONTH",			WORD_T,			_OFFSET(endMonth),		_SIZE(endMonth)},
{MIB_END_DAY,				"END_DAY",			WORD_T,			_OFFSET(endDay),		_SIZE(endDay)},
#if defined(_BR6428PNL_)
{MIB_TIMESERVER_ADDR,			"TIMESERVER_ADDR",		STRING_T,			_OFFSET(TimeServerAddr),	_SIZE(TimeServerAddr)},
#else
{MIB_TIMESERVER_ADDR,                   "TIMESERVER_ADDR",              IA_T,                   _OFFSET(TimeServerAddr),        _SIZE(TimeServerAddr)},
#endif
{MIB_DAYLIGHT_ENABLE,			"DAYLIGHT_ENABLE",		BYTE_T,			_OFFSET(DayLightEnable),	_SIZE(DayLightEnable)},
#endif
#ifdef HOME_GATEWAY
//------------------------------------Remote Management Host Address-----------------------------
{MIB_REMANHOST_ADDR,			"REMANHOST_ADDR",		IA_T,			_OFFSET(reManHostAddr),		_SIZE(reManHostAddr)},
{MIB_REMAN_PORT,			"REMAN_PORT",			WORD_T,			_OFFSET(reManPort),		_SIZE(reManPort)},
{MIB_REMANG_ENABLE,			"REMANG_ENABLE",		BYTE_T,			_OFFSET(reMangEnable),		_SIZE(reMangEnable)},
{MIB_UPNP_ENABLE,			"UPNP_ENABLE",			BYTE_T,			_OFFSET(upnpEnable),		_SIZE(upnpEnable)},
{MIB_NAT_ENABLE,			"NAT_ENABLE",			BYTE_T,			_OFFSET(natEnable),		_SIZE(natEnable)},
{MIB_FAST_NAT_ENABLE,			"FAST_NAT_ENABLE",		BYTE_T,			_OFFSET(fastNatEnable),		_SIZE(fastNatEnable)},
{MIB_FIREWALL_ENABLE,			"FIREWALL_ENABLE",		BYTE_T,			_OFFSET(FirewallEnable),	_SIZE(FirewallEnable)},
{MIB_VSER_ENABLED,			"VSER_ENABLED",			BYTE_T,			_OFFSET(vserEnabled),		_SIZE(vserEnabled)},
{MIB_VSER_NUM,				"VSER_TBL_NUM",			BYTE_T,			_OFFSET(vserNum),		_SIZE(vserNum)},
{MIB_POD_ENABLED,			"POD_ENABLED",			BYTE_T,			_OFFSET(podEnable),		_SIZE(podEnable)},
{MIB_PIN_ENABLED,			"PIN_ENABLED",			BYTE_T,			_OFFSET(pingEnable),		_SIZE(pingEnable)},
{MIB_SCAN_ENABLED,			"SCAN_ENABLED",			BYTE_T,			_OFFSET(scanEnable),		_SIZE(scanEnable)},
{MIB_SYN_ENABLED,			"SYN_ENABLED",			BYTE_T,			_OFFSET(synEnable),		_SIZE(synEnable)},
{MIB_POD_PACK,				"POD_PACK",			WORD_T,			_OFFSET(podPack),		_SIZE(podPack)},
{MIB_POD_TIME,				"POD_TIME",			BYTE_T,			_OFFSET(podTime),		_SIZE(podTime)},
{MIB_POD_BUR,				"POD_BUR",			WORD_T,			_OFFSET(podBur),		_SIZE(podBur)},
{MIB_SYN_PACK,				"SYN_PACK",			WORD_T,			_OFFSET(synPack),		_SIZE(synPack)},
{MIB_SYN_TIME,				"SYN_TIME",			BYTE_T,			_OFFSET(synTime),		_SIZE(synTime)},
{MIB_SYN_BUR,				"SYN_BUR",			WORD_T,			_OFFSET(synBur),		_SIZE(synBur)},
{MIB_SCAN_NUM,				"SCAN_NUM",			INDEXDOS_T,		_OFFSET(scanNum),		_SIZE(scanNum)},
#if defined(_ENRIP_)
//RIP
{MIB_RIP_ENABLED,			"RIP_ENABLED",			BYTE_T,			_OFFSET(ripEnable),		_SIZE(ripEnable)},
#endif
#if defined(_ENSNMP_)
//SNMP
{MIB_SNMP_ENABLE,			"SNMP_ENABLED",			BYTE_T,			_OFFSET(snmpEnable),		_SIZE(snmpEnable)},
{MIB_SNMP_NAME,				"SNMP_NAME",			STRING_T,		_OFFSET(snmpName),		_SIZE(snmpName)},
#endif
{MIB_DDNS_NAME,				"DDNS_NAME",			STRING_T,		_OFFSET(ddnsName),		_SIZE(ddnsName)},
{MIB_DDNS_ACCOUNT,			"DDNS_ACCOUNT",			STRING_T,		_OFFSET(ddnsAccount),		_SIZE(ddnsAccount)},
{MIB_DDNS_PASS,				"DDNS_PASS",			STRING_T,		_OFFSET(ddnsPass),		_SIZE(ddnsPass)},
{MIB_DDNS_ENABLE,			"DDNS_ENABLED",			BYTE_T,			_OFFSET(ddnsEnable),		_SIZE(ddnsEnable)},
{MIB_DDNS_PVIDSEL,			"DDNS_PVID_SEL",		STRING_T,		_OFFSET(ddnspvidSel),		_SIZE(ddnspvidSel)},
{MIB_APP_LAYER_GATEWAY,			"APP_LAYER_GATEWAY",		INDEX_T,		_OFFSET(appLayerGateway),	_SIZE(appLayerGateway)},
{MIB_DHIS_HOSTID,			"DHIS_HOSTID",			DWORD_T,		_OFFSET(dhisHostID),		_SIZE(dhisHostID)},
// Lance 2003.11.05
//{MIB_DHIS_ISADDR,			"DHIS_ISADDR",			IA_T,			_OFFSET(dhisISAddr),		_SIZE(dhisISAddr)},
{MIB_DHIS_ISADDR,			"DHIS_ISADDR",			STRING_T,		_OFFSET(dhisISAddr),		_SIZE(dhisISAddr)},
//
{MIB_DHIS_PASSWORD,			"DHIS_PASSWORD",		STRING_T,		_OFFSET(dhispass),		_SIZE(dhispass)},
{MIB_DHIS_AUTH_P1,			"DHIS_AUTH_P1",			STRING_T,		_OFFSET(dhisAuthP1),		_SIZE(dhisAuthP1)},
{MIB_DHIS_AUTH_P2,			"DHIS_AUTH_P2",			STRING_T,		_OFFSET(dhisAuthP2),		_SIZE(dhisAuthP2)},
{MIB_DHIS_AUTH_Q1,			"DHIS_AUTH_Q1",			STRING_T,		_OFFSET(dhisAuthQ1),		_SIZE(dhisAuthQ1)},
{MIB_DHIS_AUTH_Q2,			"DHIS_AUTH_Q2",			STRING_T,		_OFFSET(dhisAuthQ2),		_SIZE(dhisAuthQ2)},
{MIB_DHIS_SELECT,			"DHIS_SELECT",			BYTE_T,			_OFFSET(dhisSelect),		_SIZE(dhisSelect)},
#endif
#ifdef HOME_GATEWAY  // For Guarantee QoS
{MIB_MAX_DOWNLOAD_BANDWIDTH,		"MAX_DOWNLOAD_BANDWIDTH",	DWORD_T,		_OFFSET(MaxDownBandwidth),	_SIZE(MaxDownBandwidth)},
{MIB_MAX_UPLOAD_BANDWIDTH,		"MAX_UPLOAD_BANDWIDTH",		DWORD_T,		_OFFSET(MaxUpBandwidth),	_SIZE(MaxUpBandwidth)},
#endif
#ifdef UNIVERSAL_REPEATER
{MIB_REPEATER_ENABLED,			"REPEATER_ENABLED",		BYTE_T,			_OFFSET(repeaterEnabled),	_SIZE(repeaterEnabled)},
{MIB_REPEATER_SSID,			"REPEATER_SSID",		STRING_T,		_OFFSET(repeaterSSID),		_SIZE(repeaterSSID)},
#endif
//------------------------------------------------------------------------------------------------
// Lance 2004.2.16
{MIB_PS_ENABLE,				"PS_ENABLE",			BYTE_T,			_OFFSET(psEnable),		_SIZE(psEnable)},
{MIB_PS_IPPENABLE,			"PS_IPPENABLE",			BYTE_T,			_OFFSET(psIPPEnable),		_SIZE(psIPPEnable)},
{MIB_PS_LPRENABLE,			"PS_LPRENABLE",			BYTE_T,			_OFFSET(psLPREnable),		_SIZE(psLPREnable)},
{MIB_PS_NAME,				"PS_NAME",			STRING_T,		_OFFSET(psName),		_SIZE(psName)},
{MIB_PS_PORT1NAME,			"PS_PORT1NAME",			STRING_T,		_OFFSET(psPort1Name),		_SIZE(psPort1Name)},
{MIB_PS_PORT2NAME,			"PS_PORT2NAME",			STRING_T,		_OFFSET(psPort2Name),		_SIZE(psPort2Name)},
#ifdef HOME_GATEWAY
{MIB_AP_ROUTER_SWITCH,			"AP_ROUTER_SWITCH",		BYTE_T,			_OFFSET(apRouterSwitch),	_SIZE(apRouterSwitch)},
#endif
// kyle 2007.03.12 for WPS---------------------------------------------------------------------------
{MIB_WPS_ENABLE,			"WPS_ENABLE",			BYTE_T,			_OFFSET(wpsEnable),		_SIZE(wpsEnable)},
{MIB_WPS_CONFIG_MODE,			"WPS_CONFIG_MODE",		BYTE_T,			_OFFSET(wpsConfigMode),		_SIZE(wpsConfigMode)},
{MIB_WPS_PROXY_ENABLE,			"WPS_PROXY_ENABLE",		BYTE_T,			_OFFSET(wpsProxyEnable),	_SIZE(wpsProxyEnable)},
{MIB_WPS_INTERNAL_REG,			"WPS_INTERNAL_REG",		BYTE_T,			_OFFSET(wpsInternalReg),	_SIZE(wpsInternalReg)},
{MIB_WPS_CONFIG_TYPE,			"WPS_CONFIG_TYPE",		BYTE_T,			_OFFSET(wpsConfigType),		_SIZE(wpsConfigType)},
{MIB_WPS_CONFIG_STATUS,			"WPS_CONFIG_STATUS",		BYTE_T,			_OFFSET(wpsConfigStatus),	_SIZE(wpsConfigStatus)},
{MIB_WPS_PIN_CODE,			"WPS_PIN_CODE",		STRING_T,		_OFFSET(wpsPinCode),		_SIZE(wpsPinCode)},
{MIB_WPS_DISPLAY_KEY,			"WPS_DISPLAY_KEY",		BYTE_T,			_OFFSET(wpsDisplayKey),		_SIZE(wpsDisplayKey)},
//kyle add for noForwarding
#if defined(HOME_GATEWAY) || defined(_AP_WLAN_NOFORWARD_)
{MIB_WLAN_NOFORWARD,			"WLAN_NOFORWARD",		BYTE_T,			_OFFSET(wlanForward),		_SIZE(wlanForward)},
#endif
{MIB_DDNS_STATUS,			"DDNS_STATUS",			BYTE_T,			_OFFSET(ddnsStatus),		_SIZE(ddnsStatus)},
//ADSL :kyle
#ifdef _7264Wn_
{MIB_ADSL_VPI,				"ADSL_VPI",			WORD_T,			_OFFSET(adslVPI),		_SIZE(adslVPI)},
{MIB_ADSL_VCI,				"ADSL_VCI",			WORD_T,			_OFFSET(adslVCI),		_SIZE(adslVCI)},
{MIB_ADSL_ENCAP,			"ADSL_ENCAP",			BYTE_T,			_OFFSET(adslEncapsulation),	_SIZE(adslEncapsulation)},
{MIB_ADSL_WAN_TYPE,			"ADSL_WAN_TYPE",		BYTE_T,			_OFFSET(adslWanType),		_SIZE(adslWanType)},
{MIB_ADSL_ADSLMode,			"ADSL_ADSLMode",		BYTE_T,			_OFFSET(adslMode),		_SIZE(adslMode)},
{MIB_ADSL_ADSLType,			"ADSL_ADSLType",		BYTE_T,			_OFFSET(adslType),		_SIZE(adslType)},
{MIB_ADSL_ATM,				"ADSL_ATM",			BYTE_T,			_OFFSET(adslATM),		_SIZE(adslATM)},
{MIB_ADSL_PCR,				"ADSL_PCR",			WORD_T,			_OFFSET(adslPCR),		_SIZE(adslPCR)},
{MIB_ADSL_SCR,				"ADSL_SCR",			WORD_T,			_OFFSET(adslSCR),		_SIZE(adslSCR)},
{MIB_ADSL_MBS,				"ADSL_MBS",			WORD_T,			_OFFSET(adslMBS),		_SIZE(adslMBS)},
// ADSL END
#endif
// for vista support (auto bridge whan wan is private ip.)
{MIB_AUTO_BRIDGE,			"AUTO_BRIDGE",			BYTE_T,			_OFFSET(autoBridge),		_SIZE(autoBridge)},
// for wif test support.
{MIB_WIFI_TEST,				"WIFI_TEST",			BYTE_T,			_OFFSET(wifiTest),		_SIZE(wifiTest)},
{MIB_IS_RESET_DEFAULT,			"IS_RESET_DEFAULT",		BYTE_T,			_OFFSET(isResetDefault),	_SIZE(isResetDefault)},
{MIB_IGMP_PROXY_ENABLED,		"IGMP_PROXY_ENABLED",		BYTE_T,			_OFFSET(igmpproxyEnabled ),	_SIZE(igmpproxyEnabled )},
#ifdef _corega_
{MIB_TIMEZONE_SELECTED,			"TIMEZONE_SELECTED",		BYTE_T,			_OFFSET(timezoneselected),	_SIZE(timezoneselected)},
#endif
//Wise
#ifdef _MSSID_
{MIB_WLAN_BAND_1,			"BAND_1",			BYTE_T,			_OFFSET(wlanBand1),		_SIZE(wlanBand1)},
{MIB_WLAN_BAND_2,			"BAND_2",			BYTE_T,			_OFFSET(wlanBand2),		_SIZE(wlanBand2)},
{MIB_WLAN_BAND_3,			"BAND_3",			BYTE_T,			_OFFSET(wlanBand3),		_SIZE(wlanBand3)},
{MIB_WLAN_BAND_4,			"BAND_4",			BYTE_T,			_OFFSET(wlanBand4),		_SIZE(wlanBand4)},
{MIB_WLAN_SSID_1,			"SSID_1",			STRING_T,		_OFFSET(ssid1),			_SIZE(ssid1)},
{MIB_WLAN_SSID_2,			"SSID_2",			STRING_T,		_OFFSET(ssid2),			_SIZE(ssid2)},
{MIB_WLAN_SSID_3,			"SSID_3",			STRING_T,		_OFFSET(ssid3),			_SIZE(ssid3)},
{MIB_WLAN_SSID_4,			"SSID_4",			STRING_T,		_OFFSET(ssid4),			_SIZE(ssid4)},
{MIB_WLAN_SSID_5,			"SSID_5",			STRING_T,		_OFFSET(ssid5),			_SIZE(ssid5)},
{MIB_WLAN_SSID_6,			"SSID_6",			STRING_T,		_OFFSET(ssid6),			_SIZE(ssid6)},
{MIB_WLAN_SSID_7,			"SSID_7",			STRING_T,		_OFFSET(ssid7),			_SIZE(ssid7)},
{MIB_WLAN_WEP64_KEY1_1,			"WEP64_KEY1_1",			BYTE5_T,		_OFFSET(wep64Key11),		_SIZE(wep64Key11)},
{MIB_WLAN_WEP64_KEY2_1,			"WEP64_KEY2_1",			BYTE5_T,		_OFFSET(wep64Key21),		_SIZE(wep64Key21)},
{MIB_WLAN_WEP64_KEY3_1,			"WEP64_KEY3_1",			BYTE5_T,		_OFFSET(wep64Key31),		_SIZE(wep64Key31)},
{MIB_WLAN_WEP64_KEY4_1,			"WEP64_KEY4_1",			BYTE5_T,		_OFFSET(wep64Key41),		_SIZE(wep64Key41)},
{MIB_WLAN_WEP64_KEY1_2,			"WEP64_KEY1_2",			BYTE5_T,		_OFFSET(wep64Key12),		_SIZE(wep64Key12)},
{MIB_WLAN_WEP64_KEY2_2,			"WEP64_KEY2_2",			BYTE5_T,		_OFFSET(wep64Key22),		_SIZE(wep64Key22)},
{MIB_WLAN_WEP64_KEY3_2,			"WEP64_KEY3_2",			BYTE5_T,		_OFFSET(wep64Key32),		_SIZE(wep64Key32)},
{MIB_WLAN_WEP64_KEY4_2,			"WEP64_KEY4_2",			BYTE5_T,		_OFFSET(wep64Key42),		_SIZE(wep64Key42)},
{MIB_WLAN_WEP64_KEY1_3,			"WEP64_KEY1_3",			BYTE5_T,		_OFFSET(wep64Key13),		_SIZE(wep64Key13)},
{MIB_WLAN_WEP64_KEY2_3,			"WEP64_KEY2_3",			BYTE5_T,		_OFFSET(wep64Key23),		_SIZE(wep64Key23)},
{MIB_WLAN_WEP64_KEY3_3,			"WEP64_KEY3_3",			BYTE5_T,		_OFFSET(wep64Key33),		_SIZE(wep64Key33)},
{MIB_WLAN_WEP64_KEY4_3,			"WEP64_KEY4_3",			BYTE5_T,		_OFFSET(wep64Key43),		_SIZE(wep64Key43)},
{MIB_WLAN_WEP64_KEY1_4,			"WEP64_KEY1_4",			BYTE5_T,		_OFFSET(wep64Key14),		_SIZE(wep64Key14)},
{MIB_WLAN_WEP64_KEY2_4,			"WEP64_KEY2_4",			BYTE5_T,		_OFFSET(wep64Key24),		_SIZE(wep64Key24)},
{MIB_WLAN_WEP64_KEY3_4,			"WEP64_KEY3_4",			BYTE5_T,		_OFFSET(wep64Key34),		_SIZE(wep64Key34)},
{MIB_WLAN_WEP64_KEY4_4,			"WEP64_KEY4_4",			BYTE5_T,		_OFFSET(wep64Key44),		_SIZE(wep64Key44)},
{MIB_WLAN_WEP64_KEY1_5,			"WEP64_KEY1_5",			BYTE5_T,		_OFFSET(wep64Key15),		_SIZE(wep64Key15)},
{MIB_WLAN_WEP64_KEY2_5,			"WEP64_KEY2_5",			BYTE5_T,		_OFFSET(wep64Key25),		_SIZE(wep64Key25)},
{MIB_WLAN_WEP64_KEY3_5,			"WEP64_KEY3_5",			BYTE5_T,		_OFFSET(wep64Key35),		_SIZE(wep64Key35)},
{MIB_WLAN_WEP64_KEY4_5,			"WEP64_KEY4_5",			BYTE5_T,		_OFFSET(wep64Key45),		_SIZE(wep64Key45)},
{MIB_WLAN_WEP64_KEY1_6,			"WEP64_KEY1_6",			BYTE5_T,		_OFFSET(wep64Key16),		_SIZE(wep64Key16)},
{MIB_WLAN_WEP64_KEY2_6,			"WEP64_KEY2_6",			BYTE5_T,		_OFFSET(wep64Key26),		_SIZE(wep64Key26)},
{MIB_WLAN_WEP64_KEY3_6,			"WEP64_KEY3_6",			BYTE5_T,		_OFFSET(wep64Key36),		_SIZE(wep64Key36)},
{MIB_WLAN_WEP64_KEY4_6,			"WEP64_KEY4_6",			BYTE5_T,		_OFFSET(wep64Key46),		_SIZE(wep64Key46)},
{MIB_WLAN_WEP64_KEY1_7,			"WEP64_KEY1_7",			BYTE5_T,		_OFFSET(wep64Key17),		_SIZE(wep64Key17)},
{MIB_WLAN_WEP64_KEY2_7,			"WEP64_KEY2_7",			BYTE5_T,		_OFFSET(wep64Key27),		_SIZE(wep64Key27)},
{MIB_WLAN_WEP64_KEY3_7,			"WEP64_KEY3_7",			BYTE5_T,		_OFFSET(wep64Key37),		_SIZE(wep64Key37)},
{MIB_WLAN_WEP64_KEY4_7,			"WEP64_KEY4_7",			BYTE5_T,		_OFFSET(wep64Key47),		_SIZE(wep64Key47)},
{MIB_WLAN_WEP128_KEY1_1,		"WEP128_KEY1_1",		BYTE13_T,		_OFFSET(wep128Key11),		_SIZE(wep128Key11)},
{MIB_WLAN_WEP128_KEY2_1,		"WEP128_KEY2_1",		BYTE13_T,		_OFFSET(wep128Key21),		_SIZE(wep128Key21)},
{MIB_WLAN_WEP128_KEY3_1,		"WEP128_KEY3_1",		BYTE13_T,		_OFFSET(wep128Key31),		_SIZE(wep128Key31)},
{MIB_WLAN_WEP128_KEY4_1,		"WEP128_KEY4_1",		BYTE13_T,		_OFFSET(wep128Key41),		_SIZE(wep128Key41)},
{MIB_WLAN_WEP128_KEY1_2,		"WEP128_KEY1_2",		BYTE13_T,		_OFFSET(wep128Key12),		_SIZE(wep128Key12)},
{MIB_WLAN_WEP128_KEY2_2,		"WEP128_KEY2_2",		BYTE13_T,		_OFFSET(wep128Key22),		_SIZE(wep128Key22)},
{MIB_WLAN_WEP128_KEY3_2,		"WEP128_KEY3_2",		BYTE13_T,		_OFFSET(wep128Key32),		_SIZE(wep128Key32)},
{MIB_WLAN_WEP128_KEY4_2,		"WEP128_KEY4_2",		BYTE13_T,		_OFFSET(wep128Key42),		_SIZE(wep128Key42)},
{MIB_WLAN_WEP128_KEY1_3,		"WEP128_KEY1_3",		BYTE13_T,		_OFFSET(wep128Key13),		_SIZE(wep128Key13)},
{MIB_WLAN_WEP128_KEY2_3,		"WEP128_KEY2_3",		BYTE13_T,		_OFFSET(wep128Key23),		_SIZE(wep128Key23)},
{MIB_WLAN_WEP128_KEY3_3,		"WEP128_KEY3_3",		BYTE13_T,		_OFFSET(wep128Key33),		_SIZE(wep128Key33)},
{MIB_WLAN_WEP128_KEY4_3,		"WEP128_KEY4_3",		BYTE13_T,		_OFFSET(wep128Key43),		_SIZE(wep128Key43)},
{MIB_WLAN_WEP128_KEY1_4,		"WEP128_KEY1_4",		BYTE13_T,		_OFFSET(wep128Key14),		_SIZE(wep128Key14)},
{MIB_WLAN_WEP128_KEY2_4,		"WEP128_KEY2_4",		BYTE13_T,		_OFFSET(wep128Key24),		_SIZE(wep128Key24)},
{MIB_WLAN_WEP128_KEY3_4,		"WEP128_KEY3_4",		BYTE13_T,		_OFFSET(wep128Key34),		_SIZE(wep128Key34)},
{MIB_WLAN_WEP128_KEY4_4,		"WEP128_KEY4_4",		BYTE13_T,		_OFFSET(wep128Key44),		_SIZE(wep128Key44)},
{MIB_WLAN_WEP128_KEY1_5,		"WEP128_KEY1_5",		BYTE13_T,		_OFFSET(wep128Key15),		_SIZE(wep128Key15)},
{MIB_WLAN_WEP128_KEY2_5,		"WEP128_KEY2_5",		BYTE13_T,		_OFFSET(wep128Key25),		_SIZE(wep128Key25)},
{MIB_WLAN_WEP128_KEY3_5,		"WEP128_KEY3_5",		BYTE13_T,		_OFFSET(wep128Key35),		_SIZE(wep128Key35)},
{MIB_WLAN_WEP128_KEY4_5,		"WEP128_KEY4_5",		BYTE13_T,		_OFFSET(wep128Key45),		_SIZE(wep128Key45)},
{MIB_WLAN_WEP128_KEY1_6,		"WEP128_KEY1_6",		BYTE13_T,		_OFFSET(wep128Key16),		_SIZE(wep128Key16)},
{MIB_WLAN_WEP128_KEY2_6,		"WEP128_KEY2_6",		BYTE13_T,		_OFFSET(wep128Key26),		_SIZE(wep128Key26)},
{MIB_WLAN_WEP128_KEY3_6,		"WEP128_KEY3_6",		BYTE13_T,		_OFFSET(wep128Key36),		_SIZE(wep128Key36)},
{MIB_WLAN_WEP128_KEY4_6,		"WEP128_KEY4_6",		BYTE13_T,		_OFFSET(wep128Key46),		_SIZE(wep128Key46)},
{MIB_WLAN_WEP128_KEY1_7,		"WEP128_KEY1_7",		BYTE13_T,		_OFFSET(wep128Key17),		_SIZE(wep128Key17)},
{MIB_WLAN_WEP128_KEY2_7,		"WEP128_KEY2_7",		BYTE13_T,		_OFFSET(wep128Key27),		_SIZE(wep128Key27)},
{MIB_WLAN_WEP128_KEY3_7,		"WEP128_KEY3_7",		BYTE13_T,		_OFFSET(wep128Key37),		_SIZE(wep128Key37)},
{MIB_WLAN_WEP128_KEY4_7,		"WEP128_KEY4_7",		BYTE13_T,		_OFFSET(wep128Key47),		_SIZE(wep128Key47)},
{MIB_WLAN_WPA_PSK_1,			"WLAN_WPA_PSK_1",		STRING_T,		_OFFSET(wpaPSK1),		_SIZE(wpaPSK1)},
{MIB_WLAN_WPA_PSK_2,			"WLAN_WPA_PSK_2",		STRING_T,		_OFFSET(wpaPSK2),		_SIZE(wpaPSK2)},
{MIB_WLAN_WPA_PSK_3,			"WLAN_WPA_PSK_3",		STRING_T,		_OFFSET(wpaPSK3),		_SIZE(wpaPSK3)},
{MIB_WLAN_WPA_PSK_4,			"WLAN_WPA_PSK_4",		STRING_T,		_OFFSET(wpaPSK4),		_SIZE(wpaPSK4)},
{MIB_WLAN_WPA_PSK_5,			"WLAN_WPA_PSK_5",		STRING_T,		_OFFSET(wpaPSK5),		_SIZE(wpaPSK5)},
{MIB_WLAN_WPA_PSK_6,			"WLAN_WPA_PSK_6",		STRING_T,		_OFFSET(wpaPSK6),		_SIZE(wpaPSK6)},
{MIB_WLAN_WPA_PSK_7,			"WLAN_WPA_PSK_7",		STRING_T,		_OFFSET(wpaPSK7),		_SIZE(wpaPSK7)},
{MIB_SECURITY_MODE_1,			"SECURITY_MODE_1",		BYTE_T,			_OFFSET(secMode1),		_SIZE(secMode1)},
{MIB_SECURITY_MODE_2,			"SECURITY_MODE_2",		BYTE_T,			_OFFSET(secMode2),		_SIZE(secMode2)},
{MIB_SECURITY_MODE_3,			"SECURITY_MODE_3",		BYTE_T,			_OFFSET(secMode3),		_SIZE(secMode3)},
{MIB_SECURITY_MODE_4,			"SECURITY_MODE_4",		BYTE_T,			_OFFSET(secMode4),		_SIZE(secMode4)},
{MIB_SECURITY_MODE_5,			"SECURITY_MODE_5",		BYTE_T,			_OFFSET(secMode5),		_SIZE(secMode5)},
{MIB_SECURITY_MODE_6,			"SECURITY_MODE_6",		BYTE_T,			_OFFSET(secMode6),		_SIZE(secMode6)},
{MIB_SECURITY_MODE_7,			"SECURITY_MODE_7",		BYTE_T,			_OFFSET(secMode7),		_SIZE(secMode7)},
{MIB_WLAN_ENABLE_1X_1,			"WLAN_ENABLE_1X_1",		BYTE_T,			_OFFSET(enable1X1),		_SIZE(enable1X1)},
{MIB_WLAN_ENABLE_1X_2,			"WLAN_ENABLE_1X_2",		BYTE_T,			_OFFSET(enable1X2),		_SIZE(enable1X2)},
{MIB_WLAN_ENABLE_1X_3,			"WLAN_ENABLE_1X_3",		BYTE_T,			_OFFSET(enable1X3),		_SIZE(enable1X3)},
{MIB_WLAN_ENABLE_1X_4,			"WLAN_ENABLE_1X_4",		BYTE_T,			_OFFSET(enable1X4),		_SIZE(enable1X4)},
{MIB_WLAN_ENABLE_1X_5,			"WLAN_ENABLE_1X_5",		BYTE_T,			_OFFSET(enable1X5),		_SIZE(enable1X5)},
{MIB_WLAN_ENABLE_1X_6,			"WLAN_ENABLE_1X_6",		BYTE_T,			_OFFSET(enable1X6),		_SIZE(enable1X6)},
{MIB_WLAN_ENABLE_1X_7,			"WLAN_ENABLE_1X_7",		BYTE_T,			_OFFSET(enable1X7),		_SIZE(enable1X7)},
{MIB_WLAN_WEP_1,			"WEP_1",			BYTE_T,			_OFFSET(wep1),			_SIZE(wep1)},
{MIB_WLAN_WEP_2,			"WEP_2",			BYTE_T,			_OFFSET(wep2),			_SIZE(wep2)},
{MIB_WLAN_WEP_3,			"WEP_3",			BYTE_T,			_OFFSET(wep3),			_SIZE(wep3)},
{MIB_WLAN_WEP_4,			"WEP_4",			BYTE_T,			_OFFSET(wep4),			_SIZE(wep4)},
{MIB_WLAN_WEP_5,			"WEP_5",			BYTE_T,			_OFFSET(wep5),			_SIZE(wep5)},
{MIB_WLAN_WEP_6,			"WEP_6",			BYTE_T,			_OFFSET(wep6),			_SIZE(wep6)},
{MIB_WLAN_WEP_7,			"WEP_7",			BYTE_T,			_OFFSET(wep7),			_SIZE(wep7)},
{MIB_WLAN_WEP_KEY_TYPE_1,		"WEP_KEY_TYPE_1",		BYTE_T,			_OFFSET(wepKeyType1),		_SIZE(wepKeyType1)},
{MIB_WLAN_WEP_KEY_TYPE_2,		"WEP_KEY_TYPE_2",		BYTE_T,			_OFFSET(wepKeyType2),		_SIZE(wepKeyType2)},
{MIB_WLAN_WEP_KEY_TYPE_3,		"WEP_KEY_TYPE_3",		BYTE_T,			_OFFSET(wepKeyType3),		_SIZE(wepKeyType3)},
{MIB_WLAN_WEP_KEY_TYPE_4,		"WEP_KEY_TYPE_4",		BYTE_T,			_OFFSET(wepKeyType4),		_SIZE(wepKeyType4)},
{MIB_WLAN_WEP_KEY_TYPE_5,		"WEP_KEY_TYPE_5",		BYTE_T,			_OFFSET(wepKeyType5),		_SIZE(wepKeyType5)},
{MIB_WLAN_WEP_KEY_TYPE_6,		"WEP_KEY_TYPE_6",		BYTE_T,			_OFFSET(wepKeyType6),		_SIZE(wepKeyType6)},
{MIB_WLAN_WEP_KEY_TYPE_7,		"WEP_KEY_TYPE_7",		BYTE_T,			_OFFSET(wepKeyType7),		_SIZE(wepKeyType7)},
{MIB_WLAN_WPA_CIPHER_SUITE_1,		"WLAN_WPA_CIPHER_SUITE_1",	BYTE_T,			_OFFSET(wpaCipher1),		_SIZE(wpaCipher1)},
{MIB_WLAN_WPA_CIPHER_SUITE_2,		"WLAN_WPA_CIPHER_SUITE_2",	BYTE_T,			_OFFSET(wpaCipher2),		_SIZE(wpaCipher2)},
{MIB_WLAN_WPA_CIPHER_SUITE_3,		"WLAN_WPA_CIPHER_SUITE_3",	BYTE_T,			_OFFSET(wpaCipher3),		_SIZE(wpaCipher3)},
{MIB_WLAN_WPA_CIPHER_SUITE_4,		"WLAN_WPA_CIPHER_SUITE_4",	BYTE_T,			_OFFSET(wpaCipher4),		_SIZE(wpaCipher4)},
{MIB_WLAN_WPA_CIPHER_SUITE_5,		"WLAN_WPA_CIPHER_SUITE_5",	BYTE_T,			_OFFSET(wpaCipher5),		_SIZE(wpaCipher5)},
{MIB_WLAN_WPA_CIPHER_SUITE_6,		"WLAN_WPA_CIPHER_SUITE_6",	BYTE_T,			_OFFSET(wpaCipher6),		_SIZE(wpaCipher6)},
{MIB_WLAN_WPA_CIPHER_SUITE_7,		"WLAN_WPA_CIPHER_SUITE_7",	BYTE_T,			_OFFSET(wpaCipher7),		_SIZE(wpaCipher7)},
{MIB_WLAN_WPA2_CIPHER_SUITE_1,		"WPA2_CIPHER_SUITE_1",		BYTE_T,			_OFFSET(wpa2Cipher1),		_SIZE(wpa2Cipher1)},
{MIB_WLAN_WPA2_CIPHER_SUITE_2,		"WPA2_CIPHER_SUITE_2",		BYTE_T,			_OFFSET(wpa2Cipher2),		_SIZE(wpa2Cipher2)},
{MIB_WLAN_WPA2_CIPHER_SUITE_3,		"WPA2_CIPHER_SUITE_3",		BYTE_T,			_OFFSET(wpa2Cipher3),		_SIZE(wpa2Cipher3)},
{MIB_WLAN_WPA2_CIPHER_SUITE_4,		"WPA2_CIPHER_SUITE_4",		BYTE_T,			_OFFSET(wpa2Cipher4),		_SIZE(wpa2Cipher4)},
{MIB_WLAN_WPA2_CIPHER_SUITE_5,		"WPA2_CIPHER_SUITE_5",		BYTE_T,			_OFFSET(wpa2Cipher5),		_SIZE(wpa2Cipher5)},
{MIB_WLAN_WPA2_CIPHER_SUITE_6,		"WPA2_CIPHER_SUITE_6",		BYTE_T,			_OFFSET(wpa2Cipher6),		_SIZE(wpa2Cipher6)},
{MIB_WLAN_WPA2_CIPHER_SUITE_7,		"WPA2_CIPHER_SUITE_7",		BYTE_T,			_OFFSET(wpa2Cipher7),		_SIZE(wpa2Cipher7)},
{MIB_WLAN_WPA_PSK_FORMAT_1,		"WLAN_PSK_FORMAT_1",		BYTE_T,			_OFFSET(wpaPSKFormat1),		_SIZE(wpaPSKFormat1)},
{MIB_WLAN_WPA_PSK_FORMAT_2,		"WLAN_PSK_FORMAT_2",		BYTE_T,			_OFFSET(wpaPSKFormat2),		_SIZE(wpaPSKFormat2)},
{MIB_WLAN_WPA_PSK_FORMAT_3,		"WLAN_PSK_FORMAT_3",		BYTE_T,			_OFFSET(wpaPSKFormat3),		_SIZE(wpaPSKFormat3)},
{MIB_WLAN_WPA_PSK_FORMAT_4,		"WLAN_PSK_FORMAT_4",		BYTE_T,			_OFFSET(wpaPSKFormat4),		_SIZE(wpaPSKFormat4)},
{MIB_WLAN_WPA_PSK_FORMAT_5,		"WLAN_PSK_FORMAT_5",		BYTE_T,			_OFFSET(wpaPSKFormat5),		_SIZE(wpaPSKFormat5)},
{MIB_WLAN_WPA_PSK_FORMAT_6,		"WLAN_PSK_FORMAT_6",		BYTE_T,			_OFFSET(wpaPSKFormat6),		_SIZE(wpaPSKFormat6)},
{MIB_WLAN_WPA_PSK_FORMAT_7,		"WLAN_PSK_FORMAT_7",		BYTE_T,			_OFFSET(wpaPSKFormat7),		_SIZE(wpaPSKFormat7)},
{MIB_WLAN_WEP_DEFAULT_KEY_1,		"WEP_DEFAULT_KEY_1",		BYTE_T,			_OFFSET(wepDefaultKey1),	_SIZE(wepDefaultKey1)},
{MIB_WLAN_WEP_DEFAULT_KEY_2,		"WEP_DEFAULT_KEY_2",		BYTE_T,			_OFFSET(wepDefaultKey2),	_SIZE(wepDefaultKey2)},
{MIB_WLAN_WEP_DEFAULT_KEY_3,		"WEP_DEFAULT_KEY_3",		BYTE_T,			_OFFSET(wepDefaultKey3),	_SIZE(wepDefaultKey3)},
{MIB_WLAN_WEP_DEFAULT_KEY_4,		"WEP_DEFAULT_KEY_4",		BYTE_T,			_OFFSET(wepDefaultKey4),	_SIZE(wepDefaultKey4)},
{MIB_WLAN_WEP_DEFAULT_KEY_5,		"WEP_DEFAULT_KEY_5",		BYTE_T,			_OFFSET(wepDefaultKey5),	_SIZE(wepDefaultKey5)},
{MIB_WLAN_WEP_DEFAULT_KEY_6,		"WEP_DEFAULT_KEY_6",		BYTE_T,			_OFFSET(wepDefaultKey6),	_SIZE(wepDefaultKey6)},
{MIB_WLAN_WEP_DEFAULT_KEY_7,		"WEP_DEFAULT_KEY_7",		BYTE_T,			_OFFSET(wepDefaultKey7),	_SIZE(wepDefaultKey7)},
{MIB_WLAN_SSID_MIRROR_1,		"SSID_MIRROR_1",		BYTE_T,			_OFFSET(ssidMirror1),		_SIZE(ssidMirror1)},
{MIB_WLAN_SSID_MIRROR_2,		"SSID_MIRROR_2",		BYTE_T,			_OFFSET(ssidMirror2),		_SIZE(ssidMirror2)},
{MIB_WLAN_SSID_MIRROR_3,		"SSID_MIRROR_3",		BYTE_T,			_OFFSET(ssidMirror3),		_SIZE(ssidMirror3)},
{MIB_WLAN_SSID_MIRROR_4,		"SSID_MIRROR_4",		BYTE_T,			_OFFSET(ssidMirror4),		_SIZE(ssidMirror4)},
{MIB_WLAN_SSID_MIRROR_5,		"SSID_MIRROR_5",		BYTE_T,			_OFFSET(ssidMirror5),		_SIZE(ssidMirror5)},
{MIB_WLAN_SSID_MIRROR_6,		"SSID_MIRROR_6",		BYTE_T,			_OFFSET(ssidMirror6),		_SIZE(ssidMirror6)},
{MIB_WLAN_SSID_MIRROR_7,		"SSID_MIRROR_7",		BYTE_T,			_OFFSET(ssidMirror7),		_SIZE(ssidMirror7)},
{MIB_WLAN_FIX_RATE_1,			"FIX_RATE_1",			WORD_T,			_OFFSET(fixedTxRate1),		_SIZE(fixedTxRate1)},
{MIB_WLAN_FIX_RATE_2,			"FIX_RATE_2",			WORD_T,			_OFFSET(fixedTxRate2),		_SIZE(fixedTxRate2)},
{MIB_WLAN_FIX_RATE_3,			"FIX_RATE_3",			WORD_T,			_OFFSET(fixedTxRate3),		_SIZE(fixedTxRate3)},
{MIB_WLAN_FIX_RATE_4,			"FIX_RATE_4",			WORD_T,			_OFFSET(fixedTxRate4),		_SIZE(fixedTxRate4)},
{MIB_WLAN_FIX_RATE_5,			"FIX_RATE_5",			WORD_T,			_OFFSET(fixedTxRate5),		_SIZE(fixedTxRate5)},
{MIB_WLAN_FIX_RATE_6,			"FIX_RATE_6",			WORD_T,			_OFFSET(fixedTxRate6),		_SIZE(fixedTxRate6)},
{MIB_WLAN_FIX_RATE_7,			"FIX_RATE_7",			WORD_T,			_OFFSET(fixedTxRate7),		_SIZE(fixedTxRate7)},
{MIB_WLAN_HIDDEN_SSID_1,		"HIDDEN_SSID_1",		BYTE_T,			_OFFSET(hiddenSSID1),		_SIZE(hiddenSSID1)},
{MIB_WLAN_HIDDEN_SSID_2,		"HIDDEN_SSID_2",		BYTE_T,			_OFFSET(hiddenSSID2),		_SIZE(hiddenSSID2)},
{MIB_WLAN_HIDDEN_SSID_3,		"HIDDEN_SSID_3",		BYTE_T,			_OFFSET(hiddenSSID3),		_SIZE(hiddenSSID3)},
{MIB_WLAN_HIDDEN_SSID_4,		"HIDDEN_SSID_4",		BYTE_T,			_OFFSET(hiddenSSID4),		_SIZE(hiddenSSID4)},
{MIB_WLAN_HIDDEN_SSID_5,		"HIDDEN_SSID_5",		BYTE_T,			_OFFSET(hiddenSSID5),		_SIZE(hiddenSSID5)},
{MIB_WLAN_HIDDEN_SSID_6,		"HIDDEN_SSID_6",		BYTE_T,			_OFFSET(hiddenSSID6),		_SIZE(hiddenSSID6)},
{MIB_WLAN_HIDDEN_SSID_7,		"HIDDEN_SSID_7",		BYTE_T,			_OFFSET(hiddenSSID7),		_SIZE(hiddenSSID7)},
{MIB_WLAN_WMM_1,			"WLAN_WMM_1",			BYTE_T,			_OFFSET(wlanWmm1),		_SIZE(wlanWmm1)},
{MIB_WLAN_WMM_2,			"WLAN_WMM_2",			BYTE_T,			_OFFSET(wlanWmm2),		_SIZE(wlanWmm2)},
{MIB_WLAN_WMM_3,			"WLAN_WMM_3",			BYTE_T,			_OFFSET(wlanWmm3),		_SIZE(wlanWmm3)},
{MIB_WLAN_WMM_4,			"WLAN_WMM_4",			BYTE_T,			_OFFSET(wlanWmm4),		_SIZE(wlanWmm4)},
{MIB_WLAN_WMM_5,			"WLAN_WMM_5",			BYTE_T,			_OFFSET(wlanWmm5),		_SIZE(wlanWmm5)},
{MIB_WLAN_WMM_6,			"WLAN_WMM_6",			BYTE_T,			_OFFSET(wlanWmm6),		_SIZE(wlanWmm6)},
{MIB_WLAN_WMM_7,			"WLAN_WMM_7",			BYTE_T,			_OFFSET(wlanWmm7),		_SIZE(wlanWmm7)},
{MIB_WLAN_ACCESS_1,     "WLAN_ACCESS_1",   	BYTE_T, 			_OFFSET(wlanaccess1), 	_SIZE(wlanaccess1)},
{MIB_WLAN_ACCESS_2,     "WLAN_ACCESS_2",   	BYTE_T, 			_OFFSET(wlanaccess2), 	_SIZE(wlanaccess2)},
{MIB_WLAN_ACCESS_3,     "WLAN_ACCESS_3",   	BYTE_T, 			_OFFSET(wlanaccess3), 	_SIZE(wlanaccess3)},
{MIB_WLAN_ACCESS_4,     "WLAN_ACCESS_4",   	BYTE_T, 			_OFFSET(wlanaccess4), 	_SIZE(wlanaccess4)},
{MIB_WLAN_ENCRYPT_1,			"WLAN_ENCRYPT_1",		BYTE_T,			_OFFSET(encrypt1),		_SIZE(encrypt1)},
{MIB_WLAN_ENCRYPT_2,			"WLAN_ENCRYPT_2",		BYTE_T,			_OFFSET(encrypt2),		_SIZE(encrypt2)},
{MIB_WLAN_ENCRYPT_3,			"WLAN_ENCRYPT_3",		BYTE_T,			_OFFSET(encrypt3),		_SIZE(encrypt3)},
{MIB_WLAN_ENCRYPT_4,			"WLAN_ENCRYPT_4",		BYTE_T,			_OFFSET(encrypt4),		_SIZE(encrypt4)},
{MIB_WLAN_ENCRYPT_5,			"WLAN_ENCRYPT_5",		BYTE_T,			_OFFSET(encrypt5),		_SIZE(encrypt5)},
{MIB_WLAN_ENCRYPT_6,			"WLAN_ENCRYPT_6",		BYTE_T,			_OFFSET(encrypt6),		_SIZE(encrypt6)},
{MIB_WLAN_ENCRYPT_7,			"WLAN_ENCRYPT_7",		BYTE_T,			_OFFSET(encrypt7),		_SIZE(encrypt7)},
{MIB_WLAN_AUTH_TYPE_1,			"AUTH_TYPE_1",			BYTE_T,			_OFFSET(authType1),		_SIZE(authType1)},
{MIB_WLAN_AUTH_TYPE_2,			"AUTH_TYPE_2",			BYTE_T,			_OFFSET(authType2),		_SIZE(authType2)},
{MIB_WLAN_AUTH_TYPE_3,			"AUTH_TYPE_3",			BYTE_T,			_OFFSET(authType3),		_SIZE(authType3)},
{MIB_WLAN_AUTH_TYPE_4,			"AUTH_TYPE_4",			BYTE_T,			_OFFSET(authType4),		_SIZE(authType4)},
{MIB_WLAN_AUTH_TYPE_5,			"AUTH_TYPE_5",			BYTE_T,			_OFFSET(authType5),		_SIZE(authType5)},
{MIB_WLAN_AUTH_TYPE_6,			"AUTH_TYPE_6",			BYTE_T,			_OFFSET(authType6),		_SIZE(authType6)},
{MIB_WLAN_AUTH_TYPE_7,			"AUTH_TYPE_7",			BYTE_T,			_OFFSET(authType7),		_SIZE(authType7)},
{MIB_WLAN_WPA_AUTH_1,			"WLAN_WPA_AUTH_1",		BYTE_T,			_OFFSET(wpaAuth1),		_SIZE(wpaAuth1)},
{MIB_WLAN_WPA_AUTH_2,			"WLAN_WPA_AUTH_2",		BYTE_T,			_OFFSET(wpaAuth2),		_SIZE(wpaAuth2)},
{MIB_WLAN_WPA_AUTH_3,			"WLAN_WPA_AUTH_3",		BYTE_T,			_OFFSET(wpaAuth3),		_SIZE(wpaAuth3)},
{MIB_WLAN_WPA_AUTH_4,			"WLAN_WPA_AUTH_4",		BYTE_T,			_OFFSET(wpaAuth4),		_SIZE(wpaAuth4)},
{MIB_WLAN_WPA_AUTH_5,			"WLAN_WPA_AUTH_5",		BYTE_T,			_OFFSET(wpaAuth5),		_SIZE(wpaAuth5)},
{MIB_WLAN_WPA_AUTH_6,			"WLAN_WPA_AUTH_6",		BYTE_T,			_OFFSET(wpaAuth6),		_SIZE(wpaAuth6)},
{MIB_WLAN_WPA_AUTH_7,			"WLAN_WPA_AUTH_7",		BYTE_T,			_OFFSET(wpaAuth7),		_SIZE(wpaAuth7)},
#if defined(_ENVLAN_)
{MIB_WLAN_VLANID_1,			"VLANID_1",			WORD_T,			_OFFSET(vlanid1),		_SIZE(vlanid1)},
{MIB_WLAN_VLANID_2,			"VLANID_2",			WORD_T,			_OFFSET(vlanid2),		_SIZE(vlanid2)},
{MIB_WLAN_VLANID_3,			"VLANID_3",			WORD_T,			_OFFSET(vlanid3),		_SIZE(vlanid3)},
{MIB_WLAN_VLANID_4,			"VLANID_4",			WORD_T,			_OFFSET(vlanid4),		_SIZE(vlanid4)},
{MIB_WLAN_VLANID_5,			"VLANID_5",			WORD_T,			_OFFSET(vlanid5),		_SIZE(vlanid5)},
{MIB_WLAN_VLANID_6,			"VLANID_6",			WORD_T,			_OFFSET(vlanid6),		_SIZE(vlanid6)},
{MIB_WLAN_VLANID_7,			"VLANID_7",			WORD_T,			_OFFSET(vlanid7),		_SIZE(vlanid7)},
#endif
#endif
#ifdef _EZVIEW_
{MIB_EZVIEW_NUM,			"EZVIEW_NUM",			BYTE_T,			_OFFSET(EZVIEWNum),		_SIZE(EZVIEWNum)},
{MIB_EZVIEW,				"EZVIEW_TBL",			EZVIEW_ARRAY_T,		_OFFSET(EZVIEWArray),		_SIZE(EZVIEWArray)},
{MIB_EZVIEW_DMZ,			"EZVIEW_DMZ",			BYTE_T,			_OFFSET(EZVIEWdmz),		_SIZE(EZVIEWdmz)},
#endif
#ifdef _DALGFTP_
{MIB_ALG_FTP_PORTS,			"ALG_FTP_PORTS",		WORD_T,			_OFFSET(ftpPorts),		_SIZE(ftpPorts)},
#endif
#ifdef _DBAND_
{MIB_DUAL_BAND_SWITCH,			"DUAL_BAND_SWITCH",		BYTE_T,			_OFFSET(dualBandSwitch),	_SIZE(dualBandSwitch)},
{MIB_ABAND_MODE,			"ABAND_MODE",			BYTE_T,			_OFFSET(aBandMode),		_SIZE(aBandMode)},
{MIB_ABAND_CHANNEL,			"ABAND_CHANNEL",		BYTE_T,			_OFFSET(aBandChannel),		_SIZE(aBandChannel)},
#endif
#ifdef _LAN_WAN_ACCESS_
{MIB_LAN_WAN_ACCESS,			"LAN_WAN_ACCESS",		DWORD_T,		_OFFSET(enableLanWanAccess),	_SIZE(enableLanWanAccess)},
#endif
#ifdef _PPPOE_PASSTHROUGH_
{MIB_PPPOE_PASSTHROUGH,			"PPPOE_PASSTHROUGH",		BYTE_T,			_OFFSET(pppoepassthrough),	_SIZE(pppoepassthrough)},
#endif
#ifdef _IPV6_BRIDGE_
{MIB_IPV6_BRIDGE,			"IPV6_BRIDGE",			BYTE_T,			_OFFSET(ipv6bridge),		_SIZE(ipv6bridge)},
#endif
#ifdef _WANTTL_
{MIB_TTL_TYPE,				"TTL_TYPE",			BYTE_T,			_OFFSET(ttlType),		_SIZE(ttlType)},
{MIB_TTL_VALUE,				"TTL_VALUE",			WORD_T,			_OFFSET(ttlValue),		_SIZE(ttlValue)},
#endif
#ifdef _INDEPEND_DHCP_MTU_
{MIB_DHCP_MTU,				"DHCP_MTU",			WORD_T,			_OFFSET(dhcpMTU),		_SIZE(dhcpMTU)},
#endif
#ifdef _SREBOOT_BLINK_POWER_
{MID_IS_REBOOT,				"IS_REBOOT",			BYTE_T,			_OFFSET(isReboot),		_SIZE(isReboot)},
#endif
#ifdef _WATCH_DOG_
{MIB_WATCH_DOG_ENABLE,				"WATCH_DOG_ENABLE",			BYTE_T,			_OFFSET(watchdog_enable),		_SIZE(watchdog_enable)},
{MIB_WATCH_DOG_INTERVAL,				"WATCH_DOG_INTERVAL",			WORD_T,			_OFFSET(watchdog_interval),		_SIZE(watchdog_interval)},
{MIB_WATCH_DOG_HOST,			"WATCH_DOG_HOST",			IA_T,			_OFFSET(watchdog_host),		_SIZE(watchdog_host)},
#endif
//vance 2008.11.03
#ifdef _PC_DATABASE_
{MIB_GROUP1,			"GROUP1",			STRING_T,			_OFFSET(group1),		_SIZE(group1)},
{MIB_GROUP2,			"GROUP2",			STRING_T,			_OFFSET(group2),		_SIZE(group2)},
{MIB_GROUP3,			"GROUP3",			STRING_T,			_OFFSET(group3),		_SIZE(group3)},
{MIB_GROUP4,			"GROUP4",			STRING_T,			_OFFSET(group4),		_SIZE(group4)},
{MIB_GROUP1_DISABLED,	"GROUP1_DISABLED",	BYTE_T,				_OFFSET(group1Disabled),_SIZE(group1Disabled)},
{MIB_GROUP2_DISABLED,	"GROUP2_DISABLED",	BYTE_T,				_OFFSET(group2Disabled),_SIZE(group2Disabled)},
{MIB_GROUP3_DISABLED,	"GROUP3_DISABLED",	BYTE_T,				_OFFSET(group3Disabled),_SIZE(group3Disabled)},
{MIB_GROUP4_DISABLED,	"GROUP4_DISABLED",	BYTE_T,				_OFFSET(group4Disabled),_SIZE(group4Disabled)},
#endif

#if defined(_MULTIPLE_WLAN_ACCESS_CONTROL_ )
{MIB_WLAN_AC2_NUM,			"WLAN_MACAC2_NUM",		BYTE_T,			_OFFSET(acNum2),			_SIZE(acNum2)},
{MIB_WLAN_AC2_ENABLED,			"WLAN_MACAC2_ENABLED",		BYTE_T,			_OFFSET(acEnabled2),		_SIZE(acEnabled2)},
{MIB_WLAN_AC2_ADDR,			"WLAN_MACAC2_ADDR",		WLAC_ARRAY2_T,		_OFFSET(acAddrArray2),		_SIZE(acAddrArray2)},
{MIB_WLAN_AC3_NUM,			"WLAN_MACAC3_NUM",		BYTE_T,			_OFFSET(acNum3),			_SIZE(acNum3)},
{MIB_WLAN_AC3_ENABLED,			"WLAN_MACAC3_ENABLED",			BYTE_T,			_OFFSET(acEnabled3),		_SIZE(acEnabled3)},
{MIB_WLAN_AC3_ADDR,			"WLAN_MACAC3_ADDR",		WLAC_ARRAY3_T,		_OFFSET(acAddrArray3),		_SIZE(acAddrArray3)},
{MIB_WLAN_AC4_NUM,			"WLAN_MACAC4_NUM",		BYTE_T,			_OFFSET(acNum4),			_SIZE(acNum4)},
{MIB_WLAN_AC4_ENABLED,			"WLAN_MACAC4_ENABLED",		BYTE_T,			_OFFSET(acEnabled4),		_SIZE(acEnabled4)},
{MIB_WLAN_AC4_ADDR,			"WLAN_MACAC4_ADDR",		WLAC_ARRAY4_T,		_OFFSET(acAddrArray4),		_SIZE(acAddrArray4)},

{MIB_WLAN_AC5_NUM,                      "WLAN_MACAC5_NUM",              BYTE_T,                 _OFFSET(acNum5),                        _SIZE(acNum5)},
{MIB_WLAN_AC5_ENABLED,                  "WLAN_MACAC5_ENABLED",          BYTE_T,                 _OFFSET(acEnabled5),            _SIZE(acEnabled5)},
{MIB_WLAN_AC5_ADDR,                     "WLAN_MACAC5_ADDR",             WLAC_ARRAY5_T,          _OFFSET(acAddrArray5),          _SIZE(acAddrArray5)},
#endif

//vance 2008.11.14
#ifdef _WIRELESS_SCHEDULE_
{MIB_WLAN_SCH_ENABLED,		"WLAN_SCH_ENABLED",		BYTE_T,			_OFFSET(WlanSchEnabled),	_SIZE(WlanSchEnabled)},
{MIB_WLAN_SCH_NUM,			"WLAN_SCH_NUM",		BYTE_T,			_OFFSET(WlanSchNum),	_SIZE(WlanSchNum)},
{MIB_WLAN_SCH,					"WLAN_SCH",		WLAN_SCH_ARRAY_T,	_OFFSET(WlanSchArray),	_SIZE(WlanSchArray)},
#endif

//Felix 21011222
#ifdef _PROFILE_LIST_
{MIB_PROFILE_LIST_NUM,		"PROFILE_LIST_NUM",		BYTE_T,			_OFFSET(ProfileListNum),	_SIZE(ProfileListNum)},
{MIB_PROFILE_LIST,		"PROFILE_LIST",			PROFILE_LIST_ARRAY_T,	_OFFSET(ProfileListArray),	_SIZE(ProfileListArray)},
#endif
#ifdef _WAN3G_
{MIB_WWAN_AUTHMODESEL,					"WWAN_AUTHMODESEL",		STRING_T,		_OFFSET(AuthModeSel), _SIZE(AuthModeSel)},
{MIB_WWAN_OPMODESEL,					"WWAN_OPMODESEL",		STRING_T,		_OFFSET(OPModeSel), _SIZE(OPModeSel)},
{MIB_WWAN_NPSEL,					"WWAN_NPSEL",			STRING_T,		_OFFSET(NPSel), _SIZE(NPSel)},
{MIB_WWAN_NAME,						"WWAN_NAME",			STRING_T,		_OFFSET(wwanName), _SIZE(wwanName)},
{MIB_WWAN_PASSWORD,					"WWAN_PASSWORD",		STRING_T,		_OFFSET(wwanPassword), _SIZE(wwanPassword)},
{MIB_WWAN_PINCODE,					"WWAN_PINCODE",			STRING_T,		_OFFSET(PINCode), _SIZE(PINCode)},
{MIB_WWAN_APN,						"WWAN_APN",			STRING_T,		_OFFSET(wwanAPN), _SIZE(wwanAPN)},
{MIB_WWAN_PPPNAME,					"WWAN_PPPNAME",			STRING_T,		_OFFSET(PPPName), _SIZE(PPPName)},
{MIB_WWAN_PPPPASS,					"WWAN_PPPPASS",			STRING_T,		_OFFSET(PPPPass), _SIZE(PPPPass)},
{MIB_WWAN_PPPIDLETIME,					"WWAN_PPPIDLETIME",		WORD_T,			_OFFSET(PPPIdleTime), _SIZE(PPPIdleTime)},
{MIB_WWAN_PPPECHOTIMEOUT,				"WWAN_PPPECHOTIMEOUT",		WORD_T,			_OFFSET(PPPEchoTimeout), _SIZE(PPPEchoTimeout)},
{MIB_WWAN_PPPECHOCOUNT,					"WWAN_PPPECHOCOUNT",		WORD_T,			_OFFSET(PPPEchoCount), _SIZE(PPPEchoCount)},
{MIB_WWAN_PHONENO,						"WWAN_PHONENO",			STRING_T,		_OFFSET(wwanPhoneNo), _SIZE(wwanPhoneNo)},
#endif
//vance 2009.02.04 for 3G connetion
#ifdef _STAR_CF_3G_
{MIB_WWAN_NPSEL,					"WWAN_NPSEL",			STRING_T,		_OFFSET(NPSel), _SIZE(NPSel)},
{MIB_WWAN_NAME,						"WWAN_NAME",			STRING_T,		_OFFSET(wwanName), _SIZE(wwanName)},
{MIB_WWAN_PASSWORD,					"WWAN_PASSWORD",		STRING_T,		_OFFSET(wwanPassword), _SIZE(wwanPassword)},
{MIB_WWAN_APN,						"WWAN_APN",			STRING_T,		_OFFSET(wwanAPN), _SIZE(wwanAPN)},
{MIB_WWAN_PPPNAME,					"WWAN_PPPNAME",			STRING_T,		_OFFSET(PPPName), _SIZE(PPPName)},
{MIB_WWAN_PPPPASS,					"WWAN_PPPPASS",			STRING_T,		_OFFSET(PPPPass), _SIZE(PPPPass)},
{MIB_WWAN_PPPIDLETIME,					"WWAN_PPPIDLETIME",		WORD_T,			_OFFSET(PPPIdleTime), _SIZE(PPPIdleTime)},
{MIB_WWAN_PPPECHOTIMEOUT,				"WWAN_PPPECHOTIMEOUT",		WORD_T,			_OFFSET(PPPEchoTimeout), _SIZE(PPPEchoTimeout)},
{MIB_WWAN_PPPECHOCOUNT,					"WWAN_PPPECHOCOUNT",		WORD_T,			_OFFSET(PPPEchoCount), _SIZE(PPPEchoCount)},
{MIB_WWAN_PHONENO,						"WWAN_PHONENO",			STRING_T,		_OFFSET(wwanPhoneNo), _SIZE(wwanPhoneNo)},
{MIB_WWAN_CONNETTYPE,					"WWAN_CONNETTYPE",		BYTE_T,			_OFFSET(connetType), _SIZE(connetType)},
#endif
#ifdef _GENERAL_3G_ //vance 2009.04.09 for general
{MIB_WWAN_PINCODE,					"WWAN_PINCODE",			STRING_T,		_OFFSET(PINCode), _SIZE(PINCode)},
{MIB_WWAN_AUTHMODESEL,				"WWAN_AUTHMODESEL",		STRING_T,		_OFFSET(AuthModeSel), _SIZE(AuthModeSel)},
{MIB_WWAN_OPMODESEL,					"WWAN_OPMODESEL",		STRING_T,		_OFFSET(OPModeSel), _SIZE(OPModeSel)},
#endif
#ifdef _WISP_
//{MIB_STADRV_TYPE,					"STADRV_TYPE",				BYTE_T,			_OFFSET(stadrv_type),			_SIZE(stadrv_type)},
{MIB_STADRV_SSID,					"STADRV_SSID",				STRING_T,		_OFFSET(stadrv_ssid),			_SIZE(stadrv_ssid)},
{MIB_STADRV_CHAN_NUM,			"STADRV_CHANNEL",			BYTE_T,			_OFFSET(stadrv_channel),		_SIZE(stadrv_channel)},
{MIB_STADRV_BAND,					"STADRV_BAND",				BYTE_T,			_OFFSET(stadrv_band),			_SIZE(stadrv_band)},
{MIB_STADRV_ENCRYPT_TYPE,		"STADRV_ENCRYPT_TYPE",	BYTE_T,			_OFFSET(stadrv_encrypttype),	_SIZE(stadrv_encrypttype)},
{MIB_STADRV_WEP_LENGTH,			"STADRV_WEP_LENGTH",		BYTE_T,			_OFFSET(stadrv_weplength),		_SIZE(stadrv_weplength)},
{MIB_STADRV_WEP_FORMAT1,		"STADRV_WEP_FORMAT1",	BYTE_T,			_OFFSET(stadrv_wepformat1),	_SIZE(stadrv_wepformat1)},
{MIB_STADRV_WEP_FORMAT2,		"STADRV_WEP_FORMAT2",	BYTE_T,			_OFFSET(stadrv_wepformat2),	_SIZE(stadrv_wepformat2)},
{MIB_STADRV_WEP_FORMAT3,		"STADRV_WEP_FORMAT3",	BYTE_T,			_OFFSET(stadrv_wepformat3),	_SIZE(stadrv_wepformat3)},
{MIB_STADRV_WEP_FORMAT4,		"STADRV_WEP_FORMAT4",	BYTE_T,			_OFFSET(stadrv_wepformat4),	_SIZE(stadrv_wepformat4)},
{MIB_STADRV_WEP_DEFAULT_KEY,	"STADRV_WEP_DEFAULT_KEY",BYTE_T,			_OFFSET(stadrv_defaultkey),	_SIZE(stadrv_defaultkey)},
{MIB_STADRV_WPA_CIPHER,			"STADRV_WPA_CIPHER",		BYTE_T,			_OFFSET(stadrv_wpacipher),		_SIZE(stadrv_wpacipher)},
{MIB_STADRV_PSK_FORMAT,			"STADRV_PSK_FORMAT",		BYTE_T,			_OFFSET(stadrv_pskformat),		_SIZE(stadrv_pskformat)},
{MIB_STADRV_WEPKEY1,				"STADRV_WEPKEY1",			STRING_T,		_OFFSET(stadrv_wepkey1),		_SIZE(stadrv_wepkey1)},
{MIB_STADRV_WEPKEY2,				"STADRV_WEPKEY2",			STRING_T,		_OFFSET(stadrv_wepkey2),		_SIZE(stadrv_wepkey2)},
{MIB_STADRV_WEPKEY3,				"STADRV_WEPKEY3",			STRING_T,		_OFFSET(stadrv_wepkey3),		_SIZE(stadrv_wepkey3)},
{MIB_STADRV_WEPKEY4,				"STADRV_WEPKEY4",			STRING_T,		_OFFSET(stadrv_wepkey4),		_SIZE(stadrv_wepkey4)},
{MIB_STADRV_PSKKEY,				"STADRV_PSKKEY",			STRING_T,		_OFFSET(stadrv_pskkey),			_SIZE(stadrv_pskkey)},
{MIB_STADRV_CLONEMAC,			"STADRV_CLONEMAC",		BYTE6_T,			_OFFSET(stadrv_clonemac),		_SIZE(stadrv_clonemac)},
/*
{MIB_STADRV_WANTYPE,				"STADRV_WANTYPE",			BYTE_T,			_OFFSET(stadrv_wantype),		_SIZE(stadrv_wantype)},
{MIB_STADRV_HOSTNAME,			"STADRV_HOSTNAME",		STRING_T,		_OFFSET(stadrv_hostname),		_SIZE(stadrv_hostname)},
{MIB_STADRV_IP,					"STADRV_IP",				IA_T,				_OFFSET(stadrv_ip),				_SIZE(stadrv_ip)},
{MIB_STADRV_MASK,					"STADRV_MASK",				IA_T,				_OFFSET(stadrv_mask),			_SIZE(stadrv_mask)},
{MIB_STADRV_GATEWAY,				"STADRV_GATEWAY",			IA_T,				_OFFSET(stadrv_gateway),		_SIZE(stadrv_gateway)},
*/
#endif
#ifdef _Unicorn_
{MIB_QOS_MODE,                       "QOS_MODE",             BYTE_T,        _OFFSET(qosmode),             _SIZE(qosmode)},
#endif
#ifdef _SDMZ_
{MIB_DMZ_MODE,                       "DMZ_MODE",             BYTE_T,        _OFFSET(dmzmode),           _SIZE(dmzmode)},
{MIB_DMZ_MAC_ADDR,		         "DMZ_MAC_ADDR",			     BYTE6_T,		 _OFFSET(dmzMacAddr),		   _SIZE(dmzMacAddr)},
{MIB_SUPERDMZ_REFRESHTIME,        "REFRESHTIME",       WORD_T,        _OFFSET(refreshtime),           _SIZE(refreshtime)},
#endif
#ifdef _CONNECTION_CTRL_
{MIB_CONNECCOUNT_MAX,        "CONNECCOUNT_MAX",       WORD_T,        _OFFSET(conneccountmax),       _SIZE(conneccountmax)},
{MIB_UDPCOUNT_MAX,           "UDPCOUNT_MAX",          WORD_T,        _OFFSET(udpcountmax),           _SIZE(udpcountmax)},
{MIB_TCPCOUNT_MAX,           "TCPCOUNT_MAX",          WORD_T,        _OFFSET(tcpcountmax),           _SIZE(tcpcountmax)},
{MIB_ICMPCOUNT_MAX,          "ICMPCOUNT_MAX",         WORD_T,        _OFFSET(icmpcountmax),           _SIZE(icmpcountmax)},
{MIB_TIMEOUT_ESTABLISHED,    "TIMEOUT_ESTABLISHED",   WORD_T,        _OFFSET(timeoutestablished),    _SIZE(timeoutestablished)},
{MIB_TIMEOUT_SYNSENT,        "TIMEOUT_SYNSENT",       WORD_T,        _OFFSET(timeoutsynsent),        _SIZE(timeoutsynsent)},
{MIB_TIMEOUT_SYNRECV,        "TIMEOUT_SYNRECV",       WORD_T,        _OFFSET(timeoutsynrecv),        _SIZE(timeoutsynrecv)},
{MIB_TIMEOUT_FINWAIT,        "TIMEOUT_FINWAIT",       WORD_T,        _OFFSET(timeoutfinwait),        _SIZE(timeoutfinwait)},
{MIB_TIMEOUT_CLOSEWAIT,      "TIMEOUT_CLOSEWAIT",     WORD_T,        _OFFSET(timeoutclosewait),      _SIZE(timeoutclosewait)},
{MIB_TIMEOUT_LASTACK,        "TIMEOUT_LASTACK",       WORD_T,        _OFFSET(timeoutlastcck),        _SIZE(timeoutlastcck)},
{MIB_TIMEOUT_GENERIC,        "TIMEOUT_GENERIC",       WORD_T,        _OFFSET(timeoutgeneric),        _SIZE(timeoutgeneric)},
{MIB_CONNECTIONCTRL_ENABLED, "CONNECTIONCTRL_ENABLED",   BYTE_T,        _OFFSET(connectionctrlenabled),    _SIZE(connectionctrlenabled)},
#endif
#if defined(_TRIPPPOE_) & defined(_MPPPOE_)
{MIB_PPP_USER2,                          "PPP_USER_NAME2",                STRING_T,               _OFFSET(pppUserName2),           _SIZE(pppUserName2)},
{MIB_PPP_PASSWORD2,                      "PPP_PASSWORD2",                 STRING_T,               _OFFSET(pppPassword2),           _SIZE(pppPassword2)},
{MIB_PPP_IDLE_TIME2,                     "PPP_IDLE_TIME2",                WORD_T,                 _OFFSET(pppIdleTime2),           _SIZE(pppIdleTime2)},
{MIB_PPP_CONNECT_TYPE2,                  "PPP_CONNECT_TYPE2",             BYTE_T,                 _OFFSET(pppConnectType2),        _SIZE(pppConnectType2)},
{MIB_PPP_SERVNAME2,                      "PPP_SERVNAME2",                 STRING_T,               _OFFSET(pppServName2),           _SIZE(pppServName2)},
{MIB_PPP_MTU2,                           "PPP_MTU2",                      WORD_T,                 _OFFSET(pppMTU2),                _SIZE(pppMTU2)},
{MIB_PPP_UNNUMIP2,                       "PPP_UNNUMIP2",                  IA_T,                   _OFFSET(pppUnnumIP2),            _SIZE(pppUnnumIP2)},
{MIB_PPP_UNNUMMASK2,                     "PPP_UNNUMMASK2",                IA_T,                   _OFFSET(pppUnnumMask2),          _SIZE(pppUnnumMask2)},
#endif
#ifdef _LEDSWITCH_
{MIB_LED_CONTROL,                    "LED_CONTROL",                    BYTE_T,                 _OFFSET(ledContorl),              _SIZE(ledContorl)},
#endif
#ifdef _DHCP_SERVER_WITH_GW_DNS_
{MIB_DHCP_SERVER_GW,				"DHCP_SERVER_GW",			IA_T,				_OFFSET(dhcp_server_gw),		_SIZE(dhcp_server_gw)},
{MIB_DHCP_SERVER_DNS1,				"DHCP_SERVER_DNS1",			IA_T,				_OFFSET(dhcp_server_dns1),		_SIZE(dhcp_server_dns1)},
{MIB_DHCP_SERVER_DNS2,				"DHCP_SERVER_DNS2",			IA_T,				_OFFSET(dhcp_server_dns2),		_SIZE(dhcp_server_dns2)},
#endif
#ifdef _STARCRAFT_
{MIB_STARCRAFT_NUM,			"STARCRAFT_NUM",		BYTE_T,				_OFFSET(STARCRAFTNum),		_SIZE(STARCRAFTNum)},
{MIB_STARCRAFT,				"STARCRAFT_TBL",		STARCRAFT_ARRAY_T,	_OFFSET(STARCRAFTArray),	_SIZE(STARCRAFTArray)},
#endif

#ifdef _VLAN_CONFIG_SUPPORTED_
{MIB_VLANCONFIG_ENABLED,	"VLANCONFIG_ENABLED",	BYTE_T,		_OFFSET(VlanConfigEnabled), _SIZE(VlanConfigEnabled)},
{MIB_VLANCONFIG_NUM,		"VLANCONFIG_TBL_NUM",	BYTE_T,		_OFFSET(VlanConfigNum), _SIZE(VlanConfigNum)},
{MIB_VLANCONFIG,		"VLANCONFIG_TBL",	VLANCONFIG_ARRAY_T,	_OFFSET(VlanConfigArray), _SIZE(VlanConfigArray)},
#endif

#ifdef _GET_TIME_FROM_PC_
{MIB_PC_TIME,                  "PC_TIME",             BYTE_T,                 _OFFSET(pcTime),       _SIZE(pcTime)},
#endif

#if defined(_Customer_EX_) || defined(_Customer_SC_) || defined(_Customer_SA_)
{MIB_GUARD_INTERVAL,			"GUARD_INTERVAL",                BYTE_T,                 _OFFSET(guardInterval),           _SIZE(guardInterval)},
{MIB_DECLINE_BA_REQUEST,		"DECLINE_BA_REQUEST",                BYTE_T,                 _OFFSET(DeclineBARequest),           _SIZE(DeclineBARequest)},
{MIB_ISOLATION,                    "ISOLATION",                BYTE_T,                 _OFFSET(isolation),           _SIZE(isolation)},
{MIB_MBSSID_ISOLATION,                    "MBSSID_ISOLATION",                BYTE_T,                 _OFFSET(mbssidIsolation),           _SIZE(mbssidIsolation)},
#endif
#ifdef _SNTP_A_M_CTL_ //vance 2009.02.20
{MIB_TIMESERVER_DOMAIN,                 "TIMESERVER_DOMAIN",            STRING_T,                       _OFFSET(TimeServerDomain),      _SIZE(TimeServerDomain)},
{MIB_TIMESERVER_ENABLE,                 "TIMESERVER_ENABLE",            BYTE_T,         _OFFSET(TimeServerEnable),      _SIZE(TimeServerEnable)},
{MIB_STATIC_SYSTEM_TIME,                "STATIC_SYSTEM_TIME",   STRING_T,                       _OFFSET(StaticSystemTime),      _SIZE(StaticSystemTime)},
#endif

#if defined(_COPY_ROOT_SSID_)
{MIB_SSID_CHOICE,                     "SSID_CHOICE",                BYTE_T,                 _OFFSET(ssidChoice),           _SIZE(ssidChoice)},
#endif

#ifdef _GREEN_AP_SCHEDULE_
{MIB_GREENAP_ENABLE,			"GREENAP_ENABLE",				BYTE_T,		_OFFSET(greenap_enable),			_SIZE(greenap_enable)},
{MIB_GREENAP_WEEKDAYS1,		"GREENAP_WEEKDAYS1",			BYTE_T,		_OFFSET(greenap_weekdays1),		_SIZE(greenap_weekdays1)},
{MIB_GREENAP_WEEKDAYS2,		"GREENAP_WEEKDAYS2",			BYTE_T,		_OFFSET(greenap_weekdays2),     _SIZE(greenap_weekdays2)},
{MIB_GREENAP_WEEKDAYS3,		"GREENAP_WEEKDAYS3",			BYTE_T,		_OFFSET(greenap_weekdays3),     _SIZE(greenap_weekdays3)},
{MIB_GREENAP_WEEKDAYS4,		"GREENAP_WEEKDAYS4",			BYTE_T,		_OFFSET(greenap_weekdays4),     _SIZE(greenap_weekdays4)},
{MIB_GREENAP_POWERLEVEL1,		"GREENAP_POWERLEVEL1",		BYTE_T,		_OFFSET(greenap_powerlevel1),	_SIZE(greenap_powerlevel1)},
{MIB_GREENAP_POWERLEVEL2,		"GREENAP_POWERLEVEL2",		BYTE_T,		_OFFSET(greenap_powerlevel2),	_SIZE(greenap_powerlevel2)},
{MIB_GREENAP_POWERLEVEL3,		"GREENAP_POWERLEVEL3",		BYTE_T,		_OFFSET(greenap_powerlevel3),	_SIZE(greenap_powerlevel3)},
{MIB_GREENAP_POWERLEVEL4,		"GREENAP_POWERLEVEL4",		BYTE_T,		_OFFSET(greenap_powerlevel4),	_SIZE(greenap_powerlevel4)},
//{MIB_GREENAP_TIME_TYPE,		"GREENAP_TIME_TYPE",			BYTE_T,		_OFFSET(greenap_timetype),		_SIZE(greenap_timetype)},
{MIB_GREENAP_START_HOUR1,		"GREENAP_START_HOUR1",		BYTE_T,		_OFFSET(greenap_starthour1),		_SIZE(greenap_starthour1)},
{MIB_GREENAP_START_HOUR2,		"GREENAP_START_HOUR2",		BYTE_T,		_OFFSET(greenap_starthour2),		_SIZE(greenap_starthour2)},
{MIB_GREENAP_START_HOUR3,		"GREENAP_START_HOUR3",		BYTE_T,		_OFFSET(greenap_starthour3),		_SIZE(greenap_starthour3)},
{MIB_GREENAP_START_HOUR4,		"GREENAP_START_HOUR4",		BYTE_T,		_OFFSET(greenap_starthour4),		_SIZE(greenap_starthour4)},
{MIB_GREENAP_START_MINUTE1,	"GREENAP_START_MINUTE1",		BYTE_T,		_OFFSET(greenap_startminute1),	_SIZE(greenap_startminute1)},
{MIB_GREENAP_START_MINUTE2,	"GREENAP_START_MINUTE2",		BYTE_T,		_OFFSET(greenap_startminute2),	_SIZE(greenap_startminute2)},
{MIB_GREENAP_START_MINUTE3,	"GREENAP_START_MINUTE3",		BYTE_T,		_OFFSET(greenap_startminute3),	_SIZE(greenap_startminute3)},
{MIB_GREENAP_START_MINUTE4,	"GREENAP_START_MINUTE4",		BYTE_T,		_OFFSET(greenap_startminute4),	_SIZE(greenap_startminute4)},
{MIB_GREENAP_STOP_HOUR1,		"GREENAP_STOP_HOUR1",			BYTE_T,		_OFFSET(greenap_stophour1),		_SIZE(greenap_stophour1)},
{MIB_GREENAP_STOP_HOUR2,		"GREENAP_STOP_HOUR2",			BYTE_T,		_OFFSET(greenap_stophour2),		_SIZE(greenap_stophour2)},
{MIB_GREENAP_STOP_HOUR3,		"GREENAP_STOP_HOUR3",			BYTE_T,		_OFFSET(greenap_stophour3),		_SIZE(greenap_stophour3)},
{MIB_GREENAP_STOP_HOUR4,		"GREENAP_STOP_HOUR4",			BYTE_T,		_OFFSET(greenap_stophour4),		_SIZE(greenap_stophour4)},
{MIB_GREENAP_STOP_MINUTE1,	"GREENAP_STOP_MINUTE1",		BYTE_T,		_OFFSET(greenap_stopminute1),	_SIZE(greenap_stopminute1)},
{MIB_GREENAP_STOP_MINUTE2,	"GREENAP_STOP_MINUTE2",		BYTE_T,		_OFFSET(greenap_stopminute2),	_SIZE(greenap_stopminute2)},
{MIB_GREENAP_STOP_MINUTE3,	"GREENAP_STOP_MINUTE3",		BYTE_T,		_OFFSET(greenap_stopminute3),	_SIZE(greenap_stopminute3)},
{MIB_GREENAP_STOP_MINUTE4,	"GREENAP_STOP_MINUTE4",		BYTE_T,		_OFFSET(greenap_stopminute4),	_SIZE(greenap_stopminute4)},
{MIB_WLAN_RF_POWER,             "RFPOWER_SCALE", 		BYTE_T, 	_OFFSET(RFPowerScale), 	_SIZE(RFPowerScale)},
{MIB_WLAN_TX_POWER_1,                     "WLAN_TX_POWER_1",                BYTE_T,                 _OFFSET(wlanTxPower1),           _SIZE(wlanTxPower1)},
{MIB_WLAN_TX_POWER_2,                     "WLAN_TX_POWER_2",                BYTE_T,                 _OFFSET(wlanTxPower2),           _SIZE(wlanTxPower2)},
{MIB_WLAN_TX_POWER_3,                     "WLAN_TX_POWER_3",                BYTE_T,                 _OFFSET(wlanTxPower3),           _SIZE(wlanTxPower3)},
{MIB_WLAN_TX_POWER_4,                     "WLAN_TX_POWER_4",                BYTE_T,                 _OFFSET(wlanTxPower4),           _SIZE(wlanTxPower4)},
#endif

#if defined(_EW7418APN_) && defined(_CHA_TEL_)
{MIB_UPNP_FRIENDLY_NAME,	"UPNP_FRIENDLY_NAME",		STRING_T,               _OFFSET(friendlyName),           _SIZE(friendlyName)},
{MIB_UPNP_DEVICE_TYPE,		"UPNP_DEVICE_TYPE",		STRING_T,               _OFFSET(deviceType),           _SIZE(deviceType)},
{MIB_UPNP_PROVSISONING_CODE,	"UPNP_PROVSISONING_CODE",	STRING_T,               _OFFSET(provisioningCode),           _SIZE(provisioningCode)},
{MIB_UPNP_SW_VERSION,		"UPNP_SW_VERSION",		STRING_T,               _OFFSET(swVersion),           _SIZE(swVersion)},
{MIB_UPNP_SW_DESCRIPTION,	"UPNP_SW_DESCRIPTION",		STRING_T,               _OFFSET(swDescription),           _SIZE(swDescription)},
{MIB_UPNP_MODE,			"UPNP_MODE",			STRING_T,               _OFFSET(upnpMode),           _SIZE(upnpMode)},
{MIB_UPNP_HW_VERSION,           "UPNP_HW_VERSION",              STRING_T,               _OFFSET(hwVersion),           _SIZE(hwVersion)},
{MIB_UPNP_MANUFACTURER_OUI,	"UPNP_MANUFACTURER_OUI",	STRING_T,               _OFFSET(manufacturerOUI),           _SIZE(manufacturerOUI)},
{MIB_UPNP_PRODUCT_CLASS,	"UPNP_PRODUCT_CLASS",		STRING_T,               _OFFSET(productClass),           _SIZE(productClass)},
{MIB_UPNP_SERIAL_NUMBER,        "UPNP_SERIAL_NUMBER",           STRING_T,               _OFFSET(serialNumber),           _SIZE(serialNumber)},
{MIB_CLIENT_NUM,		"CLIENT_NUM",			BYTE_T,			_OFFSET(clientNumber),		_SIZE(clientNumber)},
#endif

#if defined(_WEB_ACCESS_CONTROL_)
{MIB_WEB_CONTROL,                    "WEB_CONTROL",                    BYTE_T,                 _OFFSET(webContorl),              _SIZE(webContorl)},
#endif
#if defined(_POWER_SAVING_)
{MIB_POWER_SAVING,		"POWER_SAVING",			BYTE_T,			_OFFSET(powersaving),	_SIZE(powersaving)},
#endif
#if defined(_LED_SWITCH_) || defined(_SW_LED_SWITCH_)
{MIB_LED_SWITCH,		"LED_SWITCH",			BYTE_T,			_OFFSET(ledSwitch),          _SIZE(ledSwitch)},
#endif

#if defined(_Airlive_7428HCN_)
{MIB_CS_REG_DOMAIN,             "CS_REG_DOMAIN",                BYTE_T,                 _OFFSET(csRegDomain),           _SIZE(csRegDomain)},
{MIB_CLONE_MAC_ADDR,                     "CLONE_MAC_ADDR",                BYTE6_T,                _OFFSET(cloneMacAddr),           _SIZE(cloneMacAddr)},
{MIB_KEEP_CONFIG,             "KEEP_CONFIG",                BYTE_T,                 _OFFSET(keepConfig),           _SIZE(keepConfig)},
{MIB_DEVICE_NAME,             "DEVICE_NAME",                STRING_T,                 _OFFSET(deviceName),           _SIZE(deviceName)},
{MIB_IP_FINDER,             "IP_FINDER",                BYTE_T,                 _OFFSET(ipFinder),           _SIZE(ipFinder)},
{MIB_WLAN_AGGREGATION,                  "AGGREGATION",                  BYTE_T,                 _OFFSET(aggregation),      _SIZE(aggregation)},
{MIB_WLAN_SHORT_GI,     "SHORT_GI", BYTE_T, _OFFSET(shortgiEnabled), _SIZE(shortgiEnabled)},
{MIB_ACK_TIMEOUT,     "ACK_TIMEOUT", WORD_T, _OFFSET(ackTimeout), _SIZE(ackTimeout)},
#endif

#ifdef _CONTROL_SIDEBAND_
{MIB_CONTROL_SIDEBAND,                "CONTROL_SIDEBAND",                   BYTE_T,                 _OFFSET(controlSideband),          _SIZE(controlSideband)},
#endif

#ifdef _SYSTEM_LOG_
{MIB_LOG_ENABLED,               "SCRLOG_ENABLED",       BYTE_T,         _OFFSET(scrlogEnabled), _SIZE(scrlogEnabled)},
{MIB_REMOTELOG_ENABLED,         "REMOTELOG_ENABLED",    BYTE_T, 	_OFFSET(rtLogEnabled), _SIZE(rtLogEnabled)},
{MIB_REMOTELOG_SERVER,          "REMOTELOG_SERVER",     IA_T, 		_OFFSET(rtLogServer), _SIZE(rtLogServer)},
#endif

#ifdef _RTK_NTP_
{MIB_NTP_ENABLED,               "NTP_ENABLED",  BYTE_T,         _OFFSET(ntpEnabled), _SIZE(ntpEnabled)},
{MIB_NTP_SERVER_ID,             "NTP_SERVER_ID",        BYTE_T,         _OFFSET(ntpServerId), _SIZE(ntpServerId)},
{MIB_NTP_TIMEZONE,              "NTP_TIMEZONE", STRING_T,       _OFFSET(ntpTimeZone), _SIZE(ntpTimeZone)},
{MIB_NTP_SERVER_IP1,            "NTP_SERVER_IP1",       IA_T,   _OFFSET(ntpServerIp1), _SIZE(ntpServerIp1)},
{MIB_NTP_SERVER_IP2,            "NTP_SERVER_IP2",       IA_T,   _OFFSET(ntpServerIp2), _SIZE(ntpServerIp2)},
{MIB_DAYLIGHT_SAVE,             "DAYLIGHT_SAVE",        BYTE_T,         _OFFSET(daylightsaveEnabled), _SIZE(daylightsaveEnabled)},
{MIB_TIME_YEAR,                 "SYSTIME_YEAR",         WORD_T, _OFFSET(system_time_year), _SIZE(system_time_year)},
{MIB_TIME_MONTH,		"SYSTIME_MON",          BYTE_T,         _OFFSET(system_time_month), _SIZE(system_time_month)},
{MIB_TIME_DAY,			"SYSTIME_DAY",          BYTE_T,         _OFFSET(system_time_day), _SIZE(system_time_day)},
{MIB_TIME_HOUR,			"SYSTIME_HOUR",         BYTE_T, _OFFSET(system_time_hour), _SIZE(system_time_hour)},
{MIB_TIME_MIN,			"SYSTIME_MIN",		BYTE_T, _OFFSET(system_time_min), _SIZE(system_time_min)},
{MIB_TIME_SEC,			"SYSTIME_SEC",		BYTE_T, _OFFSET(system_time_sec), _SIZE(system_time_sec)},

#endif

#ifdef _WEB_PORT_
{MIB_WEB_PORT,                      "WEB_PORT",                      WORD_T,                 _OFFSET(webPort),                _SIZE(webPort)},
#endif
#ifdef _Airlive_Schedule_
{MIB_WLSCH_ENABLED,               "WLSCH_ENABLED",       BYTE_T,         _OFFSET(wlschEnabled), _SIZE(wlschEnabled)},
{MIB_WLSCH_ENABLED_1,               "WLSCH_ENABLED_1",       BYTE_T,         _OFFSET(wlschEnabled_1), _SIZE(wlschEnabled_1)},
{MIB_WLSCH_ENABLED_2,               "WLSCH_ENABLED_2",       BYTE_T,         _OFFSET(wlschEnabled_2), _SIZE(wlschEnabled_2)},
{MIB_WLSCH_ENABLED_3,               "WLSCH_ENABLED_3",       BYTE_T,         _OFFSET(wlschEnabled_3), _SIZE(wlschEnabled_3)},
{MIB_WLSCH_ENABLED_4,               "WLSCH_ENABLED_4",       BYTE_T,         _OFFSET(wlschEnabled_4), _SIZE(wlschEnabled_4)},
{MIB_WLSCH_ENABLED_5,               "WLSCH_ENABLED_5",       BYTE_T,         _OFFSET(wlschEnabled_5), _SIZE(wlschEnabled_5)},
{MIB_WLSCH_ENABLED_6,               "WLSCH_ENABLED_6",       BYTE_T,         _OFFSET(wlschEnabled_6), _SIZE(wlschEnabled_6)},
{MIB_WLSCH_ENABLED_7,               "WLSCH_ENABLED_7",       BYTE_T,         _OFFSET(wlschEnabled_7), _SIZE(wlschEnabled_7)},
{MIB_WLSCH_ENABLED_8,               "WLSCH_ENABLED_8",       BYTE_T,         _OFFSET(wlschEnabled_8), _SIZE(wlschEnabled_8)},
{MIB_WLSCH_ENABLED_9,               "WLSCH_ENABLED_9",       BYTE_T,         _OFFSET(wlschEnabled_9), _SIZE(wlschEnabled_9)},
{MIB_WLSCH_ENABLED_10,              "WLSCH_ENABLED_10",      BYTE_T,         _OFFSET(wlschEnabled_10),_SIZE(wlschEnabled_10)},
{MIB_WLSCH_DAY1,               "WLSCH_DAY1",       BYTE_T,         _OFFSET(wlschDay1), _SIZE(wlschDay1)},
{MIB_WLSCH_DAY2,               "WLSCH_DAY2",       BYTE_T,         _OFFSET(wlschDay2), _SIZE(wlschDay2)},
{MIB_WLSCH_DAY3,               "WLSCH_DAY3",       BYTE_T,         _OFFSET(wlschDay3), _SIZE(wlschDay3)},
{MIB_WLSCH_DAY4,               "WLSCH_DAY4",       BYTE_T,         _OFFSET(wlschDay4), _SIZE(wlschDay4)},
{MIB_WLSCH_DAY5,               "WLSCH_DAY5",       BYTE_T,         _OFFSET(wlschDay5), _SIZE(wlschDay5)},
{MIB_WLSCH_DAY6,               "WLSCH_DAY6",       BYTE_T,         _OFFSET(wlschDay6), _SIZE(wlschDay6)},
{MIB_WLSCH_DAY7,               "WLSCH_DAY7",       BYTE_T,         _OFFSET(wlschDay7), _SIZE(wlschDay7)},
{MIB_WLSCH_DAY8,               "WLSCH_DAY8",       BYTE_T,         _OFFSET(wlschDay8), _SIZE(wlschDay8)},
{MIB_WLSCH_DAY9,               "WLSCH_DAY9",       BYTE_T,         _OFFSET(wlschDay9), _SIZE(wlschDay9)},
{MIB_WLSCH_DAY10,               "WLSCH_DAY10",       BYTE_T,         _OFFSET(wlschDay10), _SIZE(wlschDay10)},
{MIB_WLSCH_FROM_HOUR1,               "WLSCH_FROM_HOUR1",       BYTE_T,         _OFFSET(wlschFromHour1), _SIZE(wlschFromHour1)},
{MIB_WLSCH_FROM_HOUR2,               "WLSCH_FROM_HOUR2",       BYTE_T,         _OFFSET(wlschFromHour2), _SIZE(wlschFromHour2)},
{MIB_WLSCH_FROM_HOUR3,               "WLSCH_FROM_HOUR3",       BYTE_T,         _OFFSET(wlschFromHour3), _SIZE(wlschFromHour3)},
{MIB_WLSCH_FROM_HOUR4,               "WLSCH_FROM_HOUR4",       BYTE_T,         _OFFSET(wlschFromHour4), _SIZE(wlschFromHour4)},
{MIB_WLSCH_FROM_HOUR5,               "WLSCH_FROM_HOUR5",       BYTE_T,         _OFFSET(wlschFromHour5), _SIZE(wlschFromHour5)},
{MIB_WLSCH_FROM_HOUR6,               "WLSCH_FROM_HOUR6",       BYTE_T,         _OFFSET(wlschFromHour6), _SIZE(wlschFromHour6)},
{MIB_WLSCH_FROM_HOUR7,               "WLSCH_FROM_HOUR7",       BYTE_T,         _OFFSET(wlschFromHour7), _SIZE(wlschFromHour7)},
{MIB_WLSCH_FROM_HOUR8,               "WLSCH_FROM_HOUR8",       BYTE_T,         _OFFSET(wlschFromHour8), _SIZE(wlschFromHour8)},
{MIB_WLSCH_FROM_HOUR9,               "WLSCH_FROM_HOUR9",       BYTE_T,         _OFFSET(wlschFromHour9), _SIZE(wlschFromHour9)},
{MIB_WLSCH_FROM_HOUR10,               "WLSCH_FROM_HOUR10",       BYTE_T,         _OFFSET(wlschFromHour10), _SIZE(wlschFromHour10)},
{MIB_WLSCH_FROM_MIN1,               "WLSCH_FROM_MIN1",       BYTE_T,         _OFFSET(wlschFromMin1), _SIZE(wlschFromMin1)},
{MIB_WLSCH_FROM_MIN2,               "WLSCH_FROM_MIN2",       BYTE_T,         _OFFSET(wlschFromMin2), _SIZE(wlschFromMin2)},
{MIB_WLSCH_FROM_MIN3,               "WLSCH_FROM_MIN3",       BYTE_T,         _OFFSET(wlschFromMin3), _SIZE(wlschFromMin3)},
{MIB_WLSCH_FROM_MIN4,               "WLSCH_FROM_MIN4",       BYTE_T,         _OFFSET(wlschFromMin4), _SIZE(wlschFromMin4)},
{MIB_WLSCH_FROM_MIN5,               "WLSCH_FROM_MIN5",       BYTE_T,         _OFFSET(wlschFromMin5), _SIZE(wlschFromMin5)},
{MIB_WLSCH_FROM_MIN6,               "WLSCH_FROM_MIN6",       BYTE_T,         _OFFSET(wlschFromMin6), _SIZE(wlschFromMin6)},
{MIB_WLSCH_FROM_MIN7,               "WLSCH_FROM_MIN7",       BYTE_T,         _OFFSET(wlschFromMin7), _SIZE(wlschFromMin7)},
{MIB_WLSCH_FROM_MIN8,               "WLSCH_FROM_MIN8",       BYTE_T,         _OFFSET(wlschFromMin8), _SIZE(wlschFromMin8)},
{MIB_WLSCH_FROM_MIN9,               "WLSCH_FROM_MIN9",       BYTE_T,         _OFFSET(wlschFromMin9), _SIZE(wlschFromMin9)},
{MIB_WLSCH_FROM_MIN10,               "WLSCH_FROM_MIN10",       BYTE_T,         _OFFSET(wlschFromMin10), _SIZE(wlschFromMin10)},
{MIB_WLSCH_TO_HOUR1,               "WLSCH_TO_HOUR1",       BYTE_T,         _OFFSET(wlschToHour1), _SIZE(wlschToHour1)},
{MIB_WLSCH_TO_HOUR2,               "WLSCH_TO_HOUR2",       BYTE_T,         _OFFSET(wlschToHour2), _SIZE(wlschToHour2)},
{MIB_WLSCH_TO_HOUR3,               "WLSCH_TO_HOUR3",       BYTE_T,         _OFFSET(wlschToHour3), _SIZE(wlschToHour3)},
{MIB_WLSCH_TO_HOUR4,               "WLSCH_TO_HOUR4",       BYTE_T,         _OFFSET(wlschToHour4), _SIZE(wlschToHour4)},
{MIB_WLSCH_TO_HOUR5,               "WLSCH_TO_HOUR5",       BYTE_T,         _OFFSET(wlschToHour5), _SIZE(wlschToHour5)},
{MIB_WLSCH_TO_HOUR6,               "WLSCH_TO_HOUR6",       BYTE_T,         _OFFSET(wlschToHour6), _SIZE(wlschToHour6)},
{MIB_WLSCH_TO_HOUR7,               "WLSCH_TO_HOUR7",       BYTE_T,         _OFFSET(wlschToHour7), _SIZE(wlschToHour7)},
{MIB_WLSCH_TO_HOUR8,               "WLSCH_TO_HOUR8",       BYTE_T,         _OFFSET(wlschToHour8), _SIZE(wlschToHour8)},
{MIB_WLSCH_TO_HOUR9,               "WLSCH_TO_HOUR9",       BYTE_T,         _OFFSET(wlschToHour9), _SIZE(wlschToHour9)},
{MIB_WLSCH_TO_HOUR10,               "WLSCH_TO_HOUR10",       BYTE_T,         _OFFSET(wlschToHour10), _SIZE(wlschToHour10)},
{MIB_WLSCH_TO_MIN1,               "WLSCH_TO_MIN1",       BYTE_T,         _OFFSET(wlschToMin1), _SIZE(wlschToMin1)},
{MIB_WLSCH_TO_MIN2,               "WLSCH_TO_MIN2",       BYTE_T,         _OFFSET(wlschToMin2), _SIZE(wlschToMin2)},
{MIB_WLSCH_TO_MIN3,               "WLSCH_TO_MIN3",       BYTE_T,         _OFFSET(wlschToMin3), _SIZE(wlschToMin3)},
{MIB_WLSCH_TO_MIN4,               "WLSCH_TO_MIN4",       BYTE_T,         _OFFSET(wlschToMin4), _SIZE(wlschToMin4)},
{MIB_WLSCH_TO_MIN5,               "WLSCH_TO_MIN5",       BYTE_T,         _OFFSET(wlschToMin5), _SIZE(wlschToMin5)},
{MIB_WLSCH_TO_MIN6,               "WLSCH_TO_MIN6",       BYTE_T,         _OFFSET(wlschToMin6), _SIZE(wlschToMin6)},
{MIB_WLSCH_TO_MIN7,               "WLSCH_TO_MIN7",       BYTE_T,         _OFFSET(wlschToMin7), _SIZE(wlschToMin7)},
{MIB_WLSCH_TO_MIN8,               "WLSCH_TO_MIN8",       BYTE_T,         _OFFSET(wlschToMin8), _SIZE(wlschToMin8)},
{MIB_WLSCH_TO_MIN9,               "WLSCH_TO_MIN9",       BYTE_T,         _OFFSET(wlschToMin9), _SIZE(wlschToMin9)},
{MIB_WLSCH_TO_MIN10,               "WLSCH_TO_MIN10",       BYTE_T,         _OFFSET(wlschToMin10), _SIZE(wlschToMin10)},
#endif

#ifdef _STANUM_
{MIB_STANUM,               "STANUM",       BYTE_T,         _OFFSET(staNum), _SIZE(staNum)},
#endif
//{MIB_WLAN_AC2_ENABLED,                  "WLAN_MACAC2_ENABLED",          BYTE_T,                 _OFFSET(acEnabled2),            _SIZE(acEnabled2)},
//{MIB_WLAN_AC2_ADDR,                     "WLAN_MACAC2_ADDR",             WLAC_ARRAY2_T,          _OFFSET(acAddrArray2),          _SIZE(acAddrArray2)},

{MIB_WDS_NUM,                      "WDS_NUM",              BYTE_T,                 _OFFSET(WDSNum),                        _SIZE(WDSNum)},
{MIB_WDS_LIST,                     "WDS_LIST",             WDSLIST_T,          _OFFSET(WDSList),          _SIZE(WDSList)},

//-----------------------------------------------------------------------------
{0}
};
mib_table_entry_T hwmib_table[]={
{MIB_HW_BOARD_VER,              "HW_BOARD_ID",             BYTE_T,         _OFFSET_HW(boardVer), _SIZE_HW(boardVer)},
{MIB_HW_NIC0_ADDR,              "HW_NIC0_ADDR",            BYTE6_T,        _OFFSET_HW(nic0Addr), _SIZE_HW(nic0Addr)},
{MIB_HW_NIC1_ADDR,              "HW_NIC1_ADDR",            BYTE6_T,        _OFFSET_HW(nic1Addr), _SIZE_HW(nic1Addr)},
/*
{MIB_HW_WLAN_ADDR,              "HW_WLAN_ADDR",            BYTE6_T,        _OFFSET_HW(macAddr), _SIZE_HW(macAddr)},
{MIB_HW_WLAN_ADDR1,             "HW_WLAN_ADDR1",           BYTE6_T,        _OFFSET_HW(macAddr1), _SIZE_HW(macAddr1)},
{MIB_HW_WLAN_ADDR2,             "HW_WLAN_ADDR2",           BYTE6_T,        _OFFSET_HW(macAddr2), _SIZE_HW(macAddr2)},
{MIB_HW_WLAN_ADDR3,             "HW_WLAN_ADDR3",           BYTE6_T,        _OFFSET_HW(macAddr3), _SIZE_HW(macAddr3)},
{MIB_HW_WLAN_ADDR4,             "HW_WLAN_ADDR4",           BYTE6_T,        _OFFSET_HW(macAddr4), _SIZE_HW(macAddr4)},
{MIB_HW_WLAN_ADDR5,             "HW_WLAN_ADDR5",           BYTE6_T,        _OFFSET_HW(macAddr5), _SIZE_HW(macAddr5)},
{MIB_HW_WLAN_ADDR6,             "HW_WLAN_ADDR6",           BYTE6_T,        _OFFSET_HW(macAddr6), _SIZE_HW(macAddr6)},
{MIB_HW_WLAN_ADDR7,             "HW_WLAN_ADDR7",           BYTE6_T,        _OFFSET_HW(macAddr7), _SIZE_HW(macAddr7)},
{MIB_HW_REG_DOMAIN,             "HW_REG_DOMAIN",           BYTE_T,         _OFFSET_HW(regDomain), _SIZE_HW(regDomain)},
{MIB_HW_RF_TYPE,                "HW_RF_TYPE",              BYTE_T,         _OFFSET_HW(rfType), _SIZE_HW(rfType)},
{MIB_HW_TX_POWER_CCK,           "HW_TX_POWER_CCK",         BYTE_ARRAY_T,   _OFFSET_HW(txPowerCCK), _SIZE_HW(txPowerCCK)},
{MIB_HW_TX_POWER_OFDM_1S,	"HW_TX_POWER_OFDM_1S",     BYTE_ARRAY_T,   _OFFSET_HW(txPowerOFDM_HT_OFDM_1S), _SIZE_HW(txPowerOFDM_HT_OFDM_1S)},
{MIB_HW_TX_POWER_OFDM_2S,	"HW_TX_POWER_OFDM_2S",     BYTE_ARRAY_T,   _OFFSET_HW(txPowerOFDM_HT_OFDM_2S), _SIZE_HW(txPowerOFDM_HT_OFDM_2S)},
{MIB_HW_11N_XCAP,               "HW_11N_XCAP",             BYTE_T,         _OFFSET_HW(xCap), _SIZE_HW(xCap)},
{MIB_HW_11N_LOFDMPWDA,          "HW_11N_LOFDMPWDA",	BYTE_T,         _OFFSET_HW(LOFDMPwDiffA), _SIZE_HW(LOFDMPwDiffA)},
{MIB_HW_11N_LOFDMPWDB,          "HW_11N_LOFDMPWDB",	BYTE_T,         _OFFSET_HW(LOFDMPwDiffB), _SIZE_HW(LOFDMPwDiffB)},
{MIB_HW_11N_TSSI1,              "HW_11N_TSSI1",            BYTE_T,         _OFFSET_HW(TSSI1), _SIZE_HW(TSSI1)},
{MIB_HW_11N_TSSI2,              "HW_11N_TSSI2",            BYTE_T,         _OFFSET_HW(TSSI2), _SIZE_HW(TSSI2)},
{MIB_HW_11N_THER,               "HW_11N_THER",             BYTE_T,         _OFFSET_HW(Ther), _SIZE_HW(Ther)},
{MIB_HW_11N_RESERVED1,          "HW_11N_RESERVED1",	BYTE_T,         _OFFSET_HW(Reserved1), _SIZE_HW(Reserved1)},
{MIB_HW_11N_RESERVED2,          "HW_11N_RESERVED2", 	BYTE_T,         _OFFSET_HW(Reserved2), _SIZE_HW(Reserved2)},
{MIB_HW_11N_RESERVED3,          "HW_11N_RESERVED3",       	BYTE_T,         _OFFSET_HW(Reserved3), _SIZE_HW(Reserved3)},
{MIB_HW_11N_RESERVED4,          "HW_11N_RESERVED4",       	BYTE_T,         _OFFSET_HW(Reserved4), _SIZE_HW(Reserved4)},
{MIB_HW_11N_RESERVED5,          "HW_11N_RESERVED5",        BYTE_T,         _OFFSET_HW(Reserved5), _SIZE_HW(Reserved5)},
{MIB_HW_11N_RESERVED6,          "HW_11N_RESERVED6",        BYTE_T,         _OFFSET_HW(Reserved6), _SIZE_HW(Reserved6)},
{MIB_HW_11N_RESERVED7,          "HW_11N_RESERVED7",        BYTE_T,         _OFFSET_HW(Reserved7), _SIZE_HW(Reserved7)},
{MIB_HW_11N_RESERVED8,          "HW_11N_RESERVED8",        BYTE_T,         _OFFSET_HW(Reserved8), _SIZE_HW(Reserved8)},
{MIB_HW_LED_TYPE,               "HW_LED_TYPE",             BYTE_T,         _OFFSET_HW(ledType), _SIZE_HW(ledType)},
{MIB_HW_WSC_PIN,                "HW_WSC_PIN",              STRING_T,       _OFFSET_HW(wscPin), _OFFSET_HW(wscPin)},
*/
{MIB_HW_WLAN_ADDR,              "HW_WLAN_ADDR",            BYTE6_T,        _OFFSET_HW(macAddr), _SIZE_HW(macAddr)},
{MIB_HW_WLAN_ADDR1,             "HW_WLAN_ADDR1",           BYTE6_T,        _OFFSET_HW(macAddr1), _SIZE_HW(macAddr1)},
{MIB_HW_WLAN_ADDR2,             "HW_WLAN_ADDR2",           BYTE6_T,        _OFFSET_HW(macAddr2), _SIZE_HW(macAddr2)},
{MIB_HW_WLAN_ADDR3,             "HW_WLAN_ADDR3",           BYTE6_T,        _OFFSET_HW(macAddr3), _SIZE_HW(macAddr3)},
{MIB_HW_WLAN_ADDR4,             "HW_WLAN_ADDR4",           BYTE6_T,        _OFFSET_HW(macAddr4), _SIZE_HW(macAddr4)},
{MIB_HW_WLAN_ADDR5,             "HW_WLAN_ADDR5",           BYTE6_T,        _OFFSET_HW(macAddr5), _SIZE_HW(macAddr5)},
{MIB_HW_WLAN_ADDR6,             "HW_WLAN_ADDR6",           BYTE6_T,        _OFFSET_HW(macAddr6), _SIZE_HW(macAddr6)},
{MIB_HW_WLAN_ADDR7,             "HW_WLAN_ADDR7",           BYTE6_T,        _OFFSET_HW(macAddr7), _SIZE_HW(macAddr7)},
{MIB_HW_REG_DOMAIN,             "HW_REG_DOMAIN",           BYTE_T,         _OFFSET_HW(regDomain), _SIZE_HW(regDomain)},
{MIB_HW_RF_TYPE,                "HW_RF_TYPE",              BYTE_T,         _OFFSET_HW(rfType), _SIZE_HW(rfType)},
{MIB_HW_TX_POWER_CCK_A,                 "HW_TX_POWER_CCK_A",               BYTE_ARRAY_T,   _OFFSET_HW(pwrlevelCCK_A), _SIZE_HW(pwrlevelCCK_A)},
{MIB_HW_TX_POWER_CCK_B,                 "HW_TX_POWER_CCK_B",               BYTE_ARRAY_T,   _OFFSET_HW(pwrlevelCCK_B), _SIZE_HW(pwrlevelCCK_B)},
{MIB_HW_TX_POWER_HT40_1S_A,             "HW_TX_POWER_HT40_1S_A",   BYTE_ARRAY_T,   _OFFSET_HW(pwrlevelHT40_1S_A), _SIZE_HW(pwrlevelHT40_1S_A)},
{MIB_HW_TX_POWER_HT40_1S_B,             "HW_TX_POWER_HT40_1S_B",   BYTE_ARRAY_T,   _OFFSET_HW(pwrlevelHT40_1S_B), _SIZE_HW(pwrlevelHT40_1S_B)},
{MIB_HW_TX_POWER_HT40_2S,               "HW_TX_POWER_DIFF_HT40_2S",        BYTE_ARRAY_T,   _OFFSET_HW(pwrdiffHT40_2S), _SIZE_HW(pwrdiffHT40_2S)},
{MIB_HW_TX_POWER_HT20,          "HW_TX_POWER_DIFF_HT20",   BYTE_ARRAY_T,   _OFFSET_HW(pwrdiffHT20), _SIZE_HW(pwrdiffHT20)},
{MIB_HW_TX_POWER_DIFF_OFDM,             "HW_TX_POWER_DIFF_OFDM",   BYTE_ARRAY_T,   _OFFSET_HW(pwrdiffOFDM), _SIZE_HW(pwrdiffOFDM)},
{MIB_HW_11N_XCAP,               "HW_11N_XCAP",             BYTE_T,         _OFFSET_HW(xCap), _SIZE_HW(xCap)},
{MIB_HW_11N_TSSI1,              "HW_11N_TSSI1",            BYTE_T,         _OFFSET_HW(TSSI1), _SIZE_HW(TSSI1)},
{MIB_HW_11N_TSSI2,              "HW_11N_TSSI2",            BYTE_T,         _OFFSET_HW(TSSI2), _SIZE_HW(TSSI2)},
{MIB_HW_11N_THER,               "HW_11N_THER",             BYTE_T,         _OFFSET_HW(Ther), _SIZE_HW(Ther)},
{MIB_HW_11N_RESERVED1,		"HW_11N_RESERVED1",                BYTE_T,         _OFFSET_HW(Reserved1), _SIZE_HW(Reserved1)},
#ifdef _ENABLE_POWER_TABLE_
{MIB_HW_PWTBL_B,	"HW_PWTBL_B",	BYTE_T,	_OFFSET_HW(Reserved2),	_SIZE_HW(Reserved2)},
{MIB_HW_PWTBL_G,	"HW_PWTBL_G",	BYTE_T,	_OFFSET_HW(Reserved3),	_SIZE_HW(Reserved3)},
{MIB_HW_PWTBL_N_20M,	"HW_PWTBL_N_20M",	BYTE_T,	_OFFSET_HW(Reserved4),	_SIZE_HW(Reserved4)},
{MIB_HW_PWTBL_N_40M,	"HW_PWTBL_N_40M",	BYTE_T,	_OFFSET_HW(Reserved5),	_SIZE_HW(Reserved5)},
{MIB_HW_PWTBL_ENABLE,	"HW_PWTBL_ENABLE",	BYTE_T,	_OFFSET_HW(Reserved6),	_SIZE_HW(Reserved6)},
#else
{MIB_HW_11N_RESERVED2,          "HW_11N_RESERVED2",                BYTE_T,         _OFFSET_HW(Reserved2), _SIZE_HW(Reserved2)},
{MIB_HW_11N_RESERVED3,          "HW_11N_RESERVED3",                BYTE_T,         _OFFSET_HW(Reserved3), _SIZE_HW(Reserved3)},
{MIB_HW_11N_RESERVED4,          "HW_11N_RESERVED4",                BYTE_T,         _OFFSET_HW(Reserved4), _SIZE_HW(Reserved4)},
{MIB_HW_11N_RESERVED5,          "HW_11N_RESERVED5",                BYTE_T,         _OFFSET_HW(Reserved5), _SIZE_HW(Reserved5)},
{MIB_HW_11N_RESERVED6,          "HW_11N_RESERVED6",                BYTE_T,         _OFFSET_HW(Reserved6), _SIZE_HW(Reserved6)},
#endif
{MIB_HW_11N_RESERVED7,          "HW_11N_RESERVED7",                BYTE_T,         _OFFSET_HW(Reserved7), _SIZE_HW(Reserved7)},
{MIB_HW_11N_RESERVED8,          "HW_11N_RESERVED8",                BYTE_T,         _OFFSET_HW(Reserved8), _SIZE_HW(Reserved8)},
{MIB_HW_11N_RESERVED9,          "HW_11N_RESERVED9",                BYTE_T,         _OFFSET_HW(Reserved9), _SIZE_HW(Reserved9)},
{MIB_HW_11N_RESERVED10,                 "HW_11N_RESERVED10",               BYTE_T,         _OFFSET_HW(Reserved10), _SIZE_HW(Reserved10)},
{MIB_HW_LED_TYPE,               "HW_LED_TYPE",             BYTE_T,         _OFFSET_HW(ledType), _SIZE_HW(ledType)},
{MIB_HW_TX_POWER_5G_HT40_1S_A,          "HW_TX_POWER_5G_HT40_1S_A",        BYTE_ARRAY_T,   _OFFSET_HW(pwrlevel5GHT40_1S_A), _SIZE_HW(pwrlevel5GHT40_1S_A)},
{MIB_HW_TX_POWER_5G_HT40_1S_B,          "HW_TX_POWER_5G_HT40_1S_B",        BYTE_ARRAY_T,   _OFFSET_HW(pwrlevel5GHT40_1S_B), _SIZE_HW(pwrlevel5GHT40_1S_B)},
{MIB_HW_TX_POWER_5G_HT40_2S,            "HW_TX_POWER_DIFF_5G_HT40_2S",     BYTE_ARRAY_T,   _OFFSET_HW(pwrdiff5GHT40_2S), _SIZE_HW(pwrdiff5GHT40_2S)},
{MIB_HW_TX_POWER_5G_HT20,               "HW_TX_POWER_DIFF_5G_HT20",        BYTE_ARRAY_T,   _OFFSET_HW(pwrdiff5GHT20), _SIZE_HW(pwrdiff5GHT20)},
{MIB_HW_TX_POWER_5G_DIFF_OFDM,          "HW_TX_POWER_DIFF_5G_OFDM",        BYTE_ARRAY_T,   _OFFSET_HW(pwrdiff5GOFDM), _SIZE_HW(pwrdiff5GOFDM)},
{MIB_HW_WSC_PIN,                   "HW_WSC_PIN",                      STRING_T,       _OFFSET_HW(wscPin), _OFFSET_HW(wscPin)},
{0}
};
