#!/bin/sh
set -e
#!/bin/sh
. ../../define/PATH
. ../../define/FUNCTION_SCRIPT
if [ "${ROMFSDIR}" = "" ]; then
echo "NO Defined PATH!"
exit 0
fi
rm -rf ${ROMFSDIR}
mkdir ${ROMFSDIR}
mkdir ${ROMFSDIR}/dev
mkdir ${ROMFSDIR}/bin
mkdir ${ROMFSDIR}/sbin
mkdir ${ROMFSDIR}/usr
mkdir ${ROMFSDIR}/etc
mkdir ${ROMFSDIR}/var
mkdir ${ROMFSDIR}/proc
ln -s /var ${ROMFSDIR}/tmp
mknod -m666 ${ROMFSDIR}/dev/mtdblock0 b 31 0
mknod -m666 ${ROMFSDIR}/dev/mtdblock1 b 31 1
mknod -m666 ${ROMFSDIR}/dev/null 	c 	1 	3 	
mknod -m666 ${ROMFSDIR}/dev/random c 1 8
mknod -m666 ${ROMFSDIR}/dev/urandom 	c 1 9
mknod -m666 ${ROMFSDIR}/dev/ptmx c 5 2
mknod -m666 ${ROMFSDIR}/dev/ttyS0 c 4 64
mknod -m666 ${ROMFSDIR}/dev/console c 4 64
mknod  -m666 ${ROMFSDIR}/dev/ptyp0 c 2 0
mknod  -m666 ${ROMFSDIR}/dev/ttyp0 c 3 0
mknod  -m666 ${ROMFSDIR}/dev/ttyS1 c 4 65
mknod  -m666 ${ROMFSDIR}/dev/ptyp1 c 2 1
mknod  -m666 ${ROMFSDIR}/dev/ptyp2 c 2 2
mknod  -m666 ${ROMFSDIR}/dev/ptyp3 c 2 3
mknod  -m666 ${ROMFSDIR}/dev/ttyp1 c 3 1
mknod  -m666 ${ROMFSDIR}/dev/ttyp2 c 3 2
mknod  -m666 ${ROMFSDIR}/dev/ttyp3 c 3 3
mkdir -p ${ROMFSDIR}/dev/pts
chmod 755 /dev/pts
for minor in 0 1 2 3 4 5 6 7 8 9 10 ; do
mknod -m666 ${ROMFSDIR}/dev/pts/$minor c 136 $minor
done
ln -s /var/dev/log ${ROMFSDIR}/dev/log
mkdir ${ROMFSDIR}/lib
cp -R ${APPLIB}/*.so ${ROMFSDIR}/lib/
cp -R ${APPLIB}/*.so.* ${ROMFSDIR}/lib/
chmod 755 ${ROMFSDIR}/lib/*.so
cp -R -p ${APPDIR}/busybox-1.11.1/_install/* ${ROMFSDIR}
if [ "$_TELNETD_" = "y" ]; then
cp ${APPDIR}/busybox-1.00-pre8/busybox ${ROMFSDIR}/usr/sbin/telnetd
fi
cp ${APPDIR}/bridge-utils/brctl/brctl ${ROMFSDIR}/bin
if [ "$_USE_DNRD_" = "y" ]; then
cp -f ${APPDIR}/dnrd-2.10/src/dnrd ${ROMFSDIR}/bin
mkdir -p $ROMFSDIR/etc/dnrd
fi
cp -R -p ${APPDIR}/etc.rootfs/* ${ROMFSDIR}/etc
cp ${APPDIR}/script/*.sh ${ROMFSDIR}/bin
cp -avf ${APPDIR}/script/savelog.sh.8196C ${ROMFSDIR}/bin/savelog.sh
cp -f ${APPDIR}/${_PLATFORM_}/rc/reload ${ROMFSDIR}/bin/
cp ${APPDIR}/${_PLATFORM_}/auth/src/auth $ROMFSDIR/bin
cp ${APPDIR}/${_PLATFORM_}/auth/src/dlisten/iwcontrol $ROMFSDIR/bin
cp ${APPDIR}/${_PLATFORM_}/IAPP/iapp $ROMFSDIR/bin
cp ${APPDIR}/${_PLATFORM_}/lltdd/native-linux/lld2d $ROMFSDIR/bin
cp ${APPDIR}/${_PLATFORM_}/lltdd/src/wrt54g.large.ico $ROMFSDIR/etc/icon.ico
cp ${APPDIR}/${_PLATFORM_}/wsc/src/wscd $ROMFSDIR/bin
cp ${APPDIR}/${_PLATFORM_}/mini_upnp/mini_upnp.so $ROMFSDIR/lib
cp ${APPDIR}/${_PLATFORM_}/mini_upnp/mini_upnpd $ROMFSDIR/bin
cp ${APPDIR}/${_PLATFORM_}/wsc/src/wscd.conf $ROMFSDIR/etc/wscd.conf
ln -s /bin/wps.sh $ROMFSDIR/bin/wpstool
cp ${APPDIR}/${_PLATFORM_}/script/simplecfg* $ROMFSDIR/etc
ln -s /var/wps $ROMFSDIR/etc/simplecfg
cp ${APPDIR}/${_PLATFORM_}/miniigd/miniigd $ROMFSDIR/bin
ln -s /var/linuxigd $ROMFSDIR/etc/
mkdir -p $ROMFSDIR/etc/tmp
cp ${APPDIR}/${_PLATFORM_}/miniigd/pics* $ROMFSDIR/etc/tmp
cp -f ${APPDIR}/wireless_tools.25/iwpriv ${ROMFSDIR}/bin
if [ "$_AP_WITH_TIMEZONE_" = "y" ]; then
cp ${APPDIR}/clockspeed-0.62/sntpclock ${ROMFSDIR}/bin		
fi
cp ${IMAGEDIR}/config.bin ${ROMFSDIR}/etc/config.bin
echo ${_VERSION_} > ${ROMFSDIR}/etc/version
echo ${_DATE_} >  ${ROMFSDIR}/etc/compiler_date
cp -R -p ${APPDIR}/var/* ${ROMFSDIR}/var
if [ "$_START_BOA_" = "y" ]; then
cp -f ${GOAHEADDIR}/src/flash ${ROMFSDIR}/bin/flash
else
cp -f ${GOAHEADDIR}/LINUX/flash-ap ${ROMFSDIR}/bin/flash
fi
cp ${APPDIR}/hex_dec_convert/hex_dec_convert ${ROMFSDIR}/bin
mkdir -p ${ROMFSDIR}/web
cp -Rf ${GOAHEADDIR}/web/* ${ROMFSDIR}/web
if [ "$_START_BOA_" = "y" ]; then
cp -f ${GOAHEADDIR}/src/boa ${ROMFSDIR}/bin/webs
else
cp -f ${GOAHEADDIR}/LINUX/webs-ap ${ROMFSDIR}/bin/webs
fi
if [ "$_START_BOA_" = "y" ]; then
cp -rf ${GOAHEADDIR}/etc/boa ${ROMFSDIR}/etc/
fi
if [ "$_IS_GATEWAY_" != "y" ]; then			
if [ "$_REMOVE_RADIUS_SERVER_" = "y" ]; then				
cp -rf ${APPDIR}/freeradius-1.0.2/tmp/* ${ROMFSDIR}/
fi
fi
if [ "$_AUTOWPA_" = "y" ] || [ "$_WEP_MAC_" = "y" ] || [ "$_WPA_KEY_BY_MAC_" = "y" ]; then
cp -f ${APPDIR}/AutoWPA/AutoWPA ${ROMFSDIR}/bin
fi
cp ${ROOTDIR}/define/FUNCTION_SCRIPT ${ROMFSDIR}/web/
cp ${ROOTDIR}/AP/Airlive_ipd/ipd ${ROMFSDIR}/bin/
if [ "$_RTK_NTP_" = "y" ]; then
cp ${ROOTDIR}/AP/ntpclient/ntpclient ${ROMFSDIR}/bin
ln -s /tmp/TZ ${ROMFSDIR}/etc/TZ
fi
cd ${ROOTDIR}
if [ "$_PLATFORM_" = "RTL8196C_1200" ] || [ "$_PLATFORM_" = "RTL8196CS_1200" ]; then
PATH=${CROSSDIR}/bin:$PATH
${CROSS_COMPILE}lstrip $ROMFSDIR
fi
echo "clean SVN....."
find ${ROMFSDIR} -name .svn | xargs -i rm -rf {}
chmod 777 ${ROMFSDIR}/bin/*.*
if [ ! -f ${ROOTDIR}/toolchain/clean-space/clean-space ]; then
cd ${ROOTDIR}/toolchain/clean-space
gcc -o clean-space clean-space.c
fi
${ROOTDIR}/toolchain/clean-space/clean-space ${ROMFSDIR}
find ${ROMFSDIR}/* | xargs -i file {}  | grep "strip" | cut -f1 -d":" | xargs -r ${CROSS_COMPILE}strip -R .comment -R .note -g --strip-unneeded;
cp /home/EW7428HCN_Airlive/AP/script/*.sh /home/EW7428HCN_Airlive/AP/mkimg/romfs/bin
