#!/bin/sh
rootDir=`pwd`
crossDir=${rootDir}/toolchain/rtl8196c-toolchain-1.1/rsdk-96c
linuxDir=${rootDir}/linux-2.4.18_1200_96C
echo -e "\033[33;1m"
echo "********************************************************************************"
echo "*                       Set Compiling Path                                     *"
echo "********************************************************************************"
echo -e "\033[0m"
appDir=${rootDir}/AP
echo "ROOTDIR=$rootDir" > ./define/PATH
echo "CROSSDIR=$crossDir" >> ./define/PATH
echo "CROSS_COMPILE=${crossDir}/bin/rsdk-linux-" >> ./define/PATH
echo "LINUXDIR=${linuxDir}" >> ./define/PATH
echo "IMAGEDIR=${rootDir}/image" >> ./define/PATH
echo "APPDIR=${appDir}" >> ./define/PATH
echo "MODDIR=${appDir}/module/" >> ./define/PATH
echo "ROMFSDIR=${appDir}/mkimg/romfs" >> ./define/PATH
echo "GOAHEADDIR=${appDir}/goahead-2.1.1" >> ./define/PATH
echo "APPLIB=${crossDir}/lib" >> ./define/PATH
echo "CC=${crossDir}/bin/rsdk-linux-gcc" >> ./define/PATH
echo "STRIP=${crossDir}/bin/rsdk-linux-strip" >> ./define/PATH
echo "LD=${crossDir}/bin/rsdk-linux-ld" >> ./define/PATH
echo "AR=${crossDir}/bin/rsdk-linux-ar" >> ./define/PATH
echo "RANLIB=${crossDir}/bin/rsdk-linux-ranlib" >> ./define/PATH
if [ ! -f "./define/PATH" ]; then
echo "Error can't find ./define/PATH"
exit 0
fi
. ./define/PATH
LANG=eng
STR_DATE1=`date`
echo -e "\033[33;1m"
echo "********************************************************************************"
echo "*                       Function Define                                        *"
echo "********************************************************************************"
echo -e "\033[0m"
. ./define/FUNCTION_SCRIPT
if [ "$_START_BOA_" = "y" ]; then
sed -i "s/goahead-2.1.1/boa-0.94.14rc21/g" ./define/PATH
. ./define/PATH
fi
echo -e "\033[33;1m"
echo "********************************************************************************"
echo "*                       Application need clean                                 *"
echo "********************************************************************************"
echo -e "\033[0m"
if [ -f ./define/last_compile ]; then
diff ./define/FUNCTION_COMPILER ./define/last_compile > /dev/null
if [ $? -eq 0 ]; then
platformChanged="0"
else
platformChanged="1"
fi
else
platformChanged="1"
fi
if [ "$5" = "gpl" -o "$6" = "gpl" ]; then
platformChanged="0"
fi
if [ "$platformChanged" = "1" ]; then
if [ `echo $LINUXDIR |grep "2.6" |wc -l` == 1 ];then
KERNEL_V26=1
else
KERNEL_V26=0
fi
rm ./toolchain/rtl8196c-toolchain-1.1/rsdk-96c
cd toolchain/rtl8196c-toolchain-1.1/
if [ $KERNEL_V26 == 1 ];then
ln -s rsdk-1.3.6-4181-EB-2.6.30-0.9.30 rsdk-96c
else
ln -s rsdk-1.3.6-4181-EB-2.4.25-0.9.30 rsdk-96c
fi
cd ../../AP
./DoApp.sh clean
cd ..
fi 
set -e
echo -e "\033[33;1m"
echo ""
echo "********************************************************************************"
echo "*                            Setting WEB Directory                             *"
echo "********************************************************************************"
echo -e "\033[0m"
rm -f ${GOAHEADDIR}/web
if [ "$_IS_CONVERTER_" = "y" ]; then
WEB_DIR="web-cv-${_MODE_}"
elif [ "$_IS_GATEWAY_" = "y" ]; then
if [ "$_WEB_FILE_NAME_" != "" ]; then
WEB_DIR="web-gw-${_WEB_FILE_NAME_}-${_MODE_}"
else
WEB_DIR="web-gw-${_MODE_}"
fi
else
if [ "$_MODE_" = "Customer" -o "$_MODE_" = "Customer" ]; then
WEB_DIR="web-ap-Customer"
elif [ "$_MODE_" = "Customer" -a "$_MODEL_" = "EW7428HRN" ]; then
WEB_DIR="web-ap-Customer_HRN"
elif [ "$_MODE_" = "Customer" -a "$_MODEL_" = "EW7428HCN" ]; then
WEB_DIR="web-ap-HCN-${_MODE_}"
echo "WEB PATH = $WEB_DIR"
else
if [ "$_WEB_FILE_NAME_" != "" ]; then
WEB_DIR="web-ap-${_WEB_FILE_NAME_}-${_MODE_}"
else
WEB_DIR="web-ap-${_MODE_}"
fi
fi
fi
if [ -d "${GOAHEADDIR}/${WEB_DIR}" ]; then
ln -s ${GOAHEADDIR}/${WEB_DIR} ${GOAHEADDIR}/web
echo "Set WEB DIR to ${WEB_DIR} successfully..."
else
echo "Can not find ${WEB_DIR}..."
exit 0
fi
if [ "$5" = "gpl" -o "$6" = "gpl" ]; then
echo "WEB_DIR=${WEB_DIR}" >> ${ROOTDIR}/define/PATH
exit
fi
echo -e "\033[33;1m"
echo ""
echo "********************************************************************************"
echo "*                      Building Linux Kernel and Modules                       *"
echo "********************************************************************************"
echo -e "\033[0m"
rm -f ${APPDIR}/module/alg/*.* 2> /dev/null
rm -f ${APPDIR}/module/led/*.* 2> /dev/null
if [ "$_KERNEL_VERSION_" = "1.2b" ]; then
rm -f ${LINUXDIR}
ln -s linux-2.4.18_1200_96C_1.2b ${LINUXDIR}
else
rm -f ${LINUXDIR}
ln -s linux-2.4.18_1200_96C_12f ${LINUXDIR}
fi
cd ${LINUXDIR}
./set_kernel_config.sh
./DoLinux.sh
if [ $? != 0 ]; then
exit 1
fi
echo -e "\033[33;1m"
echo "********************************************************************************"
echo "*                            Building Applications                             *"
echo "********************************************************************************"
echo -e "\033[0m"
cd ${APPDIR}
./DoApp.sh make
if [ $? != 0 ]; then
exit 1
fi
cp -f ${ROOTDIR}/define/FUNCTION_COMPILER ${ROOTDIR}/define/last_compile
echo -e "\033[33;1m"
echo "********************************************************************************"
echo "*                               Building Image                                 *"
echo "********************************************************************************"
echo -e "\033[0m"
cd ${IMAGEDIR}
./DoImage.sh
if [ $? != 0 ];then
exit 1
fi
STR_DATE2=`date`
echo "Start Time -->"${STR_DATE1}
echo "End Time   -->"${STR_DATE2}
