#!/bin/sh
. ../define/PATH
. ../define/FUNCTION_SCRIPT
if [ "$_3G6238GN_HW_" = "y" ]; then
objcopy -I binary -O binary --gap-fill=0 --pad-to=0x10FFF0 linux linux-pad  # 0x110000 - (0x10 cvimg_head) = 0x10fff0.
else
objcopy -I binary -O binary --gap-fill=0 --pad-to=0x9FFF0 linux linux-pad  # 0xa0000 - (0x10 cvimg_head) = 0x9fff0.
fi
cat linux-pad appimg > linux-org
rm -f linux-pad
LANG=eng
if [ "$_3G6238GN_HW_" = "y" ]; then
BOOT_FILE="boot-SPI-32M-16BIT-SDRAM-3G-6238"
elif [ "$_MODEL_" = "EW7428HCN" ]; then
BOOT_FILE="boot-SPI-16M-16BIT-SDRAM-96C_7428HCN_DRAM_SPREADING"
elif [ "$_MODEL_" = "EW7438RPN" ]; then
BOOT_FILE="boot-SPI-16M-16BIT-SDRAM-96CS"
elif [ "$_PLATFORM_" = "RTL8196C_1100" ] || [ "$_PLATFORM_" = "RTL8196C_1200" ]; then
BOOT_FILE="boot-${_FLASHTYPE_}-${_MEMSIZE_}M-${_MEMBUS_}BIT-${_MEMTYPE_}-96C"
elif [ "$_PLATFORM_" = "RTL8196CS_1200" ]; then
BOOT_FILE="boot-${_FLASHTYPE_}-${_MEMSIZE_}M-${_MEMBUS_}BIT-${_MEMTYPE_}-96C"
else
BOOT_FILE="boot-${_FLASHTYPE_}-${_MEMSIZE_}M-${_MEMBUS_}BIT-${_MEMTYPE_}"
fi
if [ ! -f ${BOOT_FILE} ]; then
echo "boot code not found!!"
exit 1
else
objcopy -I binary -O binary --gap-fill=0 --pad-to=0x10000 ${BOOT_FILE} boot-pad
if [ "$_START_BOA_" = "y" ]; then
../AP/boa-0.94.14rc21/src/cvimg linux linux-org linux.bin 0x80500000 0x10000
else
../AP/goahead-2.1.1/LINUX/cvimg linux linux-org linux.bin 0x80500000 0x10000
fi
if [ "$_KERNEL_VERSION_26_" = "y" -o "$_FLASH4M_" = "y" ];then
objcopy -I binary -O binary --gap-fill=0 --pad-to=0x3f0000 linux.bin linux.bin-pad
else
objcopy -I binary -O binary --gap-fill=0 --pad-to=0x1f0000 linux.bin linux.bin-pad
fi
cat boot-pad linux.bin-pad > Factory_temp.bin
rm -rf boot-pad linux.bin-pad config-pad.bin
if [ $? != 0 ]; then
exit 1
fi
chmod 777 Factory_temp.bin
chmod 777 linux.bin
mkdir -p ./${_MODEL_}/${_MODE_}/Tester
mkdir -p ./${_MODEL_}/${_MODE_}/Factory
mv -f Factory_temp.bin ./${_MODEL_}/${_MODE_}/Factory/${_MODEL_}_${_MODE_}_${_VERSION_}_mp.bin
cp -f linux.bin        ./${_MODEL_}/${_MODE_}/Tester/${_MODEL_}_${_MODE_}_${_VERSION_}_upg.bin
ls -l ./${_MODEL_}/${_MODE_}/Tester/${_MODEL_}_${_MODE_}_${_VERSION_}_upg.bin ./${_MODEL_}/${_MODE_}/Factory/${_MODEL_}_${_MODE_}_${_VERSION_}_mp.bin
fi
