#!/bin/sh
set -e
. ../define/PATH
. ../define/FUNCTION_SCRIPT
nowPath=`pwd`
function SEARCH_AND_REPLACE {
if [ -f "$1" ]; then
filename=$1
target_old=$2
target_new=$3
target_line=`cat $filename | grep -n "$2" | cut -f 1 -d :`
if [ "$target_line" ]; then
total_line=`cat $filename | wc -l`
cat ${filename} | head -n `expr $target_line - 1` > ${filename}_temp
echo "$target_new" >> ${filename}_temp
cat ${filename} | tail -n `expr $total_line - $target_line` >> ${filename}_temp
cat ${filename}_temp > ${filename}
rm -rf ${filename}_temp
else
echo $target_new >> .config
fi
fi
}
rm -rf .config
cp .config.Normal .config
if [ "$_MSSID_" = "y" ]; then
SEARCH_AND_REPLACE .config "CONFIG_RTK_VLAN_SUPPORT" "CONFIG_RTK_VLAN_SUPPORT=y"
SEARCH_AND_REPLACE .config "CONFIG_RTK_VLAN_ROUTETYPE" "CONFIG_RTK_VLAN_ROUTETYPE=y"
fi
if [ ! -f "${LINUXDIR}/last_compile" ] || [ ../define/FUNCTION_COMPILER  -ef ${LINUXDIR}/last_compile ]; then
rm -rf ${LINUXDIR}/last_compile
make V=1 ARCH=mips CROSS_COMPILE=${CROSS_COMPILE} clean
fi
if [ "$1" = "clean" ]; then
rm -f compile.log last_compile
rm -f ./rtkload/linux.bin
make V=1 ARCH=mips CROSS_COMPILE=${CROSS_COMPILE} clean
exit
fi
make menuconfig
make dep
make ARCH=mips CROSS_COMPILE=${CROSS_COMPILE} -j1 V=1 2> compile.log
if [ $? != 0 ]; then
cat compile.log
exit
fi
if [ "${_START_BOA_}" = "y" ]; then
cvimgPath=${GOAHEADDIR}/src/cvimg
else
cvimgPath=${GOAHEADDIR}/LINUX/cvimg
fi
if [ ! -f ${cvimgPath} ]; then
cd ${GOAHEADDIR}
./DoIt.sh clean
./DoIt.sh make
fi
cd $nowPath/rtkload
make ARCH=mips NM=${CROSS_COMPILE}nm CC=${CROSS_COMPILE}gcc STRIP=${CROSS_COMPILE}strip OBJCOPY=${CROSS_COMPILE}objcopy LD=${CROSS_COMPILE}ld V=1
if [ $? != 0 ]; then
cat error
exit
fi
cd ..
cp ../define/FUNCTION_COMPILER ${LINUXDIR}/last_compile
SEARCH_AND_REPLACE .config "CONFIG_PCIE_POWER_SAVING" "CONFIG_PCIE_POWER_SAVING=n"
