#!/bin/sh

#Descript: Add General Kernel config file by function defined.
#Auth: Kyle
#Date: 2008/04/11



#**************************Configure Pattern END ********************

#Include Function Defined List.
. ../define/FUNCTION_SCRIPT

KERNEL_CONFIG=".config"
TEMP_CONFIG=".temp_config"
NEW_CONFIG=".new_config"
cp -f $KERNEL_CONFIG $NEW_CONFIG

######################################################################
#Author:    Kyle
#Date:      2008/09/24
#Describe:  字串取代
#
#Usage:     $1 old string  $2 new string 
######################################################################
ReValue=0

function replaceConfigure
{
if [ "`grep "$1" $NEW_CONFIG`" != "" -o "$ReValue" = "1" ]; then
	ReValue=1
else
	ReValue=0
fi
sed -e s/"$1"/"$2"/g $NEW_CONFIG > $TEMP_CONFIG
mv -f $TEMP_CONFIG $NEW_CONFIG
}

######################################################################
#Author:    Wise
#Date:      2009/02/25
#Describe:  打開設定 (based on 字串取代)（第二個參數預設為y）
#           尋找 [is not set] 改為 [已設定]。若無[is not set]且無[已設定]，貼在最後面
#           若原本已有 [已設定]，將其更改為新的值。
#
#Usage:     enableConfigure "CONFIG_RT2860V2_STA" "m"
#           enableConfigure "CONFIG_RT2860V2_STA" "y"
#           enableConfigure "CONFIG_RT2860V2_STA"
#           enableConfigure "CONFIG_RT2860V2_STA" "32"
######################################################################
function enableConfigure
{
	set_string="`cat $NEW_CONFIG | grep \"^$1=\"`"
	not_set_string="`cat $NEW_CONFIG | grep \"^# $1 is not set\"`"

	if [ "$2" = "" ]; then
		answer="y"
	else
		answer="$2"
	fi

	if [ "$set_string" = "" ]; then
		if [ "$not_set_string" = "" ]; then
			echo "$1=$answer" >> $NEW_CONFIG
		else
			replaceConfigure "# $1 is not set" "$1=$answer"
		fi
	else
		replaceConfigure "$set_string" "$1=$answer"
	fi 
}

######################################################################
#Author:    Wise
#Date:      2009/02/25
#Describe:  關閉設定 (based on 字串取代)
#           尋找 [已設定]，將其設為 [is not set]。若無 [已設定]，也無[is not set]
#           在最後面貼[is not set]，其他不管。
#Usage:     disableConfigure "CONFIG_RT2860V2_STA"
######################################################################
function disableConfigure
{
	set_string="`cat $NEW_CONFIG | grep \"^$1=\"`"
	not_set_string="`cat $NEW_CONFIG | grep \"^# $1 is not set\"`"

	if [ "$set_string" != "" ]; then
		replaceConfigure "$set_string" "# $1 is not set"
	elif [ "$not_set_string" == "" ]; then
		echo "# $1 is not set" >> $NEW_CONFIG
	fi 
}

#********************************************************************************************************************

if [ "$_HIGH_POWER_" = "y" ]; then
	replaceConfigure "# CONFIG_HIGH_POWER_EXT_PA is not set" "CONFIG_HIGH_POWER_EXT_PA=y"
	replaceConfigure "# CONFIG_HIGH_POWER_EXT_LNA is not set" "CONFIG_HIGH_POWER_EXT_LNA=y"
else
	replaceConfigure "CONFIG_HIGH_POWER_EXT_PA=y" "# CONFIG_HIGH_POWER_EXT_PA is not set"
	replaceConfigure "CONFIG_HIGH_POWER_EXT_LNA=y" "# CONFIG_HIGH_POWER_EXT_LNA is not set"
fi

#********************************************************************************************************************

CMP_CONFIG=`diff $KERNEL_CONFIG $NEW_CONFIG`
if [ "$CMP_CONFIG" != "" -o "$ReValue" = "1" ]; then
	cp -f $NEW_CONFIG $KERNEL_CONFIG
	#rm -f include/asm/asm-mips
   	#make config < enter
	yes "" | make config # tommy
fi 
echo "Set kernel config file successfully!"    
