/*
 *      Web server handler routines for get info and index (getinfo(), getindex())
 *
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *
 *      $Id: fmget.c,v 1.1.1.1 2005/03/09 04:52:51 rex Exp $
 *
 */
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "../../../define/C_DEFINE.h"
#include "../webs.h"
#include "apmib.h"
#include "apform.h"
#include "utility.h"
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <linux/wireless.h>
#include <stdarg.h>
#include <stdlib.h>

#define FW_VERSION	fwVersion
extern char *fwVersion;	// defined in version.c
extern int First, Changed;
//extern int need_reboot;		//removed by Erwin
//extern int vwlan_idx;
#ifdef HOME_GATEWAY
char staTbl[2][7][50];
#endif
#define RT_PRIV_IOCTL								(SIOCIWFIRSTPRIV + 0x01)
#define RTPRIV_IOCTL_SET							(SIOCIWFIRSTPRIV + 0x02)
// Ioctl value for WPS UPnP daemon and LLTD daemon must be identical in RT61 and RT2860
#define RT_OID_SYNC_RT61                            0x0D010750
// for consistency with RT61
#define RT_OID_WSC_QUERY_STATUS						((RT_OID_SYNC_RT61 + 0x01) & 0xffff)
#define RT_OID_WSC_PIN_CODE							((RT_OID_SYNC_RT61 + 0x02) & 0xffff)
#define RT_OID_WSC_UUID								((RT_OID_SYNC_RT61 + 0x03) & 0xffff)
#define RT_OID_WSC_SET_SELECTED_REGISTRAR			((RT_OID_SYNC_RT61 + 0x04) & 0xffff)
#define RT_OID_WSC_EAPMSG							((RT_OID_SYNC_RT61 + 0x05) & 0xffff)
#define RT_OID_WSC_MANUFACTURER						((RT_OID_SYNC_RT61 + 0x06) & 0xffff)
#define RT_OID_WSC_MODEL_NAME						((RT_OID_SYNC_RT61 + 0x07) & 0xffff)
#define RT_OID_WSC_MODEL_NO							((RT_OID_SYNC_RT61 + 0x08) & 0xffff)
#define RT_OID_WSC_SERIAL_NO						((RT_OID_SYNC_RT61 + 0x09) & 0xffff)
#define RT_OID_WSC_MAC_ADDRESS						((RT_OID_SYNC_RT61 + 0x10) & 0xffff)


/////////////////////////////////////////////////////////////////////////////

int getMyName(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t	*name;
	struct in_addr	intaddr;
	struct sockaddr hwaddr;
	unsigned char *pMacAddr;
	unsigned long sec, mn, hr, day, longVal;
	unsigned char buffer[100];
	int intVal, flag=1;
 	struct user_net_device_stats stats;
	DHCP_T dhcp;
	bss_info bss;
	char *ptr;
#ifdef HOME_GATEWAY
	unsigned char tmp[100];
	char *ptr1;
	OPMODE_T opmode=-1;
	char_t *iface;
#endif
   	if (ejArgs(argc, argv, T("%s"), &name) < 1) {
   		websError(wp, 400, T("Insufficient args\n"));
   		return -1;
   	}

	return websWrite(wp, T("RexHua"));
}

/***********************      Added By Yeahone!      ***********************/

int showSomeString(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t *buffer= "<h1><script type='text/javascript'>document.write(showText(textString1))</script></h1>";
	websWrite(wp, T("%s"), buffer);
}

int showWebsPasswd(int eid, webs_t wp, int argc, char_t **argv)
{
	char buffer[100];

	apmib_get(MIB_USER_NAME, (void *)buffer);
	websWrite(wp, T("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"));
	websWrite(wp, T("The User Name is : "));
	websWrite(wp, T("%s<br>"), buffer);
	apmib_get(MIB_USER_PASSWORD, (void *)buffer);
	websWrite(wp, T("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"));
	websWrite(wp, T("The User Password is : "));
	websWrite(wp, T("%s<br>"), buffer);
	apmib_get(MIB_SUPER_NAME, (void *)buffer);
	websWrite(wp, T("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"));
	websWrite(wp, T("The Super Name is : "));
	websWrite(wp, T("%s<br>"), buffer);
	apmib_get(MIB_SUPER_PASSWORD, (void *)buffer);
	websWrite(wp, T("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"));
	websWrite(wp, T("The Super Password is : "));
	websWrite(wp, T("%s<br>"), buffer);
}
/***********************      Added By Yeahone!      ***********************/
#ifdef _MSSID_
/*******************************************/
/* 1. flag 0. websWrite("\"%s\"")          */
/*    flag 1. websWrite("new Array(");     */
/*    flag 2. websWrite(wp,T(")"));        */
/*******************************************/
/*
 		 wp,1,
 		 MIB_WLAN_WEP_KEY_TYPE,
 		 MIB_WLAN_WEP64_KEY1,MIB_WLAN_WEP64_KEY2,MIB_WLAN_WEP64_KEY3,MIB_WLAN_WEP64_KEY4,
 		 MIB_WLAN_WEP128_KEY1,MIB_WLAN_WEP128_KEY2,MIB_WLAN_WEP128_KEY3,MIB_WLAN_WEP128_KEY4
*/
/*void mssid_list_all(webs_t wp,int flag,int handler, ...)
{
	int val=0,i=0,ii=0;
	int arg1;
	char buffer[100]={0};
	char tempkey[100]={0};
	if(flag==1)
		websWrite(wp,"new Array(");
	apmib_get( handler, (void *)&val);
	va_list key_list;
	va_start(key_list,handler);
	while(arg1=va_arg(key_list,int))
	{
		memset(buffer, 0, sizeof(buffer));
		memset(tempkey,0,sizeof(tempkey));
		apmib_get(arg1, (void *)buffer);
		ii=0;
		if (val == 0){
			#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
				CharFilter2(buffer);
			#endif
			if (flag==1){
			//printf("111111  %s\n , buffer");
				websWrite(wp, T("\"%s\""), buffer);
				flag=0;
			}
			else
				websWrite(wp, T(",\"%s\""), buffer);
		}
		else
		{
			if (ii<4)
			{
				for(i=0;i<5;i++){
					sprintf(tempkey,"%s%02x",tempkey,buffer[i]);
				}
			}
			else if(ii<8)
			{
				for(i=0;i<13;i++){
					sprintf(tempkey,"%s%02x",tempkey,buffer[i]);
				}
			}
			ii++;
			if(flag==1){
			printf("tempkey = %s\n" , tempkey);
				websWrite(wp, T("\"%s\""),tempkey);
				flag=0;
			}
			else
			{
				printf("tempkey2 = %s\n" , tempkey);
				websWrite(wp, T(",\"%s\""),tempkey);
				}
		}
	}
	printf("---------------------------------------------------------------\n");
	va_end(key_list);
	if(flag==2)
		websWrite(wp,T(")"));
	return;
}*/
void list_value(webs_t wp, int acount, ... ){
	websWrite(wp,T("new Array("));
	int val,ii,band;
	va_list vband;
	va_start(vband,acount);
	ii=1;
	while(band=va_arg(vband,int))
	{
		apmib_get(band,(void *)&val);
		if(ii<acount)websWrite(wp,T("\"%d\","),val);
		else websWrite(wp,T("\"%d\""),val);
		ii++;
	}
	websWrite(wp,T(")"));
}
#endif
int getInfo(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t	*name;
	struct in_addr	intaddr;
	struct sockaddr hwaddr;
	unsigned char *pMacAddr;
	unsigned long sec, mn, hr, day, longVal;
	unsigned char buffer[100];
	int intVal, flag=1, intVal2;
 	struct user_net_device_stats stats;
	DHCP_T dhcp;
	bss_info bss;
	char *ptr;
	time_t current_time;
	struct tm * tm_time;
	time_t current_secs;

#ifdef HOME_GATEWAY
	unsigned char tmp[100];
	char *ptr1;
	OPMODE_T opmode=-1;
	char_t *iface;
#endif
	WEP_T wep;
   	if (ejArgs(argc, argv, T("%s"), &name) < 1) {
   		websError(wp, 400, T("Insufficient args\n"));
   		return -1;
   	}
	//cypress 100714, for Customer 3.0
	
	//cypress 100714, for Customer 3.0
   	if ( !strcmp(name, T("uptime")))
	{
		FILE* fpt;
		char buffer[100]={0};
		int i;
        	if ((fpt = fopen("/proc/uptime","r"))!=NULL)
		{
	        	fgets(buffer,100, fpt);
			for( i=0; i<100; i++ )
			{
				if( buffer[i] == '.' )
					buffer[i] = 0;
				if( (buffer[i] == 0) || (buffer[i] == ' ') )
					break;
			}
			fclose(fpt);
			sec = atoi(buffer);
		}
		else
			sec = (unsigned long) time(NULL);
//		ez=sec;
		day = sec / 86400;
#ifdef _RTL8181_     // busybox 1.02 don't need this
//        day -= 10957; 		// day counted from 1970-2000
#endif
		sec %= 86400;
		hr = sec / 3600;
		sec %= 3600;
		mn = sec / 60;
		sec %= 60;
//#ifdef _EZVIEW_
		//return websWrite(wp, T("%d<script>dw(day)</script>:%dh:%dm:%ds"),day, hr, mn, sec);
//#else
		return websWrite(wp, T("%dday:%dh:%dm:%ds"),day, hr, mn, sec);
//#endif
	}

#ifdef _DHCP_SERVER_WITH_GW_DNS_
	else if ( !strcmp(name, T("dhcpGW"))) {
		if ( !apmib_get( MIB_DHCP_SERVER_GW, (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"),inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("dhcpDNS1"))) {
		if ( !apmib_get( MIB_DHCP_SERVER_DNS1, (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"),inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("dhcpDNS2"))) {
		if ( !apmib_get( MIB_DHCP_SERVER_DNS2, (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"),inet_ntoa(intaddr));
	}
#endif
#ifdef _IPN_WL_DEVICE_
   	else if ( !strcmp(name, T("clientnum"))) {
		apmib_get( MIB_WLAN_DISABLED, (void *)&intVal);
		if (intVal == 1)	// disable
			intVal = 0;
		else {
			WLAN_IPN_STA_Tp pInfo;
			char *buff;
			int i;
			intVal=0;
			buff = calloc(1, sizeof(WLAN_IPN_STA_T) * (MAX_STA_NUM+1));
			if ( buff == 0 ) {
				printf("Allocate buffer failed!\n");
			}
			if ( getInprocommWlSta(WLAN_IF,  (WLAN_IPN_STA_Tp)buff ) < 0 ) {
				printf("Read wlan sta info failed!\n");
			}
			for (i=0; i<=MAX_STA_NUM; i++) {
				pInfo = (WLAN_IPN_STA_Tp)&buff[i*sizeof(WLAN_IPN_STA_T)];
				if (pInfo->aid)
					intVal++;
			}
		}
		sprintf(buffer, "%d", intVal );
		return websWrite(wp, buffer);
	}
#else
   	else if ( !strcmp(name, T("clientnum"))) {
		apmib_get( MIB_WLAN_DISABLED, (void *)&intVal);
		if (intVal == 1)	// disable
			intVal = 0;
		else {
			/*
			WLAN_STA_INFO_T *pInfo;
			char *buff;
			buff = calloc(1, sizeof(WLAN_STA_INFO_T));
			getWlStaInfo(WLAN_IF,  (WLAN_STA_INFO_Tp)buff );
			pInfo = (WLAN_STA_INFO_T *)buff;
			intVal = pInfo->Num;
			*/
			if ( getWlStaNum(WLAN_IF, &intVal) < 0)
			intVal = 0;
		}
		sprintf(buffer, "%d", intVal );
		return websWrite(wp, buffer);
	}
#endif
#ifdef _WATCH_DOG_
else if ( !strcmp(name, T("watchdog_interval"))) {
		if ( !apmib_get( MIB_WATCH_DOG_INTERVAL,  (void *)&intVal) )	return -1;
		return websWrite(wp, T("%d"), intVal);
}
else if ( !strcmp(name, T("watchdog_host"))) {
		if ( !apmib_get( MIB_WATCH_DOG_HOST,  (void *)&intaddr) )	return -1;
		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
}

#endif
//************************************ Repeater Status *******************Wise*****************
else if ( !strcmp(name, T("Repeater_Stat"))) {
#if	defined(_REPEATER_STAT_) && defined(__TARGET_BOARD__)
#else
		return websWrite(wp, "0");
#endif
	}
//************************************ Easy View *******************Wise*****************
#ifdef _EZVIEW_
	else if ( !strcmp(name, T("EZview"))) {
		#define MAX_DEVICE_NUM 255
		#define MAX_NAME_LENGTH 21
		FILE *fp, *fp1, *fp2, *fp3;
		char c;
		char buf[5101], buf1[1021];
		char tmpBuf[100], tmpBuf1[100], tmpBuf2[100], tmpBuf3[100];
		char *tmp, *tmp1,*ip, *local_ip, *mask_ip;
		int i,j,k,l,m,count,nbtcount,f_count, entryNum_pf, entryNum_qos, entryNum;
//		SDHCP_T entry;
		PORTFW_T entry_pf;
		QOS_T    entry_qos;
		EZVIEW_T entry;
		char mac_from_usn[13];
		char    macaddr[MAX_DEVICE_NUM][13], f_macaddr[MAX_DEVICE_NUM][13];
		char     ipaddr[MAX_DEVICE_NUM][16];
		char devicename[MAX_DEVICE_NUM][MAX_NAME_LENGTH], f_devicename[MAX_DEVICE_NUM][MAX_NAME_LENGTH];
		int  devicetype[MAX_DEVICE_NUM], f_devicetype[MAX_DEVICE_NUM], f_block[MAX_DEVICE_NUM], f_upload[MAX_DEVICE_NUM], f_download[MAX_DEVICE_NUM];
		int  f_blockst[MAX_DEVICE_NUM], f_blocket[MAX_DEVICE_NUM], f_ipaddr[MAX_DEVICE_NUM];
		unsigned short f_portfw[MAX_DEVICE_NUM][5][2];

		apmib_get( MIB_IP_ADDR,  (void *)&intaddr);
		local_ip=inet_ntoa(intaddr);

		tmp=local_ip;
		i=0;j=0;
		while(i<3)
		{
			if(tmp[j] == '.') i=i+1;
			j=j+1;
		}
		tmp[j]='\0';
		mask_ip=tmp;

	//====NETBIOS & UPNP scan script
		system("/bin/ez.sh");

	//====START fetch
		count=0;

	//====NETBIOS fetch
		fp1=fopen("/tmp/nbtname","r");
		fp2=fopen("/tmp/nbtip","r");
		fp3=fopen("/tmp/nbtmac","r");
		while(  fgets(tmpBuf1, 100, fp1) > 0  &&  fgets(tmpBuf2, 100, fp2) > 0  &&  fgets(tmpBuf3, 100, fp3) > 0  )
		{
			if( strcmp(tmpBuf2, local_ip)!=0 )
			{
				strcpy( devicename[count], tmpBuf1 );
				sstrip( devicename[count], MAX_NAME_LENGTH);

				strcpy( ipaddr[count], tmpBuf2 );
				sstrip( ipaddr[count], 16);

				strcpy( macaddr[count], tmpBuf3);
				sstrip( macaddr[count], 13);

				devicetype[count]=4; //in ezview.js, var resolvetypeTbl=new Array("nas","cam","game","ps","user","pserver","what","ap");

				count += 1;
			}
		}
		fclose(fp1);
		fclose(fp2);
		fclose(fp3);
		nbtcount=count;
	//====UPNP fetch

		fp1=fopen("/tmp/upnptmp","r");

		k=0;
		while(fgets(tmpBuf1, 100, fp1) > 0)
		{
			//===============Get IP [XXX.XXX.XXX.XXX], this is the head of the upnp information.S
			if( strncmp(tmpBuf1,"[",1) == 0 )
			{
				strncpy( tmpBuf2, tmpBuf1+1, strchr(tmpBuf1,']') - (tmpBuf1+1) );
				tmpBuf2 [ strchr(tmpBuf1,']') - (tmpBuf1+1) ] = '\0';
				if( strcmp(tmpBuf2, local_ip)!=0 ) //Router self ip no display
				{
					strcpy( ipaddr[count], tmpBuf2 );
					k=1;
				}
				strcpy( mac_from_usn, "000000000000");
				strcpy( macaddr[count], "000000000000");
			}
			//===============Get XML from Location, and parse the XML.
			if( (strncmp(tmpBuf1,"LOCATION",8) == 0 || strncmp(tmpBuf1,"Location",8) == 0) && k==1 )
			{
				//tmp=tmpBuf1+9;
				tmp=strstr(tmpBuf1,"http://");
				sstrip(tmp, 100);
				#ifdef __TARGET_BOARD__
					//sprintf(tmpBuf,"/bin/wget -t 1 -T 1 -O /tmp/upnpxml.xml %s",tmp);
					sprintf(tmpBuf,"wget -O /tmp/upnpxml.xml %s",tmp);
				#else
					sprintf(tmpBuf,"wget -t 1 -T 1 -O /tmp/upnpxml.xml %s",tmp);
				#endif
				system(tmpBuf);
				//=============
				strcpy(devicename[count],"");
				devicetype[count]=6;
				strcpy(macaddr[count],"000000000000");
				fp3=fopen("/tmp/upnpxml.xml","r");
				l=0;
				if(!feof(fp3) && fgetc(fp3)=='<') l=1;
				fclose(fp3);
				if(l==1)
				{
					fp3=fopen("/tmp/upnpxml.xml","r");
					xmlnode *root, *zz;
					last_tag[0]='\0';
					this_tag[0]='\0';
					make_node(&root);
					make_tree(fp3,&root);
					zz=read_tree(root->child,0,"ezview","");
					if(zz!=NULL)
					{
						if(zz->child!=NULL)
						{
							zz=zz->child;
							while(1)
							{
								if(!strcmp(zz->name,"devicename")) strcpy(devicename[count],zz->content);
								if(!strcmp(zz->name,"devicetype")) devicetype[count]=atoi(zz->content);
								if(!strcmp(zz->name,"devicemac"))  strcpy(macaddr[count],zz->content);
								if(zz->sibling_next==NULL) break;
								else zz=zz->sibling_next;
							}
						}
					}
					else
					{
						zz=read_tree(root->child,0,"manufacturer","Customer Technology");
						if(zz!=NULL)
						{
							while(zz->sibling_last!=NULL) zz=zz->sibling_last;
							while(1)
							{
								if(!strcmp(zz->name,"friendlyName")) {strcpy(devicename[count],zz->content);sstrip(devicename[count],21);}
								if(!strcmp(zz->name,"modelNumber")) devicetype[count]=atoi(zz->content);
								if(!strcmp(zz->name,"serialNumber"))  strcpy(macaddr[count],zz->content);
								if(zz->sibling_next==NULL) break;
								else zz=zz->sibling_next;
							}

						}

					}
					for(i=0;i<12;i++)	macaddr[count][i]=tolower(macaddr[count][i]);
					fclose(fp3);
				}
				//===============
				/*
				fp3=fopen("/tmp/upnpxml.xml","r");
				while( fgets(buf, 5101, fp3)>0 && strstr(buf, "<ezview>")==NULL) ;

				if( strstr(buf, "<ezview>")!=NULL)
				{
					fgets(buf, 5101, fp3); //specVer
					fgets(buf, 5101, fp3); //devicename
						tmp=parse_ezview_xml(buf, "devicename");
						if(tmp!=NULL)	{ sstrip(tmp,MAX_NAME_LENGTH); strcpy(devicename[count], tmp); }
						else		strcpy(devicename[count], "N/A");
					fgets(buf, 5101, fp3); //devicetype
						tmp=parse_ezview_xml(buf, "devicetype");
						if(tmp!=NULL)	devicetype[count]=tmp[0]-'0';
						else		devicetype[count]=6;
					fgets(buf, 5101, fp3); //devicemac
						tmp=parse_ezview_xml(buf, "devicemac");
						if(tmp!=NULL)	strcpy(macaddr[count], tmp);
						else		strcpy(macaddr[count], "000000000000");
						for(i=0;i<13;i++) macaddr[count][i]=tolower(macaddr[count][i]);
				}
				else
				{
					strcpy(devicename[count], "N/A");
					devicetype[count]=6;
					strcpy(macaddr[count], "000000000000");
				}
				fclose(fp3);*/
				k+=2;  //  0x10  means got location
			}
			//===============Get XBOX360
			if( strncmp(tmpBuf1,"SERVER",6) == 0 && k>0 )
			{
				if (strstr(tmpBuf1,"Xbox/")!=NULL)
				{
					devicetype[count]=2;
					strcpy(devicename[count], "XBOX360");
					k+=2;
				}
			}
			//===============Get MAC from USN. If can't get MAC from XML, this MAC will be used.
			if( strncmp(tmpBuf1,"USN",3) == 0 && k>0 )
			{
				m=0;
				for(i=3;i<strlen(tmpBuf1)-11&&m==0;i++)
				{
					j=0;
					for(l=0;l<12&&j==0;l++)
					{
						if(!_is_hex(tmpBuf1[i+l])) j=1;
					}
					if(j==0) m=1;
				}
				if(m==1)
				{
					for(l=0;l<12;l++) mac_from_usn[l]= tolower(tmpBuf1[i+l-1]);
					mac_from_usn[12]='\0';
				}
				else	strcpy( mac_from_usn, "000000000000");
			}
			//==============="---" is tail of upnp information
			if( strncmp(tmpBuf1,"---\n",4) == 0 )
			{
				if(k>0)
				{
					if(k==1) //didn't find "Location:"
					{
						strcpy(devicename[count], "N/A");
						devicetype[count]=6;
						strcpy(macaddr[count], mac_from_usn);
					}
					j=0;
					for(i=nbtcount;i<count && j==0;i++) // if MAC has appeared before, count no +1, means this data no use. Only upnp will occer
					{
						if( /*strcmp(macaddr[count], macaddr[i]) == 0 &&*/ strcmp(ipaddr[count], ipaddr[i]) == 0 ) // mac the same
						{
							if( strcmp(devicename[count],"N/A")!=0 && strcmp(devicename[i],"N/A")==0 || devicetype[count]!=6 && devicetype[i]==6)
							{
								strcpy(devicename[i], devicename[count]);
								strcpy(ipaddr[i], ipaddr[count]);
								devicetype[i]=devicetype[count];
							}
							j=1;
						}
					}
					if(j==0) count=count+1;
				}
				k=0;
			}
		}
		fclose(fp1);
		for(i=0;i<count;i++) // after all, use << arp mac >> replace << mac get from ezview tag or usn >>, so arp will be last result
		{
			sprintf(tmpBuf1,	"cat /proc/net/arp | grep \'%s \'| cut -b42-59  > /tmp/ezarp", ipaddr[i]);
			system(tmpBuf1);
			fp1=fopen("/tmp/ezarp","r");
			if (fgets(buf, 100, fp1) > 0 && strncmp(buf,"00:00:00:00:00:00",17)!=0)
			{
//				for(j=0;j<12;j++) macaddr[i][j]=tolower(buf[j/2 + j]) //0 1 3 4 6 7 9 10 12 13 15 16
				macaddr[i][0]=tolower(buf[0]);
				macaddr[i][1]=tolower(buf[1]);
				macaddr[i][2]=tolower(buf[3]);
				macaddr[i][3]=tolower(buf[4]);
				macaddr[i][4]=tolower(buf[6]);
				macaddr[i][5]=tolower(buf[7]);
				macaddr[i][6]=tolower(buf[9]);
				macaddr[i][7]=tolower(buf[10]);
				macaddr[i][8]=tolower(buf[12]);
				macaddr[i][9]=tolower(buf[13]);
				macaddr[i][10]=tolower(buf[15]);
				macaddr[i][11]=tolower(buf[16]);
				macaddr[i][12]='\0';
			}
			fclose(fp1);
		}
		//=======cheat (Lock MAC)
		char cheat_mac[2][10] ={"00:1B:EA:", "00:19:C5:"};
		char cheat_name[2][14]={"Wii-",      "PlayStation3-"};
		for(j=0;j<2;j++)
		{
			sprintf(tmpBuf1, "cat /proc/net/arp | grep \' %s\'> /tmp/ezarp", cheat_mac[j]);
			system(tmpBuf1);
			fp1=fopen("/tmp/ezarp","r");
			while( fgets(buf, 100, fp1)>0 )
			{
				strncpy(tmpBuf1,buf,18);
				sstrip(tmpBuf1,18);
				#ifdef __TARGET_BOARD__
				sprintf(tmpBuf2,"arping -I br0 -c 1 %s > /tmp/arpingtmp",tmpBuf1);
				#else
				sprintf(tmpBuf2,"arping -I eth0 -c 1 %s > /tmp/arpingtmp",tmpBuf1);
				#endif
				system(tmpBuf2);
//				sprintf(tmpBuf3,"echo \'%s\'",tmpBuf1);
//				system(tmpBuf3);
				system("cat /tmp/arpingtmp | grep \'EZ\' > /tmp/arpingtmp1; rm /tmp/arpingtmp");
				fp2=fopen("/tmp/arpingtmp1","r");
				if ( fgets(tmpBuf2, 100, fp2) > 0
					&& tmpBuf2[2] == buf[41]
					&& tmpBuf2[3] == buf[42]
					&& tmpBuf2[4] == buf[44]
					&& tmpBuf2[5] == buf[45]
					&& tmpBuf2[6] == buf[47]
					&& tmpBuf2[7] == buf[48]
					&& tmpBuf2[8] == buf[50]
					&& tmpBuf2[9] == buf[51]
					&& tmpBuf2[10]== buf[53]
					&& tmpBuf2[11]== buf[54]
					&& tmpBuf2[12]== buf[56]
					&& tmpBuf2[13]== buf[57])
				{

					strncpy(ipaddr[count],buf,18);
					sstrip(ipaddr[count],18);

					macaddr[count][0]=tolower(buf[41]);
					macaddr[count][1]=tolower(buf[42]);
					macaddr[count][2]=tolower(buf[44]);
					macaddr[count][3]=tolower(buf[45]);
					macaddr[count][4]=tolower(buf[47]);
					macaddr[count][5]=tolower(buf[48]);
					macaddr[count][6]=tolower(buf[50]);
					macaddr[count][7]=tolower(buf[51]);
					macaddr[count][8]=tolower(buf[53]);
					macaddr[count][9]=tolower(buf[54]);
					macaddr[count][10]=tolower(buf[56]);
					macaddr[count][11]=tolower(buf[57]);
					macaddr[count][12]='\0';
					//=====name and type
					strcpy(tmpBuf1,macaddr[count]+6);
					for(i=0;i<6;i++) tmpBuf1[i]=toupper(tmpBuf1[i]);
					strcpy(devicename[count],cheat_name[j]);
					strcat(devicename[count],tmpBuf1);
					devicetype[count]=2;

					count+=1;
				}
				fclose(fp2);
			}
		}
		fclose(fp1);
		//=======cheat (Lock MAC) end
		fp2=fopen("/tmp/upnptable","w");
		for(i=0;i<count;i++)
		fprintf(fp2,"%15s, %s, %20s, type:%d\n",ipaddr[i], macaddr[i], devicename[i], devicetype[i]);
		fclose(fp2);

		system("cat /tmp/upnptable");

		websWrite(wp, "var scannameTbl = new Array (");
		for(j=0;j<count;j++)	websWrite(wp, "\"%s\",", devicename[j]);
		websWrite(wp,"\"\");\n");

		websWrite(wp, "var scanmacTbl = new Array (");
		for(j=0;j<count;j++)	websWrite(wp, "\"%s\",", macaddr[j]);
		websWrite(wp,"\"\");\n");

		websWrite(wp, "var scanipTbl = new Array (");
		for(j=0;j<count;j++)	websWrite(wp, "\"%s\",", ipaddr[j]);
		websWrite(wp,"\"\");\n");

		websWrite(wp, "var scantypeTbl = new Array (");
		for(j=0;j<count;j++)	websWrite(wp, "\"%d\",", devicetype[j]);
		websWrite(wp,"\"\");\n");


	//====Read records in flash
		//===          MIB_EZMNG_MISC :tmp[4n+0]            tmp[4n+1]               tmp[4n+2]            tmp[4n+3]
		//                             000000  0   0        00  000  000            00000000             00000000
		//                             type    dmz block    xx  up   down           blockst              blocket

		apmib_get( MIB_EZVIEW_NUM, (void *)&entryNum);
		apmib_get( MIB_PORTFW_NUM, (void *)&entryNum_pf);

		//======MIB_EZVIEW
		for(i=0 ; i<entryNum ; i++)
		{
                        *((char *)&entry) = (char)(i+1);
			apmib_get(MIB_EZVIEW, (void *)&entry);

			strcpy(f_devicename[i],entry.DeviceName);
			sprintf(f_macaddr[i],"%02x%02x%02x%02x%02x%02x", entry.macAddr[0], entry.macAddr[1], entry.macAddr[2], entry.macAddr[3], entry.macAddr[4], entry.macAddr[5]);

			f_ipaddr[i]	=entry.ipAddr;
			f_blockst[i]	=entry.BlockStartTime;
			f_blocket[i]	=entry.BlockStopTime;
			f_download[i]	=entry.QoS%8;
			f_upload[i]	=(entry.QoS/8)%8;
			f_devicetype[i]	=entry.TypeAndBlock/4;
			f_block[i]	=entry.TypeAndBlock%2;

			for(j=0;j<5;j++)
			{
				f_portfw[i][j][0] = entry.pf_from[j];
				f_portfw[i][j][1] = entry.pf_to[j];
			}
		}


		websWrite(wp, "var nameTbl = new Array (");
		for(j=0;j<i;j++)	websWrite(wp, "\"%s\",", f_devicename[j]);
		websWrite(wp,"\"\");\n");

		websWrite(wp,"var macTbl = new Array (");
		for(j=0;j<i;j++)	websWrite(wp, "\"%s\",", f_macaddr[j]);
		websWrite(wp,"\"\");\n");

		websWrite(wp,"var ipTbl = new Array (");
		for(j=0;j<i;j++)	websWrite(wp, "\"%d\",", f_ipaddr[j]);
		websWrite(wp,"\"\");\n");

		websWrite(wp, "var blockTbl = new Array (");
		for(j=0;j<i;j++)	websWrite(wp, "\"%d\",", f_block[j]);
		websWrite(wp,"\"\");\n");

		websWrite(wp, "var typeTbl = new Array (");
		for(j=0;j<i;j++)	websWrite(wp, "\"%d\",", f_devicetype[j]-1);
		websWrite(wp,"\"\");\n");

		websWrite(wp, "var downTbl = new Array (");
		for(j=0;j<i;j++)	websWrite(wp, "\"%d\",", f_download[j]==0?5:f_download[j]);
		websWrite(wp,"\"\");\n");

		websWrite(wp, "var upTbl = new Array (");
		for(j=0;j<i;j++)	websWrite(wp, "\"%d\",", f_upload[j]==0?5:f_upload[j]);
		websWrite(wp,"\"\");\n");

		websWrite(wp, "var blockstTbl = new Array (");
		for(j=0;j<i;j++)	websWrite(wp, "\"%d\",", f_blockst[j]);
		websWrite(wp,"\"\");\n");

		websWrite(wp, "var blocketTbl = new Array (");
		for(j=0;j<i;j++)	websWrite(wp, "\"%d\",", f_blocket[j]);
		websWrite(wp,"\"\");\n");

		websWrite(wp,"var pfTbl = new Array (");
		for (j=0; j<i; j++)
		{
			for(k=0;k<5;k++)
				if( f_portfw[j][k][0] != 0 && f_portfw[j][k][1] != 0 )
				{
//					sprintf(tmpBuf1, "%s%d", mask_ip, f_ipaddr[j]);
					sprintf(tmpBuf1, "%s", f_macaddr[j]);
					websWrite(wp, T("\"%s\",\"%d\",\"%d\","), tmpBuf1, f_portfw[j][k][0], f_portfw[j][k][1]);
				}
		}
                websWrite(wp,"\"\");\n");


		apmib_get( MIB_EZVIEW_DMZ, (void *)buf);
		websWrite(wp,"var dmzsetting = \"%d\";\n", (unsigned char)buf[0] );

		return 0;
	}
   	else if ( !strcmp(name, T("Legacy_PF_table"))) {
   		int	entryNum, i;
   		PORTFW_T entry;
   		apmib_get(MIB_PORTFW_NUM, (void *)&entryNum);

   		websWrite(wp, T("new Array("));
   		for (i=1; i<=entryNum; i++)
   		{
   			*((char *)&entry) = (char)i;

   			apmib_get(MIB_PORTFW, (void *)&entry);

   	   		websWrite(wp, T("\"%d\",\"%d\","),entry.fromPort, entry.toPort);

   		}
	   	websWrite(wp, T("\"\",\"\");"));
   	}
#endif

#if defined(_BR6428PNL_) || defined (_AP_WITH_DNS_)
/*
	else if ( !strcmp(name, T("wanDNS")) ) {
		DNS_TYPE_T dns;
		if ( !apmib_get( MIB_WAN_DNS_MODE, (void *)&dns) )
			return -1;
		sprintf(buffer, "%d", (int)dns);
		ejSetResult(eid, buffer);
		return 0;
	}
  */	else if ( !strcmp(name, T("wan-dns1"))) {
		if ( !apmib_get( MIB_WAN_DNS1,  (void *)&intaddr) )
			return -1;
		if (!memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4))
			return websWrite(wp, T(""));
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
  	else if ( !strcmp(name, T("wan-dns2"))) {
		if ( !apmib_get( MIB_WAN_DNS2,  (void *)&intaddr) )
			return -1;
		if (!memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4))
			return websWrite(wp, T(""));
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
  	else if ( !strcmp(name, T("wan-dns3"))) {
		if ( !apmib_get( MIB_WAN_DNS3,  (void *)&intaddr) )
			return -1;
		if (!memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4))
			return websWrite(wp, T(""));
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
#endif

#if defined(_BR6428PNL_) || defined(_AP_WITH_DHCP_CLIENT_)
	else if ( !strcmp(name, T("dhcpcheckEnabled"))) {
		if ( !apmib_get( MIB_DHCP_CHECK_ENABLED, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal);
		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("dhcp_lease_time"))) {
		int is_dhcps = 0;
		unsigned long Dhcp_lease_time=0;
		FILE *fp, *fp1;
		if ( !apmib_get( MIB_DHCP_CHECK_ENABLED, (void *)&intVal) )
			return -1;
		if ( intVal == 1 ) {
			system("/bin/dhcp_check -v -i br0 -t 2 &");
			if (fp = fopen("/tmp/is_dhcp_server_found", "r")) {
				fscanf(fp, "%d", &is_dhcps);
				fclose(fp);
				if (is_dhcps == 1) {
					if (fp1 = fopen("/tmp/dhcp_lease_time", "r")) {
						fscanf(fp1, "%lu", &Dhcp_lease_time);
						fclose(fp1);
						return websWrite(wp, T("%lu"), Dhcp_lease_time);
					}
				}
				return websWrite(wp, T("No external dhcp server"));
			}
		}
		else
			return websWrite(wp, T("---"));
	}
	else if ( !strcmp(name, T("get_ip_ifconfig"))) {
		FILE *fp1;
		#ifdef __TARGET_BOARD__
		system("ifconfig br0 | grep inet | cut -b 21- | cut -d ' ' -f 0 > /tmp/ifconfig_ip");
		#else
		system("echo \"Get IP form DHCP server\" > /tmp/ifconfig_ip");
		#endif
		if ((fp1 = fopen("/tmp/ifconfig_ip","r"))!=NULL) {
			fgets(buffer, 30, fp1);
			fclose(fp1);
			system("rm -f /tmp/ifconfig_ip");
			return websWrite(wp, buffer);
		}
        }
        else if ( !strcmp(name, T("get_mask_ifconfig"))) {
                FILE *fp1;
		#ifdef __TARGET_BOARD__
                system("ifconfig br0 | grep Mask | tr -s \" \" | cut -d \" \" -f 5 | cut -d \":\" -f 2 > /tmp/ifconfig_mask");
		#else
                system("echo \"Get mask from DHCP server\" > /tmp/ifconfig_mask");
		#endif
                if ((fp1 = fopen("/tmp/ifconfig_mask","r"))!=NULL) {
                        fgets(buffer, 30, fp1);
                        fclose(fp1);
                        system("rm -f /tmp/ifconfig_mask");
                        return websWrite(wp, buffer);
                }
        }
        else if ( !strcmp(name, T("get_gw_ifconfig"))) {
                FILE *fp1 = NULL;;
                #ifdef __TARGET_BOARD__
                system("route -n | grep ^0.0.0.0 | tr -s \" \" | cut -f 2 -d \" \" > /tmp/ifconfig_gw");
                #else
                system("echo \"Get gw from DHCP server\" > /tmp/ifconfig_gw");
                #endif
                if ((fp1 = fopen("/tmp/ifconfig_gw","r"))!=NULL) {
                        if(fgets(buffer, 30, fp1)){
	                        fclose(fp1);
	                        system("rm -f /tmp/ifconfig_gw");
			}
			else                        
				strcpy(buffer,"0.0.0.0");
printf("%d\n",strlen(buffer));
                        return websWrite(wp, buffer);
                }
        }
#endif

#if defined(_BR6428PNL_)
	else if ( !strcmp(name, T("user_id"))) {

                if ( !apmib_get( MIB_USER_NAME,  (void *)buffer) )
                        return -1;
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
                        CharFilter2(buffer);
#endif
                return websWrite(wp, buffer);
        }

#endif
/*
#ifdef _PROFILE_LIST_
	else if ( !strcmp(name, T("NoweditProfile")) ) {
		sprintf(buffer, "%d", NoweditProfile);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
*/
//************************************ Status and Information ************************************
#ifdef _corega_
   	else if ( !strcmp(name, T("TimeZoneSelected"))) {
		apmib_get( MIB_TIMEZONE_SELECTED, (void *)&intVal);
		sprintf(buffer, "%d", intVal );
		return websWrite(wp, buffer);
	}
#endif
	else if ( !strcmp(name, T("fwVersion")))
	{
		FILE *fp;
		if ((fp = fopen("/etc/version","r"))!=NULL)
		{
			fgets(buffer, 30, fp);
			if(buffer[strlen(buffer)-1]== '\n' )
				buffer[strlen(buffer)-1] ='\0';
			fclose(fp);
				return websWrite(wp, buffer);
		}
		else
		{
			#ifdef _EZVIEW_
			return websWrite(wp, " N/A");
			#else
			return websWrite(wp, "final version");
			#endif
		}
	}
	else if ( !strcmp(name, T("wlMacAddr"))) {
		FILE *fp;
// { Rex For Ralink
		system("ifconfig wlan0 | grep HWaddr > /var/wlMactmp.tmp");
// } End
		system("cut /var/wlMactmp.tmp -b 39-55 > /var/wlMac.tmp");
		if ((fp = fopen("/var/wlMac.tmp","r"))!=NULL) {
			fgets(buffer, 30, fp);
			fclose(fp);
			system("rm -f /var/wlMactmp.tmp /var/wlMac.tmp");
   			return websWrite(wp, buffer);
		}else {
   			return websWrite(wp, "00:50:fc:00:50:fc");
		}
	}
//*********************************************Read e2p value****kyle*****************************
	else if ( !strcmp(name, T("readE2P"))) {

		FILE *fp;
		char buf[100];
		sprintf(buf,"");
		if ((fp = fopen("/var/rftest2","r"))!=NULL) {
			fgets(buf, 100, fp);
			//printf("buffer= %s",buf);
			fclose(fp);

   			return websWrite(wp,T("%s"),buf);
		}else {
   			return websWrite(wp, T("%s"), "");
		}
	}
//*********************************************TX1 TX2 Aband Gain*****kyle 2008 *****************************
	else if ( !strcmp(name, T("AbnadTx1Gain"))) {
		#ifdef _DBAND_
			system("/bin/rftest_old.sh READABANDTX1");
			FILE *fp;
			char buf[200];
			sprintf(buf,"");
			if ((fp = fopen("/var/rftest","r"))!=NULL) {
				fgets(buf, 200, fp);
				//printf("buffer= %s",buf);
				fclose(fp);

	   			return websWrite(wp,T("%s"),buf);
			}else {
	   			return websWrite(wp, T("%s"), "error");
			}
		#else
				return websWrite(wp, T("%s"), "\"\"");
		#endif
	}
	else if ( !strcmp(name, T("AbnadTx2Gain"))) {
		#ifdef _DBAND_
			system("/bin/rftest_old.sh READABANDTX2");
			FILE *fp;
			char buf[200];
			sprintf(buf,"");
			if ((fp = fopen("/var/rftest","r"))!=NULL) {
				fgets(buf, 200, fp);
				//printf("buffer2= %s",buf);
				fclose(fp);

	   			return websWrite(wp,T("%s"),buf);
			}else {
	   			return websWrite(wp, T("%s"), "error");
			}
		#else
				return websWrite(wp, T("%s"), "\"\"");
		#endif
	}
//*********************************************TX1 TX2 Gain*****kyle*****************************

	else if ( !strcmp(name, T("tx1Gain"))) {
		system("/bin/rftest_old.sh READTX1");
		FILE *fp;
		char buf[100];
		sprintf(buf,"");
		if ((fp = fopen("/var/rftest","r"))!=NULL) {
			fgets(buf, 100, fp);
			//printf("buffer= %s",buf);
			fclose(fp);

   			return websWrite(wp,T("%s"),buf);
		}else {
   			return websWrite(wp, T("%s"), "error");
		}
	}
	else if ( !strcmp(name, T("tx2Gain"))) {
		system("/bin/rftest_old.sh READTX2");
		FILE *fp;
		char buf[100];
		sprintf(buf,"");
		if ((fp = fopen("/var/rftest","r"))!=NULL) {
			fgets(buf, 100, fp);
			//printf("buffer2= %s",buf);
			fclose(fp);

   			return websWrite(wp,T("%s"),buf);
		}else {
   			return websWrite(wp, T("%s"), "error");
		}
	}
	else if ( !strcmp(name, T("e2pDE"))) {
		system("iwpriv ra0 e2p DE | grep :0x | cut -f 2 -d : |  cut -b 3-6 > /var/rftest");
		FILE *fp;
		char buf[100];
		if ((fp = fopen("/var/rftest","r"))!=NULL) {
			fgets(buf, 100, fp);
			//printf("buffer2= %s",buf);
			fclose(fp);

   			return websWrite(wp,T("%s"),buf);
		}else {
   			return websWrite(wp, T("%s"), "error");
		}
	}
	else if ( !strcmp(name, T("e2pE2"))) {
		system("iwpriv ra0 e2p E2 | grep :0x | cut -f 2 -d : |  cut -b 3-6 > /var/rftest");
		FILE *fp;
		char buf[100];
		if ((fp = fopen("/var/rftest","r"))!=NULL) {
			fgets(buf, 100, fp);
			//printf("buffer2= %s",buf);
			fclose(fp);

   			return websWrite(wp,T("%s"),buf);
		}else {
   			return websWrite(wp, T("%s"), "error");
		}
	}
	else if ( !strcmp(name, T("e2pEB"))) {
		system("iwpriv ra0 e2p EA | grep :0x | cut -f 2 -d : |  cut -b 3-6 > /var/rftest");
		FILE *fp;
		char buf[100];
		if ((fp = fopen("/var/rftest","r"))!=NULL) {
			fgets(buf, 100, fp);
			//printf("buffer2= %s",buf);
			fclose(fp);

   			return websWrite(wp,T("%s"),buf);
		}else {
   			return websWrite(wp, T("%s"), "error");
		}
	}
//*********************************************LINK Status*****kyle 2007/11/29********************
	else if ( !strcmp(name, T("lanLinkStatus"))) {
			system("/bin/linkdetect.sh lan > var/linkStatus.var");
		FILE *fp;
		char buf[100];
		if ((fp = fopen("/var/linkStatus.var","r"))!=NULL) {
				while (fgets(buf, 100, fp) > 0){
					websWrite(wp, T("%s"), buf);

				}
				fclose(fp);
   			return websWrite(wp,T(""),buf);
		}else {
   			return websWrite(wp, T("%s"), "var Port0=0 \n var Port1=0 \n var Port2=0 \n Port3=0 \n Port4=0");
		}
	}

//*********************************************Net Name Scan*****kyle*****************************

	else if ( !strcmp(name, T("netNameScan"))) {
				FILE *fp;
		char buf[100];
		char command[100];
		char lanIP[30];
		int readsize=0;

		#ifdef __TARGET_BOARD__
			if ( getInAddr(BRIDGE_IF, IP_ADDR, (void *)&intaddr ) )
				sprintf(lanIP, "%s", inet_ntoa(intaddr) );
			else
				sprintf(lanIP, "%s", "0.0.0.0" );

			int i=strlen(lanIP);
			while(lanIP[i]!='.') i--;
			lanIP[i]='\0';

			sprintf(command,"/bin/nbtscan -a -r %s.1-50/24 > /var/netName.var",lanIP); system(command);
			sprintf(command,"/bin/nbtscan -a -r %s.51-100/24 >> /var/netName.var",lanIP); system(command);
			sprintf(command,"/bin/nbtscan -a -r %s.101-150/24 >> /var/netName.var",lanIP); system(command);
			sprintf(command,"/bin/nbtscan -a -r %s.151-200/24 >> /var/netName.var",lanIP); system(command);
			sprintf(command,"/bin/nbtscan -a -r %s.201-254/24 >> /var/netName.var",lanIP); system(command);
		//system("/bin/nbtscan -a -r 192.168.2.0/24 > /var/netName.var");
		#else
			system("../../nbtscan-1.5.1a/nbtscan -a -r 192.168.2.0/24 > netName.var");
		#endif

		#ifdef __TARGET_BOARD__
			if ((fp = fopen("/var/netName.var","r"))!=NULL) {
		#else
			if ((fp = fopen("netName.var","r"))!=NULL) {
		#endif

				while (fgets(buf, 100, fp) > 0){
					websWrite(wp, T("%s"), buf);

				}

			//readsize=fread(buf,1,15000, fp);
			//printf("readsize=%d,buffer= %s",readsize,buf);

				fclose(fp);

   			return websWrite(wp,T(""),buf);
		}else {
   			return websWrite(wp, T("%s"), "Null");
		}
	}

//********************************For refresh***************************************
	else if ( !strcmp(name, T("netRefreshScan")))
	{
		FILE *fp;
		char buf[100];
		char buf1[100];
		char lanIP[30];
		struct in_addr intaddr;
		#ifdef __TARGET_BOARD__
			if ((fp = fopen("/var/netName.var","r"))!=NULL)
			{
		#else
			if ((fp = fopen("netName.var","r"))!=NULL)
			{
		#endif
				if ( getInAddr(BRIDGE_IF, IP_ADDR, (void *)&intaddr )) sprintf(lanIP, "%s", inet_ntoa(intaddr) );
				else if ( getInAddr("eth0", IP_ADDR, (void *)&intaddr )) sprintf(lanIP, "%s", inet_ntoa(intaddr));
				else sprintf(lanIP, "0.0.0.0");


				sprintf(buf1,"new Array(\"%s\",",lanIP);
				system(lanIP);
				while(fgets(buf, 100, fp) > 0 )
				{
					if( strncmp(buf,buf1,strlen(buf1)) )
					websWrite(wp, T("%s"), buf);
				}

				fclose(fp);

   			return websWrite(wp,T(""),buf);
			}
			else
			{
   			return websWrite(wp, T(""));
			}
	}
//*******************************End Net Name Scan*****kyle*************************
#if defined(_AUTO_WAN_PROB_)
	else if ( !strcmp(name, T("getWanProbState"))) {
		FILE *fp;
		char buf[50];
		sprintf(buf,"WANTYPE=\"STATIC\"");
		#ifdef __TARGET_BOARD__
			if ((fp = fopen("/var/wanprob.var","r"))!=NULL) {
				fgets(buf, 100, fp);
			}
		#else
			sprintf(buf,"WANTYPE=\"STATIC\"");
		#endif

		return websWrite(wp,T("%s"),buf);
	}
#endif
//*****************Function Defined . Add by Kyle 2008.01.25****************************
	else if ( !strcmp(name, T("getDefined"))) {
				FILE *fp;
		char buf[100];
		char buf2[100];
		char *buf3;
		int i;
		#ifdef __TARGET_BOARD__
			if ((fp = fopen("/web/FUNCTION_SCRIPT","r"))!=NULL) {
		#else
			//if ((fp = fopen("../../../define/FUNCTION_SCRIPT","r"))!=NULL) {
			if ((fp = fopen("/FUNCTION_SCRIPT","r"))!=NULL) {
		#endif
				while (fgets(buf, 100, fp) > 0)
				{
					strcpy(buf2, "var ");
					strcat(buf2,strtok (buf,"="));
					buf3=strtok (NULL,"\n");

					if(buf3[0]=='\"')	strcat(buf2,"=");
					else			strcat(buf2,"=\"");

					strcat(buf2,buf3);

					if(buf3[strlen(buf3)-1]=='\"')	strcat(buf2,";");
					else				strcat(buf2,"\";");
//					strcat(buf2,"=\"");
//					strcat(buf2,strtok (NULL,"\n"));
//					strcat(buf2,"\";");
					websWrite(wp, T("%s\n"), buf2);
				}

			//readsize=fread(buf,1,15000, fp);
			//printf("readsize=%d,buffer= %s",readsize,buf);

				fclose(fp);
   			return websWrite(wp,T(""),buf);
		}else {
   			return websWrite(wp, T("%s"), "Null");
		}
	}


//*****************Function Defined END *************************************************


//*****************Country Code *************************************************

  else if ( !strcmp(name, T("getCountryCode"))) {
  	#ifdef _DFS_
			if ( !apmib_get( MIB_HW_COUNTRY_CODE,  (void *)buffer) )
				return websWrite(wp, T("%s"),  "\"\"");
			return websWrite(wp, T("%s"), buffer);
		#else
			return websWrite(wp, T("%s"),  "\"\"");
		#endif
	}


//************************************ ddns status *********************************
	else if ( !strcmp(name, T("ddnsStatus"))) {

		FILE *fp;
		char buf[100];
		int val=0;
		int val2=0;
		if(!apmib_get(MIB_DDNS_ENABLE, (void *)&val2))
			 val2=0;

		if ( val2 != 0 && ((fp = fopen("/var/ddnsstatus.var","r"))!=NULL)) {
			if ( !apmib_get( MIB_DDNS_STATUS, (void *)&val) )
				val=0;
			printf("debug val=%d",val);
				if (val==1){
					sleep(11);
					val=0;
					apmib_set(MIB_DDNS_STATUS, (void *)&val);
					apmib_update(CURRENT_SETTING);

				}
			fgets(buf, 100, fp);
			fclose(fp);



   			return websWrite(wp,T("%s"),buf);
		}else {
   			return websWrite(wp, T("%s"), "unConnection. ");
		}
	}

//************************************ station of wireless *************************************
#ifndef HOME_GATEWAY
 	else if ( !strcmp(name, T("staPsk"))) {
		int i;
		buffer[0]='\0';
		if ( !apmib_get(MIB_STA_WPA_PSK,  (void *)buffer) )
			return -1;
		for (i=0; i<strlen(buffer); i++)
			buffer[i]='*';
		buffer[i]='\0';
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("identity"))) {
		if ( !apmib_get( MIB_STA_ID,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
   	else if ( !strcmp(name, T("md5Pass"))) {
		if ( !apmib_get( MIB_STA_PASS,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
   	else if ( !strcmp(name, T("eapId"))) {
		if ( !apmib_get( MIB_STA_EAP_ID,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
   	else if ( !strcmp(name, T("eapPass"))) {
		if ( !apmib_get( MIB_STA_EAP_PASS,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
   	else if ( !strcmp(name, T("cltPass"))) {
		if ( !apmib_get( MIB_STA_CLIENT_PASS,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
   	else if ( !strcmp(name, T("serPass"))) {
		if ( !apmib_get( MIB_STA_SERVER_PASS,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
   	else if ( !strcmp(name, T("staProto"))) {
		if ( !apmib_get( MIB_STA_PROTOCOL,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("staRts"))) {
		if ( !apmib_get( MIB_STA_RTS, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("staFrag"))) {
		if ( !apmib_get( MIB_STA_FRAGMENT, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
#endif
//************************************ Wireless basic Setting *************************************
	else if ( !strcmp(name, T("name")) ) {
		buffer[0]='\0';
#ifdef HOME_GATEWAY
#if defined(_PRODUCT_NAME_)
	sprintf(buffer,"%s",_PRODUCT_NAME_);
#else
	ProductName_is_not_defined_Please_see_Set_App_Defined
#endif
//#else
//		if ( !apmib_get( MIB_ALIAS_NAME,  (void *)buffer) )
//			return -1;
#endif
		return websWrite(wp, T("%s"), buffer);
	}
   	else if ( !strcmp(name, T("ssid"))) {

		if ( !apmib_get( MIB_WLAN_SSID,  (void *)buffer) )
			return -1;
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
			CharFilter2(buffer);
#endif
#if defined(_Customer_SC_)
		//Felix add , thomas suggestion, tommy say that it is OK
		if ( strcmp(buffer, T("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"))) {
			return websWrite(wp, buffer);
		}
#else
		return websWrite(wp, buffer);
#endif
	}
#ifdef _DALGFTP_
	else if ( !strcmp(name, T("algPorts")) ) {
		if ( !apmib_get( MIB_ALG_FTP_PORTS, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal);
		return websWrite(wp, buffer);
	}
#endif
	else if ( !strcmp(name, T("vlanidAll")) ) {
		int val;
		#if defined(_ENVLAN_) && defined(_MSSID_)
		apmib_get( MIB_WLAN_VLANID_1, (void *)&val);		websWrite(wp, T("new Array(\"%d\","), val);
		apmib_get( MIB_WLAN_VLANID_2, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_VLANID_3, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_VLANID_4, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_VLANID_5, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_VLANID_6, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_VLANID_7, (void *)&val);		websWrite(wp, T("\"%d\")"), val);
		#else
		websWrite(wp, T("\"%s\""), "");
		#endif
		return 0;
	}
	else if ( !strcmp(name, T("txrateAll")) ) {
		#ifdef _MSSID_
		list_value(
			wp,8,
			MIB_WLAN_FIX_RATE,MIB_WLAN_FIX_RATE_1,MIB_WLAN_FIX_RATE_2,MIB_WLAN_FIX_RATE_3,
			MIB_WLAN_FIX_RATE_4,MIB_WLAN_FIX_RATE_5,MIB_WLAN_FIX_RATE_6,MIB_WLAN_FIX_RATE_7,
			0
		);
		#else
		int val;
		apmib_get( MIB_WLAN_FIX_RATE, (void *)&val);		websWrite(wp, T("new Array(\"%d\")"), val);
		#endif
		return 0;
	}
	else if ( !strcmp(name, T("WmmCapableAll")) ) {
		int val;
		#ifdef _MSSID_
		apmib_get( MIB_WLAN_WMM, (void *)&val);		websWrite(wp, T("new Array(\"%d\","), val);
		apmib_get( MIB_WLAN_WMM_1, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WMM_2, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WMM_3, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WMM_4, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WMM_5, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WMM_6, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WMM_7, (void *)&val);		websWrite(wp, T("\"%d\")"), val);
		#else
		apmib_get( MIB_WLAN_WMM, (void *)&val);		websWrite(wp, T("new Array(\"%d\")"), val);
		#endif
		return 0;
	}
	else if ( !strcmp(name, T("hiddenSSIDAll")) ) {
		int val;
		#ifdef _MSSID_
		apmib_get( MIB_WLAN_HIDDEN_SSID, (void *)&val);		websWrite(wp, T("new Array(\"%d\","), val);
		apmib_get( MIB_WLAN_HIDDEN_SSID_1, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_HIDDEN_SSID_2, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_HIDDEN_SSID_3, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_HIDDEN_SSID_4, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_HIDDEN_SSID_5, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_HIDDEN_SSID_6, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_HIDDEN_SSID_7, (void *)&val);		websWrite(wp, T("\"%d\")"), val);
		#else
		apmib_get( MIB_WLAN_HIDDEN_SSID, (void *)&val);		websWrite(wp, T("new Array(\"%d\")"), val);
		#endif
		return 0;
	}
	else if ( !strcmp(name, T("ssidMirrorAll")) ) {
		int val;
		#ifdef _MSSID_
		apmib_get( MIB_WLAN_SSID_MIRROR_1, (void *)&val);		websWrite(wp, T("new Array(\"%d\","), val);
		apmib_get( MIB_WLAN_SSID_MIRROR_2, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_SSID_MIRROR_3, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_SSID_MIRROR_4, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_SSID_MIRROR_5, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_SSID_MIRROR_6, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_SSID_MIRROR_7, (void *)&val);		websWrite(wp, T("\"%d\")"), val);
		#else
		websWrite(wp, T("\"%s\""), "");
		#endif
		return 0;
	}
	else if ( !strcmp(name, T("defaultKeyIdAll")) ) {
		int val;
#ifdef _MSSID_
		apmib_get( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&val);		websWrite(wp, T("new Array(\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_DEFAULT_KEY_1, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_DEFAULT_KEY_2, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_DEFAULT_KEY_3, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_DEFAULT_KEY_4, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_DEFAULT_KEY_5, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_DEFAULT_KEY_6, (void *)&val);		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_DEFAULT_KEY_7, (void *)&val);		websWrite(wp, T("\"%d\")"), val);
#else
		apmib_get( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&val);		websWrite(wp, T("new Array(\"%d\")"), val);
#endif
		return 0;
	}

 	else if ( !strcmp(name, T("pskValueAll"))) {
#ifdef _MSSID_
		apmib_get(MIB_WLAN_WPA_PSK,  (void *)buffer);	CharFilter2(buffer);	websWrite(wp, T("new Array(\"%s\","), buffer);
		apmib_get(MIB_WLAN_WPA_PSK_1,  (void *)buffer);	CharFilter2(buffer);		websWrite(wp, T("\"%s\","), buffer);
		apmib_get(MIB_WLAN_WPA_PSK_2,  (void *)buffer);	CharFilter2(buffer);		websWrite(wp, T("\"%s\","), buffer);
		apmib_get(MIB_WLAN_WPA_PSK_3,  (void *)buffer);	CharFilter2(buffer);		websWrite(wp, T("\"%s\","), buffer);
		apmib_get(MIB_WLAN_WPA_PSK_4,  (void *)buffer);	CharFilter2(buffer);		websWrite(wp, T("\"%s\","), buffer);
		apmib_get(MIB_WLAN_WPA_PSK_5,  (void *)buffer);	CharFilter2(buffer);		websWrite(wp, T("\"%s\","), buffer);
		apmib_get(MIB_WLAN_WPA_PSK_6,  (void *)buffer);	CharFilter2(buffer);		websWrite(wp, T("\"%s\","), buffer);
		apmib_get(MIB_WLAN_WPA_PSK_7,  (void *)buffer);	CharFilter2(buffer);		websWrite(wp, T("\"%s\")"), buffer);
#else
		apmib_get(MIB_WLAN_WPA_PSK,  (void *)buffer);	CharFilter2(buffer);		websWrite(wp, T("new Array(\"%s\")"), buffer);
#endif
   		return 0;
	}

	else if ( !strcmp(name, T("pskFormatAll"))) {
#ifdef _MSSID_
		list_value
		(
			wp,8,
			MIB_WLAN_WPA_PSK_FORMAT,
			MIB_WLAN_WPA_PSK_FORMAT_1,
			MIB_WLAN_WPA_PSK_FORMAT_2,
			MIB_WLAN_WPA_PSK_FORMAT_3,
			MIB_WLAN_WPA_PSK_FORMAT_4,
			MIB_WLAN_WPA_PSK_FORMAT_5,
			MIB_WLAN_WPA_PSK_FORMAT_6,
			MIB_WLAN_WPA_PSK_FORMAT_7,
			0
		);
#else
		int val;
		apmib_get( MIB_WLAN_WPA_PSK_FORMAT, (void *)&val);		websWrite(wp, T("new Array(\"%d\")"), val);
#endif
		return 0;
	}
#ifdef _MSSID_
	else if ( !strcmp(name, T("VirtualBandAll"))) {
		list_value(wp,_MSSIDNUM_,MIB_WLAN_BAND_1,MIB_WLAN_BAND_2,MIB_WLAN_BAND_3,MIB_WLAN_BAND_4,0);
	}
   else if ( !strcmp(name, T("Virtualwlanaccess"))) {
	   list_value(wp,_MSSIDNUM_,MIB_WLAN_ACCESS_1,MIB_WLAN_ACCESS_2,MIB_WLAN_ACCESS_3,MIB_WLAN_ACCESS_4,0);
    }
#endif
 	else if ( !strcmp(name, T("wepValueAll"))) {
#ifdef _MSSID_
 		int val;
 		apmib_get( MIB_WLAN_WEP_KEY_TYPE, (void *)&val);
 		if (val == 0){
 			memset(buffer, 0, sizeof(buffer));
 	 		apmib_get(MIB_WLAN_WEP64_KEY1,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 	 		websWrite(wp, T("new Array(\"%s\","), buffer);

 	 		memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY2,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY3,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY4,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY1,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY2,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY3,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY4,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);
 		}
 		else{
 			memset(buffer, 0, sizeof(buffer));
 	 		apmib_get(MIB_WLAN_WEP64_KEY1,  (void *)buffer);		websWrite(wp, T("new Array(\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY2,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY3,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY4,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY1,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY2,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY3,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY4,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 		}
 		apmib_get( MIB_WLAN_WEP_KEY_TYPE_1, (void *)&val);
 		if (val == 0){
 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY1_1,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY2_1,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY3_1,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY4_1,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY1_1,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY2_1,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY3_1,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY4_1,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);
 		}
 		else{
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY1_1,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY2_1,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY3_1,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY4_1,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY1_1,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY2_1,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY3_1,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY4_1,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 		}
 		apmib_get( MIB_WLAN_WEP_KEY_TYPE_2, (void *)&val);
		if ( val == 0){
			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY1_2,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY2_2,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY3_2,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY4_2,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY1_2,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY2_2,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY3_2,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY4_2,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);
		}
 		else{
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY1_2,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY2_2,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY3_2,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY4_2,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY1_2,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY2_2,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY3_2,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY4_2,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
		}
 		apmib_get( MIB_WLAN_WEP_KEY_TYPE_3, (void *)&val);
 		if (val == 0){
 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY1_3,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY2_3,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY3_3,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY4_3,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY1_3,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY2_3,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY3_3,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY4_3,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);
 		}
 		else{
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY1_3,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY2_3,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY3_3,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY4_3,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY1_3,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY2_3,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY3_3,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY4_3,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 		}
		apmib_get( MIB_WLAN_WEP_KEY_TYPE_4, (void *)&val);
		if ( val == 0){
			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY1_4,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY2_4,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY3_4,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY4_4,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY1_4,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY2_4,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY3_4,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY4_4,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);
		}
		else{
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY1_4,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY2_4,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY3_4,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY4_4,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY1_4,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY2_4,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY3_4,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY4_4,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
		}
 		apmib_get( MIB_WLAN_WEP_KEY_TYPE_5, (void *)&val);
 		if (val == 0){
 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY1_5,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY2_5,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY3_5,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY4_5,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY1_5,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY2_5,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY3_5,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY4_5,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);
 		}
 		else{
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY1_5,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY2_5,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY3_5,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY4_5,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY1_5,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY2_5,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY3_5,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY4_5,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 		}
 		apmib_get( MIB_WLAN_WEP_KEY_TYPE_6, (void *)&val);
 		if (val == 0){
 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY1_6,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY2_6,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY3_6,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY4_6,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY1_6,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY2_6,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY3_6,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY4_6,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);
 		}
 		else{
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY1_6,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY2_6,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY3_6,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY4_6,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY1_6,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY2_6,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY3_6,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY4_6,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 		}
 		apmib_get( MIB_WLAN_WEP_KEY_TYPE_7, (void *)&val);
 		if (val == 0){
 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY1_7,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY2_7,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY3_7,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP64_KEY4_7,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY1_7,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY2_7,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY3_7,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\","), buffer);

 			memset(buffer, 0, sizeof(buffer));
 			apmib_get(MIB_WLAN_WEP128_KEY4_7,  (void *)buffer);
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
 	 		CharFilter2(buffer);
#endif
 			websWrite(wp, T("\"%s\")"), buffer);
 		}
 		else{
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY1_7,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY2_7,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY3_7,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP64_KEY4_7,  (void *)buffer);		websWrite(wp, T("\"%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY1_7,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY2_7,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY3_7,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 			sprintf(buffer,"");
 			apmib_get(MIB_WLAN_WEP128_KEY4_7,  (void *)buffer);	websWrite(wp, T("\"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\","), buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10],buffer[11],buffer[12]);
 		}
//		#endif
#else
		apmib_get(MIB_WLAN_WEP64_KEY1,  (void *)buffer);			websWrite(wp, T("new Array(\"%s\","), buffer);
		sprintf(buffer,"");
		apmib_get(MIB_WLAN_WEP64_KEY2,  (void *)buffer);			websWrite(wp, T("\"%s\","), buffer);
		sprintf(buffer,"");
		apmib_get(MIB_WLAN_WEP64_KEY3,  (void *)buffer);			websWrite(wp, T("\"%s\","), buffer);
		sprintf(buffer,"");
		apmib_get(MIB_WLAN_WEP64_KEY4,  (void *)buffer);			websWrite(wp, T("\"%s\","), buffer);
		sprintf(buffer,"");
		apmib_get(MIB_WLAN_WEP128_KEY1,  (void *)buffer);		websWrite(wp, T("\"%s\","), buffer);
		sprintf(buffer,"");
		apmib_get(MIB_WLAN_WEP128_KEY2,  (void *)buffer);		websWrite(wp, T("\"%s\","), buffer);
		sprintf(buffer,"");
		apmib_get(MIB_WLAN_WEP128_KEY3,  (void *)buffer);		websWrite(wp, T("\"%s\","), buffer);
		sprintf(buffer,"");
		apmib_get(MIB_WLAN_WEP128_KEY4,  (void *)buffer);		websWrite(wp, T("\"%s\")"), buffer);
		sprintf(buffer,"");
#endif
   		return 0;

 	}
	else if ( !strcmp(name, T("wpaCipherAll"))) {
		int iTkip, iAes;
#if defined(_Customer_EX_) || defined(_Customer_SA_)
                apmib_get( MIB_WLAN_WPA_CIPHER_SUITE, (void *)&iTkip);          apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&iAes);
                websWrite(wp, T("new Array(\"%d\","), (iAes+iTkip)/2);
                apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_1, (void *)&iTkip);        apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_1, (void *)&iAes);
                websWrite(wp, T("\"%d\","), (iAes+iTkip)/2);
                apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_2, (void *)&iTkip);        apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_2, (void *)&iAes);
                websWrite(wp, T("\"%d\","), (iAes+iTkip)/2);
                apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_3, (void *)&iTkip);        apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_3, (void *)&iAes);
                websWrite(wp, T("\"%d\","), (iAes+iTkip)/2);
                apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_4, (void *)&iTkip);        apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_4, (void *)&iAes);
                websWrite(wp, T("\"%d\","), (iAes+iTkip)/2);
                apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_5, (void *)&iTkip);        apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_5, (void *)&iAes);
                websWrite(wp, T("\"%d\","), (iAes+iTkip)/2);
                apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_6, (void *)&iTkip);        apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_6, (void *)&iAes);
                websWrite(wp, T("\"%d\","), (iAes+iTkip)/2);
                apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_7, (void *)&iTkip);        apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_7, (void *)&iAes);
                websWrite(wp, T("\"%d\")"), (iAes+iTkip)/2);
#else	//!defined(_Customer_EX_) || defined(_Customer_SA_)
		apmib_get( MIB_WLAN_WPA_CIPHER_SUITE, (void *)&iTkip);		apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&iAes);
#ifdef _MSSID_
		websWrite(wp, T("new Array(\"%d\","), iAes+iTkip);
		apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_1, (void *)&iTkip);	apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_1, (void *)&iAes);
		websWrite(wp, T("\"%d\","), iAes+iTkip);
		apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_2, (void *)&iTkip);	apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_2, (void *)&iAes);
		websWrite(wp, T("\"%d\","), iAes+iTkip);
		apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_3, (void *)&iTkip);	apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_3, (void *)&iAes);
		websWrite(wp, T("\"%d\","), iAes+iTkip);
		apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_4, (void *)&iTkip);	apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_4, (void *)&iAes);
		websWrite(wp, T("\"%d\","), iAes+iTkip);
		apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_5, (void *)&iTkip);	apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_5, (void *)&iAes);
		websWrite(wp, T("\"%d\","), iAes+iTkip);
		apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_6, (void *)&iTkip);	apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_6, (void *)&iAes);
		websWrite(wp, T("\"%d\","), iAes+iTkip);
		apmib_get( MIB_WLAN_WPA_CIPHER_SUITE_7, (void *)&iTkip);	apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE_7, (void *)&iAes);
		websWrite(wp, T("\"%d\")"), iAes+iTkip);
#else
		websWrite(wp, T("new Array(\"%d\")"), iAes+iTkip);
#endif
#endif	//defined(_Customer_EX_) || defined(_Customer_SA_)
		return 0;
	}

	else if ( !strcmp(name, T("keyTypeAll"))) {
		int val;
		apmib_get( MIB_WLAN_WEP_KEY_TYPE, (void *)&val);
#ifdef _MSSID_
		websWrite(wp, T("new Array(\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_KEY_TYPE_1, (void *)&val);
		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_KEY_TYPE_2, (void *)&val);
		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_KEY_TYPE_3, (void *)&val);
		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_KEY_TYPE_4, (void *)&val);
		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_KEY_TYPE_5, (void *)&val);
		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_KEY_TYPE_6, (void *)&val);
		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_WEP_KEY_TYPE_7, (void *)&val);
		websWrite(wp, T("\"%d\")"), val);
#else
		websWrite(wp, T("new Array(\"%d\")"), val);
#endif
		return 0;
	}
#ifdef _BR6428PNL_
        else if ( !strcmp(name, T("secModeAll"))) {
	        int val,val_1;
                apmib_get( MIB_SECURITY_MODE,  (void *)&val);

                if( val == 0 ){	//Disable
                        apmib_get( MIB_WLAN_ENABLE_1X, (void *)&val_1);
			if (val_1 != 0)	//802.1X
				val=10;
                }
		else if ( val == 1 ){	//WEP
			apmib_get( MIB_WLAN_AUTH_TYPE, (void *)&val_1);
			if (val_1 == 0)	//Open
				val=1;
			else if (val_1 == 1)	//Share
				val=2;
			else if (val_1 == 2)	//Auto
				val=3;
		}
		else if ( val == 2 ) {	//WPA-PSK,WPA2-PSK,MIX
			apmib_get( MIB_WLAN_ENCRYPT, (void *)&val_1);
			if(val_1 == 2)	//WPA-PSK
				val=5;
                        else if(val_1 == 4)	//WPA2-PSK
                                val=7;
                        else if(val_1 == 6)	//Mix
                                val=8;
		}
		else if ( val == 3 ) {	//WPA,WPA2,MIX
                        apmib_get( MIB_WLAN_ENCRYPT, (void *)&val_1);
                        if(val_1 == 2)	//WPA
                                val=4;
                        else if(val_1 == 4)
                                val=6;
                        else if(val_1 == 6)
                                val=9;
		}
#ifdef _MSSID_  //Walter Modify
                websWrite(wp, T("new Array(\"%d\","), val);

                apmib_get( MIB_SECURITY_MODE_1,  (void *)&val) ;
                if( val == 0 ){ //Disable
                        apmib_get( MIB_WLAN_ENABLE_1X_1, (void *)&val_1);
                        if (val_1 != 0) //802.1X
                                val=10;
                }
                else if ( val == 1 ){   //WEP
                        apmib_get( MIB_WLAN_AUTH_TYPE_1, (void *)&val_1);
                        if (val_1 == 0) //Open
                                val=1;
                        else if (val_1 == 1)    //Share
                                val=2;
                        else if (val_1 == 2)    //Auto
                                val=3;
                }
                else if ( val == 2 ) {  //WPA-PSK,WPA2-PSK,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_1, (void *)&val_1);
                        if(val_1 == 2)  //WPA-PSK
                                val=5;
                        else if(val_1 == 4)     //WPA2-PSK
                                val=7;
                        else if(val_1 == 6)     //Mix
                                val=8;
                }
                else if ( val == 3 ) {  //WPA,WPA2,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_1, (void *)&val_1);
                        if(val_1 == 2)  //WPA
                                val=4;
                        else if(val_1 == 4)
                                val=6;
                        else if(val_1 == 6)
                                val=9;
                }
                websWrite(wp, T("\"%d\","), val);

                apmib_get( MIB_SECURITY_MODE_2,  (void *)&val) ;
                if( val == 0 ){ //Disable
                        apmib_get( MIB_WLAN_ENABLE_1X_2, (void *)&val_1);
                        if (val_1 != 0) //802.1X
                                val=10;
                }
                else if ( val == 1 ){   //WEP
                        apmib_get( MIB_WLAN_AUTH_TYPE_2, (void *)&val_1);
                        if (val_1 == 0) //Open
                                val=1;
                        else if (val_1 == 1)    //Share
                                val=2;
                        else if (val_1 == 2)    //Auto
                                val=3;
                }
                else if ( val == 2 ) {  //WPA-PSK,WPA2-PSK,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_2, (void *)&val_1);
                        if(val_1 == 2)  //WPA-PSK
                                val=5;
                        else if(val_1 == 4)     //WPA2-PSK
                                val=7;
                        else if(val_1 == 6)     //Mix
                                val=8;
                }
                else if ( val == 3 ) {  //WPA,WPA2,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_2, (void *)&val_1);
                        if(val_1 == 2)  //WPA
                                val=4;
                        else if(val_1 == 4)
                                val=6;
                        else if(val_1 == 6)
                                val=9;
                }
                websWrite(wp, T("\"%d\","), val);

                apmib_get( MIB_SECURITY_MODE_3,  (void *)&val) ;
                if( val == 0 ){ //Disable
                        apmib_get( MIB_WLAN_ENABLE_1X_3, (void *)&val_1);
                        if (val_1 != 0) //802.1X
                                val=10;
                }
                else if ( val == 1 ){   //WEP
                        apmib_get( MIB_WLAN_AUTH_TYPE_3, (void *)&val_1);
                        if (val_1 == 0) //Open
                                val=1;
                        else if (val_1 == 1)    //Share
                                val=2;
                        else if (val_1 == 2)    //Auto
                                val=3;
                }
                else if ( val == 2 ) {  //WPA-PSK,WPA2-PSK,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_3, (void *)&val_1);
                        if(val_1 == 2)  //WPA-PSK
                                val=5;
                        else if(val_1 == 4)     //WPA2-PSK
                                val=7;
                        else if(val_1 == 6)     //Mix
                                val=8;
                }
                else if ( val == 3 ) {  //WPA,WPA2,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_3, (void *)&val_1);
                        if(val_1 == 2)  //WPA
                                val=4;
                        else if(val_1 == 4)
                                val=6;
                        else if(val_1 == 6)
                                val=9;
                }
                websWrite(wp, T("\"%d\","), val);

                apmib_get( MIB_SECURITY_MODE_4,  (void *)&val) ;
                if( val == 0 ){ //Disable
                        apmib_get( MIB_WLAN_ENABLE_1X_4, (void *)&val_1);
                        if (val_1 != 0) //802.1X
                                val=10;
                }
                else if ( val == 1 ){   //WEP
                        apmib_get( MIB_WLAN_AUTH_TYPE_4, (void *)&val_1);
                        if (val_1 == 0) //Open
                                val=1;
                        else if (val_1 == 1)    //Share
                                val=2;
                        else if (val_1 == 2)    //Auto
                                val=3;
                }
                else if ( val == 2 ) {  //WPA-PSK,WPA2-PSK,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_4, (void *)&val_1);
                        if(val_1 == 2)  //WPA-PSK
                                val=5;
                        else if(val_1 == 4)     //WPA2-PSK
                                val=7;
                        else if(val_1 == 6)     //Mix
                                val=8;
                }
                else if ( val == 3 ) {  //WPA,WPA2,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_4, (void *)&val_1);
                        if(val_1 == 2)  //WPA
                                val=4;
                        else if(val_1 == 4)
                                val=6;
                        else if(val_1 == 6)
                                val=9;
                }
                websWrite(wp, T("\"%d\","), val);

                apmib_get( MIB_SECURITY_MODE_5, (void *)&val) ;
                if( val == 0 ){ //Disable
                        apmib_get( MIB_WLAN_ENABLE_1X_5, (void *)&val_1);
                        if (val_1 != 0) //802.1X
                                val=10;
                }
                else if ( val == 1 ){   //WEP
                        apmib_get( MIB_WLAN_AUTH_TYPE_5, (void *)&val_1);
                        if (val_1 == 0) //Open
                                val=1;
                        else if (val_1 == 1)    //Share
                                val=2;
                        else if (val_1 == 2)    //Auto
                                val=3;
                }
                else if ( val == 2 ) {  //WPA-PSK,WPA2-PSK,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_5, (void *)&val_1);
                        if(val_1 == 2)  //WPA-PSK
                                val=5;
                        else if(val_1 == 4)     //WPA2-PSK
                                val=7;
                        else if(val_1 == 6)     //Mix
                                val=8;
                }
                else if ( val == 3 ) {  //WPA,WPA2,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_5, (void *)&val_1);
                        if(val_1 == 2)  //WPA
                                val=4;
                        else if(val_1 == 4)
                                val=6;
                        else if(val_1 == 6)
                                val=9;
                }
                websWrite(wp, T("\"%d\","), val);

                apmib_get( MIB_SECURITY_MODE_6,  (void *)&val) ;
                if( val == 0 ){ //Disable
                        apmib_get( MIB_WLAN_ENABLE_1X_1, (void *)&val_1);
                        if (val_1 != 0) //802.1X
                                val=10;
                }
                else if ( val == 1 ){   //WEP
                        apmib_get( MIB_WLAN_AUTH_TYPE_1, (void *)&val_1);
                        if (val_1 == 0) //Open
                                val=1;
                        else if (val_1 == 1)    //Share
                                val=2;
                        else if (val_1 == 2)    //Auto
                                val=3;
                }
                else if ( val == 2 ) {  //WPA-PSK,WPA2-PSK,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_1, (void *)&val_1);
                        if(val_1 == 2)  //WPA-PSK
                                val=5;
                        else if(val_1 == 4)     //WPA2-PSK
                                val=7;
                        else if(val_1 == 6)     //Mix
                                val=8;
                }
                else if ( val == 3 ) {  //WPA,WPA2,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_1, (void *)&val_1);
                        if(val_1 == 2)  //WPA
                                val=4;
                        else if(val_1 == 4)
                                val=6;
                        else if(val_1 == 6)
                                val=9;
                }
                websWrite(wp, T("\"%d\","), val);

                apmib_get( MIB_SECURITY_MODE_7,  (void *)&val) ;
                if( val == 0 ){ //Disable
                        apmib_get( MIB_WLAN_ENABLE_1X_1, (void *)&val_1);
                        if (val_1 != 0) //802.1X
                                val=10;
                }
                else if ( val == 1 ){   //WEP
                        apmib_get( MIB_WLAN_AUTH_TYPE_1, (void *)&val_1);
                        if (val_1 == 0) //Open
                                val=1;
                        else if (val_1 == 1)    //Share
                                val=2;
                        else if (val_1 == 2)    //Auto
                                val=3;
                }
                else if ( val == 2 ) {  //WPA-PSK,WPA2-PSK,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_1, (void *)&val_1);
                        if(val_1 == 2)  //WPA-PSK
                                val=5;
                        else if(val_1 == 4)     //WPA2-PSK
                                val=7;
                        else if(val_1 == 6)     //Mix
                                val=8;
                }
                else if ( val == 3 ) {  //WPA,WPA2,MIX
                        apmib_get( MIB_WLAN_ENCRYPT_1, (void *)&val_1);
                        if(val_1 == 2)  //WPA
                                val=4;
                        else if(val_1 == 4)
                                val=6;
                        else if(val_1 == 6)
                                val=9;
                }
                websWrite(wp, T("\"%d\")"), val);
#else
                websWrite(wp, T("new Array(\"%d\")"), val);
#endif
                return 0;
        }
#else	//!BR6428PNL
   	else if ( !strcmp(name, T("secModeAll"))) {
   	int val,val_1,val_2;
		apmib_get( MIB_SECURITY_MODE,  (void *)&val) ;
#ifdef _MSSID_	//Walter Modify
		websWrite(wp, T("new Array(\"%d\","), val);

		apmib_get( MIB_SECURITY_MODE_1,  (void *)&val) ;
		websWrite(wp, T("\"%d\","), val);

		apmib_get( MIB_SECURITY_MODE_2,  (void *)&val) ;
		websWrite(wp, T("\"%d\","), val);

		apmib_get( MIB_SECURITY_MODE_3,  (void *)&val) ;
		websWrite(wp, T("\"%d\","), val);

		apmib_get( MIB_SECURITY_MODE_4,  (void *)&val) ;
		websWrite(wp, T("\"%d\","), val);

		apmib_get( MIB_SECURITY_MODE_5,  (void *)buffer) ;
		websWrite(wp, T("\"%d\","), (int)buffer[0]);
		apmib_get( MIB_SECURITY_MODE_6,  (void *)buffer) ;
		websWrite(wp, T("\"%d\","), (int)buffer[0]);
		apmib_get( MIB_SECURITY_MODE_7,  (void *)buffer) ;
		websWrite(wp, T("\"%d\")"), (int)buffer[0]);
#else
		websWrite(wp, T("new Array(\"%d\")"), val);
#endif
		return 0;
	}
#endif

   	else if ( !strcmp(name, T("ssidAll"))) {
		apmib_get( MIB_WLAN_SSID,  (void *)buffer) ;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
					CharFilter2(buffer);
		#endif
#ifdef _MSSID_
		websWrite(wp, T("new Array(\"%s\","), buffer);
		apmib_get( MIB_WLAN_SSID_1,  (void *)buffer) ;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
					CharFilter2(buffer);
		#endif
		websWrite(wp, T("\"%s\","), buffer);
		apmib_get( MIB_WLAN_SSID_2,  (void *)buffer) ;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
					CharFilter2(buffer);
		#endif
		websWrite(wp, T("\"%s\","), buffer);
		apmib_get( MIB_WLAN_SSID_3,  (void *)buffer) ;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
					CharFilter2(buffer);
		#endif
		websWrite(wp, T("\"%s\","), buffer);
		apmib_get( MIB_WLAN_SSID_4,  (void *)buffer) ;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
					CharFilter2(buffer);
		#endif
		websWrite(wp, T("\"%s\","), buffer);
		apmib_get( MIB_WLAN_SSID_5,  (void *)buffer) ;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
					CharFilter2(buffer);
		#endif
		websWrite(wp, T("\"%s\","), buffer);
		apmib_get( MIB_WLAN_SSID_6,  (void *)buffer) ;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
					CharFilter2(buffer);
		#endif
		websWrite(wp, T("\"%s\","), buffer);
		apmib_get( MIB_WLAN_SSID_7,  (void *)buffer) ;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
					CharFilter2(buffer);
		#endif
		websWrite(wp, T("\"%s\")"), buffer);
#else
		websWrite(wp, T("new Array(\"%s\")"), buffer);
#endif
		return 0;
	}

	else if ( !strcmp(name, T("enable1XAll"))) {
		int val;
		apmib_get( MIB_WLAN_ENABLE_1X, (void *)&val);
#ifdef _MSSID_
		websWrite(wp, T("new Array(\"%d\","), val);
		apmib_get( MIB_WLAN_ENABLE_1X_1, (void *)&val);
		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_ENABLE_1X_2, (void *)&val);
		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_ENABLE_1X_3, (void *)&val);
		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_ENABLE_1X_4, (void *)&val);
		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_ENABLE_1X_5, (void *)&val);
		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_ENABLE_1X_6, (void *)&val);
		websWrite(wp, T("\"%d\","), val);
		apmib_get( MIB_WLAN_ENABLE_1X_7, (void *)&val);
		websWrite(wp, T("\"%d\")"), val);
#else
		websWrite(wp, T("new Array(\"%d\")"), val);
#endif
		return 0;
	}

	else if ( !strcmp(name, T("1xMode"))) {
		int val;
		apmib_get( MIB_1X_MODE, (void *)&val);
		websWrite(wp, T("%d"), val);
		return 0;
	}
#if defined(_ENVLAN_)
#if defined _MSSID_
	else if ( !strcmp(name, T("mirr1"))) {
		if ( !apmib_get( MIB_WLAN_SSID_MIRROR_1, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("mirr2"))) {
		if ( !apmib_get( MIB_WLAN_SSID_MIRROR_2, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("mirr3"))) {
		if ( !apmib_get( MIB_WLAN_SSID_MIRROR_3, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("mirr4"))) {
		if ( !apmib_get( MIB_WLAN_SSID_MIRROR_4, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
#endif
#endif

   	else if ( !strcmp(name, T("staSsid"))) {
		if ( !apmib_get( MIB_STA_SSID,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}

#ifdef _7264Wn_
//get adsl status and write to file.
  else if ( !strcmp(name, T("adsl_getStatus_start"))) {
				system("/bin/adsl-command.sh 2");
		return websWrite(wp, T("%s"), " ");
	}
  else if ( !strcmp(name, T("adsl_fwVersion"))) {
		FILE *fp;
		int i;
		if ((fp = fopen("/var/adsl_status.var","r"))!=NULL) {
			for( i=0;i<=0;i++)
				fgets(buffer, 100, fp);



			fclose(fp);
   			return websWrite(wp,T("%s"),buffer);
		}else {
   			return websWrite(wp, T("%s"), " ");
		}
	}
  else if ( !strcmp(name, T("adsl_line_state"))) {
		FILE *fp;
		int i;
		if ((fp = fopen("/var/adsl_status.var","r"))!=NULL) {
			for( i=0;i<=1;i++)
				fgets(buffer, 100, fp);
			fclose(fp);
   			return websWrite(wp,T("%s"),buffer);
		}else {
   			return websWrite(wp, T("%s"), " ");
		}
	}
  else if ( !strcmp(name, T("adsl_snr_dw"))) {
		FILE *fp;
		int i;
		if ((fp = fopen("/var/adsl_status.var","r"))!=NULL) {
			for( i=0;i<=2;i++)
				fgets(buffer, 100, fp);
			fclose(fp);
   			return websWrite(wp,T("%s"),buffer);
		}else {
   			return websWrite(wp, T("%s"), " ");
		}
	}
  else if ( !strcmp(name, T("adsl_snr_up"))) {
		FILE *fp;
		int i;
		if ((fp = fopen("/var/adsl_status.var","r"))!=NULL) {
			for( i=0;i<=3;i++)
				fgets(buffer, 100, fp);
			fclose(fp);
   			return websWrite(wp,T("%s"),buffer);
		}else {
   			return websWrite(wp, T("%s"), " ");
		}
	}
  else if ( !strcmp(name, T("adsl_atten_dw"))) {
		FILE *fp;
		int i;
		if ((fp = fopen("/var/adsl_status.var","r"))!=NULL) {
			for( i=0;i<=4;i++)
				fgets(buffer, 100, fp);
			fclose(fp);
   			return websWrite(wp,T("%s"),buffer);
		}else {
   			return websWrite(wp, T("%s"), " ");
		}
	}
  else if ( !strcmp(name, T("adsl_atten_up"))) {
		FILE *fp;
		int i;
		if ((fp = fopen("/var/adsl_status.var","r"))!=NULL) {
			for( i=0;i<=5;i++)
				fgets(buffer, 100, fp);
			fclose(fp);
   			return websWrite(wp,T("%s"),buffer);
		}else {
   			return websWrite(wp, T("%s"), " ");
		}
	}
  else if ( !strcmp(name, T("adsl_dataRate_dw"))) {
		FILE *fp;
		int i;
		if ((fp = fopen("/var/adsl_status.var","r"))!=NULL) {
			for( i=0;i<=6;i++)
				fgets(buffer, 100, fp);
			fclose(fp);
   			return websWrite(wp,T("%s"),buffer);
		}else {
   			return websWrite(wp, T("%s"), " ");
		}
	}
  else if ( !strcmp(name, T("adsl_dataRate_up"))) {
		FILE *fp;
		int i;
		if ((fp = fopen("/var/adsl_status.var","r"))!=NULL) {
			for(i=0;i<=7;i++)
				fgets(buffer, 100, fp);
			fclose(fp);
   			return websWrite(wp,T("%s"),buffer);
		}else {
   			return websWrite(wp, T("%s"), " ");
		}
	}
#endif
#ifdef _IPN_WL_DEVICE_
	else if ( !strcmp(name, T("ipn_ssid"))) {
		FILE *fp;
		unsigned char ssidBuf[40];
		buffer[0]='\0';
		apmib_get( MIB_AP_MODE, (void *)&intVal);
		if (intVal == 2 || intVal == 1) {
			apmib_get( MIB_STA_SSID, (void *)buffer);
			system("iwconfig ra0 | grep ESSID | cut -f 2 -d\\\" > /tmp/wlstate.tmp");
			fp = fopen("/tmp/wlstate.tmp", "r");
			if ( ((fgets(ssidBuf,40, fp)) != NULL ) && (!strcmp(buffer, "any"))) {
				sprintf( buffer, "%s" ,ssidBuf);
				fclose(fp);
				system("rm -f /tmp/wlstate.tmp");
			}
//			printf("buffer=%s,ssidBuf=%s\n",buffer,ssidBuf);

/*			if ( (!strcmp(buffer, "any")) && (ssidBuf[0])) {
				sprintf( buffer, "%s" ,ssidBuf);
//				memcpy(ssidBuf, buffer, 40);

			}
*/		}
		else {
			if ( !apmib_get( MIB_WLAN_SSID,  (void *)buffer) )
				return -1;
		}
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
					CharFilter2(buffer);
		#endif
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("ipn_state"))) {
		FILE *fp;
		char staBuf[10];
		buffer[0]='\0';
		system("iwconfig ra0 | grep Disconnected > /tmp/wlstate.tmp");
		if ( (fp = fopen("/tmp/wlstate.tmp", "r")) != NULL) {
			if ((fread( staBuf, 1, 1 ,fp )) != NULL)
				sprintf( buffer, "%s", "Disconnected");
			else
				sprintf( buffer, "%s" ,"Connected");
		}
		else
			sprintf( buffer, "%s" ,"Connected");
		fclose(fp);
		system("rm -f /tmp/wlstate.tmp");
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("ipn_channel"))) {
		FILE *fp;
		unsigned char chanBuf[10],ssidBuf[40];

		buffer[0]='\0';
		if ( !apmib_get( MIB_AP_MODE, (void *)&intVal) )
			return -1;
		apmib_get( MIB_STA_SSID, (void *)ssidBuf);

		if ((intVal==1) || (intVal==2)) {
			system("iwconfig ra0 | grep Channel | cut -f 3 -d: | cut -f 1 -d \" \" > /tmp/wlstate.tmp");
			system("sleep 1");
			if ( !apmib_get( MIB_WLAN_CHAN_NUM,  (void *)&intVal) )
				return -1;
			sprintf(buffer, "%d", intVal );


			fp = fopen("/tmp/wlstate.tmp", "r");
			if ( ((fgets(chanBuf,10, fp)) != NULL) && (!strcmp(ssidBuf, "any")) && (strcmp(chanBuf, "\n"))) {
				sprintf(buffer, "%s", chanBuf );
				fclose(fp);
				system("rm -f /tmp/wlstate.tmp");
			}
		}
		else {
			if ( !apmib_get( MIB_WLAN_CHAN_NUM,  (void *)&intVal) )
				return -1;
			if (intVal==0)
				sprintf(buffer, "%s", "auto" );
			else
				sprintf(buffer, "%d", intVal );
		}

		return websWrite(wp, T("%s"), buffer);
	}
#endif
//************************************** ADSL Setting **************************************
#ifdef _7264Wn_
	else if ( !strcmp(name, T("vpi")) ) {
		if ( !apmib_get( MIB_ADSL_VPI, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal);
		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("vci")) ) {
		if ( !apmib_get( MIB_ADSL_VCI, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal);
		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("adsl_qos_pcr")) ) {
		if ( !apmib_get( MIB_ADSL_PCR, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal);
		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("adsl_qos_scr")) ) {
		if ( !apmib_get( MIB_ADSL_SCR, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal);
		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("adsl_qos_mbs")) ) {
		if ( !apmib_get( MIB_ADSL_MBS, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal);
		return websWrite(wp, buffer);
	}
#endif
//************************************ Wireless Information *************************************
	else if ( !strcmp(name, T("bssid_drv"))) {
        if ( !apmib_get(MIB_WLAN_MAC_ADDR,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
				                        buffer[2], buffer[3], buffer[4], buffer[5]);

	}
	else if ( !strcmp(name, T("ssid_drv"))) {
        if ( !apmib_get( MIB_WLAN_SSID,  (void *)buffer) )
        	return -1;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
			
			CharFilter2(buffer);
			
		#endif
		return websWrite(wp, buffer);
		//return websWrite(wp, T("%s"), buffer);
}
#ifdef _MSSID_
	else if ( !strcmp(name, T("ssid1_drv"))) {

        if ( !apmib_get( MIB_WLAN_SSID_1,  (void *)buffer) )
        	return -1;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
					CharFilter2(buffer);
		#endif
		return websWrite(wp, T("%s"), buffer);
}
#endif
	else if ( !strcmp(name, T("state_drv"))) {
		char *pMsg;
		if ( getWlBssInfo(WLAN_IF, &bss) < 0)
			return websWrite(wp, "state_drv");		//Erwin Modify 04.09
		switch (bss.state) {
#if defined(_BR6428PNL_)
                case STATE_DISABLED:
                        pMsg = T("showText(SCANNING)");
                        break;
                case STATE_IDLE:
                        pMsg = T("showText(SCANNING)");
                        break;
                case STATE_STARTED:
                        pMsg = T("showText(SCANNING)");
                        break;
                case STATE_CONNECTED:
                        pMsg = T("showText(CONNECT)");
                        break;
                case STATE_SCANNING:
                        pMsg = T("showText(SCANNING)");
                        break;
					default:
							  pMsg = T("showText(SCANNING)");

#else
                case STATE_DISABLED:
                        pMsg = T("Disabled");
                        break;
                case STATE_IDLE:
                        pMsg = T("Idle");
                        break;
                case STATE_STARTED:
                        pMsg = T("Started");
                        break;
                case STATE_CONNECTED:
                        pMsg = T("Connected");
                        break;
                case STATE_SCANNING:
                        pMsg = T("Scanning");
                        break;
                default:
                        pMsg=NULL;
#endif
                }
                return websWrite(wp, T("%s"), pMsg);
        }
//end,Albert
        else if ( !strcmp(name, T("state_drv1"))) {
                char *pMsg;
                if ( getWlBssInfo("wlan0-vxd", &bss) < 0)
                        return websWrite(wp, "state_drv");              //Erwin Modify 04.09
                switch (bss.state) {
#if defined(_BR6428PNL_)
                case STATE_DISABLED:
                        pMsg = T("showText(SCANNING)");
                        break;
                case STATE_IDLE:
                        pMsg = T("showText(SCANNING)");
                        break;
                case STATE_STARTED:
                        pMsg = T("showText(SCANNING)");
                        break;
                case STATE_CONNECTED:
                        pMsg = T("showText(CONNECT)");
                        break;
                case STATE_SCANNING:
                        pMsg = T("showText(SCANNING)");
                        break;
#else
                case STATE_DISABLED:
                        pMsg = T("Disabled");
                        break;
                case STATE_IDLE:
                        pMsg = T("Idle");
                        break;
                case STATE_STARTED:
                        pMsg = T("Started");
                        break;
                case STATE_CONNECTED:
                        pMsg = T("Connected");
                        break;
                case STATE_SCANNING:
                        pMsg = T("Scanning");
                        break;
#endif
                default:
                        pMsg=NULL;
                }
                return websWrite(wp, T("%s"), pMsg);
        }
	else if ( !strcmp(name, T("channel_drv"))) {
		if ( !apmib_get( MIB_WLAN_CHAN_NUM,  (void *)&intVal) )
			return -1;
	  	if (intVal==0)
			sprintf(buffer, "%s", "auto" );
		else
			sprintf(buffer, "%d", intVal );
		return websWrite(wp, buffer);

		if (bss.channel)
			sprintf(buffer, "%d", bss.channel);
		else
			buffer[0] = '\0';

		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("channel_sta"))) {
		system("iwpriv wlan0 get_mib channel | cut -d \" \" -f 12 > /tmp/channel_test");
		FILE *fp;
		char buf[10];
		int integer;
		if ((fp = fopen("/tmp/channel_test","r"))!=NULL) {
				fgets(buf, 10, fp);
				//printf("buffer2= %s",buf);
				fclose(fp);
				integer = atoi(buf);
				if ( integer == 0 )
					return websWrite(wp,T("\"auto\""));
				else
					return websWrite(wp,T("%s"),buf);
		}
		else {
				return websWrite(wp, T("\"%s\""), "error");
		}
	}
   	else if ( !strcmp(name, T("channel"))) {

		if ( !apmib_get( MIB_WLAN_CHAN_NUM,  (void *)&intVal) )
			return -1;

		if (intVal==0)
			sprintf(buffer, "%s", "auto" );
		else
			sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("wepAll"))) {
		apmib_get( MIB_WLAN_WEP, (void *)&intVal);
#ifdef _MSSID_
		websWrite(wp, T("new Array(\"%d\","), intVal);
		apmib_get( MIB_WLAN_WEP_1, (void *)&intVal);
		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_WEP_2, (void *)&intVal);
		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_WEP_3, (void *)&intVal);
		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_WEP_4, (void *)&intVal);
		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_WEP_5, (void *)&intVal);
		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_WEP_6, (void *)&intVal);
		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_WEP_7, (void *)&intVal);
		websWrite(wp, T("\"%d\")"), intVal);
#else
		websWrite(wp, T("new Array(\"%d\")"), intVal);
#endif
		return 0;
   	}
   	else if ( !strcmp(name, T("wep_key_is_empty"))) {  //0=empty     1=not empty
		websWrite(wp, T("new Array("));
		apmib_get( MIB_WLAN_WEP64_KEY1, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY2, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY3, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY4, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY1, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY2, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY3, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY4, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
#ifdef _MSSID_
		apmib_get( MIB_WLAN_WEP64_KEY1_1, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY2_1, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY3_1, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY4_1, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY1_1, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY2_1, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY3_1, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY4_1, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY1_2, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY2_2, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY3_2, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY4_2, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY1_2, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY2_2, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY3_2, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY4_2, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY1_3, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY2_3, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY3_3, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY4_3, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY1_3, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY2_3, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY3_3, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY4_3, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY1_4, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY2_4, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY3_4, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY4_4, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY1_4, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY2_4, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY3_4, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY4_4, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY1_5, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY2_5, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY3_5, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY4_5, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY1_5, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY2_5, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY3_5, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY4_5, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY1_6, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY2_6, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY3_6, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY4_6, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY1_6, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY2_6, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY3_6, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY4_6, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY1_7, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY2_7, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY3_7, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP64_KEY4_7, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY1_7, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY2_7, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY3_7, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
		apmib_get( MIB_WLAN_WEP128_KEY4_7, buffer); websWrite(wp, T("\"%d\","), ((!strcmp(buffer,""))?0:1));
#endif
		websWrite(wp, T("\"\")"));
		return 0;
   	}
   	else if ( !strcmp(name, T("wep"))) {
   		WEP_T wep;
		if ( !apmib_get( MIB_WLAN_WEP,  (void *)&wep) )
			return -1;

		if ( wep == WEP_DISABLED )
			strcpy( buffer, T("Disabled") );
		else if ( wep == WEP64 )
			strcpy( buffer, T("64bits") );
		else if ( wep == WEP128)
			strcpy( buffer, T("128bits") );
   		return websWrite(wp, buffer);
   	}
  	else if ( !strcmp(name, T("defIp"))) {
		FILE *fp;
		system("flash get DEF_IP_ADDR | cut -f 2 -d \\' > /var/defip.tmp");
		if ((fp = fopen("/var/defip.tmp","r"))!=NULL) {
			fgets(buffer, 30, fp);
			fclose(fp);
			system("rm -f /var/defip.tmp");
   			return websWrite(wp, buffer);
		}else {
   			return websWrite(wp, "192.168.2.1");
		}
	}
  	else if ( !strcmp(name, T("ip"))) {
		if ( getInAddr(BRIDGE_IF, IP_ADDR, (void *)&intaddr ) )
			return websWrite(wp, T("%s"), inet_ntoa(intaddr) );
		else
			return websWrite(wp, T("0.0.0.0"));
	}
	else if (!strcmp(name, T("cloneMac"))) {
		FILE *fp;
		char comment[100]={0}, mac[18]={0};
#ifndef _BOA_
		#ifdef _IPV6_SUPPORT_
		if (strlen(wp->ipaddr) > 15)
		#ifdef __TARGET_BOARD__
			sprintf(comment, "if [ \"`ip2 -6 neigh show | grep %s`\" ]; then ip2 -6 neigh show | grep %s | cut -d \" \" -f 5 > /tmp/cloneMac; fi", wp->ipaddr, wp->ipaddr);
		#else
			sprintf(comment, "if [ \"`ip -6 neigh show | grep %s`\" ]; then ip -6 neigh show | grep %s | cut -d \" \" -f 5 > /tmp/cloneMac; fi", wp->ipaddr, wp->ipaddr);
		#endif
		else
		#endif
		sprintf(comment, "if [ \"`cat /proc/net/arp | grep %s`\" ]; then cat /proc/net/arp | grep %s | tr -s \" \" | cut -d \" \" -f 4 > /tmp/cloneMac; fi", wp->ipaddr, wp->ipaddr);
#else
		#ifdef _IPV6_SUPPORT_
		if (strlen(wp->remote_ip_addr) > 15)
		#ifdef __TARGET_BOARD__
			sprintf(comment, "if [ \"`ip2 -6 neigh show | grep %s`\" ]; then ip2 -6 neigh show | grep %s | cut -d \" \" -f 5 > /tmp/cloneMac; fi", wp->remote_ip_addr, wp->remote_ip_addr);
		#else
			sprintf(comment, "if [ \"`ip -6 neigh show | grep %s`\" ]; then ip -6 neigh show | grep %s | cut -d \" \" -f 5 > /tmp/cloneMac; fi", wp->remote_ip_addr, wp->remote_ip_addr);
		#endif
		else
		#endif
		sprintf(comment, "if [ \"`cat /proc/net/arp | grep %s`\" ]; then cat /proc/net/arp | grep %s | tr -s \" \" | cut -d \" \" -f 4 > /tmp/cloneMac; fi", wp->remote_ip_addr, wp->remote_ip_addr);
#endif
		system(comment);
		if ((fp = fopen("/tmp/cloneMac","r")) != NULL) {
			fgets(mac, 18, fp);
			fclose(fp);
			mac[2] = mac[3];
			mac[3] = mac[4];
			mac[4] = mac[6];
			mac[5] = mac[7];
			mac[6] = mac[9];
			mac[7] = mac[10];
			mac[8] = mac[12];
			mac[9] = mac[13];
			mac[10] = mac[15];
			mac[11] = mac[16];
			mac[12] = mac[17];
			system("rm /tmp/cloneMac");
			return websWrite(wp, T("%s"), mac);
		}
		else
			return websWrite(wp, T("%s"), "000000000000");
	}
	else if ( !strcmp(name, T("wlanMac"))) {
		if ( !apmib_get(MIB_WLAN_MAC_ADDR,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
						buffer[2], buffer[3], buffer[4], buffer[5]);
	}
#if defined(HOME_GATEWAY) || defined(_AP_WITH_TIMEZONE_)
//**************************VLAN****************************
#ifdef _VLAN_CONFIG_SUPPORTED_
	else if(!strcmp(name, T("maxWebVlanNum"))){
		sprintf(buffer, "%d", MAX_IFACE_VLAN_CONFIG );
		return websWrite(wp, buffer);
	}

	else if(!strcmp(name, T("isVLANIncludeWLAN")))
        {
                sprintf(buffer, "%s", "1");
                return websWrite(wp, buffer);
        }

#endif
	else if(!strcmp(name, T("vlanOnOff"))){
#ifdef _VLAN_CONFIG_SUPPORTED_
		apmib_get( MIB_VLANCONFIG_ENABLED, (void *)&intVal);
		sprintf(buffer, "%d", intVal );
		return websWrite(wp, buffer);
#else
		sprintf(buffer, "%d", 0 );
		return websWrite(wp, buffer);
#endif
	}
	else if(!strcmp(name, T("vlan_menu_onoff"))){
#ifdef _VLAN_CONFIG_SUPPORTED_
		return websWrite(wp, "firewall.addItem('VLAN', 'vlan.asp', '', 'Setup VLAN');" );
#else
		return websWrite(wp,"");
#endif
	}
//**************************************** Time Zone ****************************************
	else if ( !strcmp(name, T("TimeZoneSel"))) {
		if ( !apmib_get( MIB_TIME_ZONE_SEL, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("startMonth"))) {
		if ( !apmib_get( MIB_START_MONTH, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("startDay"))) {
		if ( !apmib_get( MIB_START_DAY, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("endMonth"))) {
		if ( !apmib_get( MIB_END_MONTH, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("endDay"))) {
		if ( !apmib_get( MIB_END_DAY, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("TimeServerAddr"))) {
#ifdef _BR6428PNL_
                if ( !apmib_get(MIB_TIMESERVER_ADDR,   (void *)&buffer ) )
                        return -1;
		return websWrite(wp, buffer);
#else
		if ( !apmib_get(MIB_TIMESERVER_ADDR,   (void *)&intaddr ) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr) );
#endif

	}
#endif
#ifdef _SNTP_A_M_CTL_ //vance 2009.02.20
	else if ( !strcmp(name, T("staticTime"))) {
			if ( !apmib_get( MIB_STATIC_SYSTEM_TIME, (void *)&buffer) )
				return -1;
			return websWrite(wp, T("%s"), buffer);
		}
	else if ( !strcmp(name, T("timeserverDomain"))) {
		if ( !apmib_get( MIB_TIMESERVER_DOMAIN, (void *)&buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
#endif
#ifdef HOME_GATEWAY
	else if ( !strcmp(name, T("hostpassword")) ) {	//no use
		buffer[0]='\0';
		if ( !apmib_get(MIB_USER_PASSWORD,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}

//************************************** Remote Management **************************************
	else if ( !strcmp(name, T("reManHostAddr"))) {
		if ( !apmib_get(MIB_REMANHOST_ADDR,  (void *)&intaddr ) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("reManPort"))) {
		if ( !apmib_get( MIB_REMAN_PORT, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
//**************************************** Dynamic Ip ****************************************
	else if ( !strcmp(name, T("dynIPHostName")) ) {
		buffer[0]='\0';
		if ( !apmib_get(MIB_DYNIP_HOSTNAME,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("wanMac"))) {

		if ( !apmib_get(MIB_WAN_MAC_ADDR,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1], buffer[2], buffer[3], buffer[4], buffer[5]);
	}
//**************************************** Static Ip ****************************************
	else if ( !strcmp(name, T("wan-ip-rom"))) {
		if ( !apmib_get( MIB_WAN_IP_ADDR, (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"),inet_ntoa(intaddr));
	}
   	else if ( !strcmp(name, T("wan-mask-rom"))) {
		if ( !apmib_get( MIB_WAN_SUBNET_MASK,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
   	else if ( !strcmp(name, T("wan-gateway-rom"))) {
		if ( !apmib_get( MIB_WAN_DEFAULT_GATEWAY,  (void *)&intaddr) )
			return -1;
		if (!memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4))
			return websWrite(wp, T("0.0.0.0"));
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
//**************************************** PPPoE Setting ****************************************
   	else if ( !strcmp(name, T("pppServName"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_PPP_SERVNAME,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("pppMTU"))) {
		if ( !apmib_get( MIB_PPP_MTU, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
#ifdef _INDEPEND_DHCP_MTU_
	else if ( !strcmp(name, T("dhcpMTU"))) {
		if ( !apmib_get( MIB_DHCP_MTU, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
#endif
   	else if ( !strcmp(name, T("pppUserName"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_PPP_USER,  (void *)buffer) )
			return -1;

		ptr1 = buffer;
		tmp[0] = '\0';
		while ( flag ) {
			if ((ptr = strchr(ptr1, '#')) != NULL) {
				*(ptr-1) ='\0';
				ptr++;
				strcat( tmp, ptr1);
				strcat( tmp, "#");
				ptr1 = ptr;
			}
			else {
				strcat( tmp, ptr1);
				flag = 0;
			}
		}

		return websWrite(wp, T("%s"), tmp);
	}
  	else if ( !strcmp(name, T("pppPassword"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_PPP_PASSWORD,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
   	else if ( !strcmp(name, T("wan-ppp-idle"))) {
		if ( !apmib_get( MIB_PPP_IDLE_TIME,  (void *)&intVal) )
			return -1;

		sprintf(buffer, "%d", intVal/60 );
   		return websWrite(wp, buffer);
	}
#if defined(_Customer_) | defined(_MPPPOE_)
   	else if ( !strcmp(name, T("pppServName1"))) { //alex 2007/01/31
		buffer[0]='\0';
		if ( !apmib_get( MIB_PPP_SERVNAME1,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("pppMTU1"))) {  //alex 2007/01/31
		if ( !apmib_get( MIB_PPP_MTU1, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("pppUnnumIP"))) {  //alex 2007/01/31
		if ( !apmib_get(MIB_PPP_UNNUMIP,  (void *)buffer) )
			return -1;
   		//return websWrite(wp, T("%s"), inet_ntoa(*((struct in_addr *)buffer)) );
   		return websWrite(wp, T("%s"), fixed_inet_ntoa(buffer) );

	}
	else if ( !strcmp(name, T("pppUnnumMask"))) {  //alex 2007/01/31
		if ( !apmib_get(MIB_PPP_UNNUMMASK,  (void *)buffer) )
			return -1;
   		//return websWrite(wp, T("%s"), inet_ntoa(*((struct in_addr *)buffer)) );
   		return websWrite(wp, T("%s"), fixed_inet_ntoa(buffer) );
	}
	else if ( !strcmp(name, T("pppUnnumNAT"))) {  //alex 2007/01/31
		if ( !apmib_get( MIB_PPP_UNNUMNAT, (void *)&intVal) )
			return -1;
		sprintf(buffer, "");
		if(intVal == 1)
			sprintf(buffer, "checked" );
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("pppUserName1"))) { //alex 2007/01/31
		buffer[0]='\0';
		if ( !apmib_get( MIB_PPP_USER1,  (void *)buffer) )
			return -1;

		ptr1 = buffer;
		tmp[0] = '\0';
		while ( flag ) {
			if ((ptr = strchr(ptr1, '#')) != NULL) {
				*(ptr-1) ='\0';
				ptr++;
				strcat( tmp, ptr1);
				strcat( tmp, "#");
				ptr1 = ptr;
			}
			else {
				strcat( tmp, ptr1);
				flag = 0;
			}
		}

		return websWrite(wp, T("%s"), tmp);
	}
  	else if ( !strcmp(name, T("pppPassword1"))) { //alex 2007/01/31
		buffer[0]='\0';
		if ( !apmib_get( MIB_PPP_PASSWORD1,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
   	else if ( !strcmp(name, T("wan-ppp-idle1"))) { //alex 2007/01/31
		if ( !apmib_get( MIB_PPP_IDLE_TIME1,  (void *)&intVal) )
			return -1;

		sprintf(buffer, "%d", intVal/60 );
   		return websWrite(wp, buffer);
	}
   #ifdef _TRIPPPOE_
        else if ( !strcmp(name, T("pppUserName2"))) { //alex 2007/01/31
                buffer[0]='\0';
                if ( !apmib_get( MIB_PPP_USER2,  (void *)buffer) )
                        return -1;

                ptr1 = buffer;
                tmp[0] = '\0';
                while ( flag ) {
                        if ((ptr = strchr(ptr1, '#')) != NULL) {
                                *(ptr-1) ='\0';
                                ptr++;
                                strcat( tmp, ptr1);
                                strcat( tmp, "#");
                                ptr1 = ptr;
                        }
                        else {
                                strcat( tmp, ptr1);
                                flag = 0;
                        }
                }

                return websWrite(wp, T("%s"), tmp);
        }
        else if ( !strcmp(name, T("pppPassword2"))) { //alex 2007/01/31
                buffer[0]='\0';
                if ( !apmib_get( MIB_PPP_PASSWORD2,  (void *)buffer) )
                        return -1;
                return websWrite(wp, T("%s"), buffer);
        }
        else if ( !strcmp(name, T("wan-ppp-idle2"))) { //alex 2007/01/31
                if ( !apmib_get( MIB_PPP_IDLE_TIME2,  (void *)&intVal) )
                        return -1;

                sprintf(buffer, "%d", intVal/60 );
                return websWrite(wp, buffer);
        }
        else if ( !strcmp(name, T("pppServName2"))) { //alex 2007/01/31
                buffer[0]='\0';
                if ( !apmib_get( MIB_PPP_SERVNAME2,  (void *)buffer) )
                        return -1;
                return websWrite(wp, T("%s"), buffer);
        }
        else if ( !strcmp(name, T("pppMTU2"))) {  //alex 2007/01/31
                if ( !apmib_get( MIB_PPP_MTU2, (void *)&intVal) )
                        return -1;
                sprintf(buffer, "%d", intVal );
                return websWrite(wp, buffer);
        }
        else if ( !strcmp(name, T("pppUnnumIP2"))) {  //alex 2007/01/31
                if ( !apmib_get(MIB_PPP_UNNUMIP2,  (void *)buffer) )
                        return -1;
                return websWrite(wp, T("%s"), fixed_inet_ntoa(buffer) );
        }
        else if ( !strcmp(name, T("pppUnnumMask2"))) {  //alex 2007/01/31
                if ( !apmib_get(MIB_PPP_UNNUMMASK2,  (void *)buffer) )
                        return -1;
                return websWrite(wp, T("%s"), fixed_inet_ntoa(buffer) );
        }
   #endif
#endif
//**************************************** PPTP Setting ****************************************
	else if ( !strcmp(name, T("pptpIPAddr"))) {
		if ( !apmib_get(MIB_PPTPIP_ADDR,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("pptpIPMaskAddr"))) {
		if ( !apmib_get(MIB_PPTPIPMAKE_ADDR,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("pptpDfGateway"))) {
		if ( !apmib_get(MIB_PPTPDFGATEWAY,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
#ifdef _PPTP_FQDN_
  	else if ( !strcmp(name, T("pptpGateway"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_PPTPGATEWAY,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
#else
	else if ( !strcmp(name, T("pptpGateway"))) {
		if ( !apmib_get(MIB_PPTPGATEWAY,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
#endif
   	else if ( !strcmp(name, T("pptpUserName"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_PPTP_USER,  (void *)buffer) )
			return -1;

		ptr1 = buffer;
		tmp[0] = '\0';
		while ( flag ) {
			if ((ptr = strchr(ptr1, '#')) != NULL) {
				*(ptr-1) ='\0';
				ptr++;
				strcat( tmp, ptr1);
				strcat( tmp, "#");
				ptr1 = ptr;
			}
			else {
				strcat( tmp, ptr1);
				flag = 0;
			}
		}
		return websWrite(wp, T("%s"), tmp);
	}
  	else if ( !strcmp(name, T("pptpPassword"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_PPTP_PASSWORD,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
   	else if ( !strcmp(name, T("wan-pptp-idle"))) {
		if ( !apmib_get( MIB_PPTP_IDLE_TIME,  (void *)&intVal) )
			return -1;

		sprintf(buffer, "%d", intVal/60 );
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("pptpConntID"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_PPTP_CONNT_ID,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("pptpMTU"))) {
		if ( !apmib_get( MIB_PPTP_MTU, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
//**************************************** L2TP Setting ****************************************
	else if ( !strcmp(name, T("L2TPIPAddr"))) {
		if ( !apmib_get(MIB_L2TP_IP_ADDR,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("L2TPMaskAddr"))) {
		if ( !apmib_get(MIB_L2TP_MAKEADDR,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("L2TPDefGateway"))) {
		if ( !apmib_get(MIB_L2TP_DEFGATEWAY,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
  	else if ( !strcmp(name, T("L2TPGateway"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_L2TP_GATEWAY,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("L2TPUserName"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_L2TP_USER,  (void *)buffer) )
			return -1;

		ptr1 = buffer;
		tmp[0] = '\0';
		while ( flag ) {
			if ((ptr = strchr(ptr1, '#')) != NULL) {
				*(ptr-1) ='\0';
				ptr++;
				strcat( tmp, ptr1);
				strcat( tmp, "#");
				ptr1 = ptr;
			}
			else {
				strcat( tmp, ptr1);
				flag = 0;
			}
		}
		return websWrite(wp, T("%s"), tmp);
	}
  	else if ( !strcmp(name, T("L2TPPassword"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_L2TP_PASSWORD,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
   	else if ( !strcmp(name, T("L2TPIdleTime"))) {
		if ( !apmib_get( MIB_L2TP_IDLE_TIME,  (void *)&intVal) )
			return -1;

		sprintf(buffer, "%d", intVal/60 );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("L2TPMTU"))) {
		if ( !apmib_get( MIB_L2TP_MTU, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
//************************************** TelStra Big Pond **************************************
	else if ( !strcmp(name, T("telBPIPAddr"))) {
		if ( !apmib_get(MIB_TELBPIP_ADDR,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
   	else if ( !strcmp(name, T("telBPUserName"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_TELBP_USER,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
  	else if ( !strcmp(name, T("telBPPassword"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_TELBP_PASSWORD,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%s"), buffer);
	}
//*********************************** Application layer gateway ***********************************
	else if ( !strcmp(name, T("appLayerGateway"))) {
		if ( !apmib_get( MIB_APP_LAYER_GATEWAY, (void *)&longVal) )
			return -1;
		sprintf(buffer, "%lu", longVal );
   		return websWrite(wp, buffer);
	}
//*********************************** LAN WAN Access ***********************************
	else if ( !strcmp(name, T("lanWanAccess"))) {
		#ifdef _LAN_WAN_ACCESS_
		if ( !apmib_get( MIB_LAN_WAN_ACCESS, (void *)&longVal) )
			return -1;
		sprintf(buffer, "%lu", longVal );

		#else
			sprintf(buffer,"\"\"");
		#endif



   		return websWrite(wp, buffer);
	}
//**************************************** DDNS Setting ****************************************
   	else if ( !strcmp(name, T("ddnsName"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_DDNS_NAME,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("ddnspvidSel"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_DDNS_PVIDSEL,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("ddnsAccount"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_DDNS_ACCOUNT,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
  	else if ( !strcmp(name, T("ddnsPass"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_DDNS_PASS,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
#if defined(_ENSNMP_)
//**************************************** SNMP Setting ****************************************
   	else if ( !strcmp(name, T("snmpName"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_SNMP_NAME,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
#endif
//************************************** 3G WWAN Settings  **************************************
#ifdef _WAN3G_
	else if ( !strcmp(name, T("AuthModeSel"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WWAN_AUTHMODESEL,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("OPModeSel"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WWAN_OPMODESEL,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("NPSel"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WWAN_NPSEL,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("wwanName"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WWAN_NAME,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("wwanPassword"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WWAN_PASSWORD,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("PINCode"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WWAN_PINCODE,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("wwanAPN"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WWAN_APN,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("wwanPhoneNo"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WWAN_PHONENO,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("PPPName"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WWAN_PPPNAME,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("PPPPass"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WWAN_PPPPASS,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("PPPIdleTime"))) {
		if ( !apmib_get( MIB_WWAN_PPPIDLETIME,  (void *)&intVal) )
			return -1;

		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("PPPEchoTimeout"))) {
		if ( !apmib_get( MIB_WWAN_PPPECHOTIMEOUT,  (void *)&intVal) )
			return -1;

		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
   	else if ( !strcmp(name, T("PPPEchoCount"))) {
		if ( !apmib_get( MIB_WWAN_PPPECHOCOUNT,  (void *)&intVal) )
			return -1;

		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
        else if ( !strcmp(name, T("USB_Info"))) {
                FILE *fp;
                int line=0;

                system("/bin/getcard.sh");

                if ((fp = fopen("/var/tmp/CINFO","r"))!=NULL) {
                        while (fgets(cardbuf[line++], 100, fp) > 0);
                        fclose(fp);
                }
//              websWrite(wp, T("%s"), buffer);
                return 0;
        }
        else if ( !strcmp(name, T("WWAN_STAT"))) {
                return websWrite(wp, T("%s"), cardbuf[0]);
        }
        else if ( !strcmp(name, T("WWAN_IP"))) {
                return websWrite(wp, T("%s"), cardbuf[1]);
        }
        else if ( !strcmp(name, T("WWAN_NETMASK"))) {
                return websWrite(wp, T("%s"), cardbuf[2]);
        }
        else if ( !strcmp(name, T("WWAN_GATEWAY"))) {
                return websWrite(wp, T("%s"), cardbuf[3]);
        }
        else if ( !strcmp(name, T("USB_Manufact"))) {
                return websWrite(wp, T("%s"), cardbuf[4]);
        }
        else if ( !strcmp(name, T("USB_Product"))) {
                return websWrite(wp, T("%s"), cardbuf[5]);
        }
        else if ( !strcmp(name, T("USB_IMEI"))) {
                return websWrite(wp, T("%s"), cardbuf[6]);
        }
        else if ( !strcmp(name, T("USB_Signal"))) {
                return websWrite(wp, T("%s"), cardbuf[7]);
        }
#endif
#ifdef _STAR_CF_3G_ //vance 2009.02.05 3G connection for NetIndex
      else if ( !strcmp(name, T("wwanAPN"))) {
    		buffer[0]='\0';
    		if ( !apmib_get( MIB_WWAN_APN,  (void *)buffer) )
    			return -1;
       		return websWrite(wp, buffer);
    	}
      else if ( !strcmp(name, T("PPPName"))) {
    		buffer[0]='\0';
    		if ( !apmib_get( MIB_WWAN_PPPNAME,  (void *)buffer) )
    			return -1;
       		return websWrite(wp, buffer);
    	}
      else if ( !strcmp(name, T("PPPPass"))) {
    		buffer[0]='\0';
    		if ( !apmib_get( MIB_WWAN_PPPPASS,  (void *)buffer) )
    			return -1;
       		return websWrite(wp, buffer);
    	}
      else if ( !strcmp(name, T("PPPIdleTime"))) {
      		if ( !apmib_get( MIB_WWAN_PPPIDLETIME,  (void *)&intVal) )
      			return -1;

      		sprintf(buffer, "%d", intVal );
         		return websWrite(wp, buffer);
      	}
      else if ( !strcmp(name, T("PPPEchoTimeout"))) {
    		if ( !apmib_get( MIB_WWAN_PPPECHOTIMEOUT,  (void *)&intVal) )
    			return -1;

    		sprintf(buffer, "%d", intVal );
       		return websWrite(wp, buffer);
    	}
      else if ( !strcmp(name, T("PPPEchoCount"))) {
    		if ( !apmib_get( MIB_WWAN_PPPECHOCOUNT,  (void *)&intVal) )
    			return -1;

    		sprintf(buffer, "%d", intVal );
       		return websWrite(wp, buffer);
    	}
      else if ( !strcmp(name, T("connectType"))) {
        	if ( !apmib_get( MIB_WWAN_CONNETTYPE,  (void *)&intVal) )
        		return -1;

        	sprintf(buffer, "%d", intVal );
         	return websWrite(wp, buffer);
        }
      else if ( !strcmp(name, T("connectDevice"))) {
    	  	int fd,fd2;
    	  	char tmp[5]="\0";
    	  	fd = open("/dev/CF_DET",O_RDONLY);
    	  	fd2 = open("/tmp/modeminfo",O_RDONLY);
    		if (fd < -1) {
    			printf("open cf card detecter error!!\n");
    			return -1;
    		}
    		//get cf state
    		if(read(fd, tmp, 5) == -1)
    			printf("read /dev/CF_DET error!!!\n");

    		if(atoi(tmp) == 0 && fd2 == -1) //CF
    			intVal = 0;
    		else if(atoi(tmp) == 1 && fd2 != -1) //USB
    			intVal = 1;
    		else //none
    			intVal = 2;

    		close(fd);
    		sprintf(buffer, "%d", intVal );
         return websWrite(wp, buffer);
        }
#endif

#ifdef _GENERAL_3G_ //vance 2009.04.09 for general
      else if ( !strcmp(name, T("AuthModeSel"))) {
      		buffer[0]='\0';
      		if ( !apmib_get( MIB_WWAN_AUTHMODESEL,  (void *)buffer) )
      			return -1;
         		return websWrite(wp, buffer);
      	}
      else if ( !strcmp(name, T("OPModeSel"))) {
      		buffer[0]='\0';
      		if ( !apmib_get( MIB_WWAN_OPMODESEL,  (void *)buffer) )
      			return -1;
         		return websWrite(wp, buffer);
      	}
      else if ( !strcmp(name, T("NPSel"))) {
      		buffer[0]='\0';
      		if ( !apmib_get( MIB_WWAN_NPSEL,  (void *)buffer) )
      			return -1;
         		return websWrite(wp, buffer);
      	}
      else if ( !strcmp(name, T("wwanName"))) {
      		buffer[0]='\0';
      		if ( !apmib_get( MIB_WWAN_NAME,  (void *)buffer) )
      			return -1;
         		return websWrite(wp, buffer);
      	}
      else if ( !strcmp(name, T("wwanPassword"))) {
      		buffer[0]='\0';
      		if ( !apmib_get( MIB_WWAN_PASSWORD,  (void *)buffer) )
      			return -1;
         		return websWrite(wp, buffer);
      	}
      else if ( !strcmp(name, T("PINCode"))) {
      		buffer[0]='\0';
      		if ( !apmib_get( MIB_WWAN_PINCODE,  (void *)buffer) )
      			return -1;
         		return websWrite(wp, buffer);
      	}
      else if ( !strcmp(name, T("wwanPhoneNo"))) {
 			buffer[0]='\0';
 			if ( !apmib_get( MIB_WWAN_PHONENO,  (void *)buffer) )
 				return -1;
 	   		return websWrite(wp, buffer);
 		}
#endif
//************************************** DDNS DHIS Setting **************************************
	else if ( !strcmp(name, T("dhisHostID"))) {
		if ( !apmib_get( MIB_DHIS_HOSTID, (void *)&longVal) )
			return -1;
		sprintf(buffer, "%lu", longVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("dhisISAddr"))) {
		if ( !apmib_get(MIB_DHIS_ISADDR,  (void *)buffer) )
			return -1;
// 		return websWrite(wp, T("%s"), inet_ntoa(intaddr)); // Lance 2003.11.05
   		return websWrite(wp, buffer);
	}
  	else if ( !strcmp(name, T("dhispass"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_DHIS_PASSWORD,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
  	else if ( !strcmp(name, T("dhisAuthP1"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_DHIS_AUTH_P1,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
  	else if ( !strcmp(name, T("dhisAuthP2"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_DHIS_AUTH_P2,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
  	else if ( !strcmp(name, T("dhisAuthQ1"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_DHIS_AUTH_Q1,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
  	else if ( !strcmp(name, T("dhisAuthQ2"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_DHIS_AUTH_Q2,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
//**************************************** DoS ****************************************
	else if ( !strcmp(name, T("podPack"))) {
		if ( !apmib_get( MIB_POD_PACK, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("podBur"))) {
		if ( !apmib_get( MIB_POD_BUR, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("synPack"))) {
		if ( !apmib_get( MIB_SYN_PACK, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("synBur"))) {
		if ( !apmib_get( MIB_SYN_BUR, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("scanNum"))) {
		if ( !apmib_get( MIB_SCAN_NUM, (void *)&longVal) )
			return -1;
		sprintf(buffer, "%lu", longVal );
   		return websWrite(wp, buffer);
	}
#endif
//////////////////////////////////////////////////////////////////////////////////////////////
   	else if ( !strcmp(name, T("mask"))) {
		if ( getInAddr(BRIDGE_IF, SUBNET_MASK, (void *)&intaddr ))
			return websWrite(wp, T("%s"), inet_ntoa(intaddr) );
		else
			return websWrite(wp, T("0.0.0.0"));
	}
   	else if ( !strcmp(name, T("gateway"))) {
#ifdef HOME_GATEWAY
		DHCP_T dhcp;
  		apmib_get( MIB_DHCP, (void *)&dhcp);
		if ( dhcp == DHCP_SERVER ) {
		// if DHCP server, default gateway is set to LAN IP
			if ( getInAddr(BRIDGE_IF, IP_ADDR, (void *)&intaddr ) )
				return websWrite(wp, T("%s"), inet_ntoa(intaddr) );
			else
				return websWrite(wp, T("0.0.0.0"));
		}
		else
#endif

		if ( getDefaultRoute(BRIDGE_IF, &intaddr) )
			return websWrite(wp, T("%s"), inet_ntoa(intaddr) );
		else
			return websWrite(wp, T("0.0.0.0"));
	}
//**************************************** LAN Setting****************************************
	else if ( !strcmp(name, T("ip-rom"))) {
		if ( !apmib_get( MIB_IP_ADDR,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
   	else if ( !strcmp(name, T("mask-rom"))) {
		if ( !apmib_get( MIB_SUBNET_MASK,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
	else if (!strcmp(name, T("gateway-rom"))) {
		if (!apmib_get( MIB_DEFAULT_GATEWAY, (void *)&intaddr))
			return -1;
		if (!memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4))
			return websWrite(wp, T(""));
		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
   	else if ( !strcmp(name, T("dhcpRangeStart"))) {
		if ( !apmib_get( MIB_DHCP_CLIENT_START,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
  	else if ( !strcmp(name, T("dhcpRangeEnd"))) {
		if ( !apmib_get( MIB_DHCP_CLIENT_END,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("leaseTime"))) {
		if ( !apmib_get( MIB_LAN_LEASETIME, (void *)&longVal) )
			return -1;
		sprintf(buffer, "%lu", longVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("DhcpGatewayIP"))) {
		if ( !apmib_get(MIB_DHCPGATEWAYIP_ADDR,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("DhcpNameServerIP"))) {
		if ( !apmib_get(MIB_DHCPNAMESERVER_ADDR,  (void *)&intaddr) )
			return -1;
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
   	if ( !strcmp(name, T("DomainName")) ) {
		buffer[0]='\0';
		if ( !apmib_get(MIB_DOMAIN_NAME,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
//********************* TTL Function add by Kyle 2008/03/07. *******************
#ifdef _WANTTL_
  	else if ( !strcmp(name, T("getTTLValue"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_TTL_VALUE,  (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
#endif
//***************************************************************************
 	else if ( !strcmp(name, T("dhcp-current")) ) {
   		if ( !apmib_get( MIB_DHCP, (void *)&dhcp) )
			return -1;

		if (dhcp==DHCP_CLIENT) {
			if (!isDhcpClientExist(BRIDGE_IF) &&
					!getInAddr(BRIDGE_IF, IP_ADDR, (void *)&intaddr))
				return websWrite(wp, T("Getting IP from DHCP server..."));
			if (isDhcpClientExist(BRIDGE_IF))
				return websWrite(wp, T("DHCP"));
		}
		return websWrite(wp, T("Fixed IP"));
	}
#ifdef _WLCIOLOG_
//**************************************** Wireless Client Login/Logout Log ****************************************
	else if ( !strcmp(name, T("wllog"))) {
		FILE *fp1;
		FILE *fp2;
		char *charp;
		unsigned char tmpstr1[200],tmpstr2[200];
		time_t now;
		system("cat /proc/wlciolog > /tmp/wlciolog");
		fp2 = fopen("/tmp/wlciolog1","w");
		if ((fp1 = fopen("/tmp/wlciolog","r"))!=NULL) {
			while (fgets(tmpstr1, 200, fp1) > 0)
			{
					strncpy(tmpstr2,tmpstr1,10);
					now=atol(tmpstr2);
					strftime(tmpstr2, 200, "%Y-%m-%d %H:%M:%S", localtime(&now));

					charp=tmpstr1+10;

					websWrite(wp, T("[%s]%s"), tmpstr2, charp);
					fprintf(fp2, "[%s]%s", tmpstr2, charp);
			}
		fclose(fp1);
		}
		fclose(fp2);
		return 0;
	}
#endif

#if defined(HOME_GATEWAY) || defined(_Customer_EX_) || defined(_Customer_SC_) || defined(_Customer_SA_)
        else if ( !strcmp(name, T("syslog"))) {
                FILE *fp1;
                system("/bin/syslog.sh");
                if ((fp1 = fopen("/var/log/syslog","r"))!=NULL) {
                        while (fgets(buffer, 100, fp1) > 0)
                                websWrite(wp, T("%s"), buffer);
                fclose(fp1);
                }
                return 0;
        }
#endif

#ifdef  HOME_GATEWAY
  	else if ( !strcmp(name, T("wan-ip"))) {
  		if ( !apmib_get( MIB_WAN_DHCP, (void *)&dhcp) )
			return -1;
		if ( !apmib_get( MIB_OP_MODE, (void *)&opmode) )
			return -1;
		if ( dhcp == PPPOE || dhcp == PPTP) {
			iface = PPPOE_IF;
			if ( !isConnectPPP() )
				iface = NULL;
		}
//		else if (opmode == WISP_MODE)
//			iface = WLAN_IF;
		else
			iface = _WAN_IF_;

		if ( iface && getInAddr(iface, IP_ADDR, (void *)&intaddr ) )
			return websWrite(wp, T("%s"), inet_ntoa(intaddr) );
		else
			return websWrite(wp, T("0.0.0.0"));
	}
   	else if ( !strcmp(name, T("wan-mask"))) {
		if ( !apmib_get( MIB_WAN_DHCP, (void *)&dhcp) )
			return -1;
		if ( !apmib_get( MIB_OP_MODE, (void *)&opmode) )
			return -1;
		if ( dhcp == PPPOE || dhcp == PPTP) {
			iface = PPPOE_IF;
			if ( !isConnectPPP() )
				iface = NULL;
		}
//		else if (opmode == WISP_MODE)
//			iface = WLAN_IF;
		else
			iface = _WAN_IF_;

		if ( iface && getInAddr(iface, SUBNET_MASK, (void *)&intaddr ))
			return websWrite(wp, T("%s"), inet_ntoa(intaddr) );
		else
			return websWrite(wp, T("0.0.0.0"));
	}
   	else if ( !strcmp(name, T("wan-gateway"))) {
		if ( !apmib_get( MIB_WAN_DHCP, (void *)&dhcp) )
			return -1;
		if ( !apmib_get( MIB_OP_MODE, (void *)&opmode) )
			return -1;
		if ( dhcp == PPPOE || dhcp == PPTP) {
			iface = PPPOE_IF;
			if ( !isConnectPPP() )
				iface = NULL;
		}
//		else if (opmode == WISP_MODE)
//			iface = WLAN_IF;
		else
			iface = _WAN_IF_;
		if ( iface && getDefaultRoute(iface, &intaddr) )
			return websWrite(wp, T("%s"), inet_ntoa(intaddr) );
		else
			return websWrite(wp, T("0.0.0.0"));
	}
	else if ( !strcmp(name, T("wan-hwaddr"))) {
		if ( !apmib_get( MIB_OP_MODE, (void *)&opmode) )
			return -1;
//		if(opmode == WISP_MODE)
//			iface = WLAN_IF;
//		else
			iface = _WAN_IF_;
		if ( getInAddr(iface, HW_ADDR, (void *)&hwaddr ) ) {
			pMacAddr = hwaddr.sa_data;
			return websWrite(wp, T("%02X:%02X:%02X:%02X:%02X:%02X"), pMacAddr[0], pMacAddr[1],
				pMacAddr[2], pMacAddr[3], pMacAddr[4], pMacAddr[5]);
		}
		else
			return websWrite(wp, T("00:00:00:00:00:00"));
	}
//**************************************** DDNS Setting ****************************************
  	else if ( !strcmp(name, T("wan-dns1"))) {
		if ( !apmib_get( MIB_WAN_DNS1,  (void *)&intaddr) )
			return -1;
		if (!memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4))
			return websWrite(wp, T(""));
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
  	else if ( !strcmp(name, T("wan-dns2"))) {
		if ( !apmib_get( MIB_WAN_DNS2,  (void *)&intaddr) )
			return -1;
		if (!memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4))
			return websWrite(wp, T(""));
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
  	else if ( !strcmp(name, T("wan-dns3"))) {
		if ( !apmib_get( MIB_WAN_DNS3,  (void *)&intaddr) )
			return -1;
		if (!memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4))
			return websWrite(wp, T(""));
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
 	else if ( !strcmp(name, T("wanDhcp-current")) ) {
   	if ( !apmib_get( MIB_WAN_DHCP, (void *)&dhcp) )
			return -1;
		if ( dhcp == DHCP_CLIENT) {
  			if ( !apmib_get( MIB_OP_MODE, (void *)&opmode) )
				return -1;
//			if(opmode == WISP_MODE)
//				iface = WLAN_IF;
//			else
				iface = _WAN_IF_;
		 	if (!isDhcpClientExist(iface))
				return websWrite(wp, T("Getting IP from DHCP server..."));
			else
				return websWrite(wp, T("DHCP"));
		}
		else if ( dhcp == DHCP_DISABLED )
			return websWrite(wp, T("Fixed IP"));
		else if ( dhcp ==  PPPOE ) {
			if ( isConnectPPP())
				return websWrite(wp, T("PPPoE Connected"));
			else
				return websWrite(wp, T("PPPoE Disconnected"));
		}
	}
#ifdef _7264Wn_
//**************************************** AdslConsol Log ****************************************
	else if ( !strcmp(name, T("adslOutput"))) {
		FILE *fp1;

		if ((fp1 = fopen("/var/adsl_out.var","r"))!=NULL) {
			while (fgets(buffer, 100, fp1) > 0)
				websWrite(wp, T("%s"), buffer);
		fclose(fp1);
		}
		return 0;
	}
#endif
//**************************************** System Log ****************************************
	else if ( !strcmp(name, T("syslog"))) {
		FILE *fp1;
		system("/bin/syslog.sh");
		if ((fp1 = fopen("/var/log/syslog","r"))!=NULL) {
			while (fgets(buffer, 100, fp1) > 0)
				websWrite(wp, T("%s"), buffer);
		fclose(fp1);
		}
		return 0;
	}
	else if ( !strcmp(name, T("dhcplog"))) {
		#ifdef _DEBUG_DHCPC_

		FILE *fp1;

		if ((fp1 = fopen("/var/dhcp_debug.var","r"))!=NULL) {
			while (fgets(buffer, 100, fp1) > 0)
				websWrite(wp, T("%s"), buffer);
		fclose(fp1);
		}
		#else
			websWrite(wp, T("%s"), "\"\"");
		#endif

		return 0;
	}
//**************************************** routing table ****************************************
	else if ( !strcmp(name, T("routingTable"))) {

		FILE *fp1;
		int line=0;
		system("route > /var/routing.var");
		if ((fp1 = fopen("/var/routing.var","r"))!=NULL) {

			while (fgets(buffer, 100, fp1) > 0){
				if(line>0)
					websWrite(wp, T("%s"), buffer);
				line++;
			}
		fclose(fp1);
		}
		return 0;
	}
//**************************************** memory Display ****************************************
	else if ( !strcmp(name, T("getmem"))) {
		FILE *fp1;
		system("cat proc/meminfo > /var/memLog.var");
		if ((fp1 = fopen("/var/memLog.var","r"))!=NULL) {
			while (fgets(buffer, 100, fp1) > 0)
				websWrite(wp, T("%s"), buffer);
		fclose(fp1);
		}
		return 0;
	}
//**************************************** Security Log ****************************************
	else if ( !strcmp(name, T("seclog"))) {
		FILE *fp1;
		system("/bin/seclog.sh");
		if ((fp1 = fopen("/var/log/security","r"))!=NULL) {
			while (fgets(buffer, 100, fp1) > 0)
				websWrite(wp, T("%s"), buffer);
		fclose(fp1);
		}
		return 0;
	}
	else if ( !strcmp(name, T("sta-current"))) {

		int k;
		FILE *fp1;
		system("wan-status.sh");

		if ((fp1 = fopen("/var/run/wanstat","r"))!=NULL) {
			for (k=0;k<7;k++) {
				fgets(staTbl[0][k], 50, fp1);
			}
			fclose(fp1);
		}
		return websWrite(wp, T("%s"), staTbl[0][0]);
	}
#ifdef _MPPPOE_
	else if ( !strcmp(name, T("sta-current1"))) {

		int k;
		FILE *fp2;
		if ((fp2 = fopen("/var/run/wanstat1","r"))!=NULL) {
			for (k=0;k<7;k++) {
				fgets(staTbl[1][k], 50, fp2);
			}
			fclose(fp2);
		}
		return websWrite(wp, T("%s"), staTbl[1][0]);
	}
#endif
#ifdef _TRIPPPOE_
	else if ( !strcmp(name, T("sta-current2"))) {

		int k;
		FILE *fp3;
		if ((fp3 = fopen("/var/run/wanstat2","r"))!=NULL) {
			for (k=0;k<7;k++) {
				fgets(staTbl[2][k], 50, fp3);
			}
			fclose(fp3);
		}
		return websWrite(wp, T("%s"), staTbl[2][0]);
	}
#endif
	else if ( !strcmp(name, T("sta-ip"))) {		//Erwin modify 17.09
		int p;
		for( p=strlen(staTbl[0][1])-1; (isspace(staTbl[0][1][p]) || staTbl[0][1][p]==0) && p>=0 ;p--){
			staTbl[0][1][p]=0;}
		return websWrite(wp, T("%s"), staTbl[0][1]);
	}
#ifdef _MPPPOE_
	else if ( !strcmp(name, T("sta-ip1"))) //Erwin modify 17.09
		return websWrite(wp, T("%s"), staTbl[1][1]);
#endif
#ifdef _TRIPPPOE_
	else if (!strcmp(name, T("sta-ip2")))
		return websWrite(wp, T("%s"), staTbl[2][1]);
#endif
	else if ( !strcmp(name, T("sta-mask"))){
		int k;
		for( k=strlen(staTbl[0][2])-1; (isspace(staTbl[0][2][k]) || staTbl[0][2][k]==0) && k>=0 ;k--){
			staTbl[0][2][k]=0;}
		return websWrite(wp, T("%s"), staTbl[0][2]);
	}
#ifdef _MPPPOE_
	else if ( !strcmp(name, T("sta-mask1")))
		return websWrite(wp, T("%s"), staTbl[1][2]);
#endif
#ifdef _TRIPPPOE_
	else if ( !strcmp(name, T("sta-mask2")))
		return websWrite(wp, T("%s"), staTbl[2][2]);
#endif
	else if ( !strcmp(name, T("sta-gateway"))) {
		if ( getDefaultRoute(BRIDGE_IF, &intaddr) )
			return websWrite(wp, T("%s"), inet_ntoa(intaddr) );
		else
			return websWrite(wp, T("0.0.0.0"));
	}
	else if ( !strcmp(name, T("sta-mac")))
		return websWrite(wp, T("%s"), staTbl[0][3]);
	else if ( !strcmp(name, T("sta-dns1"))){
		int k;
		for( k=strlen(staTbl[0][4])-1; (isspace(staTbl[0][4][k]) || staTbl[0][4][k]==0) && k>=0 ;k--){
			staTbl[0][4][k]=0;}
		return websWrite(wp, T("%s"), staTbl[0][4]);
	}
	else if ( !strcmp(name, T("sta-dns2"))){
		int k;
		for( k=strlen(staTbl[0][5])-1; (isspace(staTbl[0][5][k]) || staTbl[0][5][k]==0) && k>=0 ;k--){
			staTbl[0][5][k]=0;}
		return websWrite(wp, T("%s"), staTbl[0][5]);
	}
#ifdef _MPPPOE_
	else if (!strcmp(name, T("sta-dns1-PPPOE2")))
		return websWrite(wp, T("%s"), staTbl[1][4]);
	else if (!strcmp(name, T("sta-dns2-PPPOE2")))
		return websWrite(wp, T("%s"), staTbl[1][5]);
#endif
#ifdef _TRIPPPOE_
	else if (!strcmp(name, T("sta-dns1-PPPOE3")))
		return websWrite(wp, T("%s"), staTbl[2][4]);
	else if (!strcmp(name, T("sta-dns2-PPPOE3")))
		return websWrite(wp, T("%s"), staTbl[2][5]);
#endif
	//-----------------------------------------------------------------------------
//************************************** USB Status ***************************************
#endif
	else if ( !strcmp(name, T("hwaddr"))) {
		if ( getInAddr(BRIDGE_IF, HW_ADDR, (void *)&hwaddr ) ) {
			pMacAddr = hwaddr.sa_data;
			return websWrite(wp, T("%02X:%02X:%02X:%02X:%02X:%02X"), pMacAddr[0], pMacAddr[1],pMacAddr[2], pMacAddr[3], pMacAddr[4], pMacAddr[5]);
		}
		else
			return websWrite(wp, T("12:34:56:78:90:ab"));
	}
        else if ( !strcmp(name, T("hwaddr-vxd"))) {
                if ( getInAddr("wlan0-vxd", HW_ADDR, (void *)&hwaddr ) ) {
                        pMacAddr = hwaddr.sa_data;
                        return websWrite(wp, T("%02x:%02x:%02x:%02x:%02x:%02x"), pMacAddr[0], pMacAddr[1],pMacAddr[2], pMacAddr[3], pMacAddr[4], pMacAddr[5]);
                }
                else
                        return websWrite(wp, T("00:00:00:00:00:00"));
        }
	else if ( !strcmp(name, T("bridgeMac"))) {
		if ( !apmib_get(MIB_ELAN_MAC_ADDR,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
						buffer[2], buffer[3], buffer[4], buffer[5]);
	}
//*************************************** Get HW_MAC flash value ***************************************
//20060417 pippen
	else if ( !strcmp(name, T("nic0mac"))) {
		if ( !apmib_get( MIB_HW_NIC0_ADDR, (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
				buffer[2], buffer[3], buffer[4], buffer[5]);
	}
	else if ( !strcmp(name, T("nic1mac"))) {
		if ( !apmib_get( MIB_HW_NIC1_ADDR, (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
				buffer[2], buffer[3], buffer[4], buffer[5]);
	}
	else if ( !strcmp(name, T("wlmac"))) {
		if ( !apmib_get( MIB_HW_WLAN_ADDR, (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
				buffer[2], buffer[3], buffer[4], buffer[5]);
	}
	else if ( !strcmp(name, T("wlmac1"))) {
                if ( !apmib_get( MIB_HW_WLAN_ADDR1, (void *)buffer) )
                        return -1;
                return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
                                buffer[2], buffer[3], buffer[4], buffer[5]);
        }
	else if ( !strcmp(name, T("wlmac2"))) {
                if ( !apmib_get( MIB_HW_WLAN_ADDR2, (void *)buffer) )
                        return -1;
                return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
                                buffer[2], buffer[3], buffer[4], buffer[5]);
        }
	else if ( !strcmp(name, T("wlmac3"))) {
                if ( !apmib_get( MIB_HW_WLAN_ADDR3, (void *)buffer) )
                        return -1;
                return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
                                buffer[2], buffer[3], buffer[4], buffer[5]);
        }
	else if ( !strcmp(name, T("wlmac4"))) {
                if ( !apmib_get( MIB_HW_WLAN_ADDR4, (void *)buffer) )
                        return -1;
                return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
                                buffer[2], buffer[3], buffer[4], buffer[5]);
        }
	else if ( !strcmp(name, T("flashregDomain"))) {
		if ( !apmib_get( MIB_HW_REG_DOMAIN, (void *)buffer) )
			return -1;
		return websWrite(wp, buffer);
	}
	/* Advance setting stuffs */
//******************************wireless setting for inprocomm ******************************
  	else if ( !strcmp(name, T("wlanTranRate"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WLAN_TRAN_RATE,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
//*********************************** Wireless Advance Setting ***********************************
//RexHua
  	else if ( !strcmp(name, T("wlanTxPower"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WLAN_TX_POWER,  (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}

	else if ( !strcmp(name, T("fragThreshold"))) {
		if ( !apmib_get( MIB_WLAN_FRAG_THRESHOLD, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("rtsThreshold"))) {
		if ( !apmib_get( MIB_WLAN_RTS_THRESHOLD, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("beaconInterval"))) {
		if ( !apmib_get( MIB_WLAN_BEACON_INTERVAL, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("dtimPeriod"))) {
		if ( !apmib_get( MIB_WLAN_DTIM_PERIOD, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("model"))) {

	}// kyle for Customer auto wpa key
	else if ( !strcmp(name, T("autowpakey"))) {
		FILE *fp;
			char buf[10];
			char buf2[100];
			char brf3[20];

	#ifdef _AUTOWPA_

		if ( !apmib_get( MIB_HW_NIC0_ADDR, (void *)buffer) )
			return -1;
		sprintf(brf3, "%02x%02x%02x%02x%02x%02x", buffer[0], buffer[1],
				buffer[2], buffer[3], buffer[4], buffer[5]);



			printf("DEBUG: mac=%s\n",buffer);
			sprintf(buf2,"/bin/AutoWPA %s > /var/autowpakey.var",brf3);
			printf("DEBUG: cmd=%s",buf2);
			system(buf2);
		if ((fp = fopen("/var/autowpakey.var","r"))!=NULL) {
			fgets(buf, 10, fp);
			fclose(fp);
		}else
			sprintf(buf, "%s", " ");
	#else
			sprintf(buf,"\"\"");
	#endif
		return websWrite(wp, buf);

	}
// kyle for Customer auto wep key
	else if ( !strcmp(name, T("autowepkey"))) {
			FILE *fp;
				char buf[10];
				char buf2[100];
				char brf3[20];
		#ifdef _WEP_MAC_

			if ( !apmib_get( MIB_HW_NIC0_ADDR, (void *)buffer) )
				return -1;
			sprintf(brf3, "%02x%02x%02x%02x%02x%02x", buffer[0], buffer[1],
					buffer[2], buffer[3], buffer[4], buffer[5]);

				sprintf(buf2,"/bin/AutoWPA %s pwepmac > /var/autowepkey.var",brf3);

				system(buf2);
			if ((fp = fopen("/var/autowepkey.var","r"))!=NULL) {
				fgets(buf, 100, fp);
				fclose(fp);
			}else
				sprintf(buf, "%s", " ");
		#else
			sprintf(buf,"\"\"");
		#endif



		return websWrite(wp, buf);

	}
// TODO: Following counter need to get from driver in the future
	else if ( !strcmp(name, T("lanTxPacketNum"))) {
		if ( getStats(ELAN_IF, &stats) < 0)
			stats.tx_packets = 0;
		sprintf(buffer, "%d", (int)stats.tx_packets);
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("lanRxPacketNum"))) {
		if ( getStats(ELAN_IF, &stats) < 0)
			stats.rx_packets = 0;
		sprintf(buffer, "%d", (int)stats.rx_packets);
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("lan2TxPacketNum"))) {
#ifdef _VLAN_CONFIG_SUPPORTED_
		if ( getStats(ELAN2_IF, &stats) < 0)
			stats.tx_packets = 0;
		sprintf(buffer, "%d", (int)stats.tx_packets);
#else
		sprintf(buffer, "%d", 0);
#endif
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("lan2RxPacketNum"))) {
#ifdef _VLAN_CONFIG_SUPPORTED_

		if ( getStats(ELAN2_IF, &stats) < 0)
			stats.rx_packets = 0;
		sprintf(buffer, "%d", (int)stats.rx_packets);
#else
		sprintf(buffer, "%d", 0);
#endif
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("lan3TxPacketNum"))) {
#ifdef _VLAN_CONFIG_SUPPORTED_
		if ( getStats(ELAN3_IF, &stats) < 0)
			stats.tx_packets = 0;
		sprintf(buffer, "%d", (int)stats.tx_packets);
#else
		sprintf(buffer, "%d", 0);
#endif
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("lan3RxPacketNum"))) {
#ifdef _VLAN_CONFIG_SUPPORTED_
		if ( getStats(ELAN3_IF, &stats) < 0)
			stats.rx_packets = 0;
		sprintf(buffer, "%d", (int)stats.rx_packets);
#else
		sprintf(buffer, "%d", 0);
#endif
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("lan4TxPacketNum"))) {
#ifdef _VLAN_CONFIG_SUPPORTED_
		if ( getStats(ELAN4_IF, &stats) < 0)
			stats.tx_packets = 0;
		sprintf(buffer, "%d", (int)stats.tx_packets);
#else
		sprintf(buffer, "%d", 0);
#endif
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("lan4RxPacketNum"))) {
#ifdef _VLAN_CONFIG_SUPPORTED_
		if ( getStats(ELAN4_IF, &stats) < 0)
			stats.rx_packets = 0;
		sprintf(buffer, "%d", (int)stats.rx_packets);
#else
		sprintf(buffer, "%d", 0);
#endif
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("wlanTxPacketNum"))) {
		if ( getStats(WLAN_IF, &stats) < 0)
			stats.tx_packets = 0;
		sprintf(buffer, "%d", (int)stats.tx_packets);
   		return websWrite(wp, buffer);

	}
	else if ( !strcmp(name, T("wlanRxPacketNum"))) {
		if ( getStats(WLAN_IF, &stats) < 0)
			stats.rx_packets = 0;
		sprintf(buffer, "%d", (int)stats.rx_packets);
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("bssid"))) {
		apmib_get( MIB_WLAN_DISABLED, (void *)&intVal);
		if ( intVal == 0 &&  getInAddr(WLAN_IF, HW_ADDR, (void *)&hwaddr ) ) {
			pMacAddr = hwaddr.sa_data;
			return websWrite(wp, T("%02x:%02x:%02x:%02x:%02x:%02x"), pMacAddr[0], pMacAddr[1],
				pMacAddr[2], pMacAddr[3], pMacAddr[4], pMacAddr[5]);
		}
		else
			return websWrite(wp, T("00:00:00:00:00:00"));
	}
//************************************** Wireless WDS **************************************
	else if ( !strcmp(name, T("wlLinkMac1"))) {
		if ( !apmib_get(MIB_WL_LINKMAC1,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
						buffer[2], buffer[3], buffer[4], buffer[5]);
	}
	else if ( !strcmp(name, T("wlLinkMac2"))) {
		if ( !apmib_get(MIB_WL_LINKMAC2,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
						buffer[2], buffer[3], buffer[4], buffer[5]);
	}
	else if ( !strcmp(name, T("wlLinkMac3"))) {
		if ( !apmib_get(MIB_WL_LINKMAC3,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
						buffer[2], buffer[3], buffer[4], buffer[5]);
	}
	else if ( !strcmp(name, T("wlLinkMac4"))) {
		if ( !apmib_get(MIB_WL_LINKMAC4,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
						buffer[2], buffer[3], buffer[4], buffer[5]);
	}
	else if ( !strcmp(name, T("wlLinkMac5"))) {
		if ( !apmib_get(MIB_WL_LINKMAC5,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
						buffer[2], buffer[3], buffer[4], buffer[5]);
	}
	else if ( !strcmp(name, T("wlLinkMac6"))) {
		if ( !apmib_get(MIB_WL_LINKMAC6,  (void *)buffer) )
			return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
						buffer[2], buffer[3], buffer[4], buffer[5]);
	}
//-----------------------------------------------------------------------------------------
#ifdef HOME_GATEWAY
	else if ( !strcmp(name, T("wanTxPacketNum"))) {
		if ( !apmib_get( MIB_OP_MODE, (void *)&opmode) )
			return -1;
//		if(opmode == WISP_MODE)
//			iface = WLAN_IF;
//		else
			iface = _WAN_IF_;
		if ( getStats(iface, &stats) < 0)
			stats.tx_packets = 0;
		sprintf(buffer, "%d", (int)stats.tx_packets);
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("wanRxPacketNum"))) {
		if ( !apmib_get( MIB_OP_MODE, (void *)&opmode) )
			return -1;
//		if(opmode == WISP_MODE)
//			iface = WLAN_IF;
//		else
			iface = _WAN_IF_;
		if ( getStats(iface, &stats) < 0)
			stats.rx_packets = 0;
		sprintf(buffer, "%d", (int)stats.rx_packets);
   		return websWrite(wp, buffer);
	}
	// Lance 2004.2.10
    else if ( !strcmp(name, T("PSName")) ) {
        buffer[0]='\0';
        if ( !apmib_get(MIB_PS_NAME,  (void *)buffer) )
            return -1;
        return websWrite(wp, buffer);
    }
	// Lance 2004.2.16
    else if ( !strcmp(name, T("PS_Port1Name")) ) {
        buffer[0]='\0';
        if ( !apmib_get(MIB_PS_PORT1NAME,  (void *)buffer) )
            return -1;
        return websWrite(wp, buffer);
    }
    else if ( !strcmp(name, T("PS_Port2Name")) ) {
        buffer[0]='\0';
        if ( !apmib_get(MIB_PS_PORT2NAME,  (void *)buffer) )
            return -1;
        return websWrite(wp, buffer);
    }
#endif
#ifdef WLAN_WPA
#if defined(_MULTIPLE_WLAN_RS_SETTING_)
	else if ( !strcmp(name, T("rsIpall"))) {
		apmib_get( MIB_WLAN_RS_IP,  (void *)&intaddr);   memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4); websWrite(wp, T("new Array(\"%s\","), inet_ntoa(intaddr));
		apmib_get( MIB_WLAN_RS_IP_1,  (void *)&intaddr); memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4); websWrite(wp, T("\"%s\","), inet_ntoa(intaddr));
		apmib_get( MIB_WLAN_RS_IP_2,  (void *)&intaddr); memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4); websWrite(wp, T("\"%s\","), inet_ntoa(intaddr));
		apmib_get( MIB_WLAN_RS_IP_3,  (void *)&intaddr); memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4); websWrite(wp, T("\"%s\","), inet_ntoa(intaddr));
		apmib_get( MIB_WLAN_RS_IP_4,  (void *)&intaddr); memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4); websWrite(wp, T("\"%s\","), inet_ntoa(intaddr));
		apmib_get( MIB_WLAN_RS_IP_5,  (void *)&intaddr); memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4); websWrite(wp, T("\"%s\","), inet_ntoa(intaddr));
		apmib_get( MIB_WLAN_RS_IP_6,  (void *)&intaddr); memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4); websWrite(wp, T("\"%s\","), inet_ntoa(intaddr));
		apmib_get( MIB_WLAN_RS_IP_7,  (void *)&intaddr); memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4); websWrite(wp, T("\"%s\")"), inet_ntoa(intaddr));
		return 0;
	}
	else if ( !strcmp(name, T("rsPortall")) ) {
		apmib_get( MIB_WLAN_RS_PORT, (void *)&intVal);			websWrite(wp, T("new Array(\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_PORT_1, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_PORT_2, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_PORT_3, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_PORT_4, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_PORT_5, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_PORT_6, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_PORT_7, (void *)&intVal);		websWrite(wp, T("\"%d\")"), intVal);
		return 0;
	}
	else if ( !strcmp(name, T("rsPasswordall"))) {
		buffer[0]='\0'; apmib_get( MIB_WLAN_RS_PASSWORD,   (void *)buffer);		websWrite(wp, T("new Array(\"%s\","), buffer);
		buffer[0]='\0'; apmib_get( MIB_WLAN_RS_PASSWORD_1, (void *)buffer);		websWrite(wp, T("\"%s\","), buffer);
		buffer[0]='\0'; apmib_get( MIB_WLAN_RS_PASSWORD_2, (void *)buffer);		websWrite(wp, T("\"%s\","), buffer);
		buffer[0]='\0'; apmib_get( MIB_WLAN_RS_PASSWORD_3, (void *)buffer);		websWrite(wp, T("\"%s\","), buffer);
		buffer[0]='\0'; apmib_get( MIB_WLAN_RS_PASSWORD_4, (void *)buffer);		websWrite(wp, T("\"%s\","), buffer);
		buffer[0]='\0'; apmib_get( MIB_WLAN_RS_PASSWORD_5, (void *)buffer);		websWrite(wp, T("\"%s\","), buffer);
		buffer[0]='\0'; apmib_get( MIB_WLAN_RS_PASSWORD_6, (void *)buffer);		websWrite(wp, T("\"%s\","), buffer);
		buffer[0]='\0'; apmib_get( MIB_WLAN_RS_PASSWORD_7, (void *)buffer);		websWrite(wp, T("\"%s\")"), buffer);
		return 0;
	}
	else if ( !strcmp(name, T("rsIntervalall")) ) {
		apmib_get( MIB_WLAN_RS_INTERVAL_TIME, (void *)&intVal);			websWrite(wp, T("new Array(\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_INTERVAL_TIME_1, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_INTERVAL_TIME_2, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_INTERVAL_TIME_3, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_INTERVAL_TIME_4, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_INTERVAL_TIME_5, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_INTERVAL_TIME_6, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_RS_INTERVAL_TIME_7, (void *)&intVal);		websWrite(wp, T("\"%d\")"), intVal);
		return 0;
	}
	else if ( !strcmp(name, T("accountRsIntervalall")) ) {
		apmib_get( MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME, (void *)&intVal);			websWrite(wp, T("new Array(\"%d\","), intVal);
		apmib_get( MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_1, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_2, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_3, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_4, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_5, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_6, (void *)&intVal);		websWrite(wp, T("\"%d\","), intVal);
		apmib_get( MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_7, (void *)&intVal);		websWrite(wp, T("\"%d\")"), intVal);
		return 0;
	}
#endif
	else if ( !strcmp(name, T("rsIp"))) {
		if ( !apmib_get( MIB_WLAN_RS_IP,  (void *)&intaddr) )
			return -1;
		if (!memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4))
			return websWrite(wp, T(""));
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("rsPort"))) {
		if ( !apmib_get( MIB_WLAN_RS_PORT, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
 	else if ( !strcmp(name, T("rsPassword"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WLAN_RS_PASSWORD,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("accountRsIp"))) {
		if ( !apmib_get( MIB_WLAN_ACCOUNT_RS_IP,  (void *)&intaddr) )
			return -1;
		if (!memcmp((unsigned char *)&intaddr, "\x0\x0\x0\x0", 4))
			return websWrite(wp, T(""));
   		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("accountRsPort"))) {
		if ( !apmib_get( MIB_WLAN_ACCOUNT_RS_PORT, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("accountRsPassword"))) {
		buffer[0]='\0';
		if ( !apmib_get( MIB_WLAN_ACCOUNT_RS_PASSWORD,  (void *)buffer) )
			return -1;
   		return websWrite(wp, buffer);
	}
#if defined(_Customer_EX_) || defined(_Customer_SA_)
        else if ( !strcmp(name, T("groupRekeyTime"))) {
                int val;
                apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME, (void *)&val);
#ifdef _MSSID_
                websWrite(wp, T("new Array(\"%d\","), val);
                apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME_1, (void *)&val);
                websWrite(wp, T("\"%d\","), val);
                apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME_2, (void *)&val);
                websWrite(wp, T("\"%d\","), val);
                apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME_3, (void *)&val);
                websWrite(wp, T("\"%d\","), val);
                apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME_4, (void *)&val);
                websWrite(wp, T("\"%d\","), val);
                apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME_5, (void *)&val);
                websWrite(wp, T("\"%d\","), val);
                apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME_6, (void *)&val);
                websWrite(wp, T("\"%d\","), val);
                apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME_7, (void *)&val);
                websWrite(wp, T("\"%d\")"), val);
#else
                websWrite(wp, T("new Array(\"%d\")"), val);
#endif
                return 0;
        }
#else
	else if ( !strcmp(name, T("groupRekeyTime"))) {
		if ( !apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
#endif
        else if ( !strcmp(name, T("groupRekeyTime"))) {
                if ( !apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME, (void *)&intVal) )
                        return -1;
                sprintf(buffer, "%d", intVal );
                return websWrite(wp, buffer);
        }
	else if ( !strcmp(name, T("groupRekeyTimeDay"))) {
		if ( !apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal/86400 );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("groupRekeyTimeHr"))) {
		if ( !apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", (intVal%86400)/3600 );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("groupRekeyTimeMin"))) {
		if ( !apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", ((intVal%86400)%3600)/60 );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("groupRekeyTimeSec"))) {
		if ( !apmib_get( MIB_WLAN_WPA_GROUP_REKEY_TIME, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", ((intVal%86400)%3600)%60 );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("wdsPskValue"))) {
		int i;
		buffer[0]='\0';
		if ( !apmib_get(MIB_WLAN_WDS_WPA_PSK,  (void *)buffer) )
			return -1;
		for (i=0; i<strlen(buffer); i++)
			buffer[i]='*';
		buffer[i]='\0';
   		return websWrite(wp, buffer);
	}
 	else if ( !strcmp(name, T("pskValue"))) {
		int i;
		buffer[0]='\0';
		if ( !apmib_get(MIB_WLAN_WPA_PSK,  (void *)buffer) )
			return -1;
		for (i=0; i<strlen(buffer); i++)
			buffer[i]='*';
		buffer[i]='\0';
   		return websWrite(wp, buffer);
	}
	
#ifdef _MSSID_ //vance
 	else if ( !strcmp(name, T("pskValue1"))) {
 			int i;
 			buffer[0]='\0';
 			if ( !apmib_get(MIB_WLAN_WPA_PSK_1,  (void *)buffer) )
 				return -1;
  			for (i=0; i<strlen(buffer); i++)
  				buffer[i]='*';
 			buffer[i]='\0';
 	   		return websWrite(wp, buffer);
 		}
 #endif
	//**************************** pinNumber from client**************
	 	else if ( !strcmp(name, T("pinNumber"))) {
		int i;
		buffer[0]='\0';
		if ( !apmib_get(MIB_WPS_PIN_CODE,  (void *)buffer) )
			return -1;
   return websWrite(wp, buffer);
	}
	//**************************************** get wps pincode , kyle ****************************************
	else if ( !strcmp(name, T("pinCode"))) {
		FILE *fp1;
		system("wpstool Pincode");
		if ((fp1 = fopen("/var/pincode.var","r"))!=NULL) {
			if(	fgets(buffer, 100, fp1) <= 0)
				sprintf( buffer, "%s" ,"0");

				if(buffer[strlen(buffer)-1] == '\n')
					buffer[strlen(buffer)-1] ='\0';

			fclose(fp1);

			}else{
				sprintf( buffer, "%s" ,"0");
			}
			return websWrite(wp, T("%s"), buffer);

	}
 	else if ( !strcmp(name, T("wpsPskValue"))) {
		buffer[0]='\0';
		if ( !apmib_get(MIB_WLAN_WPA_PSK,  (void *)buffer) )
			return -1;

   		return websWrite(wp, buffer);
	}
#ifdef _MSSID_ //vance
	else if ( !strcmp(name, T("wpsPskValue1"))) {
		buffer[0]='\0';
		if ( !apmib_get(MIB_WLAN_WPA_PSK_1,  (void *)buffer) )
			return -1;

   		return websWrite(wp, buffer);
	}
#endif
	else if ( !strcmp(name, T("accountRsUpdateDelay"))) {
		if ( !apmib_get( MIB_WLAN_ACCOUNT_UPDATE_DELAY, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("rsInterval"))) {
		if ( !apmib_get( MIB_WLAN_RS_INTERVAL_TIME, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("accountRsInterval"))) {
		if ( !apmib_get( MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
#endif

#ifdef HOME_GATEWAY // For Guarantee QoS
	else if ( !strcmp(name, T("maxdownbandwidth"))) {
		if ( !apmib_get( MIB_MAX_DOWNLOAD_BANDWIDTH, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("maxupbandwidth"))) {
		if ( !apmib_get( MIB_MAX_UPLOAD_BANDWIDTH, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
   		return websWrite(wp, buffer);
	}
#endif
#ifdef _QoS_MODE_SELECT_   // QoS select mode
	else if ( !strcmp(name, T("QOSTYPE"))) {
		if ( !apmib_get( MIB_QoS_QOSTYPE, (void *)&intVal) )
			return -1;
		sprintf(buffer, "%d", intVal );
	   	return websWrite(wp, buffer);
	}
#endif

	else if ( !strcmp(name, T("modelname")) ){
		#ifdef __TARGET_BOARD__
			system("cat /web/FUNCTION_SCRIPT | grep ^_MODEL_= | cut -f 2 -d \\\" > /tmp/modelnametmp");
		#else
			system("cat ../web/FUNCTION_SCRIPT | grep ^_MODEL_= | cut -f 2 -d \\\" > /tmp/modelnametmp");
		#endif

		FILE *ptr;
		ptr=fopen("/tmp/modelnametmp","r");
		fgets(buffer,100,ptr);
		fclose(ptr);
		system("rm -rf /tmp/modelnametmp");

			return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("modulename"))){
		#ifdef __TARGET_BOARD__
			system("cat /web/FUNCTION_SCRIPT | grep ^_MODE_= | cut -f 2 -d \\\" > /tmp/modenametmp");
		#else
			system("cat ../web/FUNCTION_SCRIPT | grep ^_MODE_= | cut -f 2 -d \\\" > /tmp/modenametmp");
		#endif

		FILE *ptr;
		ptr=fopen("/tmp/modenametmp","r");
		fgets(buffer,100,ptr);
		fclose(ptr);

		// remove space characters behind buffer[]
		intVal=strlen(buffer);
		while( buffer[intVal]=='\0' || buffer[intVal]==' ' || buffer[intVal]=='\n' || buffer[intVal]=='\t')
		{
			buffer[intVal]='\0';
			intVal=intVal-1;
		}

		system("rm -rf /tmp/modenametmp");
		return websWrite(wp, buffer);
	}
#ifdef UNIVERSAL_REPEATER
	else if ( !strcmp(name, T("repeaterSSID"))) {
		if ( !apmib_get( MIB_REPEATER_SSID, (void *)&buffer) )
			return -1;
#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
			CharFilter2(buffer);
#endif
   		return websWrite(wp, buffer);
	}
#endif

#ifdef _WISP_
	else if ( !strcmp(name, T("stadrv_type"))){
//		if ( !apmib_get( MIB_STADRV_TYPE,  (void *)&intVal) ) return -1;
		if ( !apmib_get( MIB_OP_MODE,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
  		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_ssid"))){
		if ( !apmib_get( MIB_STADRV_SSID,  (void *)buffer) ) return -1;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
			CharFilter2(buffer);
		#endif
//		return websWrite(wp, T("%s"), buffer);
	    return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_chan"))){
		if ( !apmib_get( MIB_STADRV_CHAN_NUM,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
  		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_band"))){
		if ( !apmib_get( MIB_STADRV_BAND,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
  		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_encrypttype"))){
		if ( !apmib_get( MIB_STADRV_ENCRYPT_TYPE,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
  		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_weplength"))){
		if ( !apmib_get( MIB_STADRV_WEP_LENGTH,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
  		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_wepformat"))){
		if ( !apmib_get( MIB_STADRV_WEP_FORMAT1,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
  		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_wepformat2"))){
		if ( !apmib_get( MIB_STADRV_WEP_FORMAT2,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
  		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_wepformat3"))){
		if ( !apmib_get( MIB_STADRV_WEP_FORMAT3,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
  		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_wepformat4"))){
		if ( !apmib_get( MIB_STADRV_WEP_FORMAT4,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
  		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_defaultkey"))){
		if ( !apmib_get( MIB_STADRV_WEP_DEFAULT_KEY,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
  		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_wepkey1"))){
		if ( !apmib_get( MIB_STADRV_WEPKEY1,  (void *)buffer) ) return -1;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
			CharFilter2(buffer);
		#endif
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("stadrv_wepkey2"))){
		if ( !apmib_get( MIB_STADRV_WEPKEY2,  (void *)buffer) ) return -1;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
			CharFilter2(buffer);
		#endif
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("stadrv_wepkey3"))){
		if ( !apmib_get( MIB_STADRV_WEPKEY3,  (void *)buffer) ) return -1;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
			CharFilter2(buffer);
		#endif
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("stadrv_wepkey4"))){
		if ( !apmib_get( MIB_STADRV_WEPKEY4,  (void *)buffer) ) return -1;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
			CharFilter2(buffer);
		#endif
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("stadrv_wpacipher"))){
		if ( !apmib_get( MIB_STADRV_WPA_CIPHER,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
  		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_pskformat"))){
		if ( !apmib_get( MIB_STADRV_PSK_FORMAT,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
 		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_pskkey"))){
		if ( !apmib_get( MIB_STADRV_PSKKEY,  (void *)buffer) ) return -1;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
			CharFilter2(buffer);
		#endif
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("stadrv_wantype"))){
		if ( !apmib_get( MIB_STADRV_WANTYPE,  (void *)&intVal) ) return -1;
		sprintf(buffer, "%d", intVal );
 		return websWrite(wp, buffer);
	}
	else if ( !strcmp(name, T("stadrv_hostname"))){
		if ( !apmib_get( MIB_STADRV_HOSTNAME,  (void *)buffer) ) return -1;
		#if defined(_SPECIAL_CHAR_FILTER_IN_SCRIPT_)
			CharFilter2(buffer);
		#endif
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("stadrv_clonemac"))){
		if ( !apmib_get(MIB_STADRV_CLONEMAC,  (void *)buffer) ) return -1;
		return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1], buffer[2], buffer[3], buffer[4], buffer[5]);
	}
	else if ( !strcmp(name, T("stadrv_ip"))){
		if ( !apmib_get( MIB_STADRV_IP,  (void *)&intaddr) ) return -1;
  		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("stadrv_mask"))){
		if ( !apmib_get( MIB_STADRV_MASK,  (void *)&intaddr) ) return -1;
  		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
	else if ( !strcmp(name, T("stadrv_gateway"))){
		if ( !apmib_get( MIB_STADRV_GATEWAY,  (void *)&intaddr) ) return -1;
  		return websWrite(wp, T("%s"), inet_ntoa(intaddr));
	}
#endif
#ifdef _SDMZ_
   else if ( !strcmp(name, T("dmz_mac")))
    {
	   if ( !apmib_get(MIB_DMZ_MAC_ADDR,  (void *)buffer) ) return -1;
	   return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1], buffer[2], buffer[3], buffer[4], buffer[5]);
    }
	else if ( !strcmp(name, T("refresh_time")))
	{
		if(!apmib_get( MIB_SUPERDMZ_REFRESHTIME, (void *)&intVal)) return -1;
      return websWrite(wp, T("%d"), intVal);
	}
#endif
#ifdef _Systempingtool_
   else if ( !strcmp(name, T("pingresult")))
   	{
        	FILE *ptr;
        	if((ptr=fopen("/tmp/pingresultdata.txt","r"))!=NULL)
        	{
        		while(fgets(buffer,100, ptr)>0)
        		{
        			websWrite(wp, T("%s\n"),buffer);
        		}
        		fclose(ptr);
        	}
        	return 0;
   }
#endif
#ifdef _CONNECTION_CTRL_
   else if ( !strcmp(name, T("connection_ctrlSet")))
	{
		apmib_get( MIB_CONNECCOUNT_MAX, (void *)&intVal);		websWrite(wp, T("var connectionMax=%d;\n"), intVal);
		apmib_get( MIB_UDPCOUNT_MAX, (void *)&intVal);			websWrite(wp, T("var udpcountMax=%d;\n"), intVal);
		apmib_get( MIB_ICMPCOUNT_MAX, (void *)&intVal);			websWrite(wp, T("var icmpcountMax=%d;\n"), intVal);
		apmib_get( MIB_TCPCOUNT_MAX, (void *)&intVal);			websWrite(wp, T("var tcpcountMax=%d;\n"), intVal);
		apmib_get( MIB_TIMEOUT_ESTABLISHED, (void *)&intVal);	websWrite(wp, T("var establishedTimeout=%d;\n"), intVal);
		apmib_get( MIB_TIMEOUT_SYNSENT, (void *)&intVal);		websWrite(wp, T("var synsentTimeout=%d;\n"), intVal);
		apmib_get( MIB_TIMEOUT_SYNRECV, (void *)&intVal);		websWrite(wp, T("var synrecvTimeout=%d;\n"), intVal);
		apmib_get( MIB_TIMEOUT_FINWAIT, (void *)&intVal);		websWrite(wp, T("var finwaitTimeout=%d;\n"), intVal);
		apmib_get( MIB_TIMEOUT_CLOSEWAIT, (void *)&intVal);	websWrite(wp, T("var closewaitTimeout=%d;\n"), intVal);
		apmib_get( MIB_TIMEOUT_LASTACK, (void *)&intVal);		websWrite(wp, T("var lastackTimeout=%d;\n"), intVal);
		apmib_get( MIB_TIMEOUT_GENERIC, (void *)&intVal);		websWrite(wp, T("var genericTimeout=%d;\n"), intVal);
		return 0;
	}
#endif

#ifdef _BR6428PNL_	//Felix add 20101220
	else if ( !strcmp(name, T("index_select")) )
	{
#ifdef _Customer_SC_
		return websWrite(wp, T("<frame name=\"lFrame\" src=\"template_converter.asp\" scrolling=\"no\">\n<frame name=\"main\" src=\"information_cv.asp\">"));
#else
		return websWrite(wp, T("<frame name=\"lFrame\" src=\"template3.asp\" scrolling=\"no\">\n<frame name=\"main\" src=\"information.asp\">"));
#endif
	}
#endif
	
	else if ( !strcmp(name, T("set_wizrad_index")) )
	{
#ifdef _SETTING_WIZARD_
		if ( !apmib_get( MIB_IS_RESET_DEFAULT,  (void *)&intVal) ) return -1;
		if ( !apmib_get( MIB_AP_MODE,  (void *)&intVal2) ) return -1;
		if ( intVal == 0)
		{
			wizardEnabled = 1;
			websWrite(wp, T("<frameset rows=\"*\" cols=\"*\" border=\"0\" framespacing=\"0\" frameborder=\"no\">\n"));
			if ( intVal2 == 0)
				{websWrite(wp, T("<frame name=\"main\" src=\"wizard_ssid.asp\">\n"));}
			else
				{websWrite(wp, T("<frame name=\"main\" src=\"wizard_survey.asp\">\n"));}
			return websWrite(wp, T("</frameset>\n"));
		}
		else
		{
			return websWrite(wp, T("<frameset rows=\"88,*\" cols=\"*\" border=\"0\" framespacing=\"0\" frameborder=\"no\">\n \
						<frame name=\"topFrame\" scrolling=\"no\" noresize=\"noresize\" src=\"title.asp\">\n \
						<frameset rows=\"*\" cols=\"186,*\" border=\"0\" framespacing=\"0\" frameborder=\"no\">\n \
						<frame name=\"lFrame\" src=\"template3.asp\" scrolling=\"no\">\n \
						<frame name=\"main\" src=\"information.asp\">\n \
						</frameset>\n</frameset>\n"));
		}
#else
		return websWrite(wp, T("<frameset rows=\"88,*\" cols=\"*\" border=\"0\" framespacing=\"0\" frameborder=\"no\">\n \
					<frame name=\"topFrame\" scrolling=\"no\" noresize=\"noresize\" src=\"title.html\">\n \
					<frameset rows=\"*\" cols=\"186,*\" border=\"0\" framespacing=\"0\" frameborder=\"no\">\n \
					<frame name=\"lFrame\" src=\"template3.asp\" scrolling=\"no\">\n \
					<frame name=\"main\" src=\"information.asp\">\n \
					</frameset>\n</frameset>\n"));
#endif
	}
#if 1
 	else if ( !strcmp(name, T("reset_default")) )
 	{
                  if ( !apmib_get( MIB_IS_RESET_DEFAULT, (void *)&intVal) )
                          return -1;
                  sprintf(buffer, "%d", intVal );
                  return websWrite(wp, buffer);
	}
#endif
#if defined(_Airlive_7428HCN_)  //for Airlive EW7428HCN
        else if ( !strcmp(name, T("ManuCloneMac"))) {
        if ( !apmib_get(MIB_CLONE_MAC_ADDR,  (void *)buffer) )
                        return -1;
                return websWrite(wp, T("%02x%02x%02x%02x%02x%02x"), buffer[0], buffer[1],
                                                        buffer[2], buffer[3], buffer[4], buffer[5]);

        }
        else if ( !strcmp(name, T("loginpassword")) ) {  //no use
                buffer[0]='\0';
                if ( !apmib_get(MIB_USER_PASSWORD,  (void *)buffer) )
                        return -1;
                return websWrite(wp, buffer);
        }
        else if ( !strcmp(name, T("deviceName")) ) {
                buffer[0]='\0';
                if ( !apmib_get(MIB_DEVICE_NAME,  (void *)buffer) )
                        return -1;

                return websWrite(wp, buffer);
        }
        else if ( !strcmp(name, T("ackTimeout"))) {
                if ( !apmib_get( MIB_ACK_TIMEOUT, (void *)&intVal) )
                        return -1;
                sprintf(buffer, "%d", intVal );
                return websWrite(wp, buffer);
        }
#endif
#ifdef _SYSTEM_LOG_
        else if ( !strcmp(name, T("rtLogServer"))) {
                if ( !apmib_get( MIB_REMOTELOG_SERVER,  (void *)buffer) )
                        return -1;
                if (!memcmp(buffer, "\x0\x0\x0\x0", 4))
                        return websWrite(wp, T(""));
                return websWrite(wp, T("%s"), inet_ntoa(*((struct in_addr *)buffer)) );
        }
#endif

#ifdef _RTK_NTP_
	else if ( !strcmp(name, T("year"))) {
		time(&current_secs);
		tm_time = localtime(&current_secs);
		#if 0
		sprintf(buffer , "%2d/%2d/%d %2d:%2d:%2d %s",
				(tm_time->tm_mon),
				(tm_time->tm_mday), (tm_time->tm_year+ 1900),
				(tm_time->tm_hour),
				(tm_time->tm_min),(tm_time->tm_sec)
				, _tzname[tm_time->tm_isdst]);
		#endif
		sprintf(buffer,"%d", (tm_time->tm_year+ 1900));
		return websWrite(wp, T("%s"), buffer);
	}

	else if ( !strcmp(name, T("month"))) {
		time(&current_secs);
		tm_time = localtime(&current_secs);
		sprintf(buffer,"%d", (tm_time->tm_mon+1));
		return websWrite(wp, T("%s"), buffer);
	}

	else if ( !strcmp(name, T("day"))) {
		time(&current_secs);
		tm_time = localtime(&current_secs);
		sprintf(buffer,"%d", (tm_time->tm_mday));
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("hour"))) {
		time(&current_secs);
		tm_time = localtime(&current_secs);
		sprintf(buffer,"%d", (tm_time->tm_hour));
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("minute"))) {
		time(&current_secs);
		tm_time = localtime(&current_secs);
		sprintf(buffer,"%d", (tm_time->tm_min));
		return websWrite(wp, T("%s"), buffer);
	}
	else if ( !strcmp(name, T("second"))) {
		time(&current_secs);
		tm_time = localtime(&current_secs);
		sprintf(buffer,"%d", (tm_time->tm_sec));
		return websWrite(wp, T("%s"), buffer);
	}
        else if ( !strcmp(name, T("ntpServerIp2"))) { // sc_yang
                if ( !apmib_get( MIB_NTP_SERVER_IP2,  (void *)buffer) )
                        return -1;
                if (!memcmp(buffer, "\x0\x0\x0\x0", 4))
                        return websWrite(wp, T(""));
                return websWrite(wp, T("%s"), inet_ntoa(*((struct in_addr *)buffer)) );
        }

#endif

#ifdef _WEB_PORT_
        else if ( !strcmp(name, T("webPort")) ) {
                if ( !apmib_get(MIB_WEB_PORT,  (void *)&intVal))
                        return -1;
                sprintf(buffer, "%d", intVal );
                return websWrite(wp, buffer);
        }
#endif

#ifdef _Airlive_Schedule_
	else if ( !strcmp(name, T("enableTbl"))) {
                apmib_get( MIB_WLSCH_ENABLED_1,  (void *)&intVal) ;
                websWrite(wp, T("new Array(%d,"), intVal);
                apmib_get( MIB_WLSCH_ENABLED_2,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_ENABLED_3,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_ENABLED_4,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_ENABLED_5,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_ENABLED_6,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_ENABLED_7,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_ENABLED_8,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_ENABLED_9,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_ENABLED_10,  (void *)&intVal) ;
		websWrite(wp, T("%d)"), intVal);
	}
	else if ( !strcmp(name, T("dayTbl"))) {
                apmib_get( MIB_WLSCH_DAY1,  (void *)&intVal) ;
                websWrite(wp, T("new Array(%d,"), intVal);
                apmib_get( MIB_WLSCH_DAY2,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_DAY3,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_DAY4,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_DAY5,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_DAY6,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_DAY7,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_DAY8,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_DAY9,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_DAY10,  (void *)&intVal) ;
                websWrite(wp, T("%d)"), intVal);
	}
        else if ( !strcmp(name, T("fromHourTbl"))) {
                apmib_get( MIB_WLSCH_FROM_HOUR1,  (void *)&intVal) ;
                websWrite(wp, T("new Array(%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_HOUR2,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_HOUR3,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_HOUR4,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_HOUR5,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_HOUR6,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_HOUR7,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_HOUR8,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_HOUR9,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_HOUR10,  (void *)&intVal) ;
                websWrite(wp, T("%d)"), intVal);
	}
        else if ( !strcmp(name, T("toHourTbl"))) {
                apmib_get( MIB_WLSCH_TO_HOUR1,  (void *)&intVal) ;
                websWrite(wp, T("new Array(%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_HOUR2,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_HOUR3,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_HOUR4,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_HOUR5,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_HOUR6,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_HOUR7,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_HOUR8,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_HOUR9,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_HOUR10,  (void *)&intVal) ;
                websWrite(wp, T("%d)"), intVal);
	}
        else if ( !strcmp(name, T("fromMinTbl"))) {
		apmib_get( MIB_WLSCH_FROM_MIN1,  (void *)&intVal) ;
		websWrite(wp, T("new Array(%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_MIN2,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_MIN3,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_MIN4,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_MIN5,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_MIN6,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_MIN7,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_MIN8,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_MIN9,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_FROM_MIN10,  (void *)&intVal) ;
                websWrite(wp, T("%d)"), intVal);
	}
        else if ( !strcmp(name, T("toMinTbl"))) {
                apmib_get( MIB_WLSCH_TO_MIN1,  (void *)&intVal) ;
                websWrite(wp, T("new Array(%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_MIN2,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_MIN3,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_MIN4,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_MIN5,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_MIN6,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_MIN7,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_MIN8,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_MIN9,  (void *)&intVal) ;
                websWrite(wp, T("%d,"), intVal);
                apmib_get( MIB_WLSCH_TO_MIN10,  (void *)&intVal) ;
                websWrite(wp, T("%d)"), intVal);
        }
#endif

#ifdef _RTK_NTP_
        else if ( !strcmp(name, T("ntpServerIp1"))) { // sc_yang
                if ( !apmib_get( MIB_NTP_SERVER_IP1,  (void *)buffer) )
                        return -1;
                if (!memcmp(buffer, "\x0\x0\x0\x0", 4))
                        return websWrite(wp, T(""));

                return websWrite(wp, T("%s"), inet_ntoa(*((struct in_addr *)buffer)) );
        }
        else if ( !strcmp(name, T("ntpServerIp2"))) { // sc_yang
                if ( !apmib_get( MIB_NTP_SERVER_IP2,  (void *)buffer) )
                        return -1;
                if (!memcmp(buffer, "\x0\x0\x0\x0", 4))
                        return websWrite(wp, T(""));
                return websWrite(wp, T("%s"), inet_ntoa(*((struct in_addr *)buffer)) );
        }
        else if ( !strcmp(name, T("ntpTimeZone"))) { // sc_yang
                if ( !apmib_get( MIB_NTP_TIMEZONE,  (void *)buffer) )
                        return -1;
                return websWrite(wp, T("%s"), buffer);
        }
#endif
		else if ( !strcmp(name, T("ipfinder"))) {
			unsigned char finder_SSID[100];
			unsigned char finder_BSSID[100];
			unsigned char finder_MODE[100];
			unsigned char finder_CH[100];
			unsigned char finder_SEC[100];
			char *p, *delim="&", *tmp;
//			char *auth_delim="\"", *login_password;
			int isWEP=0, isWPA=0, intTkip=0, intAes=0;
			char *pwd;
			char auth_userpass[0x80];
			if (strstr(wp->query_string,"action=list"))
			{ 
				if (strstr(wp->query_string,"Network.Wireless"))
				{
					apmib_get( MIB_WLAN_SSID,  (void *)finder_SSID);
					
					if ( getInAddr(BRIDGE_IF, HW_ADDR, (void *)&hwaddr ) ) {
						pMacAddr = hwaddr.sa_data;
						sprintf(finder_BSSID, "%02X:%02X:%02X:%02X:%02X:%02X", pMacAddr[0], pMacAddr[1],pMacAddr[2], pMacAddr[3], pMacAddr[4], pMacAddr[5]);
					}
					
					if ( !apmib_get( MIB_WLAN_CHAN_NUM,  (void *)&intVal) )
						return -1;
					if (intVal==0)
						sprintf(finder_CH, "%s", "auto" );
					else
						sprintf(finder_CH, "%d", intVal );
					sprintf(buffer, "Network.Wireless.ESSID=%s\r\nNetwork.Wireless.BSSID=%s\r\nNetwork.Wireless.Mode=managed\r\nNetwork.Wireless.Channel=%s\r\nNetwork.Wireless.SecurityMode=none\r\n", finder_SSID, finder_BSSID, finder_CH);
				}
				else if (strstr(wp->query_string,"Network.Interface"))
				{
					sprintf(buffer, "Network.Interface.I1.Link.BootProto=dhcp\r\nNetwork.InterfaceSelectMode=auto");
				}
				else if (strstr(wp->query_string,"Network.Bonjour.Enabled"))
				{
					if ( ! strncasecmp(wp->authorization,"Basic ",6))
					{
						base64decode(auth_userpass,wp->authorization+6,sizeof(auth_userpass));
						if ( (pwd = strchr(auth_userpass,':')) == 0 )
						{						
							send_r_bad_request(wp);
							return 0;
						}
						*pwd++=0;
						if (auth_check_userpass2(wp, auth_userpass,pwd)) 
						{					
							send_r_unauthorized(wp,server_name);
							return websWrite(wp, "");
						}
					}
					else
					{
						send_r_unauthorized(wp,server_name);
						return websWrite(wp, "");
					}	
					
					/*
					tmp = wp->authorization + strlen("Digest username=admin,realm=\"");
					login_password=strtok(tmp,auth_delim);
					apmib_get(MIB_USER_PASSWORD,  (void *)buffer);
					printf("=====> login_password = %s , USER_PASSWORD = %s \n", login_password, buffer);
					if ( ! strstr(login_password, buffer) )
					{
						send_r_unauthorized(wp,server_name);
						return websWrite(wp, "");
					}
					*/
				}
			}
			else
			{
				printf("========== start update ==========\n");
				strtok(wp->query_string,delim);
				while( (p=strtok(NULL,delim)) )
				{
					if (strstr(p,"ESSID"))
					{
						tmp = p + strlen("Network.Wireless.ESSID=");
						apmib_set( MIB_WLAN_SSID, (void *)tmp);
					}
					
					if (strstr(p,"Wireless.SecurityMode"))
					{
						isWEP=0; isWPA=0;
						tmp = p + strlen("Network.Wireless.SecurityMode=");
						if( !strcmp(tmp, "wep") )
						{
							isWEP=1;
							intVal=1;
							apmib_set( MIB_SECURITY_MODE, (void *)&intVal);
							apmib_set( MIB_WLAN_ENCRYPT, (void *)&intVal);
							continue ;
						}
						else if ( !strcmp(tmp, "wpa-psk") )
						{
							isWPA=1;
							intVal=2;
							apmib_set( MIB_SECURITY_MODE, (void *)&intVal);
							continue;
						}
					}
					
					if (isWEP)
					{
       int keyLen64, keyLen128;
       char key64[30], key128[30];
       keyLen64 = WEP64_KEY_LEN*2;
       keyLen128 = WEP128_KEY_LEN*2;
      // char_t *wepKey;
							if (strstr(p,"Key1"))
							{
								intVal=0;
								apmib_set( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&intVal);
        //printf("\n==>WEP_KEY1\n");							
								tmp = p + strlen("Network.Wireless.WEP.Key1=");	

        string_to_hex(tmp, key64, keyLen64);
        string_to_hex(tmp, key128, keyLen128);

        //printf("\n==>string_to_hex=%d\n",string_to_hex);
        
        if ( strlen(tmp) == 5 ){ 	//ascii
        //printf("\n==>ASCII 5\n");				
									apmib_set( MIB_WLAN_WEP64_KEY1, (void *)tmp);
        }
        else if ( strlen(tmp) == 13 )  {
        //printf("\n==>ASCII 13\n");			
									apmib_set( MIB_WLAN_WEP128_KEY1, (void *)tmp);
        }

        if ( strlen(tmp) == 10 ){
        //printf("\n==>HEX10\n");
			
								apmib_set( MIB_WLAN_WEP64_KEY1, (void *)key64);
        }
        else if ( strlen(tmp) == 26 ){
        //printf("\n==>HEX26\n");
									apmib_set( MIB_WLAN_WEP128_KEY1, (void *)key128);
        }
							}
							else if (strstr(p,"Key2"))
							{
								intVal=1;
								apmib_set( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&intVal);
        //printf("\n==>WEP_KEY2\n");									
								tmp = p + strlen("Network.Wireless.WEP.Key2=");
        
        string_to_hex(tmp, key64, keyLen64);
        string_to_hex(tmp, key128, keyLen128);
							
        if ( strlen(tmp) == 5 || strlen(tmp) == 10 ){ 					
									apmib_set( MIB_WLAN_WEP64_KEY2, (void *)tmp);
        }
        else {
									apmib_set( MIB_WLAN_WEP128_KEY2, (void *)tmp);
        }
        if ( strlen(tmp) == 10 ){
       // printf("\n==>HEX10\n");
			
								apmib_set( MIB_WLAN_WEP64_KEY2, (void *)key64);
        }
        else if ( strlen(tmp) == 26 ){
        //printf("\n==>HEX26\n");
									apmib_set( MIB_WLAN_WEP128_KEY2, (void *)key128);
        }					
							}
							else if (strstr(p,"Key3"))
							{
								intVal=2;
								apmib_set( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&intVal);
        //printf("\n==>WEP_KEY3\n");									
								tmp = p + strlen("Network.Wireless.WEP.Key3=");				

        string_to_hex(tmp, key64, keyLen64);
        string_to_hex(tmp, key128, keyLen128);
			
        if ( strlen(tmp) == 5 || strlen(tmp) == 10 ){ 					
									apmib_set( MIB_WLAN_WEP64_KEY3, (void *)tmp);
        }
        else {
									apmib_set( MIB_WLAN_WEP128_KEY3, (void *)tmp);
        }
        if ( strlen(tmp) == 10 ){
        //printf("\n==>HEX10\n");
			
								apmib_set( MIB_WLAN_WEP64_KEY3, (void *)key64);
        }
        else if ( strlen(tmp) == 26 ){
        //printf("\n==>HEX26\n");
									apmib_set( MIB_WLAN_WEP128_KEY3, (void *)key128);
        }							
							}
							else if (strstr(p,"Key4"))
							{
								intVal=3;
								apmib_set( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&intVal);
       // printf("\n==>WEP_KEY4\n");									
								tmp = p + strlen("Network.Wireless.WEP.Key4=");		

        string_to_hex(tmp, key64, keyLen64);
        string_to_hex(tmp, key128, keyLen128);
					
        if ( strlen(tmp) == 5 || strlen(tmp) == 10 ){ 					
									apmib_set( MIB_WLAN_WEP64_KEY4, (void *)tmp);
        }
        else {
									apmib_set( MIB_WLAN_WEP128_KEY4, (void *)tmp);
        }
        if ( strlen(tmp) == 10 ){
       // printf("\n==>HEX10\n");
			
								apmib_set( MIB_WLAN_WEP64_KEY4, (void *)key64);
        }
        else if ( strlen(tmp) == 26 ){
       // printf("\n==>HEX26\n");
									apmib_set( MIB_WLAN_WEP128_KEY4, (void *)key128);
        }								
							}
     
						if (strlen(tmp) == 13 || strlen(tmp) == 26) //選擇64bit or 128bit
						{
        intVal=2; 
       // printf("\n==>WEP128bits\n");
        apmib_set( MIB_WLAN_WEP, (void *)&intVal); 
      }
      else
      {
        intVal=1;
      //  printf("\n==>WEP64bits\n"); 
        apmib_set( MIB_WLAN_WEP, (void *)&intVal); 
      }   

						if (strlen(tmp) == 10 || strlen(tmp) == 26) //選擇hex or ascii
						{
							intVal=1;
      // printf("\n==>HEX\n");
							apmib_set( MIB_WLAN_WEP_KEY_TYPE, (void *)&intVal);
						}
						else
						{
							intVal=0;
      // printf("\n==>ASCII\n");
							apmib_set( MIB_WLAN_WEP_KEY_TYPE, (void *)&intVal);
						}
					}					
					else if(isWPA)
					{
						if (strstr(p,"W0.SecurityMode"))
						{
							tmp = p + strlen("Network.Wireless.W0.SecurityMode=");
							if( !strcmp(tmp, "AES") )
							{
								intTkip=0;
								intAes=WPA_CIPHER_AES;
								intVal=4;
							}
							else
							{
								intTkip=WPA_CIPHER_TKIP;
								intAes=0;
								intVal=2;
							}
							apmib_set( MIB_WLAN_ENCRYPT, (void *)&intVal);
							apmib_set( MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intTkip);
							apmib_set( MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intAes);
							continue;
						}
						
						if (strstr(p,"W0.Key"))
						{
							tmp = p + strlen("Network.Wireless.W0.Key=");
							if( strlen(tmp) > 63 )
								intVal=1;
							else
								intVal=0;
							apmib_set(MIB_WLAN_WPA_PSK_FORMAT, (void *)&intVal);
							
							apmib_set(MIB_WLAN_WPA_PSK, (void *)tmp);
						}
					}
				}
				apmib_update(CURRENT_SETTING);
				system("init.sh ap all");
				
				return websWrite(wp, "");
			}
			return websWrite(wp, T("%s"), buffer);
		}
	else{
		return websWrite(wp, "");
	}

 	return -1;
}
/////////////////////////////////////////////////////////////////////////////
#ifndef _BOA_
int getIdValue(id, eid) {
	char_t buffer[50];
	int val;
	if ( !apmib_get( id, (void *)&val) )
		return -1;
	sprintf(buffer, "%d", val);
	ejSetResult(eid, buffer);
	return 0;
}
#endif
/////////////////////////////////////////////////////////////////////////////
#ifndef _BOA_
int getIndex(int eid, webs_t wp, int argc, char_t **argv)
#else
int getIndex(char *varName, char *indexValue)
#endif
{
	char_t *name, buffer[50];
	int chan, val;
	REG_DOMAIN_T domain;
	WEP_T wep;
	DHCP_T dhcp;
#ifdef HOME_GATEWAY
	OPMODE_T opmode=-1;
	char_t *iface=NULL;
#ifdef VPN_SUPPORT
	IPSECTUNNEL_T entry;
#endif
#endif
#ifdef UNIVERSAL_REPEATER
  int id;
#endif
#ifndef _BOA_
   	if (ejArgs(argc, argv, T("%s"), &name) < 1) {
   		websError(wp, 400, T("Insufficient args\n"));
   		return -1;
   	}
#else
	name = varName;
#endif
//************************************* System setting *************************************
	if ( !strcmp(name, T("licence")) ) {
 		if ( !apmib_get( MIB_LICENCE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wlDev"))) {	// 0-disabled 1-realtek 2-intersil 3-ipn
			ejSetResult(eid, "4");
			return 0;
	}
	else if ( !strcmp(name, T("psDev"))) {
		#ifdef _OFF_PS_DEVICE_
			ejSetResult(eid, "0");
		#elif _ON_PS_DEVICE_
			ejSetResult(eid, "1");
		#endif
			return 0;
	}
	else if ( !strcmp(name, T("sDev"))) {
		#ifdef _OFF_S_DEVICE_
			ejSetResult(eid, "0");
		#elif _ON_S_DEVICE_
			ejSetResult(eid, "1");
		#endif
			return 0;
	}
	else if ( !strcmp(name, T("apMachType"))) {
		#ifndef _IS_GATEWAY_
			ejSetResult(eid, "1");
		#endif
			return 0;
	}
	else if ( !strcmp(name, T("vsionType"))) {
			ejSetResult(eid, "6");

			return 0;
	}
	else if ( !strcmp(name, T("modelType"))) {
			ejSetResult(eid, "0");

			return 0;
	}
	else if ( !strcmp(name, T("l2tpGwMode"))) {
			ejSetResult(eid, "0");
			return 0;
	}
//************************************* STAION of ENCRYPT *************************************
	else if ( !strcmp(name, T("dhcp")) ) {
 		if ( !apmib_get( MIB_DHCP, (void *)&dhcp) )
			return -1;
		sprintf(buffer, "%d", (int)dhcp);
		ejSetResult(eid, buffer);
		return 0;
	}
  	else if ( !strcmp(name, T("dhcp-current")) ) {
   		if ( !apmib_get( MIB_DHCP, (void *)&dhcp) )
			return -1;
		if ( dhcp == DHCP_CLIENT && !isDhcpClientExist(BRIDGE_IF))
			dhcp = DHCP_DISABLED;
		sprintf(buffer, "%d", (int)dhcp);
		ejSetResult(eid, buffer);
		return 0;
	}
 	else if ( !strcmp(name, T("stp")) ) {
   		if ( !apmib_get( MIB_STP_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#ifdef _WATCH_DOG_
 	else if ( !strcmp(name, T("watchdog_enable"))) {
 			if ( !apmib_get( MIB_WATCH_DOG_ENABLE,  (void *)&val) )	return -1;
 			sprintf(buffer, "%d", val);
 			ejSetResult(eid, buffer);
 		return 0;
 	}
#endif
#ifdef _IPN_WL_DEVICE_
	else if ( !strcmp(name, T("staState")) ) {
		FILE *fp;
		char staBuf[10];
		buffer[0]='\0';
		system("iwconfig ra0 | grep Disconnected > /var/wlstate.tmp");
		if ( (fp = fopen("/var/wlstate.tmp", "r")) != NULL) {
			if ((fread( staBuf, 1, 1 ,fp )) != NULL)
				sprintf( buffer, "%d", 0);
			else
				sprintf( buffer, "%d" ,1);
		}
		else
			sprintf( buffer, "%d" ,1);
		fclose(fp);
		system("rm -f /tmp/wlstate.tmp");
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
	else if ( !strcmp(name, T("systime")) ) {		//Erwin Add 09.23
		FILE* fpt;
		char *rdptr;
//		system("date +%Y,%m,%d,%H,%M,%S > timetmp.txt");
#ifdef __TARGET_BOARD__
		system("/bin/date.sh");
#else
		system("../../script/date.sh");
#endif
       if ((fpt = fopen("/var/time.tmp","r"))!=NULL)
        {
			fread(buffer, 1, 100, fpt);
			if ( (rdptr = strchr(buffer, '\n'))!=NULL)
				*rdptr = '\0';
			fclose(fpt);
			system("rm -f /var/time.tmp");
		}
		ejSetResult(eid, buffer);
		return 0;
	}
//************************************** WiFi test **************************************
	else if ( !strcmp(name, T("wifitest"))) {
		if ( !apmib_get( MIB_WIFI_TEST, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//************************************** Country Reg **************************************
	else if ( !strcmp(name, T("countryReg"))) {
		#ifdef _DFS_
			if ( !apmib_get( MIB_HW_COUNTRY_REG, (void *)&val) )
				return -1;
			sprintf(buffer, "%d", val);
			ejSetResult(eid, buffer);
		#else
			ejSetResult(eid, "\"\"");
		#endif
		return 0;
	}
	else if ( !strcmp(name, T("countryRegAband"))) {
		#ifdef _DFS_
			if ( !apmib_get( MIB_HW_COUNTRY_REG_ABAND, (void *)&val) )
				return -1;
			sprintf(buffer, "%d", val);
			ejSetResult(eid, buffer);
		#else
			ejSetResult(eid, "\"\"");
		#endif
		return 0;
	}
//************************************ STATION of ENCRYPT ************************************
#ifndef HOME_GATEWAY
	else if ( !strcmp(name, T("enCltCer")) ) {
		if ( !apmib_get( MIB_CLT_CER_FILE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("enSerCer")) ) {
		if ( !apmib_get( MIB_SER_CER_FILE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("staSecMode")) ) {
		if ( !apmib_get( MIB_STA_SEC_MODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("adhocSecMode")) ) {
		if ( !apmib_get( MIB_ADHOC_SEC_MODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("staKeyType")) ) {
		if ( !apmib_get( MIB_STA_WEP_KEY_TYPE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("staEncrypt"))) {
		if ( !apmib_get( MIB_STA_ENCRYPT, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("staWep")) ) {
		if ( !apmib_get( MIB_STA_WEP, (void *)&wep) )
			return -1;
		sprintf(buffer, "%d", (int)wep);
		ejSetResult(eid, buffer);
   	    	return 0;
	}
	else if ( !strcmp(name, T("staDefKeyId")) ) {
		if ( !apmib_get( MIB_STA_WEP_DEFKEY, (void *)&val) )
			return -1;
		val++;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("staWpaCipher"))) {
		if ( !apmib_get( MIB_STA_WPA_CIPHER_SUITE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("staPskFormat"))) {
		if ( !apmib_get( MIB_STA_WPA_PSK_FORMAT, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}

	else if ( !strcmp(name, T("staEnRadius"))) {
		if ( !apmib_get( MIB_STA_ENRADIUS, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("staEapTp"))) {
		if ( !apmib_get( MIB_STA_EAP_TYPE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("staEnCltCer"))) {
		if ( !apmib_get( MIB_STA_ENCLT_CER, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("staEnSerCer"))) {
		if ( !apmib_get( MIB_STA_ENSER_CER, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("cltCerFile"))) {
		if ( !apmib_get( MIB_CLT_CER_FILE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("serCerFile"))) {
		if ( !apmib_get( MIB_SER_CER_FILE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("staPream"))) {
		if ( !apmib_get( MIB_STA_PREAMBLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//************************************** RADIUS Server **************************************
	else if ( !strcmp(name, T("rserEnabled"))) {
		if ( !apmib_get( MIB_RSER_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("rserCltNum")) ) {
		if ( !apmib_get( MIB_RSER_CLT_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("rserUsrNum")) ) {
		if ( !apmib_get( MIB_RSER_USR_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
//**************************************** WEP of WDS ****************************************
	else if ( !strcmp(name, T("wdsEncrypt"))) {
		if ( !apmib_get( MIB_WLAN_WDS_ENCRYPT, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wdsWpaAuth"))) {
		if ( !apmib_get( MIB_WLAN_WDS_WPA_AUTH, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wdsWpaCipher"))) {
		int iTkip, iAes;
		if ( !apmib_get( MIB_WLAN_WDS_WPA_CIPHER_SUITE, (void *)&iTkip) )
			return -1;
		if ( !apmib_get( MIB_WLAN_WDS_WPA2_CIPHER_SUITE, (void *)&iAes) )
			return -1;
		if (iTkip==WPA_CIPHER_TKIP && iAes==0) val=1;
		else if (iTkip==0 && iAes==WPA_CIPHER_AES) val=2;
		else if (iTkip==WPA_CIPHER_TKIP && iAes==WPA_CIPHER_AES) val=3;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wdsPskFormat"))) {
		if ( !apmib_get( MIB_WLAN_WDS_WPA_PSK_FORMAT, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
  else if ( !strcmp(name, T("disProtection"))) {
		if ( !apmib_get( MIB_WLAN_PROTECTION_DISABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
  }
  else if ( !strcmp(name, T("wispWanId")) ) {
		if ( !apmib_get( MIB_WISP_WAN_ID, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("opMode")) ) {
		if ( !apmib_get( MIB_OP_MODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}

	else if ( !strcmp(name, T("wlanMacClone"))) {
		if ( !apmib_get( MIB_WLAN_NAT25_MAC_CLONE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("band")) ) {
		if ( !apmib_get( MIB_WLAN_BAND, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}

	else if ( !strcmp(name, T("aband")) ) {
		#ifdef _DBAND_
			if ( !apmib_get( MIB_ABAND_MODE, (void *)&val) )
				return -1;
			sprintf(buffer, "%d", (int)val) ;
			 ejSetResult(eid, buffer);
		#else
			ejSetResult(eid, "\"\"");
		#endif
		return 0;
	}
	else if ( !strcmp(name, T("dualmode")) ) {
		#ifdef _DBAND_
			if ( !apmib_get( MIB_DUAL_BAND_SWITCH, (void *)&val) )
				return -1;
			sprintf(buffer, "%d", (int)val) ;
			 ejSetResult(eid, buffer);
		#else

			ejSetResult(eid, "\"\"");
		#endif
		return 0;
	}


	else if ( !strcmp(name, T("fixTxRate")) ) {
		if ( !apmib_get( MIB_WLAN_FIX_RATE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
//**************************************  MAC Filter **************************************
	else if ( !strcmp(name, T("macFilterNum")) ) {
		if ( !apmib_get( MIB_MACFILTER_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("macDenyEnabled")) ) {
		if ( !apmib_get( MIB_MACDENY_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//**************************************  wireless Schedule **************************************
//vance 2008.11.21
#ifdef _WIRELESS_SCHEDULE_
	else if ( !strcmp(name, T("wlanSchEnabled")) ) {
		if ( !apmib_get( MIB_WLAN_SCH_ENABLED, (void *)&val) )
				return -1;
			sprintf(buffer, "%d", val);
			ejSetResult(eid, buffer);
			return 0;
	}
	else if ( !strcmp(name, T("wlschnum")) ) {
		if ( !apmib_get( MIB_WLAN_SCH_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
#ifdef _LAN_WAN_ACCESS_
	else if ( !strcmp(name, T("lanWanAccess"))) {

		if ( !apmib_get( MIB_LAN_WAN_ACCESS, (void *)&val) )
			return -1;
		sprintf(buffer, "%lu", val );
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
//******************************wireless setting for inprocomm ******************************
	else if ( !strcmp(name, T("wlanRateMode")) ) {
		if ( !apmib_get( MIB_WLAN_RATE_MODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wlanCts")) ) {
		if ( !apmib_get( MIB_WLAN_CTS, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wlanBurst")) ) {
		if ( !apmib_get( MIB_WLAN_BURST, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
//*******************************************************ADSL*****************************************
//******************************for ADSL modul******************************
#ifdef _7264Wn_
	else if ( !strcmp(name, T("adsl_mode")) ) {
		if ( !apmib_get( MIB_ADSL_ADSLMode, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("adsl_type")) ) {
		if ( !apmib_get( MIB_ADSL_ADSLType, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("adsl_atm")) ) {
		if ( !apmib_get( MIB_ADSL_ATM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("adsl_encap")) ) {
		if ( !apmib_get( MIB_ADSL_ENCAP, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}


#endif
//********************************************************************************************
#if defined(HOME_GATEWAY) || defined(_AP_WITH_WIZARD_)
#ifdef HOME_GATEWAY
	else if ( !strcmp(name, T("wanDhcp")) ) {
		if ( !apmib_get( MIB_WAN_DHCP, (void *)&dhcp) )
			return -1;
		sprintf(buffer, "%d", (int)dhcp);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wanDhcp-current")) ) {
		if ( !apmib_get( MIB_WAN_DHCP, (void *)&dhcp) )
			return -1;
  	if ( !apmib_get( MIB_OP_MODE, (void *)&opmode) )
			return -1;
//		if(opmode == WISP_MODE)
//			iface = WLAN_IF;
//		else
			iface = _WAN_IF_;
		if ( dhcp == DHCP_CLIENT && !isDhcpClientExist(iface))
			dhcp = DHCP_DISABLED;
		sprintf(buffer, "%d", (int)dhcp);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wanDNS")) ) {
		DNS_TYPE_T dns;
		if ( !apmib_get( MIB_WAN_DNS_MODE, (void *)&dns) )
			return -1;
		sprintf(buffer, "%d", (int)dns);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wanMode"))) {
		if ( !apmib_get( MIB_WAN_MODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val);
		ejSetResult(eid, buffer);
		return 0;
	}

//************************************** PPPoE Setting **************************************
	else if ( !strcmp(name, T("pppConnectType")) ) {
		PPP_CONNECT_TYPE_T type;
		if ( !apmib_get( MIB_PPP_CONNECT_TYPE, (void *)&type) )
			return -1;
		sprintf(buffer, "%d", (int)type);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("pppConnectStatus")) ) {
		sprintf(buffer, "%d", isConnectPPP());
		ejSetResult(eid, buffer);
		return 0;
	}
#ifdef _STAR_
	else if ( !strcmp(name, T("pppConnectStatus4")) ) {
			sprintf(buffer, "%d", isConnectPPP4());
			ejSetResult(eid, buffer);
			return 0;
		}
#endif
#if defined(_Customer_) | defined(_MPPPOE_)
	else if ( !strcmp(name, T("pppConnectType1")) ) { //alex 2007/01/31
		PPP_CONNECT_TYPE_T type;
		if ( !apmib_get( MIB_PPP_CONNECT_TYPE1, (void *)&type) )
			return -1;
		sprintf(buffer, "%d", (int)type);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("PPPoEMode"))) {  //alex 2007/01/31
		if ( !apmib_get( MIB_PPPoE_MODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val );
		ejSetResult(eid, buffer);
   		return 0;
	}
	else if ( !strcmp(name, T("pppConnectStatus1")) ) { //alex 2007/01/31
		sprintf(buffer, "%d", isConnectPPP1());
		ejSetResult(eid, buffer);
		return 0;
	}
  #ifdef _TRIPPPOE_
        else if ( !strcmp(name, T("pppConnectType2")) ) {
                PPP_CONNECT_TYPE_T type;
                if ( !apmib_get( MIB_PPP_CONNECT_TYPE2, (void *)&type) )
                        return -1;
                sprintf(buffer, "%d", (int)type);
                ejSetResult(eid, buffer);
                return 0;
        }
        else if ( !strcmp(name, T("pppConnectStatus2")) ) {
                sprintf(buffer, "%d", isConnectPPP2());
                ejSetResult(eid, buffer);
                return 0;
        }
  #endif

#endif
	else if ( !strcmp(name, T("pppEnTtl"))) {
		if ( !apmib_get( MIB_PPP_TTL_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//*************************************** PPTP Setting ***************************************
	else if ( !strcmp(name, T("pptpIpMode"))) {
		if ( !apmib_get( MIB_PPTP_IPMODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("pptpConnectType")) ) {
		PPP_CONNECT_TYPE_T type;
		if ( !apmib_get( MIB_PPTP_CONNECT_TYPE, (void *)&type) )
			return -1;
		sprintf(buffer, "%d", (int)type);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("pptpBEZEQEnable")) ) {
		PPP_CONNECT_TYPE_T type;
		if ( !apmib_get( MIB_PPTP_BEZEQ_ENABLE, (void *)&type) )
			return -1;
		sprintf(buffer, "%d", (int)type);
		ejSetResult(eid, buffer);
		return 0;
	}
//*************************************** L2TP Setting ***************************************
	else if ( !strcmp(name, T("L2TPIpMode"))) {
		if ( !apmib_get( MIB_L2TP_IPMODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("L2TPConnectType")) ) {
		PPP_CONNECT_TYPE_T type;
		if ( !apmib_get( MIB_L2TP_CONNECT_TYPE, (void *)&type) )
			return -1;
		sprintf(buffer, "%d", (int)type);
		ejSetResult(eid, buffer);
		return 0;
	}
//*************************************** Telstra Big Pond ***************************************
	else if ( !strcmp(name, T("telBPEnabled"))) {
		if ( !apmib_get( MIB_TELBP_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//************************************** Port Forwarding **************************************
	else if ( !strcmp(name, T("portFwEnabled"))) {
		if ( !apmib_get( MIB_PORTFW_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("portFwNum")) ) {
		if ( !apmib_get( MIB_PORTFW_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//******************************************************************************************
/*	else if ( !strcmp(name, T("ipFilterNum")) ) {	//no use
		if ( !apmib_get( MIB_IPFILTER_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("portFilterNum")) ) {	//no sue
		if ( !apmib_get( MIB_PORTFILTER_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("ipFilterEnabled"))) {	//no use
		if ( !apmib_get( MIB_IPFILTER_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("portFilterEnabled"))) {	//no use
		if ( !apmib_get( MIB_PORTFILTER_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
*/
//************************************** Special Application **************************************
	else if ( !strcmp(name, T("triggerPortEnabled"))) {
		if ( !apmib_get( MIB_TRIGGERPORT_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("triggerPortNum")) ) {
		if ( !apmib_get( MIB_TRIGGERPORT_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("macFilterEnabled"))) {
		if ( !apmib_get( MIB_MACFILTER_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("dmzEnabled"))) {
		if ( !apmib_get( MIB_DMZ_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//************************************** QoS **************************************
	else if ( !strcmp(name, T("wan1QosNum")) ) {	//WAN1
		if ( !apmib_get( MIB_WAN1_QOS_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wan1QosEnabled")) ) {
		if ( !apmib_get( MIB_WAN1_QOS_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#if defined(_Customer_) | defined(_MPPPOE_)
	else if ( !strcmp(name, T("wan2QosNum")) ) {	//WAN2
		if ( !apmib_get( MIB_WAN2_QOS_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wan2QosEnabled")) ) {
		if ( !apmib_get( MIB_WAN2_QOS_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
	else if ( !strcmp(name, T("newpage")) ) {
		sprintf(buffer, "%d", newpage);
		if(newpage == 1)
		{
			apmib_reinit();
			First = 1;
			Changed = 0;
		}
		newpage = 1;
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("Changed")) ) {
		if ( Changed == 1 && First == 1 )
		{
			sprintf(buffer, "%d", 1);
			First = 0;
		} else
			sprintf(buffer, "%d", 0);
		ejSetResult(eid, buffer);
		return 0;
	}
/*	else if ( !strcmp(name, T("apply_enabled"))) {		//removed by Erwin
		sprintf(buffer, "%d", need_reboot);
		ejSetResult(eid, buffer);
		return 0;
	}
*/
//************************************** Static Routing **************************************
	else if ( !strcmp(name, T("sroutEnabled"))) {
		if ( !apmib_get( MIB_SROUT_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("sroutNum")) ) {
		if ( !apmib_get( MIB_SROUT_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wizardEnabled")) ) {
		sprintf(buffer, "%d", wizardEnabled);
//		wizardEnabled = 0;
//		printf("\nbuffer=%s\n",buffer);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("genEnabled")) ) {
		sprintf(buffer, "%d", wizardEnabled);
		wizardEnabled = 0;
//		printf("\nbuffer=%s\n",buffer);
		ejSetResult(eid, buffer);
		return 0;
	}
#else
        else if ( !strcmp(name, T("wizardEnabled")) ) {
                sprintf(buffer, "%d", wizardEnabled);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("genEnabled")) ) {
                sprintf(buffer, "%d", wizardEnabled);
                wizardEnabled = 0;
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
#endif
#if defined(_POWER_SAVING_)
	else if ( !strcmp(name, T("ledoffEnabled"))) {
		if ( !apmib_get( MIB_POWER_SAVING, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif

// Tommy
	else if ( !strcmp(name, T("lanipChanged")) ) {
		sprintf(buffer, "%d", lanipChanged);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("sitesurveyed")) ) {
		sprintf(buffer, "%d", sitesurveyed);
		ejSetResult(eid, buffer);
		return 0;
	}
#if defined(_Customer_) && (defined(_EW7218HNL_) || defined(_EW7428HRN_)) || defined(_SETTING_WIZARD_)
        else if ( !strcmp(name, T("auth_mode")) ) {
                sprintf(buffer, "%d", auth_mode);
                ejSetResult(eid, buffer);
                return 0;
        }
        else if ( !strcmp(name, T("encrypt_mode")) ) {
                sprintf(buffer, "%d", encrypt_mode);
                ejSetResult(eid, buffer);
                return 0;
        }
#endif

#ifdef _Systempingtool_
	else if ( !strcmp(name, T("pingstatus")) ) {
		sprintf(buffer, "%d", pingstatus);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
////*************************************Kyle 2007.03.12 for WPS*************************************

	else if ( !strcmp(name, T("wpsEnable"))) {
		if ( !apmib_get( MIB_WPS_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wpsDisplayKey"))) {
		if ( !apmib_get( MIB_WPS_DISPLAY_KEY, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wpsProxyEnable"))) {
		if ( !apmib_get( MIB_WPS_PROXY_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wpsConfigMode"))) {
		if ( !apmib_get( MIB_WPS_INTERNAL_REG, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wpsConfigType"))) {
		if ( !apmib_get( MIB_WPS_CONFIG_TYPE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wpsStatus"))) {
			FILE *fp;
			char c='0';
		if ((fp = fopen("/var/wpsStatus.var","r"))!=NULL) {
			c=fgetc(fp);
			fclose(fp);
		}else
			c='0';
		if(c<'0' || c>'34')
				c='0';
		sprintf(buffer, "%c", c);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wpsTime"))) {
			FILE *fp;
			char buf[10];
		if ((fp = fopen("/var/wpsTime.var","r"))!=NULL) {
			fgets(buf, 10, fp);
			fclose(fp);
		}else
			sprintf(buf, "%s", "0");


		sprintf(buffer, "%s", buf);
		ejSetResult(eid, buffer);
		return 0;
	}

//****************************************************************************************************************************************************
// Tommy

//************************************** Wireless Setting **************************************
	else if ( !strcmp(name, T("1xMode"))) {
		if ( !apmib_get( MIB_1X_MODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}

 	else if ( !strcmp(name, T("channelA"))) {
		#ifdef _DBAND_
			if ( !apmib_get( MIB_ABAND_CHANNEL, (void *)&chan) )
				return -1;
			sprintf(buffer, "%d", chan);

		#else
			sprintf(buffer, "%d", 0 );
		#endif

			ejSetResult(eid, buffer);
			return 0;;

   	}
	else if ( !strcmp(name, T("channel")) ) {
		if ( !apmib_get( MIB_WLAN_CHAN_NUM, (void *)&chan) )
			return -1;
		sprintf(buffer, "%d", chan);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("regDomain")) ) {
		if ( !apmib_get( MIB_HW_REG_DOMAIN, (void *)&domain) )
			return -1;
		sprintf(buffer, "%d", (int)domain);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wep")) ) {
		if ( !apmib_get( MIB_WLAN_WEP, (void *)&wep) )
			return -1;
		sprintf(buffer, "%d", (int)wep);
		ejSetResult(eid, buffer);
   	    	return 0;
	}
#ifdef _MSSID_
	else if ( !strcmp(name, T("wep1")) ) {
		if ( !apmib_get( MIB_WLAN_WEP_1, (void *)&wep) )
			return -1;
		sprintf(buffer, "%d", (int)wep);
		ejSetResult(eid, buffer);
			return 0;
	}
#endif
	else if ( !strcmp(name, T("defaultKeyId")) ) {
		if ( !apmib_get( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&val) )
			return -1;
		val++;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wlanSetTx")) ) {
		if ( !apmib_get( MIB_WLAN_SET_TX, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("keyType")) ) {
		if ( !apmib_get( MIB_WLAN_WEP_KEY_TYPE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		 ejSetResult(eid, buffer);
		return 0;
	}
  	else if ( !strcmp(name, T("authType"))) {
		if ( !apmib_get( MIB_WLAN_AUTH_TYPE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val) ;
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("operRate"))) {
		if ( !apmib_get( MIB_WLAN_SUPPORTED_RATE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("basicRate"))) {
		if ( !apmib_get( MIB_WLAN_BASIC_RATE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", (int)val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("preamble"))) {
		if ( !apmib_get( MIB_WLAN_PREAMBLE_TYPE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("hiddenSSID"))) {
		if ( !apmib_get( MIB_WLAN_HIDDEN_SSID, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#ifdef _MSSID_ //vance 2008.12.30
	else if ( !strcmp(name, T("hiddenSSID1"))) {
			if ( !apmib_get( MIB_WLAN_HIDDEN_SSID_1, (void *)&val) )
				return -1;
			sprintf(buffer, "%d", val);
			ejSetResult(eid, buffer);
			return 0;
		}
#endif
	// RexHua
	else if ( !strcmp(name, T("wlanTurbo"))) {
		if ( !apmib_get( MIB_WLAN_TURBO, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("NfixTxRate"))) {
		if ( !apmib_get( MIB_WLAN_N_FIX_RATE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("NChanWidth"))) {
		if ( !apmib_get( MIB_WLAN_N_CHANNEL_WIDTH, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wlanWmm"))) {
		if ( !apmib_get( MIB_WLAN_WMM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#if defined(_AP_WLAN_NOFORWARD_)
		//kyle
		else if ( !strcmp(name, T("noForward"))) {
		if ( !apmib_get( MIB_WLAN_NOFORWARD, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif

	else if ( !strcmp(name, T("wmFilterNum"))) {
		if ( !apmib_get( MIB_WLAN_AC_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wlanDisabled"))) {
		if ( !apmib_get( MIB_WLAN_DISABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wlanAcNum")) ) {
		if ( !apmib_get( MIB_WLAN_AC_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
        else if ( !strcmp(name, T("wlanwdsNum")) ) {
                if ( !apmib_get( MIB_WDS_NUM, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
	else if ( !strcmp(name, T("wlanAcEnabled"))) {
		if ( !apmib_get( MIB_WLAN_AC_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	#ifdef _MULTIPLE_WLAN_ACCESS_CONTROL_ //vance 2008.10.24
	//SSID 2
	else if ( !strcmp(name, T("wlanAc2Num")) ) {
		if ( !apmib_get( MIB_WLAN_AC2_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wlanAc2Enabled"))) {
		if ( !apmib_get( MIB_WLAN_AC2_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	//SSID 3
	else if ( !strcmp(name, T("wlanAc3Num")) ) {
		if ( !apmib_get( MIB_WLAN_AC3_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wlanAc3Enabled"))) {
		if ( !apmib_get( MIB_WLAN_AC3_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	//SSID 4
	else if ( !strcmp(name, T("wlanAc4Num")) ) {
		if ( !apmib_get( MIB_WLAN_AC4_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wlanAc4Enabled"))) {
		if ( !apmib_get( MIB_WLAN_AC4_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	//SSID 5
	else if ( !strcmp(name, T("wlanAc5Num")) ) {
		if ( !apmib_get( MIB_WLAN_AC5_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wlanAc5Enabled"))) {
		if ( !apmib_get( MIB_WLAN_AC5_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	#endif
	else if ( !strcmp(name, T("rateAdaptiveEnabled"))) {
		if ( !apmib_get( MIB_WLAN_RATE_ADAPTIVE_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("netType"))) {
		if ( !apmib_get( MIB_WLAN_NETWORK_TYPE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
        else if ( !strcmp(name, T("aggregation"))) {
                if ( !apmib_get( MIB_WLAN_AGGREGATION, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
        else if ( !strcmp(name, T("shortGIEnabled"))) {
                if ( !apmib_get(MIB_WLAN_SHORT_GI, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
	else if ( !strcmp(name, T("iappDisabled"))) {
		if ( !apmib_get( MIB_WLAN_IAPP_DISABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("block"))) {
		if ( !apmib_get( MIB_WLAN_BLOCK_RELAY, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("autoMacClone"))) {
		if ( !apmib_get( MIB_AUTO_MAC_CLONE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("band"))) {
		if ( !apmib_get( MIB_WLAN_BAND, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//-----------------------------------Erwin Add 28.08----------------------------------------------
	else if ( !strcmp(name, T("apMode"))) {
		if ( !apmib_get( MIB_AP_MODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("secMode"))) {
		if ( !apmib_get( MIB_SECURITY_MODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("clIpDisabled"))) {
		if ( !apmib_get( MIB_CLIENT_IP_DISABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wlan_mssid_num")) ) {
//		#if defined(CONFIG_RTL8196B)//we disable mssid first for 96b
//		int mssid_num=0;
//		#else
#ifdef CONFIG_RTL8196B_GW_8M
		int mssid_num=1;
#else
		int mssid_num=4;
#endif
//		#endif
		sprintf(buffer, "%d", mssid_num);
		ejSetResult(eid, buffer);
		return 0;
	}
#ifdef _PROFILE_LIST_
        else if ( !strcmp(name, T("NoweditProfile")) ) {
                sprintf(buffer, "%d", NoweditProfile);
                ejSetResult(eid, buffer);
                return 0;
        }
#endif
#if defined (_QoS_MODE_SELECT_)
	else if ( !strcmp(name, T("ConQosNum")) ) {	//WAN1
			if ( !apmib_get( MIB_WANCON_QOS_NUM, (void *)&val) )
				return -1;
			sprintf(buffer, "%d", val);
			ejSetResult(eid, buffer);
			return 0;
		}
#endif
#if defined (HOME_GATEWAY) || defined(_AP_WITH_TIMEZONE_)
//**************************************** Time Zone ****************************************
	else if ( !strcmp(name, T("DayLightEnable"))) {
		if ( !apmib_get( MIB_DAYLIGHT_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
#ifdef _SNTP_A_M_CTL_ //vance 2009.02.20
//**************************************** Time Zone ****************************************
	else if ( !strcmp(name, T("TimeServerEnable"))) {
		if ( !apmib_get( MIB_TIMESERVER_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
#ifdef HOME_GATEWAY
//*************************************** Remote Managemen ***************************************
	else if ( !strcmp(name, T("reMangEnable"))) {
		if ( !apmib_get( MIB_REMANG_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//*************************************** UPnP Setting ***************************************
	else if ( !strcmp(name, T("upnpEnable"))) {
		if ( !apmib_get( MIB_UPNP_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//********************************** PrinterServer Setting **********************************
// Lance 2004.2.9
	else if ( !strcmp(name, T("PSEnable"))) {
		if ( !apmib_get( MIB_PS_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
// Lance 2004.2.16
	else if ( !strcmp(name, T("PS_IPPEnable"))) {
		if ( !apmib_get( MIB_PS_IPPENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("PS_LPREnable"))) {
		if ( !apmib_get( MIB_PS_LPRENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
// End - Lance
//*************************************** NAT Setting ***************************************
	else if ( !strcmp(name, T("natEnable"))) {
		if ( !apmib_get( MIB_NAT_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("fastNatEnable"))) {
		if ( !apmib_get( MIB_FAST_NAT_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//*************************************** IGMP Setting ***************************************
	else if ( !strcmp(name, T("igmpEnable"))) {
#if defined(_IGMP_PROXY_)
		if ( !apmib_get( MIB_IGMP_PROXY_ENABLED, (void *)&val) )
			return -1;
#else
		val=0;
#endif
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//********************* TTL Function add by Kyle 2008/03/07. *******************
#ifdef _WANTTL_
	else if ( !strcmp(name, T("ttlType"))) {
		if ( !apmib_get( MIB_TTL_TYPE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
//*************************************** Firewall Setting ***************************************
	else if ( !strcmp(name, T("FirewallEnable"))) {
		if ( !apmib_get( MIB_FIREWALL_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//*************************************** Virtual Server***************************************
	else if ( !strcmp(name, T("virtSVEnabled"))) {
		if ( !apmib_get( MIB_VSER_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("vserNum")) ) {
		if ( !apmib_get( MIB_VSER_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//**************************************** DMZ ****************************************
	else if ( !strcmp(name, T("dmzNum")) ) {
		if ( !apmib_get( MIB_DMZ_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//**************************************** URL Blocking ****************************************
	else if ( !strcmp(name, T("URLBEnabled"))) {
		if ( !apmib_get( MIB_URLB_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("URLBNum")) ) {
		if ( !apmib_get( MIB_URLB_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//**************************************** DoS ****************************************
	else if ( !strcmp(name, T("podEnable")) ) {
		if ( !apmib_get( MIB_POD_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("pingEnable")) ) {
		if ( !apmib_get( MIB_PIN_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("scanEnable")) ) {
		if ( !apmib_get( MIB_SCAN_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("synEnable")) ) {
		if ( !apmib_get( MIB_SYN_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("podTime")) ) {
		if ( !apmib_get( MIB_POD_TIME, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("synTime")) ) {
		if ( !apmib_get( MIB_SYN_TIME, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#if defined(_ENRIP_)
//*************************************** RIP ***************************************
	else if ( !strcmp(name, T("ripEnable")) ) {
		if ( !apmib_get( MIB_RIP_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
#if defined(_ENSNMP_)
//*************************************** SNMP***************************************
	else if ( !strcmp(name, T("snmpEnable"))) {
		if ( !apmib_get( MIB_SNMP_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
//*************************************** Access Contral Ip ***************************************
	else if ( !strcmp(name, T("ACPCEnabled"))) {
		if ( !apmib_get( MIB_ACPC_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("ipDenyEnabled")) ) {
		if ( !apmib_get( MIB_IPDENY_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("ACPCNum")) ) {
		if ( !apmib_get( MIB_ACPC_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//*************************************** DDNS Setting ***************************************
	else if ( !strcmp(name, T("ddnsEnable"))) {
		if ( !apmib_get( MIB_DDNS_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("dhisSelect"))) {
		if ( !apmib_get( MIB_DHIS_SELECT, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
//----------------------------------------------------------------------------------------------
#ifdef WLAN_WPA
	else if ( !strcmp(name, T("encrypt"))) {
#ifdef _PROFILE_LIST_
		if ( !apmib_get( MIB_WLAN_ENCRYPT, (void *)&val) )
#else
		if ( !apmib_get( MIB_SECURITY_MODE, (void *)&val) )
#endif
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#ifdef _MSSID_ //vance
	else if ( !strcmp(name, T("encrypt1"))) {
			if ( !apmib_get( MIB_SECURITY_MODE_1, (void *)&val) )
				return -1;
			sprintf(buffer, "%d", val);
			ejSetResult(eid, buffer);
			return 0;
		}
#endif
	else if ( !strcmp(name, T("enable1X"))) {
		if ( !apmib_get( MIB_WLAN_ENABLE_1X, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("enableSuppNonWpa"))) {
		if ( !apmib_get( MIB_WLAN_ENABLE_SUPP_NONWPA, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("suppNonWpa"))) {
		if ( !apmib_get( MIB_WLAN_SUPP_NONWPA, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wpaAuth"))) {
		if ( !apmib_get( MIB_WLAN_WPA_AUTH, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("wpaCipher"))) {
		int iTkip, iAes;
		if ( !apmib_get( MIB_WLAN_WPA_CIPHER_SUITE, (void *)&iTkip) )
			return -1;
		if ( !apmib_get( MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&iAes) )
			return -1;
		if (iTkip==WPA_CIPHER_TKIP && iAes==0) val=1;
		else if (iTkip==0 && iAes==WPA_CIPHER_AES) val=2;
		else if (iTkip==WPA_CIPHER_TKIP && iAes==WPA_CIPHER_AES) val=3;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("pskFormat"))) {
		if ( !apmib_get( MIB_WLAN_WPA_PSK_FORMAT, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("accountRsEnabled"))) {
		if ( !apmib_get( MIB_WLAN_ACCOUNT_RS_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("accountRsUpdateEnabled"))) {
		if ( !apmib_get( MIB_WLAN_ACCOUNT_UPDATE_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("enableMacAuth"))) {
		if ( !apmib_get( MIB_WLAN_ENABLE_MAC_AUTH, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("rsRetry")) ) {
		if ( !apmib_get( MIB_WLAN_RS_RETRY, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("accountRsRetry")) ) {
		if ( !apmib_get( MIB_WLAN_ACCOUNT_RS_RETRY, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
// Static DHCP Lease
	else if ( !strcmp(name, T("SDHCPEnabled"))) {
		if ( !apmib_get( MIB_STATIC_DHCP_ENABLED, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("SDHCPNum")) ) {
		if ( !apmib_get( MIB_STATIC_DHCP_NUM, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
//-------------------
#ifdef UNIVERSAL_REPEATER
	else if ( !strcmp(name, T("repeaterEnabled"))) {
		id = MIB_REPEATER_ENABLED;
		if ( !apmib_get( id, (void *)&val) )
				return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif

	else if ( !strcmp(name, T("apRouterSwitch"))) {
		if ( !apmib_get( MIB_AP_ROUTER_SWITCH, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}

	else if ( !strcmp(name, T("txStream"))) {
		if (_RFTYPE_ == "1T2R" || _RFTYPE_ == "1T1R")
		ejSetResult(eid, "1");
		else
		ejSetResult(eid, "2");

		return 0;
	}

	else if ( !strcmp(name, T("pppoepass"))) {
	#ifdef _PPPOE_PASSTHROUGH_
		if ( !apmib_get( MIB_PPPOE_PASSTHROUGH, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
	#else
		ejSetResult(eid, "\"\"");
	#endif
	return 0;
	}
	else if ( !strcmp(name, T("ipv6bridge"))) {
	#ifdef _IPV6_BRIDGE_
		if ( !apmib_get( MIB_IPV6_BRIDGE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
	#else
		ejSetResult(eid, "\"\"");
	#endif
	return 0;
	}
	#ifdef _Unicorn_
	else if ( !strcmp(name, T("QosMode"))){
		if (!apmib_get( MIB_QOS_MODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
	return 0;
	}
	#endif
#ifdef _LEDSWITCH_
	else if ( !strcmp(name, T("ledStatus"))) {
		if ( !apmib_get( MIB_LED_CONTROL, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
#ifdef _SDMZ_
	else if ( !strcmp(name, T("DMZ_Mode"))){
		if (!apmib_get( MIB_DMZ_MODE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
        return 0;
	}
#endif
#ifdef _CONNECTION_CTRL_
        else if ( !strcmp(name, T("connectionCtrlEnabled"))){
                if (!apmib_get( MIB_CONNECTIONCTRL_ENABLED, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
        return 0;
        }
#endif
	//**************************************** VPN PASSTHROUGH ****************************************
#ifdef _WEP_OPEN_SHARED_MODE_
        else if ( !strcmp(name, T("WEP_AuthMode"))){
                if (!apmib_get( MIB_WEP_OPEN_SHARED_MODE, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
        return 0;
        }
#endif
#if defined(_Customer_EX_) || defined(_Customer_SC_) || defined(_Customer_SA_)
        else if ( !strcmp(name, T("GuardInterval"))) {
                if ( !apmib_get( MIB_GUARD_INTERVAL, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
        else if ( !strcmp(name, T("BARequest"))) {
                if ( !apmib_get( MIB_DECLINE_BA_REQUEST, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
        else if ( !strcmp(name, T("Isolation"))) {
                if ( !apmib_get( MIB_ISOLATION, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
        else if ( !strcmp(name, T("MBSSID_Isolation"))) {
                if ( !apmib_get( MIB_MBSSID_ISOLATION, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }

#endif
		
#ifdef _TX_POWER_CONTROL_
        else if ( !strcmp(name, T("tx_power"))) {
                buffer[0]='\0';
                if ( !apmib_get( MIB_HW_11N_RESERVED9,  (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val );
                ejSetResult(eid, buffer);
                return 0;
        }
        else if ( !strcmp(name, T("reg_Domain")) ) {
                if ( !apmib_get( MIB_HW_REG_DOMAIN, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
#endif
#ifdef _GREEN_AP_SCHEDULE_
	else if ( !strcmp(name, T("greenap_enable"))) {
		if ( !apmib_get( MIB_GREENAP_ENABLE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("greenap_weekdays"))) {
		char_t *name1, *name2;
		int temp_val1, temp_val2;
/*
		if (ejArgs(argc-1, argv+1, T("%s"), &name1) < 1)
		{
			websError(wp, 400, T("Insufficient args\n"));
			return -1;
		}
		if (ejArgs(argc-2, argv+2, T("%s"), &name2) < 1)
		{
			websError(wp, 400, T("Insufficient args2\n"));
			return -1;
		}
*/
		temp_val2 = atoi(name2);
		switch(temp_val2)
		{
			case 1: apmib_get( MIB_GREENAP_WEEKDAYS1, (void *)&temp_val1); break;
			case 2: apmib_get( MIB_GREENAP_WEEKDAYS2, (void *)&temp_val1); break;
			case 3: apmib_get( MIB_GREENAP_WEEKDAYS3, (void *)&temp_val1); break;
			case 4: apmib_get( MIB_GREENAP_WEEKDAYS4, (void *)&temp_val1); break;
			default: break;
		}

		if( (temp_val1 & (1<<atoi(name1))) != 0 )
			ejSetResult(eid, "1");
		else
			ejSetResult(eid, "0");

		return 0;
	}
	else if ( !strcmp(name, T("greenap_powerlevel"))) {
		char_t *name1;
		int temp_val1;
/*
		if (ejArgs(argc-1, argv+1, T("%s"), &name1) < 1)
		{
			websError(wp, 400, T("Insufficient args\n"));
			return -1;
		}
*/
		temp_val1 = atoi(name1);
		switch(temp_val1)
		{
			case 1: apmib_get( MIB_GREENAP_POWERLEVEL1, (void *)&val); break;
			case 2: apmib_get( MIB_GREENAP_POWERLEVEL2, (void *)&val); break;
			case 3: apmib_get( MIB_GREENAP_POWERLEVEL3, (void *)&val); break;
			case 4: apmib_get( MIB_GREENAP_POWERLEVEL4, (void *)&val); break;
			default: break;
		}
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	/*else if ( !strcmp(name, T("greenap_timetype"))) {
		if ( !apmib_get( MIB_GREENAP_TIME_TYPE, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}*/
	else if ( !strcmp(name, T("greenap_time_start_hour"))) {
		char_t *name1;
		int temp_val1;
/*
		if (ejArgs(argc-1, argv+1, T("%s"), &name1) < 1)
		{
			websError(wp, 400, T("Insufficient args\n"));
			return -1;
		}
*/		temp_val1 = atoi(name1);
		switch(temp_val1)
		{
			case 1: apmib_get( MIB_GREENAP_START_HOUR1, (void *)&val); break;
			case 2: apmib_get( MIB_GREENAP_START_HOUR2, (void *)&val); break;
			case 3: apmib_get( MIB_GREENAP_START_HOUR3, (void *)&val); break;
			case 4: apmib_get( MIB_GREENAP_START_HOUR4, (void *)&val); break;
			default: break;
		}
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("greenap_time_start_minute"))) {
		char_t *name1;
		int temp_val1;
/*
		if (ejArgs(argc-1, argv+1, T("%s"), &name1) < 1)
		{
			websError(wp, 400, T("Insufficient args\n"));
			return -1;
		}
*/		temp_val1 = atoi(name1);
		switch(temp_val1)
		{
			case 1: apmib_get( MIB_GREENAP_START_MINUTE1, (void *)&val); break;
			case 2: apmib_get( MIB_GREENAP_START_MINUTE2, (void *)&val); break;
			case 3: apmib_get( MIB_GREENAP_START_MINUTE3, (void *)&val); break;
			case 4: apmib_get( MIB_GREENAP_START_MINUTE4, (void *)&val); break;
			default: break;
		}
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("greenap_time_stop_hour"))) {
		char_t *name1;
		int temp_val1;
/*
		if (ejArgs(argc-1, argv+1, T("%s"), &name1) < 1)
		{
			websError(wp, 400, T("Insufficient args\n"));
			return -1;
		}
*/
		temp_val1 = atoi(name1);
		switch(temp_val1)
		{
			case 1: apmib_get( MIB_GREENAP_STOP_HOUR1, (void *)&val); break;
			case 2: apmib_get( MIB_GREENAP_STOP_HOUR2, (void *)&val); break;
			case 3: apmib_get( MIB_GREENAP_STOP_HOUR3, (void *)&val); break;
			case 4: apmib_get( MIB_GREENAP_STOP_HOUR4, (void *)&val); break;
			default: break;
		}
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("greenap_time_stop_minute"))) {
		char_t *name1;
		int temp_val1;
/*
		if (ejArgs(argc-1, argv+1, T("%s"), &name1) < 1)
		{
			websError(wp, 400, T("Insufficient args\n"));
			return -1;
		}
*/		temp_val1 = atoi(name1);
		switch(temp_val1)
		{
			case 1: apmib_get( MIB_GREENAP_STOP_MINUTE1, (void *)&val); break;
			case 2: apmib_get( MIB_GREENAP_STOP_MINUTE2, (void *)&val); break;
			case 3: apmib_get( MIB_GREENAP_STOP_MINUTE3, (void *)&val); break;
			case 4: apmib_get( MIB_GREENAP_STOP_MINUTE4, (void *)&val); break;
			default: break;
		}
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
/*
        else if ( !strcmp(name, T("tx_power_value")) ) {
                list_value(
                        wp,4,
                        MIB_WLAN_TX_POWER_1,MIB_WLAN_TX_POWER_2,MIB_WLAN_TX_POWER_3,MIB_WLAN_TX_POWER_4,
                        0
                );
                return 0;
        }
*/
#endif
#if defined(_COPY_ROOT_SSID_)
        else if ( !strcmp(name, T("SSID_choice"))) {
                if ( !apmib_get( MIB_SSID_CHOICE, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
#endif
	else if ( !strcmp(name, T("wizardEnabled")) ) {
		sprintf(buffer, "%d", wizardEnabled);
		ejSetResult(eid, buffer);
		return 0;
	}
	else if ( !strcmp(name, T("genEnabled")) ) {
		sprintf(buffer, "%d", wizardEnabled);
		wizardEnabled = 0;
		ejSetResult(eid, buffer);
		return 0;
	}
#if defined(_WEB_ACCESS_CONTROL_)
	else if ( !strcmp(name, T("webSSIDControl"))) {
		if ( !apmib_get( MIB_WEB_CONTROL, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif
#if defined(_POWER_SAVING_)
	else if ( !strcmp(name, T("ledoffEnabled"))) {
		if ( !apmib_get( MIB_POWER_SAVING, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
#endif

	else if ( !strcmp(name, T("wlanencrypt"))) {
                if ( !apmib_get( MIB_WLAN_ENCRYPT, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
	else if ( !strcmp(name, T("Global_WEPkey")) ) {
                sprintf(buffer, "%s", GlobalWEPkey);
                ejSetResult(eid, buffer);
                return 0;
        }
#if defined(_LED_SWITCH_) || defined(_SW_LED_SWITCH_)
	else if ( !strcmp(name, T("led_status"))) {
                if ( !apmib_get(MIB_LED_SWITCH, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
#endif

#if defined(_Airlive_7428HCN_)	//for Airlive EW7428HCN
        else if ( !strcmp(name, T("csRegDomain"))) {
                if ( !apmib_get( MIB_CS_REG_DOMAIN, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
        else if ( !strcmp(name, T("keepConfig"))) {
                if ( !apmib_get( MIB_KEEP_CONFIG, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
        else if ( !strcmp(name, T("ipFinder"))) {
                if ( !apmib_get( MIB_IP_FINDER, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
#endif

#ifdef _CONTROL_SIDEBAND_
        else if ( !strcmp(name, T("controlSideband"))) {
                if ( !apmib_get(MIB_CONTROL_SIDEBAND, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
#endif

#ifdef _SYSTEM_LOG_
        else if ( !strcmp(name, T("logEnabled")) ) {
                if ( !apmib_get( MIB_LOG_ENABLED, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val) ;
                ejSetResult(eid, buffer);
                return 0;
        }
        else if ( !strcmp(name, T("rtLogEnabled")) ) {
                if ( !apmib_get( MIB_REMOTELOG_ENABLED, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", (void *)val) ;
                 ejSetResult(eid, buffer);
                return 0;
        }

#endif

#ifdef _RTK_NTP_
        else if ( !strcmp(name, T("ntpEnabled")) ) {
                if ( !apmib_get( MIB_NTP_ENABLED, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
        else if ( !strcmp(name, T("DaylightSave")) ) {
                if ( !apmib_get( MIB_DAYLIGHT_SAVE, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
        else if ( !strcmp(name, T("ntpServerId")) ) {
                if ( !apmib_get( MIB_NTP_SERVER_ID, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", val);
                ejSetResult(eid, buffer);
                return 0;
        }
#endif

#ifdef _Airlive_Schedule_
        else if ( !strcmp(name, T("schEnable")) ) {
                if ( !apmib_get( MIB_WLSCH_ENABLED, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", (void *)val) ;
                ejSetResult(eid, buffer);
                return 0;
        }
#endif

#ifdef _STANUM_
        else if ( !strcmp(name, T("stanum")) ) {
                if ( !apmib_get( MIB_STANUM, (void *)&val) )
                        return -1;
                sprintf(buffer, "%d", (void *)val) ;
                ejSetResult(eid, buffer);
                return 0;
        }
#endif
	else{
		ejSetResult(eid, "");
		return 0;
	}
		return -1;
}
