 /*
 *      Web server handler routines for TCP/IP stuffs
 *
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *
 *      $Id: fmtcpip.c,v 1.2 2005/05/13 07:53:53 tommy Exp $
 *
 */

/*-- System inlcude files --*/
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <signal.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <time.h>
#include <net/route.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <net/if.h>
#ifndef _BOA_
#include "../um.h"
#endif
#include <sys/types.h>

/*-- Local inlcude files --*/
#include "../webs.h"
#include "apmib.h"
#include "apform.h"
#include "utility.h"

static char superName[MAX_NAME_LEN]={0};//, superPass[MAX_NAME_LEN]={0};
//static char userName[MAX_NAME_LEN]={0}, userPass[MAX_NAME_LEN]={0};
#define DEFAULT_GROUP           T("administrators")
#define ACCESS_URL              T("/")
#ifndef __TARGET_BOARD__
#define _LITTLE_ENDIAN_
#endif

#define _DHCPD_PROG_NAME	T("udhcpd")
#define _DHCPD_PID_PATH		T("/var/run")
#define _DHCPC_PROG_NAME	T("udhcpc")
#define _DHCPC_PID_PATH		T("/etc/udhcpc")
#define _PATH_DHCPS_LEASES	T("/var/lib/misc/udhcpd.leases")


/*-- Macro declarations --*/
#ifdef _LITTLE_ENDIAN_
#define ntohdw(v) ( ((v&0xff)<<24) | (((v>>8)&0xff)<<16) | (((v>>16)&0xff)<<8) | ((v>>24)&0xff) )

#else
#define ntohdw(v) (v)
#endif

#define RECONNECT_MSG(url) { \
	websHeader(wp); \
	websWrite(wp, T("<head><link rel=\"stylesheet\" href=\"set.css\"></head>\n")); \
	websWrite(wp, T("<body class=\"background\"><blockquote><h4 class=\"textcolor\">Change setting successfully!<BR><BR>"\
                "<form><input type=button value=\"  OK  \" OnClick=window.location.replace(\"%s\")></form></blockquote></body>"), url);\
	websFooter(wp); \
	websDone(wp, 200); \
}

/*-- Forward declarations --*/
static int getOneDhcpClient(char **ppStart, unsigned long *size, char *ip, char *mac, char *liveTime);

static int getPid(char *filename);

int lanipChanged = 0; // Tommy Added
int main_menu=0;
int sub_menu=0;
int third_menu=0;

#ifdef _OK_MSG_CHARSET_ISO_8859_1_
char charset[20]="iso-8859-1";
#else
char charset[20]="utf-8";
#endif

//////////////////////////////////////////////////////////////////////////////
static int getOneDhcpClient(char **ppStart, unsigned long *size, char *ip, char *mac, char *liveTime)
{
	struct dhcpOfferedAddr {
        	u_int8_t chaddr[16];
        	u_int32_t yiaddr;       /* network order */
        	u_int32_t expires;      /* host order */
	};

	struct dhcpOfferedAddr entry;

	if ( *size < sizeof(entry) )
		return -1;
	entry = *((struct dhcpOfferedAddr *)*ppStart);
	*ppStart = *ppStart + sizeof(entry);
	*size = *size - sizeof(entry);

	if (entry.expires == 0)
		return 0;

	strcpy(ip, inet_ntoa(*((struct in_addr *)&entry.yiaddr)) );

	snprintf(mac, 20, "%02x:%02x:%02x:%02x:%02x:%02x",
			entry.chaddr[0],entry.chaddr[1],entry.chaddr[2],entry.chaddr[3],
			entry.chaddr[4], entry.chaddr[5]);


	snprintf(liveTime, 10, "%lu", (unsigned long)ntohl(entry.expires));

	return 1;
}


///////////////////////////////////////////////////////////
static int getPid(char *filename)
{
	struct stat status;
	char buff[100];
	FILE *fp;

	if ( stat(filename, &status) < 0)
		return -1;
	fp = fopen(filename, "r");
	if (!fp) {
#ifndef _BOA_
        	error(E_L, E_LOG, T("Read pid file error!\n"));
#endif
		return -1;
   	}
	fgets(buff, 100, fp);
	fclose(fp);

	return (atoi(buff));
}

// Static DHCP lease ----------------------------------------------
int SDHCPList(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0, entryNum, i;
	SDHCP_T entry;
	char tmpBuf[100];
	char tmpBuf1[100];
	char *ip;

	if ( !apmib_get(MIB_STATIC_DHCP_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}

	for (i=1; i<=entryNum; i++) {
		*((char *)&entry) = (char)i;
		if ( !apmib_get(MIB_STATIC_DHCP, (void *)&entry))
			return -1;

		snprintf(tmpBuf, 100, T("%02x:%02x:%02x:%02x:%02x:%02x"),
			entry.macAddr[0], entry.macAddr[1], entry.macAddr[2],
			entry.macAddr[3], entry.macAddr[4], entry.macAddr[5]);

		snprintf(tmpBuf1,100, T("%02x%02x%02x%02x%02x%02x"),
			entry.macAddr[0], entry.macAddr[1], entry.macAddr[2],
			entry.macAddr[3], entry.macAddr[4], entry.macAddr[5]);

		ip = fixed_inet_ntoa(entry.ipAddr);
		if ( !strcmp(ip, "0.0.0.0"))
			ip = "----";
		
			nBytesSent += websWrite(wp, T("<tr>\n"));
			nBytesSent += websWrite(wp, T("  <td align=center class=\"table2\">\n"));
			nBytesSent += websWrite(wp, T("    <font size=\"2\">%d</font>\n"),i);
			nBytesSent += websWrite(wp, T("  </td>\n"));
			nBytesSent += websWrite(wp, T("  <td align=center class=\"table2\">\n"));
			nBytesSent += websWrite(wp, T("    <font size=\"2\">%s</font><input type=\"hidden\" name=\"smac%d\" value=\"%s\">\n"),tmpBuf,i,tmpBuf1);
			nBytesSent += websWrite(wp, T("  </td>\n"));
			nBytesSent += websWrite(wp, T("  <td align=center class=\"table2\">\n"));
	//		nBytesSent += websWrite(wp, T("    <font size=\"2\">%s</font>\n"),ip);
			nBytesSent += websWrite(wp, T("    <font size=\"2\">%s</font><input type=\"hidden\" name=\"sip%d\" value=\"%s\">\n"),ip,i,ip);
	//		nBytesSent += websWrite(wp, T("    <font size=\"2\">%s</font><input type=\"hidden\" name=\"sip%d\" value=\"%s\">\n"),ip,i,ip);
			nBytesSent += websWrite(wp, T("  </td>\n"));
			nBytesSent += websWrite(wp, T("  <td align=center class=\"table2\">\n"));
			nBytesSent += websWrite(wp, T("    <input type=\"checkbox\" name=\"select%d\" value=\"ON\">\n"),i);
			nBytesSent += websWrite(wp, T("  </td>\n"));
			nBytesSent += websWrite(wp, T("</tr>\n"));
	
	}
	nBytesSent += websWrite(wp, T("<input type=\"hidden\" name=\"smacnum\" value=\"%d\">\n"),i-1);
	return nBytesSent;
}
//-----------------------------------------------------------------
// Static DHCP lease ----------------------------------------------
void formSDHCP(webs_t wp, char_t *path, char_t *query)
{
	char_t *strAddMac, *strDelMac, *strDelAllMac, *strVal, *submitUrl, *strEnabled, *strApply;
	char tmpBuf[100];
	int entryNum, i, enabled;
	SDHCP_T entry;

	strAddMac = websGetVar(wp, T("addSDHCPMac"), T(""));
	strDelMac = websGetVar(wp, T("deleteSelDhcpMac"), T(""));
	strDelAllMac = websGetVar(wp, T("deleteAllDhcpMac"), T(""));
	strEnabled = websGetVar(wp, T("SDHCPEnabled"), T(""));

	if (strAddMac[0]) {
		if ( !gstrcmp(strEnabled, T("ON")))
			enabled = 1;
		else
			enabled = 0;
		if ( apmib_set( MIB_STATIC_DHCP_ENABLED, (void *)&enabled) == 0) {
  			DEBUGP(tmpBuf, T("Set enabled flag error!"));
			goto setErr_sdhcp;
		}

		strVal = websGetVar(wp, T("mac"), T(""));
		printf("mac=%s\n", strVal);
		if ( !strVal[0] ) {
//			DEBUGP(tmpBuf, T("Error! No mac address to set."));
			goto setsdhcp_ret;
		}
		if (strlen(strVal)!=12 || !string_to_hex(strVal, entry.macAddr, 12)) {
			DEBUGP(tmpBuf, T("Error! Invalid MAC address."));
			goto setErr_sdhcp;
		}

		printf("mac=%02x:%02x:%02x:%02x:%02x:%02x\n", entry.macAddr[0], entry.macAddr[1],entry.macAddr[2],entry.macAddr[3],entry.macAddr[4],entry.macAddr[5]);
		strVal = websGetVar(wp, T("ip"), T(""));
		printf("ip=%s\n", strVal);
		if (!strVal[0]) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspformFilterErrInput))</script>"));
			goto setErr_sdhcp;
		}

		fixed_inet_aton(strVal, entry.ipAddr);

		printf("ip=%02x.%02x.%02x.%02x\n", entry.ipAddr[0], entry.ipAddr[1],entry.ipAddr[2],entry.ipAddr[3]);
		if ( !apmib_get(MIB_STATIC_DHCP_NUM, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("Get entry number error!"));
			goto setErr_sdhcp;
		}

		if ( (entryNum + 1) > MAX_STATIC_DHCP_NUM) {

			strcpy(tmpBuf, T("Cannot add new entry because table is full!"));
			goto setErr_sdhcp;
		}

		// set to MIB. try to delete it first to avoid duplicate case
		apmib_set(MIB_STATIC_DHCP_DEL, (void *)&entry);
		if ( apmib_set(MIB_STATIC_DHCP_ADD, (void *)&entry) == 0) {
			DEBUGP(tmpBuf, T("Add table entry error!"));
			goto setErr_sdhcp;
		}
	}

	/* Delete entry */
	if (strDelMac[0]) {
		if ( !apmib_get(MIB_STATIC_DHCP_NUM, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("Get entry number error!"));
			goto setErr_sdhcp;
		}
		for (i=entryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "select%d", i);

			strVal = websGetVar(wp, tmpBuf, T(""));
			if ( !gstrcmp(strVal, T("ON")) ) {

				*((char *)&entry) = (char)i;
				if ( !apmib_get(MIB_STATIC_DHCP, (void *)&entry)) {
					DEBUGP(tmpBuf, T("Get table entry error!"));
					goto setErr_sdhcp;
				}
				if ( !apmib_set(MIB_STATIC_DHCP_DEL, (void *)&entry)) {
					DEBUGP(tmpBuf, T("Delete table entry error!"));
					goto setErr_sdhcp;
				}
			}
		}
	}

	/* Delete all entry */
	if ( strDelAllMac[0]) {
		if ( !apmib_set(MIB_STATIC_DHCP_DELALL, (void *)&entry)) {
			DEBUGP(tmpBuf, T("Delete all table error!"));
			goto setErr_sdhcp;
		}
	}

setsdhcp_ret:
	apmib_update(CURRENT_SETTING);

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	strApply = websGetVar(wp, T("isApply"), T(""));   // Tommy

#ifdef _7207CG_
	#if defined(_Customer_) | defined(_taiCustomer_)
		OK_MSG( submitUrl );
		return;
	#else
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);

	  	return;
	#endif
#else
	// Tommy Modified on 0602
	if (strApply[0]) {
#ifdef _TAG_IN_PAGE_
main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
#endif
		OK_MSG(submitUrl);
	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}

  	return;
#endif



setErr_sdhcp:
	ERR_MSG(tmpBuf);
}
//-----------------------------------------------------------------

///////////////////////////////////////////////////////////////////
void formTcpipSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strIp, *strMask, *strGateway, *strDhcp, *strStp, *submitUrl, *strMac, *strIpChanged, *strMode, *strDNS;
	char_t	*strDomainName, *strDhcpGatewayIP, *strDhcpNameServerIP, *strLeaseTime, *strDisIp, *strDhcpcheck;
	char_t  *strUser, *strPassword, *userid, *nextUserid, *strOPassword, *ipMode;	//password
	struct in_addr inIp, inMask, inGateway, inDhcpGatewayIP, inDhcpNameServerIP, dns1, dns2, dns3;
	DHCP_T dhcp, curDhcp;
	char tmpBuf[128];
	unsigned long longVal;
	int stp, DisIp=0, Dhcpcheck;
	char_t	*strdhcpRangeStart, *strdhcpRangeEnd;
	struct in_addr dhcpRangeStart, dhcpRangeEnd;
	DNS_TYPE_T dns, dns_old;
	int dns_changed=0;
	int intVal;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	strIpChanged = websGetVar(wp, T("ipChanged"), T("")); // Tommy Added
	lanipChanged = atoi(strIpChanged);


//**************************************** DNS Setting ****************************************
#if defined(_BR6428PNL_) || defined (_AP_WITH_DNS_)
		struct in_addr dns1_old, dns2_old, dns3_old;

			// If DHCP server is enabled in LAN, update dhcpd.conf
		strDNS = websGetVar(wp, T("dns1"), T(""));

			if ( strDNS[0] ) {
				if ( !inet_aton(strDNS, &dns1) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup1))</script>"));
					goto setErr_tcpip;
				}

				if ( !apmib_set(MIB_WAN_DNS1, (void *)&dns1)) {
	  				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup2))</script>"));
					goto setErr_tcpip;
				}
			}
			else {
				if ( !apmib_get(MIB_WAN_DNS1, (void *)&dns1) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup3))</script>"));
					goto setErr_tcpip;
				}
			}
			strDNS = websGetVar(wp, T("dns2"), T(""));
			if ( strDNS[0] ) {
				if ( !inet_aton(strDNS, &dns2) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup1))</script>"));
					goto setErr_tcpip;
				}
				if ( !apmib_set(MIB_WAN_DNS2, (void *)&dns2)) {
	  				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup2))</script>"));
					goto setErr_tcpip;
				}
			}
			else {
				if ( !apmib_get(MIB_WAN_DNS2, (void *)&dns2) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWanTcpipSetup5))</script>"));
					goto setErr_tcpip;
				}
			}
			strDNS = websGetVar(wp, T("dns3"), T(""));
			if ( strDNS[0] ) {
				if ( !inet_aton(strDNS, &dns3) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup1))</script>"));
					goto setErr_tcpip;
				}
				if ( !apmib_set(MIB_WAN_DNS3, (void *)&dns3)) {
	  				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup2))</script>"));
					goto setErr_tcpip;
				}
			}
			else {
				if ( !apmib_get(MIB_WAN_DNS3, (void *)&dns3) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWanTcpipSetup6))</script>"));
					goto setErr_tcpip;
				}
			}
#endif


//**************************************** password ****************************************
#if defined(_BR6428PNL_) || defined(_Airlive_7428HCN_)
	strUser = websGetVar(wp, T("admin_str"), T(""));
#else
	strUser = "admin";
#endif
#ifdef _TAG_IN_PAGE_
        main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
        sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
        third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif
	
	strPassword = websGetVar(wp, T("newpass"), T(""));
	strOPassword = websGetVar(wp, T("oldpass"), T(""));
 //printf("\n==>oldpassword=%s, newpassword= %s, tmpbuf=%s\n", strPassword, strOPassword, tmpBuf);
	apmib_get(MIB_USER_PASSWORD, (void *)tmpBuf);
	if ( strOPassword[0] || strPassword[0]) {
		if (  strcmp(strOPassword,tmpBuf )) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup1))</script>"));
		       	goto setErr_tcpip;
		}
//	printf("\noldpass=\"%s\" MIB_USER_PASSWORD=\"%s\" newpass=\"%s\"\n",strOPassword,tmpBuf,strPassword);
	if ( strUser[0] ) {
		// Check if user name is the same as supervisor name
		if ( !apmib_get(MIB_SUPER_NAME, (void *)tmpBuf)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup2))</script>"));
			goto setErr_tcpip;
		}
		if ( !strcmp(strUser, tmpBuf)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup3))</script>"));
			goto setErr_tcpip;
		}
#ifndef _BOA_
		// Check if supervisor account exist. if not, create it
		if ( !umGroupExists(DEFAULT_GROUP) )
			if ( umAddGroup(DEFAULT_GROUP, (short)PRIV_ADMIN, AM_BASIC, FALSE, FALSE) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup4))</script>"));
				goto setErr_tcpip;
			}
		if ( !umAccessLimitExists(ACCESS_URL) )
			if ( umAddAccessLimit(ACCESS_URL, AM_FULL, (short)0, DEFAULT_GROUP) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup5))</script>"));
				goto setErr_tcpip;
			}
		if ( !umUserExists("super"))
			if ( umAddUser("super", "AP@xuniL", DEFAULT_GROUP, FALSE, FALSE) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup6))</script>"));
				goto setErr_tcpip;
			}

		// Add new one
		if ( umUserExists(strUser))
			umDeleteUser(strUser);

		if ( umAddUser(strUser, strPassword, DEFAULT_GROUP, FALSE, FALSE) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup7))</script>"));
			goto setErr_tcpip;
		}
#endif
	}
#ifndef _BOA_
	else {
		umDeleteAccessLimit("/");
		umDeleteUser(superName);
		umDeleteGroup(DEFAULT_GROUP);
	}
		// Delete current user account
		userid = umGetFirstUser();
		while (userid) {
			if ( gstrcmp(userid, superName) && gstrcmp(userid, strUser)) {
				nextUserid = umGetNextUser(userid);
				if ( umDeleteUser(userid) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup8))</script>"));
					goto setErr_tcpip;
				}
				userid = nextUserid;
				continue;
			}
			userid = umGetNextUser(userid);
		}
#ifdef HOME_GATEWAY  /* Modified by Tommy  */
		if (umCommit(NULL) != 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup9))</script>"));
			goto setErr_tcpip;
		}
#endif
#endif
		// Set user account to MIB
		if ( !apmib_set(MIB_USER_NAME, (void *)strUser) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup10))</script>"));
			goto setErr_tcpip;
		}

		if ( !apmib_set(MIB_USER_PASSWORD, (void *)strPassword) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup11))</script>"));
			goto setErr_tcpip;
		}
#ifdef _Airlive_7428HCN_
		goto setErr_Password;
#endif
	}

#ifdef _Airlive_7428HCN_
	char_t *deviceName, *ipFinder;

        deviceName = websGetVar(wp, T("DeviaceName"), T(""));
        if (deviceName[0]) {
                if ( apmib_set(MIB_DEVICE_NAME, (void *)deviceName) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup13))</script>"));
                        goto setErr_tcpip;
                }
        }

	ipFinder = websGetVar(wp, T("ipFinder"), T(""));
        if ( !gstrcmp(ipFinder, T("ON")))
                intVal = 1;
        else
                intVal = 0;
        if ( apmib_set( MIB_IP_FINDER, (void *)&intVal) == 0) {
                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup1))</script>"));
                goto setErr_tcpip;
        }

#endif

#ifdef _WEB_PORT_
	char_t *webPort;
	webPort = websGetVar(wp, T("webPort"), T(""));
	if ( webPort[0] ){
		intVal = atoi(webPort);
                if ( apmib_set(MIB_WEB_PORT, (void *)&intVal) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup13))</script>"));
                        goto setErr_tcpip;
                }
	}
#endif
	strLeaseTime = websGetVar(wp, T("leaseTime"), T(""));
	if (strLeaseTime[0]) {
		if ( !(longVal=strtoul(strLeaseTime,NULL,0))) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup12))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_LAN_LEASETIME, (void *)&longVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup13))</script>"));
			goto setErr_tcpip;
		}
	}
//---------------------------------   Client Mode   ----------------------------------------------
	// Set client mode ip type
	strDisIp = websGetVar(wp, T("clIpDisabled"), T(""));
	if (strDisIp[0]) {
		if (strDisIp[0] == '0')
			DisIp = 0;
		else
			DisIp = 1;
		if ( !apmib_set(MIB_CLIENT_IP_DISABLED, (void *)&DisIp)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup14))</script>"));
			goto setErr_tcpip;
		}
	}
//----------------------------------------------------------------------------------------
	// Set STP
	strStp = websGetVar(wp, T("stp"), T(""));
	if (strStp[0]) {
		if (strStp[0] == '0')
			stp = 0;
		else
			stp = 1;
		if ( !apmib_set(MIB_STP_ENABLED, (void *)&stp)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup15))</script>"));
			goto setErr_tcpip;
		}
	}

	// Set clone MAC address
	strMac = websGetVar(wp, T("macAddr"), T(""));
	if (strMac[0]) {
		if (strlen(strMac)!=12 || !string_to_hex(strMac, tmpBuf, 12)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup16))</script>"));
			goto setErr_tcpip;
		}
		if ( !apmib_set(MIB_ELAN_MAC_ADDR, (void *)tmpBuf)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup17))</script>"));
			goto setErr_tcpip;
		}
		if ( !apmib_set(MIB_WLAN_MAC_ADDR, (void *)tmpBuf)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup18))</script>"));
			goto setErr_tcpip;
		}
	}
#if defined(_BR6428PNL_) || defined(_AP_WITH_DHCP_CLIENT_)
	strDhcpcheck = websGetVar(wp, T("dhcpcheck"), T(""));
	if (strDhcpcheck[0]) {
                if (strDhcpcheck[0] == '0')
			Dhcpcheck = 0;
		else
			Dhcpcheck = 1;
                if ( !apmib_set(MIB_DHCP_CHECK_ENABLED, (void *)&Dhcpcheck)) {
			DEBUGP(tmpBuf, T("set DHCP_CHECK_ENABLED fail!"));
                        goto setErr_tcpip;
                }
        }
#endif
//**************************************** DHCP Server ****************************************
	// Read current DHCP setting for reference later
	if ( !apmib_get( MIB_DHCP, (void *)&curDhcp) ) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup19))</script>"));
		goto setErr_tcpip;
	}

	strDhcp = websGetVar(wp, T("dhcp"), T(""));
	if ( strDhcp[0] ) {
		if ( strDhcp[0]!='0' && strDhcp[0]!='1' && strDhcp[0]!='2' ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup20))</script>"));
			goto setErr_tcpip;
		}
		// set to MIB
		if ( strDhcp[0] == '0' )
			dhcp = DHCP_DISABLED;
		else if (strDhcp[0] == '1')
			dhcp = DHCP_CLIENT;
		else
			dhcp = DHCP_SERVER;

		if ( !apmib_set(MIB_DHCP, (void *)&dhcp)) {
	  		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup21))</script>"));
			goto setErr_tcpip;
		}
	}
	else
		dhcp = curDhcp;

	if ( dhcp == DHCP_DISABLED || dhcp == DHCP_SERVER ) {
//---------------------------------------------------------------------------------------
		strDomainName = websGetVar(wp, T("DomainName"), T(""));
		if (strDhcp[0]!='0'){
   	     if ( apmib_set(MIB_DOMAIN_NAME, (void *)strDomainName) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup22))</script>"));
		        goto setErr_tcpip;
			}
		}
		strDhcpGatewayIP = websGetVar(wp, T("DhcpGatewayIP"), T(""));
		if ( strDhcpGatewayIP[0] ) {
			if ( !inet_aton(strDhcpGatewayIP, &inDhcpGatewayIP) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
				goto setErr_tcpip;
			}
			if ( !apmib_set( MIB_DHCPGATEWAYIP_ADDR, (void *)&inDhcpGatewayIP)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
				goto setErr_tcpip;
			}
		}
		strDhcpNameServerIP = websGetVar(wp, T("DhcpNameServerIP"), T(""));
		if ( strDhcpNameServerIP[0] ){
			if ( !inet_aton(strDhcpNameServerIP, &inDhcpNameServerIP) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
				goto setErr_tcpip;
			}
			if ( !apmib_set( MIB_DHCPNAMESERVER_ADDR, (void *)&inDhcpNameServerIP)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
				goto setErr_tcpip;
			}

		}

//**************************************** Ip Settings ****************************************
	if (DisIp != 1) {	// DHCP Client
		strIp = websGetVar(wp, T("ip"), T(""));
		if ( strIp[0] ) {
			if ( !inet_aton(strIp, &inIp) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
				goto setErr_tcpip;
			}
			if ( !apmib_set( MIB_IP_ADDR, (void *)&inIp)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
				goto setErr_tcpip;
			}
		}
		else { // get current used IP
			if ( !getInAddr(BRIDGE_IF, IP_ADDR, (void *)&inIp) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup25))</script>"));
				goto setErr_tcpip;
			}
		}

		strMask = websGetVar(wp, T("mask"), T(""));
		if ( strMask[0] ) {
			if ( !inet_aton(strMask, &inMask) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup26))</script>"));
				goto setErr_tcpip;
			}
			if ( !apmib_set(MIB_SUBNET_MASK, (void *)&inMask)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup27))</script>"));
				goto setErr_tcpip;
			}
		}
		else { // get current used netmask
			if ( !getInAddr(BRIDGE_IF, SUBNET_MASK, (void *)&inMask )) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup28))</script>"));
				goto setErr_tcpip;
			}
		}
		strGateway = websGetVar(wp, T("gateway"), T(""));
//		if ( dhcp == DHCP_DISABLED && strGateway[0] ) {
		if ( strGateway[0] ) {
			if ( !inet_aton(strGateway, &inGateway) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup29))</script>"));
				goto setErr_tcpip;
			}
			if ( !apmib_set(MIB_DEFAULT_GATEWAY, (void *)&inGateway)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup30))</script>"));
				goto setErr_tcpip;
			}
		}
	}
//****************************************  ****************************************
		if ( dhcp == DHCP_SERVER ) {
			// Get/Set DHCP client range
			strdhcpRangeStart = websGetVar(wp, T("dhcpRangeStart"), T(""));
			if ( strdhcpRangeStart[0] ) {
				if ( !inet_aton(strdhcpRangeStart, &dhcpRangeStart) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup31))</script>"));
					goto setErr_tcpip;
				}
				if ( !apmib_set(MIB_DHCP_CLIENT_START, (void *)&dhcpRangeStart)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup32))</script>"));
					goto setErr_tcpip;
				}
			}
			strdhcpRangeEnd = websGetVar(wp, T("dhcpRangeEnd"), T(""));
			if ( strdhcpRangeEnd[0] ) {
				if ( !inet_aton(strdhcpRangeEnd, &dhcpRangeEnd) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup33))</script>"));
					goto setErr_tcpip;
				}
				if ( !apmib_set(MIB_DHCP_CLIENT_END, (void *)&dhcpRangeEnd)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup34))</script>"));
					goto setErr_tcpip;
				}
			}

			// update DHCP server config file
			if ( strdhcpRangeStart[0] && strdhcpRangeEnd[0] ) {
				unsigned long start, end, mask, ip, diff;

				start = *((unsigned long *)&dhcpRangeStart);
				end = *((unsigned long *)&dhcpRangeEnd);
				diff =  ((end) - (start)) ;
				ip = *((unsigned long *)&inIp);
				mask = *((unsigned long *)&inMask);
				if (diff <= 0 ||
//					diff > 256*3 ||
					(ip&mask) != (start&mask) ||
					(ip&mask) != (end& mask) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup35))</script>"));
					goto setErr_tcpip;
				}
			}
			#ifdef _DHCP_SERVER_WITH_GW_DNS_
				char_t *strdhcpGW, *strdhcpDNS1, *strdhcpDNS2;
				struct in_addr dhcpGW, dhcpDNS1, dhcpDNS2;

				strdhcpGW = websGetVar(wp, T("dhcpGW"), T(""));
				if ( strdhcpGW[0] )
				{
					inet_aton(strdhcpGW, &dhcpGW);
					apmib_set(MIB_DHCP_SERVER_GW, (void *)&dhcpGW);
				}

				strdhcpDNS1 = websGetVar(wp, T("dhcpDNS1"), T(""));
				if ( strdhcpDNS1[0] )
				{
					inet_aton(strdhcpDNS1, &dhcpDNS1);
					apmib_set(MIB_DHCP_SERVER_DNS1, (void *)&dhcpDNS1);
				}

				strdhcpDNS2 = websGetVar(wp, T("dhcpDNS2"), T(""));
				if ( strdhcpDNS2[0] )
				{
					inet_aton(strdhcpDNS2, &dhcpDNS2);
					apmib_set(MIB_DHCP_SERVER_DNS2, (void *)&dhcpDNS2);
				}
			#endif
		}
	}
setErr_Password:

	apmib_update(CURRENT_SETTING);	// update configuration to flash

//	printf("FFFF=%s\n",strIp);
//	LAN_MSG(strIp);	// display reconnect msg to remote
#ifndef NO_ACTION
/*	pid = fork();
        if (pid)
                waitpid(pid, NULL, 0);
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG);*/
#ifdef HOME_GATEWAY
/*if (strwanMode[0])
	execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", "all", NULL);
else
	execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", "bridge", NULL);*/
	//system("/bin/init.sh gw all"); // Tommy
#else
//	execl( tmpBuf, _CONFIG_SCRIPT_PROG, "ap", "bridge", NULL);
	//system("/bin/init.sh ap all"); // Tommy
#endif
  //              exit(1);
  //      }
#endif

//	submitUrl = websGetVar(wp, T("submit-url"), T(""));
//	RECONNECT_MSG(submitUrl);	// display reconnect msg to remote
	char_t *redirect_for_change_passwd;
	redirect_for_change_passwd=websGetVar(wp, T("redirect_for_change_passwd"),T("")); //EDX patrick for fixed login again

	if(redirect_for_change_passwd[0]){
		REPLACE_MSG(submitUrl);
	}
	else{
	OK_MSG(submitUrl);	// display reconnect msg to remote
 }
	return;

setErr_tcpip:
	ERR_MSG(tmpBuf);
	return;
}
/////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef HOME_GATEWAY
void formPreventionSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strpodEnable, *strpingEnable, *strscanEnable, *strsynEnable,*submitUrl, *strBasic;
	char_t	*strpodPack, *strpodTime, *strpodBur, *strsynPack, *strsynTime, *strsynBur, *strscanNum;
	
	int intVal, val;
	char tmpBuf[128];
	unsigned long longVal;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

//**************************************** Ping of Death ****************************************
	strpodEnable = websGetVar(wp, T("podEnable"), T(""));
	if ( !gstrcmp(strpodEnable, T("ON")))
		intVal = 1;
	else
		intVal = 0;
	if ( apmib_set( MIB_POD_ENABLED, (void *)&intVal) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup1))</script>"));
		goto setErr_tcpip;
	}
	strpodPack = websGetVar(wp, T("podPack"), T(""));
	if (strpodPack[0]) {
		if ( !string_to_dec(strpodPack, &val) || val<0 || val>255) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup2))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_POD_PACK, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup3))</script>"));
			goto setErr_tcpip;
		}
	}
	strpodTime = websGetVar(wp, T("podTime"), T(""));
	if (strpodTime[0]) {
		errno=0;
		val = strtol( strpodTime, (char **)NULL, 10);
		if (errno) {
   			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup4))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set( MIB_POD_TIME, (void *)&val) == 0) {
   			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup5))</script>"));
			goto setErr_tcpip;
		}
	}
	strpodBur = websGetVar(wp, T("podBur"), T(""));
	if (strpodBur[0]) {
		if ( !string_to_dec(strpodBur, &val) || val<0 || val>255) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup6))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_POD_BUR, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup7))</script>"));
			goto setErr_tcpip;
		}
	}

//*********************************** Discard Ping From WAN ***********************************
	strpingEnable = websGetVar(wp, T("pingEnable"), T(""));
	if ( !gstrcmp(strpingEnable, T("ON")))
		intVal = 1;
	else
		intVal = 0;
	if ( apmib_set( MIB_PIN_ENABLED, (void *)&intVal) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup1))</script>"));
		goto setErr_tcpip;
	}
//**************************************** Port Scan ****************************************
	strscanEnable = websGetVar(wp, T("scanEnable"), T(""));
	if ( !gstrcmp(strscanEnable, T("ON")))
		intVal = 1;
	else
		intVal = 0;
	if ( apmib_set( MIB_SCAN_ENABLED, (void *)&intVal) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup1))</script>"));
		goto setErr_tcpip;
	}

	strBasic = websGetVar(wp, T("basic"), T(""));
	if (!strBasic[0]) {
		strscanNum = websGetVar(wp, T("scanNumVal"), T(""));
		longVal=strtoul(strscanNum,NULL,0);
		if ( apmib_set(MIB_SCAN_NUM, (void *)&longVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup8))</script>"));
			goto setErr_tcpip;
		}
	}
//**************************************** Sync Flood ****************************************
	strsynEnable = websGetVar(wp, T("synEnable"), T(""));
	if ( !gstrcmp(strsynEnable, T("ON")))
		intVal = 1;
	else
		intVal = 0;
	if ( apmib_set( MIB_SYN_ENABLED, (void *)&intVal) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup1))</script>"));
		goto setErr_tcpip;
	}

	strsynPack = websGetVar(wp, T("synPack"), T(""));
	if (strsynPack[0]) {
		if ( !string_to_dec(strsynPack, &val) || val<0 || val>255) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup9))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_SYN_PACK, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup10))</script>"));
			goto setErr_tcpip;
		}
	}

	strsynTime = websGetVar(wp, T("synTime"), T(""));
	if (strsynTime[0]) {
		errno=0;
		val = strtol( strsynTime, (char **)NULL, 10);
		if (errno) {
   			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup11))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set( MIB_SYN_TIME, (void *)&val) == 0) {
   			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup12))</script>"));
			goto setErr_tcpip;
		}
	}
	strsynBur = websGetVar(wp, T("synBur"), T(""));
	if (strsynBur[0]) {
		if ( !string_to_dec(strsynBur, &val) || val<0 || val>255) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup13))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_SYN_BUR, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup14))</script>"));
			goto setErr_tcpip;
		}
	}



	apmib_update(CURRENT_SETTING);	// update to flash

#ifndef NO_ACTION
/*	pid = fork();
        if (pid) {
	      	waitpid(pid, NULL, 0);
	}
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG);
		execl( tmpBuf, _FIREWALL_SCRIPT_PROG, NULL);
               	exit(1);
        }*/
	// system("/bin/firewall.sh"); // Tommy
#endif
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif
	OK_MSG(submitUrl);

	//OK_MSG(submitUrl);

	return;
setErr_tcpip:
	ERR_MSG(tmpBuf);
	return;
}
#if defined(_ENRIP_)
////////
void formRIPSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strripEnable, *submitUrl;
	int  val;
	char tmpBuf[128];

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page



	strripEnable = websGetVar(wp, T("ripEnable"), T(""));

	if (strripEnable[0]) {
		if (!gstrcmp(strripEnable, T("no")))
			val = 0;
		else if (!gstrcmp(strripEnable, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRIPSetup1))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_RIP_ENABLED, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRIPSetup2))</script>"));
			goto setErr_tcpip;
		}
	}

	apmib_update(CURRENT_SETTING);	// update to flash

#ifndef NO_ACTION
/*	pid = fork();
        if (pid) {
	      	waitpid(pid, NULL, 0);
	}
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG);
		execl( tmpBuf, _FIREWALL_SCRIPT_PROG, NULL);
               	exit(1);
        }*/
	// system("/bin/upnp.sh"); // Tommy
#endif


	OK_MSG(submitUrl);

	return;
setErr_tcpip:
	ERR_MSG(tmpBuf);
}
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////
void formUPNPSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strupnpEnable, *submitUrl;
	int val;
	char tmpBuf[128];

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	strupnpEnable = websGetVar(wp, T("upnpEnable"), T(""));
	if (strupnpEnable[0]) {
		if (!gstrcmp(strupnpEnable, T("no")))
			val = 0;
		else if (!gstrcmp(strupnpEnable, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormUPNPSetup1))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_UPNP_ENABLE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormUPNPSetup2))</script>"));
			goto setErr_tcpip;
		}
	}

	apmib_update(CURRENT_SETTING);	// update to flash

#ifndef NO_ACTION
/*	pid = fork();
        if (pid) {
	      	waitpid(pid, NULL, 0);
	}
        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG);
		execl( tmpBuf, _FIREWALL_SCRIPT_PROG, NULL);
               	exit(1);
        }*/
	// system("/bin/upnp.sh"); // Tommy
#endif

#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif


	OK_MSG(submitUrl);


	return;
setErr_tcpip:
	ERR_MSG(tmpBuf);
}
/////////////////////////////////////////////////////////////////////////////////////////////////
// Lance 2004.2.9
void formPSSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strPTR, *submitUrl;
	int val;
	char tmpBuf[128];

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	strPTR = websGetVar(wp, T("PSEnable"), T(""));
	if (strPTR[0]) {
		if (!gstrcmp(strPTR, T("no")))
			val = 0;
		else if (!gstrcmp(strPTR, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPSSetup1))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_PS_ENABLE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPSSetup2))</script>"));
			goto setErr_tcpip;
		}
	}
	strPTR = websGetVar(wp, T("PS_IPPEnable"), T(""));
	if (strPTR[0]) {
		if (!gstrcmp(strPTR, T("no")))
			val = 0;
		else if (!gstrcmp(strPTR, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPSSetup3))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_PS_IPPENABLE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPSSetup4))</script>"));
			goto setErr_tcpip;
		}
	}
	strPTR = websGetVar(wp, T("PS_LPREnable"), T(""));
	if (strPTR[0]) {
		if (!gstrcmp(strPTR, T("no")))
			val = 0;
		else if (!gstrcmp(strPTR, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPSSetup5))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_PS_LPRENABLE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPSSetup6))</script>"));
			goto setErr_tcpip;
		}
	}
    strPTR = websGetVar(wp, T("PSName"), T(""));
    if ( strPTR[0] ) {
	    if ( apmib_set(MIB_PS_NAME, (void *)strPTR) == 0) {
    	    DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPSSetup7))</script>"));
            goto setErr_tcpip;
        }
    }
    strPTR = websGetVar(wp, T("PS_Port1Name"), T(""));
    if ( strPTR[0] ) {
	    if ( apmib_set(MIB_PS_PORT1NAME, (void *)strPTR) == 0) {
    	    DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPSSetup8))</script>"));
            goto setErr_tcpip;
        }
    }
    strPTR = websGetVar(wp, T("PS_Port2Name"), T(""));
    if ( strPTR[0] ) {
	    if ( apmib_set(MIB_PS_PORT2NAME, (void *)strPTR) == 0) {
    	    DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPSSetup9))</script>"));
            goto setErr_tcpip;
        }
    }

	apmib_update(CURRENT_SETTING);	// update to flash

#ifndef NO_ACTION
	//system("/bin/pserver.sh"); // Tommy
	//system("/bin/reboot.sh");
#endif

	OK_MSG(submitUrl);

	return;
setErr_tcpip:
	ERR_MSG(tmpBuf);
}
// End - Lance
/////////////////////////////////////////////////////////////////////////////////////////////////
void formTELBPSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strtelBPIPAddr, *submitUrl, *strVal;
	char_t  *strName, *strPassword, *strwanMode;
	int intVal, Mode;
	struct in_addr intelBPIPAddr;
	char tmpBuf[128];

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	strtelBPIPAddr = websGetVar(wp, T("telBPIPAddr"), T(""));
	if ( strtelBPIPAddr[0] ) {
		if ( !inet_aton(strtelBPIPAddr, &intelBPIPAddr) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
			goto setErr_telstra;
		}
		if ( !apmib_set( MIB_TELBPIP_ADDR, (void *)&intelBPIPAddr)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
			goto setErr_telstra;
		}
	}
	strName = websGetVar(wp, T("telBPUserName"), T(""));
		if ( strName[0] ) {
			if ( apmib_set(MIB_TELBP_USER, (void *)strName) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTELBPSetup1))</script>"));
				goto setErr_telstra;
			}
		}
	strPassword = websGetVar(wp, T("telBPPassword"), T(""));
		if ( strPassword[0] ) {
			if ( apmib_set(MIB_TELBP_PASSWORD, (void *)strPassword) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTELBPSetup2))</script>"));
				goto setErr_telstra;
			}
		}
	strVal = websGetVar(wp, T("telBPEnabled"), T(""));
	if ( !gstrcmp(strVal, T("ON")))
		intVal = 1;
	else
		intVal = 0;

	if ( apmib_set(MIB_TELBP_ENABLED, (void *)&intVal) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup1))</script>"));
		goto setErr_telstra;
	}
	strwanMode = websGetVar(wp, T("wanMode"), T(""));
	if ( strwanMode[0] ) {
		if ( !gstrcmp(strwanMode, T("4")))
			Mode = 4;
	   if ( apmib_set( MIB_WAN_MODE, (void *)&Mode) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup1))</script>"));
			goto setErr_telstra;
		}
	}
	apmib_update(CURRENT_SETTING);	// update to flash

	// run script
#ifndef NO_ACTION
	// sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all"); // Tommy
	// system(tmpBuf);
#endif
	OK_MSG(submitUrl);
	return;

setErr_telstra:
	ERR_MSG(tmpBuf);

}
/////////////////////////////////////////////////////////////////////////////////////////////
#ifdef _WAN3G_
void form3GSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*submitUrl, *wizardmode;
	char_t  *strwwanName, *strwwanPassword, *strPINCode, *strwwanAPN, *strOPModeSel, *strAuthModeSel, *strNPSel ;
	char_t	*strPPPName, *strPPPPass, *strPPPIdleTime, *strPPPEchoTimeout, *strPPPEchoCount, *strwwanPhoneNo;
	char_t  *strAuthP1, *strAuthP2, *strAuthQ1, *strAuthQ2;
	char tmpBuf[128];
	int val;
	unsigned long longVal;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	strAuthModeSel = websGetVar(wp, T("AuthModeSel"), T(""));
	if ( strAuthModeSel[0] ) {
		if ( apmib_set(MIB_WWAN_AUTHMODESEL, (void *)strAuthModeSel) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN Authentication Mode MIB error!"));
			goto setErr_tcpip;
		}
	}

	strOPModeSel = websGetVar(wp, T("OPModeSel"), T(""));
	if ( strOPModeSel[0] ) {
		if ( apmib_set(MIB_WWAN_OPMODESEL, (void *)strOPModeSel) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN Operation Mode MIB error!"));
			goto setErr_tcpip;
		}
	}

	strNPSel = websGetVar(wp, T("NPSel"), T(""));
	if ( strNPSel[0] ) {
		if ( apmib_set(MIB_WWAN_NPSEL, (void *)strNPSel) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN Network Preference MIB error!"));
			goto setErr_tcpip;
		}
	}

	strwwanName = websGetVar(wp, T("wwanName"), T(""));
	if ( strwwanName[0] ) {
		if ( apmib_set(MIB_WWAN_NAME, (void *)strwwanName) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN User Name MIB error!"));
			goto setErr_tcpip;
		}
	}

	strwwanPassword = websGetVar(wp, T("wwanPassword"), T(""));
	if ( strwwanPassword[0] ) {
		if ( apmib_set(MIB_WWAN_PASSWORD, (void *)strwwanPassword) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN Password MIB error!"));
			goto setErr_tcpip;
		}
	}

	strPINCode = websGetVar(wp, T("PINCode"), T(""));
//	if ( strPINCode[0] ) {
		if ( apmib_set(MIB_WWAN_PINCODE, (void *)strPINCode) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN PINCode MIB error!"));
			goto setErr_tcpip;
		}
//	}

	strwwanAPN = websGetVar(wp, T("wwanAPN"), T(""));
	if ( strwwanAPN[0] ) {
		if ( apmib_set(MIB_WWAN_APN, (void *)strwwanAPN) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN Access Point Nmae MIB error!"));
			goto setErr_tcpip;
		}
	}

	strwwanPhoneNo = websGetVar(wp, T("wwanPhoneNo"), T(""));
	if ( strwwanPhoneNo[0] ) {
		if ( apmib_set(MIB_WWAN_PHONENO, (void *)strwwanPhoneNo) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN Phone Number MIB error!"));
			goto setErr_tcpip;
		}
	}

	strPPPName = websGetVar(wp, T("PPPName"), T(""));
//	if ( strPPPName[0] ) {
		if ( apmib_set(MIB_WWAN_PPPNAME, (void *)strPPPName) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN PPP Name MIB error!"));
			goto setErr_tcpip;
		}
//	}

	strPPPPass = websGetVar(wp, T("PPPPass"), T(""));
//	if ( strPPPPass[0] ) {
		if ( apmib_set(MIB_WWAN_PPPPASS, (void *)strPPPPass) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN PPP Password MIB error!"));
			goto setErr_tcpip;
		}
//	}

	strPPPIdleTime = websGetVar(wp, T("PPPIdleTime"), T(""));
	if ( strPPPIdleTime[0] ) {
		int time;
		time = strtol(strPPPIdleTime, (char**)NULL, 10);
		if ( apmib_set(MIB_WWAN_PPPIDLETIME, (void *)&time) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN PPP Idle Time MIB error!"));
			goto setErr_tcpip;
		}
	}

	strPPPEchoTimeout = websGetVar(wp, T("PPPEchoTimeout"), T(""));
	if ( strPPPEchoTimeout[0] ) {
		int time;
		time = strtol(strPPPEchoTimeout, (char**)NULL, 10);
		if ( apmib_set(MIB_WWAN_PPPECHOTIMEOUT, (void *)&time) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN PPP Echo Time Out MIB error!"));
			goto setErr_tcpip;
		}
	}

	strPPPEchoCount = websGetVar(wp, T("PPPEchoCount"), T(""));
	if ( strPPPEchoCount[0] ) {
		int time;
		time = strtol(strPPPEchoCount, (char**)NULL, 10);
		if ( apmib_set(MIB_WWAN_PPPECHOCOUNT, (void *)&time) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN PPP Echo Count MIB error!"));
			goto setErr_tcpip;
		}
	}

//--------------------------------------------------------------------------------------
	apmib_update(CURRENT_SETTING);	// update to flash

	// run script
/*	if ( dns_changed )
		arg = "all";
	else
		arg = "wan";
*/
#ifndef NO_ACTION
/*        pid = fork();
        if (pid)
                waitpid(pid, NULL, 0);

        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG);
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", arg, NULL);
                exit(1);
        }*/
	// sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all"); // Tommy
	// system(tmpBuf);
#endif
        wizardmode = websGetVar(wp, T("wizard_enable"), T(""));
//      if ( !gstrcmp(strtimezoneEnable, T("ON"))){
        if (wizardmode[0]){
                REPLACE_MSG(submitUrl);
                return;
        } else {
                OK_MSG(submitUrl);
                return;
        }

setErr_tcpip:
	ERR_MSG(tmpBuf);

}
#endif
/////////////////////////////////////////////////////////////////////////////////////////////
#ifdef _STAR_CF_3G_ //vance 2009.02.04 3G connection for NetIndex
void formWan3GSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*submitUrl, *wizardmode;
	char_t   *strwwanAPN;
	char_t	*strPPPName, *strPPPPass, *strPPPEchoTimeout, *strPPPEchoCount, *strconnetType,*strConnect;
	int buttonState=0;
	char tmpBuf[128];
	int val;
	unsigned long longVal;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

#ifdef _GENERAL_3G_ //vance 2009.04.09 for general
	char_t  *strwwanName, *strwwanPassword, *strPINCode, *strOPModeSel, *strAuthModeSel, *strNPSel ;
	char_t	*strPPPIdleTime, *strwwanPhoneNo;
	char_t  *strAuthP1, *strAuthP2, *strAuthQ1, *strAuthQ2;

		strAuthModeSel = websGetVar(wp, T("AuthModeSel"), T(""));
		if ( strAuthModeSel[0] ) {
			if ( apmib_set(MIB_WWAN_AUTHMODESEL, (void *)strAuthModeSel) == 0) {
				DEBUGP(tmpBuf, T("Set WWAN Authentication Mode MIB error!"));
				goto setErr_tcpip;
			}
		}

		strOPModeSel = websGetVar(wp, T("OPModeSel"), T(""));
		if ( strOPModeSel[0] ) {
			if ( apmib_set(MIB_WWAN_OPMODESEL, (void *)strOPModeSel) == 0) {
				DEBUGP(tmpBuf, T("Set WWAN Operation Mode MIB error!"));
				goto setErr_tcpip;
			}
		}

		strNPSel = websGetVar(wp, T("NPSel"), T(""));
		if ( strNPSel[0] ) {
			if ( apmib_set(MIB_WWAN_NPSEL, (void *)strNPSel) == 0) {
				DEBUGP(tmpBuf, T("Set WWAN Network Preference MIB error!"));
				goto setErr_tcpip;
			}
		}

		strwwanName = websGetVar(wp, T("wwanName"), T(""));
		//if ( strwwanName[0] ) {
			if ( apmib_set(MIB_WWAN_NAME, (void *)strwwanName) == 0) {
				DEBUGP(tmpBuf, T("Set WWAN User Name MIB error!"));
				goto setErr_tcpip;
			}
		//}

		strwwanPassword = websGetVar(wp, T("wwanPassword"), T(""));
		//if ( strwwanPassword[0] ) {
			if ( apmib_set(MIB_WWAN_PASSWORD, (void *)strwwanPassword) == 0) {
				DEBUGP(tmpBuf, T("Set WWAN Password MIB error!"));
				goto setErr_tcpip;
			}
		//}

		strPINCode = websGetVar(wp, T("PINCode"), T(""));
	//	if ( strPINCode[0] ) {
			if ( apmib_set(MIB_WWAN_PINCODE, (void *)strPINCode) == 0) {
				DEBUGP(tmpBuf, T("Set WWAN PINCode MIB error!"));
				goto setErr_tcpip;
			}
	//	}

		strwwanPhoneNo = websGetVar(wp, T("wwanPhoneNo"), T(""));
		if ( strwwanPhoneNo[0] ) {
			if ( apmib_set(MIB_WWAN_PHONENO, (void *)strwwanPhoneNo) == 0) {
				DEBUGP(tmpBuf, T("Set WWAN Phone Number MIB error!"));
				goto setErr_tcpip;
			}
		}

		strPPPIdleTime = websGetVar(wp, T("PPPIdleTime"), T(""));
		if ( strPPPIdleTime[0] ) {
			int time;
			time = strtol(strPPPIdleTime, (char**)NULL, 10);
			if ( apmib_set(MIB_WWAN_PPPIDLETIME, (void *)&time) == 0) {
				DEBUGP(tmpBuf, T("Set WWAN PPP Idle Time MIB error!"));
				goto setErr_tcpip;
			}
		}
#endif

	strwwanAPN = websGetVar(wp, T("wwanAPN"), T(""));
	if ( strwwanAPN[0] ) {
		if ( apmib_set(MIB_WWAN_APN, (void *)strwwanAPN) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN Access Point Nmae MIB error!"));
			goto setErr_tcpip;
		}
	}

	strPPPName = websGetVar(wp, T("PPPName"), T(""));
//	if ( strPPPName[0] ) {
		if ( apmib_set(MIB_WWAN_PPPNAME, (void *)strPPPName) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN PPP Name MIB error!"));
			goto setErr_tcpip;
		}
//	}

	strPPPPass = websGetVar(wp, T("PPPPass"), T(""));
//	if ( strPPPPass[0] ) {
		if ( apmib_set(MIB_WWAN_PPPPASS, (void *)strPPPPass) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN PPP Password MIB error!"));
			goto setErr_tcpip;
		}
//	}

	strPPPEchoTimeout = websGetVar(wp, T("PPPEchoTimeout"), T(""));
	if ( strPPPEchoTimeout[0] ) {
		int time;
		time = strtol(strPPPEchoTimeout, (char**)NULL, 10);
		if ( apmib_set(MIB_WWAN_PPPECHOTIMEOUT, (void *)&time) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN PPP Echo Time Out MIB error!"));
			goto setErr_tcpip;
		}
	}

	strPPPEchoCount = websGetVar(wp, T("PPPEchoCount"), T(""));
	if ( strPPPEchoCount[0] ) {
		int time;
		time = strtol(strPPPEchoCount, (char**)NULL, 10);
		if ( apmib_set(MIB_WWAN_PPPECHOCOUNT, (void *)&time) == 0) {
			DEBUGP(tmpBuf, T("Set WWAN PPP Echo Count MIB error!"));
			goto setErr_tcpip;
		}
	}

	strconnetType = websGetVar(wp, T("connetType"), T(""));
	if ( strconnetType[0] ) {
		int time;
		time = atoi(strconnetType);
		if ( apmib_set(MIB_WWAN_CONNETTYPE, (void *)&time) == 0) {
			DEBUGP(tmpBuf, T("Set connection type MIB error!"));
			goto setErr_tcpip;
		}
	}
    strConnect = websGetVar(wp, T("pppConnect"), T(""));
    if (strConnect[0]) {
    	buttonState = 1;
    //	goto set_ppp3g;
    }
    strConnect = websGetVar(wp, T("pppDisconnect"), T(""));
    if (strConnect[0]) {
    	buttonState = 2;
    	//goto set_ppp3g;
    }



//vance 2009.02.19
if (buttonState == 1 ) { // disconnect button is pressed
	int wait_time=30;
	apmib_update(CURRENT_SETTING);	// update to flash
#ifndef NO_ACTION
			system("kill -9 `pidof probe3g` 2>/dev/null");
			system("/bin/probe3g &");
			system("kill -9 `pid of ppp3gloop.sh` 2>/dev/null");
			system("/bin/scriptlib_util.sh run_STAR3G");
			while (wait_time-- >0) {
				if (isConnectPPP4())
				break;
				sleep(1);
			}
			if (isConnectPPP4())
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup11))</script>\n"));
			else
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup12))</script>\n"));

			OK_MSG1(tmpBuf, submitUrl);
#endif
			return;
		}

else if (buttonState == 2 ) { // disconnect button is pressed

			apmib_update(CURRENT_SETTING);	// update to flash
#ifndef NO_ACTION
			system("/bin/disconnect.sh pppoe 0 all");
			system("kill -9 `pid of ppp3gloop.sh` 2>/dev/null");
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup20))</script>\n"));
			OK_MSG1(tmpBuf, submitUrl);
#endif
			return;
		}

//--------------------------------------------------------------------------------------
	apmib_update(CURRENT_SETTING);	// update to flash

	wizardmode = websGetVar(wp, T("wizard_enable"), T(""));
	//      if ( !gstrcmp(strtimezoneEnable, T("ON"))){
    if (wizardmode[0]){
            REPLACE_MSG(submitUrl);
            return;
    } else {
            OK_MSG(submitUrl);
            return;
    }

setErr_tcpip:
	ERR_MSG(tmpBuf);

}
#endif
/////////////////////////////////////////////////////////////////////////////////////////////////
void formDDNSSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*submitUrl;
	char_t  *strName, *strPassword, *strAccount, *strEnable, *strpvidSel;
	char_t	*strHostID, *strAddress, *strdhispass, *strdhisSelect;
	char_t  *strAuthP1, *strAuthP2, *strAuthQ1, *strAuthQ2;
//	struct in_addr inAddress;
	char tmpBuf[128];
	int val;
	unsigned long longVal;
/*#ifndef NO_ACTION
	int pid;
#endif*/

/*	int dns_changed=0;
	char *arg;
*/
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	strEnable = websGetVar(wp, T("ddnsEnable"), T(""));
	if (strEnable[0]) {
		if (!gstrcmp(strEnable, T("0"))){
			val = 0;

		}
		else if (!gstrcmp(strEnable, T("1")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspError))</script>"));
			goto setErr_tcpip;
		}



		if ( apmib_set(MIB_DDNS_ENABLE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup1))</script>"));
			goto setErr_tcpip;
		}
		val = 1;
		if ( apmib_set(MIB_DDNS_STATUS, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup1))</script>"));
			goto setErr_tcpip;
		}


	}

	strpvidSel = websGetVar(wp, T("ddnspvidSel"), T(""));
	if ( strpvidSel[0] ) {
		if ( apmib_set(MIB_DDNS_PVIDSEL, (void *)strpvidSel) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup2))</script>"));
			goto setErr_tcpip;
		}
	}

	if ( strcmp(strpvidSel,"dhis") && strcmp(strpvidSel,"aiaimamor")) {

		strName = websGetVar(wp, T("ddnsName"), T(""));
		if ( strName[0] ) {
			if ( apmib_set(MIB_DDNS_NAME, (void *)strName) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup3))</script>"));
				goto setErr_tcpip;
			}
		}
		strAccount = websGetVar(wp, T("ddnsAccount"), T(""));
		if ( strAccount[0] ) {
			if ( apmib_set(MIB_DDNS_ACCOUNT, (void *)strAccount) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup4))</script>"));
				goto setErr_tcpip;
			}
		}
		strPassword = websGetVar(wp, T("ddnsPass"), T(""));
		if ( strPassword[0] ) {
			if ( apmib_set(MIB_DDNS_PASS, (void *)strPassword) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup5))</script>"));
				goto setErr_tcpip;
			}
		}
    }
    else {
//--------------------------------------------------------------------------------------
		strHostID = websGetVar(wp, T("dhisHostID"), T(""));
		if (strHostID[0]) {
			longVal=strtoul(strHostID,NULL,0);
			if ( apmib_set(MIB_DHIS_HOSTID, (void *)&longVal) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup6))</script>"));
				goto setErr_tcpip;
			}
		}
		strAddress = websGetVar(wp, T("dhisISAddr"), T(""));
		if ( strAddress[0] ) {
// Lance 2003.11.06
//			if ( !inet_aton(strAddress, &inAddress) ) {
//				DEBUGP(tmpBuf, T("Invalid IP-address value!"));
//				goto setErr_tcpip;
//			}
//			if ( !apmib_set( MIB_DHIS_ISADDR, (void *)&inAddress)) {
			if ( !apmib_set( MIB_DHIS_ISADDR, (void *)strAddress)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup7))</script>"));
				goto setErr_tcpip;
			}
		}
		strdhisSelect = websGetVar(wp, T("dhisSelect"), T(""));
		if ( !gstrcmp(strdhisSelect, T("1")))
			val = 1;
		if ( !gstrcmp(strdhisSelect, T("0")))
			val = 0;
		if (strdhisSelect[0]) {
			if ( apmib_set( MIB_DHIS_SELECT, (void *)&val) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup8))</script>"));
				goto setErr_tcpip;
			}
		}


		if ( val == 0) {

 			strdhispass = websGetVar(wp, T("dhispass"), T(""));
			if ( strdhispass[0] ) {
				if ( apmib_set(MIB_DHIS_PASSWORD, (void *)strdhispass) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup9))</script>"));
					goto setErr_tcpip;
				}
			}
		}
		else {
 			strAuthP1 = websGetVar(wp, T("dhisAuthP1"), T(""));
			if ( apmib_set(MIB_DHIS_AUTH_P1, (void *)strAuthP1) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup10))</script>"));
				goto setErr_tcpip;
			}
 			strAuthP2 = websGetVar(wp, T("dhisAuthP2"), T(""));
			if ( apmib_set(MIB_DHIS_AUTH_P2, (void *)strAuthP2) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup11))</script>"));
				goto setErr_tcpip;
			}
 			strAuthQ1 = websGetVar(wp, T("dhisAuthQ1"), T(""));
			if ( apmib_set(MIB_DHIS_AUTH_Q1, (void *)strAuthQ1) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup12))</script>"));
				goto setErr_tcpip;
			}
 			strAuthQ2 = websGetVar(wp, T("dhisAuthQ2"), T(""));
			if ( apmib_set(MIB_DHIS_AUTH_Q2, (void *)strAuthQ2) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDDNSSetup13))</script>"));
				goto setErr_tcpip;
			}
		}
	}
//--------------------------------------------------------------------------------------
	apmib_update(CURRENT_SETTING);	// update to flash

	// run script
/*	if ( dns_changed )
		arg = "all";
	else
		arg = "wan";
*/
#ifndef NO_ACTION
/*        pid = fork();
        if (pid)
                waitpid(pid, NULL, 0);

        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG);
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", arg, NULL);
                exit(1);
        }*/
	// sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all"); // Tommy
	// system(tmpBuf);
#endif

#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

	OK_MSG(submitUrl);

	return;

setErr_tcpip:
	ERR_MSG(tmpBuf);

}

#if  defined(_ENSNMP_)
void formSNMPSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*submitUrl;
	char_t  *strName, *strEnable;

//	struct in_addr inAddress;
	char tmpBuf[128];
	int val;
	unsigned long longVal;
/*#ifndef NO_ACTION
	int pid;
#endif*/

/*	int dns_changed=0;
	char *arg;
*/
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	strEnable = websGetVar(wp, T("snmpEnable"), T(""));
	if (strEnable[0]) {
		if (!gstrcmp(strEnable, T("0")))
			val = 0;
		else if (!gstrcmp(strEnable, T("1")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspError))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_SNMP_ENABLE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormSNMPSetup1))</script>"));
			goto setErr_tcpip;
		}
	}
		strName = websGetVar(wp, T("snmpName"), T(""));
		if ( strName[0] ) {
			if ( apmib_set(MIB_SNMP_NAME, (void *)strName) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormSNMPSetup3))</script>"));
				goto setErr_tcpip;
			}
		}


//--------------------------------------------------------------------------------------
	apmib_update(CURRENT_SETTING);	// update to flash

	// run script
/*	if ( dns_changed )
		arg = "all";
	else
		arg = "wan";
*/
#ifndef NO_ACTION
/*        pid = fork();
        if (pid)
                waitpid(pid, NULL, 0);

        else if (pid == 0) {
		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG);
		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", arg, NULL);
                exit(1);
        }*/
	// sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all"); // Tommy
	// system(tmpBuf);
#endif
	OK_MSG(submitUrl);
	return;

setErr_tcpip:
	ERR_MSG(tmpBuf);

}
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////
void formDynIpSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strdynIPHostName, *strMac, *strMode, *submitUrl;
	int Mode;
	char tmpBuf[128];

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

	strMode = websGetVar(wp, T("wanMode"), T(""));
	if ( strMode[0] ) {
		if ( !gstrcmp(strMode, T("0")))
			Mode = 0;
		if ( apmib_set( MIB_WAN_MODE, (void *)&Mode) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup1))</script>"));
			goto setErr_dynip;
		}
	}
	strdynIPHostName = websGetVar(wp, T("dynIPHostName"), T(""));
	if ( apmib_set(MIB_DYNIP_HOSTNAME, (void *)strdynIPHostName) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup2))</script>"));
		goto setErr_dynip;
	}
	// Set clone MAC address
	strMac = websGetVar(wp, T("macAddr"), T(""));
	if (strMac[0]) {
		if (strlen(strMac)!=12 || !string_to_hex(strMac, tmpBuf, 12)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc2))</script>"));
			goto setErr_dynip;
		}
		if ( !apmib_set(MIB_WAN_MAC_ADDR, (void *)tmpBuf)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup3))</script>"));
			goto setErr_dynip;
		}
	}

	apmib_update(CURRENT_SETTING);	// update to flash

#ifndef NO_ACTION
	// sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH , _CONFIG_SCRIPT_PROG, "gw", "all"); // Tommy
	// system(tmpBuf);
#endif


	OK_MSG(submitUrl);
	return;
setErr_dynip:
	ERR_MSG(tmpBuf);
}
/////////////////////////////////////////////////////////////////////////////////////////////////
void formStcIpSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strIp, *strMask, *strGateway, *strDNS, *strMode, *submitUrl;
	struct in_addr inIp, inMask, inGateway, dns1;
	int Mode;
	char tmpBuf[128];

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	strMode = websGetVar(wp, T("wanMode"), T(""));
	if ( strMode[0] ) {
		if ( !gstrcmp(strMode, T("1")))
			Mode = 1;
		if ( apmib_set( MIB_WAN_MODE, (void *)&Mode) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup1))</script>"));
			goto setErr_stcip;
		}
	}
	strIp = websGetVar(wp, T("ip"), T(""));
	if ( strIp[0] ) {
		if ( !inet_aton(strIp, &inIp) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
			goto setErr_stcip;
		}
		if ( !apmib_set(MIB_WAN_IP_ADDR, (void *)&inIp)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
			goto setErr_stcip;
		}
	}
	strMask = websGetVar(wp, T("mask"), T(""));
	if ( strMask[0] ) {
		if ( !inet_aton(strMask, &inMask) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup26))</script>"));
			goto setErr_stcip;
		}
		if ( !apmib_set(MIB_WAN_SUBNET_MASK, (void *)&inMask)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup27))</script>"));
			goto setErr_stcip;
		}
	}
	strGateway = websGetVar(wp, T("gateway"), T(""));
	if ( strGateway[0] ) {
		if ( !inet_aton(strGateway, &inGateway) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup29))</script>"));
			goto setErr_stcip;
		}
		if ( !apmib_set(MIB_WAN_DEFAULT_GATEWAY, (void *)&inGateway)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup30))</script>"));
			goto setErr_stcip;
		}
	}
	strDNS = websGetVar(wp, T("dns1"), T(""));
	if ( strDNS[0] ) {
		if ( !inet_aton(strDNS, &dns1) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup1))</script>"));
			goto setErr_stcip;
		}
		if ( !apmib_set(MIB_WAN_DNS1, (void *)&dns1)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup2))</script>"));
			goto setErr_stcip;
		}
	}
	else {
		if ( !apmib_get(MIB_WAN_DNS1, (void *)&dns1) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup3))</script>"));
			goto setErr_stcip;
		}
	}

	apmib_update(CURRENT_SETTING);	// update to flash

#ifndef NO_ACTION
	// sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH , _CONFIG_SCRIPT_PROG, "gw", "all"); // Tommy
	// system(tmpBuf);
#endif
	OK_MSG(submitUrl);
	return;
setErr_stcip:
	ERR_MSG(tmpBuf);
}
//////////////////////////////////////////////////////////////////////////////////////////////
void formL2TPSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strIPAddr, *strIPMaskAddr, *strDfGateway, *strGateway, *strMac, *submitUrl, *strnextEnable;
	char_t  *strName, *strPassword, *strType, *strIpMode, *strConnect, *strwanMode, *strMTU, *strHostName;
	struct in_addr inIPAddr, inIPMaskAddr, inDfGateway;
	char tmpBuf[128];
	int val, Mode;
	int buttonState=0, flag=1;
	char *ptr;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	strConnect = websGetVar(wp, T("L2TPConnect"), T(""));
	if (strConnect[0])
		buttonState = 1;

        strConnect = websGetVar(wp, T("L2TPDisconnect"), T(""));
	if (strConnect[0])
		buttonState = 2;

	strIpMode = websGetVar(wp, T("L2TPIpMode"), T(""));
	if (strIpMode[0]) {
		if (!gstrcmp(strIpMode, T("0")))
			val = 0;
		else if (!gstrcmp(strIpMode, T("1")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspError))</script>"));
			goto setErr_l2tp;
		}
		if ( apmib_set(MIB_L2TP_IPMODE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup1))</script>"));
			goto setErr_l2tp;
		}
	}
	//Obtain an IP address automatically
	if (!gstrcmp(strIpMode, T("0"))) {
		strHostName = websGetVar(wp, T("HostName"), T(""));
		if ( apmib_set(MIB_DYNIP_HOSTNAME, (void *)strHostName) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup2))</script>"));
			goto setErr_l2tp;
		}
			strMac = websGetVar(wp, T("Mac"), T(""));

		if (strMac[0]) {
			if (strlen(strMac)!=12 || !string_to_hex(strMac, tmpBuf, 12)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup16))</script>"));
				goto setErr_l2tp;
			}
			if ( !apmib_set(MIB_WAN_MAC_ADDR, (void *)tmpBuf)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup3))</script>"));
				goto setErr_l2tp;
			}
		}
	}
#if defined (_EZVIEW_) || defined (_AUTO_DNS_)
	strIpMode = websGetVar(wp, T("DNSMode"), T(""));
	if (strIpMode[0])
	{
		if (!gstrcmp(strIpMode, T("0"))) val = 0;
		else val = 1;
		apmib_set(MIB_WAN_DNS_MODE, (void *)&val);
	}

	strcpy(tmpBuf,"0.0.0.0");

	if(val==0)
	{
		inet_aton(tmpBuf, &inIPAddr);
		apmib_set( MIB_WAN_DNS1, (void *)&inIPAddr);
		apmib_set( MIB_WAN_DNS2, (void *)&inIPAddr);
		apmib_set( MIB_WAN_DNS3, (void *)&inIPAddr);
	}
	else
	{
		strIPAddr = websGetVar(wp, T("dns1"), T(""));
		if(strIPAddr[0])
		{
			inet_aton(strIPAddr, &inIPAddr);
			apmib_set( MIB_WAN_DNS1, (void *)&inIPAddr);
		}
		strIPAddr = websGetVar(wp, T("dns2"), T(""));
		if(strIPAddr[0])
		{
			inet_aton(strIPAddr, &inIPAddr);
			apmib_set( MIB_WAN_DNS2, (void *)&inIPAddr);
		}
		strIPAddr = websGetVar(wp, T("dns3"), T(""));
		if(strIPAddr[0])
		{
			inet_aton(strIPAddr, &inIPAddr);
			apmib_set( MIB_WAN_DNS3, (void *)&inIPAddr);
		}
	}
#endif


	strIPAddr = websGetVar(wp, T("L2TPIPAddr"), T(""));
	if ( strIPAddr[0] ) {
		if ( !inet_aton(strIPAddr, &inIPAddr) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
			goto setErr_l2tp;
		}
		if ( !apmib_set( MIB_L2TP_IP_ADDR, (void *)&inIPAddr)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
			goto setErr_l2tp;
		}
	}
	strIPMaskAddr = websGetVar(wp, T("L2TPMaskAddr"), T(""));
	if ( strIPMaskAddr[0] ) {
		if ( !inet_aton(strIPMaskAddr, &inIPMaskAddr) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
			goto setErr_l2tp;
		}
		if ( !apmib_set( MIB_L2TP_MAKEADDR, (void *)&inIPMaskAddr)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
			goto setErr_l2tp;
		}
	}
	strDfGateway = websGetVar(wp, T("L2TPDefGateway"), T(""));
	if ( strDfGateway[0] ) {
		if ( !inet_aton(strDfGateway, &inDfGateway) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
			goto setErr_l2tp;
		}
		if ( !apmib_set( MIB_L2TP_DEFGATEWAY, (void *)&inDfGateway)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
			goto setErr_l2tp;
		}
	}
	strGateway = websGetVar(wp, T("L2TPGateway"), T(""));
	if ( strGateway[0] ) {
		if ( apmib_set( MIB_L2TP_GATEWAY, (void *)strGateway) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup3))</script>"));
			goto setErr_l2tp;
		}
	}

	strName = websGetVar(wp, T("L2TPUserName"), T(""));
	tmpBuf[0]='\0';
	flag = 1;
	while ( flag ) {
		if ((ptr = strchr(strName, '#')) != NULL) {
			*ptr ='\0';
			ptr++;
			strcat( tmpBuf, strName);
			strcat( tmpBuf, "\\#");
			strName = ptr;
		}
		else {
			strcat( tmpBuf, strName);
			flag = 0;
		}
	}
	if ( tmpBuf[0] ) {
		if ( apmib_set( MIB_L2TP_USER, (void *)tmpBuf) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup4))</script>"));
			goto setErr_l2tp;
		}
	}

	strPassword = websGetVar(wp, T("L2TPPassword"), T(""));
	if ( strPassword[0] ) {
		if ( apmib_set( MIB_L2TP_PASSWORD, (void *)strPassword) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup5))</script>"));
			goto setErr_l2tp;
		}
	}

	strMTU = websGetVar(wp, T("L2TPMTU"), T(""));
	if (strMTU[0]) {
		if ( !string_to_dec(strMTU, &val) || val< 512 || val >1492) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
			goto setErr_l2tp;
		}
		if ( apmib_set(MIB_L2TP_MTU, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup7))</script>"));
			goto setErr_l2tp;
		}
	}

	strType = websGetVar(wp, T("L2TPConnectType"), T(""));
	if ( strType[0] ) {
		PPP_CONNECT_TYPE_T type;
		if ( strType[0] == '0' )
			type = CONTINUOUS;
		else if ( strType[0] == '1' )
			type = CONNECT_ON_DEMAND;
		else if ( strType[0] == '2' )
			type = MANUAL;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup8))</script>"));
			goto setErr_l2tp;
		}
		if ( apmib_set( MIB_L2TP_CONNECT_TYPE, (void *)&type) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup9))</script>"));
			goto setErr_l2tp;
		}
		if (type != CONTINUOUS) {
			char_t *strTime;
			strTime = websGetVar(wp, T("L2TPIdleTime"), T(""));
			if ( strTime[0] ) {
				int time;
				time = strtol(strTime, (char**)NULL, 10) * 60;
				if ( apmib_set(MIB_L2TP_IDLE_TIME, (void *)&time) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup10))</script>"));
					goto setErr_l2tp;
				}
			}
		}
	}
	strwanMode = websGetVar(wp, T("wanMode"), T(""));
	if ( strwanMode[0] ) {
		if ( !gstrcmp(strwanMode, T("6")))
			Mode = 6;
		if ( apmib_set( MIB_WAN_MODE, (void *)&Mode) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup1))</script>"));
			goto setErr_l2tp;
		}
	}
//*******************************************************************************
	if ( buttonState == 1 ) { // connect button is pressed
		int wait_time=30;
		apmib_update(CURRENT_SETTING);	// update to flash
		#ifndef NO_ACTION
		#ifdef _L2TPD_
		system("/bin/l2tp_2.sh connect");
		#else
		system("/bin/l2tp.sh connect"); // Lance 2004.2.3
		#endif
		while (wait_time-- >0) {
			if (isConnectPPP())
				break;
			sleep(1);
		}
		if (isConnectPPP())
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup11))</script>\n"));
		else
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup12))</script>\n"));

		OK_MSG1(tmpBuf, submitUrl);
		#endif
		return;
	}

	if ( buttonState == 2 ) { // disconnect button is pressed

		apmib_update(CURRENT_SETTING);	// update to flash
	#ifndef NO_ACTION
//		sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all");
//		system(tmpBuf);
		system("/bin/disconnect.sh pppoe 0 all"); // Lance 2004.2.3
		strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup13))</script>\n"));

		OK_MSG1(tmpBuf, submitUrl);
	#endif
		return;
	}
	apmib_update(CURRENT_SETTING);	// update to flash
	// run script

#ifndef NO_ACTION
	// sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all"); // Tommy
	// system(tmpBuf);
#endif
//20060410 pippen
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

	strnextEnable = websGetVar(wp, T("redirect"), T(""));
	if (strnextEnable[0]){
		system("/bin/scriptlib_util.sh reloadFlash");
		REPLACE_MSG(submitUrl);
	}else{

		OK_MSG(submitUrl);

		//OK_MSG(submitUrl);
	}
	return;

setErr_l2tp:
	ERR_MSG(tmpBuf);

}

/////////////////////////////////////////////////////////////////////////////////////////////
//ADSL for 7264Wn add by  kyle @2007/05/18
#ifdef _7264Wn_

//ADSl console
void  formAdslConsole(webs_t wp, char_t *path, char_t *query){
	char_t *strCmd,*submitUrl;
	char_t runCmd[100];
	submitUrl = websGetVar(wp,T("submit-url"),T(""));
	strCmd = websGetVar(wp,T("command"),T(""));

	sprintf(runCmd,"sh /bin/adsl-command.sh 3 \"%s\"",strCmd);
	system(runCmd);
	websRedirect(wp,submitUrl);

}


int  setMIBFormWeb(char_t *varValue ,int mibID, int type){
	int val;
	char strbuf[100];
	if (varValue[0]) {
		if(type==0){//int type
			if ( !string_to_dec(varValue, &val)) {
				return 1;
			}
			if ( apmib_set(mibID, (void *)&val) == 0) {
				return 1;
			}
		}
		else{//string type
			if ( apmib_set(mibID, (void *)varValue) == 0) {
				return 1;
			}
		}
	}
	return 0;

}



void formWanAdslSetup(webs_t wp, char_t *path, char_t *query)
{
	//set adsl info
	char_t *strVpi, *strVci, *submitUrl, *strModulType, *strDslType, *strWan, *strEncaps;
	//set connetction
	char_t *strMtu, *strConnect, *strWanMode;
	//set function
	char_t *strNatEnable, *strdynIPHostName;
	//set pppoe/pppoa
	char_t *strUserName, *strPassword, *pppConType, *strTime;
	//set static ip
	char_t *strIp, *strMask, *strGateway;
	//set dynamic
	char_t *strMac;
	//set qos atm
	char_t *strQosType, *strQosPcr, *strQosScr, *strQosMbs;
	//set dns
	char_t *strDns1, *strDns2, *strDnsMode;
	DNS_TYPE_T dns;
	struct in_addr dns1, dns2, dns3;


	struct in_addr inIp, inMask, inGateway;
	char tmpBuf[100];
	int buttonState=0;
	int val;
////////////////////////add adsl info /////////////////////////////////////////////
	submitUrl = websGetVar(wp,T("submit-url"),T(""));
	strVpi = websGetVar(wp,T("Alwan_VPI"),T(""));
	if(setMIBFormWeb(strVpi,MIB_ADSL_VPI,0)){
		DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of VPI.\")</script>"));
		goto setErr_wan;
	}

	strVci = websGetVar(wp,T("Alwan_VCI"),T(""));
	if(setMIBFormWeb(strVci,MIB_ADSL_VCI,0)){
		DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of VCI.\")</script>"));
		goto setErr_wan;
	}

	strModulType = websGetVar(wp,T("ModulationType"),T(""));
	if(setMIBFormWeb(strModulType,MIB_ADSL_ADSLMode,0)){
		DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of ModulType.\")</script>"));
		goto setErr_wan;
	}

	strDslType = websGetVar(wp,T("AnnexType"),T(""));
	if(setMIBFormWeb(strDslType,MIB_ADSL_ADSLType,0)){
		DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of AnnexTypeB.\")</script>"));
		goto setErr_wan;
	}

	strWan = websGetVar(wp,T("wan_Connect_Type"),T(""));
	if(setMIBFormWeb(strWan,MIB_ADSL_WAN_TYPE,0)){
		DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of wan_Connect_Type.\")</script>"));
		goto setErr_wan;
	}
	//set ATM Qos
	strQosType = websGetVar(wp,T("Alwan_QoS"),T(""));
	if(setMIBFormWeb(strQosType,MIB_ADSL_ATM,0)){
		DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of wan_Connect_Type.\")</script>"));
		goto setErr_wan;
	}

	strQosPcr = websGetVar(wp,T("wan_PCR"),T(""));
	if(setMIBFormWeb(strQosPcr,MIB_ADSL_PCR,0)){
		DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of wan_Connect_Type.\")</script>"));
		goto setErr_wan;
	}

	strQosScr = websGetVar(wp,T("wan_SCR"),T(""));
	if(setMIBFormWeb(strQosScr,MIB_ADSL_SCR,0)){
		DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of wan_Connect_Type.\")</script>"));
		goto setErr_wan;
	}

	strQosMbs = websGetVar(wp,T("wan_MBS"),T(""));
	if(setMIBFormWeb(strQosMbs,MIB_ADSL_MBS,0)){
		DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of wan_Connect_Type.\")</script>"));
		goto setErr_wan;
	}
	//set encapsulation and wan mode.
	switch(strWan[0]){
		case '0'://pppoe/pppoa
			strWanMode=T("2");
			strEncaps = websGetVar(wp,T("wan_PPPEncap"),T(""));
			break;
		case '1'://bridge
			strWanMode=T("5");
			strEncaps = websGetVar(wp,T("wan_BridgeSelect"),T(""));
			break;
		case '2'://dynamic ip
			strWanMode=T("0");
			strEncaps = websGetVar(wp,T("wan_DynIPEncap"),T(""));
			break;
		case '3'://static ip
			strWanMode=T("1");
			strEncaps = websGetVar(wp,T("wan_StaticIPEncap"),T(""));
			break;
	}


	if(setMIBFormWeb(strEncaps,MIB_ADSL_ENCAP,0)){
		DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of ADSL_ENCAP.\")</script>"));
		goto setErr_wan;
	}

	if(setMIBFormWeb(strWanMode,MIB_WAN_MODE,0)){
				DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of WAN_MODE.\")</script>"));
				goto setErr_wan;
	}
	printf("DEBUG encapsulation=%s wanMode= %s\n",strEncaps,strWanMode);
	//apmib_update(CURRENT_SETTING);	// update to flash
	//system("sh /bin/adsl-command.sh 1");
	////////////////////////add adsl info /////////////////////////////////////////////
	////////////////////////set wan info /////////////////////////////////////////////
	switch(strWan[0]){
		case '0'://pppoe/pppoa
			printf("pppoemode\n");
			//set user name
			strUserName = websGetVar(wp,T("wan_PPPUsername"),T(""));
			if(setMIBFormWeb(strUserName,MIB_PPP_USER,1)){
				DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of PPP_USER.\")</script>"));
				goto setErr_wan;
			}
			//set passowrd
			strPassword = websGetVar(wp,T("wan_PPPPassword"),T(""));
			if(setMIBFormWeb(strPassword,MIB_PPP_PASSWORD,1)){
				DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of PPP_PASSWORD.\")</script>"));
				goto setErr_wan;
			}

			strMtu = websGetVar(wp,T("wan_TCPMTU0"),T(""));
			if(setMIBFormWeb(strMtu,MIB_PPP_MTU,0)){
				DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of PPP_MTU.\")</script>"));
				goto setErr_wan;
			}

			strNatEnable = websGetVar(wp,T("wan_NAT1"),T(""));
			if(setMIBFormWeb(strNatEnable,MIB_NAT_ENABLE,0)){
				DEBUGP(tmpBuf,T("<script>document.write(\"Error! set natEnable to mib table.\")</script>"));
				goto setErr_wan;
			}

    strConnect = websGetVar(wp, T("pppConnect"), T(""));
		 	if (strConnect[0]){

				buttonState = 1;
		 	}
    	strConnect = websGetVar(wp, T("pppDisconnect"), T(""));
	  	if (strConnect[0]){


				buttonState = 2;
	  	}

			//set pppoe connection type
			pppConType = websGetVar(wp, T("pppConnectType"), T(""));
			if ( pppConType[0] ) {
					PPP_CONNECT_TYPE_T type;
			if ( pppConType[0] == '0' )
				type = CONTINUOUS;
			else if ( pppConType[0] == '1' )
				type = CONNECT_ON_DEMAND;
			else if ( pppConType[0] == '2' )
				type = MANUAL;
			else {
				DEBUGP(tmpBuf, T("<script>document.write(\"Error! Invalid value of pppConnectType.\")</script>"));
				goto setErr_wan;
			}
			if ( apmib_set(MIB_PPP_CONNECT_TYPE, (void *)&type) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(\"Error! set  pppConnectType to mib table.\")</script>"));
				goto setErr_wan;
			}
			if (type != CONTINUOUS) {

				strTime = websGetVar(wp, T("pppIdleTime"), T(""));
				if ( strTime[0] ) {
					int time;
					time = strtol(strTime, (char**)NULL, 10) * 60;
					if ( apmib_set(MIB_PPP_IDLE_TIME, (void *)&time) == 0) {
						DEBUGP(tmpBuf, T("<script>document.write(\"Error! set  idleTime to mib table.\")</script>"));
						goto setErr_wan;
					}
				}
			}
		}



		if ( buttonState == 1 ) { // connect button is pressed

			int wait_time=30;
//---------------------------------------------------------------------------------
			apmib_update(CURRENT_SETTING);	// update to flash
		#ifndef NO_ACTION
//			pid = fork();
  //      		if (pid)
//	        		waitpid(pid, NULL, 0);
//			else if (pid == 0) {
//				snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _PPPOE_SCRIPT_PROG);
//				execl( tmpBuf, _PPPOE_SCRIPT_PROG, "connect", NULL);
  //     				exit(1);
//			}
		system("/bin/pppoe.sh connect");
		while (wait_time-- >0) {
			if (isConnectPPP())
				break;
			sleep(1);
		}
		if (isConnectPPP())
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup11))</script>\n"));
		else
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup12))</script>\n"));

	OK_MSG1(tmpBuf, submitUrl);
		#endif
			return;
		}

		if ( buttonState == 2 ) { // disconnect button is pressed

			apmib_update(CURRENT_SETTING);	// update to flash
#ifndef NO_ACTION
//			pid = fork();
//        		if (pid)
//	             		waitpid(pid, NULL, 0);
//        		else if (pid == 0) {
//				snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _PPPOE_DC_SCRIPT_PROG);
//				execl( tmpBuf, _PPPOE_DC_SCRIPT_PROG, "all", NULL);
//                		exit(1);
//        		}
//	sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all");
//	system(tmpBuf);
			system("/bin/disconnect.sh pppoe 0 all"); // Lance 2004.2.3
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup19))</script>\n"));
			OK_MSG1(tmpBuf, submitUrl);
#endif
			return;
		}

			break;
		case '1'://bridge
			strNatEnable = "0";//disable
			if(setMIBFormWeb(strNatEnable,MIB_NAT_ENABLE,0)){
				DEBUGP(tmpBuf,T("<script>document.write(\"Error! set natEnable to mib table.\")</script>"));
				goto setErr_wan;
			}
			printf("bridge mode\n");


			break;
		case '2'://dynamic ip
			strdynIPHostName = websGetVar(wp, T("dynIPHostName"), T(""));
			if ( apmib_set(MIB_DYNIP_HOSTNAME, (void *)strdynIPHostName) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup2))</script>"));
				goto setErr_wan;
			}

			strNatEnable = websGetVar(wp,T("wan_NAT2"),T(""));
			if(setMIBFormWeb(strNatEnable,MIB_NAT_ENABLE,0)){
				DEBUGP(tmpBuf,T("<script>document.write(\"Error! set natEnable to mib table.\")</script>"));
				goto setErr_wan;
			}
			// Set clone MAC address
			strMac = websGetVar(wp, T("macAddr"), T(""));
			if (strMac[0]) {
				if (strlen(strMac)!=12 || !string_to_hex(strMac, tmpBuf, 12)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup16))</script>"));
					goto setErr_wan;
				}
				if ( !apmib_set(MIB_WAN_MAC_ADDR, (void *)tmpBuf)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup3))</script>"));
					goto setErr_wan;
				}
			}
			printf("dynamic mode\n");
			break;
		case '3'://static ip

			//Set DNS
			strDns1 = websGetVar(wp,T("wan_StaticIpDNS0"),T(""));
			strDns2 = websGetVar(wp,T("wan_StaticIpDNS1"),T(""));
			strDnsMode=websGetVar(wp,T("dnsMode"),T(""));
//**************************************** DNS Setting ****************************************
	if ( strDnsMode[0] ) {

		if (!strcmp(strDnsMode, T("dnsAuto")))
			dns = DNS_AUTO;
		else if (!strcmp(strDnsMode, T("dnsManual")))
			dns = DNS_MANUAL;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWanTcpipSetup3))</script>"));
			goto setErr_wan;
		}
		// Set DNS to MIB
		if ( !apmib_set(MIB_WAN_DNS_MODE, (void *)&dns)) {
	  		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup2))</script>"));
			goto setErr_wan;
		}

		if ( strDns1[0] ) {
			if ( !inet_aton(strDns1, &dns1) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup1))</script>"));
				goto setErr_wan;
			}
			if ( !apmib_set(MIB_WAN_DNS1, (void *)&dns1)) {
	  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup2))</script>"));
				goto setErr_wan;
			}
		}

		if ( strDns2[0] ) {
			if ( !inet_aton(strDns2, &dns2) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup1))</script>"));
				goto setErr_wan;
			}
			if ( !apmib_set(MIB_WAN_DNS2, (void *)&dns2)) {
	  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup2))</script>"));
				goto setErr_wan;
			}
		}
	}
			//end set dns


			strIp = websGetVar(wp, T("wan_StaticIPaddr0"), T(""));
			if ( strIp[0] ) {
				if ( !inet_aton(strIp, &inIp) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
					goto setErr_wan;
				}
				if ( !apmib_set(MIB_WAN_IP_ADDR, (void *)&inIp)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
					goto setErr_wan;
				}
			}

			strMask = websGetVar(wp, T("wan_StaticIPSubMask0"), T(""));
			if ( strMask[0] ) {
				if ( !inet_aton(strMask, &inMask) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup26))</script>"));
					goto setErr_wan;
				}
				if ( !apmib_set(MIB_WAN_SUBNET_MASK, (void *)&inMask)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup27))</script>"));
					goto setErr_wan;
				}
			}
			strGateway = websGetVar(wp, T("wan_StaticIpGateway0"), T(""));
			if ( strGateway[0] ) {
				if ( !inet_aton(strGateway, &inGateway) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup29))</script>"));
					goto setErr_wan;
				}
				if ( !apmib_set(MIB_WAN_DEFAULT_GATEWAY, (void *)&inGateway)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup30))</script>"));
					goto setErr_wan;
				}
		}

			//set nat enabled or disabled
			strNatEnable = websGetVar(wp,T("wan_NAT4"),T(""));
			if(setMIBFormWeb(strNatEnable,MIB_NAT_ENABLE,0)){
				DEBUGP(tmpBuf,T("<script>document.write(\"Error! set natEnable to mib table.\")</script>"));
				goto setErr_wan;
			}


			printf("static mode\n");
			break;
	}


	apmib_update(CURRENT_SETTING);	// update to flash


	OK_MSG(submitUrl);
	//websRedirect(wp,submitUrl);
		return;
setErr_wan:
	ERR_MSG(tmpBuf);
}


void formWizard(webs_t wp, char_t *path, char_t *query)
{
	char_t *strIsmanual, *strVpi, *strVci, *strWan, *strEnc, *strDns1, *strDns2, *strAdslmode, *strMTU;
	char_t *submitUrl, *strUserName, *strPassword;
	struct in_addr dnsaddr1, dnsaddr2;
	char_t *strWanMode, *strNatEnable;
	char tmpBuf[100];
	int val;

	submitUrl = websGetVar(wp,T("wlanurl"),T(""));
	strIsmanual = websGetVar(wp,T("isManual"),T(""));
	if ( !string_to_dec(strIsmanual, &val)  ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWizardInvalid))</script>"));
			goto setErr_wizard;
	}
	if(val==1){
		websRedirect(wp,submitUrl);
		return;
	}
	strVpi = websGetVar(wp,T("Alwan_VPI"),T(""));
	if (strVpi[0]) {
		if ( !string_to_dec(strVpi, &val) || val< 0 ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWizardInvalid))</script>"));
			goto setErr_wizard;
		}
		if ( apmib_set(MIB_ADSL_VPI, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWizardInvalid))</script>"));
			goto setErr_wizard;
		}
	}


	strDns1 = websGetVar(wp,T("DNS1"),T(""));
	if (strDns1[0]) {
		inet_aton(strDns1, &dnsaddr1);
		apmib_set(MIB_WAN_DNS1, (void *)&dnsaddr1);
	}
	strDns2 = websGetVar(wp,T("DNS2"),T(""));
	if (strDns2[0]) {
		inet_aton(strDns2, &dnsaddr2);
		apmib_set(MIB_WAN_DNS2, (void *)&dnsaddr2);

	}

	strUserName = websGetVar(wp,T("UserName"),T(""));
	setMIBFormWeb(strUserName,MIB_PPP_USER,1);

	strPassword = websGetVar(wp,T("Psssword"),T(""));
	setMIBFormWeb(strPassword,MIB_PPP_PASSWORD,1);

	strMTU = websGetVar(wp,T("MTU"),T(""));
	setMIBFormWeb(strMTU,MIB_PPP_MTU,0);


	strVci = websGetVar(wp,T("Alwan_VCI"),T(""));
	if(strVci[0]){
		if(!string_to_dec(strVci, &val) || val<0){
			DEBUGP(tmpBuf	,T("<script>document.write(showText(aspFormWizardInvalid))</script>"));
			goto setErr_wizard;
		}
		if(apmib_set(MIB_ADSL_VCI,(void*)&val) == 0){
			DEBUGP(tmpBuf,T("<script>document.write(showText(aspFormWizardInvalid))</script>"));
			goto setErr_wizard;
		}
	}
	strWan = websGetVar(wp,T("wan_Connect_Type"),T(""));
	if(strWan[0]){
		if(!string_to_dec(strWan, &val) || val<0){
			DEBUGP(tmpBuf	,T("<script>document.write(showText(aspFormWizardInvalid))</script>"));
			goto setErr_wizard;
		}
		val=val-1;
		if(apmib_set(MIB_ADSL_WAN_TYPE,(void*)&val) == 0){
			DEBUGP(tmpBuf,T("<script>document.write(showText(aspFormWizardInvalid))</script>"));
			goto setErr_wizard;
		}
	}

	//set encapsulation and wan mode.
	switch(strWan[0]){
		case '1'://pppoe/pppoa
			strWanMode=T("2");
			strNatEnable = "1";//enable
			break;
		case '2'://bridge
			strWanMode=T("5");
			strNatEnable = "0";//disable
			break;
		case '3'://dynamic ip
			strWanMode=T("0");
			strNatEnable = "1";//enable
			break;
		case '4'://static ip
			strWanMode=T("1");
			strNatEnable = "1";//enable
			break;
	}
			if(setMIBFormWeb(strNatEnable,MIB_NAT_ENABLE,0)){
				DEBUGP(tmpBuf,T("<script>document.write(\"Error! set natEnable to mib table.\")</script>"));
				goto setErr_wizard;
			}
	if(setMIBFormWeb(strWanMode,MIB_WAN_MODE,0)){
				DEBUGP(tmpBuf,T("<script>document.write(\"Error! Invalid value of WAN_MODE.\")</script>"));
				goto setErr_wizard;
	}

	strEnc = websGetVar(wp,T("Encapsulation"),T(""));
	if(strEnc[0]){
		if(!string_to_dec(strEnc, &val) || val<0){
			DEBUGP(tmpBuf	,T("<script>document.write(showText(aspFormWizardInvalid))</script>"));
			goto setErr_wizard;
		}
		val=val-1;
		if(apmib_set(MIB_ADSL_ENCAP,(void*)&val) == 0){
			DEBUGP(tmpBuf,T("<script>document.write(showText(aspFormWizardInvalid))</script>"));
			goto setErr_wizard;
		}
	}
	strAdslmode = websGetVar(wp,T("ModulationType"),T(""));
	if(strAdslmode[0]){
		if(!string_to_dec(strAdslmode, &val) || val<0){
			DEBUGP(tmpBuf	,T("<script>document.write(showText(aspFormWizardInvalid))</script>"));
			goto setErr_wizard;
		}
	}else{
		val=0;
	}
		if(apmib_set(MIB_ADSL_ADSLMode,(void*)&val) == 0){
			DEBUGP(tmpBuf,T("<script>document.write(showText(aspFormWizardInvalid))</script>"));
			goto setErr_wizard;
		}
	val=0;
	if(apmib_set(MIB_ADSL_ADSLType,(void*)&val) == 0){
			DEBUGP(tmpBuf,T("<script>document.write(showText(aspFormWizardInvalid))</script>"));
			goto setErr_wizard;
	}
	apmib_update(CURRENT_SETTING);	// update to flash


	if(!submitUrl[0]){
system("sh /bin/adsl-command.sh 1");
		OK_MSG("/wanmain.asp");

	}
	else{
		websRedirect(wp,submitUrl);
	}

	return;
setErr_wizard:
	ERR_MSG(tmpBuf);
}


#endif
/////////////////////////////////////////////////////////////////////////////////////////////
//modify by alex @ 2007/01/31
void formPPPoESetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strName, *strPassword, *strpppServName, *strpppMTU, *submitUrl;
	char_t  *strType, *strConnect, *strwanMode;
	char tmpBuf[100];
	int val, Mode, flag=1;
	int buttonState=0;
	int buttonState1=0;
	char *ptr;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
    strConnect = websGetVar(wp, T("pppConnect"), T(""));
	if (strConnect[0])
		buttonState = 1;

	//alex 2007/02/01
    strConnect = websGetVar(wp, T("pppConnect1"), T(""));
	if (strConnect[0])
		buttonState1 = 1;

    strConnect = websGetVar(wp, T("pppDisconnect"), T(""));
	if (strConnect[0])
		buttonState = 2;

	//alex 2007/02/01
    strConnect = websGetVar(wp, T("pppDisconnect1"), T(""));
	if (strConnect[0])
		buttonState1 = 2;

	strwanMode = websGetVar(wp, T("wanMode"), T(""));
	if ( strwanMode[0] ) {
		if ( !gstrcmp(strwanMode, T("2")))
			Mode = 2;
		if ( apmib_set( MIB_WAN_MODE, (void *)&Mode) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup1))</script>"));
			goto setErr_ppp;
		}
	}
	strpppServName = websGetVar(wp, T("pppServName"), T(""));
	if (Mode == 2) {
		if ( apmib_set(MIB_PPP_SERVNAME, (void *)strpppServName) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup14))</script>"));
			goto setErr_ppp;
		}
	}

	strpppMTU = websGetVar(wp, T("pppMTU"), T(""));
	if (strpppMTU[0]) {
		if ( !string_to_dec(strpppMTU, &val) || val< 512 || val >1492) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
			goto setErr_ppp;
		}
		if ( apmib_set(MIB_PPP_MTU, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup7))</script>"));
			goto setErr_ppp;
		}
	}

	strName = websGetVar(wp, T("pppUserName"), T(""));
	tmpBuf[0]='\0';
	flag = 1;
	while ( flag ) {
		if ((ptr = strchr(strName, '#')) != NULL) {
			*ptr ='\0';
			ptr++;
			strcat( tmpBuf, strName);
			strcat( tmpBuf, "\\#");
			strName = ptr;
		}
		else {
			strcat( tmpBuf, strName);
			flag = 0;
		}
	}
	if ( tmpBuf[0] ) {
		if ( apmib_set(MIB_PPP_USER, (void *)tmpBuf) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup14))</script>"));
			goto setErr_ppp;
		}
	}

	strPassword = websGetVar(wp, T("pppPassword"), T(""));
	if ( strPassword[0] ) {
		if ( apmib_set(MIB_PPP_PASSWORD, (void *)strPassword) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup15))</script>"));
			goto setErr_ppp;
		}
	}

	strType = websGetVar(wp, T("pppConnectType"), T(""));
	if ( strType[0] ) {
		PPP_CONNECT_TYPE_T type;
		if ( strType[0] == '0' )
			type = CONTINUOUS;
		else if ( strType[0] == '1' )
			type = CONNECT_ON_DEMAND;
		else if ( strType[0] == '2' )
			type = MANUAL;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup16))</script>"));
			goto setErr_ppp;
		}
		if ( apmib_set(MIB_PPP_CONNECT_TYPE, (void *)&type) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup17))</script>"));
			goto setErr_ppp;
		}
		if (type != CONTINUOUS) {
			char_t *strTime;
			strTime = websGetVar(wp, T("pppIdleTime"), T(""));
			if ( strTime[0] ) {
				int time;
				time = strtol(strTime, (char**)NULL, 10) * 60;
				if ( apmib_set(MIB_PPP_IDLE_TIME, (void *)&time) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup18))</script>"));
					goto setErr_ppp;
				}
			}
		}
	}

#if defined(_Customer_) | defined(_MPPPOE_)
	//alex 2007/01/31
	strpppServName = websGetVar(wp, T("pppServName1"), T(""));
	if (Mode == 2) {
		if ( apmib_set(MIB_PPP_SERVNAME1, (void *)strpppServName) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup14))</script>"));
			goto setErr_ppp;
		}
	}

	//alex 2007/01/31
	strpppMTU = websGetVar(wp, T("pppMTU1"), T(""));
	if (strpppMTU[0]) {
		if ( !string_to_dec(strpppMTU, &val) || val< 512 || val >1492) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
			goto setErr_ppp;
		}
		if ( apmib_set(MIB_PPP_MTU1, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup7))</script>"));
			goto setErr_ppp;
		}
	}

	//alex 2007/01/31
	strpppMTU = websGetVar(wp, T("PPPoEMode"), T(""));
	if (strpppMTU[0]) {
		if ( !string_to_dec(strpppMTU, &val) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
			goto setErr_ppp;
		}
		if ( apmib_set(MIB_PPPoE_MODE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup7))</script>"));
			goto setErr_ppp;
		}
	}

	//alex 2007/01/31
	strName = websGetVar(wp, T("pppUserName1"), T(""));
	tmpBuf[0]='\0';
	flag = 1;
	while ( flag ) {
		if ((ptr = strchr(strName, '#')) != NULL) {
			*ptr ='\0';
			ptr++;
			strcat( tmpBuf, strName);
			strcat( tmpBuf, "\\#");
			strName = ptr;
		}
		else {
			strcat( tmpBuf, strName);
			flag = 0;
		}
	}
	if ( tmpBuf[0] ) {
		if ( apmib_set(MIB_PPP_USER1, (void *)tmpBuf) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup14))</script>"));
			goto setErr_ppp;
		}
	}

	//alex 2007/01/31
	strPassword = websGetVar(wp, T("pppPassword1"), T(""));
	if ( strPassword[0] ) {
		if ( apmib_set(MIB_PPP_PASSWORD1, (void *)strPassword) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup15))</script>"));
			goto setErr_ppp;
		}
	}

	//alex 2007/01/31
	strType = websGetVar(wp, T("pppConnectType1"), T(""));
	if ( strType[0] ) {
		PPP_CONNECT_TYPE_T type;
		if ( strType[0] == '0' )
			type = CONTINUOUS;
		else if ( strType[0] == '1' )
			type = CONNECT_ON_DEMAND;
		else if ( strType[0] == '2' )
			type = MANUAL;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup16))</script>"));
			goto setErr_ppp;
		}
		if ( apmib_set(MIB_PPP_CONNECT_TYPE1, (void *)&type) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup17))</script>"));
			goto setErr_ppp;
		}
		if (type != CONTINUOUS) {
			char_t *strTime;
			strTime = websGetVar(wp, T("pppIdleTime1"), T(""));
			if ( strTime[0] ) {
				int time;
				time = strtol(strTime, (char**)NULL, 10) * 60;
				if ( apmib_set(MIB_PPP_IDLE_TIME1, (void *)&time) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup18))</script>"));
					goto setErr_ppp;
				}
			}
		}
	}
#endif

//**************************************************************************************
	if ( buttonState == 1 ) { // connect button is pressed
		int wait_time=30;

		apmib_update(CURRENT_SETTING);	// update to flash
	#ifndef NO_ACTION
		sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH , _CONFIG_SCRIPT_PROG, "gw", "all");
		system(tmpBuf);
		while (wait_time-- >0) {
			if (isConnectPPP())
				break;
			sleep(1);
		}
		if (isConnectPPP())
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup11))</script>\n"));
		else
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup12))</script>\n"));

		OK_MSG1(tmpBuf, submitUrl);
	#endif
		return;
	}

	if ( buttonState == 2 ) { // disconnect button is pressed

		apmib_update(CURRENT_SETTING);	// update to flash
	#ifndef NO_ACTION
		sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH , _CONFIG_SCRIPT_PROG, "gw", "all");
		system(tmpBuf);
		strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup19))</script>\n"));
		OK_MSG1(tmpBuf, submitUrl);
	#endif
		return;
	}

#if defined(_Customer_) | defined(_MPPPOE_)
	//alex 2007/02/01
	if ( buttonState1 == 1 ) { // connect button is pressed
		int wait_time=30;

		apmib_update(CURRENT_SETTING);	// update to flash
	#ifndef NO_ACTION
		sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH , _CONFIG_SCRIPT_PROG, "gw", "all");
		system(tmpBuf);
		while (wait_time-- >0) {
			if (isConnectPPP1())
				break;
			sleep(1);
		}
		if (isConnectPPP1())
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup11))</script>\n"));
		else
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup12))</script>\n"));

		OK_MSG1(tmpBuf, submitUrl);
	#endif
		return;
	}

	if ( buttonState1 == 2 ) { // disconnect button is pressed

		apmib_update(CURRENT_SETTING);	// update to flash
	#ifndef NO_ACTION
		sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH , _CONFIG_SCRIPT_PROG, "gw", "all");
		system(tmpBuf);
		strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup19))</script>\n"));
		OK_MSG1(tmpBuf, submitUrl);
	#endif
		return;
	}
#endif
	apmib_update(CURRENT_SETTING);	// update to flash

#ifndef NO_ACTION
	// sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH , _CONFIG_SCRIPT_PROG, "gw", "all"); // Tommy
	// system(tmpBuf);
#endif
	OK_MSG(submitUrl);
	return;

setErr_ppp:
	ERR_MSG(tmpBuf);

}
////////////////////////////////////////////////////////////////////////////////
void formPPTPSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t	*strpptpIPAddr, *strpptpIPMaskAddr, *strpptpDfGateway, *strpptpGateway, *submitUrl, *strnextEnable;
	char_t  *strName, *strPassword, *strType, *strIpMode, *strConnect;
	char_t  *strConntID, *strBEZEQEnable, *strwanMode, *strMTU;
	char_t  *strHostName, *strMac;
	struct in_addr inpptpIPAddr, inpptpIPMaskAddr, inpptpDfGateway, inpptpGateway;
	char tmpBuf[128];
	int val, Mode, flag=1;
	int buttonState=0;
	char *ptr;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
        strConnect = websGetVar(wp, T("pptpConnect"), T(""));

	if (strConnect[0])
		buttonState = 1;

        strConnect = websGetVar(wp, T("pptpDisconnect"), T(""));
	if (strConnect[0])
		buttonState = 2;

	strIpMode = websGetVar(wp, T("pptpIpMode"), T(""));
	if (strIpMode[0]) {
		if (!gstrcmp(strIpMode, T("0")))
			val = 0;
		else if (!gstrcmp(strIpMode, T("1")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspError))</script>"));
			goto setErr_pptp;
		}
		if ( apmib_set(MIB_PPTP_IPMODE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup1))</script>"));
			goto setErr_pptp;
		}
	}
	//Obtain an IP address automatically
	if (!gstrcmp(strIpMode, T("0"))) {
		strHostName = websGetVar(wp, T("HostName"), T(""));
		if ( apmib_set(MIB_DYNIP_HOSTNAME, (void *)strHostName) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup2))</script>"));
			goto setErr_pptp;
		}

			strMac = websGetVar(wp, T("Mac"), T(""));

		if (strMac[0]) {
			if (strlen(strMac)!=12 || !string_to_hex(strMac, tmpBuf, 12)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup16))</script>"));
				goto setErr_pptp;
			}
			if ( !apmib_set(MIB_WAN_MAC_ADDR, (void *)tmpBuf)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup3))</script>"));
				goto setErr_pptp;
			}
		}
	}
	else
	{
		
		strpptpIPAddr = websGetVar(wp, T("pptpIPAddr"), T(""));
		if ( strpptpIPAddr[0] ) {
			if ( !inet_aton(strpptpIPAddr, &inpptpIPAddr) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
				goto setErr_pptp;
			}
			if ( !apmib_set( MIB_PPTPIP_ADDR, (void *)&inpptpIPAddr)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
				goto setErr_pptp;
			}
		}
		strpptpIPMaskAddr = websGetVar(wp, T("pptpIPMaskAddr"), T(""));
		if ( strpptpIPMaskAddr[0] ) {
			if ( !inet_aton(strpptpIPMaskAddr, &inpptpIPMaskAddr) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
				goto setErr_pptp;
			}
			if ( !apmib_set( MIB_PPTPIPMAKE_ADDR, (void *)&inpptpIPMaskAddr)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
				goto setErr_pptp;
			}
		}
		strpptpDfGateway = websGetVar(wp, T("pptpDfGateway"), T(""));
		if ( strpptpDfGateway[0] ) {
			if ( !inet_aton(strpptpDfGateway, &inpptpDfGateway) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
				goto setErr_pptp;
			}
			if ( !apmib_set( MIB_PPTPDFGATEWAY, (void *)&inpptpDfGateway)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
				goto setErr_pptp;
			}
		}
	}

#ifdef _PPTP_FQDN_
	strpptpGateway = websGetVar(wp, T("pptpGateway"), T(""));
	if ( strpptpGateway[0] ) {
		if ( apmib_set( MIB_PPTPGATEWAY, (void *)strpptpGateway) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
			goto setErr_pptp;
		}
	}
#else
	strpptpGateway = websGetVar(wp, T("pptpGateway"), T(""));
	if ( strpptpGateway[0] ) {
		if ( !inet_aton(strpptpGateway, &inpptpGateway) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
			goto setErr_pptp;
		}
		if ( !apmib_set( MIB_PPTPGATEWAY, (void *)&inpptpGateway)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
			goto setErr_pptp;
		}
	}
#endif


#if defined (_EZVIEW_) || defined (_AUTO_DNS_) 
	strIpMode = websGetVar(wp, T("DNSMode"), T(""));
	if (strIpMode[0])
	{
		if (!gstrcmp(strIpMode, T("0"))) val = 0;
		else val = 1;
		apmib_set(MIB_WAN_DNS_MODE, (void *)&val);
	}

	strcpy(tmpBuf,"0.0.0.0");

	if(val==0)
	{
		inet_aton(tmpBuf, &inpptpIPAddr);
		apmib_set( MIB_WAN_DNS1, (void *)&inpptpIPAddr);
		apmib_set( MIB_WAN_DNS2, (void *)&inpptpIPAddr);
		apmib_set( MIB_WAN_DNS3, (void *)&inpptpIPAddr);
	}
	else
	{
		strpptpIPAddr = websGetVar(wp, T("dns1"), T(""));
		if(strpptpIPAddr[0])
		{
			inet_aton(strpptpIPAddr, &inpptpIPAddr);
			apmib_set( MIB_WAN_DNS1, (void *)&inpptpIPAddr);
		}
		strpptpIPAddr = websGetVar(wp, T("dns2"), T(""));
		if(strpptpIPAddr[0])
		{
			inet_aton(strpptpIPAddr, &inpptpIPAddr);
			apmib_set( MIB_WAN_DNS2, (void *)&inpptpIPAddr);
		}
		strpptpIPAddr = websGetVar(wp, T("dns3"), T(""));
		if(strpptpIPAddr[0])
		{
			inet_aton(strpptpIPAddr, &inpptpIPAddr);
			apmib_set( MIB_WAN_DNS3, (void *)&inpptpIPAddr);
		}
	}
#endif



	strName = websGetVar(wp, T("pptpUserName"), T(""));
	tmpBuf[0]='\0';
	flag = 1;
	while ( flag ) {
		if ((ptr = strchr(strName, '#')) != NULL) {
			*ptr ='\0';
			ptr++;
			strcat( tmpBuf, strName);
			strcat( tmpBuf, "\\#");
			strName = ptr;
		}
		else {
			strcat( tmpBuf, strName);
			flag = 0;
		}
	}
	if ( tmpBuf[0] ) {
		if ( apmib_set(MIB_PPTP_USER, (void *)tmpBuf) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPPTPSetup1))</script>"));
			goto setErr_pptp;
		}
	}

	strPassword = websGetVar(wp, T("pptpPassword"), T(""));
	if ( strPassword[0] ) {
		if ( apmib_set(MIB_PPTP_PASSWORD, (void *)strPassword) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPPTPSetup2))</script>"));
			goto setErr_pptp;
		}
	}

	strMTU = websGetVar(wp, T("pptpMTU"), T(""));
	if (strMTU[0]) {
		if ( !string_to_dec(strMTU, &val) || val< 512 || val >1492) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
			goto setErr_pptp;
		}
		if ( apmib_set(MIB_PPTP_MTU, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup7))</script>"));
			goto setErr_pptp;
		}
	}
//-------------------------------------------------------------------------------------
	strType = websGetVar(wp, T("pptpConnectType"), T(""));
	if ( strType[0] ) {
		PPP_CONNECT_TYPE_T type;
		if ( strType[0] == '0' )
			type = CONTINUOUS;
		else if ( strType[0] == '1' )
			type = CONNECT_ON_DEMAND;
		else if ( strType[0] == '2' )
			type = MANUAL;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPPTPSetup3))</script>"));
			goto setErr_pptp;
		}
		if ( apmib_set(MIB_PPTP_CONNECT_TYPE, (void *)&type) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPPTPSetup4))</script>"));
			goto setErr_pptp;
		}
		if (type != CONTINUOUS) {
			char_t *strTime;
			strTime = websGetVar(wp, T("pptpIdleTime"), T(""));
			if ( strTime[0] ) {
				int time;
				time = strtol(strTime, (char**)NULL, 10) * 60;
				if ( apmib_set(MIB_PPTP_IDLE_TIME, (void *)&time) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPPTPSetup5))</script>"));
					goto setErr_pptp;
				}
			}
		}
	}
	strConntID = websGetVar(wp, T("pptpConntID"), T(""));
	if ( apmib_set(MIB_PPTP_CONNT_ID, (void *)strConntID) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPPTPSetup6))</script>"));
		goto setErr_pptp;
	}
	strBEZEQEnable = websGetVar(wp, T("pptpBEZEQEnable"), T(""));
	if ( !gstrcmp(strBEZEQEnable, T("ON")))
		val = 1;
	else
		val = 0;
	if ( apmib_set( MIB_PPTP_BEZEQ_ENABLE, (void *)&val) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormPreventionSetup1))</script>"));
		goto setErr_pptp;
	}
	strwanMode = websGetVar(wp, T("wanMode"), T(""));
	if ( strwanMode[0] ) {
		if ( !gstrcmp(strwanMode, T("3")))
			Mode = 3;
		if ( apmib_set( MIB_WAN_MODE, (void *)&Mode) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup1))</script>"));
			goto setErr_pptp;
		}
	}
//--------------------------------------------------------------------------------
	if ( buttonState == 1 ) { // connect button is pressed
		int wait_time=30;

		apmib_update(CURRENT_SETTING);	// update to flash
	#ifndef NO_ACTION
//		sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all");
//		system(tmpBuf);
		system("/bin/pptp.sh connect"); // Lance 2004.2.3
		while (wait_time-- >0) {
		if (isConnectPPP())
			break;
			sleep(1);
		}
		if (isConnectPPP())
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup11))</script>\n"));
		else
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup12))</script>\n"));
		OK_MSG1(tmpBuf, submitUrl);
	#endif
		return;
	}

	if ( buttonState == 2 ) { // disconnect button is pressed

		apmib_update(CURRENT_SETTING);	// update to flash
	#ifndef NO_ACTION
//		sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all");
//		system(tmpBuf);
		system("/bin/disconnect.sh pppoe 0 all"); // Lance 2004.2.3
		strcpy(tmpBuf, T("<script>document.write(showText(aspFormPPTPSetup7))</script>\n"));
		OK_MSG1(tmpBuf, submitUrl);
	#endif
		return;
	}
	apmib_update(CURRENT_SETTING);	// update to flash
	// run script
#ifndef NO_ACTION
	// sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all"); // Tommy
	// system(tmpBuf);
#endif
//20060410 pippen
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

	strnextEnable = websGetVar(wp, T("redirect"), T(""));
	if (strnextEnable[0]){
		system("/bin/scriptlib_util.sh reloadFlash");
		REPLACE_MSG(submitUrl);
	}else{

		OK_MSG(submitUrl);

		//OK_MSG(submitUrl);
	}
	return;


setErr_pptp:
	ERR_MSG(tmpBuf);

}

////////////////////////////////////////////////////////////////////////////////

void formWanTcpipSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t *strIp, *strMask, *strGateway, *strDNS, *strMode, *submitUrl, *strConnect, *strMac, *strnextEnable, *strApply;
	char_t *strdynIPHostName, *strpppServName, *strpppMTU, *strEnTtl;
	int val;
	struct in_addr inIp, inMask,dns1, dns2, dns3, inGateway;
	DHCP_T dhcp, curDhcp;
	DNS_TYPE_T dns, dns_old;
	char tmpBuf[128];
	char_t *strwanMode;
	int Mode;
	int dns_changed=0, flag=1;
	char *arg;
	int buttonState=0;
	int buttonState1=0;
	int buttonState2=0;
	char *ptr;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	strwanMode = websGetVar(wp, T("wanMode"), T(""));
/**
 for WANTTL function.
 */

#ifdef _WANTTL_
	char_t *strTTLValue, *strTTLType;
	int intVal=0;
	strTTLType =websGetVar(wp, T("ttlType"), T(""));
	strTTLValue =websGetVar(wp, T("ttlValue"), T(""));

	intVal = strtol( strTTLType, (char **)NULL, 10);
	if ( apmib_set( MIB_TTL_TYPE, (void *)&intVal) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(Set TTL type error!)</script>"));
		goto setErr_tcpip;
	}

	if (strTTLValue[0]){
			intVal = strtol( strTTLValue, (char **)NULL, 10);
  			if ( apmib_set(MIB_TTL_VALUE, (void *)&intVal) == 0) {
								DEBUGP(tmpBuf, T("<script>document.write(Set TTL value error!))</script>"));
		        goto setErr_tcpip;
				}
	}
#endif
	if (strwanMode[0]) {
		if ( !gstrcmp(strwanMode, T("0")))    Mode = 0;
		if ( !gstrcmp(strwanMode, T("1")))    Mode = 1;
     		if ( !gstrcmp(strwanMode, T("2")))    Mode = 2;
		if ( apmib_set( MIB_WAN_MODE, (void *)&Mode) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup1))</script>"));
			goto setErr_tcpip;
		}
	}
//**************************************** PPPoE Setting ****************************************
   strConnect = websGetVar(wp, T("pppConnect"), T(""));
	if (strConnect[0]) {
		buttonState = 1;
		strMode = T("ppp");
		goto set_ppp;
	}

   strConnect = websGetVar(wp, T("pppDisconnect"), T(""));
	if (strConnect[0]) {
		buttonState = 2;
		strMode = T("ppp");
		goto set_ppp;
	}

	strpppServName = websGetVar(wp, T("pppServName"), T(""));
	if (Mode == 2) {
		if ( apmib_set(MIB_PPP_SERVNAME, (void *)strpppServName) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup14))</script>"));
			goto setErr_tcpip;
		}
	}
	strpppMTU = websGetVar(wp, T("pppMTU"), T(""));
	if (strpppMTU[0]) {
		if ( !string_to_dec(strpppMTU, &val) || val< 512 || val >1492) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_PPP_MTU, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup7))</script>"));
			goto setErr_tcpip;
		}
	}

#ifdef _INDEPEND_DHCP_MTU_
	strpppMTU = websGetVar(wp, T("dhcpMTU"), T(""));
	if (strpppMTU[0]) {
		if ( !string_to_dec(strpppMTU, &val) || val< 512 || val >1492) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_DHCP_MTU, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup7))</script>"));
			goto setErr_tcpip;
		}
	}
#endif

#if defined(_Customer_) | defined(_MPPPOE_)
	//alex 2007/02/01
	strConnect = websGetVar(wp, T("pppConnect1"), T(""));
	if (strConnect[0]) {
		buttonState1 = 1;
		strMode = T("ppp");
		goto set_ppp;
	}
	//alex 2007/02/01
   strConnect = websGetVar(wp, T("pppDisconnect1"), T(""));
	if (strConnect[0]) {
		buttonState1 = 2;
		strMode = T("ppp");
		goto set_ppp;
	}
	//alex 2007/01/31
	strpppServName = websGetVar(wp, T("pppServName1"), T(""));
	if (Mode == 2) {
		if ( apmib_set(MIB_PPP_SERVNAME1, (void *)strpppServName) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup14))</script>"));
			goto setErr_tcpip;
		}
	}
	//alex 2007/01/31
	strpppMTU = websGetVar(wp, T("pppMTU1"), T(""));
	if (strpppMTU[0]) {
		if ( !string_to_dec(strpppMTU, &val) || val< 512 || val >1492) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_PPP_MTU1, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup7))</script>"));
			goto setErr_tcpip;
		}
	}

	//alex 2007/01/31
	strpppMTU = websGetVar(wp, T("PPPoEMode"), T(""));
	if (strpppMTU[0]) {
		if ( !string_to_dec(strpppMTU, &val) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
			goto setErr_tcpip;
		}

		if ( apmib_set(MIB_PPPoE_MODE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup7))</script>"));
			goto setErr_tcpip;
		}

		if ( val == 1 ){
			//alex 2007/02/02
			strIp = websGetVar(wp, T("unnum_ip"), T(""));
			if ( strIp[0] ) {
				if ( !inet_aton(strIp, &inIp) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
					goto setErr_tcpip;
				}
				if ( !apmib_set(MIB_PPP_UNNUMIP, (void *)&inIp)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
					goto setErr_tcpip;
				}
			}
			//alex 2007/02/02
			strIp = websGetVar(wp, T("unnum_netmask"), T(""));
			if ( strIp[0] ) {
				if ( !inet_aton(strIp, &inIp) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
					goto setErr_tcpip;
				}
				if ( !apmib_set(MIB_PPP_UNNUMMASK, (void *)&inIp)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
					goto setErr_tcpip;
				}
			}
			//alex 2007/02/02
			strIp = websGetVar(wp, T("unnum_nat"), T(""));
			if ( strIp[0] ) {
				if ( !string_to_dec(strIp, &val) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
					goto setErr_tcpip;
				}

				if ( apmib_set(MIB_PPP_UNNUMNAT, (void *)&val) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup7))</script>"));
					goto setErr_tcpip;
				}
			}
		}
		else if( val == 2 )
		{
			//alex 2007/02/02
			strIp = websGetVar(wp, T("unnum_ip1"), T(""));
			if ( strIp[0] ) {
				if ( !inet_aton(strIp, &inIp) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
					goto setErr_tcpip;
				}
				if ( !apmib_set(MIB_PPP_UNNUMIP, (void *)&inIp)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
					goto setErr_tcpip;
				}
			}
			//alex 2007/02/02
			strIp = websGetVar(wp, T("unnum_netmask1"), T(""));
			if ( strIp[0] ) {
				if ( !inet_aton(strIp, &inIp) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
					goto setErr_tcpip;
				}
				if ( !apmib_set(MIB_PPP_UNNUMMASK, (void *)&inIp)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
					goto setErr_tcpip;
				}
			}
			//alex 2007/02/02
			strIp = websGetVar(wp, T("unnum_nat1"), T(""));
			if ( strIp[0] ) {
				if ( !string_to_dec(strIp, &val) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
					goto setErr_tcpip;
				}

				if ( apmib_set(MIB_PPP_UNNUMNAT, (void *)&val) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup7))</script>"));
					goto setErr_tcpip;
				}
			}
		}
	}

#endif

#if defined(_TRIPPPOE_)
	strConnect = websGetVar(wp, T("pppConnect2"), T(""));
	if (strConnect[0]) {
		buttonState2 = 1;
		strMode = T("ppp");
		goto set_ppp;
	}
   strConnect = websGetVar(wp, T("pppDisconnect2"), T(""));
	if (strConnect[0]) {
		buttonState2 = 2;
		strMode = T("ppp");
		goto set_ppp;
	}
	strpppServName = websGetVar(wp, T("pppServName2"), T(""));
	if (Mode == 2) {
		if ( apmib_set(MIB_PPP_SERVNAME2, (void *)strpppServName) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup14))</script>"));
			goto setErr_tcpip;
		}
	}
	strpppMTU = websGetVar(wp, T("pppMTU2"), T(""));
	if (strpppMTU[0]) {
		if ( !string_to_dec(strpppMTU, &val) || val< 512 || val >1492) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_PPP_MTU2, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup7))</script>"));
			goto setErr_tcpip;
		}
	}

	strpppMTU = websGetVar(wp, T("PPPoEMode"), T(""));
	if (strpppMTU[0]) {
		if ( !string_to_dec(strpppMTU, &val) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup6))</script>"));
			goto setErr_tcpip;
		}

		if( val == 2 )
		{
			strIp = websGetVar(wp, T("unnum_ip2"), T(""));
			if ( strIp[0] ) {
				if ( !inet_aton(strIp, &inIp) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
					goto setErr_tcpip;
				}
				if ( !apmib_set(MIB_PPP_UNNUMIP2, (void *)&inIp)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
					goto setErr_tcpip;
				}
			}
			strIp = websGetVar(wp, T("unnum_netmask2"), T(""));
			if ( strIp[0] ) {
				if ( !inet_aton(strIp, &inIp) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
					goto setErr_tcpip;
				}
				if ( !apmib_set(MIB_PPP_UNNUMMASK2, (void *)&inIp)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
					goto setErr_tcpip;
				}
			}
		}
	}
#endif

	strEnTtl = websGetVar(wp, T("pppEnTtl"), T(""));
	if (strEnTtl[0]) {
		if (strEnTtl[0] == '0')
			val = 0;
		else if (strEnTtl[0] == '1')
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWanTcpipSetup1))</script>"));
			goto setErr_tcpip;
		}
		if ( apmib_set(MIB_PPP_TTL_ENABLED, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWanTcpipSetup2))</script>"));
			goto setErr_tcpip;
		}
	}
//**************************************** Dynamic Ip ****************************************
	if (Mode == 0) {
		strdynIPHostName = websGetVar(wp, T("dynIPHostName"), T(""));
		if ( apmib_set(MIB_DYNIP_HOSTNAME, (void *)strdynIPHostName) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup2))</script>"));
			goto setErr_tcpip;
		}
	}
	// Set clone MAC address
	strMac = websGetVar(wp, T("macAddr"), T(""));
	if (strMac[0]) {
		if (strlen(strMac)!=12 || !string_to_hex(strMac, tmpBuf, 12)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup16))</script>"));
			goto setErr_tcpip;
		}
		if ( !apmib_set(MIB_WAN_MAC_ADDR, (void *)tmpBuf)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormDynIpSetup3))</script>"));
			goto setErr_tcpip;
		}

	}
	
#if defined (_EZVIEW_) || defined (_AUTO_DNS_) 
	strIp = websGetVar(wp, T("DNSMode"), T(""));
	if (strIp[0])
	{
		if (!gstrcmp(strIp, T("0"))) val = 0;
		else val = 1;
		apmib_set(MIB_WAN_DNS_MODE, (void *)&val);
	}

	strcpy(tmpBuf,"0.0.0.0");

	if(val==0)
	{
		inet_aton(tmpBuf, &inIp);
		apmib_set( MIB_WAN_DNS1, (void *)&inIp);
		apmib_set( MIB_WAN_DNS2, (void *)&inIp);
		apmib_set( MIB_WAN_DNS3, (void *)&inIp);
	}
	else
	{
		strIp = websGetVar(wp, T("dns1"), T(""));
		if(strIp[0])
		{
			inet_aton(strIp, &inIp);
			apmib_set( MIB_WAN_DNS1, (void *)&inIp);
		}
		strIp = websGetVar(wp, T("dns2"), T(""));
		if(strIp[0])
		{
			inet_aton(strIp, &inIp);
			apmib_set( MIB_WAN_DNS2, (void *)&inIp);
		}
		strIp = websGetVar(wp, T("dns3"), T(""));
		if(strIp[0])
		{
			inet_aton(strIp, &inIp);
			apmib_set( MIB_WAN_DNS3, (void *)&inIp);
		}
	}
#endif

//**************************************** DNS Setting ****************************************
	strMode = websGetVar(wp, T("dnsMode"), T(""));

	if ( strMode[0] ) {
		struct in_addr dns1_old, dns2_old, dns3_old;
		if (!strcmp(strMode, T("dnsAuto")))
			dns = DNS_AUTO;
		else if (!strcmp(strMode, T("dnsManual")))
			dns = DNS_MANUAL;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWanTcpipSetup3))</script>"));
			goto setErr_tcpip;
		}

		if ( !apmib_get(MIB_WAN_DNS_MODE, (void *)&dns_old)) {
	  		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWanTcpipSetup4))</script>"));
			goto setErr_tcpip;
		}
		if (dns != dns_old)
			dns_changed = 1;

		// Set DNS to MIB
		if ( !apmib_set(MIB_WAN_DNS_MODE, (void *)&dns)) {
	  		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup2))</script>"));
			goto setErr_tcpip;
		}

		//if ( dns == DNS_MANUAL ) {
			if ( !apmib_get(MIB_WAN_DNS1, (void *)&dns1_old)) {
	  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup3))</script>"));
				goto setErr_tcpip;
			}
			if ( !apmib_get(MIB_WAN_DNS2, (void *)&dns2_old)) {
	  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup3))</script>"));
				goto setErr_tcpip;
			}
			if ( !apmib_get(MIB_WAN_DNS3, (void *)&dns3_old)) {
	  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup3))</script>"));
				goto setErr_tcpip;
			}


			// If DHCP server is enabled in LAN, update dhcpd.conf

			strDNS = websGetVar(wp, T("dns1"), T(""));

			if ( strDNS[0] ) {
				if ( !inet_aton(strDNS, &dns1) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup1))</script>"));
					goto setErr_tcpip;
				}

				if ( !apmib_set(MIB_WAN_DNS1, (void *)&dns1)) {
	  				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup2))</script>"));
					goto setErr_tcpip;
				}
			}
			else {
				if ( !apmib_get(MIB_WAN_DNS1, (void *)&dns1) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup3))</script>"));
					goto setErr_tcpip;
				}
			}
			strDNS = websGetVar(wp, T("dns2"), T(""));
			if ( strDNS[0] ) {
				if ( !inet_aton(strDNS, &dns2) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup1))</script>"));
					goto setErr_tcpip;
				}
				if ( !apmib_set(MIB_WAN_DNS2, (void *)&dns2)) {
	  				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup2))</script>"));
					goto setErr_tcpip;
				}
			}
			else {
				if ( !apmib_get(MIB_WAN_DNS2, (void *)&dns2) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWanTcpipSetup5))</script>"));
					goto setErr_tcpip;
				}
			}
			strDNS = websGetVar(wp, T("dns3"), T(""));
			if ( strDNS[0] ) {
				if ( !inet_aton(strDNS, &dns3) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup1))</script>"));
					goto setErr_tcpip;
				}
				if ( !apmib_set(MIB_WAN_DNS3, (void *)&dns3)) {
	  				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStcIpSetup2))</script>"));
					goto setErr_tcpip;
				}
			}
			else {
				if ( !apmib_get(MIB_WAN_DNS3, (void *)&dns3) ) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWanTcpipSetup6))</script>"));
					goto setErr_tcpip;
				}
			}

			if ( *((long *)&dns1) != *((long *)&dns1_old) ||
				 *((long *)&dns2) != *((long *)&dns2_old) ||
				  *((long *)&dns3) != *((long *)&dns3_old) )
				dns_changed = 1;
		//}
	}

	// Read current ip mode setting for reference later
	if ( !apmib_get( MIB_WAN_DHCP, (void *)&curDhcp) ) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWanTcpipSetup7))</script>"));
		goto setErr_tcpip;
	}

	strMode = websGetVar(wp, T("ipMode"), T(""));
set_ppp:
	if ( strMode[0] ) {

#if defined (_EZVIEW_) || defined (_AUTO_DNS_)
	strIp = websGetVar(wp, T("DNSMode"), T(""));
	if (strIp[0])
	{
		if (!gstrcmp(strIp, T("0"))) val = 0;
		else val = 1;
		apmib_set(MIB_WAN_DNS_MODE, (void *)&val);
	}

	strcpy(tmpBuf,"0.0.0.0");

	if(val==0)
	{
		inet_aton(tmpBuf, &inIp);
		apmib_set( MIB_WAN_DNS1, (void *)&inIp);
		apmib_set( MIB_WAN_DNS2, (void *)&inIp);
		apmib_set( MIB_WAN_DNS3, (void *)&inIp);
	}
	else
	{
		strIp = websGetVar(wp, T("dns1"), T(""));
		if(strIp[0])
		{
			inet_aton(strIp, &inIp);
			apmib_set( MIB_WAN_DNS1, (void *)&inIp);
		}

		strIp = websGetVar(wp, T("dns2"), T(""));
		if(strIp[0])
		{
			inet_aton(strIp, &inIp);
			apmib_set( MIB_WAN_DNS2, (void *)&inIp);
		}
	}
#endif



		if ( !strcmp(strMode, T("autoIp")))
			dhcp = DHCP_CLIENT;
		else if ( !strcmp(strMode, T("fixedIp")))
			dhcp = DHCP_DISABLED;
		else if ( !strcmp(strMode, T("ppp"))) {
			char_t	*strName, *strPassword, *strType;
			dhcp = PPPOE;
  			strName = websGetVar(wp, T("pppUserName"), T(""));

			tmpBuf[0]='\0';
			flag = 1;
			while ( flag ) {
				if ((ptr = strchr(strName, '#')) != NULL) {
					*ptr ='\0';
					ptr++;
					strcat( tmpBuf, strName);
					strcat( tmpBuf, "\\#");
					strName = ptr;
				}
				else {
					strcat( tmpBuf, strName);
					flag = 0;
				}
			}

			if ( tmpBuf[0] ) {
				if ( apmib_set(MIB_PPP_USER, (void *)tmpBuf) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup14))</script>"));
					goto setErr_tcpip;
				}
			}

 			strPassword = websGetVar(wp, T("pppPassword"), T(""));
			if ( strPassword[0] ) {
				if ( apmib_set(MIB_PPP_PASSWORD, (void *)strPassword) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup15))</script>"));
					goto setErr_tcpip;
				}
			}

			strType = websGetVar(wp, T("pppConnectType"), T(""));
			if ( strType[0] ) {
				PPP_CONNECT_TYPE_T type;
				if ( strType[0] == '0' )
					type = CONTINUOUS;
				else if ( strType[0] == '1' )
					type = CONNECT_ON_DEMAND;
				else if ( strType[0] == '2' )
					type = MANUAL;
				else {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup16))</script>"));
					goto setErr_tcpip;
				}
				if ( apmib_set(MIB_PPP_CONNECT_TYPE, (void *)&type) == 0) {
   					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup17))</script>"));
					goto setErr_tcpip;
				}
				if (type != CONTINUOUS) {
					char_t *strTime;
					strTime = websGetVar(wp, T("pppIdleTime"), T(""));
					if ( strTime[0] ) {
						int time;
 						time = strtol(strTime, (char**)NULL, 10) * 60;
						if ( apmib_set(MIB_PPP_IDLE_TIME, (void *)&time) == 0) {
   							DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup18))</script>"));
							goto setErr_tcpip;
						}
					}
				}
			}
#if defined(_Customer_) | defined(_MPPPOE_)
			//alex 2007/01/31
  			strName = websGetVar(wp, T("pppUserName1"), T(""));

			tmpBuf[0]='\0';
			flag = 1;
			while ( flag ) {
				if ((ptr = strchr(strName, '#')) != NULL) {
					*ptr ='\0';
					ptr++;
					strcat( tmpBuf, strName);
					strcat( tmpBuf, "\\#");
					strName = ptr;
				}
				else {
					strcat( tmpBuf, strName);
					flag = 0;
				}
			}

			if ( tmpBuf[0] ) {
				if ( apmib_set(MIB_PPP_USER1, (void *)tmpBuf) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup14))</script>"));
					goto setErr_tcpip;
				}
			}
 			//alex 2007/01/31
			strPassword = websGetVar(wp, T("pppPassword1"), T(""));
			if ( strPassword[0] ) {
				if ( apmib_set(MIB_PPP_PASSWORD1, (void *)strPassword) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup15))</script>"));
					goto setErr_tcpip;
				}
			}

			//alex 2007/01/31
			strType = websGetVar(wp, T("pppConnectType1"), T(""));
			if ( strType[0] ) {
				PPP_CONNECT_TYPE_T type;
				if ( strType[0] == '0' )
					type = CONTINUOUS;
				else if ( strType[0] == '1' )
					type = CONNECT_ON_DEMAND;
				else if ( strType[0] == '2' )
					type = MANUAL;
				else {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup16))</script>"));
					goto setErr_tcpip;
				}
				if ( apmib_set(MIB_PPP_CONNECT_TYPE1, (void *)&type) == 0) {
   					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup17))</script>"));
					goto setErr_tcpip;
				}
				if (type != CONTINUOUS) {
					char_t *strTime;
					strTime = websGetVar(wp, T("pppIdleTime1"), T(""));
					if ( strTime[0] ) {
						int time;
 						time = strtol(strTime, (char**)NULL, 10) * 60;
						if ( apmib_set(MIB_PPP_IDLE_TIME1, (void *)&time) == 0) {
   							DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup18))</script>"));
							goto setErr_tcpip;
						}
					}
				}
			}
	#ifdef _TRIPPPOE_

  			strName = websGetVar(wp, T("pppUserName2"), T(""));

			tmpBuf[0]='\0';
			flag = 1;
			while ( flag ) {
				if ((ptr = strchr(strName, '#')) != NULL) {
					*ptr ='\0';
					ptr++;
					strcat( tmpBuf, strName);
					strcat( tmpBuf, "\\#");
					strName = ptr;
				}
				else {
					strcat( tmpBuf, strName);
					flag = 0;
				}
			}

			if ( tmpBuf[0] ) {
				if ( apmib_set(MIB_PPP_USER2, (void *)tmpBuf) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup14))</script>"));
					goto setErr_tcpip;
				}
			}

			strPassword = websGetVar(wp, T("pppPassword2"), T(""));
			if ( strPassword[0] ) {
				if ( apmib_set(MIB_PPP_PASSWORD2, (void *)strPassword) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup15))</script>"));
					goto setErr_tcpip;
				}
			}

			strType = websGetVar(wp, T("pppConnectType2"), T(""));
			if ( strType[0] ) {
				PPP_CONNECT_TYPE_T type1;
				if ( strType[0] == '0' )
					type1 = CONTINUOUS;
				else if ( strType[0] == '1' )
					type1 = CONNECT_ON_DEMAND;
				else if ( strType[0] == '2' )
					type1 = MANUAL;
				else {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup16))</script>"));
					goto setErr_tcpip;
				}
				if ( apmib_set(MIB_PPP_CONNECT_TYPE2, (void *)&type1) == 0) {
   					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup17))</script>"));
					goto setErr_tcpip;
				}
				if (type1 != CONTINUOUS) {
					char_t *strTime;
					strTime = websGetVar(wp, T("pppIdleTime2"), T(""));
					if ( strTime[0] ) {
						int time1;
 						time1 = strtol(strTime, (char**)NULL, 10) * 60;
						if ( apmib_set(MIB_PPP_IDLE_TIME2, (void *)&time) == 0) {
   							DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup18))</script>"));
							goto setErr_tcpip;
						}
					}
				}
			}
	#endif
#endif
		}
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWanTcpipSetup8))</script>"));
			goto setErr_tcpip;
		}
		if ( !apmib_set(MIB_WAN_DHCP, (void *)&dhcp)) {
	  		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup21))</script>"));
			goto setErr_tcpip;
		}

		if ( dhcp == PPPOE && buttonState == 1 ) { // connect button is pressed
			int wait_time=30;
//---------------------------------------------------------------------------------
			apmib_update(CURRENT_SETTING);	// update to flash
#ifndef NO_ACTION

//			pid = fork();
//      		if (pid)
//	        		waitpid(pid, NULL, 0);
//			else if (pid == 0) {
//				snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _PPPOE_SCRIPT_PROG);
//				execl( tmpBuf, _PPPOE_SCRIPT_PROG, "connect", NULL);
//     				exit(1);
//			}
	#ifdef __TARGET_BOARD__
		system("/bin/pppoe.sh connect");
	#endif
		while (wait_time-- >0) {
			if (isConnectPPP())
				break;
			sleep(1);
		}
		if (isConnectPPP())
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup11))</script>\n"));
		else
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup12))</script>\n"));

		OK_MSG1(tmpBuf, submitUrl);
#endif
			return;
		}

		if ( dhcp == PPPOE && buttonState == 2 ) { // disconnect button is pressed

			apmib_update(CURRENT_SETTING);	// update to flash
#ifndef NO_ACTION
//			pid = fork();
//        		if (pid)
//	             		waitpid(pid, NULL, 0);
//        		else if (pid == 0) {
//				snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _PPPOE_DC_SCRIPT_PROG);
//				execl( tmpBuf, _PPPOE_DC_SCRIPT_PROG, "all", NULL);
//                		exit(1);
//        		}
//	sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all");
//	system(tmpBuf);
	#ifdef __TARGET_BOARD__
			system("/bin/disconnect.sh pppoe 0 all"); // Lance 2004.2.3
	#endif
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup19))</script>\n"));
			OK_MSG1(tmpBuf, submitUrl);
#endif
			return;
		}
#if defined(_Customer_) | defined(_MPPPOE_)
		//alex 2007/02/01
		if ( dhcp == PPPOE && buttonState1 == 1 ) { // connect button is pressed
			int wait_time=30;
//---------------------------------------------------------------------------------
			apmib_update(CURRENT_SETTING);	// update to flash
#ifndef NO_ACTION
	#if 0
			pid = fork();
      		if (pid)
	        		waitpid(pid, NULL, 0);
			else if (pid == 0) {
				snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _PPPOE_SCRIPT_PROG);
				execl( tmpBuf, _PPPOE_SCRIPT_PROG, "connect", NULL);
     				exit(1);
			}
	#endif
	#ifdef __TARGET_BOARD__
		system("/bin/pppoe.sh connect 1");
	#endif
		while (wait_time-- >0) {
			if (isConnectPPP1())
				break;
			sleep(1);
		}
		if (isConnectPPP1())
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup11))</script>\n"));
		else
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup12))</script>\n"));

		OK_MSG1(tmpBuf, submitUrl);
#endif
			return;
		}

		if ( dhcp == PPPOE && buttonState1 == 2 ) { // disconnect button is pressed

			apmib_update(CURRENT_SETTING);	// update to flash
#ifndef NO_ACTION
//			pid = fork();
//        		if (pid)
//	             		waitpid(pid, NULL, 0);
//        		else if (pid == 0) {
//				snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _PPPOE_DC_SCRIPT_PROG);
//				execl( tmpBuf, _PPPOE_DC_SCRIPT_PROG, "all", NULL);
//                		exit(1);
//        		}
//	sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all");
//	system(tmpBuf);
		#ifdef __TARGET_BOARD__
			system("/bin/disconnect.sh pppoe 1 all"); // Lance 2004.2.3
		#endif
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup19))</script>\n"));
			OK_MSG1(tmpBuf, submitUrl);
#endif
			return;
		}
#endif

#if defined(_TRIPPPOE_) & defined(_MPPPOE_)
		if ( dhcp == PPPOE && buttonState2 == 1 ) { // connect button is pressed
			int wait_time1=30;
//---------------------------------------------------------------------------------
			apmib_update(CURRENT_SETTING);	// update to flash
#ifndef NO_ACTION
	#ifdef __TARGET_BOARD__
		system("/bin/pppoe.sh connect 2");
	#endif
			while (wait_time1-- >0) {
				if (isConnectPPP2())
					break;
				sleep(1);
			}
			if (isConnectPPP2())
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup11))</script>\n"));
			else
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup12))</script>\n"));

			OK_MSG1(tmpBuf, submitUrl);
#endif
			return;
		}

		if ( dhcp == PPPOE && buttonState2 == 2 ) { // disconnect button is pressed

			apmib_update(CURRENT_SETTING);	// update to flash
#ifndef NO_ACTION
		#ifdef __TARGET_BOARD__
			system("/bin/disconnect.sh pppoe 2 all"); // Lance 2004.2.3
		#endif
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormL2TPSetup19))</script>\n"));
			OK_MSG1(tmpBuf, submitUrl);
#endif
			return;
		}
#endif
	}
	else
		dhcp = curDhcp;

	if ( dhcp == DHCP_DISABLED ) {
		strIp = websGetVar(wp, T("ip"), T(""));
		if ( strIp[0] ) {
			if ( !inet_aton(strIp, &inIp) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
				goto setErr_tcpip;
			}
			if ( !apmib_set(MIB_WAN_IP_ADDR, (void *)&inIp)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup24))</script>"));
				goto setErr_tcpip;
			}
		}

		strMask = websGetVar(wp, T("mask"), T(""));
		if ( strMask[0] ) {
			if ( !inet_aton(strMask, &inMask) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup26))</script>"));
				goto setErr_tcpip;
			}
			if ( !apmib_set(MIB_WAN_SUBNET_MASK, (void *)&inMask)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup27))</script>"));
				goto setErr_tcpip;
			}
		}

		strGateway = websGetVar(wp, T("gateway"), T(""));
		if ( strGateway[0] ) {
			if ( !inet_aton(strGateway, &inGateway) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup29))</script>"));
				goto setErr_tcpip;
			}
			if ( !apmib_set(MIB_WAN_DEFAULT_GATEWAY, (void *)&inGateway)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup30))</script>"));
				goto setErr_tcpip;
			}
		}
	}

	apmib_update(CURRENT_SETTING);	// update to flash

	// run script
	if ( dns_changed )
		arg = "all";
	else
		arg = "wan";

#ifndef NO_ACTION
//        pid = fork();
//        if (pid)
//                waitpid(pid, NULL, 0);
//
//        else if (pid == 0) {
//		snprintf(tmpBuf, 100, "%s/%s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG);
//		execl( tmpBuf, _CONFIG_SCRIPT_PROG, "gw", arg, NULL);
//                exit(1);
//        }
	// sprintf(tmpBuf, "%s %s", "/bin/init.sh gw", "all"); // Tommy
	// system(tmpBuf);
#endif
//20060410 pippen

#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

	strnextEnable = websGetVar(wp, T("redirect"), T(""));
	if (strnextEnable[0]){

		system("/bin/scriptlib_util.sh reloadFlash");

		REPLACE_MSG(submitUrl);

		}
	else{
#ifdef _Customer_WAN_PROB_
		if (wizardEnabled == 1){
			websRedirect(wp, submitUrl);
			return;
		}else{
			OK_MSG(submitUrl);
		}
#else
		OK_MSG(submitUrl);
#endif
		}
	return;

setErr_tcpip:
	ERR_MSG(tmpBuf);
}

/////////////////////////////////////////////////////////////////////////////
//============
int dhcpClientList(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp;
	int nBytesSent=0;
	int element=0, ret;
	char ipAddr[40], macAddr[40], liveTime[80], *buf=NULL, *ptr, tmpBuf[100];
	struct stat status;
	int pid;
	unsigned long longVal;

	//kyle
	system("killall -q -USR1 udhcpd");

	// siganl DHCP server to update lease file
	snprintf(tmpBuf, 100, "%s/%s.pid", _DHCPD_PID_PATH, _DHCPD_PROG_NAME);
	pid = getPid(tmpBuf);
	if ( pid > 0)
		kill(pid, SIGUSR1);
	usleep(1000);
	if ( stat(_PATH_DHCPS_LEASES, &status) < 0 )
		goto err;

	buf = malloc(status.st_size);
	if ( buf == NULL )
		goto err;
	fp = fopen(_PATH_DHCPS_LEASES, "r");
	if ( fp == NULL )
		goto err;
	fread(buf, 1, status.st_size, fp);
	fclose(fp);
	ptr = buf;

#ifdef _IP_LIST_TABLE_



#define MAX_DEVICE_NUM 255
#define MAX_NAME_LENGTH 21
FILE *fp1, *fp2, *fp3;
char c;
struct in_addr	intaddr;
char buf77[5101], buf1[1021];
char tmpBuf1[100], tmpBuf2[100], tmpBuf3[100];
char *tmp, *tmp1,*ip, *local_ip, *mask_ip;
int i,j,k,l,m,count,nbtcount,f_count, entryNum_pf, entryNum_qos, entryNum;
//		SDHCP_T entry;
PORTFW_T entry_pf;
QOS_T    entry_qos;
EZVIEW_T entry;
char devicename1[MAX_DEVICE_NUM];
char mac_from_usn[13];
char    macaddr1[MAX_DEVICE_NUM][13];
char     ipaddr1[MAX_DEVICE_NUM][16];
char devicename[MAX_DEVICE_NUM][MAX_NAME_LENGTH];
int  devicetype[MAX_DEVICE_NUM],io[MAX_DEVICE_NUM];
unsigned short f_portfw[MAX_DEVICE_NUM][5][2];

apmib_get( MIB_IP_ADDR,  (void *)&intaddr);
local_ip=inet_ntoa(intaddr);

tmp=local_ip;
i=0;j=0;
while(i<3)
{
	if(tmp[j] == '.') i=i+1;
	j=j+1;
}
tmp[j]='\0';
mask_ip=tmp;

//====NETBIOS & UPNP scan script
system("/bin/ez1.sh");

//====START fetch
count=0;

//====NETBIOS fetch
fp1=fopen("/tmp/nbtname","r");
fp2=fopen("/tmp/nbtip","r");
fp3=fopen("/tmp/nbtmac","r");
while(  fgets(tmpBuf1, 100, fp1) > 0  &&  fgets(tmpBuf2, 100, fp2) > 0  &&  fgets(tmpBuf3, 100, fp3) > 0  )
{
	if( strcmp(tmpBuf2, local_ip)!=0 )
	{
		strcpy( devicename[count], tmpBuf1 );
		sstrip( devicename[count], MAX_NAME_LENGTH);

		strcpy( ipaddr1[count], tmpBuf2 );
		sstrip( ipaddr1[count], 16);

		strcpy( macaddr1[count], tmpBuf3);
		sstrip( macaddr1[count], 13);

		devicetype[count]=4; //in ezview.js, var resolvetypeTbl=new Array("nas","cam","game","ps","user","pserver","what","ap");

		io[count]=0;

		count += 1;
	}
}
fclose(fp1);
fclose(fp2);
fclose(fp3);
nbtcount=count;
//====UPNP fetch
/*
fp1=fopen("/tmp/upnptmp","r");

k=0;
while(fgets(tmpBuf1, 100, fp1) > 0)
{
	//===============Get IP [XXX.XXX.XXX.XXX], this is the head of the upnp information.S
	if( strncmp(tmpBuf1,"[",1) == 0 )
	{
		strncpy( tmpBuf2, tmpBuf1+1, strchr(tmpBuf1,']') - (tmpBuf1+1) );
		tmpBuf2 [ strchr(tmpBuf1,']') - (tmpBuf1+1) ] = '\0';
		if( strcmp(tmpBuf2, local_ip)!=0 ) //Router self ip no display
		{
			strcpy( ipaddr1[count], tmpBuf2 );
			k=1;
		}
		strcpy( mac_from_usn, "000000000000");
		strcpy( macaddr1[count], "000000000000");
	}


	//==============="---" is tail of upnp information
	if( strncmp(tmpBuf1,"---\n",4) == 0 )
	{
		if(k>0 )
		{
			if(k==1) //didn't find "Location:"
			{
				strcpy(devicename[count], "N/A");
				devicetype[count]=6;
				strcpy(macaddr1[count], mac_from_usn);
			}
			j=0;
			sprintf(tmpBuf1,	"echo == >> /tmp/zz");
			system(tmpBuf1);

			for(i=0;i<count && j==0;i++) // if MAC has appeared before, count no +1, means this data no use. Only upnp will occer
			{
				if( !strcmp(ipaddr1[count], ipaddr1[i]) ) // mac the same
				{
					if( strcmp(devicename[count],"N/A")!=0 && strcmp(devicename[i],"N/A")==0 || devicetype[count]!=6 && devicetype[i]==6)
					{
						strcpy(devicename[i], devicename[count]);
						strcpy(ipaddr1[i], ipaddr1[count]);
						devicetype[i]=devicetype[count];
					}
					j=1;
				}
				else
				{
					sprintf(tmpBuf1,	"echo %s,%s >> /tmp/zz",ipaddr1[count], ipaddr1[i]);
					system(tmpBuf1);
				}
			}
			if(j==0) {io[count]=0;count=count+1;}
		}
		k=0;
	}
}
fclose(fp1);*/

for(i=0;i<count;i++) // after all, use << arp mac >> replace << mac get from ezview tag or usn >>, so arp will be last result
{
	sprintf(tmpBuf1,	"cat /proc/net/arp | grep \'%s\'| cut -b42-59  > /tmp/ezarp", ipaddr1[i]);
	system(tmpBuf1);
	fp1=fopen("/tmp/ezarp","r");
	if (fgets(buf77, 100, fp1) > 0 && strncmp(buf77,"00:00:00:00:00:00",17)!=0)
	{
		macaddr1[i][0]=tolower(buf77[0]);
		macaddr1[i][1]=tolower(buf77[1]);
		macaddr1[i][2]=tolower(buf77[3]);
		macaddr1[i][3]=tolower(buf77[4]);
		macaddr1[i][4]=tolower(buf77[6]);
		macaddr1[i][5]=tolower(buf77[7]);
		macaddr1[i][6]=tolower(buf77[9]);
		macaddr1[i][7]=tolower(buf77[10]);
		macaddr1[i][8]=tolower(buf77[12]);
		macaddr1[i][9]=tolower(buf77[13]);
		macaddr1[i][10]=tolower(buf77[15]);
		macaddr1[i][11]=tolower(buf77[16]);
		macaddr1[i][12]='\0';
	}
	fclose(fp1);
}


#endif
	while (1) {
		ret = getOneDhcpClient(&ptr, &status.st_size, ipAddr, macAddr, liveTime);

		if (ret < 0) break;

		if (ret == 0) continue;

		longVal=strtoul(liveTime,NULL,0);

		if (longVal > 2000000) sprintf(liveTime, "%s", "forever");

		#ifdef _IP_LIST_TABLE_
		strcpy( devicename1, "----");
		for (i=0; i<count ; i++)
		{

			tmpBuf2[0]=macAddr[0];
			tmpBuf2[1]=macAddr[1];
			tmpBuf2[2]=macAddr[3];
			tmpBuf2[3]=macAddr[4];
			tmpBuf2[4]=macAddr[6];
			tmpBuf2[5]=macAddr[7];
			tmpBuf2[6]=macAddr[9];
			tmpBuf2[7]=macAddr[10];
			tmpBuf2[8]=macAddr[12];
			tmpBuf2[9]=macAddr[13];
			tmpBuf2[10]=macAddr[15];
			tmpBuf2[11]=macAddr[16];
			tmpBuf2[12]='\0';

			if(  !strcmp(macaddr1[i],tmpBuf2)  &&  !strcmp(ipaddr1[i],ipAddr) )
			{

				strcpy(devicename1,devicename[i]);
				io[i]=1;
			}

		}

		#endif


#ifdef _IP_LIST_TABLE_
		macAddr[2]=macAddr[3];
		macAddr[3]=macAddr[4];
		macAddr[4]=macAddr[6];
		macAddr[5]=macAddr[7];
		macAddr[6]=macAddr[9];
		macAddr[7]=macAddr[10];
		macAddr[8]=macAddr[12];
		macAddr[9]=macAddr[13];
		macAddr[10]=macAddr[15];
		macAddr[11]=macAddr[16];
		macAddr[12]='\0';

		if(strcmp(macAddr, "000000000000"))
		nBytesSent += websWrite(wp,
		T("<tr><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">%s</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">%s</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">%s</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">%s</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\"><script>dw(IPStatus_dynamic)</script></td></tr>"),
		ipAddr, devicename1, macAddr, liveTime);

#elif defined(_EZVIEW_)
		nBytesSent += websWrite(wp,
				T("<tr><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">%s</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">%s</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">%s</td></tr>"),
				ipAddr, macAddr, liveTime);
#else
		if (strcmp(macAddr, "00:00:00:00:00:00") != 0) { // tommy
			nBytesSent += websWrite(wp,
			T("<tr class=table2 align=center><td><font size=2>%s</td><td><font size=2>%s</td><td><font size=2>%s</td></tr>"),
			ipAddr, macAddr, liveTime);
		}
#endif

		element++;
	}

#ifdef _IP_LIST_TABLE_

for (i=0; i<count ; i++)
{
	if( io[i]==0 && strcmp(ipaddr1[i],inet_ntoa(intaddr)) && strcmp(ipaddr1[i],"") && strcmp(macaddr1[i],"") )
	{

	nBytesSent += websWrite(wp,
	T("<tr><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">%s</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">%s</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">%s</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">----</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\"><script>dw(IPStatus_static)</script></td></tr>"),
	ipaddr1[i], devicename[i],macaddr1[i]);

	}
}
#endif


err:
#ifdef _IP_LIST_TABLE_
	if (count == 0 && element == 0) {
#else
	if (element == 0) {
#endif
		nBytesSent += websWrite(wp,
			#ifdef _IP_LIST_TABLE_
			T("<tr><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\"><script>dw(none)</script></td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">----</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">----</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">----</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">----</td></tr>"));
			#elif defined(_EZVIEW_)
			T("<tr><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\"><script>dw(none)</script></td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">----</td><td bgcolor=\"#FFFFFF\" class=\"style22\" align=\"center\">----</td></tr>"));
			#else
			T("<tr class=table2 align=center><td><font size=2>None</td><td><font size=2>----</td><td><font size=2>----</td></tr>"));
			#endif
	}
	if (buf)
		free(buf);
	return nBytesSent;
}

/////////////////////////////////////////////////////////////////////////////
void formReflashClientTbl(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	if (submitUrl[0])
		websRedirect(wp, submitUrl);
}

#endif

//////////////////////////////////////////////////////////////////////////////
int isDhcpClientExist(char *name)
{
	char tmpBuf[100];
	struct in_addr intaddr;

	if ( getInAddr(name, IP_ADDR, (void *)&intaddr ) ) {
		snprintf(tmpBuf, 100, "%s/%s-%s.pid", _DHCPC_PID_PATH, _DHCPC_PROG_NAME, name);
		if ( getPid(tmpBuf) > 0)
			return 1;
	}
	return 0;
}
/////////////////////////connectionsetting.asp/////////////////////////////////////////
void formConnectionSetting(webs_t wp, char_t *path, char_t *query){
 	char tmpBuf[100];

 		char_t *maxConn, *timeOut;

	maxConn = websGetVar(wp, T("max_Conn"), T(""));
	timeOut = websGetVar(wp, T("timeOut"), T(""));

	sprintf(tmpBuf,"echo %s > /proc/sys/net/ipv4/ip_conntrack_max",maxConn);
	system(tmpBuf);
	printf("Command: %s \n",tmpBuf);
	sprintf(tmpBuf,"echo %s > /proc/sys/net/ipv4/netfilter/ip_conntrack_tcp_timeout_established",timeOut);

	system(tmpBuf);
	printf("Command: %s \n",tmpBuf);
	websRedirect(wp, "connectionsetting.asp");
 }


//add by vance 2008.11.03
//************************************ PC Database *****************Bryan****************
#ifdef _PC_DATABASE_
void formGroupSetup(webs_t wp, char_t *path, char_t *query)
{
    char_t *groupIdx, *group, *groupEnable, *submitUrl;
    char tmpBuf[100];
    int val;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	groupIdx = websGetVar(wp, T("groupIdx"), T(""));
	groupEnable = websGetVar(wp, T("groupDisabled"), T(""));
	group = websGetVar(wp, T("group"), T(""));

	if (groupEnable[0]) {
		if (!gstrcmp(groupEnable, T("no")))
			val = 1;
		else if (!gstrcmp(groupEnable, T("yes")))
			val = 0;
		else {
			DEBUGP(tmpBuf, T("Error!"));
			goto setErr_GroupSetup;
		}
	}

	if ( !gstrcmp(groupIdx, T("1"))){
		if ( apmib_set(MIB_GROUP1, (void *)group) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write('write group1 data fail')</script>"));
			goto setErr_GroupSetup;
		}
		if ( apmib_set(MIB_GROUP1_DISABLED, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write('write group1 data fail')</script>"));
			goto setErr_GroupSetup;
		}
    }

	if ( !gstrcmp(groupIdx, T("2"))){
		if ( apmib_set(MIB_GROUP2, (void *)group) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write('write group2 data fail')</script>"));
			goto setErr_GroupSetup;
		}
		if ( apmib_set(MIB_GROUP2_DISABLED, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write('write group1 data fail')</script>"));
			goto setErr_GroupSetup;
		}
    }

	if ( !gstrcmp(groupIdx, T("3"))){
		if ( apmib_set(MIB_GROUP3, (void *)group) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write('write group3 data fail')</script>"));
			goto setErr_GroupSetup;
		}
		if ( apmib_set(MIB_GROUP3_DISABLED, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write('write group1 data fail')</script>"));
			goto setErr_GroupSetup;
		}
    }

	if ( !gstrcmp(groupIdx, T("4"))){
		if ( apmib_set(MIB_GROUP4, (void *)group) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write('write group4 data fail')</script>"));
			goto setErr_GroupSetup;
		}
		if ( apmib_set(MIB_GROUP4_DISABLED, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write('write group1 data fail')</script>"));
			goto setErr_GroupSetup;
		}
    }

	apmib_update(CURRENT_SETTING);
    OK_MSG(submitUrl);
    return;
setErr_GroupSetup:
	ERR_MSG(tmpBuf);
    return;
}

void formPcdatabaseSetup(webs_t wp, char_t *path, char_t *query)
{
	#define MAX_NAME_LENGTH 21

	char_t *strEnabled, *strAction, *strAddMac, *strVal, *strUpate, *strDelMac, *groupIdx, *submitUrl;
	int intVal, entryNum, i, enabled;
	char tmpBuf[100];
	SDHCP_T entry, orgEntry;
	EDIT_T Edit;

	memset(&entry, '\0', sizeof(entry));

	strEnabled = websGetVar(wp, T("SDHCPEnabled"), T(""));
	strAction = websGetVar(wp, T("action0"), T(""));
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	groupIdx = websGetVar(wp, T("groupIdx"), T(""));

	//add single entry
	strAddMac = websGetVar(wp, T("addSDHCPMac"), T(""));
	//if (strAddMac[0]) {
	if ( !gstrcmp(strAction, T("ADD"))){
		if ( !gstrcmp(strEnabled, T("ON")))
			enabled = 1;
		else
			enabled = 0;

		if ( apmib_set( MIB_STATIC_DHCP_ENABLED, (void *)&enabled) == 0) {
  			DEBUGP(tmpBuf, T("Set enabled flag error!"));
			goto setErr_Pcdatabase;
		}

        strVal = websGetVar(wp, T("add_pc_name_pc_dba"), T(""));
        if ( strVal[0] ) {
            if (strlen(strVal) > MAX_NAME_LENGTH-1) {
                DEBUGP(tmpBuf, T("The Length of Host Name is too long."));
                goto setErr_Pcdatabase;
            }
            strcpy(entry.hostName, strVal);
        }
        else
            entry.hostName[0] = '\0';

		strVal = websGetVar(wp, T("wan_mac_pc_dba"), T(""));
		printf("mac=%s\n", strVal);
		if ( !strVal[0] ) {
			goto setErr_Pcdatabase;
		}
		if (strlen(strVal)!=12 || !string_to_hex(strVal, entry.macAddr, 12)) {
			DEBUGP(tmpBuf, T("Error! Invalid MAC address."));
			goto setErr_Pcdatabase;
		}

		printf("mac=%02x:%02x:%02x:%02x:%02x:%02x\n", entry.macAddr[0], entry.macAddr[1],entry.macAddr[2],entry.macAddr[3],entry.macAddr[4],entry.macAddr[5]);
		strVal = websGetVar(wp, T("ip"), T(""));
		printf("ip=%s\n", strVal);
		if (!strVal[0]) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspformFilterErrInput))</script>"));
			goto setErr_Pcdatabase;
		}

		fixed_inet_aton(strVal, entry.ipAddr);

		entry.groupIdx = atoi(groupIdx);

		printf("ip=%02x.%02x.%02x.%02x\n", entry.ipAddr[0], entry.ipAddr[1],entry.ipAddr[2],entry.ipAddr[3]);
		if ( !apmib_get(MIB_STATIC_DHCP_NUM, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("Get entry number error!"));
			goto setErr_Pcdatabase;
		}

		if ( (entryNum + 1) > MAX_STATIC_DHCP_NUM) {

			strcpy(tmpBuf, T("Cannot add new entry because table is full!"));
			goto setErr_Pcdatabase;
		}

		// set to MIB. try to delete it first to avoid duplicate case
		apmib_set(MIB_STATIC_DHCP_DEL, (void *)&entry);
		if ( apmib_set(MIB_STATIC_DHCP_ADD, (void *)&entry) == 0) {
			DEBUGP(tmpBuf, T("Add table entry error!"));
			goto setErr_Pcdatabase;
		}
	}

	//update single entry
	strUpate = websGetVar(wp, T("UPDATE"), T(""));
	//if (strUpate[0]) {
	if ( !gstrcmp(strAction, T("UPDATE"))){
		if ( !apmib_get(MIB_STATIC_DHCP_NUM, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("Get entry number error!"));
			goto setErr_Pcdatabase;
		}

		if ( !gstrcmp(strEnabled, T("ON")))
			enabled = 1;
		else
			enabled = 0;

		if ( apmib_set( MIB_STATIC_DHCP_ENABLED, (void *)&enabled) == 0) {
			DEBUGP(tmpBuf, T("Set enabled flag error!"));
			goto setErr_Pcdatabase;
		}

		strVal = websGetVar(wp, T("add_pc_name_pc_dba"), T(""));
		if ( strVal[0] ) {
			if (strlen(strVal) > MAX_NAME_LENGTH-1) {
				DEBUGP(tmpBuf, T("The Length of Host Name is too long."));
				goto setErr_Pcdatabase;
			}
			strcpy(entry.hostName, strVal);
		}
		else
			entry.hostName[0] = '\0';

		strVal = websGetVar(wp, T("wan_mac_pc_dba"), T(""));
		printf("mac=%s\n", strVal);
		if ( !strVal[0] ) {
			goto setErr_Pcdatabase;
		}
		if (strlen(strVal)!=12 || !string_to_hex(strVal, entry.macAddr, 12)) {
			DEBUGP(tmpBuf, T("Error! Invalid MAC address."));
			goto setErr_Pcdatabase;
		}

		printf("mac=%02x:%02x:%02x:%02x:%02x:%02x\n", entry.macAddr[0], entry.macAddr[1],entry.macAddr[2],entry.macAddr[3],entry.macAddr[4],entry.macAddr[5]);
		strVal = websGetVar(wp, T("ip"), T(""));
		printf("ip=%s\n", strVal);
		if (!strVal[0]) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspformFilterErrInput))</script>"));
			goto setErr_Pcdatabase;
		}

		fixed_inet_aton(strVal, entry.ipAddr);

		entry.groupIdx = atoi(groupIdx);

		printf("ip=%02x.%02x.%02x.%02x\n", entry.ipAddr[0], entry.ipAddr[1],entry.ipAddr[2],entry.ipAddr[3]);
		if ( !apmib_get(MIB_STATIC_DHCP_NUM, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("Get entry number error!"));
			goto setErr_Pcdatabase;
		}

		//do update
		strVal = websGetVar(wp, "sidx", T(""));
		intVal = atoi(strVal);
		*((char *)&orgEntry) = (char)intVal;

		if ( !apmib_get( MIB_STATIC_DHCP, (void *)&orgEntry)) {
			DEBUGP(tmpBuf, T("Get original entry error!"));
			goto setErr_Pcdatabase;
		}
		Edit.selEntry = (char *)&orgEntry;
		Edit.editEntry = (char *)&entry;

		if ( !apmib_set(MIB_STATIC_DHCP_EDIT, (void *)&Edit)) {
			DEBUGP(tmpBuf, T("Update table entry error!"));
			goto setErr_Pcdatabase;
		}
	}

	//delete single entry
	strDelMac = websGetVar(wp, T("deleteSelDhcpMac"), T(""));
	if (strDelMac[0]) {
		if ( !apmib_get(MIB_STATIC_DHCP_NUM, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("Get entry number error!"));
			goto setErr_Pcdatabase;
		}

		for (i=entryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "%d", i);

			strVal = websGetVar(wp, "sidx", T(""));
			if ( !gstrcmp(strVal, T(tmpBuf)) ) {

				*((char *)&entry) = (char)i;
				if ( !apmib_get(MIB_STATIC_DHCP, (void *)&entry)) {
					DEBUGP(tmpBuf, T("Get table entry error!"));
					goto setErr_Pcdatabase;
				}
				if ( !apmib_set(MIB_STATIC_DHCP_DEL, (void *)&entry)) {
					DEBUGP(tmpBuf, T("Delete table entry error!"));
					goto setErr_Pcdatabase;
				}
			}
		}
	}

	apmib_update(CURRENT_SETTING);
    OK_MSG(submitUrl);
    return;
setErr_Pcdatabase:
	ERR_MSG(tmpBuf);
    return;
}

int groupList(int eid, webs_t wp, int argc, char_t **argv)
{
	int val, nBytesSent=0;
    unsigned char buffer[100];

	if (!apmib_get( MIB_GROUP1_DISABLED, (void *)&val) ){
		goto setErr_groupList;
	}else{
		nBytesSent += websWrite(wp, "var group1Disable = %d;\n", val);
	}

    if (!apmib_get( MIB_GROUP1,  (void *)buffer)){
		goto setErr_groupList;
	}else{
		if (buffer[0] == NULL){
			nBytesSent += websWrite(wp, "var hrStartTbl1 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
			nBytesSent += websWrite(wp, "var minStartTbl1 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
			nBytesSent += websWrite(wp, "var hrFinishTbl1 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
			nBytesSent += websWrite(wp, "var minFinishTbl1 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
		}else{
			nBytesSent += websWrite(wp, "var hrStartTbl1 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[1],buffer[2],
				buffer[10],buffer[11],buffer[19],buffer[20],buffer[28],buffer[29],
				buffer[37],buffer[38],buffer[46],buffer[47],buffer[55],buffer[56]);
			nBytesSent += websWrite(wp,");\n");

			nBytesSent += websWrite(wp, "var minStartTbl1 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[3],buffer[4],
				buffer[12],buffer[13],buffer[21],buffer[22],buffer[30],buffer[31],
				buffer[39],buffer[40],buffer[48],buffer[49],buffer[57],buffer[58]);
			nBytesSent += websWrite(wp,");\n");

			nBytesSent += websWrite(wp, "var hrFinishTbl1 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[5],buffer[6],
				buffer[14],buffer[15],buffer[23],buffer[24],buffer[32],buffer[33],
				buffer[41],buffer[42],buffer[50],buffer[51],buffer[59],buffer[60]);
			nBytesSent += websWrite(wp,");\n");

			nBytesSent += websWrite(wp, "var minFinishTbl1 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[7],buffer[8],
				buffer[16],buffer[17],buffer[25],buffer[26],buffer[34],buffer[35],
				buffer[43],buffer[44],buffer[52],buffer[53],buffer[61],buffer[62]);
			nBytesSent += websWrite(wp,");\n");
		}
    }

	if (!apmib_get( MIB_GROUP2_DISABLED, (void *)&val) ){
		goto setErr_groupList;
	}else{
		nBytesSent += websWrite(wp, "var group2Disable = %d;\n", val);
	}

    if (!apmib_get( MIB_GROUP2,  (void *)buffer)){
		goto setErr_groupList;
	}else{
		if (buffer[0] == NULL){
			nBytesSent += websWrite(wp, "var hrStartTbl2 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
			nBytesSent += websWrite(wp, "var minStartTbl2 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
			nBytesSent += websWrite(wp, "var hrFinishTbl2 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
			nBytesSent += websWrite(wp, "var minFinishTbl2 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
		}else{
			nBytesSent += websWrite(wp, "var hrStartTbl2 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[1],buffer[2],
				buffer[10],buffer[11],buffer[19],buffer[20],buffer[28],buffer[29],
				buffer[37],buffer[38],buffer[46],buffer[47],buffer[55],buffer[56]);
			nBytesSent += websWrite(wp,");\n");

			nBytesSent += websWrite(wp, "var minStartTbl2 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[3],buffer[4],
				buffer[12],buffer[13],buffer[21],buffer[22],buffer[30],buffer[31],
				buffer[39],buffer[40],buffer[48],buffer[49],buffer[57],buffer[58]);
			nBytesSent += websWrite(wp,");\n");

			nBytesSent += websWrite(wp, "var hrFinishTbl2 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[5],buffer[6],
				buffer[14],buffer[15],buffer[23],buffer[24],buffer[32],buffer[33],
				buffer[41],buffer[42],buffer[50],buffer[51],buffer[59],buffer[60]);
			nBytesSent += websWrite(wp,");\n");

			nBytesSent += websWrite(wp, "var minFinishTbl2 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[7],buffer[8],
				buffer[16],buffer[17],buffer[25],buffer[26],buffer[34],buffer[35],
				buffer[43],buffer[44],buffer[52],buffer[53],buffer[61],buffer[62]);
			nBytesSent += websWrite(wp,");\n");
		}
    }

	if (!apmib_get( MIB_GROUP3_DISABLED, (void *)&val) ){
		goto setErr_groupList;
	}else{
		nBytesSent += websWrite(wp, "var group3Disable = %d;\n", val);
	}

    if (!apmib_get( MIB_GROUP3,  (void *)buffer)){
		goto setErr_groupList;
	}else{
		if (buffer[0] == NULL){
			nBytesSent += websWrite(wp, "var hrStartTbl3 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
			nBytesSent += websWrite(wp, "var minStartTbl3 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
			nBytesSent += websWrite(wp, "var hrFinishTbl3 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
			nBytesSent += websWrite(wp, "var minFinishTbl3 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
		}else{
			nBytesSent += websWrite(wp, "var hrStartTbl3 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[1],buffer[2],
				buffer[10],buffer[11],buffer[19],buffer[20],buffer[28],buffer[29],
				buffer[37],buffer[38],buffer[46],buffer[47],buffer[55],buffer[56]);
			nBytesSent += websWrite(wp,");\n");

			nBytesSent += websWrite(wp, "var minStartTbl3 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[3],buffer[4],
				buffer[12],buffer[13],buffer[21],buffer[22],buffer[30],buffer[31],
				buffer[39],buffer[40],buffer[48],buffer[49],buffer[57],buffer[58]);
			nBytesSent += websWrite(wp,");\n");

			nBytesSent += websWrite(wp, "var hrFinishTbl3 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[5],buffer[6],
				buffer[14],buffer[15],buffer[23],buffer[24],buffer[32],buffer[33],
				buffer[41],buffer[42],buffer[50],buffer[51],buffer[59],buffer[60]);
			nBytesSent += websWrite(wp,");\n");

			nBytesSent += websWrite(wp, "var minFinishTbl3 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[7],buffer[8],
				buffer[16],buffer[17],buffer[25],buffer[26],buffer[34],buffer[35],
				buffer[43],buffer[44],buffer[52],buffer[53],buffer[61],buffer[62]);
			nBytesSent += websWrite(wp,");\n");
		}
    }

	if (!apmib_get( MIB_GROUP4_DISABLED, (void *)&val) ){
		goto setErr_groupList;
	}else{
		nBytesSent += websWrite(wp, "var group4Disable = %d;\n", val);
	}

    if (!apmib_get( MIB_GROUP4,  (void *)buffer)){
		goto setErr_groupList;
	}else{
		if (buffer[0] == NULL){
			nBytesSent += websWrite(wp, "var hrStartTbl4 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
			nBytesSent += websWrite(wp, "var minStartTbl4 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
			nBytesSent += websWrite(wp, "var hrFinishTbl4 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
			nBytesSent += websWrite(wp, "var minFinishTbl4 = new Array (");
			nBytesSent += websWrite(wp, "\"0\",\"0\",\"0\",\"0\",\"0\",\"0\",\"0\"");
			nBytesSent += websWrite(wp,");\n");
		}else{
			nBytesSent += websWrite(wp, "var hrStartTbl4 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[1],buffer[2],
				buffer[10],buffer[11],buffer[19],buffer[20],buffer[28],buffer[29],
				buffer[37],buffer[38],buffer[46],buffer[47],buffer[55],buffer[56]);
			nBytesSent += websWrite(wp,");\n");

			nBytesSent += websWrite(wp, "var minStartTbl4 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[3],buffer[4],
				buffer[12],buffer[13],buffer[21],buffer[22],buffer[30],buffer[31],
				buffer[39],buffer[40],buffer[48],buffer[49],buffer[57],buffer[58]);
			nBytesSent += websWrite(wp,");\n");

			nBytesSent += websWrite(wp, "var hrFinishTbl4 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[5],buffer[6],
				buffer[14],buffer[15],buffer[23],buffer[24],buffer[32],buffer[33],
				buffer[41],buffer[42],buffer[50],buffer[51],buffer[59],buffer[60]);
			nBytesSent += websWrite(wp,");\n");

			nBytesSent += websWrite(wp, "var minFinishTbl4 = new Array (");
			nBytesSent += websWrite(wp, "\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\",\"%c%c\"",
				buffer[7],buffer[8],
				buffer[16],buffer[17],buffer[25],buffer[26],buffer[34],buffer[35],
				buffer[43],buffer[44],buffer[52],buffer[53],buffer[61],buffer[62]);
			nBytesSent += websWrite(wp,");\n");
		}
    }

	return nBytesSent;
setErr_groupList:
	return nBytesSent;
}

int pcDatabaseList(int eid, webs_t wp, int argc, char_t **argv)
{
//	#define NO_ACTION

	#define MAX_DEVICE_NUM 255
	#define MAX_NAME_LENGTH 21

	int nBytesSent=0;

	int entryNum;
	SDHCP_T entry;
	char *ip;

	struct stat status;
	struct in_addr intaddr;

	FILE *fp, *fp1, *fp2, *fp3;
	char *local_ip, mask_ip[20];

	int  pccount = 0;
	char pcname[MAX_DEVICE_NUM][MAX_NAME_LENGTH];
	char Customerpaddr[MAX_DEVICE_NUM][16];
	char pcmacaddr[MAX_DEVICE_NUM][13];
	int  pclantype[MAX_DEVICE_NUM];
	int  Customerptype[MAX_DEVICE_NUM];
	int  pcgid[MAX_DEVICE_NUM];
	int  pcsidx[MAX_DEVICE_NUM]; //static ip record index

	char devicename[MAX_DEVICE_NUM][MAX_NAME_LENGTH];
	char ipaddr1[MAX_DEVICE_NUM][16];
	char macaddr1[MAX_DEVICE_NUM][13];
	int  devicetype[MAX_DEVICE_NUM];

	int  ret;
	char ipAddr[40], macAddr[40], liveTime[80];
	char devicename1[MAX_NAME_LENGTH];
	unsigned long longVal;

	char *buf=NULL, *ptr;
	char tmp[20], tmpBuf[100], tmpBuf1[100], tmpBuf2[100], tmpBuf3[100];
	char buf77[100];

	int pid;
	int i, j, k, count, nbtcount;
	int io[MAX_DEVICE_NUM]; //count duplicate record
	int isDup;

	WLAN_STA_INFO_T *pInfo;
	char wlmacaddr[MAX_DEVICE_NUM][13];
	char *buff;
	int wlcount=0;

//get wireless client list
	buff = calloc(1, sizeof(WLAN_STA_INFO_T));
	if ( buff == 0 ) {
		printf("Allocate buffer failed!");
		return 0;
	}

	if ( getWlStaInfo(WLAN_IF,  (WLAN_STA_INFO_Tp)buff ) < 0 ) {
		printf("Read wlan sta info failed!");
		return 0;
	}
	pInfo = (WLAN_STA_INFO_T *)buff;

	for (i=0; i<pInfo->Num ; i++) {
		if (pInfo->Entry[i].Aid){
			snprintf(tmpBuf, 100, T("%02x%02x%02x%02x%02x%02x"),
				pInfo->Entry[i].Addr[0],pInfo->Entry[i].Addr[1],pInfo->Entry[i].Addr[2],
				pInfo->Entry[i].Addr[3],pInfo->Entry[i].Addr[4],pInfo->Entry[i].Addr[5]);
			strcpy(wlmacaddr[wlcount], tmpBuf);
			wlcount++;
		}
	}

	//if (wlcount == 0) {
	//}

	free(buff);

//get mask ip
	apmib_get( MIB_IP_ADDR,  (void *)&intaddr);
	local_ip=inet_ntoa(intaddr);
	strcpy( tmp, local_ip);
	i=0;j=0;
	while(i<3)
	{
		if(tmp[j] == '.') i=i+1;
		j=j+1;
	}
	tmp[j]='\0';
	strcpy( mask_ip, tmp);

#ifndef NO_ACTION
	// get nbtscan data
	system("/bin/ez1.sh");
	fp1=fopen("/tmp/nbtname","r");
	fp2=fopen("/tmp/nbtip","r");
	fp3=fopen("/tmp/nbtmac","r");

	count=0;
	while(  fgets(tmpBuf1, 100, fp1) > 0  &&  fgets(tmpBuf2, 100, fp2) > 0  &&  fgets(tmpBuf3, 100, fp3) > 0  )
	{
		if( strcmp(tmpBuf2, local_ip)!=0 )
		{
			strcpy( devicename[count], tmpBuf1 );
			sstrip( devicename[count], MAX_NAME_LENGTH);

			strcpy( ipaddr1[count], tmpBuf2 );
			sstrip( ipaddr1[count], 16);

			strcpy( macaddr1[count], tmpBuf3);
			sstrip( macaddr1[count], 13);

			devicetype[count]=4; //in ezview.js, var resolvetypeTbl=new Array("nas","cam","game","ps","user","pserver","what","ap");

			io[count]=0; //count duplicate record

			count += 1;
		}
	}
	fclose(fp1);
	fclose(fp2);
	fclose(fp3);
	nbtcount=count;

	// after all, use << arp mac >> replace << mac get from ezview tag or usn >>, so arp will be last result
	for(i=0;i<count;i++)
	{
		sprintf(tmpBuf1, "cat /proc/net/arp | grep \'%s\'| cut -b42-59  > /tmp/ezarp", ipaddr1[i]);
		system(tmpBuf1);
		fp1=fopen("/tmp/ezarp","r");
		if (fgets(buf77, 100, fp1) > 0 && strncmp(buf77,"00:00:00:00:00:00",17)!=0)
		{
			macaddr1[i][0]=tolower(buf77[0]);
			macaddr1[i][1]=tolower(buf77[1]);
			macaddr1[i][2]=tolower(buf77[3]);
			macaddr1[i][3]=tolower(buf77[4]);
			macaddr1[i][4]=tolower(buf77[6]);
			macaddr1[i][5]=tolower(buf77[7]);
			macaddr1[i][6]=tolower(buf77[9]);
			macaddr1[i][7]=tolower(buf77[10]);
			macaddr1[i][8]=tolower(buf77[12]);
			macaddr1[i][9]=tolower(buf77[13]);
			macaddr1[i][10]=tolower(buf77[15]);
			macaddr1[i][11]=tolower(buf77[16]);
			macaddr1[i][12]='\0';
		}
		fclose(fp1);
	}
#endif

	//get Static DHCP Leases
		if ( !apmib_get(MIB_STATIC_DHCP_NUM, (void *)&entryNum)) {
	  		websError(wp, 400, T("Get table entry error!\n"));
			return -1;
		}

		for (k=1; k<=entryNum; k++) {
			*((char *)&entry) = (char)k;
			if ( !apmib_get(MIB_STATIC_DHCP, (void *)&entry))
				return -1;

			snprintf(tmpBuf, 100, T("%02x%02x%02x%02x%02x%02x"),
				entry.macAddr[0], entry.macAddr[1], entry.macAddr[2],
				entry.macAddr[3], entry.macAddr[4], entry.macAddr[5]);
			strcpy(pcmacaddr[pccount], tmpBuf);

			ip = fixed_inet_ntoa(entry.ipAddr);
			if ( !strcmp(ip, "0.0.0.0"))
				ip = "----";
			strcpy(Customerpaddr[pccount], ip);

			if (strcmp(entry.hostName,""))
				strcpy(pcname[pccount], entry.hostName);
			else
				strcpy(pcname[pccount], "----");

			pcgid[pccount] = entry.groupIdx;

			pclantype[pccount]= 0; //unknown

			strcpy(tmp, ip);
			i=0;j=0;
			while(i<3)
			{
				if(tmp[j] == '.') i=i+1;
				j=j+1;
			}
			tmp[j]='\0';

			if (!strcmp(mask_ip, tmp))
				Customerptype[pccount] = 1; //Reserved
			else
				Customerptype[pccount] = 2; //Fixed

			pcsidx[pccount] = k;

			//check if already in nbtscan result
			for (i=0; i < count; i++)
			{
				if( !strcmp(macaddr1[i], pcmacaddr[pccount]) && !strcmp(ipaddr1[i], Customerpaddr[pccount]) )
				{
					io[i]=2;
					pclantype[pccount]= 1; //LAN
				}
			}

			//check if wireless LAN
			for (i=0; i < wlcount; i++)
			{
				if( !strcmp(wlmacaddr[i], pcmacaddr[pccount]))
				{
					pclantype[pccount]= 2; //Wireless
				}
			}

			pccount++;
		}

	#ifndef NO_ACTION
	//get DHCP Leases
		// siganl DHCP server to update lease file
		snprintf(tmpBuf, 100, "%s/%s.pid", _DHCPD_PID_PATH, _DHCPD_PROG_NAME);
		pid = getPid(tmpBuf);
		if ( pid > 0) kill(pid, SIGUSR1);
		usleep(1000);
		if ( stat(_PATH_DHCPS_LEASES, &status) < 0 ) goto noDhcpLeases;

		buf = malloc(status.st_size);
		if ( buf == NULL ) goto pcDatabaseList;
		fp = fopen(_PATH_DHCPS_LEASES, "r");
		if ( fp == NULL ) goto pcDatabaseList;

		fread(buf, 1, status.st_size, fp);
		fclose(fp);
		ptr = buf;

		while (1) {
			ret = getOneDhcpClient(&ptr, &status.st_size, ipAddr, macAddr, liveTime);
			if (ret < 0) break;
			if (ret == 0) continue;

			longVal=strtoul(liveTime, NULL, 0);
			if (longVal > 2000000) sprintf(liveTime, "%s", "forever");

			//check if already in nbtscan result and get devicename
			strcpy( devicename1, "----");
			for (i=0; i < count; i++)
			{
				tmpBuf2[0]=macAddr[0];
				tmpBuf2[1]=macAddr[1];
				tmpBuf2[2]=macAddr[3];
				tmpBuf2[3]=macAddr[4];
				tmpBuf2[4]=macAddr[6];
				tmpBuf2[5]=macAddr[7];
				tmpBuf2[6]=macAddr[9];
				tmpBuf2[7]=macAddr[10];
				tmpBuf2[8]=macAddr[12];
				tmpBuf2[9]=macAddr[13];
				tmpBuf2[10]=macAddr[15];
				tmpBuf2[11]=macAddr[16];
				tmpBuf2[12]='\0';

				if( !strcmp(macaddr1[i], tmpBuf2) && !strcmp(ipaddr1[i], ipAddr) )
				{
					strcpy(devicename1, devicename[i]);
					io[i]=1;
				}
			}

			macAddr[2]=macAddr[3];
			macAddr[3]=macAddr[4];
			macAddr[4]=macAddr[6];
			macAddr[5]=macAddr[7];
			macAddr[6]=macAddr[9];
			macAddr[7]=macAddr[10];
			macAddr[8]=macAddr[12];
			macAddr[9]=macAddr[13];
			macAddr[10]=macAddr[15];
			macAddr[11]=macAddr[16];
			macAddr[12]='\0';

			//add DHCP leases which not in SDHCP
			isDup = 0;
			for(j=0; j<pccount; j++)
			{
				if(!strcmp(Customerpaddr[j], ipAddr))
				{
					isDup = 1;
				}
				if(!strcmp(pcmacaddr[j], macAddr))
				{
					isDup = 1;
				}
			}

			if(!isDup){
				strcpy(pcname[pccount], devicename1);
				strcpy(Customerpaddr[pccount], ipAddr);
				strcpy(pcmacaddr[pccount], macAddr);
				pclantype[pccount]= 0; //Unknown
				Customerptype[pccount] = 0; //DHCP
				pcgid[pccount] = 0;
				pcsidx[pccount] = -1;

				//check if already in nbtscan result
				for (i=0; i < count; i++)
				{
					if( !strcmp(macAddr, pcmacaddr[pccount]) && !strcmp(ipAddr, Customerpaddr[pccount]) )
					{
						pclantype[pccount]= 1; //LAN
					}
				}

				//check if wireless LAN
				for (i=0; i < wlcount; i++)
				{
					if( !strcmp(wlmacaddr[i], macAddr))
					{
						pclantype[pccount]= 2; //Wireless
					}
				}

				pccount++;
			}
		}
	#endif
	noDhcpLeases:

		//add nbtscan result which not in DHCP leases
	#if 0
		for (i=0; i < count ; i++)
		{
			if( io[i]==0 && strcmp(ipaddr1[i],inet_ntoa(intaddr)) && strcmp(ipaddr1[i],"") && strcmp(macaddr1[i],"") )
			{
				strcpy(pcname[pccount], devicename[i]);
				strcpy(Customerpaddr[pccount], ipaddr1[i]);
				strcpy(pcmacaddr[pccount], macaddr1[i]);
				pclantype[pccount]= 0; //wired
				Customerptype[pccount] = 3; //NBTscan
				pcgid[pccount] = 0;
				pcsidx[pccount] = -1;

				pccount++;
			}
		}
	#endif

		//generate javascript
		nBytesSent += websWrite(wp, "var mask_ip = \"%s\";\n", mask_ip);

		nBytesSent += websWrite(wp, "var pcnameTbl = new Array (");
		for(j=0;j<pccount;j++) nBytesSent += websWrite(wp, "\"%s\",", pcname[j]);
		nBytesSent += websWrite(wp,"\"\");\n");

		nBytesSent += websWrite(wp, "var CustomerpaddrTbl = new Array (");
		for(j=0;j<pccount;j++) nBytesSent += websWrite(wp, "\"%s\",", Customerpaddr[j]);
		nBytesSent += websWrite(wp,"\"\");\n");

		nBytesSent += websWrite(wp, "var pcmacTbl = new Array (");
		for(j=0;j<pccount;j++) nBytesSent += websWrite(wp, "\"%s\",", pcmacaddr[j]);
		nBytesSent += websWrite(wp,"\"\");\n");

		nBytesSent += websWrite(wp, "var pclantypeTbl = new Array (");
		for(j=0;j<pccount;j++) nBytesSent += websWrite(wp, "\"%d\",", pclantype[j]);
		nBytesSent += websWrite(wp,"\"\");\n");

		nBytesSent += websWrite(wp, "var CustomerptypeTbl = new Array (");
		for(j=0;j<pccount;j++) nBytesSent += websWrite(wp, "\"%d\",", Customerptype[j]);
		nBytesSent += websWrite(wp,"\"\");\n");

		nBytesSent += websWrite(wp, "var pcgidTbl = new Array (");
		for(j=0;j<pccount;j++) nBytesSent += websWrite(wp, "\"%d\",", pcgid[j]);
		nBytesSent += websWrite(wp,"\"\");\n");

		nBytesSent += websWrite(wp, "var pcsidxTbl = new Array (");
		for(j=0;j<pccount;j++) nBytesSent += websWrite(wp, "\"%d\",", pcsidx[j]);
		nBytesSent += websWrite(wp,"\"\");\n");

		nBytesSent += websWrite(wp, "var nbtnameTbl = new Array (");
		for(j=0;j<count;j++) nBytesSent += websWrite(wp, "\"%s\",", devicename[j]);
		nBytesSent += websWrite(wp,"\"\");\n");

		nBytesSent += websWrite(wp, "var nbtipTbl = new Array (");
		for(j=0;j<count;j++) nBytesSent += websWrite(wp, "\"%s\",", ipaddr1[j]);
		nBytesSent += websWrite(wp,"\"\");\n");

		nBytesSent += websWrite(wp, "var nbtmacTbl = new Array (");
		for(j=0;j<count;j++) nBytesSent += websWrite(wp, "\"%s\",", macaddr1[j]);
		nBytesSent += websWrite(wp,"\"\");\n");

		nBytesSent += websWrite(wp, "var nbtioTbl = new Array (");
		for(j=0;j<count;j++) nBytesSent += websWrite(wp, "\"%d\",", io[j]);
		nBytesSent += websWrite(wp,"\"\");\n");

		return nBytesSent;
	pcDatabaseList:
		if (pccount == 0) {
			nBytesSent += websWrite(wp, "var pcnameTbl = new Array (\"\");\n");
			nBytesSent += websWrite(wp, "var CustomerpaddrTbl = new Array (\"\");\n");
			nBytesSent += websWrite(wp, "var pcmacTbl = new Array (\"\");\n");
			nBytesSent += websWrite(wp, "var pclantypeTbl = new Array (\"\");\n");
			nBytesSent += websWrite(wp, "var pcgidTbl = new Array (\"\");\n");
			nBytesSent += websWrite(wp, "var CustomerptypeTbl = new Array (\"\");\n");
			nBytesSent += websWrite(wp, "var pcsidxTbl = new Array (\"\");\n");
		}

		if (count == 0) {
			nBytesSent += websWrite(wp, "var nbtnameTbl = new Array (\"\");\n");
			nBytesSent += websWrite(wp, "var nbtipTbl = new Array (\"\");\n");
			nBytesSent += websWrite(wp, "var nbtmacTbl = new Array (\"\");\n");
			nBytesSent += websWrite(wp, "var nbtioTbl = new Array (\"\");\n");
		}

		if (buf)
			free(buf);
		return nBytesSent;
}
#endif
	/////////////////////////////////////////////////////////////////////////////
#ifdef _CONNECTION_CTRL_
void formConnectionCtrlSet(webs_t wp, char_t *path, char_t *query)
{
	char_t *strConnectCtrlEnabled, *submitUrl, *strApply;
	char_t *srtMaxConnecCount, *strMaxUDPConnecCount, *strMaxICMPConnecCount, *strMaxTCPConnecCount;
	char_t *strTimeoutEstablished, *strTimeoutSynSent, *strTimeoutSynRecv;
	char_t *strTimeoutFinWait, *strTimeoutCloseWait, *strTimeoutLastAck, *strTimeoutGeneric;
	int intVal;

	strConnectCtrlEnabled = websGetVar(wp, T("connectCtlEnabled"), T(""));
	srtMaxConnecCount     = websGetVar(wp, T("MaxConnecCount"), T(""));
	strMaxUDPConnecCount  = websGetVar(wp, T("MaxUDPConnecCount"), T(""));
	strMaxICMPConnecCount = websGetVar(wp, T("MaxICMPConnecCount"), T(""));
	strMaxTCPConnecCount = websGetVar(wp, T("MaxTCPConnecCount"), T(""));
	strTimeoutEstablished = websGetVar(wp, T("TimeoutEstablished"), T(""));
	strTimeoutSynSent     = websGetVar(wp, T("TimeoutSynSent"), T(""));
	strTimeoutSynRecv     = websGetVar(wp, T("TimeoutSynRecv"), T(""));
	strTimeoutFinWait     = websGetVar(wp, T("TimeoutFinWait"), T(""));
	strTimeoutCloseWait   = websGetVar(wp, T("TimeoutCloseWait"), T(""));
	strTimeoutLastAck     = websGetVar(wp, T("TimeoutLastAck"), T(""));
	strTimeoutGeneric     = websGetVar(wp, T("TimeoutGeneric"), T(""));

	if (strConnectCtrlEnabled[0]){
			if ( !gstrcmp(strConnectCtrlEnabled, T("ON")))
				intVal = 1;
			else
			   intVal = 0;
			if ( !apmib_set(MIB_CONNECTIONCTRL_ENABLED, (void *)&intVal))
			{
			  		websError(wp, 400, T("Set connection control error!\n"));
					return -1;
			}
	}

	if (srtMaxConnecCount[0]){
		intVal = atoi(srtMaxConnecCount);
		if ( !apmib_set(MIB_CONNECCOUNT_MAX, (void *)&intVal))
		{
		  		websError(wp, 400, T("Set Max Connection Count error!\n"));
				return -1;
		}
	}

	if (strMaxUDPConnecCount[0]){
		intVal = atoi(strMaxUDPConnecCount);
		if ( !apmib_set(MIB_UDPCOUNT_MAX, (void *)&intVal))
		{
		  		websError(wp, 400, T("Set Max Connection Count error!\n"));
				return -1;
		}
	}

	if (strMaxICMPConnecCount[0]){
		intVal = atoi(strMaxICMPConnecCount);
		if ( !apmib_set(MIB_ICMPCOUNT_MAX, (void *)&intVal))
		{
		  		websError(wp, 400, T("Set Max Connection Count error!\n"));
				return -1;
		}
	}

	if (strMaxTCPConnecCount[0]){
		intVal = atoi(strMaxTCPConnecCount);

		if ( !apmib_set(MIB_TCPCOUNT_MAX, (void *)&intVal))
		{
		  		websError(wp, 400, T("Set Max Connection Count error!\n"));
				return -1;
		}
	}


	if (strTimeoutEstablished[0]){
		intVal = atoi(strTimeoutEstablished);
		if ( !apmib_set(MIB_TIMEOUT_ESTABLISHED, (void *)&intVal))
		{
		  		websError(wp, 400, T("Set Timeout Established error!\n"));
				return -1;
		}
	}

	if (strTimeoutSynSent[0]){
		intVal = atoi(strTimeoutSynSent);
		if ( !apmib_set(MIB_TIMEOUT_SYNSENT, (void *)&intVal))
		{
		  		websError(wp, 400, T("Set Timeout SynSent error!\n"));
				return -1;
		}
	}

	if (strTimeoutSynRecv[0]){
		intVal = atoi(strTimeoutSynRecv);
		if ( !apmib_set(MIB_TIMEOUT_SYNRECV, (void *)&intVal))
		{
		  		websError(wp, 400, T("Set Timeout SynRecv error!\n"));
				return -1;
		}
	}

	if (strTimeoutFinWait[0]){
		intVal = atoi(strTimeoutFinWait);
		if ( !apmib_set(MIB_TIMEOUT_FINWAIT, (void *)&intVal))
		{
		  		websError(wp, 400, T("Set Timeout FinWait error!\n"));
				return -1;
		}
	}

	if (strTimeoutCloseWait[0]){
		intVal = atoi(strTimeoutCloseWait);
		if ( !apmib_set(MIB_TIMEOUT_CLOSEWAIT, (void *)&intVal))
		{
		  		websError(wp, 400, T("Set Timeout CloseWait error!\n"));
				return -1;
		}
	}

	if (strTimeoutLastAck[0]){
		intVal = atoi(strTimeoutLastAck);
		if ( !apmib_set(MIB_TIMEOUT_LASTACK, (void *)&intVal))
		{
		  		websError(wp, 400, T("Set Timeout LastAck error!\n"));
				return -1;
		}
	}

	if (strTimeoutGeneric[0]){
		intVal = atoi(strTimeoutGeneric);
		if ( !apmib_set(MIB_TIMEOUT_GENERIC, (void *)&intVal))
		{
		  		websError(wp, 400, T("Set Timeout Generic error!\n"));
				return -1;
		}
	}

	apmib_update(CURRENT_SETTING);

	submitUrl = websGetVar(wp, T("submit-url"),T(""));
	strApply = websGetVar(wp, T("isApply"), T(""));

	if (strApply[0]) {
		OK_MSG(submitUrl);
	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}
	return;
}
#endif

#ifdef _CONNECTION_INFO_

struct ConnectCount{
        char *IP;
        unsigned long Packets_TX;
        unsigned long Packets_RX;
        unsigned long Bytes_TX;
        unsigned long Bytes_RX;
        int TCP_Current;
        int UDP_Current;
        int ICMP_Current;
        int unKnown_Current;
        struct ConnectCount *pre;
        struct ConnectCount *next;
};
typedef struct ConnectCount *ConnectCountPtr;

ConnectCountPtr getConnectCurrent(void)
{
        ConnectCountPtr NewPtr = (ConnectCountPtr)malloc(sizeof(struct ConnectCount));
        NewPtr->IP = NULL;
        NewPtr->Packets_TX = NULL;
        NewPtr->Packets_RX = NULL;
        NewPtr->Bytes_TX = NULL;
        NewPtr->Bytes_RX = NULL;
        NewPtr->TCP_Current = NULL;
        NewPtr->UDP_Current = NULL;
        NewPtr->ICMP_Current = NULL;
        NewPtr->unKnown_Current = NULL;
        NewPtr->pre = NULL;
        NewPtr->next = NULL;

        return NewPtr;
}
/*
ConnectCountPtr checkIP(ConnectCountPtr checkIP){
	ConnectCountPtr tmp;
	if (checkIP->pre == NULL)
		return checkIP;
	}
	if (strstr(checkIP->IP,checkIP->pre->IP)){
		checkIP->pre->Packets_TX += checkIP->Packets_TX;
		checkIP->pre->Packets_RX += checkIP->Packets_RX;
		checkIP->pre->Bytes_TX += checkIP->Bytes_TX;
		checkIP->pre->Bytes_RX += checkIP->Bytes_RX;
		checkIP->pre->TCP_Current += checkIP->TCP_Current;
		checkIP->pre->UDP_Current += checkIP->UDP_Current;
		checkIP->pre->ICMP_Current += checkIP->ICMP_Current;
		checkIP->pre->unKnown_Currentt += checkIP->unKnown_Currentt;
		tmp = checkIP->pre;
		tmp->next = NULL;
		free(checkIP);
		return tmp;
	}else{
		newIP = getConnectCurrent();
		newIP = checkIP;
		return newIP;
	}
	return checkIP;
}

*/
static unsigned long parese_ip(char *ptr)
{
	char *string_ip = strchr(ptr, '=');
	if (!string_ip++) return 0;
	return inet_addr(string_ip);
}

static int parese_value(char *ptr)
{
	char *string_value = strchr(ptr, '=');
	int intval;
	if (!string_value++) return 0;
	intval = atoi(string_value);
	return intval;
}

int formConnectInfoList(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent = 0;
	unsigned long Totaltcp = 20,Totalicmp = 12,Totaludp = 23,Totalunknown = 10,TotalPtx = 200,TotalPrx = 220,TotalBtx = 50,TotalBrx = 10;
	int i=0,j,k;

   static int istype = 1;
   static int isIP = 1;
   static int isPacket = 2;
   static int isBytes = 2;
   static int isUse = 1;

	char_t *filename = "/tmp/ConnectInfo.dat";
	char StringBuf[100];
	char sfilter[] = " \t\n";
	char *tok = NULL;
	FILE *fp;
	struct sockaddr_in *aa;
	ConnectCountPtr head=NULL,temp=NULL,tail=NULL;
	head = getConnectCurrent();
	tail = head;


	system("cat /proc/net/nf_conntrack > /tmp/ConnectInfo.dat");
	fp = fopen(filename,"r");
	if (!fp) goto ConnectInfoNull;

	temp = head;
	while( fgets(StringBuf, 100, fp) > 0 )
	{
		tok = strtok( StringBuf, sfilter );
		while(tok){
			//while(isUse){
				while(istype){
					if (strstr(tok,"udp")){
					  temp->TCP_Current+=1;
				  	  istype = 0;
					}
					else if (strstr(tok,"tcp")){
					  temp->UDP_Current+=1;
				  	  istype = 0;
					}
					else if (strstr(tok,"icmp")){
					  temp->ICMP_Current+=1;
				  	  istype = 0;
					}
					else{
					  temp->unKnown_Current+=1;
				  	  istype = 0;
					}
					printf("istype=%d\n",istype);
					tok = strtok( NULL, sfilter );
				}

				while(isIP){
					if (strstr(tok,"src=")){
						aa->sin_addr.s_addr = parese_ip(tok);
						temp->IP = inet_ntoa(aa->sin_addr);
						isIP = 0;
					}
					printf("isIP=%d\n",isIP);
					tok = strtok( NULL, sfilter );
				}

				while(isPacket || isBytes){
					if (strstr(tok,"packets")){
						temp->Packets_TX = parese_value(tok);
						isPacket--;
						if (isPacket==1 && isBytes==1){
							temp->Packets_RX = parese_value(tok);
							isPacket--;
						}
					}
					if (strstr(tok,"bytes")){
						temp->Bytes_TX = parese_value(tok);
						tok = strtok( NULL, sfilter );
						isBytes--;
						if (isPacket==0 && isBytes==1){
							temp->Bytes_RX = parese_value(tok);
							isPacket--;
						}
					}
					printf("isPacket=%d, isBytes=%d\n",isPacket, isBytes);
					tok = strtok( NULL, sfilter );
				}

				/*while(isUse){
					if (strstr(tok,"use")){
						tail = getConnectCurrent();
						temp->next = tail;
						tail->next = NULL;
						isUse--;
					}
					tok = strtok( NULL, sfilter );
				}*/
			//}
		}
	}

	fclose(fp);

	nBytesSent += websWrite(wp, T("<script>\n"
					"displayconnection(\"Total\",%lu,%lu,%lu,%lu,%lu,%lu,%lu,%lu);\n"
					"</script>\n"),
					Totaltcp,Totalicmp,Totaludp,Totalunknown,TotalPtx,TotalPrx,TotalBtx,TotalBrx);

	for (k=0;k<10;k++){
		/*Totaltcp += PC[k].tcp_type;
		Totalicmp += PC[k].icmp_type;
		Totaludp += PC[k].udp_type;
		Totalunknown += PC[k].unknown_type;
		TotalPtx += PC[k].Packets_Tx;
		TotalPrx += PC[k].Packets_Rx;
		TotalBtx += PC[k].Bytes_Tx;
		TotalBrx += PC[k].Bytes_Rx;*/
		nBytesSent += websWrite(wp, T("<tr cellspan=\"2\">\n"));
		nBytesSent += websWrite(wp, T("<td class=\"table2\" align=\"center\">%s</td>\n"),"123");
		nBytesSent += websWrite(wp, T("<td class=\"table2\" nowrap>\n"));
		nBytesSent += websWrite(wp, T("<span id=\"displaycurrent%d\"></span>\n"),k);
		nBytesSent += websWrite(wp, T("</td>\n"));
		nBytesSent += websWrite(wp, T("<td class=\"table2\" align=\"center\" nowrap>\n"));
		nBytesSent += websWrite(wp, T("<span id=\"CurrentPackets%d\"></span>&nbsp;</td>\n"),k);
		nBytesSent += websWrite(wp, T("<td class=\"table2\" align=\"center\" nowrap>\n"));
		nBytesSent += websWrite(wp, T("<span id=\"CurrentBytes%d\"></span>&nbsp;</td>\n"),k);
		nBytesSent += websWrite(wp, T("</tr>\n"));
		/*nBytesSent += websWrite(wp, T("<script>\n"
					"displayconnection(%d,%d,%d,%d,%d,%d,%d,%d,%d);\n"
					"</script>\n"),k+1,PC[k].tcp_type,PC[k].icmp_type,PC[k].udp_type,PC[k].unknown_type,PC[k].Packets_Tx,PC[k].Packets_Rx,PC[k].Bytes_Tx,PC[k].Bytes_Rx);*/
		nBytesSent += websWrite(wp, T("<script>\n"
					"displayconnection(%d,%d,%d,%d,%d,%d,%d,%d,%d);\n"
					"</script>\n"),k,12,23,22,11,500,623,222,123);
	}

	system("rm -rf /tmp/ConnectInfo.dat");
	return nBytesSent;

ConnectInfoNull:
	nBytesSent += websWrite(wp, "displayconnection(0,0,0,0,0,0,0,0,0);\n");
	return nBytesSent;
}
#endif
#if defined(_LED_SWITCH_) || defined(_SW_LED_SWITCH_)
void formLedSwitch(webs_t wp, char_t *path, char_t *query)
{

        char_t *submitUrl, *strLedSwitch ;
        int val;
        char tmpBuf[100];
        strLedSwitch =  websGetVar(wp, T("ledSwitch"), T(""));

	val = atoi(strLedSwitch);
#ifdef __TARGET_BOARD__
#ifdef _LED_SWITCH_
	if(val == 0)
		system("echo 0 > /proc/led_switch");
	else
		system("echo 1 > /proc/led_switch");
#elif defined(_SW_LED_SWITCH_)
	if(val == 0){
		system("echo 3 > /proc/wlan_led");
		system("echo 3 > /proc/power_led");
		system("iwpriv wlan0 write_mem dw,b8000040,1,343c30");
	}
	else{
		system("echo 2 > /proc/wlan_led");
		system("echo 1 > /proc/power_led");
		system("iwpriv wlan0 write_mem dw,b8000040,1,343c00");
	}
#endif
#endif
	apmib_set(MIB_LED_SWITCH, (void *)&val);

	apmib_update(CURRENT_SETTING);
	sleep(2);
	submitUrl = websGetVar(wp, T("submit_Url"), T(""));
	websRedirect(wp, submitUrl);
}
#endif
int dhcpClientList(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp;
	int nBytesSent=0;
	int element=0, ret;
	char ipAddr[40], macAddr[40], liveTime[80], *buf=NULL, *ptr, tmpBuf[100];
	struct stat status;
	int pid;
	unsigned long longVal;

	//kyle
	system("killall -q -USR1 udhcpd");

	// siganl DHCP server to update lease file
	snprintf(tmpBuf, 100, "%s/%s.pid", _DHCPD_PID_PATH, _DHCPD_PROG_NAME);
	pid = getPid(tmpBuf);
	if ( pid > 0)
		kill(pid, SIGUSR1);
	usleep(1000);
	if ( stat(_PATH_DHCPS_LEASES, &status) < 0 )
		goto err;

	buf = malloc(status.st_size);
	if ( buf == NULL )
		goto err;
	fp = fopen(_PATH_DHCPS_LEASES, "r");
	if ( fp == NULL )
		goto err;
	fread(buf, 1, status.st_size, fp);
	fclose(fp);
	ptr = buf;

	while (1) {
		ret = getOneDhcpClient(&ptr, &status.st_size, ipAddr, macAddr, liveTime);

		if (ret < 0) break;

		if (ret == 0) continue;

		longVal=strtoul(liveTime,NULL,0);

		if (longVal > 2000000) sprintf(liveTime, "%s", "forever");

		if (strcmp(macAddr, "00:00:00:00:00:00") != 0) { // tommy
			nBytesSent += websWrite(wp,
			T("<tr class=table2 align=center><td><font size=2>%s</td><td><font size=2>%s</td><td><font size=2>%s</td></tr>"),
			ipAddr, macAddr, liveTime);
		}

		element++;
	}

err:
	if (element == 0) {
		nBytesSent += websWrite(wp,
			T("<tr class=table2 align=center><td><font size=2>None</td><td><font size=2>----</td><td><font size=2>----</td></tr>"));
	}
	if (buf)
		free(buf);
	return nBytesSent;
}
void formReflashClientTbl(webs_t wp, char_t *path, char_t *query)
{
        char_t *submitUrl;

        submitUrl = websGetVar(wp, T("submit-url"), T(""));
        if (submitUrl[0])
                websRedirect(wp, submitUrl);
}

/////////////////////////////////////////////////////////////////////////////
