/*
 *      Web server handler routines wlan stuffs
 *
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *
 *      $Id: fmwlan.c,v 1.3 2005/05/13 07:53:56 tommy Exp $
 *
 */

#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#include	<sys/ioctl.h>
#include	<arpa/inet.h>

#include	<linux/wireless.h>
#include "../webs.h"
#include "apmib.h"
#include "apform.h"
#include "utility.h"
static SS_STATUS_Tp pStatus=NULL;
int wizardEnabled = 0;
int sitesurveyed = 0;
int auth_mode = 0;
int encrypt_mode = 0;
int manualssid = 0;
char GlobalWEPkey[60];
#ifdef _PROFILE_LIST_
int NoweditProfile;
#endif
/////////////////////////////////////////////////////////////////////////////
static inline int isAllStar(char *data)
{
	int i;
	for (i=0; i<strlen(data); i++) {
		if (data[i] != '*')
			return 0;
	}
	return 1;
}
// Preamble MODE in TxD
#define MODE_CCK	0
#define MODE_OFDM   1
#define MODE_HTMIX	2
#define MODE_HTGREENFIELD	3
static inline char* GetPhyMode(int Mode)
{
	switch(Mode)
	{
		case MODE_CCK:
			return "CCK";

		case MODE_OFDM:
			return "OFDM";

		case MODE_HTMIX:
			return "HTMIX";

		case MODE_HTGREENFIELD:
			return "GREEN";

		default:
			return "N/A";
	}
}
// BW
#define BW_20	0
#define BW_40	1
#define BW_BOTH		2
#define BW_10		3
static inline char* GetBW(int BW)
{
	switch(BW)
	{
		case BW_10:
			return "10M";

		case BW_20:
			return "20M";

		case BW_40:
			return "40M";

		default:
			return "N/A";
	}
}

WLAN_RATE_T rate_11n_table_20M_LONG[]={
	{MCS0, 	"6.5"},
	{MCS1, 	"13"},
	{MCS2, 	"19.5"},
	{MCS3, 	"26"},
	{MCS4, 	"39"},
	{MCS5, 	"52"},
	{MCS6, 	"58.5"},
	{MCS7, 	"65"},
	{MCS8, 	"13"},
	{MCS9, 	"26"},
	{MCS10, 	"39"},
	{MCS11, 	"52"},
	{MCS12, 	"78"},
	{MCS13, 	"104"},
	{MCS14, 	"117"},
	{MCS15, 	"130"},
	{0}
};
WLAN_RATE_T rate_11n_table_20M_SHORT[]={
	{MCS0, 	"7.2"},
	{MCS1, 	"14.4"},
	{MCS2, 	"21.7"},
	{MCS3, 	"28.9"},
	{MCS4, 	"43.3"},
	{MCS5, 	"57.8"},
	{MCS6, 	"65"},
	{MCS7, 	"72.2"},
	{MCS8, 	"14.444"},
	{MCS9, 	"28.889"},
	{MCS10, 	"43.333"},
	{MCS11, 	"57.778"},
	{MCS12, 	"86.667"},
	{MCS13, 	"115.556"},
	{MCS14, 	"130"},
	{MCS15, 	"144.444"},
	{0}
};
WLAN_RATE_T rate_11n_table_40M_LONG[]={
	{MCS0, 	"13.5"},
	{MCS1, 	"27"},
	{MCS2, 	"40.5"},
	{MCS3, 	"54"},
	{MCS4, 	"81"},
	{MCS5, 	"108"},
	{MCS6, 	"121.5"},
	{MCS7, 	"135"},
	{MCS8, 	"27"},
	{MCS9, 	"54"},
	{MCS10, 	"81"},
	{MCS11, 	"108"},
	{MCS12, 	"162"},
	{MCS13, 	"216"},
	{MCS14, 	"243"},
	{MCS15, 	"270"},
	{0}
};
WLAN_RATE_T rate_11n_table_40M_SHORT[]={
	{MCS0, 	"15"},
	{MCS1, 	"30"},
	{MCS2, 	"45"},
	{MCS3, 	"60"},
	{MCS4, 	"90"},
	{MCS5, 	"120"},
	{MCS6, 	"135"},
	{MCS7, 	"150"},
	{MCS8, 	"30"},
	{MCS9, 	"60"},
	{MCS10, 	"90"},
	{MCS11, 	"120"},
	{MCS12, 	"180"},
	{MCS13, 	"240"},
	{MCS14, 	"270"},
	{MCS15, 	"300"},
	{0}
};
WLAN_RATE_T tx_fixed_rate[]={
	{1, "1"},
	{(1<<1), 	"2"},
	{(1<<2), 	"5.5"},
	{(1<<3), 	"11"},
	{(1<<4), 	"6"},
	{(1<<5), 	"9"},
	{(1<<6), 	"12"},
	{(1<<7), 	"18"},
	{(1<<8), 	"24"},
	{(1<<9), 	"36"},
	{(1<<10), 	"48"},
	{(1<<11), 	"54"},
	{(1<<12), 	"MCS0"},
	{(1<<13), 	"MCS1"},
	{(1<<14), 	"MCS2"},
	{(1<<15), 	"MCS3"},
	{(1<<16), 	"MCS4"},
	{(1<<17), 	"MCS5"},
	{(1<<18), 	"MCS6"},
	{(1<<19), 	"MCS7"},
	{(1<<20), 	"MCS8"},
	{(1<<21), 	"MCS9"},
	{(1<<22), 	"MCS10"},
	{(1<<23), 	"MCS11"},
	{(1<<24), 	"MCS12"},
	{(1<<25), 	"MCS13"},
	{(1<<26), 	"MCS14"},
	{(1<<27), 	"MCS15"},
	{0}
};
/////////////////////////////////////////////////////////////////////////////
void formLicence(webs_t wp, char_t *path, char_t *query)
{
	char_t *strAccept, *submitUrl;
	char tmpBuf[100];
	int val=1;
	strAccept = websGetVar(wp, T("accept"), T(""));
	if (strAccept[0]) {
		if ( apmib_set(MIB_LICENCE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormLicence1))</script>"));
			goto setErr_licence;
		}
		apmib_update(CURRENT_SETTING);
	}

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	if (strAccept[0]) {		//accept
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}
	else					//reject
		REJECT_MSG();

  	return;

setErr_licence:
	ERR_MSG(tmpBuf);
}
/////////////////////////////WiFi Test///////////////////////////

void formWifiEnable(webs_t wp, char_t *path, char_t *query)
{
   	char_t *submitUrl, *strWifiEnable, *strWpsTest,*strReg,*strAReg;
	int val;
		char tmpBuf[100];

	strWifiEnable =  websGetVar(wp, T("wifitest"), T(""));

		if (!gstrcmp(strWifiEnable, T("YES")))
			val = 1;
		else
			val = 0;
		if ( apmib_set(MIB_WIFI_TEST, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
			goto setErr_advance;
		}
	#ifdef _DFS_

		strReg  =  websGetVar(wp, T("countryReg"), T(""));
		strAReg =  websGetVar(wp, T("aBandCountryReg"), T(""));
		if ( strReg[0] ) {
			val = (strReg[0] - '0');
			apmib_set(MIB_HW_COUNTRY_REG, (void *)&val);
		}
		if ( strAReg[0] ) {
			val = (strAReg[0] - '0');
			apmib_set(MIB_HW_COUNTRY_REG_ABAND, (void *)&val);
		}
		apmib_update(HW_SETTING);
	#endif


	apmib_update(CURRENT_SETTING);
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

#ifdef _corega_
	strWpsTest			= websGetVar(wp, T("wpsTest"), T(""));
	if(strWpsTest[0]){
		if (!gstrcmp(strWpsTest, T("ON")))
			system("/bin/wpsbuttontest.sh &");
	}
#endif
	OK_MSG(submitUrl);
	return;
setErr_advance:
	ERR_MSG(tmpBuf);
}

#ifdef _WPS_NO_BROADCAST_
void formWpsProxyEnable(webs_t wp, char_t *path, char_t *query)
{


	char_t *submitUrl,*strWpsProxyEnable;
	int val;
	char tmpBuf[100];
	strWpsProxyEnable =  websGetVar(wp, T("wpsProxyEnable"), T(""));
	if (!gstrcmp(strWpsProxyEnable, T("ON"))){
		val = 1;
		system("iwpriv ra0 set WscConfMode=2");
	}else{
		val = 0;
		system("iwpriv ra0 set WscConfMode=0");
	}
	if ( apmib_set(MIB_WPS_PROXY_ENABLE, (void *)&val) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
		goto setErr_advance;
	}
	apmib_update(CURRENT_SETTING);


	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
	websRedirect(wp, submitUrl);
	return;
setErr_advance:
	ERR_MSG(tmpBuf);

}
#endif
////////////////////////////WPS /////////////////////////////////
void formWpsEnable(webs_t wp, char_t *path, char_t *query)
{

   	char_t *submitUrl, *strWpsEnable, *strshowpwd ;
	int val;
	char tmpBuf[100];
	strWpsEnable =  websGetVar(wp, T("wpsEnable"), T(""));
		if (!gstrcmp(strWpsEnable, T("ON")))
			val = 1;
		else
			val = 0;
		if ( apmib_set(MIB_WPS_ENABLE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
			goto setErr_advance;
		}
		if( val == 1){
					val = 7;

		}
		else{
			val = 0;

		}
			if ( apmib_set(MIB_WPS_CONFIG_MODE, (void *)&val) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
				goto setErr_advance;
			}




	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	//sprintf(tmpBuf, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG); // Tommy
	//system(tmpBuf);
#endif

#if defined(_Customer_EX_) || defined(_Customer_SA_)
        submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
        OK_MSG(submitUrl);
        return;
#else
	system("/bin/scriptlib_util.sh reloadFlash");
//	system("/bin/wps.sh 3 0 0");
	system("/bin/wlanapp.sh start wlan0 br0");
	sleep(2);
	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
	//REPLACE_MSG(submitUrl); // Tommy
	websRedirect(wp, submitUrl);

	return;
#endif
setErr_advance:
	ERR_MSG(tmpBuf);
}
void formWsc(webs_t wp, char_t *path, char_t *query)//Thomas_20100611
{
	char_t *submitUrl;
        char tmpBuf[100];
	int tmp=0;

	if ( apmib_set(MIB_WPS_CONFIG_TYPE, (void *)&tmp) == 0) {
		DEBUGP(tmpBuf, T("Reset to OOB error!"));
		goto setErr_oob;
	}
	if ( apmib_set(MIB_WPS_CONFIG_STATUS, (void *)&tmp) == 0) {
		DEBUGP(tmpBuf, T("Reset to OOB error!"));
		goto setErr_oob;
	}
        submitUrl = websGetVar(wp, T("submitUrl"), T(""));   // hidden page 
	OK_MSG(submitUrl);
	apmib_update(CURRENT_SETTING);
	return;
setErr_oob:
        ERR_MSG(tmpBuf);
}

/*
/////////WPSCONFIG//////proxy,internal Register ////////
void formWpsConfig(webs_t wp, char_t *path, char_t *query)
{
   char_t *submitUrl, *strEnProxy, *strEnInternalReg;
	int proxyVal,regVal,cmodeVal;
	char tmpBuf[100];

	strEnProxy = websGetVar(wp, T("enProxy"), T(""));
	if (strEnProxy[0]) {
		if (!gstrcmp(strEnProxy, T("no")))
			proxyVal = 0;
		else if (!gstrcmp(strEnProxy, T("yes")))
			proxyVal = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEnable1))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WPS_PROXY_ENABLE, (void *)&proxyVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
			goto setErr_advance;
		}
	}
		strEnInternalReg = websGetVar(wp, T("enInternalReg"), T(""));
	if (strEnInternalReg[0]) {
		if (!gstrcmp(strEnInternalReg, T("no")))
			regVal = 0;
		else if (!gstrcmp(strEnInternalReg, T("yes")))
			regVal = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEnable1))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WPS_INTERNAL_REG, (void *)&regVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
			goto setErr_advance;
		}
	}
		cmodeVal=1+(2*proxyVal)+(4*regVal);
		if ( apmib_set(MIB_WPS_CONFIG_MODE, (void *)&cmodeVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
			goto setErr_advance;
		}
	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	//sprintf(tmpBuf, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG); // Tommy
	//system(tmpBuf);
#endif


	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
	//REPLACE_MSG(submitUrl); // Tommy
	OK_MSG(submitUrl);

	return;
setErr_advance:
	ERR_MSG(tmpBuf);
}


///////////////////////////WpS Reset//Out-Of-Box//////////////////
void formWpsRest(webs_t wp, char_t *path, char_t *query)
{
	char_t *resetOOB,*submitUrl;
	int val;
	char tmpBuf[100];
		resetOOB = websGetVar(wp, T("resetOOB"), T(""));
	if (resetOOB[0]) {
		if (!gstrcmp(resetOOB, T("no")))
			val = 0;
		else if (!gstrcmp(resetOOB, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEnable1))</script>"));
			goto setErr_advance;
		}
	}
		sprintf(tmpBuf, "iwpriv ra0 set WscOOB=%d", val);
		system(tmpBuf);

	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	//sprintf(tmpBuf, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG); // Tommy
	//system(tmpBuf);
#endif


	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
	//REPLACE_MSG(submitUrl); // Tommy
	OK_MSG(submitUrl);

	return;
setErr_advance:
	ERR_MSG(tmpBuf);

}
*/
////////////////////WpsStart/////////////////////////////////////
void formWpsStart(webs_t wp, char_t *path, char_t *query)
{
   char_t *submitUrl, *strModeOpt ,*pinCode,*strConfigMode;
	int modeVal,configValue,intVal;
	char tmpBuf[100];
	char pinNumber[10];//vance
	configValue=0;
	
	strConfigMode = websGetVar(wp, T("confMode"), T(""));	//Registrar=0 Enrollee=1
	if (strConfigMode[0]){
		if(strConfigMode[0]=='0')
			configValue=0;
		else if(strConfigMode[0]=='1')
			configValue=1;
	}
	/*
	if ( apmib_set(MIB_WPS_INTERNAL_REG, (void *)&configValue) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
		goto setErr_advance;
	}
	apmib_update(CURRENT_SETTING);
	*/

	strModeOpt = websGetVar(wp, T("configOption"), T(""));
	if (strModeOpt[0]) {
		if (!gstrcmp(strModeOpt, T("pin")))
			modeVal = 1;
		else if (!gstrcmp(strModeOpt, T("pbc")))
			modeVal = 2;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEnable1))</script>"));
			goto setErr_advance;
		}
                apmib_get( MIB_AP_MODE, (void *)&intVal);
		pinCode=websGetVar(wp, T("pinCode"), T(""));
		
		if( modeVal == 1 ) {					//pin
			if( configValue == 1 ) {			//Enrollee PIN
				if ( intVal == 6 ||  intVal == 2 )	//Repeater/Converter Mode
					sprintf(tmpBuf, "wps.sh %d -1 2",modeVal);
				else					//AP Mode
					sprintf(tmpBuf, "wps.sh %d -1 0",modeVal);
			}
			else {						//Registrar PIN
				sprintf(tmpBuf, "wps.sh %d %s 0",modeVal,pinCode);
			}
		}
		else if( modeVal == 2 ) {				//pbc
			if ( configValue == 1 ) {			//Enrollee PBC
				if ( intVal == 6 ||  intVal == 2 )      //Repeater/Converter Mode
					sprintf(tmpBuf, "wps.sh %d 0 2",modeVal);
				else					//AP Mode
					sprintf(tmpBuf, "wps.sh %d 0 0",modeVal);
			}
                        else {						//Registrar PBC
				sprintf(tmpBuf, "wps.sh %d 0 0",modeVal);
			}
		}
		system(tmpBuf);
		sprintf(pinNumber, "%s",pinCode);
	}
//		if ( apmib_set(MIB_WPS_PIN_CODE, (void *)&pinNumber) == 0) {
//			DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
//			goto setErr_advance;
//		}


//	system("iwpriv ra0 set SSID=`flash all2 | grep ^SSID= | cut -f 2 -d =`");

//	apmib_reinit();

#ifndef NO_ACTION
	//sprintf(tmpBuf, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG); // Tommy
	//system(tmpBuf);
#endif


	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
	//REPLACE_MSG(submitUrl); // Tommy
	//OK_MSG(submitUrl);

	websRedirect(wp, submitUrl);
	return;
setErr_advance:
	ERR_MSG(tmpBuf);
}

///////////////////////////////////WPS/////////////////////////////
#ifdef _AUTO_WAN_PROB_
void formWanProb(webs_t wp, char_t *path, char_t *query)
{
#ifdef _Customer_WAN_PROB_

	char_t *submitUrl,*strMode,*strPingWanIp,*strwizardResult, *strmobile;
	char tmpChar[30];
	char strbuf[30];
	char aaaa[30];
	int status;
	FILE *fp;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));
	strwizardResult = websGetVar(wp, T("wizardResult"), T(""));
	strMode = websGetVar(wp, T("connectionMode"), T(""));
	strPingWanIp = websGetVar(wp ,T("pingWanIp"),T(""));
//printf("sub = %s , strwizardResult = %s , strMode = %s , strPingWanIP = %s \n" , submitUrl , strwizardResult , strMode , strPingWanIp);
	#ifdef __TARGET_BOARD__
		if (!gstrcmp(strPingWanIp,T("start"))){
		int succ = 0;
			#ifdef HOME_GATEWAY
				system("/bin/reset.sh gw 2 &");
			#else
			   system("/bin/reset.sh ap 2 &");
			#endif
			system("/bin/scriptlib_util.sh checkIsConnect");
			if((fp = fopen("/tmp/wanStatus","r")) != NULL){
				while( fgets(tmpChar, 30, fp)>0 ){
					status = atoi(tmpChar);
					memcpy(strbuf,strwizardResult,strlen(strwizardResult)+1);
					strcat(strbuf,T("?Status="));
					strcat(strbuf,tmpChar);
					if (status == 1)      websRedirect(wp, strbuf);
					else if (status == 2) websRedirect(wp, strbuf);
					else if (status == 3) websRedirect(wp, strbuf);
					else if (status == 4) websRedirect(wp, strbuf);
					else		      websRedirect(wp, strbuf);
				}
			}
			//websRedirect(wp, "/wizardStatus.asp?Status=1");
			//Static 頁面最後會被別的程式導到Quick Setup的首頁面，所以這邊怎麼websRedirect，對Static IP 都沒用
			return;
		}
		if (!gstrcmp(strMode,T("dhcp"))){
			system("flash set WAN_MODE 0");
			#ifdef _Customer_
			if (strmobile[0])
				websRedirect(wp, "/mwizardProb.asp?Status=confirming");
			else
				websRedirect(wp, "/wizardProb.asp?Status=confirming");
			#else
			websRedirect(wp, T("/wizardProb.asp?Status=confirming"));
			#endif
			return;
		}else{
			system("killall wanprob.sh");
			system("/bin/wanprob.sh");
		}
	#endif

	if (submitUrl[0]){
		websRedirect(wp, submitUrl);
	}
	return;
#elif defined( _LOGIN_WEB_ )
	char_t *strKeyID;
	char buffer [100];
	strKeyID = websGetVar(wp, T("KeyID"), T(""));
	sprintf(buffer,"/wizardStatus.asp?KeyID=%s",strKeyID);
	#ifdef __TARGET_BOARD__
		system("killall wanprob.sh");
		system("/bin/wanprob.sh");
	#endif

	websRedirect(wp, buffer);
	return;

#else

	#ifdef __TARGET_BOARD__
		system("killall wanprob.sh");
		system("/bin/wanprob.sh");
	#endif
	websRedirect(wp, "/wizardStatus.asp");
	return;

#endif

}
#endif
/////////////////////////////////////////////////////////////////////////////////////////
#if defined(HOME_GATEWAY) || defined(_AP_WITH_WIZARD_)
void formWizSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl, *strEnWiz;
	char_t *strStateChanged;
	int intVal;

   submitUrl = websGetVar(wp, T("setPage"), T(""));
   strEnWiz = websGetVar(wp, T("wizEnabled"), T(""));
   strStateChanged = websGetVar(wp, T("chagestate"), T(""));
   wizardEnabled = atoi(strEnWiz);
	printf("sub = %s , strEnWiz = %s , strstatechanged = %s wizardEnabled = %d \n" , submitUrl , strEnWiz , strStateChanged , wizardEnabled);
#ifdef _LEDSWITCH_
printf("LEDSWITCH \n");
    char tempBuf[100];
    if (strStateChanged[0]){
	intVal = atoi(strStateChanged);
	if ( !apmib_set(MIB_LED_CONTROL, (void *)&intVal)) {
	   return;
	}
    	apmib_update(CURRENT_SETTING);

#ifdef __TARGET_BOARD__
	if ( intVal == 1)
	{
		system("echo 2 > /proc/wlan_led");
		//system("/bin/scriptlib_util.sh led_control ON");
	}
	else if ( intVal == 0)
	{
		system("echo 3 > /proc/wlan_led");
		//system("/bin/scriptlib_util.sh led_control OFF");
	}
#endif

      websRedirect(wp,"/template1.asp");
      return;
     }
#endif

#ifdef _EZVIEW_
            REPLACE_MSG(submitUrl);
#else
   if(wizardEnabled == 1)
    {
	#ifdef _LOGIN_WEB_
	printf("LOGIN-WEB \n");
        if ( gstrstr(submitUrl,"/setmenu.html")) {

	#else
	printf("NO - LOGIN-WEB \n");
#ifdef _BR6428PNL_
	if ( !strcmp(submitUrl,"/setmenu.asp")) {
#else
        if ( !strcmp(submitUrl,"/setmenu.html")) {
#endif
	#endif

			printf("last submitUrl = %s \n" , submitUrl);

  			system("echo \"replace1 funciton\"");
	#ifdef _Phoebe_
		        REPLACE2_MSG(submitUrl);
	#else
			printf("replace1\n");
        	        REPLACE1_MSG(submitUrl);
	#endif
	   	        return;
       		 }
       		 else {
        		system("echo \"replace funciton\"");

        		REPLACE_MSG(submitUrl);
           	 return;
       		 }	
        }	
#endif

    return;
}
#endif //HOME_GATEWAY || _AP_WITH_WIZARD_

#if defined(HOME_GATEWAY)

///////////////////////////////////////////////////////////////////////////////////////////
void formALGSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t *strALG, *submitUrl, *algPorts;
	char tmpBuf[100];
	unsigned long longVal;

	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
	strALG = websGetVar(wp, T("appLyGatewayValue"), T(""));
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

#ifdef _DALGFTP_
	algPorts = websGetVar(wp, T("portNum"), T(""));
	longVal=strtoul(algPorts,NULL,0);
	if ( apmib_set(MIB_ALG_FTP_PORTS, (void *)&longVal) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormALGSetup))</script>"));
		goto setErr_advance;
	}
#endif
	longVal=strtoul(strALG,NULL,0);
	if ( apmib_set(MIB_APP_LAYER_GATEWAY, (void *)&longVal) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormALGSetup))</script>"));
		goto setErr_advance;
	}
	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	//sprintf(tmpBuf, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG); // Tommy
	//system(tmpBuf);
#endif

	OK_MSG(submitUrl);
	return;

setErr_advance:
	ERR_MSG(tmpBuf);
	return ;
}
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
void formWlEnable(webs_t wp, char_t *path, char_t *query)
{
   	char_t *submitUrl, *strWirelessEnable, *strnextEnable;
	int val;
	char tmpBuf[100];

	strWirelessEnable = websGetVar(wp, T("wlanDisabled"), T(""));
#if defined(_STAR_) && defined(_MSSID_)
	if (strWirelessEnable[0]) {
		if (!gstrcmp(strWirelessEnable, T("no")))
				val = 0;
			else if (!gstrcmp(strWirelessEnable, T("yes")))
				val = 2;
			else {
				DEBUGP(tmpBuf, T("Error!"));
				goto setErr_advance;
			}
			if ( apmib_set(MIB_WLAN_SSID_MIRROR_1, (void *)&val) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEnable2))</script>"));
				goto setErr_advance;
			}
	}
#else
	if (strWirelessEnable[0]) {
		if (!gstrcmp(strWirelessEnable, T("no")))
			val = 1;
		else if (!gstrcmp(strWirelessEnable, T("yes")))
			val = 0;
		else {
			DEBUGP(tmpBuf, T("Error!"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_DISABLED, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEnable2))</script>"));
			goto setErr_advance;
		}
	}
#endif
	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	// run script file to update WLAN parameters
	//sprintf(tmpBuf, "%s %s %s", "/bin/init.sh", "gw", "all"); // Tommy
	//system(tmpBuf);
#endif

	//submitUrl = websGetVar(wp, T("wlanurl"), T(""));   // hidden page
	//REPLACE_MSG(submitUrl);

//20060410 pippen
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
		OK_MSG(submitUrl);
	return;

setErr_advance:
	ERR_MSG(tmpBuf);
}
#if defined(_IGMP_PROXY_)
/////////////////////////////////////////////////////////////////////////////
void formIgmpEnable(webs_t wp, char_t *path, char_t *query)
{
   	char_t *submitUrl, *strIgmpEnable;
	int val;
	char tmpBuf[100];

	strIgmpEnable = websGetVar(wp, T("igmpEnable"), T(""));
	if (strIgmpEnable[0]) {
		if (!gstrcmp(strIgmpEnable, T("no")))
			val = 0;
		else if (!gstrcmp(strIgmpEnable, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("Error!"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_IGMP_PROXY_ENABLED, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormNatEnable))</script>"));
			goto setErr_advance;
		}
	}


	apmib_update(CURRENT_SETTING);
#ifndef NO_ACTION
	//sprintf(tmpBuf, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG); // Tpmmy
	//system(tmpBuf);
#endif

	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
	//REPLACE_MSG(submitUrl); // Tommy
	OK_MSG(submitUrl);

	return;
setErr_advance:
	ERR_MSG(tmpBuf);
}
#endif
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
void formAPModeSwitch(webs_t wp, char_t *path, char_t *query)
{
   	char_t *submitUrl, *strSwitch;
	int apEnable,chkAPEnable,val,oldSwitchValue;
	char tmpBuf[200];
	strSwitch = websGetVar(wp, T("switch"), T(""));
	if (strSwitch[0]) {
		if (!gstrcmp(strSwitch, T("Router"))){
			apEnable = 0;
			chkAPEnable=0;

		}
		else if (!gstrcmp(strSwitch, T("AP"))){
			apEnable = 1;
			chkAPEnable=1;

		}
		else {
			DEBUGP(tmpBuf, T("Error!"));
			goto setErr_advance;
		}
		apmib_get(MIB_AP_ROUTER_SWITCH, (void *)&oldSwitchValue);
		if ( apmib_set(MIB_AP_ROUTER_SWITCH, (void *)&apEnable) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormNatEnable))</script>"));
			goto setErr_advance;
		}
	}

	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
	if(apEnable==1){
		val=0;
		apmib_set(MIB_DHCP, (void *)&val);
		apmib_set(MIB_FIREWALL_ENABLE, (void *)&val);

	}else{
		val=2;
		apmib_set(MIB_DHCP, (void *)&val);
		val=1;
		apmib_set(MIB_FIREWALL_ENABLE, (void *)&val);
	}

	apmib_update(CURRENT_SETTING);
	if(oldSwitchValue!=chkAPEnable){

#ifdef __TARGET_BOARD__
		system("killall -SIGTERM pppd");
		sprintf(tmpBuf, "%s %s %s", "/bin/init.sh", "gw", "all");
		system(tmpBuf);
#else
		sleep(3);
#endif

	}
	websRedirect(wp, submitUrl);
	return;
setErr_advance:
	ERR_MSG(tmpBuf);
}

/////////////////////////////////////////////////////////////////////////////
void formNatEnable(webs_t wp, char_t *path, char_t *query)
{
   	char_t *submitUrl, *strNatEnable,*strFastNatEnable;
	int val;
	char tmpBuf[100];

	strNatEnable = websGetVar(wp, T("natEnable"), T(""));
	if (strNatEnable[0]) {
		if (!gstrcmp(strNatEnable, T("no")))
			val = 0;
		else if (!gstrcmp(strNatEnable, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("Error!"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_NAT_ENABLE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormNatEnable))</script>"));
			goto setErr_advance;
		}
	}

	strFastNatEnable = websGetVar(wp, T("fastNatEnable"), T(""));
	if (strFastNatEnable[0]) {
		if (!gstrcmp(strFastNatEnable, T("no")))
			val = 0;
		else if (!gstrcmp(strFastNatEnable, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("Error!"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_FAST_NAT_ENABLE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormFastNatEnable))</script>"));
			goto setErr_advance;
		}
	}

	apmib_update(CURRENT_SETTING);
#ifndef NO_ACTION
	//sprintf(tmpBuf, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG); // Tpmmy
	//system(tmpBuf);
#endif

	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
	//REPLACE_MSG(submitUrl); // Tommy

#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif
	OK_MSG(submitUrl);

	return;
setErr_advance:
	ERR_MSG(tmpBuf);
}
/////////////////////////////////////////////////////////////////////////////
void formFwEnable(webs_t wp, char_t *path, char_t *query)
{
   	char_t *submitUrl, *strFwEnable, *strpingEnable;
	int val;
	char tmpBuf[100];

	strFwEnable = websGetVar(wp, T("FirewallEnable"), T(""));
	if (strFwEnable[0]) {
		if (!gstrcmp(strFwEnable, T("no")))
			val = 0;
		else if (!gstrcmp(strFwEnable, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEnable1))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_FIREWALL_ENABLE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
			goto setErr_advance;
		}
	}
	apmib_update(CURRENT_SETTING);
	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
	//REPLACE_MSG(submitUrl); // Tommy
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif
	OK_MSG(submitUrl);

	return;
setErr_advance:
	ERR_MSG(tmpBuf);
}
#endif
///////////////////////////////////////////////////////////////////////////////////////////
void formWlanMP(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl;
	char_t *strAteFUNC, *strAteGain, *strAteRate, *strAteChan, *strAteTxCount, *strE2pTx2Power1, *strE2pTx2Power2, *strE2pTx2Power3, *strE2pTx2Power4, *strE2pTx2Power5, *strE2pTx2Power6, *strE2pTx2Power7, *strE2pTxPower1, *strE2pTxPower2, *strE2pTxPower3, *strE2pTxPower4, *strE2pTxPower5, *strE2pTxPower6, *strE2pTxPower7, *strAteFreqOffset, *strE2pTxPwDelta, *strE2pTxFreqOffset;
	char_t *strAteMode, *strAteBW, *strAteAntenna, *strE2pTxPwDeltaB, *strE2pTxPwDeltaG, *strE2pTxPwDeltaN, *strReadE2P, *strE2pTxPwDeltaMix;
	char_t *strMacID;

	char tmpBuf[300];
	int intVal=0;
	int pcmode=0;
	printf("Enter WlanMP");
	// set wlan Disabled
	strAteFUNC = websGetVar(wp, T("ateFunc"), T(""));
	strAteGain = websGetVar(wp, T("ateGain"), T(""));
	strAteTxCount = websGetVar(wp, T("ateTxCount"), T(""));
	strAteChan = websGetVar(wp, T("ateChan"), T(""));
	strAteRate = websGetVar(wp, T("ateRate"), T(""));
	strMacID = websGetVar(wp,T("ateMacID"),T(""));
	strE2pTxPower1 = websGetVar(wp, T("e2pTxPower1"), T(""));
	strE2pTxPower2 = websGetVar(wp, T("e2pTxPower2"), T(""));
	strE2pTxPower3 = websGetVar(wp, T("e2pTxPower3"), T(""));
	strE2pTxPower4 = websGetVar(wp, T("e2pTxPower4"), T(""));
	strE2pTxPower5 = websGetVar(wp, T("e2pTxPower5"), T(""));
	strE2pTxPower6 = websGetVar(wp, T("e2pTxPower6"), T(""));
	strE2pTxPower7 = websGetVar(wp, T("e2pTxPower7"), T(""));
	strE2pTx2Power1 = websGetVar(wp, T("e2pTx2Power1"), T(""));
	strE2pTx2Power2 = websGetVar(wp, T("e2pTx2Power2"), T(""));
	strE2pTx2Power3 = websGetVar(wp, T("e2pTx2Power3"), T(""));
	strE2pTx2Power4 = websGetVar(wp, T("e2pTx2Power4"), T(""));
	strE2pTx2Power5 = websGetVar(wp, T("e2pTx2Power5"), T(""));
	strE2pTx2Power6 = websGetVar(wp, T("e2pTx2Power6"), T(""));
	strE2pTx2Power7 = websGetVar(wp, T("e2pTx2Power7"), T(""));

	if ( !gstrcmp(strE2pTxPower1, T(""))){
		strE2pTxPower1 = T("null");
	}
	if ( !gstrcmp(strE2pTxPower2, T(""))){
		strE2pTxPower2 = T("null");
	}
	if ( !gstrcmp(strE2pTxPower3, T(""))){
		strE2pTxPower3 = T("null");
	}
	if ( !gstrcmp(strE2pTxPower4, T(""))){
		strE2pTxPower4 = T("null");
	}
	if ( !gstrcmp(strE2pTxPower5, T(""))){
		strE2pTxPower5 = T("null");
	}
	if ( !gstrcmp(strE2pTxPower6, T(""))){
		strE2pTxPower6 = T("null");
	}
	if ( !gstrcmp(strE2pTxPower7, T(""))){
		strE2pTxPower7 = T("null");
	}
	if ( !gstrcmp(strE2pTx2Power1, T(""))){
		strE2pTx2Power1 = T("null");
	}
	if ( !gstrcmp(strE2pTx2Power2, T(""))){
		strE2pTx2Power2 = T("null");
	}
	if ( !gstrcmp(strE2pTx2Power3, T(""))){
		strE2pTx2Power3 = T("null");
	}
	if ( !gstrcmp(strE2pTx2Power4, T(""))){
		strE2pTx2Power4 = T("null");
	}
	if ( !gstrcmp(strE2pTx2Power5, T(""))){
		strE2pTx2Power5 = T("null");
	}
	if ( !gstrcmp(strE2pTx2Power6, T(""))){
		strE2pTx2Power6 = T("null");
	}
	if ( !gstrcmp(strE2pTx2Power7, T(""))){
		strE2pTx2Power7 = T("null");
	}
	strAteFreqOffset = websGetVar(wp, T("ateTxFreqOffset"), T(""));
	strAteMode = websGetVar(wp, T("ateMode"), T(""));
	strAteBW = websGetVar(wp, T("ateBW"), T(""));
	strAteAntenna = websGetVar(wp, T("ateAntenna"), T(""));
	strE2pTxFreqOffset = websGetVar(wp, T("e2pTxFreqOffset"), T(""));
	strE2pTxPwDeltaB = websGetVar(wp, T("e2pTxPwDeltaB"), T(""));
	strE2pTxPwDeltaG = websGetVar(wp, T("e2pTxPwDeltaG"), T(""));
	strE2pTxPwDeltaMix = websGetVar(wp, T("e2pTxPwDeltaMix"), T(""));
	strE2pTxPwDeltaN = websGetVar(wp, T("e2pTxPwDeltaN"), T(""));
	strReadE2P = websGetVar(wp, T("readE2P"), T(""));


	#ifdef _DBAND_
		char_t *strAbandTxPower1;
		char_t *strAbandTxPower2;
		strAbandTxPower1=websGetVar(wp, T("AbandTx1"), T(""));
		strAbandTxPower2=websGetVar(wp, T("AbandTx2"), T(""));
	#endif

	//strE2pTxPwDelta = websGetVar(wp, T("e2pTxPwDelta"), T(""));

#ifdef __TARGET_BOARD__
	#ifdef _DBAND_
		sprintf(tmpBuf, "/bin/rftest_old.sh \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\"",
		strAteFUNC, strAteGain, strAteTxCount, strAteChan, strAteRate, strE2pTxPower1, strE2pTxPower2, strE2pTxPower3, strE2pTxPower4, strE2pTxPower5,
		strE2pTxPower6, strE2pTxPower7, strE2pTx2Power1, strE2pTx2Power2, strE2pTx2Power3, strE2pTx2Power4, strE2pTx2Power5, strE2pTx2Power6, strE2pTx2Power7,
		strAteFreqOffset, strAteMode, strAteBW,strAteAntenna,strE2pTxFreqOffset,strE2pTxPwDeltaB,strE2pTxPwDeltaG,strE2pTxPwDeltaMix,strReadE2P,strE2pTxPwDeltaN,
		strMacID,strAbandTxPower1,strAbandTxPower2);
		system(tmpBuf);

	#else
		sprintf(tmpBuf, "/bin/rftest_old.sh %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s",
		strAteFUNC, strAteGain, strAteTxCount, strAteChan, strAteRate, strE2pTxPower1, strE2pTxPower2, strE2pTxPower3, strE2pTxPower4, strE2pTxPower5,
		strE2pTxPower6, strE2pTxPower7, strE2pTx2Power1, strE2pTx2Power2, strE2pTx2Power3, strE2pTx2Power4, strE2pTx2Power5, strE2pTx2Power6, strE2pTx2Power7,
		strAteFreqOffset, strAteMode, strAteBW,strAteAntenna,strE2pTxFreqOffset,strE2pTxPwDeltaB,strE2pTxPwDeltaG,strE2pTxPwDeltaMix,strReadE2P,strE2pTxPwDeltaN,strMacID);
		system(tmpBuf);
	#endif

#else
	#ifdef _DBAND_

		printf("ateMacID=%s\n ateFunc=%s\n  ateGain=%s\n  ateTxCount=%s\n  ateChan=%s\n  ateRate=%s\n e2pTxPower1~7=%s %s %s %s %s %s %s \n  e2pTx2Power1~7=%s %s %s %s %s %s %s\n  ateTxFreqOffset=%s\n  ateMode=%s\n  ateBW=%s\n  ateAntenna=%s\n  e2pTxFreqOffset=%s\n  e2pTxPwDeltaB=%s\n  e2pTxPwDeltaG=%s\n  e2pTxPwDeltaMix=%s\n e2pRead=%s\n e2pTxPwDeltaN=%s\n strAbandTxPower1=%s\n strAbandTxPower2=%s\n",
	strMacID,strAteFUNC, strAteGain, strAteTxCount, strAteChan, strAteRate, strE2pTxPower1, strE2pTxPower2, strE2pTxPower3, strE2pTxPower4, strE2pTxPower5,
	strE2pTxPower6, strE2pTxPower7, strE2pTx2Power1, strE2pTx2Power2, strE2pTx2Power3, strE2pTx2Power4, strE2pTx2Power5, strE2pTx2Power6, strE2pTx2Power7,
	strAteFreqOffset, strAteMode, strAteBW,strAteAntenna,strE2pTxFreqOffset,strE2pTxPwDeltaB,strE2pTxPwDeltaG,strE2pTxPwDeltaMix,strReadE2P,strE2pTxPwDeltaN,
	strAbandTxPower1,strAbandTxPower2);
	#else
			printf("ateMacID=%s\n ateFunc=%s\n  ateGain=%s\n  ateTxCount=%s\n  ateChan=%s\n  ateRate=%s\n e2pTxPower1~7=%s %s %s %s %s %s %s \n  e2pTx2Power1~7=%s %s %s %s %s %s %s\n  ateTxFreqOffset=%s\n  ateMode=%s\n  ateBW=%s\n  ateAntenna=%s\n  e2pTxFreqOffset=%s\n  e2pTxPwDeltaB=%s\n  e2pTxPwDeltaG=%s\n  e2pTxPwDeltaMix=%s\n e2pRead=%s\n e2pTxPwDeltaN=%s\n",
		strMacID,strAteFUNC, strAteGain, strAteTxCount, strAteChan, strAteRate, strE2pTxPower1, strE2pTxPower2, strE2pTxPower3, strE2pTxPower4, strE2pTxPower5,
		strE2pTxPower6, strE2pTxPower7, strE2pTx2Power1, strE2pTx2Power2, strE2pTx2Power3, strE2pTx2Power4, strE2pTx2Power5, strE2pTx2Power6, strE2pTx2Power7,
		strAteFreqOffset, strAteMode, strAteBW,strAteAntenna,strE2pTxFreqOffset,strE2pTxPwDeltaB,strE2pTxPwDeltaG,strE2pTxPwDeltaMix,strReadE2P,strE2pTxPwDeltaN);

	#endif

#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	websRedirect(wp, submitUrl);
	//OK_MSG(submitUrl);
}
//////////////////////////////////////////////////////////////////////////////////
//kyle for Customer wizard.
///////////////////////////////////////////////////////////////////////////////////////////
void formWlanSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl, *strSSID, *strSSID1, *strChan, *strBand,*strABand, *strAutoClone, *strVal, *strWisp, *strnextEnable, *strReboot;
	char_t *strMode, *strMac1, *strMac2, *strMac3, *strMac4, *strMac5, *strMac6, *strWlanMac, *strWpsStatus, *strWlansetupEnable;
	char_t *strRate, *strDisabled, *strNFixRate, *strChanWidth, *strGuardInterval, *strBARequest, *strMIsolation, *strIsolation, *strSSIDChoice, *strHiddenSSID, *strProtection;
	char_t *ssid1, *ssid2, *ssid3, *ssid4, *ssid5, *ssid6;
	char_t *strEnWiz;
	char_t *strLEDoffenable, *strLEDoff;
	int chan, disabled, mode, mv, val, wisp,txval;
	NETWORK_TYPE_T net;
	char tmpBuf[100];
	int intVal=0;

#ifdef _STANUM_
	char_t *wlanCliLimit;
	wlanCliLimit = websGetVar(wp, T("wlanCliLimit"), T(""));
	intVal = atoi(wlanCliLimit);
	if ( apmib_set( MIB_STANUM, (void *)&intVal) == 0) {
                DEBUGP(tmpBuf, T("<script>document.write(\"Setting client limit error!\")</script>"));
                goto setErr_wlan;
	}
#endif
        strDisabled = websGetVar(wp, T("wlanDisabled"), T(""));
        if ( !gstrcmp(strDisabled, T("ON")))
                disabled = 1;
        else
                disabled = 0;
        if ( apmib_set( MIB_WLAN_DISABLED, (void *)&disabled) == 0) {
                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup1))</script>"));
                goto setErr_wlan;
        }

	// set wlan Disabled

	// set AP Mode
	strMode = websGetVar(wp, T("apMode"), T(""));
	if (strMode[0]) {
		errno=0;
		mode = strtol( strMode, (char **)NULL, 10);
		if (errno) {
   			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup2))</script>"));
			goto setErr_wlan;
		}
		if ( apmib_set( MIB_AP_MODE, (void *)&mode) == 0) {
   			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup3))</script>"));
			goto setErr_wlan;
		}
	}

	strBand = websGetVar(wp, T("band"), T(""));
	if ( strBand[0] ) {
		if (strBand[0] < '0' || strBand[0] > '6') {
  			strcpy(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup4))</script>"));
			goto setErr_wlan;
		}
		val = (strBand[0] - '0' + 1);
		if ( apmib_set( MIB_WLAN_BAND, (void *)&val) == 0) {
   			strcpy(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup5))</script>"));
			goto setErr_wlan;
		}
	}

	if (val == 2) {
		apmib_get(MIB_SECURITY_MODE, (void *)&intVal);
		if (intVal != 2) {	//not WPA or WPA2
			intVal = ENCRYPT_DISABLED;
			apmib_set(MIB_WLAN_ENCRYPT, (void *)&intVal);
			apmib_set(MIB_SECURITY_MODE, (void *)&intVal);
		}
		else {
			apmib_get(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intVal);
			if (intVal != 0) {
				intVal = 0;
				apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intVal);
			}
			apmib_get(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intVal);
			if (intVal != WPA_CIPHER_AES) {
				intVal = WPA_CIPHER_AES;
				apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intVal);
			}
		}
	}

#ifdef UNIVERSAL_REPEATER
	// Universal Repeater
	strWisp = websGetVar(wp, T("wisp"), T(""));
	wisp = strtol( strWisp, (char **)NULL, 10);
	if (mode == 6 || mode == 2 || wisp == 1) {
		val = (mode == 2) ? 0 : 1;
		if ( apmib_set( MIB_REPEATER_ENABLED, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup6))</script>"));
			goto setErr_wlan;
		}
		//Kyle add.Set AP Mode , bridge wan and lan , disable nat dhcp and some web ui.
		//if ( apmib_set( MIB_AP_ROUTER_SWITCH, (void *)&val) == 0) {
			//DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup6))</script>"));
			//goto setErr_wlan;
		//}

		if (mode == 2) {
			strSSID = websGetVar(wp, T("ssid"), T(""));
		}
		else {
			strSSID = websGetVar(wp, T("repeaterSSID"), T(""));
		}

		if ( strSSID[0] ) {
			int ii;
			for(ii=MAX_SSID_LEN-1;ii>0 && isspace(strSSID[ii]) ;ii--)
			{
				strSSID[ii]='\0';
			}
			if ( apmib_set(MIB_REPEATER_SSID, (void *)strSSID) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup7))</script>"));
					goto setErr_wlan;
			}
		}
	}
	else {
		val = 0;
		if ( apmib_set( MIB_REPEATER_ENABLED, (void *)&val) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspformStatsErrRep))</script>"));
		goto setErr_wlan;
		}
	}

	//AP client mode type
	#ifndef _RESERVE_ENCRYPTION_SETTING_
	if (mode == 1 || mode ==2) {
		if (strMode[0]=='1')
			net = ADHOC;
		if (strMode[0]=='2')
			net = INFRASTRUCTURE;
		if ( apmib_set(MIB_WLAN_NETWORK_TYPE, (void *)&net) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup8))</script>"));
			goto setErr_wlan;
		}
		//------------------------------------------------------------ Added by Tommy
		if (apmib_set( MIB_SECURITY_MODE, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup9))</script>"));
			goto setErr_wlan;
		}

		if (apmib_set( MIB_WLAN_ENABLE_1X, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup10))</script>"));
			goto setErr_wlan;
		}

		if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
			goto setErr_wlan;
		}

		if (apmib_set( MIB_WLAN_AUTH_TYPE, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup12))</script>"));
			goto setErr_wlan;
		}

		//------------------------------------------------------------
	}
	#endif
#endif
	// set auto MAC Clone
	strAutoClone = websGetVar(wp, T("autoMacClone"), T(""));
	if (strAutoClone[0]) {
		if (!gstrcmp(strAutoClone, T("no")))
			val = 0;
		else if (!gstrcmp(strAutoClone, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup13))</script>"));
			goto setErr_wlan;
		}
		if ( apmib_set(MIB_AUTO_MAC_CLONE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup14))</script>"));
			goto setErr_wlan;
		}
	}

	strSSID = websGetVar(wp, T("ssid"), T(""));
	if ( strSSID[0] ) {
		if ( apmib_set(MIB_WLAN_SSID, (void *)strSSID) == 0) {
   	 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup15))</script>"));
				goto setErr_wlan;
		}
	}

	strChan = websGetVar(wp, T("chan"), T(""));

	if ( strChan[0] ) {
		errno=0;
		chan = strtol( strChan, (char **)NULL, 10);
		if (errno) {
   			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup16))</script>"));
			goto setErr_wlan;
		}

		if ( apmib_set( MIB_WLAN_CHAN_NUM, (void *)&chan) == 0) {
   			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup17))</script>"));
			goto setErr_wlan;
		}

	}

	strWisp = websGetVar(wp, T("wisp"), T(""));
	wisp = strtol( strWisp, (char **)NULL, 10);
	if ( mode == 1 || mode ==2 || mode==6 || wisp == 1 ) {
		strWlanMac = websGetVar(wp, T("wlanMac"), T(""));
		if (strWlanMac[0]) {
			if (strlen(strWlanMac)!=12 || !string_to_hex(strWlanMac, tmpBuf, 12)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup18))</script>"));
				goto setErr_wlan;
			}
			if ( !apmib_set(MIB_WLAN_MAC_ADDR, (void *)tmpBuf)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup19))</script>"));
				goto setErr_wlan;
			}

			if (strcmp(strWlanMac,"000000000000")) {
				for (mv=5; mv>=3; mv--) {
					tmpBuf[mv] = (tmpBuf[mv]-1);
					if ( (tmpBuf[mv]+1) != 0 )
						break;
				}
			}
			else {
				if (!string_to_hex("000000000000", tmpBuf, 12)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup20))</script>"));
					goto setErr_wlan;
				}
			}

			if ( !apmib_set(MIB_ELAN_MAC_ADDR, (void *)tmpBuf)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup21))</script>"));
				goto setErr_wlan;
			}
		}
	}

//**************************************** WDS setting ****************************************
	strMac1 = websGetVar(wp, T("wlLinkMac1"), T(""));
	if (strMac1[0]) {
		if (strlen(strMac1)!=12 || !string_to_hex(strMac1, tmpBuf, 12)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup22))</script>"));
			goto setErr_wlan;
		}
		if ( !apmib_set(MIB_WL_LINKMAC1, (void *)tmpBuf)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup23))</script>"));
			goto setErr_wlan;
		}
	}
	strMac2 = websGetVar(wp, T("wlLinkMac2"), T(""));
	if (strMac2[0]) {
		if (strlen(strMac2)!=12 || !string_to_hex(strMac2, tmpBuf, 12)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup24))</script>"));
			goto setErr_wlan;
		}
		if ( !apmib_set(MIB_WL_LINKMAC2, (void *)tmpBuf)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup25))</script>"));
			goto setErr_wlan;
		}
	}
	strMac3 = websGetVar(wp, T("wlLinkMac3"), T(""));
	if (strMac3[0]) {
		if (strlen(strMac3)!=12 || !string_to_hex(strMac3, tmpBuf, 12)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup26))</script>"));
			goto setErr_wlan;
		}
		if ( !apmib_set(MIB_WL_LINKMAC3, (void *)tmpBuf)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup27))</script>"));
			goto setErr_wlan;
		}
	}
	strMac4 = websGetVar(wp, T("wlLinkMac4"), T(""));
	if (strMac4[0]) {
		if (strlen(strMac4)!=12 || !string_to_hex(strMac4, tmpBuf, 12)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup28))</script>"));
			goto setErr_wlan;
		}
		if ( !apmib_set(MIB_WL_LINKMAC4, (void *)tmpBuf)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup29))</script>"));
			goto setErr_wlan;
		}
	}
	strMac5 = websGetVar(wp, T("wlLinkMac5"), T(""));
	if (strMac5[0]) {
		if (strlen(strMac5)!=12 || !string_to_hex(strMac5, tmpBuf, 12)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup30))</script>"));
			goto setErr_wlan;
		}
		if ( !apmib_set(MIB_WL_LINKMAC5, (void *)tmpBuf)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup31))</script>"));
			goto setErr_wlan;
		}
	}
	strMac6 = websGetVar(wp, T("wlLinkMac6"), T(""));
	if (strMac6[0]) {
		if (strlen(strMac6)!=12 || !string_to_hex(strMac6, tmpBuf, 12)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup32))</script>"));
			goto setErr_wlan;
		}
		if ( !apmib_set(MIB_WL_LINKMAC6, (void *)tmpBuf)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup33))</script>"));
			goto setErr_wlan;
		}
	}

#if defined(_POWER_SAVING_)
	strLEDoffenable = websGetVar(wp, T("ledoffEnabled"), T(""));
	if ( !gstrcmp(strLEDoffenable, T("ON")))
	{
		strLEDoff = websGetVar(wp, T("turnoffall"), T(""));
		if ( !gstrcmp(strLEDoff, T("yes")))
			val = 1;
		else
			val = 2;
	}
	else
		val = 0;
	if ( apmib_set(MIB_POWER_SAVING, (void *)&val) == 0) {
		goto setErr_wlan;
	}
#endif
#ifdef _Airlive_7428HCN_
        char_t *strDomain, *strWmm, *strAutoCloneMAC, *strManualCloneMac, *strLedSwitch;

        strLedSwitch = websGetVar(wp, T("ledSwitch"), T(""));
        if ( !gstrcmp(strLedSwitch, T("ON")))
                val = 0;
        else
                val = 1;
	if ( !apmib_set( MIB_LED_SWITCH, (void *)&val ) ) {
        	DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt27))</script>"));
                goto setErr_wlan;
	}

        strAutoCloneMAC = websGetVar(wp, T("AutoCloneMAC"), T(""));
        if ( strAutoCloneMAC[0] ){
                intVal = atoi(strAutoCloneMAC);
                if ( apmib_set(MIB_AUTO_MAC_CLONE, (void *)&intVal) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup14))</script>"));
                        goto setErr_wlan;
                }
        }

        strManualCloneMac = websGetVar(wp, T("ManualCloneMac"), T(""));
        if ( strManualCloneMac[0] ){
                if (strlen(strManualCloneMac)!=12 || !string_to_hex(strManualCloneMac, tmpBuf, 12)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup18))</script>"));
                        goto setErr_wlan;
                }
                if ( !apmib_set(MIB_CLONE_MAC_ADDR, (void *)tmpBuf)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup19))</script>"));
                        goto setErr_wlan;
                }
        }

	strNFixRate = websGetVar(wp, T("NtxRate"), T(""));
	if ( strNFixRate[0] ) {
		val = atoi(strNFixRate);
        	if ( apmib_set(MIB_WLAN_N_FIX_RATE, (void *)&val) == 0) {
        		strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup16))</script>"));
	        	goto setErr_wlan;
		}
	}

	// set tx rate
	strRate = websGetVar(wp, T("txRate"), T(""));
	if ( strRate[0] ) {

		if ( strRate[0] == '0' ) { // auto
			val = 1;
			if ( apmib_set(MIB_WLAN_RATE_ADAPTIVE_ENABLED, (void *)&val) == 0) {
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup14))</script>"));
				goto setErr_wlan;
			}
			val = atoi(strRate);


			if ( apmib_set(MIB_WLAN_FIX_RATE, (void *)&val) == 0) {
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup15))</script>"));
				goto setErr_wlan;
			}
		}
		else
		{
			val = 0;
			if ( apmib_set(MIB_WLAN_RATE_ADAPTIVE_ENABLED, (void *)&val) == 0) {
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup14))</script>"));
				goto setErr_wlan;
			}

			val = atoi(strRate);

			if ( apmib_set(MIB_WLAN_FIX_RATE, (void *)&val) == 0) {
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup15))</script>"));
				goto setErr_wlan;
			}



			strRate = websGetVar(wp, T("basicrates"), T(""));
			if ( strRate[0] ) {
				val = atoi(strRate);
				if ( apmib_set(MIB_WLAN_BASIC_RATE, (void *)&val) == 0) {
					strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup16))</script>"));
					goto setErr_wlan;
				}
			}

			strRate = websGetVar(wp, T("operrates"), T(""));
			if ( strRate[0] ) {
				val = atoi(strRate);
				if ( apmib_set(MIB_WLAN_SUPPORTED_RATE, (void *)&val) == 0) {
					strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup17))</script>"));
					goto setErr_wlan;
				}
			}
		}
	}

        strWmm = websGetVar(wp, T("wlanWmm"), T(""));   //no use
        if (strWmm[0]) {
                if (!gstrcmp(strWmm, T("no")))
                        val = 0;
                else if (!gstrcmp(strWmm, T("yes")))
                        val = 1;
                else {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup12))</script>"));
                        goto setErr_wlan;
                }
                if ( apmib_set(MIB_WLAN_WMM, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup13))</script>"));
                        goto setErr_wlan;
                }
        }

        strDomain = websGetVar(wp, T("domain"), T(""));
        if (strDomain[0]){
                intVal = atoi(strDomain);
                if( apmib_set( MIB_CS_REG_DOMAIN, (void *)&intVal) == 0) {
                        DEBUGP(tmpBuf, T("Set Domain Error!"));
                        goto setErr_wlan;
                }
        }

        strHiddenSSID = websGetVar(wp, T("hiddenSSID"), T(""));
        if (strHiddenSSID[0]) {
                if (!gstrcmp(strHiddenSSID, T("no")))
                        intVal = 0;
                else if (!gstrcmp(strHiddenSSID, T("yes")))
                        intVal = 1;
                else {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup20))</script>"));
                        goto setErr_wlan;
                }
                if ( apmib_set(MIB_WLAN_HIDDEN_SSID, (void *)&intVal) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup11))</script>"));
                        goto setErr_wlan;
                }
        }
        strChanWidth = websGetVar(wp, T("wlanNChanWidth"), T(""));      //no use
        if (strChanWidth[0]) {
                if (!gstrcmp(strChanWidth, T("0")))
                        intVal = 0;
                else if (!gstrcmp(strChanWidth, T("1")))
                        intVal = 1;
                else {
                        DEBUGP(tmpBuf, T("Invalid Channel Width 0"));
                        goto setErr_wlan;
                }
                if ( apmib_set(MIB_WLAN_N_CHANNEL_WIDTH, (void *)&intVal) == 0) {
                        DEBUGP(tmpBuf, T("Invalid Channel Width 1"));
                        goto setErr_wlan;
                }
        }


#endif


setwlan_ret:
	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	#ifdef HOME_GATEWAY
		//sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG, "gw", "all"); // Tommy
		//system(tmpBuf);
	#else
		//sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG, "ap", "all"); // Tommy
		//system(tmpBuf);
	#endif
#endif

	//submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
//200703.29 kyle set wps configured when ssid is change.
	strWpsStatus = websGetVar(wp, T("wpsStatus"), T(""));   // hidden page
		if (!gstrcmp(strWpsStatus, T("1"))){
			val = 1;
			if ( apmib_set(MIB_WPS_CONFIG_TYPE, (void *)&val) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
				goto setErr_wlan;
			}
			if ( apmib_set(MIB_WPS_CONFIG_STATUS, (void *)&val) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
				goto setErr_wlan;
			}
			val = 0;
			if ( apmib_set(MIB_WPS_DISPLAY_KEY, (void *)&val) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
				goto setErr_wlan;
			}
		}

#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

//20060410 pippen
#ifdef _START_BOA_
//	char_t *strEnWiz;

	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page 
	strEnWiz = websGetVar(wp, T("wizEnabled"), T(""));      //Felix
	wizardEnabled = atoi(strEnWiz);
	if (wizardEnabled==1){
		REPLACE_MSG(submitUrl);
	}
	else {
		OK_MSG(submitUrl);
	}
#else
	submitUrl = websGetVar(wp, T("wlan-url"), T(""));   // hidden page
		strnextEnable = websGetVar(wp, T("redirect"), T(""));
		if (strnextEnable[0] || wizardEnabled == 1) {
			REPLACE_MSG(submitUrl);
		}
		else {
	OK_MSG(submitUrl);
			//OK_MSG(submitUrl);
		}
#endif
    	return;

setErr_wlan:
	ERR_MSG(tmpBuf);
}
/////////////////////////////////////////////////////////////////////////////
#ifndef HOME_GATEWAY
void formStaEncrypt(webs_t wp, char_t *path, char_t *query)
{
	int keyLen, ret, i;
	WEP_T wep;
	char tmpBuf[100], key[30];
	int intVal=0, method=0, len, eapType=0, secMode=0, enRadius=0,ahSecMode=0;

   	char_t *wepKey, *strKeyLen, *strFormat, *strKeyId, *submitUrl, *strVal;
	char_t *strMethod, *strWepTp, *strEnRadius, *strEapTp;
	char_t *strId, *strPass, *strTtls, *strPeap, *strEapId, *strEapPass;
	char_t *strEnCltCer, *strEnSerCer, *strCltPass, *strSerPass;

	strMethod = websGetVar(wp, T("method"), T(""));
	method = strMethod[0] - '0';
	if ( !apmib_set( MIB_STA_ENCRYPT, (void *)&method ) ) {
 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt1))</script>"));
		goto setErr_encrypt;
	}

//*********************************** Wep setting ***********************************
	strWepTp = websGetVar(wp, T("wepTp"), T(""));

	if ( method==1 || (method==0 && strWepTp[0]=='1')) {
		strKeyLen = websGetVar(wp, T("length"), T(""));
		if (!strKeyLen[0]) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt2))</script>"));
			goto setErr_encrypt;
		}
		if (strKeyLen[0]!='1' && strKeyLen[0]!='2' && strKeyLen[0]!='3') {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt3))</script>"));
			goto setErr_encrypt;
		}
		if (strKeyLen[0] == '1')
			wep = WEP64;
		else if (strKeyLen[0] == '2')
			wep = WEP128;
		else
			wep = WEP152;
	}
	else
		wep = WEP_DISABLED;

	if ( apmib_set( MIB_STA_WEP, (void *)&wep) == 0) {
  		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt4))</script>"));
		goto setErr_encrypt;
	}

//	if (wep == WEP_DISABLED)
//		goto setwep_ret;

	if ( method==1 || (method==0 && strWepTp[0]=='1')) {
		strFormat = websGetVar(wp, T("format"), T(""));
		if (!strFormat[0]) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt5))</script>"));
			goto setErr_encrypt;
		}

		if (strFormat[0]!='1' && strFormat[0]!='2') {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt6))</script>"));
			goto setErr_encrypt;
		}

		i = strFormat[0] - '0' - 1;
		if ( apmib_set( MIB_STA_WEP_KEY_TYPE, (void *)&i) == 0) {
  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt7))</script>"));
			goto setErr_encrypt;
		}

		if (wep == WEP64) {
			if (strFormat[0]=='1')
				keyLen = WEP64_KEY_LEN;
			else
				keyLen = WEP64_KEY_LEN*2;
		}
		else if (wep == WEP128) {
			if (strFormat[0]=='1')
				keyLen = WEP128_KEY_LEN;
			else
				keyLen = WEP128_KEY_LEN*2;
		}
		else {
			if (strFormat[0]=='1')
				keyLen = WEP152_KEY_LEN;
			else
				keyLen = WEP152_KEY_LEN*2;
		}

		strKeyId = websGetVar(wp, T("defaultTxKeyId"), T(""));
		if ( strKeyId[0] ) {
			if ( strKeyId[0]!='1' && strKeyId[0]!='2' && strKeyId[0]!='3' && strKeyId[0]!='4' ) {
		 		DEBUGP(tmpBuf, T("<script>document.write(showText())</script>Invalid default tx key id!"));
   				goto setErr_encrypt;
			}
			i = strKeyId[0] - '0' - 1;
			if ( !apmib_set( MIB_STA_WEP_DEFKEY, (void *)&i ) ) {
		 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt8))</script>"));
   				goto setErr_encrypt;
			}
		}

		wepKey = websGetVar(wp, T("key1"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt10))</script>"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt11))</script>"));
						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_STA_WEP64_KEY1, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_STA_WEP128_KEY1, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY1, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt12))</script>"));
					goto setErr_encrypt;
				}
			}
		}
		wepKey = websGetVar(wp, T("key2"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt13))</script>"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt14))</script>"));
   						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_STA_WEP64_KEY2, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_STA_WEP128_KEY2, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY2, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt15))</script>"));
					goto setErr_encrypt;
				}
			}
		}

		wepKey = websGetVar(wp, T("key3"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt16))</script>"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt17))</script>"));
   						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_STA_WEP64_KEY3, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_STA_WEP128_KEY3, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY3, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt18))</script>"));
					goto setErr_encrypt;
				}
			}
		}

		wepKey = websGetVar(wp, T("key4"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt10))</script>"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt19))</script>"));
   						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_STA_WEP64_KEY4, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_STA_WEP128_KEY4, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY4, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt20))</script>"));
					goto setErr_encrypt;
				}
			}
		}
	}

	if ( method==2 || method==3) {
		strVal = websGetVar(wp, T("wpaCipher"), T(""));
		intVal = strVal[0] - '0';
		if ( apmib_set(MIB_STA_WPA_CIPHER_SUITE, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
			goto setErr_encrypt;
		}
	}
//*********************************** pre-shared key setting ***********************************
	if ( method==2 ) {
		int oldFormat, oldPskLen, i;

		strVal = websGetVar(wp, T("pskFormat"), T(""));
		if (!strVal[0]) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt22))</script>"));
			goto setErr_encrypt;
		}
		intVal = strVal[0] - '0';
		if (intVal != 0 && intVal != 1) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt23))</script>"));
			goto setErr_encrypt;
		}

		// remember current psk format and length to compare to default case "****"
		apmib_get(MIB_STA_WPA_PSK_FORMAT, (void *)&oldFormat);
		apmib_get(MIB_STA_WPA_PSK, (void *)tmpBuf);
		oldPskLen = strlen(tmpBuf);

		strVal = websGetVar(wp, T("psk"), T(""));
		len = strlen(strVal);

		if (oldFormat == intVal && len == oldPskLen ) {
			for (i=0; i<len; i++) {
				if ( strVal[i] != '*' )
					break;
			}
			if (i == len)
				goto setwep_ret;
		}

		if ( apmib_set(MIB_STA_WPA_PSK_FORMAT, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt24))</script>"));
			goto setErr_encrypt;
		}

		if (intVal==1) { // hex
			if (len!=MAX_PSK_LEN || !string_to_hex(strVal, tmpBuf, MAX_PSK_LEN)) {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt25))</script>"));
				goto setErr_encrypt;
			}
		}
		else { // passphras
			if (len==0 || len > (MAX_PSK_LEN-1) ) {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt25))</script>"));
				goto setErr_encrypt;
			}
		}
		if ( !apmib_set(MIB_STA_WPA_PSK, (void *)strVal)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt26))</script>"));
			goto setErr_encrypt;
		}
	}
//**************************************** Radius ****************************************
	if (method!=3) {
		strEnRadius = websGetVar(wp, T("enRadius"), T(""));
		if ( !gstrcmp(strEnRadius, T("ON")))
			enRadius = 1;
		else
			enRadius = 0;
	}
	else
		enRadius = 1;
	if ( !apmib_set( MIB_STA_ENRADIUS, (void *)&enRadius ) ) {
 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt27))</script>"));
		goto setErr_encrypt;
	}

	if ( enRadius==1 && method!=2 ) {

		strEapTp = websGetVar(wp, T("eapType"), T(""));
		eapType = strEapTp[0] - '0';
		if ( !apmib_set( MIB_STA_EAP_TYPE, (void *)&eapType ) ) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt28))</script>"));
			goto setErr_encrypt;
		}
		strId = websGetVar(wp, T("identity"), T(""));
		if ( strId[0] ) {
			if ( apmib_set( MIB_STA_ID, (void *)strId) == 0) {
   		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt29))</script>"));
					goto setErr_encrypt;
			}
		}
		if ( eapType==3 ) {
			strPass = websGetVar(wp, T("md5Pass"), T(""));
			if ( strPass[0] ) {
				if ( apmib_set( MIB_STA_PASS, (void *)strPass) == 0) {
   			 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt30))</script>"));
						goto setErr_encrypt;
				}
			}
		}

		if ( eapType==0 ) {
			strPeap = websGetVar(wp, T("peap"), T(""));
			if ( strPeap[0] ) {
				if ( apmib_set( MIB_STA_PROTOCOL, (void *)strPeap) == 0) {
   			 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt31))</script>"));
						goto setErr_encrypt;
				}
			}
		}
		else if ( eapType==2 ) {
			strTtls = websGetVar(wp, T("ttls"), T(""));
			if ( strTtls[0] ) {
				if ( apmib_set( MIB_STA_PROTOCOL, (void *)strTtls) == 0) {
   		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt31))</script>"));
					goto setErr_encrypt;
				}
			}
		}

		if ( eapType==0 || eapType==2) {
			strEapId = websGetVar(wp, T("eapId"), T(""));
			if ( strEapId[0] ) {
				if ( apmib_set( MIB_STA_EAP_ID, (void *)strEapId) == 0) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt32))</script>"));
					goto setErr_encrypt;
				}
			}

			strEapPass = websGetVar(wp, T("eapPass"), T(""));
			if ( strEapPass[0] ) {
				if ( apmib_set( MIB_STA_EAP_PASS, (void *)strEapPass) == 0) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt33))</script>"));
					goto setErr_encrypt;
				}
			}
		}

		if ( eapType!=1 ) {
			strEnCltCer = websGetVar(wp, T("enCltCer"), T(""));
			if ( !gstrcmp(strEnCltCer, T("ON")))
				intVal = 1;
			else
				intVal = 0;
		}
		else {
			intVal = 1;
		}
		if ( !apmib_set( MIB_STA_ENCLT_CER, (void *)&intVal ) ) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt34))</script>"));
			goto setErr_encrypt;
		}

		strCltPass = websGetVar(wp, T("cltPass"), T(""));
		if ( strCltPass[0] ) {
			if ( apmib_set( MIB_STA_CLIENT_PASS, (void *)strCltPass) == 0) {
   		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt35))</script>"));
					goto setErr_encrypt;
			}
		}

		strEnSerCer = websGetVar(wp, T("enSerCer"), T(""));
		if ( !gstrcmp(strEnSerCer, T("ON")))
			intVal = 1;
		else
			intVal = 0;
		if ( !apmib_set( MIB_STA_ENSER_CER, (void *)&intVal ) ) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt36))</script>"));
			goto setErr_encrypt;
		}

		strSerPass = websGetVar(wp, T("serPass"), T(""));
		if ( strSerPass[0] ) {
			if ( apmib_set( MIB_STA_SERVER_PASS, (void *)strSerPass) == 0) {
   		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt37))</script>"));
					goto setErr_encrypt;
			}
		}
	}

setwep_ret:


	apmib_get( MIB_AP_MODE, (void *)&intVal);

//	if ( intVal == 2) {

		if (method==0 && wep==WEP_DISABLED && enRadius==0) {
			ahSecMode = 0;
			secMode = 0;
		}
		else if ((method==0 || method==1) && wep!=WEP_DISABLED && enRadius==0) {
			ahSecMode = 1;
			secMode = 1;
		}
		else if (method==0 &&  wep==WEP_DISABLED && enRadius==1) {
			ahSecMode = 0;
			secMode = 2;
		}
		else if ((method==0 || method==1) && wep!=WEP_DISABLED && enRadius==1) {
			ahSecMode = 1;
			secMode = 3;
		}
		else if (method==2) {
			ahSecMode = 0;
			secMode = 4;
		}
		else {
			ahSecMode = 0;
			secMode = 5;
		}

		if ( !apmib_set( MIB_STA_SEC_MODE, (void *)&secMode ) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt38))</script>"));
			goto setErr_encrypt;
		}

		if ( !apmib_set( MIB_ADHOC_SEC_MODE, (void *)&ahSecMode ) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt39))</script>"));
			goto setErr_encrypt;
		}
/*	}
	else if (intVal ==1) {
		if (method==0 && wep==WEP_DISABLED)
			secMode = 0;
		else
			secMode = 1;

		if ( !apmib_set( MIB_ADHOC_SEC_MODE, (void *)&secMode ) ) {
			DEBUGP(tmpBuf, T("Set MIB_ADHOC_SEC_MODE error!"));
			goto setErr_encrypt;
		}
	}
*/

	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	#ifdef HOME_GATEWAY
		//sprintf(tmpBuf, "%s %s %s", "/bin/init.sh", "gw", "all"); // Tommy
		//system(tmpBuf);
	#else
		//sprintf(tmpBuf, "%s %s %s", "/bin/init.sh", "ap", "all"); // Tommy
		//system(tmpBuf);
	#endif
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	OK_MSG(submitUrl);

	return;

setErr_encrypt:
	ERR_MSG(tmpBuf);
}
#endif


/////////////////////////////////////////////////////////////////////////////
#ifndef HOME_GATEWAY

#if 0
void formStaSec(webs_t wp, char_t *path, char_t *query)
{
   	char_t *wepKey;
   	char_t *strKeyLen, *strFormat, *strKeyId, *strEnabled;
	char key[30];
	int enabled, keyLen, ret, i;
	WEP_T wep;


   	char_t *submitUrl, *strEncrypt, *strVal;
	char tmpBuf[100];
	ENCRYPT_T encrypt;
	int enableRS=0, intVal, getPSK=0, len;




	//Set security method
   	strEncrypt = websGetVar(wp, T("method"), T(""));
	if (!strEncrypt[0]) {
 		DEBUGP(tmpBuf, T("Error! no encryption method."));
		goto setErr_encrypt;
	}
	encrypt = (ENCRYPT_T) strEncrypt[0] - '0';
	if (encrypt!=ENCRYPT_DISABLED && encrypt!=ENCRYPT_WEP && encrypt!=ENCRYPT_WPA &&
		encrypt!=ENCRYPT_WSK && encrypt!=ENCRYPT_PSK && encrypt!=ENCRYPT_ARS) {
		DEBUGP(tmpBuf, T("Invalid encryption method!"));
		goto setErr_encrypt;
	}
	if (apmib_set( MIB_STA_SEC_MODE, (void *)&encrypt) == 0) {
  		DEBUGP(tmpBuf, T("Set MIB_STA_SEC_MODE mib error!"));
		goto setErr_encrypt;
	}

	//Follow Realtek, Set WLAN_ENCRYPT
	if (encrypt==ENCRYPT_DISABLED || encrypt==ENCRYPT_WPA)
		intVal = 0;
	else if (encrypt==ENCRYPT_WEP || encrypt==ENCRYPT_WSK)
		intVal = 1;
	else
		intVal = 2;
	if (apmib_set( MIB_STA_ENCRYPT, (void *)&intVal) == 0) {
  		DEBUGP(tmpBuf, T("Set MIB_STA_ENCRYPT mib error!"));
		goto setErr_encrypt;
	}


   	strEncrypt = websGetVar(wp, T("method"), T(""));
	if (strEncrypt[0]=='0')
		intVal=0;
	else if (strEncrypt[0]=='1')
		intVal=1;
	else
		intVal=2;
	if (apmib_set( MIB_STA_ENCRYPT, (void *)&intVal) == 0) {
  		DEBUGP(tmpBuf, T("Set  mib error!"));
		goto setErr_encrypt;
	}





	// WPA authentication
	if (encrypt!=ENCRYPT_DISABLED && encrypt!=ENCRYPT_WEP) {
		strVal = websGetVar(wp, T("wpaAuth"), T(""));
		if (strVal[0]) {
			if ( !gstrcmp(strVal, T("eap"))) {
				intVal = WPA_AUTH_AUTO;
				enableRS = 1;
			}
			else if ( !gstrcmp(strVal, T("psk"))) {
				intVal = WPA_AUTH_PSK;
				getPSK = 1;
			}
			else {
				DEBUGP(tmpBuf, T("Error! Invalid wpa authentication value."));
				goto setErr_encrypt;
			}
			if ( apmib_set(MIB_STA_WPA_AUTH, (void *)&intVal) == 0) {
				DEBUGP(tmpBuf, T("Set MIB_STA_AUTH_TYPE failed!"));
				goto setErr_encrypt;
			}
		}
	}

	// cipher suite
	if (encrypt==ENCRYPT_PSK || encrypt==ENCRYPT_ARS) {
		strVal = websGetVar(wp, T("wpaCipher"), T(""));
		intVal = strVal[0] - '0';
		if ( apmib_set(MIB_STA_WPA_CIPHER_SUITE, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("Set MIB_STA_WPA_CIPHER_SUITE failed!"));
			goto setErr_encrypt;
		}
/*		intVal = 0;
		strVal = websGetVar(wp, T("tkip"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			intVal |= WPA_CIPHER_TKIP;
		strVal = websGetVar(wp, T("aes"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			intVal |= WPA_CIPHER_AES;
		if (intVal == 0) {
			DEBUGP(tmpBuf, T("Invalid value of cipher suite!"));
			goto setErr_encrypt;
		}
		if ( apmib_set(MIB_STA_WPA_CIPHER_SUITE, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("Set MIB_STA_WPA_CIPHER_SUITE failed!"));
			goto setErr_encrypt;
		}
*/	}

//*********************************** Wep setting ***********************************
	strEnabled = websGetVar(wp, T("wepEnabled"), T(""));
	if ( !gstrcmp(strEnabled, T("ON")))
		enabled = 1;
	else
		enabled = 0;

	if ( enabled ) {
		strKeyLen = websGetVar(wp, T("length"), T(""));
		if (!strKeyLen[0]) {
 			DEBUGP(tmpBuf, T("Key length must exist!"));
			goto setErr_encrypt;
		}
		if (strKeyLen[0]!='1' && strKeyLen[0]!='2' && strKeyLen[0]!='3') {
 			DEBUGP(tmpBuf, T("Invalid key length value!"));
			goto setErr_encrypt;
		}
		if (strKeyLen[0] == '1')
			wep = WEP64;
		else if (strKeyLen[0] == '2')
			wep = WEP128;
		else
			wep = WEP152;
	}
	else
		wep = WEP_DISABLED;

	if ( apmib_set( MIB_STA_WEP, (void *)&wep) == 0) {
  		DEBUGP(tmpBuf, T("Set STA WEP error!"));
		goto setErr_encrypt;
	}

	if (wep == WEP_DISABLED)
		goto setwep_ret;

	if (encrypt==ENCRYPT_WEP || encrypt==ENCRYPT_WSK) { //Erwin Modify 01.09.'03
		strFormat = websGetVar(wp, T("format"), T(""));
		if (!strFormat[0]) {
 			DEBUGP(tmpBuf, T("Key type must exist!"));
			goto setErr_encrypt;
		}

		if (strFormat[0]!='1' && strFormat[0]!='2') {
			DEBUGP(tmpBuf, T("Invalid key type value!"));
			goto setErr_encrypt;
		}

		i = strFormat[0] - '0' - 1;
		if ( apmib_set( MIB_STA_WEP_KEY_TYPE, (void *)&i) == 0) {
  			DEBUGP(tmpBuf, T("Set WEP key type error!"));
			goto setErr_encrypt;
		}

		if (wep == WEP64) {
			if (strFormat[0]=='1')
				keyLen = WEP64_KEY_LEN;
			else
				keyLen = WEP64_KEY_LEN*2;
		}
		else if (wep == WEP128) {
			if (strFormat[0]=='1')
				keyLen = WEP128_KEY_LEN;
			else
				keyLen = WEP128_KEY_LEN*2;
		}
		else {
			if (strFormat[0]=='1')
				keyLen = WEP152_KEY_LEN;
			else
				keyLen = WEP152_KEY_LEN*2;
		}

		strKeyId = websGetVar(wp, T("defaultTxKeyId"), T(""));
		if ( strKeyId[0] ) {
			if ( strKeyId[0]!='1' && strKeyId[0]!='2' && strKeyId[0]!='3' && strKeyId[0]!='4' ) {
		 		DEBUGP(tmpBuf, T("Invalid default tx key id!"));
   				goto setErr_encrypt;
			}
			i = strKeyId[0] - '0' - 1;
			if ( !apmib_set( MIB_STA_WEP_DEFKEY, (void *)&i ) ) {
		 		DEBUGP(tmpBuf, T("Set default tx key id error!"));
   				goto setErr_encrypt;
			}
		}

		wepKey = websGetVar(wp, T("key1"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("Invalid key 1 length!"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("Invalid wep-key1 value!"));
						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_STA_WEP64_KEY1, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_STA_WEP128_KEY1, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY1, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("Set wep-key1 error!"));
					goto setErr_encrypt;
				}
			}
		}
		wepKey = websGetVar(wp, T("key2"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("Invalid key 2 length!"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("Invalid wep-key2 value!"));
   						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_STA_WEP64_KEY2, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_STA_WEP128_KEY2, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY2, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("Set wep-key2 error!"));
					goto setErr_encrypt;
				}
			}
		}

		wepKey = websGetVar(wp, T("key3"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("Invalid key 3 length!"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("Invalid wep-key3 value!"));
   						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_STA_WEP64_KEY3, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_STA_WEP128_KEY3, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY3, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("Set wep-key3 error!"));
					goto setErr_encrypt;
				}
			}
		}

		wepKey = websGetVar(wp, T("key4"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("Invalid key 1 length!"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("Invalid wep-key4 value!"));
   						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_STA_WEP64_KEY4, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_STA_WEP128_KEY4, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY4, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("Set wep-key4 error!"));
					goto setErr_encrypt;
				}
			}
		}
	}
//*********************************** pre-shared key setting ***********************************
	if ( getPSK ) {
		int oldFormat, oldPskLen, i;

		strVal = websGetVar(wp, T("pskFormat"), T(""));
		if (!strVal[0]) {
 			DEBUGP(tmpBuf, T("Error! no psk format."));
			goto setErr_encrypt;
		}
		intVal = strVal[0] - '0';
		if (intVal != 0 && intVal != 1) {
 			DEBUGP(tmpBuf, T("Error! invalid psk format."));
			goto setErr_encrypt;
		}

		// remember current psk format and length to compare to default case "****"
		apmib_get(MIB_STA_WPA_PSK_FORMAT, (void *)&oldFormat);
		apmib_get(MIB_STA_WPA_PSK, (void *)tmpBuf);
		oldPskLen = strlen(tmpBuf);

		strVal = websGetVar(wp, T("pskValue"), T(""));
		len = strlen(strVal);

		if (oldFormat == intVal && len == oldPskLen ) {
			for (i=0; i<len; i++) {
				if ( strVal[i] != '*' )
					break;
			}
			if (i == len)
				goto rekey_time;
		}

		if ( apmib_set(MIB_STA_WPA_PSK_FORMAT, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("Set MIB_STA_WPA_PSK_FORMAT failed!"));
			goto setErr_encrypt;
		}

		if (intVal==1) { // hex
			if (len!=MAX_PSK_LEN || !string_to_hex(strVal, tmpBuf, MAX_PSK_LEN)) {
 				DEBUGP(tmpBuf, T("Error! invalid psk value."));
				goto setErr_encrypt;
			}
		}
		else { // passphras
			if (len==0 || len > (MAX_PSK_LEN-1) ) {
 				DEBUGP(tmpBuf, T("Error! invalid psk value."));
				goto setErr_encrypt;
			}
		}
		if ( !apmib_set(MIB_STA_WPA_PSK, (void *)strVal)) {
			DEBUGP(tmpBuf, T("Set MIB_STA_WPA_PSK error!"));
			goto setErr_encrypt;
		}
	}
//****************************************  ****************************************
rekey_time:

		// get 802.1x WEP key length
		strVal = websGetVar(wp, T("wepKeyLen"), T(""));
		if (strVal[0]) {
			if ( !gstrcmp(strVal, T("wep64")))
				intVal = WEP64;
			else if ( !gstrcmp(strVal, T("wep128")))
				intVal = WEP128;
			else {
				DEBUGP(tmpBuf, T("Error! Invalid wepkeylen value."));
				goto setErr_encrypt;
			}
			if ( apmib_set(MIB_STA_WEP, (void *)&intVal) == 0) {
				DEBUGP(tmpBuf, T("Set MIB_STA_WEP failed!"));
				goto setErr_encrypt;
			}
		}
//-----------------------------------------------------------------------------------------------
setwep_ret:
	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	#ifdef HOME_GATEWAY
		sprintf(tmpBuf, "%s %s %s", "/bin/init.sh", "gw", "all");
		system(tmpBuf);
	#else
		sprintf(tmpBuf, "%s %s %s", "/bin/init.sh", "ap", "all");
		system(tmpBuf);
	#endif
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	OK_MSG(submitUrl);

	return;

setErr_encrypt:
	ERR_MSG(tmpBuf);
}
#endif
#endif

#ifdef WLAN_WPA
/////////////////////////////////////////////////////////////////////////////
void formWlEncrypt(webs_t wp, char_t *path, char_t *query)
{
   	char_t *wepKey;
   	char_t *strKeyLen, *strFormat, *strKeyId, *strEnabled, *strWlencryEnable, *strWizSecurity, *strCONNTEST , *wiz_utility;
	char key[30];
	int enabled, keyLen, ret, i,val;
	WEP_T wep;


#ifdef _WEP_OPEN_SHARED_MODE_
	char_t *strWepMode;
#endif
   	char_t *submitUrl, *strEncrypt, *strVal, *strEnRadius, *strWpaCipher, *str1xMode;
	char tmpBuf[100], tmpBuf1[100], tmpBuf2[100];
	ENCRYPT_T encrypt;
	int enableRS=0, intVal, getPSK=0, len, intTkip, intAes;
	unsigned long int longintVal;
	unsigned long reKeyTime;
	SUPP_NONWAP_T suppNonWPA;
	struct in_addr inIp;

#ifdef _MSSID_
char *temp;
int ssidID,broadcast_enable,wepenable;
temp = websGetVar(wp, T("selected_ssid"), T(""));
ssidID = (int)temp[0] - '0';
#endif
		//200703.29 kyle wps status
			intVal = 1;
			if ( apmib_set(MIB_WPS_CONFIG_TYPE, (void *)&intVal) == 0) { //Felix 20120111 !!!
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
				goto setErr_encrypt;
			}
			if ( apmib_set(MIB_WPS_CONFIG_STATUS, (void *)&intVal) == 0) { //Felix 20120111 !!!
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
				goto setErr_encrypt;
			}
			intVal = 0;
			if ( apmib_set(MIB_WPS_DISPLAY_KEY, (void *)&intVal) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
				goto setErr_encrypt;
			}
	//Set security method
   	strEncrypt = websGetVar(wp, T("method"), T(""));

	if (!strEncrypt[0]) {
 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt1))</script>"));
		goto setErr_encrypt;
	}
	encrypt = atoi(strEncrypt);
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	if (encrypt == 1 || encrypt == 2 || encrypt == 3) {	//WEP(Open/share/auto)
	//===============WEB AUTH_TYPE SET===========	//1:OPEN 2:Share 3:Auto
		if ( encrypt == 1 )
			intVal=0;
		else if ( encrypt == 2 )
			intVal=1;
		else if ( encrypt == 3 )
			intVal=2;
		switch(ssidID)
		{
		        case 0: apmib_set( MIB_WLAN_AUTH_TYPE,   (void *)&intVal); break;
               	        case 1: apmib_set( MIB_WLAN_AUTH_TYPE_1,   (void *)&intVal); break;
                       	case 2: apmib_set( MIB_WLAN_AUTH_TYPE_2,   (void *)&intVal); break;
                        case 3: apmib_set( MIB_WLAN_AUTH_TYPE_3,   (void *)&intVal); break;
       	                case 4: apmib_set( MIB_WLAN_AUTH_TYPE_4,   (void *)&intVal); break;
               	        case 5: apmib_set( MIB_WLAN_AUTH_TYPE_5,   (void *)&intVal); break;
                       	case 6: apmib_set( MIB_WLAN_AUTH_TYPE_6,   (void *)&intVal); break;
                        case 7: apmib_set( MIB_WLAN_AUTH_TYPE_7,   (void *)&intVal); break;
		        default: break; 
		}
                encrypt=1;	
	//===============WEB AUTH_TYPE SET end===========
	}
	else if(encrypt == 5 || encrypt == 7 || encrypt == 8)	//WPA-PSK/WPA2-PSK/WPA-PSK+WPA2-PSK
		encrypt=2;
	else if (encrypt == 4 || encrypt == 6 || encrypt == 9)	//WPA/WPA2/WPA+WPA2
		encrypt=3;
	else if (encrypt == 10){
		encrypt=0;
	}
#endif

#ifdef _MSSID_

//char *temp;
//int ssidID;
temp=websGetVar(wp, T("selected_ssid"), T(""));
ssidID=(int)temp[0] - '0';
switch(ssidID)
{
	case 0: apmib_set( MIB_SECURITY_MODE, (void *)&encrypt); break;
	case 1: apmib_set( MIB_SECURITY_MODE_1, (void *)&encrypt); break;
	case 2: apmib_set( MIB_SECURITY_MODE_2, (void *)&encrypt); break;
	case 3: apmib_set( MIB_SECURITY_MODE_3, (void *)&encrypt); break;
	case 4: apmib_set( MIB_SECURITY_MODE_4, (void *)&encrypt); break;
	case 5: apmib_set( MIB_SECURITY_MODE_5, (void *)&encrypt); break;
	case 6: apmib_set( MIB_SECURITY_MODE_6, (void *)&encrypt); break;
	case 7: apmib_set( MIB_SECURITY_MODE_7, (void *)&encrypt); break;
	default: break;
}

#else
	if (apmib_set( MIB_SECURITY_MODE, (void *)&encrypt) == 0) {
  		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup9))</script>"));
		goto setErr_encrypt;
	}
#endif

	//Set 802.1x Enable
   	strEnRadius = websGetVar(wp, T("enRadius"), T(""));
	if ( ((encrypt==0 || encrypt==1) && !gstrcmp(strEnRadius, T("ON"))) || encrypt==3) {
		intVal = 1;
		enableRS = 1;
	}
	else
		intVal = 0;

#ifdef _MSSID_
switch(ssidID)
{
	case 0: apmib_set( MIB_WLAN_ENABLE_1X, (void *)&intVal); break;
	case 1: apmib_set( MIB_WLAN_ENABLE_1X_1, (void *)&intVal); break;
	case 2: apmib_set( MIB_WLAN_ENABLE_1X_2, (void *)&intVal); break;
	case 3: apmib_set( MIB_WLAN_ENABLE_1X_3, (void *)&intVal); break;
	case 4: apmib_set( MIB_WLAN_ENABLE_1X_4, (void *)&intVal); break;
	case 5: apmib_set( MIB_WLAN_ENABLE_1X_5, (void *)&intVal); break;
	case 6: apmib_set( MIB_WLAN_ENABLE_1X_6, (void *)&intVal); break;
	case 7: apmib_set( MIB_WLAN_ENABLE_1X_7, (void *)&intVal); break;
	default: break;
}

#else
	if ( apmib_set( MIB_WLAN_ENABLE_1X, (void *)&intVal) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup10))</script>"));
		goto setErr_encrypt;
	}
#endif



#ifndef HOME_GATEWAY
	//set internal or external RADIUS
	str1xMode = websGetVar(wp, T("sel1xMode"), T(""));
	if (!gstrcmp(str1xMode, T("ON")))
		intVal = 1;
	else
		intVal = 0;

	if ( apmib_set(MIB_1X_MODE, (void *)&intVal) == 0) {
		DEBUGP(tmpBuf, T("Set 802.1x Mode failed!"));
		goto setErr_encrypt;
	}
#endif

	// support nonWPA client
	strVal = websGetVar(wp, T("nonWpaSupp"), T(""));
	if ( !gstrcmp(strVal, T("ON")))
		intVal = 1;
	else
		intVal = 0;
	if ( apmib_set( MIB_WLAN_ENABLE_SUPP_NONWPA, (void *)&intVal) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt2))</script>"));
		goto setErr_encrypt;
	}
	if ( intVal ) {
		suppNonWPA = SUPP_NONWPA_NONE;
		strVal = websGetVar(wp, T("nonWpaWep"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			suppNonWPA |= SUPP_NONWPA_WEP;

		strVal = websGetVar(wp, T("nonWpa1x"), T(""));
		if ( !gstrcmp(strVal, T("ON"))) {
			suppNonWPA |= SUPP_NONWPA_1X;
			enableRS = 1;
		}
		if ( apmib_set( MIB_WLAN_SUPP_NONWPA, (void *)&suppNonWPA) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt3))</script>"));
			goto setErr_encrypt;
		}
	}

	if (encrypt==2 || encrypt==3) {
		// WPA authentication
		if (encrypt==2) {
			intVal = WPA_AUTH_PSK;
			getPSK = 1;
		}
		else if (encrypt==3) {
//			intVal = WPA_AUTH_AUTO;
			intVal = 1;
			enableRS = 1;
		}
#ifdef _MSSID_
		switch(ssidID)
		{
	case 0: apmib_set(MIB_WLAN_WPA_AUTH, (void *)&intVal);break;
	case 1: apmib_set(MIB_WLAN_WPA_AUTH_1, (void *)&intVal);break;
	case 2: apmib_set(MIB_WLAN_WPA_AUTH_2, (void *)&intVal);break;
	case 3: apmib_set(MIB_WLAN_WPA_AUTH_3, (void *)&intVal);break;
	case 4: apmib_set(MIB_WLAN_WPA_AUTH_4, (void *)&intVal);break;
	case 5: apmib_set(MIB_WLAN_WPA_AUTH_5, (void *)&intVal);break;
	case 6: apmib_set(MIB_WLAN_WPA_AUTH_6, (void *)&intVal);break;
	case 7: apmib_set(MIB_WLAN_WPA_AUTH_7, (void *)&intVal);break;
	default: break;
		}
#else
		if ( apmib_set(MIB_WLAN_WPA_AUTH, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt4))</script>"));
			goto setErr_encrypt;
		}
#endif
		//if ( apmib_set(MIB_WLAN_WPA_AUTH, (void *)&intVal) == 0) {
		//	DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt4))</script>"));
		//	goto setErr_encrypt;
		//}

		// cipher suite
		strVal = websGetVar(wp, T("wpaCipher"), T(""));
		intVal = strVal[0] - '0';
#if defined(_Customer_SA_) || defined(_Customer_EX_)
                if (strVal[0]) {
                        intTkip=intVal;
			intAes=intVal;
#else
		if (strVal[0]) {
			if (intVal==1 || intVal==3)	intTkip=WPA_CIPHER_TKIP; else intTkip=0;
			if (intVal==2 || intVal==3) intAes=WPA_CIPHER_AES; else intAes=0;
#endif
#ifdef _MSSID_

switch(ssidID)
{
	case 0: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intTkip);   apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intAes);break;
	case 1: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_1, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_1, (void *)&intAes);break;
	case 2: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_2, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_2, (void *)&intAes);break;
	case 3: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_3, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_3, (void *)&intAes);break;
	case 4: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_4, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_4, (void *)&intAes);break;
	case 5: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_5, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_5, (void *)&intAes);break;
	case 6: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_6, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_6, (void *)&intAes);break;
	case 7: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_7, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_7, (void *)&intAes);break;
	default: break;
}

#else
			if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intTkip) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
				goto setErr_encrypt;
			}
			if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intAes) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
				goto setErr_encrypt;
			}
#endif
		}
	}

	//Follow Realtek, Set WLAN_ENCRYPT
	strWpaCipher = websGetVar(wp, T("wpaCipher"), T(""));
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	strEncrypt = websGetVar(wp, T("method"), T(""));
	encrypt = atoi(strEncrypt);
	if (!(strEncrypt[1] - '0'))
		encrypt=0;
	else {
		if ( encrypt == 0 || encrypt == 10)	encrypt=0;	//disable,802.1X
		else if ( encrypt > 0 && encrypt < 4)	encrypt=1;	//WEP
		else if ( encrypt == 4 || encrypt == 5 )encrypt=2;	//WPA
		else if ( encrypt == 6 || encrypt == 7)	encrypt=4;	//WPA2
		else if ( encrypt == 8 || encrypt == 9 )encrypt=6;	//WPA+WPA2
	}
#else
	if (strEncrypt[0]=='0')	encrypt=0;
	else if (strEncrypt[0]=='1') encrypt=1;
	else if (((strEncrypt[0]=='2')||(strEncrypt[0]=='3')) && (strWpaCipher[0]=='1')) encrypt=2;
	else if (((strEncrypt[0]=='2')||(strEncrypt[0]=='3')) && (strWpaCipher[0]=='2')) encrypt=4;
	else if (((strEncrypt[0]=='2')||(strEncrypt[0]=='3')) && (strWpaCipher[0]=='3')) encrypt=6;
#endif
#ifdef _MSSID_
	switch(ssidID)
	{
		case 0:
			apmib_set( MIB_WLAN_ENCRYPT, (void *)&encrypt);

		break;
		case 1:	apmib_set( MIB_WLAN_ENCRYPT_1, (void *)&encrypt); break;
		case 2:	apmib_set( MIB_WLAN_ENCRYPT_2, (void *)&encrypt); break;
		case 3:	apmib_set( MIB_WLAN_ENCRYPT_3, (void *)&encrypt); break;
		case 4:	apmib_set( MIB_WLAN_ENCRYPT_4, (void *)&encrypt); break;
		case 5:	apmib_set( MIB_WLAN_ENCRYPT_5, (void *)&encrypt); break;
		case 6:	apmib_set( MIB_WLAN_ENCRYPT_6, (void *)&encrypt); break;
		case 7:	apmib_set( MIB_WLAN_ENCRYPT_7, (void *)&encrypt); break;
		default: break;
	}
#else
	if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&encrypt) == 0) {
  		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
		goto setErr_encrypt;
	}
#endif
//*********************************** Wep setting ***********************************
	if (encrypt==ENCRYPT_WEP) {
		strEnabled = websGetVar(wp, T("wepEnabled"), T(""));
		if ( !gstrcmp(strEnabled, T("ON")))
			enabled = 1;
		else
			enabled = 0;

		if ( enabled ) {
			strKeyLen = websGetVar(wp, T("length"), T(""));
			if (!strKeyLen[0]) {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt2))</script>"));
				goto setErr_encrypt;
			}
			if (strKeyLen[0]!='1' && strKeyLen[0]!='2' && strKeyLen[0]!='3') {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt3))</script>"));
				goto setErr_encrypt;
			}
			if (strKeyLen[0] == '1')
				wep = WEP64;
			else if (strKeyLen[0] == '2')
				wep = WEP128;
			else
				wep = WEP152;
		}
		else
			wep = WEP_DISABLED;

#ifdef _MSSID_

switch(ssidID)
{
	case 0:	apmib_set( MIB_WLAN_WEP, (void *)&wep);  break;
	case 1:	apmib_set( MIB_WLAN_WEP_1, (void *)&wep);break;
	case 2:	apmib_set( MIB_WLAN_WEP_2, (void *)&wep);break;
	case 3:	apmib_set( MIB_WLAN_WEP_3, (void *)&wep);break;
	case 4:	apmib_set( MIB_WLAN_WEP_4, (void *)&wep);break;
	case 5:	apmib_set( MIB_WLAN_WEP_5, (void *)&wep);break;
	case 6:	apmib_set( MIB_WLAN_WEP_6, (void *)&wep);break;
	case 7:	apmib_set( MIB_WLAN_WEP_7, (void *)&wep);break;
	default:break;
}
#else
		if ( apmib_set( MIB_WLAN_WEP, (void *)&wep) == 0) {
  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt5))</script>"));
			goto setErr_encrypt;
		}
#endif
		if (wep == WEP_DISABLED)
			goto setwep_ret;

		strFormat = websGetVar(wp, T("format"), T(""));
		if (!strFormat[0]) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt5))</script>"));
			goto setErr_encrypt;
		}

		if (strFormat[0]!='1' && strFormat[0]!='2') {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt6))</script>"));
			goto setErr_encrypt;
		}

		i = strFormat[0] - '0' - 1;

#ifdef _MSSID_

switch(ssidID)
{
	case 0:	apmib_set( MIB_WLAN_WEP_KEY_TYPE, (void *)&i);  break;
	case 1:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_1, (void *)&i);break;
	case 2:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_2, (void *)&i);break;
	case 3:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_3, (void *)&i);break;
	case 4:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_4, (void *)&i);break;
	case 5:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_5, (void *)&i);break;
	case 6:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_6, (void *)&i);break;
	case 7:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_7, (void *)&i);break;
	default:break;
}
#else
		if ( apmib_set( MIB_WLAN_WEP_KEY_TYPE, (void *)&i) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt7))</script>"));
			goto setErr_encrypt;
		}
#endif
		if (wep == WEP64) {
			if (strFormat[0]=='1')
				keyLen = WEP64_KEY_LEN;
			else
				keyLen = WEP64_KEY_LEN*2;
		}
		else if (wep == WEP128) {
			if (strFormat[0]=='1')
				keyLen = WEP128_KEY_LEN;
			else
				keyLen = WEP128_KEY_LEN*2;
		}
		else {
			if (strFormat[0]=='1')
				keyLen = WEP152_KEY_LEN;
			else
				keyLen = WEP152_KEY_LEN*2;
		}
		strKeyId = websGetVar(wp, T("defaultTxKeyId"), T(""));
		if ( strKeyId[0] ) {
			if ( strKeyId[0]!='1' && strKeyId[0]!='2' && strKeyId[0]!='3' && strKeyId[0]!='4' ) {
		 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt8))</script>"));
				goto setErr_encrypt;
			}
			i = strKeyId[0] - '0' - 1;

#ifdef _MSSID_
			switch(ssidID)
			{
				case 0:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&i);  break;
				case 1:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_1, (void *)&i);break;
				case 2:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_2, (void *)&i);break;
				case 3:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_3, (void *)&i);break;
				case 4:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_4, (void *)&i);break;
				case 5:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_5, (void *)&i);break;
				case 6:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_6, (void *)&i);break;
				case 7:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_7, (void *)&i);break;
				default:break;
			}
#else
			if ( !apmib_set( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&i ) ) {
		 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt9))</script>"));
				goto setErr_encrypt;
			}
#endif
		}




#ifdef _MSSID_

wepKey = websGetVar(wp, T("key1"), T(""));
if( wepKey[0] && strlen(wepKey) == keyLen && !isAllStar(wepKey) )
{
	if (strFormat[0] == '1')	strcpy(key, wepKey);
	else				string_to_hex(wepKey, key, keyLen);

	if (wep == WEP64)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP64_KEY1, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP64_KEY1_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP64_KEY1_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP64_KEY1_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP64_KEY1_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP64_KEY1_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP64_KEY1_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP64_KEY1_7, (void *)&key);	break;
			default:break;
		}
	else if	(wep == WEP128)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP128_KEY1, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP128_KEY1_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP128_KEY1_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP128_KEY1_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP128_KEY1_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP128_KEY1_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP128_KEY1_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP128_KEY1_7, (void *)&key);	break;
			default:break;
		}
	/*else
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP152_KEY1, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP152_KEY1_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP152_KEY1_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP152_KEY1_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP152_KEY1_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP152_KEY1_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP152_KEY1_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP152_KEY1_7, (void *)&key);	break;
			default:break;
		}*/
}
wepKey = websGetVar(wp, T("key2"), T(""));
if( wepKey[0] && strlen(wepKey) == keyLen && !isAllStar(wepKey) )
{
	if (strFormat[0] == '1')	strcpy(key, wepKey);
	else						string_to_hex(wepKey, key, keyLen);

	if (wep == WEP64)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP64_KEY2, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP64_KEY2_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP64_KEY2_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP64_KEY2_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP64_KEY2_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP64_KEY2_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP64_KEY2_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP64_KEY2_7, (void *)&key);	break;
			default:break;
		}
	else if	(wep == WEP128)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP128_KEY2, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP128_KEY2_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP128_KEY2_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP128_KEY2_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP128_KEY2_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP128_KEY2_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP128_KEY2_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP128_KEY2_7, (void *)&key);	break;
			default:break;
		}
	/*else
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP152_KEY2, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP152_KEY2_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP152_KEY2_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP152_KEY2_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP152_KEY2_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP152_KEY2_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP152_KEY2_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP152_KEY2_7, (void *)&key);	break;
			default:break;
		}*/
}
wepKey = websGetVar(wp, T("key3"), T(""));
if( wepKey[0] && strlen(wepKey) == keyLen && !isAllStar(wepKey) )
{
	if (strFormat[0] == '1')	strcpy(key, wepKey);
	else						string_to_hex(wepKey, key, keyLen);

	if (wep == WEP64)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP64_KEY3, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP64_KEY3_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP64_KEY3_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP64_KEY3_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP64_KEY3_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP64_KEY3_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP64_KEY3_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP64_KEY3_7, (void *)&key);	break;
			default:break;
		}
	else if	(wep == WEP128)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP128_KEY3, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP128_KEY3_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP128_KEY3_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP128_KEY3_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP128_KEY3_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP128_KEY3_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP128_KEY3_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP128_KEY3_7, (void *)&key);	break;
			default:break;
		}
	/*else
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP152_KEY3, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP152_KEY3_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP152_KEY3_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP152_KEY3_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP152_KEY3_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP152_KEY3_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP152_KEY3_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP152_KEY3_7, (void *)&key);	break;
			default:break;
		}*/
}
wepKey = websGetVar(wp, T("key4"), T(""));
if( wepKey[0] && strlen(wepKey) == keyLen && !isAllStar(wepKey) )
{
	if (strFormat[0] == '1')	strcpy(key, wepKey);
	else						string_to_hex(wepKey, key, keyLen);

	if (wep == WEP64)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP64_KEY4, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP64_KEY4_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP64_KEY4_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP64_KEY4_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP64_KEY4_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP64_KEY4_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP64_KEY4_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP64_KEY4_7, (void *)&key);	break;
			default:break;
		}
	else if	(wep == WEP128)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP128_KEY4, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP128_KEY4_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP128_KEY4_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP128_KEY4_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP128_KEY4_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP128_KEY4_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP128_KEY4_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP128_KEY4_7, (void *)&key);	break;
			default:break;
		}
	/*else
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP152_KEY4, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP152_KEY4_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP152_KEY4_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP152_KEY4_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP152_KEY4_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP152_KEY4_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP152_KEY4_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP152_KEY4_7, (void *)&key);	break;
			default:break;
		}*/
}
#else
		wepKey = websGetVar(wp, T("key1"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt10))</script>"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt11))</script>"));
						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_WLAN_WEP64_KEY1, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_WLAN_WEP128_KEY1, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY1, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt12))</script>"));
					goto setErr_encrypt;
				}
			}
		}

		wepKey = websGetVar(wp, T("key2"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt13))</script>"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt14))</script>"));
						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_WLAN_WEP64_KEY2, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_WLAN_WEP128_KEY2, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY2, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt15))</script>"));
					goto setErr_encrypt;
				}
			}
		}

		wepKey = websGetVar(wp, T("key3"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt16))</script>"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt17))</script>"));
						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_WLAN_WEP64_KEY3, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_WLAN_WEP128_KEY3, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY3, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt18))</script>"));
					goto setErr_encrypt;
				}
			}
		}


		wepKey = websGetVar(wp, T("key4"), T(""));

		if(wepKey[0])
		{
			if (strlen(wepKey) != keyLen)
			{
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt10))</script>"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) )
			{
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else // hex
				{
					if ( !string_to_hex(wepKey, key, keyLen))
					{
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt19))</script>"));
						goto setErr_encrypt;
					}
				}

				if (wep == WEP64)        ret=apmib_set(MIB_WLAN_WEP64_KEY4, (void *)key);
				else if (wep == WEP128) ret=apmib_set(MIB_WLAN_WEP128_KEY4, (void *)key);
				else                     ret=apmib_set(MIB_WLAN_WEP152_KEY4, (void *)key);

				if (!ret)
				{
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt20))</script>"));
					goto setErr_encrypt;
				}
			}
		}

#endif
	}

//*********************************** pre-shared key setting ***********************************
	if ( getPSK ) {
		int oldFormat, oldPskLen, i;

		strVal = websGetVar(wp, T("pskFormat"), T(""));
		if (!strVal[0]) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt22))</script>"));
			goto setErr_encrypt;
		}
		intVal = strVal[0] - '0';
		if (intVal != 0 && intVal != 1) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt23))</script>"));
			goto setErr_encrypt;
		}

		// remember current psk format and length to compare to default case "****"
#ifdef _MSSID_
		//vance 2009.02.23 fixed pskvalue error
		switch(ssidID)
		{
			case 0:apmib_get(MIB_WLAN_WPA_PSK_FORMAT, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK, (void *)tmpBuf);break;
			case 1:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_1, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_1, (void *)tmpBuf);break;
			case 2:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_2, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_2, (void *)tmpBuf);break;
			case 3:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_3, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_3, (void *)tmpBuf);break;
			case 4:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_4, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_4, (void *)tmpBuf);break;
			case 5:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_5, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_5, (void *)tmpBuf);break;
			case 6:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_6, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_6, (void *)tmpBuf);break;
			case 7:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_7, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_7, (void *)tmpBuf);break;
			default:break;
		}
		oldPskLen = strlen(tmpBuf);

		strVal = websGetVar(wp, T("pskValue"), T(""));
		len = strlen(strVal);
			if (oldFormat == intVal && len == oldPskLen ) {
				for (i=0; i<len; i++) {
					if ( strVal[i] != '*' )
						break;
				}
				if (i == len)
					goto rekey_time;
			}
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WPA_PSK_FORMAT, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK, (void *)strVal);	break;
			case 1: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_1, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_1, (void *)strVal);	break;
			case 2: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_2, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_2, (void *)strVal);	break;
			case 3: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_3, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_3, (void *)strVal);	break;
			case 4: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_4, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_4, (void *)strVal);	break;
			case 5: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_5, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_5, (void *)strVal);	break;
			case 6: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_6, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_6, (void *)strVal);	break;
			case 7: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_7, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_7, (void *)strVal);	break;
			default:break;
		}
#else
		apmib_get(MIB_WLAN_WPA_PSK_FORMAT, (void *)&oldFormat);
		apmib_get(MIB_WLAN_WPA_PSK, (void *)tmpBuf);
		oldPskLen = strlen(tmpBuf);

		strVal = websGetVar(wp, T("pskValue"), T(""));
		len = strlen(strVal);
		if (oldFormat == intVal && len == oldPskLen ) {
			for (i=0; i<len; i++) {
				if ( strVal[i] != '*' )
					break;
			}
			if (i == len)
				goto rekey_time;
		}
		if ( apmib_set(MIB_WLAN_WPA_PSK_FORMAT, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWdsEncrypt))</script>"));
			goto setErr_encrypt;
		}
		if (intVal==1) { // hex
			if (len!=MAX_PSK_LEN || !string_to_hex(strVal, tmpBuf, MAX_PSK_LEN)) {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt25))</script>"));
				goto setErr_encrypt;
			}
		}
		else { // passphras
			if (len==0 || len > (MAX_PSK_LEN-1) ) {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt25))</script>"));
				goto setErr_encrypt;
			}
		}
		if ( !apmib_set(MIB_WLAN_WPA_PSK, (void *)strVal)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt6))</script>"));
			goto setErr_encrypt;
		}
#endif
	}
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	// set key renewed interval
	strVal = websGetVar(wp, T("RekeyTime"), T(""));
	/*if (!strVal[0]) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt7))</script>"));
		goto setErr_encrypt;
	}*/
	if (!string_to_dec(strVal, &longintVal) || longintVal<0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt19))</script>"));
		goto setErr_encrypt;
	}
        switch(ssidID)
        {
                case 0: apmib_set(MIB_WLAN_WPA_GROUP_REKEY_TIME, (void *)&longintVal);    break;
                case 1: apmib_set(MIB_WLAN_WPA_GROUP_REKEY_TIME_1, (void *)&longintVal);  break;
                case 2: apmib_set(MIB_WLAN_WPA_GROUP_REKEY_TIME_2, (void *)&longintVal);  break;
                case 3: apmib_set(MIB_WLAN_WPA_GROUP_REKEY_TIME_3, (void *)&longintVal);  break;
                case 4: apmib_set(MIB_WLAN_WPA_GROUP_REKEY_TIME_4, (void *)&longintVal);  break;
                case 5: apmib_set(MIB_WLAN_WPA_GROUP_REKEY_TIME_5, (void *)&longintVal);  break;
                case 6: apmib_set(MIB_WLAN_WPA_GROUP_REKEY_TIME_6, (void *)&longintVal);  break;
                case 7: apmib_set(MIB_WLAN_WPA_GROUP_REKEY_TIME_7, (void *)&longintVal);  break;
                default:break;
        }

/*
	if ( !apmib_set(MIB_WLAN_WPA_GROUP_REKEY_TIME, (void *)&longintVal)) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt22))</script>"));
		goto setErr_encrypt;
	}
*/
#endif
//****************************************  ****************************************
rekey_time:
		// group key rekey time
/*		reKeyTime = 0;
		strVal = websGetVar(wp, T("groupKeyTimeDay"), T(""));
		if (strVal[0]) {
			if ( !string_to_dec(strVal, &intVal) ) {
				DEBUGP(tmpBuf, T("Error! Invalid value of rekey day."));
				goto setErr_encrypt;
			}
			reKeyTime += intVal*86400;
		}
		strVal = websGetVar(wp, T("groupKeyTimeHr"), T(""));
		if (strVal[0]) {
			if ( !string_to_dec(strVal, &intVal) ) {
				DEBUGP(tmpBuf, T("Error! Invalid value of rekey hr."));
				goto setErr_encrypt;
			}
			reKeyTime += intVal*3600;
		}
		strVal = websGetVar(wp, T("groupKeyTimeMin"), T(""));
		if (strVal[0]) {
			if ( !string_to_dec(strVal, &intVal) ) {
				DEBUGP(tmpBuf, T("Error! Invalid value of rekey min."));
				goto setErr_encrypt;
			}
			reKeyTime += intVal*60;
		}

		strVal = websGetVar(wp, T("groupKeyTimeSec"), T(""));
		if (strVal[0]) {
			if ( !string_to_dec(strVal, &intVal) ) {
				DEBUGP(tmpBuf, T("Error! Invalid value of rekey sec."));
				goto setErr_encrypt;
			}
			reKeyTime += intVal;
		}
		if (reKeyTime) {
			if ( !apmib_set(MIB_WLAN_WPA_GROUP_REKEY_TIME, (void *)&reKeyTime)) {
				DEBUGP(tmpBuf, T("Set MIB_WLAN_WPA_GROUP_REKEY_TIME error!"));
				goto setErr_encrypt;
			}
		}
*/
//*********************************** RADIUS Server setting ***********************************
	if (enableRS == 1) { // if 1x enabled, get RADIUS server info
		#ifndef HOME_GATEWAY
		 if (!str1xMode[0]) {
		 #endif
		// set Radius Port
		strVal = websGetVar(wp, T("radiusPort"), T(""));
		if (!strVal[0]) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt7))</script>"));
				goto setErr_encrypt;
			}
			if (!string_to_dec(strVal, &intVal) || intVal<=0 || intVal>65535) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt8))</script>"));
				goto setErr_encrypt;
			}
#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_RS_PORT, (void *)&intVal); break;
				case 1: apmib_set(MIB_WLAN_RS_PORT_1, (void *)&intVal); break;
				case 2: apmib_set(MIB_WLAN_RS_PORT_2, (void *)&intVal); break;
				case 3: apmib_set(MIB_WLAN_RS_PORT_3, (void *)&intVal); break;
				case 4: apmib_set(MIB_WLAN_RS_PORT_4, (void *)&intVal); break;
				case 5: apmib_set(MIB_WLAN_RS_PORT_5, (void *)&intVal); break;
				case 6: apmib_set(MIB_WLAN_RS_PORT_6, (void *)&intVal); break;
				case 7: apmib_set(MIB_WLAN_RS_PORT_7, (void *)&intVal); break;
				default: break;
			}
#else
			if ( !apmib_set(MIB_WLAN_RS_PORT, (void *)&intVal)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt9))</script>"));
				goto setErr_encrypt;
			}
#endif
			//Radius Ip
			strVal = websGetVar(wp, T("radiusIP"), T(""));
			if (!strVal[0]) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt10))</script>"));
				goto setErr_encrypt;
			}
			if ( !inet_aton(strVal, &inIp) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt11))</script>"));
				goto setErr_encrypt;
			}

#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_RS_IP, (void *)&inIp); break;
				case 1: apmib_set(MIB_WLAN_RS_IP_1, (void *)&inIp); break;
				case 2: apmib_set(MIB_WLAN_RS_IP_2, (void *)&inIp); break;
				case 3: apmib_set(MIB_WLAN_RS_IP_3, (void *)&inIp); break;
				case 4: apmib_set(MIB_WLAN_RS_IP_4, (void *)&inIp); break;
				case 5: apmib_set(MIB_WLAN_RS_IP_5, (void *)&inIp); break;
				case 6: apmib_set(MIB_WLAN_RS_IP_6, (void *)&inIp); break;
				case 7: apmib_set(MIB_WLAN_RS_IP_7, (void *)&inIp); break;
				default: break;
			}
#else
			if ( !apmib_set(MIB_WLAN_RS_IP, (void *)&inIp)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt12))</script>"));
				goto setErr_encrypt;
			}
#endif
			//Radius password
			strVal = websGetVar(wp, T("radiusPass"), T(""));
			if (strlen(strVal) > (MAX_RS_PASS_LEN -1) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt13))</script>"));
				goto setErr_encrypt;
			}

#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_RS_PASSWORD, (void *)strVal); break;
				case 1: apmib_set(MIB_WLAN_RS_PASSWORD_1, (void *)strVal); break;
				case 2: apmib_set(MIB_WLAN_RS_PASSWORD_2, (void *)strVal); break;
				case 3: apmib_set(MIB_WLAN_RS_PASSWORD_3, (void *)strVal); break;
				case 4: apmib_set(MIB_WLAN_RS_PASSWORD_4, (void *)strVal); break;
				case 5: apmib_set(MIB_WLAN_RS_PASSWORD_5, (void *)strVal); break;
				case 6: apmib_set(MIB_WLAN_RS_PASSWORD_6, (void *)strVal); break;
				case 7: apmib_set(MIB_WLAN_RS_PASSWORD_7, (void *)strVal); break;
				default: break;
			}
#else
			if ( !apmib_set(MIB_WLAN_RS_PASSWORD, (void *)strVal)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt14))</script>"));
				goto setErr_encrypt;
			}
#endif

		#ifndef HOME_GATEWAY
		}
		#endif



/*
		strVal = websGetVar(wp, T("radiusRetry"), T("")); // differance "rsRetry"
		if (strVal[0]) {
			if ( !string_to_dec(strVal, &intVal) ) {
				DEBUGP(tmpBuf, T("Invalid RS retry value!"));
				goto setErr_encrypt;
			}
			if ( !apmib_set(MIB_WLAN_RS_RETRY, (void *)&intVal)) {
				DEBUGP(tmpBuf, T("Set MIB_WLAN_RS_RETRY error!"));
				goto setErr_encrypt;
			}
		}
		strVal = websGetVar(wp, T("radiusTime"), T(""));
		if (strVal[0]) {
			if ( !string_to_dec(strVal, &intVal) ) {
				DEBUGP(tmpBuf, T("Invalid RS time value!"));
				goto setErr_encrypt;
			}
			if ( !apmib_set(MIB_WLAN_RS_INTERVAL_TIME, (void *)&intVal)) {
				DEBUGP(tmpBuf, T("Set MIB_WLAN_RS_INTERVAL_TIME error!"));
				goto setErr_encrypt;
			}
		}
		strVal = websGetVar(wp, T("useAccount"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			intVal = 1;
		else
			intVal = 0;
		if ( apmib_set( MIB_WLAN_ACCOUNT_RS_ENABLED, (void *)&intVal) == 0) {
  			DEBUGP(tmpBuf, T("Set MIB_WLAN_ACCOUNT_RS_ENABLED mib error!"));
			goto setErr_encrypt;
		}
		if (intVal == 0)
			goto get_wepkey;

		strVal = websGetVar(wp, T("accountPort"), T(""));
		if (!strVal[0]) {
			DEBUGP(tmpBuf, T("No account RS port number!"));
			goto setErr_encrypt;
		}
		if (!string_to_dec(strVal, &intVal) || intVal<=0 || intVal>65535) {
			DEBUGP(tmpBuf, T("Error! Invalid value of account RS port number."));
			goto setErr_encrypt;
		}
		if ( !apmib_set(MIB_WLAN_ACCOUNT_RS_PORT, (void *)&intVal)) {
			DEBUGP(tmpBuf, T("Set account RS port error!"));
			goto setErr_encrypt;
		}
		strVal = websGetVar(wp, T("accountIP"), T(""));
		if (!strVal[0]) {
			DEBUGP(tmpBuf, T("No account RS IP address!"));
			goto setErr_encrypt;
		}
		if ( !inet_aton(strVal, &inIp) ) {
			DEBUGP(tmpBuf, T("Invalid account RS IP-address value!"));
			goto setErr_encrypt;
		}
		if ( !apmib_set(MIB_WLAN_ACCOUNT_RS_IP, (void *)&inIp)) {
			DEBUGP(tmpBuf, T("Set account RS IP-address error!"));
			goto setErr_encrypt;
		}
		strVal = websGetVar(wp, T("accountPass"), T(""));
		if (strlen(strVal) > (MAX_RS_PASS_LEN -1) ) {
			DEBUGP(tmpBuf, T("Account RS password length too long!"));
			goto setErr_encrypt;
		}
		if ( !apmib_set(MIB_WLAN_ACCOUNT_RS_PASSWORD, (void *)strVal)) {
			DEBUGP(tmpBuf, T("Set account RS password error!"));
			goto setErr_encrypt;
		}
		strVal = websGetVar(wp, T("accountRetry"), T(""));
		if (strVal[0]) {
			if ( !string_to_dec(strVal, &intVal) ) {
				DEBUGP(tmpBuf, T("Invalid account RS retry value!"));
				goto setErr_encrypt;
			}
			if ( !apmib_set(MIB_WLAN_ACCOUNT_RS_RETRY, (void *)&intVal)) {
				DEBUGP(tmpBuf, T("Set MIB_WLAN_ACCOUNT_RS_RETRY error!"));
				goto setErr_encrypt;
			}
		}
		strVal = websGetVar(wp, T("accountTime"), T(""));
		if (strVal[0]) {
			if ( !string_to_dec(strVal, &intVal) ) {
				DEBUGP(tmpBuf, T("Invalid account RS time value!"));
				goto setErr_encrypt;
			}
			if ( !apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME, (void *)&intVal)) {
				DEBUGP(tmpBuf, T("Set MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME error!"));
				goto setErr_encrypt;
			}
		}
		strVal = websGetVar(wp, T("accountUpdateEnabled"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			intVal = 1;
		else
			intVal = 0;
		if ( apmib_set( MIB_WLAN_ACCOUNT_UPDATE_ENABLED, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("Set MIB_WLAN_ACCOUNT_UPDATE_ENABLED mib error!"));
			goto setErr_encrypt;
		}
		strVal = websGetVar(wp, T("accountUpdateTime"), T(""));
		if (strVal[0]) {
			if ( !string_to_dec(strVal, &intVal) ) {
				DEBUGP(tmpBuf, T("Error! Invalid value of update time"));
				goto setErr_encrypt;
			}
			if ( !apmib_set(MIB_WLAN_ACCOUNT_UPDATE_DELAY, (void *)&intVal)) {
				DEBUGP(tmpBuf, T("Set MIB_WLAN_ACCOUNT_UPDATE_DELAY mib error!"));
				goto setErr_encrypt;
			}
		}
*/
get_wepkey:
		// get 802.1x WEP key length
		strVal = websGetVar(wp, T("wepKeyLen"), T(""));
		if (strVal[0]) {
			if ( !gstrcmp(strVal, T("wep64")))
				intVal = WEP64;
			else if ( !gstrcmp(strVal, T("wep128")))
				intVal = WEP128;
			else {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt15))</script>"));
				goto setErr_encrypt;
			}
			if ( apmib_set(MIB_WLAN_WEP, (void *)&intVal) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt16))</script>"));
				goto setErr_encrypt;
			}
		}
			// set session timeout
			strVal = websGetVar(wp, T("session_timeout"), T(""));
			/*if (!strVal[0]) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt7))</script>"));
				goto setErr_encrypt;
			}*/
			if (!string_to_dec(strVal, &intVal) || intVal<0 || intVal>65535) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt17))</script>"));
				goto setErr_encrypt;
			}
			if ( intVal == 0 )	//Felix add set default value, if web have not session_timeout
				intVal = 5;
#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME, (void *)&intVal); break;
				case 1: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_1, (void *)&intVal); break;
				case 2: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_2, (void *)&intVal); break;
				case 3: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_3, (void *)&intVal); break;
				case 4: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_4, (void *)&intVal); break;
				case 5: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_5, (void *)&intVal); break;
				case 6: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_6, (void *)&intVal); break;
				case 7: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_7, (void *)&intVal); break;
				default: break;
			}
#else
			if ( !apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME, (void *)&intVal)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt20))</script>"));
				goto setErr_encrypt;
			}
#endif
			// set idle timeout 
			strVal = websGetVar(wp, T("idle_timeout"), T(""));
			/*if (!strVal[0]) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt7))</script>"));
				goto setErr_encrypt;
			}*/
			if (!string_to_dec(strVal, &intVal) || intVal<0 || intVal>65535) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt18))</script>"));
				goto setErr_encrypt;
			}
			if ( intVal == 0 )      //Felix add set default value, if web have not idle_timeout
				intVal = 5;
#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_RS_INTERVAL_TIME, (void *)&intVal); break;
				case 1: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_1, (void *)&intVal); break;
				case 2: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_2, (void *)&intVal); break;
				case 3: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_3, (void *)&intVal); break;
				case 4: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_4, (void *)&intVal); break;
				case 5: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_5, (void *)&intVal); break;
				case 6: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_6, (void *)&intVal); break;
				case 7: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_7, (void *)&intVal); break;
				default: break;
			}
#else
			if ( !apmib_set(MIB_WLAN_RS_INTERVAL_TIME, (void *)&intVal)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt21))</script>"));
				goto setErr_encrypt;
			}
#endif
	}
//-----------------------------------------------------------------------------------------------
setwep_ret:
	apmib_update(CURRENT_SETTING);

#ifdef HOME_GATEWAY
	//sprintf(tmpBuf, "%s %s %s", "/bin/init.sh", "gw", "all"); // Tommy
	//system(tmpBuf);
#else
	//sprintf(tmpBuf, "%s %s %s", "/bin/init.sh", "ap", "all"); // Tommy
	//system(tmpBuf);
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	strWlencryEnable = websGetVar(wp, T("setwlencryptEnable"), T(""));

#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

#if defined(_Airlive_7428HCN_)
	char_t *isWizard;
        isWizard = websGetVar(wp, T("isWizard"), T(""));
        if ( isWizard[0] ){
                websHeader(wp);
                websWrite(wp, T("<script>window.close();</script>"));
                websDone(wp);
		return;
	}
#endif
#if defined(_Customer_) && (defined(_EW7218HNL_) || defined(_EW7428HRN_))
	if (strWlencryEnable[0] || wizardEnabled==1){
#else
	if (strWlencryEnable[0]){
#endif

		REPLACE_MSG(submitUrl);
	}
	else {
		OK_MSG(submitUrl);
	}
	return;

setErr_encrypt:
	ERR_MSG(tmpBuf);
}

/////////////////////////////////////////////////////////////////////////////
#if defined(_Customer_SA_) || defined(_Customer_EX_)
void formWlEncryptWizard(webs_t wp, char_t *path, char_t *query)
{

   	char_t *wepKey;
   	char_t *strKeyLen, *strFormat, *strKeyId, *strEnabled, *strWlencryEnable;
	char key[30];
	int enabled, keyLen, ret, i;
	WEP_T wep;

#ifdef _WEP_OPEN_SHARED_MODE_
	char_t *strWepMode;
#endif
   	char_t *submitUrl, *strEncrypt, *strVal, *strEnRadius, *strWpaCipher, *str1xMode;
	char tmpBuf[100];
	ENCRYPT_T encrypt;
	int enableRS=0, intVal, getPSK=0, len, intTkip, intAes;
	unsigned long int longintVal;
	unsigned long reKeyTime;
	SUPP_NONWAP_T suppNonWPA;
	struct in_addr inIp;
	char_t *strSSID, *ssid1, *ssid2, *ssid3, *ssid4, *ssid5, *ssid6;
		//200703.29 kyle wps status
			intVal = 1;
			if ( apmib_set(MIB_WPS_CONFIG_TYPE, (void *)&intVal) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
				goto setErr_encrypt;
			}
			intVal = 0;
			if ( apmib_set(MIB_WPS_DISPLAY_KEY, (void *)&intVal) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
				goto setErr_encrypt;
			}
	//Set SSID
	strSSID = websGetVar(wp, T("selected_ssid_1"), T(""));
        if ( strSSID[0] ) {
                if ( apmib_set(MIB_WLAN_SSID, (void *)strSSID) == 0) {
                                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup15))</script>"));
                                goto setErr_encrypt;
                }
        }
        ssid1=websGetVar(wp,T("selected_ssid_2"),T(""));
        if (ssid1[0]) intVal=1; else intVal=0;
        apmib_set(MIB_WLAN_SSID_MIRROR_1, (void *)&intVal);
        apmib_set(MIB_WLAN_SSID_1, (void *)websGetVar(wp,T("selected_ssid_2"),T("")));

	//Set security method
   	strEncrypt = websGetVar(wp, T("method_1"), T(""));

//	printf("strEncrypt=%s\n");
	if (!strEncrypt[0]) {
 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt1))</script>"));
		goto setErr_encrypt;
	}
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	if (!(strEncrypt[1] - '0'))
		encrypt = 10;
	else
#endif
		encrypt = strEncrypt[0] - '0';
char *temp;
int ssidID,broadcast_enable,wepenable;
temp = websGetVar(wp, T("selssid_1"), T(""));
ssidID = (int)temp[0] - '0';
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	if (encrypt == 1 || encrypt == 2 || encrypt == 3) {	//WEP(Open/share/auto)
	//===============WEB AUTH_TYPE SET===========	//1:OPEN 2:Share 3:Auto
		if ( encrypt == 1 )
			intVal=0;
		else if ( encrypt == 2 )
			intVal=1;
		else if ( encrypt == 3 )
			intVal=2;
		switch(ssidID)
		{
			case 0: apmib_set( MIB_WLAN_AUTH_TYPE,   	(void *)&intVal); break;
			case 1: apmib_set( MIB_WLAN_AUTH_TYPE_1,   (void *)&intVal); break;
			case 2: apmib_set( MIB_WLAN_AUTH_TYPE_2,   (void *)&intVal); break;
			case 3: apmib_set( MIB_WLAN_AUTH_TYPE_3,   (void *)&intVal); break;
			case 4: apmib_set( MIB_WLAN_AUTH_TYPE_4,   (void *)&intVal); break;
			case 5: apmib_set( MIB_WLAN_AUTH_TYPE_5,   (void *)&intVal); break;
			case 6: apmib_set( MIB_WLAN_AUTH_TYPE_6,   (void *)&intVal); break;
			case 7: apmib_set( MIB_WLAN_AUTH_TYPE_7,   (void *)&intVal); break;
			default: break; 
		}
                encrypt=1;	
	//===============WEB AUTH_TYPE SET end===========
	}
	else if(encrypt == 5 || encrypt == 7 || encrypt == 8)	//WPA-PSK/WPA2-PSK/WPA-PSK+WPA2-PSK
		encrypt=2;
	else if (encrypt == 4 || encrypt == 6 || encrypt == 9)	//WPA/WPA2/WPA+WPA2
		encrypt=3;
	else if (encrypt == 10){
		encrypt=0;
	}
#endif
/*#if defined(_Customer_SA_) || defined(_Customer_EX_)
temp = websGetVar(wp, T("wep_enable_1"), T(""));
wepenable = (int)temp[0] - '0';
apmib_set( MIB_WLAN_WEP, (void *)&wepenable);

temp = websGetVar(wp, T("wlbroadcast_enable_1"), T(""));
broadcast_enable = (int)temp[0] - '0';

switch(ssidID)
{
	case 0: apmib_set( MIB_WLAN_HIDDEN_SSID,   (void *)&broadcast_enable); break;
	case 1: apmib_set( MIB_WLAN_HIDDEN_SSID_1, (void *)&broadcast_enable); break;
	case 2: apmib_set( MIB_WLAN_HIDDEN_SSID_2, (void *)&broadcast_enable); break;
	case 3: apmib_set( MIB_WLAN_HIDDEN_SSID_3, (void *)&broadcast_enable); break;
	case 4: apmib_set( MIB_WLAN_HIDDEN_SSID_4, (void *)&broadcast_enable); break;
	case 5: apmib_set( MIB_WLAN_HIDDEN_SSID_5, (void *)&broadcast_enable); break;
	case 6: apmib_set( MIB_WLAN_HIDDEN_SSID_6, (void *)&broadcast_enable); break;
	case 7: apmib_set( MIB_WLAN_HIDDEN_SSID_7, (void *)&broadcast_enable); break;
	default: break;	
}
#endif*/
switch(ssidID)
{
	case 0: apmib_set( MIB_SECURITY_MODE, (void *)&encrypt); break;
	case 1: apmib_set( MIB_SECURITY_MODE_1, (void *)&encrypt); break;
	case 2: apmib_set( MIB_SECURITY_MODE_2, (void *)&encrypt); break;
	case 3: apmib_set( MIB_SECURITY_MODE_3, (void *)&encrypt); break;
	case 4: apmib_set( MIB_SECURITY_MODE_4, (void *)&encrypt); break;
	case 5: apmib_set( MIB_SECURITY_MODE_5, (void *)&encrypt); break;
	case 6: apmib_set( MIB_SECURITY_MODE_6, (void *)&encrypt); break;
	case 7: apmib_set( MIB_SECURITY_MODE_7, (void *)&encrypt); break;
	default: break;
}
	//Set 802.1x Enable
   	strEnRadius = websGetVar(wp, T("enRadius_1"), T(""));
//#if defined(_Customer_SA_) || defined(_Customer_EX_)
//	if ( ((encrypt==4 || encrypt==6 || encrypt==9 || encrypt==10) && !gstrcmp(strEnRadius, T("ON"))) ) {		
//#else
	if ( ((encrypt==0 || encrypt==1) && !gstrcmp(strEnRadius, T("ON"))) || encrypt==3) {
//#endif
		intVal = 1;
		enableRS = 1;
	}
	else
		intVal = 0;

switch(ssidID)
{
	case 0: apmib_set( MIB_WLAN_ENABLE_1X, (void *)&intVal); break;
	case 1: apmib_set( MIB_WLAN_ENABLE_1X_1, (void *)&intVal); break;
	case 2: apmib_set( MIB_WLAN_ENABLE_1X_2, (void *)&intVal); break;
	case 3: apmib_set( MIB_WLAN_ENABLE_1X_3, (void *)&intVal); break;
	case 4: apmib_set( MIB_WLAN_ENABLE_1X_4, (void *)&intVal); break;
	case 5: apmib_set( MIB_WLAN_ENABLE_1X_5, (void *)&intVal); break;
	case 6: apmib_set( MIB_WLAN_ENABLE_1X_6, (void *)&intVal); break;
	case 7: apmib_set( MIB_WLAN_ENABLE_1X_7, (void *)&intVal); break;
	default: break;
}
	// support nonWPA client
	strVal = websGetVar(wp, T("nonWpaSupp_1"), T(""));
	if ( !gstrcmp(strVal, T("ON")))
		intVal = 1;
	else
		intVal = 0;
	if ( apmib_set( MIB_WLAN_ENABLE_SUPP_NONWPA, (void *)&intVal) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt2))</script>"));
		goto setErr_encrypt;
	}
	if ( intVal ) {
		suppNonWPA = SUPP_NONWPA_NONE;
		strVal = websGetVar(wp, T("nonWpaWep_1"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			suppNonWPA |= SUPP_NONWPA_WEP;

		strVal = websGetVar(wp, T("nonWpa1x_1"), T(""));
		if ( !gstrcmp(strVal, T("ON"))) {
			suppNonWPA |= SUPP_NONWPA_1X;
			enableRS = 1;
		}
		if ( apmib_set( MIB_WLAN_SUPP_NONWPA, (void *)&suppNonWPA) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt3))</script>"));
			goto setErr_encrypt;
		}
	}
/*#if defined(_Customer_SA_) || defined(_Customer_EX_)
	if (encrypt==4 || encrypt==5 || encrypt==6 || encrypt==7 || encrypt==8 || encrypt==9 || encrypt==10) {
		// WPA authentication
		if (encrypt==5 || encrypt==7 || encrypt==8) {
			intVal = WPA_AUTH_PSK;
			getPSK = 1;
		}
		else if (encrypt==4 || encrypt==6 || encrypt==9 || encrypt==10) {
			intVal = 1;
			enableRS = 1;
		}
#else*/
	if (encrypt==2 || encrypt==3) {
		// WPA authentication
		if (encrypt==2) {
			intVal = WPA_AUTH_PSK;
			getPSK = 1;
		}
		else if (encrypt==3) {
//			intVal = WPA_AUTH_AUTO;
			intVal = 1;
			enableRS = 1;
		}
//#endif
#ifdef _MSSID_
	switch(ssidID)
	{
	case 0: apmib_set(MIB_WLAN_WPA_AUTH, (void *)&intVal);break;
	case 1: apmib_set(MIB_WLAN_WPA_AUTH_1, (void *)&intVal);break;
	case 2: apmib_set(MIB_WLAN_WPA_AUTH_2, (void *)&intVal);break;
	case 3: apmib_set(MIB_WLAN_WPA_AUTH_3, (void *)&intVal);break;
	case 4: apmib_set(MIB_WLAN_WPA_AUTH_4, (void *)&intVal);break;
	case 5: apmib_set(MIB_WLAN_WPA_AUTH_5, (void *)&intVal);break;
	case 6: apmib_set(MIB_WLAN_WPA_AUTH_6, (void *)&intVal);break;
	case 7: apmib_set(MIB_WLAN_WPA_AUTH_7, (void *)&intVal);break;
	default: break;
		}
#else
		if ( apmib_set(MIB_WLAN_WPA_AUTH, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt4))</script>"));
			goto setErr_encrypt;
		}
#endif
		//if ( apmib_set(MIB_WLAN_WPA_AUTH, (void *)&intVal) == 0) {
		//	DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt4))</script>"));
		//	goto setErr_encrypt;
		//}

		// cipher suite
		strVal = websGetVar(wp, T("wpaCipher_1"), T(""));
		intVal = strVal[0] - '0';
#if defined(_Customer_SA_) || defined(_Customer_EX_)
                if (strVal[0]) {
                        intTkip=intVal;
			intAes=intVal;
#else
		if (strVal[0]) {
			if (intVal==1 || intVal==3)	intTkip=WPA_CIPHER_TKIP; else intTkip=0;
			if (intVal==2 || intVal==3) intAes=WPA_CIPHER_AES; else intAes=0;
#endif
switch(ssidID)
{
	case 0: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intTkip);   apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intAes);break;
	case 1: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_1, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_1, (void *)&intAes);break;
	case 2: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_2, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_2, (void *)&intAes);break;
	case 3: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_3, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_3, (void *)&intAes);break;
	case 4: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_4, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_4, (void *)&intAes);break;
	case 5: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_5, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_5, (void *)&intAes);break;
	case 6: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_6, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_6, (void *)&intAes);break;
	case 7: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_7, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_7, (void *)&intAes);break;
	default: break;
}
	}
	}

	//Follow Realtek, Set WLAN_ENCRYPT
	strWpaCipher = websGetVar(wp, T("wpaCipher_1"), T(""));
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	strEncrypt = websGetVar(wp, T("method_1"), T(""));
	encrypt = strEncrypt[0] - '0';
	if (!(strEncrypt[1] - '0'))
		encrypt=0;
	else {
		if ( encrypt == 0 || encrypt == 10)	encrypt=0;	//disable,802.1X
		else if ( encrypt > 0 && encrypt < 4)	encrypt=1;	//WEP
		else if ( encrypt == 4 || encrypt == 5 )encrypt=2;	//WPA
		else if ( encrypt == 6 || encrypt == 7)	encrypt=4;	//WPA2
		else if ( encrypt == 8 || encrypt == 9 )encrypt=6;	//WPA+WPA2
	}
#else
	if (strEncrypt[0]=='0')	encrypt=0;
	else if (strEncrypt[0]=='1') encrypt=1;
	else if (((strEncrypt[0]=='2')||(strEncrypt[0]=='3')) && (strWpaCipher[0]=='1')) encrypt=2;
	else if (((strEncrypt[0]=='2')||(strEncrypt[0]=='3')) && (strWpaCipher[0]=='2')) encrypt=4;
	else if (((strEncrypt[0]=='2')||(strEncrypt[0]=='3')) && (strWpaCipher[0]=='3')) encrypt=6;
#endif
	switch(ssidID)
	{
		case 0:	apmib_set( MIB_WLAN_ENCRYPT,   (void *)&encrypt); break;
		case 1:	apmib_set( MIB_WLAN_ENCRYPT_1, (void *)&encrypt); break;
		case 2:	apmib_set( MIB_WLAN_ENCRYPT_2, (void *)&encrypt); break;
		case 3:	apmib_set( MIB_WLAN_ENCRYPT_3, (void *)&encrypt); break;
		case 4:	apmib_set( MIB_WLAN_ENCRYPT_4, (void *)&encrypt); break;
		case 5:	apmib_set( MIB_WLAN_ENCRYPT_5, (void *)&encrypt); break;
		case 6:	apmib_set( MIB_WLAN_ENCRYPT_6, (void *)&encrypt); break;
		case 7:	apmib_set( MIB_WLAN_ENCRYPT_7, (void *)&encrypt); break;
		default: break;
	}
//*********************************** Wep setting ***********************************
	if (encrypt==ENCRYPT_WEP) {
		strEnabled = websGetVar(wp, T("wepEnabled_1"), T(""));
		if ( !gstrcmp(strEnabled, T("ON")))
			enabled = 1;
		else
			enabled = 0;

		if ( enabled ) {
			strKeyLen = websGetVar(wp, T("length_1"), T(""));
			if (!strKeyLen[0]) {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt2))</script>"));
				goto setErr_encrypt;
			}
			if (strKeyLen[0]!='1' && strKeyLen[0]!='2' && strKeyLen[0]!='3') {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt3))</script>"));
				goto setErr_encrypt;
			}
			if (strKeyLen[0] == '1')
				wep = WEP64;
			else if (strKeyLen[0] == '2')
				wep = WEP128;
			else
				wep = WEP152;
		}
		else
			wep = WEP_DISABLED;

switch(ssidID)
{
	case 0:	apmib_set( MIB_WLAN_WEP, (void *)&wep);  break;
	case 1:	apmib_set( MIB_WLAN_WEP_1, (void *)&wep);break;
	case 2:	apmib_set( MIB_WLAN_WEP_2, (void *)&wep);break;
	case 3:	apmib_set( MIB_WLAN_WEP_3, (void *)&wep);break;
	case 4:	apmib_set( MIB_WLAN_WEP_4, (void *)&wep);break;
	case 5:	apmib_set( MIB_WLAN_WEP_5, (void *)&wep);break;
	case 6:	apmib_set( MIB_WLAN_WEP_6, (void *)&wep);break;
	case 7:	apmib_set( MIB_WLAN_WEP_7, (void *)&wep);break;
	default:break;
}
		if (wep == WEP_DISABLED)
			goto setwep_ret;

		strFormat = websGetVar(wp, T("format_1"), T(""));
		if (!strFormat[0]) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt5))</script>"));
			goto setErr_encrypt;
		}

		if (strFormat[0]!='1' && strFormat[0]!='2') {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt6))</script>"));
			goto setErr_encrypt;
		}

		i = strFormat[0] - '0' - 1;

switch(ssidID)
{
	case 0:	apmib_set( MIB_WLAN_WEP_KEY_TYPE, (void *)&i);  break;
	case 1:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_1, (void *)&i);break;
	case 2:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_2, (void *)&i);break;
	case 3:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_3, (void *)&i);break;
	case 4:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_4, (void *)&i);break;
	case 5:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_5, (void *)&i);break;
	case 6:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_6, (void *)&i);break;
	case 7:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_7, (void *)&i);break;
	default:break;
}
		if (wep == WEP64) {
			if (strFormat[0]=='1')
				keyLen = WEP64_KEY_LEN;
			else
				keyLen = WEP64_KEY_LEN*2;
		}
		else if (wep == WEP128) {
			if (strFormat[0]=='1')
				keyLen = WEP128_KEY_LEN;
			else
				keyLen = WEP128_KEY_LEN*2;
		}
		else {
			if (strFormat[0]=='1')
				keyLen = WEP152_KEY_LEN;
			else
				keyLen = WEP152_KEY_LEN*2;
		}
		strKeyId = websGetVar(wp, T("defaultTxKeyId_1"), T(""));
		if ( strKeyId[0] ) {
			if ( strKeyId[0]!='1' && strKeyId[0]!='2' && strKeyId[0]!='3' && strKeyId[0]!='4' ) {
		 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt8))</script>"));
				goto setErr_encrypt;
			}
			i = strKeyId[0] - '0' - 1;
			switch(ssidID)
			{
				case 0:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&i);  break;
				case 1:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_1, (void *)&i);break;
				case 2:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_2, (void *)&i);break;
				case 3:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_3, (void *)&i);break;
				case 4:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_4, (void *)&i);break;
				case 5:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_5, (void *)&i);break;
				case 6:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_6, (void *)&i);break;
				case 7:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_7, (void *)&i);break;
				default:break;
			}
		}

wepKey = websGetVar(wp, T("key1_1"), T(""));
if( wepKey[0] && strlen(wepKey) == keyLen && !isAllStar(wepKey) )
{
	if (strFormat[0] == '1')	strcpy(key, wepKey);
	else				string_to_hex(wepKey, key, keyLen);

	if (wep == WEP64)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP64_KEY1, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP64_KEY1_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP64_KEY1_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP64_KEY1_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP64_KEY1_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP64_KEY1_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP64_KEY1_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP64_KEY1_7, (void *)&key);	break;
			default:break;
		}
	else if	(wep == WEP128)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP128_KEY1, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP128_KEY1_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP128_KEY1_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP128_KEY1_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP128_KEY1_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP128_KEY1_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP128_KEY1_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP128_KEY1_7, (void *)&key);	break;
			default:break;
		}
	/*else
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP152_KEY1, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP152_KEY1_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP152_KEY1_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP152_KEY1_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP152_KEY1_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP152_KEY1_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP152_KEY1_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP152_KEY1_7, (void *)&key);	break;
			default:break;
		}*/
}
wepKey = websGetVar(wp, T("key2_1"), T(""));
if( wepKey[0] && strlen(wepKey) == keyLen && !isAllStar(wepKey) )
{
	if (strFormat[0] == '1')	strcpy(key, wepKey);
	else						string_to_hex(wepKey, key, keyLen);

	if (wep == WEP64)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP64_KEY2, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP64_KEY2_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP64_KEY2_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP64_KEY2_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP64_KEY2_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP64_KEY2_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP64_KEY2_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP64_KEY2_7, (void *)&key);	break;
			default:break;
		}
	else if	(wep == WEP128)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP128_KEY2, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP128_KEY2_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP128_KEY2_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP128_KEY2_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP128_KEY2_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP128_KEY2_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP128_KEY2_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP128_KEY2_7, (void *)&key);	break;
			default:break;
		}
	/*else
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP152_KEY2, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP152_KEY2_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP152_KEY2_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP152_KEY2_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP152_KEY2_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP152_KEY2_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP152_KEY2_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP152_KEY2_7, (void *)&key);	break;
			default:break;
		}*/
}
wepKey = websGetVar(wp, T("key3_1"), T(""));
if( wepKey[0] && strlen(wepKey) == keyLen && !isAllStar(wepKey) )
{
	if (strFormat[0] == '1')	strcpy(key, wepKey);
	else						string_to_hex(wepKey, key, keyLen);

	if (wep == WEP64)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP64_KEY3, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP64_KEY3_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP64_KEY3_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP64_KEY3_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP64_KEY3_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP64_KEY3_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP64_KEY3_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP64_KEY3_7, (void *)&key);	break;
			default:break;
		}
	else if	(wep == WEP128)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP128_KEY3, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP128_KEY3_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP128_KEY3_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP128_KEY3_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP128_KEY3_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP128_KEY3_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP128_KEY3_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP128_KEY3_7, (void *)&key);	break;
			default:break;
		}
	/*else
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP152_KEY3, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP152_KEY3_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP152_KEY3_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP152_KEY3_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP152_KEY3_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP152_KEY3_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP152_KEY3_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP152_KEY3_7, (void *)&key);	break;
			default:break;
		}*/
}
wepKey = websGetVar(wp, T("key4_1"), T(""));
if( wepKey[0] && strlen(wepKey) == keyLen && !isAllStar(wepKey) )
{
	if (strFormat[0] == '1')	strcpy(key, wepKey);
	else						string_to_hex(wepKey, key, keyLen);

	if (wep == WEP64)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP64_KEY4, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP64_KEY4_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP64_KEY4_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP64_KEY4_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP64_KEY4_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP64_KEY4_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP64_KEY4_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP64_KEY4_7, (void *)&key);	break;
			default:break;
		}
	else if	(wep == WEP128)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP128_KEY4, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP128_KEY4_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP128_KEY4_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP128_KEY4_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP128_KEY4_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP128_KEY4_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP128_KEY4_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP128_KEY4_7, (void *)&key);	break;
			default:break;
		}
	/*else
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP152_KEY4, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP152_KEY4_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP152_KEY4_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP152_KEY4_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP152_KEY4_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP152_KEY4_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP152_KEY4_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP152_KEY4_7, (void *)&key);	break;
			default:break;
		}*/
}
}

//*********************************** pre-shared key setting ***********************************
	if ( getPSK ) {
		int oldFormat, oldPskLen, i;

		strVal = websGetVar(wp, T("pskFormat_1"), T(""));
		if (!strVal[0]) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt22))</script>"));
			goto setErr_encrypt;
		}
		intVal = strVal[0] - '0';
		if (intVal != 0 && intVal != 1) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt23))</script>"));
			goto setErr_encrypt;
		}

		// remember current psk format and length to compare to default case "****"
		//vance 2009.02.23 fixed pskvalue error
		switch(ssidID)
		{
			case 0:apmib_get(MIB_WLAN_WPA_PSK_FORMAT, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK, (void *)tmpBuf);break;
			case 1:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_1, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_1, (void *)tmpBuf);break;
			case 2:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_2, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_2, (void *)tmpBuf);break;
			case 3:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_3, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_3, (void *)tmpBuf);break;
			case 4:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_4, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_4, (void *)tmpBuf);break;
			case 5:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_5, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_5, (void *)tmpBuf);break;
			case 6:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_6, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_6, (void *)tmpBuf);break;
			case 7:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_7, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_7, (void *)tmpBuf);break;
			default:break;
		}
		oldPskLen = strlen(tmpBuf);

		strVal = websGetVar(wp, T("pskValue_1"), T(""));
		len = strlen(strVal);
			if (oldFormat == intVal && len == oldPskLen ) {
				for (i=0; i<len; i++) {
					if ( strVal[i] != '*' )
						break;
				}
				if (i == len)
					goto rekey_time;
			}
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WPA_PSK_FORMAT, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK, (void *)strVal);	break;
			case 1: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_1, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_1, (void *)strVal);	break;
			case 2: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_2, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_2, (void *)strVal);	break;
			case 3: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_3, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_3, (void *)strVal);	break;
			case 4: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_4, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_4, (void *)strVal);	break;
			case 5: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_5, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_5, (void *)strVal);	break;
			case 6: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_6, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_6, (void *)strVal);	break;
			case 7: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_7, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_7, (void *)strVal);	break;
			default:break;
		}
	}
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	// set key renewed interval
	strVal = websGetVar(wp, T("RekeyTime_1"), T(""));
	/*if (!strVal[0]) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt7))</script>"));
		goto setErr_encrypt;
	}*/
	if (!string_to_dec(strVal, &longintVal) || longintVal<0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt19))</script>"));
		goto setErr_encrypt;
	}

	if ( !apmib_set(MIB_WLAN_WPA_GROUP_REKEY_TIME, (void *)&longintVal)) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt22))</script>"));
		goto setErr_encrypt;
	}
#endif
//*********************************** RADIUS Server setting ***********************************
	if (enableRS == 1) { // if 1x enabled, get RADIUS server info
		#ifndef HOME_GATEWAY
		 if (!str1xMode[0]) {
		 #endif
		// set Radius Port
		strVal = websGetVar(wp, T("radiusPort_1"), T(""));
		if (!strVal[0]) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt7))</script>"));
				goto setErr_encrypt;
			}
			if (!string_to_dec(strVal, &intVal) || intVal<=0 || intVal>65535) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt8))</script>"));
				goto setErr_encrypt;
			}
#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_RS_PORT, (void *)&intVal); break;
				case 1: apmib_set(MIB_WLAN_RS_PORT_1, (void *)&intVal); break;
				case 2: apmib_set(MIB_WLAN_RS_PORT_2, (void *)&intVal); break;
				case 3: apmib_set(MIB_WLAN_RS_PORT_3, (void *)&intVal); break;
				case 4: apmib_set(MIB_WLAN_RS_PORT_4, (void *)&intVal); break;
				case 5: apmib_set(MIB_WLAN_RS_PORT_5, (void *)&intVal); break;
				case 6: apmib_set(MIB_WLAN_RS_PORT_6, (void *)&intVal); break;
				case 7: apmib_set(MIB_WLAN_RS_PORT_7, (void *)&intVal); break;
				default: break;
			}
#else
			if ( !apmib_set(MIB_WLAN_RS_PORT, (void *)&intVal)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt9))</script>"));
				goto setErr_encrypt;
			}
#endif
		//Radius Ip
			strVal = websGetVar(wp, T("radiusIP_1"), T(""));
			if (!strVal[0]) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt10))</script>"));
				goto setErr_encrypt;
			}
			if ( !inet_aton(strVal, &inIp) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt11))</script>"));
				goto setErr_encrypt;
			}

#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_RS_IP, (void *)&inIp); break;
				case 1: apmib_set(MIB_WLAN_RS_IP_1, (void *)&inIp); break;
				case 2: apmib_set(MIB_WLAN_RS_IP_2, (void *)&inIp); break;
				case 3: apmib_set(MIB_WLAN_RS_IP_3, (void *)&inIp); break;
				case 4: apmib_set(MIB_WLAN_RS_IP_4, (void *)&inIp); break;
				case 5: apmib_set(MIB_WLAN_RS_IP_5, (void *)&inIp); break;
				case 6: apmib_set(MIB_WLAN_RS_IP_6, (void *)&inIp); break;
				case 7: apmib_set(MIB_WLAN_RS_IP_7, (void *)&inIp); break;
				default: break;
			}
#else
			if ( !apmib_set(MIB_WLAN_RS_IP, (void *)&inIp)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt12))</script>"));
				goto setErr_encrypt;
			}
#endif
			//Radius password
			strVal = websGetVar(wp, T("radiusPass_1"), T(""));
			if (strlen(strVal) > (MAX_RS_PASS_LEN -1) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt13))</script>"));
				goto setErr_encrypt;
			}

#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_RS_PASSWORD, (void *)strVal); break;
				case 1: apmib_set(MIB_WLAN_RS_PASSWORD_1, (void *)strVal); break;
				case 2: apmib_set(MIB_WLAN_RS_PASSWORD_2, (void *)strVal); break;
				case 3: apmib_set(MIB_WLAN_RS_PASSWORD_3, (void *)strVal); break;
				case 4: apmib_set(MIB_WLAN_RS_PASSWORD_4, (void *)strVal); break;
				case 5: apmib_set(MIB_WLAN_RS_PASSWORD_5, (void *)strVal); break;
				case 6: apmib_set(MIB_WLAN_RS_PASSWORD_6, (void *)strVal); break;
				case 7: apmib_set(MIB_WLAN_RS_PASSWORD_7, (void *)strVal); break;
				default: break;
			}
#else
			if ( !apmib_set(MIB_WLAN_RS_PASSWORD, (void *)strVal)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt14))</script>"));
				goto setErr_encrypt;
			}
#endif
		#ifndef HOME_GATEWAY
		}
		#endif

		strVal = websGetVar(wp, T("wepKeyLen_1"), T(""));
		if (strVal[0]) {
			if ( !gstrcmp(strVal, T("wep64")))
				intVal = WEP64;
			else if ( !gstrcmp(strVal, T("wep128")))
				intVal = WEP128;
			else {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt15))</script>"));
				goto setErr_encrypt;
			}
			if ( apmib_set(MIB_WLAN_WEP, (void *)&intVal) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt16))</script>"));
				goto setErr_encrypt;
			}
		}
#if defined(_Customer_SA_) || defined(_Customer_EX_)
			// set session timeout
			strVal = websGetVar(wp, T("session_timeout_1"), T(""));
			/*if (!strVal[0]) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt7))</script>"));
					goto setErr_encrypt;
				}*/
				if (!string_to_dec(strVal, &intVal) || intVal<0 || intVal>65535) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt17))</script>"));
					goto setErr_encrypt;
				}
#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME, (void *)&intVal); break;
				case 1: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_1, (void *)&intVal); break;
				case 2: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_2, (void *)&intVal); break;
				case 3: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_3, (void *)&intVal); break;
				case 4: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_4, (void *)&intVal); break;
				case 5: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_5, (void *)&intVal); break;
				case 6: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_6, (void *)&intVal); break;
				case 7: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_7, (void *)&intVal); break;
				default: break;
			}
#else
				if ( !apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME, (void *)&intVal)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt20))</script>"));
					goto setErr_encrypt;
				}
#endif
			// set idle timeout 
			strVal = websGetVar(wp, T("idle_timeout_1"), T(""));
			/*if (!strVal[0]) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt7))</script>"));
					goto setErr_encrypt;
				}*/
				if (!string_to_dec(strVal, &intVal) || intVal<0 || intVal>65535) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt18))</script>"));
					goto setErr_encrypt;
				}
#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_RS_INTERVAL_TIME, (void *)&intVal); break;
				case 1: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_1, (void *)&intVal); break;
				case 2: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_2, (void *)&intVal); break;
				case 3: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_3, (void *)&intVal); break;
				case 4: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_4, (void *)&intVal); break;
				case 5: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_5, (void *)&intVal); break;
				case 6: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_6, (void *)&intVal); break;
				case 7: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_7, (void *)&intVal); break;
				default: break;
			}
#else
				if ( !apmib_set(MIB_WLAN_RS_INTERVAL_TIME, (void *)&intVal)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt21))</script>"));
					goto setErr_encrypt;
				}
#endif
#endif
	}

//-----------------------------------------------------------------------------------------------

	//Set security method
   	strEncrypt = websGetVar(wp, T("method_2"), T(""));

//	printf("strEncrypt=%s\n");
	if (!strEncrypt[0]) {
 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt1))</script>"));
		goto setErr_encrypt;
	}
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	if (!(strEncrypt[1] - '0'))
		encrypt = 10;
	else
#endif
		encrypt = strEncrypt[0] - '0';
//char *temp;
//int ssidID,broadcast_enable,wepenable;
temp = websGetVar(wp, T("selssid_2"), T(""));
ssidID = (int)temp[0] - '0';
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	if (encrypt == 1 || encrypt == 2 || encrypt == 3) {	//WEP(Open/share/auto)
	//===============WEB AUTH_TYPE SET===========	//1:OPEN 2:Share 3:Auto
		if ( encrypt == 1 )
			intVal=0;
		else if ( encrypt == 2 )
			intVal=1;
		else if ( encrypt == 3 )
			intVal=2;
		switch(ssidID)
		{
		        case 0: apmib_set( MIB_WLAN_AUTH_TYPE,   (void *)&intVal); break;
               	        case 1: apmib_set( MIB_WLAN_AUTH_TYPE_1,   (void *)&intVal); break;
                       	case 2: apmib_set( MIB_WLAN_AUTH_TYPE_2,   (void *)&intVal); break;
                        case 3: apmib_set( MIB_WLAN_AUTH_TYPE_3,   (void *)&intVal); break;
       	                case 4: apmib_set( MIB_WLAN_AUTH_TYPE_4,   (void *)&intVal); break;
               	        case 5: apmib_set( MIB_WLAN_AUTH_TYPE_5,   (void *)&intVal); break;
                       	case 6: apmib_set( MIB_WLAN_AUTH_TYPE_6,   (void *)&intVal); break;
                        case 7: apmib_set( MIB_WLAN_AUTH_TYPE_7,   (void *)&intVal); break;
		        default: break; 
		}
                encrypt=1;	
	//===============WEB AUTH_TYPE SET end===========
	}
	else if(encrypt == 5 || encrypt == 7 || encrypt == 8)	//WPA-PSK/WPA2-PSK/WPA-PSK+WPA2-PSK
		encrypt=2;
	else if (encrypt == 4 || encrypt == 6 || encrypt == 9)	//WPA/WPA2/WPA+WPA2
		encrypt=3;
	else if (encrypt == 10){
		encrypt=0;
	}
#endif
/*#if defined(_Customer_SA_) || defined(_Customer_EX_)
//temp = websGetVar(wp, T("wep_enable_2"), T(""));
//wepenable = (int)temp[0] - '0';
//apmib_set( MIB_WLAN_WEP, (void *)&wepenable);

temp = websGetVar(wp, T("wlbroadcast_enable_2"), T(""));
broadcast_enable = (int)temp[0] - '0';

switch(ssidID)
{
	case 0: apmib_set( MIB_WLAN_HIDDEN_SSID,   (void *)&broadcast_enable); break;
	case 1: apmib_set( MIB_WLAN_HIDDEN_SSID_1, (void *)&broadcast_enable); break;
	case 2: apmib_set( MIB_WLAN_HIDDEN_SSID_2, (void *)&broadcast_enable); break;
	case 3: apmib_set( MIB_WLAN_HIDDEN_SSID_3, (void *)&broadcast_enable); break;
	case 4: apmib_set( MIB_WLAN_HIDDEN_SSID_4, (void *)&broadcast_enable); break;
	case 5: apmib_set( MIB_WLAN_HIDDEN_SSID_5, (void *)&broadcast_enable); break;
	case 6: apmib_set( MIB_WLAN_HIDDEN_SSID_6, (void *)&broadcast_enable); break;
	case 7: apmib_set( MIB_WLAN_HIDDEN_SSID_7, (void *)&broadcast_enable); break;
	default: break;	
}
#endif*/
switch(ssidID)
{
	case 0: apmib_set( MIB_SECURITY_MODE, (void *)&encrypt); break;
	case 1: apmib_set( MIB_SECURITY_MODE_1, (void *)&encrypt); break;
	case 2: apmib_set( MIB_SECURITY_MODE_2, (void *)&encrypt); break;
	case 3: apmib_set( MIB_SECURITY_MODE_3, (void *)&encrypt); break;
	case 4: apmib_set( MIB_SECURITY_MODE_4, (void *)&encrypt); break;
	case 5: apmib_set( MIB_SECURITY_MODE_5, (void *)&encrypt); break;
	case 6: apmib_set( MIB_SECURITY_MODE_6, (void *)&encrypt); break;
	case 7: apmib_set( MIB_SECURITY_MODE_7, (void *)&encrypt); break;
	default: break;
}
	//Set 802.1x Enable
   	strEnRadius = websGetVar(wp, T("enRadius_2"), T(""));
//#if defined(_Customer_SA_) || defined(_Customer_EX_)
//	if ( ((encrypt==4 || encrypt==6 || encrypt==9 || encrypt==10) && !gstrcmp(strEnRadius, T("ON"))) ) {		
//#else
	if ( ((encrypt==0 || encrypt==1) && !gstrcmp(strEnRadius, T("ON"))) || encrypt==3) {
//#endif
		intVal = 1;
		enableRS = 1;
	}
	else
		intVal = 0;

switch(ssidID)
{
	case 0: apmib_set( MIB_WLAN_ENABLE_1X, (void *)&intVal); break;
	case 1: apmib_set( MIB_WLAN_ENABLE_1X_1, (void *)&intVal); break;
	case 2: apmib_set( MIB_WLAN_ENABLE_1X_2, (void *)&intVal); break;
	case 3: apmib_set( MIB_WLAN_ENABLE_1X_3, (void *)&intVal); break;
	case 4: apmib_set( MIB_WLAN_ENABLE_1X_4, (void *)&intVal); break;
	case 5: apmib_set( MIB_WLAN_ENABLE_1X_5, (void *)&intVal); break;
	case 6: apmib_set( MIB_WLAN_ENABLE_1X_6, (void *)&intVal); break;
	case 7: apmib_set( MIB_WLAN_ENABLE_1X_7, (void *)&intVal); break;
	default: break;
}
	// support nonWPA client
	strVal = websGetVar(wp, T("nonWpaSupp_2"), T(""));
	if ( !gstrcmp(strVal, T("ON")))
		intVal = 1;
	else
		intVal = 0;
	if ( apmib_set( MIB_WLAN_ENABLE_SUPP_NONWPA, (void *)&intVal) == 0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt2))</script>"));
		goto setErr_encrypt;
	}
	if ( intVal ) {
		suppNonWPA = SUPP_NONWPA_NONE;
		strVal = websGetVar(wp, T("nonWpaWep_2"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			suppNonWPA |= SUPP_NONWPA_WEP;

		strVal = websGetVar(wp, T("nonWpa1x_2"), T(""));
		if ( !gstrcmp(strVal, T("ON"))) {
			suppNonWPA |= SUPP_NONWPA_1X;
			enableRS = 1;
		}
		if ( apmib_set( MIB_WLAN_SUPP_NONWPA, (void *)&suppNonWPA) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt3))</script>"));
			goto setErr_encrypt;
		}
	}
/*#if defined(_Customer_SA_) || defined(_Customer_EX_)
	if (encrypt==4 || encrypt==5 || encrypt==6 || encrypt==7 || encrypt==8 || encrypt==9 || encrypt==10) {
		// WPA authentication
		if (encrypt==5 || encrypt==7 || encrypt==8) {
			intVal = WPA_AUTH_PSK;
			getPSK = 1;
		}
		else if (encrypt==4 || encrypt==6 || encrypt==9 || encrypt==10) {
			intVal = 1;
			enableRS = 1;
		}
#else*/
	if (encrypt==2 || encrypt==3) {
		// WPA authentication
		if (encrypt==2) {
			intVal = WPA_AUTH_PSK;
			getPSK = 1;
		}
		else if (encrypt==3) {
//			intVal = WPA_AUTH_AUTO;
			intVal = 1;
			enableRS = 1;
		}
//#endif
#ifdef _MSSID_
	switch(ssidID)
	{
	case 0: apmib_set(MIB_WLAN_WPA_AUTH, (void *)&intVal);break;
	case 1: apmib_set(MIB_WLAN_WPA_AUTH_1, (void *)&intVal);break;
	case 2: apmib_set(MIB_WLAN_WPA_AUTH_2, (void *)&intVal);break;
	case 3: apmib_set(MIB_WLAN_WPA_AUTH_3, (void *)&intVal);break;
	case 4: apmib_set(MIB_WLAN_WPA_AUTH_4, (void *)&intVal);break;
	case 5: apmib_set(MIB_WLAN_WPA_AUTH_5, (void *)&intVal);break;
	case 6: apmib_set(MIB_WLAN_WPA_AUTH_6, (void *)&intVal);break;
	case 7: apmib_set(MIB_WLAN_WPA_AUTH_7, (void *)&intVal);break;
	default: break;
		}
#else
		if ( apmib_set(MIB_WLAN_WPA_AUTH, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt4))</script>"));
			goto setErr_encrypt;
		}
#endif
		//if ( apmib_set(MIB_WLAN_WPA_AUTH, (void *)&intVal) == 0) {
		//	DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt4))</script>"));
		//	goto setErr_encrypt;
		//}

		// cipher suite
		strVal = websGetVar(wp, T("wpaCipher_2"), T(""));
		intVal = strVal[0] - '0';
#if defined(_Customer_SA_) || defined(_Customer_EX_)
                if (strVal[0]) {
                        intTkip=intVal;
			intAes=intVal;
#else
		if (strVal[0]) {
			if (intVal==1 || intVal==3)	intTkip=WPA_CIPHER_TKIP; else intTkip=0;
			if (intVal==2 || intVal==3) intAes=WPA_CIPHER_AES; else intAes=0;
#endif
switch(ssidID)
{
	case 0: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intTkip);   apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intAes);break;
	case 1: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_1, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_1, (void *)&intAes);break;
	case 2: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_2, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_2, (void *)&intAes);break;
	case 3: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_3, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_3, (void *)&intAes);break;
	case 4: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_4, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_4, (void *)&intAes);break;
	case 5: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_5, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_5, (void *)&intAes);break;
	case 6: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_6, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_6, (void *)&intAes);break;
	case 7: apmib_set( MIB_WLAN_WPA_CIPHER_SUITE_7, (void *)&intTkip); apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE_7, (void *)&intAes);break;
	default: break;
}
	}
	}

	//Follow Realtek, Set WLAN_ENCRYPT
	strWpaCipher = websGetVar(wp, T("wpaCipher_2"), T(""));
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	strEncrypt = websGetVar(wp, T("method_2"), T(""));
	encrypt = strEncrypt[0] - '0';
	if (!(strEncrypt[1] - '0'))
		encrypt=0;
	else {
		if ( encrypt == 0 || encrypt == 10)	encrypt=0;	//disable,802.1X
		else if ( encrypt > 0 && encrypt < 4)	encrypt=1;	//WEP
		else if ( encrypt == 4 || encrypt == 5 )encrypt=2;	//WPA
		else if ( encrypt == 6 || encrypt == 7)	encrypt=4;	//WPA2
		else if ( encrypt == 8 || encrypt == 9 )encrypt=6;	//WPA+WPA2
	}
#else
	if (strEncrypt[0]=='0')	encrypt=0;
	else if (strEncrypt[0]=='1') encrypt=1;
	else if (((strEncrypt[0]=='2')||(strEncrypt[0]=='3')) && (strWpaCipher[0]=='1')) encrypt=2;
	else if (((strEncrypt[0]=='2')||(strEncrypt[0]=='3')) && (strWpaCipher[0]=='2')) encrypt=4;
	else if (((strEncrypt[0]=='2')||(strEncrypt[0]=='3')) && (strWpaCipher[0]=='3')) encrypt=6;
#endif
	switch(ssidID)
	{
		case 0:	apmib_set( MIB_WLAN_ENCRYPT,   (void *)&encrypt); break;
		case 1:	apmib_set( MIB_WLAN_ENCRYPT_1, (void *)&encrypt); break;
		case 2:	apmib_set( MIB_WLAN_ENCRYPT_2, (void *)&encrypt); break;
		case 3:	apmib_set( MIB_WLAN_ENCRYPT_3, (void *)&encrypt); break;
		case 4:	apmib_set( MIB_WLAN_ENCRYPT_4, (void *)&encrypt); break;
		case 5:	apmib_set( MIB_WLAN_ENCRYPT_5, (void *)&encrypt); break;
		case 6:	apmib_set( MIB_WLAN_ENCRYPT_6, (void *)&encrypt); break;
		case 7:	apmib_set( MIB_WLAN_ENCRYPT_7, (void *)&encrypt); break;
		default: break;
	}
//*********************************** Wep setting ***********************************
	if (encrypt==ENCRYPT_WEP) {
		strEnabled = websGetVar(wp, T("wepEnabled_2"), T(""));
		if ( !gstrcmp(strEnabled, T("ON")))
			enabled = 1;
		else
			enabled = 0;

		if ( enabled ) {
			strKeyLen = websGetVar(wp, T("length_2"), T(""));
			if (!strKeyLen[0]) {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt2))</script>"));
				goto setErr_encrypt;
			}
			if (strKeyLen[0]!='1' && strKeyLen[0]!='2' && strKeyLen[0]!='3') {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt3))</script>"));
				goto setErr_encrypt;
			}
			if (strKeyLen[0] == '1')
				wep = WEP64;
			else if (strKeyLen[0] == '2')
				wep = WEP128;
			else
				wep = WEP152;
		}
		else
			wep = WEP_DISABLED;

switch(ssidID)
{
	case 0:	apmib_set( MIB_WLAN_WEP, (void *)&wep);  break;
	case 1:	apmib_set( MIB_WLAN_WEP_1, (void *)&wep);break;
	case 2:	apmib_set( MIB_WLAN_WEP_2, (void *)&wep);break;
	case 3:	apmib_set( MIB_WLAN_WEP_3, (void *)&wep);break;
	case 4:	apmib_set( MIB_WLAN_WEP_4, (void *)&wep);break;
	case 5:	apmib_set( MIB_WLAN_WEP_5, (void *)&wep);break;
	case 6:	apmib_set( MIB_WLAN_WEP_6, (void *)&wep);break;
	case 7:	apmib_set( MIB_WLAN_WEP_7, (void *)&wep);break;
	default:break;
}
		if (wep == WEP_DISABLED)
			goto setwep_ret;

		strFormat = websGetVar(wp, T("format_2"), T(""));
		if (!strFormat[0]) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt5))</script>"));
			goto setErr_encrypt;
		}

		if (strFormat[0]!='1' && strFormat[0]!='2') {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt6))</script>"));
			goto setErr_encrypt;
		}

		i = strFormat[0] - '0' - 1;

switch(ssidID)
{
	case 0:	apmib_set( MIB_WLAN_WEP_KEY_TYPE, (void *)&i);  break;
	case 1:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_1, (void *)&i);break;
	case 2:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_2, (void *)&i);break;
	case 3:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_3, (void *)&i);break;
	case 4:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_4, (void *)&i);break;
	case 5:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_5, (void *)&i);break;
	case 6:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_6, (void *)&i);break;
	case 7:	apmib_set( MIB_WLAN_WEP_KEY_TYPE_7, (void *)&i);break;
	default:break;
}
		if (wep == WEP64) {
			if (strFormat[0]=='1')
				keyLen = WEP64_KEY_LEN;
			else
				keyLen = WEP64_KEY_LEN*2;
		}
		else if (wep == WEP128) {
			if (strFormat[0]=='1')
				keyLen = WEP128_KEY_LEN;
			else
				keyLen = WEP128_KEY_LEN*2;
		}
		else {
			if (strFormat[0]=='1')
				keyLen = WEP152_KEY_LEN;
			else
				keyLen = WEP152_KEY_LEN*2;
		}
		strKeyId = websGetVar(wp, T("defaultTxKeyId_2"), T(""));
		if ( strKeyId[0] ) {
			if ( strKeyId[0]!='1' && strKeyId[0]!='2' && strKeyId[0]!='3' && strKeyId[0]!='4' ) {
		 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt8))</script>"));
				goto setErr_encrypt;
			}
			i = strKeyId[0] - '0' - 1;
			switch(ssidID)
			{
				case 0:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&i);  break;
				case 1:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_1, (void *)&i);break;
				case 2:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_2, (void *)&i);break;
				case 3:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_3, (void *)&i);break;
				case 4:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_4, (void *)&i);break;
				case 5:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_5, (void *)&i);break;
				case 6:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_6, (void *)&i);break;
				case 7:	apmib_set( MIB_WLAN_WEP_DEFAULT_KEY_7, (void *)&i);break;
				default:break;
			}
		}

wepKey = websGetVar(wp, T("key1_2"), T(""));
if( wepKey[0] && strlen(wepKey) == keyLen && !isAllStar(wepKey) )
{
	if (strFormat[0] == '1')	strcpy(key, wepKey);
	else				string_to_hex(wepKey, key, keyLen);

	if (wep == WEP64)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP64_KEY1, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP64_KEY1_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP64_KEY1_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP64_KEY1_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP64_KEY1_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP64_KEY1_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP64_KEY1_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP64_KEY1_7, (void *)&key);	break;
			default:break;
		}
	else if	(wep == WEP128)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP128_KEY1, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP128_KEY1_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP128_KEY1_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP128_KEY1_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP128_KEY1_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP128_KEY1_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP128_KEY1_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP128_KEY1_7, (void *)&key);	break;
			default:break;
		}
	/*else
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP152_KEY1, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP152_KEY1_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP152_KEY1_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP152_KEY1_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP152_KEY1_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP152_KEY1_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP152_KEY1_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP152_KEY1_7, (void *)&key);	break;
			default:break;
		}*/
}
wepKey = websGetVar(wp, T("key2_2"), T(""));
if( wepKey[0] && strlen(wepKey) == keyLen && !isAllStar(wepKey) )
{
	if (strFormat[0] == '1')	strcpy(key, wepKey);
	else						string_to_hex(wepKey, key, keyLen);

	if (wep == WEP64)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP64_KEY2, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP64_KEY2_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP64_KEY2_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP64_KEY2_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP64_KEY2_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP64_KEY2_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP64_KEY2_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP64_KEY2_7, (void *)&key);	break;
			default:break;
		}
	else if	(wep == WEP128)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP128_KEY2, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP128_KEY2_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP128_KEY2_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP128_KEY2_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP128_KEY2_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP128_KEY2_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP128_KEY2_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP128_KEY2_7, (void *)&key);	break;
			default:break;
		}
	/*else
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP152_KEY2, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP152_KEY2_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP152_KEY2_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP152_KEY2_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP152_KEY2_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP152_KEY2_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP152_KEY2_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP152_KEY2_7, (void *)&key);	break;
			default:break;
		}*/
}
wepKey = websGetVar(wp, T("key3_2"), T(""));
if( wepKey[0] && strlen(wepKey) == keyLen && !isAllStar(wepKey) )
{
	if (strFormat[0] == '1')	strcpy(key, wepKey);
	else						string_to_hex(wepKey, key, keyLen);

	if (wep == WEP64)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP64_KEY3, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP64_KEY3_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP64_KEY3_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP64_KEY3_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP64_KEY3_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP64_KEY3_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP64_KEY3_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP64_KEY3_7, (void *)&key);	break;
			default:break;
		}
	else if	(wep == WEP128)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP128_KEY3, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP128_KEY3_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP128_KEY3_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP128_KEY3_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP128_KEY3_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP128_KEY3_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP128_KEY3_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP128_KEY3_7, (void *)&key);	break;
			default:break;
		}
	/*else
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP152_KEY3, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP152_KEY3_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP152_KEY3_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP152_KEY3_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP152_KEY3_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP152_KEY3_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP152_KEY3_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP152_KEY3_7, (void *)&key);	break;
			default:break;
		}*/
}
wepKey = websGetVar(wp, T("key4_2"), T(""));
if( wepKey[0] && strlen(wepKey) == keyLen && !isAllStar(wepKey) )
{
	if (strFormat[0] == '1')	strcpy(key, wepKey);
	else						string_to_hex(wepKey, key, keyLen);

	if (wep == WEP64)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP64_KEY4, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP64_KEY4_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP64_KEY4_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP64_KEY4_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP64_KEY4_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP64_KEY4_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP64_KEY4_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP64_KEY4_7, (void *)&key);	break;
			default:break;
		}
	else if	(wep == WEP128)
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP128_KEY4, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP128_KEY4_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP128_KEY4_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP128_KEY4_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP128_KEY4_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP128_KEY4_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP128_KEY4_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP128_KEY4_7, (void *)&key);	break;
			default:break;
		}
	/*else
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WEP152_KEY4, (void *)&key);	break;
			case 1: apmib_set(MIB_WLAN_WEP152_KEY4_1, (void *)&key);	break;
			case 2: apmib_set(MIB_WLAN_WEP152_KEY4_2, (void *)&key);	break;
			case 3: apmib_set(MIB_WLAN_WEP152_KEY4_3, (void *)&key);	break;
			case 4: apmib_set(MIB_WLAN_WEP152_KEY4_4, (void *)&key);	break;
			case 5: apmib_set(MIB_WLAN_WEP152_KEY4_5, (void *)&key);	break;
			case 6: apmib_set(MIB_WLAN_WEP152_KEY4_6, (void *)&key);	break;
			case 7: apmib_set(MIB_WLAN_WEP152_KEY4_7, (void *)&key);	break;
			default:break;
		}*/
}
}

//*********************************** pre-shared key setting ***********************************
	if ( getPSK ) {
		int oldFormat, oldPskLen, i;

		strVal = websGetVar(wp, T("pskFormat_2"), T(""));
		if (!strVal[0]) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt22))</script>"));
			goto setErr_encrypt;
		}
		intVal = strVal[0] - '0';
		if (intVal != 0 && intVal != 1) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt23))</script>"));
			goto setErr_encrypt;
		}

		// remember current psk format and length to compare to default case "****"
		//vance 2009.02.23 fixed pskvalue error
		switch(ssidID)
		{
			case 0:apmib_get(MIB_WLAN_WPA_PSK_FORMAT, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK, (void *)tmpBuf);break;
			case 1:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_1, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_1, (void *)tmpBuf);break;
			case 2:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_2, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_2, (void *)tmpBuf);break;
			case 3:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_3, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_3, (void *)tmpBuf);break;
			case 4:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_4, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_4, (void *)tmpBuf);break;
			case 5:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_5, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_5, (void *)tmpBuf);break;
			case 6:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_6, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_6, (void *)tmpBuf);break;
			case 7:apmib_get(MIB_WLAN_WPA_PSK_FORMAT_7, (void *)&oldFormat);apmib_get(MIB_WLAN_WPA_PSK_7, (void *)tmpBuf);break;
			default:break;
		}
		oldPskLen = strlen(tmpBuf);

		strVal = websGetVar(wp, T("pskValue_2"), T(""));
		len = strlen(strVal);
			if (oldFormat == intVal && len == oldPskLen ) {
				for (i=0; i<len; i++) {
					if ( strVal[i] != '*' )
						break;
				}
				if (i == len)
					goto rekey_time;
			}
		switch(ssidID)
		{
			case 0: apmib_set(MIB_WLAN_WPA_PSK_FORMAT, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK, (void *)strVal);	break;
			case 1: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_1, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_1, (void *)strVal);	break;
			case 2: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_2, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_2, (void *)strVal);	break;
			case 3: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_3, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_3, (void *)strVal);	break;
			case 4: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_4, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_4, (void *)strVal);	break;
			case 5: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_5, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_5, (void *)strVal);	break;
			case 6: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_6, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_6, (void *)strVal);	break;
			case 7: apmib_set(MIB_WLAN_WPA_PSK_FORMAT_7, (void *)&intVal);	apmib_set(MIB_WLAN_WPA_PSK_7, (void *)strVal);	break;
			default:break;
		}
	}
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	// set key renewed interval
	strVal = websGetVar(wp, T("RekeyTime_2"), T(""));
	/*if (!strVal[0]) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt7))</script>"));
		goto setErr_encrypt;
	}*/
	if (!string_to_dec(strVal, &longintVal) || longintVal<0) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt19))</script>"));
		goto setErr_encrypt;
	}
	if ( !apmib_set(MIB_WLAN_WPA_GROUP_REKEY_TIME_1, (void *)&longintVal)) {
		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt22))</script>"));
		goto setErr_encrypt;
	}
#endif
//****************************************  ****************************************
rekey_time:

//*********************************** RADIUS Server setting ***********************************
	if (enableRS == 1) { // if 1x enabled, get RADIUS server info
		#ifndef HOME_GATEWAY
		 if (!str1xMode[0]) {
		 #endif
		// set Radius Port
		strVal = websGetVar(wp, T("radiusPort_2"), T(""));
		if (!strVal[0]) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt7))</script>"));
				goto setErr_encrypt;
			}
			if (!string_to_dec(strVal, &intVal) || intVal<=0 || intVal>65535) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt8))</script>"));
				goto setErr_encrypt;
			}
#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_RS_PORT, (void *)&intVal); break;
				case 1: apmib_set(MIB_WLAN_RS_PORT_1, (void *)&intVal); break;
				case 2: apmib_set(MIB_WLAN_RS_PORT_2, (void *)&intVal); break;
				case 3: apmib_set(MIB_WLAN_RS_PORT_3, (void *)&intVal); break;
				case 4: apmib_set(MIB_WLAN_RS_PORT_4, (void *)&intVal); break;
				case 5: apmib_set(MIB_WLAN_RS_PORT_5, (void *)&intVal); break;
				case 6: apmib_set(MIB_WLAN_RS_PORT_6, (void *)&intVal); break;
				case 7: apmib_set(MIB_WLAN_RS_PORT_7, (void *)&intVal); break;
				default: break;
			}
#else
			if ( !apmib_set(MIB_WLAN_RS_PORT, (void *)&intVal)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt9))</script>"));
				goto setErr_encrypt;
			}
#endif
		//Radius Ip
			strVal = websGetVar(wp, T("radiusIP_2"), T(""));
			if (!strVal[0]) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt10))</script>"));
				goto setErr_encrypt;
			}
			if ( !inet_aton(strVal, &inIp) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt11))</script>"));
				goto setErr_encrypt;
			}

#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_RS_IP, (void *)&inIp); break;
				case 1: apmib_set(MIB_WLAN_RS_IP_1, (void *)&inIp); break;
				case 2: apmib_set(MIB_WLAN_RS_IP_2, (void *)&inIp); break;
				case 3: apmib_set(MIB_WLAN_RS_IP_3, (void *)&inIp); break;
				case 4: apmib_set(MIB_WLAN_RS_IP_4, (void *)&inIp); break;
				case 5: apmib_set(MIB_WLAN_RS_IP_5, (void *)&inIp); break;
				case 6: apmib_set(MIB_WLAN_RS_IP_6, (void *)&inIp); break;
				case 7: apmib_set(MIB_WLAN_RS_IP_7, (void *)&inIp); break;
				default: break;
			}
#else
			if ( !apmib_set(MIB_WLAN_RS_IP, (void *)&inIp)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt12))</script>"));
				goto setErr_encrypt;
			}
#endif
			//Radius password
			strVal = websGetVar(wp, T("radiusPass_2"), T(""));
			if (strlen(strVal) > (MAX_RS_PASS_LEN -1) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt13))</script>"));
				goto setErr_encrypt;
			}

#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_RS_PASSWORD, (void *)strVal); break;
				case 1: apmib_set(MIB_WLAN_RS_PASSWORD_1, (void *)strVal); break;
				case 2: apmib_set(MIB_WLAN_RS_PASSWORD_2, (void *)strVal); break;
				case 3: apmib_set(MIB_WLAN_RS_PASSWORD_3, (void *)strVal); break;
				case 4: apmib_set(MIB_WLAN_RS_PASSWORD_4, (void *)strVal); break;
				case 5: apmib_set(MIB_WLAN_RS_PASSWORD_5, (void *)strVal); break;
				case 6: apmib_set(MIB_WLAN_RS_PASSWORD_6, (void *)strVal); break;
				case 7: apmib_set(MIB_WLAN_RS_PASSWORD_7, (void *)strVal); break;
				default: break;
			}
#else
			if ( !apmib_set(MIB_WLAN_RS_PASSWORD, (void *)strVal)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt14))</script>"));
				goto setErr_encrypt;
			}
#endif
		#ifndef HOME_GATEWAY
		}
		#endif

		strVal = websGetVar(wp, T("wepKeyLen_2"), T(""));
		if (strVal[0]) {
			if ( !gstrcmp(strVal, T("wep64")))
				intVal = WEP64;
			else if ( !gstrcmp(strVal, T("wep128")))
				intVal = WEP128;
			else {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt15))</script>"));
				goto setErr_encrypt;
			}
			if ( apmib_set(MIB_WLAN_WEP, (void *)&intVal) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt16))</script>"));
				goto setErr_encrypt;
			}
		}
#if defined(_Customer_SA_) || defined(_Customer_EX_)
			// set session timeout
			strVal = websGetVar(wp, T("session_timeout_2"), T(""));
			/*if (!strVal[0]) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt7))</script>"));
					goto setErr_encrypt;
				}*/
				if (!string_to_dec(strVal, &intVal) || intVal<0 || intVal>65535) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt17))</script>"));
					goto setErr_encrypt;
				}
#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME, (void *)&intVal); break;
				case 1: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_1, (void *)&intVal); break;
				case 2: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_2, (void *)&intVal); break;
				case 3: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_3, (void *)&intVal); break;
				case 4: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_4, (void *)&intVal); break;
				case 5: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_5, (void *)&intVal); break;
				case 6: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_6, (void *)&intVal); break;
				case 7: apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME_7, (void *)&intVal); break;
				default: break;
			}
#else
				if ( !apmib_set(MIB_WLAN_ACCOUNT_RS_INTERVAL_TIME, (void *)&intVal)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt20))</script>"));
					goto setErr_encrypt;
				}
#endif
			// set idle timeout 
			strVal = websGetVar(wp, T("idle_timeout_2"), T(""));
			/*if (!strVal[0]) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt7))</script>"));
					goto setErr_encrypt;
				}*/
				if (!string_to_dec(strVal, &intVal) || intVal<0 || intVal>65535) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt18))</script>"));
					goto setErr_encrypt;
				}
#ifdef _MULTIPLE_WLAN_RS_SETTING_
			switch(ssidID)
			{
				case 0: apmib_set(MIB_WLAN_RS_INTERVAL_TIME, (void *)&intVal); break;
				case 1: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_1, (void *)&intVal); break;
				case 2: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_2, (void *)&intVal); break;
				case 3: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_3, (void *)&intVal); break;
				case 4: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_4, (void *)&intVal); break;
				case 5: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_5, (void *)&intVal); break;
				case 6: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_6, (void *)&intVal); break;
				case 7: apmib_set(MIB_WLAN_RS_INTERVAL_TIME_7, (void *)&intVal); break;
				default: break;
			}
#else
				if ( !apmib_set(MIB_WLAN_RS_INTERVAL_TIME, (void *)&intVal)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt21))</script>"));
					goto setErr_encrypt;
				}
#endif
#endif
	}

//-----------------------------------------------------------------------------------------------
setwep_ret:
	apmib_update(CURRENT_SETTING);
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	strWlencryEnable = websGetVar(wp, T("setwlencryptEnable"), T(""));

	if (strWlencryEnable[0]){
		REPLACE_MSG(submitUrl);
	}
	else {
		OK_MSG(submitUrl);
	}
	return;

setErr_encrypt:
	ERR_MSG(tmpBuf);
}
/////////////////////////////////////////////////////////////////////////////
#endif
#endif
/////////////////////////////////////////////////////////////////////////////
int wlAcList(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0, entryNum, i;
	MACFILTER_T entry;
	char tmpBuf[100];
	char macBuf[100];


	#ifdef _MULTIPLE_WLAN_ACCESS_CONTROL_ //vance 2008.10.24
	if ( argv[0][0] == '1' ) {
		if ( !apmib_get(MIB_WLAN_AC_NUM, (void *)&entryNum))
		{
	  		websError(wp, 400, T("Get table entry error!\n"));
			return -1;
		}
	}
	else if ( argv[0][0] == '2' ) {
		if ( !apmib_get(MIB_WLAN_AC2_NUM, (void *)&entryNum))
		{
	  		websError(wp, 400, T("Get table entry error!\n"));
			return -1;
		}
	}
	else if ( argv[0][0] == '3' ) {
		if ( !apmib_get(MIB_WLAN_AC3_NUM, (void *)&entryNum))
		{
	  		websError(wp, 400, T("Get table entry error!\n"));
			return -1;
		}
	}
	else if ( argv[0][0] == '4' ) {
		if ( !apmib_get(MIB_WLAN_AC4_NUM, (void *)&entryNum))
		{
	  		websError(wp, 400, T("Get table entry error!\n"));
			return -1;
		}
	}
	else if ( argv[0][0] == '5' ) {
		if ( !apmib_get(MIB_WLAN_AC5_NUM, (void *)&entryNum))
		{
	  		websError(wp, 400, T("Get table entry error!\n"));
			return -1;
		}
	}
	#else
	if ( !apmib_get(MIB_WLAN_AC_NUM, (void *)&entryNum))
	{
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}
	#endif


	for (i=1; i<=entryNum; i++)
	{
		*((char *)&entry) = (char)i;

	#ifdef _MULTIPLE_WLAN_ACCESS_CONTROL_ //vance 2008.10.24
		if ( argv[0][0] == '1' ) {
			if ( !apmib_get(MIB_WLAN_AC_ADDR, (void *)&entry)) return -1;
		}
		else if ( argv[0][0] == '2' ) {
			if ( !apmib_get(MIB_WLAN_AC2_ADDR, (void *)&entry)) return -1;
		}
		else if ( argv[0][0] == '3' ) {
			if ( !apmib_get(MIB_WLAN_AC3_ADDR, (void *)&entry)) return -1;
		}
		else if ( argv[0][0] == '4' ) {
			if ( !apmib_get(MIB_WLAN_AC4_ADDR, (void *)&entry)) return -1;
		}
		else if ( argv[0][0] == '5' ) {
			if ( !apmib_get(MIB_WLAN_AC5_ADDR, (void *)&entry)) return -1;
		}
	#else
		if ( !apmib_get(MIB_WLAN_AC_ADDR, (void *)&entry)) return -1;
	#endif
		snprintf(tmpBuf, 100, T("%02x:%02x:%02x:%02x:%02x:%02x"),
			entry.macAddr[0], entry.macAddr[1], entry.macAddr[2],
			entry.macAddr[3], entry.macAddr[4], entry.macAddr[5]);
		snprintf(macBuf, 100, T("%02x%02x%02x%02x%02x%02x"),
			entry.macAddr[0], entry.macAddr[1], entry.macAddr[2],
			entry.macAddr[3], entry.macAddr[4], entry.macAddr[5]);
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	        nBytesSent += websWrite(wp, T("<tr>"
		"<td class=\"ntable\"><font size=\"2\">%d</td>\n"
		"<td class=\"ntable\"><font size=\"2\">%s</td><input type=\"hidden\" name=\"macn%d\" value=\"%s\">\n"
		"<td class=\"ntable\"><font size=\"2\">%s</td><input type=\"hidden\" name=\"comment%d\" value=\"%s\">\n"
		"<td class=\"ntable\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td></tr>\n"),
		i, tmpBuf,i,macBuf,CharFilter4(entry.comment),i ,CharFilter4(entry.comment),i);
#elif defined(_Customer_) && (defined(_EW7218HNL_) || defined(_EW7428HRN_))
                nBytesSent += websWrite(wp, T("<tr bgcolor=\"#f1f1f1\">"
                "<td width=\"5%%\" style=\"padding:5px;\"><div align=\"left\">%d</div></td>\n"
                "<td style=\"padding:5px;\"><div align=\"left\">%s</div></td><input type=\"hidden\" name=\"macn%d\" value=\"%s\">\n"
                "<td style=\"padding:5px;\"><div align=\"left\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td></tr></div></td></tr>\n"),
		i, tmpBuf,i,macBuf,i);
#elif defined(_Airlive_7428HCN_)
                nBytesSent += websWrite(wp, T("<tr>"
                "<td align=center class=\"table5\"><font size=\"2\">%s</td><input type=\"hidden\" name=\"macn%d\" value=\"%s\">\n"
                "<td align=center class=\"table5\"><font size=\"2\">%s</td><input type=\"hidden\" name=\"comment%d\" value=\"%s\">\n"
                "<td align=center class=\"table5\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td></tr>\n"),
                tmpBuf,i,macBuf,CharFilter4(entry.comment),i ,CharFilter4(entry.comment),i);

#else
                nBytesSent += websWrite(wp, T("<tr>"
		"<td align=center class=\"table2\"><font size=\"2\">%d</td>\n"
		"<td align=center class=\"table2\"><font size=\"2\">%s</td><input type=\"hidden\" name=\"macn%d\" value=\"%s\">\n"
      		"<td align=center class=\"table2\"><font size=\"2\">%s</td><input type=\"hidden\" name=\"comment%d\" value=\"%s\">\n"
	       	"<td align=center class=\"table2\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td></tr>\n"),
		i, tmpBuf,i,macBuf,CharFilter4(entry.comment),i ,CharFilter4(entry.comment),i);
#endif
	}
	nBytesSent += websWrite(wp, T("<input type=\"hidden\" name=\"sipnum\" value=\"%d\">\n"),i-1);
	return nBytesSent;
}

/////////////////////////////////////////////////////////////////////////////
void formWlAc(webs_t wp, char_t *path, char_t *query)
{
	char_t *strAddMac, *strDelMac, *strDelAllMac, *strVal, *submitUrl, *strEnabled, *strApply;
	char tmpBuf[100];
	int entryNum, i, enabled;
	MACFILTER_T macEntry;

	strAddMac = websGetVar(wp, T("addFilterMac"), T(""));
	strDelMac = websGetVar(wp, T("deleteSelFilterMac"), T(""));
	strDelAllMac = websGetVar(wp, T("deleteAllFilterMac"), T(""));
	strEnabled = websGetVar(wp, T("wlanAcEnabled"), T(""));

	#ifdef _MULTIPLE_WLAN_ACCESS_CONTROL_ //vance 2008.10.24
		char_t *strIndex;
		strIndex = websGetVar(wp, T("wlanSSIDIndex"), T(""));
	#endif

	//printf("strIndex=%c\n",strIndex[0]);
#if defined(_Customer_SA_) || defined(_Customer_EX_)      //Felix add enabled=0--disable   enabled=1--accept   enabled=2--deny
        if (strAddMac[0] || strEnabled[0]) {
#else
	if (strAddMac[0]) {
#endif

#ifdef _Airlive_7428HCN_
		enabled = atoi(strEnabled);
#else
		if ( !gstrcmp(strEnabled, T("ON")))
			enabled = 1;
		else
			enabled = 0;
#endif
#if defined(_Customer_SA_) || defined(_Customer_EX_)	//Felix add enabled=0--disable   enabled=1--accept   enabled=2--deny
	if ( !gstrcmp(strEnabled, T("OFF")) )
		enabled = 0;
	else {
		strVal = websGetVar(wp, T("wlan_enable"), T(""));
		enabled = (int)strVal[0] - '0' + 1;
		printf(" enabled = %d\n",enabled);
	}
	if (strEnabled[0]) {
#endif
	#ifdef _MULTIPLE_WLAN_ACCESS_CONTROL_ //vance 2008.10.24
		if ( strIndex[0] == '1' ) {
			if ( apmib_set( MIB_WLAN_AC_ENABLED, (void *)&enabled) == 0) {
	  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc1))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '2' ) {
			if ( apmib_set( MIB_WLAN_AC2_ENABLED, (void *)&enabled) == 0) {
	  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc1))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '3' ) {
			if ( apmib_set( MIB_WLAN_AC3_ENABLED, (void *)&enabled) == 0) {
	  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc1))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '4' ) {
			if ( apmib_set( MIB_WLAN_AC4_ENABLED, (void *)&enabled) == 0) {
	  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc1))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '5' ) {
			if ( apmib_set( MIB_WLAN_AC5_ENABLED, (void *)&enabled) == 0) {
	  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc1))</script>"));
				goto setErr_ac;
			}
		}
	#else
		if ( apmib_set( MIB_WLAN_AC_ENABLED, (void *)&enabled) == 0) {
  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc1))</script>"));
			goto setErr_ac;
		}
	#endif
#if defined(_Customer_SA_) || defined(_Customer_EX_)
	}
#endif

		strVal = websGetVar(wp, T("mac"), T(""));
		if ( !strVal[0] ) {
//			DEBUGP(tmpBuf, T("Error! No mac address to set."));
			goto setac_ret;
		}
		if (strlen(strVal)!=12 || !string_to_hex(strVal, macEntry.macAddr, 12)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc2))</script>"));
			goto setErr_ac;
		}

		strVal = websGetVar(wp, T("comment"), T(""));
		translate_control_code(strVal);
		if ( strVal[0] ) {
			if (strlen(strVal) > COMMENT_LEN-1) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc3))</script>"));
				goto setErr_ac;
			}
			strcpy(macEntry.comment, CharFilter3(strVal));
		}
		else
			macEntry.comment[0] = '\0';


	#ifdef _MULTIPLE_WLAN_ACCESS_CONTROL_ //vance 2008.10.24
		if ( strIndex[0] == '1' ) {
			if ( !apmib_get(MIB_WLAN_AC_NUM, (void *)&entryNum)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '2' ) {
			if ( !apmib_get(MIB_WLAN_AC2_NUM, (void *)&entryNum)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '3' ) {
			if ( !apmib_get(MIB_WLAN_AC3_NUM, (void *)&entryNum)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '4' ) {
			if ( !apmib_get(MIB_WLAN_AC4_NUM, (void *)&entryNum)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '5' ) {
			if ( !apmib_get(MIB_WLAN_AC5_NUM, (void *)&entryNum)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
				goto setErr_ac;
			}
		}

	#else
		if ( !apmib_get(MIB_WLAN_AC_NUM, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
			goto setErr_ac;
		}
	#endif

		if ( (entryNum + 1) > MAX_WLAN_AC_NUM) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormWlAc5))</script>"));
			goto setErr_ac;
		}

		// set to MIB. try to delete it first to avoid duplicate case
	#ifdef _MULTIPLE_WLAN_ACCESS_CONTROL_ //vance 2008.10.24
		if ( strIndex[0] == '1' ) {
			apmib_set(MIB_WLAN_AC_ADDR_DEL, (void *)&macEntry);
			if ( apmib_set(MIB_WLAN_AC_ADDR_ADD, (void *)&macEntry) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc6))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '2' ) {
			apmib_set(MIB_WLAN_AC2_ADDR_DEL, (void *)&macEntry);
			if ( apmib_set(MIB_WLAN_AC2_ADDR_ADD, (void *)&macEntry) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc6))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '3' ) {
			apmib_set(MIB_WLAN_AC3_ADDR_DEL, (void *)&macEntry);
			if ( apmib_set(MIB_WLAN_AC3_ADDR_ADD, (void *)&macEntry) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc6))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '4' ) {
			apmib_set(MIB_WLAN_AC4_ADDR_DEL, (void *)&macEntry);
			if ( apmib_set(MIB_WLAN_AC4_ADDR_ADD, (void *)&macEntry) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc6))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '5' ) {
			apmib_set(MIB_WLAN_AC5_ADDR_DEL, (void *)&macEntry);
			if ( apmib_set(MIB_WLAN_AC5_ADDR_ADD, (void *)&macEntry) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc6))</script>"));
				goto setErr_ac;
			}
		}
	#else
		apmib_set(MIB_WLAN_AC_ADDR_DEL, (void *)&macEntry);
		if ( apmib_set(MIB_WLAN_AC_ADDR_ADD, (void *)&macEntry) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc6))</script>"));
			goto setErr_ac;
		}
	#endif


	}

	/* Delete entry */
	if (strDelMac[0]) {


	#ifdef _MULTIPLE_WLAN_ACCESS_CONTROL_ //vance 2008.10.24
		if ( strIndex[0] == '1' ) {
			if ( !apmib_get(MIB_WLAN_AC_NUM, (void *)&entryNum)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '2' ) {
			if ( !apmib_get(MIB_WLAN_AC2_NUM, (void *)&entryNum)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '3' ) {
			if ( !apmib_get(MIB_WLAN_AC3_NUM, (void *)&entryNum)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '4' ) {
			if ( !apmib_get(MIB_WLAN_AC4_NUM, (void *)&entryNum)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '5' ) {
			if ( !apmib_get(MIB_WLAN_AC5_NUM, (void *)&entryNum)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
				goto setErr_ac;
			}
		}
	#else
		if ( !apmib_get(MIB_WLAN_AC_NUM, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
			goto setErr_ac;
		}
	#endif


		for (i=entryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "select%d", i);

			strVal = websGetVar(wp, tmpBuf, T(""));
			if ( !gstrcmp(strVal, T("ON")) ) {

				*((char *)&macEntry) = (char)i;


	#ifdef _MULTIPLE_WLAN_ACCESS_CONTROL_ //vance 2008.10.24
				if ( strIndex[0] == '1' ) {
					if ( !apmib_get(MIB_WLAN_AC_ADDR, (void *)&macEntry)) {
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspWlAcList1))</script>"));
						goto setErr_ac;
					}
					if ( !apmib_set(MIB_WLAN_AC_ADDR_DEL, (void *)&macEntry)) {
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRoute21))</script>"));
						goto setErr_ac;
					}
				}
				else if ( strIndex[0] == '2' ) {
					if ( !apmib_get(MIB_WLAN_AC2_ADDR, (void *)&macEntry)) {
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspWlAcList1))</script>"));
						goto setErr_ac;
					}
					if ( !apmib_set(MIB_WLAN_AC2_ADDR_DEL, (void *)&macEntry)) {
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRoute21))</script>"));
						goto setErr_ac;
					}
				}
				else if ( strIndex[0] == '3' ) {
					if ( !apmib_get(MIB_WLAN_AC3_ADDR, (void *)&macEntry)) {
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspWlAcList1))</script>"));
						goto setErr_ac;
					}
					if ( !apmib_set(MIB_WLAN_AC3_ADDR_DEL, (void *)&macEntry)) {
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRoute21))</script>"));
						goto setErr_ac;
					}
				}
				else if ( strIndex[0] == '4' ) {
					if ( !apmib_get(MIB_WLAN_AC4_ADDR, (void *)&macEntry)) {
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspWlAcList1))</script>"));
						goto setErr_ac;
					}
					if ( !apmib_set(MIB_WLAN_AC4_ADDR_DEL, (void *)&macEntry)) {
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRoute21))</script>"));
						goto setErr_ac;
					}
				}
				else if ( strIndex[0] == '5' ) {
					if ( !apmib_get(MIB_WLAN_AC5_ADDR, (void *)&macEntry)) {
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspWlAcList1))</script>"));
						goto setErr_ac;
					}
					if ( !apmib_set(MIB_WLAN_AC5_ADDR_DEL, (void *)&macEntry)) {
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRoute21))</script>"));
						goto setErr_ac;
					}
				}
	#else
				if ( !apmib_get(MIB_WLAN_AC_ADDR, (void *)&macEntry)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspWlAcList1))</script>"));
					goto setErr_ac;
				}
				if ( !apmib_set(MIB_WLAN_AC_ADDR_DEL, (void *)&macEntry)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRoute21))</script>"));
					goto setErr_ac;
				}
	#endif


			}
		}
	}

	/* Delete all entry */
	if ( strDelAllMac[0]) {


	#ifdef _MULTIPLE_WLAN_ACCESS_CONTROL_ //vance 2008.10.24
		if ( strIndex[0] == '1' ) {
			if ( !apmib_set(MIB_WLAN_AC_ADDR_DELALL, (void *)&macEntry)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc8))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '2' ) {
			if ( !apmib_set(MIB_WLAN_AC2_ADDR_DELALL, (void *)&macEntry)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc8))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '3' ) {
			if ( !apmib_set(MIB_WLAN_AC3_ADDR_DELALL, (void *)&macEntry)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc8))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '4' ) {
			if ( !apmib_set(MIB_WLAN_AC4_ADDR_DELALL, (void *)&macEntry)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc8))</script>"));
				goto setErr_ac;
			}
		}
		else if ( strIndex[0] == '5' ) {
			if ( !apmib_set(MIB_WLAN_AC5_ADDR_DELALL, (void *)&macEntry)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc8))</script>"));
				goto setErr_ac;
			}
		}
	#else
		if ( !apmib_set(MIB_WLAN_AC_ADDR_DELALL, (void *)&macEntry)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc8))</script>"));
			goto setErr_ac;
		}
	#endif


	}


setac_ret:
	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	// run script file to update WLAN parameters
	#ifdef HOME_GATEWAY
		//sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG, "gw", "all");
		//system(tmpBuf);
	#else
		//sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG, "ap", "all");
		//system(tmpBuf);
	#endif
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	strApply = websGetVar(wp, T("isApply"), T(""));   // Tommy

#ifdef _MULTIPLE_WLAN_ACCESS_CONTROL_ //vance 2008.10.27
	char tmp[100];
	sprintf(tmp,"%s?page=%s",submitUrl,strIndex);
	submitUrl=tmp;
#endif


#ifdef _7207CG_
	#if defined(_Customer_) | defined(_taiCustomer_)
		OK_MSG( submitUrl );
		return;
	#else
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);

	  	return;
	#endif
#else
	// Tommy Modified on 0602
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif


	if (strApply[0]) {

		OK_MSG(submitUrl);

	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}

  	return;
#endif

setErr_ac:
	ERR_MSG(tmpBuf);
}

//vance add 2008.11.20
#if defined(_WIRELESS_SCHEDULE_)
int wlSchList(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0, entryNum, i;
	SCHEDULE_T entry;
	char buf[500];
	#if defined(_EZVIEW_)
		char WEEKArray[7][40]= {"<script>dw(wlshedule_s4)</script>","<script>dw(wlshedule_s5)</script>","<script>dw(wlshedule_s6)</script>","<script>dw(wlshedule_s7)</script>","<script>dw(wlshedule_s8)</script>","<script>dw(wlshedule_s9)</script>","<script>dw(wlshedule_s10)</script>"};
		char ComArray[6][40]= {"<script>dw(wlshedule_s15)</script>","<script>dw(wlshedule_s16)</script>","Port Forwarding on","Port Forwarding off","Url Blocking on","Url Blocking off"};
	#else
		char WEEKArray[7][10]= {"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};
		char ComArray[6][40]= {"wireless on","wireless off","Port Forwarding on","Port Forwarding off","Url Blocking on","Url Blocking off"};
	#endif

	if ( !apmib_get(MIB_WLAN_SCH_NUM, (void *)&entryNum))
	{
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}

	buf[0]='\0';
	for (i=1; i<=entryNum; i++)
	{
		*((char *)&entry) = (char)i;

		if ( !apmib_get(MIB_WLAN_SCH, (void *)&entry)) return -1;

		/*snprintf(tmpBuf, 100, T("%02x:%02x:%02x:%02x:%02x:%02x"),
			entry.macAddr[0], entry.macAddr[1], entry.macAddr[2],
			entry.macAddr[3], entry.macAddr[4], entry.macAddr[5]);*/
		//use binary type to decide that weekday be selected
		int first=1;
		int indexVal=0x0001;
		int j;
		for( j=0; j<=6 ;j++ )
		{
			if (entry.week & indexVal)
			{
				if (first == 0)
					strcat(buf,",");
				else
					strcpy(buf," ");
				strcat(buf,WEEKArray[j]);
				first = 0;
			}
			indexVal *=2;
		}

		nBytesSent += websWrite(wp, T("<tr>"));
		nBytesSent += websWrite(wp, T("  <td align=center class=\"table2\">%s</td>\n"),buf);
		nBytesSent += websWrite(wp, T("  <td align=center class=\"table2\">%02d:%02d</td>\n"),entry.hour,entry.minute);
		nBytesSent += websWrite(wp, T("  <td align=center class=\"table2\">%s</td>\n"),ComArray[entry.command]);
		nBytesSent += websWrite(wp, T("  <td align=center class=\"table2\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td>\n"),i);
		nBytesSent += websWrite(wp, T("</tr>\n"));
	}
	return nBytesSent;
}


void formWlSch(webs_t wp, char_t *path, char_t *query)
{
	char_t *strAddSch, *strDelSch, *strDelAllSch, *strVal, *submitUrl, *strEnabled, *strApply;
	char tmpBuf[100];
	int entryNum, i, enabled;
	SCHEDULE_T schEntry;

	strAddSch = websGetVar(wp, T("addSchdule"), T(""));
	strDelSch = websGetVar(wp, T("deleteSelSch"), T(""));
	strDelAllSch = websGetVar(wp, T("deleteAllSch"), T(""));
	strEnabled = websGetVar(wp, T("wlanSchEnabled"), T(""));

	if (strAddSch[0]) {
		//printf("stradd %s\n",strEnabled);
		if ( !gstrcmp(strEnabled, T("ON")))
			enabled = 1;
		else
			enabled = 0;
		//printf("go!!\n");
		if ( apmib_set( MIB_WLAN_SCH_ENABLED, (void *)&enabled) == 0) {
  			//DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc1))</script>"));
			goto setErr_ac;
		}

		//initialize entry
		schEntry.month=100;
		schEntry.day=100;
		strVal = websGetVar(wp, T("applyWeekValue"), T(""));
		if ( !strVal[0] ) {
//			DEBUGP(tmpBuf, T("Error! No mac address to set."));
			goto setac_ret;
		}
		else
			schEntry.week=atoi(strVal);

		strVal = websGetVar(wp, T("addSchHour"), T(""));
		if ( !strVal[0] ) {
//			DEBUGP(tmpBuf, T("Error! No mac address to set."));
			goto setac_ret;
		}
		else
			schEntry.hour=atoi(strVal);

		strVal = websGetVar(wp, T("addSchMin"), T(""));
		if ( !strVal[0] ) {
//			DEBUGP(tmpBuf, T("Error! No mac address to set."));
			goto setac_ret;
		}
		else
			schEntry.minute=atoi(strVal);

		strVal = websGetVar(wp, T("addSchCom"), T(""));
		if ( !strVal[0] ) {
//			DEBUGP(tmpBuf, T("Error! No mac address to set."));
			goto setac_ret;
		}
		else
			schEntry.command=atoi(strVal);

		/*strVal = websGetVar(wp, T("addSchCom"), T(""));
		if ( strVal[0] ) {
			if (strlen(strVal) > COMMENT_LEN-1) {
			//	DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc3))</script>"));
				goto setErr_ac;
			}
			strcpy(macEntry.comment, strVal);
		}
		else
			macEntry.comment[0] = '\0';*/

		if ( !apmib_get(MIB_WLAN_SCH_NUM, (void *)&entryNum)) {
		//	DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
			goto setErr_ac;
		}


		if ( (entryNum + 1) > MIB_WLAN_SCH_NUM) {
		//	strcpy(tmpBuf, T("<script>document.write(showText(aspFormWlAc5))</script>"));
			goto setErr_ac;
		}

		// set to MIB. try to delete it first to avoid duplicate case

		//apmib_set(MIB_WLAN_SCH_DEL, (void *)&macEntry);
		if ( apmib_set(MIB_WLAN_SCH_ADD, (void *)&schEntry) == 0) {
			//DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc6))</script>"));
			goto setErr_ac;
		}
	}

	/* Delete entry */
	if (strDelSch[0]) {
		if ( !apmib_get(MIB_WLAN_SCH_NUM, (void *)&entryNum)) {
			//DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
			goto setErr_ac;
		}
		for (i=entryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "select%d", i);

			strVal = websGetVar(wp, tmpBuf, T(""));
			if ( !gstrcmp(strVal, T("ON")) ) {

				*((char *)&schEntry) = (char)i;


				if ( !apmib_get(MIB_WLAN_SCH, (void *)&schEntry)) {
					//DEBUGP(tmpBuf, T("<script>document.write(showText(aspWlAcList1))</script>"));
					goto setErr_ac;
				}
				if ( !apmib_set(MIB_WLAN_SCH_DEL, (void *)&schEntry)) {
					//DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRoute21))</script>"));
					goto setErr_ac;
				}
			}
		}
	}

	/* Delete all entry */
	if ( strDelAllSch[0]) {
		if ( !apmib_set(MIB_WLAN_SCH_DELALL, (void *)&schEntry)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc8))</script>"));
			goto setErr_ac;
		}
	}


setac_ret:
	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	// run script file to update WLAN parameters
	#ifdef HOME_GATEWAY
		//sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG, "gw", "all");
		//system(tmpBuf);
	#else
		//sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG, "ap", "all");
		//system(tmpBuf);
	#endif
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	strApply = websGetVar(wp, T("isApply"), T(""));   // Tommy


#ifdef _7207CG_
	#if defined(_Customer_) | defined(_taiCustomer_)
		OK_MSG( submitUrl );
		return;
	#else
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);

	  	return;
	#endif
#else
	// Tommy Modified on 0602
	if (strApply[0]) {
#ifdef _TAG_IN_PAGE_
		main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
		sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
#endif
		OK_MSG(submitUrl);

	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}

  	return;
#endif

setErr_ac:
	ERR_MSG(tmpBuf);
}
#endif
///////////////////////////////////////////////////////////////////////////////////////////
#ifdef _PROFILE_LIST_
int profileList(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0, entryNum, i;
	PROFILELIST_T entry;
	char tmpBuf[50];

	if ( !apmib_get(MIB_PROFILE_LIST_NUM, (void *)&entryNum))
	{
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}

	for (i=1; i<=entryNum; i++)
	{
		*((char *)&entry) = (char)i;

		if ( !apmib_get(MIB_PROFILE_LIST, (void *)&entry)) return -1;

		nBytesSent += websWrite(wp, T("<tr>"));
		nBytesSent += websWrite(wp, T("  <td nowrap class=\"ntable\"><input type=\"radio\" name=\"select\" value=\"\" onClick=\"display_pre();\"></td>\n"));
		nBytesSent += websWrite(wp, T("  <td align=center class=\"ntable\">%s</td>\n"),entry.profile_name);
		nBytesSent += websWrite(wp, T("  <td align=center class=\"ntable\">%s</td>\n"),entry.ssid);
#ifndef _Customer_EX_
		if (entry.networktype == 0)
			nBytesSent += websWrite(wp, T("  <td align=center class=\"ntable\">---</td>\n"));
		else
#endif
			nBytesSent += websWrite(wp, T("  <td align=center class=\"ntable\">%d</td>\n"),entry.channel);
		if (entry.auth == 0)
			sprintf(tmpBuf, "OPEN");
		else if (entry.auth == 1)
			sprintf(tmpBuf, "SHARED");
		else if (entry.auth == 2)
			sprintf(tmpBuf, "WPA");
		else
			sprintf(tmpBuf, "WPA2");
		nBytesSent += websWrite(wp, T("  <td align=center class=\"ntable\">%s</td>\n"),tmpBuf);

		if (entry.encrypt == 0)
			sprintf(tmpBuf, "<script>dw(info_26)</script>");
		else if (entry.encrypt == 1)
			sprintf(tmpBuf, "WEP");
		else if (entry.encrypt == 2)
			sprintf(tmpBuf, "TKIP");
		else	
			sprintf(tmpBuf, "AES");
		nBytesSent += websWrite(wp, T("  <td align=center class=\"ntable\">%s</td>\n"),tmpBuf);

		if (entry.networktype == 0)
			sprintf(tmpBuf, "dw(profile_6)");
		else
			sprintf(tmpBuf, "dw(profile_7)");
		nBytesSent += websWrite(wp, T("  <td align=center class=\"ntable\"><script>%s</script></td>\n"),tmpBuf);

		nBytesSent += websWrite(wp, T("</tr>\n"));
	}
	nBytesSent += websWrite(wp, T("<input type=\"hidden\" name=\"select_len\" value=\"%d\">\n"),entryNum);
	return nBytesSent;
}

int profileListShow(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0, entryNum, i, j, t;
	PROFILELIST_T entry;
	char tmpBuf[20];
	char_t *name;
	if ( !apmib_get(MIB_PROFILE_LIST_NUM, (void *)&entryNum))
	{
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}
	if (ejArgs(argc, argv, T("%s"), &name) < 1) {
		websError(wp, 400, T("Insufficient args\n"));
		return -1;
	}
	for (i=1; i<=entryNum; i++)
	{
		if ( NoweditProfile == i) {
			*((char *)&entry) = (char)i;
			if ( !apmib_get(MIB_PROFILE_LIST, (void *)&entry)) return -1;

			if ( !strcmp(name, T("ProfileName")))
				nBytesSent += websWrite(wp, T("%s"),CharFilter2(entry.profile_name));
			else if ( !strcmp(name, T("SSID")))
				nBytesSent += websWrite(wp, T("%s"),CharFilter2(entry.ssid));
			else if ( !strcmp(name, T("network_type")))
				nBytesSent += websWrite(wp, T("%d"),entry.networktype);
			else if ( !strcmp(name, T("preamble")))
				nBytesSent += websWrite(wp, T("%d"),entry.preamble_type);
			else if ( !strcmp(name, T("powersaveing")))
				nBytesSent += websWrite(wp, T("%d"),entry.cam_psm);
			else if ( !strcmp(name, T("rtsThreshold")))
				nBytesSent += websWrite(wp, T("%d"),entry.RTS_value);
			else if ( !strcmp(name, T("fragThreshold")))
				nBytesSent += websWrite(wp, T("%d"),entry.Fragment_value);
			else if ( !strcmp(name, T("channel")))
				nBytesSent += websWrite(wp, T("%d"),entry.channel);			
			else if ( !strcmp(name, T("encrypt")))
				nBytesSent += websWrite(wp, T("%d"),entry.encrypt);
			else if ( !strcmp(name, T("auth")))
				nBytesSent += websWrite(wp, T("%d"),entry.auth);
			else if ( !strcmp(name, T("wep_length")))
				nBytesSent += websWrite(wp, T("%d"),entry.wep_length);
			else if ( !strcmp(name, T("wep_format")))
				nBytesSent += websWrite(wp, T("%d"),entry.wep_format);
			else if ( !strcmp(name, T("wepkey_index")))
				nBytesSent += websWrite(wp, T("%d"),entry.wepkey_index);
			else if ( !strcmp(name, T("wepkey1")))
				nBytesSent += websWrite(wp, T("%s"),entry.wepkey1);
			else if ( !strcmp(name, T("wepkey2")))
				nBytesSent += websWrite(wp, T("%s"),entry.wepkey2);
			else if ( !strcmp(name, T("wepkey3")))
				nBytesSent += websWrite(wp, T("%s"),entry.wepkey3);
			else if ( !strcmp(name, T("wepkey4")))
				nBytesSent += websWrite(wp, T("%s"),entry.wepkey4);
			else if ( !strcmp(name, T("wpapsk")))
				nBytesSent += websWrite(wp, T("%s"),CharFilter2(entry.wpapsk));
			break;
		}
	}
	return nBytesSent;
}

int profileListSSID(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0, entryNum, i;
	PROFILELIST_T entry;
	char tmpBuf[20];

	if ( !apmib_get(MIB_PROFILE_LIST_NUM, (void *)&entryNum))
	{
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}

	nBytesSent += websWrite(wp, T("new Array("));
	for (i=1; i<=entryNum; i++)
	{
		*((char *)&entry) = (char)i;

		if ( !apmib_get(MIB_PROFILE_LIST, (void *)&entry)) return -1;

		if (i == entryNum) {
			nBytesSent += websWrite(wp, T("\"%s\""),CharFilter2(entry.ssid));
		}
		else {
			nBytesSent += websWrite(wp, T("\"%s\","),CharFilter2(entry.ssid));
		}
	}
	nBytesSent += websWrite(wp, T(");"));
	return nBytesSent;
}

void formProfileList(webs_t wp, char_t *path, char_t *query)
{
	char_t *strEditbutton, *strEditSubmit, *strAddSch, *strDelSch, *strDelAllSch, *strVal, *submitUrl, *strEnabled, *strApply;
	char_t *strSiteApply, *strAddApply, *strprofileAddEnable;
	char tmpBuf[100];
	int entryNum, i, enabled, tmpInt;
	PROFILELIST_T ProfileEntry, orignProfileEntry;
	EDIT_T Edit;

	strEditSubmit = websGetVar(wp, T("submit_edit"), T(""));
	strEditbutton = websGetVar(wp, T("edit_button"), T(""));
	strAddSch = websGetVar(wp, T("addProfile"), T(""));
	strDelSch = websGetVar(wp, T("deleteProfile"), T(""));
	strDelAllSch = websGetVar(wp, T("deleteAllProfile"), T(""));
	strApply	= websGetVar(wp, T("isApply"), T(""));
	strSiteApply = websGetVar(wp, T("is_siteApply"), T(""));
	strAddApply = websGetVar(wp, T("addApply"), T(""));
	strprofileAddEnable = websGetVar(wp, T("profileAddEnable"), T(""));


	if ( strEditbutton[0]) {
		strVal = websGetVar(wp, T("select_check"), T(""));
		i = strVal[0] - '0';
		if ( gstrcmp(strVal, T("")) ) {
			NoweditProfile = i;
			printf("NoweditProfile = %d",NoweditProfile);
		}
	}
	/* Add entry */
	else if (strAddSch[0] || strAddApply[0] || strEditSubmit[0]) {
		strVal = websGetVar(wp, T("profilename"), T(""));
		if ( !strVal[0] ) {
			DEBUGP(tmpBuf, T("<script>dw(formprofile)</script>"));
			goto setprofile_error;
		}
		else 
			strcpy(ProfileEntry.profile_name, strVal);

		strVal = websGetVar(wp, T("profilessid"), T(""));
		if ( !strVal[0] ) {
			DEBUGP(tmpBuf, T("<script>dw(formssid)</script>"));
			goto setprofile_error;
		}
		else
			strcpy(ProfileEntry.ssid, strVal);

		strVal = websGetVar(wp, T("network_type"), T(""));
		if ( !strVal[0] ) {
			DEBUGP(tmpBuf, T("Error! No networktype to set."));
			goto setprofile_error;
		}
		else
			ProfileEntry.networktype=atoi(strVal);

		strVal= websGetVar(wp, T("preamble"), T(""));
		if (strVal[0]) {
			if (!gstrcmp(strVal, T("short")))
				i = 1;
			else if (!gstrcmp(strVal, T("long")))
				i = 0;
			else {
				DEBUGP(tmpBuf, T("ERROR to set preamble"));
				goto setprofile_error;
			}
			ProfileEntry.preamble_type = i;
		}

		strVal= websGetVar(wp, T("powersaveing"), T(""));
		if (!strVal[0]) {
				DEBUGP(tmpBuf, T("ERROR to set powersaveing"));
				goto setprofile_error;
		}
		else
			ProfileEntry.cam_psm = atoi(strVal);

		strVal= websGetVar(wp, T("rtsThreshold"), T(""));
		if (!strVal[0]) {
				DEBUGP(tmpBuf, T("ERROR to set RTS value"));
				goto setprofile_error;
		}
		else
			ProfileEntry.RTS_value = atoi(strVal);

		strVal= websGetVar(wp, T("fragThreshold"), T(""));
		if (!strVal[0]) {
				DEBUGP(tmpBuf, T("ERROR to set Fragment value"));
				goto setprofile_error;
		}
		else
			ProfileEntry.Fragment_value = atoi(strVal);

		strVal = websGetVar(wp, T("channel"), T(""));
		if ( !strVal[0] )
			ProfileEntry.channel=0;
		else
			ProfileEntry.channel=atoi(strVal);

		strVal = websGetVar(wp, T("auth"), T(""));
		if ( !strVal[0] ) {
			DEBUGP(tmpBuf, T("Error! No method to set."));
			goto setprofile_error;
		}
		else
			ProfileEntry.auth=atoi(strVal);

		strVal = websGetVar(wp, T("encrypt"), T(""));
		if ( !strVal[0] ) {
			DEBUGP(tmpBuf, T("Error! No encrypt to set."));
			goto setprofile_error;
		}
		else
			ProfileEntry.encrypt=atoi(strVal);

		strVal = websGetVar(wp, T("length"), T(""));
		if ( !strVal[0] ) {
			DEBUGP(tmpBuf, T("Error! No length to set."));
			goto setprofile_error;
		}
		else
			ProfileEntry.wep_length=atoi(strVal);

		strVal = websGetVar(wp, T("format"), T(""));
		if ( !strVal[0] ) {
			DEBUGP(tmpBuf, T("Error! No format to set."));
			goto setprofile_error;
		}
		else
			ProfileEntry.wep_format=atoi(strVal);

		strVal = websGetVar(wp, T("defaultTxKeyId"), T(""));
		if ( !strVal[0] ) {
			DEBUGP(tmpBuf, T("Error! No defaultTxKeyId to set."));
			goto setprofile_error;
		}
		else
			ProfileEntry.wepkey_index=atoi(strVal);

		strVal = websGetVar(wp, T("key1"), T(""));
		if ( !strVal[0] ) {
			strcpy(ProfileEntry.wepkey1,strVal);
			//ProfileEntry.wepkey1[sizeof(strVal)] = '\0';
		}
		else {
			strcpy(ProfileEntry.wepkey1,strVal);	
			//ProfileEntry.wepkey1[sizeof(strVal)] = '\0';
		}

		strVal = websGetVar(wp, T("key2"), T(""));
		if ( !strVal[0] ) {
			strcpy(ProfileEntry.wepkey2,strVal);
			//ProfileEntry.wepkey2[sizeof(strVal)] = '\0';
		}
		else {
			strcpy(ProfileEntry.wepkey2,strVal);	
			//ProfileEntry.wepkey2[sizeof(strVal)] = '\0';
		}

		strVal = websGetVar(wp, T("key3"), T(""));
		if ( !strVal[0] ) {
			strcpy(ProfileEntry.wepkey3,strVal);
			//ProfileEntry.wepkey3[sizeof(strVal)] = '\0';
		}
		else {
			strcpy(ProfileEntry.wepkey3,strVal);	
			//ProfileEntry.wepkey3[sizeof(strVal)] = '\0';
		}

		strVal = websGetVar(wp, T("key4"), T(""));
		if ( !strVal[0] ) {
			strcpy(ProfileEntry.wepkey4,strVal);
			//ProfileEntry.wepkey4[sizeof(strVal)] = '\0';
		}
		else {
			strcpy(ProfileEntry.wepkey4,strVal);	
			//ProfileEntry.wepkey4[sizeof(strVal)] = '\0';
		}
		
		strVal = websGetVar(wp, T("pskValue"), T(""));
		if ( !strVal[0] ) {
			strcpy(ProfileEntry.wpapsk,strVal);
			//ProfileEntry.wpapsk[sizeof(strVal)] = '\0';
		}
		else {
			strcpy(ProfileEntry.wpapsk,strVal);	
			//ProfileEntry.wpapsk[sizeof(strVal)] = '\0';
		}
		if ( strAddSch[0] || strAddApply[0] ) {
			if ( !apmib_get(MIB_PROFILE_LIST_NUM, (void *)&entryNum)) {
				goto setprofile_error;
			}
			if ( (entryNum + 1) > MIB_PROFILE_LIST_NUM) {
			//	strcpy(tmpBuf, T("<script>document.write(showText(aspFormWlAc5))</script>"));
				goto setprofile_error;
			}
			// set to MIB. try to delete it first to avoid duplicate case
			//apmib_set(MIB_WLAN_SCH_DEL, (void *)&macEntry);
			if ( apmib_set(MIB_PROFILE_LIST_ADD, (void *)&ProfileEntry) == 0) {
				DEBUGP(tmpBuf, T("apmib set Error!"));
				goto setprofile_error;
			}
		}
		if ( strEditSubmit[0] ) {
			*((char *)&orignProfileEntry) = (char)NoweditProfile;
			if ( !apmib_get(MIB_PROFILE_LIST, (void *)&orignProfileEntry)) {
				DEBUGP(tmpBuf, T("apmib get PROFILE_LIST error"));
				goto setprofile_error;
			}
			Edit.selEntry = (char *)&orignProfileEntry;
			Edit.editEntry = (char *)&ProfileEntry;
			if ( !apmib_set(MIB_PROFILE_LIST_EDIT, (void *)&Edit)) {
				DEBUGP(tmpBuf, T("apmib get PROFILE_LIST_DEL error"));
				goto setprofile_error;
			}
		}
	}

	/* Delete entry */
	if (strDelSch[0]) {
		if ( !apmib_get(MIB_PROFILE_LIST_NUM, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("apmib get PROFILE_LIST_NUM error"));
			goto setprofile_error;
		}
		//for (i=entryNum; i>0; i--) {
		//	snprintf(tmpBuf, 20, "select%d", i);
		//	strVal = websGetVar(wp, tmpBuf, T(""));
			strVal = websGetVar(wp, T("select_check"), T(""));
			i = strVal[0] - '0';
			if ( gstrcmp(strVal, T("")) ) {

				*((char *)&ProfileEntry) = (char)i;

				if ( !apmib_get(MIB_PROFILE_LIST, (void *)&ProfileEntry)) {
					DEBUGP(tmpBuf, T("apmib get PROFILE_LIST error"));
					goto setprofile_error;
				}
				if ( !apmib_set(MIB_PROFILE_LIST_DEL, (void *)&ProfileEntry)) {
					DEBUGP(tmpBuf, T("apmib get PROFILE_LIST_DEL error"));
					goto setprofile_error;
				}
			}
		//}
	}

	/* Delete all entry */
	if ( strDelAllSch[0]) {
		if ( !apmib_set(MIB_PROFILE_LIST_DELALL, (void *)&ProfileEntry)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc8))</script>"));
			goto setprofile_error;
		}
	}

	if (strApply[0] || strSiteApply[0] || strEditSubmit[0]) {
/******************************************/
		if ( !apmib_get(MIB_PROFILE_LIST_NUM, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("apmib get PROFILE_LIST_NUM error"));
			goto setprofile_error;
		}
		//for (i=entryNum; i>0; i--) {
			//snprintf(tmpBuf, 20, "select%d", i);
			//strVal = websGetVar(wp, tmpBuf, T(""));
			strVal = websGetVar(wp, T("select_check"), T(""));
			i = strVal[0] - '0';
			if ( gstrcmp(strVal, T("")) ) {
			
				*((char *)&ProfileEntry) = (char)i;

				if ( !apmib_get(MIB_PROFILE_LIST, (void *)&ProfileEntry)) {
					DEBUGP(tmpBuf, T("apmib get PROFILE_LIST error"));
					goto setprofile_error;
				}
			}
		//}
/******************************************/
		char_t strTmp[200], *wepkeyTmp;
		if ( ProfileEntry.encrypt == 0) {			//Disable
			tmpInt = 0;
			apmib_set(MIB_WLAN_WEP, (void *)&tmpInt);
			apmib_set(MIB_SECURITY_MODE, (void *)&tmpInt);
			apmib_set(MIB_WLAN_ENCRYPT, (void *)&tmpInt);
			apmib_set(MIB_WLAN_AUTH_TYPE, (void *)&tmpInt);
		}
		else if ( ProfileEntry.encrypt == 1) {		//WEP
			if ( ProfileEntry.auth == 0) {
				tmpInt = 0;
				apmib_set(MIB_WLAN_AUTH_TYPE, (void *)&tmpInt);
			}
			else {
				tmpInt = 1;
				apmib_set(MIB_WLAN_AUTH_TYPE, (void *)&tmpInt);
			}
			tmpInt = 1;
			apmib_set(MIB_SECURITY_MODE, (void *)&tmpInt);
			apmib_set(MIB_WLAN_ENCRYPT, (void *)&tmpInt);

			tmpInt = ProfileEntry.wep_length;
			if (tmpInt == 0)
				tmpInt = 1;	//64bit
			else
				tmpInt = 2;	//128bit
			apmib_set(MIB_WLAN_WEP, (void *)&tmpInt);
			
			tmpInt = ProfileEntry.wepkey_index;
			apmib_set(MIB_WLAN_WEP_DEFAULT_KEY, (void *)&tmpInt);

			tmpInt = ProfileEntry.wep_format;
			apmib_set(MIB_WLAN_WEP_KEY_TYPE, (void *)&tmpInt);

			if (ProfileEntry.wep_length == 0) {			//64bit
				if (ProfileEntry.wep_format == 1) {		//HEX
					wepkeyTmp = ProfileEntry.wepkey1;
					if ( !isAllStar(wepkeyTmp) ) {
						string_to_hex(wepkeyTmp, strTmp, 10);
						apmib_set(MIB_WLAN_WEP64_KEY1, (void *)strTmp);
					}
					wepkeyTmp = ProfileEntry.wepkey2;
					if ( !isAllStar(wepkeyTmp) ) {
						string_to_hex(wepkeyTmp, strTmp, 10);
						apmib_set(MIB_WLAN_WEP64_KEY2, (void *)strTmp);
					}
					wepkeyTmp = ProfileEntry.wepkey3;
					if ( !isAllStar(wepkeyTmp) ) {
						string_to_hex(wepkeyTmp, strTmp, 10);
						apmib_set(MIB_WLAN_WEP64_KEY3, (void *)strTmp);
					}
					wepkeyTmp = ProfileEntry.wepkey4;
					if ( !isAllStar(wepkeyTmp) ) {
						string_to_hex(wepkeyTmp, strTmp, 10);
						apmib_set(MIB_WLAN_WEP64_KEY4, (void *)strTmp);
					}
				}
				else {										//ASCII
					sprintf(strTmp,"%s",ProfileEntry.wepkey1);
					if ( !isAllStar(strTmp) )
						apmib_set(MIB_WLAN_WEP64_KEY1, (void *)&strTmp);
					sprintf(strTmp,"%s",ProfileEntry.wepkey2);
					if ( !isAllStar(strTmp) )
						apmib_set(MIB_WLAN_WEP64_KEY2, (void *)&strTmp);
					sprintf(strTmp,"%s",ProfileEntry.wepkey3);
					if ( !isAllStar(strTmp) )
						apmib_set(MIB_WLAN_WEP64_KEY3, (void *)&strTmp);
					sprintf(strTmp,"%s",ProfileEntry.wepkey4);
					if ( !isAllStar(strTmp) )
						apmib_set(MIB_WLAN_WEP64_KEY4, (void *)&strTmp);
				}
			}
			else {											//128bit
				if (ProfileEntry.wep_format == 1) {		//HEX
					wepkeyTmp = ProfileEntry.wepkey1;
					if ( !isAllStar(wepkeyTmp) ) {
						string_to_hex(wepkeyTmp, strTmp, 26);
						apmib_set(MIB_WLAN_WEP128_KEY1, (void *)strTmp);
					}
					wepkeyTmp = ProfileEntry.wepkey2;
					if ( !isAllStar(wepkeyTmp) ) {
						string_to_hex(wepkeyTmp, strTmp, 26);
						apmib_set(MIB_WLAN_WEP128_KEY2, (void *)strTmp);
					}
					wepkeyTmp = ProfileEntry.wepkey3;
					if ( !isAllStar(wepkeyTmp) ) {
						string_to_hex(wepkeyTmp, strTmp, 26);
						apmib_set(MIB_WLAN_WEP128_KEY3, (void *)strTmp);
					}
					wepkeyTmp = ProfileEntry.wepkey4;
					if ( !isAllStar(wepkeyTmp) ) {
						string_to_hex(wepkeyTmp, strTmp, 26);
						apmib_set(MIB_WLAN_WEP128_KEY4, (void *)strTmp);
					}
				}
				else {
					sprintf(strTmp,"%s",ProfileEntry.wepkey1);
					if ( !isAllStar(strTmp) )
						apmib_set(MIB_WLAN_WEP128_KEY1, (void *)&strTmp);
					sprintf(strTmp,"%s",ProfileEntry.wepkey2);
					if ( !isAllStar(strTmp) )
						apmib_set(MIB_WLAN_WEP128_KEY2, (void *)&strTmp);
					sprintf(strTmp,"%s",ProfileEntry.wepkey3);
					if ( !isAllStar(strTmp) )
						apmib_set(MIB_WLAN_WEP128_KEY3, (void *)&strTmp);
					sprintf(strTmp,"%s",ProfileEntry.wepkey4);
					if ( !isAllStar(strTmp) )
						apmib_set(MIB_WLAN_WEP128_KEY4, (void *)&strTmp);
				}	
			}
		}
		else if ( ProfileEntry.encrypt == 2) {		//TKIP
			tmpInt = 0;
			apmib_set(MIB_WLAN_WEP, (void *)&tmpInt);
			tmpInt = 1;
			apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&tmpInt);
			apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&tmpInt);
			tmpInt = 2;
			apmib_set(MIB_SECURITY_MODE, (void *)&tmpInt);
			apmib_set(MIB_WLAN_AUTH_TYPE, (void *)&tmpInt);
			sprintf(strTmp,"%s",ProfileEntry.wpapsk);
			apmib_set(MIB_WLAN_WPA_PSK, (void *)&strTmp);
			if ( ProfileEntry.auth == 2) {		//WPA TKIP
				tmpInt = 2;
				apmib_set(MIB_WLAN_ENCRYPT, (void *)&tmpInt);
			}
			else {					//WPA2 AKIP
				tmpInt = 4;
				apmib_set(MIB_WLAN_ENCRYPT, (void *)&tmpInt);
			}
		}
		else {						//AES
			tmpInt = 0;
			apmib_set(MIB_WLAN_WEP, (void *)&tmpInt);
			tmpInt = 2;
			apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&tmpInt);
			apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&tmpInt);
			apmib_set(MIB_SECURITY_MODE, (void *)&tmpInt);
			apmib_set(MIB_WLAN_AUTH_TYPE, (void *)&tmpInt);
			sprintf(strTmp,"%s",ProfileEntry.wpapsk);
			apmib_set(MIB_WLAN_WPA_PSK, (void *)&strTmp);
			if ( ProfileEntry.auth == 2) {		//WPA AES
				tmpInt = 2;
				apmib_set(MIB_WLAN_ENCRYPT, (void *)&tmpInt);
			}
			else {					//WPA2 AES
				tmpInt = 4;
				apmib_set(MIB_WLAN_ENCRYPT, (void *)&tmpInt);
			}
		}
		sprintf(strTmp,"%s",ProfileEntry.ssid);
#ifdef _Customer_EX_
                apmib_set(MIB_REPEATER_SSID, (void *)&strTmp);
#endif
		apmib_set(MIB_WLAN_SSID, (void *)&strTmp);
		printf("strTmp = %s\n",strTmp);
		tmpInt = ProfileEntry.channel;
		apmib_set(MIB_WLAN_CHAN_NUM, (void *)&tmpInt);
		
		tmpInt = ProfileEntry.networktype;
		apmib_set(MIB_WLAN_NETWORK_TYPE, (void *)&tmpInt);
		
		tmpInt = ProfileEntry.RTS_value;
		apmib_set(MIB_WLAN_RTS_THRESHOLD, (void *)&tmpInt);
		
		tmpInt = ProfileEntry.Fragment_value;
		apmib_set(MIB_WLAN_FRAG_THRESHOLD, (void *)&tmpInt);
		

	}

printf("setup Profile !!!!!");
setprofile_ret:
	apmib_update(CURRENT_SETTING);
	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	printf("submitUrl = %s\n",submitUrl);
	strApply = websGetVar(wp, T("isApply"), T(""));   // Tommy
	
	if (strprofileAddEnable[0]) {
		printf("REPLACE\n");
		REPLACE_MSG(submitUrl);
	}	
	else if (strApply[0] || strSiteApply[0]) {
		if ( wizardEnabled == 0) {
			printf("OK_MSG\n");
			OK_MSG(submitUrl);
		}
		else {
			printf("REPLACE\n");
			REPLACE_MSG(submitUrl);
		}
	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}
  	return;
setprofile_error:
	ERR_MSG(tmpBuf);
}
#endif


///////////////////////////////////////////////////////////////////////////////////////////
#if defined(HOME_GATEWAY) || defined(_AP_WITH_TIMEZONE_)
void formTimeZoneSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl, *strTimeZoneSel, *strTimeServerAddr, *strDisabled, *strtimezoneEnable, *strsetTmie;
	char_t *strstartMonth, *strstartDay, *strendMonth, *strendDay;
	char_t **strTime;
	int i;
#ifdef _SNTP_A_M_CTL_ //vance
	char_t *strTimeServerEnable;
#endif

	int val, disabled, val2;
#ifdef _corega_
	int timezoneselected;
#endif
	struct in_addr inTimeServerAddr;
	char tmpBuf[100];

	strsetTmie = websGetVar(wp, T("setTime"), T(""));
	if (strsetTmie[0]) {
                if ( !string_to_dec(strsetTmie, &val2)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_advance;
                }
                if ( apmib_set(MIB_PC_TIME, (void *)&val2) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_advance;
                }
		if ( val2 == 1 ){
		        strTime = (char_t *)malloc(6*sizeof(char_t *));
        	        strTime[0] = websGetVar(wp, T("year"), T(""));
                	strTime[1] = websGetVar(wp, T("mon"), T(""));
			sprintf(strTime[1],"%d",atoi(websGetVar(wp, T("mon"), T(""))) + 1);
	                strTime[2] = websGetVar(wp, T("day"), T(""));
        	        strTime[3] = websGetVar(wp, T("hour"), T(""));
                	strTime[4] = websGetVar(wp, T("min"), T(""));
	                strTime[5] = websGetVar(wp, T("sec"), T(""));
        	        for(i=1;i<6;i++)
                	{
	                	if(strlen(strTime[i]) <2 )
        	                sprintf(strTime[i],"0%c",strTime[i][0]);
			}
			sprintf(tmpBuf, "date %s.%s.%s-%s:%s:%s",strTime[0],strTime[1],strTime[2],strTime[3],strTime[4],strTime[5]);
#ifndef NO_ACTION
			system(tmpBuf);
#endif
		}
	}
	strTimeZoneSel = websGetVar(wp, T("TimeZoneSel"), T(""));
	if (strTimeZoneSel[0]) {
		if ( !string_to_dec(strTimeZoneSel, &val) || val<0 || val>66) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_TIME_ZONE_SEL, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
			goto setErr_advance;
		}
#ifdef _corega_
		timezoneselected=1;
		apmib_set(MIB_TIMEZONE_SELECTED, (void *)&timezoneselected);
#endif
	}

//***********************vance 2009.02.20***********************************
int enable = 0;
#ifdef _SNTP_A_M_CTL_
		strTimeServerEnable = websGetVar(wp, T("TimeServerEnable"), T(""));
		if ( !gstrcmp(strTimeServerEnable, T("ON")))
			enable = 1;
		else
			enable = 0;

		if ( strTimeServerEnable != NULL ) {
			if ( !apmib_set( MIB_TIMESERVER_ENABLE, (void *)&enable)) {
				//DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup4))</script>"));
				goto setErr_advance;
			}
		}
		if(enable == 0)
		{
			char_t strStaticTime[13];
			strTime = (char_t *)malloc(5*sizeof(char_t *));
			//set system static time
			strTime[0] = websGetVar(wp, T("TimeYear"), T(""));
			strTime[1] = websGetVar(wp, T("TimeMonth"), T(""));
			strTime[2] = websGetVar(wp, T("TimeDay"), T(""));
			strTime[3] = websGetVar(wp, T("TimeHour"), T(""));
			strTime[4] = websGetVar(wp, T("TimeMinute"), T(""));
			for(i=1;i<5;i++)
			{
				//printf("%s-",strTime[i]);
				if(strlen(strTime[i]) <2 )
					sprintf(strTime[i],"0%c",strTime[i][0]);
				//printf("%s\n",strTime[i]);
			}
			//strTime[5] = websGetVar(wp, T("TimeSecond"), T(""));

			snprintf(strStaticTime,13,"%s%s%s%s%s",strTime[1],strTime[2],strTime[3],strTime[4],strTime[0]);
			//printf("time=%s\n",strStaticTime);

			if ( strStaticTime[0] ) {
				if ( !apmib_set( MIB_STATIC_SYSTEM_TIME, (void *)&strStaticTime)) {
					//DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup4))</script>"));
					goto setErr_advance;
				}
			}
			free(strTime);
		}
#endif

#ifdef _SNTP_A_M_CTL_
	if(enable == 1){
		strTimeServerAddr = websGetVar(wp, T("TimeServerAddr"), T(""));
		//printf("sss=%s",strTimeServerAddr);
		if ( strTimeServerAddr[0] ) {
			if ( !apmib_set( MIB_TIMESERVER_DOMAIN, (void *)strTimeServerAddr)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup4))</script>"));
				goto setErr_advance;
			}
		}
	}
#else
	strTimeServerAddr = websGetVar(wp, T("TimeServerAddr"), T(""));
	if ( strTimeServerAddr[0] ) {
#if defined(_BR6428PNL_)
                if ( !apmib_set( MIB_TIMESERVER_ADDR, (void *)strTimeServerAddr)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup4))</script>"));
                        goto setErr_advance;
                }
#else
		if ( !inet_aton(strTimeServerAddr, &inTimeServerAddr) ) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
			goto setErr_advance;
		}
		if ( !apmib_set( MIB_TIMESERVER_ADDR, (void *)&inTimeServerAddr)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup4))</script>"));
			goto setErr_advance;
		}
#endif
	}
#endif

//***********************************************************************************

	strDisabled = websGetVar(wp, T("DayLightEnable"), T(""));
	if ( !gstrcmp(strDisabled, T("ON")))
		disabled = 1;
	else
		disabled = 0;
	if ( apmib_set( MIB_DAYLIGHT_ENABLE, (void *)&disabled) == 0) {
  		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc1))</script>"));
		goto setErr_advance;
	}
	strstartMonth = websGetVar(wp, T("startMonth"), T(""));
	if (strstartMonth[0]) {
		if ( !string_to_dec(strstartMonth, &val)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup5))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_START_MONTH, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup6))</script>"));
			goto setErr_advance;
		}
	}
	strstartDay = websGetVar(wp, T("startDay"), T(""));
	if (strstartDay[0]) {
		if ( !string_to_dec(strstartDay, &val)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup7))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_START_DAY, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup8))</script>"));
			goto setErr_advance;
		}
	}
	strendMonth = websGetVar(wp, T("endMonth"), T(""));
	if (strendMonth[0]) {
		if ( !string_to_dec(strendMonth, &val)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup9))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_END_MONTH, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup10))</script>"));
			goto setErr_advance;
		}
	}
	strendDay = websGetVar(wp, T("endDay"), T(""));
	if (strendDay[0]) {
		if ( !string_to_dec(strendDay, &val)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup11))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_END_DAY, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup12))</script>"));
			goto setErr_advance;
		}
	}

	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	// run script file to update WLAN parameters
//	sprintf(tmpBuf, "%s/%s %s", _CONFIG_SCRIPT_PATH, _WLAN_SCRIPT_PROG, WLAN_IF);
	if ( val2 == 0 ){
		system("/bin/flash all2 > /var/flash.inc");
		system("/bin/sntp.sh");
	}
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
//	websRedirect(wp, submitUrl);

	strtimezoneEnable = websGetVar(wp, T("settimezoneEnable"), T(""));
//	if ( !gstrcmp(strtimezoneEnable, T("ON"))){
#ifdef _EZVIEW_
	if (strtimezoneEnable[0] || wizardEnabled==1){
#else
	if (strtimezoneEnable[0]){
#endif
		REPLACE_MSG(submitUrl);
  		return;
	} else {
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif
	OK_MSG(submitUrl);

  		return;
	}


setErr_advance:
	ERR_MSG(tmpBuf);
}
#endif
/////////////////////////////////////////////////////////////////////////////
#ifdef HOME_GATEWAY

/////////////////////////////////////////////////////////////////////////////
void formReManagementSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl, *strreManHostAddr, *strreMangEnable, *strPort;
	int disabled, val;
	struct in_addr inreManHostAddr;
	char tmpBuf[100];

		strreManHostAddr = websGetVar(wp, T("reManHostAddr"), T(""));
		if ( strreManHostAddr[0] ) {
			if ( !inet_aton(strreManHostAddr, &inreManHostAddr) ) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup3))</script>"));
				goto setErr_advance;
			}
			if ( !apmib_set( MIB_REMANHOST_ADDR, (void *)&inreManHostAddr)) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup4))</script>"));
				goto setErr_advance;
			}
		}
	strPort = websGetVar(wp, T("reManPort"), T(""));
	if (strPort[0]) {
		if ( !string_to_dec(strPort, &val)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormReManagementSetup1))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_REMAN_PORT, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormReManagementSetup2))</script>"));
			goto setErr_advance;
		}
	}
	strreMangEnable = websGetVar(wp, T("reMangEnable"), T(""));
	if ( !gstrcmp(strreMangEnable, T("ON")))
		disabled = 1;
	else
		disabled = 0;
	if ( apmib_set( MIB_REMANG_ENABLE, (void *)&disabled) == 0) {
  		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormVpnConn1))</script>"));
		goto setErr_advance;
	}

	apmib_update(CURRENT_SETTING);


#ifndef NO_ACTION
	//sprintf(tmpBuf, "%s/%s", _CONFIG_SCRIPT_PATH, _FIREWALL_SCRIPT_PROG);  // Tommy
	//system(tmpBuf);
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page



#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif
//	websRedirect(wp, submitUrl);
	OK_MSG(submitUrl);
  	return;



setErr_advance:
	ERR_MSG(tmpBuf);
}
#endif
/////////////////////////////////////////////////////////////////////////////
void formAdvanceSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl, *strAuth, *strFragTh, *strRtsTh, *strBeacon, *strPreamble, *strBlock;
	char_t *strRate, *strHiddenSSID, *strDtim, *strIapp, *strTx, *strProtection, *strShortGI;
	char_t *strTxPower, *strWmm, *strTurbo, *strNFixRate, *strChanWidth, *strNoForward, *strAggregation, *strWLANPartition, *strSTBC;
	char_t *char_t_tmp ,*strChan, *strAckTimeout;
	AUTH_TYPE_T authType;
	int val, chan;
	char tmpBuf[100];
#ifdef _IPN_WL_DEVICE_
	char_t *strTranRate, *strRateMode;
#else
	PREAMBLE_T preamble;
#endif

#ifdef _LAN_WAN_ACCESS_
	int blValue=0;
	char_t *strBlockLan;
	strBlockLan = websGetVar(wp, T("blockLan"), T(""));

	if (strBlockLan[0]) apmib_get( MIB_LAN_WAN_ACCESS, (void *)&blValue);

	if ( !gstrcmp(strBlockLan, T("yes"))){
		blValue|=1;
	}
	else{
		blValue=blValue& (~1);
	}
	apmib_set(MIB_LAN_WAN_ACCESS, (void *)&blValue);

#endif

#if defined(_IPN_WL_DEVICE_) || defined(_STAR_) //vance 2008.12.30
	char_t *strBurst;
#endif

#ifdef _STAR_ //vance 2008.12.30
	char_t *strHiddenSSID1;
#endif


	char_t *strCts;

	strAuth = websGetVar(wp, T("authType"), T(""));
	if (strAuth[0]) {
		if ( !gstrcmp(strAuth, T("open")))
			authType = AUTH_OPEN;
		else if ( !gstrcmp(strAuth, T("shared")))
			authType = AUTH_SHARED;
		else if ( !gstrcmp(strAuth, T("both")))
			authType = AUTH_BOTH;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup1))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_AUTH_TYPE, (void *)&authType) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup12))</script>"));
			goto setErr_advance;
		}
	}
	strFragTh = websGetVar(wp, T("fragThreshold"), T(""));
	if (strFragTh[0]) {
		if ( !string_to_dec(strFragTh, &val) || val<256 || val>2346) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup2))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_FRAG_THRESHOLD, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup3))</script>"));
			goto setErr_advance;
		}
	}
	strRtsTh = websGetVar(wp, T("rtsThreshold"), T(""));
	if (strRtsTh[0]) {
		if ( !string_to_dec(strRtsTh, &val) || val<0 || val>2347) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup4))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_RTS_THRESHOLD, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup5))</script>"));
			goto setErr_advance;
		}
	}

	strBeacon = websGetVar(wp, T("beaconInterval"), T(""));
	if (strBeacon[0]) {
		if ( !string_to_dec(strBeacon, &val) || val<20 || val>1024) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup6))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_BEACON_INTERVAL, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup7))</script>"));
			goto setErr_advance;
		}
	}

// RexHua
	strTxPower = websGetVar(wp, T("wlanTxPower"), T(""));	//no use
	if (strTxPower[0]) {
		if ( !string_to_dec(strTxPower, &val) || val >100 || val<0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup8))</script>"));
			goto setErr_advance;
		}
		val = val % 100; // 0:100%
		if ( apmib_set(MIB_WLAN_TX_POWER, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup9))</script>"));
			goto setErr_advance;
		}
	}
	//kyle
		strNoForward = websGetVar(wp, T("noForwarding"), T(""));	//no use
	if (strNoForward[0]) {
		if (!gstrcmp(strNoForward, T("no")))
			val = 0;
		else if (!gstrcmp(strNoForward, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup10))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_NOFORWARD, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup11))</script>"));
			goto setErr_advance;
		}
	}

	strTurbo = websGetVar(wp, T("wlanTurbo"), T(""));	//no use
	if (strTurbo[0]) {
		if (!gstrcmp(strTurbo, T("no")))
			val = 0;
		else if (!gstrcmp(strTurbo, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup10))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_TURBO, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup11))</script>"));
			goto setErr_advance;
		}
	}

	strWmm = websGetVar(wp, T("wlanWmm"), T(""));	//no use
	if (strWmm[0]) {
		if (!gstrcmp(strWmm, T("no")))
			val = 1;
		else if (!gstrcmp(strWmm, T("yes")))
			val = 0;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup12))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_WMM, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup13))</script>"));
			goto setErr_advance;
		}
#ifdef _NetIndex_
		if ( apmib_set(MIB_WLAN_WMM_1, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup13))</script>"));
			goto setErr_advance;
		}
#endif
	}

	strChanWidth = websGetVar(wp, T("wlanNChanWidth"), T(""));	//no use
	if (strChanWidth[0]) {
		if (!gstrcmp(strChanWidth, T("0")))
			val = 0;
		else if (!gstrcmp(strChanWidth, T("1")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("Invalid Channel Width 0"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_N_CHANNEL_WIDTH, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("Invalid Channel Width 1"));
			goto setErr_advance;
		}
	}

	strNFixRate = websGetVar(wp, T("NtxRate"), T(""));
    if ( strNFixRate[0] ) {
		val = atoi(strNFixRate);
        if ( apmib_set(MIB_WLAN_N_FIX_RATE, (void *)&val) == 0) {
        	strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup16))</script>"));
            goto setErr_advance;
		}
	}

	// set tx rate
	strRate = websGetVar(wp, T("txRate"), T(""));
	if ( strRate[0] ) {

		if ( strRate[0] == '0' ) { // auto
			val = 1;
			if ( apmib_set(MIB_WLAN_RATE_ADAPTIVE_ENABLED, (void *)&val) == 0) {
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup14))</script>"));
				goto setErr_advance;
			}
			val = atoi(strRate);


			if ( apmib_set(MIB_WLAN_FIX_RATE, (void *)&val) == 0) {
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup15))</script>"));
				goto setErr_advance;
			}
		}
		else
		{
			val = 0;
			if ( apmib_set(MIB_WLAN_RATE_ADAPTIVE_ENABLED, (void *)&val) == 0) {
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup14))</script>"));
				goto setErr_advance;
			}

			val = atoi(strRate);

			if ( apmib_set(MIB_WLAN_FIX_RATE, (void *)&val) == 0) {
				strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup15))</script>"));
				goto setErr_advance;
			}



			strRate = websGetVar(wp, T("basicrates"), T(""));
			if ( strRate[0] ) {
				val = atoi(strRate);
				if ( apmib_set(MIB_WLAN_BASIC_RATE, (void *)&val) == 0) {
					strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup16))</script>"));
					goto setErr_advance;
				}
			}

			strRate = websGetVar(wp, T("operrates"), T(""));
			if ( strRate[0] ) {
				val = atoi(strRate);
				if ( apmib_set(MIB_WLAN_SUPPORTED_RATE, (void *)&val) == 0) {
					strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup17))</script>"));
					goto setErr_advance;
				}
			}
		}
	}

	val = 0;
	strRate = websGetVar(wp, T("operRate1M"), T(""));
	if (strRate==NULL || strRate[0]==0)
		goto skip_rate_setting;
	if ( !gstrcmp(strRate, T("1M")))
		val |= TX_RATE_1M;
	strRate = websGetVar(wp, T("operRate2M"), T(""));
	if ( !gstrcmp(strRate, T("2M")))
		val |= TX_RATE_2M;
	strRate = websGetVar(wp, T("operRate5M"), T(""));
	if ( !gstrcmp(strRate, T("5M")))
		val |= TX_RATE_5M;
	strRate = websGetVar(wp, T("operRate11M"), T(""));
	if ( !gstrcmp(strRate, T("11M")))
		val |= TX_RATE_11M;
	strRate = websGetVar(wp, T("operRate6M"), T(""));
	if ( !gstrcmp(strRate, T("6M")))
		val |= TX_RATE_6M;
	strRate = websGetVar(wp, T("operRate9M"), T(""));
	if ( !gstrcmp(strRate, T("9M")))
		val |= TX_RATE_9M;
	strRate = websGetVar(wp, T("operRate12M"), T(""));
	if ( !gstrcmp(strRate, T("12M")))
		val |= TX_RATE_12M;
	strRate = websGetVar(wp, T("operRate18M"), T(""));
	if ( !gstrcmp(strRate, T("18M")))
		val |= TX_RATE_18M;
	strRate = websGetVar(wp, T("operRate24M"), T(""));
	if ( !gstrcmp(strRate, T("24M")))
		val |= TX_RATE_24M;
	strRate = websGetVar(wp, T("operRate36M"), T(""));
	if ( !gstrcmp(strRate, T("36M")))
		val |= TX_RATE_36M;
	strRate = websGetVar(wp, T("operRate48M"), T(""));
	if ( !gstrcmp(strRate, T("48M")))
		val |= TX_RATE_48M;
	strRate = websGetVar(wp, T("operRate54M"), T(""));
	if ( !gstrcmp(strRate, T("54M")))
		val |= TX_RATE_54M;
	if ( apmib_set(MIB_WLAN_SUPPORTED_RATE, (void *)&val) == 0) {
		strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup17))</script>"));
		goto setErr_advance;
	}

	// set basic tx rate
	val = 0;
	strRate = websGetVar(wp, T("basicRate1M"), T(""));
	if (strRate==NULL || strRate[0]==0)
		goto skip_rate_setting;
	if ( !gstrcmp(strRate, T("1M")))
		val |= TX_RATE_1M;
	strRate = websGetVar(wp, T("basicRate2M"), T(""));
	if ( !gstrcmp(strRate, T("2M")))
		val |= TX_RATE_2M;
	strRate = websGetVar(wp, T("basicRate5M"), T(""));
	if ( !gstrcmp(strRate, T("5M")))
		val |= TX_RATE_5M;
	strRate = websGetVar(wp, T("basicRate11M"), T(""));
	if ( !gstrcmp(strRate, T("11M")))
		val |= TX_RATE_11M;
	strRate = websGetVar(wp, T("basicRate6M"), T(""));
	if ( !gstrcmp(strRate, T("6M")))
		val |= TX_RATE_6M;
	strRate = websGetVar(wp, T("basicRate9M"), T(""));
	if ( !gstrcmp(strRate, T("9M")))
		val |= TX_RATE_9M;
	strRate = websGetVar(wp, T("basicRate12M"), T(""));
	if ( !gstrcmp(strRate, T("12M")))
		val |= TX_RATE_12M;
	strRate = websGetVar(wp, T("basicRate18M"), T(""));
	if ( !gstrcmp(strRate, T("18M")))
		val |= TX_RATE_18M;
	strRate = websGetVar(wp, T("basicRate24M"), T(""));
	if ( !gstrcmp(strRate, T("24M")))
		val |= TX_RATE_24M;
	strRate = websGetVar(wp, T("basicRate36M"), T(""));
	if ( !gstrcmp(strRate, T("36M")))
		val |= TX_RATE_36M;
	strRate = websGetVar(wp, T("basicRate48M"), T(""));
	if ( !gstrcmp(strRate, T("48M")))
		val |= TX_RATE_48M;
	strRate = websGetVar(wp, T("basicRate54M"), T(""));
	if ( !gstrcmp(strRate, T("54M")))
		val |= TX_RATE_54M;
	if ( apmib_set(MIB_WLAN_BASIC_RATE, (void *)&val) == 0) {
		strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup16))</script>"));
		goto setErr_advance;
	}
skip_rate_setting:




/*
	// set tx rate
	strRate = websGetVar(wp, T("txRate"), T(""));
	if ( strRate[0] ) {
		if ( strRate[0] == '0' ) { // auto
			val = 1;
			if ( apmib_set(MIB_WLAN_RATE_ADAPTIVE_ENABLED, (void *)&val) == 0) {
				DEBUGP(tmpBuf, T("Set rate adaptive failed!"));
				goto setErr_advance;
			}
		}
		else  {
			val = 0;
			if ( apmib_set(MIB_WLAN_RATE_ADAPTIVE_ENABLED, (void *)&val) == 0) {
				DEBUGP(tmpBuf, T("Set rate adaptive failed!"));
				goto setErr_advance;
			}

			if (strRate[0] == '1' )  // 11M
				val = TX_RATE_11M;
			else if (strRate[0] == '2' ) // 5.5M
				val = TX_RATE_5M;
			else if (strRate[0] == '3' ) // 2M
				val = TX_RATE_2M;
			else if (strRate[0] == '4' ) // 1M
				val = TX_RATE_1M;
			else {
				DEBUGP(tmpBuf, T("invalud value of tx rate!"));
				goto setErr_advance;
	else if ( !strcmp(name, T("hiddenSSID"))) {
		if ( !apmib_get( MIB_WLAN_HIDDEN_SSID, (void *)&val) )
			return -1;
		sprintf(buffer, "%d", val);
		ejSetResult(eid, buffer);
		return 0;
	}
			}
			if ( apmib_set(MIB_WLAN_SUPPORTED_RATE, (void *)&val) == 0) {
				DEBUGP(tmpBuf, T("Set Tx operation rate failed!"));
				goto setErr_advance;
			}
			if ( apmib_set(MIB_WLAN_BASIC_RATE, (void *)&val) == 0) {
				DEBUGP(tmpBuf, T("Set Tx basic rate failed!"));
				goto setErr_advance;
			}
		}
	}
	else { // set rate in operate, basic sperately
		val = 0;
		// disable rate adaptive
		if ( apmib_set(MIB_WLAN_RATE_ADAPTIVE_ENABLED, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("Set rate adaptive failed!"));
			goto setErr_advance;
			}

		strRate = websGetVar(wp, T("operRate1M"), T(""));
		if ( !gstrcmp(strRate, T("1M")))
			val |= TX_RATE_1M;
		strRate = websGetVar(wp, T("operRate2M"), T(""));
		if ( !gstrcmp(strRate, T("2M")))
			val |= TX_RATE_2M;
		strRate = websGetVar(wp, T("operRate5M"), T(""));
		if ( !gstrcmp(strRate, T("5M")))
			val |= TX_RATE_5M;
		strRate = websGetVar(wp, T("operRate11M"), T(""));
		if ( !gstrcmp(strRate, T("11M")))
			val |= TX_RATE_11M;
		if ( apmib_set(MIB_WLAN_SUPPORTED_RATE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("Set Tx operation rate failed!"));
			goto setErr_advance;
		}

		// set basic tx rate
		val = 0;
		strRate = websGetVar(wp, T("basicRate1M"), T(""));
		if ( !gstrcmp(strRate, T("1M")))
			val |= TX_RATE_1M;
		strRate = websGetVar(wp, T("basicRate2M"), T(""));
		if ( !gstrcmp(strRate, T("2M")))
			val |= TX_RATE_2M;
		strRate = websGetVar(wp, T("basicRate5M"), T(""));
		if ( !gstrcmp(strRate, T("5M")))
			val |= TX_RATE_5M;
		strRate = websGetVar(wp, T("basicRate11M"), T(""));
		if ( !gstrcmp(strRate, T("11M")))
			val |= TX_RATE_11M;
		if ( apmib_set(MIB_WLAN_BASIC_RATE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("Set Tx basic rate failed!"));
			goto setErr_advance;
		}
	}
*/
#ifdef _IPN_WL_DEVICE_
	// set IPN preamble
	strPreamble = websGetVar(wp, T("ipnPrmb"), T(""));
	if (strPreamble[0]) {
		if (strPreamble[0] == '0')
			val = 0;
		else if (strPreamble[0] == '1')
			val = 1;
		else if (strPreamble[0] == '2')
			val = 2;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup18))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_PREAMBLE_TYPE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup19))</script>"));
			goto setErr_advance;
		}
	}
#else
	// set preamble
	strPreamble = websGetVar(wp, T("preamble"), T(""));
	if (strPreamble[0]) {
		if (!gstrcmp(strPreamble, T("long")))
			preamble = LONG_PREAMBLE;
		else if (!gstrcmp(strPreamble, T("short")))
			preamble = SHORT_PREAMBLE;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup18))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_PREAMBLE_TYPE, (void *)&preamble) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup19))</script>"));
			goto setErr_advance;
		}
	}
#endif



	// set hidden SSID
	strHiddenSSID = websGetVar(wp, T("hiddenSSID"), T(""));
	if (strHiddenSSID[0]) {
		if (!gstrcmp(strHiddenSSID, T("no")))
			val = 0;
		else if (!gstrcmp(strHiddenSSID, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup20))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_HIDDEN_SSID, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup11))</script>"));
			goto setErr_advance;
		}
//Felix add for multiple SSID also can be hidden 2010.11.05
#ifdef _MSSID_	
		if ( apmib_set(MIB_WLAN_HIDDEN_SSID_1, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup11))</script>"));
                        goto setErr_advance;
                }
		if ( apmib_set(MIB_WLAN_HIDDEN_SSID_2, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup11))</script>"));
                        goto setErr_advance;
                }
		if ( apmib_set(MIB_WLAN_HIDDEN_SSID_3, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup11))</script>"));
                        goto setErr_advance;
                }
#endif
	}

#if defined(_STAR_) && defined(_MSSID_) //vance 2008.12.30
	strHiddenSSID1 = websGetVar(wp, T("hiddenSSID1"), T(""));
		if (strHiddenSSID1[0]) {
			if (!gstrcmp(strHiddenSSID1, T("no")))
				val = 0;
			else if (!gstrcmp(strHiddenSSID1, T("yes")))
				val = 1;
			else {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup20))</script>"));
				goto setErr_advance;
			}
			if ( apmib_set(MIB_WLAN_HIDDEN_SSID_1, (void *)&val) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup11))</script>"));
				goto setErr_advance;
			}
		}
#endif

	strDtim = websGetVar(wp, T("dtimPeriod"), T(""));
	if (strDtim[0]) {
		if ( !string_to_dec(strDtim, &val) || val<1 || val>255) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup21))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_DTIM_PERIOD, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup22))</script>"));
			goto setErr_advance;
		}
	}
	strAggregation = websGetVar(wp, T("aggregation"), T(""));
	if (strAggregation[0]) {
                if (!gstrcmp(strAggregation, T("no")))
                        val = 0;
                else if (!gstrcmp(strAggregation, T("yes")))
                        val = 1;
                else {
                        DEBUGP(tmpBuf, T("Get aggregation Error!"));
                        goto setErr_advance;
                }
                if ( apmib_set(MIB_WLAN_AGGREGATION, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("Set aggregation Error!"));
                        goto setErr_advance;
                }
	}
        strProtection= websGetVar(wp, T("shortGI0"), T(""));
        if (strProtection[0]) {
                if (!gstrcmp(strProtection, T("on")))
                        val = 1;
                else if (!gstrcmp(strProtection, T("off")))
                        val = 0;
                else {
                        strcpy(tmpBuf, T("Error! Invalid short GI."));
                        goto setErr_advance;
                }
                if ( apmib_set(MIB_WLAN_SHORT_GI, (void *)&val) == 0) {
                        strcpy(tmpBuf, T("Set MIB_WLAN_SHORT_GI failed!"));
                        goto setErr_advance;
                }
        }

	strIapp = websGetVar(wp, T("iapp"), T(""));
	if (strIapp[0]) {
		if (!gstrcmp(strIapp, T("no")))
			val = 1;
		else if (!gstrcmp(strIapp, T("yes")))
			val = 0;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup23))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_IAPP_DISABLED, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup24))</script>"));
			goto setErr_advance;
		}
	}
	strBlock = websGetVar(wp, T("block"), T(""));
	if (strBlock[0]) {
		if (!gstrcmp(strBlock, T("no")))
			val = 0;
		else if (!gstrcmp(strBlock, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup25))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_BLOCK_RELAY, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup26))</script>"));
			goto setErr_advance;
		}
	}

        strAckTimeout = websGetVar(wp, T("ackTimeout"), T(""));
        if (strAckTimeout[0]) {
		val=atoi(strAckTimeout);
                if ( apmib_set(MIB_ACK_TIMEOUT, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup26))</script>"));
                        goto setErr_advance;
                }
        }

//******************************wireless setting for inprocomm ******************************
#ifdef _IPN_WL_DEVICE_
	strTranRate = websGetVar(wp, T("wlanTranRate"), T(""));
//	printf("\nstrTranRate=%s\n",strTranRate);
	if ( strTranRate[0] ) {
		if ( apmib_set(MIB_WLAN_TRAN_RATE, (void *)strTranRate) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup27))</script>"));
			goto setErr_advance;
		}
	}
	// set Basic Rates Mode
	strRateMode = websGetVar(wp, T("wlanRateMode"), T(""));
//	printf("\nstrRateMode=%s\n",strRateMode);
	if (strRateMode[0]) {
		if (!gstrcmp(strRateMode, T("mixed")))
			val = 0;
		else if (!gstrcmp(strRateMode, T("g_only")))
			val = 1;
		else if (!gstrcmp(strRateMode, T("b_only")))
			val = 2;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup28))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_RATE_MODE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup29))</script>"));
			goto setErr_advance;
		}
	}
	// set Network Authentication
	strAuth = websGetVar(wp, T("netAuth"), T(""));
//	printf("\nstrAuth=%s\n",strAuth);
	if (strAuth[0]) {
		if ( !string_to_dec(strAuth, &val) || val<0 || val>5) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup32))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_AUTH_TYPE, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup33))</script>"));
			goto setErr_advance;
		}
	}
#endif

#if defined(_IPN_WL_DEVICE_) || defined(_STAR_) //vance 2008.12.30
	// set Transmit Burst Mode
	strBurst = websGetVar(wp, T("wlanBurst"), T(""));
	printf("\nstrBurst=%s\n",strBurst);
	if (strBurst[0]) {
		if (!gstrcmp(strBurst, T("no")))
			val = 0;
		else if (!gstrcmp(strBurst, T("yes")))
			val = 1;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup30))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_BURST, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup31))</script>"));
			goto setErr_advance;
		}
	}
#endif
	// set CTS Protection
	strCts = websGetVar(wp, T("wlanCts"), T(""));
	if (strCts[0]) {
		if (!gstrcmp(strCts, T("auto")))
			val = 0;
		else if (!gstrcmp(strCts, T("always")))
			val = 1;
		else if (!gstrcmp(strCts, T("none")))
			val = 2;
		else {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup34))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_CTS, (void *)&val) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup35))</script>"));
			goto setErr_advance;
		}
	}

	strProtection= websGetVar(wp, T("disProtection"), T(""));
	if (strProtection[0]) {
		if (!gstrcmp(strProtection, T("no")))
			val = 1;
		else if (!gstrcmp(strProtection, T("yes")))
			val = 0;
		else {
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup36))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WLAN_PROTECTION_DISABLED, (void *)&val) == 0) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup37))</script>"));
			goto setErr_advance;
		}
	}

#ifdef _WATCH_DOG_
	char_t *watchdog_enable, *watchdog_function;
	struct in_addr watchdog_host;

	watchdog_function = websGetVar(wp, T("watchdog_function"), T(""));
	if (watchdog_function[0]){
		watchdog_enable= websGetVar(wp, T("watchdog_enable"), T(""));
		if ( !gstrcmp(watchdog_enable, T("ON")))
			val = 1;
		else
			val = 0;
		apmib_set(MIB_WATCH_DOG_ENABLE, (void *)&val);

		if(val==1)
		{
			val= atoi((char_t *)websGetVar(wp, T("watchdog_interval"), T("1")));;
			apmib_set(MIB_WATCH_DOG_INTERVAL, (void *)&val);

			inet_aton(websGetVar(wp, T("watchdog_host"), T("0.0.0.0")), &watchdog_host);
			apmib_set(MIB_WATCH_DOG_HOST, (void *)&watchdog_host);

		}
	}
#endif

#if defined(_WEB_ACCESS_CONTROL_)
	webControl= websGetVar(wp, T("webControl"), T(""));
	if (webControl[0]) {
		if (!gstrcmp(webControl, T("no")))
			val = 1;
		else if (!gstrcmp(webControl, T("yes")))
			val = 0;
		else {
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup36))</script>"));
			goto setErr_advance;
		}
		if ( apmib_set(MIB_WEB_CONTROL, (void *)&val) == 0) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup37))</script>"));
			goto setErr_advance;
		}
	}
#endif

#ifdef _AP_WLAN_NOFORWARD_
	char_t *strwlanforward;
	strwlanforward = websGetVar(wp, T("wlanForward"), T(""));
	if ( !gstrcmp(strwlanforward, T("yes")))
		val=1;
	else
		val=0;

	apmib_set(MIB_WLAN_NOFORWARD, (void *)&val);
#endif

#if defined(_POWER_SAVING_)
	char_t *strLEDoffenable, *strLEDoff;
	strLEDoffenable = websGetVar(wp, T("ledoffEnabled"), T(""));
	if ( !gstrcmp(strLEDoffenable, T("ON")))
	{
		strLEDoff = websGetVar(wp, T("turnoffall"), T(""));
		if ( !gstrcmp(strLEDoff, T("yes")))
			val = 1;
		else
			val = 2;
	}
	else
		val = 0;
	if ( apmib_set(MIB_POWER_SAVING, (void *)&val) == 0) {
		goto setErr_advance;
	}
#endif

	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
	// run script file to update WLAN parameters
	#ifdef HOME_GATEWAY
		//sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG, "gw", "bridge"); // Tommy
		//system(tmpBuf);
	#else
		//sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG, "ap", "bridge"); // Tommy
		//system(tmpBuf);
	#endif
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page

//	websRedirect(wp, submitUrl);
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif
	OK_MSG(submitUrl);
  	return;

setErr_advance:
	ERR_MSG(tmpBuf);
}

/////////////////////////////////////////////////////////////////////////////
#ifdef _BR6428PNL_
int wirelessClientList_Customer(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t *interface_name;
	int  rateid=0, found=0, nBytesSent=0, i;
	char *buff, mode_buf[20], txrate[20], interface_name_ui[100];
	WLAN_STA_INFO_Tp pInfo;

	if (ejArgs(argc, argv, T("%s"), &interface_name) >= 1) // 參數夠
	{
		buff = calloc(1, sizeof(WLAN_STA_INFO_T) * (MAX_STA_NUM+1));
		if ( buff > 0 ) // 記憶體分配得到
		{
			if ( getWlStaInfo(interface_name,  (WLAN_STA_INFO_Tp)buff ) >= 0 ) // 找得到介面
			{
				for (i=1; i<=MAX_STA_NUM; i++)
				{
					pInfo = (WLAN_STA_INFO_Tp)&buff[i*sizeof(WLAN_STA_INFO_T)];
					if (pInfo->aid && (pInfo->flag & STA_INFO_FLAG_ASOC))
					{
						if(pInfo->network & BAND_11N)
							sprintf(mode_buf, "%s", T("11n"));
						else if (pInfo->network & BAND_11G)
							sprintf(mode_buf,"%s",  T("11g"));
						else if (pInfo->network & BAND_11B)
							sprintf(mode_buf, "%s", T("11b"));
						else if (pInfo->network& BAND_11A)
							sprintf(mode_buf, "%s", T("11a"));
						else
							sprintf(mode_buf, "%s", T("N/A"));

						if((pInfo->txOperaRates & 0x80) != 0x80)
						{
							if(pInfo->txOperaRates%2)
								sprintf(txrate, "%d%s",pInfo->txOperaRates/2, ".5");
							else
								sprintf(txrate, "%d",pInfo->txOperaRates/2);
						}
						else
						{
							if((pInfo->ht_info & 0x1)==0)
							{ //20M
								if((pInfo->ht_info & 0x2)==0)
								{//long
									for(rateid=0; rateid<16;rateid++)
									{
										if(rate_11n_table_20M_LONG[rateid].id == pInfo->txOperaRates)
										{
											sprintf(txrate, "%s", rate_11n_table_20M_LONG[rateid].rate);
											break;
										}
									}
								}
								else if((pInfo->ht_info & 0x2)==0x2)
								{//short
									for(rateid=0; rateid<16;rateid++)
									{
										if(rate_11n_table_20M_SHORT[rateid].id == pInfo->txOperaRates)
										{
											sprintf(txrate, "%s", rate_11n_table_20M_SHORT[rateid].rate);
											break;
										}
									}
								}
							}
							else if((pInfo->ht_info & 0x1)==0x1)
							{//40M
								if((pInfo->ht_info & 0x2)==0)
								{//long
									for(rateid=0; rateid<16;rateid++)
									{
										if(rate_11n_table_40M_LONG[rateid].id == pInfo->txOperaRates)
										{
											sprintf(txrate, "%s", rate_11n_table_40M_LONG[rateid].rate);
											break;
										}
									}
								}
								else if((pInfo->ht_info & 0x2)==0x2)
								{//short
									for(rateid=0; rateid<16;rateid++)
									{
										if(rate_11n_table_40M_SHORT[rateid].id == pInfo->txOperaRates)
										{
											sprintf(txrate, "%s", rate_11n_table_40M_SHORT[rateid].rate);
											break;
										}
									}
								}
							}
						}

						if(strcmp(interface_name, "wlan0"))
							sprintf(interface_name_ui, "<script>dw(WirelessAP)</script>");
						else if(strcmp(interface_name, "wlan0-va0"))
							sprintf(interface_name_ui, "<script>dw(VirtualAP)</script>1");
						else if(strcmp(interface_name, "wlan0-va1"))
							sprintf(interface_name_ui, "<script>dw(VirtualAP)</script>2");
						else if(strcmp(interface_name, "wlan0-va2"))
							sprintf(interface_name_ui, "<script>dw(VirtualAP)</script>3");
						else if(strcmp(interface_name, "wlan0-va3"))
							sprintf(interface_name_ui, "<script>dw(VirtualAP)</script>4");
						else
							sprintf(interface_name_ui, "%s", interface_name);

						nBytesSent += websWrite(wp, T("<tr class=\"table3\">"));
						nBytesSent += websWrite(wp, T("<td><font size=2>%02x:%02x:%02x:%02x:%02x:%02x</font></td>"),pInfo->addr[0],pInfo->addr[1],pInfo->addr[2],pInfo->addr[3],pInfo->addr[4],pInfo->addr[5]);
						nBytesSent += websWrite(wp, T("<td><font size=2>%s</font></td>"),mode_buf);
						nBytesSent += websWrite(wp, T("<td><font size=2>%d</font></td>"), pInfo->tx_packets);
						nBytesSent += websWrite(wp, T("<td><font size=2>%d</font></td>"), pInfo->rx_packets);
						nBytesSent += websWrite(wp, T("<td><font size=2>%s</font></td>"), txrate);
						nBytesSent += websWrite(wp, T("<td><font size=2>%s</font></td>"), (pInfo->flag & STA_INFO_FLAG_ASLEEP) ? "yes" : "no");
						nBytesSent += websWrite(wp, T("<td><font size=2>%d</font></td>"), pInfo->expired_time/100);
						//nBytesSent += websWrite(wp, T("<td><font size=2>%s</font></td>"), interface_name_ui);
						nBytesSent += websWrite(wp, T("</tr>"));
						found++;
					}
				}
				free(buff);
			}
		}
	}
/*	if (found == 0)
	{
		nBytesSent += websWrite(wp, T("<tr class=\"table3\">"));
		nBytesSent += websWrite(wp, T("<td><font size=2>None</font></td>"));
		nBytesSent += websWrite(wp, T("<td><font size=2>---</font></td>"));
		nBytesSent += websWrite(wp, T("<td><font size=2>---</font></td>"));
		nBytesSent += websWrite(wp, T("<td><font size=2>---</font></td>"));
		nBytesSent += websWrite(wp, T("<td><font size=2>---</font></td>"));
		nBytesSent += websWrite(wp, T("<td><font size=2>---</font></td>"));
		nBytesSent += websWrite(wp, T("<td><font size=2>---</font></td>"));
		//nBytesSent += websWrite(wp, T("<td><font size=2>%s</font></td>"));
		nBytesSent += websWrite(wp, T("</tr>"));
	}*/
	return nBytesSent;
}
int wirelessClientNumber_Customer(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t *interface_name;
	int  rateid=0, found=0, nBytesSent=0, i;
	char *buff, mode_buf[20], txrate[20], interface_name_ui[100];
	WLAN_STA_INFO_Tp pInfo;

	if (ejArgs(argc, argv, T("%s"), &interface_name) >= 1) //enough data
	{
		buff = calloc(1, sizeof(WLAN_STA_INFO_T) * (MAX_STA_NUM+1));
		if ( buff > 0 ) //
		{
			if ( getWlStaInfo(interface_name,  (WLAN_STA_INFO_Tp)buff ) >= 0 ) //
			{
				for (i=1; i<=MAX_STA_NUM; i++)
				{
					pInfo = (WLAN_STA_INFO_Tp)&buff[i*sizeof(WLAN_STA_INFO_T)];
					if (pInfo->aid && (pInfo->flag & STA_INFO_FLAG_ASOC))
						{found++;}
				}
				free(buff);
			}
		}
	}
	nBytesSent += websWrite(wp, T("%d"),found);
	return nBytesSent;
}
#endif


int wirelessClientList(int eid, webs_t wp, int argc, char_t **argv)
{
	//printf("test\n");
	int nBytesSent=0, i, found=0;
	WLAN_STA_INFO_Tp pInfo;
	char *buff;
	char mode_buf[20];
	char txrate[20];
	int rateid=0;
	char comb[50];

	buff = calloc(1, sizeof(WLAN_STA_INFO_T) * (MAX_STA_NUM+1));
	if ( buff == 0 ) {
		printf("Allocate buffer failed!\n");
		return 0;
	}

	sprintf(comb , "%s" , WLAN_IF);
#ifdef _MSSID_
	char Root_WLAN_IF[20];

	if (argc == 2) {
		int virtual_index;
		char virtual_name[20];
		strcpy(Root_WLAN_IF, WLAN_IF);

		virtual_index = atoi(argv[argc-1]) - 1;
		sprintf(virtual_name, "-va%d", virtual_index);
		//printf("wlan_if = %s\n" , WLAN_IF);
		//printf("virtual_name = %s\n" , virtual_name);
		strcat(comb, virtual_name);
		//printf("comb = %s \n" , comb);
	}
#endif

	if ( getWlStaInfo(comb,  (WLAN_STA_INFO_Tp)buff ) < 0 ) {
		printf("Read wlan sta info failed!\n");

#ifdef _MSSID_

		if (argc == 2)
			strcpy(comb, Root_WLAN_IF);
#endif
		return 0;
	}

#ifdef _MSSID_
	if (argc == 2)
		strcpy(comb, Root_WLAN_IF);
#endif



	for (i=1; i<=MAX_STA_NUM; i++) {
		pInfo = (WLAN_STA_INFO_Tp)&buff[i*sizeof(WLAN_STA_INFO_T)];
		if (pInfo->aid && (pInfo->flag & STA_INFO_FLAG_ASOC)) {

		if(pInfo->network & BAND_11N)
			sprintf(mode_buf, "%s", T(" 11n"));
		else if (pInfo->network & BAND_11G)
			sprintf(mode_buf,"%s",  T(" 11g"));
		else if (pInfo->network & BAND_11B)
			sprintf(mode_buf, "%s", T(" 11b"));
		else if (pInfo->network& BAND_11A)
			sprintf(mode_buf, "%s", T(" 11a"));
		else
			sprintf(mode_buf, "%s", T(" ---"));

		//printf("\n\nthe sta txrate=%d\n\n\n", pInfo->txOperaRates);


		if((pInfo->txOperaRates & 0x80) != 0x80){
			if(pInfo->txOperaRates%2){
				sprintf(txrate, "%d%s",pInfo->txOperaRates/2, ".5");
			}else{
				sprintf(txrate, "%d",pInfo->txOperaRates/2);
			}
		}else{
			if((pInfo->ht_info & 0x1)==0){ //20M
				if((pInfo->ht_info & 0x2)==0){//long
					for(rateid=0; rateid<16;rateid++){
						if(rate_11n_table_20M_LONG[rateid].id == pInfo->txOperaRates){
							sprintf(txrate, "%s", rate_11n_table_20M_LONG[rateid].rate);
							break;
						}
					}
				}else if((pInfo->ht_info & 0x2)==0x2){//short
					for(rateid=0; rateid<16;rateid++){
						if(rate_11n_table_20M_SHORT[rateid].id == pInfo->txOperaRates){
							sprintf(txrate, "%s", rate_11n_table_20M_SHORT[rateid].rate);
							break;
						}
					}
				}
			}else if((pInfo->ht_info & 0x1)==0x1){//40M
				if((pInfo->ht_info & 0x2)==0){//long

					for(rateid=0; rateid<16;rateid++){
						if(rate_11n_table_40M_LONG[rateid].id == pInfo->txOperaRates){
							sprintf(txrate, "%s", rate_11n_table_40M_LONG[rateid].rate);
							break;
						}
					}
				}else if((pInfo->ht_info & 0x2)==0x2){//short
					for(rateid=0; rateid<16;rateid++){
						if(rate_11n_table_40M_SHORT[rateid].id == pInfo->txOperaRates){
							sprintf(txrate, "%s", rate_11n_table_40M_SHORT[rateid].rate);
							break;
						}
					}
				}
			}

		}
			nBytesSent += websWrite(wp,
	   		T("<tr class=\"table3\"><td><font size=2>%02x:%02x:%02x:%02x:%02x:%02x</td>"
			"<td><font size=2>%s</td>"
			"<td><font size=2>%d</td>"
	     		"<td><font size=2>%d</td>"
			"<td><font size=2>%s</td>"
			"<td><font size=2>%s</td>"
			"<td><font size=2>%d</td>"
			"</tr>"),
			pInfo->addr[0],pInfo->addr[1],pInfo->addr[2],pInfo->addr[3],pInfo->addr[4],pInfo->addr[5],
			mode_buf,
			pInfo->tx_packets, pInfo->rx_packets,
			txrate,
			( (pInfo->flag & STA_INFO_FLAG_ASLEEP) ? "yes" : "no"),
			pInfo->expired_time/100
			);
			found++;
		}
	}
	if (found == 0) {
		nBytesSent += websWrite(wp,
	   		T("<tr class=\"table3\"><td><font size=2>None</td>"
			"<td><font size=2>---</td>"
	     		"<td><font size=2>---</td>"
			"<td><font size=2>---</td>"
			"<td><font size=2>---</td>"
			"<td><font size=2>---</td>"
			"<td><font size=2>---</td>"
			"</tr>"));
	}

	free(buff);

	return nBytesSent;
}
/////////////////////////////////////////////////////////////////////////////
void formWirelessTbl(webs_t wp, char_t *path, char_t *query)
{
	char_t *submitUrl , *submitUrl2;

	submitUrl = websGetVar(wp, T("submit-url"), T(""));

	submitUrl2 = websGetVar(wp, T("vapurl"), T(""));
	//printf("suburl = %s \n" , submitUrl);
	if (submitUrl[0])
		websRedirect(wp, submitUrl);
	if (submitUrl2[0])
		websRedirect(wp, submitUrl2);
}

/////////////////////////////////////////////////////////////////////////////
void formWlSiteSurvey(webs_t wp, char_t *path, char_t *query)
{
 	char_t *submitUrl, *refresh, *connect, *done, *strSel;
 	char_t *strSSID, *strChan;
	int status, idx, encrypt;
	unsigned char res, *pMsg=NULL;
	int apEnable=1;
	int wait_time;
	char tmpBuf[100];

	submitUrl = websGetVar(wp, T("submit-url"), T(""));

	done = websGetVar(wp, T("done"), T(""));
	if ( done[0] ) {
		strSSID = websGetVar(wp, T("selSSID"), T(""));
		strChan = websGetVar(wp, T("selChan"), T(""));
		printf("siteform ssid=%s\n",strSSID);
		if( strSSID[0]){

			int chan=0;
			CharFilter2(strSSID);
			if ( apmib_set(MIB_REPEATER_SSID, (void *)strSSID) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlSiteSurvey13))</script>"));
				goto ss_err;
			}
			printf("siteform ssid=%s\n",strSSID);


			chan=strtol(strChan, (char**)NULL, 10);
			printf("siteform channel=%d\n",chan);
			if ( apmib_set( MIB_WLAN_CHAN_NUM, (void *)&chan) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup17))</script>"));
				goto ss_err;
			}
			// apmib_set(MIB_AP_ROUTER_SWITCH, (void *)&apEnable);


		}

	}

	refresh = websGetVar(wp, T("refresh"), T(""));
	if ( refresh[0] ) {
		// issue scan request
#ifdef __TARGET_BOARD__
		wait_time = 0;
		while (1) {
			if ( getWlSiteSurveyRequest(WLAN_IF,  &status) < 0 ) {
				strcpy(tmpBuf, T("Site-survey request failed!"));
				goto ss_err;
			}
			if (status != 0) {	// not ready
				if (wait_time++ > 5) {
					strcpy(tmpBuf, T("scan request timeout!"));
					goto ss_err;
				}
				sleep(1);
			}
			else
				break;
		}

		// wait until scan completely
		wait_time = 0;
		while (1) {
			res = 1;	// only request request status
			if ( getWlSiteSurveyResult(WLAN_IF, (SS_STATUS_Tp)&res) < 0 ) {
				strcpy(tmpBuf, T("Read site-survey status failed!"));
				free(pStatus);
				pStatus = NULL;
				goto ss_err;
			}
			if (res == 0xff) {   // in progress
				if (wait_time++ > 10) {
					strcpy(tmpBuf, T("scan timeout!"));
					free(pStatus);
					pStatus = NULL;
					goto ss_err;
				}
				sleep(1);
			}
			else
				break;
		}
#endif
		sitesurveyed = 1;
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		return;
	}

	connect = websGetVar(wp, T("connect"), T(""));
	if ( connect[0] ) {
		strSel = websGetVar(wp, T("select"), T(""));
		if (strSel[0]) {
			unsigned char res;
			NETWORK_TYPE_T net;
			int chan;

			if (pStatus == NULL) {
				strcpy(tmpBuf, T("Please refresh again!"));
				goto ss_err;

			}
			sscanf(strSel, "sel%d", &idx);
			if ( idx >= pStatus->number ) { // invalid index
				strcpy(tmpBuf, T("Connect failed!"));
				goto ss_err;
			}

			// check encryption type match or not
			if ( !apmib_get( MIB_WLAN_ENCRYPT, (void *)&encrypt) ) {
				strcpy(tmpBuf, T("Check encryption error!"));
				goto ss_err;
			}
			else {
				// no encryption
				if (encrypt == ENCRYPT_DISABLED)
				{
					if (pStatus->bssdb[idx].bdCap & 0x00000010) {
						strcpy(tmpBuf, T("Encryption type mismatch!"));
						goto ss_err;
					}
					else
						; // success
				}
				// legacy encryption
				else if (encrypt == ENCRYPT_WEP)
				{
					if ((pStatus->bssdb[idx].bdCap & 0x00000010) == 0) {
						strcpy(tmpBuf, T("Encryption type mismatch!"));
						goto ss_err;
					}
					else if (pStatus->bssdb[idx].bdTstamp[0] != 0) {
						strcpy(tmpBuf, T("Encryption type mismatch!"));
						goto ss_err;
					}
					else
						; // success
				}
				// WPA/WPA2
				else
				{
					int isPSK, auth;
					apmib_get(MIB_WLAN_WPA_AUTH, (void *)&auth);
					if (auth == WPA_AUTH_PSK)
						isPSK = 1;
					else
						isPSK = 0;

					if ((pStatus->bssdb[idx].bdCap & 0x00000010) == 0) {
						strcpy(tmpBuf, T("Encryption type mismatch!"));
						goto ss_err;
					}
					else if (pStatus->bssdb[idx].bdTstamp[0] == 0) {
						strcpy(tmpBuf, T("Encryption type mismatch!"));
						goto ss_err;
					}
					else if (encrypt == ENCRYPT_WPA) {
						if (((pStatus->bssdb[idx].bdTstamp[0] & 0x0000ffff) == 0) ||
								(isPSK && !(pStatus->bssdb[idx].bdTstamp[0] & 0x4000)) ||
								(!isPSK && (pStatus->bssdb[idx].bdTstamp[0] & 0x4000)) ) {
						strcpy(tmpBuf, T("Encryption type mismatch!"));
						goto ss_err;
					}
					}
					else if (encrypt == ENCRYPT_WPA2) {
						if (((pStatus->bssdb[idx].bdTstamp[0] & 0xffff0000) == 0) ||
								(isPSK && !(pStatus->bssdb[idx].bdTstamp[0] & 0x40000000)) ||
								(!isPSK && (pStatus->bssdb[idx].bdTstamp[0] & 0x40000000)) ) {
							strcpy(tmpBuf, T("Encryption type mismatch!"));
							goto ss_err;
						}
					}
					else
						; // success
				}
			}

			// Set SSID, network type to MIB
			memcpy(tmpBuf, pStatus->bssdb[idx].bdSsIdBuf, pStatus->bssdb[idx].bdSsId.Length);
			tmpBuf[pStatus->bssdb[idx].bdSsId.Length] = '\0';
			if ( apmib_set(MIB_WLAN_SSID, (void *)tmpBuf) == 0) {
				strcpy(tmpBuf, T("Set SSID error!"));
				goto ss_err;
			}

			if ( pStatus->bssdb[idx].bdCap & cESS )
				net = INFRASTRUCTURE;
			else
				net = ADHOC;

			if ( apmib_set(MIB_WLAN_NETWORK_TYPE, (void *)&net) == 0) {
				strcpy(tmpBuf, T("Set MIB_WLAN_NETWORK_TYPE failed!"));
				goto ss_err;
			}

			/*
			if (net == ADHOC) {
				chan = pStatus->bssdb[idx].ChannelNumber;
				if ( apmib_set( MIB_WLAN_CHAN_NUM, (void *)&chan) == 0) {
   					strcpy(tmpBuf, T("Set channel number error!"));
					goto ss_err;
				}
				int is_40m_bw = (pStatus->bssdb[idx].bdTstamp[1] & 2) ? 1 : 0;
				apmib_set(MIB_WLAN_CHANNEL_BONDING, (void *)&is_40m_bw);
			}
			*/

			//apmib_update_web(CURRENT_SETTING);
			apmib_update(CURRENT_SETTING);

			res = idx;
			wait_time = 0;
			while (1) {
				if ( getWlJoinRequest(WLAN_IF, &pStatus->bssdb[idx], &res) < 0 ) {
					strcpy(tmpBuf, T("Join request failed!"));
					goto ss_err;
				}
				if ( res == 1 ) { // wait
					if (wait_time++ > 5) {
						strcpy(tmpBuf, T("connect-request timeout!"));
						goto ss_err;
					}
					sleep(1);
					continue;
				}
				break;
			}

			if ( res == 2 ) // invalid index
				pMsg = "Connect failed!";
			else {
				wait_time = 0;
				while (1) {
					if ( getWlJoinResult(WLAN_IF, &res) < 0 ) {
						strcpy(tmpBuf, T("Get Join result failed!"));
						goto ss_err;
					}
					if ( res != 0xff ) { // completed
						if (wait_time++ > 10) {
							strcpy(tmpBuf, T("connect timeout!"));
							goto ss_err;
						}
						break;
					}
					sleep(1);
				}

				if ( res!=STATE_Bss && res!=STATE_Ibss_Idle && res!=STATE_Ibss_Active )
					pMsg = "Connect failed!";
				else {
					status = 0;
					if (encrypt == ENCRYPT_WPA || encrypt == ENCRYPT_WPA2) {
						bss_info bss;
						wait_time = 0;
						while (wait_time++ < 5) {
							getWlBssInfo(WLAN_IF, &bss);
							if (bss.state == STATE_CONNECTED)
								break;
							sleep(1);
						}
						if (wait_time >= 5)
							status = 1;
					}
					if (status)
						pMsg = "Connect failed!";
					else
						pMsg = "Connect successfully!";
				}
			}
			OK_MSG1(pMsg, submitUrl);
		}
	}
		else {
		// issue scan request
#ifdef __TARGET_BOARD__
		wait_time = 0;
		while (1) {
			if ( getWlSiteSurveyRequest(WLAN_IF,  &status) < 0 ) {
				strcpy(tmpBuf, T("Site-survey request failed!"));
				goto ss_err;
			}
			if (status != 0) {	// not ready
				if (wait_time++ > 5) {
					strcpy(tmpBuf, T("scan request timeout!"));
					goto ss_err;
				}
				sleep(1);
			}
			else
				break;
		}

		// wait until scan completely
		wait_time = 0;
		while (1) {
			res = 1;	// only request request status
			if ( getWlSiteSurveyResult(WLAN_IF, (SS_STATUS_Tp)&res) < 0 ) {
				strcpy(tmpBuf, T("Read site-survey status failed!"));
				free(pStatus);
				pStatus = NULL;
				goto ss_err;
			}
			if (res == 0xff) {   // in progress
				if (wait_time++ > 10) {
					strcpy(tmpBuf, T("scan timeout!"));
					free(pStatus);
					pStatus = NULL;
					goto ss_err;
				}
				sleep(1);
			}
			else
				break;
		}
#endif
		sitesurveyed = 1;
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		return;
	}
	return;

ss_err:

#if defined(_Customer_) && (defined(_EW7218HNL_) || defined(_EW7428HRN_))
	return websWrite(wp, T("%s\n"),tmpBuf);
#else
	ERR_MSG(tmpBuf);
#endif

}
/////////////////////////////////////////////////////////////////////////////

void formWizSurvey(webs_t wp, char_t *path, char_t *query)
{
 	char_t *submitUrl, *refresh, *done;
 	char_t *strSSID, *strChan, *strManualSSID;
	char_t *encryption, *auth;
	int status, wait_time, chan;
	unsigned char res;
	char tmpBuf[100];
	encrypt_mode = 0;
	auth_mode = 0;
	
	submitUrl = websGetVar(wp, T("submit-url"), T(""));

	done = websGetVar(wp, T("done"), T(""));
	if ( done[0] ) {
		strManualSSID = websGetVar(wp, T("manualssid"), T(""));
		if ( strManualSSID[0] )
		{
			manualssid = 1;
			CharFilter4(strManualSSID);
			if ( apmib_set(MIB_REPEATER_SSID, (void *)strManualSSID) == 0) {	//REPEATER_SSID
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlSiteSurvey13))</script>"));
				goto ws_err;
			}
			if ( apmib_set(MIB_WLAN_SSID, (void *)strManualSSID) == 0) {	//WLAN_SSID
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlSiteSurvey15))</script>"));
				goto ws_err;
			}
		}
		else
		{
			manualssid = 0;
			strSSID = websGetVar(wp, T("ssid"), T(""));
			if( strSSID[0]){
				CharFilter2(strSSID);
				if ( apmib_set(MIB_REPEATER_SSID, (void *)strSSID) == 0) {	//REPEATER_SSID
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlSiteSurvey13))</script>"));
					goto ws_err;
				}
				if ( apmib_set(MIB_WLAN_SSID, (void *)strSSID) == 0) {        //WLAN_SSID
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlSiteSurvey15))</script>"));
					goto ws_err;
				}
				//printf("sitesurvey ssid=%s\n",strSSID);
			}
		
			strChan = websGetVar(wp, T("chan"), T(""));
			if ( strChan[0] ) {
				errno=0;
				chan = strtol( strChan, (char **)NULL, 10);
				if (errno) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup16))</script>"));
					goto ws_err;
				}
	#ifdef _DBAND_
				if ( strABand[0] ) {
					if ( apmib_set( MIB_ABAND_CHANNEL, (void *)&chan) == 0) {
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup17))</script>"));
						goto ws_err;
					}
				}else{
					if ( apmib_set( MIB_WLAN_CHAN_NUM, (void *)&chan) == 0) {
						DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup17))</script>"));
						goto ws_err;
					}
				}
	#else
				if ( apmib_set( MIB_WLAN_CHAN_NUM, (void *)&chan) == 0) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup17))</script>"));
					goto ws_err;
				}
	#endif
			}
			apmib_update(CURRENT_SETTING);
		
			auth = websGetVar(wp, T("auth"), T(""));
		    if ( auth[0] ){
				if (!gstrcmp(auth, T("WPA-PSK"))) //WPA
						auth_mode = 1;
				else if (!gstrcmp(auth, T("WPA2-PSK")) || !gstrcmp(auth, T("WPA-PSK/WPA2-PSK"))) //WPA2/WPAWPA2
						auth_mode = 2;
				else //disable/WEP
						auth_mode = 0;
		    }
		
			encryption = websGetVar(wp, T("encrypt"), T(""));
		    if ( encryption[0] && gstrcmp(auth, T("no")) ) {
				if (!gstrcmp(encryption, T("TKIP"))) //TKIP
						encrypt_mode = 2;
				else if (!gstrcmp(encryption, T("AES")) || !gstrcmp(encryption, T("AES/TKIP"))) //AES/TKIPAES
						encrypt_mode = 3;
		    }
		    else
				if (gstrcmp(auth, T("no"))) //not disable -> WEP
					encrypt_mode = 1;
		}
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		return;
	}

	refresh = websGetVar(wp, T("refresh"), T(""));
	if ( refresh[0] ) {
		// issue scan request
#ifdef __TARGET_BOARD__
		wait_time = 0;
		while (1) {
			if ( getWlSiteSurveyRequest(WLAN_IF,  &status) < 0 ) {
				strcpy(tmpBuf, T("Site-survey request failed!"));
				goto ws_err;
			}
			if (status != 0) {	// not ready
				if (wait_time++ > 5) {
					strcpy(tmpBuf, T("scan request timeout!"));
					goto ws_err;
				}
				sleep(1);
			}
			else
				break;
		}

		// wait until scan completely
		wait_time = 0;
		while (1) {
			res = 1;	// only request request status
			if ( getWlSiteSurveyResult(WLAN_IF, (SS_STATUS_Tp)&res) < 0 ) {
				strcpy(tmpBuf, T("Read site-survey status failed!"));
				free(pStatus);
				pStatus = NULL;
				goto ws_err;
			}
			if (res == 0xff) {   // in progress
				if (wait_time++ > 10) {
					strcpy(tmpBuf, T("scan timeout!"));
					free(pStatus);
					pStatus = NULL;
					goto ws_err;
				}
				sleep(1);
			}
			else
				break;
		}
#endif
		sitesurveyed = 1;
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		return;
	}
	return;

ws_err:
	ERR_MSG(tmpBuf);
}

/////////////////////////////////////////////////////////////////////////////

int wlSiteSurveyTbl(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0, i, status, apCount, intVal;
	BssDscr *pBss;
	char tmpBuf[100], ssidbuf[40], tmp1Buf[10], tmp2Buf[20], wpa_tkip_aes[20],wpa2_tkip_aes[20], tmp3Buf[20];

	WLAN_MODE_T mode;
	bss_info bss;
strcpy(tmp2Buf,"WPA-PSK/WPA2-PSK");
                if ( !strcmp("WPA-PSK/WPA2-PSK",tmp2Buf) )
                        strcpy(tmp3Buf,"WPA-Mix");
                else
                        strcpy(tmp3Buf,tmp2Buf);

#ifdef __TARGET_BOARD__
	if (pStatus==NULL) {
		pStatus = calloc(1, sizeof(SS_STATUS_T));
		if ( pStatus == NULL ) {
			printf("Allocate buffer failed!\n");
			return 0;
		}
	}

	pStatus->number = 0; // request BSS DB

	if ( getWlSiteSurveyResult(WLAN_IF, pStatus) < 0 ) {
		//ERR_MSG("Read site-survey status failed!");
		websWrite(wp, "Read site-survey status failed!");
		free(pStatus); //sc_yang
		pStatus = NULL;
		return 0;
	}

	if ( !apmib_get( MIB_AP_MODE, (void *)&mode) )
	{
		printf("Get MIB_WLAN_MODE MIB failed!");
		return 0;
	}

	if ( getWlBssInfo(WLAN_IF, &bss) < 0) {
		printf("Get bssinfo failed!");
		return 0;
	}

	for (i=0; i<pStatus->number && pStatus->number!=0xff; i++) {
		pBss = &pStatus->bssdb[i];
		snprintf(tmpBuf, 200, T("%02x:%02x:%02x:%02x:%02x:%02x"),
			pBss->bdBssId[0], pBss->bdBssId[1], pBss->bdBssId[2],
			pBss->bdBssId[3], pBss->bdBssId[4], pBss->bdBssId[5]);
		memcpy(ssidbuf, pBss->bdSsIdBuf, pBss->bdSsId.Length);
		ssidbuf[pBss->bdSsId.Length] = '\0';

		if (pBss->network==BAND_11B)
			strcpy(tmp1Buf, T(" (B)"));
		else if (pBss->network==BAND_11G)
			strcpy(tmp1Buf, T(" (G)"));
		else if (pBss->network==(BAND_11G|BAND_11B))
			strcpy(tmp1Buf, T(" (B+G)"));
		else if (pBss->network==(BAND_11N))
			strcpy(tmp1Buf, T(" (N)"));
		else if (pBss->network==(BAND_11G|BAND_11N))
			strcpy(tmp1Buf, T(" (G+N)"));
		else if (pBss->network==(BAND_11G|BAND_11B | BAND_11N))
			strcpy(tmp1Buf, T(" (B+G+N)"));
		else if(pBss->network== BAND_11A)
			strcpy(tmp1Buf, T(" (A)"));
		else
			strcpy(tmp1Buf, T(" ---"));

                memset(wpa_tkip_aes,0x00,sizeof(wpa_tkip_aes));
                memset(wpa2_tkip_aes,0x00,sizeof(wpa2_tkip_aes));

		int encryption_integer=0;
		if ((pBss->bdCap & cPrivacy) == 0) {
			sprintf(tmp2Buf, "no");
			encryption_integer=0;
		}
		else {
			if (pBss->bdTstamp[0] == 0) {
				sprintf(tmp2Buf, "WEP");
				encryption_integer=1;
			}
			else {
				int wpa_exist = 0, idx = 0;
				if (pBss->bdTstamp[0] & 0x0000ffff) {
					idx = sprintf(tmp2Buf, "WPA");
					encryption_integer=2;
					if (((pBss->bdTstamp[0] & 0x0000f000) >> 12) == 0x4) {
						idx += sprintf(tmp2Buf+idx, "-PSK");
						encryption_integer=3;
					}
					wpa_exist = 1;

                                        if (((pBss->bdTstamp[0] & 0x00000f00) >> 8) == 0x5)
                                                //sprintf(wpa_tkip_aes,"%s","aes/tkip");
                                                sprintf(wpa_tkip_aes,"%s","AES/TKIP");
                                        else if (((pBss->bdTstamp[0] & 0x00000f00) >> 8) == 0x4)
                                                //sprintf(wpa_tkip_aes,"%s","aes");
                                                sprintf(wpa_tkip_aes,"%s","AES");                                              
                                        else if (((pBss->bdTstamp[0] & 0x00000f00) >> 8) == 0x1)
                                                //sprintf(wpa_tkip_aes,"%s","tkip");
                                                sprintf(wpa_tkip_aes,"%s","TKIP");
				}
				if (pBss->bdTstamp[0] & 0xffff0000) {
					if (wpa_exist)
						idx += sprintf(tmp2Buf+idx, "/");
					idx += sprintf(tmp2Buf+idx, "WPA2");
					encryption_integer=4;
					if (((pBss->bdTstamp[0] & 0xf0000000) >> 28) == 0x4) {
						idx += sprintf(tmp2Buf+idx, "-PSK");
						encryption_integer=5;
					}

                                        if (((pBss->bdTstamp[0] & 0x0f000000) >> 24) == 0x5)
                                                //sprintf(wpa2_tkip_aes,"%s","aes/tkip");
                                                sprintf(wpa_tkip_aes,"%s","AES/TKIP");
                                        else if (((pBss->bdTstamp[0] & 0x0f000000) >> 24) == 0x4)
                                                //sprintf(wpa2_tkip_aes,"%s","aes");
                                                sprintf(wpa_tkip_aes,"%s","AES");     
                                        else if (((pBss->bdTstamp[0] & 0x0f000000) >> 24) == 0x1)
                                                //sprintf(wpa2_tkip_aes,"%s","tkip");
                                                sprintf(wpa_tkip_aes,"%s","TKIP");
				}
			}
		}
		if ( !strcmp("WPA-PSK/WPA2-PSK",tmp2Buf) )
			strcpy(tmp3Buf,"WPA-Mix");
		else
			strcpy(tmp3Buf,tmp2Buf);
                nBytesSent += websWrite(wp, T("<tr>"));

                nBytesSent += websWrite(wp, T("<td align=left class=\"table5\">\n"));
                nBytesSent += websWrite(wp, T("  <font size=\"2\"><script>document.write(\"%s\");</script></font>\n"),CharFilter2(ssidbuf));
                nBytesSent += websWrite(wp, T(" <input type=\"hidden\" name=\"ssid%d\" value=\"\">\n"),i);
                nBytesSent += websWrite(wp, T(" <script>document.forms['formWlSiteSurvey'].elements['ssid'+%d].value=\""),i);
                nBytesSent += websWrite(wp, CharFilter2(ssidbuf));
                nBytesSent += websWrite(wp, T("\"     </script>\n"));
                nBytesSent += websWrite(wp, T("</td>\n"));

                nBytesSent += websWrite(wp, T("<td align=center class=\"table5\">\n"));
                nBytesSent += websWrite(wp, T(  "<font size=\"2\">%s</font>\n"),tmpBuf);
                nBytesSent += websWrite(wp, T("</td>\n"));

                nBytesSent += websWrite(wp, T("<td align=center class=\"table5\">\n"));
                nBytesSent += websWrite(wp, T(" <font size=\"2\">%d</font><br>\n"),pBss->ChannelNumber);
                nBytesSent += websWrite(wp, T(" <input type=\"hidden\" name=\"chan%d\" value=\"%d\">\n"),i, pBss->ChannelNumber);
                nBytesSent += websWrite(wp, T(" <font size=\"2\">%s</font>\n"),tmp1Buf);
                nBytesSent += websWrite(wp, T("</td>\n"));

                nBytesSent += websWrite(wp, T("<td align=center class=\"table5\">\n"));
                nBytesSent += websWrite(wp, T(" <font size=\"2\">%s</font>\n"),((pBss->bdCap & cIBSS) ? "Ad hoc" : "AP"));
                nBytesSent += websWrite(wp, T("</td>\n"));

                nBytesSent += websWrite(wp, T("<td align=center class=\"table5\">\n"));
                nBytesSent += websWrite(wp, T(" <font size=\"2\">%s</font>\n"),tmp3Buf);
                nBytesSent += websWrite(wp, T(" <input type=\"hidden\" name=\"encryption%d\" value=\"\">\n"),i);
                nBytesSent += websWrite(wp, T(" <input type=\"hidden\" name=\"wpa_tkip_aes_%d\" value=\"%s\" >\n"),i,wpa_tkip_aes);
                nBytesSent += websWrite(wp, T(" <script>document.forms['formWlSiteSurvey'].elements['encryption'+%d].value=\"%s\""),i ,tmp2Buf);
                nBytesSent += websWrite(wp, T(" </script>\n"));
                nBytesSent += websWrite(wp, T("</td>\n"));

                nBytesSent += websWrite(wp, T("<td align=center class=\"table5\">\n"));
                nBytesSent += websWrite(wp, T(" <font size=\"2\">%d</font>"),pBss->rssi);
                nBytesSent += websWrite(wp, T("</td>\n"));

		if( mode == 2 || mode == 6){
	                nBytesSent += websWrite(wp, T("<td align=center width=\"10%%\" class=\"table5\" style=\"width:5%%\">"));
			nBytesSent += websWrite(wp, T("<input type=\"radio\" name=\"select\" value=\"sel%d\" onClick=\"enableConnect('%d')\">\n"),i,i);
	                nBytesSent += websWrite(wp, T("</td>\n"));
		}
                nBytesSent += websWrite(wp, T("</tr>\n"));
	}
#else	//!__TARGET_BOARD__
        if ( !apmib_get( MIB_AP_MODE, (void *)&mode) )
        {
                printf("Get MIB_WLAN_MODE MIB failed!");
                return 0;
        }

        for(i=0;i<2;i++) {
                nBytesSent += websWrite(wp, T("<tr>"));

                nBytesSent += websWrite(wp, T("<td align=left class=\"table5\">\n"));
                nBytesSent += websWrite(wp, T("  <font size=\"2\"><script>document.write(\"12345678901234567890123456789012\");</script></font>\n"));
                nBytesSent += websWrite(wp, T(" <input type=\"hidden\" name=\"ssid%d\" value=\"\">\n"),i);
                nBytesSent += websWrite(wp, T(" <script>document.forms['formWlSiteSurvey'].elements['ssid'+%d].value=\"Airlive\"</script>"),i);
                nBytesSent += websWrite(wp, T("</td>\n"));

                nBytesSent += websWrite(wp, T("<td align=center class=\"table5\">\n"));
                nBytesSent += websWrite(wp, T(  "<font size=\"2\">00:11:22:33:44:55</font>\n"));
                nBytesSent += websWrite(wp, T("</td>\n"));

                nBytesSent += websWrite(wp, T("<td align=center class=\"table5\">\n"));
                nBytesSent += websWrite(wp, T(" <font size=\"2\">11</font><br>\n"));
                nBytesSent += websWrite(wp, T(" <input type=\"hidden\" name=\"chan%d\" value=\"11\">\n"),i);
                nBytesSent += websWrite(wp, T(" <font size=\"2\">(B+G+N)</font>\n"));
                nBytesSent += websWrite(wp, T("</td>\n"));

                nBytesSent += websWrite(wp, T("<td align=center class=\"table5\">\n"));
                nBytesSent += websWrite(wp, T(" <font size=\"2\">AP</font>\n"));
                nBytesSent += websWrite(wp, T("</td>\n"));

                nBytesSent += websWrite(wp, T("<td align=center class=\"table5\">\n"));
                nBytesSent += websWrite(wp, T(" <font size=\"2\">WPA2-PSK</font>\n"));
                nBytesSent += websWrite(wp, T(" <input type=\"hidden\" name=\"encryption%d\" value=\"\">\n"),i);
                nBytesSent += websWrite(wp, T(" <input type=\"hidden\" name=\"wpa_tkip_aes_%d\" value=\"AES\" >\n"),i);
                nBytesSent += websWrite(wp, T(" <script>document.forms['formWlSiteSurvey'].elements['encryption'+%d].value=\"WPA-PSK/WPA2-PSK\""),i);
                nBytesSent += websWrite(wp, T(" </script>\n"));
                nBytesSent += websWrite(wp, T("</td>\n"));

                nBytesSent += websWrite(wp, T("<td align=center class=\"table5\">\n"));
                nBytesSent += websWrite(wp, T(" <font size=\"2\">50</font>"));
                nBytesSent += websWrite(wp, T("</td>\n"));

                if( mode == 2 || mode == 6){
                        nBytesSent += websWrite(wp, T("<td align=center width=\"10%%\" class=\"table5\" style=\"width:5%%\">"));
                        nBytesSent += websWrite(wp, T("<input type=\"radio\" name=\"select\" value=\"sel%d\" onClick=\"enableConnect('%d')\">\n"),i,i);
                        nBytesSent += websWrite(wp, T("</td>\n"));
                }
                nBytesSent += websWrite(wp, T("</tr>\n"));
        }

#endif	//__TARGET_BOARD__
	apCount = i;
	nBytesSent += websWrite(wp, T("<input type=\"hidden\" name=\"apCount\" value=\"%d\">"),apCount);

	return nBytesSent;
}
int WizSurveyTbl(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0, i, apCount;
	BssDscr *pBss;
	char tmpBuf[100], ssidbuf[40], tmp1Buf[10], tmp2Buf[20], wpa_tkip_aes[20],wpa2_tkip_aes[20];
	WLAN_MODE_T mode;
	bss_info bss;

#ifdef __TARGET_BOARD__
	if (pStatus==NULL) {
		pStatus = calloc(1, sizeof(SS_STATUS_T));
		if ( pStatus == NULL ) {
			printf("Allocate buffer failed!\n");
			return 0;
		}
	}

	pStatus->number = 0; // request BSS DB

	if ( getWlSiteSurveyResult(WLAN_IF, pStatus) < 0 ) {
		//ERR_MSG("Read site-survey status failed!");
		free(pStatus); //sc_yang
		pStatus = NULL;
		return 0;
	}

	if ( !apmib_get( MIB_AP_MODE, (void *)&mode) )
	{
		printf("Get MIB_WLAN_MODE MIB failed!");
		return 0;
	}

	if ( getWlBssInfo(WLAN_IF, &bss) < 0) {
		printf("Get bssinfo failed!");
		return 0;
	}

	for (i=0; i<pStatus->number && pStatus->number!=0xff; i++) {
		pBss = &pStatus->bssdb[i];
		snprintf(tmpBuf, 200, T("%02x:%02x:%02x:%02x:%02x:%02x"),
			pBss->bdBssId[0], pBss->bdBssId[1], pBss->bdBssId[2],
			pBss->bdBssId[3], pBss->bdBssId[4], pBss->bdBssId[5]);
		memcpy(ssidbuf, pBss->bdSsIdBuf, pBss->bdSsId.Length);
		ssidbuf[pBss->bdSsId.Length] = '\0';

		if (pBss->network==BAND_11B)
			strcpy(tmp1Buf, T(" (B)"));
		else if (pBss->network==BAND_11G)
			strcpy(tmp1Buf, T(" (G)"));
		else if (pBss->network==(BAND_11G|BAND_11B))
			strcpy(tmp1Buf, T(" (B+G)"));
		else if (pBss->network==(BAND_11N))
			strcpy(tmp1Buf, T(" (N)"));
		else if (pBss->network==(BAND_11G|BAND_11N))
			strcpy(tmp1Buf, T(" (G+N)"));
		else if (pBss->network==(BAND_11G|BAND_11B | BAND_11N))
			strcpy(tmp1Buf, T(" (B+G+N)"));
		else if(pBss->network== BAND_11A)
			strcpy(tmp1Buf, T(" (A)"));
		else
			strcpy(tmp1Buf, T(" ---"));

		memset(wpa_tkip_aes,0x00,sizeof(wpa_tkip_aes));
		memset(wpa2_tkip_aes,0x00,sizeof(wpa2_tkip_aes));
		int encryption_integer=0;

		if ((pBss->bdCap & cPrivacy) == 0) {
			sprintf(tmp2Buf, "no");
			encryption_integer=0;
		}
		else {
			if (pBss->bdTstamp[0] == 0) {
				sprintf(tmp2Buf, "WEP");
				encryption_integer=1;
			}
			else {
				int wpa_exist = 0, idx = 0;
				if (pBss->bdTstamp[0] & 0x0000ffff) {
					idx = sprintf(tmp2Buf, "WPA");
					encryption_integer=2;
					if (((pBss->bdTstamp[0] & 0x0000f000) >> 12) == 0x4) {
						idx += sprintf(tmp2Buf+idx, "-PSK");
						encryption_integer=3;
					}
					wpa_exist = 1;

					if (((pBss->bdTstamp[0] & 0x00000f00) >> 8) == 0x5)
						sprintf(wpa_tkip_aes,"%s","AES/TKIP");
					else if (((pBss->bdTstamp[0] & 0x00000f00) >> 8) == 0x4)
						sprintf(wpa_tkip_aes,"%s","AES");                                              
					else if (((pBss->bdTstamp[0] & 0x00000f00) >> 8) == 0x1)
						sprintf(wpa_tkip_aes,"%s","TKIP");
				}
				if (pBss->bdTstamp[0] & 0xffff0000) {
					if (wpa_exist)
						idx += sprintf(tmp2Buf+idx, "/");
					idx += sprintf(tmp2Buf+idx, "WPA2");
					encryption_integer=4;
					if (((pBss->bdTstamp[0] & 0xf0000000) >> 28) == 0x4) {
						idx += sprintf(tmp2Buf+idx, "-PSK");
						encryption_integer=5;
					}
					if (((pBss->bdTstamp[0] & 0x0f000000) >> 24) == 0x5)
						sprintf(wpa_tkip_aes,"%s","AES/TKIP");
					else if (((pBss->bdTstamp[0] & 0x0f000000) >> 24) == 0x4)
						sprintf(wpa_tkip_aes,"%s","AES");     
					else if (((pBss->bdTstamp[0] & 0x0f000000) >> 24) == 0x1)
						sprintf(wpa_tkip_aes,"%s","TKIP");
				}
			}
		}
		nBytesSent += websWrite(wp, T("<tr>"
			"<td align=center width=\"10%%\" class=\"table2\" style=\"width:5%%\"><input type=\"radio\" name="
			"\"select\" value=\"sel%d\" onClick=\"enableConnect('sel%d')\">\n"),i,i);

		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T(" <font size=\"2\"><script>document.write(\"%s\");</script></font>\n"),CharFilter2(ssidbuf));
		nBytesSent += websWrite(wp, T("	<input type=\"hidden\" name=\"ssid%d\" value=\"\">\n"),i);
		nBytesSent += websWrite(wp, T("	<script>document.forms['formWizSurvey'].elements['ssid'+%d].value=\""),i);
		nBytesSent += websWrite(wp, CharFilter2(ssidbuf));
		nBytesSent += websWrite(wp, T("\"     </script>\n"));
		nBytesSent += websWrite(wp, T("</td>\n"));

		/*nBytesSent += websWrite(wp, T("<td align=center class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T(	"<font size=\"2\">%s</font>\n"),tmpBuf);
		nBytesSent += websWrite(wp, T("</td>\n"));
		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("	<font size=\"2\">%s</font>\n"),tmp1Buf);
		nBytesSent += websWrite(wp, T("</td>\n"));*/

		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("	<font size=\"2\">%d</font>\n"),pBss->ChannelNumber);
		nBytesSent += websWrite(wp, T("	<input type=\"hidden\" name=\"chan%d\" value=\"%d\">\n"),i, pBss->ChannelNumber);
		nBytesSent += websWrite(wp, T("</td>\n"));

		/*nBytesSent += websWrite(wp, T("<td align=center class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("	<font size=\"2\">%s</font>\n"),((pBss->bdCap & cIBSS) ? "Ad hoc" : "AP"));
		nBytesSent += websWrite(wp, T("</td>\n"));*/

		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("	<font size=\"2\">%s</font>\n"),tmp2Buf);
		nBytesSent += websWrite(wp, T("	<input type=\"hidden\" name=\"encryption%d\" value=\"\">\n"),i);
		nBytesSent += websWrite(wp, T(" <input type=\"hidden\" name=\"wpa_tkip_aes_%d\" value=\"%s\" >\n"),i,wpa_tkip_aes);
		nBytesSent += websWrite(wp, T("	<script>document.forms['formWizSurvey'].elements['encryption'+%d].value=\"%s\""),i ,tmp2Buf);
		nBytesSent += websWrite(wp, T(" </script>\n"));
		nBytesSent += websWrite(wp, T("</td>\n"));

		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("	<font size=\"2\">%d</font>"),pBss->rssi);
		nBytesSent += websWrite(wp, T("</td>\n"));
		nBytesSent += websWrite(wp, T("</tr>\n"));
	}
#else	//!__TARGET_BOARD__
	for(i=0;i<2;i++) {
		nBytesSent += websWrite(wp, T("<tr>"
			"<td align=center width=\"10%%\" class=\"table2\" style=\"width:5%%\"><input type=\"radio\" name="
			"\"select\" value=\"sel%d\" onClick=\"enableConnect('sel%d')\">\n"),i,i);
		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("  <font size=\"2\">SS%%ID%d</font>\n"),i);
		nBytesSent += websWrite(wp, T("	<input type=\"hidden\" name=\"ssid%d\" value=\"\">\n"),i,i);
		nBytesSent += websWrite(wp, T("	<script>document.forms['formWizSurvey'].elements['ssid'+%d].value=\"SS%ID%d\";"),i,i);
		nBytesSent += websWrite(wp, T("     </script>\n"));
		nBytesSent += websWrite(wp, T("</td>\n"));

		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("	<font size=\"2\">6</font>\n"));
		nBytesSent += websWrite(wp, T("	<input type=\"hidden\" name=\"chan%d\" value=\"6\">\n"),i);
		nBytesSent += websWrite(wp, T("</td>\n"));

		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\" nowrap>\n"));
		nBytesSent += websWrite(wp, T("	<font size=\"2\">no</font>\n"));
		nBytesSent += websWrite(wp, T("	<input type=\"hidden\" name=\"encryption%d\" value=\"\">\n"),i);
		nBytesSent += websWrite(wp, T(" <input type=\"hidden\" name=\"wpa_tkip_aes_%d\" value=\"\" >\n"),i);
		nBytesSent += websWrite(wp, T("	<script>document.forms['formWizSurvey'].elements['encryption'+%d].value=\"WEP\""),i);
		nBytesSent += websWrite(wp, T(" </script>\n"));
		nBytesSent += websWrite(wp, T("</td>\n"));

		nBytesSent += websWrite(wp, T("<td align=center class=\"table2\">\n"));
		nBytesSent += websWrite(wp, T("	<font size=\"2\">66</font>\n"));
		nBytesSent += websWrite(wp, T("</td></tr>\n"));
	}
#endif	//__TARGET_BOARD__
	apCount = i;
	nBytesSent += websWrite(wp, T("<input type=\"hidden\" name=\"apCount\" value=\"%d\">"),apCount);
	return nBytesSent;
}

/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#ifndef HOME_GATEWAY	// Radius server
void formRadius(webs_t wp, char_t *path, char_t *query)
{
	char_t *strUsrName, *strUsrPass, *strAddUsr, *strDelUsr, *strDelAllUsr;
	char_t *strCltIp, *strCltPass, *strAddClt, *strDelClt, *strDelAllClt;
	char_t *strVal, *submitUrl, *strApply;
//	char_t *strFrom, *strTo;
	char tmpBuf[100];
	int entryNum, intVal, i;
	RSER_CLT_T cltEntry;	// for radius server client
	RSER_USR_T usrEntry;	// for radius server user
//	struct in_addr curIpAddr, curSubnet;
	void *pEntry;
	int num_id, get_id, add_id, del_id, delall_id, enable_id;

	strAddUsr = websGetVar(wp, T("addRSerUsr"), T(""));
	strDelUsr = websGetVar(wp, T("delSelRSerUsr"), T(""));
	strDelAllUsr = websGetVar(wp, T("delAllRSerUsr"), T(""));

	strAddClt = websGetVar(wp, T("addRSerClt"), T(""));
	strDelClt = websGetVar(wp, T("delSelRSerClt"), T(""));
	strDelAllClt = websGetVar(wp, T("delAllRSerClt"), T(""));

	if (strAddUsr[0] || strDelUsr[0] || strDelAllUsr[0]) {
		num_id = MIB_RSER_USR_NUM;
		get_id = MIB_RSER_USR;
		add_id = MIB_RSER_USR_ADD;
		del_id = MIB_RSER_USR_DEL;
		delall_id = MIB_RSER_USR_DELALL;
		enable_id = MIB_RSER_ENABLED;
		memset(&usrEntry, '\0', sizeof(usrEntry));
		pEntry = (void *)&usrEntry;
	}
	else {
		num_id = MIB_RSER_CLT_NUM;
		get_id = MIB_RSER_CLT;
		add_id = MIB_RSER_CLT_ADD;
		del_id = MIB_RSER_CLT_DEL;
		delall_id = MIB_RSER_CLT_DELALL;
		enable_id = MIB_RSER_ENABLED;
		memset(&cltEntry, '\0', sizeof(cltEntry));
		pEntry = (void *)&cltEntry;
	}

	// Set enable flag
	if (strAddUsr[0]) {
		strVal = websGetVar(wp, T("enabled"), T(""));
		if ( !gstrcmp(strVal, T("ON")))
			intVal = 1;
		else
			intVal = 0;

		if ( apmib_set(enable_id, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspformDdnsErrFlag))</script>"));
			goto setErr_radius;
		}
	}
//*********************************** Add Radius usr ***********************************
	if (strAddUsr[0]) {
		strUsrName = websGetVar(wp, T("rserUsrName"), T(""));
		strUsrPass = websGetVar(wp, T("rserUsrPass"), T(""));

		if (!strUsrName[0] && !strUsrPass[0])
			goto setOk_radius;

		if (!strUsrName[0] || !strUsrPass[0]) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspformFilterErrInput))</script>"));
			goto setErr_radius;
		}

		if ( strUsrName[0] ) {
			if (strlen(strUsrName) > 32) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRadiusl2))</script>"));
				goto setErr_radius;
			}
			else
				strcpy(usrEntry.username, strUsrName);
		}

		if ( strUsrPass[0] ) {
			if (strlen(strUsrPass) > 16) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRadiusl3))</script>"));
				goto setErr_radius;
			}
			else
				strcpy(usrEntry.password, strUsrPass);
		}
	}

//*********************************** Add Radius client ***********************************
	if (strAddClt[0]) {
		strCltIp = websGetVar(wp, T("rserCltIp"), T(""));
		strCltPass = websGetVar(wp, T("rserCltPass"), T(""));

		if (!strCltIp[0] && !strCltPass[0])
			goto setOk_radius;

		if (!strCltIp[0] || !strCltPass[0]) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspformFilterErrInput))</script>"));
			goto setErr_radius;
		}

		fixed_inet_aton(strCltIp, cltEntry.ipAddr);

		if ( strCltPass[0] ) {
			if (strlen(strCltPass) > 16) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRadiusl3))</script>"));
				goto setErr_radius;
			}
			else
				strcpy(cltEntry.password, strCltPass);
		}
	}

	if (strAddUsr[0] || strAddClt[0]) {

		if ( !apmib_get(num_id, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspformQoSErrGetNum))</script>"));
			goto setErr_radius;
		}
		if (strAddUsr[0]) {
			if ( (entryNum + 1) > 96) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspformQoSInvAddEntry))</script>"));
				goto setErr_radius;
			}
		}
		if (strAddClt[0]) {
			if ( (entryNum + 1) > 16) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspformQoSInvAddEntry))</script>"));
				goto setErr_radius;
			}
		}
		// set to MIB. try to delete it first to avoid duplicate case
		apmib_set(del_id, pEntry);
		if ( apmib_set(add_id, pEntry) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspformQoSErrAddEntry))</script>"));
			goto setErr_radius;
		}
	}

	// Delete entry
	if (strDelUsr[0] || strDelClt[0]) {
		if ( !apmib_get(num_id, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrGetNum))</script>"));
			goto setErr_radius;
		}
		for (i=entryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "select%d", i);

			strVal = websGetVar(wp, tmpBuf, T(""));
			if ( !gstrcmp(strVal, T("ON")) ) {

				*((char *)pEntry) = (char)i;
				if ( !apmib_get(get_id, pEntry)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrGetTbl))</script>"));
					goto setErr_radius;
				}
				if ( !apmib_set(del_id, pEntry)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrDelEntry))</script>"));
					goto setErr_radius;
				}
			}
		}
	}

	// Delete all entry
	if (strDelAllUsr[0] || strDelAllClt[0]) {
		if ( !apmib_set(delall_id, pEntry)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspformVirtualSvErrDelAll))</script>"));
			goto setErr_radius;
		}
	}
setOk_radius:
	apmib_update(CURRENT_SETTING);

#ifndef NO_ACTION
//	sprintf(tmpBuf, "%s/%s %s %s", _CONFIG_SCRIPT_PATH, _CONFIG_SCRIPT_PROG, "ap", "all");
	//system("/bin/Radiusd.sh stop");
	//system("/bin/Radiusd.sh start&");
#endif

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	strApply = websGetVar(wp, T("isApply"), T(""));   // Tommy
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
#endif

	if (strApply[0]) {
		OK_MSG(submitUrl);
	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}

  	return;
setErr_radius:
	ERR_MSG(tmpBuf);
  	return;
}
/////////////////////////////////////////////////////////////////////////////
int RadiusCltList(int eid, webs_t wp, int argc, char_t **argv)
{
	int	nBytesSent=0, entryNum, i;
	RSER_CLT_T entry;
	char	*ip;

	if ( !apmib_get(MIB_RSER_CLT_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}
	for (i=1; i<=entryNum; i++) {
		*((char *)&entry) = (char)i;
		if ( !apmib_get(MIB_RSER_CLT, (void *)&entry))
			return -1;

		ip = fixed_inet_ntoa(entry.ipAddr);

		nBytesSent += websWrite(wp, T("<tr>"
		"<td align=center class=\"table2\"><font size=\"2\">%d</td>\n"
		"<td align=center class=\"table2\"><font size=\"2\">%s</td><input type=\"hidden\" name=\"ip%d\" value=\"%s\">\n"
   		"<td align=center class=\"table2\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td></tr>\n"),
				i, ip, i ,ip,i);
	}
	nBytesSent += websWrite(wp, T("<input type=\"hidden\" name=\"sipnum\" value=\"%d\">\n"),i-1);
	return nBytesSent;
}
/////////////////////////////////////////////////////////////////////////////
int RadiusUsrList(int eid, webs_t wp, int argc, char_t **argv)
{
	int	nBytesSent=0, entryNum, i;
	RSER_USR_T entry;
//	char	*type, *ip, portFrom[20], portTo[20];

	if ( !apmib_get(MIB_RSER_USR_NUM, (void *)&entryNum)) {
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}
	for (i=1; i<=entryNum; i++) {
		*((char *)&entry) = (char)i;
		if ( !apmib_get(MIB_RSER_USR, (void *)&entry))
			return -1;

		nBytesSent += websWrite(wp, T("<tr>"
		"<td align=center class=\"table2\"><font size=\"2\">%d</td>\n"
		"<td align=center class=\"table2\"><font size=\"2\">%s</td><input type=\"hidden\" name=\"user%d\" value=\"%s\">\n"
   		"<td align=center class=\"table2\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td></tr>\n"),
				i, entry.username, i, entry.username, i);
	}
	nBytesSent += websWrite(wp, T("<input type=\"hidden\" name=\"usernum\" value=\"%d\">\n"),i-1);
	return nBytesSent;
}
#endif
/////////////////////////////////////////////////////////////////////////////
void formWdsEncrypt(webs_t wp, char_t *path, char_t *query)
{
   char_t *wepKey;
   char_t *strKeyLen, *strFormat, *strKeyId, *strEnabled;
	char key[30];
	int enabled, keyLen, ret, i;
	WEP_T wep;

   	char_t *submitUrl, *strEncrypt, *strVal, *strEnRadius, *strWpaCipher;
	char tmpBuf[100];
	ENCRYPT_T encrypt;
	int enableRS=0, intVal, getPSK=0, len, intTkip, intAes;
	unsigned long reKeyTime;
	SUPP_NONWAP_T suppNonWPA;
	struct in_addr inIp;

#ifdef _Airlive_7428HCN_
        char_t *strMac1;
        strMac1 = websGetVar(wp, T("wlLinkMac1"), T(""));
        if (strMac1[0]) {
                if (strlen(strMac1)!=12 || !string_to_hex(strMac1, tmpBuf, 12)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup22))</script>"));
                        goto setErr_encrypt;
                }
                if ( !apmib_set(MIB_WL_LINKMAC1, (void *)tmpBuf)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup23))</script>"));
                        goto setErr_encrypt;
                }
        }
#endif

	//Set security method
   	strEncrypt = websGetVar(wp, T("method"), T(""));
//	printf("strEncrypt=%s\n");
	if (!strEncrypt[0]) {
 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt1))</script>"));
		goto setErr_encrypt;
	}
	encrypt = strEncrypt[0] - '0';
	if (apmib_set( MIB_WLAN_WDS_ENCRYPT, (void *)&encrypt) == 0) {
  		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup9))</script>"));
		goto setErr_encrypt;
	}

	if (encrypt==2 || encrypt==3) {
		// WPA authentication
		if (encrypt==2) {
			intVal = WPA_AUTH_PSK;
			getPSK = 1;
		}
		else if (encrypt==3) {
			intVal = WPA_AUTH_AUTO;
			enableRS = 1;
		}
		if ( apmib_set(MIB_WLAN_WPA_AUTH, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt4))</script>"));
			goto setErr_encrypt;
		}

		// cipher suite
		strVal = websGetVar(wp, T("wdsWpaCipher"), T(""));
		intVal = strVal[0] - '0';
		if (strVal[0]) {
			if (intVal==1 || intVal==3)	intTkip=WPA_CIPHER_TKIP; else intTkip=0;	// 2 0
			if (intVal==2 || intVal==3) intAes=WPA_CIPHER_AES; else intAes=0;		// 1 0

			if ( apmib_set(MIB_WLAN_WDS_WPA_CIPHER_SUITE, (void *)&intTkip) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
				goto setErr_encrypt;
			}
			if ( apmib_set(MIB_WLAN_WDS_WPA2_CIPHER_SUITE, (void *)&intAes) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
				goto setErr_encrypt;
			}
		}
	}

	//Follow Realtek, Set WLAN_ENCRYPT
	strWpaCipher = websGetVar(wp, T("wdsWpaCipher"), T(""));
	if (strEncrypt[0]=='0')	encrypt=0;
	else if (strEncrypt[0]=='1') encrypt=1;
	else if (((strEncrypt[0]=='2')||(strEncrypt[0]=='3')) && (strWpaCipher[0]=='1')) encrypt=2;
	else if (((strEncrypt[0]=='2')||(strEncrypt[0]=='3')) && (strWpaCipher[0]=='2')) encrypt=2;
	else if (((strEncrypt[0]=='2')||(strEncrypt[0]=='3')) && (strWpaCipher[0]=='3')) encrypt=2;
	if (apmib_set( MIB_WLAN_WDS_ENCRYPT, (void *)&encrypt) == 0) {
  		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
		goto setErr_encrypt;
	}
//*********************************** Wep setting ***********************************
	if (encrypt==ENCRYPT_WEP) {
		strEnabled = websGetVar(wp, T("wepEnabled"), T(""));
		if ( !gstrcmp(strEnabled, T("ON")))
			enabled = 1;
		else
			enabled = 0;

		if ( enabled ) {
			strKeyLen = websGetVar(wp, T("length"), T(""));
			if (!strKeyLen[0]) {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt2))</script>"));
				goto setErr_encrypt;
			}
			if (strKeyLen[0]!='1' && strKeyLen[0]!='2' && strKeyLen[0]!='3') {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt3))</script>"));
				goto setErr_encrypt;
			}
			if (strKeyLen[0] == '1')
				wep = WEP64;
			else if (strKeyLen[0] == '2')
				wep = WEP128;
			else
				wep = WEP152;
		}
		else
			wep = WEP_DISABLED;

		if ( apmib_set( MIB_WLAN_WEP, (void *)&wep) == 0) {
  			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt5))</script>"));
			goto setErr_encrypt;
		}

		if (wep == WEP_DISABLED)
			goto setwep_ret;

		strFormat = websGetVar(wp, T("format"), T(""));
		if (!strFormat[0]) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt5))</script>"));
			goto setErr_encrypt;
		}

		if (strFormat[0]!='1' && strFormat[0]!='2') {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt6))</script>"));
			goto setErr_encrypt;
		}

		i = strFormat[0] - '0' - 1;
		if ( apmib_set( MIB_WLAN_WEP_KEY_TYPE, (void *)&i) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt7))</script>"));
			goto setErr_encrypt;
		}

		if (wep == WEP64) {
			if (strFormat[0]=='1')
				keyLen = WEP64_KEY_LEN;
			else
				keyLen = WEP64_KEY_LEN*2;
		}
		else if (wep == WEP128) {
			if (strFormat[0]=='1')
				keyLen = WEP128_KEY_LEN;
			else
				keyLen = WEP128_KEY_LEN*2;
		}
		else {
			if (strFormat[0]=='1')
				keyLen = WEP152_KEY_LEN;
			else
				keyLen = WEP152_KEY_LEN*2;
		}
			strKeyId = websGetVar(wp, T("defaultTxKeyId"), T(""));
		if ( strKeyId[0] ) {
			if ( strKeyId[0]!='1' && strKeyId[0]!='2' && strKeyId[0]!='3' && strKeyId[0]!='4' ) {
		 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt8))</script>"));
				goto setErr_encrypt;
			}
			i = strKeyId[0] - '0' - 1;
			if ( !apmib_set( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&i ) ) {
		 		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt9))</script>"));
				goto setErr_encrypt;
			}
		}

		wepKey = websGetVar(wp, T("key1"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt10))</script>"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt11))</script>"));
						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_WLAN_WEP64_KEY1, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_WLAN_WEP128_KEY1, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY1, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt12))</script>"));
					goto setErr_encrypt;
				}
			}
		}
		wepKey = websGetVar(wp, T("key2"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt13))</script>"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt14))</script>"));
						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_WLAN_WEP64_KEY2, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_WLAN_WEP128_KEY2, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY2, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt15))</script>"));
					goto setErr_encrypt;
				}
			}
		}

		wepKey = websGetVar(wp, T("key3"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt16))</script>"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt17))</script>"));
						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_WLAN_WEP64_KEY3, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_WLAN_WEP128_KEY3, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY3, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt18))</script>"));
					goto setErr_encrypt;
				}
			}
		}
		wepKey = websGetVar(wp, T("key4"), T(""));
		if  (wepKey[0]) {
			if (strlen(wepKey) != keyLen) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt10))</script>"));
				goto setErr_encrypt;
			}
			if ( !isAllStar(wepKey) ) {
				if (strFormat[0] == '1') // ascii
					strcpy(key, wepKey);
				else { // hex
					if ( !string_to_hex(wepKey, key, keyLen)) {
		   				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt19))</script>"));
						goto setErr_encrypt;
					}
				}
				if (wep == WEP64)
					ret=apmib_set(MIB_WLAN_WEP64_KEY4, (void *)key);
				else if (wep == WEP128)
					ret=apmib_set(MIB_WLAN_WEP128_KEY4, (void *)key);
				else
					ret=apmib_set(MIB_WLAN_WEP152_KEY4, (void *)key);
				if (!ret) {
		 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt20))</script>"));
					goto setErr_encrypt;
				}
			}
		}
	}

//*********************************** pre-shared key setting ***********************************
	if ( getPSK ) {
		int oldFormat, oldPskLen, i;

		strVal = websGetVar(wp, T("wdsPskFormat"), T(""));
		if (!strVal[0]) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt22))</script>"));
			goto setErr_encrypt;
		}
		intVal = strVal[0] - '0';
		if (intVal != 0 && intVal != 1) {
 			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt23))</script>"));
			goto setErr_encrypt;
		}

		// remember current psk format and length to compare to default case "****"
		apmib_get(MIB_WLAN_WDS_WPA_PSK_FORMAT, (void *)&oldFormat);
		apmib_get(MIB_WLAN_WDS_WPA_PSK, (void *)tmpBuf);
		oldPskLen = strlen(tmpBuf);

		strVal = websGetVar(wp, T("wdsPskValue"), T(""));
		len = strlen(strVal);

		if (oldFormat == intVal && len == oldPskLen ) {
			for (i=0; i<len; i++) {
				if ( strVal[i] != '*' )
					break;
			}
			if (i == len)
				goto rekey_time;
		}

		if ( apmib_set(MIB_WLAN_WDS_WPA_PSK_FORMAT, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWdsEncrypt))</script>"));
			goto setErr_encrypt;
		}

		if (intVal==1) { // hex
			if (len!=MAX_PSK_LEN || !string_to_hex(strVal, tmpBuf, MAX_PSK_LEN)) {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt25))</script>"));
				goto setErr_encrypt;
			}
		}
		else { // passphras
			if (len==0 || len > (MAX_PSK_LEN-1) ) {
 				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt25))</script>"));
				goto setErr_encrypt;
			}
		}
		if ( !apmib_set(MIB_WLAN_WDS_WPA_PSK, (void *)strVal)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt6))</script>"));
			goto setErr_encrypt;
		}
	}
//****************************************  ****************************************
rekey_time:
get_wepkey:
		// get 802.1x WEP key length
		strVal = websGetVar(wp, T("wepKeyLen"), T(""));
		if (strVal[0]) {
			if ( !gstrcmp(strVal, T("wep64")))
				intVal = WEP64;
			else if ( !gstrcmp(strVal, T("wep128")))
				intVal = WEP128;
			else {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt15))</script>"));
				goto setErr_encrypt;
			}
			if ( apmib_set(MIB_WLAN_WEP, (void *)&intVal) == 0) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt16))</script>"));
				goto setErr_encrypt;
			}
		}
//-----------------------------------------------------------------------------------------------
setwep_ret:
	apmib_update(CURRENT_SETTING);


	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

#ifdef _Airlive_7428HCN_
        char_t *isWizard;
        isWizard = websGetVar(wp, T("isWizard"), T(""));
        if ( isWizard[0] ){
		REPLACE_MSG(submitUrl);
		return;
/*
		websHeader(wp);
                websWrite(wp, T("<script>window.close();</script>"));
                websDone(wp);
                return;
*/
        }

#endif
	OK_MSG(submitUrl);

	return;

setErr_encrypt:
	ERR_MSG(tmpBuf);
}
/////////////////////////////////////////////////////////////////////////////
int wdsList(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0, i;
	WDS_INFO_Tp pInfo;
	char *buff;

	buff = calloc(1, sizeof(WDS_INFO_T)*MAX_STA_NUM);
	if ( buff == 0 ) {
		printf("<script>document.write(showText(aspWirelessClientList1))</script>\n");
		return 0;
	}

	if ( getWdsInfo(WLAN_IF, buff) < 0 ) {
		printf("<script>document.write(showText(aspWirelessClientList2))</script>\n");
		return 0;
	}

	for (i=0; i<MAX_WDS_NUM; i++) {
		pInfo = (WDS_INFO_Tp)&buff[i*sizeof(WDS_INFO_T)];

		if (pInfo->state == STATE_WDS_EMPTY)
			break;

		nBytesSent += websWrite(wp,
	   		"<tr bgcolor=#b7b7b7><td><font size=2>%02x:%02x:%02x:%02x:%02x:%02x</td>"
			"<td><font size=2>%d</td>"
	     		"<td><font size=2>%d</td>"
			"<td><font size=2>%d</td>"
			"<td><font size=2>%d%s</td>",
			pInfo->addr[0],pInfo->addr[1],pInfo->addr[2],pInfo->addr[3],pInfo->addr[4],pInfo->addr[5],
			pInfo->tx_packets, pInfo->tx_errors, pInfo->rx_packets,
			pInfo->txOperaRate/2, ((pInfo->txOperaRate%2) ? ".5" : "" ));
	}

	free(buff);

	return nBytesSent;
}

#ifdef _MSSID_
void formMultipleSSID(webs_t wp, char_t *path, char_t *query)
{
int val;
char_t *ssid1, *ssid2, *ssid3, *ssid4, *ssid5, *ssid6;


struct in_addr inIp;
ssid1=websGetVar(wp,T("SSID1"),T(""));
ssid2=websGetVar(wp,T("SSID2"),T(""));
ssid3=websGetVar(wp,T("SSID3"),T(""));
ssid4=websGetVar(wp,T("SSID4"),T(""));
ssid5=websGetVar(wp,T("SSID5"),T(""));
ssid6=websGetVar(wp,T("SSID6"),T(""));

if(gstrcmp(ssid1,T(""))) apmib_set(MIB_WLAN_SSID_1, (void *)websGetVar(wp,T("SSID1"),T("")));
if(gstrcmp(ssid2,T(""))) apmib_set(MIB_WLAN_SSID_2, (void *)websGetVar(wp,T("SSID2"),T("")));
if(gstrcmp(ssid3,T(""))) apmib_set(MIB_WLAN_SSID_3, (void *)websGetVar(wp,T("SSID3"),T("")));
if(gstrcmp(ssid4,T(""))) apmib_set(MIB_WLAN_SSID_4, (void *)websGetVar(wp,T("SSID4"),T("")));
if(gstrcmp(ssid5,T(""))) apmib_set(MIB_WLAN_SSID_5, (void *)websGetVar(wp,T("SSID5"),T("")));
if(gstrcmp(ssid6,T(""))) apmib_set(MIB_WLAN_SSID_6, (void *)websGetVar(wp,T("SSID6"),T("")));

val=atoi(websGetVar(wp,T("mirror1"),T("")));apmib_set(MIB_WLAN_SSID_MIRROR_1, (void *)&val);
val=atoi(websGetVar(wp,T("mirror2"),T("")));apmib_set(MIB_WLAN_SSID_MIRROR_2, (void *)&val);
val=atoi(websGetVar(wp,T("mirror3"),T("")));apmib_set(MIB_WLAN_SSID_MIRROR_3, (void *)&val);
val=atoi(websGetVar(wp,T("mirror4"),T("")));apmib_set(MIB_WLAN_SSID_MIRROR_4, (void *)&val);
val=atoi(websGetVar(wp,T("mirror5"),T("")));apmib_set(MIB_WLAN_SSID_MIRROR_5, (void *)&val);
val=atoi(websGetVar(wp,T("mirror6"),T("")));apmib_set(MIB_WLAN_SSID_MIRROR_6, (void *)&val);

if(gstrcmp(ssid1,T(""))) {val=strtol(websGetVar(wp,T("wlband1"),T("")), (char **)NULL, 10)+1;apmib_set(MIB_WLAN_BAND_1, (void *)&val);}
if(gstrcmp(ssid2,T(""))) {val=strtol(websGetVar(wp,T("wlband2"),T("")), (char **)NULL, 10)+1;apmib_set(MIB_WLAN_BAND_2, (void *)&val);}
if(gstrcmp(ssid3,T(""))) {val=strtol(websGetVar(wp,T("wlband3"),T("")), (char **)NULL, 10)+1;apmib_set(MIB_WLAN_BAND_3, (void *)&val);}
if(gstrcmp(ssid4,T(""))) {val=strtol(websGetVar(wp,T("wlband4"),T("")), (char **)NULL, 10)+1;apmib_set(MIB_WLAN_BAND_4, (void *)&val);}

if(gstrcmp(ssid1,T(""))) {val=atoi(websGetVar(wp,T("hiddenSSID1"),T("")));apmib_set(MIB_WLAN_HIDDEN_SSID_1, (void *)&val);}
if(gstrcmp(ssid2,T(""))) {val=atoi(websGetVar(wp,T("hiddenSSID2"),T("")));apmib_set(MIB_WLAN_HIDDEN_SSID_2, (void *)&val);}
if(gstrcmp(ssid3,T(""))) {val=atoi(websGetVar(wp,T("hiddenSSID3"),T("")));apmib_set(MIB_WLAN_HIDDEN_SSID_3, (void *)&val);}
if(gstrcmp(ssid4,T(""))) {val=atoi(websGetVar(wp,T("hiddenSSID4"),T("")));apmib_set(MIB_WLAN_HIDDEN_SSID_4, (void *)&val);}
if(gstrcmp(ssid5,T(""))) {val=atoi(websGetVar(wp,T("hiddenSSID5"),T("")));apmib_set(MIB_WLAN_HIDDEN_SSID_5, (void *)&val);}
if(gstrcmp(ssid6,T(""))) {val=atoi(websGetVar(wp,T("hiddenSSID6"),T("")));apmib_set(MIB_WLAN_HIDDEN_SSID_6, (void *)&val);}

if(gstrcmp(ssid1,T(""))) {val=atoi(websGetVar(wp,T("WmmCapable1"),T("")));apmib_set(MIB_WLAN_WMM_1, (void *)&val);}
if(gstrcmp(ssid2,T(""))) {val=atoi(websGetVar(wp,T("WmmCapable2"),T("")));apmib_set(MIB_WLAN_WMM_2, (void *)&val);}
if(gstrcmp(ssid3,T(""))) {val=atoi(websGetVar(wp,T("WmmCapable3"),T("")));apmib_set(MIB_WLAN_WMM_3, (void *)&val);}
if(gstrcmp(ssid4,T(""))) {val=atoi(websGetVar(wp,T("WmmCapable4"),T("")));apmib_set(MIB_WLAN_WMM_4, (void *)&val);}
if(gstrcmp(ssid5,T(""))) {val=atoi(websGetVar(wp,T("WmmCapable5"),T("")));apmib_set(MIB_WLAN_WMM_5, (void *)&val);}
if(gstrcmp(ssid6,T(""))) {val=atoi(websGetVar(wp,T("WmmCapable6"),T("")));apmib_set(MIB_WLAN_WMM_6, (void *)&val);}

if(gstrcmp(ssid1,T(""))) {val=atoi(websGetVar(wp,T("vaccess1"),T("")));apmib_set(MIB_WLAN_ACCESS_1, (void *)&val);}
if(gstrcmp(ssid2,T(""))) {val=atoi(websGetVar(wp,T("vaccess2"),T("")));apmib_set(MIB_WLAN_ACCESS_2, (void *)&val);}
if(gstrcmp(ssid3,T(""))) {val=atoi(websGetVar(wp,T("vaccess3"),T("")));apmib_set(MIB_WLAN_ACCESS_3, (void *)&val);}
if(gstrcmp(ssid4,T(""))) {val=atoi(websGetVar(wp,T("vaccess4"),T("")));apmib_set(MIB_WLAN_ACCESS_4, (void *)&val);}

if(gstrcmp(ssid1,T(""))) {val = atoi(websGetVar(wp,T("txrate1"),T("")));val = 1 << (val-1);apmib_set(MIB_WLAN_FIX_RATE_1, (void *)&val);}
if(gstrcmp(ssid2,T(""))) {val = atoi(websGetVar(wp,T("txrate2"),T("")));val = 1 << (val-1);apmib_set(MIB_WLAN_FIX_RATE_2, (void *)&val);}
if(gstrcmp(ssid3,T(""))) {val = atoi(websGetVar(wp,T("txrate3"),T("")));val = 1 << (val-1);apmib_set(MIB_WLAN_FIX_RATE_3, (void *)&val);}
if(gstrcmp(ssid4,T(""))) {val = atoi(websGetVar(wp,T("txrate4"),T("")));val = 1 << (val-1);apmib_set(MIB_WLAN_FIX_RATE_4, (void *)&val);}
if(gstrcmp(ssid5,T(""))) {val = atoi(websGetVar(wp,T("txrate5"),T("")));val = 1 << (val-1);apmib_set(MIB_WLAN_FIX_RATE_5, (void *)&val);}
if(gstrcmp(ssid6,T(""))) {val = atoi(websGetVar(wp,T("txrate6"),T("")));val = 1 << (val-1);apmib_set(MIB_WLAN_FIX_RATE_6, (void *)&val);}

#if defined(_ENVLAN_)
if(gstrcmp(ssid1,T(""))) {val=atoi(websGetVar(wp,T("vlanid1"),T("")));apmib_set(MIB_WLAN_VLANID_1, (void *)&val);}
if(gstrcmp(ssid2,T(""))) {val=atoi(websGetVar(wp,T("vlanid2"),T("")));apmib_set(MIB_WLAN_VLANID_2, (void *)&val);}
if(gstrcmp(ssid3,T(""))) {val=atoi(websGetVar(wp,T("vlanid3"),T("")));apmib_set(MIB_WLAN_VLANID_3, (void *)&val);}
if(gstrcmp(ssid4,T(""))) {val=atoi(websGetVar(wp,T("vlanid4"),T("")));apmib_set(MIB_WLAN_VLANID_4, (void *)&val);}
if(gstrcmp(ssid5,T(""))) {val=atoi(websGetVar(wp,T("vlanid5"),T("")));apmib_set(MIB_WLAN_VLANID_5, (void *)&val);}
if(gstrcmp(ssid6,T(""))) {val=atoi(websGetVar(wp,T("vlanid6"),T("")));apmib_set(MIB_WLAN_VLANID_6, (void *)&val);}
#endif

#ifdef _LAN_WAN_ACCESS_
char_t *strLanWan;
strLanWan=(void *)websGetVar(wp,T("lanWanAccessValue"),T(""));

int lwValue=strtol(strLanWan, (char**)NULL, 10);

apmib_set(MIB_LAN_WAN_ACCESS,(void *)&lwValue  );

#endif
//**********************************************Realtek Vlan setting********************************

#if (defined(_ENVLAN_) && defined(_VLAN_CONFIG_SUPPORTED_))

	VLAN_CONFIG_T entry;
	char_t *submitUrl,*strTmp;
	int	i, vlan_onoff;
	char tmpBuf[100];
	int vid1,vid2,vid3,vid4;

	//displayPostDate(wp->postData);

	//strTmp= websGetVar(wp, T("vlan_onoff"), T(""));
	vid1=atoi(websGetVar(wp,T("vlanid1"),T("")));
	vid2=atoi(websGetVar(wp,T("vlanid2"),T("")));
	vid3=atoi(websGetVar(wp,T("vlanid3"),T("")));
	vid4=atoi(websGetVar(wp,T("vlanid4"),T("")));
	//vid11=atoi(websGetVar(wp,T("vlan_id_6"),T("")));
	//vid22=atoi(websGetVar(wp,T("vlan_id_7"),T("")));
	//vid33=atoi(websGetVar(wp,T("vlan_id_8"),T("")));
	//vid44=atoi(websGetVar(wp,T("vlan_id_9"),T("")));

	if(vid1 <= 1 && vid2 <= 1 && vid3 <= 1 && vid4 <= 1 )
		vlan_onoff = 0;
	else if (vid1 > 1 || vid2 > 1 || vid3 > 1 || vid4 > 1 )
		vlan_onoff = 1;

	printf("vlanEnable = %d \n" , vlan_onoff);

	if (!apmib_set(MIB_VLANCONFIG_ENABLED, (void *)&vlan_onoff))
	{
		printf("set  MIB_VLANCONFIG_ENABLED error!");

	}
	if(vlan_onoff == 1)
	{
		if ( !apmib_set(MIB_VLANCONFIG_DELALL, (void *)&entry))
		{
			printf("Delete all table error!");
		}
//only use to Customer's 4 VAP   6-9為四個VAP		some default value is Realtek def value

		for(i=1; i<=MAX_IFACE_VLAN_CONFIG ; i++)
		{
		printf("*******************************************************************************\n");
			memset(&entry, '\0', sizeof(entry));

			*((char *)&entry) = (char)i;
			apmib_get(MIB_VLANCONFIG, (void *)&entry);

			memset(tmpBuf,0x00, sizeof(tmpBuf));
			sprintf(tmpBuf,"vlan_iface_%d",i);
			//strTmp = websGetVar(wp, T(tmpBuf), T(""));
			if(i==1) strTmp="Ethernet Port1";		 if(i==2) strTmp="Ethernet Port2";
			if(i==3) strTmp="Ethernet Port3";		 if(i==4) strTmp="Ethernet Port4";
			if(i==5) strTmp="Wireless Primary AP"; if(i==6) strTmp="Virtual AP1";
			if(i==7) strTmp="Virtual AP2";		 if(i==8) strTmp="Virtual AP3";
			if(i==9) strTmp="Virtual AP4";		 if(i==10) strTmp="Ethernet Port5";
			if(strTmp[0])
			{
			}
			else
			{
				continue;
			}

			memset(tmpBuf,0x00, sizeof(tmpBuf));
			sprintf(tmpBuf,"vlan_enable_%d",i);
			//strTmp = websGetVar(wp, T(tmpBuf), T(""));

			if(i==1) strTmp="0";		 if(i==2) strTmp="0";
			if(i==3) strTmp="0";		 if(i==4) strTmp="0";
			if(i==5) strTmp="0"; 		 if(i==10) strTmp="0";
			if(i==6 && vid1>1)	strTmp="1"; else if(i==6 && vid1<=1) strTmp="0";
			if(i==7 && vid2>1)	strTmp="1"; else if(i==7 && vid2<=1) strTmp="0";
			if(i==8 && vid3>1)	strTmp="1"; else if(i==8 && vid3<=1) strTmp="0";
			if(i==9 && vid4>1)	strTmp="1"; else if(i==9 && vid4<=1) strTmp="0";
			if(strTmp[0])
			{
				entry.enabled = atoi(strTmp);
			}

			memset(tmpBuf,0x00, sizeof(tmpBuf));
			sprintf(tmpBuf,"vlan_tag_%d",i);
			//strTmp = websGetVar(wp, T(tmpBuf), T(""));
			strTmp = "0";

			if(strTmp[0])
			{
			printf("tagged = %s \n" , strTmp);
				entry.tagged = atoi(strTmp);
			}

			memset(tmpBuf,0x00, sizeof(tmpBuf));
			sprintf(tmpBuf,"vlan_cfg_%d",i);
			//strTmp = websGetVar(wp, T(tmpBuf), T(""));
			strTmp = "1";
			if(strTmp[0])
			{
			printf("cfi = %s \n" , strTmp);
				entry.cfi = atoi(strTmp);
			}

			memset(tmpBuf,0x00, sizeof(tmpBuf));
			//sprintf(tmpBuf,"vlan_id_%d",i);
			printf("tmpBuf%d = %s  \n" , i,tmpBuf );
			//strTmp = websGetVar(wp, T(tmpBuf), T(""));
			if(i==1) strTmp="3022";		 if(i==2) strTmp="3030";
			if(i==3) strTmp="500";		 if(i==4) strTmp="1";
			if(i==5) strTmp="1"; 		 if(i==10) strTmp="1";
			if(i==6){sprintf(tmpBuf,"vlanid%d",1); strTmp = websGetVar(wp, T(tmpBuf), T("")); }
			if(i==7){sprintf(tmpBuf,"vlanid%d",2); strTmp = websGetVar(wp, T(tmpBuf), T("")); }
			if(i==8){sprintf(tmpBuf,"vlanid%d",3); strTmp = websGetVar(wp, T(tmpBuf), T("")); }
			if(i==9){sprintf(tmpBuf,"vlanid%d",4); strTmp = websGetVar(wp, T(tmpBuf), T("")); }
			int vlani;
			if(strTmp[0])
			{
			printf("vlanID%d = %s \n" , i,strTmp);
				entry.vlanId = atoi(strTmp);
				vlani = atoi(strTmp);
				if(i==6) apmib_set(MIB_WLAN_VLANID_1, (void *)&vlani);
				if(i==7) apmib_set(MIB_WLAN_VLANID_2, (void *)&vlani);
				if(i==8) apmib_set(MIB_WLAN_VLANID_3, (void *)&vlani);
				if(i==9) apmib_set(MIB_WLAN_VLANID_4, (void *)&vlani);
			}
			else
			{
			printf("vlanID%d = 1 \n" , i);
			entry.vlanId = 1;
			vlani=1;
				if(i==6) apmib_set(MIB_WLAN_VLANID_1, (void *)&vlani);
				if(i==7) apmib_set(MIB_WLAN_VLANID_2, (void *)&vlani);
				if(i==8) apmib_set(MIB_WLAN_VLANID_3, (void *)&vlani);
				if(i==9) apmib_set(MIB_WLAN_VLANID_4, (void *)&vlani);
			}
			memset(tmpBuf,0x00, sizeof(tmpBuf));
			sprintf(tmpBuf,"vlan_priority_%d",i);
			//strTmp = websGetVar(wp, T(tmpBuf), T(""));
			strTmp ="0";
			if(strTmp[0])
			{
				entry.priority = atoi(strTmp);
			}

			if ( apmib_set(MIB_VLANCONFIG_ADD, (void *)&entry) == 0)
			{
				printf("Add table entry error!");

			}
		}

	}
#endif
	//**********************************************Realtek Vlan setting  end********************************

apmib_update(CURRENT_SETTING);
OK_MSG(websGetVar(wp, T("submit-url"), T("")));



}
/*
int MwirelessClientList(int eid, webs_t wp, int argc, char_t **argv)
{

	int nBytesSent=0, i, found=0;
	WLAN_STA_INFO_T *pInfo;
	char *buff;
	char tmp[100];

	buff = calloc(1, sizeof(WLAN_STA_INFO_T));
	if ( buff == 0 ) {
		printf("<script>document.write(showText(aspWirelessClientList1))</script>\n");
		return 0;
	}

	sprintf(tmp,"ra%s",argv[0]);

				if ( getWlStaInfo( T(tmp),  (WLAN_STA_INFO_Tp)buff ) < 0 )
				{
					printf("<script>document.write(showText(aspWirelessClientList2))</script>!\n",tmp);
					return 0;
				}

	pInfo = (WLAN_STA_INFO_T *)buff;

	for (i=0; i<pInfo->Num ; i++) {

		if (pInfo->Entry[i].Aid){
			nBytesSent += websWrite(wp,
	   		T("<tr class='table2'>"
	   		"<td><font size=2>%d</td>"
	   		"<td><font size=2>%02x:%02x:%02x:%02x:%02x:%02x</td>"
	   		"<td><font size=2>%s</td>"
			"<td><font size=2>%s</td>"
			"<td><font size=2>%s</td></tr>"),
			pInfo->Entry[i].Aid,
			pInfo->Entry[i].Addr[0],pInfo->Entry[i].Addr[1],pInfo->Entry[i].Addr[2],pInfo->Entry[i].Addr[3],pInfo->Entry[i].Addr[4],pInfo->Entry[i].Addr[5],
			GetPhyMode(pInfo->Entry[i].TxRate.field.MODE),
			((pInfo->Entry[i].Psm) ? "ON" : "OFF"),
			GetBW(pInfo->Entry[i].TxRate.field.BW));
			found++;
		}
	}

	if (found == 0) {
		nBytesSent += websWrite(wp,
	   		T("<tr class='table2'>"
	   		"<td><font size=2>---</td>"
	   		"<td><font size=2>---</td>"
	   		"<td><font size=2>---</td>"
			"<td><font size=2>---</td>"
			"<td><font size=2>---</td></tr>"));
	}

	free(buff);

	return nBytesSent;
}*/

#endif

#ifdef _WISP_
void formStaDrvSetup(webs_t wp, char_t *path, char_t *query)
{
	char_t *str;
	char tmp[100];
	struct in_addr inIp;
	int val;
	int len;

	str = websGetVar(wp, T("stadrv_type"), T(""));
	val=atoi(str);
	apmib_set(MIB_OP_MODE, (void *)&val);
	#ifdef _MSSID_
		if (val != 0)
		{
			val=0;
			apmib_set(MIB_WLAN_SSID_MIRROR_1, (void *)&val);
			apmib_set(MIB_WLAN_SSID_MIRROR_2, (void *)&val);
			apmib_set(MIB_WLAN_SSID_MIRROR_3, (void *)&val);
			apmib_set(MIB_WLAN_SSID_MIRROR_4, (void *)&val);
			apmib_set(MIB_WLAN_SSID_MIRROR_5, (void *)&val);
			apmib_set(MIB_WLAN_SSID_MIRROR_6, (void *)&val);
		}
	#endif

	if(val==1)
	{
		apmib_get(MIB_AP_MODE, (void *)&val);
		if(val==1 || val==2 || val==6)
		{
			val=0;
			apmib_set(MIB_AP_MODE, (void *)&val);
		}
	}

	str = websGetVar(wp, T("stadrv_clonemac"), T(""));
	string_to_hex(str, tmp, 12);
	apmib_set(MIB_STADRV_CLONEMAC, (void *)tmp);

	str = websGetVar(wp, T("stadrv_ssid"), T(""));
	apmib_set(MIB_STADRV_SSID, (void *)str);

	str = websGetVar(wp, T("stadrv_chan"), T(""));
	val=atoi(str);
	apmib_set(MIB_STADRV_CHAN_NUM, (void *)&val);

	str = websGetVar(wp, T("stadrv_band"), T(""));
//	val=atoi(str);
	val=9;
	apmib_set(MIB_STADRV_BAND, (void *)&val);

	str = websGetVar(wp, T("stadrv_encrypttype"), T(""));
	val=atoi(str);
	apmib_set(MIB_STADRV_ENCRYPT_TYPE, (void *)&val);

	switch(val)
	{
	case 0:
		break;
	case 1:
		str = websGetVar(wp, T("stadrv_weplength"), T(""));
		val=atoi(str);
		len=val;
		apmib_set(MIB_STADRV_WEP_LENGTH, (void *)&val);

		str = websGetVar(wp, T("stadrv_wepformat"), T(""));
		val=atoi(str);
		apmib_set(MIB_STADRV_WEP_FORMAT1, (void *)&val);

		str = websGetVar(wp, T("key1"), T(""));
		if (val==0)
		{
			if (len==0)
				sprintf(tmp, "%.2x%.2x%.2x%.2x%.2x", str[0], str[1], str[2], str[3], str[4]);
			else
				sprintf(tmp, "%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x", str[0], str[1], str[2], str[3], str[4], str[5], str[6], str[7], str[8], str[9], str[10], str[11], str[12]);
			apmib_set(MIB_STADRV_WEPKEY1, (void *)tmp);
		}
		else
			apmib_set(MIB_STADRV_WEPKEY1, (void *)str);

		str = websGetVar(wp, T("stadrv_wepformat2"), T(""));
		val=atoi(str);
		apmib_set(MIB_STADRV_WEP_FORMAT2, (void *)&val);

		str = websGetVar(wp, T("stadrv_wepformat3"), T(""));
		val=atoi(str);
		apmib_set(MIB_STADRV_WEP_FORMAT3, (void *)&val);

		str = websGetVar(wp, T("stadrv_wepformat4"), T(""));
		val=atoi(str);
		apmib_set(MIB_STADRV_WEP_FORMAT4, (void *)&val);

		str = websGetVar(wp, T("stadrv_defaultkey"), T(""));
		val=atoi(str);
		apmib_set(MIB_STADRV_WEP_DEFAULT_KEY, (void *)&val);

		str = websGetVar(wp, T("key2"), T(""));
		apmib_set(MIB_STADRV_WEPKEY2, (void *)str);

		str = websGetVar(wp, T("key3"), T(""));
		apmib_set(MIB_STADRV_WEPKEY3, (void *)str);

		str = websGetVar(wp, T("key4"), T(""));
		apmib_set(MIB_STADRV_WEPKEY4, (void *)str);
		break;
	case 2:
		str = websGetVar(wp, T("stadrv_wpacipher"), T(""));
		val=atoi(str);
		apmib_set(MIB_STADRV_WPA_CIPHER, (void *)&val);

		str = websGetVar(wp, T("stadrv_pskformat"), T(""));
		val=atoi(str);
		apmib_set(MIB_STADRV_PSK_FORMAT, (void *)&val);

		str = websGetVar(wp, T("stadrv_pskkey"), T(""));
		apmib_set(MIB_STADRV_PSKKEY, (void *)str);
		break;
	default:
		break;
	}

	apmib_update(CURRENT_SETTING);

#ifdef _TAG_IN_PAGE_
	main_menu=atoi((char_t *)websGetVar(wp, T("main_menu_number"), T("0")));
	sub_menu=atoi((char_t *)websGetVar(wp, T("sub_menu_number"), T("0")));
	third_menu=atoi((char_t *)websGetVar(wp, T("third_menu_number"), T("0")));
#endif

	str = websGetVar(wp, T("submit-url"), T(""));
	OK_MSG(str);

}
#endif


#ifdef _MULTI_TX_POWER_CONTROL_
//void formTimeZoneSetup(webs_t wp, char_t *path, char_t *query)
void formMultiPowerControl(webs_t wp, char_t *path, char_t *query)
{
        char_t *submitUrl, *strsetHour, *strsetMin, *strsetPower, *strTimeZoneSel, *strTimeServerAddr, *strmultipowerEenable;
        int val;
        char tmpBuf[100];
        struct in_addr inTimeServerAddr;

        strsetHour = websGetVar(wp, T("hour1"), T(""));
        if (strsetHour[0]) {
                if ( !string_to_dec(strsetHour, &val)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_TX_HOUR_1, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
	}
        strsetMin = websGetVar(wp, T("min1"), T(""));
        if (strsetMin[0]) {
                if ( !string_to_dec(strsetMin, &val)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_TX_MIN_1, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
        }
	strsetPower = websGetVar(wp, T("power1"), T(""));
        if (strsetPower[0]) {
                if ( !string_to_dec(strsetPower, &val)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_WLAN_TX_POWER_1, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
        }
        strsetHour = websGetVar(wp, T("hour2"), T(""));
        if (strsetHour[0]) {
                if ( !string_to_dec(strsetHour, &val)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_TX_HOUR_2, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
        }
        strsetMin = websGetVar(wp, T("min2"), T(""));
        if (strsetMin[0]) {
                if ( !string_to_dec(strsetMin, &val)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_TX_MIN_2, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
        }
        strsetPower = websGetVar(wp, T("power2"), T(""));
        if (strsetPower[0]) {
                if ( !string_to_dec(strsetPower, &val)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_WLAN_TX_POWER_2, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
        }
        strsetHour = websGetVar(wp, T("hour3"), T(""));
        if (strsetHour[0]) {
                if ( !string_to_dec(strsetHour, &val)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_TX_HOUR_3, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
        }
        strsetMin = websGetVar(wp, T("min3"), T(""));
        if (strsetMin[0]) {
                if ( !string_to_dec(strsetMin, &val)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_TX_MIN_3, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
        }
        strsetPower = websGetVar(wp, T("power3"), T(""));
        if (strsetPower[0]) {
                if ( !string_to_dec(strsetPower, &val)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_WLAN_TX_POWER_3, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
        }
        strsetHour = websGetVar(wp, T("hour4"), T(""));
        if (strsetHour[0]) {
                if ( !string_to_dec(strsetHour, &val)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_TX_HOUR_4, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
        }
        strsetMin = websGetVar(wp, T("min4"), T(""));
        if (strsetMin[0]) {
                if ( !string_to_dec(strsetMin, &val)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_TX_MIN_4, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
        }
        strsetPower = websGetVar(wp, T("power4"), T(""));
        if (strsetPower[0]) {
                if ( !string_to_dec(strsetPower, &val)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_WLAN_TX_POWER_4, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
        }
#ifdef _AP_WITH_TIMEZONE_
        strTimeZoneSel = websGetVar(wp, T("TimeZoneSel"), T(""));
        if (strTimeZoneSel[0]) {
                if ( !string_to_dec(strTimeZoneSel, &val) || val<0 || val>66) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup1))</script>"));
                        goto setErr_mtxpower;
                }
                if ( apmib_set(MIB_TIME_ZONE_SEL, (void *)&val) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup2))</script>"));
                        goto setErr_mtxpower;
                }
        }
        strTimeServerAddr = websGetVar(wp, T("TimeServerAddr"), T(""));
        if ( strTimeServerAddr[0] ) {
                if ( !inet_aton(strTimeServerAddr, &inTimeServerAddr) ) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTcpipSetup23))</script>"));
                        goto setErr_mtxpower;
                }
                if ( !apmib_set( MIB_TIMESERVER_ADDR, (void *)&inTimeServerAddr)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormTimeZoneSetup4))</script>"));
                        goto setErr_mtxpower;
                }
        }
#endif

        submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
		 strmultipowerEenable = websGetVar(wp, T("submit-url"), T(""));
        apmib_update(CURRENT_SETTING);
#if defined(_Customer_) && (defined(_EW7218HNL_) || defined(_EW7428HRN_))
		if (strmultipowerEenable[0] || wizardEnabled==1){
#else
		if (strmultipowerEenable[0]){
#endif
			REPLACE_MSG(submitUrl);
		}
		else {
			OK_MSG(submitUrl);
		}
        return;
setErr_mtxpower:
        ERR_MSG(tmpBuf);
}
#endif
#ifdef _GREEN_AP_SCHEDULE_
void formGreenAPschedule(webs_t wp, char_t *path, char_t *query)
{
	int val, i, j;
	char temp_str[20];

	if (!gstrcmp(websGetVar(wp, T("enable_greenap"), T("")), T("ON")))
		val=1;
	else
		val=0;
	apmib_set(MIB_GREENAP_ENABLE, (void *)&val);

	//if( val == 1)
	{
		for (j=1;j<=4;j++)
		{
			switch(j)
			{
				case 1: apmib_get( MIB_GREENAP_WEEKDAYS1, (void *)&val); break;
				case 2: apmib_get( MIB_GREENAP_WEEKDAYS2, (void *)&val); break;
				case 3: apmib_get( MIB_GREENAP_WEEKDAYS3, (void *)&val); break;
				case 4: apmib_get( MIB_GREENAP_WEEKDAYS4, (void *)&val); break;
				default: break;
			}
			/*if (!gstrcmp(websGetVar(wp, T("weekdayall"), T("")), T("ON")))
			{
				val |= (1<<7);
			}
			else*/
			{
				val &= ~(1<<7);
				for(i=0; i<7; i++)
				{
					sprintf(temp_str, "week%d_%d", j, i);
					if (!gstrcmp(websGetVar(wp, temp_str, T("")), T("ON")))
						val |= (1<<i);
					else
						val &= ~(1<<i);
				}
			}
			switch(j)
			{
				case 1: apmib_set( MIB_GREENAP_WEEKDAYS1, (void *)&val); break;
				case 2: apmib_set( MIB_GREENAP_WEEKDAYS2, (void *)&val); break;
				case 3: apmib_set( MIB_GREENAP_WEEKDAYS3, (void *)&val); break;
				case 4: apmib_set( MIB_GREENAP_WEEKDAYS4, (void *)&val); break;
				default: break;
			}
			//val=atoi(websGetVar(wp, T("timetype"), T("")));
			//apmib_set(MIB_GREENAP_TIME_TYPE, (void *)&val);
			//if( val == 1 )
			{
				sprintf(temp_str, "start_hour%d", j);
				val=atoi(websGetVar(wp, temp_str, T("")));
				switch(j)
				{
					case 1: apmib_set( MIB_GREENAP_START_HOUR1, (void *)&val); break;
					case 2: apmib_set( MIB_GREENAP_START_HOUR2, (void *)&val); break;
					case 3: apmib_set( MIB_GREENAP_START_HOUR3, (void *)&val); break;
					case 4: apmib_set( MIB_GREENAP_START_HOUR4, (void *)&val); break;
					default: break;
				}
				sprintf(temp_str, "start_min%d", j);
				val=atoi(websGetVar(wp, temp_str, T("")));
				switch(j)
				{
					case 1: apmib_set(MIB_GREENAP_START_MINUTE1, (void *)&val); break;
					case 2: apmib_set(MIB_GREENAP_START_MINUTE2, (void *)&val); break;
					case 3: apmib_set(MIB_GREENAP_START_MINUTE3, (void *)&val); break;
					case 4: apmib_set(MIB_GREENAP_START_MINUTE4, (void *)&val); break;
					default: break;
				}
				sprintf(temp_str, "stop_hour%d", j);
				val=atoi(websGetVar(wp, temp_str, T("")));
				switch(j)
				{
					case 1: apmib_set(MIB_GREENAP_STOP_HOUR1, (void *)&val); break;
					case 2: apmib_set(MIB_GREENAP_STOP_HOUR2, (void *)&val); break;
					case 3: apmib_set(MIB_GREENAP_STOP_HOUR3, (void *)&val); break;
					case 4: apmib_set(MIB_GREENAP_STOP_HOUR4, (void *)&val); break;
					default: break;
				}
				sprintf(temp_str, "stop_min%d", j);
				val=atoi(websGetVar(wp, temp_str, T("")));
				switch(j)
				{
					case 1: apmib_set(MIB_GREENAP_STOP_MINUTE1, (void *)&val); break;
					case 2: apmib_set(MIB_GREENAP_STOP_MINUTE2, (void *)&val); break;
					case 3: apmib_set(MIB_GREENAP_STOP_MINUTE3, (void *)&val); break;
					case 4: apmib_set(MIB_GREENAP_STOP_MINUTE4, (void *)&val); break;
					default: break;
				}
                                sprintf(temp_str, "power%d", j);
                                val=atoi(websGetVar(wp, temp_str, T("")));
                                switch(j)
                                {
                                        case 1: apmib_set( MIB_WLAN_TX_POWER_1, (void *)&val); break;
                                        case 2: apmib_set( MIB_WLAN_TX_POWER_2, (void *)&val); break;
                                        case 3: apmib_set( MIB_WLAN_TX_POWER_3, (void *)&val); break;
                                        case 4: apmib_set( MIB_WLAN_TX_POWER_4, (void *)&val); break;
                                        default: break;
                                }
			}
		}
	}
	apmib_update(CURRENT_SETTING);
	OK_MSG(websGetVar(wp, T("submit-url"), T("")));   // hidden page
	
}
#endif

#if defined(_Customer_) && (defined(_EW7218HNL_) || defined(_EW7428HRN_))
void formWizSetting(webs_t wp, char_t *path, char_t *query){

	char_t *strMode, *submitUrl, *strSSID, *strChan, *strEncrypt, *strAuth, *strPasswd, *strReboot, *strDHCP;
	int mode, val, chan, encrypt, authMode, intTkip=0, intAes=0, tmp;
	char tmpBuf[100], key[30];

	strEncrypt = websGetVar(wp, T("encrypt"), T(""));
	strAuth = websGetVar(wp, T("auth"), T(""));
	authMode = strtol( strAuth, (char **)NULL, 10);
        encrypt = strtol( strEncrypt, (char **)NULL, 10);
	if ( strEncrypt[0] || strAuth[0] ) {
		if ( authMode == 1 || authMode == 2 ){	//WPA,WPA2
			tmp = 2;
                        if (apmib_set( MIB_SECURITY_MODE, (void *)&tmp) == 0) {
                                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup9))</script>"));
                                //goto setErr_wlan;
                        }
			strPasswd = websGetVar(wp, T("password"), T(""));
                        if ( !apmib_set(MIB_WLAN_WPA_PSK, (void *)strPasswd)) {
                                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt6))</script>"));
                                //goto EZsetErr_wlan;
                        }
			if ( authMode == 1 && encrypt == 2 ){	//WPA-TKIP
				intTkip=1;
				tmp=2;
                	        if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intTkip) == 0) {
                        	        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
	                        }
        	                if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intAes) == 0) {
                	                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                        	}
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
			}
        	        if ( authMode == 1 && encrypt == 3 ){   //WPA-AES
                	        intTkip=4;
                                tmp=2;
                        	if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intTkip) == 0) {
                                	DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
	                        }
        	                if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intAes) == 0) {
                                	DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
	                        }
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
        	        }
                	if ( authMode == 1 && encrypt == 4 ){   //WPA-TKIP+AES
                        	intTkip=3;
				intAes=3;
                                tmp=2;
        	                if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intTkip) == 0) {
                	                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                        	}
	                        if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intAes) == 0) {
        	                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                	        }
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
	                }
        	        if ( authMode == 2 && encrypt == 2 ){   //WPA2-TKIP
                	        intAes=5;
                                tmp=4;
                        	if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intTkip) == 0) {
                                	DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
	                        }
        	                if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intAes) == 0) {
                	                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                        	}
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
	                }
        	        if ( authMode == 2 && encrypt == 3 ){   //WPA2-AES
                	        intAes=2;
                                tmp=4;
                        	if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intTkip) == 0) {
                                	DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
	                        }
        	                if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intAes) == 0) {
                	                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                        	}
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
	                }
	                if ( authMode == 2 && encrypt == 4 ){   //WPA2-TKIP+AES
        	                intTkip=3;
				intAes=4;
                                tmp=4;
                        	if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intTkip) == 0) {
                                	DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
	                        }
        	                if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intAes) == 0) {
                	                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                        	}
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
	                }
		}
		else{	//disable,WEP
			if ( encrypt == 1 ){	//WEP
				tmp=2
			        if ( apmib_set(MIB_WLAN_AUTH_TYPE, (void *)&authMode) == 0) 	//if authMode=3:Share
        	        		DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup12))</script>"));

				tmp = 1;
		                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
        	        	        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
		                }
	                        if (apmib_set( MIB_SECURITY_MODE, (void *)&tmp) == 0) {
        	                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup9))</script>"));
                                }
				tmp = 0;
	                        if ( !apmib_set( MIB_WLAN_WEP_DEFAULT_KEY, (void *)&tmp ) ) {
        	                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt9))</script>"));
                	                //goto setErr_encrypt;
                        	}
				strPasswd = websGetVar(wp, T("password"), T(""));
				if ( strlen(strPasswd) == 5 || strlen(strPasswd) == 10 ){
	                                if ( strlen(strPasswd) == 5 ){ // ascii
        	                                strcpy(key, strPasswd);
					}
                	                else { // hex
                        	                if ( !string_to_hex(strPasswd, key, strlen(strPasswd))) {
                                	                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt11))</script>"));
                                        	        //goto setErr_encrypt;
	                                        }
        	                        }
					apmib_set(MIB_WLAN_WEP64_KEY1, (void *)&key);
                                        apmib_set(MIB_WLAN_WEP64_KEY2, (void *)&key);
                                        apmib_set(MIB_WLAN_WEP64_KEY3, (void *)&key);
                                        apmib_set(MIB_WLAN_WEP64_KEY4, (void *)&key);
					tmp=1;

			                if ( apmib_set( MIB_WLAN_WEP, (void *)&tmp) == 0) {
                        			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt5))</script>"));
			                        //goto setErr_encrypt;
			                }
					if ( strlen(strPasswd) == 5 )
						tmp=0;
					else
						tmp=1;
		                        if ( apmib_set( MIB_WLAN_WEP_KEY_TYPE, (void *)&tmp) == 0) {
                		                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt7))</script>"));
                                		//goto setErr_wlan;
		                        }
				}
				else if  ( strlen(strPasswd) == 13 || strlen(strPasswd) == 26 ){
                                        if ( strlen(strPasswd) == 13 ) // ascii
                                                strcpy(key, strPasswd);
                                        else { // hex
                                                if ( !string_to_hex(strPasswd, key, strlen(strPasswd))) {
                                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt11))</script>"));
                                                        //goto setErr_encrypt;
                                                }
                                        }
                                        apmib_set(MIB_WLAN_WEP128_KEY1, (void *)&key);
                                        apmib_set(MIB_WLAN_WEP128_KEY2, (void *)&key);
                                        apmib_set(MIB_WLAN_WEP128_KEY3, (void *)&key);
                                        apmib_set(MIB_WLAN_WEP128_KEY4, (void *)&key);

                                        tmp=2;
                                        if ( apmib_set( MIB_WLAN_WEP, (void *)&tmp) == 0) {
                                                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt5))</script>"));
                                                //goto setErr_encrypt;
                                        }
                                        if ( strlen(strPasswd) == 13 )
                                                tmp=0;
                                        else
                                                tmp=1;
                                        if ( apmib_set( MIB_WLAN_WEP_KEY_TYPE, (void *)&tmp) == 0) {
                                                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt7))</script>"));
                                                //goto setErr_wlan;
                                        }
				}
			}	//WEP
			else{	//disable
				tmp=0;
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
                                if (apmib_set( MIB_SECURITY_MODE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup9))</script>"));
                                }
			}
		}
	}
        strReboot = websGetVar(wp, T("reboot"), T(""));
        if ( strReboot[0] ){
                tmp=DHCP_DISABLED;
                apmib_set(MIB_DHCP, (void *)&tmp);
	}
        apmib_update(CURRENT_SETTING);

	submitUrl = websGetVar(wp, T("submit-url"), T(""));


	if ( submitUrl[0] )
		REPLACE_MSG(submitUrl);

        #ifdef __TARGET_BOARD__ 
	if ( strReboot[0] ){
		system("/bin/init.sh ap all");
	}
        #endif

	return;
}
#endif
#ifdef _AUTO_CHANNEL_DET_
int channelDet()
{
	int nBytesSent=0, i, wait_time, status;
	BssDscr *pBss;
        char ssidbuf[40];
        unsigned char buffer[40], buff[100], res;

	WLAN_MODE_T mode;
	bss_info bss;

#ifdef __TARGET_BOARD__
        system("touch /tmp/SetChange_status");
        system("rm -rf /tmp/rootAP_ch 2> /dev/null");
        printf("Exe channel detect!\n");

	wait_time = 0;
	while (1) {
		if ( getWlSiteSurveyRequest(WLAN_IF,  &status) < 0 ) {
			printf("Site-survey request failed!");
                }
                if (status != 0) {      // not ready
                	if (wait_time++ > 5) {
                        	printf("scan request timeout!");
                        }
                        sleep(1);
                }
                else
                	break;
	}
	wait_time = 0;
        while (1) {
        	res = 1;        // only request request status
                if ( getWlSiteSurveyResult(WLAN_IF, (SS_STATUS_Tp)&res) < 0 ) {
                	printf("Read site-survey status failed!");
                        free(pStatus);
                        pStatus = NULL;
                }
                if (res == 0xff) {   // in progress
                	if (wait_time++ > 10) {
                        	printf("scan timeout!");
                                free(pStatus);
                                pStatus = NULL;
                        }
                        sleep(1);
                }
                else
                	break;
        }


	if ( !apmib_get( MIB_REPEATER_SSID, (void *)&buffer) )
		return -1;

	if (pStatus==NULL) {
		pStatus = calloc(1, sizeof(SS_STATUS_T));
		if ( pStatus == NULL ) {
			printf("Allocate buffer failed!\n");
			return 0;
		}
	}

	pStatus->number = 0; // request BSS DB

	if ( getWlSiteSurveyResult(WLAN_IF, pStatus) < 0 ) {
		free(pStatus); //sc_yang
		pStatus = NULL;
		return 0;
	}
/*
	if ( !apmib_get( MIB_AP_MODE, (void *)&mode) )
	{
		printf("Get MIB_WLAN_MODE MIB failed!");
		return 0;
	}
*/
	if ( getWlBssInfo(WLAN_IF, &bss) < 0) {
		printf("Get bssinfo failed!");
		return 0;
	}

	for (i=0; i<pStatus->number && pStatus->number!=0xff; i++) {
		pBss = &pStatus->bssdb[i];
		memcpy(ssidbuf, pBss->bdSsIdBuf, pBss->bdSsId.Length);
		ssidbuf[pBss->bdSsId.Length] = '\0';
		if ( !strcmp(ssidbuf,buffer)){
	                //snprintf(buff, sizeof(buff), "iwpriv wlan0 set_mib channel=%d", pBss->ChannelNumber);
	                snprintf(buff, sizeof(buff), "echo %d > /tmp/rootAP_ch", pBss->ChannelNumber);
                        system(buff);
	                /*if ( apmib_set( MIB_WLAN_CHAN_NUM, (void *)&pBss->ChannelNumber) == 0) {
				printf("Set Root AP Channel Error!\n");
	                }*/
			break;
		}
	}
        system("rm -rf /tmp/SetChange_status 2> /dev/null");
#endif	//__TARGET_BOARD__
	return 0;
}
#endif
#ifdef _Airlive_7428HCN_
void formSetSurvey(webs_t wp, char_t *path, char_t *query){
	char_t *strSsid, *strChannel, *encryption, *auth, *submitUrl;
	WLAN_MODE_T mode ;
	char tmpBuf[100];
	int tmp;

        if ( !apmib_get( MIB_AP_MODE, (void *)&mode) )
        {
                printf("Get MIB_WLAN_MODE MIB failed!");
                return 0;
        }

	strSsid = websGetVar(wp, T("ssid"), T(""));
	if( strSsid[0] ){
		if(mode == 6){	//repeater mode
                        if ( apmib_set(MIB_REPEATER_SSID, (void *)strSsid) == 0) {
                                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup7))</script>"));
                                goto setErr_svy;
                        }
		}
		else{	//client mode
                	if ( apmib_set(MIB_WLAN_SSID, (void *)strSsid) == 0) {
                                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup15))</script>"));
                                goto setErr_svy;
                	}
		}
	}
	
	strChannel = websGetVar(wp, T("channel"), T(""));
	if(strChannel[0]){
		tmp=atoi(strChannel);
                if ( apmib_set( MIB_WLAN_CHAN_NUM, (void *)&tmp) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup17))</script>"));
                        goto setErr_svy;
                }
	}

        encryption = websGetVar(wp, T("encrypt"), T(""));
        auth = websGetVar(wp, T("auth"), T(""));

	if ( encryption[0] || auth[0] ) {	//WPAPSK, WPA2PSK
		if (!gstrcmp(auth, T("WPA-PSK")) || !gstrcmp(auth, T("WPA2-PSK")) || !gstrcmp(auth, T("WPA-PSK/WPA2-PSK"))){
                        tmp = 2;
                        if (apmib_set( MIB_SECURITY_MODE, (void *)&tmp) == 0) {
                                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup9))</script>"));
				goto setErr_svy;
                        }
		
			if (!gstrcmp(auth, T("WPA-PSK")) && !gstrcmp(encryption, T("TKIP"))){
				tmp=1;
	                        if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&tmp) == 0) {
        	                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                	        }
				tmp=0;
	                        if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&tmp) == 0) {
        	                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                	        }
				tmp=2;
	                        if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
        	                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                	        }
			}
        	        else if (!gstrcmp(auth, T("WPA-PSK")) && !gstrcmp(encryption, T("AES"))){
				tmp=4;
                                if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                                }
				tmp=0;
                                if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                                }
				tmp=2;
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
			}
                        else if (!gstrcmp(auth, T("WPA-PSK")) && !gstrcmp(encryption, T("AES/TKIP"))){
                                tmp=3;
                                if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                                }
                                tmp=3;
                                if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                                }
                                tmp=2;
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
                        }
                        else if (!gstrcmp(auth, T("WPA2-PSK")) && !gstrcmp(encryption, T("TKIP"))){
                                tmp=0;
                                if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                                }
                                tmp=5;
                                if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                                }
                                tmp=4;
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
                        }
                        else if (!gstrcmp(auth, T("WPA2-PSK")) && !gstrcmp(encryption, T("AES"))){
                                tmp=0;
                                if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                                }
                                tmp=2;
                                if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                                }
                                tmp=4;
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
                        }
                        else if (!gstrcmp(auth, T("WPA2-PSK")) && !gstrcmp(encryption, T("AES/TKIP"))){
                                tmp=3;
                                if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                                }
                                tmp=4;
                                if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                                }
                                tmp=4;
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
                        }
			else{	//Mix mode
                                tmp=3;
                                if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                                }
                                tmp=4;
                                if ( apmib_set(MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                                }
                                tmp=4;
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
                        }
		}
		else{	//WEP, none
			if (gstrcmp(auth, T("no"))){	//WEP
				tmp=2;	//0:open 1:share 2:auto
                                if ( apmib_set(MIB_WLAN_AUTH_TYPE, (void *)&tmp) == 0)     //if authMode=3:Share
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup12))</script>"));

                                tmp = 1;
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
                                if (apmib_set( MIB_SECURITY_MODE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup9))</script>"));
                                }
			}
                        else{   //disable
                                tmp=0;
                                if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup11))</script>"));
                                }
                                if (apmib_set( MIB_SECURITY_MODE, (void *)&tmp) == 0) {
                                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup9))</script>"));
                                }
                        }

		}
	}
        apmib_update(CURRENT_SETTING);

        submitUrl = websGetVar(wp, T("submit_url"), T(""));
        if ( submitUrl[0] ){
		REPLACE_MSG(submitUrl);
	}
	return;
setErr_svy:
	ERR_MSG(tmpBuf);
}
void formAirliveWiz(webs_t wp, char_t *path, char_t *query){

	char_t *strMode, *submitUrl, *strReboot, *strDomain, *strBand, *strSSID, *strChanWidth, *strChan, *strHiddenSSID, *strWizSec, *strVal, *strAutoCloneMAC, *strManualCloneMac, *strControlSideband, *strUrSSID;
	int mode, intVal, chan, encrypt, len;
	char tmpBuf[100];


	strMode = websGetVar(wp, T("ap_mode"), T(""));
        if (strMode[0]) {
                mode = atoi(strMode);
                if ( apmib_set( MIB_AP_MODE, (void *)&mode) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup3))</script>"));
                        goto setErr_wiz;
                }
        }

	strDomain = websGetVar(wp, T("domain"), T(""));
	if (strDomain[0]){
		intVal = atoi(strDomain);
		if( apmib_set( MIB_CS_REG_DOMAIN, (void *)&intVal) == 0) {
			DEBUGP(tmpBuf, T("Set Domain Error!"));
			goto setErr_wiz;
		}
	}

	strBand = websGetVar(wp, T("band"), T(""));
	if ( strBand[0] ) {
		if (strBand[0] < '0' || strBand[0] > '6') {
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup4))</script>"));
			goto setErr_wiz;
                }
                intVal = (strBand[0] - '0' + 1);
                if ( apmib_set( MIB_WLAN_BAND, (void *)&intVal) == 0) {
                        strcpy(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup5))</script>"));
                        goto setErr_wiz;
                }
        }

	strSSID = websGetVar(wp, T("ssid"), T(""));
        if ( strSSID[0] ) {
                if ( apmib_set(MIB_WLAN_SSID, (void *)strSSID) == 0) {
                                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup15))</script>"));
                                goto setErr_wiz;
                }
        }

        strUrSSID = websGetVar(wp, T("repeaterSSID"), T(""));
        if ( strSSID[0] ) {
                if ( apmib_set(MIB_REPEATER_SSID, (void *)strUrSSID) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup15))</script>"));
                        goto setErr_wiz;
                }
        }

        strChanWidth = websGetVar(wp, T("wlanNChanWidth"), T(""));      //no use
        if (strChanWidth[0]) {
                if (!gstrcmp(strChanWidth, T("0")))
                        intVal = 0;
                else if (!gstrcmp(strChanWidth, T("1")))
                        intVal = 1;
                else {
                        DEBUGP(tmpBuf, T("Invalid Channel Width 0"));
                        goto setErr_wiz;
                }
                if ( apmib_set(MIB_WLAN_N_CHANNEL_WIDTH, (void *)&intVal) == 0) {
                        DEBUGP(tmpBuf, T("Invalid Channel Width 1"));
                        goto setErr_wiz;
                }
        }

	strChan = websGetVar(wp, T("chan"), T(""));
	if ( strChan[0] ) {
                chan = strtol( strChan, (char **)NULL, 10);
                if ( apmib_set( MIB_WLAN_CHAN_NUM, (void *)&chan) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup17))</script>"));
                        goto setErr_wiz;
                }
        }

	strHiddenSSID = websGetVar(wp, T("hiddenSSID"), T(""));
	if (strHiddenSSID[0]) {
		if (!gstrcmp(strHiddenSSID, T("no")))
                        intVal = 0;
                else if (!gstrcmp(strHiddenSSID, T("yes")))
                        intVal = 1;
                else {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup20))</script>"));
                        goto setErr_wiz;
                }
                if ( apmib_set(MIB_WLAN_HIDDEN_SSID, (void *)&intVal) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormAdvanceSetup11))</script>"));
                        goto setErr_wiz;
                }
        }

	strWizSec = websGetVar(wp, T("wizSec"), T(""));
	if( strWizSec[0] ){
		intVal = 1;
                if ( apmib_set(MIB_WPS_CONFIG_TYPE, (void *)&intVal) == 0) { //Felix 20120111 !!!
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
                        goto setErr_wiz;
                }
                if ( apmib_set(MIB_WPS_CONFIG_STATUS, (void *)&intVal) == 0) { //Felix 20120111 !!!
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspSetFirewallFail))</script>"));
                        goto setErr_wiz;
                }

	        intVal = 2;
		if (apmib_set( MIB_SECURITY_MODE, (void *)&intVal) == 0) {	//WPAPSK WPA2PSK
	                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup9))</script>"));
        	        goto setErr_wiz;
	        }
		intVal = 4;
		if (apmib_set( MIB_WLAN_ENCRYPT, (void *)&intVal) == 0) {      //WPAPSK WPA2PSK
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup9))</script>"));
                        goto setErr_wiz;
                }
		intVal = 2;
		if (apmib_set( MIB_WLAN_WPA2_CIPHER_SUITE, (void *)&intVal) == 0) {	//WPA2PSK
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup9))</script>"));
                        goto setErr_wiz;
                }
		intVal = 0;
		if ( apmib_set(MIB_WLAN_WPA_CIPHER_SUITE, (void *)&intVal) == 0) {	//WPA2PSK
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt21))</script>"));
                        goto setErr_wiz;
                }

		strVal = websGetVar(wp, T("pskValue"), T(""));
                len = strlen(strVal);
                if ( len == 64 ) { // hex
			intVal = 1;
                        if (!string_to_hex(strVal, tmpBuf, MAX_PSK_LEN)) {
                                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt25))</script>"));
                                goto setErr_wiz;
                        }
                }
                else { // passphras
			intVal = 0;
                        if (len < 8 || len > (MAX_PSK_LEN-1) ) {
                                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormStaEncrypt25))</script>"));
                                goto setErr_wiz;
                        }
                }

		if ( apmib_set(MIB_WLAN_WPA_PSK_FORMAT, (void *)&intVal) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWdsEncrypt))</script>"));
                        goto setErr_wiz;
                }
	
                if ( !apmib_set(MIB_WLAN_WPA_PSK, (void *)strVal)) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlEncrypt6))</script>"));
                        goto setErr_wiz;
                }
	}

	strAutoCloneMAC = websGetVar(wp, T("AutoCloneMAC"), T(""));
	if ( strAutoCloneMAC[0] ){
		intVal = atoi(strAutoCloneMAC);	
		if ( apmib_set(MIB_AUTO_MAC_CLONE, (void *)&intVal) == 0) {
		        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup14))</script>"));
			goto setErr_wiz;
		}
	}

	strManualCloneMac = websGetVar(wp, T("ManualCloneMac"), T(""));
	if ( strManualCloneMac[0] ){
		if (strlen(strManualCloneMac)!=12 || !string_to_hex(strManualCloneMac, tmpBuf, 12)) {
	                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup18))</script>"));
                        goto setErr_wiz;
                }
                if ( !apmib_set(MIB_CLONE_MAC_ADDR, (void *)tmpBuf)) {
	                DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup19))</script>"));
                        goto setErr_wiz;
                }	
	}

	strControlSideband = websGetVar(wp, T("controlsideband"), T(""));
        if ( strControlSideband[0] ){
                intVal = atoi(strControlSideband);
                if ( apmib_set(MIB_CONTROL_SIDEBAND, (void *)&intVal) == 0) {
                        DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlanSetup14))</script>"));
                        goto setErr_wiz;
                }
        }

        apmib_update(CURRENT_SETTING);
	apmib_get( MIB_AP_MODE, (void *)&intVal);
        submitUrl = websGetVar(wp, T("submit_url"), T(""));

        if ( submitUrl[0] ){
		if ( strcmp(submitUrl,"/wiz_start.asp")){
	                REPLACE_MSG(submitUrl);
		}
		else{
//			sprintf(tmpBuf, T("<script>if(window.sysrst) document.write(showText(sysrst)); else  document.write(\"System Restarting! Please wait for a while !\");</script>"));
			sprintf(tmpBuf, T("<script>document.write(\"System Restarting! Please wait for a while !\");</script>"));

	                OK_MSG3(tmpBuf, submitUrl);

		        unsigned char buffer1[100];

		        apmib_get( MIB_AP_MODE, (void *)&intVal);
		        if (intVal == 2 )
		                sprintf(buffer1,"/bin/reboot.sh");
		        else
                		sprintf(buffer1,"/bin/reset.sh ap 2 &");

			system(buffer1);
		}
	}
/*
        #ifdef __TARGET_BOARD__ 
        if ( strReboot[0] ){
                system("/bin/init.sh ap all");
        }
        #endif
*/
        return;

setErr_wiz:
        ERR_MSG(tmpBuf);

}
#endif

#ifdef _Airlive_Schedule_
void formAirliveSchedule(webs_t wp, char_t *path, char_t *query){
	char_t *tmpBuf, *submitUrl, *settingValue;
	int intVal, i;
	char temp_str[11];
        if (!gstrcmp(websGetVar(wp, T("enable"), T("")), T("ON")))
                intVal=1;
        else
                intVal=0;
        apmib_set(MIB_WLSCH_ENABLED, (void *)&intVal);

	for (i=1; i<=10; i++){
        	sprintf(temp_str, "enable_%d", i);
	        if (!gstrcmp(websGetVar(wp, temp_str, T("")), T("ON")))
        	        intVal=1;
        	else
                	intVal=0;
                switch(i)
                {
                	case 1: apmib_set( MIB_WLSCH_ENABLED_1, (void *)&intVal); break;
                        case 2: apmib_set( MIB_WLSCH_ENABLED_2, (void *)&intVal); break;
                        case 3: apmib_set( MIB_WLSCH_ENABLED_3, (void *)&intVal); break;
                        case 4: apmib_set( MIB_WLSCH_ENABLED_4, (void *)&intVal); break;
                        case 5: apmib_set( MIB_WLSCH_ENABLED_5, (void *)&intVal); break;
                        case 6: apmib_set( MIB_WLSCH_ENABLED_6, (void *)&intVal); break;
                        case 7: apmib_set( MIB_WLSCH_ENABLED_7, (void *)&intVal); break;
                        case 8: apmib_set( MIB_WLSCH_ENABLED_8, (void *)&intVal); break;
                        case 9: apmib_set( MIB_WLSCH_ENABLED_9, (void *)&intVal); break;
                        case 10: apmib_set( MIB_WLSCH_ENABLED_10, (void *)&intVal); break;
                        default: break;
                }
                sprintf(temp_str, "day%d", i);
                intVal=atoi(websGetVar(wp, temp_str, T("")));
                switch(i)
                {
                        case 1: apmib_set( MIB_WLSCH_DAY1, (void *)&intVal); break;
                        case 2: apmib_set( MIB_WLSCH_DAY2, (void *)&intVal); break;
                        case 3: apmib_set( MIB_WLSCH_DAY3, (void *)&intVal); break;
                        case 4: apmib_set( MIB_WLSCH_DAY4, (void *)&intVal); break;
                        case 5: apmib_set( MIB_WLSCH_DAY5, (void *)&intVal); break;
                        case 6: apmib_set( MIB_WLSCH_DAY6, (void *)&intVal); break;
                        case 7: apmib_set( MIB_WLSCH_DAY7, (void *)&intVal); break;
                        case 8: apmib_set( MIB_WLSCH_DAY8, (void *)&intVal); break;
                        case 9: apmib_set( MIB_WLSCH_DAY9, (void *)&intVal); break;
                        case 10: apmib_set( MIB_WLSCH_DAY10, (void *)&intVal); break;
                        default: break;
                }
                sprintf(temp_str, "fromHour%d", i);
                intVal=atoi(websGetVar(wp, temp_str, T("")));
                switch(i)
                { 
                        case 1: apmib_set( MIB_WLSCH_FROM_HOUR1, (void *)&intVal); break;
                        case 2: apmib_set( MIB_WLSCH_FROM_HOUR2, (void *)&intVal); break;
                        case 3: apmib_set( MIB_WLSCH_FROM_HOUR3, (void *)&intVal); break;
                        case 4: apmib_set( MIB_WLSCH_FROM_HOUR4, (void *)&intVal); break;
                        case 5: apmib_set( MIB_WLSCH_FROM_HOUR5, (void *)&intVal); break;
                        case 6: apmib_set( MIB_WLSCH_FROM_HOUR6, (void *)&intVal); break;
                        case 7: apmib_set( MIB_WLSCH_FROM_HOUR7, (void *)&intVal); break;
                        case 8: apmib_set( MIB_WLSCH_FROM_HOUR8, (void *)&intVal); break;
                        case 9: apmib_set( MIB_WLSCH_FROM_HOUR9, (void *)&intVal); break;
                        case 10: apmib_set( MIB_WLSCH_FROM_HOUR10, (void *)&intVal); break;
                        default: break;
                }
                sprintf(temp_str, "fromMin%d", i);
                intVal=atoi(websGetVar(wp, temp_str, T("")));
                switch(i)
                {
                        case 1: apmib_set( MIB_WLSCH_FROM_MIN1, (void *)&intVal); break;
                        case 2: apmib_set( MIB_WLSCH_FROM_MIN2, (void *)&intVal); break;
                        case 3: apmib_set( MIB_WLSCH_FROM_MIN3, (void *)&intVal); break;
                        case 4: apmib_set( MIB_WLSCH_FROM_MIN4, (void *)&intVal); break;
                        case 5: apmib_set( MIB_WLSCH_FROM_MIN5, (void *)&intVal); break;
                        case 6: apmib_set( MIB_WLSCH_FROM_MIN6, (void *)&intVal); break;
                        case 7: apmib_set( MIB_WLSCH_FROM_MIN7, (void *)&intVal); break;
                        case 8: apmib_set( MIB_WLSCH_FROM_MIN8, (void *)&intVal); break;
                        case 9: apmib_set( MIB_WLSCH_FROM_MIN9, (void *)&intVal); break;
                        case 10: apmib_set( MIB_WLSCH_FROM_MIN10, (void *)&intVal); break;
                        default: break;
                }
                sprintf(temp_str, "toHour%d", i);
                intVal=atoi(websGetVar(wp, temp_str, T("")));
                switch(i)
                {
                        case 1: apmib_set( MIB_WLSCH_TO_HOUR1, (void *)&intVal); break;
                        case 2: apmib_set( MIB_WLSCH_TO_HOUR2, (void *)&intVal); break;
                        case 3: apmib_set( MIB_WLSCH_TO_HOUR3, (void *)&intVal); break;
                        case 4: apmib_set( MIB_WLSCH_TO_HOUR4, (void *)&intVal); break;
                        case 5: apmib_set( MIB_WLSCH_TO_HOUR5, (void *)&intVal); break;
                        case 6: apmib_set( MIB_WLSCH_TO_HOUR6, (void *)&intVal); break;
                        case 7: apmib_set( MIB_WLSCH_TO_HOUR7, (void *)&intVal); break;
                        case 8: apmib_set( MIB_WLSCH_TO_HOUR8, (void *)&intVal); break;
                        case 9: apmib_set( MIB_WLSCH_TO_HOUR9, (void *)&intVal); break;
                        case 10: apmib_set( MIB_WLSCH_TO_HOUR10, (void *)&intVal); break;
                        default: break;
                }
                sprintf(temp_str, "toMin%d", i);
                intVal=atoi(websGetVar(wp, temp_str, T("")));
                switch(i)
                {
                        case 1: apmib_set( MIB_WLSCH_TO_MIN1, (void *)&intVal); break;
                        case 2: apmib_set( MIB_WLSCH_TO_MIN2, (void *)&intVal); break;
                        case 3: apmib_set( MIB_WLSCH_TO_MIN3, (void *)&intVal); break;
                        case 4: apmib_set( MIB_WLSCH_TO_MIN4, (void *)&intVal); break;
                        case 5: apmib_set( MIB_WLSCH_TO_MIN5, (void *)&intVal); break;
                        case 6: apmib_set( MIB_WLSCH_TO_MIN6, (void *)&intVal); break;
                        case 7: apmib_set( MIB_WLSCH_TO_MIN7, (void *)&intVal); break;
                        case 8: apmib_set( MIB_WLSCH_TO_MIN8, (void *)&intVal); break;
                        case 9: apmib_set( MIB_WLSCH_TO_MIN9, (void *)&intVal); break;
                        case 10: apmib_set( MIB_WLSCH_TO_MIN10, (void *)&intVal); break;
                        default: break;
                }

	}
	apmib_update(CURRENT_SETTING);
	submitUrl = websGetVar(wp, T("submit_url"), T(""));
        OK_MSG(submitUrl);
        return;

}
#endif
void formWlWds(webs_t wp, char_t *path, char_t *query)
{
	char_t *strAddMac, *strDelMac, *strDelAllMac, *strVal, *submitUrl, *strEnabled, *strApply;
	char tmpBuf[100];
	int entryNum, i, enabled;
	MACFILTER_T macEntry;

	strAddMac = websGetVar(wp, T("addFilterMac"), T(""));
	strDelMac = websGetVar(wp, T("deleteSelFilterMac"), T(""));
	strDelAllMac = websGetVar(wp, T("deleteAllFilterMac"), T(""));

	if (strAddMac[0]) {

		strVal = websGetVar(wp, T("mac"), T(""));
		if ( !strVal[0] ) {
			goto setac_ret;
		}
		if (strlen(strVal)!=12 || !string_to_hex(strVal, macEntry.macAddr, 12)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc2))</script>"));
			goto setErr_ac;
		}

		strVal = websGetVar(wp, T("comment"), T(""));
		translate_control_code(strVal);
		if ( strVal[0] ) {
			if (strlen(strVal) > COMMENT_LEN-1) {
				DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc3))</script>"));
				goto setErr_ac;
			}
			strcpy(macEntry.comment, CharFilter3(strVal));
		}
		else
			macEntry.comment[0] = '\0';


		if ( !apmib_get(MIB_WDS_NUM, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
			goto setErr_ac;
		}

		if ( (entryNum + 1) > MAX_WDS_NUM) {
			strcpy(tmpBuf, T("<script>document.write(showText(aspFormWlAc5))</script>"));
			goto setErr_ac;
		}

		// set to MIB. try to delete it first to avoid duplicate case
		apmib_set(MIB_WDS_LIST_DEL, (void *)&macEntry);
		if ( apmib_set(MIB_WDS_LIST_ADD, (void *)&macEntry) == 0) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc6))</script>"));
			goto setErr_ac;
		}

	}

	/* Delete entry */
	if (strDelMac[0]) {


		if ( !apmib_get(MIB_WDS_NUM, (void *)&entryNum)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc4))</script>"));
			goto setErr_ac;
		}
		for (i=entryNum; i>0; i--) {
			snprintf(tmpBuf, 20, "select%d", i);

			strVal = websGetVar(wp, tmpBuf, T(""));
			if ( !gstrcmp(strVal, T("ON")) ) {

				*((char *)&macEntry) = (char)i;

				if ( !apmib_get(MIB_WDS_LIST, (void *)&macEntry)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspWlAcList1))</script>"));
					goto setErr_ac;
				}
				if ( !apmib_set(MIB_WDS_LIST_DEL, (void *)&macEntry)) {
					DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormRoute21))</script>"));
					goto setErr_ac;
				}
			}
		}
	}

	/* Delete all entry */
	if ( strDelAllMac[0]) {

		if ( !apmib_set(MIB_WDS_LIST_DELALL, (void *)&macEntry)) {
			DEBUGP(tmpBuf, T("<script>document.write(showText(aspFormWlAc8))</script>"));
			goto setErr_ac;
		}
	}


setac_ret:
	apmib_update(CURRENT_SETTING);

	submitUrl = websGetVar(wp, T("submit-url"), T(""));   // hidden page
	strApply = websGetVar(wp, T("isApply"), T(""));   // Tommy
	if (strApply[0]) {
	        websHeader(wp);
	        websWrite(wp, T("<script>window.close();</script>"));
	        websDone(wp);
//		OK_MSG(submitUrl);
	}
	else {
		if (submitUrl[0])
			websRedirect(wp, submitUrl);
		else
			websDone(wp, 200);
	}

  	return;

setErr_ac:
	ERR_MSG(tmpBuf);
}
int wlwdsList(int eid, webs_t wp, int argc, char_t **argv)
{
	int nBytesSent=0, entryNum, i;
	MACFILTER_T entry;
	char tmpBuf[100];
	char macBuf[100];

	if ( !apmib_get(MIB_WDS_NUM, (void *)&entryNum))
	{
  		websError(wp, 400, T("Get table entry error!\n"));
		return -1;
	}


	for (i=1; i<=entryNum; i++)
	{
		*((char *)&entry) = (char)i;

		if ( !apmib_get(MIB_WDS_LIST, (void *)&entry)) return -1;
		snprintf(tmpBuf, 100, T("%02x:%02x:%02x:%02x:%02x:%02x"),
			entry.macAddr[0], entry.macAddr[1], entry.macAddr[2],
			entry.macAddr[3], entry.macAddr[4], entry.macAddr[5]);
		snprintf(macBuf, 100, T("%02x%02x%02x%02x%02x%02x"),
			entry.macAddr[0], entry.macAddr[1], entry.macAddr[2],
			entry.macAddr[3], entry.macAddr[4], entry.macAddr[5]);
                nBytesSent += websWrite(wp, T("<tr>"
                "<td align=center class=\"table5\"><font size=\"2\">%s</td><input type=\"hidden\" name=\"macn%d\" value=\"%s\">\n"
		"<td align=center class=\"table5\"><font size=\"2\">Auto</td>\n"
                "<td align=center class=\"table5\"><font size=\"2\">%s</td><input type=\"hidden\" name=\"comment%d\" value=\"%s\">\n"
                "<td align=center class=\"table5\"><input type=\"checkbox\" name=\"select%d\" value=\"ON\"></td></tr>\n"),
                tmpBuf,i,macBuf,CharFilter4(entry.comment),i ,CharFilter4(entry.comment),i);

	}
	nBytesSent += websWrite(wp, T("<input type=\"hidden\" name=\"sipnum\" value=\"%d\">\n"),i-1);
	return nBytesSent;
}

